""" Cisco_IOS_XR_ipv6_ospfv3_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR ipv6\-ospfv3 package operational data.

This module contains definitions
for the following management objects\:
  ospfv3\: OSPFv3 operational information 

Copyright (c) 2013\-2016 by Cisco Systems, Inc.
All rights reserved.

"""
from ydk.entity_utils import get_relative_entity_path as _get_relative_entity_path
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YPYError, YPYModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error


class ImStateEnum(Enum):
    """
    ImStateEnum

    Im state enum

    .. data:: im_state_not_ready = 0

    	im state not ready

    .. data:: im_state_admin_down = 1

    	im state admin down

    .. data:: im_state_down = 2

    	im state down

    .. data:: im_state_up = 3

    	im state up

    .. data:: im_state_shutdown = 4

    	im state shutdown

    .. data:: im_state_err_disable = 5

    	im state err disable

    .. data:: im_state_down_immediate = 6

    	im state down immediate

    .. data:: im_state_down_immediate_admin = 7

    	im state down immediate admin

    .. data:: im_state_down_graceful = 8

    	im state down graceful

    .. data:: im_state_begin_shutdown = 9

    	im state begin shutdown

    .. data:: im_state_end_shutdown = 10

    	im state end shutdown

    .. data:: im_state_begin_error_disable = 11

    	im state begin error disable

    .. data:: im_state_end_error_disable = 12

    	im state end error disable

    .. data:: im_state_begin_down_graceful = 13

    	im state begin down graceful

    .. data:: im_state_reset = 14

    	im state reset

    .. data:: im_state_operational = 15

    	im state operational

    .. data:: im_state_not_operational = 16

    	im state not operational

    .. data:: im_state_unknown = 17

    	im state unknown

    .. data:: im_state_last = 18

    	im state last

    """

    im_state_not_ready = Enum.YLeaf(0, "im-state-not-ready")

    im_state_admin_down = Enum.YLeaf(1, "im-state-admin-down")

    im_state_down = Enum.YLeaf(2, "im-state-down")

    im_state_up = Enum.YLeaf(3, "im-state-up")

    im_state_shutdown = Enum.YLeaf(4, "im-state-shutdown")

    im_state_err_disable = Enum.YLeaf(5, "im-state-err-disable")

    im_state_down_immediate = Enum.YLeaf(6, "im-state-down-immediate")

    im_state_down_immediate_admin = Enum.YLeaf(7, "im-state-down-immediate-admin")

    im_state_down_graceful = Enum.YLeaf(8, "im-state-down-graceful")

    im_state_begin_shutdown = Enum.YLeaf(9, "im-state-begin-shutdown")

    im_state_end_shutdown = Enum.YLeaf(10, "im-state-end-shutdown")

    im_state_begin_error_disable = Enum.YLeaf(11, "im-state-begin-error-disable")

    im_state_end_error_disable = Enum.YLeaf(12, "im-state-end-error-disable")

    im_state_begin_down_graceful = Enum.YLeaf(13, "im-state-begin-down-graceful")

    im_state_reset = Enum.YLeaf(14, "im-state-reset")

    im_state_operational = Enum.YLeaf(15, "im-state-operational")

    im_state_not_operational = Enum.YLeaf(16, "im-state-not-operational")

    im_state_unknown = Enum.YLeaf(17, "im-state-unknown")

    im_state_last = Enum.YLeaf(18, "im-state-last")


class IpfrrTbrkr(Enum):
    """
    IpfrrTbrkr

    FRR Tiebreakers

    .. data:: downstream = 0

    	Downsteram

    .. data:: line_card_disjoint = 1

    	LC Disjoint

    .. data:: backup_metric = 2

    	Backup metric

    .. data:: node_protect = 3

    	Node protection

    .. data:: primary_path = 4

    	Primary path

    .. data:: secondary_path = 5

    	Secondary path

    .. data:: srlg_disjoint = 6

    	SRLG disjoint

    .. data:: tunnel = 7

    	Tunnel

    """

    downstream = Enum.YLeaf(0, "downstream")

    line_card_disjoint = Enum.YLeaf(1, "line-card-disjoint")

    backup_metric = Enum.YLeaf(2, "backup-metric")

    node_protect = Enum.YLeaf(3, "node-protect")

    primary_path = Enum.YLeaf(4, "primary-path")

    secondary_path = Enum.YLeaf(5, "secondary-path")

    srlg_disjoint = Enum.YLeaf(6, "srlg-disjoint")

    tunnel = Enum.YLeaf(7, "tunnel")


class OspfLsaSyncState(Enum):
    """
    OspfLsaSyncState

    LSA synchronization states

    .. data:: none = 0

    	State not set

    .. data:: out_of_sync = 1

    	LSA out of sync with active

    .. data:: in_sync = 2

    	LSA in sync with active

    .. data:: nsr_ack_pending = 3

    	NSR ack pending for LSA sync

    """

    none = Enum.YLeaf(0, "none")

    out_of_sync = Enum.YLeaf(1, "out-of-sync")

    in_sync = Enum.YLeaf(2, "in-sync")

    nsr_ack_pending = Enum.YLeaf(3, "nsr-ack-pending")


class OspfNsrSchedPri(Enum):
    """
    OspfNsrSchedPri

    Ospf nsr sched pri

    .. data:: ospf_nsr_stats_sched_pri_hi = 0

    	ospf nsr stats sched pri hi

    .. data:: ospf_nsr_stats_sched_pri_med = 1

    	ospf nsr stats sched pri med

    .. data:: ospf_nsr_stats_sched_pri_low = 2

    	ospf nsr stats sched pri low

    .. data:: ospf_nsr_stats_sched_pri_max = 3

    	ospf nsr stats sched pri max

    """

    ospf_nsr_stats_sched_pri_hi = Enum.YLeaf(0, "ospf-nsr-stats-sched-pri-hi")

    ospf_nsr_stats_sched_pri_med = Enum.YLeaf(1, "ospf-nsr-stats-sched-pri-med")

    ospf_nsr_stats_sched_pri_low = Enum.YLeaf(2, "ospf-nsr-stats-sched-pri-low")

    ospf_nsr_stats_sched_pri_max = Enum.YLeaf(3, "ospf-nsr-stats-sched-pri-max")


class Ospfv3AreaRangeStatus(Enum):
    """
    Ospfv3AreaRangeStatus

    Ospfv3 area range status

    .. data:: advertise = 1

    	Advertise this range

    .. data:: do_not_advertise = 2

    	Do not advertise this range

    """

    advertise = Enum.YLeaf(1, "advertise")

    do_not_advertise = Enum.YLeaf(2, "do-not-advertise")


class Ospfv3BorderRoute(Enum):
    """
    Ospfv3BorderRoute

    OSPFv3 border route destination types

    .. data:: abr = 1

    	Area border router

    .. data:: asbr = 2

    	Area system boundary router

    .. data:: abr_asbr = 3

    	Area border router and area system boundary

    	router

    """

    abr = Enum.YLeaf(1, "abr")

    asbr = Enum.YLeaf(2, "asbr")

    abr_asbr = Enum.YLeaf(3, "abr-asbr")


class Ospfv3DefaultMetric(Enum):
    """
    Ospfv3DefaultMetric

    OSPFv3 default metric types 

    .. data:: type_none = 0

    	OSPFv3 default metric type None 

    .. data:: type1 = 1

    	OSPFv3 default metric type 1 

    .. data:: type2 = 2

    	OSPFv3 default metric type 2 

    """

    type_none = Enum.YLeaf(0, "type-none")

    type1 = Enum.YLeaf(1, "type1")

    type2 = Enum.YLeaf(2, "type2")


class Ospfv3GracefulRestartReason(Enum):
    """
    Ospfv3GracefulRestartReason

    Reason for router restart

    .. data:: grace_reason_unknown = 0

    	Grace reason unknown

    .. data:: grace_reason_software_restart = 1

    	Grace reason software restart

    .. data:: grace_reason_software_upgrade = 2

    	Software reload/upgrade, RFC 3623

    .. data:: grace_reason_switchover = 3

    	Switch to redundant control processor

    """

    grace_reason_unknown = Enum.YLeaf(0, "grace-reason-unknown")

    grace_reason_software_restart = Enum.YLeaf(1, "grace-reason-software-restart")

    grace_reason_software_upgrade = Enum.YLeaf(2, "grace-reason-software-upgrade")

    grace_reason_switchover = Enum.YLeaf(3, "grace-reason-switchover")


class Ospfv3GracefulShutdownState(Enum):
    """
    Ospfv3GracefulShutdownState

    Graceful Shutdown state

    .. data:: init = 0

    	Init

    .. data:: normal = 1

    	Normal

    .. data:: flushing = 2

    	Flushing

    .. data:: empty_hellos = 3

    	Empty Hellos

    .. data:: quiet = 4

    	Quiet

    """

    init = Enum.YLeaf(0, "init")

    normal = Enum.YLeaf(1, "normal")

    flushing = Enum.YLeaf(2, "flushing")

    empty_hellos = Enum.YLeaf(3, "empty-hellos")

    quiet = Enum.YLeaf(4, "quiet")


class Ospfv3Interface(Enum):
    """
    Ospfv3Interface

    OSPFv3 neighbor interface types

    .. data:: none = 0

    	None

    .. data:: broadcast = 1

    	Broadcast

    .. data:: non_broadcast = 2

    	Non broadcast

    .. data:: point_to_point = 3

    	Point To Point

    .. data:: point_to_multipoint = 4

    	Point To Multipoint

    .. data:: point_to_multipoint_non_broadcast = 5

    	Point-To-Multipoint Non broadcast

    .. data:: virtual_link = 6

    	Virtual link

    .. data:: loopback_interface = 7

    	Loopback

    .. data:: mpls_traffic_engineering = 8

    	MPLS traffic engineering

    .. data:: sham_link = 9

    	Sham link

    """

    none = Enum.YLeaf(0, "none")

    broadcast = Enum.YLeaf(1, "broadcast")

    non_broadcast = Enum.YLeaf(2, "non-broadcast")

    point_to_point = Enum.YLeaf(3, "point-to-point")

    point_to_multipoint = Enum.YLeaf(4, "point-to-multipoint")

    point_to_multipoint_non_broadcast = Enum.YLeaf(5, "point-to-multipoint-non-broadcast")

    virtual_link = Enum.YLeaf(6, "virtual-link")

    loopback_interface = Enum.YLeaf(7, "loopback-interface")

    mpls_traffic_engineering = Enum.YLeaf(8, "mpls-traffic-engineering")

    sham_link = Enum.YLeaf(9, "sham-link")


class Ospfv3InterfaceState(Enum):
    """
    Ospfv3InterfaceState

    OSPFv3 interface states

    .. data:: down = 0

    	Down

    .. data:: loopback = 1

    	Loopback

    .. data:: waiting = 2

    	Waiting

    .. data:: point_to_multipoint = 3

    	Point To Multipoint

    .. data:: point_to_point = 4

    	Point To Point

    .. data:: designated_router = 5

    	Designated router

    .. data:: backup_designated_router = 6

    	Backup designated router

    .. data:: other_designated_router = 7

    	Other designated router

    """

    down = Enum.YLeaf(0, "down")

    loopback = Enum.YLeaf(1, "loopback")

    waiting = Enum.YLeaf(2, "waiting")

    point_to_multipoint = Enum.YLeaf(3, "point-to-multipoint")

    point_to_point = Enum.YLeaf(4, "point-to-point")

    designated_router = Enum.YLeaf(5, "designated-router")

    backup_designated_router = Enum.YLeaf(6, "backup-designated-router")

    other_designated_router = Enum.YLeaf(7, "other-designated-router")


class Ospfv3Link(Enum):
    """
    Ospfv3Link

    OSPFV3 Link type

    .. data:: link_router = 1

    	Router link

    .. data:: link_trans_net = 2

    	Transit network link

    .. data:: link_virtual_link = 4

    	Virutal link

    """

    link_router = Enum.YLeaf(1, "link-router")

    link_trans_net = Enum.YLeaf(2, "link-trans-net")

    link_virtual_link = Enum.YLeaf(4, "link-virtual-link")


class Ospfv3Lsa(Enum):
    """
    Ospfv3Lsa

    Ospfv3 lsa

    .. data:: link_lsa = 8

    	Link LSA

    .. data:: grace_lsa = 11

    	Grace LSA

    .. data:: router = 8193

    	Router LSA

    .. data:: network = 8194

    	Network LSA

    .. data:: inter_area_prefix = 8195

    	Inter-Area Prefix LSA

    .. data:: inter_area_router = 8196

    	Inter-Area Router LSA

    .. data:: nssa_external = 8199

    	NSSA External LSA

    .. data:: intra_area_prefix = 8201

    	Intra-Area Prefix LSA

    .. data:: external = 16389

    	External LSA

    .. data:: opaque_link = 32768

    	Opaque LSALink Scope

    .. data:: opaque_area = 40960

    	Opaque LSA Area Scope

    .. data:: opaque_as = 49152

    	Opaque LSA AS Scope

    .. data:: unknown = 57344

    	Unknown Reserved Scope LSAs

    """

    link_lsa = Enum.YLeaf(8, "link-lsa")

    grace_lsa = Enum.YLeaf(11, "grace-lsa")

    router = Enum.YLeaf(8193, "router")

    network = Enum.YLeaf(8194, "network")

    inter_area_prefix = Enum.YLeaf(8195, "inter-area-prefix")

    inter_area_router = Enum.YLeaf(8196, "inter-area-router")

    nssa_external = Enum.YLeaf(8199, "nssa-external")

    intra_area_prefix = Enum.YLeaf(8201, "intra-area-prefix")

    external = Enum.YLeaf(16389, "external")

    opaque_link = Enum.YLeaf(32768, "opaque-link")

    opaque_area = Enum.YLeaf(40960, "opaque-area")

    opaque_as = Enum.YLeaf(49152, "opaque-as")

    unknown = Enum.YLeaf(57344, "unknown")


class Ospfv3Lsa1(Enum):
    """
    Ospfv3Lsa1

    OSPFv3 LSA types

    .. data:: link = 8

    	Link LSA

    .. data:: grace = 11

    	Grace LSA

    .. data:: router = 8193

    	Router LSA

    .. data:: network = 8194

    	Network LSA

    .. data:: inter_area_prefix = 8195

    	Inter area prefix LSA

    .. data:: inter_area_router = 8196

    	Inter area router LSA

    .. data:: mospf = 8198

    	MOSPF LSA

    .. data:: type7_external = 8199

    	Type-7 External LSA

    .. data:: lsa_prefix = 8201

    	Prefix LSA

    .. data:: as_external = 16389

    	AS external LSA

    .. data:: unknown_link = 32768

    	Unknown link LSA

    .. data:: unknown_area = 40960

    	Unknown area LSA

    .. data:: unknown_as = 49152

    	Unknown AS LSA

    .. data:: unknown_type = 57344

    	Unknown type LSA

    """

    link = Enum.YLeaf(8, "link")

    grace = Enum.YLeaf(11, "grace")

    router = Enum.YLeaf(8193, "router")

    network = Enum.YLeaf(8194, "network")

    inter_area_prefix = Enum.YLeaf(8195, "inter-area-prefix")

    inter_area_router = Enum.YLeaf(8196, "inter-area-router")

    mospf = Enum.YLeaf(8198, "mospf")

    type7_external = Enum.YLeaf(8199, "type7-external")

    lsa_prefix = Enum.YLeaf(8201, "lsa-prefix")

    as_external = Enum.YLeaf(16389, "as-external")

    unknown_link = Enum.YLeaf(32768, "unknown-link")

    unknown_area = Enum.YLeaf(40960, "unknown-area")

    unknown_as = Enum.YLeaf(49152, "unknown-as")

    unknown_type = Enum.YLeaf(57344, "unknown-type")


class Ospfv3LsaInfoTypes(Enum):
    """
    Ospfv3LsaInfoTypes

    OSPFv3 LSA format types

    .. data:: mgmt_lsa_lsasum_type = 0

    	Summary information of LSAs

    .. data:: mgmt_lsa_link_type = 8

    	Link LSA

    .. data:: mgmt_lsa_gr_type = 11

    	Grace LSA

    .. data:: mgmt_lsa_rtr_type = 8193

    	Router LSA

    .. data:: mgmt_lsa_net_type = 8194

    	Network LSA

    .. data:: mgmt_lsa_iapfx_type = 8195

    	Inter Area Prefix Summary LSA

    .. data:: mgmt_lsa_iartr_type = 8196

    	Inter Area Router Summay LSA

    .. data:: mgmt_lsa_nssaext_type = 8199

    	NSSA external LSA

    .. data:: mgmt_lsa_prefix_type = 8201

    	Intra Area Prefix LSA

    .. data:: mgmt_lsa_ext_type = 16389

    	Type 5 External LSA

    .. data:: mgmt_lsa_unk_link_type = 32768

    	Opaque Link scope LSA

    .. data:: mgmt_lsa_unk_area_type = 40960

    	Opaque Area scope LSA

    .. data:: mgmt_lsa_unk_as_type = 49152

    	Opaque AS scope LSA

    .. data:: mgmt_lsa_unk_type = 57344

    	Opaque Reserved scope LSA

    """

    mgmt_lsa_lsasum_type = Enum.YLeaf(0, "mgmt-lsa-lsasum-type")

    mgmt_lsa_link_type = Enum.YLeaf(8, "mgmt-lsa-link-type")

    mgmt_lsa_gr_type = Enum.YLeaf(11, "mgmt-lsa-gr-type")

    mgmt_lsa_rtr_type = Enum.YLeaf(8193, "mgmt-lsa-rtr-type")

    mgmt_lsa_net_type = Enum.YLeaf(8194, "mgmt-lsa-net-type")

    mgmt_lsa_iapfx_type = Enum.YLeaf(8195, "mgmt-lsa-iapfx-type")

    mgmt_lsa_iartr_type = Enum.YLeaf(8196, "mgmt-lsa-iartr-type")

    mgmt_lsa_nssaext_type = Enum.YLeaf(8199, "mgmt-lsa-nssaext-type")

    mgmt_lsa_prefix_type = Enum.YLeaf(8201, "mgmt-lsa-prefix-type")

    mgmt_lsa_ext_type = Enum.YLeaf(16389, "mgmt-lsa-ext-type")

    mgmt_lsa_unk_link_type = Enum.YLeaf(32768, "mgmt-lsa-unk-link-type")

    mgmt_lsa_unk_area_type = Enum.YLeaf(40960, "mgmt-lsa-unk-area-type")

    mgmt_lsa_unk_as_type = Enum.YLeaf(49152, "mgmt-lsa-unk-as-type")

    mgmt_lsa_unk_type = Enum.YLeaf(57344, "mgmt-lsa-unk-type")


class Ospfv3NeighborState(Enum):
    """
    Ospfv3NeighborState

    OSPFv3 neighbor states

    .. data:: neigbhor_down = 0

    	Down

    .. data:: attempt = 1

    	Attempting

    .. data:: init = 2

    	Initializing

    .. data:: two_way = 3

    	2 Way

    .. data:: exstart = 4

    	Exstart

    .. data:: exchange = 5

    	Exchange

    .. data:: loading = 6

    	Loading

    .. data:: full = 7

    	Full

    .. data:: sc_virtual = 8

    	SCVirtual

    """

    neigbhor_down = Enum.YLeaf(0, "neigbhor-down")

    attempt = Enum.YLeaf(1, "attempt")

    init = Enum.YLeaf(2, "init")

    two_way = Enum.YLeaf(3, "two-way")

    exstart = Enum.YLeaf(4, "exstart")

    exchange = Enum.YLeaf(5, "exchange")

    loading = Enum.YLeaf(6, "loading")

    full = Enum.YLeaf(7, "full")

    sc_virtual = Enum.YLeaf(8, "sc-virtual")


class PrefixPriority(Enum):
    """
    PrefixPriority

    Prefix priority

    .. data:: critical = 0

    	Critical priority

    .. data:: high = 1

    	High priority

    .. data:: medium = 2

    	Medium priority

    .. data:: low = 3

    	Low priority

    """

    critical = Enum.YLeaf(0, "critical")

    high = Enum.YLeaf(1, "high")

    medium = Enum.YLeaf(2, "medium")

    low = Enum.YLeaf(3, "low")


class StubRouterAbrOffReason(Enum):
    """
    StubRouterAbrOffReason

    Reason to exiting stub router mode

    .. data:: init_delay = 2

    	Initial delay when stub router mode is

    	activated

    .. data:: no_neighbor = 3

    	No neighbor present

    .. data:: no_full_neighbor = 4

    	No neighbor in FULL state present

    .. data:: new_neighbor = 5

    	A new neighbor discovered less than 60 seconds

    	ago

    .. data:: full_neighbor = 6

    	A neighbor transitioned to FULL state less than

    	60 seconds ago

    """

    init_delay = Enum.YLeaf(2, "init-delay")

    no_neighbor = Enum.YLeaf(3, "no-neighbor")

    no_full_neighbor = Enum.YLeaf(4, "no-full-neighbor")

    new_neighbor = Enum.YLeaf(5, "new-neighbor")

    full_neighbor = Enum.YLeaf(6, "full-neighbor")


class StubRouterExitReason(Enum):
    """
    StubRouterExitReason

    Reason to exiting stub router mode

    .. data:: none = 0

    	No reason

    .. data:: bgp = 1

    	BGP has converged

    .. data:: timer = 2

    	Stub Router timer has expired

    .. data:: configuration = 3

    	Configuration has changed

    .. data:: cleared = 4

    	Process has been cleared

    .. data:: override = 5

    	Preempted by always

    """

    none = Enum.YLeaf(0, "none")

    bgp = Enum.YLeaf(1, "bgp")

    timer = Enum.YLeaf(2, "timer")

    configuration = Enum.YLeaf(3, "configuration")

    cleared = Enum.YLeaf(4, "cleared")

    override = Enum.YLeaf(5, "override")


class StubRouterMode(Enum):
    """
    StubRouterMode

    Stub Router mode

    .. data:: rbit = 0

    	Stub Router mode r-bit

    .. data:: v6bit = 1

    	Stub Router mode v6-bit

    .. data:: max_metric = 2

    	Stub Router mode max-metric

    .. data:: none = 3

    	Stub Router not configured

    """

    rbit = Enum.YLeaf(0, "rbit")

    v6bit = Enum.YLeaf(1, "v6bit")

    max_metric = Enum.YLeaf(2, "max-metric")

    none = Enum.YLeaf(3, "none")


class StubRouterTrigger(Enum):
    """
    StubRouterTrigger

    Trigger for entering stub router mode

    .. data:: on_proc_migration = 0

    	Process migration

    .. data:: on_proc_restart = 1

    	Process restart

    .. data:: on_switchover = 2

    	RP switchover

    .. data:: on_startup = 3

    	Router startup

    .. data:: always = 4

    	Always on

    .. data:: none = 5

    	No trigger

    """

    on_proc_migration = Enum.YLeaf(0, "on-proc-migration")

    on_proc_restart = Enum.YLeaf(1, "on-proc-restart")

    on_switchover = Enum.YLeaf(2, "on-switchover")

    on_startup = Enum.YLeaf(3, "on-startup")

    always = Enum.YLeaf(4, "always")

    none = Enum.YLeaf(5, "none")



class Ospfv3(Entity):
    """
    OSPFv3 operational information 
    
    .. attribute:: processes
    
    	OSPFv3 Process Table
    	**type**\:   :py:class:`Processes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes>`
    
    

    """

    _prefix = 'ipv6-ospfv3-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(Ospfv3, self).__init__()
        self._top_entity = None

        self.yang_name = "ospfv3"
        self.yang_parent_name = "Cisco-IOS-XR-ipv6-ospfv3-oper"

        self.processes = Ospfv3.Processes()
        self.processes.parent = self
        self._children_name_map["processes"] = "processes"
        self._children_yang_names.add("processes")


    class Processes(Entity):
        """
        OSPFv3 Process Table
        
        .. attribute:: process
        
        	OSPFv3 Operational data for a particular OSPFv3 process 
        	**type**\: list of    :py:class:`Process <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process>`
        
        

        """

        _prefix = 'ipv6-ospfv3-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(Ospfv3.Processes, self).__init__()

            self.yang_name = "processes"
            self.yang_parent_name = "ospfv3"

            self.process = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(Ospfv3.Processes, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(Ospfv3.Processes, self).__setattr__(name, value)


        class Process(Entity):
            """
            OSPFv3 Operational data for a particular OSPFv3
            process 
            
            .. attribute:: process_name  <key>
            
            	Particular OSPFv3 process
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: default_vrf
            
            	Operational data for the default VRF (instance) in the OSPFv3 process
            	**type**\:   :py:class:`DefaultVrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf>`
            
            .. attribute:: statistics
            
            	Container for Statistics
            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics>`
            
            .. attribute:: vrfs
            
            	Table for each VRF
            	**type**\:   :py:class:`Vrfs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs>`
            
            

            """

            _prefix = 'ipv6-ospfv3-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(Ospfv3.Processes.Process, self).__init__()

                self.yang_name = "process"
                self.yang_parent_name = "processes"

                self.process_name = YLeaf(YType.str, "process-name")

                self.default_vrf = Ospfv3.Processes.Process.DefaultVrf()
                self.default_vrf.parent = self
                self._children_name_map["default_vrf"] = "default-vrf"
                self._children_yang_names.add("default-vrf")

                self.statistics = Ospfv3.Processes.Process.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"
                self._children_yang_names.add("statistics")

                self.vrfs = Ospfv3.Processes.Process.Vrfs()
                self.vrfs.parent = self
                self._children_name_map["vrfs"] = "vrfs"
                self._children_yang_names.add("vrfs")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("process_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(Ospfv3.Processes.Process, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(Ospfv3.Processes.Process, self).__setattr__(name, value)


            class Vrfs(Entity):
                """
                Table for each VRF
                
                .. attribute:: vrf
                
                	Operational data for a particular VRF (instance) in the OSPFv3 process
                	**type**\: list of    :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf>`
                
                

                """

                _prefix = 'ipv6-ospfv3-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(Ospfv3.Processes.Process.Vrfs, self).__init__()

                    self.yang_name = "vrfs"
                    self.yang_parent_name = "process"

                    self.vrf = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Ospfv3.Processes.Process.Vrfs, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Ospfv3.Processes.Process.Vrfs, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    Operational data for a particular VRF
                    (instance) in the OSPFv3 process
                    
                    .. attribute:: vrf_name  <key>
                    
                    	VRF Name
                    	**type**\:  str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    .. attribute:: area_informations
                    
                    	OSPFv3 area information table
                    	**type**\:   :py:class:`AreaInformations <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations>`
                    
                    .. attribute:: areas
                    
                    	OSPFv3 area table
                    	**type**\:   :py:class:`Areas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas>`
                    
                    .. attribute:: bad_checksums
                    
                    	Bad Checksum Packets information table
                    	**type**\:   :py:class:`BadChecksums <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums>`
                    
                    .. attribute:: border_routers
                    
                    	OSPFv3 border router information table
                    	**type**\:   :py:class:`BorderRouters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters>`
                    
                    .. attribute:: connected_routes
                    
                    	OSPFv3 connected route information table
                    	**type**\:   :py:class:`ConnectedRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes>`
                    
                    .. attribute:: database_summary_table
                    
                    	Database summary table
                    	**type**\:   :py:class:`DatabaseSummaryTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable>`
                    
                    .. attribute:: database_table
                    
                    	OSPF Link State Database
                    	**type**\:   :py:class:`DatabaseTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable>`
                    
                    .. attribute:: external_routes
                    
                    	OSPFv3 external route information table
                    	**type**\:   :py:class:`ExternalRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes>`
                    
                    .. attribute:: fast_reroutes
                    
                    	OSPFv3 fast reroute topology information table
                    	**type**\:   :py:class:`FastReroutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes>`
                    
                    .. attribute:: flood_list_process_table
                    
                    	OSPFv3 flood list information table for all areas
                    	**type**\:   :py:class:`FloodListProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable>`
                    
                    .. attribute:: interface_brief_process_table
                    
                    	OSPFv3 interface brief information table for all areas
                    	**type**\:   :py:class:`InterfaceBriefProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable>`
                    
                    .. attribute:: interface_process_table
                    
                    	OSPFv3 interface information table for all areas
                    	**type**\:   :py:class:`InterfaceProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable>`
                    
                    .. attribute:: internal_routes
                    
                    	OSPFv3 internal route information table
                    	**type**\:   :py:class:`InternalRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes>`
                    
                    .. attribute:: neighbor_detail_process_table
                    
                    	OSPFv3 neighbor information table for all areas
                    	**type**\:   :py:class:`NeighborDetailProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable>`
                    
                    .. attribute:: neighbor_process_table
                    
                    	OSPFv3 neighbor information table for all areas
                    	**type**\:   :py:class:`NeighborProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable>`
                    
                    .. attribute:: protocol_areas
                    
                    	Protocol area table 
                    	**type**\:   :py:class:`ProtocolAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas>`
                    
                    .. attribute:: redistributions
                    
                    	Redistribution information table
                    	**type**\:   :py:class:`Redistributions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions>`
                    
                    .. attribute:: request_list_process_table
                    
                    	OSPFv3 request list information for all areas
                    	**type**\:   :py:class:`RequestListProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable>`
                    
                    .. attribute:: retransmission_list_process_table
                    
                    	OSPFv3 retransmission list information table for all areas
                    	**type**\:   :py:class:`RetransmissionListProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable>`
                    
                    .. attribute:: route_summary
                    
                    	Summarize OSPFv3 local RIB tables
                    	**type**\:   :py:class:`RouteSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.RouteSummary>`
                    
                    .. attribute:: sham_link_table
                    
                    	Sham link information
                    	**type**\:   :py:class:`ShamLinkTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable>`
                    
                    .. attribute:: summary
                    
                    	OSPFv3 summary
                    	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary>`
                    
                    .. attribute:: summary_prefixes
                    
                    	Summary prefix information table
                    	**type**\:   :py:class:`SummaryPrefixes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes>`
                    
                    .. attribute:: virtual_link
                    
                    	Virtual link information
                    	**type**\:   :py:class:`VirtualLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink>`
                    
                    .. attribute:: vrf_statistics
                    
                    	Container for Statistics
                    	**type**\:   :py:class:`VrfStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.Vrfs.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "vrfs"

                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                        self.area_informations = Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations()
                        self.area_informations.parent = self
                        self._children_name_map["area_informations"] = "area-informations"
                        self._children_yang_names.add("area-informations")

                        self.areas = Ospfv3.Processes.Process.Vrfs.Vrf.Areas()
                        self.areas.parent = self
                        self._children_name_map["areas"] = "areas"
                        self._children_yang_names.add("areas")

                        self.bad_checksums = Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums()
                        self.bad_checksums.parent = self
                        self._children_name_map["bad_checksums"] = "bad-checksums"
                        self._children_yang_names.add("bad-checksums")

                        self.border_routers = Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters()
                        self.border_routers.parent = self
                        self._children_name_map["border_routers"] = "border-routers"
                        self._children_yang_names.add("border-routers")

                        self.connected_routes = Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes()
                        self.connected_routes.parent = self
                        self._children_name_map["connected_routes"] = "connected-routes"
                        self._children_yang_names.add("connected-routes")

                        self.database_summary_table = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable()
                        self.database_summary_table.parent = self
                        self._children_name_map["database_summary_table"] = "database-summary-table"
                        self._children_yang_names.add("database-summary-table")

                        self.database_table = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable()
                        self.database_table.parent = self
                        self._children_name_map["database_table"] = "database-table"
                        self._children_yang_names.add("database-table")

                        self.external_routes = Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes()
                        self.external_routes.parent = self
                        self._children_name_map["external_routes"] = "external-routes"
                        self._children_yang_names.add("external-routes")

                        self.fast_reroutes = Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes()
                        self.fast_reroutes.parent = self
                        self._children_name_map["fast_reroutes"] = "fast-reroutes"
                        self._children_yang_names.add("fast-reroutes")

                        self.flood_list_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable()
                        self.flood_list_process_table.parent = self
                        self._children_name_map["flood_list_process_table"] = "flood-list-process-table"
                        self._children_yang_names.add("flood-list-process-table")

                        self.interface_brief_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable()
                        self.interface_brief_process_table.parent = self
                        self._children_name_map["interface_brief_process_table"] = "interface-brief-process-table"
                        self._children_yang_names.add("interface-brief-process-table")

                        self.interface_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable()
                        self.interface_process_table.parent = self
                        self._children_name_map["interface_process_table"] = "interface-process-table"
                        self._children_yang_names.add("interface-process-table")

                        self.internal_routes = Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes()
                        self.internal_routes.parent = self
                        self._children_name_map["internal_routes"] = "internal-routes"
                        self._children_yang_names.add("internal-routes")

                        self.neighbor_detail_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable()
                        self.neighbor_detail_process_table.parent = self
                        self._children_name_map["neighbor_detail_process_table"] = "neighbor-detail-process-table"
                        self._children_yang_names.add("neighbor-detail-process-table")

                        self.neighbor_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable()
                        self.neighbor_process_table.parent = self
                        self._children_name_map["neighbor_process_table"] = "neighbor-process-table"
                        self._children_yang_names.add("neighbor-process-table")

                        self.protocol_areas = Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas()
                        self.protocol_areas.parent = self
                        self._children_name_map["protocol_areas"] = "protocol-areas"
                        self._children_yang_names.add("protocol-areas")

                        self.redistributions = Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions()
                        self.redistributions.parent = self
                        self._children_name_map["redistributions"] = "redistributions"
                        self._children_yang_names.add("redistributions")

                        self.request_list_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable()
                        self.request_list_process_table.parent = self
                        self._children_name_map["request_list_process_table"] = "request-list-process-table"
                        self._children_yang_names.add("request-list-process-table")

                        self.retransmission_list_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable()
                        self.retransmission_list_process_table.parent = self
                        self._children_name_map["retransmission_list_process_table"] = "retransmission-list-process-table"
                        self._children_yang_names.add("retransmission-list-process-table")

                        self.route_summary = Ospfv3.Processes.Process.Vrfs.Vrf.RouteSummary()
                        self.route_summary.parent = self
                        self._children_name_map["route_summary"] = "route-summary"
                        self._children_yang_names.add("route-summary")

                        self.sham_link_table = Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable()
                        self.sham_link_table.parent = self
                        self._children_name_map["sham_link_table"] = "sham-link-table"
                        self._children_yang_names.add("sham-link-table")

                        self.summary = Ospfv3.Processes.Process.Vrfs.Vrf.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                        self._children_yang_names.add("summary")

                        self.summary_prefixes = Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes()
                        self.summary_prefixes.parent = self
                        self._children_name_map["summary_prefixes"] = "summary-prefixes"
                        self._children_yang_names.add("summary-prefixes")

                        self.virtual_link = Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink()
                        self.virtual_link.parent = self
                        self._children_name_map["virtual_link"] = "virtual-link"
                        self._children_yang_names.add("virtual-link")

                        self.vrf_statistics = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics()
                        self.vrf_statistics.parent = self
                        self._children_name_map["vrf_statistics"] = "vrf-statistics"
                        self._children_yang_names.add("vrf-statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("vrf_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.Vrfs.Vrf, self).__setattr__(name, value)


                    class SummaryPrefixes(Entity):
                        """
                        Summary prefix information table
                        
                        .. attribute:: summary_prefix
                        
                        	Summary prefix information
                        	**type**\: list of    :py:class:`SummaryPrefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes.SummaryPrefix>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes, self).__init__()

                            self.yang_name = "summary-prefixes"
                            self.yang_parent_name = "vrf"

                            self.summary_prefix = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes, self).__setattr__(name, value)


                        class SummaryPrefix(Entity):
                            """
                            Summary prefix information
                            
                            .. attribute:: prefix
                            
                            	Summary prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..128
                            
                            .. attribute:: prefix_metric
                            
                            	Prefix metric
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: prefix_metric_type
                            
                            	Prefix metric type
                            	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                            
                            .. attribute:: tag
                            
                            	Tag
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes.SummaryPrefix, self).__init__()

                                self.yang_name = "summary-prefix"
                                self.yang_parent_name = "summary-prefixes"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.prefix_metric = YLeaf(YType.uint32, "prefix-metric")

                                self.prefix_metric_type = YLeaf(YType.enumeration, "prefix-metric-type")

                                self.tag = YLeaf(YType.uint32, "tag")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "prefix_metric",
                                                "prefix_metric_type",
                                                "tag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes.SummaryPrefix, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes.SummaryPrefix, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.prefix_metric.is_set or
                                    self.prefix_metric_type.is_set or
                                    self.tag.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.prefix_metric.yfilter != YFilter.not_set or
                                    self.prefix_metric_type.yfilter != YFilter.not_set or
                                    self.tag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "summary-prefix" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.prefix_metric.is_set or self.prefix_metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_metric.get_name_leafdata())
                                if (self.prefix_metric_type.is_set or self.prefix_metric_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_metric_type.get_name_leafdata())
                                if (self.tag.is_set or self.tag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "prefix-metric" or name == "prefix-metric-type" or name == "tag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-metric"):
                                    self.prefix_metric = value
                                    self.prefix_metric.value_namespace = name_space
                                    self.prefix_metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-metric-type"):
                                    self.prefix_metric_type = value
                                    self.prefix_metric_type.value_namespace = name_space
                                    self.prefix_metric_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "tag"):
                                    self.tag = value
                                    self.tag.value_namespace = name_space
                                    self.tag.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.summary_prefix:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.summary_prefix:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "summary-prefixes" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "summary-prefix"):
                                for c in self.summary_prefix:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes.SummaryPrefix()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.summary_prefix.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "summary-prefix"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class BorderRouters(Entity):
                        """
                        OSPFv3 border router information table
                        
                        .. attribute:: border_router
                        
                        	OSPFv3 border router information
                        	**type**\: list of    :py:class:`BorderRouter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters.BorderRouter>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters, self).__init__()

                            self.yang_name = "border-routers"
                            self.yang_parent_name = "vrf"

                            self.border_router = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters, self).__setattr__(name, value)


                        class BorderRouter(Entity):
                            """
                            OSPFv3 border router information
                            
                            .. attribute:: border_router_id  <key>
                            
                            	Router address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: border_router_path
                            
                            	List of border router paths
                            	**type**\: list of    :py:class:`BorderRouterPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters.BorderRouter.BorderRouterPath>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters.BorderRouter, self).__init__()

                                self.yang_name = "border-router"
                                self.yang_parent_name = "border-routers"

                                self.border_router_id = YLeaf(YType.str, "border-router-id")

                                self.border_router_path = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("border_router_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters.BorderRouter, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters.BorderRouter, self).__setattr__(name, value)


                            class BorderRouterPath(Entity):
                                """
                                List of border router paths
                                
                                .. attribute:: border_router_area_id
                                
                                	Area string in decimal or dotted\-decimal format 
                                	**type**\:  str
                                
                                	**length:** 0..16
                                
                                .. attribute:: border_router_next_hop
                                
                                	Next hop address 
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: border_router_route_metric
                                
                                	Metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: border_router_type
                                
                                	Border router type 
                                	**type**\:   :py:class:`Ospfv3BorderRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3BorderRoute>`
                                
                                .. attribute:: interface_name
                                
                                	Next hop interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: is_intra_area_router
                                
                                	If true, intra\-area router else inter\-area router
                                	**type**\:  bool
                                
                                .. attribute:: spf_version
                                
                                	SPF version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters.BorderRouter.BorderRouterPath, self).__init__()

                                    self.yang_name = "border-router-path"
                                    self.yang_parent_name = "border-router"

                                    self.border_router_area_id = YLeaf(YType.str, "border-router-area-id")

                                    self.border_router_next_hop = YLeaf(YType.str, "border-router-next-hop")

                                    self.border_router_route_metric = YLeaf(YType.uint32, "border-router-route-metric")

                                    self.border_router_type = YLeaf(YType.enumeration, "border-router-type")

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.is_intra_area_router = YLeaf(YType.boolean, "is-intra-area-router")

                                    self.spf_version = YLeaf(YType.uint32, "spf-version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("border_router_area_id",
                                                    "border_router_next_hop",
                                                    "border_router_route_metric",
                                                    "border_router_type",
                                                    "interface_name",
                                                    "is_intra_area_router",
                                                    "spf_version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters.BorderRouter.BorderRouterPath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters.BorderRouter.BorderRouterPath, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.border_router_area_id.is_set or
                                        self.border_router_next_hop.is_set or
                                        self.border_router_route_metric.is_set or
                                        self.border_router_type.is_set or
                                        self.interface_name.is_set or
                                        self.is_intra_area_router.is_set or
                                        self.spf_version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.border_router_area_id.yfilter != YFilter.not_set or
                                        self.border_router_next_hop.yfilter != YFilter.not_set or
                                        self.border_router_route_metric.yfilter != YFilter.not_set or
                                        self.border_router_type.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.is_intra_area_router.yfilter != YFilter.not_set or
                                        self.spf_version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "border-router-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.border_router_area_id.is_set or self.border_router_area_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.border_router_area_id.get_name_leafdata())
                                    if (self.border_router_next_hop.is_set or self.border_router_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.border_router_next_hop.get_name_leafdata())
                                    if (self.border_router_route_metric.is_set or self.border_router_route_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.border_router_route_metric.get_name_leafdata())
                                    if (self.border_router_type.is_set or self.border_router_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.border_router_type.get_name_leafdata())
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.is_intra_area_router.is_set or self.is_intra_area_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_intra_area_router.get_name_leafdata())
                                    if (self.spf_version.is_set or self.spf_version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spf_version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "border-router-area-id" or name == "border-router-next-hop" or name == "border-router-route-metric" or name == "border-router-type" or name == "interface-name" or name == "is-intra-area-router" or name == "spf-version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "border-router-area-id"):
                                        self.border_router_area_id = value
                                        self.border_router_area_id.value_namespace = name_space
                                        self.border_router_area_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "border-router-next-hop"):
                                        self.border_router_next_hop = value
                                        self.border_router_next_hop.value_namespace = name_space
                                        self.border_router_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "border-router-route-metric"):
                                        self.border_router_route_metric = value
                                        self.border_router_route_metric.value_namespace = name_space
                                        self.border_router_route_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "border-router-type"):
                                        self.border_router_type = value
                                        self.border_router_type.value_namespace = name_space
                                        self.border_router_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-intra-area-router"):
                                        self.is_intra_area_router = value
                                        self.is_intra_area_router.value_namespace = name_space
                                        self.is_intra_area_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spf-version"):
                                        self.spf_version = value
                                        self.spf_version.value_namespace = name_space
                                        self.spf_version.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.border_router_path:
                                    if (c.has_data()):
                                        return True
                                return self.border_router_id.is_set

                            def has_operation(self):
                                for c in self.border_router_path:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.border_router_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "border-router" + "[border-router-id='" + self.border_router_id.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.border_router_id.is_set or self.border_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.border_router_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "border-router-path"):
                                    for c in self.border_router_path:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters.BorderRouter.BorderRouterPath()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.border_router_path.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "border-router-path" or name == "border-router-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "border-router-id"):
                                    self.border_router_id = value
                                    self.border_router_id.value_namespace = name_space
                                    self.border_router_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.border_router:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.border_router:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "border-routers" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "border-router"):
                                for c in self.border_router:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters.BorderRouter()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.border_router.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "border-router"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class ShamLinkTable(Entity):
                        """
                        Sham link information
                        
                        .. attribute:: is_sham_link_authentication_enabled
                        
                        	If true, sham link authentication is enabled 
                        	**type**\:  bool
                        
                        .. attribute:: is_sham_link_encryption_enabled
                        
                        	If true, sham link encryption is enabled 
                        	**type**\:  bool
                        
                        .. attribute:: is_sham_link_ip_security_active
                        
                        	If true, Sham link IP security is active 
                        	**type**\:  bool
                        
                        .. attribute:: is_sham_link_ip_security_required
                        
                        	If true, sham link IP security is required 
                        	**type**\:  bool
                        
                        .. attribute:: sham_link_area
                        
                        	Area id
                        	**type**\:  str
                        
                        .. attribute:: sham_link_authentication_transmit
                        
                        	Sham link authentication transmit 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: sham_link_cost
                        
                        	Cost of the sham link
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: sham_link_dc_bitless_lsa
                        
                        	Number of LSA's with demand circuit bit not set
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: sham_link_dead_interval
                        
                        	Dead interval (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: sham_link_demand_circuit
                        
                        	If true, the link runs as demand circuit
                        	**type**\:  bool
                        
                        .. attribute:: sham_link_dest_address
                        
                        	Sham\-link dest
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: sham_link_encrypted_authentication_transmitted
                        
                        	Sham link encrypted authentication transmitted 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: sham_link_encryption_spi
                        
                        	Sham link encryption spi
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: sham_link_encryption_transmitted
                        
                        	Sham link encryption transmitted 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: sham_link_gr
                        
                        	If true, Gracefule restart in progress
                        	**type**\:  bool
                        
                        .. attribute:: sham_link_gr_enabled
                        
                        	If true,  enabled
                        	**type**\:  bool
                        
                        .. attribute:: sham_link_hello_interval
                        
                        	Hello interval (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: sham_link_ifindex
                        
                        	Sham\-link ifindex
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: sham_link_last_gr
                        
                        	Time in seconds since last GR
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: sham_link_neighbor
                        
                        	Neighbor information
                        	**type**\:   :py:class:`ShamLinkNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor>`
                        
                        .. attribute:: sham_link_neighbor_id
                        
                        	Neighbor on other end of this sham link
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: sham_link_next_hello
                        
                        	Time until next hello (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: sham_link_passive
                        
                        	If true, interface is passive
                        	**type**\:  bool
                        
                        .. attribute:: sham_link_retransmission_interval
                        
                        	Retransmission interval (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: sham_link_source_address
                        
                        	Sham\-link source
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: sham_link_state
                        
                        	OSPF interface state for the sham link
                        	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                        
                        .. attribute:: sham_link_transmission_delay
                        
                        	Transmission delay in seconds
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: sham_link_wait_interval
                        
                        	Wait interval (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_authentication_spi
                        
                        	Sham link authentication spi 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable, self).__init__()

                            self.yang_name = "sham-link-table"
                            self.yang_parent_name = "vrf"

                            self.is_sham_link_authentication_enabled = YLeaf(YType.boolean, "is-sham-link-authentication-enabled")

                            self.is_sham_link_encryption_enabled = YLeaf(YType.boolean, "is-sham-link-encryption-enabled")

                            self.is_sham_link_ip_security_active = YLeaf(YType.boolean, "is-sham-link-ip-security-active")

                            self.is_sham_link_ip_security_required = YLeaf(YType.boolean, "is-sham-link-ip-security-required")

                            self.sham_link_area = YLeaf(YType.str, "sham-link-area")

                            self.sham_link_authentication_transmit = YLeaf(YType.uint32, "sham-link-authentication-transmit")

                            self.sham_link_cost = YLeaf(YType.uint16, "sham-link-cost")

                            self.sham_link_dc_bitless_lsa = YLeaf(YType.uint32, "sham-link-dc-bitless-lsa")

                            self.sham_link_dead_interval = YLeaf(YType.uint32, "sham-link-dead-interval")

                            self.sham_link_demand_circuit = YLeaf(YType.boolean, "sham-link-demand-circuit")

                            self.sham_link_dest_address = YLeaf(YType.str, "sham-link-dest-address")

                            self.sham_link_encrypted_authentication_transmitted = YLeaf(YType.uint32, "sham-link-encrypted-authentication-transmitted")

                            self.sham_link_encryption_spi = YLeaf(YType.uint32, "sham-link-encryption-spi")

                            self.sham_link_encryption_transmitted = YLeaf(YType.uint32, "sham-link-encryption-transmitted")

                            self.sham_link_gr = YLeaf(YType.boolean, "sham-link-gr")

                            self.sham_link_gr_enabled = YLeaf(YType.boolean, "sham-link-gr-enabled")

                            self.sham_link_hello_interval = YLeaf(YType.uint32, "sham-link-hello-interval")

                            self.sham_link_ifindex = YLeaf(YType.uint32, "sham-link-ifindex")

                            self.sham_link_last_gr = YLeaf(YType.uint32, "sham-link-last-gr")

                            self.sham_link_neighbor_id = YLeaf(YType.str, "sham-link-neighbor-id")

                            self.sham_link_next_hello = YLeaf(YType.uint32, "sham-link-next-hello")

                            self.sham_link_passive = YLeaf(YType.boolean, "sham-link-passive")

                            self.sham_link_retransmission_interval = YLeaf(YType.uint32, "sham-link-retransmission-interval")

                            self.sham_link_source_address = YLeaf(YType.str, "sham-link-source-address")

                            self.sham_link_state = YLeaf(YType.enumeration, "sham-link-state")

                            self.sham_link_transmission_delay = YLeaf(YType.uint16, "sham-link-transmission-delay")

                            self.sham_link_wait_interval = YLeaf(YType.uint32, "sham-link-wait-interval")

                            self.virtual_link_authentication_spi = YLeaf(YType.uint32, "virtual-link-authentication-spi")

                            self.sham_link_neighbor = Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor()
                            self.sham_link_neighbor.parent = self
                            self._children_name_map["sham_link_neighbor"] = "sham-link-neighbor"
                            self._children_yang_names.add("sham-link-neighbor")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_sham_link_authentication_enabled",
                                            "is_sham_link_encryption_enabled",
                                            "is_sham_link_ip_security_active",
                                            "is_sham_link_ip_security_required",
                                            "sham_link_area",
                                            "sham_link_authentication_transmit",
                                            "sham_link_cost",
                                            "sham_link_dc_bitless_lsa",
                                            "sham_link_dead_interval",
                                            "sham_link_demand_circuit",
                                            "sham_link_dest_address",
                                            "sham_link_encrypted_authentication_transmitted",
                                            "sham_link_encryption_spi",
                                            "sham_link_encryption_transmitted",
                                            "sham_link_gr",
                                            "sham_link_gr_enabled",
                                            "sham_link_hello_interval",
                                            "sham_link_ifindex",
                                            "sham_link_last_gr",
                                            "sham_link_neighbor_id",
                                            "sham_link_next_hello",
                                            "sham_link_passive",
                                            "sham_link_retransmission_interval",
                                            "sham_link_source_address",
                                            "sham_link_state",
                                            "sham_link_transmission_delay",
                                            "sham_link_wait_interval",
                                            "virtual_link_authentication_spi") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable, self).__setattr__(name, value)


                        class ShamLinkNeighbor(Entity):
                            """
                            Neighbor information
                            
                            .. attribute:: sham_link_retransmission
                            
                            	Neighbor retransmission info
                            	**type**\:   :py:class:`ShamLinkRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission>`
                            
                            .. attribute:: sham_link_state
                            
                            	Adjacency state
                            	**type**\:   :py:class:`Ospfv3NeighborState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3NeighborState>`
                            
                            .. attribute:: sham_link_suppress_hello
                            
                            	If true Hellos suppressed
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor, self).__init__()

                                self.yang_name = "sham-link-neighbor"
                                self.yang_parent_name = "sham-link-table"

                                self.sham_link_state = YLeaf(YType.enumeration, "sham-link-state")

                                self.sham_link_suppress_hello = YLeaf(YType.boolean, "sham-link-suppress-hello")

                                self.sham_link_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission()
                                self.sham_link_retransmission.parent = self
                                self._children_name_map["sham_link_retransmission"] = "sham-link-retransmission"
                                self._children_yang_names.add("sham-link-retransmission")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("sham_link_state",
                                                "sham_link_suppress_hello") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor, self).__setattr__(name, value)


                            class ShamLinkRetransmission(Entity):
                                """
                                Neighbor retransmission info
                                
                                .. attribute:: area_first_flood
                                
                                	First flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_first_flood_index
                                
                                	Index of the first flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_flood_index
                                
                                	Area scope LSA's flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_next_flood
                                
                                	Next flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_next_flood_index
                                
                                	Index of next flood item for Area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_first_flood
                                
                                	First flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_first_flood_index
                                
                                	Index for first flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_flood_index
                                
                                	AS scope LSA's flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_next_flood
                                
                                	Next flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_next_flood_index
                                
                                	Index of next flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: database_descriptor_retransmissions
                                
                                	Number of database descriptor retransmissions during last exchange
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_retransmission_length
                                
                                	Number of LSAs sent in last retransmission
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_retransmission_time
                                
                                	Last retransmission scan time (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_first_flood
                                
                                	Link first flood information 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_first_flood_index
                                
                                	Link first flood information index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_flood_index
                                
                                	Link flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_next_flood
                                
                                	Link next flood information 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_next_flood_index
                                
                                	Link next flood information index 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsa_retransmission_timer
                                
                                	Time until next LSA retransmission (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: maximum_retransmission_length
                                
                                	Maximum number of LSAs sent in a retransmission
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: maximum_retransmission_time
                                
                                	Maximum retransmission scan time (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_retransmissions
                                
                                	Number of neighbor retransmissions 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: retransmissions
                                
                                	Number of retransmissions for this neighbor
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission, self).__init__()

                                    self.yang_name = "sham-link-retransmission"
                                    self.yang_parent_name = "sham-link-neighbor"

                                    self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                    self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                    self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                    self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                    self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                    self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                    self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                    self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                    self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                    self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                    self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                    self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                    self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                    self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                    self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                    self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                    self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                    self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                    self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                    self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                    self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                    self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                    self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("area_first_flood",
                                                    "area_first_flood_index",
                                                    "area_flood_index",
                                                    "area_next_flood",
                                                    "area_next_flood_index",
                                                    "as_first_flood",
                                                    "as_first_flood_index",
                                                    "as_flood_index",
                                                    "as_next_flood",
                                                    "as_next_flood_index",
                                                    "database_descriptor_retransmissions",
                                                    "last_retransmission_length",
                                                    "last_retransmission_time",
                                                    "link_first_flood",
                                                    "link_first_flood_index",
                                                    "link_flood_index",
                                                    "link_next_flood",
                                                    "link_next_flood_index",
                                                    "lsa_retransmission_timer",
                                                    "maximum_retransmission_length",
                                                    "maximum_retransmission_time",
                                                    "neighbor_retransmissions",
                                                    "retransmissions") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.area_first_flood.is_set or
                                        self.area_first_flood_index.is_set or
                                        self.area_flood_index.is_set or
                                        self.area_next_flood.is_set or
                                        self.area_next_flood_index.is_set or
                                        self.as_first_flood.is_set or
                                        self.as_first_flood_index.is_set or
                                        self.as_flood_index.is_set or
                                        self.as_next_flood.is_set or
                                        self.as_next_flood_index.is_set or
                                        self.database_descriptor_retransmissions.is_set or
                                        self.last_retransmission_length.is_set or
                                        self.last_retransmission_time.is_set or
                                        self.link_first_flood.is_set or
                                        self.link_first_flood_index.is_set or
                                        self.link_flood_index.is_set or
                                        self.link_next_flood.is_set or
                                        self.link_next_flood_index.is_set or
                                        self.lsa_retransmission_timer.is_set or
                                        self.maximum_retransmission_length.is_set or
                                        self.maximum_retransmission_time.is_set or
                                        self.neighbor_retransmissions.is_set or
                                        self.retransmissions.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.area_first_flood.yfilter != YFilter.not_set or
                                        self.area_first_flood_index.yfilter != YFilter.not_set or
                                        self.area_flood_index.yfilter != YFilter.not_set or
                                        self.area_next_flood.yfilter != YFilter.not_set or
                                        self.area_next_flood_index.yfilter != YFilter.not_set or
                                        self.as_first_flood.yfilter != YFilter.not_set or
                                        self.as_first_flood_index.yfilter != YFilter.not_set or
                                        self.as_flood_index.yfilter != YFilter.not_set or
                                        self.as_next_flood.yfilter != YFilter.not_set or
                                        self.as_next_flood_index.yfilter != YFilter.not_set or
                                        self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                        self.last_retransmission_length.yfilter != YFilter.not_set or
                                        self.last_retransmission_time.yfilter != YFilter.not_set or
                                        self.link_first_flood.yfilter != YFilter.not_set or
                                        self.link_first_flood_index.yfilter != YFilter.not_set or
                                        self.link_flood_index.yfilter != YFilter.not_set or
                                        self.link_next_flood.yfilter != YFilter.not_set or
                                        self.link_next_flood_index.yfilter != YFilter.not_set or
                                        self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                        self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                        self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                        self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                        self.retransmissions.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sham-link-retransmission" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                    if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                    if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                    if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                    if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                    if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                    if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                    if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                    if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                    if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                    if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                    if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                    if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                    if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                    if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                    if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                    if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                    if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                    if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                    if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                    if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                    if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                    if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "area-first-flood"):
                                        self.area_first_flood = value
                                        self.area_first_flood.value_namespace = name_space
                                        self.area_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-first-flood-index"):
                                        self.area_first_flood_index = value
                                        self.area_first_flood_index.value_namespace = name_space
                                        self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-flood-index"):
                                        self.area_flood_index = value
                                        self.area_flood_index.value_namespace = name_space
                                        self.area_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-next-flood"):
                                        self.area_next_flood = value
                                        self.area_next_flood.value_namespace = name_space
                                        self.area_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-next-flood-index"):
                                        self.area_next_flood_index = value
                                        self.area_next_flood_index.value_namespace = name_space
                                        self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-first-flood"):
                                        self.as_first_flood = value
                                        self.as_first_flood.value_namespace = name_space
                                        self.as_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-first-flood-index"):
                                        self.as_first_flood_index = value
                                        self.as_first_flood_index.value_namespace = name_space
                                        self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-flood-index"):
                                        self.as_flood_index = value
                                        self.as_flood_index.value_namespace = name_space
                                        self.as_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-next-flood"):
                                        self.as_next_flood = value
                                        self.as_next_flood.value_namespace = name_space
                                        self.as_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-next-flood-index"):
                                        self.as_next_flood_index = value
                                        self.as_next_flood_index.value_namespace = name_space
                                        self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "database-descriptor-retransmissions"):
                                        self.database_descriptor_retransmissions = value
                                        self.database_descriptor_retransmissions.value_namespace = name_space
                                        self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-retransmission-length"):
                                        self.last_retransmission_length = value
                                        self.last_retransmission_length.value_namespace = name_space
                                        self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-retransmission-time"):
                                        self.last_retransmission_time = value
                                        self.last_retransmission_time.value_namespace = name_space
                                        self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-first-flood"):
                                        self.link_first_flood = value
                                        self.link_first_flood.value_namespace = name_space
                                        self.link_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-first-flood-index"):
                                        self.link_first_flood_index = value
                                        self.link_first_flood_index.value_namespace = name_space
                                        self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-flood-index"):
                                        self.link_flood_index = value
                                        self.link_flood_index.value_namespace = name_space
                                        self.link_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-next-flood"):
                                        self.link_next_flood = value
                                        self.link_next_flood.value_namespace = name_space
                                        self.link_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-next-flood-index"):
                                        self.link_next_flood_index = value
                                        self.link_next_flood_index.value_namespace = name_space
                                        self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsa-retransmission-timer"):
                                        self.lsa_retransmission_timer = value
                                        self.lsa_retransmission_timer.value_namespace = name_space
                                        self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "maximum-retransmission-length"):
                                        self.maximum_retransmission_length = value
                                        self.maximum_retransmission_length.value_namespace = name_space
                                        self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "maximum-retransmission-time"):
                                        self.maximum_retransmission_time = value
                                        self.maximum_retransmission_time.value_namespace = name_space
                                        self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-retransmissions"):
                                        self.neighbor_retransmissions = value
                                        self.neighbor_retransmissions.value_namespace = name_space
                                        self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                    if(value_path == "retransmissions"):
                                        self.retransmissions = value
                                        self.retransmissions.value_namespace = name_space
                                        self.retransmissions.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.sham_link_state.is_set or
                                    self.sham_link_suppress_hello.is_set or
                                    (self.sham_link_retransmission is not None and self.sham_link_retransmission.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.sham_link_state.yfilter != YFilter.not_set or
                                    self.sham_link_suppress_hello.yfilter != YFilter.not_set or
                                    (self.sham_link_retransmission is not None and self.sham_link_retransmission.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sham-link-neighbor" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.sham_link_state.is_set or self.sham_link_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sham_link_state.get_name_leafdata())
                                if (self.sham_link_suppress_hello.is_set or self.sham_link_suppress_hello.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sham_link_suppress_hello.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sham-link-retransmission"):
                                    if (self.sham_link_retransmission is None):
                                        self.sham_link_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission()
                                        self.sham_link_retransmission.parent = self
                                        self._children_name_map["sham_link_retransmission"] = "sham-link-retransmission"
                                    return self.sham_link_retransmission

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sham-link-retransmission" or name == "sham-link-state" or name == "sham-link-suppress-hello"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "sham-link-state"):
                                    self.sham_link_state = value
                                    self.sham_link_state.value_namespace = name_space
                                    self.sham_link_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "sham-link-suppress-hello"):
                                    self.sham_link_suppress_hello = value
                                    self.sham_link_suppress_hello.value_namespace = name_space
                                    self.sham_link_suppress_hello.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.is_sham_link_authentication_enabled.is_set or
                                self.is_sham_link_encryption_enabled.is_set or
                                self.is_sham_link_ip_security_active.is_set or
                                self.is_sham_link_ip_security_required.is_set or
                                self.sham_link_area.is_set or
                                self.sham_link_authentication_transmit.is_set or
                                self.sham_link_cost.is_set or
                                self.sham_link_dc_bitless_lsa.is_set or
                                self.sham_link_dead_interval.is_set or
                                self.sham_link_demand_circuit.is_set or
                                self.sham_link_dest_address.is_set or
                                self.sham_link_encrypted_authentication_transmitted.is_set or
                                self.sham_link_encryption_spi.is_set or
                                self.sham_link_encryption_transmitted.is_set or
                                self.sham_link_gr.is_set or
                                self.sham_link_gr_enabled.is_set or
                                self.sham_link_hello_interval.is_set or
                                self.sham_link_ifindex.is_set or
                                self.sham_link_last_gr.is_set or
                                self.sham_link_neighbor_id.is_set or
                                self.sham_link_next_hello.is_set or
                                self.sham_link_passive.is_set or
                                self.sham_link_retransmission_interval.is_set or
                                self.sham_link_source_address.is_set or
                                self.sham_link_state.is_set or
                                self.sham_link_transmission_delay.is_set or
                                self.sham_link_wait_interval.is_set or
                                self.virtual_link_authentication_spi.is_set or
                                (self.sham_link_neighbor is not None and self.sham_link_neighbor.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_sham_link_authentication_enabled.yfilter != YFilter.not_set or
                                self.is_sham_link_encryption_enabled.yfilter != YFilter.not_set or
                                self.is_sham_link_ip_security_active.yfilter != YFilter.not_set or
                                self.is_sham_link_ip_security_required.yfilter != YFilter.not_set or
                                self.sham_link_area.yfilter != YFilter.not_set or
                                self.sham_link_authentication_transmit.yfilter != YFilter.not_set or
                                self.sham_link_cost.yfilter != YFilter.not_set or
                                self.sham_link_dc_bitless_lsa.yfilter != YFilter.not_set or
                                self.sham_link_dead_interval.yfilter != YFilter.not_set or
                                self.sham_link_demand_circuit.yfilter != YFilter.not_set or
                                self.sham_link_dest_address.yfilter != YFilter.not_set or
                                self.sham_link_encrypted_authentication_transmitted.yfilter != YFilter.not_set or
                                self.sham_link_encryption_spi.yfilter != YFilter.not_set or
                                self.sham_link_encryption_transmitted.yfilter != YFilter.not_set or
                                self.sham_link_gr.yfilter != YFilter.not_set or
                                self.sham_link_gr_enabled.yfilter != YFilter.not_set or
                                self.sham_link_hello_interval.yfilter != YFilter.not_set or
                                self.sham_link_ifindex.yfilter != YFilter.not_set or
                                self.sham_link_last_gr.yfilter != YFilter.not_set or
                                self.sham_link_neighbor_id.yfilter != YFilter.not_set or
                                self.sham_link_next_hello.yfilter != YFilter.not_set or
                                self.sham_link_passive.yfilter != YFilter.not_set or
                                self.sham_link_retransmission_interval.yfilter != YFilter.not_set or
                                self.sham_link_source_address.yfilter != YFilter.not_set or
                                self.sham_link_state.yfilter != YFilter.not_set or
                                self.sham_link_transmission_delay.yfilter != YFilter.not_set or
                                self.sham_link_wait_interval.yfilter != YFilter.not_set or
                                self.virtual_link_authentication_spi.yfilter != YFilter.not_set or
                                (self.sham_link_neighbor is not None and self.sham_link_neighbor.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sham-link-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_sham_link_authentication_enabled.is_set or self.is_sham_link_authentication_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_sham_link_authentication_enabled.get_name_leafdata())
                            if (self.is_sham_link_encryption_enabled.is_set or self.is_sham_link_encryption_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_sham_link_encryption_enabled.get_name_leafdata())
                            if (self.is_sham_link_ip_security_active.is_set or self.is_sham_link_ip_security_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_sham_link_ip_security_active.get_name_leafdata())
                            if (self.is_sham_link_ip_security_required.is_set or self.is_sham_link_ip_security_required.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_sham_link_ip_security_required.get_name_leafdata())
                            if (self.sham_link_area.is_set or self.sham_link_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_area.get_name_leafdata())
                            if (self.sham_link_authentication_transmit.is_set or self.sham_link_authentication_transmit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_authentication_transmit.get_name_leafdata())
                            if (self.sham_link_cost.is_set or self.sham_link_cost.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_cost.get_name_leafdata())
                            if (self.sham_link_dc_bitless_lsa.is_set or self.sham_link_dc_bitless_lsa.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_dc_bitless_lsa.get_name_leafdata())
                            if (self.sham_link_dead_interval.is_set or self.sham_link_dead_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_dead_interval.get_name_leafdata())
                            if (self.sham_link_demand_circuit.is_set or self.sham_link_demand_circuit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_demand_circuit.get_name_leafdata())
                            if (self.sham_link_dest_address.is_set or self.sham_link_dest_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_dest_address.get_name_leafdata())
                            if (self.sham_link_encrypted_authentication_transmitted.is_set or self.sham_link_encrypted_authentication_transmitted.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_encrypted_authentication_transmitted.get_name_leafdata())
                            if (self.sham_link_encryption_spi.is_set or self.sham_link_encryption_spi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_encryption_spi.get_name_leafdata())
                            if (self.sham_link_encryption_transmitted.is_set or self.sham_link_encryption_transmitted.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_encryption_transmitted.get_name_leafdata())
                            if (self.sham_link_gr.is_set or self.sham_link_gr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_gr.get_name_leafdata())
                            if (self.sham_link_gr_enabled.is_set or self.sham_link_gr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_gr_enabled.get_name_leafdata())
                            if (self.sham_link_hello_interval.is_set or self.sham_link_hello_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_hello_interval.get_name_leafdata())
                            if (self.sham_link_ifindex.is_set or self.sham_link_ifindex.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_ifindex.get_name_leafdata())
                            if (self.sham_link_last_gr.is_set or self.sham_link_last_gr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_last_gr.get_name_leafdata())
                            if (self.sham_link_neighbor_id.is_set or self.sham_link_neighbor_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_neighbor_id.get_name_leafdata())
                            if (self.sham_link_next_hello.is_set or self.sham_link_next_hello.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_next_hello.get_name_leafdata())
                            if (self.sham_link_passive.is_set or self.sham_link_passive.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_passive.get_name_leafdata())
                            if (self.sham_link_retransmission_interval.is_set or self.sham_link_retransmission_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_retransmission_interval.get_name_leafdata())
                            if (self.sham_link_source_address.is_set or self.sham_link_source_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_source_address.get_name_leafdata())
                            if (self.sham_link_state.is_set or self.sham_link_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_state.get_name_leafdata())
                            if (self.sham_link_transmission_delay.is_set or self.sham_link_transmission_delay.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_transmission_delay.get_name_leafdata())
                            if (self.sham_link_wait_interval.is_set or self.sham_link_wait_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_wait_interval.get_name_leafdata())
                            if (self.virtual_link_authentication_spi.is_set or self.virtual_link_authentication_spi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_authentication_spi.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "sham-link-neighbor"):
                                if (self.sham_link_neighbor is None):
                                    self.sham_link_neighbor = Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable.ShamLinkNeighbor()
                                    self.sham_link_neighbor.parent = self
                                    self._children_name_map["sham_link_neighbor"] = "sham-link-neighbor"
                                return self.sham_link_neighbor

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sham-link-neighbor" or name == "is-sham-link-authentication-enabled" or name == "is-sham-link-encryption-enabled" or name == "is-sham-link-ip-security-active" or name == "is-sham-link-ip-security-required" or name == "sham-link-area" or name == "sham-link-authentication-transmit" or name == "sham-link-cost" or name == "sham-link-dc-bitless-lsa" or name == "sham-link-dead-interval" or name == "sham-link-demand-circuit" or name == "sham-link-dest-address" or name == "sham-link-encrypted-authentication-transmitted" or name == "sham-link-encryption-spi" or name == "sham-link-encryption-transmitted" or name == "sham-link-gr" or name == "sham-link-gr-enabled" or name == "sham-link-hello-interval" or name == "sham-link-ifindex" or name == "sham-link-last-gr" or name == "sham-link-neighbor-id" or name == "sham-link-next-hello" or name == "sham-link-passive" or name == "sham-link-retransmission-interval" or name == "sham-link-source-address" or name == "sham-link-state" or name == "sham-link-transmission-delay" or name == "sham-link-wait-interval" or name == "virtual-link-authentication-spi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-sham-link-authentication-enabled"):
                                self.is_sham_link_authentication_enabled = value
                                self.is_sham_link_authentication_enabled.value_namespace = name_space
                                self.is_sham_link_authentication_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-sham-link-encryption-enabled"):
                                self.is_sham_link_encryption_enabled = value
                                self.is_sham_link_encryption_enabled.value_namespace = name_space
                                self.is_sham_link_encryption_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-sham-link-ip-security-active"):
                                self.is_sham_link_ip_security_active = value
                                self.is_sham_link_ip_security_active.value_namespace = name_space
                                self.is_sham_link_ip_security_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-sham-link-ip-security-required"):
                                self.is_sham_link_ip_security_required = value
                                self.is_sham_link_ip_security_required.value_namespace = name_space
                                self.is_sham_link_ip_security_required.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-area"):
                                self.sham_link_area = value
                                self.sham_link_area.value_namespace = name_space
                                self.sham_link_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-authentication-transmit"):
                                self.sham_link_authentication_transmit = value
                                self.sham_link_authentication_transmit.value_namespace = name_space
                                self.sham_link_authentication_transmit.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-cost"):
                                self.sham_link_cost = value
                                self.sham_link_cost.value_namespace = name_space
                                self.sham_link_cost.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-dc-bitless-lsa"):
                                self.sham_link_dc_bitless_lsa = value
                                self.sham_link_dc_bitless_lsa.value_namespace = name_space
                                self.sham_link_dc_bitless_lsa.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-dead-interval"):
                                self.sham_link_dead_interval = value
                                self.sham_link_dead_interval.value_namespace = name_space
                                self.sham_link_dead_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-demand-circuit"):
                                self.sham_link_demand_circuit = value
                                self.sham_link_demand_circuit.value_namespace = name_space
                                self.sham_link_demand_circuit.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-dest-address"):
                                self.sham_link_dest_address = value
                                self.sham_link_dest_address.value_namespace = name_space
                                self.sham_link_dest_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-encrypted-authentication-transmitted"):
                                self.sham_link_encrypted_authentication_transmitted = value
                                self.sham_link_encrypted_authentication_transmitted.value_namespace = name_space
                                self.sham_link_encrypted_authentication_transmitted.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-encryption-spi"):
                                self.sham_link_encryption_spi = value
                                self.sham_link_encryption_spi.value_namespace = name_space
                                self.sham_link_encryption_spi.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-encryption-transmitted"):
                                self.sham_link_encryption_transmitted = value
                                self.sham_link_encryption_transmitted.value_namespace = name_space
                                self.sham_link_encryption_transmitted.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-gr"):
                                self.sham_link_gr = value
                                self.sham_link_gr.value_namespace = name_space
                                self.sham_link_gr.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-gr-enabled"):
                                self.sham_link_gr_enabled = value
                                self.sham_link_gr_enabled.value_namespace = name_space
                                self.sham_link_gr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-hello-interval"):
                                self.sham_link_hello_interval = value
                                self.sham_link_hello_interval.value_namespace = name_space
                                self.sham_link_hello_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-ifindex"):
                                self.sham_link_ifindex = value
                                self.sham_link_ifindex.value_namespace = name_space
                                self.sham_link_ifindex.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-last-gr"):
                                self.sham_link_last_gr = value
                                self.sham_link_last_gr.value_namespace = name_space
                                self.sham_link_last_gr.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-neighbor-id"):
                                self.sham_link_neighbor_id = value
                                self.sham_link_neighbor_id.value_namespace = name_space
                                self.sham_link_neighbor_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-next-hello"):
                                self.sham_link_next_hello = value
                                self.sham_link_next_hello.value_namespace = name_space
                                self.sham_link_next_hello.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-passive"):
                                self.sham_link_passive = value
                                self.sham_link_passive.value_namespace = name_space
                                self.sham_link_passive.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-retransmission-interval"):
                                self.sham_link_retransmission_interval = value
                                self.sham_link_retransmission_interval.value_namespace = name_space
                                self.sham_link_retransmission_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-source-address"):
                                self.sham_link_source_address = value
                                self.sham_link_source_address.value_namespace = name_space
                                self.sham_link_source_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-state"):
                                self.sham_link_state = value
                                self.sham_link_state.value_namespace = name_space
                                self.sham_link_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-transmission-delay"):
                                self.sham_link_transmission_delay = value
                                self.sham_link_transmission_delay.value_namespace = name_space
                                self.sham_link_transmission_delay.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-wait-interval"):
                                self.sham_link_wait_interval = value
                                self.sham_link_wait_interval.value_namespace = name_space
                                self.sham_link_wait_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-authentication-spi"):
                                self.virtual_link_authentication_spi = value
                                self.virtual_link_authentication_spi.value_namespace = name_space
                                self.virtual_link_authentication_spi.value_namespace_prefix = name_space_prefix


                    class AreaInformations(Entity):
                        """
                        OSPFv3 area information table
                        
                        .. attribute:: area_information
                        
                        	OSPFv3 area information
                        	**type**\: list of    :py:class:`AreaInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations.AreaInformation>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations, self).__init__()

                            self.yang_name = "area-informations"
                            self.yang_parent_name = "vrf"

                            self.area_information = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations, self).__setattr__(name, value)


                        class AreaInformation(Entity):
                            """
                            OSPFv3 area information
                            
                            .. attribute:: area_id  <key>
                            
                            	Area ID
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: area_dc_bitless_ls_as
                            
                            	Number of LSA with demand circuit bit not set
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_interfaces
                            
                            	Number of interfaces in the area
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: area_lfa_interface_count
                            
                            	Number of LFA enabled interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_lfa_revision
                            
                            	Area LFA revision
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_opaque_lsa_checksum
                            
                            	Sum of opaque LSA checksums
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_opaque_lsas
                            
                            	Number of opaque LSAs in the area
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_per_prefix_lfa_interface_count
                            
                            	Number of Per Prefix LFA enabled interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_range
                            
                            	List of ranges to summarize
                            	**type**\: list of    :py:class:`AreaRange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations.AreaInformation.AreaRange>`
                            
                            .. attribute:: do_not_age_ls_as
                            
                            	Number of do not age LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flood_list_length
                            
                            	Number of LSAs which need to be flooded
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: indication_ls_as
                            
                            	Number of indication LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: is_area_nssa
                            
                            	If true, area is a NSSA
                            	**type**\:  bool
                            
                            .. attribute:: is_area_stubbed
                            
                            	If true, stub area
                            	**type**\:  bool
                            
                            .. attribute:: is_area_total_stubbed
                            
                            	If true, totally stubby area
                            	**type**\:  bool
                            
                            .. attribute:: is_backbone_area_active
                            
                            	If true, Backbone area is active
                            	**type**\:  bool
                            
                            .. attribute:: is_nssa_default
                            
                            	If true, generate NSSA default route
                            	**type**\:  bool
                            
                            .. attribute:: is_nssa_translated
                            
                            	If true, perform 7/5 translation
                            	**type**\:  bool
                            
                            .. attribute:: is_rrr_enabled
                            
                            	If true, RRR is enabled
                            	**type**\:  bool
                            
                            .. attribute:: nssa_no_redistribution
                            
                            	If true, No redistribution into this NSSA area
                            	**type**\:  bool
                            
                            .. attribute:: sp_fs
                            
                            	Number of SPF calculations run
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: stub_default_cost
                            
                            	Default cost for Stub or NSSA area
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations.AreaInformation, self).__init__()

                                self.yang_name = "area-information"
                                self.yang_parent_name = "area-informations"

                                self.area_id = YLeaf(YType.int32, "area-id")

                                self.area_dc_bitless_ls_as = YLeaf(YType.uint32, "area-dc-bitless-ls-as")

                                self.area_interfaces = YLeaf(YType.uint16, "area-interfaces")

                                self.area_lfa_interface_count = YLeaf(YType.uint32, "area-lfa-interface-count")

                                self.area_lfa_revision = YLeaf(YType.uint32, "area-lfa-revision")

                                self.area_opaque_lsa_checksum = YLeaf(YType.uint32, "area-opaque-lsa-checksum")

                                self.area_opaque_lsas = YLeaf(YType.uint32, "area-opaque-lsas")

                                self.area_per_prefix_lfa_interface_count = YLeaf(YType.uint32, "area-per-prefix-lfa-interface-count")

                                self.do_not_age_ls_as = YLeaf(YType.uint32, "do-not-age-ls-as")

                                self.flood_list_length = YLeaf(YType.uint32, "flood-list-length")

                                self.indication_ls_as = YLeaf(YType.uint32, "indication-ls-as")

                                self.is_area_nssa = YLeaf(YType.boolean, "is-area-nssa")

                                self.is_area_stubbed = YLeaf(YType.boolean, "is-area-stubbed")

                                self.is_area_total_stubbed = YLeaf(YType.boolean, "is-area-total-stubbed")

                                self.is_backbone_area_active = YLeaf(YType.boolean, "is-backbone-area-active")

                                self.is_nssa_default = YLeaf(YType.boolean, "is-nssa-default")

                                self.is_nssa_translated = YLeaf(YType.boolean, "is-nssa-translated")

                                self.is_rrr_enabled = YLeaf(YType.boolean, "is-rrr-enabled")

                                self.nssa_no_redistribution = YLeaf(YType.boolean, "nssa-no-redistribution")

                                self.sp_fs = YLeaf(YType.uint32, "sp-fs")

                                self.stub_default_cost = YLeaf(YType.uint16, "stub-default-cost")

                                self.area_range = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("area_id",
                                                "area_dc_bitless_ls_as",
                                                "area_interfaces",
                                                "area_lfa_interface_count",
                                                "area_lfa_revision",
                                                "area_opaque_lsa_checksum",
                                                "area_opaque_lsas",
                                                "area_per_prefix_lfa_interface_count",
                                                "do_not_age_ls_as",
                                                "flood_list_length",
                                                "indication_ls_as",
                                                "is_area_nssa",
                                                "is_area_stubbed",
                                                "is_area_total_stubbed",
                                                "is_backbone_area_active",
                                                "is_nssa_default",
                                                "is_nssa_translated",
                                                "is_rrr_enabled",
                                                "nssa_no_redistribution",
                                                "sp_fs",
                                                "stub_default_cost") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations.AreaInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations.AreaInformation, self).__setattr__(name, value)


                            class AreaRange(Entity):
                                """
                                List of ranges to summarize
                                
                                .. attribute:: is_cost_configured
                                
                                	If true, cost is configured 
                                	**type**\:  bool
                                
                                .. attribute:: net_cost
                                
                                	Net cost 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: range_prefix
                                
                                	IP prefix for summarization
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: range_prefix_length
                                
                                	IP prefix length for summarization
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: status
                                
                                	Area range status 
                                	**type**\:   :py:class:`Ospfv3AreaRangeStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3AreaRangeStatus>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations.AreaInformation.AreaRange, self).__init__()

                                    self.yang_name = "area-range"
                                    self.yang_parent_name = "area-information"

                                    self.is_cost_configured = YLeaf(YType.boolean, "is-cost-configured")

                                    self.net_cost = YLeaf(YType.uint32, "net-cost")

                                    self.range_prefix = YLeaf(YType.str, "range-prefix")

                                    self.range_prefix_length = YLeaf(YType.uint32, "range-prefix-length")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_cost_configured",
                                                    "net_cost",
                                                    "range_prefix",
                                                    "range_prefix_length",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations.AreaInformation.AreaRange, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations.AreaInformation.AreaRange, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_cost_configured.is_set or
                                        self.net_cost.is_set or
                                        self.range_prefix.is_set or
                                        self.range_prefix_length.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_cost_configured.yfilter != YFilter.not_set or
                                        self.net_cost.yfilter != YFilter.not_set or
                                        self.range_prefix.yfilter != YFilter.not_set or
                                        self.range_prefix_length.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "area-range" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_cost_configured.is_set or self.is_cost_configured.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_cost_configured.get_name_leafdata())
                                    if (self.net_cost.is_set or self.net_cost.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.net_cost.get_name_leafdata())
                                    if (self.range_prefix.is_set or self.range_prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.range_prefix.get_name_leafdata())
                                    if (self.range_prefix_length.is_set or self.range_prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.range_prefix_length.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-cost-configured" or name == "net-cost" or name == "range-prefix" or name == "range-prefix-length" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-cost-configured"):
                                        self.is_cost_configured = value
                                        self.is_cost_configured.value_namespace = name_space
                                        self.is_cost_configured.value_namespace_prefix = name_space_prefix
                                    if(value_path == "net-cost"):
                                        self.net_cost = value
                                        self.net_cost.value_namespace = name_space
                                        self.net_cost.value_namespace_prefix = name_space_prefix
                                    if(value_path == "range-prefix"):
                                        self.range_prefix = value
                                        self.range_prefix.value_namespace = name_space
                                        self.range_prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "range-prefix-length"):
                                        self.range_prefix_length = value
                                        self.range_prefix_length.value_namespace = name_space
                                        self.range_prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.area_range:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.area_id.is_set or
                                    self.area_dc_bitless_ls_as.is_set or
                                    self.area_interfaces.is_set or
                                    self.area_lfa_interface_count.is_set or
                                    self.area_lfa_revision.is_set or
                                    self.area_opaque_lsa_checksum.is_set or
                                    self.area_opaque_lsas.is_set or
                                    self.area_per_prefix_lfa_interface_count.is_set or
                                    self.do_not_age_ls_as.is_set or
                                    self.flood_list_length.is_set or
                                    self.indication_ls_as.is_set or
                                    self.is_area_nssa.is_set or
                                    self.is_area_stubbed.is_set or
                                    self.is_area_total_stubbed.is_set or
                                    self.is_backbone_area_active.is_set or
                                    self.is_nssa_default.is_set or
                                    self.is_nssa_translated.is_set or
                                    self.is_rrr_enabled.is_set or
                                    self.nssa_no_redistribution.is_set or
                                    self.sp_fs.is_set or
                                    self.stub_default_cost.is_set)

                            def has_operation(self):
                                for c in self.area_range:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.area_id.yfilter != YFilter.not_set or
                                    self.area_dc_bitless_ls_as.yfilter != YFilter.not_set or
                                    self.area_interfaces.yfilter != YFilter.not_set or
                                    self.area_lfa_interface_count.yfilter != YFilter.not_set or
                                    self.area_lfa_revision.yfilter != YFilter.not_set or
                                    self.area_opaque_lsa_checksum.yfilter != YFilter.not_set or
                                    self.area_opaque_lsas.yfilter != YFilter.not_set or
                                    self.area_per_prefix_lfa_interface_count.yfilter != YFilter.not_set or
                                    self.do_not_age_ls_as.yfilter != YFilter.not_set or
                                    self.flood_list_length.yfilter != YFilter.not_set or
                                    self.indication_ls_as.yfilter != YFilter.not_set or
                                    self.is_area_nssa.yfilter != YFilter.not_set or
                                    self.is_area_stubbed.yfilter != YFilter.not_set or
                                    self.is_area_total_stubbed.yfilter != YFilter.not_set or
                                    self.is_backbone_area_active.yfilter != YFilter.not_set or
                                    self.is_nssa_default.yfilter != YFilter.not_set or
                                    self.is_nssa_translated.yfilter != YFilter.not_set or
                                    self.is_rrr_enabled.yfilter != YFilter.not_set or
                                    self.nssa_no_redistribution.yfilter != YFilter.not_set or
                                    self.sp_fs.yfilter != YFilter.not_set or
                                    self.stub_default_cost.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "area-information" + "[area-id='" + self.area_id.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_id.get_name_leafdata())
                                if (self.area_dc_bitless_ls_as.is_set or self.area_dc_bitless_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_dc_bitless_ls_as.get_name_leafdata())
                                if (self.area_interfaces.is_set or self.area_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_interfaces.get_name_leafdata())
                                if (self.area_lfa_interface_count.is_set or self.area_lfa_interface_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_lfa_interface_count.get_name_leafdata())
                                if (self.area_lfa_revision.is_set or self.area_lfa_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_lfa_revision.get_name_leafdata())
                                if (self.area_opaque_lsa_checksum.is_set or self.area_opaque_lsa_checksum.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_opaque_lsa_checksum.get_name_leafdata())
                                if (self.area_opaque_lsas.is_set or self.area_opaque_lsas.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_opaque_lsas.get_name_leafdata())
                                if (self.area_per_prefix_lfa_interface_count.is_set or self.area_per_prefix_lfa_interface_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_per_prefix_lfa_interface_count.get_name_leafdata())
                                if (self.do_not_age_ls_as.is_set or self.do_not_age_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.do_not_age_ls_as.get_name_leafdata())
                                if (self.flood_list_length.is_set or self.flood_list_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.flood_list_length.get_name_leafdata())
                                if (self.indication_ls_as.is_set or self.indication_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.indication_ls_as.get_name_leafdata())
                                if (self.is_area_nssa.is_set or self.is_area_nssa.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_area_nssa.get_name_leafdata())
                                if (self.is_area_stubbed.is_set or self.is_area_stubbed.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_area_stubbed.get_name_leafdata())
                                if (self.is_area_total_stubbed.is_set or self.is_area_total_stubbed.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_area_total_stubbed.get_name_leafdata())
                                if (self.is_backbone_area_active.is_set or self.is_backbone_area_active.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_backbone_area_active.get_name_leafdata())
                                if (self.is_nssa_default.is_set or self.is_nssa_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_nssa_default.get_name_leafdata())
                                if (self.is_nssa_translated.is_set or self.is_nssa_translated.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_nssa_translated.get_name_leafdata())
                                if (self.is_rrr_enabled.is_set or self.is_rrr_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_rrr_enabled.get_name_leafdata())
                                if (self.nssa_no_redistribution.is_set or self.nssa_no_redistribution.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nssa_no_redistribution.get_name_leafdata())
                                if (self.sp_fs.is_set or self.sp_fs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_fs.get_name_leafdata())
                                if (self.stub_default_cost.is_set or self.stub_default_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.stub_default_cost.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "area-range"):
                                    for c in self.area_range:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations.AreaInformation.AreaRange()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.area_range.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "area-range" or name == "area-id" or name == "area-dc-bitless-ls-as" or name == "area-interfaces" or name == "area-lfa-interface-count" or name == "area-lfa-revision" or name == "area-opaque-lsa-checksum" or name == "area-opaque-lsas" or name == "area-per-prefix-lfa-interface-count" or name == "do-not-age-ls-as" or name == "flood-list-length" or name == "indication-ls-as" or name == "is-area-nssa" or name == "is-area-stubbed" or name == "is-area-total-stubbed" or name == "is-backbone-area-active" or name == "is-nssa-default" or name == "is-nssa-translated" or name == "is-rrr-enabled" or name == "nssa-no-redistribution" or name == "sp-fs" or name == "stub-default-cost"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "area-id"):
                                    self.area_id = value
                                    self.area_id.value_namespace = name_space
                                    self.area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-dc-bitless-ls-as"):
                                    self.area_dc_bitless_ls_as = value
                                    self.area_dc_bitless_ls_as.value_namespace = name_space
                                    self.area_dc_bitless_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-interfaces"):
                                    self.area_interfaces = value
                                    self.area_interfaces.value_namespace = name_space
                                    self.area_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-lfa-interface-count"):
                                    self.area_lfa_interface_count = value
                                    self.area_lfa_interface_count.value_namespace = name_space
                                    self.area_lfa_interface_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-lfa-revision"):
                                    self.area_lfa_revision = value
                                    self.area_lfa_revision.value_namespace = name_space
                                    self.area_lfa_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-opaque-lsa-checksum"):
                                    self.area_opaque_lsa_checksum = value
                                    self.area_opaque_lsa_checksum.value_namespace = name_space
                                    self.area_opaque_lsa_checksum.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-opaque-lsas"):
                                    self.area_opaque_lsas = value
                                    self.area_opaque_lsas.value_namespace = name_space
                                    self.area_opaque_lsas.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-per-prefix-lfa-interface-count"):
                                    self.area_per_prefix_lfa_interface_count = value
                                    self.area_per_prefix_lfa_interface_count.value_namespace = name_space
                                    self.area_per_prefix_lfa_interface_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "do-not-age-ls-as"):
                                    self.do_not_age_ls_as = value
                                    self.do_not_age_ls_as.value_namespace = name_space
                                    self.do_not_age_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "flood-list-length"):
                                    self.flood_list_length = value
                                    self.flood_list_length.value_namespace = name_space
                                    self.flood_list_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "indication-ls-as"):
                                    self.indication_ls_as = value
                                    self.indication_ls_as.value_namespace = name_space
                                    self.indication_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-area-nssa"):
                                    self.is_area_nssa = value
                                    self.is_area_nssa.value_namespace = name_space
                                    self.is_area_nssa.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-area-stubbed"):
                                    self.is_area_stubbed = value
                                    self.is_area_stubbed.value_namespace = name_space
                                    self.is_area_stubbed.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-area-total-stubbed"):
                                    self.is_area_total_stubbed = value
                                    self.is_area_total_stubbed.value_namespace = name_space
                                    self.is_area_total_stubbed.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-backbone-area-active"):
                                    self.is_backbone_area_active = value
                                    self.is_backbone_area_active.value_namespace = name_space
                                    self.is_backbone_area_active.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-nssa-default"):
                                    self.is_nssa_default = value
                                    self.is_nssa_default.value_namespace = name_space
                                    self.is_nssa_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-nssa-translated"):
                                    self.is_nssa_translated = value
                                    self.is_nssa_translated.value_namespace = name_space
                                    self.is_nssa_translated.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-rrr-enabled"):
                                    self.is_rrr_enabled = value
                                    self.is_rrr_enabled.value_namespace = name_space
                                    self.is_rrr_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "nssa-no-redistribution"):
                                    self.nssa_no_redistribution = value
                                    self.nssa_no_redistribution.value_namespace = name_space
                                    self.nssa_no_redistribution.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-fs"):
                                    self.sp_fs = value
                                    self.sp_fs.value_namespace = name_space
                                    self.sp_fs.value_namespace_prefix = name_space_prefix
                                if(value_path == "stub-default-cost"):
                                    self.stub_default_cost = value
                                    self.stub_default_cost.value_namespace = name_space
                                    self.stub_default_cost.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.area_information:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.area_information:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "area-informations" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "area-information"):
                                for c in self.area_information:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations.AreaInformation()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.area_information.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area-information"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class DatabaseTable(Entity):
                        """
                        OSPF Link State Database
                        
                        .. attribute:: lsa_internal_table
                        
                        	Database LSA information
                        	**type**\:   :py:class:`LsaInternalTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable>`
                        
                        .. attribute:: lsa_table
                        
                        	Database LSA information
                        	**type**\:   :py:class:`LsaTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable, self).__init__()

                            self.yang_name = "database-table"
                            self.yang_parent_name = "vrf"

                            self.lsa_internal_table = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable()
                            self.lsa_internal_table.parent = self
                            self._children_name_map["lsa_internal_table"] = "lsa-internal-table"
                            self._children_yang_names.add("lsa-internal-table")

                            self.lsa_table = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable()
                            self.lsa_table.parent = self
                            self._children_name_map["lsa_table"] = "lsa-table"
                            self._children_yang_names.add("lsa-table")


                        class LsaTable(Entity):
                            """
                            Database LSA information
                            
                            .. attribute:: lsa
                            
                            	Database LSA information
                            	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable, self).__init__()

                                self.yang_name = "lsa-table"
                                self.yang_parent_name = "database-table"

                                self.lsa = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable, self).__setattr__(name, value)


                            class Lsa(Entity):
                                """
                                Database LSA information
                                
                                .. attribute:: advertising_router
                                
                                	Advertising Router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: area_id
                                
                                	Area ID
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: interface_name
                                
                                	InterfaceName
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: ls_id
                                
                                	Link state ID
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: ls_type
                                
                                	LSA type
                                	**type**\:   :py:class:`Ospfv3Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa>`
                                
                                .. attribute:: lsa_info
                                
                                	Summary of all LSAs or LSA specific information 
                                	**type**\:   :py:class:`LsaInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa, self).__init__()

                                    self.yang_name = "lsa"
                                    self.yang_parent_name = "lsa-table"

                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                    self.area_id = YLeaf(YType.int32, "area-id")

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.ls_id = YLeaf(YType.int32, "ls-id")

                                    self.ls_type = YLeaf(YType.enumeration, "ls-type")

                                    self.lsa_info = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo()
                                    self.lsa_info.parent = self
                                    self._children_name_map["lsa_info"] = "lsa-info"
                                    self._children_yang_names.add("lsa-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("advertising_router",
                                                    "area_id",
                                                    "interface_name",
                                                    "ls_id",
                                                    "ls_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa, self).__setattr__(name, value)


                                class LsaInfo(Entity):
                                    """
                                    Summary of all LSAs or LSA specific information 
                                    
                                    .. attribute:: external_lsa_type
                                    
                                    	External LSA
                                    	**type**\:   :py:class:`ExternalLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType>`
                                    
                                    .. attribute:: grace_lsa
                                    
                                    	Grace LSA
                                    	**type**\:   :py:class:`GraceLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa>`
                                    
                                    .. attribute:: inter_area_prefix_lsa_type
                                    
                                    	Inter Area Prefix LSA
                                    	**type**\:   :py:class:`InterAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType>`
                                    
                                    .. attribute:: inter_area_router_lsa_type
                                    
                                    	Inter Area Router LSA
                                    	**type**\:   :py:class:`InterAreaRouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType>`
                                    
                                    .. attribute:: intra_area_prefix_lsa_type
                                    
                                    	Intra Area Prefix LSA
                                    	**type**\:   :py:class:`IntraAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType>`
                                    
                                    .. attribute:: link_lsa_type
                                    
                                    	Link LSA
                                    	**type**\:   :py:class:`LinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType>`
                                    
                                    .. attribute:: lsa_info_type
                                    
                                    	LSAInfoType
                                    	**type**\:   :py:class:`Ospfv3LsaInfoTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3LsaInfoTypes>`
                                    
                                    .. attribute:: lsa_summary_info
                                    
                                    	Summary information of LSAs
                                    	**type**\:   :py:class:`LsaSummaryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo>`
                                    
                                    .. attribute:: network_lsa_type
                                    
                                    	Network LSA
                                    	**type**\:   :py:class:`NetworkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType>`
                                    
                                    .. attribute:: nssalsa_type
                                    
                                    	NSSA External LSA
                                    	**type**\:   :py:class:`NssalsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType>`
                                    
                                    .. attribute:: router_lsa_type
                                    
                                    	Router LSA
                                    	**type**\:   :py:class:`RouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType>`
                                    
                                    .. attribute:: unknown_area_lsa_type
                                    
                                    	Unknown\-Area scope LSA
                                    	**type**\:   :py:class:`UnknownAreaLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType>`
                                    
                                    .. attribute:: unknown_aslsa_type
                                    
                                    	Unknown\-AS scope LSA
                                    	**type**\:   :py:class:`UnknownAslsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType>`
                                    
                                    .. attribute:: unknown_link_lsa_type
                                    
                                    	Unknown Link Scope LSA
                                    	**type**\:   :py:class:`UnknownLinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType>`
                                    
                                    .. attribute:: unknown_lsa_type
                                    
                                    	Unknown LSA
                                    	**type**\:   :py:class:`UnknownLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__init__()

                                        self.yang_name = "lsa-info"
                                        self.yang_parent_name = "lsa"

                                        self.lsa_info_type = YLeaf(YType.enumeration, "lsa-info-type")

                                        self.external_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType()
                                        self.external_lsa_type.parent = self
                                        self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                        self._children_yang_names.add("external-lsa-type")

                                        self.grace_lsa = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa()
                                        self.grace_lsa.parent = self
                                        self._children_name_map["grace_lsa"] = "grace-lsa"
                                        self._children_yang_names.add("grace-lsa")

                                        self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                        self.inter_area_prefix_lsa_type.parent = self
                                        self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                        self._children_yang_names.add("inter-area-prefix-lsa-type")

                                        self.inter_area_router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                        self.inter_area_router_lsa_type.parent = self
                                        self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                        self._children_yang_names.add("inter-area-router-lsa-type")

                                        self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                        self.intra_area_prefix_lsa_type.parent = self
                                        self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                        self._children_yang_names.add("intra-area-prefix-lsa-type")

                                        self.link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType()
                                        self.link_lsa_type.parent = self
                                        self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                        self._children_yang_names.add("link-lsa-type")

                                        self.lsa_summary_info = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo()
                                        self.lsa_summary_info.parent = self
                                        self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                        self._children_yang_names.add("lsa-summary-info")

                                        self.network_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType()
                                        self.network_lsa_type.parent = self
                                        self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                        self._children_yang_names.add("network-lsa-type")

                                        self.nssalsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType()
                                        self.nssalsa_type.parent = self
                                        self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                        self._children_yang_names.add("nssalsa-type")

                                        self.router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType()
                                        self.router_lsa_type.parent = self
                                        self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                        self._children_yang_names.add("router-lsa-type")

                                        self.unknown_area_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                        self.unknown_area_lsa_type.parent = self
                                        self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                        self._children_yang_names.add("unknown-area-lsa-type")

                                        self.unknown_aslsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType()
                                        self.unknown_aslsa_type.parent = self
                                        self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                        self._children_yang_names.add("unknown-aslsa-type")

                                        self.unknown_link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                        self.unknown_link_lsa_type.parent = self
                                        self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                        self._children_yang_names.add("unknown-link-lsa-type")

                                        self.unknown_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType()
                                        self.unknown_lsa_type.parent = self
                                        self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                        self._children_yang_names.add("unknown-lsa-type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("lsa_info_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__setattr__(name, value)


                                    class LsaSummaryInfo(Entity):
                                        """
                                        Summary information of LSAs
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface name 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: links
                                        
                                        	Number of links
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader>`
                                        
                                        .. attribute:: lsa_router_id
                                        
                                        	LSA router ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: prefix
                                        
                                        	OSPFv3 address Prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: prefix_length
                                        
                                        	Prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: reference_lsa_id
                                        
                                        	Reference LSA ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: reference_type
                                        
                                        	Reference type 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: router_la_bits
                                        
                                        	Router LA bits 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Sham link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__init__()

                                            self.yang_name = "lsa-summary-info"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.links = YLeaf(YType.uint16, "links")

                                            self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                            self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                            self.reference_type = YLeaf(YType.uint16, "reference-type")

                                            self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "links",
                                                            "lsa_router_id",
                                                            "prefix",
                                                            "prefix_length",
                                                            "reference_lsa_id",
                                                            "reference_type",
                                                            "router_la_bits",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "lsa-summary-info"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "lsa-summary-info"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.links.is_set or
                                                self.lsa_router_id.is_set or
                                                self.prefix.is_set or
                                                self.prefix_length.is_set or
                                                self.reference_lsa_id.is_set or
                                                self.reference_type.is_set or
                                                self.router_la_bits.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.links.yfilter != YFilter.not_set or
                                                self.lsa_router_id.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.prefix_length.yfilter != YFilter.not_set or
                                                self.reference_lsa_id.yfilter != YFilter.not_set or
                                                self.reference_type.yfilter != YFilter.not_set or
                                                self.router_la_bits.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-summary-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.links.get_name_leafdata())
                                            if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_router_id.get_name_leafdata())
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                            if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                            if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.reference_type.get_name_leafdata())
                                            if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.router_la_bits.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "links" or name == "lsa-router-id" or name == "prefix" or name == "prefix-length" or name == "reference-lsa-id" or name == "reference-type" or name == "router-la-bits" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "links"):
                                                self.links = value
                                                self.links.value_namespace = name_space
                                                self.links.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-router-id"):
                                                self.lsa_router_id = value
                                                self.lsa_router_id.value_namespace = name_space
                                                self.lsa_router_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-length"):
                                                self.prefix_length = value
                                                self.prefix_length.value_namespace = name_space
                                                self.prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "reference-lsa-id"):
                                                self.reference_lsa_id = value
                                                self.reference_lsa_id.value_namespace = name_space
                                                self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "reference-type"):
                                                self.reference_type = value
                                                self.reference_type.value_namespace = name_space
                                                self.reference_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "router-la-bits"):
                                                self.router_la_bits = value
                                                self.router_la_bits.value_namespace = name_space
                                                self.router_la_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                    class RouterLsaType(Entity):
                                        """
                                        Router LSA
                                        
                                        .. attribute:: link
                                        
                                        	List of links in this LSA
                                        	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link>`
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader>`
                                        
                                        .. attribute:: router_la_bits
                                        
                                        	Router LA bits 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: rpf_path
                                        
                                        	Router LSA Reverse\-Path Forwarding information 
                                        	**type**\:   :py:class:`RpfPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__init__()

                                            self.yang_name = "router-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                            self.rpf_path = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                            self.rpf_path.parent = self
                                            self._children_name_map["rpf_path"] = "rpf-path"
                                            self._children_yang_names.add("rpf-path")

                                            self.link = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("router_la_bits") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "router-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "router-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix


                                        class RpfPath(Entity):
                                            """
                                            Router LSA Reverse\-Path Forwarding information 
                                            
                                            .. attribute:: interface_name
                                            
                                            	RPF multicast IDB 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: rpf_multicast_next_hop
                                            
                                            	RPF multicast next hop 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__init__()

                                                self.yang_name = "rpf-path"
                                                self.yang_parent_name = "router-lsa-type"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.rpf_multicast_next_hop = YLeaf(YType.uint32, "rpf-multicast-next-hop")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "rpf_multicast_next_hop") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.rpf_multicast_next_hop.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.rpf_multicast_next_hop.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "rpf-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.rpf_multicast_next_hop.is_set or self.rpf_multicast_next_hop.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rpf_multicast_next_hop.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "interface-name" or name == "rpf-multicast-next-hop"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rpf-multicast-next-hop"):
                                                    self.rpf_multicast_next_hop = value
                                                    self.rpf_multicast_next_hop.value_namespace = name_space
                                                    self.rpf_multicast_next_hop.value_namespace_prefix = name_space_prefix


                                        class Link(Entity):
                                            """
                                            List of links in this LSA
                                            
                                            .. attribute:: link_interface_id
                                            
                                            	LSA link interface ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_metric
                                            
                                            	LSA link metric 
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: link_neighbor_interface_id
                                            
                                            	LSA link neighbor interface ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_neighbor_router_id
                                            
                                            	LSA link neigbhor router id 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_type
                                            
                                            	Type of link
                                            	**type**\:   :py:class:`Ospfv3Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Link>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__init__()

                                                self.yang_name = "link"
                                                self.yang_parent_name = "router-lsa-type"

                                                self.link_interface_id = YLeaf(YType.uint32, "link-interface-id")

                                                self.link_metric = YLeaf(YType.uint16, "link-metric")

                                                self.link_neighbor_interface_id = YLeaf(YType.uint32, "link-neighbor-interface-id")

                                                self.link_neighbor_router_id = YLeaf(YType.uint32, "link-neighbor-router-id")

                                                self.link_type = YLeaf(YType.enumeration, "link-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("link_interface_id",
                                                                "link_metric",
                                                                "link_neighbor_interface_id",
                                                                "link_neighbor_router_id",
                                                                "link_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.link_interface_id.is_set or
                                                    self.link_metric.is_set or
                                                    self.link_neighbor_interface_id.is_set or
                                                    self.link_neighbor_router_id.is_set or
                                                    self.link_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.link_interface_id.yfilter != YFilter.not_set or
                                                    self.link_metric.yfilter != YFilter.not_set or
                                                    self.link_neighbor_interface_id.yfilter != YFilter.not_set or
                                                    self.link_neighbor_router_id.yfilter != YFilter.not_set or
                                                    self.link_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "link" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.link_interface_id.is_set or self.link_interface_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_interface_id.get_name_leafdata())
                                                if (self.link_metric.is_set or self.link_metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_metric.get_name_leafdata())
                                                if (self.link_neighbor_interface_id.is_set or self.link_neighbor_interface_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_neighbor_interface_id.get_name_leafdata())
                                                if (self.link_neighbor_router_id.is_set or self.link_neighbor_router_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_neighbor_router_id.get_name_leafdata())
                                                if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "link-interface-id" or name == "link-metric" or name == "link-neighbor-interface-id" or name == "link-neighbor-router-id" or name == "link-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "link-interface-id"):
                                                    self.link_interface_id = value
                                                    self.link_interface_id.value_namespace = name_space
                                                    self.link_interface_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-metric"):
                                                    self.link_metric = value
                                                    self.link_metric.value_namespace = name_space
                                                    self.link_metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-neighbor-interface-id"):
                                                    self.link_neighbor_interface_id = value
                                                    self.link_neighbor_interface_id.value_namespace = name_space
                                                    self.link_neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-neighbor-router-id"):
                                                    self.link_neighbor_router_id = value
                                                    self.link_neighbor_router_id.value_namespace = name_space
                                                    self.link_neighbor_router_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-type"):
                                                    self.link_type = value
                                                    self.link_type.value_namespace = name_space
                                                    self.link_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.link:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.router_la_bits.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()) or
                                                (self.rpf_path is not None and self.rpf_path.has_data()))

                                        def has_operation(self):
                                            for c in self.link:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.router_la_bits.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()) or
                                                (self.rpf_path is not None and self.rpf_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "router-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.router_la_bits.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "link"):
                                                for c in self.link:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.link.append(c)
                                                return c

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            if (child_yang_name == "rpf-path"):
                                                if (self.rpf_path is None):
                                                    self.rpf_path = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                    self.rpf_path.parent = self
                                                    self._children_name_map["rpf_path"] = "rpf-path"
                                                return self.rpf_path

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "link" or name == "lsa-detail" or name == "lsa-header" or name == "rpf-path" or name == "router-la-bits"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "router-la-bits"):
                                                self.router_la_bits = value
                                                self.router_la_bits.value_namespace = name_space
                                                self.router_la_bits.value_namespace_prefix = name_space_prefix


                                    class NetworkLsaType(Entity):
                                        """
                                        Network LSA
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader>`
                                        
                                        .. attribute:: neighbor_router
                                        
                                        	Neighbor router list
                                        	**type**\:  list of str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__init__()

                                            self.yang_name = "network-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.neighbor_router = YLeafList(YType.str, "neighbor-router")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("neighbor_router") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "network-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "network-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for leaf in self.neighbor_router.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return (
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            for leaf in self.neighbor_router.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.neighbor_router.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "network-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            leaf_name_data.extend(self.neighbor_router.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "neighbor-router"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "neighbor-router"):
                                                self.neighbor_router.append(value)


                                    class InterAreaPrefixLsaType(Entity):
                                        """
                                        Inter Area Prefix LSA
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA Information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader>`
                                        
                                        .. attribute:: prefix
                                        
                                        	LSA address prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: prefix_length
                                        
                                        	Prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: priority
                                        
                                        	Prefix priority
                                        	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__init__()

                                            self.yang_name = "inter-area-prefix-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                            self.priority = YLeaf(YType.enumeration, "priority")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("prefix",
                                                            "prefix_length",
                                                            "priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA Information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.prefix.is_set or
                                                self.prefix_length.is_set or
                                                self.priority.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.prefix_length.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inter-area-prefix-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "prefix-length" or name == "priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-length"):
                                                self.prefix_length = value
                                                self.prefix_length.value_namespace = name_space
                                                self.prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix


                                    class InterAreaRouterLsaType(Entity):
                                        """
                                        Inter Area Router LSA
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader>`
                                        
                                        .. attribute:: lsa_router_id
                                        
                                        	LSA router ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__init__()

                                            self.yang_name = "inter-area-router-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("lsa_router_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "inter-area-router-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "inter-area-router-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.lsa_router_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.lsa_router_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inter-area-router-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_router_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "lsa-router-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "lsa-router-id"):
                                                self.lsa_router_id = value
                                                self.lsa_router_id.value_namespace = name_space
                                                self.lsa_router_id.value_namespace_prefix = name_space_prefix


                                    class ExternalLsaType(Entity):
                                        """
                                        External LSA
                                        
                                        .. attribute:: external_tag
                                        
                                        	Route Tag
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forwarding_address
                                        
                                        	Forwarding Address
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: is_forwarding_address_set
                                        
                                        	If true, forwarding address is set 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA Information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader>`
                                        
                                        .. attribute:: metric_type
                                        
                                        	Metric type 
                                        	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                        
                                        .. attribute:: prefix
                                        
                                        	IPV6 address prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: prefix_length
                                        
                                        	Prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: priority
                                        
                                        	Prefix priority
                                        	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                        
                                        .. attribute:: tos_cost
                                        
                                        	Type of service cost metric 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__init__()

                                            self.yang_name = "external-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.external_tag = YLeaf(YType.uint32, "external-tag")

                                            self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                            self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                            self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                            self.priority = YLeaf(YType.enumeration, "priority")

                                            self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("external_tag",
                                                            "forwarding_address",
                                                            "is_forwarding_address_set",
                                                            "metric_type",
                                                            "prefix",
                                                            "prefix_length",
                                                            "priority",
                                                            "tos_cost") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "external-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA Information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "external-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.external_tag.is_set or
                                                self.forwarding_address.is_set or
                                                self.is_forwarding_address_set.is_set or
                                                self.metric_type.is_set or
                                                self.prefix.is_set or
                                                self.prefix_length.is_set or
                                                self.priority.is_set or
                                                self.tos_cost.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.external_tag.yfilter != YFilter.not_set or
                                                self.forwarding_address.yfilter != YFilter.not_set or
                                                self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                self.metric_type.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.prefix_length.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set or
                                                self.tos_cost.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "external-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.external_tag.get_name_leafdata())
                                            if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                            if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                            if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.metric_type.get_name_leafdata())
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())
                                            if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "external-tag"):
                                                self.external_tag = value
                                                self.external_tag.value_namespace = name_space
                                                self.external_tag.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forwarding-address"):
                                                self.forwarding_address = value
                                                self.forwarding_address.value_namespace = name_space
                                                self.forwarding_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-forwarding-address-set"):
                                                self.is_forwarding_address_set = value
                                                self.is_forwarding_address_set.value_namespace = name_space
                                                self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                            if(value_path == "metric-type"):
                                                self.metric_type = value
                                                self.metric_type.value_namespace = name_space
                                                self.metric_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-length"):
                                                self.prefix_length = value
                                                self.prefix_length.value_namespace = name_space
                                                self.prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tos-cost"):
                                                self.tos_cost = value
                                                self.tos_cost.value_namespace = name_space
                                                self.tos_cost.value_namespace_prefix = name_space_prefix


                                    class NssalsaType(Entity):
                                        """
                                        NSSA External LSA
                                        
                                        .. attribute:: external_tag
                                        
                                        	Route Tag
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forwarding_address
                                        
                                        	Forwarding Address
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: is_forwarding_address_set
                                        
                                        	If true, forwarding address is set 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA Information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader>`
                                        
                                        .. attribute:: metric_type
                                        
                                        	Metric type 
                                        	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                        
                                        .. attribute:: prefix
                                        
                                        	IPV6 address prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: prefix_length
                                        
                                        	Prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: priority
                                        
                                        	Prefix priority
                                        	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                        
                                        .. attribute:: tos_cost
                                        
                                        	Type of service cost metric 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__init__()

                                            self.yang_name = "nssalsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.external_tag = YLeaf(YType.uint32, "external-tag")

                                            self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                            self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                            self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                            self.priority = YLeaf(YType.enumeration, "priority")

                                            self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("external_tag",
                                                            "forwarding_address",
                                                            "is_forwarding_address_set",
                                                            "metric_type",
                                                            "prefix",
                                                            "prefix_length",
                                                            "priority",
                                                            "tos_cost") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "nssalsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA Information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "nssalsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.external_tag.is_set or
                                                self.forwarding_address.is_set or
                                                self.is_forwarding_address_set.is_set or
                                                self.metric_type.is_set or
                                                self.prefix.is_set or
                                                self.prefix_length.is_set or
                                                self.priority.is_set or
                                                self.tos_cost.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.external_tag.yfilter != YFilter.not_set or
                                                self.forwarding_address.yfilter != YFilter.not_set or
                                                self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                self.metric_type.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.prefix_length.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set or
                                                self.tos_cost.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nssalsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.external_tag.get_name_leafdata())
                                            if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                            if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                            if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.metric_type.get_name_leafdata())
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())
                                            if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "external-tag"):
                                                self.external_tag = value
                                                self.external_tag.value_namespace = name_space
                                                self.external_tag.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forwarding-address"):
                                                self.forwarding_address = value
                                                self.forwarding_address.value_namespace = name_space
                                                self.forwarding_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-forwarding-address-set"):
                                                self.is_forwarding_address_set = value
                                                self.is_forwarding_address_set.value_namespace = name_space
                                                self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                            if(value_path == "metric-type"):
                                                self.metric_type = value
                                                self.metric_type.value_namespace = name_space
                                                self.metric_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-length"):
                                                self.prefix_length = value
                                                self.prefix_length.value_namespace = name_space
                                                self.prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tos-cost"):
                                                self.tos_cost = value
                                                self.tos_cost.value_namespace = name_space
                                                self.tos_cost.value_namespace_prefix = name_space_prefix


                                    class LinkLsaType(Entity):
                                        """
                                        Link LSA
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface handle
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader>`
                                        
                                        .. attribute:: lsa_link_local
                                        
                                        	LSA link local 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: prefix
                                        
                                        	OSPFv3 prefix 
                                        	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix>`
                                        
                                        .. attribute:: router_priority
                                        
                                        	Router priority 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Sham link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__init__()

                                            self.yang_name = "link-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.lsa_link_local = YLeaf(YType.str, "lsa-link-local")

                                            self.router_priority = YLeaf(YType.uint8, "router-priority")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                            self.prefix = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "lsa_link_local",
                                                            "router_priority",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "link-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "link-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix


                                        class Prefix(Entity):
                                            """
                                            OSPFv3 prefix 
                                            
                                            .. attribute:: ospfv3_prefix_length
                                            
                                            	OSPFv3 prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ospfv3_prefix_metric
                                            
                                            	OSPFv3 prefix metric 
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: ospfv3_prefix_options
                                            
                                            	OSPFv3 prefix options 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: prefix
                                            
                                            	OSPFv3 prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: priority
                                            
                                            	Prefix priority
                                            	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__init__()

                                                self.yang_name = "prefix"
                                                self.yang_parent_name = "link-lsa-type"

                                                self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.priority = YLeaf(YType.enumeration, "priority")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("ospfv3_prefix_length",
                                                                "ospfv3_prefix_metric",
                                                                "ospfv3_prefix_options",
                                                                "prefix",
                                                                "priority") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.ospfv3_prefix_length.is_set or
                                                    self.ospfv3_prefix_metric.is_set or
                                                    self.ospfv3_prefix_options.is_set or
                                                    self.prefix.is_set or
                                                    self.priority.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prefix" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "ospfv3-prefix-length"):
                                                    self.ospfv3_prefix_length = value
                                                    self.ospfv3_prefix_length.value_namespace = name_space
                                                    self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ospfv3-prefix-metric"):
                                                    self.ospfv3_prefix_metric = value
                                                    self.ospfv3_prefix_metric.value_namespace = name_space
                                                    self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ospfv3-prefix-options"):
                                                    self.ospfv3_prefix_options = value
                                                    self.ospfv3_prefix_options.value_namespace = name_space
                                                    self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prefix:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.lsa_link_local.is_set or
                                                self.router_priority.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            for c in self.prefix:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.lsa_link_local.yfilter != YFilter.not_set or
                                                self.router_priority.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.lsa_link_local.is_set or self.lsa_link_local.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_link_local.get_name_leafdata())
                                            if (self.router_priority.is_set or self.router_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.router_priority.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            if (child_yang_name == "prefix"):
                                                for c in self.prefix:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prefix.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "lsa-link-local" or name == "router-priority" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-link-local"):
                                                self.lsa_link_local = value
                                                self.lsa_link_local.value_namespace = name_space
                                                self.lsa_link_local.value_namespace_prefix = name_space_prefix
                                            if(value_path == "router-priority"):
                                                self.router_priority = value
                                                self.router_priority.value_namespace = name_space
                                                self.router_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                    class IntraAreaPrefixLsaType(Entity):
                                        """
                                        Intra Area Prefix LSA
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader>`
                                        
                                        .. attribute:: prefix
                                        
                                        	OSPFv3 prefix 
                                        	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix>`
                                        
                                        .. attribute:: reference_advertised_router
                                        
                                        	Reference advertised router 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: reference_lsa_id
                                        
                                        	Reference LSA ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: reference_type
                                        
                                        	Reference type 
                                        	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__init__()

                                            self.yang_name = "intra-area-prefix-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.reference_advertised_router = YLeaf(YType.str, "reference-advertised-router")

                                            self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                            self.reference_type = YLeaf(YType.enumeration, "reference-type")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                            self.prefix = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("reference_advertised_router",
                                                            "reference_lsa_id",
                                                            "reference_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix


                                        class Prefix(Entity):
                                            """
                                            OSPFv3 prefix 
                                            
                                            .. attribute:: ospfv3_prefix_length
                                            
                                            	OSPFv3 prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ospfv3_prefix_metric
                                            
                                            	OSPFv3 prefix metric 
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: ospfv3_prefix_options
                                            
                                            	OSPFv3 prefix options 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: prefix
                                            
                                            	OSPFv3 prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: priority
                                            
                                            	Prefix priority
                                            	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__init__()

                                                self.yang_name = "prefix"
                                                self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.priority = YLeaf(YType.enumeration, "priority")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("ospfv3_prefix_length",
                                                                "ospfv3_prefix_metric",
                                                                "ospfv3_prefix_options",
                                                                "prefix",
                                                                "priority") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.ospfv3_prefix_length.is_set or
                                                    self.ospfv3_prefix_metric.is_set or
                                                    self.ospfv3_prefix_options.is_set or
                                                    self.prefix.is_set or
                                                    self.priority.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prefix" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "ospfv3-prefix-length"):
                                                    self.ospfv3_prefix_length = value
                                                    self.ospfv3_prefix_length.value_namespace = name_space
                                                    self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ospfv3-prefix-metric"):
                                                    self.ospfv3_prefix_metric = value
                                                    self.ospfv3_prefix_metric.value_namespace = name_space
                                                    self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ospfv3-prefix-options"):
                                                    self.ospfv3_prefix_options = value
                                                    self.ospfv3_prefix_options.value_namespace = name_space
                                                    self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prefix:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.reference_advertised_router.is_set or
                                                self.reference_lsa_id.is_set or
                                                self.reference_type.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            for c in self.prefix:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.reference_advertised_router.yfilter != YFilter.not_set or
                                                self.reference_lsa_id.yfilter != YFilter.not_set or
                                                self.reference_type.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "intra-area-prefix-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.reference_advertised_router.is_set or self.reference_advertised_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.reference_advertised_router.get_name_leafdata())
                                            if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                            if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.reference_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            if (child_yang_name == "prefix"):
                                                for c in self.prefix:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prefix.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "reference-advertised-router" or name == "reference-lsa-id" or name == "reference-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "reference-advertised-router"):
                                                self.reference_advertised_router = value
                                                self.reference_advertised_router.value_namespace = name_space
                                                self.reference_advertised_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "reference-lsa-id"):
                                                self.reference_lsa_id = value
                                                self.reference_lsa_id.value_namespace = name_space
                                                self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "reference-type"):
                                                self.reference_type = value
                                                self.reference_type.value_namespace = name_space
                                                self.reference_type.value_namespace_prefix = name_space_prefix


                                    class GraceLsa(Entity):
                                        """
                                        Grace LSA
                                        
                                        .. attribute:: grace_period
                                        
                                        	The grace periord where helper routers should wait before advertising it fully adjacent(s) 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: grace_reason
                                        
                                        	Reason for router restart
                                        	**type**\:   :py:class:`Ospfv3GracefulRestartReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3GracefulRestartReason>`
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__init__()

                                            self.yang_name = "grace-lsa"
                                            self.yang_parent_name = "lsa-info"

                                            self.grace_period = YLeaf(YType.uint32, "grace-period")

                                            self.grace_reason = YLeaf(YType.enumeration, "grace-reason")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("grace_period",
                                                            "grace_reason") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "grace-lsa"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "grace-lsa"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.grace_period.is_set or
                                                self.grace_reason.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.grace_period.yfilter != YFilter.not_set or
                                                self.grace_reason.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "grace-lsa" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.grace_period.is_set or self.grace_period.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grace_period.get_name_leafdata())
                                            if (self.grace_reason.is_set or self.grace_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grace_reason.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "grace-period" or name == "grace-reason"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "grace-period"):
                                                self.grace_period = value
                                                self.grace_period.value_namespace = name_space
                                                self.grace_period.value_namespace_prefix = name_space_prefix
                                            if(value_path == "grace-reason"):
                                                self.grace_reason = value
                                                self.grace_reason.value_namespace = name_space
                                                self.grace_reason.value_namespace_prefix = name_space_prefix


                                    class UnknownLinkLsaType(Entity):
                                        """
                                        Unknown Link Scope LSA
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface name 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader>`
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Shamlink ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__init__()

                                            self.yang_name = "unknown-link-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "unknown-link-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "unknown-link-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unknown-link-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                    class UnknownAreaLsaType(Entity):
                                        """
                                        Unknown\-Area scope LSA
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface name 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader>`
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Shamlink ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__init__()

                                            self.yang_name = "unknown-area-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "unknown-area-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "unknown-area-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unknown-area-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                    class UnknownAslsaType(Entity):
                                        """
                                        Unknown\-AS scope LSA
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface name 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader>`
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Shamlink ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__init__()

                                            self.yang_name = "unknown-aslsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "unknown-aslsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "unknown-aslsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unknown-aslsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                    class UnknownLsaType(Entity):
                                        """
                                        Unknown LSA
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface name 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader>`
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Shamlink ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__init__()

                                            self.yang_name = "unknown-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "unknown-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "unknown-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unknown-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.lsa_info_type.is_set or
                                            (self.external_lsa_type is not None and self.external_lsa_type.has_data()) or
                                            (self.grace_lsa is not None and self.grace_lsa.has_data()) or
                                            (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_data()) or
                                            (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_data()) or
                                            (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_data()) or
                                            (self.link_lsa_type is not None and self.link_lsa_type.has_data()) or
                                            (self.lsa_summary_info is not None and self.lsa_summary_info.has_data()) or
                                            (self.network_lsa_type is not None and self.network_lsa_type.has_data()) or
                                            (self.nssalsa_type is not None and self.nssalsa_type.has_data()) or
                                            (self.router_lsa_type is not None and self.router_lsa_type.has_data()) or
                                            (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_data()) or
                                            (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_data()) or
                                            (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_data()) or
                                            (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.lsa_info_type.yfilter != YFilter.not_set or
                                            (self.external_lsa_type is not None and self.external_lsa_type.has_operation()) or
                                            (self.grace_lsa is not None and self.grace_lsa.has_operation()) or
                                            (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_operation()) or
                                            (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_operation()) or
                                            (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_operation()) or
                                            (self.link_lsa_type is not None and self.link_lsa_type.has_operation()) or
                                            (self.lsa_summary_info is not None and self.lsa_summary_info.has_operation()) or
                                            (self.network_lsa_type is not None and self.network_lsa_type.has_operation()) or
                                            (self.nssalsa_type is not None and self.nssalsa_type.has_operation()) or
                                            (self.router_lsa_type is not None and self.router_lsa_type.has_operation()) or
                                            (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_operation()) or
                                            (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_operation()) or
                                            (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_operation()) or
                                            (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsa-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.lsa_info_type.is_set or self.lsa_info_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_info_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "external-lsa-type"):
                                            if (self.external_lsa_type is None):
                                                self.external_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType()
                                                self.external_lsa_type.parent = self
                                                self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                            return self.external_lsa_type

                                        if (child_yang_name == "grace-lsa"):
                                            if (self.grace_lsa is None):
                                                self.grace_lsa = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa()
                                                self.grace_lsa.parent = self
                                                self._children_name_map["grace_lsa"] = "grace-lsa"
                                            return self.grace_lsa

                                        if (child_yang_name == "inter-area-prefix-lsa-type"):
                                            if (self.inter_area_prefix_lsa_type is None):
                                                self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                                self.inter_area_prefix_lsa_type.parent = self
                                                self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                            return self.inter_area_prefix_lsa_type

                                        if (child_yang_name == "inter-area-router-lsa-type"):
                                            if (self.inter_area_router_lsa_type is None):
                                                self.inter_area_router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                                self.inter_area_router_lsa_type.parent = self
                                                self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                            return self.inter_area_router_lsa_type

                                        if (child_yang_name == "intra-area-prefix-lsa-type"):
                                            if (self.intra_area_prefix_lsa_type is None):
                                                self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                                self.intra_area_prefix_lsa_type.parent = self
                                                self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                            return self.intra_area_prefix_lsa_type

                                        if (child_yang_name == "link-lsa-type"):
                                            if (self.link_lsa_type is None):
                                                self.link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType()
                                                self.link_lsa_type.parent = self
                                                self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                            return self.link_lsa_type

                                        if (child_yang_name == "lsa-summary-info"):
                                            if (self.lsa_summary_info is None):
                                                self.lsa_summary_info = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo()
                                                self.lsa_summary_info.parent = self
                                                self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                            return self.lsa_summary_info

                                        if (child_yang_name == "network-lsa-type"):
                                            if (self.network_lsa_type is None):
                                                self.network_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType()
                                                self.network_lsa_type.parent = self
                                                self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                            return self.network_lsa_type

                                        if (child_yang_name == "nssalsa-type"):
                                            if (self.nssalsa_type is None):
                                                self.nssalsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType()
                                                self.nssalsa_type.parent = self
                                                self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                            return self.nssalsa_type

                                        if (child_yang_name == "router-lsa-type"):
                                            if (self.router_lsa_type is None):
                                                self.router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType()
                                                self.router_lsa_type.parent = self
                                                self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                            return self.router_lsa_type

                                        if (child_yang_name == "unknown-area-lsa-type"):
                                            if (self.unknown_area_lsa_type is None):
                                                self.unknown_area_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                                self.unknown_area_lsa_type.parent = self
                                                self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                            return self.unknown_area_lsa_type

                                        if (child_yang_name == "unknown-aslsa-type"):
                                            if (self.unknown_aslsa_type is None):
                                                self.unknown_aslsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType()
                                                self.unknown_aslsa_type.parent = self
                                                self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                            return self.unknown_aslsa_type

                                        if (child_yang_name == "unknown-link-lsa-type"):
                                            if (self.unknown_link_lsa_type is None):
                                                self.unknown_link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                                self.unknown_link_lsa_type.parent = self
                                                self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                            return self.unknown_link_lsa_type

                                        if (child_yang_name == "unknown-lsa-type"):
                                            if (self.unknown_lsa_type is None):
                                                self.unknown_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType()
                                                self.unknown_lsa_type.parent = self
                                                self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                            return self.unknown_lsa_type

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "external-lsa-type" or name == "grace-lsa" or name == "inter-area-prefix-lsa-type" or name == "inter-area-router-lsa-type" or name == "intra-area-prefix-lsa-type" or name == "link-lsa-type" or name == "lsa-summary-info" or name == "network-lsa-type" or name == "nssalsa-type" or name == "router-lsa-type" or name == "unknown-area-lsa-type" or name == "unknown-aslsa-type" or name == "unknown-link-lsa-type" or name == "unknown-lsa-type" or name == "lsa-info-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "lsa-info-type"):
                                            self.lsa_info_type = value
                                            self.lsa_info_type.value_namespace = name_space
                                            self.lsa_info_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.advertising_router.is_set or
                                        self.area_id.is_set or
                                        self.interface_name.is_set or
                                        self.ls_id.is_set or
                                        self.ls_type.is_set or
                                        (self.lsa_info is not None and self.lsa_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.advertising_router.yfilter != YFilter.not_set or
                                        self.area_id.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.ls_id.yfilter != YFilter.not_set or
                                        self.ls_type.yfilter != YFilter.not_set or
                                        (self.lsa_info is not None and self.lsa_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsa" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_id.get_name_leafdata())
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                    if (self.ls_type.is_set or self.ls_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "lsa-info"):
                                        if (self.lsa_info is None):
                                            self.lsa_info = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa.LsaInfo()
                                            self.lsa_info.parent = self
                                            self._children_name_map["lsa_info"] = "lsa-info"
                                        return self.lsa_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "lsa-info" or name == "advertising-router" or name == "area-id" or name == "interface-name" or name == "ls-id" or name == "ls-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "advertising-router"):
                                        self.advertising_router = value
                                        self.advertising_router.value_namespace = name_space
                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-id"):
                                        self.area_id = value
                                        self.area_id.value_namespace = name_space
                                        self.area_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-id"):
                                        self.ls_id = value
                                        self.ls_id.value_namespace = name_space
                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-type"):
                                        self.ls_type = value
                                        self.ls_type.value_namespace = name_space
                                        self.ls_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.lsa:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.lsa:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsa-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "lsa"):
                                    for c in self.lsa:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable.Lsa()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.lsa.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsa"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class LsaInternalTable(Entity):
                            """
                            Database LSA information
                            
                            .. attribute:: lsa
                            
                            	Database LSA information
                            	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable, self).__init__()

                                self.yang_name = "lsa-internal-table"
                                self.yang_parent_name = "database-table"

                                self.lsa = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable, self).__setattr__(name, value)


                            class Lsa(Entity):
                                """
                                Database LSA information
                                
                                .. attribute:: advertising_router
                                
                                	Advertising Router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: area_id
                                
                                	Area ID
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: interface_name
                                
                                	InterfaceName
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: ls_id
                                
                                	Link state ID
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: ls_type
                                
                                	LSA type
                                	**type**\:   :py:class:`Ospfv3Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa>`
                                
                                .. attribute:: lsa_info
                                
                                	Summary of all LSAs or LSA specific information 
                                	**type**\:   :py:class:`LsaInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa, self).__init__()

                                    self.yang_name = "lsa"
                                    self.yang_parent_name = "lsa-internal-table"

                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                    self.area_id = YLeaf(YType.int32, "area-id")

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.ls_id = YLeaf(YType.int32, "ls-id")

                                    self.ls_type = YLeaf(YType.enumeration, "ls-type")

                                    self.lsa_info = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo()
                                    self.lsa_info.parent = self
                                    self._children_name_map["lsa_info"] = "lsa-info"
                                    self._children_yang_names.add("lsa-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("advertising_router",
                                                    "area_id",
                                                    "interface_name",
                                                    "ls_id",
                                                    "ls_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa, self).__setattr__(name, value)


                                class LsaInfo(Entity):
                                    """
                                    Summary of all LSAs or LSA specific information 
                                    
                                    .. attribute:: external_lsa_type
                                    
                                    	External LSA
                                    	**type**\:   :py:class:`ExternalLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType>`
                                    
                                    .. attribute:: grace_lsa
                                    
                                    	Grace LSA
                                    	**type**\:   :py:class:`GraceLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa>`
                                    
                                    .. attribute:: inter_area_prefix_lsa_type
                                    
                                    	Inter Area Prefix LSA
                                    	**type**\:   :py:class:`InterAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType>`
                                    
                                    .. attribute:: inter_area_router_lsa_type
                                    
                                    	Inter Area Router LSA
                                    	**type**\:   :py:class:`InterAreaRouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType>`
                                    
                                    .. attribute:: intra_area_prefix_lsa_type
                                    
                                    	Intra Area Prefix LSA
                                    	**type**\:   :py:class:`IntraAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType>`
                                    
                                    .. attribute:: link_lsa_type
                                    
                                    	Link LSA
                                    	**type**\:   :py:class:`LinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType>`
                                    
                                    .. attribute:: lsa_info_type
                                    
                                    	LSAInfoType
                                    	**type**\:   :py:class:`Ospfv3LsaInfoTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3LsaInfoTypes>`
                                    
                                    .. attribute:: lsa_summary_info
                                    
                                    	Summary information of LSAs
                                    	**type**\:   :py:class:`LsaSummaryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo>`
                                    
                                    .. attribute:: network_lsa_type
                                    
                                    	Network LSA
                                    	**type**\:   :py:class:`NetworkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType>`
                                    
                                    .. attribute:: nssalsa_type
                                    
                                    	NSSA External LSA
                                    	**type**\:   :py:class:`NssalsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType>`
                                    
                                    .. attribute:: router_lsa_type
                                    
                                    	Router LSA
                                    	**type**\:   :py:class:`RouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType>`
                                    
                                    .. attribute:: unknown_area_lsa_type
                                    
                                    	Unknown\-Area scope LSA
                                    	**type**\:   :py:class:`UnknownAreaLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType>`
                                    
                                    .. attribute:: unknown_aslsa_type
                                    
                                    	Unknown\-AS scope LSA
                                    	**type**\:   :py:class:`UnknownAslsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType>`
                                    
                                    .. attribute:: unknown_link_lsa_type
                                    
                                    	Unknown Link Scope LSA
                                    	**type**\:   :py:class:`UnknownLinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType>`
                                    
                                    .. attribute:: unknown_lsa_type
                                    
                                    	Unknown LSA
                                    	**type**\:   :py:class:`UnknownLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__init__()

                                        self.yang_name = "lsa-info"
                                        self.yang_parent_name = "lsa"

                                        self.lsa_info_type = YLeaf(YType.enumeration, "lsa-info-type")

                                        self.external_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType()
                                        self.external_lsa_type.parent = self
                                        self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                        self._children_yang_names.add("external-lsa-type")

                                        self.grace_lsa = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa()
                                        self.grace_lsa.parent = self
                                        self._children_name_map["grace_lsa"] = "grace-lsa"
                                        self._children_yang_names.add("grace-lsa")

                                        self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                        self.inter_area_prefix_lsa_type.parent = self
                                        self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                        self._children_yang_names.add("inter-area-prefix-lsa-type")

                                        self.inter_area_router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                        self.inter_area_router_lsa_type.parent = self
                                        self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                        self._children_yang_names.add("inter-area-router-lsa-type")

                                        self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                        self.intra_area_prefix_lsa_type.parent = self
                                        self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                        self._children_yang_names.add("intra-area-prefix-lsa-type")

                                        self.link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType()
                                        self.link_lsa_type.parent = self
                                        self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                        self._children_yang_names.add("link-lsa-type")

                                        self.lsa_summary_info = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo()
                                        self.lsa_summary_info.parent = self
                                        self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                        self._children_yang_names.add("lsa-summary-info")

                                        self.network_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType()
                                        self.network_lsa_type.parent = self
                                        self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                        self._children_yang_names.add("network-lsa-type")

                                        self.nssalsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType()
                                        self.nssalsa_type.parent = self
                                        self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                        self._children_yang_names.add("nssalsa-type")

                                        self.router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType()
                                        self.router_lsa_type.parent = self
                                        self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                        self._children_yang_names.add("router-lsa-type")

                                        self.unknown_area_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                        self.unknown_area_lsa_type.parent = self
                                        self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                        self._children_yang_names.add("unknown-area-lsa-type")

                                        self.unknown_aslsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType()
                                        self.unknown_aslsa_type.parent = self
                                        self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                        self._children_yang_names.add("unknown-aslsa-type")

                                        self.unknown_link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                        self.unknown_link_lsa_type.parent = self
                                        self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                        self._children_yang_names.add("unknown-link-lsa-type")

                                        self.unknown_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType()
                                        self.unknown_lsa_type.parent = self
                                        self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                        self._children_yang_names.add("unknown-lsa-type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("lsa_info_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__setattr__(name, value)


                                    class LsaSummaryInfo(Entity):
                                        """
                                        Summary information of LSAs
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface name 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: links
                                        
                                        	Number of links
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader>`
                                        
                                        .. attribute:: lsa_router_id
                                        
                                        	LSA router ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: prefix
                                        
                                        	OSPFv3 address Prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: prefix_length
                                        
                                        	Prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: reference_lsa_id
                                        
                                        	Reference LSA ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: reference_type
                                        
                                        	Reference type 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: router_la_bits
                                        
                                        	Router LA bits 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Sham link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__init__()

                                            self.yang_name = "lsa-summary-info"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.links = YLeaf(YType.uint16, "links")

                                            self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                            self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                            self.reference_type = YLeaf(YType.uint16, "reference-type")

                                            self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "links",
                                                            "lsa_router_id",
                                                            "prefix",
                                                            "prefix_length",
                                                            "reference_lsa_id",
                                                            "reference_type",
                                                            "router_la_bits",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "lsa-summary-info"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "lsa-summary-info"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.links.is_set or
                                                self.lsa_router_id.is_set or
                                                self.prefix.is_set or
                                                self.prefix_length.is_set or
                                                self.reference_lsa_id.is_set or
                                                self.reference_type.is_set or
                                                self.router_la_bits.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.links.yfilter != YFilter.not_set or
                                                self.lsa_router_id.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.prefix_length.yfilter != YFilter.not_set or
                                                self.reference_lsa_id.yfilter != YFilter.not_set or
                                                self.reference_type.yfilter != YFilter.not_set or
                                                self.router_la_bits.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-summary-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.links.get_name_leafdata())
                                            if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_router_id.get_name_leafdata())
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                            if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                            if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.reference_type.get_name_leafdata())
                                            if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.router_la_bits.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "links" or name == "lsa-router-id" or name == "prefix" or name == "prefix-length" or name == "reference-lsa-id" or name == "reference-type" or name == "router-la-bits" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "links"):
                                                self.links = value
                                                self.links.value_namespace = name_space
                                                self.links.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-router-id"):
                                                self.lsa_router_id = value
                                                self.lsa_router_id.value_namespace = name_space
                                                self.lsa_router_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-length"):
                                                self.prefix_length = value
                                                self.prefix_length.value_namespace = name_space
                                                self.prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "reference-lsa-id"):
                                                self.reference_lsa_id = value
                                                self.reference_lsa_id.value_namespace = name_space
                                                self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "reference-type"):
                                                self.reference_type = value
                                                self.reference_type.value_namespace = name_space
                                                self.reference_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "router-la-bits"):
                                                self.router_la_bits = value
                                                self.router_la_bits.value_namespace = name_space
                                                self.router_la_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                    class RouterLsaType(Entity):
                                        """
                                        Router LSA
                                        
                                        .. attribute:: link
                                        
                                        	List of links in this LSA
                                        	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link>`
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader>`
                                        
                                        .. attribute:: router_la_bits
                                        
                                        	Router LA bits 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: rpf_path
                                        
                                        	Router LSA Reverse\-Path Forwarding information 
                                        	**type**\:   :py:class:`RpfPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__init__()

                                            self.yang_name = "router-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                            self.rpf_path = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                            self.rpf_path.parent = self
                                            self._children_name_map["rpf_path"] = "rpf-path"
                                            self._children_yang_names.add("rpf-path")

                                            self.link = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("router_la_bits") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "router-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "router-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix


                                        class RpfPath(Entity):
                                            """
                                            Router LSA Reverse\-Path Forwarding information 
                                            
                                            .. attribute:: interface_name
                                            
                                            	RPF multicast IDB 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: rpf_multicast_next_hop
                                            
                                            	RPF multicast next hop 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__init__()

                                                self.yang_name = "rpf-path"
                                                self.yang_parent_name = "router-lsa-type"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.rpf_multicast_next_hop = YLeaf(YType.uint32, "rpf-multicast-next-hop")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "rpf_multicast_next_hop") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.rpf_multicast_next_hop.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.rpf_multicast_next_hop.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "rpf-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.rpf_multicast_next_hop.is_set or self.rpf_multicast_next_hop.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rpf_multicast_next_hop.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "interface-name" or name == "rpf-multicast-next-hop"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rpf-multicast-next-hop"):
                                                    self.rpf_multicast_next_hop = value
                                                    self.rpf_multicast_next_hop.value_namespace = name_space
                                                    self.rpf_multicast_next_hop.value_namespace_prefix = name_space_prefix


                                        class Link(Entity):
                                            """
                                            List of links in this LSA
                                            
                                            .. attribute:: link_interface_id
                                            
                                            	LSA link interface ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_metric
                                            
                                            	LSA link metric 
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: link_neighbor_interface_id
                                            
                                            	LSA link neighbor interface ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_neighbor_router_id
                                            
                                            	LSA link neigbhor router id 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_type
                                            
                                            	Type of link
                                            	**type**\:   :py:class:`Ospfv3Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Link>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__init__()

                                                self.yang_name = "link"
                                                self.yang_parent_name = "router-lsa-type"

                                                self.link_interface_id = YLeaf(YType.uint32, "link-interface-id")

                                                self.link_metric = YLeaf(YType.uint16, "link-metric")

                                                self.link_neighbor_interface_id = YLeaf(YType.uint32, "link-neighbor-interface-id")

                                                self.link_neighbor_router_id = YLeaf(YType.uint32, "link-neighbor-router-id")

                                                self.link_type = YLeaf(YType.enumeration, "link-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("link_interface_id",
                                                                "link_metric",
                                                                "link_neighbor_interface_id",
                                                                "link_neighbor_router_id",
                                                                "link_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.link_interface_id.is_set or
                                                    self.link_metric.is_set or
                                                    self.link_neighbor_interface_id.is_set or
                                                    self.link_neighbor_router_id.is_set or
                                                    self.link_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.link_interface_id.yfilter != YFilter.not_set or
                                                    self.link_metric.yfilter != YFilter.not_set or
                                                    self.link_neighbor_interface_id.yfilter != YFilter.not_set or
                                                    self.link_neighbor_router_id.yfilter != YFilter.not_set or
                                                    self.link_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "link" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.link_interface_id.is_set or self.link_interface_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_interface_id.get_name_leafdata())
                                                if (self.link_metric.is_set or self.link_metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_metric.get_name_leafdata())
                                                if (self.link_neighbor_interface_id.is_set or self.link_neighbor_interface_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_neighbor_interface_id.get_name_leafdata())
                                                if (self.link_neighbor_router_id.is_set or self.link_neighbor_router_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_neighbor_router_id.get_name_leafdata())
                                                if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "link-interface-id" or name == "link-metric" or name == "link-neighbor-interface-id" or name == "link-neighbor-router-id" or name == "link-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "link-interface-id"):
                                                    self.link_interface_id = value
                                                    self.link_interface_id.value_namespace = name_space
                                                    self.link_interface_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-metric"):
                                                    self.link_metric = value
                                                    self.link_metric.value_namespace = name_space
                                                    self.link_metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-neighbor-interface-id"):
                                                    self.link_neighbor_interface_id = value
                                                    self.link_neighbor_interface_id.value_namespace = name_space
                                                    self.link_neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-neighbor-router-id"):
                                                    self.link_neighbor_router_id = value
                                                    self.link_neighbor_router_id.value_namespace = name_space
                                                    self.link_neighbor_router_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-type"):
                                                    self.link_type = value
                                                    self.link_type.value_namespace = name_space
                                                    self.link_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.link:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.router_la_bits.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()) or
                                                (self.rpf_path is not None and self.rpf_path.has_data()))

                                        def has_operation(self):
                                            for c in self.link:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.router_la_bits.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()) or
                                                (self.rpf_path is not None and self.rpf_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "router-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.router_la_bits.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "link"):
                                                for c in self.link:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.link.append(c)
                                                return c

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            if (child_yang_name == "rpf-path"):
                                                if (self.rpf_path is None):
                                                    self.rpf_path = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                    self.rpf_path.parent = self
                                                    self._children_name_map["rpf_path"] = "rpf-path"
                                                return self.rpf_path

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "link" or name == "lsa-detail" or name == "lsa-header" or name == "rpf-path" or name == "router-la-bits"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "router-la-bits"):
                                                self.router_la_bits = value
                                                self.router_la_bits.value_namespace = name_space
                                                self.router_la_bits.value_namespace_prefix = name_space_prefix


                                    class NetworkLsaType(Entity):
                                        """
                                        Network LSA
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader>`
                                        
                                        .. attribute:: neighbor_router
                                        
                                        	Neighbor router list
                                        	**type**\:  list of str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__init__()

                                            self.yang_name = "network-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.neighbor_router = YLeafList(YType.str, "neighbor-router")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("neighbor_router") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "network-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "network-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for leaf in self.neighbor_router.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return (
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            for leaf in self.neighbor_router.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.neighbor_router.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "network-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            leaf_name_data.extend(self.neighbor_router.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "neighbor-router"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "neighbor-router"):
                                                self.neighbor_router.append(value)


                                    class InterAreaPrefixLsaType(Entity):
                                        """
                                        Inter Area Prefix LSA
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA Information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader>`
                                        
                                        .. attribute:: prefix
                                        
                                        	LSA address prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: prefix_length
                                        
                                        	Prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: priority
                                        
                                        	Prefix priority
                                        	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__init__()

                                            self.yang_name = "inter-area-prefix-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                            self.priority = YLeaf(YType.enumeration, "priority")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("prefix",
                                                            "prefix_length",
                                                            "priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA Information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.prefix.is_set or
                                                self.prefix_length.is_set or
                                                self.priority.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.prefix_length.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inter-area-prefix-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "prefix-length" or name == "priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-length"):
                                                self.prefix_length = value
                                                self.prefix_length.value_namespace = name_space
                                                self.prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix


                                    class InterAreaRouterLsaType(Entity):
                                        """
                                        Inter Area Router LSA
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader>`
                                        
                                        .. attribute:: lsa_router_id
                                        
                                        	LSA router ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__init__()

                                            self.yang_name = "inter-area-router-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("lsa_router_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "inter-area-router-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "inter-area-router-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.lsa_router_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.lsa_router_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inter-area-router-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_router_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "lsa-router-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "lsa-router-id"):
                                                self.lsa_router_id = value
                                                self.lsa_router_id.value_namespace = name_space
                                                self.lsa_router_id.value_namespace_prefix = name_space_prefix


                                    class ExternalLsaType(Entity):
                                        """
                                        External LSA
                                        
                                        .. attribute:: external_tag
                                        
                                        	Route Tag
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forwarding_address
                                        
                                        	Forwarding Address
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: is_forwarding_address_set
                                        
                                        	If true, forwarding address is set 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA Information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader>`
                                        
                                        .. attribute:: metric_type
                                        
                                        	Metric type 
                                        	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                        
                                        .. attribute:: prefix
                                        
                                        	IPV6 address prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: prefix_length
                                        
                                        	Prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: priority
                                        
                                        	Prefix priority
                                        	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                        
                                        .. attribute:: tos_cost
                                        
                                        	Type of service cost metric 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__init__()

                                            self.yang_name = "external-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.external_tag = YLeaf(YType.uint32, "external-tag")

                                            self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                            self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                            self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                            self.priority = YLeaf(YType.enumeration, "priority")

                                            self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("external_tag",
                                                            "forwarding_address",
                                                            "is_forwarding_address_set",
                                                            "metric_type",
                                                            "prefix",
                                                            "prefix_length",
                                                            "priority",
                                                            "tos_cost") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "external-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA Information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "external-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.external_tag.is_set or
                                                self.forwarding_address.is_set or
                                                self.is_forwarding_address_set.is_set or
                                                self.metric_type.is_set or
                                                self.prefix.is_set or
                                                self.prefix_length.is_set or
                                                self.priority.is_set or
                                                self.tos_cost.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.external_tag.yfilter != YFilter.not_set or
                                                self.forwarding_address.yfilter != YFilter.not_set or
                                                self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                self.metric_type.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.prefix_length.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set or
                                                self.tos_cost.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "external-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.external_tag.get_name_leafdata())
                                            if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                            if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                            if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.metric_type.get_name_leafdata())
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())
                                            if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "external-tag"):
                                                self.external_tag = value
                                                self.external_tag.value_namespace = name_space
                                                self.external_tag.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forwarding-address"):
                                                self.forwarding_address = value
                                                self.forwarding_address.value_namespace = name_space
                                                self.forwarding_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-forwarding-address-set"):
                                                self.is_forwarding_address_set = value
                                                self.is_forwarding_address_set.value_namespace = name_space
                                                self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                            if(value_path == "metric-type"):
                                                self.metric_type = value
                                                self.metric_type.value_namespace = name_space
                                                self.metric_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-length"):
                                                self.prefix_length = value
                                                self.prefix_length.value_namespace = name_space
                                                self.prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tos-cost"):
                                                self.tos_cost = value
                                                self.tos_cost.value_namespace = name_space
                                                self.tos_cost.value_namespace_prefix = name_space_prefix


                                    class NssalsaType(Entity):
                                        """
                                        NSSA External LSA
                                        
                                        .. attribute:: external_tag
                                        
                                        	Route Tag
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forwarding_address
                                        
                                        	Forwarding Address
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: is_forwarding_address_set
                                        
                                        	If true, forwarding address is set 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA Information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader>`
                                        
                                        .. attribute:: metric_type
                                        
                                        	Metric type 
                                        	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                        
                                        .. attribute:: prefix
                                        
                                        	IPV6 address prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: prefix_length
                                        
                                        	Prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: priority
                                        
                                        	Prefix priority
                                        	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                        
                                        .. attribute:: tos_cost
                                        
                                        	Type of service cost metric 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__init__()

                                            self.yang_name = "nssalsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.external_tag = YLeaf(YType.uint32, "external-tag")

                                            self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                            self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                            self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                            self.priority = YLeaf(YType.enumeration, "priority")

                                            self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("external_tag",
                                                            "forwarding_address",
                                                            "is_forwarding_address_set",
                                                            "metric_type",
                                                            "prefix",
                                                            "prefix_length",
                                                            "priority",
                                                            "tos_cost") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "nssalsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA Information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "nssalsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.external_tag.is_set or
                                                self.forwarding_address.is_set or
                                                self.is_forwarding_address_set.is_set or
                                                self.metric_type.is_set or
                                                self.prefix.is_set or
                                                self.prefix_length.is_set or
                                                self.priority.is_set or
                                                self.tos_cost.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.external_tag.yfilter != YFilter.not_set or
                                                self.forwarding_address.yfilter != YFilter.not_set or
                                                self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                self.metric_type.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.prefix_length.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set or
                                                self.tos_cost.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nssalsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.external_tag.get_name_leafdata())
                                            if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                            if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                            if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.metric_type.get_name_leafdata())
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())
                                            if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "external-tag"):
                                                self.external_tag = value
                                                self.external_tag.value_namespace = name_space
                                                self.external_tag.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forwarding-address"):
                                                self.forwarding_address = value
                                                self.forwarding_address.value_namespace = name_space
                                                self.forwarding_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-forwarding-address-set"):
                                                self.is_forwarding_address_set = value
                                                self.is_forwarding_address_set.value_namespace = name_space
                                                self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                            if(value_path == "metric-type"):
                                                self.metric_type = value
                                                self.metric_type.value_namespace = name_space
                                                self.metric_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-length"):
                                                self.prefix_length = value
                                                self.prefix_length.value_namespace = name_space
                                                self.prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tos-cost"):
                                                self.tos_cost = value
                                                self.tos_cost.value_namespace = name_space
                                                self.tos_cost.value_namespace_prefix = name_space_prefix


                                    class LinkLsaType(Entity):
                                        """
                                        Link LSA
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface handle
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader>`
                                        
                                        .. attribute:: lsa_link_local
                                        
                                        	LSA link local 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: prefix
                                        
                                        	OSPFv3 prefix 
                                        	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix>`
                                        
                                        .. attribute:: router_priority
                                        
                                        	Router priority 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Sham link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__init__()

                                            self.yang_name = "link-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.lsa_link_local = YLeaf(YType.str, "lsa-link-local")

                                            self.router_priority = YLeaf(YType.uint8, "router-priority")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                            self.prefix = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "lsa_link_local",
                                                            "router_priority",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "link-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "link-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix


                                        class Prefix(Entity):
                                            """
                                            OSPFv3 prefix 
                                            
                                            .. attribute:: ospfv3_prefix_length
                                            
                                            	OSPFv3 prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ospfv3_prefix_metric
                                            
                                            	OSPFv3 prefix metric 
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: ospfv3_prefix_options
                                            
                                            	OSPFv3 prefix options 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: prefix
                                            
                                            	OSPFv3 prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: priority
                                            
                                            	Prefix priority
                                            	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__init__()

                                                self.yang_name = "prefix"
                                                self.yang_parent_name = "link-lsa-type"

                                                self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.priority = YLeaf(YType.enumeration, "priority")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("ospfv3_prefix_length",
                                                                "ospfv3_prefix_metric",
                                                                "ospfv3_prefix_options",
                                                                "prefix",
                                                                "priority") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.ospfv3_prefix_length.is_set or
                                                    self.ospfv3_prefix_metric.is_set or
                                                    self.ospfv3_prefix_options.is_set or
                                                    self.prefix.is_set or
                                                    self.priority.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prefix" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "ospfv3-prefix-length"):
                                                    self.ospfv3_prefix_length = value
                                                    self.ospfv3_prefix_length.value_namespace = name_space
                                                    self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ospfv3-prefix-metric"):
                                                    self.ospfv3_prefix_metric = value
                                                    self.ospfv3_prefix_metric.value_namespace = name_space
                                                    self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ospfv3-prefix-options"):
                                                    self.ospfv3_prefix_options = value
                                                    self.ospfv3_prefix_options.value_namespace = name_space
                                                    self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prefix:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.lsa_link_local.is_set or
                                                self.router_priority.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            for c in self.prefix:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.lsa_link_local.yfilter != YFilter.not_set or
                                                self.router_priority.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.lsa_link_local.is_set or self.lsa_link_local.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_link_local.get_name_leafdata())
                                            if (self.router_priority.is_set or self.router_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.router_priority.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            if (child_yang_name == "prefix"):
                                                for c in self.prefix:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prefix.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "lsa-link-local" or name == "router-priority" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-link-local"):
                                                self.lsa_link_local = value
                                                self.lsa_link_local.value_namespace = name_space
                                                self.lsa_link_local.value_namespace_prefix = name_space_prefix
                                            if(value_path == "router-priority"):
                                                self.router_priority = value
                                                self.router_priority.value_namespace = name_space
                                                self.router_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                    class IntraAreaPrefixLsaType(Entity):
                                        """
                                        Intra Area Prefix LSA
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader>`
                                        
                                        .. attribute:: prefix
                                        
                                        	OSPFv3 prefix 
                                        	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix>`
                                        
                                        .. attribute:: reference_advertised_router
                                        
                                        	Reference advertised router 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: reference_lsa_id
                                        
                                        	Reference LSA ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: reference_type
                                        
                                        	Reference type 
                                        	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__init__()

                                            self.yang_name = "intra-area-prefix-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.reference_advertised_router = YLeaf(YType.str, "reference-advertised-router")

                                            self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                            self.reference_type = YLeaf(YType.enumeration, "reference-type")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                            self.prefix = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("reference_advertised_router",
                                                            "reference_lsa_id",
                                                            "reference_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix


                                        class Prefix(Entity):
                                            """
                                            OSPFv3 prefix 
                                            
                                            .. attribute:: ospfv3_prefix_length
                                            
                                            	OSPFv3 prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ospfv3_prefix_metric
                                            
                                            	OSPFv3 prefix metric 
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: ospfv3_prefix_options
                                            
                                            	OSPFv3 prefix options 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: prefix
                                            
                                            	OSPFv3 prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: priority
                                            
                                            	Prefix priority
                                            	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__init__()

                                                self.yang_name = "prefix"
                                                self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.priority = YLeaf(YType.enumeration, "priority")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("ospfv3_prefix_length",
                                                                "ospfv3_prefix_metric",
                                                                "ospfv3_prefix_options",
                                                                "prefix",
                                                                "priority") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.ospfv3_prefix_length.is_set or
                                                    self.ospfv3_prefix_metric.is_set or
                                                    self.ospfv3_prefix_options.is_set or
                                                    self.prefix.is_set or
                                                    self.priority.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                    self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prefix" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "ospfv3-prefix-length"):
                                                    self.ospfv3_prefix_length = value
                                                    self.ospfv3_prefix_length.value_namespace = name_space
                                                    self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ospfv3-prefix-metric"):
                                                    self.ospfv3_prefix_metric = value
                                                    self.ospfv3_prefix_metric.value_namespace = name_space
                                                    self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ospfv3-prefix-options"):
                                                    self.ospfv3_prefix_options = value
                                                    self.ospfv3_prefix_options.value_namespace = name_space
                                                    self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prefix:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.reference_advertised_router.is_set or
                                                self.reference_lsa_id.is_set or
                                                self.reference_type.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            for c in self.prefix:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.reference_advertised_router.yfilter != YFilter.not_set or
                                                self.reference_lsa_id.yfilter != YFilter.not_set or
                                                self.reference_type.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "intra-area-prefix-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.reference_advertised_router.is_set or self.reference_advertised_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.reference_advertised_router.get_name_leafdata())
                                            if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                            if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.reference_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            if (child_yang_name == "prefix"):
                                                for c in self.prefix:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prefix.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "reference-advertised-router" or name == "reference-lsa-id" or name == "reference-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "reference-advertised-router"):
                                                self.reference_advertised_router = value
                                                self.reference_advertised_router.value_namespace = name_space
                                                self.reference_advertised_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "reference-lsa-id"):
                                                self.reference_lsa_id = value
                                                self.reference_lsa_id.value_namespace = name_space
                                                self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "reference-type"):
                                                self.reference_type = value
                                                self.reference_type.value_namespace = name_space
                                                self.reference_type.value_namespace_prefix = name_space_prefix


                                    class GraceLsa(Entity):
                                        """
                                        Grace LSA
                                        
                                        .. attribute:: grace_period
                                        
                                        	The grace periord where helper routers should wait before advertising it fully adjacent(s) 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: grace_reason
                                        
                                        	Reason for router restart
                                        	**type**\:   :py:class:`Ospfv3GracefulRestartReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3GracefulRestartReason>`
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__init__()

                                            self.yang_name = "grace-lsa"
                                            self.yang_parent_name = "lsa-info"

                                            self.grace_period = YLeaf(YType.uint32, "grace-period")

                                            self.grace_reason = YLeaf(YType.enumeration, "grace-reason")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("grace_period",
                                                            "grace_reason") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "grace-lsa"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "grace-lsa"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.grace_period.is_set or
                                                self.grace_reason.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.grace_period.yfilter != YFilter.not_set or
                                                self.grace_reason.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "grace-lsa" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.grace_period.is_set or self.grace_period.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grace_period.get_name_leafdata())
                                            if (self.grace_reason.is_set or self.grace_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grace_reason.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "grace-period" or name == "grace-reason"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "grace-period"):
                                                self.grace_period = value
                                                self.grace_period.value_namespace = name_space
                                                self.grace_period.value_namespace_prefix = name_space_prefix
                                            if(value_path == "grace-reason"):
                                                self.grace_reason = value
                                                self.grace_reason.value_namespace = name_space
                                                self.grace_reason.value_namespace_prefix = name_space_prefix


                                    class UnknownLinkLsaType(Entity):
                                        """
                                        Unknown Link Scope LSA
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface name 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader>`
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Shamlink ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__init__()

                                            self.yang_name = "unknown-link-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "unknown-link-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "unknown-link-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unknown-link-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                    class UnknownAreaLsaType(Entity):
                                        """
                                        Unknown\-Area scope LSA
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface name 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader>`
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Shamlink ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__init__()

                                            self.yang_name = "unknown-area-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "unknown-area-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "unknown-area-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unknown-area-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                    class UnknownAslsaType(Entity):
                                        """
                                        Unknown\-AS scope LSA
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface name 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader>`
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Shamlink ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__init__()

                                            self.yang_name = "unknown-aslsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "unknown-aslsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "unknown-aslsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unknown-aslsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                    class UnknownLsaType(Entity):
                                        """
                                        Unknown LSA
                                        
                                        .. attribute:: interface_name
                                        
                                        	LSA interface name 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: is_sham_link
                                        
                                        	If true, it is a sham link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_virtual_link
                                        
                                        	If true, it is a virtual link 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_detail
                                        
                                        	Detailed LSA information
                                        	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail>`
                                        
                                        .. attribute:: lsa_header
                                        
                                        	Header information 
                                        	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader>`
                                        
                                        .. attribute:: sham_link_id
                                        
                                        	Shamlink ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: virtual_link_id
                                        
                                        	Virtual link ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__init__()

                                            self.yang_name = "unknown-lsa-type"
                                            self.yang_parent_name = "lsa-info"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                            self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                            self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                            self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                            self.lsa_detail.parent = self
                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                            self._children_yang_names.add("lsa-detail")

                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                            self.lsa_header.parent = self
                                            self._children_name_map["lsa_header"] = "lsa-header"
                                            self._children_yang_names.add("lsa-header")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "is_sham_link",
                                                            "is_virtual_link",
                                                            "sham_link_id",
                                                            "virtual_link_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)


                                        class LsaHeader(Entity):
                                            """
                                            Header information 
                                            
                                            .. attribute:: advertising_router
                                            
                                            	Router ID of Advertising Router
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: checksum
                                            
                                            	Checksum value
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: is_do_not_age_lsa
                                            
                                            	If true, Do Not Age this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_graceful_restart_active
                                            
                                            	If true, if grace restart is active 
                                            	**type**\:  bool
                                            
                                            .. attribute:: ls_id
                                            
                                            	LS ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_age
                                            
                                            	LSA's Age (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_area_id
                                            
                                            	Area ID in decimal or dotted\-decimal format
                                            	**type**\:  str
                                            
                                            	**length:** 0..16
                                            
                                            .. attribute:: lsa_type
                                            
                                            	LSA type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sequence_number
                                            
                                            	Current Sequence number
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__init__()

                                                self.yang_name = "lsa-header"
                                                self.yang_parent_name = "unknown-lsa-type"

                                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                self.checksum = YLeaf(YType.uint16, "checksum")

                                                self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("advertising_router",
                                                                "checksum",
                                                                "is_do_not_age_lsa",
                                                                "is_graceful_restart_active",
                                                                "ls_id",
                                                                "lsa_age",
                                                                "lsa_area_id",
                                                                "lsa_type",
                                                                "sequence_number") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.advertising_router.is_set or
                                                    self.checksum.is_set or
                                                    self.is_do_not_age_lsa.is_set or
                                                    self.is_graceful_restart_active.is_set or
                                                    self.ls_id.is_set or
                                                    self.lsa_age.is_set or
                                                    self.lsa_area_id.is_set or
                                                    self.lsa_type.is_set or
                                                    self.sequence_number.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.advertising_router.yfilter != YFilter.not_set or
                                                    self.checksum.yfilter != YFilter.not_set or
                                                    self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                    self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                    self.ls_id.yfilter != YFilter.not_set or
                                                    self.lsa_age.yfilter != YFilter.not_set or
                                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                                    self.lsa_type.yfilter != YFilter.not_set or
                                                    self.sequence_number.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-header" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.checksum.get_name_leafdata())
                                                if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "advertising-router"):
                                                    self.advertising_router = value
                                                    self.advertising_router.value_namespace = name_space
                                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "checksum"):
                                                    self.checksum = value
                                                    self.checksum.value_namespace = name_space
                                                    self.checksum.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-do-not-age-lsa"):
                                                    self.is_do_not_age_lsa = value
                                                    self.is_do_not_age_lsa.value_namespace = name_space
                                                    self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-graceful-restart-active"):
                                                    self.is_graceful_restart_active = value
                                                    self.is_graceful_restart_active.value_namespace = name_space
                                                    self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ls-id"):
                                                    self.ls_id = value
                                                    self.ls_id.value_namespace = name_space
                                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-age"):
                                                    self.lsa_age = value
                                                    self.lsa_age.value_namespace = name_space
                                                    self.lsa_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-area-id"):
                                                    self.lsa_area_id = value
                                                    self.lsa_area_id.value_namespace = name_space
                                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-type"):
                                                    self.lsa_type = value
                                                    self.lsa_type.value_namespace = name_space
                                                    self.lsa_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sequence-number"):
                                                    self.sequence_number = value
                                                    self.sequence_number.value_namespace = name_space
                                                    self.sequence_number.value_namespace_prefix = name_space_prefix


                                        class LsaDetail(Entity):
                                            """
                                            Detailed LSA information
                                            
                                            .. attribute:: free_time
                                            
                                            	The amount of time since the last check was made to free this LSA (s)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_acknowledged
                                            
                                            	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_advertising_router_reachable
                                            
                                            	If true, Advertising Router is reachable
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_deleted
                                            
                                            	If true, flag is set to delete this LSA 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_flood_pending
                                            
                                            	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_maximum_aged
                                            
                                            	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_neighbor_exchange
                                            
                                            	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_no_delete
                                            
                                            	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_nsr_ack_pending
                                            
                                            	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_partial_spf
                                            
                                            	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_bit
                                            
                                            	If true, Routing Bit set on the LSA
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_routing_table
                                            
                                            	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_flood_required_post_fail_over
                                            
                                            	LSA flood required after FO
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_length
                                            
                                            	Length of the LSA
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_sync_state
                                            
                                            	State of LSA sync with active
                                            	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                            
                                            .. attribute:: minute_table_index
                                            
                                            	Minute table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: nsr_flood_required
                                            
                                            	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                            	**type**\:  bool
                                            
                                            .. attribute:: rate_limit
                                            
                                            	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                            	**type**\:  bool
                                            
                                            .. attribute:: second_table_index
                                            
                                            	Second table index
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__init__()

                                                self.yang_name = "lsa-detail"
                                                self.yang_parent_name = "unknown-lsa-type"

                                                self.free_time = YLeaf(YType.uint32, "free-time")

                                                self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("free_time",
                                                                "is_acknowledged",
                                                                "is_advertising_router_reachable",
                                                                "is_deleted",
                                                                "is_flood_pending",
                                                                "is_maximum_aged",
                                                                "is_neighbor_exchange",
                                                                "is_no_delete",
                                                                "is_nsr_ack_pending",
                                                                "is_partial_spf",
                                                                "is_routing_bit",
                                                                "is_routing_table",
                                                                "lsa_flood_required_post_fail_over",
                                                                "lsa_length",
                                                                "lsa_sync_state",
                                                                "minute_table_index",
                                                                "nsr_flood_required",
                                                                "rate_limit",
                                                                "second_table_index") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.free_time.is_set or
                                                    self.is_acknowledged.is_set or
                                                    self.is_advertising_router_reachable.is_set or
                                                    self.is_deleted.is_set or
                                                    self.is_flood_pending.is_set or
                                                    self.is_maximum_aged.is_set or
                                                    self.is_neighbor_exchange.is_set or
                                                    self.is_no_delete.is_set or
                                                    self.is_nsr_ack_pending.is_set or
                                                    self.is_partial_spf.is_set or
                                                    self.is_routing_bit.is_set or
                                                    self.is_routing_table.is_set or
                                                    self.lsa_flood_required_post_fail_over.is_set or
                                                    self.lsa_length.is_set or
                                                    self.lsa_sync_state.is_set or
                                                    self.minute_table_index.is_set or
                                                    self.nsr_flood_required.is_set or
                                                    self.rate_limit.is_set or
                                                    self.second_table_index.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.free_time.yfilter != YFilter.not_set or
                                                    self.is_acknowledged.yfilter != YFilter.not_set or
                                                    self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                    self.is_deleted.yfilter != YFilter.not_set or
                                                    self.is_flood_pending.yfilter != YFilter.not_set or
                                                    self.is_maximum_aged.yfilter != YFilter.not_set or
                                                    self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                    self.is_no_delete.yfilter != YFilter.not_set or
                                                    self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                    self.is_partial_spf.yfilter != YFilter.not_set or
                                                    self.is_routing_bit.yfilter != YFilter.not_set or
                                                    self.is_routing_table.yfilter != YFilter.not_set or
                                                    self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                    self.lsa_length.yfilter != YFilter.not_set or
                                                    self.lsa_sync_state.yfilter != YFilter.not_set or
                                                    self.minute_table_index.yfilter != YFilter.not_set or
                                                    self.nsr_flood_required.yfilter != YFilter.not_set or
                                                    self.rate_limit.yfilter != YFilter.not_set or
                                                    self.second_table_index.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-detail" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.free_time.get_name_leafdata())
                                                if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "free-time"):
                                                    self.free_time = value
                                                    self.free_time.value_namespace = name_space
                                                    self.free_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-acknowledged"):
                                                    self.is_acknowledged = value
                                                    self.is_acknowledged.value_namespace = name_space
                                                    self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-advertising-router-reachable"):
                                                    self.is_advertising_router_reachable = value
                                                    self.is_advertising_router_reachable.value_namespace = name_space
                                                    self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-deleted"):
                                                    self.is_deleted = value
                                                    self.is_deleted.value_namespace = name_space
                                                    self.is_deleted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-flood-pending"):
                                                    self.is_flood_pending = value
                                                    self.is_flood_pending.value_namespace = name_space
                                                    self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-maximum-aged"):
                                                    self.is_maximum_aged = value
                                                    self.is_maximum_aged.value_namespace = name_space
                                                    self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-neighbor-exchange"):
                                                    self.is_neighbor_exchange = value
                                                    self.is_neighbor_exchange.value_namespace = name_space
                                                    self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-delete"):
                                                    self.is_no_delete = value
                                                    self.is_no_delete.value_namespace = name_space
                                                    self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-nsr-ack-pending"):
                                                    self.is_nsr_ack_pending = value
                                                    self.is_nsr_ack_pending.value_namespace = name_space
                                                    self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-partial-spf"):
                                                    self.is_partial_spf = value
                                                    self.is_partial_spf.value_namespace = name_space
                                                    self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-bit"):
                                                    self.is_routing_bit = value
                                                    self.is_routing_bit.value_namespace = name_space
                                                    self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-routing-table"):
                                                    self.is_routing_table = value
                                                    self.is_routing_table.value_namespace = name_space
                                                    self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-flood-required-post-fail-over"):
                                                    self.lsa_flood_required_post_fail_over = value
                                                    self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                    self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-length"):
                                                    self.lsa_length = value
                                                    self.lsa_length.value_namespace = name_space
                                                    self.lsa_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-sync-state"):
                                                    self.lsa_sync_state = value
                                                    self.lsa_sync_state.value_namespace = name_space
                                                    self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "minute-table-index"):
                                                    self.minute_table_index = value
                                                    self.minute_table_index.value_namespace = name_space
                                                    self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nsr-flood-required"):
                                                    self.nsr_flood_required = value
                                                    self.nsr_flood_required.value_namespace = name_space
                                                    self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                if(value_path == "rate-limit"):
                                                    self.rate_limit = value
                                                    self.rate_limit.value_namespace = name_space
                                                    self.rate_limit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "second-table-index"):
                                                    self.second_table_index = value
                                                    self.second_table_index.value_namespace = name_space
                                                    self.second_table_index.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.is_sham_link.is_set or
                                                self.is_virtual_link.is_set or
                                                self.sham_link_id.is_set or
                                                self.virtual_link_id.is_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                (self.lsa_header is not None and self.lsa_header.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.is_sham_link.yfilter != YFilter.not_set or
                                                self.is_virtual_link.yfilter != YFilter.not_set or
                                                self.sham_link_id.yfilter != YFilter.not_set or
                                                self.virtual_link_id.yfilter != YFilter.not_set or
                                                (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                (self.lsa_header is not None and self.lsa_header.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unknown-lsa-type" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                            if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                            if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                            if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-detail"):
                                                if (self.lsa_detail is None):
                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                return self.lsa_detail

                                            if (child_yang_name == "lsa-header"):
                                                if (self.lsa_header is None):
                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                return self.lsa_header

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-sham-link"):
                                                self.is_sham_link = value
                                                self.is_sham_link.value_namespace = name_space
                                                self.is_sham_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-virtual-link"):
                                                self.is_virtual_link = value
                                                self.is_virtual_link.value_namespace = name_space
                                                self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sham-link-id"):
                                                self.sham_link_id = value
                                                self.sham_link_id.value_namespace = name_space
                                                self.sham_link_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "virtual-link-id"):
                                                self.virtual_link_id = value
                                                self.virtual_link_id.value_namespace = name_space
                                                self.virtual_link_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.lsa_info_type.is_set or
                                            (self.external_lsa_type is not None and self.external_lsa_type.has_data()) or
                                            (self.grace_lsa is not None and self.grace_lsa.has_data()) or
                                            (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_data()) or
                                            (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_data()) or
                                            (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_data()) or
                                            (self.link_lsa_type is not None and self.link_lsa_type.has_data()) or
                                            (self.lsa_summary_info is not None and self.lsa_summary_info.has_data()) or
                                            (self.network_lsa_type is not None and self.network_lsa_type.has_data()) or
                                            (self.nssalsa_type is not None and self.nssalsa_type.has_data()) or
                                            (self.router_lsa_type is not None and self.router_lsa_type.has_data()) or
                                            (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_data()) or
                                            (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_data()) or
                                            (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_data()) or
                                            (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.lsa_info_type.yfilter != YFilter.not_set or
                                            (self.external_lsa_type is not None and self.external_lsa_type.has_operation()) or
                                            (self.grace_lsa is not None and self.grace_lsa.has_operation()) or
                                            (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_operation()) or
                                            (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_operation()) or
                                            (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_operation()) or
                                            (self.link_lsa_type is not None and self.link_lsa_type.has_operation()) or
                                            (self.lsa_summary_info is not None and self.lsa_summary_info.has_operation()) or
                                            (self.network_lsa_type is not None and self.network_lsa_type.has_operation()) or
                                            (self.nssalsa_type is not None and self.nssalsa_type.has_operation()) or
                                            (self.router_lsa_type is not None and self.router_lsa_type.has_operation()) or
                                            (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_operation()) or
                                            (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_operation()) or
                                            (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_operation()) or
                                            (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsa-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.lsa_info_type.is_set or self.lsa_info_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_info_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "external-lsa-type"):
                                            if (self.external_lsa_type is None):
                                                self.external_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType()
                                                self.external_lsa_type.parent = self
                                                self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                            return self.external_lsa_type

                                        if (child_yang_name == "grace-lsa"):
                                            if (self.grace_lsa is None):
                                                self.grace_lsa = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa()
                                                self.grace_lsa.parent = self
                                                self._children_name_map["grace_lsa"] = "grace-lsa"
                                            return self.grace_lsa

                                        if (child_yang_name == "inter-area-prefix-lsa-type"):
                                            if (self.inter_area_prefix_lsa_type is None):
                                                self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                                self.inter_area_prefix_lsa_type.parent = self
                                                self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                            return self.inter_area_prefix_lsa_type

                                        if (child_yang_name == "inter-area-router-lsa-type"):
                                            if (self.inter_area_router_lsa_type is None):
                                                self.inter_area_router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                                self.inter_area_router_lsa_type.parent = self
                                                self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                            return self.inter_area_router_lsa_type

                                        if (child_yang_name == "intra-area-prefix-lsa-type"):
                                            if (self.intra_area_prefix_lsa_type is None):
                                                self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                                self.intra_area_prefix_lsa_type.parent = self
                                                self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                            return self.intra_area_prefix_lsa_type

                                        if (child_yang_name == "link-lsa-type"):
                                            if (self.link_lsa_type is None):
                                                self.link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType()
                                                self.link_lsa_type.parent = self
                                                self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                            return self.link_lsa_type

                                        if (child_yang_name == "lsa-summary-info"):
                                            if (self.lsa_summary_info is None):
                                                self.lsa_summary_info = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo()
                                                self.lsa_summary_info.parent = self
                                                self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                            return self.lsa_summary_info

                                        if (child_yang_name == "network-lsa-type"):
                                            if (self.network_lsa_type is None):
                                                self.network_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType()
                                                self.network_lsa_type.parent = self
                                                self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                            return self.network_lsa_type

                                        if (child_yang_name == "nssalsa-type"):
                                            if (self.nssalsa_type is None):
                                                self.nssalsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType()
                                                self.nssalsa_type.parent = self
                                                self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                            return self.nssalsa_type

                                        if (child_yang_name == "router-lsa-type"):
                                            if (self.router_lsa_type is None):
                                                self.router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType()
                                                self.router_lsa_type.parent = self
                                                self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                            return self.router_lsa_type

                                        if (child_yang_name == "unknown-area-lsa-type"):
                                            if (self.unknown_area_lsa_type is None):
                                                self.unknown_area_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                                self.unknown_area_lsa_type.parent = self
                                                self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                            return self.unknown_area_lsa_type

                                        if (child_yang_name == "unknown-aslsa-type"):
                                            if (self.unknown_aslsa_type is None):
                                                self.unknown_aslsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType()
                                                self.unknown_aslsa_type.parent = self
                                                self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                            return self.unknown_aslsa_type

                                        if (child_yang_name == "unknown-link-lsa-type"):
                                            if (self.unknown_link_lsa_type is None):
                                                self.unknown_link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                                self.unknown_link_lsa_type.parent = self
                                                self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                            return self.unknown_link_lsa_type

                                        if (child_yang_name == "unknown-lsa-type"):
                                            if (self.unknown_lsa_type is None):
                                                self.unknown_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType()
                                                self.unknown_lsa_type.parent = self
                                                self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                            return self.unknown_lsa_type

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "external-lsa-type" or name == "grace-lsa" or name == "inter-area-prefix-lsa-type" or name == "inter-area-router-lsa-type" or name == "intra-area-prefix-lsa-type" or name == "link-lsa-type" or name == "lsa-summary-info" or name == "network-lsa-type" or name == "nssalsa-type" or name == "router-lsa-type" or name == "unknown-area-lsa-type" or name == "unknown-aslsa-type" or name == "unknown-link-lsa-type" or name == "unknown-lsa-type" or name == "lsa-info-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "lsa-info-type"):
                                            self.lsa_info_type = value
                                            self.lsa_info_type.value_namespace = name_space
                                            self.lsa_info_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.advertising_router.is_set or
                                        self.area_id.is_set or
                                        self.interface_name.is_set or
                                        self.ls_id.is_set or
                                        self.ls_type.is_set or
                                        (self.lsa_info is not None and self.lsa_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.advertising_router.yfilter != YFilter.not_set or
                                        self.area_id.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.ls_id.yfilter != YFilter.not_set or
                                        self.ls_type.yfilter != YFilter.not_set or
                                        (self.lsa_info is not None and self.lsa_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsa" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_id.get_name_leafdata())
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                    if (self.ls_type.is_set or self.ls_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "lsa-info"):
                                        if (self.lsa_info is None):
                                            self.lsa_info = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo()
                                            self.lsa_info.parent = self
                                            self._children_name_map["lsa_info"] = "lsa-info"
                                        return self.lsa_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "lsa-info" or name == "advertising-router" or name == "area-id" or name == "interface-name" or name == "ls-id" or name == "ls-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "advertising-router"):
                                        self.advertising_router = value
                                        self.advertising_router.value_namespace = name_space
                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-id"):
                                        self.area_id = value
                                        self.area_id.value_namespace = name_space
                                        self.area_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-id"):
                                        self.ls_id = value
                                        self.ls_id.value_namespace = name_space
                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-type"):
                                        self.ls_type = value
                                        self.ls_type.value_namespace = name_space
                                        self.ls_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.lsa:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.lsa:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsa-internal-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "lsa"):
                                    for c in self.lsa:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable.Lsa()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.lsa.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsa"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.lsa_internal_table is not None and self.lsa_internal_table.has_data()) or
                                (self.lsa_table is not None and self.lsa_table.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.lsa_internal_table is not None and self.lsa_internal_table.has_operation()) or
                                (self.lsa_table is not None and self.lsa_table.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "database-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "lsa-internal-table"):
                                if (self.lsa_internal_table is None):
                                    self.lsa_internal_table = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaInternalTable()
                                    self.lsa_internal_table.parent = self
                                    self._children_name_map["lsa_internal_table"] = "lsa-internal-table"
                                return self.lsa_internal_table

                            if (child_yang_name == "lsa-table"):
                                if (self.lsa_table is None):
                                    self.lsa_table = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable.LsaTable()
                                    self.lsa_table.parent = self
                                    self._children_name_map["lsa_table"] = "lsa-table"
                                return self.lsa_table

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsa-internal-table" or name == "lsa-table"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class InterfaceProcessTable(Entity):
                        """
                        OSPFv3 interface information table for all areas
                        
                        .. attribute:: interface
                        
                        	OSPFv3 interface information
                        	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable, self).__init__()

                            self.yang_name = "interface-process-table"
                            self.yang_parent_name = "vrf"

                            self.interface = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable, self).__setattr__(name, value)


                        class Interface(Entity):
                            """
                            OSPFv3 interface information
                            
                            .. attribute:: interface_name  <key>
                            
                            	Interface name
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: active_interface
                            
                            	Active interface details 
                            	**type**\:   :py:class:`ActiveInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.ActiveInterface>`
                            
                            .. attribute:: adjacent_neighbor
                            
                            	Number of adjacent neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: backup_designated_router_address
                            
                            	Backup designated router interface address
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: backup_designated_router_id
                            
                            	Backup designated router ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: configured_ldp_sync
                            
                            	If true, configured as LDP sync
                            	**type**\:  bool
                            
                            .. attribute:: dead_interval
                            
                            	Configured dead interval (s) 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: designated_router_address
                            
                            	Designated router interface address
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: designated_router_id
                            
                            	Designated router ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hello_interval
                            
                            	Configured hello interval (s)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_address
                            
                            	Interface IPv6 address
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: interface_authentication_spi
                            
                            	Interface authentication spi 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_authentication_transmit
                            
                            	Interface authentication transmit 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_bfd
                            
                            	BFD information 
                            	**type**\:   :py:class:`InterfaceBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceBfd>`
                            
                            .. attribute:: interface_dc_bitless_ls_as
                            
                            	Number of LSAs with demand circuit bit not set for the area in which the interface is running
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_encrypted_authentication_transmitted
                            
                            	Interface encrypted authentication transmitted 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_encryption_spi
                            
                            	Interface encryption spi
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_encryption_transmitted
                            
                            	Interface encryption transmitted 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_ldp_sync
                            
                            	If true, interface LDP sync is achieved
                            	**type**\:  bool
                            
                            .. attribute:: interface_link_cost
                            
                            	Interface link cost
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: interface_neighbor
                            
                            	Information for neighbors on the interface
                            	**type**\: list of    :py:class:`InterfaceNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceNeighbor>`
                            
                            .. attribute:: interface_number
                            
                            	Interface number 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_priority
                            
                            	Interface priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: interface_references
                            
                            	Interface reference count 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_retransmission_interval
                            
                            	Configured retransmit interval (s) 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_router_id
                            
                            	Interface router ID 
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: interface_state
                            
                            	Interface state
                            	**type**\:   :py:class:`ImStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.ImStateEnum>`
                            
                            .. attribute:: is_demand_circuit_configured
                            
                            	If true, configured as demand circuit 
                            	**type**\:  bool
                            
                            .. attribute:: is_designated_router
                            
                            	If true, designated router
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_demand_circuit
                            
                            	If true, interface running as demand circuit
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_encryption_enabled
                            
                            	If true, interface encryption is enabled 
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_flood_reduction
                            
                            	If true, interface flood reduction is active 
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_ip_security_active
                            
                            	If true, interface IP security is active 
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_ip_security_required
                            
                            	If true, interface IP security is required 
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_line_up
                            
                            	If true, line protocol is up 
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_lsa_filtered
                            
                            	Filter is configured for out going LSAs 
                            	**type**\:  bool
                            
                            .. attribute:: is_prefix_suppress
                            
                            	If true prefix suppression is enabled
                            	**type**\:  bool
                            
                            .. attribute:: network_lsa_flush_timer
                            
                            	The amount of time in seconds before flush timer for old network LSA expires 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: network_type
                            
                            	Network type
                            	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                            
                            .. attribute:: next_hello_time
                            
                            	Time until next Hello (s) 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ospf_interface_state
                            
                            	Interface state
                            	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                            
                            .. attribute:: transmission_delay
                            
                            	Interface transmission delay (sec)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: wait_interval
                            
                            	Configured wait interval (s) 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface, self).__init__()

                                self.yang_name = "interface"
                                self.yang_parent_name = "interface-process-table"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.adjacent_neighbor = YLeaf(YType.uint32, "adjacent-neighbor")

                                self.backup_designated_router_address = YLeaf(YType.str, "backup-designated-router-address")

                                self.backup_designated_router_id = YLeaf(YType.str, "backup-designated-router-id")

                                self.configured_ldp_sync = YLeaf(YType.boolean, "configured-ldp-sync")

                                self.dead_interval = YLeaf(YType.uint32, "dead-interval")

                                self.designated_router_address = YLeaf(YType.str, "designated-router-address")

                                self.designated_router_id = YLeaf(YType.str, "designated-router-id")

                                self.hello_interval = YLeaf(YType.uint32, "hello-interval")

                                self.interface_address = YLeaf(YType.str, "interface-address")

                                self.interface_authentication_spi = YLeaf(YType.uint32, "interface-authentication-spi")

                                self.interface_authentication_transmit = YLeaf(YType.uint32, "interface-authentication-transmit")

                                self.interface_dc_bitless_ls_as = YLeaf(YType.uint32, "interface-dc-bitless-ls-as")

                                self.interface_encrypted_authentication_transmitted = YLeaf(YType.uint32, "interface-encrypted-authentication-transmitted")

                                self.interface_encryption_spi = YLeaf(YType.uint32, "interface-encryption-spi")

                                self.interface_encryption_transmitted = YLeaf(YType.uint32, "interface-encryption-transmitted")

                                self.interface_ldp_sync = YLeaf(YType.boolean, "interface-ldp-sync")

                                self.interface_link_cost = YLeaf(YType.uint16, "interface-link-cost")

                                self.interface_number = YLeaf(YType.uint32, "interface-number")

                                self.interface_priority = YLeaf(YType.uint8, "interface-priority")

                                self.interface_references = YLeaf(YType.uint32, "interface-references")

                                self.interface_retransmission_interval = YLeaf(YType.uint32, "interface-retransmission-interval")

                                self.interface_router_id = YLeaf(YType.str, "interface-router-id")

                                self.interface_state = YLeaf(YType.enumeration, "interface-state")

                                self.is_demand_circuit_configured = YLeaf(YType.boolean, "is-demand-circuit-configured")

                                self.is_designated_router = YLeaf(YType.boolean, "is-designated-router")

                                self.is_interface_demand_circuit = YLeaf(YType.boolean, "is-interface-demand-circuit")

                                self.is_interface_encryption_enabled = YLeaf(YType.boolean, "is-interface-encryption-enabled")

                                self.is_interface_flood_reduction = YLeaf(YType.boolean, "is-interface-flood-reduction")

                                self.is_interface_ip_security_active = YLeaf(YType.boolean, "is-interface-ip-security-active")

                                self.is_interface_ip_security_required = YLeaf(YType.boolean, "is-interface-ip-security-required")

                                self.is_interface_line_up = YLeaf(YType.boolean, "is-interface-line-up")

                                self.is_interface_lsa_filtered = YLeaf(YType.boolean, "is-interface-lsa-filtered")

                                self.is_prefix_suppress = YLeaf(YType.boolean, "is-prefix-suppress")

                                self.network_lsa_flush_timer = YLeaf(YType.uint32, "network-lsa-flush-timer")

                                self.network_type = YLeaf(YType.enumeration, "network-type")

                                self.next_hello_time = YLeaf(YType.uint32, "next-hello-time")

                                self.ospf_interface_state = YLeaf(YType.enumeration, "ospf-interface-state")

                                self.transmission_delay = YLeaf(YType.uint16, "transmission-delay")

                                self.wait_interval = YLeaf(YType.uint32, "wait-interval")

                                self.active_interface = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.ActiveInterface()
                                self.active_interface.parent = self
                                self._children_name_map["active_interface"] = "active-interface"
                                self._children_yang_names.add("active-interface")

                                self.interface_bfd = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceBfd()
                                self.interface_bfd.parent = self
                                self._children_name_map["interface_bfd"] = "interface-bfd"
                                self._children_yang_names.add("interface-bfd")

                                self.interface_neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "adjacent_neighbor",
                                                "backup_designated_router_address",
                                                "backup_designated_router_id",
                                                "configured_ldp_sync",
                                                "dead_interval",
                                                "designated_router_address",
                                                "designated_router_id",
                                                "hello_interval",
                                                "interface_address",
                                                "interface_authentication_spi",
                                                "interface_authentication_transmit",
                                                "interface_dc_bitless_ls_as",
                                                "interface_encrypted_authentication_transmitted",
                                                "interface_encryption_spi",
                                                "interface_encryption_transmitted",
                                                "interface_ldp_sync",
                                                "interface_link_cost",
                                                "interface_number",
                                                "interface_priority",
                                                "interface_references",
                                                "interface_retransmission_interval",
                                                "interface_router_id",
                                                "interface_state",
                                                "is_demand_circuit_configured",
                                                "is_designated_router",
                                                "is_interface_demand_circuit",
                                                "is_interface_encryption_enabled",
                                                "is_interface_flood_reduction",
                                                "is_interface_ip_security_active",
                                                "is_interface_ip_security_required",
                                                "is_interface_line_up",
                                                "is_interface_lsa_filtered",
                                                "is_prefix_suppress",
                                                "network_lsa_flush_timer",
                                                "network_type",
                                                "next_hello_time",
                                                "ospf_interface_state",
                                                "transmission_delay",
                                                "wait_interval") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface, self).__setattr__(name, value)


                            class ActiveInterface(Entity):
                                """
                                Active interface details 
                                
                                .. attribute:: flood_queue_length
                                
                                	Flood queue length
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: flood_scan_length
                                
                                	Last flood scan length 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_area_flood_index
                                
                                	Area scope LSAs flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_area_next_flood
                                
                                	Next LSA to flood (Area scope)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_area_next_flood_index
                                
                                	Index of next LSA to flood (Area scope) 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_as_flood_index
                                
                                	AS scope LSAs flood index 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_as_next_flood
                                
                                	Next LSA to flood (AS scope)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_as_next_flood_index
                                
                                	Index of next LSA to flood (AS scope)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_flood_pacing_timer
                                
                                	Time until next flood pacing timer (ms) 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_link_flood_index
                                
                                	Interface flood link index 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_link_next_flood
                                
                                	Interface link next flood information 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_link_next_index
                                
                                	Interface link next information index 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_neighbors
                                
                                	Total number of neighbors 
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: last_flood_time
                                
                                	Last flood scan time (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: maximum_flood_length
                                
                                	Maximum flood length 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: maximum_flood_time
                                
                                	Maximum flood time (ms) 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: suppressed_hellos
                                
                                	Number of neighbors for which hellos are suppressed 
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: wait_time
                                
                                	Wait time for DR/BDR selection (s)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.ActiveInterface, self).__init__()

                                    self.yang_name = "active-interface"
                                    self.yang_parent_name = "interface"

                                    self.flood_queue_length = YLeaf(YType.uint32, "flood-queue-length")

                                    self.flood_scan_length = YLeaf(YType.uint32, "flood-scan-length")

                                    self.interface_area_flood_index = YLeaf(YType.uint32, "interface-area-flood-index")

                                    self.interface_area_next_flood = YLeaf(YType.uint32, "interface-area-next-flood")

                                    self.interface_area_next_flood_index = YLeaf(YType.uint32, "interface-area-next-flood-index")

                                    self.interface_as_flood_index = YLeaf(YType.uint32, "interface-as-flood-index")

                                    self.interface_as_next_flood = YLeaf(YType.uint32, "interface-as-next-flood")

                                    self.interface_as_next_flood_index = YLeaf(YType.uint32, "interface-as-next-flood-index")

                                    self.interface_flood_pacing_timer = YLeaf(YType.uint32, "interface-flood-pacing-timer")

                                    self.interface_link_flood_index = YLeaf(YType.uint32, "interface-link-flood-index")

                                    self.interface_link_next_flood = YLeaf(YType.uint32, "interface-link-next-flood")

                                    self.interface_link_next_index = YLeaf(YType.uint32, "interface-link-next-index")

                                    self.interface_neighbors = YLeaf(YType.uint16, "interface-neighbors")

                                    self.last_flood_time = YLeaf(YType.uint32, "last-flood-time")

                                    self.maximum_flood_length = YLeaf(YType.uint32, "maximum-flood-length")

                                    self.maximum_flood_time = YLeaf(YType.uint32, "maximum-flood-time")

                                    self.suppressed_hellos = YLeaf(YType.uint16, "suppressed-hellos")

                                    self.wait_time = YLeaf(YType.uint32, "wait-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("flood_queue_length",
                                                    "flood_scan_length",
                                                    "interface_area_flood_index",
                                                    "interface_area_next_flood",
                                                    "interface_area_next_flood_index",
                                                    "interface_as_flood_index",
                                                    "interface_as_next_flood",
                                                    "interface_as_next_flood_index",
                                                    "interface_flood_pacing_timer",
                                                    "interface_link_flood_index",
                                                    "interface_link_next_flood",
                                                    "interface_link_next_index",
                                                    "interface_neighbors",
                                                    "last_flood_time",
                                                    "maximum_flood_length",
                                                    "maximum_flood_time",
                                                    "suppressed_hellos",
                                                    "wait_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.ActiveInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.ActiveInterface, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.flood_queue_length.is_set or
                                        self.flood_scan_length.is_set or
                                        self.interface_area_flood_index.is_set or
                                        self.interface_area_next_flood.is_set or
                                        self.interface_area_next_flood_index.is_set or
                                        self.interface_as_flood_index.is_set or
                                        self.interface_as_next_flood.is_set or
                                        self.interface_as_next_flood_index.is_set or
                                        self.interface_flood_pacing_timer.is_set or
                                        self.interface_link_flood_index.is_set or
                                        self.interface_link_next_flood.is_set or
                                        self.interface_link_next_index.is_set or
                                        self.interface_neighbors.is_set or
                                        self.last_flood_time.is_set or
                                        self.maximum_flood_length.is_set or
                                        self.maximum_flood_time.is_set or
                                        self.suppressed_hellos.is_set or
                                        self.wait_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.flood_queue_length.yfilter != YFilter.not_set or
                                        self.flood_scan_length.yfilter != YFilter.not_set or
                                        self.interface_area_flood_index.yfilter != YFilter.not_set or
                                        self.interface_area_next_flood.yfilter != YFilter.not_set or
                                        self.interface_area_next_flood_index.yfilter != YFilter.not_set or
                                        self.interface_as_flood_index.yfilter != YFilter.not_set or
                                        self.interface_as_next_flood.yfilter != YFilter.not_set or
                                        self.interface_as_next_flood_index.yfilter != YFilter.not_set or
                                        self.interface_flood_pacing_timer.yfilter != YFilter.not_set or
                                        self.interface_link_flood_index.yfilter != YFilter.not_set or
                                        self.interface_link_next_flood.yfilter != YFilter.not_set or
                                        self.interface_link_next_index.yfilter != YFilter.not_set or
                                        self.interface_neighbors.yfilter != YFilter.not_set or
                                        self.last_flood_time.yfilter != YFilter.not_set or
                                        self.maximum_flood_length.yfilter != YFilter.not_set or
                                        self.maximum_flood_time.yfilter != YFilter.not_set or
                                        self.suppressed_hellos.yfilter != YFilter.not_set or
                                        self.wait_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "active-interface" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.flood_queue_length.is_set or self.flood_queue_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.flood_queue_length.get_name_leafdata())
                                    if (self.flood_scan_length.is_set or self.flood_scan_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.flood_scan_length.get_name_leafdata())
                                    if (self.interface_area_flood_index.is_set or self.interface_area_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_area_flood_index.get_name_leafdata())
                                    if (self.interface_area_next_flood.is_set or self.interface_area_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_area_next_flood.get_name_leafdata())
                                    if (self.interface_area_next_flood_index.is_set or self.interface_area_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_area_next_flood_index.get_name_leafdata())
                                    if (self.interface_as_flood_index.is_set or self.interface_as_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_as_flood_index.get_name_leafdata())
                                    if (self.interface_as_next_flood.is_set or self.interface_as_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_as_next_flood.get_name_leafdata())
                                    if (self.interface_as_next_flood_index.is_set or self.interface_as_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_as_next_flood_index.get_name_leafdata())
                                    if (self.interface_flood_pacing_timer.is_set or self.interface_flood_pacing_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_flood_pacing_timer.get_name_leafdata())
                                    if (self.interface_link_flood_index.is_set or self.interface_link_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_link_flood_index.get_name_leafdata())
                                    if (self.interface_link_next_flood.is_set or self.interface_link_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_link_next_flood.get_name_leafdata())
                                    if (self.interface_link_next_index.is_set or self.interface_link_next_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_link_next_index.get_name_leafdata())
                                    if (self.interface_neighbors.is_set or self.interface_neighbors.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_neighbors.get_name_leafdata())
                                    if (self.last_flood_time.is_set or self.last_flood_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_flood_time.get_name_leafdata())
                                    if (self.maximum_flood_length.is_set or self.maximum_flood_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_flood_length.get_name_leafdata())
                                    if (self.maximum_flood_time.is_set or self.maximum_flood_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_flood_time.get_name_leafdata())
                                    if (self.suppressed_hellos.is_set or self.suppressed_hellos.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.suppressed_hellos.get_name_leafdata())
                                    if (self.wait_time.is_set or self.wait_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.wait_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flood-queue-length" or name == "flood-scan-length" or name == "interface-area-flood-index" or name == "interface-area-next-flood" or name == "interface-area-next-flood-index" or name == "interface-as-flood-index" or name == "interface-as-next-flood" or name == "interface-as-next-flood-index" or name == "interface-flood-pacing-timer" or name == "interface-link-flood-index" or name == "interface-link-next-flood" or name == "interface-link-next-index" or name == "interface-neighbors" or name == "last-flood-time" or name == "maximum-flood-length" or name == "maximum-flood-time" or name == "suppressed-hellos" or name == "wait-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "flood-queue-length"):
                                        self.flood_queue_length = value
                                        self.flood_queue_length.value_namespace = name_space
                                        self.flood_queue_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "flood-scan-length"):
                                        self.flood_scan_length = value
                                        self.flood_scan_length.value_namespace = name_space
                                        self.flood_scan_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-area-flood-index"):
                                        self.interface_area_flood_index = value
                                        self.interface_area_flood_index.value_namespace = name_space
                                        self.interface_area_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-area-next-flood"):
                                        self.interface_area_next_flood = value
                                        self.interface_area_next_flood.value_namespace = name_space
                                        self.interface_area_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-area-next-flood-index"):
                                        self.interface_area_next_flood_index = value
                                        self.interface_area_next_flood_index.value_namespace = name_space
                                        self.interface_area_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-as-flood-index"):
                                        self.interface_as_flood_index = value
                                        self.interface_as_flood_index.value_namespace = name_space
                                        self.interface_as_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-as-next-flood"):
                                        self.interface_as_next_flood = value
                                        self.interface_as_next_flood.value_namespace = name_space
                                        self.interface_as_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-as-next-flood-index"):
                                        self.interface_as_next_flood_index = value
                                        self.interface_as_next_flood_index.value_namespace = name_space
                                        self.interface_as_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-flood-pacing-timer"):
                                        self.interface_flood_pacing_timer = value
                                        self.interface_flood_pacing_timer.value_namespace = name_space
                                        self.interface_flood_pacing_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-link-flood-index"):
                                        self.interface_link_flood_index = value
                                        self.interface_link_flood_index.value_namespace = name_space
                                        self.interface_link_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-link-next-flood"):
                                        self.interface_link_next_flood = value
                                        self.interface_link_next_flood.value_namespace = name_space
                                        self.interface_link_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-link-next-index"):
                                        self.interface_link_next_index = value
                                        self.interface_link_next_index.value_namespace = name_space
                                        self.interface_link_next_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-neighbors"):
                                        self.interface_neighbors = value
                                        self.interface_neighbors.value_namespace = name_space
                                        self.interface_neighbors.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-flood-time"):
                                        self.last_flood_time = value
                                        self.last_flood_time.value_namespace = name_space
                                        self.last_flood_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "maximum-flood-length"):
                                        self.maximum_flood_length = value
                                        self.maximum_flood_length.value_namespace = name_space
                                        self.maximum_flood_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "maximum-flood-time"):
                                        self.maximum_flood_time = value
                                        self.maximum_flood_time.value_namespace = name_space
                                        self.maximum_flood_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "suppressed-hellos"):
                                        self.suppressed_hellos = value
                                        self.suppressed_hellos.value_namespace = name_space
                                        self.suppressed_hellos.value_namespace_prefix = name_space_prefix
                                    if(value_path == "wait-time"):
                                        self.wait_time = value
                                        self.wait_time.value_namespace = name_space
                                        self.wait_time.value_namespace_prefix = name_space_prefix


                            class InterfaceBfd(Entity):
                                """
                                BFD information 
                                
                                .. attribute:: bfd_detection_multiplier
                                
                                	BFD detection multiplier 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: bfd_interval
                                
                                	BFD interval (ms) 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: bfd_intf_enable_mode
                                
                                	BFD Enable Mode on the interface \- Default/Strict
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceBfd, self).__init__()

                                    self.yang_name = "interface-bfd"
                                    self.yang_parent_name = "interface"

                                    self.bfd_detection_multiplier = YLeaf(YType.uint32, "bfd-detection-multiplier")

                                    self.bfd_interval = YLeaf(YType.uint32, "bfd-interval")

                                    self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bfd_detection_multiplier",
                                                    "bfd_interval",
                                                    "bfd_intf_enable_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceBfd, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceBfd, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bfd_detection_multiplier.is_set or
                                        self.bfd_interval.is_set or
                                        self.bfd_intf_enable_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bfd_detection_multiplier.yfilter != YFilter.not_set or
                                        self.bfd_interval.yfilter != YFilter.not_set or
                                        self.bfd_intf_enable_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface-bfd" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bfd_detection_multiplier.is_set or self.bfd_detection_multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bfd_detection_multiplier.get_name_leafdata())
                                    if (self.bfd_interval.is_set or self.bfd_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bfd_interval.get_name_leafdata())
                                    if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bfd-detection-multiplier" or name == "bfd-interval" or name == "bfd-intf-enable-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bfd-detection-multiplier"):
                                        self.bfd_detection_multiplier = value
                                        self.bfd_detection_multiplier.value_namespace = name_space
                                        self.bfd_detection_multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "bfd-interval"):
                                        self.bfd_interval = value
                                        self.bfd_interval.value_namespace = name_space
                                        self.bfd_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "bfd-intf-enable-mode"):
                                        self.bfd_intf_enable_mode = value
                                        self.bfd_intf_enable_mode.value_namespace = name_space
                                        self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix


                            class InterfaceNeighbor(Entity):
                                """
                                Information for neighbors on the interface
                                
                                .. attribute:: interface_neighbor_cost
                                
                                	Cost of link to neighbor
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_neighbor_id
                                
                                	Neighbor router ID 
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_hello_suppressed
                                
                                	If true, hello is suppressed 
                                	**type**\:  bool
                                
                                .. attribute:: is_neighbor_bdr
                                
                                	If true, backup designated router is found 
                                	**type**\:  bool
                                
                                .. attribute:: is_neighbor_dr
                                
                                	If true, designated router is found 
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceNeighbor, self).__init__()

                                    self.yang_name = "interface-neighbor"
                                    self.yang_parent_name = "interface"

                                    self.interface_neighbor_cost = YLeaf(YType.uint32, "interface-neighbor-cost")

                                    self.interface_neighbor_id = YLeaf(YType.str, "interface-neighbor-id")

                                    self.is_hello_suppressed = YLeaf(YType.boolean, "is-hello-suppressed")

                                    self.is_neighbor_bdr = YLeaf(YType.boolean, "is-neighbor-bdr")

                                    self.is_neighbor_dr = YLeaf(YType.boolean, "is-neighbor-dr")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_neighbor_cost",
                                                    "interface_neighbor_id",
                                                    "is_hello_suppressed",
                                                    "is_neighbor_bdr",
                                                    "is_neighbor_dr") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceNeighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceNeighbor, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.interface_neighbor_cost.is_set or
                                        self.interface_neighbor_id.is_set or
                                        self.is_hello_suppressed.is_set or
                                        self.is_neighbor_bdr.is_set or
                                        self.is_neighbor_dr.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_neighbor_cost.yfilter != YFilter.not_set or
                                        self.interface_neighbor_id.yfilter != YFilter.not_set or
                                        self.is_hello_suppressed.yfilter != YFilter.not_set or
                                        self.is_neighbor_bdr.yfilter != YFilter.not_set or
                                        self.is_neighbor_dr.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface-neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_neighbor_cost.is_set or self.interface_neighbor_cost.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_neighbor_cost.get_name_leafdata())
                                    if (self.interface_neighbor_id.is_set or self.interface_neighbor_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_neighbor_id.get_name_leafdata())
                                    if (self.is_hello_suppressed.is_set or self.is_hello_suppressed.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_hello_suppressed.get_name_leafdata())
                                    if (self.is_neighbor_bdr.is_set or self.is_neighbor_bdr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_neighbor_bdr.get_name_leafdata())
                                    if (self.is_neighbor_dr.is_set or self.is_neighbor_dr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_neighbor_dr.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-neighbor-cost" or name == "interface-neighbor-id" or name == "is-hello-suppressed" or name == "is-neighbor-bdr" or name == "is-neighbor-dr"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-neighbor-cost"):
                                        self.interface_neighbor_cost = value
                                        self.interface_neighbor_cost.value_namespace = name_space
                                        self.interface_neighbor_cost.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-neighbor-id"):
                                        self.interface_neighbor_id = value
                                        self.interface_neighbor_id.value_namespace = name_space
                                        self.interface_neighbor_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-hello-suppressed"):
                                        self.is_hello_suppressed = value
                                        self.is_hello_suppressed.value_namespace = name_space
                                        self.is_hello_suppressed.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-neighbor-bdr"):
                                        self.is_neighbor_bdr = value
                                        self.is_neighbor_bdr.value_namespace = name_space
                                        self.is_neighbor_bdr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-neighbor-dr"):
                                        self.is_neighbor_dr = value
                                        self.is_neighbor_dr.value_namespace = name_space
                                        self.is_neighbor_dr.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.interface_neighbor:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.interface_name.is_set or
                                    self.adjacent_neighbor.is_set or
                                    self.backup_designated_router_address.is_set or
                                    self.backup_designated_router_id.is_set or
                                    self.configured_ldp_sync.is_set or
                                    self.dead_interval.is_set or
                                    self.designated_router_address.is_set or
                                    self.designated_router_id.is_set or
                                    self.hello_interval.is_set or
                                    self.interface_address.is_set or
                                    self.interface_authentication_spi.is_set or
                                    self.interface_authentication_transmit.is_set or
                                    self.interface_dc_bitless_ls_as.is_set or
                                    self.interface_encrypted_authentication_transmitted.is_set or
                                    self.interface_encryption_spi.is_set or
                                    self.interface_encryption_transmitted.is_set or
                                    self.interface_ldp_sync.is_set or
                                    self.interface_link_cost.is_set or
                                    self.interface_number.is_set or
                                    self.interface_priority.is_set or
                                    self.interface_references.is_set or
                                    self.interface_retransmission_interval.is_set or
                                    self.interface_router_id.is_set or
                                    self.interface_state.is_set or
                                    self.is_demand_circuit_configured.is_set or
                                    self.is_designated_router.is_set or
                                    self.is_interface_demand_circuit.is_set or
                                    self.is_interface_encryption_enabled.is_set or
                                    self.is_interface_flood_reduction.is_set or
                                    self.is_interface_ip_security_active.is_set or
                                    self.is_interface_ip_security_required.is_set or
                                    self.is_interface_line_up.is_set or
                                    self.is_interface_lsa_filtered.is_set or
                                    self.is_prefix_suppress.is_set or
                                    self.network_lsa_flush_timer.is_set or
                                    self.network_type.is_set or
                                    self.next_hello_time.is_set or
                                    self.ospf_interface_state.is_set or
                                    self.transmission_delay.is_set or
                                    self.wait_interval.is_set or
                                    (self.active_interface is not None and self.active_interface.has_data()) or
                                    (self.interface_bfd is not None and self.interface_bfd.has_data()))

                            def has_operation(self):
                                for c in self.interface_neighbor:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.adjacent_neighbor.yfilter != YFilter.not_set or
                                    self.backup_designated_router_address.yfilter != YFilter.not_set or
                                    self.backup_designated_router_id.yfilter != YFilter.not_set or
                                    self.configured_ldp_sync.yfilter != YFilter.not_set or
                                    self.dead_interval.yfilter != YFilter.not_set or
                                    self.designated_router_address.yfilter != YFilter.not_set or
                                    self.designated_router_id.yfilter != YFilter.not_set or
                                    self.hello_interval.yfilter != YFilter.not_set or
                                    self.interface_address.yfilter != YFilter.not_set or
                                    self.interface_authentication_spi.yfilter != YFilter.not_set or
                                    self.interface_authentication_transmit.yfilter != YFilter.not_set or
                                    self.interface_dc_bitless_ls_as.yfilter != YFilter.not_set or
                                    self.interface_encrypted_authentication_transmitted.yfilter != YFilter.not_set or
                                    self.interface_encryption_spi.yfilter != YFilter.not_set or
                                    self.interface_encryption_transmitted.yfilter != YFilter.not_set or
                                    self.interface_ldp_sync.yfilter != YFilter.not_set or
                                    self.interface_link_cost.yfilter != YFilter.not_set or
                                    self.interface_number.yfilter != YFilter.not_set or
                                    self.interface_priority.yfilter != YFilter.not_set or
                                    self.interface_references.yfilter != YFilter.not_set or
                                    self.interface_retransmission_interval.yfilter != YFilter.not_set or
                                    self.interface_router_id.yfilter != YFilter.not_set or
                                    self.interface_state.yfilter != YFilter.not_set or
                                    self.is_demand_circuit_configured.yfilter != YFilter.not_set or
                                    self.is_designated_router.yfilter != YFilter.not_set or
                                    self.is_interface_demand_circuit.yfilter != YFilter.not_set or
                                    self.is_interface_encryption_enabled.yfilter != YFilter.not_set or
                                    self.is_interface_flood_reduction.yfilter != YFilter.not_set or
                                    self.is_interface_ip_security_active.yfilter != YFilter.not_set or
                                    self.is_interface_ip_security_required.yfilter != YFilter.not_set or
                                    self.is_interface_line_up.yfilter != YFilter.not_set or
                                    self.is_interface_lsa_filtered.yfilter != YFilter.not_set or
                                    self.is_prefix_suppress.yfilter != YFilter.not_set or
                                    self.network_lsa_flush_timer.yfilter != YFilter.not_set or
                                    self.network_type.yfilter != YFilter.not_set or
                                    self.next_hello_time.yfilter != YFilter.not_set or
                                    self.ospf_interface_state.yfilter != YFilter.not_set or
                                    self.transmission_delay.yfilter != YFilter.not_set or
                                    self.wait_interval.yfilter != YFilter.not_set or
                                    (self.active_interface is not None and self.active_interface.has_operation()) or
                                    (self.interface_bfd is not None and self.interface_bfd.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.adjacent_neighbor.is_set or self.adjacent_neighbor.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.adjacent_neighbor.get_name_leafdata())
                                if (self.backup_designated_router_address.is_set or self.backup_designated_router_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_designated_router_address.get_name_leafdata())
                                if (self.backup_designated_router_id.is_set or self.backup_designated_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_designated_router_id.get_name_leafdata())
                                if (self.configured_ldp_sync.is_set or self.configured_ldp_sync.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_ldp_sync.get_name_leafdata())
                                if (self.dead_interval.is_set or self.dead_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dead_interval.get_name_leafdata())
                                if (self.designated_router_address.is_set or self.designated_router_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.designated_router_address.get_name_leafdata())
                                if (self.designated_router_id.is_set or self.designated_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.designated_router_id.get_name_leafdata())
                                if (self.hello_interval.is_set or self.hello_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hello_interval.get_name_leafdata())
                                if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_address.get_name_leafdata())
                                if (self.interface_authentication_spi.is_set or self.interface_authentication_spi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_authentication_spi.get_name_leafdata())
                                if (self.interface_authentication_transmit.is_set or self.interface_authentication_transmit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_authentication_transmit.get_name_leafdata())
                                if (self.interface_dc_bitless_ls_as.is_set or self.interface_dc_bitless_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_dc_bitless_ls_as.get_name_leafdata())
                                if (self.interface_encrypted_authentication_transmitted.is_set or self.interface_encrypted_authentication_transmitted.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_encrypted_authentication_transmitted.get_name_leafdata())
                                if (self.interface_encryption_spi.is_set or self.interface_encryption_spi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_encryption_spi.get_name_leafdata())
                                if (self.interface_encryption_transmitted.is_set or self.interface_encryption_transmitted.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_encryption_transmitted.get_name_leafdata())
                                if (self.interface_ldp_sync.is_set or self.interface_ldp_sync.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_ldp_sync.get_name_leafdata())
                                if (self.interface_link_cost.is_set or self.interface_link_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_link_cost.get_name_leafdata())
                                if (self.interface_number.is_set or self.interface_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_number.get_name_leafdata())
                                if (self.interface_priority.is_set or self.interface_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_priority.get_name_leafdata())
                                if (self.interface_references.is_set or self.interface_references.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_references.get_name_leafdata())
                                if (self.interface_retransmission_interval.is_set or self.interface_retransmission_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_retransmission_interval.get_name_leafdata())
                                if (self.interface_router_id.is_set or self.interface_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_router_id.get_name_leafdata())
                                if (self.interface_state.is_set or self.interface_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_state.get_name_leafdata())
                                if (self.is_demand_circuit_configured.is_set or self.is_demand_circuit_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_demand_circuit_configured.get_name_leafdata())
                                if (self.is_designated_router.is_set or self.is_designated_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_designated_router.get_name_leafdata())
                                if (self.is_interface_demand_circuit.is_set or self.is_interface_demand_circuit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_demand_circuit.get_name_leafdata())
                                if (self.is_interface_encryption_enabled.is_set or self.is_interface_encryption_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_encryption_enabled.get_name_leafdata())
                                if (self.is_interface_flood_reduction.is_set or self.is_interface_flood_reduction.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_flood_reduction.get_name_leafdata())
                                if (self.is_interface_ip_security_active.is_set or self.is_interface_ip_security_active.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_ip_security_active.get_name_leafdata())
                                if (self.is_interface_ip_security_required.is_set or self.is_interface_ip_security_required.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_ip_security_required.get_name_leafdata())
                                if (self.is_interface_line_up.is_set or self.is_interface_line_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_line_up.get_name_leafdata())
                                if (self.is_interface_lsa_filtered.is_set or self.is_interface_lsa_filtered.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_lsa_filtered.get_name_leafdata())
                                if (self.is_prefix_suppress.is_set or self.is_prefix_suppress.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_prefix_suppress.get_name_leafdata())
                                if (self.network_lsa_flush_timer.is_set or self.network_lsa_flush_timer.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.network_lsa_flush_timer.get_name_leafdata())
                                if (self.network_type.is_set or self.network_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.network_type.get_name_leafdata())
                                if (self.next_hello_time.is_set or self.next_hello_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hello_time.get_name_leafdata())
                                if (self.ospf_interface_state.is_set or self.ospf_interface_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ospf_interface_state.get_name_leafdata())
                                if (self.transmission_delay.is_set or self.transmission_delay.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.transmission_delay.get_name_leafdata())
                                if (self.wait_interval.is_set or self.wait_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.wait_interval.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "active-interface"):
                                    if (self.active_interface is None):
                                        self.active_interface = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.ActiveInterface()
                                        self.active_interface.parent = self
                                        self._children_name_map["active_interface"] = "active-interface"
                                    return self.active_interface

                                if (child_yang_name == "interface-bfd"):
                                    if (self.interface_bfd is None):
                                        self.interface_bfd = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceBfd()
                                        self.interface_bfd.parent = self
                                        self._children_name_map["interface_bfd"] = "interface-bfd"
                                    return self.interface_bfd

                                if (child_yang_name == "interface-neighbor"):
                                    for c in self.interface_neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface.InterfaceNeighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.interface_neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "active-interface" or name == "interface-bfd" or name == "interface-neighbor" or name == "interface-name" or name == "adjacent-neighbor" or name == "backup-designated-router-address" or name == "backup-designated-router-id" or name == "configured-ldp-sync" or name == "dead-interval" or name == "designated-router-address" or name == "designated-router-id" or name == "hello-interval" or name == "interface-address" or name == "interface-authentication-spi" or name == "interface-authentication-transmit" or name == "interface-dc-bitless-ls-as" or name == "interface-encrypted-authentication-transmitted" or name == "interface-encryption-spi" or name == "interface-encryption-transmitted" or name == "interface-ldp-sync" or name == "interface-link-cost" or name == "interface-number" or name == "interface-priority" or name == "interface-references" or name == "interface-retransmission-interval" or name == "interface-router-id" or name == "interface-state" or name == "is-demand-circuit-configured" or name == "is-designated-router" or name == "is-interface-demand-circuit" or name == "is-interface-encryption-enabled" or name == "is-interface-flood-reduction" or name == "is-interface-ip-security-active" or name == "is-interface-ip-security-required" or name == "is-interface-line-up" or name == "is-interface-lsa-filtered" or name == "is-prefix-suppress" or name == "network-lsa-flush-timer" or name == "network-type" or name == "next-hello-time" or name == "ospf-interface-state" or name == "transmission-delay" or name == "wait-interval"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "adjacent-neighbor"):
                                    self.adjacent_neighbor = value
                                    self.adjacent_neighbor.value_namespace = name_space
                                    self.adjacent_neighbor.value_namespace_prefix = name_space_prefix
                                if(value_path == "backup-designated-router-address"):
                                    self.backup_designated_router_address = value
                                    self.backup_designated_router_address.value_namespace = name_space
                                    self.backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "backup-designated-router-id"):
                                    self.backup_designated_router_id = value
                                    self.backup_designated_router_id.value_namespace = name_space
                                    self.backup_designated_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "configured-ldp-sync"):
                                    self.configured_ldp_sync = value
                                    self.configured_ldp_sync.value_namespace = name_space
                                    self.configured_ldp_sync.value_namespace_prefix = name_space_prefix
                                if(value_path == "dead-interval"):
                                    self.dead_interval = value
                                    self.dead_interval.value_namespace = name_space
                                    self.dead_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "designated-router-address"):
                                    self.designated_router_address = value
                                    self.designated_router_address.value_namespace = name_space
                                    self.designated_router_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "designated-router-id"):
                                    self.designated_router_id = value
                                    self.designated_router_id.value_namespace = name_space
                                    self.designated_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "hello-interval"):
                                    self.hello_interval = value
                                    self.hello_interval.value_namespace = name_space
                                    self.hello_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-address"):
                                    self.interface_address = value
                                    self.interface_address.value_namespace = name_space
                                    self.interface_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-authentication-spi"):
                                    self.interface_authentication_spi = value
                                    self.interface_authentication_spi.value_namespace = name_space
                                    self.interface_authentication_spi.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-authentication-transmit"):
                                    self.interface_authentication_transmit = value
                                    self.interface_authentication_transmit.value_namespace = name_space
                                    self.interface_authentication_transmit.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-dc-bitless-ls-as"):
                                    self.interface_dc_bitless_ls_as = value
                                    self.interface_dc_bitless_ls_as.value_namespace = name_space
                                    self.interface_dc_bitless_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-encrypted-authentication-transmitted"):
                                    self.interface_encrypted_authentication_transmitted = value
                                    self.interface_encrypted_authentication_transmitted.value_namespace = name_space
                                    self.interface_encrypted_authentication_transmitted.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-encryption-spi"):
                                    self.interface_encryption_spi = value
                                    self.interface_encryption_spi.value_namespace = name_space
                                    self.interface_encryption_spi.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-encryption-transmitted"):
                                    self.interface_encryption_transmitted = value
                                    self.interface_encryption_transmitted.value_namespace = name_space
                                    self.interface_encryption_transmitted.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-ldp-sync"):
                                    self.interface_ldp_sync = value
                                    self.interface_ldp_sync.value_namespace = name_space
                                    self.interface_ldp_sync.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-link-cost"):
                                    self.interface_link_cost = value
                                    self.interface_link_cost.value_namespace = name_space
                                    self.interface_link_cost.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-number"):
                                    self.interface_number = value
                                    self.interface_number.value_namespace = name_space
                                    self.interface_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-priority"):
                                    self.interface_priority = value
                                    self.interface_priority.value_namespace = name_space
                                    self.interface_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-references"):
                                    self.interface_references = value
                                    self.interface_references.value_namespace = name_space
                                    self.interface_references.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-retransmission-interval"):
                                    self.interface_retransmission_interval = value
                                    self.interface_retransmission_interval.value_namespace = name_space
                                    self.interface_retransmission_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-router-id"):
                                    self.interface_router_id = value
                                    self.interface_router_id.value_namespace = name_space
                                    self.interface_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-state"):
                                    self.interface_state = value
                                    self.interface_state.value_namespace = name_space
                                    self.interface_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-demand-circuit-configured"):
                                    self.is_demand_circuit_configured = value
                                    self.is_demand_circuit_configured.value_namespace = name_space
                                    self.is_demand_circuit_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-designated-router"):
                                    self.is_designated_router = value
                                    self.is_designated_router.value_namespace = name_space
                                    self.is_designated_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-demand-circuit"):
                                    self.is_interface_demand_circuit = value
                                    self.is_interface_demand_circuit.value_namespace = name_space
                                    self.is_interface_demand_circuit.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-encryption-enabled"):
                                    self.is_interface_encryption_enabled = value
                                    self.is_interface_encryption_enabled.value_namespace = name_space
                                    self.is_interface_encryption_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-flood-reduction"):
                                    self.is_interface_flood_reduction = value
                                    self.is_interface_flood_reduction.value_namespace = name_space
                                    self.is_interface_flood_reduction.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-ip-security-active"):
                                    self.is_interface_ip_security_active = value
                                    self.is_interface_ip_security_active.value_namespace = name_space
                                    self.is_interface_ip_security_active.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-ip-security-required"):
                                    self.is_interface_ip_security_required = value
                                    self.is_interface_ip_security_required.value_namespace = name_space
                                    self.is_interface_ip_security_required.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-line-up"):
                                    self.is_interface_line_up = value
                                    self.is_interface_line_up.value_namespace = name_space
                                    self.is_interface_line_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-lsa-filtered"):
                                    self.is_interface_lsa_filtered = value
                                    self.is_interface_lsa_filtered.value_namespace = name_space
                                    self.is_interface_lsa_filtered.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-prefix-suppress"):
                                    self.is_prefix_suppress = value
                                    self.is_prefix_suppress.value_namespace = name_space
                                    self.is_prefix_suppress.value_namespace_prefix = name_space_prefix
                                if(value_path == "network-lsa-flush-timer"):
                                    self.network_lsa_flush_timer = value
                                    self.network_lsa_flush_timer.value_namespace = name_space
                                    self.network_lsa_flush_timer.value_namespace_prefix = name_space_prefix
                                if(value_path == "network-type"):
                                    self.network_type = value
                                    self.network_type.value_namespace = name_space
                                    self.network_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "next-hello-time"):
                                    self.next_hello_time = value
                                    self.next_hello_time.value_namespace = name_space
                                    self.next_hello_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "ospf-interface-state"):
                                    self.ospf_interface_state = value
                                    self.ospf_interface_state.value_namespace = name_space
                                    self.ospf_interface_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "transmission-delay"):
                                    self.transmission_delay = value
                                    self.transmission_delay.value_namespace = name_space
                                    self.transmission_delay.value_namespace_prefix = name_space_prefix
                                if(value_path == "wait-interval"):
                                    self.wait_interval = value
                                    self.wait_interval.value_namespace = name_space
                                    self.wait_interval.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.interface:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.interface:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface-process-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "interface"):
                                for c in self.interface:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable.Interface()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.interface.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "interface"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Redistributions(Entity):
                        """
                        Redistribution information table
                        
                        .. attribute:: redistribution
                        
                        	Redistribution information
                        	**type**\: list of    :py:class:`Redistribution <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions.Redistribution>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions, self).__init__()

                            self.yang_name = "redistributions"
                            self.yang_parent_name = "vrf"

                            self.redistribution = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions, self).__setattr__(name, value)


                        class Redistribution(Entity):
                            """
                            Redistribution information
                            
                            .. attribute:: policy_name
                            
                            	Route policy name 
                            	**type**\:  str
                            
                            .. attribute:: process_id
                            
                            	Process ID 
                            	**type**\:  str
                            
                            	**length:** 0..40
                            
                            .. attribute:: process_name
                            
                            	Process name of a protocolbeing redistributed 
                            	**type**\:  str
                            
                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                            
                            .. attribute:: protocol_name
                            
                            	Protocol name that is redistributed
                            	**type**\:  str
                            
                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                            
                            .. attribute:: protocol_name_xr
                            
                            	Protocol name 
                            	**type**\:  str
                            
                            	**length:** 0..40
                            
                            .. attribute:: red_metric
                            
                            	red metric
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: red_metric_flag
                            
                            	red metric flag
                            	**type**\:  bool
                            
                            .. attribute:: red_metric_type
                            
                            	red metric type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: red_mtype_flag
                            
                            	red mtype flag
                            	**type**\:  bool
                            
                            .. attribute:: red_tag
                            
                            	red tag
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions.Redistribution, self).__init__()

                                self.yang_name = "redistribution"
                                self.yang_parent_name = "redistributions"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.process_id = YLeaf(YType.str, "process-id")

                                self.process_name = YLeaf(YType.str, "process-name")

                                self.protocol_name = YLeaf(YType.str, "protocol-name")

                                self.protocol_name_xr = YLeaf(YType.str, "protocol-name-xr")

                                self.red_metric = YLeaf(YType.uint32, "red-metric")

                                self.red_metric_flag = YLeaf(YType.boolean, "red-metric-flag")

                                self.red_metric_type = YLeaf(YType.uint8, "red-metric-type")

                                self.red_mtype_flag = YLeaf(YType.boolean, "red-mtype-flag")

                                self.red_tag = YLeaf(YType.uint32, "red-tag")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "process_id",
                                                "process_name",
                                                "protocol_name",
                                                "protocol_name_xr",
                                                "red_metric",
                                                "red_metric_flag",
                                                "red_metric_type",
                                                "red_mtype_flag",
                                                "red_tag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions.Redistribution, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions.Redistribution, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.policy_name.is_set or
                                    self.process_id.is_set or
                                    self.process_name.is_set or
                                    self.protocol_name.is_set or
                                    self.protocol_name_xr.is_set or
                                    self.red_metric.is_set or
                                    self.red_metric_flag.is_set or
                                    self.red_metric_type.is_set or
                                    self.red_mtype_flag.is_set or
                                    self.red_tag.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.process_id.yfilter != YFilter.not_set or
                                    self.process_name.yfilter != YFilter.not_set or
                                    self.protocol_name.yfilter != YFilter.not_set or
                                    self.protocol_name_xr.yfilter != YFilter.not_set or
                                    self.red_metric.yfilter != YFilter.not_set or
                                    self.red_metric_flag.yfilter != YFilter.not_set or
                                    self.red_metric_type.yfilter != YFilter.not_set or
                                    self.red_mtype_flag.yfilter != YFilter.not_set or
                                    self.red_tag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "redistribution" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.process_id.is_set or self.process_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.process_id.get_name_leafdata())
                                if (self.process_name.is_set or self.process_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.process_name.get_name_leafdata())
                                if (self.protocol_name.is_set or self.protocol_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protocol_name.get_name_leafdata())
                                if (self.protocol_name_xr.is_set or self.protocol_name_xr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protocol_name_xr.get_name_leafdata())
                                if (self.red_metric.is_set or self.red_metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_metric.get_name_leafdata())
                                if (self.red_metric_flag.is_set or self.red_metric_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_metric_flag.get_name_leafdata())
                                if (self.red_metric_type.is_set or self.red_metric_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_metric_type.get_name_leafdata())
                                if (self.red_mtype_flag.is_set or self.red_mtype_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_mtype_flag.get_name_leafdata())
                                if (self.red_tag.is_set or self.red_tag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_tag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "policy-name" or name == "process-id" or name == "process-name" or name == "protocol-name" or name == "protocol-name-xr" or name == "red-metric" or name == "red-metric-flag" or name == "red-metric-type" or name == "red-mtype-flag" or name == "red-tag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "process-id"):
                                    self.process_id = value
                                    self.process_id.value_namespace = name_space
                                    self.process_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "process-name"):
                                    self.process_name = value
                                    self.process_name.value_namespace = name_space
                                    self.process_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "protocol-name"):
                                    self.protocol_name = value
                                    self.protocol_name.value_namespace = name_space
                                    self.protocol_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "protocol-name-xr"):
                                    self.protocol_name_xr = value
                                    self.protocol_name_xr.value_namespace = name_space
                                    self.protocol_name_xr.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-metric"):
                                    self.red_metric = value
                                    self.red_metric.value_namespace = name_space
                                    self.red_metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-metric-flag"):
                                    self.red_metric_flag = value
                                    self.red_metric_flag.value_namespace = name_space
                                    self.red_metric_flag.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-metric-type"):
                                    self.red_metric_type = value
                                    self.red_metric_type.value_namespace = name_space
                                    self.red_metric_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-mtype-flag"):
                                    self.red_mtype_flag = value
                                    self.red_mtype_flag.value_namespace = name_space
                                    self.red_mtype_flag.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-tag"):
                                    self.red_tag = value
                                    self.red_tag.value_namespace = name_space
                                    self.red_tag.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.redistribution:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.redistribution:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "redistributions" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "redistribution"):
                                for c in self.redistribution:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions.Redistribution()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.redistribution.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "redistribution"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class ExternalRoutes(Entity):
                        """
                        OSPFv3 external route information table
                        
                        .. attribute:: external_route
                        
                        	OSPFv3 external route information
                        	**type**\: list of    :py:class:`ExternalRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes, self).__init__()

                            self.yang_name = "external-routes"
                            self.yang_parent_name = "vrf"

                            self.external_route = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes, self).__setattr__(name, value)


                        class ExternalRoute(Entity):
                            """
                            OSPFv3 external route information
                            
                            .. attribute:: prefix
                            
                            	Route prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..128
                            
                            .. attribute:: route_extended_community
                            
                            	Extended communities in the route
                            	**type**\:   :py:class:`RouteExtendedCommunity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity>`
                            
                            .. attribute:: route_path
                            
                            	List of paths to this route
                            	**type**\: list of    :py:class:`RoutePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath>`
                            
                            .. attribute:: route_topology
                            
                            	Common Route topology information
                            	**type**\:   :py:class:`RouteTopology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteTopology>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute, self).__init__()

                                self.yang_name = "external-route"
                                self.yang_parent_name = "external-routes"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.route_extended_community = Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity()
                                self.route_extended_community.parent = self
                                self._children_name_map["route_extended_community"] = "route-extended-community"
                                self._children_yang_names.add("route-extended-community")

                                self.route_topology = Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteTopology()
                                self.route_topology.parent = self
                                self._children_name_map["route_topology"] = "route-topology"
                                self._children_yang_names.add("route-topology")

                                self.route_path = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute, self).__setattr__(name, value)


                            class RouteTopology(Entity):
                                """
                                Common Route topology information
                                
                                .. attribute:: route_cost
                                
                                	Route cost 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: route_distance
                                
                                	Route distance 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: route_id
                                
                                	Route ID 
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: route_type
                                
                                	Route type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteTopology, self).__init__()

                                    self.yang_name = "route-topology"
                                    self.yang_parent_name = "external-route"

                                    self.route_cost = YLeaf(YType.uint32, "route-cost")

                                    self.route_distance = YLeaf(YType.uint32, "route-distance")

                                    self.route_id = YLeaf(YType.str, "route-id")

                                    self.route_type = YLeaf(YType.uint32, "route-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("route_cost",
                                                    "route_distance",
                                                    "route_id",
                                                    "route_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteTopology, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteTopology, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.route_cost.is_set or
                                        self.route_distance.is_set or
                                        self.route_id.is_set or
                                        self.route_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.route_cost.yfilter != YFilter.not_set or
                                        self.route_distance.yfilter != YFilter.not_set or
                                        self.route_id.yfilter != YFilter.not_set or
                                        self.route_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-topology" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.route_cost.is_set or self.route_cost.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_cost.get_name_leafdata())
                                    if (self.route_distance.is_set or self.route_distance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distance.get_name_leafdata())
                                    if (self.route_id.is_set or self.route_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_id.get_name_leafdata())
                                    if (self.route_type.is_set or self.route_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "route-cost" or name == "route-distance" or name == "route-id" or name == "route-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "route-cost"):
                                        self.route_cost = value
                                        self.route_cost.value_namespace = name_space
                                        self.route_cost.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distance"):
                                        self.route_distance = value
                                        self.route_distance.value_namespace = name_space
                                        self.route_distance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-id"):
                                        self.route_id = value
                                        self.route_id.value_namespace = name_space
                                        self.route_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-type"):
                                        self.route_type = value
                                        self.route_type.value_namespace = name_space
                                        self.route_type.value_namespace_prefix = name_space_prefix


                            class RouteExtendedCommunity(Entity):
                                """
                                Extended communities in the route
                                
                                .. attribute:: extended_community_area_id
                                
                                	Area id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: extended_community_domain_id_value
                                
                                	Domain ID value
                                	**type**\:  str
                                
                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                
                                .. attribute:: extended_community_options
                                
                                	Route Options
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: extended_community_route_type
                                
                                	Route type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: extended_community_router_id
                                
                                	Router id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: extended_communityl_domain_id_type
                                
                                	Domain ID type
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity, self).__init__()

                                    self.yang_name = "route-extended-community"
                                    self.yang_parent_name = "external-route"

                                    self.extended_community_area_id = YLeaf(YType.uint32, "extended-community-area-id")

                                    self.extended_community_domain_id_value = YLeaf(YType.str, "extended-community-domain-id-value")

                                    self.extended_community_options = YLeaf(YType.uint8, "extended-community-options")

                                    self.extended_community_route_type = YLeaf(YType.uint8, "extended-community-route-type")

                                    self.extended_community_router_id = YLeaf(YType.str, "extended-community-router-id")

                                    self.extended_communityl_domain_id_type = YLeaf(YType.uint16, "extended-communityl-domain-id-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("extended_community_area_id",
                                                    "extended_community_domain_id_value",
                                                    "extended_community_options",
                                                    "extended_community_route_type",
                                                    "extended_community_router_id",
                                                    "extended_communityl_domain_id_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.extended_community_area_id.is_set or
                                        self.extended_community_domain_id_value.is_set or
                                        self.extended_community_options.is_set or
                                        self.extended_community_route_type.is_set or
                                        self.extended_community_router_id.is_set or
                                        self.extended_communityl_domain_id_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.extended_community_area_id.yfilter != YFilter.not_set or
                                        self.extended_community_domain_id_value.yfilter != YFilter.not_set or
                                        self.extended_community_options.yfilter != YFilter.not_set or
                                        self.extended_community_route_type.yfilter != YFilter.not_set or
                                        self.extended_community_router_id.yfilter != YFilter.not_set or
                                        self.extended_communityl_domain_id_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-extended-community" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.extended_community_area_id.is_set or self.extended_community_area_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.extended_community_area_id.get_name_leafdata())
                                    if (self.extended_community_domain_id_value.is_set or self.extended_community_domain_id_value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.extended_community_domain_id_value.get_name_leafdata())
                                    if (self.extended_community_options.is_set or self.extended_community_options.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.extended_community_options.get_name_leafdata())
                                    if (self.extended_community_route_type.is_set or self.extended_community_route_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.extended_community_route_type.get_name_leafdata())
                                    if (self.extended_community_router_id.is_set or self.extended_community_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.extended_community_router_id.get_name_leafdata())
                                    if (self.extended_communityl_domain_id_type.is_set or self.extended_communityl_domain_id_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.extended_communityl_domain_id_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "extended-community-area-id" or name == "extended-community-domain-id-value" or name == "extended-community-options" or name == "extended-community-route-type" or name == "extended-community-router-id" or name == "extended-communityl-domain-id-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "extended-community-area-id"):
                                        self.extended_community_area_id = value
                                        self.extended_community_area_id.value_namespace = name_space
                                        self.extended_community_area_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "extended-community-domain-id-value"):
                                        self.extended_community_domain_id_value = value
                                        self.extended_community_domain_id_value.value_namespace = name_space
                                        self.extended_community_domain_id_value.value_namespace_prefix = name_space_prefix
                                    if(value_path == "extended-community-options"):
                                        self.extended_community_options = value
                                        self.extended_community_options.value_namespace = name_space
                                        self.extended_community_options.value_namespace_prefix = name_space_prefix
                                    if(value_path == "extended-community-route-type"):
                                        self.extended_community_route_type = value
                                        self.extended_community_route_type.value_namespace = name_space
                                        self.extended_community_route_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "extended-community-router-id"):
                                        self.extended_community_router_id = value
                                        self.extended_community_router_id.value_namespace = name_space
                                        self.extended_community_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "extended-communityl-domain-id-type"):
                                        self.extended_communityl_domain_id_type = value
                                        self.extended_communityl_domain_id_type.value_namespace = name_space
                                        self.extended_communityl_domain_id_type.value_namespace_prefix = name_space_prefix


                            class RoutePath(Entity):
                                """
                                List of paths to this route
                                
                                .. attribute:: interface_name
                                
                                	Route path interface name 
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: route_backup_path
                                
                                	Backup Path Info
                                	**type**\:   :py:class:`RouteBackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath>`
                                
                                .. attribute:: route_path_id
                                
                                	Path ID of path
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: route_path_next_hop
                                
                                	Route path next hop 
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath, self).__init__()

                                    self.yang_name = "route-path"
                                    self.yang_parent_name = "external-route"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.route_path_id = YLeaf(YType.uint16, "route-path-id")

                                    self.route_path_next_hop = YLeaf(YType.str, "route-path-next-hop")

                                    self.route_backup_path = Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath()
                                    self.route_backup_path.parent = self
                                    self._children_name_map["route_backup_path"] = "route-backup-path"
                                    self._children_yang_names.add("route-backup-path")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "route_path_id",
                                                    "route_path_next_hop") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath, self).__setattr__(name, value)


                                class RouteBackupPath(Entity):
                                    """
                                    Backup Path Info
                                    
                                    .. attribute:: backup_metric
                                    
                                    	Metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: backup_route_interface_name
                                    
                                    	Next hop Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: backup_route_next_hop_address
                                    
                                    	Nexthop IP address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: backup_route_source
                                    
                                    	IP address of source of route
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: downstream
                                    
                                    	Downstream
                                    	**type**\:  bool
                                    
                                    .. attribute:: line_card_disjoint
                                    
                                    	Line Card Disjoint
                                    	**type**\:  bool
                                    
                                    .. attribute:: node_protect
                                    
                                    	Node Protect
                                    	**type**\:  bool
                                    
                                    .. attribute:: primary_path
                                    
                                    	Primary Path
                                    	**type**\:  bool
                                    
                                    .. attribute:: srlg_disjoint
                                    
                                    	SRLG Disjoint
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath, self).__init__()

                                        self.yang_name = "route-backup-path"
                                        self.yang_parent_name = "route-path"

                                        self.backup_metric = YLeaf(YType.uint32, "backup-metric")

                                        self.backup_route_interface_name = YLeaf(YType.str, "backup-route-interface-name")

                                        self.backup_route_next_hop_address = YLeaf(YType.str, "backup-route-next-hop-address")

                                        self.backup_route_source = YLeaf(YType.str, "backup-route-source")

                                        self.downstream = YLeaf(YType.boolean, "downstream")

                                        self.line_card_disjoint = YLeaf(YType.boolean, "line-card-disjoint")

                                        self.node_protect = YLeaf(YType.boolean, "node-protect")

                                        self.primary_path = YLeaf(YType.boolean, "primary-path")

                                        self.srlg_disjoint = YLeaf(YType.boolean, "srlg-disjoint")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_metric",
                                                        "backup_route_interface_name",
                                                        "backup_route_next_hop_address",
                                                        "backup_route_source",
                                                        "downstream",
                                                        "line_card_disjoint",
                                                        "node_protect",
                                                        "primary_path",
                                                        "srlg_disjoint") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_metric.is_set or
                                            self.backup_route_interface_name.is_set or
                                            self.backup_route_next_hop_address.is_set or
                                            self.backup_route_source.is_set or
                                            self.downstream.is_set or
                                            self.line_card_disjoint.is_set or
                                            self.node_protect.is_set or
                                            self.primary_path.is_set or
                                            self.srlg_disjoint.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_metric.yfilter != YFilter.not_set or
                                            self.backup_route_interface_name.yfilter != YFilter.not_set or
                                            self.backup_route_next_hop_address.yfilter != YFilter.not_set or
                                            self.backup_route_source.yfilter != YFilter.not_set or
                                            self.downstream.yfilter != YFilter.not_set or
                                            self.line_card_disjoint.yfilter != YFilter.not_set or
                                            self.node_protect.yfilter != YFilter.not_set or
                                            self.primary_path.yfilter != YFilter.not_set or
                                            self.srlg_disjoint.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "route-backup-path" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_metric.is_set or self.backup_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_metric.get_name_leafdata())
                                        if (self.backup_route_interface_name.is_set or self.backup_route_interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_route_interface_name.get_name_leafdata())
                                        if (self.backup_route_next_hop_address.is_set or self.backup_route_next_hop_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_route_next_hop_address.get_name_leafdata())
                                        if (self.backup_route_source.is_set or self.backup_route_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_route_source.get_name_leafdata())
                                        if (self.downstream.is_set or self.downstream.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.downstream.get_name_leafdata())
                                        if (self.line_card_disjoint.is_set or self.line_card_disjoint.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.line_card_disjoint.get_name_leafdata())
                                        if (self.node_protect.is_set or self.node_protect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.node_protect.get_name_leafdata())
                                        if (self.primary_path.is_set or self.primary_path.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.primary_path.get_name_leafdata())
                                        if (self.srlg_disjoint.is_set or self.srlg_disjoint.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_disjoint.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-metric" or name == "backup-route-interface-name" or name == "backup-route-next-hop-address" or name == "backup-route-source" or name == "downstream" or name == "line-card-disjoint" or name == "node-protect" or name == "primary-path" or name == "srlg-disjoint"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-metric"):
                                            self.backup_metric = value
                                            self.backup_metric.value_namespace = name_space
                                            self.backup_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-route-interface-name"):
                                            self.backup_route_interface_name = value
                                            self.backup_route_interface_name.value_namespace = name_space
                                            self.backup_route_interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-route-next-hop-address"):
                                            self.backup_route_next_hop_address = value
                                            self.backup_route_next_hop_address.value_namespace = name_space
                                            self.backup_route_next_hop_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-route-source"):
                                            self.backup_route_source = value
                                            self.backup_route_source.value_namespace = name_space
                                            self.backup_route_source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "downstream"):
                                            self.downstream = value
                                            self.downstream.value_namespace = name_space
                                            self.downstream.value_namespace_prefix = name_space_prefix
                                        if(value_path == "line-card-disjoint"):
                                            self.line_card_disjoint = value
                                            self.line_card_disjoint.value_namespace = name_space
                                            self.line_card_disjoint.value_namespace_prefix = name_space_prefix
                                        if(value_path == "node-protect"):
                                            self.node_protect = value
                                            self.node_protect.value_namespace = name_space
                                            self.node_protect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "primary-path"):
                                            self.primary_path = value
                                            self.primary_path.value_namespace = name_space
                                            self.primary_path.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-disjoint"):
                                            self.srlg_disjoint = value
                                            self.srlg_disjoint.value_namespace = name_space
                                            self.srlg_disjoint.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        self.route_path_id.is_set or
                                        self.route_path_next_hop.is_set or
                                        (self.route_backup_path is not None and self.route_backup_path.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.route_path_id.yfilter != YFilter.not_set or
                                        self.route_path_next_hop.yfilter != YFilter.not_set or
                                        (self.route_backup_path is not None and self.route_backup_path.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.route_path_id.is_set or self.route_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_path_id.get_name_leafdata())
                                    if (self.route_path_next_hop.is_set or self.route_path_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_path_next_hop.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "route-backup-path"):
                                        if (self.route_backup_path is None):
                                            self.route_backup_path = Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath()
                                            self.route_backup_path.parent = self
                                            self._children_name_map["route_backup_path"] = "route-backup-path"
                                        return self.route_backup_path

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "route-backup-path" or name == "interface-name" or name == "route-path-id" or name == "route-path-next-hop"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-path-id"):
                                        self.route_path_id = value
                                        self.route_path_id.value_namespace = name_space
                                        self.route_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-path-next-hop"):
                                        self.route_path_next_hop = value
                                        self.route_path_next_hop.value_namespace = name_space
                                        self.route_path_next_hop.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.route_path:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    (self.route_extended_community is not None and self.route_extended_community.has_data()) or
                                    (self.route_topology is not None and self.route_topology.has_data()))

                            def has_operation(self):
                                for c in self.route_path:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    (self.route_extended_community is not None and self.route_extended_community.has_operation()) or
                                    (self.route_topology is not None and self.route_topology.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "external-route" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "route-extended-community"):
                                    if (self.route_extended_community is None):
                                        self.route_extended_community = Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity()
                                        self.route_extended_community.parent = self
                                        self._children_name_map["route_extended_community"] = "route-extended-community"
                                    return self.route_extended_community

                                if (child_yang_name == "route-path"):
                                    for c in self.route_path:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RoutePath()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.route_path.append(c)
                                    return c

                                if (child_yang_name == "route-topology"):
                                    if (self.route_topology is None):
                                        self.route_topology = Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute.RouteTopology()
                                        self.route_topology.parent = self
                                        self._children_name_map["route_topology"] = "route-topology"
                                    return self.route_topology

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "route-extended-community" or name == "route-path" or name == "route-topology" or name == "prefix" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.external_route:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.external_route:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "external-routes" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "external-route"):
                                for c in self.external_route:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes.ExternalRoute()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.external_route.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "external-route"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class RequestListProcessTable(Entity):
                        """
                        OSPFv3 request list information for all areas
                        
                        .. attribute:: request
                        
                        	OSPFv3 request list information
                        	**type**\: list of    :py:class:`Request <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable.Request>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable, self).__init__()

                            self.yang_name = "request-list-process-table"
                            self.yang_parent_name = "vrf"

                            self.request = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable, self).__setattr__(name, value)


                        class Request(Entity):
                            """
                            OSPFv3 request list information
                            
                            .. attribute:: interface_name
                            
                            	Interface name
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: is_request_sham_link
                            
                            	If true, sham link is requested 
                            	**type**\:  bool
                            
                            .. attribute:: is_request_virtual_link
                            
                            	If true, virtual link is requested 
                            	**type**\:  bool
                            
                            .. attribute:: neighbor_address
                            
                            	Neighbor address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: request
                            
                            	List of request list entries
                            	**type**\: list of    :py:class:`Request <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable.Request.Request>`
                            
                            .. attribute:: request_neighbor_address
                            
                            	Neighbor IP address
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: request_sham_link_id
                            
                            	Request sham link ID 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: request_virtual_link_id
                            
                            	Request virtual link ID 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable.Request, self).__init__()

                                self.yang_name = "request"
                                self.yang_parent_name = "request-list-process-table"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.is_request_sham_link = YLeaf(YType.boolean, "is-request-sham-link")

                                self.is_request_virtual_link = YLeaf(YType.boolean, "is-request-virtual-link")

                                self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                self.request_neighbor_address = YLeaf(YType.str, "request-neighbor-address")

                                self.request_sham_link_id = YLeaf(YType.uint32, "request-sham-link-id")

                                self.request_virtual_link_id = YLeaf(YType.uint32, "request-virtual-link-id")

                                self.request = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "is_request_sham_link",
                                                "is_request_virtual_link",
                                                "neighbor_address",
                                                "request_neighbor_address",
                                                "request_sham_link_id",
                                                "request_virtual_link_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable.Request, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable.Request, self).__setattr__(name, value)


                            class Request(Entity):
                                """
                                List of request list entries
                                
                                .. attribute:: header_advertising_router
                                
                                	Router ID of the advertising router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_age
                                
                                	Age of the LSA (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                	**units**\: second
                                
                                .. attribute:: header_lsa_id
                                
                                	LSA ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_type
                                
                                	LSA type
                                	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                
                                .. attribute:: header_sequence_number
                                
                                	Current LSA sequence number
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable.Request.Request, self).__init__()

                                    self.yang_name = "request"
                                    self.yang_parent_name = "request"

                                    self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                    self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                    self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                    self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                    self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("header_advertising_router",
                                                    "header_lsa_age",
                                                    "header_lsa_id",
                                                    "header_lsa_type",
                                                    "header_sequence_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable.Request.Request, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable.Request.Request, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.header_advertising_router.is_set or
                                        self.header_lsa_age.is_set or
                                        self.header_lsa_id.is_set or
                                        self.header_lsa_type.is_set or
                                        self.header_sequence_number.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.header_advertising_router.yfilter != YFilter.not_set or
                                        self.header_lsa_age.yfilter != YFilter.not_set or
                                        self.header_lsa_id.yfilter != YFilter.not_set or
                                        self.header_lsa_type.yfilter != YFilter.not_set or
                                        self.header_sequence_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "request" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                    if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                    if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                    if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                    if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "header-advertising-router"):
                                        self.header_advertising_router = value
                                        self.header_advertising_router.value_namespace = name_space
                                        self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-age"):
                                        self.header_lsa_age = value
                                        self.header_lsa_age.value_namespace = name_space
                                        self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-id"):
                                        self.header_lsa_id = value
                                        self.header_lsa_id.value_namespace = name_space
                                        self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-type"):
                                        self.header_lsa_type = value
                                        self.header_lsa_type.value_namespace = name_space
                                        self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-sequence-number"):
                                        self.header_sequence_number = value
                                        self.header_sequence_number.value_namespace = name_space
                                        self.header_sequence_number.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.request:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.interface_name.is_set or
                                    self.is_request_sham_link.is_set or
                                    self.is_request_virtual_link.is_set or
                                    self.neighbor_address.is_set or
                                    self.request_neighbor_address.is_set or
                                    self.request_sham_link_id.is_set or
                                    self.request_virtual_link_id.is_set)

                            def has_operation(self):
                                for c in self.request:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.is_request_sham_link.yfilter != YFilter.not_set or
                                    self.is_request_virtual_link.yfilter != YFilter.not_set or
                                    self.neighbor_address.yfilter != YFilter.not_set or
                                    self.request_neighbor_address.yfilter != YFilter.not_set or
                                    self.request_sham_link_id.yfilter != YFilter.not_set or
                                    self.request_virtual_link_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "request" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.is_request_sham_link.is_set or self.is_request_sham_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_request_sham_link.get_name_leafdata())
                                if (self.is_request_virtual_link.is_set or self.is_request_virtual_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_request_virtual_link.get_name_leafdata())
                                if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                if (self.request_neighbor_address.is_set or self.request_neighbor_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.request_neighbor_address.get_name_leafdata())
                                if (self.request_sham_link_id.is_set or self.request_sham_link_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.request_sham_link_id.get_name_leafdata())
                                if (self.request_virtual_link_id.is_set or self.request_virtual_link_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.request_virtual_link_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "request"):
                                    for c in self.request:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable.Request.Request()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.request.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "request" or name == "interface-name" or name == "is-request-sham-link" or name == "is-request-virtual-link" or name == "neighbor-address" or name == "request-neighbor-address" or name == "request-sham-link-id" or name == "request-virtual-link-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-request-sham-link"):
                                    self.is_request_sham_link = value
                                    self.is_request_sham_link.value_namespace = name_space
                                    self.is_request_sham_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-request-virtual-link"):
                                    self.is_request_virtual_link = value
                                    self.is_request_virtual_link.value_namespace = name_space
                                    self.is_request_virtual_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-address"):
                                    self.neighbor_address = value
                                    self.neighbor_address.value_namespace = name_space
                                    self.neighbor_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "request-neighbor-address"):
                                    self.request_neighbor_address = value
                                    self.request_neighbor_address.value_namespace = name_space
                                    self.request_neighbor_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "request-sham-link-id"):
                                    self.request_sham_link_id = value
                                    self.request_sham_link_id.value_namespace = name_space
                                    self.request_sham_link_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "request-virtual-link-id"):
                                    self.request_virtual_link_id = value
                                    self.request_virtual_link_id.value_namespace = name_space
                                    self.request_virtual_link_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.request:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.request:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "request-list-process-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "request"):
                                for c in self.request:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable.Request()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.request.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "request"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class VirtualLink(Entity):
                        """
                        Virtual link information
                        
                        .. attribute:: interface_name
                        
                        	Interface on which this virtual link is formed
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: is_virtual_link_authentication_enabled
                        
                        	If true, virtual link authentication is enabled 
                        	**type**\:  bool
                        
                        .. attribute:: is_virtual_link_demand_circuit
                        
                        	If true, the link runs as demand circuit
                        	**type**\:  bool
                        
                        .. attribute:: is_virtual_link_encryption_enabled
                        
                        	If true, virtual link encryption is enabled 
                        	**type**\:  bool
                        
                        .. attribute:: is_virtual_link_ip_security_active
                        
                        	If true, Virtual link IP security is active 
                        	**type**\:  bool
                        
                        .. attribute:: is_virtual_link_ip_security_required
                        
                        	If true, virtual link IP security is required 
                        	**type**\:  bool
                        
                        .. attribute:: is_virtual_link_passive
                        
                        	If true, interface is passive
                        	**type**\:  bool
                        
                        .. attribute:: transit_area_id
                        
                        	Transit area id 
                        	**type**\:  str
                        
                        .. attribute:: virtual_link_authentication_spi
                        
                        	Virtual link authentication spi 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_authentication_transmit
                        
                        	Virtual link authentication transmit 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_cost
                        
                        	Cost of the virtual link
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: virtual_link_dc_bitless_lsa
                        
                        	Number of LSA's with demand circuit bit not set 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_dead_interval
                        
                        	Dead interval (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_encrypted_authentication_transmitted
                        
                        	Virtual link encrypted authentication transmitted 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_encryption_spi
                        
                        	Virtual link encryption spi
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_encryption_transmitted
                        
                        	Virtual link encryption transmitted 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_hello_interval
                        
                        	Hello interval (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_interface_number
                        
                        	Virtual link interface number 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_neighbor
                        
                        	Neighbor information 
                        	**type**\:   :py:class:`VirtualLinkNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor>`
                        
                        .. attribute:: virtual_link_neighbor_address
                        
                        	Virtual link neighbor addresss 
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: virtual_link_neighbor_id
                        
                        	Neighbor on other end of this virtual link
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: virtual_link_next_hello
                        
                        	Time until next hello (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_retransmission_interval
                        
                        	Retransmission interval (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virtual_link_state
                        
                        	OSPF interface state for the virtual link
                        	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                        
                        .. attribute:: virtual_link_wait_interval
                        
                        	Wait interval (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: virual_link_transmission_delay
                        
                        	Transmission delay in seconds
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink, self).__init__()

                            self.yang_name = "virtual-link"
                            self.yang_parent_name = "vrf"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.is_virtual_link_authentication_enabled = YLeaf(YType.boolean, "is-virtual-link-authentication-enabled")

                            self.is_virtual_link_demand_circuit = YLeaf(YType.boolean, "is-virtual-link-demand-circuit")

                            self.is_virtual_link_encryption_enabled = YLeaf(YType.boolean, "is-virtual-link-encryption-enabled")

                            self.is_virtual_link_ip_security_active = YLeaf(YType.boolean, "is-virtual-link-ip-security-active")

                            self.is_virtual_link_ip_security_required = YLeaf(YType.boolean, "is-virtual-link-ip-security-required")

                            self.is_virtual_link_passive = YLeaf(YType.boolean, "is-virtual-link-passive")

                            self.transit_area_id = YLeaf(YType.str, "transit-area-id")

                            self.virtual_link_authentication_spi = YLeaf(YType.uint32, "virtual-link-authentication-spi")

                            self.virtual_link_authentication_transmit = YLeaf(YType.uint32, "virtual-link-authentication-transmit")

                            self.virtual_link_cost = YLeaf(YType.uint16, "virtual-link-cost")

                            self.virtual_link_dc_bitless_lsa = YLeaf(YType.uint32, "virtual-link-dc-bitless-lsa")

                            self.virtual_link_dead_interval = YLeaf(YType.uint32, "virtual-link-dead-interval")

                            self.virtual_link_encrypted_authentication_transmitted = YLeaf(YType.uint32, "virtual-link-encrypted-authentication-transmitted")

                            self.virtual_link_encryption_spi = YLeaf(YType.uint32, "virtual-link-encryption-spi")

                            self.virtual_link_encryption_transmitted = YLeaf(YType.uint32, "virtual-link-encryption-transmitted")

                            self.virtual_link_hello_interval = YLeaf(YType.uint32, "virtual-link-hello-interval")

                            self.virtual_link_interface_number = YLeaf(YType.uint32, "virtual-link-interface-number")

                            self.virtual_link_neighbor_address = YLeaf(YType.str, "virtual-link-neighbor-address")

                            self.virtual_link_neighbor_id = YLeaf(YType.str, "virtual-link-neighbor-id")

                            self.virtual_link_next_hello = YLeaf(YType.uint32, "virtual-link-next-hello")

                            self.virtual_link_retransmission_interval = YLeaf(YType.uint32, "virtual-link-retransmission-interval")

                            self.virtual_link_state = YLeaf(YType.enumeration, "virtual-link-state")

                            self.virtual_link_wait_interval = YLeaf(YType.uint32, "virtual-link-wait-interval")

                            self.virual_link_transmission_delay = YLeaf(YType.uint16, "virual-link-transmission-delay")

                            self.virtual_link_neighbor = Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor()
                            self.virtual_link_neighbor.parent = self
                            self._children_name_map["virtual_link_neighbor"] = "virtual-link-neighbor"
                            self._children_yang_names.add("virtual-link-neighbor")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "is_virtual_link_authentication_enabled",
                                            "is_virtual_link_demand_circuit",
                                            "is_virtual_link_encryption_enabled",
                                            "is_virtual_link_ip_security_active",
                                            "is_virtual_link_ip_security_required",
                                            "is_virtual_link_passive",
                                            "transit_area_id",
                                            "virtual_link_authentication_spi",
                                            "virtual_link_authentication_transmit",
                                            "virtual_link_cost",
                                            "virtual_link_dc_bitless_lsa",
                                            "virtual_link_dead_interval",
                                            "virtual_link_encrypted_authentication_transmitted",
                                            "virtual_link_encryption_spi",
                                            "virtual_link_encryption_transmitted",
                                            "virtual_link_hello_interval",
                                            "virtual_link_interface_number",
                                            "virtual_link_neighbor_address",
                                            "virtual_link_neighbor_id",
                                            "virtual_link_next_hello",
                                            "virtual_link_retransmission_interval",
                                            "virtual_link_state",
                                            "virtual_link_wait_interval",
                                            "virual_link_transmission_delay") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink, self).__setattr__(name, value)


                        class VirtualLinkNeighbor(Entity):
                            """
                            Neighbor information 
                            
                            .. attribute:: is_virtual_link_hello_suppressed
                            
                            	If true, hello suppressed 
                            	**type**\:  bool
                            
                            .. attribute:: virtual_link_retransmission
                            
                            	Virtual link retransmission information 
                            	**type**\:   :py:class:`VirtualLinkRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission>`
                            
                            .. attribute:: virtual_link_state
                            
                            	OSPF interface state for the virtual link
                            	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor, self).__init__()

                                self.yang_name = "virtual-link-neighbor"
                                self.yang_parent_name = "virtual-link"

                                self.is_virtual_link_hello_suppressed = YLeaf(YType.boolean, "is-virtual-link-hello-suppressed")

                                self.virtual_link_state = YLeaf(YType.enumeration, "virtual-link-state")

                                self.virtual_link_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission()
                                self.virtual_link_retransmission.parent = self
                                self._children_name_map["virtual_link_retransmission"] = "virtual-link-retransmission"
                                self._children_yang_names.add("virtual-link-retransmission")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_virtual_link_hello_suppressed",
                                                "virtual_link_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor, self).__setattr__(name, value)


                            class VirtualLinkRetransmission(Entity):
                                """
                                Virtual link retransmission information 
                                
                                .. attribute:: area_first_flood
                                
                                	First flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_first_flood_index
                                
                                	Index of the first flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_flood_index
                                
                                	Area scope LSA's flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_next_flood
                                
                                	Next flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_next_flood_index
                                
                                	Index of next flood item for Area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_first_flood
                                
                                	First flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_first_flood_index
                                
                                	Index for first flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_flood_index
                                
                                	AS scope LSA's flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_next_flood
                                
                                	Next flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_next_flood_index
                                
                                	Index of next flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: database_descriptor_retransmissions
                                
                                	Number of database descriptor retransmissions during last exchange
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_retransmission_length
                                
                                	Number of LSAs sent in last retransmission
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_retransmission_time
                                
                                	Last retransmission scan time (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_first_flood
                                
                                	Link first flood information 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_first_flood_index
                                
                                	Link first flood information index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_flood_index
                                
                                	Link flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_next_flood
                                
                                	Link next flood information 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_next_flood_index
                                
                                	Link next flood information index 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsa_retransmission_timer
                                
                                	Time until next LSA retransmission (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: maximum_retransmission_length
                                
                                	Maximum number of LSAs sent in a retransmission
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: maximum_retransmission_time
                                
                                	Maximum retransmission scan time (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_retransmissions
                                
                                	Number of neighbor retransmissions 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: retransmissions
                                
                                	Number of retransmissions for this neighbor
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission, self).__init__()

                                    self.yang_name = "virtual-link-retransmission"
                                    self.yang_parent_name = "virtual-link-neighbor"

                                    self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                    self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                    self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                    self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                    self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                    self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                    self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                    self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                    self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                    self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                    self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                    self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                    self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                    self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                    self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                    self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                    self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                    self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                    self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                    self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                    self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                    self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                    self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("area_first_flood",
                                                    "area_first_flood_index",
                                                    "area_flood_index",
                                                    "area_next_flood",
                                                    "area_next_flood_index",
                                                    "as_first_flood",
                                                    "as_first_flood_index",
                                                    "as_flood_index",
                                                    "as_next_flood",
                                                    "as_next_flood_index",
                                                    "database_descriptor_retransmissions",
                                                    "last_retransmission_length",
                                                    "last_retransmission_time",
                                                    "link_first_flood",
                                                    "link_first_flood_index",
                                                    "link_flood_index",
                                                    "link_next_flood",
                                                    "link_next_flood_index",
                                                    "lsa_retransmission_timer",
                                                    "maximum_retransmission_length",
                                                    "maximum_retransmission_time",
                                                    "neighbor_retransmissions",
                                                    "retransmissions") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.area_first_flood.is_set or
                                        self.area_first_flood_index.is_set or
                                        self.area_flood_index.is_set or
                                        self.area_next_flood.is_set or
                                        self.area_next_flood_index.is_set or
                                        self.as_first_flood.is_set or
                                        self.as_first_flood_index.is_set or
                                        self.as_flood_index.is_set or
                                        self.as_next_flood.is_set or
                                        self.as_next_flood_index.is_set or
                                        self.database_descriptor_retransmissions.is_set or
                                        self.last_retransmission_length.is_set or
                                        self.last_retransmission_time.is_set or
                                        self.link_first_flood.is_set or
                                        self.link_first_flood_index.is_set or
                                        self.link_flood_index.is_set or
                                        self.link_next_flood.is_set or
                                        self.link_next_flood_index.is_set or
                                        self.lsa_retransmission_timer.is_set or
                                        self.maximum_retransmission_length.is_set or
                                        self.maximum_retransmission_time.is_set or
                                        self.neighbor_retransmissions.is_set or
                                        self.retransmissions.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.area_first_flood.yfilter != YFilter.not_set or
                                        self.area_first_flood_index.yfilter != YFilter.not_set or
                                        self.area_flood_index.yfilter != YFilter.not_set or
                                        self.area_next_flood.yfilter != YFilter.not_set or
                                        self.area_next_flood_index.yfilter != YFilter.not_set or
                                        self.as_first_flood.yfilter != YFilter.not_set or
                                        self.as_first_flood_index.yfilter != YFilter.not_set or
                                        self.as_flood_index.yfilter != YFilter.not_set or
                                        self.as_next_flood.yfilter != YFilter.not_set or
                                        self.as_next_flood_index.yfilter != YFilter.not_set or
                                        self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                        self.last_retransmission_length.yfilter != YFilter.not_set or
                                        self.last_retransmission_time.yfilter != YFilter.not_set or
                                        self.link_first_flood.yfilter != YFilter.not_set or
                                        self.link_first_flood_index.yfilter != YFilter.not_set or
                                        self.link_flood_index.yfilter != YFilter.not_set or
                                        self.link_next_flood.yfilter != YFilter.not_set or
                                        self.link_next_flood_index.yfilter != YFilter.not_set or
                                        self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                        self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                        self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                        self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                        self.retransmissions.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "virtual-link-retransmission" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                    if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                    if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                    if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                    if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                    if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                    if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                    if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                    if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                    if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                    if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                    if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                    if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                    if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                    if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                    if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                    if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                    if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                    if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                    if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                    if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                    if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                    if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "area-first-flood"):
                                        self.area_first_flood = value
                                        self.area_first_flood.value_namespace = name_space
                                        self.area_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-first-flood-index"):
                                        self.area_first_flood_index = value
                                        self.area_first_flood_index.value_namespace = name_space
                                        self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-flood-index"):
                                        self.area_flood_index = value
                                        self.area_flood_index.value_namespace = name_space
                                        self.area_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-next-flood"):
                                        self.area_next_flood = value
                                        self.area_next_flood.value_namespace = name_space
                                        self.area_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-next-flood-index"):
                                        self.area_next_flood_index = value
                                        self.area_next_flood_index.value_namespace = name_space
                                        self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-first-flood"):
                                        self.as_first_flood = value
                                        self.as_first_flood.value_namespace = name_space
                                        self.as_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-first-flood-index"):
                                        self.as_first_flood_index = value
                                        self.as_first_flood_index.value_namespace = name_space
                                        self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-flood-index"):
                                        self.as_flood_index = value
                                        self.as_flood_index.value_namespace = name_space
                                        self.as_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-next-flood"):
                                        self.as_next_flood = value
                                        self.as_next_flood.value_namespace = name_space
                                        self.as_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-next-flood-index"):
                                        self.as_next_flood_index = value
                                        self.as_next_flood_index.value_namespace = name_space
                                        self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "database-descriptor-retransmissions"):
                                        self.database_descriptor_retransmissions = value
                                        self.database_descriptor_retransmissions.value_namespace = name_space
                                        self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-retransmission-length"):
                                        self.last_retransmission_length = value
                                        self.last_retransmission_length.value_namespace = name_space
                                        self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-retransmission-time"):
                                        self.last_retransmission_time = value
                                        self.last_retransmission_time.value_namespace = name_space
                                        self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-first-flood"):
                                        self.link_first_flood = value
                                        self.link_first_flood.value_namespace = name_space
                                        self.link_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-first-flood-index"):
                                        self.link_first_flood_index = value
                                        self.link_first_flood_index.value_namespace = name_space
                                        self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-flood-index"):
                                        self.link_flood_index = value
                                        self.link_flood_index.value_namespace = name_space
                                        self.link_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-next-flood"):
                                        self.link_next_flood = value
                                        self.link_next_flood.value_namespace = name_space
                                        self.link_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-next-flood-index"):
                                        self.link_next_flood_index = value
                                        self.link_next_flood_index.value_namespace = name_space
                                        self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsa-retransmission-timer"):
                                        self.lsa_retransmission_timer = value
                                        self.lsa_retransmission_timer.value_namespace = name_space
                                        self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "maximum-retransmission-length"):
                                        self.maximum_retransmission_length = value
                                        self.maximum_retransmission_length.value_namespace = name_space
                                        self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "maximum-retransmission-time"):
                                        self.maximum_retransmission_time = value
                                        self.maximum_retransmission_time.value_namespace = name_space
                                        self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-retransmissions"):
                                        self.neighbor_retransmissions = value
                                        self.neighbor_retransmissions.value_namespace = name_space
                                        self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                    if(value_path == "retransmissions"):
                                        self.retransmissions = value
                                        self.retransmissions.value_namespace = name_space
                                        self.retransmissions.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.is_virtual_link_hello_suppressed.is_set or
                                    self.virtual_link_state.is_set or
                                    (self.virtual_link_retransmission is not None and self.virtual_link_retransmission.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_virtual_link_hello_suppressed.yfilter != YFilter.not_set or
                                    self.virtual_link_state.yfilter != YFilter.not_set or
                                    (self.virtual_link_retransmission is not None and self.virtual_link_retransmission.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "virtual-link-neighbor" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_virtual_link_hello_suppressed.is_set or self.is_virtual_link_hello_suppressed.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_virtual_link_hello_suppressed.get_name_leafdata())
                                if (self.virtual_link_state.is_set or self.virtual_link_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.virtual_link_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "virtual-link-retransmission"):
                                    if (self.virtual_link_retransmission is None):
                                        self.virtual_link_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission()
                                        self.virtual_link_retransmission.parent = self
                                        self._children_name_map["virtual_link_retransmission"] = "virtual-link-retransmission"
                                    return self.virtual_link_retransmission

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "virtual-link-retransmission" or name == "is-virtual-link-hello-suppressed" or name == "virtual-link-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-virtual-link-hello-suppressed"):
                                    self.is_virtual_link_hello_suppressed = value
                                    self.is_virtual_link_hello_suppressed.value_namespace = name_space
                                    self.is_virtual_link_hello_suppressed.value_namespace_prefix = name_space_prefix
                                if(value_path == "virtual-link-state"):
                                    self.virtual_link_state = value
                                    self.virtual_link_state.value_namespace = name_space
                                    self.virtual_link_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.interface_name.is_set or
                                self.is_virtual_link_authentication_enabled.is_set or
                                self.is_virtual_link_demand_circuit.is_set or
                                self.is_virtual_link_encryption_enabled.is_set or
                                self.is_virtual_link_ip_security_active.is_set or
                                self.is_virtual_link_ip_security_required.is_set or
                                self.is_virtual_link_passive.is_set or
                                self.transit_area_id.is_set or
                                self.virtual_link_authentication_spi.is_set or
                                self.virtual_link_authentication_transmit.is_set or
                                self.virtual_link_cost.is_set or
                                self.virtual_link_dc_bitless_lsa.is_set or
                                self.virtual_link_dead_interval.is_set or
                                self.virtual_link_encrypted_authentication_transmitted.is_set or
                                self.virtual_link_encryption_spi.is_set or
                                self.virtual_link_encryption_transmitted.is_set or
                                self.virtual_link_hello_interval.is_set or
                                self.virtual_link_interface_number.is_set or
                                self.virtual_link_neighbor_address.is_set or
                                self.virtual_link_neighbor_id.is_set or
                                self.virtual_link_next_hello.is_set or
                                self.virtual_link_retransmission_interval.is_set or
                                self.virtual_link_state.is_set or
                                self.virtual_link_wait_interval.is_set or
                                self.virual_link_transmission_delay.is_set or
                                (self.virtual_link_neighbor is not None and self.virtual_link_neighbor.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.is_virtual_link_authentication_enabled.yfilter != YFilter.not_set or
                                self.is_virtual_link_demand_circuit.yfilter != YFilter.not_set or
                                self.is_virtual_link_encryption_enabled.yfilter != YFilter.not_set or
                                self.is_virtual_link_ip_security_active.yfilter != YFilter.not_set or
                                self.is_virtual_link_ip_security_required.yfilter != YFilter.not_set or
                                self.is_virtual_link_passive.yfilter != YFilter.not_set or
                                self.transit_area_id.yfilter != YFilter.not_set or
                                self.virtual_link_authentication_spi.yfilter != YFilter.not_set or
                                self.virtual_link_authentication_transmit.yfilter != YFilter.not_set or
                                self.virtual_link_cost.yfilter != YFilter.not_set or
                                self.virtual_link_dc_bitless_lsa.yfilter != YFilter.not_set or
                                self.virtual_link_dead_interval.yfilter != YFilter.not_set or
                                self.virtual_link_encrypted_authentication_transmitted.yfilter != YFilter.not_set or
                                self.virtual_link_encryption_spi.yfilter != YFilter.not_set or
                                self.virtual_link_encryption_transmitted.yfilter != YFilter.not_set or
                                self.virtual_link_hello_interval.yfilter != YFilter.not_set or
                                self.virtual_link_interface_number.yfilter != YFilter.not_set or
                                self.virtual_link_neighbor_address.yfilter != YFilter.not_set or
                                self.virtual_link_neighbor_id.yfilter != YFilter.not_set or
                                self.virtual_link_next_hello.yfilter != YFilter.not_set or
                                self.virtual_link_retransmission_interval.yfilter != YFilter.not_set or
                                self.virtual_link_state.yfilter != YFilter.not_set or
                                self.virtual_link_wait_interval.yfilter != YFilter.not_set or
                                self.virual_link_transmission_delay.yfilter != YFilter.not_set or
                                (self.virtual_link_neighbor is not None and self.virtual_link_neighbor.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "virtual-link" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.is_virtual_link_authentication_enabled.is_set or self.is_virtual_link_authentication_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_virtual_link_authentication_enabled.get_name_leafdata())
                            if (self.is_virtual_link_demand_circuit.is_set or self.is_virtual_link_demand_circuit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_virtual_link_demand_circuit.get_name_leafdata())
                            if (self.is_virtual_link_encryption_enabled.is_set or self.is_virtual_link_encryption_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_virtual_link_encryption_enabled.get_name_leafdata())
                            if (self.is_virtual_link_ip_security_active.is_set or self.is_virtual_link_ip_security_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_virtual_link_ip_security_active.get_name_leafdata())
                            if (self.is_virtual_link_ip_security_required.is_set or self.is_virtual_link_ip_security_required.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_virtual_link_ip_security_required.get_name_leafdata())
                            if (self.is_virtual_link_passive.is_set or self.is_virtual_link_passive.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_virtual_link_passive.get_name_leafdata())
                            if (self.transit_area_id.is_set or self.transit_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.transit_area_id.get_name_leafdata())
                            if (self.virtual_link_authentication_spi.is_set or self.virtual_link_authentication_spi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_authentication_spi.get_name_leafdata())
                            if (self.virtual_link_authentication_transmit.is_set or self.virtual_link_authentication_transmit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_authentication_transmit.get_name_leafdata())
                            if (self.virtual_link_cost.is_set or self.virtual_link_cost.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_cost.get_name_leafdata())
                            if (self.virtual_link_dc_bitless_lsa.is_set or self.virtual_link_dc_bitless_lsa.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_dc_bitless_lsa.get_name_leafdata())
                            if (self.virtual_link_dead_interval.is_set or self.virtual_link_dead_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_dead_interval.get_name_leafdata())
                            if (self.virtual_link_encrypted_authentication_transmitted.is_set or self.virtual_link_encrypted_authentication_transmitted.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_encrypted_authentication_transmitted.get_name_leafdata())
                            if (self.virtual_link_encryption_spi.is_set or self.virtual_link_encryption_spi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_encryption_spi.get_name_leafdata())
                            if (self.virtual_link_encryption_transmitted.is_set or self.virtual_link_encryption_transmitted.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_encryption_transmitted.get_name_leafdata())
                            if (self.virtual_link_hello_interval.is_set or self.virtual_link_hello_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_hello_interval.get_name_leafdata())
                            if (self.virtual_link_interface_number.is_set or self.virtual_link_interface_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_interface_number.get_name_leafdata())
                            if (self.virtual_link_neighbor_address.is_set or self.virtual_link_neighbor_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_neighbor_address.get_name_leafdata())
                            if (self.virtual_link_neighbor_id.is_set or self.virtual_link_neighbor_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_neighbor_id.get_name_leafdata())
                            if (self.virtual_link_next_hello.is_set or self.virtual_link_next_hello.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_next_hello.get_name_leafdata())
                            if (self.virtual_link_retransmission_interval.is_set or self.virtual_link_retransmission_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_retransmission_interval.get_name_leafdata())
                            if (self.virtual_link_state.is_set or self.virtual_link_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_state.get_name_leafdata())
                            if (self.virtual_link_wait_interval.is_set or self.virtual_link_wait_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_wait_interval.get_name_leafdata())
                            if (self.virual_link_transmission_delay.is_set or self.virual_link_transmission_delay.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virual_link_transmission_delay.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "virtual-link-neighbor"):
                                if (self.virtual_link_neighbor is None):
                                    self.virtual_link_neighbor = Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink.VirtualLinkNeighbor()
                                    self.virtual_link_neighbor.parent = self
                                    self._children_name_map["virtual_link_neighbor"] = "virtual-link-neighbor"
                                return self.virtual_link_neighbor

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "virtual-link-neighbor" or name == "interface-name" or name == "is-virtual-link-authentication-enabled" or name == "is-virtual-link-demand-circuit" or name == "is-virtual-link-encryption-enabled" or name == "is-virtual-link-ip-security-active" or name == "is-virtual-link-ip-security-required" or name == "is-virtual-link-passive" or name == "transit-area-id" or name == "virtual-link-authentication-spi" or name == "virtual-link-authentication-transmit" or name == "virtual-link-cost" or name == "virtual-link-dc-bitless-lsa" or name == "virtual-link-dead-interval" or name == "virtual-link-encrypted-authentication-transmitted" or name == "virtual-link-encryption-spi" or name == "virtual-link-encryption-transmitted" or name == "virtual-link-hello-interval" or name == "virtual-link-interface-number" or name == "virtual-link-neighbor-address" or name == "virtual-link-neighbor-id" or name == "virtual-link-next-hello" or name == "virtual-link-retransmission-interval" or name == "virtual-link-state" or name == "virtual-link-wait-interval" or name == "virual-link-transmission-delay"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-virtual-link-authentication-enabled"):
                                self.is_virtual_link_authentication_enabled = value
                                self.is_virtual_link_authentication_enabled.value_namespace = name_space
                                self.is_virtual_link_authentication_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-virtual-link-demand-circuit"):
                                self.is_virtual_link_demand_circuit = value
                                self.is_virtual_link_demand_circuit.value_namespace = name_space
                                self.is_virtual_link_demand_circuit.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-virtual-link-encryption-enabled"):
                                self.is_virtual_link_encryption_enabled = value
                                self.is_virtual_link_encryption_enabled.value_namespace = name_space
                                self.is_virtual_link_encryption_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-virtual-link-ip-security-active"):
                                self.is_virtual_link_ip_security_active = value
                                self.is_virtual_link_ip_security_active.value_namespace = name_space
                                self.is_virtual_link_ip_security_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-virtual-link-ip-security-required"):
                                self.is_virtual_link_ip_security_required = value
                                self.is_virtual_link_ip_security_required.value_namespace = name_space
                                self.is_virtual_link_ip_security_required.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-virtual-link-passive"):
                                self.is_virtual_link_passive = value
                                self.is_virtual_link_passive.value_namespace = name_space
                                self.is_virtual_link_passive.value_namespace_prefix = name_space_prefix
                            if(value_path == "transit-area-id"):
                                self.transit_area_id = value
                                self.transit_area_id.value_namespace = name_space
                                self.transit_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-authentication-spi"):
                                self.virtual_link_authentication_spi = value
                                self.virtual_link_authentication_spi.value_namespace = name_space
                                self.virtual_link_authentication_spi.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-authentication-transmit"):
                                self.virtual_link_authentication_transmit = value
                                self.virtual_link_authentication_transmit.value_namespace = name_space
                                self.virtual_link_authentication_transmit.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-cost"):
                                self.virtual_link_cost = value
                                self.virtual_link_cost.value_namespace = name_space
                                self.virtual_link_cost.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-dc-bitless-lsa"):
                                self.virtual_link_dc_bitless_lsa = value
                                self.virtual_link_dc_bitless_lsa.value_namespace = name_space
                                self.virtual_link_dc_bitless_lsa.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-dead-interval"):
                                self.virtual_link_dead_interval = value
                                self.virtual_link_dead_interval.value_namespace = name_space
                                self.virtual_link_dead_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-encrypted-authentication-transmitted"):
                                self.virtual_link_encrypted_authentication_transmitted = value
                                self.virtual_link_encrypted_authentication_transmitted.value_namespace = name_space
                                self.virtual_link_encrypted_authentication_transmitted.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-encryption-spi"):
                                self.virtual_link_encryption_spi = value
                                self.virtual_link_encryption_spi.value_namespace = name_space
                                self.virtual_link_encryption_spi.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-encryption-transmitted"):
                                self.virtual_link_encryption_transmitted = value
                                self.virtual_link_encryption_transmitted.value_namespace = name_space
                                self.virtual_link_encryption_transmitted.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-hello-interval"):
                                self.virtual_link_hello_interval = value
                                self.virtual_link_hello_interval.value_namespace = name_space
                                self.virtual_link_hello_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-interface-number"):
                                self.virtual_link_interface_number = value
                                self.virtual_link_interface_number.value_namespace = name_space
                                self.virtual_link_interface_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-neighbor-address"):
                                self.virtual_link_neighbor_address = value
                                self.virtual_link_neighbor_address.value_namespace = name_space
                                self.virtual_link_neighbor_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-neighbor-id"):
                                self.virtual_link_neighbor_id = value
                                self.virtual_link_neighbor_id.value_namespace = name_space
                                self.virtual_link_neighbor_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-next-hello"):
                                self.virtual_link_next_hello = value
                                self.virtual_link_next_hello.value_namespace = name_space
                                self.virtual_link_next_hello.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-retransmission-interval"):
                                self.virtual_link_retransmission_interval = value
                                self.virtual_link_retransmission_interval.value_namespace = name_space
                                self.virtual_link_retransmission_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-state"):
                                self.virtual_link_state = value
                                self.virtual_link_state.value_namespace = name_space
                                self.virtual_link_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-wait-interval"):
                                self.virtual_link_wait_interval = value
                                self.virtual_link_wait_interval.value_namespace = name_space
                                self.virtual_link_wait_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "virual-link-transmission-delay"):
                                self.virual_link_transmission_delay = value
                                self.virual_link_transmission_delay.value_namespace = name_space
                                self.virual_link_transmission_delay.value_namespace_prefix = name_space_prefix


                    class FloodListProcessTable(Entity):
                        """
                        OSPFv3 flood list information table for all
                        areas
                        
                        .. attribute:: flood
                        
                        	OSPFv3 flood list information
                        	**type**\: list of    :py:class:`Flood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable, self).__init__()

                            self.yang_name = "flood-list-process-table"
                            self.yang_parent_name = "vrf"

                            self.flood = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable, self).__setattr__(name, value)


                        class Flood(Entity):
                            """
                            OSPFv3 flood list information
                            
                            .. attribute:: interface_name  <key>
                            
                            	Interface name
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: area_flood
                            
                            	Area scope floodlist
                            	**type**\: list of    :py:class:`AreaFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.AreaFlood>`
                            
                            .. attribute:: as_flood
                            
                            	AS scope floodlist
                            	**type**\: list of    :py:class:`AsFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.AsFlood>`
                            
                            .. attribute:: link_flood
                            
                            	Link floodlist
                            	**type**\: list of    :py:class:`LinkFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.LinkFlood>`
                            
                            .. attribute:: ls_transmission_timer
                            
                            	Time until next LS transmission (ms) 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: queue_length
                            
                            	Number of LSAs currently being flooded 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood, self).__init__()

                                self.yang_name = "flood"
                                self.yang_parent_name = "flood-list-process-table"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.ls_transmission_timer = YLeaf(YType.uint32, "ls-transmission-timer")

                                self.queue_length = YLeaf(YType.uint32, "queue-length")

                                self.area_flood = YList(self)
                                self.as_flood = YList(self)
                                self.link_flood = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "ls_transmission_timer",
                                                "queue_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood, self).__setattr__(name, value)


                            class LinkFlood(Entity):
                                """
                                Link floodlist
                                
                                .. attribute:: header_advertising_router
                                
                                	Router ID of the advertising router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_age
                                
                                	Age of the LSA (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                	**units**\: second
                                
                                .. attribute:: header_lsa_id
                                
                                	LSA ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_type
                                
                                	LSA type
                                	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                
                                .. attribute:: header_sequence_number
                                
                                	Current LSA sequence number
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.LinkFlood, self).__init__()

                                    self.yang_name = "link-flood"
                                    self.yang_parent_name = "flood"

                                    self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                    self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                    self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                    self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                    self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("header_advertising_router",
                                                    "header_lsa_age",
                                                    "header_lsa_id",
                                                    "header_lsa_type",
                                                    "header_sequence_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.LinkFlood, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.LinkFlood, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.header_advertising_router.is_set or
                                        self.header_lsa_age.is_set or
                                        self.header_lsa_id.is_set or
                                        self.header_lsa_type.is_set or
                                        self.header_sequence_number.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.header_advertising_router.yfilter != YFilter.not_set or
                                        self.header_lsa_age.yfilter != YFilter.not_set or
                                        self.header_lsa_id.yfilter != YFilter.not_set or
                                        self.header_lsa_type.yfilter != YFilter.not_set or
                                        self.header_sequence_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "link-flood" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                    if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                    if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                    if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                    if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "header-advertising-router"):
                                        self.header_advertising_router = value
                                        self.header_advertising_router.value_namespace = name_space
                                        self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-age"):
                                        self.header_lsa_age = value
                                        self.header_lsa_age.value_namespace = name_space
                                        self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-id"):
                                        self.header_lsa_id = value
                                        self.header_lsa_id.value_namespace = name_space
                                        self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-type"):
                                        self.header_lsa_type = value
                                        self.header_lsa_type.value_namespace = name_space
                                        self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-sequence-number"):
                                        self.header_sequence_number = value
                                        self.header_sequence_number.value_namespace = name_space
                                        self.header_sequence_number.value_namespace_prefix = name_space_prefix


                            class AreaFlood(Entity):
                                """
                                Area scope floodlist
                                
                                .. attribute:: header_advertising_router
                                
                                	Router ID of the advertising router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_age
                                
                                	Age of the LSA (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                	**units**\: second
                                
                                .. attribute:: header_lsa_id
                                
                                	LSA ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_type
                                
                                	LSA type
                                	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                
                                .. attribute:: header_sequence_number
                                
                                	Current LSA sequence number
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.AreaFlood, self).__init__()

                                    self.yang_name = "area-flood"
                                    self.yang_parent_name = "flood"

                                    self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                    self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                    self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                    self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                    self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("header_advertising_router",
                                                    "header_lsa_age",
                                                    "header_lsa_id",
                                                    "header_lsa_type",
                                                    "header_sequence_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.AreaFlood, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.AreaFlood, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.header_advertising_router.is_set or
                                        self.header_lsa_age.is_set or
                                        self.header_lsa_id.is_set or
                                        self.header_lsa_type.is_set or
                                        self.header_sequence_number.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.header_advertising_router.yfilter != YFilter.not_set or
                                        self.header_lsa_age.yfilter != YFilter.not_set or
                                        self.header_lsa_id.yfilter != YFilter.not_set or
                                        self.header_lsa_type.yfilter != YFilter.not_set or
                                        self.header_sequence_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "area-flood" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                    if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                    if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                    if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                    if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "header-advertising-router"):
                                        self.header_advertising_router = value
                                        self.header_advertising_router.value_namespace = name_space
                                        self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-age"):
                                        self.header_lsa_age = value
                                        self.header_lsa_age.value_namespace = name_space
                                        self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-id"):
                                        self.header_lsa_id = value
                                        self.header_lsa_id.value_namespace = name_space
                                        self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-type"):
                                        self.header_lsa_type = value
                                        self.header_lsa_type.value_namespace = name_space
                                        self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-sequence-number"):
                                        self.header_sequence_number = value
                                        self.header_sequence_number.value_namespace = name_space
                                        self.header_sequence_number.value_namespace_prefix = name_space_prefix


                            class AsFlood(Entity):
                                """
                                AS scope floodlist
                                
                                .. attribute:: header_advertising_router
                                
                                	Router ID of the advertising router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_age
                                
                                	Age of the LSA (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                	**units**\: second
                                
                                .. attribute:: header_lsa_id
                                
                                	LSA ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_type
                                
                                	LSA type
                                	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                
                                .. attribute:: header_sequence_number
                                
                                	Current LSA sequence number
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.AsFlood, self).__init__()

                                    self.yang_name = "as-flood"
                                    self.yang_parent_name = "flood"

                                    self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                    self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                    self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                    self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                    self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("header_advertising_router",
                                                    "header_lsa_age",
                                                    "header_lsa_id",
                                                    "header_lsa_type",
                                                    "header_sequence_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.AsFlood, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.AsFlood, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.header_advertising_router.is_set or
                                        self.header_lsa_age.is_set or
                                        self.header_lsa_id.is_set or
                                        self.header_lsa_type.is_set or
                                        self.header_sequence_number.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.header_advertising_router.yfilter != YFilter.not_set or
                                        self.header_lsa_age.yfilter != YFilter.not_set or
                                        self.header_lsa_id.yfilter != YFilter.not_set or
                                        self.header_lsa_type.yfilter != YFilter.not_set or
                                        self.header_sequence_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "as-flood" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                    if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                    if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                    if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                    if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "header-advertising-router"):
                                        self.header_advertising_router = value
                                        self.header_advertising_router.value_namespace = name_space
                                        self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-age"):
                                        self.header_lsa_age = value
                                        self.header_lsa_age.value_namespace = name_space
                                        self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-id"):
                                        self.header_lsa_id = value
                                        self.header_lsa_id.value_namespace = name_space
                                        self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-type"):
                                        self.header_lsa_type = value
                                        self.header_lsa_type.value_namespace = name_space
                                        self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-sequence-number"):
                                        self.header_sequence_number = value
                                        self.header_sequence_number.value_namespace = name_space
                                        self.header_sequence_number.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.area_flood:
                                    if (c.has_data()):
                                        return True
                                for c in self.as_flood:
                                    if (c.has_data()):
                                        return True
                                for c in self.link_flood:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.interface_name.is_set or
                                    self.ls_transmission_timer.is_set or
                                    self.queue_length.is_set)

                            def has_operation(self):
                                for c in self.area_flood:
                                    if (c.has_operation()):
                                        return True
                                for c in self.as_flood:
                                    if (c.has_operation()):
                                        return True
                                for c in self.link_flood:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.ls_transmission_timer.yfilter != YFilter.not_set or
                                    self.queue_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flood" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.ls_transmission_timer.is_set or self.ls_transmission_timer.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_transmission_timer.get_name_leafdata())
                                if (self.queue_length.is_set or self.queue_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.queue_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "area-flood"):
                                    for c in self.area_flood:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.AreaFlood()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.area_flood.append(c)
                                    return c

                                if (child_yang_name == "as-flood"):
                                    for c in self.as_flood:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.AsFlood()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.as_flood.append(c)
                                    return c

                                if (child_yang_name == "link-flood"):
                                    for c in self.link_flood:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood.LinkFlood()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.link_flood.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "area-flood" or name == "as-flood" or name == "link-flood" or name == "interface-name" or name == "ls-transmission-timer" or name == "queue-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-transmission-timer"):
                                    self.ls_transmission_timer = value
                                    self.ls_transmission_timer.value_namespace = name_space
                                    self.ls_transmission_timer.value_namespace_prefix = name_space_prefix
                                if(value_path == "queue-length"):
                                    self.queue_length = value
                                    self.queue_length.value_namespace = name_space
                                    self.queue_length.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.flood:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.flood:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flood-list-process-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "flood"):
                                for c in self.flood:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable.Flood()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.flood.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flood"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class RouteSummary(Entity):
                        """
                        Summarize OSPFv3 local RIB tables
                        
                        .. attribute:: extern_one_route
                        
                        	Extern 1 route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: extern_two_route
                        
                        	Extern 2 route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: inter_area_route
                        
                        	Inter route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: intra_area_route
                        
                        	Intra route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nssa_one_route
                        
                        	NSSA 1 route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nssa_two_route
                        
                        	NSSA 2 route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: redistribution_route
                        
                        	Redistribution route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: route_connected
                        
                        	Route connected 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: route_id
                        
                        	Route summary of a route ID 
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: total_received_route
                        
                        	Total route received summary
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_sent_route
                        
                        	Total route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.RouteSummary, self).__init__()

                            self.yang_name = "route-summary"
                            self.yang_parent_name = "vrf"

                            self.extern_one_route = YLeaf(YType.uint32, "extern-one-route")

                            self.extern_two_route = YLeaf(YType.uint32, "extern-two-route")

                            self.inter_area_route = YLeaf(YType.uint32, "inter-area-route")

                            self.intra_area_route = YLeaf(YType.uint32, "intra-area-route")

                            self.nssa_one_route = YLeaf(YType.uint32, "nssa-one-route")

                            self.nssa_two_route = YLeaf(YType.uint32, "nssa-two-route")

                            self.redistribution_route = YLeaf(YType.uint32, "redistribution-route")

                            self.route_connected = YLeaf(YType.uint32, "route-connected")

                            self.route_id = YLeaf(YType.str, "route-id")

                            self.total_received_route = YLeaf(YType.uint32, "total-received-route")

                            self.total_sent_route = YLeaf(YType.uint32, "total-sent-route")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("extern_one_route",
                                            "extern_two_route",
                                            "inter_area_route",
                                            "intra_area_route",
                                            "nssa_one_route",
                                            "nssa_two_route",
                                            "redistribution_route",
                                            "route_connected",
                                            "route_id",
                                            "total_received_route",
                                            "total_sent_route") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.RouteSummary, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.RouteSummary, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.extern_one_route.is_set or
                                self.extern_two_route.is_set or
                                self.inter_area_route.is_set or
                                self.intra_area_route.is_set or
                                self.nssa_one_route.is_set or
                                self.nssa_two_route.is_set or
                                self.redistribution_route.is_set or
                                self.route_connected.is_set or
                                self.route_id.is_set or
                                self.total_received_route.is_set or
                                self.total_sent_route.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.extern_one_route.yfilter != YFilter.not_set or
                                self.extern_two_route.yfilter != YFilter.not_set or
                                self.inter_area_route.yfilter != YFilter.not_set or
                                self.intra_area_route.yfilter != YFilter.not_set or
                                self.nssa_one_route.yfilter != YFilter.not_set or
                                self.nssa_two_route.yfilter != YFilter.not_set or
                                self.redistribution_route.yfilter != YFilter.not_set or
                                self.route_connected.yfilter != YFilter.not_set or
                                self.route_id.yfilter != YFilter.not_set or
                                self.total_received_route.yfilter != YFilter.not_set or
                                self.total_sent_route.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "route-summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.extern_one_route.is_set or self.extern_one_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.extern_one_route.get_name_leafdata())
                            if (self.extern_two_route.is_set or self.extern_two_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.extern_two_route.get_name_leafdata())
                            if (self.inter_area_route.is_set or self.inter_area_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.inter_area_route.get_name_leafdata())
                            if (self.intra_area_route.is_set or self.intra_area_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.intra_area_route.get_name_leafdata())
                            if (self.nssa_one_route.is_set or self.nssa_one_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nssa_one_route.get_name_leafdata())
                            if (self.nssa_two_route.is_set or self.nssa_two_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nssa_two_route.get_name_leafdata())
                            if (self.redistribution_route.is_set or self.redistribution_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.redistribution_route.get_name_leafdata())
                            if (self.route_connected.is_set or self.route_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.route_connected.get_name_leafdata())
                            if (self.route_id.is_set or self.route_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.route_id.get_name_leafdata())
                            if (self.total_received_route.is_set or self.total_received_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_received_route.get_name_leafdata())
                            if (self.total_sent_route.is_set or self.total_sent_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_sent_route.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "extern-one-route" or name == "extern-two-route" or name == "inter-area-route" or name == "intra-area-route" or name == "nssa-one-route" or name == "nssa-two-route" or name == "redistribution-route" or name == "route-connected" or name == "route-id" or name == "total-received-route" or name == "total-sent-route"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "extern-one-route"):
                                self.extern_one_route = value
                                self.extern_one_route.value_namespace = name_space
                                self.extern_one_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "extern-two-route"):
                                self.extern_two_route = value
                                self.extern_two_route.value_namespace = name_space
                                self.extern_two_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "inter-area-route"):
                                self.inter_area_route = value
                                self.inter_area_route.value_namespace = name_space
                                self.inter_area_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "intra-area-route"):
                                self.intra_area_route = value
                                self.intra_area_route.value_namespace = name_space
                                self.intra_area_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "nssa-one-route"):
                                self.nssa_one_route = value
                                self.nssa_one_route.value_namespace = name_space
                                self.nssa_one_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "nssa-two-route"):
                                self.nssa_two_route = value
                                self.nssa_two_route.value_namespace = name_space
                                self.nssa_two_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "redistribution-route"):
                                self.redistribution_route = value
                                self.redistribution_route.value_namespace = name_space
                                self.redistribution_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "route-connected"):
                                self.route_connected = value
                                self.route_connected.value_namespace = name_space
                                self.route_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "route-id"):
                                self.route_id = value
                                self.route_id.value_namespace = name_space
                                self.route_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-received-route"):
                                self.total_received_route = value
                                self.total_received_route.value_namespace = name_space
                                self.total_received_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-sent-route"):
                                self.total_sent_route = value
                                self.total_sent_route.value_namespace = name_space
                                self.total_sent_route.value_namespace_prefix = name_space_prefix


                    class Areas(Entity):
                        """
                        OSPFv3 area table
                        
                        .. attribute:: area
                        
                        	Per\-area information
                        	**type**\: list of    :py:class:`Area <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas, self).__init__()

                            self.yang_name = "areas"
                            self.yang_parent_name = "vrf"

                            self.area = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas, self).__setattr__(name, value)


                        class Area(Entity):
                            """
                            Per\-area information
                            
                            .. attribute:: area_id  <key>
                            
                            	Area ID
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: database_summary_table
                            
                            	Database summary table
                            	**type**\:   :py:class:`DatabaseSummaryTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable>`
                            
                            .. attribute:: database_table
                            
                            	OSPF Link State Database
                            	**type**\:   :py:class:`DatabaseTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable>`
                            
                            .. attribute:: flood_list_table
                            
                            	OSPFv3 flood list information table for an area
                            	**type**\:   :py:class:`FloodListTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable>`
                            
                            .. attribute:: interface_brief_table
                            
                            	OSPFv3 interface brief information table for an area
                            	**type**\:   :py:class:`InterfaceBriefTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable>`
                            
                            .. attribute:: interface_table
                            
                            	OSPFv3 interface information table for an area
                            	**type**\:   :py:class:`InterfaceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable>`
                            
                            .. attribute:: neighbor_detail_table
                            
                            	OSPFv3 area neighbor information table
                            	**type**\:   :py:class:`NeighborDetailTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable>`
                            
                            .. attribute:: neighbor_table
                            
                            	OSPFv3 neighbor information table
                            	**type**\:   :py:class:`NeighborTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable>`
                            
                            .. attribute:: request_list_table
                            
                            	OSPFv3 request list information in an area
                            	**type**\:   :py:class:`RequestListTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable>`
                            
                            .. attribute:: retransmission_list_table
                            
                            	OSPFv3 retransmission list information table in an area
                            	**type**\:   :py:class:`RetransmissionListTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area, self).__init__()

                                self.yang_name = "area"
                                self.yang_parent_name = "areas"

                                self.area_id = YLeaf(YType.int32, "area-id")

                                self.database_summary_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable()
                                self.database_summary_table.parent = self
                                self._children_name_map["database_summary_table"] = "database-summary-table"
                                self._children_yang_names.add("database-summary-table")

                                self.database_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable()
                                self.database_table.parent = self
                                self._children_name_map["database_table"] = "database-table"
                                self._children_yang_names.add("database-table")

                                self.flood_list_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable()
                                self.flood_list_table.parent = self
                                self._children_name_map["flood_list_table"] = "flood-list-table"
                                self._children_yang_names.add("flood-list-table")

                                self.interface_brief_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable()
                                self.interface_brief_table.parent = self
                                self._children_name_map["interface_brief_table"] = "interface-brief-table"
                                self._children_yang_names.add("interface-brief-table")

                                self.interface_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable()
                                self.interface_table.parent = self
                                self._children_name_map["interface_table"] = "interface-table"
                                self._children_yang_names.add("interface-table")

                                self.neighbor_detail_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable()
                                self.neighbor_detail_table.parent = self
                                self._children_name_map["neighbor_detail_table"] = "neighbor-detail-table"
                                self._children_yang_names.add("neighbor-detail-table")

                                self.neighbor_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable()
                                self.neighbor_table.parent = self
                                self._children_name_map["neighbor_table"] = "neighbor-table"
                                self._children_yang_names.add("neighbor-table")

                                self.request_list_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable()
                                self.request_list_table.parent = self
                                self._children_name_map["request_list_table"] = "request-list-table"
                                self._children_yang_names.add("request-list-table")

                                self.retransmission_list_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable()
                                self.retransmission_list_table.parent = self
                                self._children_name_map["retransmission_list_table"] = "retransmission-list-table"
                                self._children_yang_names.add("retransmission-list-table")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("area_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area, self).__setattr__(name, value)


                            class NeighborDetailTable(Entity):
                                """
                                OSPFv3 area neighbor information table
                                
                                .. attribute:: neighbor_detail
                                
                                	OSPFv3 neighbor detail information
                                	**type**\: list of    :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable, self).__init__()

                                    self.yang_name = "neighbor-detail-table"
                                    self.yang_parent_name = "area"

                                    self.neighbor_detail = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable, self).__setattr__(name, value)


                                class NeighborDetail(Entity):
                                    """
                                    OSPFv3 neighbor detail information
                                    
                                    .. attribute:: interface_name
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_neighbor_sham_link
                                    
                                    	If true, neighbor is on a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_neighbor_virtual_link
                                    
                                    	If true, neighbor is on a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: neighbor_address
                                    
                                    	Neighbor ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: neighbor_address_xr
                                    
                                    	Neighbor IP Address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: neighbor_bfd_info
                                    
                                    	Neighbor BFD information
                                    	**type**\:   :py:class:`NeighborBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo>`
                                    
                                    .. attribute:: neighbor_dead_timer
                                    
                                    	Time until neighbor's dead timer expires (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: neighbor_designated_router
                                    
                                    	Designated router 
                                    	**type**\:  str
                                    
                                    	**length:** 0..9
                                    
                                    .. attribute:: neighbor_detail
                                    
                                    	Detailed OSPFv3 neighbor information 
                                    	**type**\:   :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail>`
                                    
                                    .. attribute:: neighbor_dr_priority
                                    
                                    	Neighbor's DR priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: neighbor_interface_id
                                    
                                    	Neighbor interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_sham_link_id
                                    
                                    	Neighbor sham link id 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_state
                                    
                                    	Neighbor's state
                                    	**type**\:   :py:class:`Ospfv3NeighborState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3NeighborState>`
                                    
                                    .. attribute:: neighbor_up_time
                                    
                                    	Amount of time since the adjacency is up (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: neighbor_virtual_link_id
                                    
                                    	Neighbor virtual link id 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail, self).__init__()

                                        self.yang_name = "neighbor-detail"
                                        self.yang_parent_name = "neighbor-detail-table"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_neighbor_sham_link = YLeaf(YType.boolean, "is-neighbor-sham-link")

                                        self.is_neighbor_virtual_link = YLeaf(YType.boolean, "is-neighbor-virtual-link")

                                        self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                        self.neighbor_address_xr = YLeaf(YType.str, "neighbor-address-xr")

                                        self.neighbor_dead_timer = YLeaf(YType.uint32, "neighbor-dead-timer")

                                        self.neighbor_designated_router = YLeaf(YType.str, "neighbor-designated-router")

                                        self.neighbor_dr_priority = YLeaf(YType.uint8, "neighbor-dr-priority")

                                        self.neighbor_interface_id = YLeaf(YType.uint32, "neighbor-interface-id")

                                        self.neighbor_sham_link_id = YLeaf(YType.uint32, "neighbor-sham-link-id")

                                        self.neighbor_state = YLeaf(YType.enumeration, "neighbor-state")

                                        self.neighbor_up_time = YLeaf(YType.uint32, "neighbor-up-time")

                                        self.neighbor_virtual_link_id = YLeaf(YType.uint32, "neighbor-virtual-link-id")

                                        self.neighbor_bfd_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo()
                                        self.neighbor_bfd_info.parent = self
                                        self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                        self._children_yang_names.add("neighbor-bfd-info")

                                        self.neighbor_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail()
                                        self.neighbor_detail.parent = self
                                        self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                        self._children_yang_names.add("neighbor-detail")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_neighbor_sham_link",
                                                        "is_neighbor_virtual_link",
                                                        "neighbor_address",
                                                        "neighbor_address_xr",
                                                        "neighbor_dead_timer",
                                                        "neighbor_designated_router",
                                                        "neighbor_dr_priority",
                                                        "neighbor_interface_id",
                                                        "neighbor_sham_link_id",
                                                        "neighbor_state",
                                                        "neighbor_up_time",
                                                        "neighbor_virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail, self).__setattr__(name, value)


                                    class NeighborDetail(Entity):
                                        """
                                        Detailed OSPFv3 neighbor information 
                                        
                                        .. attribute:: interface_type
                                        
                                        	Interface type
                                        	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                                        
                                        .. attribute:: is_neighbor_filtered
                                        
                                        	If true, filter outgoing LSAs 
                                        	**type**\:  bool
                                        
                                        .. attribute:: neighbor_backup_designated_router_address
                                        
                                        	Address of backup designated router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: neighbor_cost
                                        
                                        	Cost of path to this neighbor 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: neighbor_designated_router_address
                                        
                                        	Address of designated router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: neighbor_ignore_timer
                                        
                                        	Remaining time when ignore timer is running 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: neighbor_option
                                        
                                        	 This is bitmask of neighbor's option field received 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: neighbor_retransmission
                                        
                                        	Retransmission information with this neighbor
                                        	**type**\:   :py:class:`NeighborRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission>`
                                        
                                        .. attribute:: next_poll_interval
                                        
                                        	For NBMA networks, amount of time remaining in seconds before the next poll interval expires and Hello is sent (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: pending_events
                                        
                                        	Number of pending events 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: poll_interval
                                        
                                        	Poll interval (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state_changes
                                        
                                        	Number of state changes 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail, self).__init__()

                                            self.yang_name = "neighbor-detail"
                                            self.yang_parent_name = "neighbor-detail"

                                            self.interface_type = YLeaf(YType.enumeration, "interface-type")

                                            self.is_neighbor_filtered = YLeaf(YType.boolean, "is-neighbor-filtered")

                                            self.neighbor_backup_designated_router_address = YLeaf(YType.str, "neighbor-backup-designated-router-address")

                                            self.neighbor_cost = YLeaf(YType.uint16, "neighbor-cost")

                                            self.neighbor_designated_router_address = YLeaf(YType.str, "neighbor-designated-router-address")

                                            self.neighbor_ignore_timer = YLeaf(YType.uint32, "neighbor-ignore-timer")

                                            self.neighbor_option = YLeaf(YType.uint32, "neighbor-option")

                                            self.next_poll_interval = YLeaf(YType.uint32, "next-poll-interval")

                                            self.pending_events = YLeaf(YType.uint16, "pending-events")

                                            self.poll_interval = YLeaf(YType.uint32, "poll-interval")

                                            self.state_changes = YLeaf(YType.uint16, "state-changes")

                                            self.neighbor_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission()
                                            self.neighbor_retransmission.parent = self
                                            self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                            self._children_yang_names.add("neighbor-retransmission")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_type",
                                                            "is_neighbor_filtered",
                                                            "neighbor_backup_designated_router_address",
                                                            "neighbor_cost",
                                                            "neighbor_designated_router_address",
                                                            "neighbor_ignore_timer",
                                                            "neighbor_option",
                                                            "next_poll_interval",
                                                            "pending_events",
                                                            "poll_interval",
                                                            "state_changes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail, self).__setattr__(name, value)


                                        class NeighborRetransmission(Entity):
                                            """
                                            Retransmission information with this neighbor
                                            
                                            .. attribute:: area_first_flood
                                            
                                            	First flood item for area scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: area_first_flood_index
                                            
                                            	Index of the first flood item for area scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: area_flood_index
                                            
                                            	Area scope LSA's flood index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: area_next_flood
                                            
                                            	Next flood item for area scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: area_next_flood_index
                                            
                                            	Index of next flood item for Area scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: as_first_flood
                                            
                                            	First flood item for AS scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: as_first_flood_index
                                            
                                            	Index for first flood item for AS scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: as_flood_index
                                            
                                            	AS scope LSA's flood index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: as_next_flood
                                            
                                            	Next flood item for AS scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: as_next_flood_index
                                            
                                            	Index of next flood item for AS scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: database_descriptor_retransmissions
                                            
                                            	Number of database descriptor retransmissions during last exchange
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: last_retransmission_length
                                            
                                            	Number of LSAs sent in last retransmission
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: last_retransmission_time
                                            
                                            	Last retransmission scan time (ms)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_first_flood
                                            
                                            	Link first flood information 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_first_flood_index
                                            
                                            	Link first flood information index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_flood_index
                                            
                                            	Link flood index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_next_flood
                                            
                                            	Link next flood information 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_next_flood_index
                                            
                                            	Link next flood information index 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_retransmission_timer
                                            
                                            	Time until next LSA retransmission (ms)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: maximum_retransmission_length
                                            
                                            	Maximum number of LSAs sent in a retransmission
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: maximum_retransmission_time
                                            
                                            	Maximum retransmission scan time (ms)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: neighbor_retransmissions
                                            
                                            	Number of neighbor retransmissions 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: retransmissions
                                            
                                            	Number of retransmissions for this neighbor
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__init__()

                                                self.yang_name = "neighbor-retransmission"
                                                self.yang_parent_name = "neighbor-detail"

                                                self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                                self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                                self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                                self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                                self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                                self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                                self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                                self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                                self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                                self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                                self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                                self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                                self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                                self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                                self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                                self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                                self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                                self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                                self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                                self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                                self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                                self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                                self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("area_first_flood",
                                                                "area_first_flood_index",
                                                                "area_flood_index",
                                                                "area_next_flood",
                                                                "area_next_flood_index",
                                                                "as_first_flood",
                                                                "as_first_flood_index",
                                                                "as_flood_index",
                                                                "as_next_flood",
                                                                "as_next_flood_index",
                                                                "database_descriptor_retransmissions",
                                                                "last_retransmission_length",
                                                                "last_retransmission_time",
                                                                "link_first_flood",
                                                                "link_first_flood_index",
                                                                "link_flood_index",
                                                                "link_next_flood",
                                                                "link_next_flood_index",
                                                                "lsa_retransmission_timer",
                                                                "maximum_retransmission_length",
                                                                "maximum_retransmission_time",
                                                                "neighbor_retransmissions",
                                                                "retransmissions") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.area_first_flood.is_set or
                                                    self.area_first_flood_index.is_set or
                                                    self.area_flood_index.is_set or
                                                    self.area_next_flood.is_set or
                                                    self.area_next_flood_index.is_set or
                                                    self.as_first_flood.is_set or
                                                    self.as_first_flood_index.is_set or
                                                    self.as_flood_index.is_set or
                                                    self.as_next_flood.is_set or
                                                    self.as_next_flood_index.is_set or
                                                    self.database_descriptor_retransmissions.is_set or
                                                    self.last_retransmission_length.is_set or
                                                    self.last_retransmission_time.is_set or
                                                    self.link_first_flood.is_set or
                                                    self.link_first_flood_index.is_set or
                                                    self.link_flood_index.is_set or
                                                    self.link_next_flood.is_set or
                                                    self.link_next_flood_index.is_set or
                                                    self.lsa_retransmission_timer.is_set or
                                                    self.maximum_retransmission_length.is_set or
                                                    self.maximum_retransmission_time.is_set or
                                                    self.neighbor_retransmissions.is_set or
                                                    self.retransmissions.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.area_first_flood.yfilter != YFilter.not_set or
                                                    self.area_first_flood_index.yfilter != YFilter.not_set or
                                                    self.area_flood_index.yfilter != YFilter.not_set or
                                                    self.area_next_flood.yfilter != YFilter.not_set or
                                                    self.area_next_flood_index.yfilter != YFilter.not_set or
                                                    self.as_first_flood.yfilter != YFilter.not_set or
                                                    self.as_first_flood_index.yfilter != YFilter.not_set or
                                                    self.as_flood_index.yfilter != YFilter.not_set or
                                                    self.as_next_flood.yfilter != YFilter.not_set or
                                                    self.as_next_flood_index.yfilter != YFilter.not_set or
                                                    self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                                    self.last_retransmission_length.yfilter != YFilter.not_set or
                                                    self.last_retransmission_time.yfilter != YFilter.not_set or
                                                    self.link_first_flood.yfilter != YFilter.not_set or
                                                    self.link_first_flood_index.yfilter != YFilter.not_set or
                                                    self.link_flood_index.yfilter != YFilter.not_set or
                                                    self.link_next_flood.yfilter != YFilter.not_set or
                                                    self.link_next_flood_index.yfilter != YFilter.not_set or
                                                    self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                                    self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                                    self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                                    self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                                    self.retransmissions.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "neighbor-retransmission" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                                if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                                if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                                if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                                if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                                if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                                if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                                if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                                if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                                if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                                if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                                if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                                if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                                if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                                if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                                if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                                if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                                if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                                if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                                if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                                if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                                if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                                if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "area-first-flood"):
                                                    self.area_first_flood = value
                                                    self.area_first_flood.value_namespace = name_space
                                                    self.area_first_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "area-first-flood-index"):
                                                    self.area_first_flood_index = value
                                                    self.area_first_flood_index.value_namespace = name_space
                                                    self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "area-flood-index"):
                                                    self.area_flood_index = value
                                                    self.area_flood_index.value_namespace = name_space
                                                    self.area_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "area-next-flood"):
                                                    self.area_next_flood = value
                                                    self.area_next_flood.value_namespace = name_space
                                                    self.area_next_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "area-next-flood-index"):
                                                    self.area_next_flood_index = value
                                                    self.area_next_flood_index.value_namespace = name_space
                                                    self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "as-first-flood"):
                                                    self.as_first_flood = value
                                                    self.as_first_flood.value_namespace = name_space
                                                    self.as_first_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "as-first-flood-index"):
                                                    self.as_first_flood_index = value
                                                    self.as_first_flood_index.value_namespace = name_space
                                                    self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "as-flood-index"):
                                                    self.as_flood_index = value
                                                    self.as_flood_index.value_namespace = name_space
                                                    self.as_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "as-next-flood"):
                                                    self.as_next_flood = value
                                                    self.as_next_flood.value_namespace = name_space
                                                    self.as_next_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "as-next-flood-index"):
                                                    self.as_next_flood_index = value
                                                    self.as_next_flood_index.value_namespace = name_space
                                                    self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "database-descriptor-retransmissions"):
                                                    self.database_descriptor_retransmissions = value
                                                    self.database_descriptor_retransmissions.value_namespace = name_space
                                                    self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-retransmission-length"):
                                                    self.last_retransmission_length = value
                                                    self.last_retransmission_length.value_namespace = name_space
                                                    self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-retransmission-time"):
                                                    self.last_retransmission_time = value
                                                    self.last_retransmission_time.value_namespace = name_space
                                                    self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-first-flood"):
                                                    self.link_first_flood = value
                                                    self.link_first_flood.value_namespace = name_space
                                                    self.link_first_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-first-flood-index"):
                                                    self.link_first_flood_index = value
                                                    self.link_first_flood_index.value_namespace = name_space
                                                    self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-flood-index"):
                                                    self.link_flood_index = value
                                                    self.link_flood_index.value_namespace = name_space
                                                    self.link_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-next-flood"):
                                                    self.link_next_flood = value
                                                    self.link_next_flood.value_namespace = name_space
                                                    self.link_next_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-next-flood-index"):
                                                    self.link_next_flood_index = value
                                                    self.link_next_flood_index.value_namespace = name_space
                                                    self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-retransmission-timer"):
                                                    self.lsa_retransmission_timer = value
                                                    self.lsa_retransmission_timer.value_namespace = name_space
                                                    self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                                if(value_path == "maximum-retransmission-length"):
                                                    self.maximum_retransmission_length = value
                                                    self.maximum_retransmission_length.value_namespace = name_space
                                                    self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "maximum-retransmission-time"):
                                                    self.maximum_retransmission_time = value
                                                    self.maximum_retransmission_time.value_namespace = name_space
                                                    self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-retransmissions"):
                                                    self.neighbor_retransmissions = value
                                                    self.neighbor_retransmissions.value_namespace = name_space
                                                    self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                                if(value_path == "retransmissions"):
                                                    self.retransmissions = value
                                                    self.retransmissions.value_namespace = name_space
                                                    self.retransmissions.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_type.is_set or
                                                self.is_neighbor_filtered.is_set or
                                                self.neighbor_backup_designated_router_address.is_set or
                                                self.neighbor_cost.is_set or
                                                self.neighbor_designated_router_address.is_set or
                                                self.neighbor_ignore_timer.is_set or
                                                self.neighbor_option.is_set or
                                                self.next_poll_interval.is_set or
                                                self.pending_events.is_set or
                                                self.poll_interval.is_set or
                                                self.state_changes.is_set or
                                                (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_type.yfilter != YFilter.not_set or
                                                self.is_neighbor_filtered.yfilter != YFilter.not_set or
                                                self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set or
                                                self.neighbor_cost.yfilter != YFilter.not_set or
                                                self.neighbor_designated_router_address.yfilter != YFilter.not_set or
                                                self.neighbor_ignore_timer.yfilter != YFilter.not_set or
                                                self.neighbor_option.yfilter != YFilter.not_set or
                                                self.next_poll_interval.yfilter != YFilter.not_set or
                                                self.pending_events.yfilter != YFilter.not_set or
                                                self.poll_interval.yfilter != YFilter.not_set or
                                                self.state_changes.yfilter != YFilter.not_set or
                                                (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "neighbor-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_type.is_set or self.interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_type.get_name_leafdata())
                                            if (self.is_neighbor_filtered.is_set or self.is_neighbor_filtered.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_filtered.get_name_leafdata())
                                            if (self.neighbor_backup_designated_router_address.is_set or self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_backup_designated_router_address.get_name_leafdata())
                                            if (self.neighbor_cost.is_set or self.neighbor_cost.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_cost.get_name_leafdata())
                                            if (self.neighbor_designated_router_address.is_set or self.neighbor_designated_router_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_designated_router_address.get_name_leafdata())
                                            if (self.neighbor_ignore_timer.is_set or self.neighbor_ignore_timer.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_ignore_timer.get_name_leafdata())
                                            if (self.neighbor_option.is_set or self.neighbor_option.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_option.get_name_leafdata())
                                            if (self.next_poll_interval.is_set or self.next_poll_interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_poll_interval.get_name_leafdata())
                                            if (self.pending_events.is_set or self.pending_events.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pending_events.get_name_leafdata())
                                            if (self.poll_interval.is_set or self.poll_interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.poll_interval.get_name_leafdata())
                                            if (self.state_changes.is_set or self.state_changes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_changes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "neighbor-retransmission"):
                                                if (self.neighbor_retransmission is None):
                                                    self.neighbor_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission()
                                                    self.neighbor_retransmission.parent = self
                                                    self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                                return self.neighbor_retransmission

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "neighbor-retransmission" or name == "interface-type" or name == "is-neighbor-filtered" or name == "neighbor-backup-designated-router-address" or name == "neighbor-cost" or name == "neighbor-designated-router-address" or name == "neighbor-ignore-timer" or name == "neighbor-option" or name == "next-poll-interval" or name == "pending-events" or name == "poll-interval" or name == "state-changes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-type"):
                                                self.interface_type = value
                                                self.interface_type.value_namespace = name_space
                                                self.interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-filtered"):
                                                self.is_neighbor_filtered = value
                                                self.is_neighbor_filtered.value_namespace = name_space
                                                self.is_neighbor_filtered.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-backup-designated-router-address"):
                                                self.neighbor_backup_designated_router_address = value
                                                self.neighbor_backup_designated_router_address.value_namespace = name_space
                                                self.neighbor_backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-cost"):
                                                self.neighbor_cost = value
                                                self.neighbor_cost.value_namespace = name_space
                                                self.neighbor_cost.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-designated-router-address"):
                                                self.neighbor_designated_router_address = value
                                                self.neighbor_designated_router_address.value_namespace = name_space
                                                self.neighbor_designated_router_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-ignore-timer"):
                                                self.neighbor_ignore_timer = value
                                                self.neighbor_ignore_timer.value_namespace = name_space
                                                self.neighbor_ignore_timer.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-option"):
                                                self.neighbor_option = value
                                                self.neighbor_option.value_namespace = name_space
                                                self.neighbor_option.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-poll-interval"):
                                                self.next_poll_interval = value
                                                self.next_poll_interval.value_namespace = name_space
                                                self.next_poll_interval.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pending-events"):
                                                self.pending_events = value
                                                self.pending_events.value_namespace = name_space
                                                self.pending_events.value_namespace_prefix = name_space_prefix
                                            if(value_path == "poll-interval"):
                                                self.poll_interval = value
                                                self.poll_interval.value_namespace = name_space
                                                self.poll_interval.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-changes"):
                                                self.state_changes = value
                                                self.state_changes.value_namespace = name_space
                                                self.state_changes.value_namespace_prefix = name_space_prefix


                                    class NeighborBfdInfo(Entity):
                                        """
                                        Neighbor BFD information
                                        
                                        .. attribute:: bfd_intf_enable_mode
                                        
                                        	BFD enable mode \- Default/Strict
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: bfd_status_flag
                                        
                                        	Status of the BFD Session
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo, self).__init__()

                                            self.yang_name = "neighbor-bfd-info"
                                            self.yang_parent_name = "neighbor-detail"

                                            self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                            self.bfd_status_flag = YLeaf(YType.uint8, "bfd-status-flag")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bfd_intf_enable_mode",
                                                            "bfd_status_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bfd_intf_enable_mode.is_set or
                                                self.bfd_status_flag.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bfd_intf_enable_mode.yfilter != YFilter.not_set or
                                                self.bfd_status_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "neighbor-bfd-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())
                                            if (self.bfd_status_flag.is_set or self.bfd_status_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bfd_status_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bfd-intf-enable-mode" or name == "bfd-status-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bfd-intf-enable-mode"):
                                                self.bfd_intf_enable_mode = value
                                                self.bfd_intf_enable_mode.value_namespace = name_space
                                                self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bfd-status-flag"):
                                                self.bfd_status_flag = value
                                                self.bfd_status_flag.value_namespace = name_space
                                                self.bfd_status_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_neighbor_sham_link.is_set or
                                            self.is_neighbor_virtual_link.is_set or
                                            self.neighbor_address.is_set or
                                            self.neighbor_address_xr.is_set or
                                            self.neighbor_dead_timer.is_set or
                                            self.neighbor_designated_router.is_set or
                                            self.neighbor_dr_priority.is_set or
                                            self.neighbor_interface_id.is_set or
                                            self.neighbor_sham_link_id.is_set or
                                            self.neighbor_state.is_set or
                                            self.neighbor_up_time.is_set or
                                            self.neighbor_virtual_link_id.is_set or
                                            (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_data()) or
                                            (self.neighbor_detail is not None and self.neighbor_detail.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_neighbor_sham_link.yfilter != YFilter.not_set or
                                            self.is_neighbor_virtual_link.yfilter != YFilter.not_set or
                                            self.neighbor_address.yfilter != YFilter.not_set or
                                            self.neighbor_address_xr.yfilter != YFilter.not_set or
                                            self.neighbor_dead_timer.yfilter != YFilter.not_set or
                                            self.neighbor_designated_router.yfilter != YFilter.not_set or
                                            self.neighbor_dr_priority.yfilter != YFilter.not_set or
                                            self.neighbor_interface_id.yfilter != YFilter.not_set or
                                            self.neighbor_sham_link_id.yfilter != YFilter.not_set or
                                            self.neighbor_state.yfilter != YFilter.not_set or
                                            self.neighbor_up_time.yfilter != YFilter.not_set or
                                            self.neighbor_virtual_link_id.yfilter != YFilter.not_set or
                                            (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_operation()) or
                                            (self.neighbor_detail is not None and self.neighbor_detail.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "neighbor-detail" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_neighbor_sham_link.is_set or self.is_neighbor_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_neighbor_sham_link.get_name_leafdata())
                                        if (self.is_neighbor_virtual_link.is_set or self.is_neighbor_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_neighbor_virtual_link.get_name_leafdata())
                                        if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                        if (self.neighbor_address_xr.is_set or self.neighbor_address_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_address_xr.get_name_leafdata())
                                        if (self.neighbor_dead_timer.is_set or self.neighbor_dead_timer.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_dead_timer.get_name_leafdata())
                                        if (self.neighbor_designated_router.is_set or self.neighbor_designated_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_designated_router.get_name_leafdata())
                                        if (self.neighbor_dr_priority.is_set or self.neighbor_dr_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_dr_priority.get_name_leafdata())
                                        if (self.neighbor_interface_id.is_set or self.neighbor_interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_interface_id.get_name_leafdata())
                                        if (self.neighbor_sham_link_id.is_set or self.neighbor_sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_sham_link_id.get_name_leafdata())
                                        if (self.neighbor_state.is_set or self.neighbor_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_state.get_name_leafdata())
                                        if (self.neighbor_up_time.is_set or self.neighbor_up_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_up_time.get_name_leafdata())
                                        if (self.neighbor_virtual_link_id.is_set or self.neighbor_virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "neighbor-bfd-info"):
                                            if (self.neighbor_bfd_info is None):
                                                self.neighbor_bfd_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo()
                                                self.neighbor_bfd_info.parent = self
                                                self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                            return self.neighbor_bfd_info

                                        if (child_yang_name == "neighbor-detail"):
                                            if (self.neighbor_detail is None):
                                                self.neighbor_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail()
                                                self.neighbor_detail.parent = self
                                                self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                            return self.neighbor_detail

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "neighbor-bfd-info" or name == "neighbor-detail" or name == "interface-name" or name == "is-neighbor-sham-link" or name == "is-neighbor-virtual-link" or name == "neighbor-address" or name == "neighbor-address-xr" or name == "neighbor-dead-timer" or name == "neighbor-designated-router" or name == "neighbor-dr-priority" or name == "neighbor-interface-id" or name == "neighbor-sham-link-id" or name == "neighbor-state" or name == "neighbor-up-time" or name == "neighbor-virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-neighbor-sham-link"):
                                            self.is_neighbor_sham_link = value
                                            self.is_neighbor_sham_link.value_namespace = name_space
                                            self.is_neighbor_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-neighbor-virtual-link"):
                                            self.is_neighbor_virtual_link = value
                                            self.is_neighbor_virtual_link.value_namespace = name_space
                                            self.is_neighbor_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-address"):
                                            self.neighbor_address = value
                                            self.neighbor_address.value_namespace = name_space
                                            self.neighbor_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-address-xr"):
                                            self.neighbor_address_xr = value
                                            self.neighbor_address_xr.value_namespace = name_space
                                            self.neighbor_address_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-dead-timer"):
                                            self.neighbor_dead_timer = value
                                            self.neighbor_dead_timer.value_namespace = name_space
                                            self.neighbor_dead_timer.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-designated-router"):
                                            self.neighbor_designated_router = value
                                            self.neighbor_designated_router.value_namespace = name_space
                                            self.neighbor_designated_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-dr-priority"):
                                            self.neighbor_dr_priority = value
                                            self.neighbor_dr_priority.value_namespace = name_space
                                            self.neighbor_dr_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-interface-id"):
                                            self.neighbor_interface_id = value
                                            self.neighbor_interface_id.value_namespace = name_space
                                            self.neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-sham-link-id"):
                                            self.neighbor_sham_link_id = value
                                            self.neighbor_sham_link_id.value_namespace = name_space
                                            self.neighbor_sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-state"):
                                            self.neighbor_state = value
                                            self.neighbor_state.value_namespace = name_space
                                            self.neighbor_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-up-time"):
                                            self.neighbor_up_time = value
                                            self.neighbor_up_time.value_namespace = name_space
                                            self.neighbor_up_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-virtual-link-id"):
                                            self.neighbor_virtual_link_id = value
                                            self.neighbor_virtual_link_id.value_namespace = name_space
                                            self.neighbor_virtual_link_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.neighbor_detail:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.neighbor_detail:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "neighbor-detail-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "neighbor-detail"):
                                        for c in self.neighbor_detail:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable.NeighborDetail()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.neighbor_detail.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "neighbor-detail"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class InterfaceBriefTable(Entity):
                                """
                                OSPFv3 interface brief information table for
                                an area
                                
                                .. attribute:: interface_brief
                                
                                	Interface brief information
                                	**type**\: list of    :py:class:`InterfaceBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable.InterfaceBrief>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable, self).__init__()

                                    self.yang_name = "interface-brief-table"
                                    self.yang_parent_name = "area"

                                    self.interface_brief = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable, self).__setattr__(name, value)


                                class InterfaceBrief(Entity):
                                    """
                                    Interface brief information
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_address
                                    
                                    	Interface IP address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: interface_adjacent_neighbors
                                    
                                    	Total number of adjacent neighbors
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: interface_link_cost
                                    
                                    	Interface link cost
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: interface_neighbors
                                    
                                    	Total number of neighbors 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: network_type
                                    
                                    	Network type
                                    	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                                    
                                    .. attribute:: ospf_interface_state
                                    
                                    	Interface OSPF state
                                    	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable.InterfaceBrief, self).__init__()

                                        self.yang_name = "interface-brief"
                                        self.yang_parent_name = "interface-brief-table"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.interface_address = YLeaf(YType.str, "interface-address")

                                        self.interface_adjacent_neighbors = YLeaf(YType.uint16, "interface-adjacent-neighbors")

                                        self.interface_link_cost = YLeaf(YType.uint16, "interface-link-cost")

                                        self.interface_neighbors = YLeaf(YType.uint16, "interface-neighbors")

                                        self.network_type = YLeaf(YType.enumeration, "network-type")

                                        self.ospf_interface_state = YLeaf(YType.enumeration, "ospf-interface-state")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "interface_address",
                                                        "interface_adjacent_neighbors",
                                                        "interface_link_cost",
                                                        "interface_neighbors",
                                                        "network_type",
                                                        "ospf_interface_state") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable.InterfaceBrief, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable.InterfaceBrief, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.interface_address.is_set or
                                            self.interface_adjacent_neighbors.is_set or
                                            self.interface_link_cost.is_set or
                                            self.interface_neighbors.is_set or
                                            self.network_type.is_set or
                                            self.ospf_interface_state.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.interface_address.yfilter != YFilter.not_set or
                                            self.interface_adjacent_neighbors.yfilter != YFilter.not_set or
                                            self.interface_link_cost.yfilter != YFilter.not_set or
                                            self.interface_neighbors.yfilter != YFilter.not_set or
                                            self.network_type.yfilter != YFilter.not_set or
                                            self.ospf_interface_state.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "interface-brief" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_address.get_name_leafdata())
                                        if (self.interface_adjacent_neighbors.is_set or self.interface_adjacent_neighbors.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_adjacent_neighbors.get_name_leafdata())
                                        if (self.interface_link_cost.is_set or self.interface_link_cost.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_link_cost.get_name_leafdata())
                                        if (self.interface_neighbors.is_set or self.interface_neighbors.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_neighbors.get_name_leafdata())
                                        if (self.network_type.is_set or self.network_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.network_type.get_name_leafdata())
                                        if (self.ospf_interface_state.is_set or self.ospf_interface_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ospf_interface_state.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-name" or name == "interface-address" or name == "interface-adjacent-neighbors" or name == "interface-link-cost" or name == "interface-neighbors" or name == "network-type" or name == "ospf-interface-state"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-address"):
                                            self.interface_address = value
                                            self.interface_address.value_namespace = name_space
                                            self.interface_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-adjacent-neighbors"):
                                            self.interface_adjacent_neighbors = value
                                            self.interface_adjacent_neighbors.value_namespace = name_space
                                            self.interface_adjacent_neighbors.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-link-cost"):
                                            self.interface_link_cost = value
                                            self.interface_link_cost.value_namespace = name_space
                                            self.interface_link_cost.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-neighbors"):
                                            self.interface_neighbors = value
                                            self.interface_neighbors.value_namespace = name_space
                                            self.interface_neighbors.value_namespace_prefix = name_space_prefix
                                        if(value_path == "network-type"):
                                            self.network_type = value
                                            self.network_type.value_namespace = name_space
                                            self.network_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ospf-interface-state"):
                                            self.ospf_interface_state = value
                                            self.ospf_interface_state.value_namespace = name_space
                                            self.ospf_interface_state.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.interface_brief:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.interface_brief:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface-brief-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "interface-brief"):
                                        for c in self.interface_brief:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable.InterfaceBrief()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.interface_brief.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-brief"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class RequestListTable(Entity):
                                """
                                OSPFv3 request list information in an area
                                
                                .. attribute:: request
                                
                                	OSPFv3 request list information
                                	**type**\: list of    :py:class:`Request <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable.Request>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable, self).__init__()

                                    self.yang_name = "request-list-table"
                                    self.yang_parent_name = "area"

                                    self.request = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable, self).__setattr__(name, value)


                                class Request(Entity):
                                    """
                                    OSPFv3 request list information
                                    
                                    .. attribute:: interface_name
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_request_sham_link
                                    
                                    	If true, sham link is requested 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_request_virtual_link
                                    
                                    	If true, virtual link is requested 
                                    	**type**\:  bool
                                    
                                    .. attribute:: neighbor_address
                                    
                                    	Neighbor address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: request
                                    
                                    	List of request list entries
                                    	**type**\: list of    :py:class:`Request <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable.Request.Request>`
                                    
                                    .. attribute:: request_neighbor_address
                                    
                                    	Neighbor IP address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: request_sham_link_id
                                    
                                    	Request sham link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: request_virtual_link_id
                                    
                                    	Request virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable.Request, self).__init__()

                                        self.yang_name = "request"
                                        self.yang_parent_name = "request-list-table"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_request_sham_link = YLeaf(YType.boolean, "is-request-sham-link")

                                        self.is_request_virtual_link = YLeaf(YType.boolean, "is-request-virtual-link")

                                        self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                        self.request_neighbor_address = YLeaf(YType.str, "request-neighbor-address")

                                        self.request_sham_link_id = YLeaf(YType.uint32, "request-sham-link-id")

                                        self.request_virtual_link_id = YLeaf(YType.uint32, "request-virtual-link-id")

                                        self.request = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_request_sham_link",
                                                        "is_request_virtual_link",
                                                        "neighbor_address",
                                                        "request_neighbor_address",
                                                        "request_sham_link_id",
                                                        "request_virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable.Request, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable.Request, self).__setattr__(name, value)


                                    class Request(Entity):
                                        """
                                        List of request list entries
                                        
                                        .. attribute:: header_advertising_router
                                        
                                        	Router ID of the advertising router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_age
                                        
                                        	Age of the LSA (seconds)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: header_lsa_id
                                        
                                        	LSA ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_type
                                        
                                        	LSA type
                                        	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                        
                                        .. attribute:: header_sequence_number
                                        
                                        	Current LSA sequence number
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable.Request.Request, self).__init__()

                                            self.yang_name = "request"
                                            self.yang_parent_name = "request"

                                            self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                            self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                            self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                            self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                            self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("header_advertising_router",
                                                            "header_lsa_age",
                                                            "header_lsa_id",
                                                            "header_lsa_type",
                                                            "header_sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable.Request.Request, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable.Request.Request, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.header_advertising_router.is_set or
                                                self.header_lsa_age.is_set or
                                                self.header_lsa_id.is_set or
                                                self.header_lsa_type.is_set or
                                                self.header_sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.header_advertising_router.yfilter != YFilter.not_set or
                                                self.header_lsa_age.yfilter != YFilter.not_set or
                                                self.header_lsa_id.yfilter != YFilter.not_set or
                                                self.header_lsa_type.yfilter != YFilter.not_set or
                                                self.header_sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "request" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                            if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                            if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                            if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                            if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "header-advertising-router"):
                                                self.header_advertising_router = value
                                                self.header_advertising_router.value_namespace = name_space
                                                self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-age"):
                                                self.header_lsa_age = value
                                                self.header_lsa_age.value_namespace = name_space
                                                self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-id"):
                                                self.header_lsa_id = value
                                                self.header_lsa_id.value_namespace = name_space
                                                self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-type"):
                                                self.header_lsa_type = value
                                                self.header_lsa_type.value_namespace = name_space
                                                self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-sequence-number"):
                                                self.header_sequence_number = value
                                                self.header_sequence_number.value_namespace = name_space
                                                self.header_sequence_number.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.request:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.is_request_sham_link.is_set or
                                            self.is_request_virtual_link.is_set or
                                            self.neighbor_address.is_set or
                                            self.request_neighbor_address.is_set or
                                            self.request_sham_link_id.is_set or
                                            self.request_virtual_link_id.is_set)

                                    def has_operation(self):
                                        for c in self.request:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_request_sham_link.yfilter != YFilter.not_set or
                                            self.is_request_virtual_link.yfilter != YFilter.not_set or
                                            self.neighbor_address.yfilter != YFilter.not_set or
                                            self.request_neighbor_address.yfilter != YFilter.not_set or
                                            self.request_sham_link_id.yfilter != YFilter.not_set or
                                            self.request_virtual_link_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "request" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_request_sham_link.is_set or self.is_request_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_request_sham_link.get_name_leafdata())
                                        if (self.is_request_virtual_link.is_set or self.is_request_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_request_virtual_link.get_name_leafdata())
                                        if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                        if (self.request_neighbor_address.is_set or self.request_neighbor_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.request_neighbor_address.get_name_leafdata())
                                        if (self.request_sham_link_id.is_set or self.request_sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.request_sham_link_id.get_name_leafdata())
                                        if (self.request_virtual_link_id.is_set or self.request_virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.request_virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "request"):
                                            for c in self.request:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable.Request.Request()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.request.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "request" or name == "interface-name" or name == "is-request-sham-link" or name == "is-request-virtual-link" or name == "neighbor-address" or name == "request-neighbor-address" or name == "request-sham-link-id" or name == "request-virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-request-sham-link"):
                                            self.is_request_sham_link = value
                                            self.is_request_sham_link.value_namespace = name_space
                                            self.is_request_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-request-virtual-link"):
                                            self.is_request_virtual_link = value
                                            self.is_request_virtual_link.value_namespace = name_space
                                            self.is_request_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-address"):
                                            self.neighbor_address = value
                                            self.neighbor_address.value_namespace = name_space
                                            self.neighbor_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "request-neighbor-address"):
                                            self.request_neighbor_address = value
                                            self.request_neighbor_address.value_namespace = name_space
                                            self.request_neighbor_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "request-sham-link-id"):
                                            self.request_sham_link_id = value
                                            self.request_sham_link_id.value_namespace = name_space
                                            self.request_sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "request-virtual-link-id"):
                                            self.request_virtual_link_id = value
                                            self.request_virtual_link_id.value_namespace = name_space
                                            self.request_virtual_link_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.request:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.request:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "request-list-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "request"):
                                        for c in self.request:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable.Request()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.request.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "request"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class NeighborTable(Entity):
                                """
                                OSPFv3 neighbor information table
                                
                                .. attribute:: neighbor
                                
                                	OSPFv3 neighbor detail information
                                	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable, self).__init__()

                                    self.yang_name = "neighbor-table"
                                    self.yang_parent_name = "area"

                                    self.neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable, self).__setattr__(name, value)


                                class Neighbor(Entity):
                                    """
                                    OSPFv3 neighbor detail information
                                    
                                    .. attribute:: interface_name
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_neighbor_sham_link
                                    
                                    	If true, neighbor is on a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_neighbor_virtual_link
                                    
                                    	If true, neighbor is on a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: neighbor_address
                                    
                                    	Neighbor ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: neighbor_address_xr
                                    
                                    	Neighbor IP Address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: neighbor_bfd_info
                                    
                                    	Neighbor BFD information
                                    	**type**\:   :py:class:`NeighborBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo>`
                                    
                                    .. attribute:: neighbor_dead_timer
                                    
                                    	Time until neighbor's dead timer expires (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: neighbor_designated_router
                                    
                                    	Designated router 
                                    	**type**\:  str
                                    
                                    	**length:** 0..9
                                    
                                    .. attribute:: neighbor_detail
                                    
                                    	Detailed OSPFv3 neighbor information 
                                    	**type**\:   :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail>`
                                    
                                    .. attribute:: neighbor_dr_priority
                                    
                                    	Neighbor's DR priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: neighbor_interface_id
                                    
                                    	Neighbor interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_sham_link_id
                                    
                                    	Neighbor sham link id 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_state
                                    
                                    	Neighbor's state
                                    	**type**\:   :py:class:`Ospfv3NeighborState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3NeighborState>`
                                    
                                    .. attribute:: neighbor_up_time
                                    
                                    	Amount of time since the adjacency is up (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: neighbor_virtual_link_id
                                    
                                    	Neighbor virtual link id 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor, self).__init__()

                                        self.yang_name = "neighbor"
                                        self.yang_parent_name = "neighbor-table"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_neighbor_sham_link = YLeaf(YType.boolean, "is-neighbor-sham-link")

                                        self.is_neighbor_virtual_link = YLeaf(YType.boolean, "is-neighbor-virtual-link")

                                        self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                        self.neighbor_address_xr = YLeaf(YType.str, "neighbor-address-xr")

                                        self.neighbor_dead_timer = YLeaf(YType.uint32, "neighbor-dead-timer")

                                        self.neighbor_designated_router = YLeaf(YType.str, "neighbor-designated-router")

                                        self.neighbor_dr_priority = YLeaf(YType.uint8, "neighbor-dr-priority")

                                        self.neighbor_interface_id = YLeaf(YType.uint32, "neighbor-interface-id")

                                        self.neighbor_sham_link_id = YLeaf(YType.uint32, "neighbor-sham-link-id")

                                        self.neighbor_state = YLeaf(YType.enumeration, "neighbor-state")

                                        self.neighbor_up_time = YLeaf(YType.uint32, "neighbor-up-time")

                                        self.neighbor_virtual_link_id = YLeaf(YType.uint32, "neighbor-virtual-link-id")

                                        self.neighbor_bfd_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo()
                                        self.neighbor_bfd_info.parent = self
                                        self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                        self._children_yang_names.add("neighbor-bfd-info")

                                        self.neighbor_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail()
                                        self.neighbor_detail.parent = self
                                        self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                        self._children_yang_names.add("neighbor-detail")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_neighbor_sham_link",
                                                        "is_neighbor_virtual_link",
                                                        "neighbor_address",
                                                        "neighbor_address_xr",
                                                        "neighbor_dead_timer",
                                                        "neighbor_designated_router",
                                                        "neighbor_dr_priority",
                                                        "neighbor_interface_id",
                                                        "neighbor_sham_link_id",
                                                        "neighbor_state",
                                                        "neighbor_up_time",
                                                        "neighbor_virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor, self).__setattr__(name, value)


                                    class NeighborDetail(Entity):
                                        """
                                        Detailed OSPFv3 neighbor information 
                                        
                                        .. attribute:: interface_type
                                        
                                        	Interface type
                                        	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                                        
                                        .. attribute:: is_neighbor_filtered
                                        
                                        	If true, filter outgoing LSAs 
                                        	**type**\:  bool
                                        
                                        .. attribute:: neighbor_backup_designated_router_address
                                        
                                        	Address of backup designated router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: neighbor_cost
                                        
                                        	Cost of path to this neighbor 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: neighbor_designated_router_address
                                        
                                        	Address of designated router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: neighbor_ignore_timer
                                        
                                        	Remaining time when ignore timer is running 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: neighbor_option
                                        
                                        	 This is bitmask of neighbor's option field received 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: neighbor_retransmission
                                        
                                        	Retransmission information with this neighbor
                                        	**type**\:   :py:class:`NeighborRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission>`
                                        
                                        .. attribute:: next_poll_interval
                                        
                                        	For NBMA networks, amount of time remaining in seconds before the next poll interval expires and Hello is sent (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: pending_events
                                        
                                        	Number of pending events 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: poll_interval
                                        
                                        	Poll interval (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state_changes
                                        
                                        	Number of state changes 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail, self).__init__()

                                            self.yang_name = "neighbor-detail"
                                            self.yang_parent_name = "neighbor"

                                            self.interface_type = YLeaf(YType.enumeration, "interface-type")

                                            self.is_neighbor_filtered = YLeaf(YType.boolean, "is-neighbor-filtered")

                                            self.neighbor_backup_designated_router_address = YLeaf(YType.str, "neighbor-backup-designated-router-address")

                                            self.neighbor_cost = YLeaf(YType.uint16, "neighbor-cost")

                                            self.neighbor_designated_router_address = YLeaf(YType.str, "neighbor-designated-router-address")

                                            self.neighbor_ignore_timer = YLeaf(YType.uint32, "neighbor-ignore-timer")

                                            self.neighbor_option = YLeaf(YType.uint32, "neighbor-option")

                                            self.next_poll_interval = YLeaf(YType.uint32, "next-poll-interval")

                                            self.pending_events = YLeaf(YType.uint16, "pending-events")

                                            self.poll_interval = YLeaf(YType.uint32, "poll-interval")

                                            self.state_changes = YLeaf(YType.uint16, "state-changes")

                                            self.neighbor_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission()
                                            self.neighbor_retransmission.parent = self
                                            self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                            self._children_yang_names.add("neighbor-retransmission")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_type",
                                                            "is_neighbor_filtered",
                                                            "neighbor_backup_designated_router_address",
                                                            "neighbor_cost",
                                                            "neighbor_designated_router_address",
                                                            "neighbor_ignore_timer",
                                                            "neighbor_option",
                                                            "next_poll_interval",
                                                            "pending_events",
                                                            "poll_interval",
                                                            "state_changes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail, self).__setattr__(name, value)


                                        class NeighborRetransmission(Entity):
                                            """
                                            Retransmission information with this neighbor
                                            
                                            .. attribute:: area_first_flood
                                            
                                            	First flood item for area scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: area_first_flood_index
                                            
                                            	Index of the first flood item for area scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: area_flood_index
                                            
                                            	Area scope LSA's flood index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: area_next_flood
                                            
                                            	Next flood item for area scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: area_next_flood_index
                                            
                                            	Index of next flood item for Area scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: as_first_flood
                                            
                                            	First flood item for AS scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: as_first_flood_index
                                            
                                            	Index for first flood item for AS scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: as_flood_index
                                            
                                            	AS scope LSA's flood index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: as_next_flood
                                            
                                            	Next flood item for AS scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: as_next_flood_index
                                            
                                            	Index of next flood item for AS scope LSAs
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: database_descriptor_retransmissions
                                            
                                            	Number of database descriptor retransmissions during last exchange
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: last_retransmission_length
                                            
                                            	Number of LSAs sent in last retransmission
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: last_retransmission_time
                                            
                                            	Last retransmission scan time (ms)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_first_flood
                                            
                                            	Link first flood information 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_first_flood_index
                                            
                                            	Link first flood information index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_flood_index
                                            
                                            	Link flood index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_next_flood
                                            
                                            	Link next flood information 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: link_next_flood_index
                                            
                                            	Link next flood information index 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_retransmission_timer
                                            
                                            	Time until next LSA retransmission (ms)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: maximum_retransmission_length
                                            
                                            	Maximum number of LSAs sent in a retransmission
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: maximum_retransmission_time
                                            
                                            	Maximum retransmission scan time (ms)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: neighbor_retransmissions
                                            
                                            	Number of neighbor retransmissions 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: retransmissions
                                            
                                            	Number of retransmissions for this neighbor
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__init__()

                                                self.yang_name = "neighbor-retransmission"
                                                self.yang_parent_name = "neighbor-detail"

                                                self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                                self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                                self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                                self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                                self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                                self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                                self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                                self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                                self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                                self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                                self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                                self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                                self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                                self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                                self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                                self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                                self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                                self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                                self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                                self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                                self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                                self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                                self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("area_first_flood",
                                                                "area_first_flood_index",
                                                                "area_flood_index",
                                                                "area_next_flood",
                                                                "area_next_flood_index",
                                                                "as_first_flood",
                                                                "as_first_flood_index",
                                                                "as_flood_index",
                                                                "as_next_flood",
                                                                "as_next_flood_index",
                                                                "database_descriptor_retransmissions",
                                                                "last_retransmission_length",
                                                                "last_retransmission_time",
                                                                "link_first_flood",
                                                                "link_first_flood_index",
                                                                "link_flood_index",
                                                                "link_next_flood",
                                                                "link_next_flood_index",
                                                                "lsa_retransmission_timer",
                                                                "maximum_retransmission_length",
                                                                "maximum_retransmission_time",
                                                                "neighbor_retransmissions",
                                                                "retransmissions") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.area_first_flood.is_set or
                                                    self.area_first_flood_index.is_set or
                                                    self.area_flood_index.is_set or
                                                    self.area_next_flood.is_set or
                                                    self.area_next_flood_index.is_set or
                                                    self.as_first_flood.is_set or
                                                    self.as_first_flood_index.is_set or
                                                    self.as_flood_index.is_set or
                                                    self.as_next_flood.is_set or
                                                    self.as_next_flood_index.is_set or
                                                    self.database_descriptor_retransmissions.is_set or
                                                    self.last_retransmission_length.is_set or
                                                    self.last_retransmission_time.is_set or
                                                    self.link_first_flood.is_set or
                                                    self.link_first_flood_index.is_set or
                                                    self.link_flood_index.is_set or
                                                    self.link_next_flood.is_set or
                                                    self.link_next_flood_index.is_set or
                                                    self.lsa_retransmission_timer.is_set or
                                                    self.maximum_retransmission_length.is_set or
                                                    self.maximum_retransmission_time.is_set or
                                                    self.neighbor_retransmissions.is_set or
                                                    self.retransmissions.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.area_first_flood.yfilter != YFilter.not_set or
                                                    self.area_first_flood_index.yfilter != YFilter.not_set or
                                                    self.area_flood_index.yfilter != YFilter.not_set or
                                                    self.area_next_flood.yfilter != YFilter.not_set or
                                                    self.area_next_flood_index.yfilter != YFilter.not_set or
                                                    self.as_first_flood.yfilter != YFilter.not_set or
                                                    self.as_first_flood_index.yfilter != YFilter.not_set or
                                                    self.as_flood_index.yfilter != YFilter.not_set or
                                                    self.as_next_flood.yfilter != YFilter.not_set or
                                                    self.as_next_flood_index.yfilter != YFilter.not_set or
                                                    self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                                    self.last_retransmission_length.yfilter != YFilter.not_set or
                                                    self.last_retransmission_time.yfilter != YFilter.not_set or
                                                    self.link_first_flood.yfilter != YFilter.not_set or
                                                    self.link_first_flood_index.yfilter != YFilter.not_set or
                                                    self.link_flood_index.yfilter != YFilter.not_set or
                                                    self.link_next_flood.yfilter != YFilter.not_set or
                                                    self.link_next_flood_index.yfilter != YFilter.not_set or
                                                    self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                                    self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                                    self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                                    self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                                    self.retransmissions.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "neighbor-retransmission" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                                if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                                if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                                if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                                if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                                if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                                if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                                if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                                if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                                if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                                if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                                if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                                if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                                if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                                if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                                if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                                if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                                if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                                if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                                if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                                if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                                if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                                if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "area-first-flood"):
                                                    self.area_first_flood = value
                                                    self.area_first_flood.value_namespace = name_space
                                                    self.area_first_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "area-first-flood-index"):
                                                    self.area_first_flood_index = value
                                                    self.area_first_flood_index.value_namespace = name_space
                                                    self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "area-flood-index"):
                                                    self.area_flood_index = value
                                                    self.area_flood_index.value_namespace = name_space
                                                    self.area_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "area-next-flood"):
                                                    self.area_next_flood = value
                                                    self.area_next_flood.value_namespace = name_space
                                                    self.area_next_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "area-next-flood-index"):
                                                    self.area_next_flood_index = value
                                                    self.area_next_flood_index.value_namespace = name_space
                                                    self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "as-first-flood"):
                                                    self.as_first_flood = value
                                                    self.as_first_flood.value_namespace = name_space
                                                    self.as_first_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "as-first-flood-index"):
                                                    self.as_first_flood_index = value
                                                    self.as_first_flood_index.value_namespace = name_space
                                                    self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "as-flood-index"):
                                                    self.as_flood_index = value
                                                    self.as_flood_index.value_namespace = name_space
                                                    self.as_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "as-next-flood"):
                                                    self.as_next_flood = value
                                                    self.as_next_flood.value_namespace = name_space
                                                    self.as_next_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "as-next-flood-index"):
                                                    self.as_next_flood_index = value
                                                    self.as_next_flood_index.value_namespace = name_space
                                                    self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "database-descriptor-retransmissions"):
                                                    self.database_descriptor_retransmissions = value
                                                    self.database_descriptor_retransmissions.value_namespace = name_space
                                                    self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-retransmission-length"):
                                                    self.last_retransmission_length = value
                                                    self.last_retransmission_length.value_namespace = name_space
                                                    self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-retransmission-time"):
                                                    self.last_retransmission_time = value
                                                    self.last_retransmission_time.value_namespace = name_space
                                                    self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-first-flood"):
                                                    self.link_first_flood = value
                                                    self.link_first_flood.value_namespace = name_space
                                                    self.link_first_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-first-flood-index"):
                                                    self.link_first_flood_index = value
                                                    self.link_first_flood_index.value_namespace = name_space
                                                    self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-flood-index"):
                                                    self.link_flood_index = value
                                                    self.link_flood_index.value_namespace = name_space
                                                    self.link_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-next-flood"):
                                                    self.link_next_flood = value
                                                    self.link_next_flood.value_namespace = name_space
                                                    self.link_next_flood.value_namespace_prefix = name_space_prefix
                                                if(value_path == "link-next-flood-index"):
                                                    self.link_next_flood_index = value
                                                    self.link_next_flood_index.value_namespace = name_space
                                                    self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-retransmission-timer"):
                                                    self.lsa_retransmission_timer = value
                                                    self.lsa_retransmission_timer.value_namespace = name_space
                                                    self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                                if(value_path == "maximum-retransmission-length"):
                                                    self.maximum_retransmission_length = value
                                                    self.maximum_retransmission_length.value_namespace = name_space
                                                    self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "maximum-retransmission-time"):
                                                    self.maximum_retransmission_time = value
                                                    self.maximum_retransmission_time.value_namespace = name_space
                                                    self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-retransmissions"):
                                                    self.neighbor_retransmissions = value
                                                    self.neighbor_retransmissions.value_namespace = name_space
                                                    self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                                if(value_path == "retransmissions"):
                                                    self.retransmissions = value
                                                    self.retransmissions.value_namespace = name_space
                                                    self.retransmissions.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interface_type.is_set or
                                                self.is_neighbor_filtered.is_set or
                                                self.neighbor_backup_designated_router_address.is_set or
                                                self.neighbor_cost.is_set or
                                                self.neighbor_designated_router_address.is_set or
                                                self.neighbor_ignore_timer.is_set or
                                                self.neighbor_option.is_set or
                                                self.next_poll_interval.is_set or
                                                self.pending_events.is_set or
                                                self.poll_interval.is_set or
                                                self.state_changes.is_set or
                                                (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_type.yfilter != YFilter.not_set or
                                                self.is_neighbor_filtered.yfilter != YFilter.not_set or
                                                self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set or
                                                self.neighbor_cost.yfilter != YFilter.not_set or
                                                self.neighbor_designated_router_address.yfilter != YFilter.not_set or
                                                self.neighbor_ignore_timer.yfilter != YFilter.not_set or
                                                self.neighbor_option.yfilter != YFilter.not_set or
                                                self.next_poll_interval.yfilter != YFilter.not_set or
                                                self.pending_events.yfilter != YFilter.not_set or
                                                self.poll_interval.yfilter != YFilter.not_set or
                                                self.state_changes.yfilter != YFilter.not_set or
                                                (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "neighbor-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_type.is_set or self.interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_type.get_name_leafdata())
                                            if (self.is_neighbor_filtered.is_set or self.is_neighbor_filtered.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_filtered.get_name_leafdata())
                                            if (self.neighbor_backup_designated_router_address.is_set or self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_backup_designated_router_address.get_name_leafdata())
                                            if (self.neighbor_cost.is_set or self.neighbor_cost.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_cost.get_name_leafdata())
                                            if (self.neighbor_designated_router_address.is_set or self.neighbor_designated_router_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_designated_router_address.get_name_leafdata())
                                            if (self.neighbor_ignore_timer.is_set or self.neighbor_ignore_timer.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_ignore_timer.get_name_leafdata())
                                            if (self.neighbor_option.is_set or self.neighbor_option.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_option.get_name_leafdata())
                                            if (self.next_poll_interval.is_set or self.next_poll_interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_poll_interval.get_name_leafdata())
                                            if (self.pending_events.is_set or self.pending_events.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pending_events.get_name_leafdata())
                                            if (self.poll_interval.is_set or self.poll_interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.poll_interval.get_name_leafdata())
                                            if (self.state_changes.is_set or self.state_changes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_changes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "neighbor-retransmission"):
                                                if (self.neighbor_retransmission is None):
                                                    self.neighbor_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission()
                                                    self.neighbor_retransmission.parent = self
                                                    self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                                return self.neighbor_retransmission

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "neighbor-retransmission" or name == "interface-type" or name == "is-neighbor-filtered" or name == "neighbor-backup-designated-router-address" or name == "neighbor-cost" or name == "neighbor-designated-router-address" or name == "neighbor-ignore-timer" or name == "neighbor-option" or name == "next-poll-interval" or name == "pending-events" or name == "poll-interval" or name == "state-changes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-type"):
                                                self.interface_type = value
                                                self.interface_type.value_namespace = name_space
                                                self.interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-filtered"):
                                                self.is_neighbor_filtered = value
                                                self.is_neighbor_filtered.value_namespace = name_space
                                                self.is_neighbor_filtered.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-backup-designated-router-address"):
                                                self.neighbor_backup_designated_router_address = value
                                                self.neighbor_backup_designated_router_address.value_namespace = name_space
                                                self.neighbor_backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-cost"):
                                                self.neighbor_cost = value
                                                self.neighbor_cost.value_namespace = name_space
                                                self.neighbor_cost.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-designated-router-address"):
                                                self.neighbor_designated_router_address = value
                                                self.neighbor_designated_router_address.value_namespace = name_space
                                                self.neighbor_designated_router_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-ignore-timer"):
                                                self.neighbor_ignore_timer = value
                                                self.neighbor_ignore_timer.value_namespace = name_space
                                                self.neighbor_ignore_timer.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-option"):
                                                self.neighbor_option = value
                                                self.neighbor_option.value_namespace = name_space
                                                self.neighbor_option.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-poll-interval"):
                                                self.next_poll_interval = value
                                                self.next_poll_interval.value_namespace = name_space
                                                self.next_poll_interval.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pending-events"):
                                                self.pending_events = value
                                                self.pending_events.value_namespace = name_space
                                                self.pending_events.value_namespace_prefix = name_space_prefix
                                            if(value_path == "poll-interval"):
                                                self.poll_interval = value
                                                self.poll_interval.value_namespace = name_space
                                                self.poll_interval.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-changes"):
                                                self.state_changes = value
                                                self.state_changes.value_namespace = name_space
                                                self.state_changes.value_namespace_prefix = name_space_prefix


                                    class NeighborBfdInfo(Entity):
                                        """
                                        Neighbor BFD information
                                        
                                        .. attribute:: bfd_intf_enable_mode
                                        
                                        	BFD enable mode \- Default/Strict
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: bfd_status_flag
                                        
                                        	Status of the BFD Session
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo, self).__init__()

                                            self.yang_name = "neighbor-bfd-info"
                                            self.yang_parent_name = "neighbor"

                                            self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                            self.bfd_status_flag = YLeaf(YType.uint8, "bfd-status-flag")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bfd_intf_enable_mode",
                                                            "bfd_status_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bfd_intf_enable_mode.is_set or
                                                self.bfd_status_flag.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bfd_intf_enable_mode.yfilter != YFilter.not_set or
                                                self.bfd_status_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "neighbor-bfd-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())
                                            if (self.bfd_status_flag.is_set or self.bfd_status_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bfd_status_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bfd-intf-enable-mode" or name == "bfd-status-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bfd-intf-enable-mode"):
                                                self.bfd_intf_enable_mode = value
                                                self.bfd_intf_enable_mode.value_namespace = name_space
                                                self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bfd-status-flag"):
                                                self.bfd_status_flag = value
                                                self.bfd_status_flag.value_namespace = name_space
                                                self.bfd_status_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_neighbor_sham_link.is_set or
                                            self.is_neighbor_virtual_link.is_set or
                                            self.neighbor_address.is_set or
                                            self.neighbor_address_xr.is_set or
                                            self.neighbor_dead_timer.is_set or
                                            self.neighbor_designated_router.is_set or
                                            self.neighbor_dr_priority.is_set or
                                            self.neighbor_interface_id.is_set or
                                            self.neighbor_sham_link_id.is_set or
                                            self.neighbor_state.is_set or
                                            self.neighbor_up_time.is_set or
                                            self.neighbor_virtual_link_id.is_set or
                                            (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_data()) or
                                            (self.neighbor_detail is not None and self.neighbor_detail.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_neighbor_sham_link.yfilter != YFilter.not_set or
                                            self.is_neighbor_virtual_link.yfilter != YFilter.not_set or
                                            self.neighbor_address.yfilter != YFilter.not_set or
                                            self.neighbor_address_xr.yfilter != YFilter.not_set or
                                            self.neighbor_dead_timer.yfilter != YFilter.not_set or
                                            self.neighbor_designated_router.yfilter != YFilter.not_set or
                                            self.neighbor_dr_priority.yfilter != YFilter.not_set or
                                            self.neighbor_interface_id.yfilter != YFilter.not_set or
                                            self.neighbor_sham_link_id.yfilter != YFilter.not_set or
                                            self.neighbor_state.yfilter != YFilter.not_set or
                                            self.neighbor_up_time.yfilter != YFilter.not_set or
                                            self.neighbor_virtual_link_id.yfilter != YFilter.not_set or
                                            (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_operation()) or
                                            (self.neighbor_detail is not None and self.neighbor_detail.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_neighbor_sham_link.is_set or self.is_neighbor_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_neighbor_sham_link.get_name_leafdata())
                                        if (self.is_neighbor_virtual_link.is_set or self.is_neighbor_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_neighbor_virtual_link.get_name_leafdata())
                                        if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                        if (self.neighbor_address_xr.is_set or self.neighbor_address_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_address_xr.get_name_leafdata())
                                        if (self.neighbor_dead_timer.is_set or self.neighbor_dead_timer.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_dead_timer.get_name_leafdata())
                                        if (self.neighbor_designated_router.is_set or self.neighbor_designated_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_designated_router.get_name_leafdata())
                                        if (self.neighbor_dr_priority.is_set or self.neighbor_dr_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_dr_priority.get_name_leafdata())
                                        if (self.neighbor_interface_id.is_set or self.neighbor_interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_interface_id.get_name_leafdata())
                                        if (self.neighbor_sham_link_id.is_set or self.neighbor_sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_sham_link_id.get_name_leafdata())
                                        if (self.neighbor_state.is_set or self.neighbor_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_state.get_name_leafdata())
                                        if (self.neighbor_up_time.is_set or self.neighbor_up_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_up_time.get_name_leafdata())
                                        if (self.neighbor_virtual_link_id.is_set or self.neighbor_virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "neighbor-bfd-info"):
                                            if (self.neighbor_bfd_info is None):
                                                self.neighbor_bfd_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo()
                                                self.neighbor_bfd_info.parent = self
                                                self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                            return self.neighbor_bfd_info

                                        if (child_yang_name == "neighbor-detail"):
                                            if (self.neighbor_detail is None):
                                                self.neighbor_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail()
                                                self.neighbor_detail.parent = self
                                                self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                            return self.neighbor_detail

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "neighbor-bfd-info" or name == "neighbor-detail" or name == "interface-name" or name == "is-neighbor-sham-link" or name == "is-neighbor-virtual-link" or name == "neighbor-address" or name == "neighbor-address-xr" or name == "neighbor-dead-timer" or name == "neighbor-designated-router" or name == "neighbor-dr-priority" or name == "neighbor-interface-id" or name == "neighbor-sham-link-id" or name == "neighbor-state" or name == "neighbor-up-time" or name == "neighbor-virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-neighbor-sham-link"):
                                            self.is_neighbor_sham_link = value
                                            self.is_neighbor_sham_link.value_namespace = name_space
                                            self.is_neighbor_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-neighbor-virtual-link"):
                                            self.is_neighbor_virtual_link = value
                                            self.is_neighbor_virtual_link.value_namespace = name_space
                                            self.is_neighbor_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-address"):
                                            self.neighbor_address = value
                                            self.neighbor_address.value_namespace = name_space
                                            self.neighbor_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-address-xr"):
                                            self.neighbor_address_xr = value
                                            self.neighbor_address_xr.value_namespace = name_space
                                            self.neighbor_address_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-dead-timer"):
                                            self.neighbor_dead_timer = value
                                            self.neighbor_dead_timer.value_namespace = name_space
                                            self.neighbor_dead_timer.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-designated-router"):
                                            self.neighbor_designated_router = value
                                            self.neighbor_designated_router.value_namespace = name_space
                                            self.neighbor_designated_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-dr-priority"):
                                            self.neighbor_dr_priority = value
                                            self.neighbor_dr_priority.value_namespace = name_space
                                            self.neighbor_dr_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-interface-id"):
                                            self.neighbor_interface_id = value
                                            self.neighbor_interface_id.value_namespace = name_space
                                            self.neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-sham-link-id"):
                                            self.neighbor_sham_link_id = value
                                            self.neighbor_sham_link_id.value_namespace = name_space
                                            self.neighbor_sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-state"):
                                            self.neighbor_state = value
                                            self.neighbor_state.value_namespace = name_space
                                            self.neighbor_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-up-time"):
                                            self.neighbor_up_time = value
                                            self.neighbor_up_time.value_namespace = name_space
                                            self.neighbor_up_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-virtual-link-id"):
                                            self.neighbor_virtual_link_id = value
                                            self.neighbor_virtual_link_id.value_namespace = name_space
                                            self.neighbor_virtual_link_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.neighbor:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "neighbor-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "neighbor"):
                                        for c in self.neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable.Neighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "neighbor"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class InterfaceTable(Entity):
                                """
                                OSPFv3 interface information table for an area
                                
                                .. attribute:: interface
                                
                                	OSPFv3 interface information
                                	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable, self).__init__()

                                    self.yang_name = "interface-table"
                                    self.yang_parent_name = "area"

                                    self.interface = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable, self).__setattr__(name, value)


                                class Interface(Entity):
                                    """
                                    OSPFv3 interface information
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: active_interface
                                    
                                    	Active interface details 
                                    	**type**\:   :py:class:`ActiveInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.ActiveInterface>`
                                    
                                    .. attribute:: adjacent_neighbor
                                    
                                    	Number of adjacent neighbors
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: backup_designated_router_address
                                    
                                    	Backup designated router interface address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: backup_designated_router_id
                                    
                                    	Backup designated router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: configured_ldp_sync
                                    
                                    	If true, configured as LDP sync
                                    	**type**\:  bool
                                    
                                    .. attribute:: dead_interval
                                    
                                    	Configured dead interval (s) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: designated_router_address
                                    
                                    	Designated router interface address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: designated_router_id
                                    
                                    	Designated router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: hello_interval
                                    
                                    	Configured hello interval (s)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_address
                                    
                                    	Interface IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: interface_authentication_spi
                                    
                                    	Interface authentication spi 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_authentication_transmit
                                    
                                    	Interface authentication transmit 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_bfd
                                    
                                    	BFD information 
                                    	**type**\:   :py:class:`InterfaceBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd>`
                                    
                                    .. attribute:: interface_dc_bitless_ls_as
                                    
                                    	Number of LSAs with demand circuit bit not set for the area in which the interface is running
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_encrypted_authentication_transmitted
                                    
                                    	Interface encrypted authentication transmitted 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_encryption_spi
                                    
                                    	Interface encryption spi
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_encryption_transmitted
                                    
                                    	Interface encryption transmitted 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_ldp_sync
                                    
                                    	If true, interface LDP sync is achieved
                                    	**type**\:  bool
                                    
                                    .. attribute:: interface_link_cost
                                    
                                    	Interface link cost
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: interface_neighbor
                                    
                                    	Information for neighbors on the interface
                                    	**type**\: list of    :py:class:`InterfaceNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceNeighbor>`
                                    
                                    .. attribute:: interface_number
                                    
                                    	Interface number 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_priority
                                    
                                    	Interface priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: interface_references
                                    
                                    	Interface reference count 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_retransmission_interval
                                    
                                    	Configured retransmit interval (s) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_router_id
                                    
                                    	Interface router ID 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: interface_state
                                    
                                    	Interface state
                                    	**type**\:   :py:class:`ImStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.ImStateEnum>`
                                    
                                    .. attribute:: is_demand_circuit_configured
                                    
                                    	If true, configured as demand circuit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_designated_router
                                    
                                    	If true, designated router
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_demand_circuit
                                    
                                    	If true, interface running as demand circuit
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_encryption_enabled
                                    
                                    	If true, interface encryption is enabled 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_flood_reduction
                                    
                                    	If true, interface flood reduction is active 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_ip_security_active
                                    
                                    	If true, interface IP security is active 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_ip_security_required
                                    
                                    	If true, interface IP security is required 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_line_up
                                    
                                    	If true, line protocol is up 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_lsa_filtered
                                    
                                    	Filter is configured for out going LSAs 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prefix_suppress
                                    
                                    	If true prefix suppression is enabled
                                    	**type**\:  bool
                                    
                                    .. attribute:: network_lsa_flush_timer
                                    
                                    	The amount of time in seconds before flush timer for old network LSA expires 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: network_type
                                    
                                    	Network type
                                    	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                                    
                                    .. attribute:: next_hello_time
                                    
                                    	Time until next Hello (s) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ospf_interface_state
                                    
                                    	Interface state
                                    	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                                    
                                    .. attribute:: transmission_delay
                                    
                                    	Interface transmission delay (sec)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: wait_interval
                                    
                                    	Configured wait interval (s) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface, self).__init__()

                                        self.yang_name = "interface"
                                        self.yang_parent_name = "interface-table"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.adjacent_neighbor = YLeaf(YType.uint32, "adjacent-neighbor")

                                        self.backup_designated_router_address = YLeaf(YType.str, "backup-designated-router-address")

                                        self.backup_designated_router_id = YLeaf(YType.str, "backup-designated-router-id")

                                        self.configured_ldp_sync = YLeaf(YType.boolean, "configured-ldp-sync")

                                        self.dead_interval = YLeaf(YType.uint32, "dead-interval")

                                        self.designated_router_address = YLeaf(YType.str, "designated-router-address")

                                        self.designated_router_id = YLeaf(YType.str, "designated-router-id")

                                        self.hello_interval = YLeaf(YType.uint32, "hello-interval")

                                        self.interface_address = YLeaf(YType.str, "interface-address")

                                        self.interface_authentication_spi = YLeaf(YType.uint32, "interface-authentication-spi")

                                        self.interface_authentication_transmit = YLeaf(YType.uint32, "interface-authentication-transmit")

                                        self.interface_dc_bitless_ls_as = YLeaf(YType.uint32, "interface-dc-bitless-ls-as")

                                        self.interface_encrypted_authentication_transmitted = YLeaf(YType.uint32, "interface-encrypted-authentication-transmitted")

                                        self.interface_encryption_spi = YLeaf(YType.uint32, "interface-encryption-spi")

                                        self.interface_encryption_transmitted = YLeaf(YType.uint32, "interface-encryption-transmitted")

                                        self.interface_ldp_sync = YLeaf(YType.boolean, "interface-ldp-sync")

                                        self.interface_link_cost = YLeaf(YType.uint16, "interface-link-cost")

                                        self.interface_number = YLeaf(YType.uint32, "interface-number")

                                        self.interface_priority = YLeaf(YType.uint8, "interface-priority")

                                        self.interface_references = YLeaf(YType.uint32, "interface-references")

                                        self.interface_retransmission_interval = YLeaf(YType.uint32, "interface-retransmission-interval")

                                        self.interface_router_id = YLeaf(YType.str, "interface-router-id")

                                        self.interface_state = YLeaf(YType.enumeration, "interface-state")

                                        self.is_demand_circuit_configured = YLeaf(YType.boolean, "is-demand-circuit-configured")

                                        self.is_designated_router = YLeaf(YType.boolean, "is-designated-router")

                                        self.is_interface_demand_circuit = YLeaf(YType.boolean, "is-interface-demand-circuit")

                                        self.is_interface_encryption_enabled = YLeaf(YType.boolean, "is-interface-encryption-enabled")

                                        self.is_interface_flood_reduction = YLeaf(YType.boolean, "is-interface-flood-reduction")

                                        self.is_interface_ip_security_active = YLeaf(YType.boolean, "is-interface-ip-security-active")

                                        self.is_interface_ip_security_required = YLeaf(YType.boolean, "is-interface-ip-security-required")

                                        self.is_interface_line_up = YLeaf(YType.boolean, "is-interface-line-up")

                                        self.is_interface_lsa_filtered = YLeaf(YType.boolean, "is-interface-lsa-filtered")

                                        self.is_prefix_suppress = YLeaf(YType.boolean, "is-prefix-suppress")

                                        self.network_lsa_flush_timer = YLeaf(YType.uint32, "network-lsa-flush-timer")

                                        self.network_type = YLeaf(YType.enumeration, "network-type")

                                        self.next_hello_time = YLeaf(YType.uint32, "next-hello-time")

                                        self.ospf_interface_state = YLeaf(YType.enumeration, "ospf-interface-state")

                                        self.transmission_delay = YLeaf(YType.uint16, "transmission-delay")

                                        self.wait_interval = YLeaf(YType.uint32, "wait-interval")

                                        self.active_interface = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.ActiveInterface()
                                        self.active_interface.parent = self
                                        self._children_name_map["active_interface"] = "active-interface"
                                        self._children_yang_names.add("active-interface")

                                        self.interface_bfd = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd()
                                        self.interface_bfd.parent = self
                                        self._children_name_map["interface_bfd"] = "interface-bfd"
                                        self._children_yang_names.add("interface-bfd")

                                        self.interface_neighbor = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "adjacent_neighbor",
                                                        "backup_designated_router_address",
                                                        "backup_designated_router_id",
                                                        "configured_ldp_sync",
                                                        "dead_interval",
                                                        "designated_router_address",
                                                        "designated_router_id",
                                                        "hello_interval",
                                                        "interface_address",
                                                        "interface_authentication_spi",
                                                        "interface_authentication_transmit",
                                                        "interface_dc_bitless_ls_as",
                                                        "interface_encrypted_authentication_transmitted",
                                                        "interface_encryption_spi",
                                                        "interface_encryption_transmitted",
                                                        "interface_ldp_sync",
                                                        "interface_link_cost",
                                                        "interface_number",
                                                        "interface_priority",
                                                        "interface_references",
                                                        "interface_retransmission_interval",
                                                        "interface_router_id",
                                                        "interface_state",
                                                        "is_demand_circuit_configured",
                                                        "is_designated_router",
                                                        "is_interface_demand_circuit",
                                                        "is_interface_encryption_enabled",
                                                        "is_interface_flood_reduction",
                                                        "is_interface_ip_security_active",
                                                        "is_interface_ip_security_required",
                                                        "is_interface_line_up",
                                                        "is_interface_lsa_filtered",
                                                        "is_prefix_suppress",
                                                        "network_lsa_flush_timer",
                                                        "network_type",
                                                        "next_hello_time",
                                                        "ospf_interface_state",
                                                        "transmission_delay",
                                                        "wait_interval") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface, self).__setattr__(name, value)


                                    class ActiveInterface(Entity):
                                        """
                                        Active interface details 
                                        
                                        .. attribute:: flood_queue_length
                                        
                                        	Flood queue length
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: flood_scan_length
                                        
                                        	Last flood scan length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_area_flood_index
                                        
                                        	Area scope LSAs flood index
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_area_next_flood
                                        
                                        	Next LSA to flood (Area scope)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_area_next_flood_index
                                        
                                        	Index of next LSA to flood (Area scope) 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_as_flood_index
                                        
                                        	AS scope LSAs flood index 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_as_next_flood
                                        
                                        	Next LSA to flood (AS scope)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_as_next_flood_index
                                        
                                        	Index of next LSA to flood (AS scope)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_flood_pacing_timer
                                        
                                        	Time until next flood pacing timer (ms) 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_link_flood_index
                                        
                                        	Interface flood link index 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_link_next_flood
                                        
                                        	Interface link next flood information 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_link_next_index
                                        
                                        	Interface link next information index 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_neighbors
                                        
                                        	Total number of neighbors 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: last_flood_time
                                        
                                        	Last flood scan time (ms)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: maximum_flood_length
                                        
                                        	Maximum flood length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: maximum_flood_time
                                        
                                        	Maximum flood time (ms) 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: suppressed_hellos
                                        
                                        	Number of neighbors for which hellos are suppressed 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: wait_time
                                        
                                        	Wait time for DR/BDR selection (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.ActiveInterface, self).__init__()

                                            self.yang_name = "active-interface"
                                            self.yang_parent_name = "interface"

                                            self.flood_queue_length = YLeaf(YType.uint32, "flood-queue-length")

                                            self.flood_scan_length = YLeaf(YType.uint32, "flood-scan-length")

                                            self.interface_area_flood_index = YLeaf(YType.uint32, "interface-area-flood-index")

                                            self.interface_area_next_flood = YLeaf(YType.uint32, "interface-area-next-flood")

                                            self.interface_area_next_flood_index = YLeaf(YType.uint32, "interface-area-next-flood-index")

                                            self.interface_as_flood_index = YLeaf(YType.uint32, "interface-as-flood-index")

                                            self.interface_as_next_flood = YLeaf(YType.uint32, "interface-as-next-flood")

                                            self.interface_as_next_flood_index = YLeaf(YType.uint32, "interface-as-next-flood-index")

                                            self.interface_flood_pacing_timer = YLeaf(YType.uint32, "interface-flood-pacing-timer")

                                            self.interface_link_flood_index = YLeaf(YType.uint32, "interface-link-flood-index")

                                            self.interface_link_next_flood = YLeaf(YType.uint32, "interface-link-next-flood")

                                            self.interface_link_next_index = YLeaf(YType.uint32, "interface-link-next-index")

                                            self.interface_neighbors = YLeaf(YType.uint16, "interface-neighbors")

                                            self.last_flood_time = YLeaf(YType.uint32, "last-flood-time")

                                            self.maximum_flood_length = YLeaf(YType.uint32, "maximum-flood-length")

                                            self.maximum_flood_time = YLeaf(YType.uint32, "maximum-flood-time")

                                            self.suppressed_hellos = YLeaf(YType.uint16, "suppressed-hellos")

                                            self.wait_time = YLeaf(YType.uint32, "wait-time")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("flood_queue_length",
                                                            "flood_scan_length",
                                                            "interface_area_flood_index",
                                                            "interface_area_next_flood",
                                                            "interface_area_next_flood_index",
                                                            "interface_as_flood_index",
                                                            "interface_as_next_flood",
                                                            "interface_as_next_flood_index",
                                                            "interface_flood_pacing_timer",
                                                            "interface_link_flood_index",
                                                            "interface_link_next_flood",
                                                            "interface_link_next_index",
                                                            "interface_neighbors",
                                                            "last_flood_time",
                                                            "maximum_flood_length",
                                                            "maximum_flood_time",
                                                            "suppressed_hellos",
                                                            "wait_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.ActiveInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.ActiveInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.flood_queue_length.is_set or
                                                self.flood_scan_length.is_set or
                                                self.interface_area_flood_index.is_set or
                                                self.interface_area_next_flood.is_set or
                                                self.interface_area_next_flood_index.is_set or
                                                self.interface_as_flood_index.is_set or
                                                self.interface_as_next_flood.is_set or
                                                self.interface_as_next_flood_index.is_set or
                                                self.interface_flood_pacing_timer.is_set or
                                                self.interface_link_flood_index.is_set or
                                                self.interface_link_next_flood.is_set or
                                                self.interface_link_next_index.is_set or
                                                self.interface_neighbors.is_set or
                                                self.last_flood_time.is_set or
                                                self.maximum_flood_length.is_set or
                                                self.maximum_flood_time.is_set or
                                                self.suppressed_hellos.is_set or
                                                self.wait_time.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.flood_queue_length.yfilter != YFilter.not_set or
                                                self.flood_scan_length.yfilter != YFilter.not_set or
                                                self.interface_area_flood_index.yfilter != YFilter.not_set or
                                                self.interface_area_next_flood.yfilter != YFilter.not_set or
                                                self.interface_area_next_flood_index.yfilter != YFilter.not_set or
                                                self.interface_as_flood_index.yfilter != YFilter.not_set or
                                                self.interface_as_next_flood.yfilter != YFilter.not_set or
                                                self.interface_as_next_flood_index.yfilter != YFilter.not_set or
                                                self.interface_flood_pacing_timer.yfilter != YFilter.not_set or
                                                self.interface_link_flood_index.yfilter != YFilter.not_set or
                                                self.interface_link_next_flood.yfilter != YFilter.not_set or
                                                self.interface_link_next_index.yfilter != YFilter.not_set or
                                                self.interface_neighbors.yfilter != YFilter.not_set or
                                                self.last_flood_time.yfilter != YFilter.not_set or
                                                self.maximum_flood_length.yfilter != YFilter.not_set or
                                                self.maximum_flood_time.yfilter != YFilter.not_set or
                                                self.suppressed_hellos.yfilter != YFilter.not_set or
                                                self.wait_time.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "active-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.flood_queue_length.is_set or self.flood_queue_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.flood_queue_length.get_name_leafdata())
                                            if (self.flood_scan_length.is_set or self.flood_scan_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.flood_scan_length.get_name_leafdata())
                                            if (self.interface_area_flood_index.is_set or self.interface_area_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_area_flood_index.get_name_leafdata())
                                            if (self.interface_area_next_flood.is_set or self.interface_area_next_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_area_next_flood.get_name_leafdata())
                                            if (self.interface_area_next_flood_index.is_set or self.interface_area_next_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_area_next_flood_index.get_name_leafdata())
                                            if (self.interface_as_flood_index.is_set or self.interface_as_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_as_flood_index.get_name_leafdata())
                                            if (self.interface_as_next_flood.is_set or self.interface_as_next_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_as_next_flood.get_name_leafdata())
                                            if (self.interface_as_next_flood_index.is_set or self.interface_as_next_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_as_next_flood_index.get_name_leafdata())
                                            if (self.interface_flood_pacing_timer.is_set or self.interface_flood_pacing_timer.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_flood_pacing_timer.get_name_leafdata())
                                            if (self.interface_link_flood_index.is_set or self.interface_link_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_link_flood_index.get_name_leafdata())
                                            if (self.interface_link_next_flood.is_set or self.interface_link_next_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_link_next_flood.get_name_leafdata())
                                            if (self.interface_link_next_index.is_set or self.interface_link_next_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_link_next_index.get_name_leafdata())
                                            if (self.interface_neighbors.is_set or self.interface_neighbors.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_neighbors.get_name_leafdata())
                                            if (self.last_flood_time.is_set or self.last_flood_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_flood_time.get_name_leafdata())
                                            if (self.maximum_flood_length.is_set or self.maximum_flood_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.maximum_flood_length.get_name_leafdata())
                                            if (self.maximum_flood_time.is_set or self.maximum_flood_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.maximum_flood_time.get_name_leafdata())
                                            if (self.suppressed_hellos.is_set or self.suppressed_hellos.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.suppressed_hellos.get_name_leafdata())
                                            if (self.wait_time.is_set or self.wait_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "flood-queue-length" or name == "flood-scan-length" or name == "interface-area-flood-index" or name == "interface-area-next-flood" or name == "interface-area-next-flood-index" or name == "interface-as-flood-index" or name == "interface-as-next-flood" or name == "interface-as-next-flood-index" or name == "interface-flood-pacing-timer" or name == "interface-link-flood-index" or name == "interface-link-next-flood" or name == "interface-link-next-index" or name == "interface-neighbors" or name == "last-flood-time" or name == "maximum-flood-length" or name == "maximum-flood-time" or name == "suppressed-hellos" or name == "wait-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "flood-queue-length"):
                                                self.flood_queue_length = value
                                                self.flood_queue_length.value_namespace = name_space
                                                self.flood_queue_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "flood-scan-length"):
                                                self.flood_scan_length = value
                                                self.flood_scan_length.value_namespace = name_space
                                                self.flood_scan_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-area-flood-index"):
                                                self.interface_area_flood_index = value
                                                self.interface_area_flood_index.value_namespace = name_space
                                                self.interface_area_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-area-next-flood"):
                                                self.interface_area_next_flood = value
                                                self.interface_area_next_flood.value_namespace = name_space
                                                self.interface_area_next_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-area-next-flood-index"):
                                                self.interface_area_next_flood_index = value
                                                self.interface_area_next_flood_index.value_namespace = name_space
                                                self.interface_area_next_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-as-flood-index"):
                                                self.interface_as_flood_index = value
                                                self.interface_as_flood_index.value_namespace = name_space
                                                self.interface_as_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-as-next-flood"):
                                                self.interface_as_next_flood = value
                                                self.interface_as_next_flood.value_namespace = name_space
                                                self.interface_as_next_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-as-next-flood-index"):
                                                self.interface_as_next_flood_index = value
                                                self.interface_as_next_flood_index.value_namespace = name_space
                                                self.interface_as_next_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-flood-pacing-timer"):
                                                self.interface_flood_pacing_timer = value
                                                self.interface_flood_pacing_timer.value_namespace = name_space
                                                self.interface_flood_pacing_timer.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-link-flood-index"):
                                                self.interface_link_flood_index = value
                                                self.interface_link_flood_index.value_namespace = name_space
                                                self.interface_link_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-link-next-flood"):
                                                self.interface_link_next_flood = value
                                                self.interface_link_next_flood.value_namespace = name_space
                                                self.interface_link_next_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-link-next-index"):
                                                self.interface_link_next_index = value
                                                self.interface_link_next_index.value_namespace = name_space
                                                self.interface_link_next_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-neighbors"):
                                                self.interface_neighbors = value
                                                self.interface_neighbors.value_namespace = name_space
                                                self.interface_neighbors.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-flood-time"):
                                                self.last_flood_time = value
                                                self.last_flood_time.value_namespace = name_space
                                                self.last_flood_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "maximum-flood-length"):
                                                self.maximum_flood_length = value
                                                self.maximum_flood_length.value_namespace = name_space
                                                self.maximum_flood_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "maximum-flood-time"):
                                                self.maximum_flood_time = value
                                                self.maximum_flood_time.value_namespace = name_space
                                                self.maximum_flood_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "suppressed-hellos"):
                                                self.suppressed_hellos = value
                                                self.suppressed_hellos.value_namespace = name_space
                                                self.suppressed_hellos.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-time"):
                                                self.wait_time = value
                                                self.wait_time.value_namespace = name_space
                                                self.wait_time.value_namespace_prefix = name_space_prefix


                                    class InterfaceBfd(Entity):
                                        """
                                        BFD information 
                                        
                                        .. attribute:: bfd_detection_multiplier
                                        
                                        	BFD detection multiplier 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: bfd_interval
                                        
                                        	BFD interval (ms) 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: bfd_intf_enable_mode
                                        
                                        	BFD Enable Mode on the interface \- Default/Strict
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd, self).__init__()

                                            self.yang_name = "interface-bfd"
                                            self.yang_parent_name = "interface"

                                            self.bfd_detection_multiplier = YLeaf(YType.uint32, "bfd-detection-multiplier")

                                            self.bfd_interval = YLeaf(YType.uint32, "bfd-interval")

                                            self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bfd_detection_multiplier",
                                                            "bfd_interval",
                                                            "bfd_intf_enable_mode") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bfd_detection_multiplier.is_set or
                                                self.bfd_interval.is_set or
                                                self.bfd_intf_enable_mode.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bfd_detection_multiplier.yfilter != YFilter.not_set or
                                                self.bfd_interval.yfilter != YFilter.not_set or
                                                self.bfd_intf_enable_mode.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "interface-bfd" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bfd_detection_multiplier.is_set or self.bfd_detection_multiplier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bfd_detection_multiplier.get_name_leafdata())
                                            if (self.bfd_interval.is_set or self.bfd_interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bfd_interval.get_name_leafdata())
                                            if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bfd-detection-multiplier" or name == "bfd-interval" or name == "bfd-intf-enable-mode"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bfd-detection-multiplier"):
                                                self.bfd_detection_multiplier = value
                                                self.bfd_detection_multiplier.value_namespace = name_space
                                                self.bfd_detection_multiplier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bfd-interval"):
                                                self.bfd_interval = value
                                                self.bfd_interval.value_namespace = name_space
                                                self.bfd_interval.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bfd-intf-enable-mode"):
                                                self.bfd_intf_enable_mode = value
                                                self.bfd_intf_enable_mode.value_namespace = name_space
                                                self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix


                                    class InterfaceNeighbor(Entity):
                                        """
                                        Information for neighbors on the interface
                                        
                                        .. attribute:: interface_neighbor_cost
                                        
                                        	Cost of link to neighbor
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface_neighbor_id
                                        
                                        	Neighbor router ID 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: is_hello_suppressed
                                        
                                        	If true, hello is suppressed 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_bdr
                                        
                                        	If true, backup designated router is found 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_dr
                                        
                                        	If true, designated router is found 
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceNeighbor, self).__init__()

                                            self.yang_name = "interface-neighbor"
                                            self.yang_parent_name = "interface"

                                            self.interface_neighbor_cost = YLeaf(YType.uint32, "interface-neighbor-cost")

                                            self.interface_neighbor_id = YLeaf(YType.str, "interface-neighbor-id")

                                            self.is_hello_suppressed = YLeaf(YType.boolean, "is-hello-suppressed")

                                            self.is_neighbor_bdr = YLeaf(YType.boolean, "is-neighbor-bdr")

                                            self.is_neighbor_dr = YLeaf(YType.boolean, "is-neighbor-dr")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_neighbor_cost",
                                                            "interface_neighbor_id",
                                                            "is_hello_suppressed",
                                                            "is_neighbor_bdr",
                                                            "is_neighbor_dr") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceNeighbor, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceNeighbor, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.interface_neighbor_cost.is_set or
                                                self.interface_neighbor_id.is_set or
                                                self.is_hello_suppressed.is_set or
                                                self.is_neighbor_bdr.is_set or
                                                self.is_neighbor_dr.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_neighbor_cost.yfilter != YFilter.not_set or
                                                self.interface_neighbor_id.yfilter != YFilter.not_set or
                                                self.is_hello_suppressed.yfilter != YFilter.not_set or
                                                self.is_neighbor_bdr.yfilter != YFilter.not_set or
                                                self.is_neighbor_dr.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "interface-neighbor" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_neighbor_cost.is_set or self.interface_neighbor_cost.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_neighbor_cost.get_name_leafdata())
                                            if (self.interface_neighbor_id.is_set or self.interface_neighbor_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_neighbor_id.get_name_leafdata())
                                            if (self.is_hello_suppressed.is_set or self.is_hello_suppressed.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_hello_suppressed.get_name_leafdata())
                                            if (self.is_neighbor_bdr.is_set or self.is_neighbor_bdr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_bdr.get_name_leafdata())
                                            if (self.is_neighbor_dr.is_set or self.is_neighbor_dr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_dr.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface-neighbor-cost" or name == "interface-neighbor-id" or name == "is-hello-suppressed" or name == "is-neighbor-bdr" or name == "is-neighbor-dr"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-neighbor-cost"):
                                                self.interface_neighbor_cost = value
                                                self.interface_neighbor_cost.value_namespace = name_space
                                                self.interface_neighbor_cost.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-neighbor-id"):
                                                self.interface_neighbor_id = value
                                                self.interface_neighbor_id.value_namespace = name_space
                                                self.interface_neighbor_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-hello-suppressed"):
                                                self.is_hello_suppressed = value
                                                self.is_hello_suppressed.value_namespace = name_space
                                                self.is_hello_suppressed.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-bdr"):
                                                self.is_neighbor_bdr = value
                                                self.is_neighbor_bdr.value_namespace = name_space
                                                self.is_neighbor_bdr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-dr"):
                                                self.is_neighbor_dr = value
                                                self.is_neighbor_dr.value_namespace = name_space
                                                self.is_neighbor_dr.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.interface_neighbor:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.adjacent_neighbor.is_set or
                                            self.backup_designated_router_address.is_set or
                                            self.backup_designated_router_id.is_set or
                                            self.configured_ldp_sync.is_set or
                                            self.dead_interval.is_set or
                                            self.designated_router_address.is_set or
                                            self.designated_router_id.is_set or
                                            self.hello_interval.is_set or
                                            self.interface_address.is_set or
                                            self.interface_authentication_spi.is_set or
                                            self.interface_authentication_transmit.is_set or
                                            self.interface_dc_bitless_ls_as.is_set or
                                            self.interface_encrypted_authentication_transmitted.is_set or
                                            self.interface_encryption_spi.is_set or
                                            self.interface_encryption_transmitted.is_set or
                                            self.interface_ldp_sync.is_set or
                                            self.interface_link_cost.is_set or
                                            self.interface_number.is_set or
                                            self.interface_priority.is_set or
                                            self.interface_references.is_set or
                                            self.interface_retransmission_interval.is_set or
                                            self.interface_router_id.is_set or
                                            self.interface_state.is_set or
                                            self.is_demand_circuit_configured.is_set or
                                            self.is_designated_router.is_set or
                                            self.is_interface_demand_circuit.is_set or
                                            self.is_interface_encryption_enabled.is_set or
                                            self.is_interface_flood_reduction.is_set or
                                            self.is_interface_ip_security_active.is_set or
                                            self.is_interface_ip_security_required.is_set or
                                            self.is_interface_line_up.is_set or
                                            self.is_interface_lsa_filtered.is_set or
                                            self.is_prefix_suppress.is_set or
                                            self.network_lsa_flush_timer.is_set or
                                            self.network_type.is_set or
                                            self.next_hello_time.is_set or
                                            self.ospf_interface_state.is_set or
                                            self.transmission_delay.is_set or
                                            self.wait_interval.is_set or
                                            (self.active_interface is not None and self.active_interface.has_data()) or
                                            (self.interface_bfd is not None and self.interface_bfd.has_data()))

                                    def has_operation(self):
                                        for c in self.interface_neighbor:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.adjacent_neighbor.yfilter != YFilter.not_set or
                                            self.backup_designated_router_address.yfilter != YFilter.not_set or
                                            self.backup_designated_router_id.yfilter != YFilter.not_set or
                                            self.configured_ldp_sync.yfilter != YFilter.not_set or
                                            self.dead_interval.yfilter != YFilter.not_set or
                                            self.designated_router_address.yfilter != YFilter.not_set or
                                            self.designated_router_id.yfilter != YFilter.not_set or
                                            self.hello_interval.yfilter != YFilter.not_set or
                                            self.interface_address.yfilter != YFilter.not_set or
                                            self.interface_authentication_spi.yfilter != YFilter.not_set or
                                            self.interface_authentication_transmit.yfilter != YFilter.not_set or
                                            self.interface_dc_bitless_ls_as.yfilter != YFilter.not_set or
                                            self.interface_encrypted_authentication_transmitted.yfilter != YFilter.not_set or
                                            self.interface_encryption_spi.yfilter != YFilter.not_set or
                                            self.interface_encryption_transmitted.yfilter != YFilter.not_set or
                                            self.interface_ldp_sync.yfilter != YFilter.not_set or
                                            self.interface_link_cost.yfilter != YFilter.not_set or
                                            self.interface_number.yfilter != YFilter.not_set or
                                            self.interface_priority.yfilter != YFilter.not_set or
                                            self.interface_references.yfilter != YFilter.not_set or
                                            self.interface_retransmission_interval.yfilter != YFilter.not_set or
                                            self.interface_router_id.yfilter != YFilter.not_set or
                                            self.interface_state.yfilter != YFilter.not_set or
                                            self.is_demand_circuit_configured.yfilter != YFilter.not_set or
                                            self.is_designated_router.yfilter != YFilter.not_set or
                                            self.is_interface_demand_circuit.yfilter != YFilter.not_set or
                                            self.is_interface_encryption_enabled.yfilter != YFilter.not_set or
                                            self.is_interface_flood_reduction.yfilter != YFilter.not_set or
                                            self.is_interface_ip_security_active.yfilter != YFilter.not_set or
                                            self.is_interface_ip_security_required.yfilter != YFilter.not_set or
                                            self.is_interface_line_up.yfilter != YFilter.not_set or
                                            self.is_interface_lsa_filtered.yfilter != YFilter.not_set or
                                            self.is_prefix_suppress.yfilter != YFilter.not_set or
                                            self.network_lsa_flush_timer.yfilter != YFilter.not_set or
                                            self.network_type.yfilter != YFilter.not_set or
                                            self.next_hello_time.yfilter != YFilter.not_set or
                                            self.ospf_interface_state.yfilter != YFilter.not_set or
                                            self.transmission_delay.yfilter != YFilter.not_set or
                                            self.wait_interval.yfilter != YFilter.not_set or
                                            (self.active_interface is not None and self.active_interface.has_operation()) or
                                            (self.interface_bfd is not None and self.interface_bfd.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.adjacent_neighbor.is_set or self.adjacent_neighbor.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.adjacent_neighbor.get_name_leafdata())
                                        if (self.backup_designated_router_address.is_set or self.backup_designated_router_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_designated_router_address.get_name_leafdata())
                                        if (self.backup_designated_router_id.is_set or self.backup_designated_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_designated_router_id.get_name_leafdata())
                                        if (self.configured_ldp_sync.is_set or self.configured_ldp_sync.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_ldp_sync.get_name_leafdata())
                                        if (self.dead_interval.is_set or self.dead_interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dead_interval.get_name_leafdata())
                                        if (self.designated_router_address.is_set or self.designated_router_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.designated_router_address.get_name_leafdata())
                                        if (self.designated_router_id.is_set or self.designated_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.designated_router_id.get_name_leafdata())
                                        if (self.hello_interval.is_set or self.hello_interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hello_interval.get_name_leafdata())
                                        if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_address.get_name_leafdata())
                                        if (self.interface_authentication_spi.is_set or self.interface_authentication_spi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_authentication_spi.get_name_leafdata())
                                        if (self.interface_authentication_transmit.is_set or self.interface_authentication_transmit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_authentication_transmit.get_name_leafdata())
                                        if (self.interface_dc_bitless_ls_as.is_set or self.interface_dc_bitless_ls_as.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_dc_bitless_ls_as.get_name_leafdata())
                                        if (self.interface_encrypted_authentication_transmitted.is_set or self.interface_encrypted_authentication_transmitted.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_encrypted_authentication_transmitted.get_name_leafdata())
                                        if (self.interface_encryption_spi.is_set or self.interface_encryption_spi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_encryption_spi.get_name_leafdata())
                                        if (self.interface_encryption_transmitted.is_set or self.interface_encryption_transmitted.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_encryption_transmitted.get_name_leafdata())
                                        if (self.interface_ldp_sync.is_set or self.interface_ldp_sync.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_ldp_sync.get_name_leafdata())
                                        if (self.interface_link_cost.is_set or self.interface_link_cost.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_link_cost.get_name_leafdata())
                                        if (self.interface_number.is_set or self.interface_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_number.get_name_leafdata())
                                        if (self.interface_priority.is_set or self.interface_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_priority.get_name_leafdata())
                                        if (self.interface_references.is_set or self.interface_references.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_references.get_name_leafdata())
                                        if (self.interface_retransmission_interval.is_set or self.interface_retransmission_interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_retransmission_interval.get_name_leafdata())
                                        if (self.interface_router_id.is_set or self.interface_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_router_id.get_name_leafdata())
                                        if (self.interface_state.is_set or self.interface_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_state.get_name_leafdata())
                                        if (self.is_demand_circuit_configured.is_set or self.is_demand_circuit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_demand_circuit_configured.get_name_leafdata())
                                        if (self.is_designated_router.is_set or self.is_designated_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_designated_router.get_name_leafdata())
                                        if (self.is_interface_demand_circuit.is_set or self.is_interface_demand_circuit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_demand_circuit.get_name_leafdata())
                                        if (self.is_interface_encryption_enabled.is_set or self.is_interface_encryption_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_encryption_enabled.get_name_leafdata())
                                        if (self.is_interface_flood_reduction.is_set or self.is_interface_flood_reduction.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_flood_reduction.get_name_leafdata())
                                        if (self.is_interface_ip_security_active.is_set or self.is_interface_ip_security_active.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_ip_security_active.get_name_leafdata())
                                        if (self.is_interface_ip_security_required.is_set or self.is_interface_ip_security_required.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_ip_security_required.get_name_leafdata())
                                        if (self.is_interface_line_up.is_set or self.is_interface_line_up.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_line_up.get_name_leafdata())
                                        if (self.is_interface_lsa_filtered.is_set or self.is_interface_lsa_filtered.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_lsa_filtered.get_name_leafdata())
                                        if (self.is_prefix_suppress.is_set or self.is_prefix_suppress.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prefix_suppress.get_name_leafdata())
                                        if (self.network_lsa_flush_timer.is_set or self.network_lsa_flush_timer.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.network_lsa_flush_timer.get_name_leafdata())
                                        if (self.network_type.is_set or self.network_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.network_type.get_name_leafdata())
                                        if (self.next_hello_time.is_set or self.next_hello_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hello_time.get_name_leafdata())
                                        if (self.ospf_interface_state.is_set or self.ospf_interface_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ospf_interface_state.get_name_leafdata())
                                        if (self.transmission_delay.is_set or self.transmission_delay.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmission_delay.get_name_leafdata())
                                        if (self.wait_interval.is_set or self.wait_interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_interval.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "active-interface"):
                                            if (self.active_interface is None):
                                                self.active_interface = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.ActiveInterface()
                                                self.active_interface.parent = self
                                                self._children_name_map["active_interface"] = "active-interface"
                                            return self.active_interface

                                        if (child_yang_name == "interface-bfd"):
                                            if (self.interface_bfd is None):
                                                self.interface_bfd = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd()
                                                self.interface_bfd.parent = self
                                                self._children_name_map["interface_bfd"] = "interface-bfd"
                                            return self.interface_bfd

                                        if (child_yang_name == "interface-neighbor"):
                                            for c in self.interface_neighbor:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface.InterfaceNeighbor()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.interface_neighbor.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "active-interface" or name == "interface-bfd" or name == "interface-neighbor" or name == "interface-name" or name == "adjacent-neighbor" or name == "backup-designated-router-address" or name == "backup-designated-router-id" or name == "configured-ldp-sync" or name == "dead-interval" or name == "designated-router-address" or name == "designated-router-id" or name == "hello-interval" or name == "interface-address" or name == "interface-authentication-spi" or name == "interface-authentication-transmit" or name == "interface-dc-bitless-ls-as" or name == "interface-encrypted-authentication-transmitted" or name == "interface-encryption-spi" or name == "interface-encryption-transmitted" or name == "interface-ldp-sync" or name == "interface-link-cost" or name == "interface-number" or name == "interface-priority" or name == "interface-references" or name == "interface-retransmission-interval" or name == "interface-router-id" or name == "interface-state" or name == "is-demand-circuit-configured" or name == "is-designated-router" or name == "is-interface-demand-circuit" or name == "is-interface-encryption-enabled" or name == "is-interface-flood-reduction" or name == "is-interface-ip-security-active" or name == "is-interface-ip-security-required" or name == "is-interface-line-up" or name == "is-interface-lsa-filtered" or name == "is-prefix-suppress" or name == "network-lsa-flush-timer" or name == "network-type" or name == "next-hello-time" or name == "ospf-interface-state" or name == "transmission-delay" or name == "wait-interval"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "adjacent-neighbor"):
                                            self.adjacent_neighbor = value
                                            self.adjacent_neighbor.value_namespace = name_space
                                            self.adjacent_neighbor.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-designated-router-address"):
                                            self.backup_designated_router_address = value
                                            self.backup_designated_router_address.value_namespace = name_space
                                            self.backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-designated-router-id"):
                                            self.backup_designated_router_id = value
                                            self.backup_designated_router_id.value_namespace = name_space
                                            self.backup_designated_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-ldp-sync"):
                                            self.configured_ldp_sync = value
                                            self.configured_ldp_sync.value_namespace = name_space
                                            self.configured_ldp_sync.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dead-interval"):
                                            self.dead_interval = value
                                            self.dead_interval.value_namespace = name_space
                                            self.dead_interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "designated-router-address"):
                                            self.designated_router_address = value
                                            self.designated_router_address.value_namespace = name_space
                                            self.designated_router_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "designated-router-id"):
                                            self.designated_router_id = value
                                            self.designated_router_id.value_namespace = name_space
                                            self.designated_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hello-interval"):
                                            self.hello_interval = value
                                            self.hello_interval.value_namespace = name_space
                                            self.hello_interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-address"):
                                            self.interface_address = value
                                            self.interface_address.value_namespace = name_space
                                            self.interface_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-authentication-spi"):
                                            self.interface_authentication_spi = value
                                            self.interface_authentication_spi.value_namespace = name_space
                                            self.interface_authentication_spi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-authentication-transmit"):
                                            self.interface_authentication_transmit = value
                                            self.interface_authentication_transmit.value_namespace = name_space
                                            self.interface_authentication_transmit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-dc-bitless-ls-as"):
                                            self.interface_dc_bitless_ls_as = value
                                            self.interface_dc_bitless_ls_as.value_namespace = name_space
                                            self.interface_dc_bitless_ls_as.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-encrypted-authentication-transmitted"):
                                            self.interface_encrypted_authentication_transmitted = value
                                            self.interface_encrypted_authentication_transmitted.value_namespace = name_space
                                            self.interface_encrypted_authentication_transmitted.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-encryption-spi"):
                                            self.interface_encryption_spi = value
                                            self.interface_encryption_spi.value_namespace = name_space
                                            self.interface_encryption_spi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-encryption-transmitted"):
                                            self.interface_encryption_transmitted = value
                                            self.interface_encryption_transmitted.value_namespace = name_space
                                            self.interface_encryption_transmitted.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-ldp-sync"):
                                            self.interface_ldp_sync = value
                                            self.interface_ldp_sync.value_namespace = name_space
                                            self.interface_ldp_sync.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-link-cost"):
                                            self.interface_link_cost = value
                                            self.interface_link_cost.value_namespace = name_space
                                            self.interface_link_cost.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-number"):
                                            self.interface_number = value
                                            self.interface_number.value_namespace = name_space
                                            self.interface_number.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-priority"):
                                            self.interface_priority = value
                                            self.interface_priority.value_namespace = name_space
                                            self.interface_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-references"):
                                            self.interface_references = value
                                            self.interface_references.value_namespace = name_space
                                            self.interface_references.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-retransmission-interval"):
                                            self.interface_retransmission_interval = value
                                            self.interface_retransmission_interval.value_namespace = name_space
                                            self.interface_retransmission_interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-router-id"):
                                            self.interface_router_id = value
                                            self.interface_router_id.value_namespace = name_space
                                            self.interface_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-state"):
                                            self.interface_state = value
                                            self.interface_state.value_namespace = name_space
                                            self.interface_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-demand-circuit-configured"):
                                            self.is_demand_circuit_configured = value
                                            self.is_demand_circuit_configured.value_namespace = name_space
                                            self.is_demand_circuit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-designated-router"):
                                            self.is_designated_router = value
                                            self.is_designated_router.value_namespace = name_space
                                            self.is_designated_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-demand-circuit"):
                                            self.is_interface_demand_circuit = value
                                            self.is_interface_demand_circuit.value_namespace = name_space
                                            self.is_interface_demand_circuit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-encryption-enabled"):
                                            self.is_interface_encryption_enabled = value
                                            self.is_interface_encryption_enabled.value_namespace = name_space
                                            self.is_interface_encryption_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-flood-reduction"):
                                            self.is_interface_flood_reduction = value
                                            self.is_interface_flood_reduction.value_namespace = name_space
                                            self.is_interface_flood_reduction.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-ip-security-active"):
                                            self.is_interface_ip_security_active = value
                                            self.is_interface_ip_security_active.value_namespace = name_space
                                            self.is_interface_ip_security_active.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-ip-security-required"):
                                            self.is_interface_ip_security_required = value
                                            self.is_interface_ip_security_required.value_namespace = name_space
                                            self.is_interface_ip_security_required.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-line-up"):
                                            self.is_interface_line_up = value
                                            self.is_interface_line_up.value_namespace = name_space
                                            self.is_interface_line_up.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-lsa-filtered"):
                                            self.is_interface_lsa_filtered = value
                                            self.is_interface_lsa_filtered.value_namespace = name_space
                                            self.is_interface_lsa_filtered.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prefix-suppress"):
                                            self.is_prefix_suppress = value
                                            self.is_prefix_suppress.value_namespace = name_space
                                            self.is_prefix_suppress.value_namespace_prefix = name_space_prefix
                                        if(value_path == "network-lsa-flush-timer"):
                                            self.network_lsa_flush_timer = value
                                            self.network_lsa_flush_timer.value_namespace = name_space
                                            self.network_lsa_flush_timer.value_namespace_prefix = name_space_prefix
                                        if(value_path == "network-type"):
                                            self.network_type = value
                                            self.network_type.value_namespace = name_space
                                            self.network_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hello-time"):
                                            self.next_hello_time = value
                                            self.next_hello_time.value_namespace = name_space
                                            self.next_hello_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ospf-interface-state"):
                                            self.ospf_interface_state = value
                                            self.ospf_interface_state.value_namespace = name_space
                                            self.ospf_interface_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmission-delay"):
                                            self.transmission_delay = value
                                            self.transmission_delay.value_namespace = name_space
                                            self.transmission_delay.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-interval"):
                                            self.wait_interval = value
                                            self.wait_interval.value_namespace = name_space
                                            self.wait_interval.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.interface:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.interface:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "interface"):
                                        for c in self.interface:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable.Interface()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.interface.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class FloodListTable(Entity):
                                """
                                OSPFv3 flood list information table for an
                                area
                                
                                .. attribute:: flood
                                
                                	OSPFv3 flood list information
                                	**type**\: list of    :py:class:`Flood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable, self).__init__()

                                    self.yang_name = "flood-list-table"
                                    self.yang_parent_name = "area"

                                    self.flood = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable, self).__setattr__(name, value)


                                class Flood(Entity):
                                    """
                                    OSPFv3 flood list information
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: area_flood
                                    
                                    	Area scope floodlist
                                    	**type**\: list of    :py:class:`AreaFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.AreaFlood>`
                                    
                                    .. attribute:: as_flood
                                    
                                    	AS scope floodlist
                                    	**type**\: list of    :py:class:`AsFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.AsFlood>`
                                    
                                    .. attribute:: link_flood
                                    
                                    	Link floodlist
                                    	**type**\: list of    :py:class:`LinkFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.LinkFlood>`
                                    
                                    .. attribute:: ls_transmission_timer
                                    
                                    	Time until next LS transmission (ms) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_length
                                    
                                    	Number of LSAs currently being flooded 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood, self).__init__()

                                        self.yang_name = "flood"
                                        self.yang_parent_name = "flood-list-table"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.ls_transmission_timer = YLeaf(YType.uint32, "ls-transmission-timer")

                                        self.queue_length = YLeaf(YType.uint32, "queue-length")

                                        self.area_flood = YList(self)
                                        self.as_flood = YList(self)
                                        self.link_flood = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "ls_transmission_timer",
                                                        "queue_length") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood, self).__setattr__(name, value)


                                    class LinkFlood(Entity):
                                        """
                                        Link floodlist
                                        
                                        .. attribute:: header_advertising_router
                                        
                                        	Router ID of the advertising router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_age
                                        
                                        	Age of the LSA (seconds)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: header_lsa_id
                                        
                                        	LSA ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_type
                                        
                                        	LSA type
                                        	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                        
                                        .. attribute:: header_sequence_number
                                        
                                        	Current LSA sequence number
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.LinkFlood, self).__init__()

                                            self.yang_name = "link-flood"
                                            self.yang_parent_name = "flood"

                                            self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                            self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                            self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                            self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                            self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("header_advertising_router",
                                                            "header_lsa_age",
                                                            "header_lsa_id",
                                                            "header_lsa_type",
                                                            "header_sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.LinkFlood, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.LinkFlood, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.header_advertising_router.is_set or
                                                self.header_lsa_age.is_set or
                                                self.header_lsa_id.is_set or
                                                self.header_lsa_type.is_set or
                                                self.header_sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.header_advertising_router.yfilter != YFilter.not_set or
                                                self.header_lsa_age.yfilter != YFilter.not_set or
                                                self.header_lsa_id.yfilter != YFilter.not_set or
                                                self.header_lsa_type.yfilter != YFilter.not_set or
                                                self.header_sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-flood" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                            if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                            if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                            if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                            if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "header-advertising-router"):
                                                self.header_advertising_router = value
                                                self.header_advertising_router.value_namespace = name_space
                                                self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-age"):
                                                self.header_lsa_age = value
                                                self.header_lsa_age.value_namespace = name_space
                                                self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-id"):
                                                self.header_lsa_id = value
                                                self.header_lsa_id.value_namespace = name_space
                                                self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-type"):
                                                self.header_lsa_type = value
                                                self.header_lsa_type.value_namespace = name_space
                                                self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-sequence-number"):
                                                self.header_sequence_number = value
                                                self.header_sequence_number.value_namespace = name_space
                                                self.header_sequence_number.value_namespace_prefix = name_space_prefix


                                    class AreaFlood(Entity):
                                        """
                                        Area scope floodlist
                                        
                                        .. attribute:: header_advertising_router
                                        
                                        	Router ID of the advertising router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_age
                                        
                                        	Age of the LSA (seconds)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: header_lsa_id
                                        
                                        	LSA ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_type
                                        
                                        	LSA type
                                        	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                        
                                        .. attribute:: header_sequence_number
                                        
                                        	Current LSA sequence number
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.AreaFlood, self).__init__()

                                            self.yang_name = "area-flood"
                                            self.yang_parent_name = "flood"

                                            self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                            self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                            self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                            self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                            self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("header_advertising_router",
                                                            "header_lsa_age",
                                                            "header_lsa_id",
                                                            "header_lsa_type",
                                                            "header_sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.AreaFlood, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.AreaFlood, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.header_advertising_router.is_set or
                                                self.header_lsa_age.is_set or
                                                self.header_lsa_id.is_set or
                                                self.header_lsa_type.is_set or
                                                self.header_sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.header_advertising_router.yfilter != YFilter.not_set or
                                                self.header_lsa_age.yfilter != YFilter.not_set or
                                                self.header_lsa_id.yfilter != YFilter.not_set or
                                                self.header_lsa_type.yfilter != YFilter.not_set or
                                                self.header_sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "area-flood" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                            if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                            if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                            if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                            if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "header-advertising-router"):
                                                self.header_advertising_router = value
                                                self.header_advertising_router.value_namespace = name_space
                                                self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-age"):
                                                self.header_lsa_age = value
                                                self.header_lsa_age.value_namespace = name_space
                                                self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-id"):
                                                self.header_lsa_id = value
                                                self.header_lsa_id.value_namespace = name_space
                                                self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-type"):
                                                self.header_lsa_type = value
                                                self.header_lsa_type.value_namespace = name_space
                                                self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-sequence-number"):
                                                self.header_sequence_number = value
                                                self.header_sequence_number.value_namespace = name_space
                                                self.header_sequence_number.value_namespace_prefix = name_space_prefix


                                    class AsFlood(Entity):
                                        """
                                        AS scope floodlist
                                        
                                        .. attribute:: header_advertising_router
                                        
                                        	Router ID of the advertising router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_age
                                        
                                        	Age of the LSA (seconds)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: header_lsa_id
                                        
                                        	LSA ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_type
                                        
                                        	LSA type
                                        	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                        
                                        .. attribute:: header_sequence_number
                                        
                                        	Current LSA sequence number
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.AsFlood, self).__init__()

                                            self.yang_name = "as-flood"
                                            self.yang_parent_name = "flood"

                                            self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                            self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                            self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                            self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                            self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("header_advertising_router",
                                                            "header_lsa_age",
                                                            "header_lsa_id",
                                                            "header_lsa_type",
                                                            "header_sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.AsFlood, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.AsFlood, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.header_advertising_router.is_set or
                                                self.header_lsa_age.is_set or
                                                self.header_lsa_id.is_set or
                                                self.header_lsa_type.is_set or
                                                self.header_sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.header_advertising_router.yfilter != YFilter.not_set or
                                                self.header_lsa_age.yfilter != YFilter.not_set or
                                                self.header_lsa_id.yfilter != YFilter.not_set or
                                                self.header_lsa_type.yfilter != YFilter.not_set or
                                                self.header_sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "as-flood" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                            if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                            if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                            if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                            if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "header-advertising-router"):
                                                self.header_advertising_router = value
                                                self.header_advertising_router.value_namespace = name_space
                                                self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-age"):
                                                self.header_lsa_age = value
                                                self.header_lsa_age.value_namespace = name_space
                                                self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-id"):
                                                self.header_lsa_id = value
                                                self.header_lsa_id.value_namespace = name_space
                                                self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-type"):
                                                self.header_lsa_type = value
                                                self.header_lsa_type.value_namespace = name_space
                                                self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-sequence-number"):
                                                self.header_sequence_number = value
                                                self.header_sequence_number.value_namespace = name_space
                                                self.header_sequence_number.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.area_flood:
                                            if (c.has_data()):
                                                return True
                                        for c in self.as_flood:
                                            if (c.has_data()):
                                                return True
                                        for c in self.link_flood:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.ls_transmission_timer.is_set or
                                            self.queue_length.is_set)

                                    def has_operation(self):
                                        for c in self.area_flood:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.as_flood:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.link_flood:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.ls_transmission_timer.yfilter != YFilter.not_set or
                                            self.queue_length.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flood" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.ls_transmission_timer.is_set or self.ls_transmission_timer.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ls_transmission_timer.get_name_leafdata())
                                        if (self.queue_length.is_set or self.queue_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_length.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "area-flood"):
                                            for c in self.area_flood:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.AreaFlood()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.area_flood.append(c)
                                            return c

                                        if (child_yang_name == "as-flood"):
                                            for c in self.as_flood:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.AsFlood()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.as_flood.append(c)
                                            return c

                                        if (child_yang_name == "link-flood"):
                                            for c in self.link_flood:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood.LinkFlood()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.link_flood.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "area-flood" or name == "as-flood" or name == "link-flood" or name == "interface-name" or name == "ls-transmission-timer" or name == "queue-length"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ls-transmission-timer"):
                                            self.ls_transmission_timer = value
                                            self.ls_transmission_timer.value_namespace = name_space
                                            self.ls_transmission_timer.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-length"):
                                            self.queue_length = value
                                            self.queue_length.value_namespace = name_space
                                            self.queue_length.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.flood:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.flood:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flood-list-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flood"):
                                        for c in self.flood:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable.Flood()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.flood.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flood"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class RetransmissionListTable(Entity):
                                """
                                OSPFv3 retransmission list information table
                                in an area
                                
                                .. attribute:: retransmission
                                
                                	OSPFv3 retransmission list information
                                	**type**\: list of    :py:class:`Retransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable, self).__init__()

                                    self.yang_name = "retransmission-list-table"
                                    self.yang_parent_name = "area"

                                    self.retransmission = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable, self).__setattr__(name, value)


                                class Retransmission(Entity):
                                    """
                                    OSPFv3 retransmission list information
                                    
                                    .. attribute:: interface_name
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_retransmission_sham_link
                                    
                                    	If true, sham link is retransmitted 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_retransmissionvirtual_link
                                    
                                    	If true, virtual link is retransmitted 
                                    	**type**\:  bool
                                    
                                    .. attribute:: neighbor_address
                                    
                                    	Neighbor address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: retransmission_area_db
                                    
                                    	List of area scope entries
                                    	**type**\: list of    :py:class:`RetransmissionAreaDb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAreaDb>`
                                    
                                    .. attribute:: retransmission_asdb
                                    
                                    	List of AS scope entries
                                    	**type**\: list of    :py:class:`RetransmissionAsdb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAsdb>`
                                    
                                    .. attribute:: retransmission_length
                                    
                                    	Retransmission queue length
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: retransmission_neighbor_address
                                    
                                    	Neighbor IP address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: retransmission_sham_link_id
                                    
                                    	Retransmission sham link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: retransmission_timer
                                    
                                    	Amount of time remaining on retransmission timer (ms)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: retransmissionvirtual_link_db
                                    
                                    	List of virtual link scope entries 
                                    	**type**\: list of    :py:class:`RetransmissionvirtualLinkDb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionvirtualLinkDb>`
                                    
                                    .. attribute:: retransmissionvirtual_link_id
                                    
                                    	Retransmission virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission, self).__init__()

                                        self.yang_name = "retransmission"
                                        self.yang_parent_name = "retransmission-list-table"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_retransmission_sham_link = YLeaf(YType.boolean, "is-retransmission-sham-link")

                                        self.is_retransmissionvirtual_link = YLeaf(YType.boolean, "is-retransmissionvirtual-link")

                                        self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                        self.retransmission_length = YLeaf(YType.uint32, "retransmission-length")

                                        self.retransmission_neighbor_address = YLeaf(YType.str, "retransmission-neighbor-address")

                                        self.retransmission_sham_link_id = YLeaf(YType.uint32, "retransmission-sham-link-id")

                                        self.retransmission_timer = YLeaf(YType.uint32, "retransmission-timer")

                                        self.retransmissionvirtual_link_id = YLeaf(YType.uint32, "retransmissionvirtual-link-id")

                                        self.retransmission_area_db = YList(self)
                                        self.retransmission_asdb = YList(self)
                                        self.retransmissionvirtual_link_db = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_retransmission_sham_link",
                                                        "is_retransmissionvirtual_link",
                                                        "neighbor_address",
                                                        "retransmission_length",
                                                        "retransmission_neighbor_address",
                                                        "retransmission_sham_link_id",
                                                        "retransmission_timer",
                                                        "retransmissionvirtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission, self).__setattr__(name, value)


                                    class RetransmissionvirtualLinkDb(Entity):
                                        """
                                        List of virtual link scope entries 
                                        
                                        .. attribute:: header_advertising_router
                                        
                                        	Router ID of the advertising router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_age
                                        
                                        	Age of the LSA (seconds)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: header_lsa_id
                                        
                                        	LSA ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_type
                                        
                                        	LSA type
                                        	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                        
                                        .. attribute:: header_sequence_number
                                        
                                        	Current LSA sequence number
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionvirtualLinkDb, self).__init__()

                                            self.yang_name = "retransmissionvirtual-link-db"
                                            self.yang_parent_name = "retransmission"

                                            self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                            self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                            self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                            self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                            self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("header_advertising_router",
                                                            "header_lsa_age",
                                                            "header_lsa_id",
                                                            "header_lsa_type",
                                                            "header_sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionvirtualLinkDb, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionvirtualLinkDb, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.header_advertising_router.is_set or
                                                self.header_lsa_age.is_set or
                                                self.header_lsa_id.is_set or
                                                self.header_lsa_type.is_set or
                                                self.header_sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.header_advertising_router.yfilter != YFilter.not_set or
                                                self.header_lsa_age.yfilter != YFilter.not_set or
                                                self.header_lsa_id.yfilter != YFilter.not_set or
                                                self.header_lsa_type.yfilter != YFilter.not_set or
                                                self.header_sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "retransmissionvirtual-link-db" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                            if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                            if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                            if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                            if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "header-advertising-router"):
                                                self.header_advertising_router = value
                                                self.header_advertising_router.value_namespace = name_space
                                                self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-age"):
                                                self.header_lsa_age = value
                                                self.header_lsa_age.value_namespace = name_space
                                                self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-id"):
                                                self.header_lsa_id = value
                                                self.header_lsa_id.value_namespace = name_space
                                                self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-type"):
                                                self.header_lsa_type = value
                                                self.header_lsa_type.value_namespace = name_space
                                                self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-sequence-number"):
                                                self.header_sequence_number = value
                                                self.header_sequence_number.value_namespace = name_space
                                                self.header_sequence_number.value_namespace_prefix = name_space_prefix


                                    class RetransmissionAreaDb(Entity):
                                        """
                                        List of area scope entries
                                        
                                        .. attribute:: header_advertising_router
                                        
                                        	Router ID of the advertising router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_age
                                        
                                        	Age of the LSA (seconds)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: header_lsa_id
                                        
                                        	LSA ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_type
                                        
                                        	LSA type
                                        	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                        
                                        .. attribute:: header_sequence_number
                                        
                                        	Current LSA sequence number
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAreaDb, self).__init__()

                                            self.yang_name = "retransmission-area-db"
                                            self.yang_parent_name = "retransmission"

                                            self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                            self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                            self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                            self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                            self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("header_advertising_router",
                                                            "header_lsa_age",
                                                            "header_lsa_id",
                                                            "header_lsa_type",
                                                            "header_sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAreaDb, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAreaDb, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.header_advertising_router.is_set or
                                                self.header_lsa_age.is_set or
                                                self.header_lsa_id.is_set or
                                                self.header_lsa_type.is_set or
                                                self.header_sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.header_advertising_router.yfilter != YFilter.not_set or
                                                self.header_lsa_age.yfilter != YFilter.not_set or
                                                self.header_lsa_id.yfilter != YFilter.not_set or
                                                self.header_lsa_type.yfilter != YFilter.not_set or
                                                self.header_sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "retransmission-area-db" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                            if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                            if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                            if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                            if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "header-advertising-router"):
                                                self.header_advertising_router = value
                                                self.header_advertising_router.value_namespace = name_space
                                                self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-age"):
                                                self.header_lsa_age = value
                                                self.header_lsa_age.value_namespace = name_space
                                                self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-id"):
                                                self.header_lsa_id = value
                                                self.header_lsa_id.value_namespace = name_space
                                                self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-type"):
                                                self.header_lsa_type = value
                                                self.header_lsa_type.value_namespace = name_space
                                                self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-sequence-number"):
                                                self.header_sequence_number = value
                                                self.header_sequence_number.value_namespace = name_space
                                                self.header_sequence_number.value_namespace_prefix = name_space_prefix


                                    class RetransmissionAsdb(Entity):
                                        """
                                        List of AS scope entries
                                        
                                        .. attribute:: header_advertising_router
                                        
                                        	Router ID of the advertising router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_age
                                        
                                        	Age of the LSA (seconds)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: header_lsa_id
                                        
                                        	LSA ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: header_lsa_type
                                        
                                        	LSA type
                                        	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                        
                                        .. attribute:: header_sequence_number
                                        
                                        	Current LSA sequence number
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAsdb, self).__init__()

                                            self.yang_name = "retransmission-asdb"
                                            self.yang_parent_name = "retransmission"

                                            self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                            self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                            self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                            self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                            self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("header_advertising_router",
                                                            "header_lsa_age",
                                                            "header_lsa_id",
                                                            "header_lsa_type",
                                                            "header_sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAsdb, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAsdb, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.header_advertising_router.is_set or
                                                self.header_lsa_age.is_set or
                                                self.header_lsa_id.is_set or
                                                self.header_lsa_type.is_set or
                                                self.header_sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.header_advertising_router.yfilter != YFilter.not_set or
                                                self.header_lsa_age.yfilter != YFilter.not_set or
                                                self.header_lsa_id.yfilter != YFilter.not_set or
                                                self.header_lsa_type.yfilter != YFilter.not_set or
                                                self.header_sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "retransmission-asdb" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                            if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                            if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                            if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                            if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "header-advertising-router"):
                                                self.header_advertising_router = value
                                                self.header_advertising_router.value_namespace = name_space
                                                self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-age"):
                                                self.header_lsa_age = value
                                                self.header_lsa_age.value_namespace = name_space
                                                self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-id"):
                                                self.header_lsa_id = value
                                                self.header_lsa_id.value_namespace = name_space
                                                self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-lsa-type"):
                                                self.header_lsa_type = value
                                                self.header_lsa_type.value_namespace = name_space
                                                self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "header-sequence-number"):
                                                self.header_sequence_number = value
                                                self.header_sequence_number.value_namespace = name_space
                                                self.header_sequence_number.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.retransmission_area_db:
                                            if (c.has_data()):
                                                return True
                                        for c in self.retransmission_asdb:
                                            if (c.has_data()):
                                                return True
                                        for c in self.retransmissionvirtual_link_db:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.is_retransmission_sham_link.is_set or
                                            self.is_retransmissionvirtual_link.is_set or
                                            self.neighbor_address.is_set or
                                            self.retransmission_length.is_set or
                                            self.retransmission_neighbor_address.is_set or
                                            self.retransmission_sham_link_id.is_set or
                                            self.retransmission_timer.is_set or
                                            self.retransmissionvirtual_link_id.is_set)

                                    def has_operation(self):
                                        for c in self.retransmission_area_db:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.retransmission_asdb:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.retransmissionvirtual_link_db:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_retransmission_sham_link.yfilter != YFilter.not_set or
                                            self.is_retransmissionvirtual_link.yfilter != YFilter.not_set or
                                            self.neighbor_address.yfilter != YFilter.not_set or
                                            self.retransmission_length.yfilter != YFilter.not_set or
                                            self.retransmission_neighbor_address.yfilter != YFilter.not_set or
                                            self.retransmission_sham_link_id.yfilter != YFilter.not_set or
                                            self.retransmission_timer.yfilter != YFilter.not_set or
                                            self.retransmissionvirtual_link_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "retransmission" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_retransmission_sham_link.is_set or self.is_retransmission_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_retransmission_sham_link.get_name_leafdata())
                                        if (self.is_retransmissionvirtual_link.is_set or self.is_retransmissionvirtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_retransmissionvirtual_link.get_name_leafdata())
                                        if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                        if (self.retransmission_length.is_set or self.retransmission_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.retransmission_length.get_name_leafdata())
                                        if (self.retransmission_neighbor_address.is_set or self.retransmission_neighbor_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.retransmission_neighbor_address.get_name_leafdata())
                                        if (self.retransmission_sham_link_id.is_set or self.retransmission_sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.retransmission_sham_link_id.get_name_leafdata())
                                        if (self.retransmission_timer.is_set or self.retransmission_timer.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.retransmission_timer.get_name_leafdata())
                                        if (self.retransmissionvirtual_link_id.is_set or self.retransmissionvirtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.retransmissionvirtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "retransmission-area-db"):
                                            for c in self.retransmission_area_db:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAreaDb()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.retransmission_area_db.append(c)
                                            return c

                                        if (child_yang_name == "retransmission-asdb"):
                                            for c in self.retransmission_asdb:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAsdb()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.retransmission_asdb.append(c)
                                            return c

                                        if (child_yang_name == "retransmissionvirtual-link-db"):
                                            for c in self.retransmissionvirtual_link_db:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionvirtualLinkDb()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.retransmissionvirtual_link_db.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "retransmission-area-db" or name == "retransmission-asdb" or name == "retransmissionvirtual-link-db" or name == "interface-name" or name == "is-retransmission-sham-link" or name == "is-retransmissionvirtual-link" or name == "neighbor-address" or name == "retransmission-length" or name == "retransmission-neighbor-address" or name == "retransmission-sham-link-id" or name == "retransmission-timer" or name == "retransmissionvirtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-retransmission-sham-link"):
                                            self.is_retransmission_sham_link = value
                                            self.is_retransmission_sham_link.value_namespace = name_space
                                            self.is_retransmission_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-retransmissionvirtual-link"):
                                            self.is_retransmissionvirtual_link = value
                                            self.is_retransmissionvirtual_link.value_namespace = name_space
                                            self.is_retransmissionvirtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-address"):
                                            self.neighbor_address = value
                                            self.neighbor_address.value_namespace = name_space
                                            self.neighbor_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "retransmission-length"):
                                            self.retransmission_length = value
                                            self.retransmission_length.value_namespace = name_space
                                            self.retransmission_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "retransmission-neighbor-address"):
                                            self.retransmission_neighbor_address = value
                                            self.retransmission_neighbor_address.value_namespace = name_space
                                            self.retransmission_neighbor_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "retransmission-sham-link-id"):
                                            self.retransmission_sham_link_id = value
                                            self.retransmission_sham_link_id.value_namespace = name_space
                                            self.retransmission_sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "retransmission-timer"):
                                            self.retransmission_timer = value
                                            self.retransmission_timer.value_namespace = name_space
                                            self.retransmission_timer.value_namespace_prefix = name_space_prefix
                                        if(value_path == "retransmissionvirtual-link-id"):
                                            self.retransmissionvirtual_link_id = value
                                            self.retransmissionvirtual_link_id.value_namespace = name_space
                                            self.retransmissionvirtual_link_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.retransmission:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.retransmission:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "retransmission-list-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "retransmission"):
                                        for c in self.retransmission:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable.Retransmission()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.retransmission.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "retransmission"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class DatabaseTable(Entity):
                                """
                                OSPF Link State Database
                                
                                .. attribute:: lsa_internal_table
                                
                                	Database LSA information
                                	**type**\:   :py:class:`LsaInternalTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable>`
                                
                                .. attribute:: lsa_table
                                
                                	Database LSA information
                                	**type**\:   :py:class:`LsaTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable, self).__init__()

                                    self.yang_name = "database-table"
                                    self.yang_parent_name = "area"

                                    self.lsa_internal_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable()
                                    self.lsa_internal_table.parent = self
                                    self._children_name_map["lsa_internal_table"] = "lsa-internal-table"
                                    self._children_yang_names.add("lsa-internal-table")

                                    self.lsa_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable()
                                    self.lsa_table.parent = self
                                    self._children_name_map["lsa_table"] = "lsa-table"
                                    self._children_yang_names.add("lsa-table")


                                class LsaTable(Entity):
                                    """
                                    Database LSA information
                                    
                                    .. attribute:: lsa
                                    
                                    	Database LSA information
                                    	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable, self).__init__()

                                        self.yang_name = "lsa-table"
                                        self.yang_parent_name = "database-table"

                                        self.lsa = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable, self).__setattr__(name, value)


                                    class Lsa(Entity):
                                        """
                                        Database LSA information
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Advertising Router ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: area_id
                                        
                                        	Area ID
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: interface_name
                                        
                                        	InterfaceName
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: ls_id
                                        
                                        	Link state ID
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: ls_type
                                        
                                        	LSA type
                                        	**type**\:   :py:class:`Ospfv3Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa>`
                                        
                                        .. attribute:: lsa_info
                                        
                                        	Summary of all LSAs or LSA specific information 
                                        	**type**\:   :py:class:`LsaInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa, self).__init__()

                                            self.yang_name = "lsa"
                                            self.yang_parent_name = "lsa-table"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.area_id = YLeaf(YType.int32, "area-id")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.ls_id = YLeaf(YType.int32, "ls-id")

                                            self.ls_type = YLeaf(YType.enumeration, "ls-type")

                                            self.lsa_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo()
                                            self.lsa_info.parent = self
                                            self._children_name_map["lsa_info"] = "lsa-info"
                                            self._children_yang_names.add("lsa-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "area_id",
                                                            "interface_name",
                                                            "ls_id",
                                                            "ls_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa, self).__setattr__(name, value)


                                        class LsaInfo(Entity):
                                            """
                                            Summary of all LSAs or LSA specific information 
                                            
                                            .. attribute:: external_lsa_type
                                            
                                            	External LSA
                                            	**type**\:   :py:class:`ExternalLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType>`
                                            
                                            .. attribute:: grace_lsa
                                            
                                            	Grace LSA
                                            	**type**\:   :py:class:`GraceLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa>`
                                            
                                            .. attribute:: inter_area_prefix_lsa_type
                                            
                                            	Inter Area Prefix LSA
                                            	**type**\:   :py:class:`InterAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType>`
                                            
                                            .. attribute:: inter_area_router_lsa_type
                                            
                                            	Inter Area Router LSA
                                            	**type**\:   :py:class:`InterAreaRouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType>`
                                            
                                            .. attribute:: intra_area_prefix_lsa_type
                                            
                                            	Intra Area Prefix LSA
                                            	**type**\:   :py:class:`IntraAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType>`
                                            
                                            .. attribute:: link_lsa_type
                                            
                                            	Link LSA
                                            	**type**\:   :py:class:`LinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType>`
                                            
                                            .. attribute:: lsa_info_type
                                            
                                            	LSAInfoType
                                            	**type**\:   :py:class:`Ospfv3LsaInfoTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3LsaInfoTypes>`
                                            
                                            .. attribute:: lsa_summary_info
                                            
                                            	Summary information of LSAs
                                            	**type**\:   :py:class:`LsaSummaryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo>`
                                            
                                            .. attribute:: network_lsa_type
                                            
                                            	Network LSA
                                            	**type**\:   :py:class:`NetworkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType>`
                                            
                                            .. attribute:: nssalsa_type
                                            
                                            	NSSA External LSA
                                            	**type**\:   :py:class:`NssalsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType>`
                                            
                                            .. attribute:: router_lsa_type
                                            
                                            	Router LSA
                                            	**type**\:   :py:class:`RouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType>`
                                            
                                            .. attribute:: unknown_area_lsa_type
                                            
                                            	Unknown\-Area scope LSA
                                            	**type**\:   :py:class:`UnknownAreaLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType>`
                                            
                                            .. attribute:: unknown_aslsa_type
                                            
                                            	Unknown\-AS scope LSA
                                            	**type**\:   :py:class:`UnknownAslsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType>`
                                            
                                            .. attribute:: unknown_link_lsa_type
                                            
                                            	Unknown Link Scope LSA
                                            	**type**\:   :py:class:`UnknownLinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType>`
                                            
                                            .. attribute:: unknown_lsa_type
                                            
                                            	Unknown LSA
                                            	**type**\:   :py:class:`UnknownLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__init__()

                                                self.yang_name = "lsa-info"
                                                self.yang_parent_name = "lsa"

                                                self.lsa_info_type = YLeaf(YType.enumeration, "lsa-info-type")

                                                self.external_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType()
                                                self.external_lsa_type.parent = self
                                                self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                                self._children_yang_names.add("external-lsa-type")

                                                self.grace_lsa = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa()
                                                self.grace_lsa.parent = self
                                                self._children_name_map["grace_lsa"] = "grace-lsa"
                                                self._children_yang_names.add("grace-lsa")

                                                self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                                self.inter_area_prefix_lsa_type.parent = self
                                                self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                                self._children_yang_names.add("inter-area-prefix-lsa-type")

                                                self.inter_area_router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                                self.inter_area_router_lsa_type.parent = self
                                                self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                                self._children_yang_names.add("inter-area-router-lsa-type")

                                                self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                                self.intra_area_prefix_lsa_type.parent = self
                                                self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                                self._children_yang_names.add("intra-area-prefix-lsa-type")

                                                self.link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType()
                                                self.link_lsa_type.parent = self
                                                self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                                self._children_yang_names.add("link-lsa-type")

                                                self.lsa_summary_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo()
                                                self.lsa_summary_info.parent = self
                                                self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                                self._children_yang_names.add("lsa-summary-info")

                                                self.network_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType()
                                                self.network_lsa_type.parent = self
                                                self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                                self._children_yang_names.add("network-lsa-type")

                                                self.nssalsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType()
                                                self.nssalsa_type.parent = self
                                                self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                                self._children_yang_names.add("nssalsa-type")

                                                self.router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType()
                                                self.router_lsa_type.parent = self
                                                self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                                self._children_yang_names.add("router-lsa-type")

                                                self.unknown_area_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                                self.unknown_area_lsa_type.parent = self
                                                self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                                self._children_yang_names.add("unknown-area-lsa-type")

                                                self.unknown_aslsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType()
                                                self.unknown_aslsa_type.parent = self
                                                self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                                self._children_yang_names.add("unknown-aslsa-type")

                                                self.unknown_link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                                self.unknown_link_lsa_type.parent = self
                                                self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                                self._children_yang_names.add("unknown-link-lsa-type")

                                                self.unknown_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType()
                                                self.unknown_lsa_type.parent = self
                                                self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                                self._children_yang_names.add("unknown-lsa-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("lsa_info_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__setattr__(name, value)


                                            class LsaSummaryInfo(Entity):
                                                """
                                                Summary information of LSAs
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface name 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: links
                                                
                                                	Number of links
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader>`
                                                
                                                .. attribute:: lsa_router_id
                                                
                                                	LSA router ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: prefix
                                                
                                                	OSPFv3 address Prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: prefix_length
                                                
                                                	Prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: reference_lsa_id
                                                
                                                	Reference LSA ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: reference_type
                                                
                                                	Reference type 
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: router_la_bits
                                                
                                                	Router LA bits 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Sham link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__init__()

                                                    self.yang_name = "lsa-summary-info"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.links = YLeaf(YType.uint16, "links")

                                                    self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                    self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                                    self.reference_type = YLeaf(YType.uint16, "reference-type")

                                                    self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "links",
                                                                    "lsa_router_id",
                                                                    "prefix",
                                                                    "prefix_length",
                                                                    "reference_lsa_id",
                                                                    "reference_type",
                                                                    "router_la_bits",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "lsa-summary-info"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "lsa-summary-info"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.links.is_set or
                                                        self.lsa_router_id.is_set or
                                                        self.prefix.is_set or
                                                        self.prefix_length.is_set or
                                                        self.reference_lsa_id.is_set or
                                                        self.reference_type.is_set or
                                                        self.router_la_bits.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.links.yfilter != YFilter.not_set or
                                                        self.lsa_router_id.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.prefix_length.yfilter != YFilter.not_set or
                                                        self.reference_lsa_id.yfilter != YFilter.not_set or
                                                        self.reference_type.yfilter != YFilter.not_set or
                                                        self.router_la_bits.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-summary-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.links.get_name_leafdata())
                                                    if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_router_id.get_name_leafdata())
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                    if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                                    if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.reference_type.get_name_leafdata())
                                                    if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.router_la_bits.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "links" or name == "lsa-router-id" or name == "prefix" or name == "prefix-length" or name == "reference-lsa-id" or name == "reference-type" or name == "router-la-bits" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "links"):
                                                        self.links = value
                                                        self.links.value_namespace = name_space
                                                        self.links.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-router-id"):
                                                        self.lsa_router_id = value
                                                        self.lsa_router_id.value_namespace = name_space
                                                        self.lsa_router_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-length"):
                                                        self.prefix_length = value
                                                        self.prefix_length.value_namespace = name_space
                                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "reference-lsa-id"):
                                                        self.reference_lsa_id = value
                                                        self.reference_lsa_id.value_namespace = name_space
                                                        self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "reference-type"):
                                                        self.reference_type = value
                                                        self.reference_type.value_namespace = name_space
                                                        self.reference_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "router-la-bits"):
                                                        self.router_la_bits = value
                                                        self.router_la_bits.value_namespace = name_space
                                                        self.router_la_bits.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                            class RouterLsaType(Entity):
                                                """
                                                Router LSA
                                                
                                                .. attribute:: link
                                                
                                                	List of links in this LSA
                                                	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link>`
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader>`
                                                
                                                .. attribute:: router_la_bits
                                                
                                                	Router LA bits 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: rpf_path
                                                
                                                	Router LSA Reverse\-Path Forwarding information 
                                                	**type**\:   :py:class:`RpfPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__init__()

                                                    self.yang_name = "router-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                    self.rpf_path = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                    self.rpf_path.parent = self
                                                    self._children_name_map["rpf_path"] = "rpf-path"
                                                    self._children_yang_names.add("rpf-path")

                                                    self.link = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("router_la_bits") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "router-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "router-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix


                                                class RpfPath(Entity):
                                                    """
                                                    Router LSA Reverse\-Path Forwarding information 
                                                    
                                                    .. attribute:: interface_name
                                                    
                                                    	RPF multicast IDB 
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                    
                                                    .. attribute:: rpf_multicast_next_hop
                                                    
                                                    	RPF multicast next hop 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__init__()

                                                        self.yang_name = "rpf-path"
                                                        self.yang_parent_name = "router-lsa-type"

                                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                                        self.rpf_multicast_next_hop = YLeaf(YType.uint32, "rpf-multicast-next-hop")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("interface_name",
                                                                        "rpf_multicast_next_hop") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.interface_name.is_set or
                                                            self.rpf_multicast_next_hop.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.interface_name.yfilter != YFilter.not_set or
                                                            self.rpf_multicast_next_hop.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "rpf-path" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                        if (self.rpf_multicast_next_hop.is_set or self.rpf_multicast_next_hop.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rpf_multicast_next_hop.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "interface-name" or name == "rpf-multicast-next-hop"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "interface-name"):
                                                            self.interface_name = value
                                                            self.interface_name.value_namespace = name_space
                                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rpf-multicast-next-hop"):
                                                            self.rpf_multicast_next_hop = value
                                                            self.rpf_multicast_next_hop.value_namespace = name_space
                                                            self.rpf_multicast_next_hop.value_namespace_prefix = name_space_prefix


                                                class Link(Entity):
                                                    """
                                                    List of links in this LSA
                                                    
                                                    .. attribute:: link_interface_id
                                                    
                                                    	LSA link interface ID 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: link_metric
                                                    
                                                    	LSA link metric 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: link_neighbor_interface_id
                                                    
                                                    	LSA link neighbor interface ID 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: link_neighbor_router_id
                                                    
                                                    	LSA link neigbhor router id 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: link_type
                                                    
                                                    	Type of link
                                                    	**type**\:   :py:class:`Ospfv3Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Link>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__init__()

                                                        self.yang_name = "link"
                                                        self.yang_parent_name = "router-lsa-type"

                                                        self.link_interface_id = YLeaf(YType.uint32, "link-interface-id")

                                                        self.link_metric = YLeaf(YType.uint16, "link-metric")

                                                        self.link_neighbor_interface_id = YLeaf(YType.uint32, "link-neighbor-interface-id")

                                                        self.link_neighbor_router_id = YLeaf(YType.uint32, "link-neighbor-router-id")

                                                        self.link_type = YLeaf(YType.enumeration, "link-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("link_interface_id",
                                                                        "link_metric",
                                                                        "link_neighbor_interface_id",
                                                                        "link_neighbor_router_id",
                                                                        "link_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.link_interface_id.is_set or
                                                            self.link_metric.is_set or
                                                            self.link_neighbor_interface_id.is_set or
                                                            self.link_neighbor_router_id.is_set or
                                                            self.link_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.link_interface_id.yfilter != YFilter.not_set or
                                                            self.link_metric.yfilter != YFilter.not_set or
                                                            self.link_neighbor_interface_id.yfilter != YFilter.not_set or
                                                            self.link_neighbor_router_id.yfilter != YFilter.not_set or
                                                            self.link_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "link" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.link_interface_id.is_set or self.link_interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.link_interface_id.get_name_leafdata())
                                                        if (self.link_metric.is_set or self.link_metric.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.link_metric.get_name_leafdata())
                                                        if (self.link_neighbor_interface_id.is_set or self.link_neighbor_interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.link_neighbor_interface_id.get_name_leafdata())
                                                        if (self.link_neighbor_router_id.is_set or self.link_neighbor_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.link_neighbor_router_id.get_name_leafdata())
                                                        if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.link_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "link-interface-id" or name == "link-metric" or name == "link-neighbor-interface-id" or name == "link-neighbor-router-id" or name == "link-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "link-interface-id"):
                                                            self.link_interface_id = value
                                                            self.link_interface_id.value_namespace = name_space
                                                            self.link_interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "link-metric"):
                                                            self.link_metric = value
                                                            self.link_metric.value_namespace = name_space
                                                            self.link_metric.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "link-neighbor-interface-id"):
                                                            self.link_neighbor_interface_id = value
                                                            self.link_neighbor_interface_id.value_namespace = name_space
                                                            self.link_neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "link-neighbor-router-id"):
                                                            self.link_neighbor_router_id = value
                                                            self.link_neighbor_router_id.value_namespace = name_space
                                                            self.link_neighbor_router_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "link-type"):
                                                            self.link_type = value
                                                            self.link_type.value_namespace = name_space
                                                            self.link_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.link:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.router_la_bits.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()) or
                                                        (self.rpf_path is not None and self.rpf_path.has_data()))

                                                def has_operation(self):
                                                    for c in self.link:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.router_la_bits.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()) or
                                                        (self.rpf_path is not None and self.rpf_path.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "router-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.router_la_bits.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "link"):
                                                        for c in self.link:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.link.append(c)
                                                        return c

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    if (child_yang_name == "rpf-path"):
                                                        if (self.rpf_path is None):
                                                            self.rpf_path = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                            self.rpf_path.parent = self
                                                            self._children_name_map["rpf_path"] = "rpf-path"
                                                        return self.rpf_path

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "link" or name == "lsa-detail" or name == "lsa-header" or name == "rpf-path" or name == "router-la-bits"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "router-la-bits"):
                                                        self.router_la_bits = value
                                                        self.router_la_bits.value_namespace = name_space
                                                        self.router_la_bits.value_namespace_prefix = name_space_prefix


                                            class NetworkLsaType(Entity):
                                                """
                                                Network LSA
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader>`
                                                
                                                .. attribute:: neighbor_router
                                                
                                                	Neighbor router list
                                                	**type**\:  list of str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__init__()

                                                    self.yang_name = "network-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.neighbor_router = YLeafList(YType.str, "neighbor-router")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("neighbor_router") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "network-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "network-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for leaf in self.neighbor_router.getYLeafs():
                                                        if (leaf.yfilter != YFilter.not_set):
                                                            return True
                                                    return (
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    for leaf in self.neighbor_router.getYLeafs():
                                                        if (leaf.is_set):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.neighbor_router.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "network-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    leaf_name_data.extend(self.neighbor_router.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "neighbor-router"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "neighbor-router"):
                                                        self.neighbor_router.append(value)


                                            class InterAreaPrefixLsaType(Entity):
                                                """
                                                Inter Area Prefix LSA
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA Information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader>`
                                                
                                                .. attribute:: prefix
                                                
                                                	LSA address prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: prefix_length
                                                
                                                	Prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: priority
                                                
                                                	Prefix priority
                                                	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__init__()

                                                    self.yang_name = "inter-area-prefix-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                    self.priority = YLeaf(YType.enumeration, "priority")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("prefix",
                                                                    "prefix_length",
                                                                    "priority") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA Information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.prefix.is_set or
                                                        self.prefix_length.is_set or
                                                        self.priority.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.prefix_length.yfilter != YFilter.not_set or
                                                        self.priority.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "inter-area-prefix-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                    if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.priority.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "prefix-length" or name == "priority"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-length"):
                                                        self.prefix_length = value
                                                        self.prefix_length.value_namespace = name_space
                                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "priority"):
                                                        self.priority = value
                                                        self.priority.value_namespace = name_space
                                                        self.priority.value_namespace_prefix = name_space_prefix


                                            class InterAreaRouterLsaType(Entity):
                                                """
                                                Inter Area Router LSA
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader>`
                                                
                                                .. attribute:: lsa_router_id
                                                
                                                	LSA router ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__init__()

                                                    self.yang_name = "inter-area-router-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("lsa_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "inter-area-router-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "inter-area-router-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.lsa_router_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.lsa_router_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "inter-area-router-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "lsa-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "lsa-router-id"):
                                                        self.lsa_router_id = value
                                                        self.lsa_router_id.value_namespace = name_space
                                                        self.lsa_router_id.value_namespace_prefix = name_space_prefix


                                            class ExternalLsaType(Entity):
                                                """
                                                External LSA
                                                
                                                .. attribute:: external_tag
                                                
                                                	Route Tag
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forwarding_address
                                                
                                                	Forwarding Address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: is_forwarding_address_set
                                                
                                                	If true, forwarding address is set 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA Information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader>`
                                                
                                                .. attribute:: metric_type
                                                
                                                	Metric type 
                                                	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                                
                                                .. attribute:: prefix
                                                
                                                	IPV6 address prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: prefix_length
                                                
                                                	Prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: priority
                                                
                                                	Prefix priority
                                                	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                
                                                .. attribute:: tos_cost
                                                
                                                	Type of service cost metric 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__init__()

                                                    self.yang_name = "external-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.external_tag = YLeaf(YType.uint32, "external-tag")

                                                    self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                                    self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                                    self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                    self.priority = YLeaf(YType.enumeration, "priority")

                                                    self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("external_tag",
                                                                    "forwarding_address",
                                                                    "is_forwarding_address_set",
                                                                    "metric_type",
                                                                    "prefix",
                                                                    "prefix_length",
                                                                    "priority",
                                                                    "tos_cost") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "external-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA Information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "external-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.external_tag.is_set or
                                                        self.forwarding_address.is_set or
                                                        self.is_forwarding_address_set.is_set or
                                                        self.metric_type.is_set or
                                                        self.prefix.is_set or
                                                        self.prefix_length.is_set or
                                                        self.priority.is_set or
                                                        self.tos_cost.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.external_tag.yfilter != YFilter.not_set or
                                                        self.forwarding_address.yfilter != YFilter.not_set or
                                                        self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                        self.metric_type.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.prefix_length.yfilter != YFilter.not_set or
                                                        self.priority.yfilter != YFilter.not_set or
                                                        self.tos_cost.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "external-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.external_tag.get_name_leafdata())
                                                    if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                                    if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                                    if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.metric_type.get_name_leafdata())
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                    if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.priority.get_name_leafdata())
                                                    if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "external-tag"):
                                                        self.external_tag = value
                                                        self.external_tag.value_namespace = name_space
                                                        self.external_tag.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forwarding-address"):
                                                        self.forwarding_address = value
                                                        self.forwarding_address.value_namespace = name_space
                                                        self.forwarding_address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-forwarding-address-set"):
                                                        self.is_forwarding_address_set = value
                                                        self.is_forwarding_address_set.value_namespace = name_space
                                                        self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "metric-type"):
                                                        self.metric_type = value
                                                        self.metric_type.value_namespace = name_space
                                                        self.metric_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-length"):
                                                        self.prefix_length = value
                                                        self.prefix_length.value_namespace = name_space
                                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "priority"):
                                                        self.priority = value
                                                        self.priority.value_namespace = name_space
                                                        self.priority.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tos-cost"):
                                                        self.tos_cost = value
                                                        self.tos_cost.value_namespace = name_space
                                                        self.tos_cost.value_namespace_prefix = name_space_prefix


                                            class NssalsaType(Entity):
                                                """
                                                NSSA External LSA
                                                
                                                .. attribute:: external_tag
                                                
                                                	Route Tag
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forwarding_address
                                                
                                                	Forwarding Address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: is_forwarding_address_set
                                                
                                                	If true, forwarding address is set 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA Information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader>`
                                                
                                                .. attribute:: metric_type
                                                
                                                	Metric type 
                                                	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                                
                                                .. attribute:: prefix
                                                
                                                	IPV6 address prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: prefix_length
                                                
                                                	Prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: priority
                                                
                                                	Prefix priority
                                                	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                
                                                .. attribute:: tos_cost
                                                
                                                	Type of service cost metric 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__init__()

                                                    self.yang_name = "nssalsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.external_tag = YLeaf(YType.uint32, "external-tag")

                                                    self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                                    self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                                    self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                    self.priority = YLeaf(YType.enumeration, "priority")

                                                    self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("external_tag",
                                                                    "forwarding_address",
                                                                    "is_forwarding_address_set",
                                                                    "metric_type",
                                                                    "prefix",
                                                                    "prefix_length",
                                                                    "priority",
                                                                    "tos_cost") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "nssalsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA Information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "nssalsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.external_tag.is_set or
                                                        self.forwarding_address.is_set or
                                                        self.is_forwarding_address_set.is_set or
                                                        self.metric_type.is_set or
                                                        self.prefix.is_set or
                                                        self.prefix_length.is_set or
                                                        self.priority.is_set or
                                                        self.tos_cost.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.external_tag.yfilter != YFilter.not_set or
                                                        self.forwarding_address.yfilter != YFilter.not_set or
                                                        self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                        self.metric_type.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.prefix_length.yfilter != YFilter.not_set or
                                                        self.priority.yfilter != YFilter.not_set or
                                                        self.tos_cost.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "nssalsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.external_tag.get_name_leafdata())
                                                    if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                                    if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                                    if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.metric_type.get_name_leafdata())
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                    if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.priority.get_name_leafdata())
                                                    if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "external-tag"):
                                                        self.external_tag = value
                                                        self.external_tag.value_namespace = name_space
                                                        self.external_tag.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forwarding-address"):
                                                        self.forwarding_address = value
                                                        self.forwarding_address.value_namespace = name_space
                                                        self.forwarding_address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-forwarding-address-set"):
                                                        self.is_forwarding_address_set = value
                                                        self.is_forwarding_address_set.value_namespace = name_space
                                                        self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "metric-type"):
                                                        self.metric_type = value
                                                        self.metric_type.value_namespace = name_space
                                                        self.metric_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-length"):
                                                        self.prefix_length = value
                                                        self.prefix_length.value_namespace = name_space
                                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "priority"):
                                                        self.priority = value
                                                        self.priority.value_namespace = name_space
                                                        self.priority.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tos-cost"):
                                                        self.tos_cost = value
                                                        self.tos_cost.value_namespace = name_space
                                                        self.tos_cost.value_namespace_prefix = name_space_prefix


                                            class LinkLsaType(Entity):
                                                """
                                                Link LSA
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface handle
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader>`
                                                
                                                .. attribute:: lsa_link_local
                                                
                                                	LSA link local 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: prefix
                                                
                                                	OSPFv3 prefix 
                                                	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix>`
                                                
                                                .. attribute:: router_priority
                                                
                                                	Router priority 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Sham link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__init__()

                                                    self.yang_name = "link-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.lsa_link_local = YLeaf(YType.str, "lsa-link-local")

                                                    self.router_priority = YLeaf(YType.uint8, "router-priority")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                    self.prefix = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "lsa_link_local",
                                                                    "router_priority",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "link-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "link-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix


                                                class Prefix(Entity):
                                                    """
                                                    OSPFv3 prefix 
                                                    
                                                    .. attribute:: ospfv3_prefix_length
                                                    
                                                    	OSPFv3 prefix length 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: ospfv3_prefix_metric
                                                    
                                                    	OSPFv3 prefix metric 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: ospfv3_prefix_options
                                                    
                                                    	OSPFv3 prefix options 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	OSPFv3 prefix 
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: priority
                                                    
                                                    	Prefix priority
                                                    	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__init__()

                                                        self.yang_name = "prefix"
                                                        self.yang_parent_name = "link-lsa-type"

                                                        self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                        self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                        self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                        self.prefix = YLeaf(YType.str, "prefix")

                                                        self.priority = YLeaf(YType.enumeration, "priority")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("ospfv3_prefix_length",
                                                                        "ospfv3_prefix_metric",
                                                                        "ospfv3_prefix_options",
                                                                        "prefix",
                                                                        "priority") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.ospfv3_prefix_length.is_set or
                                                            self.ospfv3_prefix_metric.is_set or
                                                            self.ospfv3_prefix_options.is_set or
                                                            self.prefix.is_set or
                                                            self.priority.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                            self.prefix.yfilter != YFilter.not_set or
                                                            self.priority.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "prefix" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                        if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                        if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.priority.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "ospfv3-prefix-length"):
                                                            self.ospfv3_prefix_length = value
                                                            self.ospfv3_prefix_length.value_namespace = name_space
                                                            self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ospfv3-prefix-metric"):
                                                            self.ospfv3_prefix_metric = value
                                                            self.ospfv3_prefix_metric.value_namespace = name_space
                                                            self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ospfv3-prefix-options"):
                                                            self.ospfv3_prefix_options = value
                                                            self.ospfv3_prefix_options.value_namespace = name_space
                                                            self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix"):
                                                            self.prefix = value
                                                            self.prefix.value_namespace = name_space
                                                            self.prefix.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "priority"):
                                                            self.priority = value
                                                            self.priority.value_namespace = name_space
                                                            self.priority.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.prefix:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.lsa_link_local.is_set or
                                                        self.router_priority.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    for c in self.prefix:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.lsa_link_local.yfilter != YFilter.not_set or
                                                        self.router_priority.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "link-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.lsa_link_local.is_set or self.lsa_link_local.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_link_local.get_name_leafdata())
                                                    if (self.router_priority.is_set or self.router_priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.router_priority.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    if (child_yang_name == "prefix"):
                                                        for c in self.prefix:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.prefix.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "lsa-link-local" or name == "router-priority" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-link-local"):
                                                        self.lsa_link_local = value
                                                        self.lsa_link_local.value_namespace = name_space
                                                        self.lsa_link_local.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "router-priority"):
                                                        self.router_priority = value
                                                        self.router_priority.value_namespace = name_space
                                                        self.router_priority.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                            class IntraAreaPrefixLsaType(Entity):
                                                """
                                                Intra Area Prefix LSA
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader>`
                                                
                                                .. attribute:: prefix
                                                
                                                	OSPFv3 prefix 
                                                	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix>`
                                                
                                                .. attribute:: reference_advertised_router
                                                
                                                	Reference advertised router 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: reference_lsa_id
                                                
                                                	Reference LSA ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: reference_type
                                                
                                                	Reference type 
                                                	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__init__()

                                                    self.yang_name = "intra-area-prefix-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.reference_advertised_router = YLeaf(YType.str, "reference-advertised-router")

                                                    self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                                    self.reference_type = YLeaf(YType.enumeration, "reference-type")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                    self.prefix = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("reference_advertised_router",
                                                                    "reference_lsa_id",
                                                                    "reference_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix


                                                class Prefix(Entity):
                                                    """
                                                    OSPFv3 prefix 
                                                    
                                                    .. attribute:: ospfv3_prefix_length
                                                    
                                                    	OSPFv3 prefix length 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: ospfv3_prefix_metric
                                                    
                                                    	OSPFv3 prefix metric 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: ospfv3_prefix_options
                                                    
                                                    	OSPFv3 prefix options 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	OSPFv3 prefix 
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: priority
                                                    
                                                    	Prefix priority
                                                    	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__init__()

                                                        self.yang_name = "prefix"
                                                        self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                        self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                        self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                        self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                        self.prefix = YLeaf(YType.str, "prefix")

                                                        self.priority = YLeaf(YType.enumeration, "priority")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("ospfv3_prefix_length",
                                                                        "ospfv3_prefix_metric",
                                                                        "ospfv3_prefix_options",
                                                                        "prefix",
                                                                        "priority") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.ospfv3_prefix_length.is_set or
                                                            self.ospfv3_prefix_metric.is_set or
                                                            self.ospfv3_prefix_options.is_set or
                                                            self.prefix.is_set or
                                                            self.priority.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                            self.prefix.yfilter != YFilter.not_set or
                                                            self.priority.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "prefix" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                        if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                        if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.priority.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "ospfv3-prefix-length"):
                                                            self.ospfv3_prefix_length = value
                                                            self.ospfv3_prefix_length.value_namespace = name_space
                                                            self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ospfv3-prefix-metric"):
                                                            self.ospfv3_prefix_metric = value
                                                            self.ospfv3_prefix_metric.value_namespace = name_space
                                                            self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ospfv3-prefix-options"):
                                                            self.ospfv3_prefix_options = value
                                                            self.ospfv3_prefix_options.value_namespace = name_space
                                                            self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix"):
                                                            self.prefix = value
                                                            self.prefix.value_namespace = name_space
                                                            self.prefix.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "priority"):
                                                            self.priority = value
                                                            self.priority.value_namespace = name_space
                                                            self.priority.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.prefix:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.reference_advertised_router.is_set or
                                                        self.reference_lsa_id.is_set or
                                                        self.reference_type.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    for c in self.prefix:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.reference_advertised_router.yfilter != YFilter.not_set or
                                                        self.reference_lsa_id.yfilter != YFilter.not_set or
                                                        self.reference_type.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "intra-area-prefix-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.reference_advertised_router.is_set or self.reference_advertised_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.reference_advertised_router.get_name_leafdata())
                                                    if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                                    if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.reference_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    if (child_yang_name == "prefix"):
                                                        for c in self.prefix:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.prefix.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "reference-advertised-router" or name == "reference-lsa-id" or name == "reference-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "reference-advertised-router"):
                                                        self.reference_advertised_router = value
                                                        self.reference_advertised_router.value_namespace = name_space
                                                        self.reference_advertised_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "reference-lsa-id"):
                                                        self.reference_lsa_id = value
                                                        self.reference_lsa_id.value_namespace = name_space
                                                        self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "reference-type"):
                                                        self.reference_type = value
                                                        self.reference_type.value_namespace = name_space
                                                        self.reference_type.value_namespace_prefix = name_space_prefix


                                            class GraceLsa(Entity):
                                                """
                                                Grace LSA
                                                
                                                .. attribute:: grace_period
                                                
                                                	The grace periord where helper routers should wait before advertising it fully adjacent(s) 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: grace_reason
                                                
                                                	Reason for router restart
                                                	**type**\:   :py:class:`Ospfv3GracefulRestartReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3GracefulRestartReason>`
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__init__()

                                                    self.yang_name = "grace-lsa"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.grace_period = YLeaf(YType.uint32, "grace-period")

                                                    self.grace_reason = YLeaf(YType.enumeration, "grace-reason")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("grace_period",
                                                                    "grace_reason") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "grace-lsa"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "grace-lsa"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.grace_period.is_set or
                                                        self.grace_reason.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.grace_period.yfilter != YFilter.not_set or
                                                        self.grace_reason.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "grace-lsa" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.grace_period.is_set or self.grace_period.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.grace_period.get_name_leafdata())
                                                    if (self.grace_reason.is_set or self.grace_reason.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.grace_reason.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "grace-period" or name == "grace-reason"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "grace-period"):
                                                        self.grace_period = value
                                                        self.grace_period.value_namespace = name_space
                                                        self.grace_period.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "grace-reason"):
                                                        self.grace_reason = value
                                                        self.grace_reason.value_namespace = name_space
                                                        self.grace_reason.value_namespace_prefix = name_space_prefix


                                            class UnknownLinkLsaType(Entity):
                                                """
                                                Unknown Link Scope LSA
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface name 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader>`
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Shamlink ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__init__()

                                                    self.yang_name = "unknown-link-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "unknown-link-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "unknown-link-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unknown-link-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                            class UnknownAreaLsaType(Entity):
                                                """
                                                Unknown\-Area scope LSA
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface name 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader>`
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Shamlink ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__init__()

                                                    self.yang_name = "unknown-area-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "unknown-area-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "unknown-area-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unknown-area-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                            class UnknownAslsaType(Entity):
                                                """
                                                Unknown\-AS scope LSA
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface name 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader>`
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Shamlink ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__init__()

                                                    self.yang_name = "unknown-aslsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "unknown-aslsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "unknown-aslsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unknown-aslsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                            class UnknownLsaType(Entity):
                                                """
                                                Unknown LSA
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface name 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader>`
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Shamlink ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__init__()

                                                    self.yang_name = "unknown-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "unknown-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "unknown-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unknown-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.lsa_info_type.is_set or
                                                    (self.external_lsa_type is not None and self.external_lsa_type.has_data()) or
                                                    (self.grace_lsa is not None and self.grace_lsa.has_data()) or
                                                    (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_data()) or
                                                    (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_data()) or
                                                    (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_data()) or
                                                    (self.link_lsa_type is not None and self.link_lsa_type.has_data()) or
                                                    (self.lsa_summary_info is not None and self.lsa_summary_info.has_data()) or
                                                    (self.network_lsa_type is not None and self.network_lsa_type.has_data()) or
                                                    (self.nssalsa_type is not None and self.nssalsa_type.has_data()) or
                                                    (self.router_lsa_type is not None and self.router_lsa_type.has_data()) or
                                                    (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_data()) or
                                                    (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_data()) or
                                                    (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_data()) or
                                                    (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.lsa_info_type.yfilter != YFilter.not_set or
                                                    (self.external_lsa_type is not None and self.external_lsa_type.has_operation()) or
                                                    (self.grace_lsa is not None and self.grace_lsa.has_operation()) or
                                                    (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_operation()) or
                                                    (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_operation()) or
                                                    (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_operation()) or
                                                    (self.link_lsa_type is not None and self.link_lsa_type.has_operation()) or
                                                    (self.lsa_summary_info is not None and self.lsa_summary_info.has_operation()) or
                                                    (self.network_lsa_type is not None and self.network_lsa_type.has_operation()) or
                                                    (self.nssalsa_type is not None and self.nssalsa_type.has_operation()) or
                                                    (self.router_lsa_type is not None and self.router_lsa_type.has_operation()) or
                                                    (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_operation()) or
                                                    (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_operation()) or
                                                    (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_operation()) or
                                                    (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.lsa_info_type.is_set or self.lsa_info_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_info_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "external-lsa-type"):
                                                    if (self.external_lsa_type is None):
                                                        self.external_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType()
                                                        self.external_lsa_type.parent = self
                                                        self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                                    return self.external_lsa_type

                                                if (child_yang_name == "grace-lsa"):
                                                    if (self.grace_lsa is None):
                                                        self.grace_lsa = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa()
                                                        self.grace_lsa.parent = self
                                                        self._children_name_map["grace_lsa"] = "grace-lsa"
                                                    return self.grace_lsa

                                                if (child_yang_name == "inter-area-prefix-lsa-type"):
                                                    if (self.inter_area_prefix_lsa_type is None):
                                                        self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                                        self.inter_area_prefix_lsa_type.parent = self
                                                        self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                                    return self.inter_area_prefix_lsa_type

                                                if (child_yang_name == "inter-area-router-lsa-type"):
                                                    if (self.inter_area_router_lsa_type is None):
                                                        self.inter_area_router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                                        self.inter_area_router_lsa_type.parent = self
                                                        self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                                    return self.inter_area_router_lsa_type

                                                if (child_yang_name == "intra-area-prefix-lsa-type"):
                                                    if (self.intra_area_prefix_lsa_type is None):
                                                        self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                                        self.intra_area_prefix_lsa_type.parent = self
                                                        self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                                    return self.intra_area_prefix_lsa_type

                                                if (child_yang_name == "link-lsa-type"):
                                                    if (self.link_lsa_type is None):
                                                        self.link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType()
                                                        self.link_lsa_type.parent = self
                                                        self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                                    return self.link_lsa_type

                                                if (child_yang_name == "lsa-summary-info"):
                                                    if (self.lsa_summary_info is None):
                                                        self.lsa_summary_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo()
                                                        self.lsa_summary_info.parent = self
                                                        self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                                    return self.lsa_summary_info

                                                if (child_yang_name == "network-lsa-type"):
                                                    if (self.network_lsa_type is None):
                                                        self.network_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType()
                                                        self.network_lsa_type.parent = self
                                                        self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                                    return self.network_lsa_type

                                                if (child_yang_name == "nssalsa-type"):
                                                    if (self.nssalsa_type is None):
                                                        self.nssalsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType()
                                                        self.nssalsa_type.parent = self
                                                        self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                                    return self.nssalsa_type

                                                if (child_yang_name == "router-lsa-type"):
                                                    if (self.router_lsa_type is None):
                                                        self.router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType()
                                                        self.router_lsa_type.parent = self
                                                        self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                                    return self.router_lsa_type

                                                if (child_yang_name == "unknown-area-lsa-type"):
                                                    if (self.unknown_area_lsa_type is None):
                                                        self.unknown_area_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                                        self.unknown_area_lsa_type.parent = self
                                                        self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                                    return self.unknown_area_lsa_type

                                                if (child_yang_name == "unknown-aslsa-type"):
                                                    if (self.unknown_aslsa_type is None):
                                                        self.unknown_aslsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType()
                                                        self.unknown_aslsa_type.parent = self
                                                        self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                                    return self.unknown_aslsa_type

                                                if (child_yang_name == "unknown-link-lsa-type"):
                                                    if (self.unknown_link_lsa_type is None):
                                                        self.unknown_link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                                        self.unknown_link_lsa_type.parent = self
                                                        self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                                    return self.unknown_link_lsa_type

                                                if (child_yang_name == "unknown-lsa-type"):
                                                    if (self.unknown_lsa_type is None):
                                                        self.unknown_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType()
                                                        self.unknown_lsa_type.parent = self
                                                        self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                                    return self.unknown_lsa_type

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "external-lsa-type" or name == "grace-lsa" or name == "inter-area-prefix-lsa-type" or name == "inter-area-router-lsa-type" or name == "intra-area-prefix-lsa-type" or name == "link-lsa-type" or name == "lsa-summary-info" or name == "network-lsa-type" or name == "nssalsa-type" or name == "router-lsa-type" or name == "unknown-area-lsa-type" or name == "unknown-aslsa-type" or name == "unknown-link-lsa-type" or name == "unknown-lsa-type" or name == "lsa-info-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "lsa-info-type"):
                                                    self.lsa_info_type = value
                                                    self.lsa_info_type.value_namespace = name_space
                                                    self.lsa_info_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.area_id.is_set or
                                                self.interface_name.is_set or
                                                self.ls_id.is_set or
                                                self.ls_type.is_set or
                                                (self.lsa_info is not None and self.lsa_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.area_id.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.ls_type.yfilter != YFilter.not_set or
                                                (self.lsa_info is not None and self.lsa_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_id.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.ls_type.is_set or self.ls_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-info"):
                                                if (self.lsa_info is None):
                                                    self.lsa_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo()
                                                    self.lsa_info.parent = self
                                                    self._children_name_map["lsa_info"] = "lsa-info"
                                                return self.lsa_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-info" or name == "advertising-router" or name == "area-id" or name == "interface-name" or name == "ls-id" or name == "ls-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "area-id"):
                                                self.area_id = value
                                                self.area_id.value_namespace = name_space
                                                self.area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-type"):
                                                self.ls_type = value
                                                self.ls_type.value_namespace = name_space
                                                self.ls_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.lsa:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.lsa:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsa-table" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa"):
                                            for c in self.lsa:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable.Lsa()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.lsa.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class LsaInternalTable(Entity):
                                    """
                                    Database LSA information
                                    
                                    .. attribute:: lsa
                                    
                                    	Database LSA information
                                    	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable, self).__init__()

                                        self.yang_name = "lsa-internal-table"
                                        self.yang_parent_name = "database-table"

                                        self.lsa = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable, self).__setattr__(name, value)


                                    class Lsa(Entity):
                                        """
                                        Database LSA information
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Advertising Router ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: area_id
                                        
                                        	Area ID
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: interface_name
                                        
                                        	InterfaceName
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: ls_id
                                        
                                        	Link state ID
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: ls_type
                                        
                                        	LSA type
                                        	**type**\:   :py:class:`Ospfv3Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa>`
                                        
                                        .. attribute:: lsa_info
                                        
                                        	Summary of all LSAs or LSA specific information 
                                        	**type**\:   :py:class:`LsaInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa, self).__init__()

                                            self.yang_name = "lsa"
                                            self.yang_parent_name = "lsa-internal-table"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.area_id = YLeaf(YType.int32, "area-id")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.ls_id = YLeaf(YType.int32, "ls-id")

                                            self.ls_type = YLeaf(YType.enumeration, "ls-type")

                                            self.lsa_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo()
                                            self.lsa_info.parent = self
                                            self._children_name_map["lsa_info"] = "lsa-info"
                                            self._children_yang_names.add("lsa-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "area_id",
                                                            "interface_name",
                                                            "ls_id",
                                                            "ls_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa, self).__setattr__(name, value)


                                        class LsaInfo(Entity):
                                            """
                                            Summary of all LSAs or LSA specific information 
                                            
                                            .. attribute:: external_lsa_type
                                            
                                            	External LSA
                                            	**type**\:   :py:class:`ExternalLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType>`
                                            
                                            .. attribute:: grace_lsa
                                            
                                            	Grace LSA
                                            	**type**\:   :py:class:`GraceLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa>`
                                            
                                            .. attribute:: inter_area_prefix_lsa_type
                                            
                                            	Inter Area Prefix LSA
                                            	**type**\:   :py:class:`InterAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType>`
                                            
                                            .. attribute:: inter_area_router_lsa_type
                                            
                                            	Inter Area Router LSA
                                            	**type**\:   :py:class:`InterAreaRouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType>`
                                            
                                            .. attribute:: intra_area_prefix_lsa_type
                                            
                                            	Intra Area Prefix LSA
                                            	**type**\:   :py:class:`IntraAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType>`
                                            
                                            .. attribute:: link_lsa_type
                                            
                                            	Link LSA
                                            	**type**\:   :py:class:`LinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType>`
                                            
                                            .. attribute:: lsa_info_type
                                            
                                            	LSAInfoType
                                            	**type**\:   :py:class:`Ospfv3LsaInfoTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3LsaInfoTypes>`
                                            
                                            .. attribute:: lsa_summary_info
                                            
                                            	Summary information of LSAs
                                            	**type**\:   :py:class:`LsaSummaryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo>`
                                            
                                            .. attribute:: network_lsa_type
                                            
                                            	Network LSA
                                            	**type**\:   :py:class:`NetworkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType>`
                                            
                                            .. attribute:: nssalsa_type
                                            
                                            	NSSA External LSA
                                            	**type**\:   :py:class:`NssalsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType>`
                                            
                                            .. attribute:: router_lsa_type
                                            
                                            	Router LSA
                                            	**type**\:   :py:class:`RouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType>`
                                            
                                            .. attribute:: unknown_area_lsa_type
                                            
                                            	Unknown\-Area scope LSA
                                            	**type**\:   :py:class:`UnknownAreaLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType>`
                                            
                                            .. attribute:: unknown_aslsa_type
                                            
                                            	Unknown\-AS scope LSA
                                            	**type**\:   :py:class:`UnknownAslsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType>`
                                            
                                            .. attribute:: unknown_link_lsa_type
                                            
                                            	Unknown Link Scope LSA
                                            	**type**\:   :py:class:`UnknownLinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType>`
                                            
                                            .. attribute:: unknown_lsa_type
                                            
                                            	Unknown LSA
                                            	**type**\:   :py:class:`UnknownLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__init__()

                                                self.yang_name = "lsa-info"
                                                self.yang_parent_name = "lsa"

                                                self.lsa_info_type = YLeaf(YType.enumeration, "lsa-info-type")

                                                self.external_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType()
                                                self.external_lsa_type.parent = self
                                                self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                                self._children_yang_names.add("external-lsa-type")

                                                self.grace_lsa = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa()
                                                self.grace_lsa.parent = self
                                                self._children_name_map["grace_lsa"] = "grace-lsa"
                                                self._children_yang_names.add("grace-lsa")

                                                self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                                self.inter_area_prefix_lsa_type.parent = self
                                                self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                                self._children_yang_names.add("inter-area-prefix-lsa-type")

                                                self.inter_area_router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                                self.inter_area_router_lsa_type.parent = self
                                                self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                                self._children_yang_names.add("inter-area-router-lsa-type")

                                                self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                                self.intra_area_prefix_lsa_type.parent = self
                                                self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                                self._children_yang_names.add("intra-area-prefix-lsa-type")

                                                self.link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType()
                                                self.link_lsa_type.parent = self
                                                self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                                self._children_yang_names.add("link-lsa-type")

                                                self.lsa_summary_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo()
                                                self.lsa_summary_info.parent = self
                                                self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                                self._children_yang_names.add("lsa-summary-info")

                                                self.network_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType()
                                                self.network_lsa_type.parent = self
                                                self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                                self._children_yang_names.add("network-lsa-type")

                                                self.nssalsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType()
                                                self.nssalsa_type.parent = self
                                                self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                                self._children_yang_names.add("nssalsa-type")

                                                self.router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType()
                                                self.router_lsa_type.parent = self
                                                self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                                self._children_yang_names.add("router-lsa-type")

                                                self.unknown_area_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                                self.unknown_area_lsa_type.parent = self
                                                self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                                self._children_yang_names.add("unknown-area-lsa-type")

                                                self.unknown_aslsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType()
                                                self.unknown_aslsa_type.parent = self
                                                self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                                self._children_yang_names.add("unknown-aslsa-type")

                                                self.unknown_link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                                self.unknown_link_lsa_type.parent = self
                                                self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                                self._children_yang_names.add("unknown-link-lsa-type")

                                                self.unknown_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType()
                                                self.unknown_lsa_type.parent = self
                                                self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                                self._children_yang_names.add("unknown-lsa-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("lsa_info_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__setattr__(name, value)


                                            class LsaSummaryInfo(Entity):
                                                """
                                                Summary information of LSAs
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface name 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: links
                                                
                                                	Number of links
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader>`
                                                
                                                .. attribute:: lsa_router_id
                                                
                                                	LSA router ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: prefix
                                                
                                                	OSPFv3 address Prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: prefix_length
                                                
                                                	Prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: reference_lsa_id
                                                
                                                	Reference LSA ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: reference_type
                                                
                                                	Reference type 
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: router_la_bits
                                                
                                                	Router LA bits 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Sham link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__init__()

                                                    self.yang_name = "lsa-summary-info"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.links = YLeaf(YType.uint16, "links")

                                                    self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                    self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                                    self.reference_type = YLeaf(YType.uint16, "reference-type")

                                                    self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "links",
                                                                    "lsa_router_id",
                                                                    "prefix",
                                                                    "prefix_length",
                                                                    "reference_lsa_id",
                                                                    "reference_type",
                                                                    "router_la_bits",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "lsa-summary-info"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "lsa-summary-info"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.links.is_set or
                                                        self.lsa_router_id.is_set or
                                                        self.prefix.is_set or
                                                        self.prefix_length.is_set or
                                                        self.reference_lsa_id.is_set or
                                                        self.reference_type.is_set or
                                                        self.router_la_bits.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.links.yfilter != YFilter.not_set or
                                                        self.lsa_router_id.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.prefix_length.yfilter != YFilter.not_set or
                                                        self.reference_lsa_id.yfilter != YFilter.not_set or
                                                        self.reference_type.yfilter != YFilter.not_set or
                                                        self.router_la_bits.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-summary-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.links.get_name_leafdata())
                                                    if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_router_id.get_name_leafdata())
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                    if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                                    if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.reference_type.get_name_leafdata())
                                                    if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.router_la_bits.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "links" or name == "lsa-router-id" or name == "prefix" or name == "prefix-length" or name == "reference-lsa-id" or name == "reference-type" or name == "router-la-bits" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "links"):
                                                        self.links = value
                                                        self.links.value_namespace = name_space
                                                        self.links.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-router-id"):
                                                        self.lsa_router_id = value
                                                        self.lsa_router_id.value_namespace = name_space
                                                        self.lsa_router_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-length"):
                                                        self.prefix_length = value
                                                        self.prefix_length.value_namespace = name_space
                                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "reference-lsa-id"):
                                                        self.reference_lsa_id = value
                                                        self.reference_lsa_id.value_namespace = name_space
                                                        self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "reference-type"):
                                                        self.reference_type = value
                                                        self.reference_type.value_namespace = name_space
                                                        self.reference_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "router-la-bits"):
                                                        self.router_la_bits = value
                                                        self.router_la_bits.value_namespace = name_space
                                                        self.router_la_bits.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                            class RouterLsaType(Entity):
                                                """
                                                Router LSA
                                                
                                                .. attribute:: link
                                                
                                                	List of links in this LSA
                                                	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link>`
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader>`
                                                
                                                .. attribute:: router_la_bits
                                                
                                                	Router LA bits 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: rpf_path
                                                
                                                	Router LSA Reverse\-Path Forwarding information 
                                                	**type**\:   :py:class:`RpfPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__init__()

                                                    self.yang_name = "router-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                    self.rpf_path = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                    self.rpf_path.parent = self
                                                    self._children_name_map["rpf_path"] = "rpf-path"
                                                    self._children_yang_names.add("rpf-path")

                                                    self.link = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("router_la_bits") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "router-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "router-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix


                                                class RpfPath(Entity):
                                                    """
                                                    Router LSA Reverse\-Path Forwarding information 
                                                    
                                                    .. attribute:: interface_name
                                                    
                                                    	RPF multicast IDB 
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                    
                                                    .. attribute:: rpf_multicast_next_hop
                                                    
                                                    	RPF multicast next hop 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__init__()

                                                        self.yang_name = "rpf-path"
                                                        self.yang_parent_name = "router-lsa-type"

                                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                                        self.rpf_multicast_next_hop = YLeaf(YType.uint32, "rpf-multicast-next-hop")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("interface_name",
                                                                        "rpf_multicast_next_hop") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.interface_name.is_set or
                                                            self.rpf_multicast_next_hop.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.interface_name.yfilter != YFilter.not_set or
                                                            self.rpf_multicast_next_hop.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "rpf-path" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                        if (self.rpf_multicast_next_hop.is_set or self.rpf_multicast_next_hop.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rpf_multicast_next_hop.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "interface-name" or name == "rpf-multicast-next-hop"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "interface-name"):
                                                            self.interface_name = value
                                                            self.interface_name.value_namespace = name_space
                                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rpf-multicast-next-hop"):
                                                            self.rpf_multicast_next_hop = value
                                                            self.rpf_multicast_next_hop.value_namespace = name_space
                                                            self.rpf_multicast_next_hop.value_namespace_prefix = name_space_prefix


                                                class Link(Entity):
                                                    """
                                                    List of links in this LSA
                                                    
                                                    .. attribute:: link_interface_id
                                                    
                                                    	LSA link interface ID 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: link_metric
                                                    
                                                    	LSA link metric 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: link_neighbor_interface_id
                                                    
                                                    	LSA link neighbor interface ID 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: link_neighbor_router_id
                                                    
                                                    	LSA link neigbhor router id 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: link_type
                                                    
                                                    	Type of link
                                                    	**type**\:   :py:class:`Ospfv3Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Link>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__init__()

                                                        self.yang_name = "link"
                                                        self.yang_parent_name = "router-lsa-type"

                                                        self.link_interface_id = YLeaf(YType.uint32, "link-interface-id")

                                                        self.link_metric = YLeaf(YType.uint16, "link-metric")

                                                        self.link_neighbor_interface_id = YLeaf(YType.uint32, "link-neighbor-interface-id")

                                                        self.link_neighbor_router_id = YLeaf(YType.uint32, "link-neighbor-router-id")

                                                        self.link_type = YLeaf(YType.enumeration, "link-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("link_interface_id",
                                                                        "link_metric",
                                                                        "link_neighbor_interface_id",
                                                                        "link_neighbor_router_id",
                                                                        "link_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.link_interface_id.is_set or
                                                            self.link_metric.is_set or
                                                            self.link_neighbor_interface_id.is_set or
                                                            self.link_neighbor_router_id.is_set or
                                                            self.link_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.link_interface_id.yfilter != YFilter.not_set or
                                                            self.link_metric.yfilter != YFilter.not_set or
                                                            self.link_neighbor_interface_id.yfilter != YFilter.not_set or
                                                            self.link_neighbor_router_id.yfilter != YFilter.not_set or
                                                            self.link_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "link" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.link_interface_id.is_set or self.link_interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.link_interface_id.get_name_leafdata())
                                                        if (self.link_metric.is_set or self.link_metric.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.link_metric.get_name_leafdata())
                                                        if (self.link_neighbor_interface_id.is_set or self.link_neighbor_interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.link_neighbor_interface_id.get_name_leafdata())
                                                        if (self.link_neighbor_router_id.is_set or self.link_neighbor_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.link_neighbor_router_id.get_name_leafdata())
                                                        if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.link_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "link-interface-id" or name == "link-metric" or name == "link-neighbor-interface-id" or name == "link-neighbor-router-id" or name == "link-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "link-interface-id"):
                                                            self.link_interface_id = value
                                                            self.link_interface_id.value_namespace = name_space
                                                            self.link_interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "link-metric"):
                                                            self.link_metric = value
                                                            self.link_metric.value_namespace = name_space
                                                            self.link_metric.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "link-neighbor-interface-id"):
                                                            self.link_neighbor_interface_id = value
                                                            self.link_neighbor_interface_id.value_namespace = name_space
                                                            self.link_neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "link-neighbor-router-id"):
                                                            self.link_neighbor_router_id = value
                                                            self.link_neighbor_router_id.value_namespace = name_space
                                                            self.link_neighbor_router_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "link-type"):
                                                            self.link_type = value
                                                            self.link_type.value_namespace = name_space
                                                            self.link_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.link:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.router_la_bits.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()) or
                                                        (self.rpf_path is not None and self.rpf_path.has_data()))

                                                def has_operation(self):
                                                    for c in self.link:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.router_la_bits.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()) or
                                                        (self.rpf_path is not None and self.rpf_path.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "router-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.router_la_bits.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "link"):
                                                        for c in self.link:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.link.append(c)
                                                        return c

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    if (child_yang_name == "rpf-path"):
                                                        if (self.rpf_path is None):
                                                            self.rpf_path = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                            self.rpf_path.parent = self
                                                            self._children_name_map["rpf_path"] = "rpf-path"
                                                        return self.rpf_path

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "link" or name == "lsa-detail" or name == "lsa-header" or name == "rpf-path" or name == "router-la-bits"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "router-la-bits"):
                                                        self.router_la_bits = value
                                                        self.router_la_bits.value_namespace = name_space
                                                        self.router_la_bits.value_namespace_prefix = name_space_prefix


                                            class NetworkLsaType(Entity):
                                                """
                                                Network LSA
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader>`
                                                
                                                .. attribute:: neighbor_router
                                                
                                                	Neighbor router list
                                                	**type**\:  list of str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__init__()

                                                    self.yang_name = "network-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.neighbor_router = YLeafList(YType.str, "neighbor-router")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("neighbor_router") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "network-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "network-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for leaf in self.neighbor_router.getYLeafs():
                                                        if (leaf.yfilter != YFilter.not_set):
                                                            return True
                                                    return (
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    for leaf in self.neighbor_router.getYLeafs():
                                                        if (leaf.is_set):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.neighbor_router.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "network-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    leaf_name_data.extend(self.neighbor_router.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "neighbor-router"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "neighbor-router"):
                                                        self.neighbor_router.append(value)


                                            class InterAreaPrefixLsaType(Entity):
                                                """
                                                Inter Area Prefix LSA
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA Information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader>`
                                                
                                                .. attribute:: prefix
                                                
                                                	LSA address prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: prefix_length
                                                
                                                	Prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: priority
                                                
                                                	Prefix priority
                                                	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__init__()

                                                    self.yang_name = "inter-area-prefix-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                    self.priority = YLeaf(YType.enumeration, "priority")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("prefix",
                                                                    "prefix_length",
                                                                    "priority") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA Information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.prefix.is_set or
                                                        self.prefix_length.is_set or
                                                        self.priority.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.prefix_length.yfilter != YFilter.not_set or
                                                        self.priority.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "inter-area-prefix-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                    if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.priority.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "prefix-length" or name == "priority"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-length"):
                                                        self.prefix_length = value
                                                        self.prefix_length.value_namespace = name_space
                                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "priority"):
                                                        self.priority = value
                                                        self.priority.value_namespace = name_space
                                                        self.priority.value_namespace_prefix = name_space_prefix


                                            class InterAreaRouterLsaType(Entity):
                                                """
                                                Inter Area Router LSA
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader>`
                                                
                                                .. attribute:: lsa_router_id
                                                
                                                	LSA router ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__init__()

                                                    self.yang_name = "inter-area-router-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("lsa_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "inter-area-router-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "inter-area-router-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.lsa_router_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.lsa_router_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "inter-area-router-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "lsa-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "lsa-router-id"):
                                                        self.lsa_router_id = value
                                                        self.lsa_router_id.value_namespace = name_space
                                                        self.lsa_router_id.value_namespace_prefix = name_space_prefix


                                            class ExternalLsaType(Entity):
                                                """
                                                External LSA
                                                
                                                .. attribute:: external_tag
                                                
                                                	Route Tag
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forwarding_address
                                                
                                                	Forwarding Address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: is_forwarding_address_set
                                                
                                                	If true, forwarding address is set 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA Information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader>`
                                                
                                                .. attribute:: metric_type
                                                
                                                	Metric type 
                                                	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                                
                                                .. attribute:: prefix
                                                
                                                	IPV6 address prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: prefix_length
                                                
                                                	Prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: priority
                                                
                                                	Prefix priority
                                                	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                
                                                .. attribute:: tos_cost
                                                
                                                	Type of service cost metric 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__init__()

                                                    self.yang_name = "external-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.external_tag = YLeaf(YType.uint32, "external-tag")

                                                    self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                                    self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                                    self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                    self.priority = YLeaf(YType.enumeration, "priority")

                                                    self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("external_tag",
                                                                    "forwarding_address",
                                                                    "is_forwarding_address_set",
                                                                    "metric_type",
                                                                    "prefix",
                                                                    "prefix_length",
                                                                    "priority",
                                                                    "tos_cost") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "external-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA Information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "external-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.external_tag.is_set or
                                                        self.forwarding_address.is_set or
                                                        self.is_forwarding_address_set.is_set or
                                                        self.metric_type.is_set or
                                                        self.prefix.is_set or
                                                        self.prefix_length.is_set or
                                                        self.priority.is_set or
                                                        self.tos_cost.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.external_tag.yfilter != YFilter.not_set or
                                                        self.forwarding_address.yfilter != YFilter.not_set or
                                                        self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                        self.metric_type.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.prefix_length.yfilter != YFilter.not_set or
                                                        self.priority.yfilter != YFilter.not_set or
                                                        self.tos_cost.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "external-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.external_tag.get_name_leafdata())
                                                    if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                                    if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                                    if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.metric_type.get_name_leafdata())
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                    if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.priority.get_name_leafdata())
                                                    if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "external-tag"):
                                                        self.external_tag = value
                                                        self.external_tag.value_namespace = name_space
                                                        self.external_tag.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forwarding-address"):
                                                        self.forwarding_address = value
                                                        self.forwarding_address.value_namespace = name_space
                                                        self.forwarding_address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-forwarding-address-set"):
                                                        self.is_forwarding_address_set = value
                                                        self.is_forwarding_address_set.value_namespace = name_space
                                                        self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "metric-type"):
                                                        self.metric_type = value
                                                        self.metric_type.value_namespace = name_space
                                                        self.metric_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-length"):
                                                        self.prefix_length = value
                                                        self.prefix_length.value_namespace = name_space
                                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "priority"):
                                                        self.priority = value
                                                        self.priority.value_namespace = name_space
                                                        self.priority.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tos-cost"):
                                                        self.tos_cost = value
                                                        self.tos_cost.value_namespace = name_space
                                                        self.tos_cost.value_namespace_prefix = name_space_prefix


                                            class NssalsaType(Entity):
                                                """
                                                NSSA External LSA
                                                
                                                .. attribute:: external_tag
                                                
                                                	Route Tag
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forwarding_address
                                                
                                                	Forwarding Address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: is_forwarding_address_set
                                                
                                                	If true, forwarding address is set 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA Information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader>`
                                                
                                                .. attribute:: metric_type
                                                
                                                	Metric type 
                                                	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                                
                                                .. attribute:: prefix
                                                
                                                	IPV6 address prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: prefix_length
                                                
                                                	Prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: priority
                                                
                                                	Prefix priority
                                                	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                
                                                .. attribute:: tos_cost
                                                
                                                	Type of service cost metric 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__init__()

                                                    self.yang_name = "nssalsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.external_tag = YLeaf(YType.uint32, "external-tag")

                                                    self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                                    self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                                    self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                    self.priority = YLeaf(YType.enumeration, "priority")

                                                    self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("external_tag",
                                                                    "forwarding_address",
                                                                    "is_forwarding_address_set",
                                                                    "metric_type",
                                                                    "prefix",
                                                                    "prefix_length",
                                                                    "priority",
                                                                    "tos_cost") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "nssalsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA Information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "nssalsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.external_tag.is_set or
                                                        self.forwarding_address.is_set or
                                                        self.is_forwarding_address_set.is_set or
                                                        self.metric_type.is_set or
                                                        self.prefix.is_set or
                                                        self.prefix_length.is_set or
                                                        self.priority.is_set or
                                                        self.tos_cost.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.external_tag.yfilter != YFilter.not_set or
                                                        self.forwarding_address.yfilter != YFilter.not_set or
                                                        self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                        self.metric_type.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.prefix_length.yfilter != YFilter.not_set or
                                                        self.priority.yfilter != YFilter.not_set or
                                                        self.tos_cost.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "nssalsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.external_tag.get_name_leafdata())
                                                    if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                                    if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                                    if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.metric_type.get_name_leafdata())
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                    if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.priority.get_name_leafdata())
                                                    if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "external-tag"):
                                                        self.external_tag = value
                                                        self.external_tag.value_namespace = name_space
                                                        self.external_tag.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forwarding-address"):
                                                        self.forwarding_address = value
                                                        self.forwarding_address.value_namespace = name_space
                                                        self.forwarding_address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-forwarding-address-set"):
                                                        self.is_forwarding_address_set = value
                                                        self.is_forwarding_address_set.value_namespace = name_space
                                                        self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "metric-type"):
                                                        self.metric_type = value
                                                        self.metric_type.value_namespace = name_space
                                                        self.metric_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-length"):
                                                        self.prefix_length = value
                                                        self.prefix_length.value_namespace = name_space
                                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "priority"):
                                                        self.priority = value
                                                        self.priority.value_namespace = name_space
                                                        self.priority.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tos-cost"):
                                                        self.tos_cost = value
                                                        self.tos_cost.value_namespace = name_space
                                                        self.tos_cost.value_namespace_prefix = name_space_prefix


                                            class LinkLsaType(Entity):
                                                """
                                                Link LSA
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface handle
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader>`
                                                
                                                .. attribute:: lsa_link_local
                                                
                                                	LSA link local 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: prefix
                                                
                                                	OSPFv3 prefix 
                                                	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix>`
                                                
                                                .. attribute:: router_priority
                                                
                                                	Router priority 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Sham link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__init__()

                                                    self.yang_name = "link-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.lsa_link_local = YLeaf(YType.str, "lsa-link-local")

                                                    self.router_priority = YLeaf(YType.uint8, "router-priority")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                    self.prefix = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "lsa_link_local",
                                                                    "router_priority",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "link-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "link-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix


                                                class Prefix(Entity):
                                                    """
                                                    OSPFv3 prefix 
                                                    
                                                    .. attribute:: ospfv3_prefix_length
                                                    
                                                    	OSPFv3 prefix length 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: ospfv3_prefix_metric
                                                    
                                                    	OSPFv3 prefix metric 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: ospfv3_prefix_options
                                                    
                                                    	OSPFv3 prefix options 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	OSPFv3 prefix 
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: priority
                                                    
                                                    	Prefix priority
                                                    	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__init__()

                                                        self.yang_name = "prefix"
                                                        self.yang_parent_name = "link-lsa-type"

                                                        self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                        self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                        self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                        self.prefix = YLeaf(YType.str, "prefix")

                                                        self.priority = YLeaf(YType.enumeration, "priority")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("ospfv3_prefix_length",
                                                                        "ospfv3_prefix_metric",
                                                                        "ospfv3_prefix_options",
                                                                        "prefix",
                                                                        "priority") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.ospfv3_prefix_length.is_set or
                                                            self.ospfv3_prefix_metric.is_set or
                                                            self.ospfv3_prefix_options.is_set or
                                                            self.prefix.is_set or
                                                            self.priority.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                            self.prefix.yfilter != YFilter.not_set or
                                                            self.priority.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "prefix" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                        if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                        if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.priority.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "ospfv3-prefix-length"):
                                                            self.ospfv3_prefix_length = value
                                                            self.ospfv3_prefix_length.value_namespace = name_space
                                                            self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ospfv3-prefix-metric"):
                                                            self.ospfv3_prefix_metric = value
                                                            self.ospfv3_prefix_metric.value_namespace = name_space
                                                            self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ospfv3-prefix-options"):
                                                            self.ospfv3_prefix_options = value
                                                            self.ospfv3_prefix_options.value_namespace = name_space
                                                            self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix"):
                                                            self.prefix = value
                                                            self.prefix.value_namespace = name_space
                                                            self.prefix.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "priority"):
                                                            self.priority = value
                                                            self.priority.value_namespace = name_space
                                                            self.priority.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.prefix:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.lsa_link_local.is_set or
                                                        self.router_priority.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    for c in self.prefix:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.lsa_link_local.yfilter != YFilter.not_set or
                                                        self.router_priority.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "link-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.lsa_link_local.is_set or self.lsa_link_local.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_link_local.get_name_leafdata())
                                                    if (self.router_priority.is_set or self.router_priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.router_priority.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    if (child_yang_name == "prefix"):
                                                        for c in self.prefix:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.prefix.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "lsa-link-local" or name == "router-priority" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-link-local"):
                                                        self.lsa_link_local = value
                                                        self.lsa_link_local.value_namespace = name_space
                                                        self.lsa_link_local.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "router-priority"):
                                                        self.router_priority = value
                                                        self.router_priority.value_namespace = name_space
                                                        self.router_priority.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                            class IntraAreaPrefixLsaType(Entity):
                                                """
                                                Intra Area Prefix LSA
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader>`
                                                
                                                .. attribute:: prefix
                                                
                                                	OSPFv3 prefix 
                                                	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix>`
                                                
                                                .. attribute:: reference_advertised_router
                                                
                                                	Reference advertised router 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: reference_lsa_id
                                                
                                                	Reference LSA ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: reference_type
                                                
                                                	Reference type 
                                                	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__init__()

                                                    self.yang_name = "intra-area-prefix-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.reference_advertised_router = YLeaf(YType.str, "reference-advertised-router")

                                                    self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                                    self.reference_type = YLeaf(YType.enumeration, "reference-type")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                    self.prefix = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("reference_advertised_router",
                                                                    "reference_lsa_id",
                                                                    "reference_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix


                                                class Prefix(Entity):
                                                    """
                                                    OSPFv3 prefix 
                                                    
                                                    .. attribute:: ospfv3_prefix_length
                                                    
                                                    	OSPFv3 prefix length 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: ospfv3_prefix_metric
                                                    
                                                    	OSPFv3 prefix metric 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: ospfv3_prefix_options
                                                    
                                                    	OSPFv3 prefix options 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	OSPFv3 prefix 
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: priority
                                                    
                                                    	Prefix priority
                                                    	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__init__()

                                                        self.yang_name = "prefix"
                                                        self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                        self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                        self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                        self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                        self.prefix = YLeaf(YType.str, "prefix")

                                                        self.priority = YLeaf(YType.enumeration, "priority")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("ospfv3_prefix_length",
                                                                        "ospfv3_prefix_metric",
                                                                        "ospfv3_prefix_options",
                                                                        "prefix",
                                                                        "priority") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.ospfv3_prefix_length.is_set or
                                                            self.ospfv3_prefix_metric.is_set or
                                                            self.ospfv3_prefix_options.is_set or
                                                            self.prefix.is_set or
                                                            self.priority.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                            self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                            self.prefix.yfilter != YFilter.not_set or
                                                            self.priority.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "prefix" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                        if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                        if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.priority.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "ospfv3-prefix-length"):
                                                            self.ospfv3_prefix_length = value
                                                            self.ospfv3_prefix_length.value_namespace = name_space
                                                            self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ospfv3-prefix-metric"):
                                                            self.ospfv3_prefix_metric = value
                                                            self.ospfv3_prefix_metric.value_namespace = name_space
                                                            self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ospfv3-prefix-options"):
                                                            self.ospfv3_prefix_options = value
                                                            self.ospfv3_prefix_options.value_namespace = name_space
                                                            self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix"):
                                                            self.prefix = value
                                                            self.prefix.value_namespace = name_space
                                                            self.prefix.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "priority"):
                                                            self.priority = value
                                                            self.priority.value_namespace = name_space
                                                            self.priority.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.prefix:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.reference_advertised_router.is_set or
                                                        self.reference_lsa_id.is_set or
                                                        self.reference_type.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    for c in self.prefix:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.reference_advertised_router.yfilter != YFilter.not_set or
                                                        self.reference_lsa_id.yfilter != YFilter.not_set or
                                                        self.reference_type.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "intra-area-prefix-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.reference_advertised_router.is_set or self.reference_advertised_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.reference_advertised_router.get_name_leafdata())
                                                    if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                                    if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.reference_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    if (child_yang_name == "prefix"):
                                                        for c in self.prefix:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.prefix.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "reference-advertised-router" or name == "reference-lsa-id" or name == "reference-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "reference-advertised-router"):
                                                        self.reference_advertised_router = value
                                                        self.reference_advertised_router.value_namespace = name_space
                                                        self.reference_advertised_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "reference-lsa-id"):
                                                        self.reference_lsa_id = value
                                                        self.reference_lsa_id.value_namespace = name_space
                                                        self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "reference-type"):
                                                        self.reference_type = value
                                                        self.reference_type.value_namespace = name_space
                                                        self.reference_type.value_namespace_prefix = name_space_prefix


                                            class GraceLsa(Entity):
                                                """
                                                Grace LSA
                                                
                                                .. attribute:: grace_period
                                                
                                                	The grace periord where helper routers should wait before advertising it fully adjacent(s) 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: grace_reason
                                                
                                                	Reason for router restart
                                                	**type**\:   :py:class:`Ospfv3GracefulRestartReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3GracefulRestartReason>`
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__init__()

                                                    self.yang_name = "grace-lsa"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.grace_period = YLeaf(YType.uint32, "grace-period")

                                                    self.grace_reason = YLeaf(YType.enumeration, "grace-reason")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("grace_period",
                                                                    "grace_reason") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "grace-lsa"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "grace-lsa"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.grace_period.is_set or
                                                        self.grace_reason.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.grace_period.yfilter != YFilter.not_set or
                                                        self.grace_reason.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "grace-lsa" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.grace_period.is_set or self.grace_period.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.grace_period.get_name_leafdata())
                                                    if (self.grace_reason.is_set or self.grace_reason.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.grace_reason.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "grace-period" or name == "grace-reason"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "grace-period"):
                                                        self.grace_period = value
                                                        self.grace_period.value_namespace = name_space
                                                        self.grace_period.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "grace-reason"):
                                                        self.grace_reason = value
                                                        self.grace_reason.value_namespace = name_space
                                                        self.grace_reason.value_namespace_prefix = name_space_prefix


                                            class UnknownLinkLsaType(Entity):
                                                """
                                                Unknown Link Scope LSA
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface name 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader>`
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Shamlink ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__init__()

                                                    self.yang_name = "unknown-link-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "unknown-link-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "unknown-link-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unknown-link-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                            class UnknownAreaLsaType(Entity):
                                                """
                                                Unknown\-Area scope LSA
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface name 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader>`
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Shamlink ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__init__()

                                                    self.yang_name = "unknown-area-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "unknown-area-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "unknown-area-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unknown-area-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                            class UnknownAslsaType(Entity):
                                                """
                                                Unknown\-AS scope LSA
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface name 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader>`
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Shamlink ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__init__()

                                                    self.yang_name = "unknown-aslsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "unknown-aslsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "unknown-aslsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unknown-aslsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                            class UnknownLsaType(Entity):
                                                """
                                                Unknown LSA
                                                
                                                .. attribute:: interface_name
                                                
                                                	LSA interface name 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: is_sham_link
                                                
                                                	If true, it is a sham link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_virtual_link
                                                
                                                	If true, it is a virtual link 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_detail
                                                
                                                	Detailed LSA information
                                                	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail>`
                                                
                                                .. attribute:: lsa_header
                                                
                                                	Header information 
                                                	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader>`
                                                
                                                .. attribute:: sham_link_id
                                                
                                                	Shamlink ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: virtual_link_id
                                                
                                                	Virtual link ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__init__()

                                                    self.yang_name = "unknown-lsa-type"
                                                    self.yang_parent_name = "lsa-info"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                    self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                    self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                    self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                    self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                    self.lsa_detail.parent = self
                                                    self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    self._children_yang_names.add("lsa-detail")

                                                    self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                    self.lsa_header.parent = self
                                                    self._children_name_map["lsa_header"] = "lsa-header"
                                                    self._children_yang_names.add("lsa-header")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "is_sham_link",
                                                                    "is_virtual_link",
                                                                    "sham_link_id",
                                                                    "virtual_link_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)


                                                class LsaHeader(Entity):
                                                    """
                                                    Header information 
                                                    
                                                    .. attribute:: advertising_router
                                                    
                                                    	Router ID of Advertising Router
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: checksum
                                                    
                                                    	Checksum value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: is_do_not_age_lsa
                                                    
                                                    	If true, Do Not Age this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_graceful_restart_active
                                                    
                                                    	If true, if grace restart is active 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: ls_id
                                                    
                                                    	LS ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: lsa_age
                                                    
                                                    	LSA's Age (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_area_id
                                                    
                                                    	Area ID in decimal or dotted\-decimal format
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..16
                                                    
                                                    .. attribute:: lsa_type
                                                    
                                                    	LSA type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: sequence_number
                                                    
                                                    	Current Sequence number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__init__()

                                                        self.yang_name = "lsa-header"
                                                        self.yang_parent_name = "unknown-lsa-type"

                                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                        self.checksum = YLeaf(YType.uint16, "checksum")

                                                        self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                        self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                        self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                        self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                        self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                        self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("advertising_router",
                                                                        "checksum",
                                                                        "is_do_not_age_lsa",
                                                                        "is_graceful_restart_active",
                                                                        "ls_id",
                                                                        "lsa_age",
                                                                        "lsa_area_id",
                                                                        "lsa_type",
                                                                        "sequence_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.advertising_router.is_set or
                                                            self.checksum.is_set or
                                                            self.is_do_not_age_lsa.is_set or
                                                            self.is_graceful_restart_active.is_set or
                                                            self.ls_id.is_set or
                                                            self.lsa_age.is_set or
                                                            self.lsa_area_id.is_set or
                                                            self.lsa_type.is_set or
                                                            self.sequence_number.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.advertising_router.yfilter != YFilter.not_set or
                                                            self.checksum.yfilter != YFilter.not_set or
                                                            self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                            self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                            self.ls_id.yfilter != YFilter.not_set or
                                                            self.lsa_age.yfilter != YFilter.not_set or
                                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                                            self.lsa_type.yfilter != YFilter.not_set or
                                                            self.sequence_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-header" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                        if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.checksum.get_name_leafdata())
                                                        if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                        if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                        if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                        if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "advertising-router"):
                                                            self.advertising_router = value
                                                            self.advertising_router.value_namespace = name_space
                                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "checksum"):
                                                            self.checksum = value
                                                            self.checksum.value_namespace = name_space
                                                            self.checksum.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-do-not-age-lsa"):
                                                            self.is_do_not_age_lsa = value
                                                            self.is_do_not_age_lsa.value_namespace = name_space
                                                            self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-graceful-restart-active"):
                                                            self.is_graceful_restart_active = value
                                                            self.is_graceful_restart_active.value_namespace = name_space
                                                            self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ls-id"):
                                                            self.ls_id = value
                                                            self.ls_id.value_namespace = name_space
                                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-age"):
                                                            self.lsa_age = value
                                                            self.lsa_age.value_namespace = name_space
                                                            self.lsa_age.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-area-id"):
                                                            self.lsa_area_id = value
                                                            self.lsa_area_id.value_namespace = name_space
                                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-type"):
                                                            self.lsa_type = value
                                                            self.lsa_type.value_namespace = name_space
                                                            self.lsa_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "sequence-number"):
                                                            self.sequence_number = value
                                                            self.sequence_number.value_namespace = name_space
                                                            self.sequence_number.value_namespace_prefix = name_space_prefix


                                                class LsaDetail(Entity):
                                                    """
                                                    Detailed LSA information
                                                    
                                                    .. attribute:: free_time
                                                    
                                                    	The amount of time since the last check was made to free this LSA (s)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: is_acknowledged
                                                    
                                                    	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_advertising_router_reachable
                                                    
                                                    	If true, Advertising Router is reachable
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_deleted
                                                    
                                                    	If true, flag is set to delete this LSA 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_flood_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_maximum_aged
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_neighbor_exchange
                                                    
                                                    	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_no_delete
                                                    
                                                    	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_nsr_ack_pending
                                                    
                                                    	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_partial_spf
                                                    
                                                    	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_bit
                                                    
                                                    	If true, Routing Bit set on the LSA
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_routing_table
                                                    
                                                    	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_flood_required_post_fail_over
                                                    
                                                    	LSA flood required after FO
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: lsa_length
                                                    
                                                    	Length of the LSA
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: lsa_sync_state
                                                    
                                                    	State of LSA sync with active
                                                    	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                    
                                                    .. attribute:: minute_table_index
                                                    
                                                    	Minute table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: nsr_flood_required
                                                    
                                                    	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: rate_limit
                                                    
                                                    	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: second_table_index
                                                    
                                                    	Second table index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'ipv6-ospfv3-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__init__()

                                                        self.yang_name = "lsa-detail"
                                                        self.yang_parent_name = "unknown-lsa-type"

                                                        self.free_time = YLeaf(YType.uint32, "free-time")

                                                        self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                        self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                        self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                        self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                        self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                        self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                        self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                        self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                        self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                        self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                        self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                        self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                        self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                        self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                        self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                        self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                        self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                        self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("free_time",
                                                                        "is_acknowledged",
                                                                        "is_advertising_router_reachable",
                                                                        "is_deleted",
                                                                        "is_flood_pending",
                                                                        "is_maximum_aged",
                                                                        "is_neighbor_exchange",
                                                                        "is_no_delete",
                                                                        "is_nsr_ack_pending",
                                                                        "is_partial_spf",
                                                                        "is_routing_bit",
                                                                        "is_routing_table",
                                                                        "lsa_flood_required_post_fail_over",
                                                                        "lsa_length",
                                                                        "lsa_sync_state",
                                                                        "minute_table_index",
                                                                        "nsr_flood_required",
                                                                        "rate_limit",
                                                                        "second_table_index") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.free_time.is_set or
                                                            self.is_acknowledged.is_set or
                                                            self.is_advertising_router_reachable.is_set or
                                                            self.is_deleted.is_set or
                                                            self.is_flood_pending.is_set or
                                                            self.is_maximum_aged.is_set or
                                                            self.is_neighbor_exchange.is_set or
                                                            self.is_no_delete.is_set or
                                                            self.is_nsr_ack_pending.is_set or
                                                            self.is_partial_spf.is_set or
                                                            self.is_routing_bit.is_set or
                                                            self.is_routing_table.is_set or
                                                            self.lsa_flood_required_post_fail_over.is_set or
                                                            self.lsa_length.is_set or
                                                            self.lsa_sync_state.is_set or
                                                            self.minute_table_index.is_set or
                                                            self.nsr_flood_required.is_set or
                                                            self.rate_limit.is_set or
                                                            self.second_table_index.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.free_time.yfilter != YFilter.not_set or
                                                            self.is_acknowledged.yfilter != YFilter.not_set or
                                                            self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                            self.is_deleted.yfilter != YFilter.not_set or
                                                            self.is_flood_pending.yfilter != YFilter.not_set or
                                                            self.is_maximum_aged.yfilter != YFilter.not_set or
                                                            self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                            self.is_no_delete.yfilter != YFilter.not_set or
                                                            self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                            self.is_partial_spf.yfilter != YFilter.not_set or
                                                            self.is_routing_bit.yfilter != YFilter.not_set or
                                                            self.is_routing_table.yfilter != YFilter.not_set or
                                                            self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                            self.lsa_length.yfilter != YFilter.not_set or
                                                            self.lsa_sync_state.yfilter != YFilter.not_set or
                                                            self.minute_table_index.yfilter != YFilter.not_set or
                                                            self.nsr_flood_required.yfilter != YFilter.not_set or
                                                            self.rate_limit.yfilter != YFilter.not_set or
                                                            self.second_table_index.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsa-detail" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.free_time.get_name_leafdata())
                                                        if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                        if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                        if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                        if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                        if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                        if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                        if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                        if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                        if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                        if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                        if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                        if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                        if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                        if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                        if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                        if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                        if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                        if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "free-time"):
                                                            self.free_time = value
                                                            self.free_time.value_namespace = name_space
                                                            self.free_time.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-acknowledged"):
                                                            self.is_acknowledged = value
                                                            self.is_acknowledged.value_namespace = name_space
                                                            self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-advertising-router-reachable"):
                                                            self.is_advertising_router_reachable = value
                                                            self.is_advertising_router_reachable.value_namespace = name_space
                                                            self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-deleted"):
                                                            self.is_deleted = value
                                                            self.is_deleted.value_namespace = name_space
                                                            self.is_deleted.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-flood-pending"):
                                                            self.is_flood_pending = value
                                                            self.is_flood_pending.value_namespace = name_space
                                                            self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-maximum-aged"):
                                                            self.is_maximum_aged = value
                                                            self.is_maximum_aged.value_namespace = name_space
                                                            self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-neighbor-exchange"):
                                                            self.is_neighbor_exchange = value
                                                            self.is_neighbor_exchange.value_namespace = name_space
                                                            self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-no-delete"):
                                                            self.is_no_delete = value
                                                            self.is_no_delete.value_namespace = name_space
                                                            self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-nsr-ack-pending"):
                                                            self.is_nsr_ack_pending = value
                                                            self.is_nsr_ack_pending.value_namespace = name_space
                                                            self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-partial-spf"):
                                                            self.is_partial_spf = value
                                                            self.is_partial_spf.value_namespace = name_space
                                                            self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-bit"):
                                                            self.is_routing_bit = value
                                                            self.is_routing_bit.value_namespace = name_space
                                                            self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-routing-table"):
                                                            self.is_routing_table = value
                                                            self.is_routing_table.value_namespace = name_space
                                                            self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-flood-required-post-fail-over"):
                                                            self.lsa_flood_required_post_fail_over = value
                                                            self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                            self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-length"):
                                                            self.lsa_length = value
                                                            self.lsa_length.value_namespace = name_space
                                                            self.lsa_length.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsa-sync-state"):
                                                            self.lsa_sync_state = value
                                                            self.lsa_sync_state.value_namespace = name_space
                                                            self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "minute-table-index"):
                                                            self.minute_table_index = value
                                                            self.minute_table_index.value_namespace = name_space
                                                            self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "nsr-flood-required"):
                                                            self.nsr_flood_required = value
                                                            self.nsr_flood_required.value_namespace = name_space
                                                            self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "rate-limit"):
                                                            self.rate_limit = value
                                                            self.rate_limit.value_namespace = name_space
                                                            self.rate_limit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "second-table-index"):
                                                            self.second_table_index = value
                                                            self.second_table_index.value_namespace = name_space
                                                            self.second_table_index.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.is_sham_link.is_set or
                                                        self.is_virtual_link.is_set or
                                                        self.sham_link_id.is_set or
                                                        self.virtual_link_id.is_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.is_sham_link.yfilter != YFilter.not_set or
                                                        self.is_virtual_link.yfilter != YFilter.not_set or
                                                        self.sham_link_id.yfilter != YFilter.not_set or
                                                        self.virtual_link_id.yfilter != YFilter.not_set or
                                                        (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                        (self.lsa_header is not None and self.lsa_header.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unknown-lsa-type" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                    if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                    if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                    if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "lsa-detail"):
                                                        if (self.lsa_detail is None):
                                                            self.lsa_detail = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                            self.lsa_detail.parent = self
                                                            self._children_name_map["lsa_detail"] = "lsa-detail"
                                                        return self.lsa_detail

                                                    if (child_yang_name == "lsa-header"):
                                                        if (self.lsa_header is None):
                                                            self.lsa_header = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                            self.lsa_header.parent = self
                                                            self._children_name_map["lsa_header"] = "lsa-header"
                                                        return self.lsa_header

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-sham-link"):
                                                        self.is_sham_link = value
                                                        self.is_sham_link.value_namespace = name_space
                                                        self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-virtual-link"):
                                                        self.is_virtual_link = value
                                                        self.is_virtual_link.value_namespace = name_space
                                                        self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sham-link-id"):
                                                        self.sham_link_id = value
                                                        self.sham_link_id.value_namespace = name_space
                                                        self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "virtual-link-id"):
                                                        self.virtual_link_id = value
                                                        self.virtual_link_id.value_namespace = name_space
                                                        self.virtual_link_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.lsa_info_type.is_set or
                                                    (self.external_lsa_type is not None and self.external_lsa_type.has_data()) or
                                                    (self.grace_lsa is not None and self.grace_lsa.has_data()) or
                                                    (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_data()) or
                                                    (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_data()) or
                                                    (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_data()) or
                                                    (self.link_lsa_type is not None and self.link_lsa_type.has_data()) or
                                                    (self.lsa_summary_info is not None and self.lsa_summary_info.has_data()) or
                                                    (self.network_lsa_type is not None and self.network_lsa_type.has_data()) or
                                                    (self.nssalsa_type is not None and self.nssalsa_type.has_data()) or
                                                    (self.router_lsa_type is not None and self.router_lsa_type.has_data()) or
                                                    (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_data()) or
                                                    (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_data()) or
                                                    (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_data()) or
                                                    (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.lsa_info_type.yfilter != YFilter.not_set or
                                                    (self.external_lsa_type is not None and self.external_lsa_type.has_operation()) or
                                                    (self.grace_lsa is not None and self.grace_lsa.has_operation()) or
                                                    (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_operation()) or
                                                    (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_operation()) or
                                                    (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_operation()) or
                                                    (self.link_lsa_type is not None and self.link_lsa_type.has_operation()) or
                                                    (self.lsa_summary_info is not None and self.lsa_summary_info.has_operation()) or
                                                    (self.network_lsa_type is not None and self.network_lsa_type.has_operation()) or
                                                    (self.nssalsa_type is not None and self.nssalsa_type.has_operation()) or
                                                    (self.router_lsa_type is not None and self.router_lsa_type.has_operation()) or
                                                    (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_operation()) or
                                                    (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_operation()) or
                                                    (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_operation()) or
                                                    (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.lsa_info_type.is_set or self.lsa_info_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_info_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "external-lsa-type"):
                                                    if (self.external_lsa_type is None):
                                                        self.external_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType()
                                                        self.external_lsa_type.parent = self
                                                        self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                                    return self.external_lsa_type

                                                if (child_yang_name == "grace-lsa"):
                                                    if (self.grace_lsa is None):
                                                        self.grace_lsa = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa()
                                                        self.grace_lsa.parent = self
                                                        self._children_name_map["grace_lsa"] = "grace-lsa"
                                                    return self.grace_lsa

                                                if (child_yang_name == "inter-area-prefix-lsa-type"):
                                                    if (self.inter_area_prefix_lsa_type is None):
                                                        self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                                        self.inter_area_prefix_lsa_type.parent = self
                                                        self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                                    return self.inter_area_prefix_lsa_type

                                                if (child_yang_name == "inter-area-router-lsa-type"):
                                                    if (self.inter_area_router_lsa_type is None):
                                                        self.inter_area_router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                                        self.inter_area_router_lsa_type.parent = self
                                                        self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                                    return self.inter_area_router_lsa_type

                                                if (child_yang_name == "intra-area-prefix-lsa-type"):
                                                    if (self.intra_area_prefix_lsa_type is None):
                                                        self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                                        self.intra_area_prefix_lsa_type.parent = self
                                                        self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                                    return self.intra_area_prefix_lsa_type

                                                if (child_yang_name == "link-lsa-type"):
                                                    if (self.link_lsa_type is None):
                                                        self.link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType()
                                                        self.link_lsa_type.parent = self
                                                        self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                                    return self.link_lsa_type

                                                if (child_yang_name == "lsa-summary-info"):
                                                    if (self.lsa_summary_info is None):
                                                        self.lsa_summary_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo()
                                                        self.lsa_summary_info.parent = self
                                                        self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                                    return self.lsa_summary_info

                                                if (child_yang_name == "network-lsa-type"):
                                                    if (self.network_lsa_type is None):
                                                        self.network_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType()
                                                        self.network_lsa_type.parent = self
                                                        self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                                    return self.network_lsa_type

                                                if (child_yang_name == "nssalsa-type"):
                                                    if (self.nssalsa_type is None):
                                                        self.nssalsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType()
                                                        self.nssalsa_type.parent = self
                                                        self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                                    return self.nssalsa_type

                                                if (child_yang_name == "router-lsa-type"):
                                                    if (self.router_lsa_type is None):
                                                        self.router_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType()
                                                        self.router_lsa_type.parent = self
                                                        self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                                    return self.router_lsa_type

                                                if (child_yang_name == "unknown-area-lsa-type"):
                                                    if (self.unknown_area_lsa_type is None):
                                                        self.unknown_area_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                                        self.unknown_area_lsa_type.parent = self
                                                        self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                                    return self.unknown_area_lsa_type

                                                if (child_yang_name == "unknown-aslsa-type"):
                                                    if (self.unknown_aslsa_type is None):
                                                        self.unknown_aslsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType()
                                                        self.unknown_aslsa_type.parent = self
                                                        self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                                    return self.unknown_aslsa_type

                                                if (child_yang_name == "unknown-link-lsa-type"):
                                                    if (self.unknown_link_lsa_type is None):
                                                        self.unknown_link_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                                        self.unknown_link_lsa_type.parent = self
                                                        self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                                    return self.unknown_link_lsa_type

                                                if (child_yang_name == "unknown-lsa-type"):
                                                    if (self.unknown_lsa_type is None):
                                                        self.unknown_lsa_type = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType()
                                                        self.unknown_lsa_type.parent = self
                                                        self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                                    return self.unknown_lsa_type

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "external-lsa-type" or name == "grace-lsa" or name == "inter-area-prefix-lsa-type" or name == "inter-area-router-lsa-type" or name == "intra-area-prefix-lsa-type" or name == "link-lsa-type" or name == "lsa-summary-info" or name == "network-lsa-type" or name == "nssalsa-type" or name == "router-lsa-type" or name == "unknown-area-lsa-type" or name == "unknown-aslsa-type" or name == "unknown-link-lsa-type" or name == "unknown-lsa-type" or name == "lsa-info-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "lsa-info-type"):
                                                    self.lsa_info_type = value
                                                    self.lsa_info_type.value_namespace = name_space
                                                    self.lsa_info_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.area_id.is_set or
                                                self.interface_name.is_set or
                                                self.ls_id.is_set or
                                                self.ls_type.is_set or
                                                (self.lsa_info is not None and self.lsa_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.area_id.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.ls_type.yfilter != YFilter.not_set or
                                                (self.lsa_info is not None and self.lsa_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_id.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.ls_type.is_set or self.ls_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "lsa-info"):
                                                if (self.lsa_info is None):
                                                    self.lsa_info = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo()
                                                    self.lsa_info.parent = self
                                                    self._children_name_map["lsa_info"] = "lsa-info"
                                                return self.lsa_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "lsa-info" or name == "advertising-router" or name == "area-id" or name == "interface-name" or name == "ls-id" or name == "ls-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "area-id"):
                                                self.area_id = value
                                                self.area_id.value_namespace = name_space
                                                self.area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-type"):
                                                self.ls_type = value
                                                self.ls_type.value_namespace = name_space
                                                self.ls_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.lsa:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.lsa:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsa-internal-table" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa"):
                                            for c in self.lsa:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.lsa.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        (self.lsa_internal_table is not None and self.lsa_internal_table.has_data()) or
                                        (self.lsa_table is not None and self.lsa_table.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.lsa_internal_table is not None and self.lsa_internal_table.has_operation()) or
                                        (self.lsa_table is not None and self.lsa_table.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "database-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "lsa-internal-table"):
                                        if (self.lsa_internal_table is None):
                                            self.lsa_internal_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaInternalTable()
                                            self.lsa_internal_table.parent = self
                                            self._children_name_map["lsa_internal_table"] = "lsa-internal-table"
                                        return self.lsa_internal_table

                                    if (child_yang_name == "lsa-table"):
                                        if (self.lsa_table is None):
                                            self.lsa_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable.LsaTable()
                                            self.lsa_table.parent = self
                                            self._children_name_map["lsa_table"] = "lsa-table"
                                        return self.lsa_table

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "lsa-internal-table" or name == "lsa-table"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class DatabaseSummaryTable(Entity):
                                """
                                Database summary table
                                
                                .. attribute:: database_summary
                                
                                	Database Summary information
                                	**type**\:   :py:class:`DatabaseSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable, self).__init__()

                                    self.yang_name = "database-summary-table"
                                    self.yang_parent_name = "area"

                                    self.database_summary = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary()
                                    self.database_summary.parent = self
                                    self._children_name_map["database_summary"] = "database-summary"
                                    self._children_yang_names.add("database-summary")


                                class DatabaseSummary(Entity):
                                    """
                                    Database Summary information
                                    
                                    .. attribute:: area_database
                                    
                                    	OSPFv3 Area Database list 
                                    	**type**\: list of    :py:class:`AreaDatabase <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase>`
                                    
                                    .. attribute:: database_counters
                                    
                                    	OSPFv3 database counters 
                                    	**type**\:   :py:class:`DatabaseCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters>`
                                    
                                    .. attribute:: database_router_id
                                    
                                    	Database router ID 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: is_opaque_database_capable
                                    
                                    	If true, opaque database is capable 
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary, self).__init__()

                                        self.yang_name = "database-summary"
                                        self.yang_parent_name = "database-summary-table"

                                        self.database_router_id = YLeaf(YType.str, "database-router-id")

                                        self.is_opaque_database_capable = YLeaf(YType.boolean, "is-opaque-database-capable")

                                        self.database_counters = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters()
                                        self.database_counters.parent = self
                                        self._children_name_map["database_counters"] = "database-counters"
                                        self._children_yang_names.add("database-counters")

                                        self.area_database = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("database_router_id",
                                                        "is_opaque_database_capable") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary, self).__setattr__(name, value)


                                    class DatabaseCounters(Entity):
                                        """
                                        OSPFv3 database counters 
                                        
                                        .. attribute:: deleted_lsa
                                        
                                        	deleted lsa
                                        	**type**\:  list of int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa
                                        
                                        	lsa
                                        	**type**\:  list of int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_checksum
                                        
                                        	lsa checksum
                                        	**type**\:  list of int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_age_lsa
                                        
                                        	max age lsa
                                        	**type**\:  list of int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__init__()

                                            self.yang_name = "database-counters"
                                            self.yang_parent_name = "database-summary"

                                            self.deleted_lsa = YLeafList(YType.uint32, "deleted-lsa")

                                            self.lsa = YLeafList(YType.uint32, "lsa")

                                            self.lsa_checksum = YLeafList(YType.uint32, "lsa-checksum")

                                            self.max_age_lsa = YLeafList(YType.uint32, "max-age-lsa")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("deleted_lsa",
                                                            "lsa",
                                                            "lsa_checksum",
                                                            "max_age_lsa") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__setattr__(name, value)

                                        def has_data(self):
                                            for leaf in self.deleted_lsa.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            for leaf in self.lsa.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            for leaf in self.lsa_checksum.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            for leaf in self.max_age_lsa.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for leaf in self.deleted_lsa.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            for leaf in self.lsa.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            for leaf in self.lsa_checksum.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            for leaf in self.max_age_lsa.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.deleted_lsa.yfilter != YFilter.not_set or
                                                self.lsa.yfilter != YFilter.not_set or
                                                self.lsa_checksum.yfilter != YFilter.not_set or
                                                self.max_age_lsa.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "database-counters" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            leaf_name_data.extend(self.deleted_lsa.get_name_leafdata())

                                            leaf_name_data.extend(self.lsa.get_name_leafdata())

                                            leaf_name_data.extend(self.lsa_checksum.get_name_leafdata())

                                            leaf_name_data.extend(self.max_age_lsa.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "deleted-lsa" or name == "lsa" or name == "lsa-checksum" or name == "max-age-lsa"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "deleted-lsa"):
                                                self.deleted_lsa.append(value)
                                            if(value_path == "lsa"):
                                                self.lsa.append(value)
                                            if(value_path == "lsa-checksum"):
                                                self.lsa_checksum.append(value)
                                            if(value_path == "max-age-lsa"):
                                                self.max_age_lsa.append(value)


                                    class AreaDatabase(Entity):
                                        """
                                        OSPFv3 Area Database list 
                                        
                                        .. attribute:: area_database_summary
                                        
                                        	Area database summary 
                                        	**type**\:   :py:class:`AreaDatabaseSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary>`
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__init__()

                                            self.yang_name = "area-database"
                                            self.yang_parent_name = "database-summary"

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.area_database_summary = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary()
                                            self.area_database_summary.parent = self
                                            self._children_name_map["area_database_summary"] = "area-database-summary"
                                            self._children_yang_names.add("area-database-summary")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("lsa_area_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__setattr__(name, value)


                                        class AreaDatabaseSummary(Entity):
                                            """
                                            Area database summary 
                                            
                                            .. attribute:: deleted_lsa
                                            
                                            	deleted lsa
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa
                                            
                                            	lsa
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: lsa_checksum
                                            
                                            	lsa checksum
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_age_lsa
                                            
                                            	max age lsa
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__init__()

                                                self.yang_name = "area-database-summary"
                                                self.yang_parent_name = "area-database"

                                                self.deleted_lsa = YLeafList(YType.uint32, "deleted-lsa")

                                                self.lsa = YLeafList(YType.uint32, "lsa")

                                                self.lsa_checksum = YLeafList(YType.uint32, "lsa-checksum")

                                                self.max_age_lsa = YLeafList(YType.uint32, "max-age-lsa")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("deleted_lsa",
                                                                "lsa",
                                                                "lsa_checksum",
                                                                "max_age_lsa") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__setattr__(name, value)

                                            def has_data(self):
                                                for leaf in self.deleted_lsa.getYLeafs():
                                                    if (leaf.yfilter != YFilter.not_set):
                                                        return True
                                                for leaf in self.lsa.getYLeafs():
                                                    if (leaf.yfilter != YFilter.not_set):
                                                        return True
                                                for leaf in self.lsa_checksum.getYLeafs():
                                                    if (leaf.yfilter != YFilter.not_set):
                                                        return True
                                                for leaf in self.max_age_lsa.getYLeafs():
                                                    if (leaf.yfilter != YFilter.not_set):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for leaf in self.deleted_lsa.getYLeafs():
                                                    if (leaf.is_set):
                                                        return True
                                                for leaf in self.lsa.getYLeafs():
                                                    if (leaf.is_set):
                                                        return True
                                                for leaf in self.lsa_checksum.getYLeafs():
                                                    if (leaf.is_set):
                                                        return True
                                                for leaf in self.max_age_lsa.getYLeafs():
                                                    if (leaf.is_set):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.deleted_lsa.yfilter != YFilter.not_set or
                                                    self.lsa.yfilter != YFilter.not_set or
                                                    self.lsa_checksum.yfilter != YFilter.not_set or
                                                    self.max_age_lsa.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "area-database-summary" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                leaf_name_data.extend(self.deleted_lsa.get_name_leafdata())

                                                leaf_name_data.extend(self.lsa.get_name_leafdata())

                                                leaf_name_data.extend(self.lsa_checksum.get_name_leafdata())

                                                leaf_name_data.extend(self.max_age_lsa.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "deleted-lsa" or name == "lsa" or name == "lsa-checksum" or name == "max-age-lsa"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "deleted-lsa"):
                                                    self.deleted_lsa.append(value)
                                                if(value_path == "lsa"):
                                                    self.lsa.append(value)
                                                if(value_path == "lsa-checksum"):
                                                    self.lsa_checksum.append(value)
                                                if(value_path == "max-age-lsa"):
                                                    self.max_age_lsa.append(value)

                                        def has_data(self):
                                            return (
                                                self.lsa_area_id.is_set or
                                                (self.area_database_summary is not None and self.area_database_summary.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                (self.area_database_summary is not None and self.area_database_summary.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "area-database" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "area-database-summary"):
                                                if (self.area_database_summary is None):
                                                    self.area_database_summary = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary()
                                                    self.area_database_summary.parent = self
                                                    self._children_name_map["area_database_summary"] = "area-database-summary"
                                                return self.area_database_summary

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "area-database-summary" or name == "lsa-area-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.area_database:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.database_router_id.is_set or
                                            self.is_opaque_database_capable.is_set or
                                            (self.database_counters is not None and self.database_counters.has_data()))

                                    def has_operation(self):
                                        for c in self.area_database:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.database_router_id.yfilter != YFilter.not_set or
                                            self.is_opaque_database_capable.yfilter != YFilter.not_set or
                                            (self.database_counters is not None and self.database_counters.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "database-summary" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.database_router_id.is_set or self.database_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.database_router_id.get_name_leafdata())
                                        if (self.is_opaque_database_capable.is_set or self.is_opaque_database_capable.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_opaque_database_capable.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "area-database"):
                                            for c in self.area_database:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.area_database.append(c)
                                            return c

                                        if (child_yang_name == "database-counters"):
                                            if (self.database_counters is None):
                                                self.database_counters = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters()
                                                self.database_counters.parent = self
                                                self._children_name_map["database_counters"] = "database-counters"
                                            return self.database_counters

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "area-database" or name == "database-counters" or name == "database-router-id" or name == "is-opaque-database-capable"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "database-router-id"):
                                            self.database_router_id = value
                                            self.database_router_id.value_namespace = name_space
                                            self.database_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-opaque-database-capable"):
                                            self.is_opaque_database_capable = value
                                            self.is_opaque_database_capable.value_namespace = name_space
                                            self.is_opaque_database_capable.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.database_summary is not None and self.database_summary.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.database_summary is not None and self.database_summary.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "database-summary-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "database-summary"):
                                        if (self.database_summary is None):
                                            self.database_summary = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary()
                                            self.database_summary.parent = self
                                            self._children_name_map["database_summary"] = "database-summary"
                                        return self.database_summary

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "database-summary"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.area_id.is_set or
                                    (self.database_summary_table is not None and self.database_summary_table.has_data()) or
                                    (self.database_table is not None and self.database_table.has_data()) or
                                    (self.flood_list_table is not None and self.flood_list_table.has_data()) or
                                    (self.interface_brief_table is not None and self.interface_brief_table.has_data()) or
                                    (self.interface_table is not None and self.interface_table.has_data()) or
                                    (self.neighbor_detail_table is not None and self.neighbor_detail_table.has_data()) or
                                    (self.neighbor_table is not None and self.neighbor_table.has_data()) or
                                    (self.request_list_table is not None and self.request_list_table.has_data()) or
                                    (self.retransmission_list_table is not None and self.retransmission_list_table.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.area_id.yfilter != YFilter.not_set or
                                    (self.database_summary_table is not None and self.database_summary_table.has_operation()) or
                                    (self.database_table is not None and self.database_table.has_operation()) or
                                    (self.flood_list_table is not None and self.flood_list_table.has_operation()) or
                                    (self.interface_brief_table is not None and self.interface_brief_table.has_operation()) or
                                    (self.interface_table is not None and self.interface_table.has_operation()) or
                                    (self.neighbor_detail_table is not None and self.neighbor_detail_table.has_operation()) or
                                    (self.neighbor_table is not None and self.neighbor_table.has_operation()) or
                                    (self.request_list_table is not None and self.request_list_table.has_operation()) or
                                    (self.retransmission_list_table is not None and self.retransmission_list_table.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "area" + "[area-id='" + self.area_id.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "database-summary-table"):
                                    if (self.database_summary_table is None):
                                        self.database_summary_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseSummaryTable()
                                        self.database_summary_table.parent = self
                                        self._children_name_map["database_summary_table"] = "database-summary-table"
                                    return self.database_summary_table

                                if (child_yang_name == "database-table"):
                                    if (self.database_table is None):
                                        self.database_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.DatabaseTable()
                                        self.database_table.parent = self
                                        self._children_name_map["database_table"] = "database-table"
                                    return self.database_table

                                if (child_yang_name == "flood-list-table"):
                                    if (self.flood_list_table is None):
                                        self.flood_list_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.FloodListTable()
                                        self.flood_list_table.parent = self
                                        self._children_name_map["flood_list_table"] = "flood-list-table"
                                    return self.flood_list_table

                                if (child_yang_name == "interface-brief-table"):
                                    if (self.interface_brief_table is None):
                                        self.interface_brief_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceBriefTable()
                                        self.interface_brief_table.parent = self
                                        self._children_name_map["interface_brief_table"] = "interface-brief-table"
                                    return self.interface_brief_table

                                if (child_yang_name == "interface-table"):
                                    if (self.interface_table is None):
                                        self.interface_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.InterfaceTable()
                                        self.interface_table.parent = self
                                        self._children_name_map["interface_table"] = "interface-table"
                                    return self.interface_table

                                if (child_yang_name == "neighbor-detail-table"):
                                    if (self.neighbor_detail_table is None):
                                        self.neighbor_detail_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborDetailTable()
                                        self.neighbor_detail_table.parent = self
                                        self._children_name_map["neighbor_detail_table"] = "neighbor-detail-table"
                                    return self.neighbor_detail_table

                                if (child_yang_name == "neighbor-table"):
                                    if (self.neighbor_table is None):
                                        self.neighbor_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.NeighborTable()
                                        self.neighbor_table.parent = self
                                        self._children_name_map["neighbor_table"] = "neighbor-table"
                                    return self.neighbor_table

                                if (child_yang_name == "request-list-table"):
                                    if (self.request_list_table is None):
                                        self.request_list_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RequestListTable()
                                        self.request_list_table.parent = self
                                        self._children_name_map["request_list_table"] = "request-list-table"
                                    return self.request_list_table

                                if (child_yang_name == "retransmission-list-table"):
                                    if (self.retransmission_list_table is None):
                                        self.retransmission_list_table = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area.RetransmissionListTable()
                                        self.retransmission_list_table.parent = self
                                        self._children_name_map["retransmission_list_table"] = "retransmission-list-table"
                                    return self.retransmission_list_table

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "database-summary-table" or name == "database-table" or name == "flood-list-table" or name == "interface-brief-table" or name == "interface-table" or name == "neighbor-detail-table" or name == "neighbor-table" or name == "request-list-table" or name == "retransmission-list-table" or name == "area-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "area-id"):
                                    self.area_id = value
                                    self.area_id.value_namespace = name_space
                                    self.area_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.area:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.area:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "areas" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "area"):
                                for c in self.area:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.Areas.Area()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.area.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class InternalRoutes(Entity):
                        """
                        OSPFv3 internal route information table
                        
                        .. attribute:: internal_route
                        
                        	OSPFv3 internal route information
                        	**type**\: list of    :py:class:`InternalRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes, self).__init__()

                            self.yang_name = "internal-routes"
                            self.yang_parent_name = "vrf"

                            self.internal_route = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes, self).__setattr__(name, value)


                        class InternalRoute(Entity):
                            """
                            OSPFv3 internal route information
                            
                            .. attribute:: prefix
                            
                            	Route prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..128
                            
                            .. attribute:: route_area_id
                            
                            	Route area ID 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: route_path
                            
                            	List of paths to this route
                            	**type**\: list of    :py:class:`RoutePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath>`
                            
                            .. attribute:: route_source
                            
                            	List of topology source information
                            	**type**\: list of    :py:class:`RouteSource <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteSource>`
                            
                            .. attribute:: route_topology
                            
                            	Common Route topology information
                            	**type**\:   :py:class:`RouteTopology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteTopology>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute, self).__init__()

                                self.yang_name = "internal-route"
                                self.yang_parent_name = "internal-routes"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.route_area_id = YLeaf(YType.uint32, "route-area-id")

                                self.route_topology = Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteTopology()
                                self.route_topology.parent = self
                                self._children_name_map["route_topology"] = "route-topology"
                                self._children_yang_names.add("route-topology")

                                self.route_path = YList(self)
                                self.route_source = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "route_area_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute, self).__setattr__(name, value)


                            class RouteTopology(Entity):
                                """
                                Common Route topology information
                                
                                .. attribute:: route_cost
                                
                                	Route cost 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: route_distance
                                
                                	Route distance 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: route_id
                                
                                	Route ID 
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: route_type
                                
                                	Route type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteTopology, self).__init__()

                                    self.yang_name = "route-topology"
                                    self.yang_parent_name = "internal-route"

                                    self.route_cost = YLeaf(YType.uint32, "route-cost")

                                    self.route_distance = YLeaf(YType.uint32, "route-distance")

                                    self.route_id = YLeaf(YType.str, "route-id")

                                    self.route_type = YLeaf(YType.uint32, "route-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("route_cost",
                                                    "route_distance",
                                                    "route_id",
                                                    "route_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteTopology, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteTopology, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.route_cost.is_set or
                                        self.route_distance.is_set or
                                        self.route_id.is_set or
                                        self.route_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.route_cost.yfilter != YFilter.not_set or
                                        self.route_distance.yfilter != YFilter.not_set or
                                        self.route_id.yfilter != YFilter.not_set or
                                        self.route_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-topology" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.route_cost.is_set or self.route_cost.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_cost.get_name_leafdata())
                                    if (self.route_distance.is_set or self.route_distance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distance.get_name_leafdata())
                                    if (self.route_id.is_set or self.route_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_id.get_name_leafdata())
                                    if (self.route_type.is_set or self.route_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "route-cost" or name == "route-distance" or name == "route-id" or name == "route-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "route-cost"):
                                        self.route_cost = value
                                        self.route_cost.value_namespace = name_space
                                        self.route_cost.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distance"):
                                        self.route_distance = value
                                        self.route_distance.value_namespace = name_space
                                        self.route_distance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-id"):
                                        self.route_id = value
                                        self.route_id.value_namespace = name_space
                                        self.route_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-type"):
                                        self.route_type = value
                                        self.route_type.value_namespace = name_space
                                        self.route_type.value_namespace_prefix = name_space_prefix


                            class RouteSource(Entity):
                                """
                                List of topology source information
                                
                                .. attribute:: route_source_adversting_router
                                
                                	Route source of the advertising router 
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: route_source_id
                                
                                	Route source ID 
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: route_source_lsa_type
                                
                                	Type of LSA advertising the prefix, see RFC5340
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteSource, self).__init__()

                                    self.yang_name = "route-source"
                                    self.yang_parent_name = "internal-route"

                                    self.route_source_adversting_router = YLeaf(YType.str, "route-source-adversting-router")

                                    self.route_source_id = YLeaf(YType.str, "route-source-id")

                                    self.route_source_lsa_type = YLeaf(YType.uint32, "route-source-lsa-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("route_source_adversting_router",
                                                    "route_source_id",
                                                    "route_source_lsa_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteSource, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteSource, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.route_source_adversting_router.is_set or
                                        self.route_source_id.is_set or
                                        self.route_source_lsa_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.route_source_adversting_router.yfilter != YFilter.not_set or
                                        self.route_source_id.yfilter != YFilter.not_set or
                                        self.route_source_lsa_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-source" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.route_source_adversting_router.is_set or self.route_source_adversting_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_source_adversting_router.get_name_leafdata())
                                    if (self.route_source_id.is_set or self.route_source_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_source_id.get_name_leafdata())
                                    if (self.route_source_lsa_type.is_set or self.route_source_lsa_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_source_lsa_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "route-source-adversting-router" or name == "route-source-id" or name == "route-source-lsa-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "route-source-adversting-router"):
                                        self.route_source_adversting_router = value
                                        self.route_source_adversting_router.value_namespace = name_space
                                        self.route_source_adversting_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-source-id"):
                                        self.route_source_id = value
                                        self.route_source_id.value_namespace = name_space
                                        self.route_source_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-source-lsa-type"):
                                        self.route_source_lsa_type = value
                                        self.route_source_lsa_type.value_namespace = name_space
                                        self.route_source_lsa_type.value_namespace_prefix = name_space_prefix


                            class RoutePath(Entity):
                                """
                                List of paths to this route
                                
                                .. attribute:: interface_name
                                
                                	Route path interface name 
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: route_backup_path
                                
                                	Backup Path Info
                                	**type**\:   :py:class:`RouteBackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath>`
                                
                                .. attribute:: route_path_id
                                
                                	Path ID of path
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: route_path_next_hop
                                
                                	Route path next hop 
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath, self).__init__()

                                    self.yang_name = "route-path"
                                    self.yang_parent_name = "internal-route"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.route_path_id = YLeaf(YType.uint16, "route-path-id")

                                    self.route_path_next_hop = YLeaf(YType.str, "route-path-next-hop")

                                    self.route_backup_path = Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath()
                                    self.route_backup_path.parent = self
                                    self._children_name_map["route_backup_path"] = "route-backup-path"
                                    self._children_yang_names.add("route-backup-path")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "route_path_id",
                                                    "route_path_next_hop") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath, self).__setattr__(name, value)


                                class RouteBackupPath(Entity):
                                    """
                                    Backup Path Info
                                    
                                    .. attribute:: backup_metric
                                    
                                    	Metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: backup_route_interface_name
                                    
                                    	Next hop Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: backup_route_next_hop_address
                                    
                                    	Nexthop IP address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: backup_route_source
                                    
                                    	IP address of source of route
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: downstream
                                    
                                    	Downstream
                                    	**type**\:  bool
                                    
                                    .. attribute:: line_card_disjoint
                                    
                                    	Line Card Disjoint
                                    	**type**\:  bool
                                    
                                    .. attribute:: node_protect
                                    
                                    	Node Protect
                                    	**type**\:  bool
                                    
                                    .. attribute:: primary_path
                                    
                                    	Primary Path
                                    	**type**\:  bool
                                    
                                    .. attribute:: srlg_disjoint
                                    
                                    	SRLG Disjoint
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath, self).__init__()

                                        self.yang_name = "route-backup-path"
                                        self.yang_parent_name = "route-path"

                                        self.backup_metric = YLeaf(YType.uint32, "backup-metric")

                                        self.backup_route_interface_name = YLeaf(YType.str, "backup-route-interface-name")

                                        self.backup_route_next_hop_address = YLeaf(YType.str, "backup-route-next-hop-address")

                                        self.backup_route_source = YLeaf(YType.str, "backup-route-source")

                                        self.downstream = YLeaf(YType.boolean, "downstream")

                                        self.line_card_disjoint = YLeaf(YType.boolean, "line-card-disjoint")

                                        self.node_protect = YLeaf(YType.boolean, "node-protect")

                                        self.primary_path = YLeaf(YType.boolean, "primary-path")

                                        self.srlg_disjoint = YLeaf(YType.boolean, "srlg-disjoint")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_metric",
                                                        "backup_route_interface_name",
                                                        "backup_route_next_hop_address",
                                                        "backup_route_source",
                                                        "downstream",
                                                        "line_card_disjoint",
                                                        "node_protect",
                                                        "primary_path",
                                                        "srlg_disjoint") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_metric.is_set or
                                            self.backup_route_interface_name.is_set or
                                            self.backup_route_next_hop_address.is_set or
                                            self.backup_route_source.is_set or
                                            self.downstream.is_set or
                                            self.line_card_disjoint.is_set or
                                            self.node_protect.is_set or
                                            self.primary_path.is_set or
                                            self.srlg_disjoint.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_metric.yfilter != YFilter.not_set or
                                            self.backup_route_interface_name.yfilter != YFilter.not_set or
                                            self.backup_route_next_hop_address.yfilter != YFilter.not_set or
                                            self.backup_route_source.yfilter != YFilter.not_set or
                                            self.downstream.yfilter != YFilter.not_set or
                                            self.line_card_disjoint.yfilter != YFilter.not_set or
                                            self.node_protect.yfilter != YFilter.not_set or
                                            self.primary_path.yfilter != YFilter.not_set or
                                            self.srlg_disjoint.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "route-backup-path" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_metric.is_set or self.backup_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_metric.get_name_leafdata())
                                        if (self.backup_route_interface_name.is_set or self.backup_route_interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_route_interface_name.get_name_leafdata())
                                        if (self.backup_route_next_hop_address.is_set or self.backup_route_next_hop_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_route_next_hop_address.get_name_leafdata())
                                        if (self.backup_route_source.is_set or self.backup_route_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_route_source.get_name_leafdata())
                                        if (self.downstream.is_set or self.downstream.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.downstream.get_name_leafdata())
                                        if (self.line_card_disjoint.is_set or self.line_card_disjoint.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.line_card_disjoint.get_name_leafdata())
                                        if (self.node_protect.is_set or self.node_protect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.node_protect.get_name_leafdata())
                                        if (self.primary_path.is_set or self.primary_path.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.primary_path.get_name_leafdata())
                                        if (self.srlg_disjoint.is_set or self.srlg_disjoint.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_disjoint.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-metric" or name == "backup-route-interface-name" or name == "backup-route-next-hop-address" or name == "backup-route-source" or name == "downstream" or name == "line-card-disjoint" or name == "node-protect" or name == "primary-path" or name == "srlg-disjoint"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-metric"):
                                            self.backup_metric = value
                                            self.backup_metric.value_namespace = name_space
                                            self.backup_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-route-interface-name"):
                                            self.backup_route_interface_name = value
                                            self.backup_route_interface_name.value_namespace = name_space
                                            self.backup_route_interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-route-next-hop-address"):
                                            self.backup_route_next_hop_address = value
                                            self.backup_route_next_hop_address.value_namespace = name_space
                                            self.backup_route_next_hop_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-route-source"):
                                            self.backup_route_source = value
                                            self.backup_route_source.value_namespace = name_space
                                            self.backup_route_source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "downstream"):
                                            self.downstream = value
                                            self.downstream.value_namespace = name_space
                                            self.downstream.value_namespace_prefix = name_space_prefix
                                        if(value_path == "line-card-disjoint"):
                                            self.line_card_disjoint = value
                                            self.line_card_disjoint.value_namespace = name_space
                                            self.line_card_disjoint.value_namespace_prefix = name_space_prefix
                                        if(value_path == "node-protect"):
                                            self.node_protect = value
                                            self.node_protect.value_namespace = name_space
                                            self.node_protect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "primary-path"):
                                            self.primary_path = value
                                            self.primary_path.value_namespace = name_space
                                            self.primary_path.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-disjoint"):
                                            self.srlg_disjoint = value
                                            self.srlg_disjoint.value_namespace = name_space
                                            self.srlg_disjoint.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        self.route_path_id.is_set or
                                        self.route_path_next_hop.is_set or
                                        (self.route_backup_path is not None and self.route_backup_path.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.route_path_id.yfilter != YFilter.not_set or
                                        self.route_path_next_hop.yfilter != YFilter.not_set or
                                        (self.route_backup_path is not None and self.route_backup_path.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.route_path_id.is_set or self.route_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_path_id.get_name_leafdata())
                                    if (self.route_path_next_hop.is_set or self.route_path_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_path_next_hop.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "route-backup-path"):
                                        if (self.route_backup_path is None):
                                            self.route_backup_path = Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath()
                                            self.route_backup_path.parent = self
                                            self._children_name_map["route_backup_path"] = "route-backup-path"
                                        return self.route_backup_path

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "route-backup-path" or name == "interface-name" or name == "route-path-id" or name == "route-path-next-hop"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-path-id"):
                                        self.route_path_id = value
                                        self.route_path_id.value_namespace = name_space
                                        self.route_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-path-next-hop"):
                                        self.route_path_next_hop = value
                                        self.route_path_next_hop.value_namespace = name_space
                                        self.route_path_next_hop.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.route_path:
                                    if (c.has_data()):
                                        return True
                                for c in self.route_source:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.route_area_id.is_set or
                                    (self.route_topology is not None and self.route_topology.has_data()))

                            def has_operation(self):
                                for c in self.route_path:
                                    if (c.has_operation()):
                                        return True
                                for c in self.route_source:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.route_area_id.yfilter != YFilter.not_set or
                                    (self.route_topology is not None and self.route_topology.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "internal-route" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.route_area_id.is_set or self.route_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_area_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "route-path"):
                                    for c in self.route_path:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RoutePath()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.route_path.append(c)
                                    return c

                                if (child_yang_name == "route-source"):
                                    for c in self.route_source:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteSource()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.route_source.append(c)
                                    return c

                                if (child_yang_name == "route-topology"):
                                    if (self.route_topology is None):
                                        self.route_topology = Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute.RouteTopology()
                                        self.route_topology.parent = self
                                        self._children_name_map["route_topology"] = "route-topology"
                                    return self.route_topology

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "route-path" or name == "route-source" or name == "route-topology" or name == "prefix" or name == "prefix-length" or name == "route-area-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-area-id"):
                                    self.route_area_id = value
                                    self.route_area_id.value_namespace = name_space
                                    self.route_area_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.internal_route:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.internal_route:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "internal-routes" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "internal-route"):
                                for c in self.internal_route:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes.InternalRoute()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.internal_route.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "internal-route"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class ProtocolAreas(Entity):
                        """
                        Protocol area table 
                        
                        .. attribute:: protocol_area
                        
                        	Area information 
                        	**type**\: list of    :py:class:`ProtocolArea <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas.ProtocolArea>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas, self).__init__()

                            self.yang_name = "protocol-areas"
                            self.yang_parent_name = "vrf"

                            self.protocol_area = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas, self).__setattr__(name, value)


                        class ProtocolArea(Entity):
                            """
                            Area information 
                            
                            .. attribute:: area_id  <key>
                            
                            	Area ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: distribute_list_in
                            
                            	Distribute List In
                            	**type**\:  str
                            
                            .. attribute:: protocol_area_id
                            
                            	Area ID string in decimal and dotted\-decimal format
                            	**type**\:  str
                            
                            	**length:** 0..16
                            
                            .. attribute:: protocol_interface
                            
                            	Interface list
                            	**type**\: list of    :py:class:`ProtocolInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas.ProtocolArea.ProtocolInterface>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas.ProtocolArea, self).__init__()

                                self.yang_name = "protocol-area"
                                self.yang_parent_name = "protocol-areas"

                                self.area_id = YLeaf(YType.str, "area-id")

                                self.distribute_list_in = YLeaf(YType.str, "distribute-list-in")

                                self.protocol_area_id = YLeaf(YType.str, "protocol-area-id")

                                self.protocol_interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("area_id",
                                                "distribute_list_in",
                                                "protocol_area_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas.ProtocolArea, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas.ProtocolArea, self).__setattr__(name, value)


                            class ProtocolInterface(Entity):
                                """
                                Interface list
                                
                                .. attribute:: distribute_list_in
                                
                                	Distribute List In
                                	**type**\:  str
                                
                                .. attribute:: interface_name
                                
                                	Protocol interface name 
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas.ProtocolArea.ProtocolInterface, self).__init__()

                                    self.yang_name = "protocol-interface"
                                    self.yang_parent_name = "protocol-area"

                                    self.distribute_list_in = YLeaf(YType.str, "distribute-list-in")

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("distribute_list_in",
                                                    "interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas.ProtocolArea.ProtocolInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas.ProtocolArea.ProtocolInterface, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.distribute_list_in.is_set or
                                        self.interface_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.distribute_list_in.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protocol-interface" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.distribute_list_in.is_set or self.distribute_list_in.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.distribute_list_in.get_name_leafdata())
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "distribute-list-in" or name == "interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "distribute-list-in"):
                                        self.distribute_list_in = value
                                        self.distribute_list_in.value_namespace = name_space
                                        self.distribute_list_in.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.protocol_interface:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.area_id.is_set or
                                    self.distribute_list_in.is_set or
                                    self.protocol_area_id.is_set)

                            def has_operation(self):
                                for c in self.protocol_interface:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.area_id.yfilter != YFilter.not_set or
                                    self.distribute_list_in.yfilter != YFilter.not_set or
                                    self.protocol_area_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protocol-area" + "[area-id='" + self.area_id.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_id.get_name_leafdata())
                                if (self.distribute_list_in.is_set or self.distribute_list_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.distribute_list_in.get_name_leafdata())
                                if (self.protocol_area_id.is_set or self.protocol_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protocol_area_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "protocol-interface"):
                                    for c in self.protocol_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas.ProtocolArea.ProtocolInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.protocol_interface.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "protocol-interface" or name == "area-id" or name == "distribute-list-in" or name == "protocol-area-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "area-id"):
                                    self.area_id = value
                                    self.area_id.value_namespace = name_space
                                    self.area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "distribute-list-in"):
                                    self.distribute_list_in = value
                                    self.distribute_list_in.value_namespace = name_space
                                    self.distribute_list_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "protocol-area-id"):
                                    self.protocol_area_id = value
                                    self.protocol_area_id.value_namespace = name_space
                                    self.protocol_area_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.protocol_area:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.protocol_area:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protocol-areas" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protocol-area"):
                                for c in self.protocol_area:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas.ProtocolArea()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.protocol_area.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protocol-area"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class ConnectedRoutes(Entity):
                        """
                        OSPFv3 connected route information table
                        
                        .. attribute:: connected_route
                        
                        	OSPFv3 connected route information
                        	**type**\: list of    :py:class:`ConnectedRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes, self).__init__()

                            self.yang_name = "connected-routes"
                            self.yang_parent_name = "vrf"

                            self.connected_route = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes, self).__setattr__(name, value)


                        class ConnectedRoute(Entity):
                            """
                            OSPFv3 connected route information
                            
                            .. attribute:: prefix
                            
                            	Route prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..128
                            
                            .. attribute:: route_path
                            
                            	List of paths to this route
                            	**type**\: list of    :py:class:`RoutePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath>`
                            
                            .. attribute:: route_topology
                            
                            	Common Route topology information
                            	**type**\:   :py:class:`RouteTopology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RouteTopology>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute, self).__init__()

                                self.yang_name = "connected-route"
                                self.yang_parent_name = "connected-routes"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.route_topology = Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RouteTopology()
                                self.route_topology.parent = self
                                self._children_name_map["route_topology"] = "route-topology"
                                self._children_yang_names.add("route-topology")

                                self.route_path = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute, self).__setattr__(name, value)


                            class RouteTopology(Entity):
                                """
                                Common Route topology information
                                
                                .. attribute:: route_cost
                                
                                	Route cost 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: route_distance
                                
                                	Route distance 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: route_id
                                
                                	Route ID 
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: route_type
                                
                                	Route type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RouteTopology, self).__init__()

                                    self.yang_name = "route-topology"
                                    self.yang_parent_name = "connected-route"

                                    self.route_cost = YLeaf(YType.uint32, "route-cost")

                                    self.route_distance = YLeaf(YType.uint32, "route-distance")

                                    self.route_id = YLeaf(YType.str, "route-id")

                                    self.route_type = YLeaf(YType.uint32, "route-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("route_cost",
                                                    "route_distance",
                                                    "route_id",
                                                    "route_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RouteTopology, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RouteTopology, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.route_cost.is_set or
                                        self.route_distance.is_set or
                                        self.route_id.is_set or
                                        self.route_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.route_cost.yfilter != YFilter.not_set or
                                        self.route_distance.yfilter != YFilter.not_set or
                                        self.route_id.yfilter != YFilter.not_set or
                                        self.route_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-topology" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.route_cost.is_set or self.route_cost.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_cost.get_name_leafdata())
                                    if (self.route_distance.is_set or self.route_distance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distance.get_name_leafdata())
                                    if (self.route_id.is_set or self.route_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_id.get_name_leafdata())
                                    if (self.route_type.is_set or self.route_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "route-cost" or name == "route-distance" or name == "route-id" or name == "route-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "route-cost"):
                                        self.route_cost = value
                                        self.route_cost.value_namespace = name_space
                                        self.route_cost.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distance"):
                                        self.route_distance = value
                                        self.route_distance.value_namespace = name_space
                                        self.route_distance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-id"):
                                        self.route_id = value
                                        self.route_id.value_namespace = name_space
                                        self.route_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-type"):
                                        self.route_type = value
                                        self.route_type.value_namespace = name_space
                                        self.route_type.value_namespace_prefix = name_space_prefix


                            class RoutePath(Entity):
                                """
                                List of paths to this route
                                
                                .. attribute:: interface_name
                                
                                	Route path interface name 
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: route_backup_path
                                
                                	Backup Path Info
                                	**type**\:   :py:class:`RouteBackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath>`
                                
                                .. attribute:: route_path_id
                                
                                	Path ID of path
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: route_path_next_hop
                                
                                	Route path next hop 
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath, self).__init__()

                                    self.yang_name = "route-path"
                                    self.yang_parent_name = "connected-route"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.route_path_id = YLeaf(YType.uint16, "route-path-id")

                                    self.route_path_next_hop = YLeaf(YType.str, "route-path-next-hop")

                                    self.route_backup_path = Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath()
                                    self.route_backup_path.parent = self
                                    self._children_name_map["route_backup_path"] = "route-backup-path"
                                    self._children_yang_names.add("route-backup-path")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "route_path_id",
                                                    "route_path_next_hop") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath, self).__setattr__(name, value)


                                class RouteBackupPath(Entity):
                                    """
                                    Backup Path Info
                                    
                                    .. attribute:: backup_metric
                                    
                                    	Metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: backup_route_interface_name
                                    
                                    	Next hop Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: backup_route_next_hop_address
                                    
                                    	Nexthop IP address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: backup_route_source
                                    
                                    	IP address of source of route
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: downstream
                                    
                                    	Downstream
                                    	**type**\:  bool
                                    
                                    .. attribute:: line_card_disjoint
                                    
                                    	Line Card Disjoint
                                    	**type**\:  bool
                                    
                                    .. attribute:: node_protect
                                    
                                    	Node Protect
                                    	**type**\:  bool
                                    
                                    .. attribute:: primary_path
                                    
                                    	Primary Path
                                    	**type**\:  bool
                                    
                                    .. attribute:: srlg_disjoint
                                    
                                    	SRLG Disjoint
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath, self).__init__()

                                        self.yang_name = "route-backup-path"
                                        self.yang_parent_name = "route-path"

                                        self.backup_metric = YLeaf(YType.uint32, "backup-metric")

                                        self.backup_route_interface_name = YLeaf(YType.str, "backup-route-interface-name")

                                        self.backup_route_next_hop_address = YLeaf(YType.str, "backup-route-next-hop-address")

                                        self.backup_route_source = YLeaf(YType.str, "backup-route-source")

                                        self.downstream = YLeaf(YType.boolean, "downstream")

                                        self.line_card_disjoint = YLeaf(YType.boolean, "line-card-disjoint")

                                        self.node_protect = YLeaf(YType.boolean, "node-protect")

                                        self.primary_path = YLeaf(YType.boolean, "primary-path")

                                        self.srlg_disjoint = YLeaf(YType.boolean, "srlg-disjoint")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_metric",
                                                        "backup_route_interface_name",
                                                        "backup_route_next_hop_address",
                                                        "backup_route_source",
                                                        "downstream",
                                                        "line_card_disjoint",
                                                        "node_protect",
                                                        "primary_path",
                                                        "srlg_disjoint") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_metric.is_set or
                                            self.backup_route_interface_name.is_set or
                                            self.backup_route_next_hop_address.is_set or
                                            self.backup_route_source.is_set or
                                            self.downstream.is_set or
                                            self.line_card_disjoint.is_set or
                                            self.node_protect.is_set or
                                            self.primary_path.is_set or
                                            self.srlg_disjoint.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_metric.yfilter != YFilter.not_set or
                                            self.backup_route_interface_name.yfilter != YFilter.not_set or
                                            self.backup_route_next_hop_address.yfilter != YFilter.not_set or
                                            self.backup_route_source.yfilter != YFilter.not_set or
                                            self.downstream.yfilter != YFilter.not_set or
                                            self.line_card_disjoint.yfilter != YFilter.not_set or
                                            self.node_protect.yfilter != YFilter.not_set or
                                            self.primary_path.yfilter != YFilter.not_set or
                                            self.srlg_disjoint.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "route-backup-path" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_metric.is_set or self.backup_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_metric.get_name_leafdata())
                                        if (self.backup_route_interface_name.is_set or self.backup_route_interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_route_interface_name.get_name_leafdata())
                                        if (self.backup_route_next_hop_address.is_set or self.backup_route_next_hop_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_route_next_hop_address.get_name_leafdata())
                                        if (self.backup_route_source.is_set or self.backup_route_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_route_source.get_name_leafdata())
                                        if (self.downstream.is_set or self.downstream.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.downstream.get_name_leafdata())
                                        if (self.line_card_disjoint.is_set or self.line_card_disjoint.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.line_card_disjoint.get_name_leafdata())
                                        if (self.node_protect.is_set or self.node_protect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.node_protect.get_name_leafdata())
                                        if (self.primary_path.is_set or self.primary_path.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.primary_path.get_name_leafdata())
                                        if (self.srlg_disjoint.is_set or self.srlg_disjoint.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_disjoint.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-metric" or name == "backup-route-interface-name" or name == "backup-route-next-hop-address" or name == "backup-route-source" or name == "downstream" or name == "line-card-disjoint" or name == "node-protect" or name == "primary-path" or name == "srlg-disjoint"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-metric"):
                                            self.backup_metric = value
                                            self.backup_metric.value_namespace = name_space
                                            self.backup_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-route-interface-name"):
                                            self.backup_route_interface_name = value
                                            self.backup_route_interface_name.value_namespace = name_space
                                            self.backup_route_interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-route-next-hop-address"):
                                            self.backup_route_next_hop_address = value
                                            self.backup_route_next_hop_address.value_namespace = name_space
                                            self.backup_route_next_hop_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-route-source"):
                                            self.backup_route_source = value
                                            self.backup_route_source.value_namespace = name_space
                                            self.backup_route_source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "downstream"):
                                            self.downstream = value
                                            self.downstream.value_namespace = name_space
                                            self.downstream.value_namespace_prefix = name_space_prefix
                                        if(value_path == "line-card-disjoint"):
                                            self.line_card_disjoint = value
                                            self.line_card_disjoint.value_namespace = name_space
                                            self.line_card_disjoint.value_namespace_prefix = name_space_prefix
                                        if(value_path == "node-protect"):
                                            self.node_protect = value
                                            self.node_protect.value_namespace = name_space
                                            self.node_protect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "primary-path"):
                                            self.primary_path = value
                                            self.primary_path.value_namespace = name_space
                                            self.primary_path.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-disjoint"):
                                            self.srlg_disjoint = value
                                            self.srlg_disjoint.value_namespace = name_space
                                            self.srlg_disjoint.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        self.route_path_id.is_set or
                                        self.route_path_next_hop.is_set or
                                        (self.route_backup_path is not None and self.route_backup_path.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.route_path_id.yfilter != YFilter.not_set or
                                        self.route_path_next_hop.yfilter != YFilter.not_set or
                                        (self.route_backup_path is not None and self.route_backup_path.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.route_path_id.is_set or self.route_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_path_id.get_name_leafdata())
                                    if (self.route_path_next_hop.is_set or self.route_path_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_path_next_hop.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "route-backup-path"):
                                        if (self.route_backup_path is None):
                                            self.route_backup_path = Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath()
                                            self.route_backup_path.parent = self
                                            self._children_name_map["route_backup_path"] = "route-backup-path"
                                        return self.route_backup_path

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "route-backup-path" or name == "interface-name" or name == "route-path-id" or name == "route-path-next-hop"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-path-id"):
                                        self.route_path_id = value
                                        self.route_path_id.value_namespace = name_space
                                        self.route_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-path-next-hop"):
                                        self.route_path_next_hop = value
                                        self.route_path_next_hop.value_namespace = name_space
                                        self.route_path_next_hop.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.route_path:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    (self.route_topology is not None and self.route_topology.has_data()))

                            def has_operation(self):
                                for c in self.route_path:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    (self.route_topology is not None and self.route_topology.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "connected-route" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "route-path"):
                                    for c in self.route_path:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RoutePath()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.route_path.append(c)
                                    return c

                                if (child_yang_name == "route-topology"):
                                    if (self.route_topology is None):
                                        self.route_topology = Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute.RouteTopology()
                                        self.route_topology.parent = self
                                        self._children_name_map["route_topology"] = "route-topology"
                                    return self.route_topology

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "route-path" or name == "route-topology" or name == "prefix" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.connected_route:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.connected_route:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "connected-routes" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "connected-route"):
                                for c in self.connected_route:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes.ConnectedRoute()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.connected_route.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "connected-route"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class VrfStatistics(Entity):
                        """
                        Container for Statistics
                        
                        .. attribute:: prefix_priority_stats
                        
                        	OSPF Prefix SPF Prioritization statistics
                        	**type**\:   :py:class:`PrefixPriorityStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.PrefixPriorityStats>`
                        
                        .. attribute:: protocol_stats
                        
                        	Protocol table
                        	**type**\:   :py:class:`ProtocolStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats>`
                        
                        .. attribute:: rawio_stats
                        
                        	OSPF Prefix SPF Prioritization statistics
                        	**type**\:   :py:class:`RawioStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.RawioStats>`
                        
                        .. attribute:: spf_stats
                        
                        	OSPFv3 RIB batch statistics
                        	**type**\:   :py:class:`SpfStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats>`
                        
                        .. attribute:: vrf_rib_batch_stats
                        
                        	OSPFv3 RIB batch statistics
                        	**type**\:   :py:class:`VrfRibBatchStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.VrfRibBatchStats>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics, self).__init__()

                            self.yang_name = "vrf-statistics"
                            self.yang_parent_name = "vrf"

                            self.prefix_priority_stats = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.PrefixPriorityStats()
                            self.prefix_priority_stats.parent = self
                            self._children_name_map["prefix_priority_stats"] = "prefix-priority-stats"
                            self._children_yang_names.add("prefix-priority-stats")

                            self.protocol_stats = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats()
                            self.protocol_stats.parent = self
                            self._children_name_map["protocol_stats"] = "protocol-stats"
                            self._children_yang_names.add("protocol-stats")

                            self.rawio_stats = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.RawioStats()
                            self.rawio_stats.parent = self
                            self._children_name_map["rawio_stats"] = "rawio-stats"
                            self._children_yang_names.add("rawio-stats")

                            self.spf_stats = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats()
                            self.spf_stats.parent = self
                            self._children_name_map["spf_stats"] = "spf-stats"
                            self._children_yang_names.add("spf-stats")

                            self.vrf_rib_batch_stats = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.VrfRibBatchStats()
                            self.vrf_rib_batch_stats.parent = self
                            self._children_name_map["vrf_rib_batch_stats"] = "vrf-rib-batch-stats"
                            self._children_yang_names.add("vrf-rib-batch-stats")


                        class ProtocolStats(Entity):
                            """
                            Protocol table
                            
                            .. attribute:: protocol_stat
                            
                            	Protocol statistics for an interface
                            	**type**\: list of    :py:class:`ProtocolStat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats.ProtocolStat>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats, self).__init__()

                                self.yang_name = "protocol-stats"
                                self.yang_parent_name = "vrf-statistics"

                                self.protocol_stat = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats, self).__setattr__(name, value)


                            class ProtocolStat(Entity):
                                """
                                Protocol statistics for an interface
                                
                                .. attribute:: interface_name  <key>
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: checksum_err
                                
                                	Checksum Errors
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: dbdes_in_ls_as
                                
                                	Database Description LSAs in
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: dbdes_in_packets
                                
                                	Database Description Packets in
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: dbdes_out_ls_as
                                
                                	Database Description LSAs out
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: dbdes_out_packets
                                
                                	Database Description Packets out
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: dropped_in_gs
                                
                                	Dropped in GS
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: hello_in_packets
                                
                                	Hello packets in
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: hello_out_packets
                                
                                	Hello Out Packets
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_ack_in_ls_as
                                
                                	LS Ack LSAs in
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_ack_in_packets
                                
                                	LS Acks Packets in
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_ack_out_ls_as
                                
                                	LS Ack LSAs out
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_ack_out_packets
                                
                                	LS Ack Packets out
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_req_in_ls_as
                                
                                	LS Requests in
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_req_in_packets
                                
                                	LSA Requests in
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_req_out_ls_as
                                
                                	LS Reuqests LSAs out
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_req_out_packets
                                
                                	LS Request Packets out
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_upd_in_ignored
                                
                                	LS Updates ignored
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_upd_in_ls_as
                                
                                	LS Updates LSAs in
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_upd_in_packets
                                
                                	LS Updates Packets in
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_upd_out_ls_as
                                
                                	LS Update LSAs out
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: ls_upd_out_packets
                                
                                	LS Update Packets out
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: total_in_packets
                                
                                	Total inputs packets
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: total_out_packets
                                
                                	Total Out Packets
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats.ProtocolStat, self).__init__()

                                    self.yang_name = "protocol-stat"
                                    self.yang_parent_name = "protocol-stats"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.checksum_err = YLeaf(YType.uint64, "checksum-err")

                                    self.dbdes_in_ls_as = YLeaf(YType.uint64, "dbdes-in-ls-as")

                                    self.dbdes_in_packets = YLeaf(YType.uint64, "dbdes-in-packets")

                                    self.dbdes_out_ls_as = YLeaf(YType.uint64, "dbdes-out-ls-as")

                                    self.dbdes_out_packets = YLeaf(YType.uint64, "dbdes-out-packets")

                                    self.dropped_in_gs = YLeaf(YType.uint64, "dropped-in-gs")

                                    self.hello_in_packets = YLeaf(YType.uint64, "hello-in-packets")

                                    self.hello_out_packets = YLeaf(YType.uint64, "hello-out-packets")

                                    self.ls_ack_in_ls_as = YLeaf(YType.uint64, "ls-ack-in-ls-as")

                                    self.ls_ack_in_packets = YLeaf(YType.uint64, "ls-ack-in-packets")

                                    self.ls_ack_out_ls_as = YLeaf(YType.uint64, "ls-ack-out-ls-as")

                                    self.ls_ack_out_packets = YLeaf(YType.uint64, "ls-ack-out-packets")

                                    self.ls_req_in_ls_as = YLeaf(YType.uint64, "ls-req-in-ls-as")

                                    self.ls_req_in_packets = YLeaf(YType.uint64, "ls-req-in-packets")

                                    self.ls_req_out_ls_as = YLeaf(YType.uint64, "ls-req-out-ls-as")

                                    self.ls_req_out_packets = YLeaf(YType.uint64, "ls-req-out-packets")

                                    self.ls_upd_in_ignored = YLeaf(YType.uint64, "ls-upd-in-ignored")

                                    self.ls_upd_in_ls_as = YLeaf(YType.uint64, "ls-upd-in-ls-as")

                                    self.ls_upd_in_packets = YLeaf(YType.uint64, "ls-upd-in-packets")

                                    self.ls_upd_out_ls_as = YLeaf(YType.uint64, "ls-upd-out-ls-as")

                                    self.ls_upd_out_packets = YLeaf(YType.uint64, "ls-upd-out-packets")

                                    self.total_in_packets = YLeaf(YType.uint64, "total-in-packets")

                                    self.total_out_packets = YLeaf(YType.uint64, "total-out-packets")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "checksum_err",
                                                    "dbdes_in_ls_as",
                                                    "dbdes_in_packets",
                                                    "dbdes_out_ls_as",
                                                    "dbdes_out_packets",
                                                    "dropped_in_gs",
                                                    "hello_in_packets",
                                                    "hello_out_packets",
                                                    "ls_ack_in_ls_as",
                                                    "ls_ack_in_packets",
                                                    "ls_ack_out_ls_as",
                                                    "ls_ack_out_packets",
                                                    "ls_req_in_ls_as",
                                                    "ls_req_in_packets",
                                                    "ls_req_out_ls_as",
                                                    "ls_req_out_packets",
                                                    "ls_upd_in_ignored",
                                                    "ls_upd_in_ls_as",
                                                    "ls_upd_in_packets",
                                                    "ls_upd_out_ls_as",
                                                    "ls_upd_out_packets",
                                                    "total_in_packets",
                                                    "total_out_packets") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats.ProtocolStat, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats.ProtocolStat, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        self.checksum_err.is_set or
                                        self.dbdes_in_ls_as.is_set or
                                        self.dbdes_in_packets.is_set or
                                        self.dbdes_out_ls_as.is_set or
                                        self.dbdes_out_packets.is_set or
                                        self.dropped_in_gs.is_set or
                                        self.hello_in_packets.is_set or
                                        self.hello_out_packets.is_set or
                                        self.ls_ack_in_ls_as.is_set or
                                        self.ls_ack_in_packets.is_set or
                                        self.ls_ack_out_ls_as.is_set or
                                        self.ls_ack_out_packets.is_set or
                                        self.ls_req_in_ls_as.is_set or
                                        self.ls_req_in_packets.is_set or
                                        self.ls_req_out_ls_as.is_set or
                                        self.ls_req_out_packets.is_set or
                                        self.ls_upd_in_ignored.is_set or
                                        self.ls_upd_in_ls_as.is_set or
                                        self.ls_upd_in_packets.is_set or
                                        self.ls_upd_out_ls_as.is_set or
                                        self.ls_upd_out_packets.is_set or
                                        self.total_in_packets.is_set or
                                        self.total_out_packets.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.checksum_err.yfilter != YFilter.not_set or
                                        self.dbdes_in_ls_as.yfilter != YFilter.not_set or
                                        self.dbdes_in_packets.yfilter != YFilter.not_set or
                                        self.dbdes_out_ls_as.yfilter != YFilter.not_set or
                                        self.dbdes_out_packets.yfilter != YFilter.not_set or
                                        self.dropped_in_gs.yfilter != YFilter.not_set or
                                        self.hello_in_packets.yfilter != YFilter.not_set or
                                        self.hello_out_packets.yfilter != YFilter.not_set or
                                        self.ls_ack_in_ls_as.yfilter != YFilter.not_set or
                                        self.ls_ack_in_packets.yfilter != YFilter.not_set or
                                        self.ls_ack_out_ls_as.yfilter != YFilter.not_set or
                                        self.ls_ack_out_packets.yfilter != YFilter.not_set or
                                        self.ls_req_in_ls_as.yfilter != YFilter.not_set or
                                        self.ls_req_in_packets.yfilter != YFilter.not_set or
                                        self.ls_req_out_ls_as.yfilter != YFilter.not_set or
                                        self.ls_req_out_packets.yfilter != YFilter.not_set or
                                        self.ls_upd_in_ignored.yfilter != YFilter.not_set or
                                        self.ls_upd_in_ls_as.yfilter != YFilter.not_set or
                                        self.ls_upd_in_packets.yfilter != YFilter.not_set or
                                        self.ls_upd_out_ls_as.yfilter != YFilter.not_set or
                                        self.ls_upd_out_packets.yfilter != YFilter.not_set or
                                        self.total_in_packets.yfilter != YFilter.not_set or
                                        self.total_out_packets.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protocol-stat" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.checksum_err.is_set or self.checksum_err.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.checksum_err.get_name_leafdata())
                                    if (self.dbdes_in_ls_as.is_set or self.dbdes_in_ls_as.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dbdes_in_ls_as.get_name_leafdata())
                                    if (self.dbdes_in_packets.is_set or self.dbdes_in_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dbdes_in_packets.get_name_leafdata())
                                    if (self.dbdes_out_ls_as.is_set or self.dbdes_out_ls_as.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dbdes_out_ls_as.get_name_leafdata())
                                    if (self.dbdes_out_packets.is_set or self.dbdes_out_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dbdes_out_packets.get_name_leafdata())
                                    if (self.dropped_in_gs.is_set or self.dropped_in_gs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dropped_in_gs.get_name_leafdata())
                                    if (self.hello_in_packets.is_set or self.hello_in_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hello_in_packets.get_name_leafdata())
                                    if (self.hello_out_packets.is_set or self.hello_out_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hello_out_packets.get_name_leafdata())
                                    if (self.ls_ack_in_ls_as.is_set or self.ls_ack_in_ls_as.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_ack_in_ls_as.get_name_leafdata())
                                    if (self.ls_ack_in_packets.is_set or self.ls_ack_in_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_ack_in_packets.get_name_leafdata())
                                    if (self.ls_ack_out_ls_as.is_set or self.ls_ack_out_ls_as.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_ack_out_ls_as.get_name_leafdata())
                                    if (self.ls_ack_out_packets.is_set or self.ls_ack_out_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_ack_out_packets.get_name_leafdata())
                                    if (self.ls_req_in_ls_as.is_set or self.ls_req_in_ls_as.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_req_in_ls_as.get_name_leafdata())
                                    if (self.ls_req_in_packets.is_set or self.ls_req_in_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_req_in_packets.get_name_leafdata())
                                    if (self.ls_req_out_ls_as.is_set or self.ls_req_out_ls_as.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_req_out_ls_as.get_name_leafdata())
                                    if (self.ls_req_out_packets.is_set or self.ls_req_out_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_req_out_packets.get_name_leafdata())
                                    if (self.ls_upd_in_ignored.is_set or self.ls_upd_in_ignored.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_upd_in_ignored.get_name_leafdata())
                                    if (self.ls_upd_in_ls_as.is_set or self.ls_upd_in_ls_as.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_upd_in_ls_as.get_name_leafdata())
                                    if (self.ls_upd_in_packets.is_set or self.ls_upd_in_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_upd_in_packets.get_name_leafdata())
                                    if (self.ls_upd_out_ls_as.is_set or self.ls_upd_out_ls_as.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_upd_out_ls_as.get_name_leafdata())
                                    if (self.ls_upd_out_packets.is_set or self.ls_upd_out_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_upd_out_packets.get_name_leafdata())
                                    if (self.total_in_packets.is_set or self.total_in_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_in_packets.get_name_leafdata())
                                    if (self.total_out_packets.is_set or self.total_out_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_out_packets.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-name" or name == "checksum-err" or name == "dbdes-in-ls-as" or name == "dbdes-in-packets" or name == "dbdes-out-ls-as" or name == "dbdes-out-packets" or name == "dropped-in-gs" or name == "hello-in-packets" or name == "hello-out-packets" or name == "ls-ack-in-ls-as" or name == "ls-ack-in-packets" or name == "ls-ack-out-ls-as" or name == "ls-ack-out-packets" or name == "ls-req-in-ls-as" or name == "ls-req-in-packets" or name == "ls-req-out-ls-as" or name == "ls-req-out-packets" or name == "ls-upd-in-ignored" or name == "ls-upd-in-ls-as" or name == "ls-upd-in-packets" or name == "ls-upd-out-ls-as" or name == "ls-upd-out-packets" or name == "total-in-packets" or name == "total-out-packets"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "checksum-err"):
                                        self.checksum_err = value
                                        self.checksum_err.value_namespace = name_space
                                        self.checksum_err.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dbdes-in-ls-as"):
                                        self.dbdes_in_ls_as = value
                                        self.dbdes_in_ls_as.value_namespace = name_space
                                        self.dbdes_in_ls_as.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dbdes-in-packets"):
                                        self.dbdes_in_packets = value
                                        self.dbdes_in_packets.value_namespace = name_space
                                        self.dbdes_in_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dbdes-out-ls-as"):
                                        self.dbdes_out_ls_as = value
                                        self.dbdes_out_ls_as.value_namespace = name_space
                                        self.dbdes_out_ls_as.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dbdes-out-packets"):
                                        self.dbdes_out_packets = value
                                        self.dbdes_out_packets.value_namespace = name_space
                                        self.dbdes_out_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dropped-in-gs"):
                                        self.dropped_in_gs = value
                                        self.dropped_in_gs.value_namespace = name_space
                                        self.dropped_in_gs.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hello-in-packets"):
                                        self.hello_in_packets = value
                                        self.hello_in_packets.value_namespace = name_space
                                        self.hello_in_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hello-out-packets"):
                                        self.hello_out_packets = value
                                        self.hello_out_packets.value_namespace = name_space
                                        self.hello_out_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-ack-in-ls-as"):
                                        self.ls_ack_in_ls_as = value
                                        self.ls_ack_in_ls_as.value_namespace = name_space
                                        self.ls_ack_in_ls_as.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-ack-in-packets"):
                                        self.ls_ack_in_packets = value
                                        self.ls_ack_in_packets.value_namespace = name_space
                                        self.ls_ack_in_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-ack-out-ls-as"):
                                        self.ls_ack_out_ls_as = value
                                        self.ls_ack_out_ls_as.value_namespace = name_space
                                        self.ls_ack_out_ls_as.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-ack-out-packets"):
                                        self.ls_ack_out_packets = value
                                        self.ls_ack_out_packets.value_namespace = name_space
                                        self.ls_ack_out_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-req-in-ls-as"):
                                        self.ls_req_in_ls_as = value
                                        self.ls_req_in_ls_as.value_namespace = name_space
                                        self.ls_req_in_ls_as.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-req-in-packets"):
                                        self.ls_req_in_packets = value
                                        self.ls_req_in_packets.value_namespace = name_space
                                        self.ls_req_in_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-req-out-ls-as"):
                                        self.ls_req_out_ls_as = value
                                        self.ls_req_out_ls_as.value_namespace = name_space
                                        self.ls_req_out_ls_as.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-req-out-packets"):
                                        self.ls_req_out_packets = value
                                        self.ls_req_out_packets.value_namespace = name_space
                                        self.ls_req_out_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-upd-in-ignored"):
                                        self.ls_upd_in_ignored = value
                                        self.ls_upd_in_ignored.value_namespace = name_space
                                        self.ls_upd_in_ignored.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-upd-in-ls-as"):
                                        self.ls_upd_in_ls_as = value
                                        self.ls_upd_in_ls_as.value_namespace = name_space
                                        self.ls_upd_in_ls_as.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-upd-in-packets"):
                                        self.ls_upd_in_packets = value
                                        self.ls_upd_in_packets.value_namespace = name_space
                                        self.ls_upd_in_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-upd-out-ls-as"):
                                        self.ls_upd_out_ls_as = value
                                        self.ls_upd_out_ls_as.value_namespace = name_space
                                        self.ls_upd_out_ls_as.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-upd-out-packets"):
                                        self.ls_upd_out_packets = value
                                        self.ls_upd_out_packets.value_namespace = name_space
                                        self.ls_upd_out_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-in-packets"):
                                        self.total_in_packets = value
                                        self.total_in_packets.value_namespace = name_space
                                        self.total_in_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-out-packets"):
                                        self.total_out_packets = value
                                        self.total_out_packets.value_namespace = name_space
                                        self.total_out_packets.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.protocol_stat:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.protocol_stat:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protocol-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "protocol-stat"):
                                    for c in self.protocol_stat:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats.ProtocolStat()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.protocol_stat.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "protocol-stat"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class SpfStats(Entity):
                            """
                            OSPFv3 RIB batch statistics
                            
                            .. attribute:: spf_header
                            
                            	SPF statistics header
                            	**type**\:   :py:class:`SpfHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader>`
                            
                            .. attribute:: spf_runtime
                            
                            	List of SPF run\-time statistics
                            	**type**\: list of    :py:class:`SpfRuntime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats, self).__init__()

                                self.yang_name = "spf-stats"
                                self.yang_parent_name = "vrf-statistics"

                                self.spf_header = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader()
                                self.spf_header.parent = self
                                self._children_name_map["spf_header"] = "spf-header"
                                self._children_yang_names.add("spf-header")

                                self.spf_runtime = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats, self).__setattr__(name, value)


                            class SpfHeader(Entity):
                                """
                                SPF statistics header
                                
                                .. attribute:: area_summary
                                
                                	List of Areas with SPF statistics
                                	**type**\: list of    :py:class:`AreaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader.AreaSummary>`
                                
                                .. attribute:: header_router_id
                                
                                	Router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_sp_fs
                                
                                	Number of SPF calculations
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader, self).__init__()

                                    self.yang_name = "spf-header"
                                    self.yang_parent_name = "spf-stats"

                                    self.header_router_id = YLeaf(YType.str, "header-router-id")

                                    self.header_sp_fs = YLeaf(YType.uint32, "header-sp-fs")

                                    self.area_summary = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("header_router_id",
                                                    "header_sp_fs") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader, self).__setattr__(name, value)


                                class AreaSummary(Entity):
                                    """
                                    List of Areas with SPF statistics
                                    
                                    .. attribute:: area_id
                                    
                                    	Area ID of the area SPF statistics
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: sp_fs
                                    
                                    	Number of SPF calculations
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader.AreaSummary, self).__init__()

                                        self.yang_name = "area-summary"
                                        self.yang_parent_name = "spf-header"

                                        self.area_id = YLeaf(YType.uint32, "area-id")

                                        self.sp_fs = YLeaf(YType.uint32, "sp-fs")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("area_id",
                                                        "sp_fs") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader.AreaSummary, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader.AreaSummary, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.area_id.is_set or
                                            self.sp_fs.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.area_id.yfilter != YFilter.not_set or
                                            self.sp_fs.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "area-summary" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_id.get_name_leafdata())
                                        if (self.sp_fs.is_set or self.sp_fs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sp_fs.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "area-id" or name == "sp-fs"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "area-id"):
                                            self.area_id = value
                                            self.area_id.value_namespace = name_space
                                            self.area_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sp-fs"):
                                            self.sp_fs = value
                                            self.sp_fs.value_namespace = name_space
                                            self.sp_fs.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.area_summary:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.header_router_id.is_set or
                                        self.header_sp_fs.is_set)

                                def has_operation(self):
                                    for c in self.area_summary:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.header_router_id.yfilter != YFilter.not_set or
                                        self.header_sp_fs.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "spf-header" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.header_router_id.is_set or self.header_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_router_id.get_name_leafdata())
                                    if (self.header_sp_fs.is_set or self.header_sp_fs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_sp_fs.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "area-summary"):
                                        for c in self.area_summary:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader.AreaSummary()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.area_summary.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "area-summary" or name == "header-router-id" or name == "header-sp-fs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "header-router-id"):
                                        self.header_router_id = value
                                        self.header_router_id.value_namespace = name_space
                                        self.header_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-sp-fs"):
                                        self.header_sp_fs = value
                                        self.header_sp_fs.value_namespace = name_space
                                        self.header_sp_fs.value_namespace_prefix = name_space_prefix


                            class SpfRuntime(Entity):
                                """
                                List of SPF run\-time statistics
                                
                                .. attribute:: area_stat
                                
                                	List of per\-area SPF statistics
                                	**type**\: list of    :py:class:`AreaStat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat>`
                                
                                .. attribute:: global_time
                                
                                	Global SPF times
                                	**type**\:   :py:class:`GlobalTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime>`
                                
                                .. attribute:: lsa
                                
                                	List of LSAs triggering the SPF calculation
                                	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.Lsa>`
                                
                                .. attribute:: lsa_changes
                                
                                	Number of LSA changes triggering an SPF calculation
                                	**type**\:  int
                                
                                	**range:** \-32768..32767
                                
                                .. attribute:: reason_flags
                                
                                	Reasons for triggering an SPF calculation Bit 1 \- Router LSA update Bit 2 \- Network LSA update Bit 3 \- Inter\-Area Prefix LSA update Bit 4 \- Inter\-Area Router LSA update Bit 5 \- AS External LSA update Bit 6 \- MOSPF LSA update Bit 7 \- Type 7 AS External LSA update Bit 8 \- Link LSA update Bit 9 \- Prefix LSA update
                                	**type**\:  str
                                
                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                
                                .. attribute:: rib_add_routes
                                
                                	Number of routes added to RIB
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rib_delete_routes
                                
                                	Number of routes deleted from RIB
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: start_time
                                
                                	SPF calculation start time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime, self).__init__()

                                    self.yang_name = "spf-runtime"
                                    self.yang_parent_name = "spf-stats"

                                    self.lsa_changes = YLeaf(YType.int16, "lsa-changes")

                                    self.reason_flags = YLeaf(YType.str, "reason-flags")

                                    self.rib_add_routes = YLeaf(YType.uint32, "rib-add-routes")

                                    self.rib_delete_routes = YLeaf(YType.uint32, "rib-delete-routes")

                                    self.start_time = YLeaf(YType.uint32, "start-time")

                                    self.global_time = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime()
                                    self.global_time.parent = self
                                    self._children_name_map["global_time"] = "global-time"
                                    self._children_yang_names.add("global-time")

                                    self.area_stat = YList(self)
                                    self.lsa = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("lsa_changes",
                                                    "reason_flags",
                                                    "rib_add_routes",
                                                    "rib_delete_routes",
                                                    "start_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime, self).__setattr__(name, value)


                                class GlobalTime(Entity):
                                    """
                                    Global SPF times
                                    
                                    .. attribute:: dijkstra
                                    
                                    	Dijkstra time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: external_prefix
                                    
                                    	External prefix processing time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: external_prefix_del
                                    
                                    	External prefix deletion time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: inter_prefix
                                    
                                    	Inter\-prefix processing time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: inter_prefix_del
                                    
                                    	Intra\-prefix deletion time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intra_prefix
                                    
                                    	Intra\-prefix processing time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intra_prefix_del
                                    
                                    	Intra\-prefix deletion time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rib_add
                                    
                                    	RIB add processing time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rib_del
                                    
                                    	RIB deletion time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime, self).__init__()

                                        self.yang_name = "global-time"
                                        self.yang_parent_name = "spf-runtime"

                                        self.dijkstra = YLeaf(YType.uint32, "dijkstra")

                                        self.external_prefix = YLeaf(YType.uint32, "external-prefix")

                                        self.external_prefix_del = YLeaf(YType.uint32, "external-prefix-del")

                                        self.inter_prefix = YLeaf(YType.uint32, "inter-prefix")

                                        self.inter_prefix_del = YLeaf(YType.uint32, "inter-prefix-del")

                                        self.intra_prefix = YLeaf(YType.uint32, "intra-prefix")

                                        self.intra_prefix_del = YLeaf(YType.uint32, "intra-prefix-del")

                                        self.rib_add = YLeaf(YType.uint32, "rib-add")

                                        self.rib_del = YLeaf(YType.uint32, "rib-del")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("dijkstra",
                                                        "external_prefix",
                                                        "external_prefix_del",
                                                        "inter_prefix",
                                                        "inter_prefix_del",
                                                        "intra_prefix",
                                                        "intra_prefix_del",
                                                        "rib_add",
                                                        "rib_del") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.dijkstra.is_set or
                                            self.external_prefix.is_set or
                                            self.external_prefix_del.is_set or
                                            self.inter_prefix.is_set or
                                            self.inter_prefix_del.is_set or
                                            self.intra_prefix.is_set or
                                            self.intra_prefix_del.is_set or
                                            self.rib_add.is_set or
                                            self.rib_del.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.dijkstra.yfilter != YFilter.not_set or
                                            self.external_prefix.yfilter != YFilter.not_set or
                                            self.external_prefix_del.yfilter != YFilter.not_set or
                                            self.inter_prefix.yfilter != YFilter.not_set or
                                            self.inter_prefix_del.yfilter != YFilter.not_set or
                                            self.intra_prefix.yfilter != YFilter.not_set or
                                            self.intra_prefix_del.yfilter != YFilter.not_set or
                                            self.rib_add.yfilter != YFilter.not_set or
                                            self.rib_del.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "global-time" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.dijkstra.is_set or self.dijkstra.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dijkstra.get_name_leafdata())
                                        if (self.external_prefix.is_set or self.external_prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.external_prefix.get_name_leafdata())
                                        if (self.external_prefix_del.is_set or self.external_prefix_del.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.external_prefix_del.get_name_leafdata())
                                        if (self.inter_prefix.is_set or self.inter_prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.inter_prefix.get_name_leafdata())
                                        if (self.inter_prefix_del.is_set or self.inter_prefix_del.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.inter_prefix_del.get_name_leafdata())
                                        if (self.intra_prefix.is_set or self.intra_prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intra_prefix.get_name_leafdata())
                                        if (self.intra_prefix_del.is_set or self.intra_prefix_del.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intra_prefix_del.get_name_leafdata())
                                        if (self.rib_add.is_set or self.rib_add.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rib_add.get_name_leafdata())
                                        if (self.rib_del.is_set or self.rib_del.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rib_del.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dijkstra" or name == "external-prefix" or name == "external-prefix-del" or name == "inter-prefix" or name == "inter-prefix-del" or name == "intra-prefix" or name == "intra-prefix-del" or name == "rib-add" or name == "rib-del"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "dijkstra"):
                                            self.dijkstra = value
                                            self.dijkstra.value_namespace = name_space
                                            self.dijkstra.value_namespace_prefix = name_space_prefix
                                        if(value_path == "external-prefix"):
                                            self.external_prefix = value
                                            self.external_prefix.value_namespace = name_space
                                            self.external_prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "external-prefix-del"):
                                            self.external_prefix_del = value
                                            self.external_prefix_del.value_namespace = name_space
                                            self.external_prefix_del.value_namespace_prefix = name_space_prefix
                                        if(value_path == "inter-prefix"):
                                            self.inter_prefix = value
                                            self.inter_prefix.value_namespace = name_space
                                            self.inter_prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "inter-prefix-del"):
                                            self.inter_prefix_del = value
                                            self.inter_prefix_del.value_namespace = name_space
                                            self.inter_prefix_del.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intra-prefix"):
                                            self.intra_prefix = value
                                            self.intra_prefix.value_namespace = name_space
                                            self.intra_prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intra-prefix-del"):
                                            self.intra_prefix_del = value
                                            self.intra_prefix_del.value_namespace = name_space
                                            self.intra_prefix_del.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rib-add"):
                                            self.rib_add = value
                                            self.rib_add.value_namespace = name_space
                                            self.rib_add.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rib-del"):
                                            self.rib_del = value
                                            self.rib_del.value_namespace = name_space
                                            self.rib_del.value_namespace_prefix = name_space_prefix


                                class Lsa(Entity):
                                    """
                                    List of LSAs triggering the SPF calculation
                                    
                                    .. attribute:: lsa_advertising_router
                                    
                                    	Advertising router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: lsa_area_id
                                    
                                    	Area ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lsa_flush
                                    
                                    	If true, the LSA change is a flush
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_id
                                    
                                    	LSA ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: lsa_type
                                    
                                    	LSA type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.Lsa, self).__init__()

                                        self.yang_name = "lsa"
                                        self.yang_parent_name = "spf-runtime"

                                        self.lsa_advertising_router = YLeaf(YType.str, "lsa-advertising-router")

                                        self.lsa_area_id = YLeaf(YType.uint32, "lsa-area-id")

                                        self.lsa_flush = YLeaf(YType.boolean, "lsa-flush")

                                        self.lsa_id = YLeaf(YType.str, "lsa-id")

                                        self.lsa_type = YLeaf(YType.uint8, "lsa-type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("lsa_advertising_router",
                                                        "lsa_area_id",
                                                        "lsa_flush",
                                                        "lsa_id",
                                                        "lsa_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.Lsa, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.Lsa, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.lsa_advertising_router.is_set or
                                            self.lsa_area_id.is_set or
                                            self.lsa_flush.is_set or
                                            self.lsa_id.is_set or
                                            self.lsa_type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.lsa_advertising_router.yfilter != YFilter.not_set or
                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                            self.lsa_flush.yfilter != YFilter.not_set or
                                            self.lsa_id.yfilter != YFilter.not_set or
                                            self.lsa_type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsa" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.lsa_advertising_router.is_set or self.lsa_advertising_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_advertising_router.get_name_leafdata())
                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                        if (self.lsa_flush.is_set or self.lsa_flush.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_flush.get_name_leafdata())
                                        if (self.lsa_id.is_set or self.lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_id.get_name_leafdata())
                                        if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-advertising-router" or name == "lsa-area-id" or name == "lsa-flush" or name == "lsa-id" or name == "lsa-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "lsa-advertising-router"):
                                            self.lsa_advertising_router = value
                                            self.lsa_advertising_router.value_namespace = name_space
                                            self.lsa_advertising_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsa-area-id"):
                                            self.lsa_area_id = value
                                            self.lsa_area_id.value_namespace = name_space
                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsa-flush"):
                                            self.lsa_flush = value
                                            self.lsa_flush.value_namespace = name_space
                                            self.lsa_flush.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsa-id"):
                                            self.lsa_id = value
                                            self.lsa_id.value_namespace = name_space
                                            self.lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsa-type"):
                                            self.lsa_type = value
                                            self.lsa_type.value_namespace = name_space
                                            self.lsa_type.value_namespace_prefix = name_space_prefix


                                class AreaStat(Entity):
                                    """
                                    List of per\-area SPF statistics
                                    
                                    .. attribute:: spf_stat_area_id
                                    
                                    	Area ID for area of these SPF statistics
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: spf_stat_lsa_type_count
                                    
                                    	Counts of LSA types triggering an SPF calculation
                                    	**type**\:  list of int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: spf_stat_time
                                    
                                    	SPF time calculations
                                    	**type**\:   :py:class:`SpfStatTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat, self).__init__()

                                        self.yang_name = "area-stat"
                                        self.yang_parent_name = "spf-runtime"

                                        self.spf_stat_area_id = YLeaf(YType.uint32, "spf-stat-area-id")

                                        self.spf_stat_lsa_type_count = YLeafList(YType.uint32, "spf-stat-lsa-type-count")

                                        self.spf_stat_time = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime()
                                        self.spf_stat_time.parent = self
                                        self._children_name_map["spf_stat_time"] = "spf-stat-time"
                                        self._children_yang_names.add("spf-stat-time")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("spf_stat_area_id",
                                                        "spf_stat_lsa_type_count") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat, self).__setattr__(name, value)


                                    class SpfStatTime(Entity):
                                        """
                                        SPF time calculations
                                        
                                        .. attribute:: dijkstra
                                        
                                        	Dijkstra time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: external_prefix
                                        
                                        	External prefix processing time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: external_prefix_del
                                        
                                        	External prefix deletion time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: inter_prefix
                                        
                                        	Inter\-prefix processing time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: inter_prefix_del
                                        
                                        	Intra\-prefix deletion time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: intra_prefix
                                        
                                        	Intra\-prefix processing time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: intra_prefix_del
                                        
                                        	Intra\-prefix deletion time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rib_add
                                        
                                        	RIB add processing time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rib_del
                                        
                                        	RIB deletion time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime, self).__init__()

                                            self.yang_name = "spf-stat-time"
                                            self.yang_parent_name = "area-stat"

                                            self.dijkstra = YLeaf(YType.uint32, "dijkstra")

                                            self.external_prefix = YLeaf(YType.uint32, "external-prefix")

                                            self.external_prefix_del = YLeaf(YType.uint32, "external-prefix-del")

                                            self.inter_prefix = YLeaf(YType.uint32, "inter-prefix")

                                            self.inter_prefix_del = YLeaf(YType.uint32, "inter-prefix-del")

                                            self.intra_prefix = YLeaf(YType.uint32, "intra-prefix")

                                            self.intra_prefix_del = YLeaf(YType.uint32, "intra-prefix-del")

                                            self.rib_add = YLeaf(YType.uint32, "rib-add")

                                            self.rib_del = YLeaf(YType.uint32, "rib-del")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("dijkstra",
                                                            "external_prefix",
                                                            "external_prefix_del",
                                                            "inter_prefix",
                                                            "inter_prefix_del",
                                                            "intra_prefix",
                                                            "intra_prefix_del",
                                                            "rib_add",
                                                            "rib_del") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.dijkstra.is_set or
                                                self.external_prefix.is_set or
                                                self.external_prefix_del.is_set or
                                                self.inter_prefix.is_set or
                                                self.inter_prefix_del.is_set or
                                                self.intra_prefix.is_set or
                                                self.intra_prefix_del.is_set or
                                                self.rib_add.is_set or
                                                self.rib_del.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.dijkstra.yfilter != YFilter.not_set or
                                                self.external_prefix.yfilter != YFilter.not_set or
                                                self.external_prefix_del.yfilter != YFilter.not_set or
                                                self.inter_prefix.yfilter != YFilter.not_set or
                                                self.inter_prefix_del.yfilter != YFilter.not_set or
                                                self.intra_prefix.yfilter != YFilter.not_set or
                                                self.intra_prefix_del.yfilter != YFilter.not_set or
                                                self.rib_add.yfilter != YFilter.not_set or
                                                self.rib_del.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "spf-stat-time" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.dijkstra.is_set or self.dijkstra.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dijkstra.get_name_leafdata())
                                            if (self.external_prefix.is_set or self.external_prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.external_prefix.get_name_leafdata())
                                            if (self.external_prefix_del.is_set or self.external_prefix_del.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.external_prefix_del.get_name_leafdata())
                                            if (self.inter_prefix.is_set or self.inter_prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.inter_prefix.get_name_leafdata())
                                            if (self.inter_prefix_del.is_set or self.inter_prefix_del.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.inter_prefix_del.get_name_leafdata())
                                            if (self.intra_prefix.is_set or self.intra_prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.intra_prefix.get_name_leafdata())
                                            if (self.intra_prefix_del.is_set or self.intra_prefix_del.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.intra_prefix_del.get_name_leafdata())
                                            if (self.rib_add.is_set or self.rib_add.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rib_add.get_name_leafdata())
                                            if (self.rib_del.is_set or self.rib_del.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rib_del.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "dijkstra" or name == "external-prefix" or name == "external-prefix-del" or name == "inter-prefix" or name == "inter-prefix-del" or name == "intra-prefix" or name == "intra-prefix-del" or name == "rib-add" or name == "rib-del"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "dijkstra"):
                                                self.dijkstra = value
                                                self.dijkstra.value_namespace = name_space
                                                self.dijkstra.value_namespace_prefix = name_space_prefix
                                            if(value_path == "external-prefix"):
                                                self.external_prefix = value
                                                self.external_prefix.value_namespace = name_space
                                                self.external_prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "external-prefix-del"):
                                                self.external_prefix_del = value
                                                self.external_prefix_del.value_namespace = name_space
                                                self.external_prefix_del.value_namespace_prefix = name_space_prefix
                                            if(value_path == "inter-prefix"):
                                                self.inter_prefix = value
                                                self.inter_prefix.value_namespace = name_space
                                                self.inter_prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "inter-prefix-del"):
                                                self.inter_prefix_del = value
                                                self.inter_prefix_del.value_namespace = name_space
                                                self.inter_prefix_del.value_namespace_prefix = name_space_prefix
                                            if(value_path == "intra-prefix"):
                                                self.intra_prefix = value
                                                self.intra_prefix.value_namespace = name_space
                                                self.intra_prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "intra-prefix-del"):
                                                self.intra_prefix_del = value
                                                self.intra_prefix_del.value_namespace = name_space
                                                self.intra_prefix_del.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rib-add"):
                                                self.rib_add = value
                                                self.rib_add.value_namespace = name_space
                                                self.rib_add.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rib-del"):
                                                self.rib_del = value
                                                self.rib_del.value_namespace = name_space
                                                self.rib_del.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for leaf in self.spf_stat_lsa_type_count.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            self.spf_stat_area_id.is_set or
                                            (self.spf_stat_time is not None and self.spf_stat_time.has_data()))

                                    def has_operation(self):
                                        for leaf in self.spf_stat_lsa_type_count.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.spf_stat_area_id.yfilter != YFilter.not_set or
                                            self.spf_stat_lsa_type_count.yfilter != YFilter.not_set or
                                            (self.spf_stat_time is not None and self.spf_stat_time.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "area-stat" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.spf_stat_area_id.is_set or self.spf_stat_area_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.spf_stat_area_id.get_name_leafdata())

                                        leaf_name_data.extend(self.spf_stat_lsa_type_count.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "spf-stat-time"):
                                            if (self.spf_stat_time is None):
                                                self.spf_stat_time = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime()
                                                self.spf_stat_time.parent = self
                                                self._children_name_map["spf_stat_time"] = "spf-stat-time"
                                            return self.spf_stat_time

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "spf-stat-time" or name == "spf-stat-area-id" or name == "spf-stat-lsa-type-count"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "spf-stat-area-id"):
                                            self.spf_stat_area_id = value
                                            self.spf_stat_area_id.value_namespace = name_space
                                            self.spf_stat_area_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "spf-stat-lsa-type-count"):
                                            self.spf_stat_lsa_type_count.append(value)

                                def has_data(self):
                                    for c in self.area_stat:
                                        if (c.has_data()):
                                            return True
                                    for c in self.lsa:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.lsa_changes.is_set or
                                        self.reason_flags.is_set or
                                        self.rib_add_routes.is_set or
                                        self.rib_delete_routes.is_set or
                                        self.start_time.is_set or
                                        (self.global_time is not None and self.global_time.has_data()))

                                def has_operation(self):
                                    for c in self.area_stat:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.lsa:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.lsa_changes.yfilter != YFilter.not_set or
                                        self.reason_flags.yfilter != YFilter.not_set or
                                        self.rib_add_routes.yfilter != YFilter.not_set or
                                        self.rib_delete_routes.yfilter != YFilter.not_set or
                                        self.start_time.yfilter != YFilter.not_set or
                                        (self.global_time is not None and self.global_time.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "spf-runtime" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.lsa_changes.is_set or self.lsa_changes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_changes.get_name_leafdata())
                                    if (self.reason_flags.is_set or self.reason_flags.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reason_flags.get_name_leafdata())
                                    if (self.rib_add_routes.is_set or self.rib_add_routes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rib_add_routes.get_name_leafdata())
                                    if (self.rib_delete_routes.is_set or self.rib_delete_routes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rib_delete_routes.get_name_leafdata())
                                    if (self.start_time.is_set or self.start_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.start_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "area-stat"):
                                        for c in self.area_stat:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.area_stat.append(c)
                                        return c

                                    if (child_yang_name == "global-time"):
                                        if (self.global_time is None):
                                            self.global_time = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime()
                                            self.global_time.parent = self
                                            self._children_name_map["global_time"] = "global-time"
                                        return self.global_time

                                    if (child_yang_name == "lsa"):
                                        for c in self.lsa:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime.Lsa()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.lsa.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "area-stat" or name == "global-time" or name == "lsa" or name == "lsa-changes" or name == "reason-flags" or name == "rib-add-routes" or name == "rib-delete-routes" or name == "start-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "lsa-changes"):
                                        self.lsa_changes = value
                                        self.lsa_changes.value_namespace = name_space
                                        self.lsa_changes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reason-flags"):
                                        self.reason_flags = value
                                        self.reason_flags.value_namespace = name_space
                                        self.reason_flags.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rib-add-routes"):
                                        self.rib_add_routes = value
                                        self.rib_add_routes.value_namespace = name_space
                                        self.rib_add_routes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rib-delete-routes"):
                                        self.rib_delete_routes = value
                                        self.rib_delete_routes.value_namespace = name_space
                                        self.rib_delete_routes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "start-time"):
                                        self.start_time = value
                                        self.start_time.value_namespace = name_space
                                        self.start_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.spf_runtime:
                                    if (c.has_data()):
                                        return True
                                return (self.spf_header is not None and self.spf_header.has_data())

                            def has_operation(self):
                                for c in self.spf_runtime:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.spf_header is not None and self.spf_header.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "spf-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "spf-header"):
                                    if (self.spf_header is None):
                                        self.spf_header = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfHeader()
                                        self.spf_header.parent = self
                                        self._children_name_map["spf_header"] = "spf-header"
                                    return self.spf_header

                                if (child_yang_name == "spf-runtime"):
                                    for c in self.spf_runtime:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats.SpfRuntime()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.spf_runtime.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "spf-header" or name == "spf-runtime"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class RawioStats(Entity):
                            """
                            OSPF Prefix SPF Prioritization statistics
                            
                            .. attribute:: in_bytes
                            
                            	Received Bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: in_error_drops
                            
                            	In Error Drops
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: in_handle_drops
                            
                            	In Handle Drops
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: in_ipsec_drops
                            
                            	In IPSEC Drops
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: in_long_packets
                            
                            	Received Long Packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: in_malloc_drops
                            
                            	In Malloc Drops
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: in_packets
                            
                            	Received Packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: in_queue_drops
                            
                            	In Queue Drops
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: in_short_drops
                            
                            	In Short Drops
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: out_bytes
                            
                            	Sent Bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: out_error_drops
                            
                            	Error Drops
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: out_ipsec_drops
                            
                            	Out IPSEC Drops
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: out_nofd_drops
                            
                            	No FileDescriptor Drops
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: out_nopak_drops
                            
                            	No Packet Buffers
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: out_packets
                            
                            	Packets Sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: out_pakapi_errors
                            
                            	PAK API Errors
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: raw_conn_close
                            
                            	Raw Connections Close
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: raw_conn_error
                            
                            	Raw Connections Error
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: raw_conn_open
                            
                            	Raw Connections Open
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: raw_conn_state
                            
                            	Raw Connection State
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.RawioStats, self).__init__()

                                self.yang_name = "rawio-stats"
                                self.yang_parent_name = "vrf-statistics"

                                self.in_bytes = YLeaf(YType.uint64, "in-bytes")

                                self.in_error_drops = YLeaf(YType.uint64, "in-error-drops")

                                self.in_handle_drops = YLeaf(YType.uint64, "in-handle-drops")

                                self.in_ipsec_drops = YLeaf(YType.uint64, "in-ipsec-drops")

                                self.in_long_packets = YLeaf(YType.uint64, "in-long-packets")

                                self.in_malloc_drops = YLeaf(YType.uint64, "in-malloc-drops")

                                self.in_packets = YLeaf(YType.uint64, "in-packets")

                                self.in_queue_drops = YLeaf(YType.uint64, "in-queue-drops")

                                self.in_short_drops = YLeaf(YType.uint64, "in-short-drops")

                                self.out_bytes = YLeaf(YType.uint64, "out-bytes")

                                self.out_error_drops = YLeaf(YType.uint64, "out-error-drops")

                                self.out_ipsec_drops = YLeaf(YType.uint64, "out-ipsec-drops")

                                self.out_nofd_drops = YLeaf(YType.uint64, "out-nofd-drops")

                                self.out_nopak_drops = YLeaf(YType.uint64, "out-nopak-drops")

                                self.out_packets = YLeaf(YType.uint64, "out-packets")

                                self.out_pakapi_errors = YLeaf(YType.uint64, "out-pakapi-errors")

                                self.raw_conn_close = YLeaf(YType.uint64, "raw-conn-close")

                                self.raw_conn_error = YLeaf(YType.uint64, "raw-conn-error")

                                self.raw_conn_open = YLeaf(YType.uint64, "raw-conn-open")

                                self.raw_conn_state = YLeaf(YType.uint32, "raw-conn-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("in_bytes",
                                                "in_error_drops",
                                                "in_handle_drops",
                                                "in_ipsec_drops",
                                                "in_long_packets",
                                                "in_malloc_drops",
                                                "in_packets",
                                                "in_queue_drops",
                                                "in_short_drops",
                                                "out_bytes",
                                                "out_error_drops",
                                                "out_ipsec_drops",
                                                "out_nofd_drops",
                                                "out_nopak_drops",
                                                "out_packets",
                                                "out_pakapi_errors",
                                                "raw_conn_close",
                                                "raw_conn_error",
                                                "raw_conn_open",
                                                "raw_conn_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.RawioStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.RawioStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.in_bytes.is_set or
                                    self.in_error_drops.is_set or
                                    self.in_handle_drops.is_set or
                                    self.in_ipsec_drops.is_set or
                                    self.in_long_packets.is_set or
                                    self.in_malloc_drops.is_set or
                                    self.in_packets.is_set or
                                    self.in_queue_drops.is_set or
                                    self.in_short_drops.is_set or
                                    self.out_bytes.is_set or
                                    self.out_error_drops.is_set or
                                    self.out_ipsec_drops.is_set or
                                    self.out_nofd_drops.is_set or
                                    self.out_nopak_drops.is_set or
                                    self.out_packets.is_set or
                                    self.out_pakapi_errors.is_set or
                                    self.raw_conn_close.is_set or
                                    self.raw_conn_error.is_set or
                                    self.raw_conn_open.is_set or
                                    self.raw_conn_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.in_bytes.yfilter != YFilter.not_set or
                                    self.in_error_drops.yfilter != YFilter.not_set or
                                    self.in_handle_drops.yfilter != YFilter.not_set or
                                    self.in_ipsec_drops.yfilter != YFilter.not_set or
                                    self.in_long_packets.yfilter != YFilter.not_set or
                                    self.in_malloc_drops.yfilter != YFilter.not_set or
                                    self.in_packets.yfilter != YFilter.not_set or
                                    self.in_queue_drops.yfilter != YFilter.not_set or
                                    self.in_short_drops.yfilter != YFilter.not_set or
                                    self.out_bytes.yfilter != YFilter.not_set or
                                    self.out_error_drops.yfilter != YFilter.not_set or
                                    self.out_ipsec_drops.yfilter != YFilter.not_set or
                                    self.out_nofd_drops.yfilter != YFilter.not_set or
                                    self.out_nopak_drops.yfilter != YFilter.not_set or
                                    self.out_packets.yfilter != YFilter.not_set or
                                    self.out_pakapi_errors.yfilter != YFilter.not_set or
                                    self.raw_conn_close.yfilter != YFilter.not_set or
                                    self.raw_conn_error.yfilter != YFilter.not_set or
                                    self.raw_conn_open.yfilter != YFilter.not_set or
                                    self.raw_conn_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rawio-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.in_bytes.is_set or self.in_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_bytes.get_name_leafdata())
                                if (self.in_error_drops.is_set or self.in_error_drops.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_error_drops.get_name_leafdata())
                                if (self.in_handle_drops.is_set or self.in_handle_drops.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_handle_drops.get_name_leafdata())
                                if (self.in_ipsec_drops.is_set or self.in_ipsec_drops.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_ipsec_drops.get_name_leafdata())
                                if (self.in_long_packets.is_set or self.in_long_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_long_packets.get_name_leafdata())
                                if (self.in_malloc_drops.is_set or self.in_malloc_drops.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_malloc_drops.get_name_leafdata())
                                if (self.in_packets.is_set or self.in_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_packets.get_name_leafdata())
                                if (self.in_queue_drops.is_set or self.in_queue_drops.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_queue_drops.get_name_leafdata())
                                if (self.in_short_drops.is_set or self.in_short_drops.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_short_drops.get_name_leafdata())
                                if (self.out_bytes.is_set or self.out_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_bytes.get_name_leafdata())
                                if (self.out_error_drops.is_set or self.out_error_drops.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_error_drops.get_name_leafdata())
                                if (self.out_ipsec_drops.is_set or self.out_ipsec_drops.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_ipsec_drops.get_name_leafdata())
                                if (self.out_nofd_drops.is_set or self.out_nofd_drops.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_nofd_drops.get_name_leafdata())
                                if (self.out_nopak_drops.is_set or self.out_nopak_drops.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_nopak_drops.get_name_leafdata())
                                if (self.out_packets.is_set or self.out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_packets.get_name_leafdata())
                                if (self.out_pakapi_errors.is_set or self.out_pakapi_errors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_pakapi_errors.get_name_leafdata())
                                if (self.raw_conn_close.is_set or self.raw_conn_close.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.raw_conn_close.get_name_leafdata())
                                if (self.raw_conn_error.is_set or self.raw_conn_error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.raw_conn_error.get_name_leafdata())
                                if (self.raw_conn_open.is_set or self.raw_conn_open.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.raw_conn_open.get_name_leafdata())
                                if (self.raw_conn_state.is_set or self.raw_conn_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.raw_conn_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "in-bytes" or name == "in-error-drops" or name == "in-handle-drops" or name == "in-ipsec-drops" or name == "in-long-packets" or name == "in-malloc-drops" or name == "in-packets" or name == "in-queue-drops" or name == "in-short-drops" or name == "out-bytes" or name == "out-error-drops" or name == "out-ipsec-drops" or name == "out-nofd-drops" or name == "out-nopak-drops" or name == "out-packets" or name == "out-pakapi-errors" or name == "raw-conn-close" or name == "raw-conn-error" or name == "raw-conn-open" or name == "raw-conn-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "in-bytes"):
                                    self.in_bytes = value
                                    self.in_bytes.value_namespace = name_space
                                    self.in_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-error-drops"):
                                    self.in_error_drops = value
                                    self.in_error_drops.value_namespace = name_space
                                    self.in_error_drops.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-handle-drops"):
                                    self.in_handle_drops = value
                                    self.in_handle_drops.value_namespace = name_space
                                    self.in_handle_drops.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-ipsec-drops"):
                                    self.in_ipsec_drops = value
                                    self.in_ipsec_drops.value_namespace = name_space
                                    self.in_ipsec_drops.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-long-packets"):
                                    self.in_long_packets = value
                                    self.in_long_packets.value_namespace = name_space
                                    self.in_long_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-malloc-drops"):
                                    self.in_malloc_drops = value
                                    self.in_malloc_drops.value_namespace = name_space
                                    self.in_malloc_drops.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-packets"):
                                    self.in_packets = value
                                    self.in_packets.value_namespace = name_space
                                    self.in_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-queue-drops"):
                                    self.in_queue_drops = value
                                    self.in_queue_drops.value_namespace = name_space
                                    self.in_queue_drops.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-short-drops"):
                                    self.in_short_drops = value
                                    self.in_short_drops.value_namespace = name_space
                                    self.in_short_drops.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-bytes"):
                                    self.out_bytes = value
                                    self.out_bytes.value_namespace = name_space
                                    self.out_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-error-drops"):
                                    self.out_error_drops = value
                                    self.out_error_drops.value_namespace = name_space
                                    self.out_error_drops.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-ipsec-drops"):
                                    self.out_ipsec_drops = value
                                    self.out_ipsec_drops.value_namespace = name_space
                                    self.out_ipsec_drops.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-nofd-drops"):
                                    self.out_nofd_drops = value
                                    self.out_nofd_drops.value_namespace = name_space
                                    self.out_nofd_drops.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-nopak-drops"):
                                    self.out_nopak_drops = value
                                    self.out_nopak_drops.value_namespace = name_space
                                    self.out_nopak_drops.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-packets"):
                                    self.out_packets = value
                                    self.out_packets.value_namespace = name_space
                                    self.out_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-pakapi-errors"):
                                    self.out_pakapi_errors = value
                                    self.out_pakapi_errors.value_namespace = name_space
                                    self.out_pakapi_errors.value_namespace_prefix = name_space_prefix
                                if(value_path == "raw-conn-close"):
                                    self.raw_conn_close = value
                                    self.raw_conn_close.value_namespace = name_space
                                    self.raw_conn_close.value_namespace_prefix = name_space_prefix
                                if(value_path == "raw-conn-error"):
                                    self.raw_conn_error = value
                                    self.raw_conn_error.value_namespace = name_space
                                    self.raw_conn_error.value_namespace_prefix = name_space_prefix
                                if(value_path == "raw-conn-open"):
                                    self.raw_conn_open = value
                                    self.raw_conn_open.value_namespace = name_space
                                    self.raw_conn_open.value_namespace_prefix = name_space_prefix
                                if(value_path == "raw-conn-state"):
                                    self.raw_conn_state = value
                                    self.raw_conn_state.value_namespace = name_space
                                    self.raw_conn_state.value_namespace_prefix = name_space_prefix


                        class PrefixPriorityStats(Entity):
                            """
                            OSPF Prefix SPF Prioritization statistics
                            
                            .. attribute:: critical
                            
                            	Critical priority classifications
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: high
                            
                            	High priority classifications
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: low
                            
                            	Low priority classifications
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: medium
                            
                            	Medium priority classifications
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.PrefixPriorityStats, self).__init__()

                                self.yang_name = "prefix-priority-stats"
                                self.yang_parent_name = "vrf-statistics"

                                self.critical = YLeaf(YType.uint32, "critical")

                                self.high = YLeaf(YType.uint32, "high")

                                self.low = YLeaf(YType.uint32, "low")

                                self.medium = YLeaf(YType.uint32, "medium")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("critical",
                                                "high",
                                                "low",
                                                "medium") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.PrefixPriorityStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.PrefixPriorityStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.critical.is_set or
                                    self.high.is_set or
                                    self.low.is_set or
                                    self.medium.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.critical.yfilter != YFilter.not_set or
                                    self.high.yfilter != YFilter.not_set or
                                    self.low.yfilter != YFilter.not_set or
                                    self.medium.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "prefix-priority-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.critical.is_set or self.critical.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.critical.get_name_leafdata())
                                if (self.high.is_set or self.high.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.high.get_name_leafdata())
                                if (self.low.is_set or self.low.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.low.get_name_leafdata())
                                if (self.medium.is_set or self.medium.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.medium.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "critical" or name == "high" or name == "low" or name == "medium"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "critical"):
                                    self.critical = value
                                    self.critical.value_namespace = name_space
                                    self.critical.value_namespace_prefix = name_space_prefix
                                if(value_path == "high"):
                                    self.high = value
                                    self.high.value_namespace = name_space
                                    self.high.value_namespace_prefix = name_space_prefix
                                if(value_path == "low"):
                                    self.low = value
                                    self.low.value_namespace = name_space
                                    self.low.value_namespace_prefix = name_space_prefix
                                if(value_path == "medium"):
                                    self.medium = value
                                    self.medium.value_namespace = name_space
                                    self.medium.value_namespace_prefix = name_space_prefix


                        class VrfRibBatchStats(Entity):
                            """
                            OSPFv3 RIB batch statistics
                            
                            .. attribute:: batches_sent
                            
                            	No. of RIB batches sent
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: max_routes
                            
                            	Max No. of Routes in a batch
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: paths_add
                            
                            	No. of paths added to RIB
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: paths_add_errs
                            
                            	No. of paths add errors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: paths_del
                            
                            	No. of paths del sent to RIB
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: paths_del_errs
                            
                            	No. of Paths del errors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: paths_pending
                            
                            	No. of paths waiting to be sent to RIB
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: paths_sent
                            
                            	No. of Paths sent to RIB
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: routes_pending
                            
                            	No of Pending Routes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: routes_sent
                            
                            	No. of Routes sent to RIB
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.VrfRibBatchStats, self).__init__()

                                self.yang_name = "vrf-rib-batch-stats"
                                self.yang_parent_name = "vrf-statistics"

                                self.batches_sent = YLeaf(YType.uint32, "batches-sent")

                                self.max_routes = YLeaf(YType.uint32, "max-routes")

                                self.paths_add = YLeaf(YType.uint32, "paths-add")

                                self.paths_add_errs = YLeaf(YType.uint32, "paths-add-errs")

                                self.paths_del = YLeaf(YType.uint32, "paths-del")

                                self.paths_del_errs = YLeaf(YType.uint32, "paths-del-errs")

                                self.paths_pending = YLeaf(YType.uint32, "paths-pending")

                                self.paths_sent = YLeaf(YType.uint32, "paths-sent")

                                self.routes_pending = YLeaf(YType.uint32, "routes-pending")

                                self.routes_sent = YLeaf(YType.uint32, "routes-sent")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("batches_sent",
                                                "max_routes",
                                                "paths_add",
                                                "paths_add_errs",
                                                "paths_del",
                                                "paths_del_errs",
                                                "paths_pending",
                                                "paths_sent",
                                                "routes_pending",
                                                "routes_sent") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.VrfRibBatchStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.VrfRibBatchStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.batches_sent.is_set or
                                    self.max_routes.is_set or
                                    self.paths_add.is_set or
                                    self.paths_add_errs.is_set or
                                    self.paths_del.is_set or
                                    self.paths_del_errs.is_set or
                                    self.paths_pending.is_set or
                                    self.paths_sent.is_set or
                                    self.routes_pending.is_set or
                                    self.routes_sent.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.batches_sent.yfilter != YFilter.not_set or
                                    self.max_routes.yfilter != YFilter.not_set or
                                    self.paths_add.yfilter != YFilter.not_set or
                                    self.paths_add_errs.yfilter != YFilter.not_set or
                                    self.paths_del.yfilter != YFilter.not_set or
                                    self.paths_del_errs.yfilter != YFilter.not_set or
                                    self.paths_pending.yfilter != YFilter.not_set or
                                    self.paths_sent.yfilter != YFilter.not_set or
                                    self.routes_pending.yfilter != YFilter.not_set or
                                    self.routes_sent.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf-rib-batch-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.batches_sent.is_set or self.batches_sent.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.batches_sent.get_name_leafdata())
                                if (self.max_routes.is_set or self.max_routes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_routes.get_name_leafdata())
                                if (self.paths_add.is_set or self.paths_add.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.paths_add.get_name_leafdata())
                                if (self.paths_add_errs.is_set or self.paths_add_errs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.paths_add_errs.get_name_leafdata())
                                if (self.paths_del.is_set or self.paths_del.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.paths_del.get_name_leafdata())
                                if (self.paths_del_errs.is_set or self.paths_del_errs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.paths_del_errs.get_name_leafdata())
                                if (self.paths_pending.is_set or self.paths_pending.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.paths_pending.get_name_leafdata())
                                if (self.paths_sent.is_set or self.paths_sent.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.paths_sent.get_name_leafdata())
                                if (self.routes_pending.is_set or self.routes_pending.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.routes_pending.get_name_leafdata())
                                if (self.routes_sent.is_set or self.routes_sent.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.routes_sent.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "batches-sent" or name == "max-routes" or name == "paths-add" or name == "paths-add-errs" or name == "paths-del" or name == "paths-del-errs" or name == "paths-pending" or name == "paths-sent" or name == "routes-pending" or name == "routes-sent"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "batches-sent"):
                                    self.batches_sent = value
                                    self.batches_sent.value_namespace = name_space
                                    self.batches_sent.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-routes"):
                                    self.max_routes = value
                                    self.max_routes.value_namespace = name_space
                                    self.max_routes.value_namespace_prefix = name_space_prefix
                                if(value_path == "paths-add"):
                                    self.paths_add = value
                                    self.paths_add.value_namespace = name_space
                                    self.paths_add.value_namespace_prefix = name_space_prefix
                                if(value_path == "paths-add-errs"):
                                    self.paths_add_errs = value
                                    self.paths_add_errs.value_namespace = name_space
                                    self.paths_add_errs.value_namespace_prefix = name_space_prefix
                                if(value_path == "paths-del"):
                                    self.paths_del = value
                                    self.paths_del.value_namespace = name_space
                                    self.paths_del.value_namespace_prefix = name_space_prefix
                                if(value_path == "paths-del-errs"):
                                    self.paths_del_errs = value
                                    self.paths_del_errs.value_namespace = name_space
                                    self.paths_del_errs.value_namespace_prefix = name_space_prefix
                                if(value_path == "paths-pending"):
                                    self.paths_pending = value
                                    self.paths_pending.value_namespace = name_space
                                    self.paths_pending.value_namespace_prefix = name_space_prefix
                                if(value_path == "paths-sent"):
                                    self.paths_sent = value
                                    self.paths_sent.value_namespace = name_space
                                    self.paths_sent.value_namespace_prefix = name_space_prefix
                                if(value_path == "routes-pending"):
                                    self.routes_pending = value
                                    self.routes_pending.value_namespace = name_space
                                    self.routes_pending.value_namespace_prefix = name_space_prefix
                                if(value_path == "routes-sent"):
                                    self.routes_sent = value
                                    self.routes_sent.value_namespace = name_space
                                    self.routes_sent.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.prefix_priority_stats is not None and self.prefix_priority_stats.has_data()) or
                                (self.protocol_stats is not None and self.protocol_stats.has_data()) or
                                (self.rawio_stats is not None and self.rawio_stats.has_data()) or
                                (self.spf_stats is not None and self.spf_stats.has_data()) or
                                (self.vrf_rib_batch_stats is not None and self.vrf_rib_batch_stats.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.prefix_priority_stats is not None and self.prefix_priority_stats.has_operation()) or
                                (self.protocol_stats is not None and self.protocol_stats.has_operation()) or
                                (self.rawio_stats is not None and self.rawio_stats.has_operation()) or
                                (self.spf_stats is not None and self.spf_stats.has_operation()) or
                                (self.vrf_rib_batch_stats is not None and self.vrf_rib_batch_stats.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vrf-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "prefix-priority-stats"):
                                if (self.prefix_priority_stats is None):
                                    self.prefix_priority_stats = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.PrefixPriorityStats()
                                    self.prefix_priority_stats.parent = self
                                    self._children_name_map["prefix_priority_stats"] = "prefix-priority-stats"
                                return self.prefix_priority_stats

                            if (child_yang_name == "protocol-stats"):
                                if (self.protocol_stats is None):
                                    self.protocol_stats = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.ProtocolStats()
                                    self.protocol_stats.parent = self
                                    self._children_name_map["protocol_stats"] = "protocol-stats"
                                return self.protocol_stats

                            if (child_yang_name == "rawio-stats"):
                                if (self.rawio_stats is None):
                                    self.rawio_stats = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.RawioStats()
                                    self.rawio_stats.parent = self
                                    self._children_name_map["rawio_stats"] = "rawio-stats"
                                return self.rawio_stats

                            if (child_yang_name == "spf-stats"):
                                if (self.spf_stats is None):
                                    self.spf_stats = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.SpfStats()
                                    self.spf_stats.parent = self
                                    self._children_name_map["spf_stats"] = "spf-stats"
                                return self.spf_stats

                            if (child_yang_name == "vrf-rib-batch-stats"):
                                if (self.vrf_rib_batch_stats is None):
                                    self.vrf_rib_batch_stats = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics.VrfRibBatchStats()
                                    self.vrf_rib_batch_stats.parent = self
                                    self._children_name_map["vrf_rib_batch_stats"] = "vrf-rib-batch-stats"
                                return self.vrf_rib_batch_stats

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "prefix-priority-stats" or name == "protocol-stats" or name == "rawio-stats" or name == "spf-stats" or name == "vrf-rib-batch-stats"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Summary(Entity):
                        """
                        OSPFv3 summary
                        
                        .. attribute:: ospfv3
                        
                        	OSPFv3 summary
                        	**type**\:   :py:class:`Ospfv3 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3>`
                        
                        .. attribute:: protocol
                        
                        	OSPFv3 protocol summary
                        	**type**\:   :py:class:`Protocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Protocol>`
                        
                        .. attribute:: route
                        
                        	OSPFv3 route summary
                        	**type**\:   :py:class:`Route <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Route>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary, self).__init__()

                            self.yang_name = "summary"
                            self.yang_parent_name = "vrf"

                            self.ospfv3 = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3()
                            self.ospfv3.parent = self
                            self._children_name_map["ospfv3"] = "ospfv3"
                            self._children_yang_names.add("ospfv3")

                            self.protocol = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Protocol()
                            self.protocol.parent = self
                            self._children_name_map["protocol"] = "protocol"
                            self._children_yang_names.add("protocol")

                            self.route = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Route()
                            self.route.parent = self
                            self._children_name_map["route"] = "route"
                            self._children_yang_names.add("route")


                        class Protocol(Entity):
                            """
                            OSPFv3 protocol summary
                            
                            .. attribute:: administrative_distance
                            
                            	Administrative distance
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: administrative_distance_external
                            
                            	Administrative Distance for External routes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: administrative_distance_inter_area
                            
                            	Administrative Distance for Inter Area routes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: distribute_list_in
                            
                            	Distribute List In
                            	**type**\:  str
                            
                            .. attribute:: is_graceful_restart
                            
                            	If true, Graceful restart is enabled 
                            	**type**\:  bool
                            
                            .. attribute:: protocol_router_id
                            
                            	Protocol router ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Protocol, self).__init__()

                                self.yang_name = "protocol"
                                self.yang_parent_name = "summary"

                                self.administrative_distance = YLeaf(YType.uint32, "administrative-distance")

                                self.administrative_distance_external = YLeaf(YType.uint32, "administrative-distance-external")

                                self.administrative_distance_inter_area = YLeaf(YType.uint32, "administrative-distance-inter-area")

                                self.distribute_list_in = YLeaf(YType.str, "distribute-list-in")

                                self.is_graceful_restart = YLeaf(YType.boolean, "is-graceful-restart")

                                self.protocol_router_id = YLeaf(YType.str, "protocol-router-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("administrative_distance",
                                                "administrative_distance_external",
                                                "administrative_distance_inter_area",
                                                "distribute_list_in",
                                                "is_graceful_restart",
                                                "protocol_router_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Protocol, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Protocol, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.administrative_distance.is_set or
                                    self.administrative_distance_external.is_set or
                                    self.administrative_distance_inter_area.is_set or
                                    self.distribute_list_in.is_set or
                                    self.is_graceful_restart.is_set or
                                    self.protocol_router_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.administrative_distance.yfilter != YFilter.not_set or
                                    self.administrative_distance_external.yfilter != YFilter.not_set or
                                    self.administrative_distance_inter_area.yfilter != YFilter.not_set or
                                    self.distribute_list_in.yfilter != YFilter.not_set or
                                    self.is_graceful_restart.yfilter != YFilter.not_set or
                                    self.protocol_router_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protocol" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.administrative_distance.is_set or self.administrative_distance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.administrative_distance.get_name_leafdata())
                                if (self.administrative_distance_external.is_set or self.administrative_distance_external.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.administrative_distance_external.get_name_leafdata())
                                if (self.administrative_distance_inter_area.is_set or self.administrative_distance_inter_area.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.administrative_distance_inter_area.get_name_leafdata())
                                if (self.distribute_list_in.is_set or self.distribute_list_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.distribute_list_in.get_name_leafdata())
                                if (self.is_graceful_restart.is_set or self.is_graceful_restart.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_graceful_restart.get_name_leafdata())
                                if (self.protocol_router_id.is_set or self.protocol_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protocol_router_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "administrative-distance" or name == "administrative-distance-external" or name == "administrative-distance-inter-area" or name == "distribute-list-in" or name == "is-graceful-restart" or name == "protocol-router-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "administrative-distance"):
                                    self.administrative_distance = value
                                    self.administrative_distance.value_namespace = name_space
                                    self.administrative_distance.value_namespace_prefix = name_space_prefix
                                if(value_path == "administrative-distance-external"):
                                    self.administrative_distance_external = value
                                    self.administrative_distance_external.value_namespace = name_space
                                    self.administrative_distance_external.value_namespace_prefix = name_space_prefix
                                if(value_path == "administrative-distance-inter-area"):
                                    self.administrative_distance_inter_area = value
                                    self.administrative_distance_inter_area.value_namespace = name_space
                                    self.administrative_distance_inter_area.value_namespace_prefix = name_space_prefix
                                if(value_path == "distribute-list-in"):
                                    self.distribute_list_in = value
                                    self.distribute_list_in.value_namespace = name_space
                                    self.distribute_list_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-graceful-restart"):
                                    self.is_graceful_restart = value
                                    self.is_graceful_restart.value_namespace = name_space
                                    self.is_graceful_restart.value_namespace_prefix = name_space_prefix
                                if(value_path == "protocol-router-id"):
                                    self.protocol_router_id = value
                                    self.protocol_router_id.value_namespace = name_space
                                    self.protocol_router_id.value_namespace_prefix = name_space_prefix


                        class Ospfv3(Entity):
                            """
                            OSPFv3 summary
                            
                            .. attribute:: areas
                            
                            	Number of areas
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: as_dc_bitless_ls_as
                            
                            	Number of external and AS opaque LSAs with demand circut bit not set
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_do_not_age_ls_as
                            
                            	Number of external and AS opaque LSAs with do not age set 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_ls_as
                            
                            	Number of AS scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_lsa_flood_list_length
                            
                            	Length of AS LSAs flood list
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: context_name
                            
                            	Context name
                            	**type**\:  str
                            
                            	**length:** 0..32
                            
                            .. attribute:: default_metric
                            
                            	Default metric 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: default_metric_type
                            
                            	Default metric type 
                            	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                            
                            .. attribute:: default_policy_name
                            
                            	Default policy name 
                            	**type**\:  str
                            
                            .. attribute:: default_tag
                            
                            	Default tag 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: domain_id
                            
                            	Domain ID information
                            	**type**\:   :py:class:`DomainId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId>`
                            
                            .. attribute:: grace_resync_time
                            
                            	Grace time to resync 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: graceful_shutdown_state
                            
                            	Graceful shutdown state
                            	**type**\:   :py:class:`Ospfv3GracefulShutdownState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3GracefulShutdownState>`
                            
                            .. attribute:: ipfrr_tiebreakers
                            
                            	IPFRR\-Tiebreakers list
                            	**type**\: list of    :py:class:`IpfrrTiebreakers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.IpfrrTiebreakers>`
                            
                            .. attribute:: is_area_border_router
                            
                            	If true, is an area border router
                            	**type**\:  bool
                            
                            .. attribute:: is_as_border_router
                            
                            	If true, is an AS border router
                            	**type**\:  bool
                            
                            .. attribute:: is_auto_cost
                            
                            	If true, auto cost is enabled
                            	**type**\:  bool
                            
                            .. attribute:: is_default_always
                            
                            	If true, default always 
                            	**type**\:  bool
                            
                            .. attribute:: is_default_originated
                            
                            	If true, origin is by default 
                            	**type**\:  bool
                            
                            .. attribute:: is_default_policy
                            
                            	If true, is a default policy 
                            	**type**\:  bool
                            
                            .. attribute:: is_grace_restart_enabled
                            
                            	If true, grace restart is enabled 
                            	**type**\:  bool
                            
                            .. attribute:: is_nsr_enabled
                            
                            	If true, NSR is enabled
                            	**type**\:  bool
                            
                            .. attribute:: is_nsr_switchover_on_restart
                            
                            	Trigger RP Switchover on detectable process restart
                            	**type**\:  bool
                            
                            .. attribute:: is_opaque_capable
                            
                            	Opaque LSA capable 
                            	**type**\:  bool
                            
                            .. attribute:: is_role_standby
                            
                            	If true, the process is running as stanby role
                            	**type**\:  bool
                            
                            .. attribute:: is_router_id_stalled
                            
                            	Stalled Router ID 
                            	**type**\:  bool
                            
                            .. attribute:: last_nsf_time
                            
                            	 Length of time since the last NSF (s)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa_flood_pacing_interval
                            
                            	LSA flood pacing timer (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa_group_interval
                            
                            	LSA refresh interval (sec)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa_hold_time
                            
                            	Second delay before generating next LSA (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa_maximum_time
                            
                            	Maximum delay before generating an LSA (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa_retransmission_pacing_interval
                            
                            	LSA retransmission pacing timer (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa_start_time
                            
                            	Initial LSA throttle delay (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: maximum_interfaces
                            
                            	Maximum number of interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: maximum_paths
                            
                            	Maximum number of paths
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: metric
                            
                            	Redistribution metric 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: minimum_lsa_interval
                            
                            	Minimum time between LSA regeneration (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: normal_areas
                            
                            	Number of normal areas
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nssa_areas
                            
                            	Number of NSSA areas
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: opaque_lsa_checksum
                            
                            	Sum of opaque LSA checksum
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: opaque_lsas
                            
                            	Number of opaque LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: redistribution_limit
                            
                            	The number of redistributed prefixes allowed
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: redistribution_threshold
                            
                            	When the number of redistributed prefixes reaches this threshold, a warning message is issued 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: reference_bandwidth
                            
                            	Reference Bandwdith
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: role
                            
                            	Role, V1/V2 Active/Standby
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: router_id
                            
                            	Router ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: snmp_trap_enabled
                            
                            	If true, snmp trap is enabled
                            	**type**\:  bool
                            
                            .. attribute:: spf_hold_time
                            
                            	Minimum delay time between SPF runs (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: spf_maximum_time
                            
                            	Maximum delay time between SPF runs (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: spf_start_time
                            
                            	Scheduling delay for SPF (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: stub_areas
                            
                            	Number of stub and total stub areas
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: stub_router
                            
                            	Stub Router Information
                            	**type**\: list of    :py:class:`StubRouter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3, self).__init__()

                                self.yang_name = "ospfv3"
                                self.yang_parent_name = "summary"

                                self.areas = YLeaf(YType.uint16, "areas")

                                self.as_dc_bitless_ls_as = YLeaf(YType.uint32, "as-dc-bitless-ls-as")

                                self.as_do_not_age_ls_as = YLeaf(YType.uint32, "as-do-not-age-ls-as")

                                self.as_ls_as = YLeaf(YType.uint32, "as-ls-as")

                                self.as_lsa_flood_list_length = YLeaf(YType.uint32, "as-lsa-flood-list-length")

                                self.context_name = YLeaf(YType.str, "context-name")

                                self.default_metric = YLeaf(YType.uint32, "default-metric")

                                self.default_metric_type = YLeaf(YType.enumeration, "default-metric-type")

                                self.default_policy_name = YLeaf(YType.str, "default-policy-name")

                                self.default_tag = YLeaf(YType.uint32, "default-tag")

                                self.grace_resync_time = YLeaf(YType.uint32, "grace-resync-time")

                                self.graceful_shutdown_state = YLeaf(YType.enumeration, "graceful-shutdown-state")

                                self.is_area_border_router = YLeaf(YType.boolean, "is-area-border-router")

                                self.is_as_border_router = YLeaf(YType.boolean, "is-as-border-router")

                                self.is_auto_cost = YLeaf(YType.boolean, "is-auto-cost")

                                self.is_default_always = YLeaf(YType.boolean, "is-default-always")

                                self.is_default_originated = YLeaf(YType.boolean, "is-default-originated")

                                self.is_default_policy = YLeaf(YType.boolean, "is-default-policy")

                                self.is_grace_restart_enabled = YLeaf(YType.boolean, "is-grace-restart-enabled")

                                self.is_nsr_enabled = YLeaf(YType.boolean, "is-nsr-enabled")

                                self.is_nsr_switchover_on_restart = YLeaf(YType.boolean, "is-nsr-switchover-on-restart")

                                self.is_opaque_capable = YLeaf(YType.boolean, "is-opaque-capable")

                                self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                                self.is_router_id_stalled = YLeaf(YType.boolean, "is-router-id-stalled")

                                self.last_nsf_time = YLeaf(YType.uint32, "last-nsf-time")

                                self.lsa_flood_pacing_interval = YLeaf(YType.uint32, "lsa-flood-pacing-interval")

                                self.lsa_group_interval = YLeaf(YType.uint32, "lsa-group-interval")

                                self.lsa_hold_time = YLeaf(YType.uint32, "lsa-hold-time")

                                self.lsa_maximum_time = YLeaf(YType.uint32, "lsa-maximum-time")

                                self.lsa_retransmission_pacing_interval = YLeaf(YType.uint32, "lsa-retransmission-pacing-interval")

                                self.lsa_start_time = YLeaf(YType.uint32, "lsa-start-time")

                                self.maximum_interfaces = YLeaf(YType.uint32, "maximum-interfaces")

                                self.maximum_paths = YLeaf(YType.uint32, "maximum-paths")

                                self.metric = YLeaf(YType.uint32, "metric")

                                self.minimum_lsa_interval = YLeaf(YType.uint32, "minimum-lsa-interval")

                                self.normal_areas = YLeaf(YType.uint16, "normal-areas")

                                self.nssa_areas = YLeaf(YType.uint16, "nssa-areas")

                                self.opaque_lsa_checksum = YLeaf(YType.uint32, "opaque-lsa-checksum")

                                self.opaque_lsas = YLeaf(YType.uint32, "opaque-lsas")

                                self.redistribution_limit = YLeaf(YType.uint32, "redistribution-limit")

                                self.redistribution_threshold = YLeaf(YType.uint32, "redistribution-threshold")

                                self.reference_bandwidth = YLeaf(YType.uint32, "reference-bandwidth")

                                self.role = YLeaf(YType.uint32, "role")

                                self.router_id = YLeaf(YType.str, "router-id")

                                self.snmp_trap_enabled = YLeaf(YType.boolean, "snmp-trap-enabled")

                                self.spf_hold_time = YLeaf(YType.uint32, "spf-hold-time")

                                self.spf_maximum_time = YLeaf(YType.uint32, "spf-maximum-time")

                                self.spf_start_time = YLeaf(YType.uint32, "spf-start-time")

                                self.stub_areas = YLeaf(YType.uint16, "stub-areas")

                                self.domain_id = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId()
                                self.domain_id.parent = self
                                self._children_name_map["domain_id"] = "domain-id"
                                self._children_yang_names.add("domain-id")

                                self.ipfrr_tiebreakers = YList(self)
                                self.stub_router = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("areas",
                                                "as_dc_bitless_ls_as",
                                                "as_do_not_age_ls_as",
                                                "as_ls_as",
                                                "as_lsa_flood_list_length",
                                                "context_name",
                                                "default_metric",
                                                "default_metric_type",
                                                "default_policy_name",
                                                "default_tag",
                                                "grace_resync_time",
                                                "graceful_shutdown_state",
                                                "is_area_border_router",
                                                "is_as_border_router",
                                                "is_auto_cost",
                                                "is_default_always",
                                                "is_default_originated",
                                                "is_default_policy",
                                                "is_grace_restart_enabled",
                                                "is_nsr_enabled",
                                                "is_nsr_switchover_on_restart",
                                                "is_opaque_capable",
                                                "is_role_standby",
                                                "is_router_id_stalled",
                                                "last_nsf_time",
                                                "lsa_flood_pacing_interval",
                                                "lsa_group_interval",
                                                "lsa_hold_time",
                                                "lsa_maximum_time",
                                                "lsa_retransmission_pacing_interval",
                                                "lsa_start_time",
                                                "maximum_interfaces",
                                                "maximum_paths",
                                                "metric",
                                                "minimum_lsa_interval",
                                                "normal_areas",
                                                "nssa_areas",
                                                "opaque_lsa_checksum",
                                                "opaque_lsas",
                                                "redistribution_limit",
                                                "redistribution_threshold",
                                                "reference_bandwidth",
                                                "role",
                                                "router_id",
                                                "snmp_trap_enabled",
                                                "spf_hold_time",
                                                "spf_maximum_time",
                                                "spf_start_time",
                                                "stub_areas") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3, self).__setattr__(name, value)


                            class DomainId(Entity):
                                """
                                Domain ID information
                                
                                .. attribute:: primary_domain_id
                                
                                	Primary Domain ID
                                	**type**\:   :py:class:`PrimaryDomainId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.PrimaryDomainId>`
                                
                                .. attribute:: secondary_domain_id
                                
                                	List of secondary domain IDs
                                	**type**\: list of    :py:class:`SecondaryDomainId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.SecondaryDomainId>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId, self).__init__()

                                    self.yang_name = "domain-id"
                                    self.yang_parent_name = "ospfv3"

                                    self.primary_domain_id = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.PrimaryDomainId()
                                    self.primary_domain_id.parent = self
                                    self._children_name_map["primary_domain_id"] = "primary-domain-id"
                                    self._children_yang_names.add("primary-domain-id")

                                    self.secondary_domain_id = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId, self).__setattr__(name, value)


                                class PrimaryDomainId(Entity):
                                    """
                                    Primary Domain ID
                                    
                                    .. attribute:: domain_id_type
                                    
                                    	Domain ID Type
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: domain_id_value
                                    
                                    	Domain ID value
                                    	**type**\:  str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.PrimaryDomainId, self).__init__()

                                        self.yang_name = "primary-domain-id"
                                        self.yang_parent_name = "domain-id"

                                        self.domain_id_type = YLeaf(YType.uint16, "domain-id-type")

                                        self.domain_id_value = YLeaf(YType.str, "domain-id-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("domain_id_type",
                                                        "domain_id_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.PrimaryDomainId, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.PrimaryDomainId, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.domain_id_type.is_set or
                                            self.domain_id_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.domain_id_type.yfilter != YFilter.not_set or
                                            self.domain_id_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "primary-domain-id" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.domain_id_type.is_set or self.domain_id_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.domain_id_type.get_name_leafdata())
                                        if (self.domain_id_value.is_set or self.domain_id_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.domain_id_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "domain-id-type" or name == "domain-id-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "domain-id-type"):
                                            self.domain_id_type = value
                                            self.domain_id_type.value_namespace = name_space
                                            self.domain_id_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "domain-id-value"):
                                            self.domain_id_value = value
                                            self.domain_id_value.value_namespace = name_space
                                            self.domain_id_value.value_namespace_prefix = name_space_prefix


                                class SecondaryDomainId(Entity):
                                    """
                                    List of secondary domain IDs
                                    
                                    .. attribute:: domain_id_type
                                    
                                    	Domain ID Type
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: domain_id_value
                                    
                                    	Domain ID value
                                    	**type**\:  str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.SecondaryDomainId, self).__init__()

                                        self.yang_name = "secondary-domain-id"
                                        self.yang_parent_name = "domain-id"

                                        self.domain_id_type = YLeaf(YType.uint16, "domain-id-type")

                                        self.domain_id_value = YLeaf(YType.str, "domain-id-value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("domain_id_type",
                                                        "domain_id_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.SecondaryDomainId, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.SecondaryDomainId, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.domain_id_type.is_set or
                                            self.domain_id_value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.domain_id_type.yfilter != YFilter.not_set or
                                            self.domain_id_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "secondary-domain-id" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.domain_id_type.is_set or self.domain_id_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.domain_id_type.get_name_leafdata())
                                        if (self.domain_id_value.is_set or self.domain_id_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.domain_id_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "domain-id-type" or name == "domain-id-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "domain-id-type"):
                                            self.domain_id_type = value
                                            self.domain_id_type.value_namespace = name_space
                                            self.domain_id_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "domain-id-value"):
                                            self.domain_id_value = value
                                            self.domain_id_value.value_namespace = name_space
                                            self.domain_id_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.secondary_domain_id:
                                        if (c.has_data()):
                                            return True
                                    return (self.primary_domain_id is not None and self.primary_domain_id.has_data())

                                def has_operation(self):
                                    for c in self.secondary_domain_id:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.primary_domain_id is not None and self.primary_domain_id.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "domain-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "primary-domain-id"):
                                        if (self.primary_domain_id is None):
                                            self.primary_domain_id = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.PrimaryDomainId()
                                            self.primary_domain_id.parent = self
                                            self._children_name_map["primary_domain_id"] = "primary-domain-id"
                                        return self.primary_domain_id

                                    if (child_yang_name == "secondary-domain-id"):
                                        for c in self.secondary_domain_id:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId.SecondaryDomainId()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.secondary_domain_id.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "primary-domain-id" or name == "secondary-domain-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class StubRouter(Entity):
                                """
                                Stub Router Information
                                
                                .. attribute:: abr_off_reason
                                
                                	Reason for being in ABR off mode
                                	**type**\:   :py:class:`StubRouterAbrOffReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterAbrOffReason>`
                                
                                .. attribute:: abr_resume_time
                                
                                	Timestamp (relative to 1970/1/1 00\:00) when ABR duties were resumed
                                	**type**\:   :py:class:`AbrResumeTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.AbrResumeTime>`
                                
                                .. attribute:: active
                                
                                	If true, stub router mode is active
                                	**type**\:  bool
                                
                                .. attribute:: external_lsa_metric
                                
                                	Metric for external LSAs in max\-metric mode
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: include_stub_links
                                
                                	If true, advertise maximum metric for stub links
                                	**type**\:  bool
                                
                                .. attribute:: mode
                                
                                	Stub router mode
                                	**type**\:   :py:class:`StubRouterMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterMode>`
                                
                                .. attribute:: remaining_time
                                
                                	Remaining time (in seconds) in stub router mode
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: set_reason
                                
                                	Reason for entering stub router mode
                                	**type**\:   :py:class:`StubRouterTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterTrigger>`
                                
                                .. attribute:: start_time
                                
                                	Timestamp (relative to 1970/1/1 00\:00) when stub router mode was activated
                                	**type**\:   :py:class:`StartTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.StartTime>`
                                
                                .. attribute:: summary_lsa_metric
                                
                                	Metric for summary LSAs in max\-metric mode
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: trigger
                                
                                	Triggers for entering stub router mode
                                	**type**\: list of    :py:class:`Trigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger>`
                                
                                .. attribute:: unset_reason
                                
                                	Reason for clearing stub router condition
                                	**type**\:   :py:class:`StubRouterExitReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterExitReason>`
                                
                                .. attribute:: unset_time
                                
                                	Timestamp (relative to 1970/1/1 00\:00) when stub router condition was cleared
                                	**type**\:   :py:class:`UnsetTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.UnsetTime>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter, self).__init__()

                                    self.yang_name = "stub-router"
                                    self.yang_parent_name = "ospfv3"

                                    self.abr_off_reason = YLeaf(YType.enumeration, "abr-off-reason")

                                    self.active = YLeaf(YType.boolean, "active")

                                    self.external_lsa_metric = YLeaf(YType.uint32, "external-lsa-metric")

                                    self.include_stub_links = YLeaf(YType.boolean, "include-stub-links")

                                    self.mode = YLeaf(YType.enumeration, "mode")

                                    self.remaining_time = YLeaf(YType.uint32, "remaining-time")

                                    self.set_reason = YLeaf(YType.enumeration, "set-reason")

                                    self.summary_lsa_metric = YLeaf(YType.uint32, "summary-lsa-metric")

                                    self.unset_reason = YLeaf(YType.enumeration, "unset-reason")

                                    self.abr_resume_time = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.AbrResumeTime()
                                    self.abr_resume_time.parent = self
                                    self._children_name_map["abr_resume_time"] = "abr-resume-time"
                                    self._children_yang_names.add("abr-resume-time")

                                    self.start_time = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.StartTime()
                                    self.start_time.parent = self
                                    self._children_name_map["start_time"] = "start-time"
                                    self._children_yang_names.add("start-time")

                                    self.unset_time = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.UnsetTime()
                                    self.unset_time.parent = self
                                    self._children_name_map["unset_time"] = "unset-time"
                                    self._children_yang_names.add("unset-time")

                                    self.trigger = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("abr_off_reason",
                                                    "active",
                                                    "external_lsa_metric",
                                                    "include_stub_links",
                                                    "mode",
                                                    "remaining_time",
                                                    "set_reason",
                                                    "summary_lsa_metric",
                                                    "unset_reason") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter, self).__setattr__(name, value)


                                class UnsetTime(Entity):
                                    """
                                    Timestamp (relative to 1970/1/1 00\:00) when stub
                                    router condition was cleared
                                    
                                    .. attribute:: nanosecond
                                    
                                    	Nano seconds 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: nanosecond
                                    
                                    .. attribute:: second
                                    
                                    	Seconds 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.UnsetTime, self).__init__()

                                        self.yang_name = "unset-time"
                                        self.yang_parent_name = "stub-router"

                                        self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                        self.second = YLeaf(YType.uint32, "second")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nanosecond",
                                                        "second") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.UnsetTime, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.UnsetTime, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.nanosecond.is_set or
                                            self.second.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nanosecond.yfilter != YFilter.not_set or
                                            self.second.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unset-time" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                        if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.second.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "nanosecond" or name == "second"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nanosecond"):
                                            self.nanosecond = value
                                            self.nanosecond.value_namespace = name_space
                                            self.nanosecond.value_namespace_prefix = name_space_prefix
                                        if(value_path == "second"):
                                            self.second = value
                                            self.second.value_namespace = name_space
                                            self.second.value_namespace_prefix = name_space_prefix


                                class StartTime(Entity):
                                    """
                                    Timestamp (relative to 1970/1/1 00\:00) when stub
                                    router mode was activated
                                    
                                    .. attribute:: nanosecond
                                    
                                    	Nano seconds 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: nanosecond
                                    
                                    .. attribute:: second
                                    
                                    	Seconds 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.StartTime, self).__init__()

                                        self.yang_name = "start-time"
                                        self.yang_parent_name = "stub-router"

                                        self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                        self.second = YLeaf(YType.uint32, "second")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nanosecond",
                                                        "second") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.StartTime, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.StartTime, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.nanosecond.is_set or
                                            self.second.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nanosecond.yfilter != YFilter.not_set or
                                            self.second.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "start-time" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                        if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.second.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "nanosecond" or name == "second"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nanosecond"):
                                            self.nanosecond = value
                                            self.nanosecond.value_namespace = name_space
                                            self.nanosecond.value_namespace_prefix = name_space_prefix
                                        if(value_path == "second"):
                                            self.second = value
                                            self.second.value_namespace = name_space
                                            self.second.value_namespace_prefix = name_space_prefix


                                class AbrResumeTime(Entity):
                                    """
                                    Timestamp (relative to 1970/1/1 00\:00) when ABR
                                    duties were resumed
                                    
                                    .. attribute:: nanosecond
                                    
                                    	Nano seconds 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: nanosecond
                                    
                                    .. attribute:: second
                                    
                                    	Seconds 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.AbrResumeTime, self).__init__()

                                        self.yang_name = "abr-resume-time"
                                        self.yang_parent_name = "stub-router"

                                        self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                        self.second = YLeaf(YType.uint32, "second")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nanosecond",
                                                        "second") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.AbrResumeTime, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.AbrResumeTime, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.nanosecond.is_set or
                                            self.second.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nanosecond.yfilter != YFilter.not_set or
                                            self.second.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "abr-resume-time" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                        if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.second.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "nanosecond" or name == "second"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nanosecond"):
                                            self.nanosecond = value
                                            self.nanosecond.value_namespace = name_space
                                            self.nanosecond.value_namespace_prefix = name_space_prefix
                                        if(value_path == "second"):
                                            self.second = value
                                            self.second.value_namespace = name_space
                                            self.second.value_namespace_prefix = name_space_prefix


                                class Trigger(Entity):
                                    """
                                    Triggers for entering stub router mode
                                    
                                    .. attribute:: start_time
                                    
                                    	Timestamp (relative to 1970/1/1 00\:00) when stub router mode was activated
                                    	**type**\:   :py:class:`StartTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.StartTime>`
                                    
                                    .. attribute:: time
                                    
                                    	Time (in seconds) to stay in stub router mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: trigger
                                    
                                    	Stub Router Trigger type
                                    	**type**\:   :py:class:`StubRouterTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterTrigger>`
                                    
                                    .. attribute:: unset_reason
                                    
                                    	Reason for clearing stub router condition
                                    	**type**\:   :py:class:`StubRouterExitReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterExitReason>`
                                    
                                    .. attribute:: unset_time
                                    
                                    	Timestamp (relative to 1970/1/1 00\:00) when stub router condition was cleared
                                    	**type**\:   :py:class:`UnsetTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime>`
                                    
                                    .. attribute:: wait_for_bgp
                                    
                                    	If true, stub router is terminated when BGP converges
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger, self).__init__()

                                        self.yang_name = "trigger"
                                        self.yang_parent_name = "stub-router"

                                        self.time = YLeaf(YType.uint32, "time")

                                        self.trigger = YLeaf(YType.enumeration, "trigger")

                                        self.unset_reason = YLeaf(YType.enumeration, "unset-reason")

                                        self.wait_for_bgp = YLeaf(YType.boolean, "wait-for-bgp")

                                        self.start_time = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.StartTime()
                                        self.start_time.parent = self
                                        self._children_name_map["start_time"] = "start-time"
                                        self._children_yang_names.add("start-time")

                                        self.unset_time = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime()
                                        self.unset_time.parent = self
                                        self._children_name_map["unset_time"] = "unset-time"
                                        self._children_yang_names.add("unset-time")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("time",
                                                        "trigger",
                                                        "unset_reason",
                                                        "wait_for_bgp") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger, self).__setattr__(name, value)


                                    class UnsetTime(Entity):
                                        """
                                        Timestamp (relative to 1970/1/1 00\:00) when stub
                                        router condition was cleared
                                        
                                        .. attribute:: nanosecond
                                        
                                        	Nano seconds 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: nanosecond
                                        
                                        .. attribute:: second
                                        
                                        	Seconds 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime, self).__init__()

                                            self.yang_name = "unset-time"
                                            self.yang_parent_name = "trigger"

                                            self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                            self.second = YLeaf(YType.uint32, "second")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nanosecond",
                                                            "second") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.nanosecond.is_set or
                                                self.second.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nanosecond.yfilter != YFilter.not_set or
                                                self.second.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unset-time" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                            if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "nanosecond" or name == "second"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nanosecond"):
                                                self.nanosecond = value
                                                self.nanosecond.value_namespace = name_space
                                                self.nanosecond.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second"):
                                                self.second = value
                                                self.second.value_namespace = name_space
                                                self.second.value_namespace_prefix = name_space_prefix


                                    class StartTime(Entity):
                                        """
                                        Timestamp (relative to 1970/1/1 00\:00) when stub
                                        router mode was activated
                                        
                                        .. attribute:: nanosecond
                                        
                                        	Nano seconds 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: nanosecond
                                        
                                        .. attribute:: second
                                        
                                        	Seconds 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.StartTime, self).__init__()

                                            self.yang_name = "start-time"
                                            self.yang_parent_name = "trigger"

                                            self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                            self.second = YLeaf(YType.uint32, "second")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nanosecond",
                                                            "second") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.StartTime, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.StartTime, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.nanosecond.is_set or
                                                self.second.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nanosecond.yfilter != YFilter.not_set or
                                                self.second.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "start-time" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                            if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "nanosecond" or name == "second"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nanosecond"):
                                                self.nanosecond = value
                                                self.nanosecond.value_namespace = name_space
                                                self.nanosecond.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second"):
                                                self.second = value
                                                self.second.value_namespace = name_space
                                                self.second.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.time.is_set or
                                            self.trigger.is_set or
                                            self.unset_reason.is_set or
                                            self.wait_for_bgp.is_set or
                                            (self.start_time is not None and self.start_time.has_data()) or
                                            (self.unset_time is not None and self.unset_time.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.time.yfilter != YFilter.not_set or
                                            self.trigger.yfilter != YFilter.not_set or
                                            self.unset_reason.yfilter != YFilter.not_set or
                                            self.wait_for_bgp.yfilter != YFilter.not_set or
                                            (self.start_time is not None and self.start_time.has_operation()) or
                                            (self.unset_time is not None and self.unset_time.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "trigger" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.time.is_set or self.time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.time.get_name_leafdata())
                                        if (self.trigger.is_set or self.trigger.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.trigger.get_name_leafdata())
                                        if (self.unset_reason.is_set or self.unset_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.unset_reason.get_name_leafdata())
                                        if (self.wait_for_bgp.is_set or self.wait_for_bgp.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_for_bgp.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "start-time"):
                                            if (self.start_time is None):
                                                self.start_time = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.StartTime()
                                                self.start_time.parent = self
                                                self._children_name_map["start_time"] = "start-time"
                                            return self.start_time

                                        if (child_yang_name == "unset-time"):
                                            if (self.unset_time is None):
                                                self.unset_time = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime()
                                                self.unset_time.parent = self
                                                self._children_name_map["unset_time"] = "unset-time"
                                            return self.unset_time

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "start-time" or name == "unset-time" or name == "time" or name == "trigger" or name == "unset-reason" or name == "wait-for-bgp"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "time"):
                                            self.time = value
                                            self.time.value_namespace = name_space
                                            self.time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "trigger"):
                                            self.trigger = value
                                            self.trigger.value_namespace = name_space
                                            self.trigger.value_namespace_prefix = name_space_prefix
                                        if(value_path == "unset-reason"):
                                            self.unset_reason = value
                                            self.unset_reason.value_namespace = name_space
                                            self.unset_reason.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-for-bgp"):
                                            self.wait_for_bgp = value
                                            self.wait_for_bgp.value_namespace = name_space
                                            self.wait_for_bgp.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.trigger:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.abr_off_reason.is_set or
                                        self.active.is_set or
                                        self.external_lsa_metric.is_set or
                                        self.include_stub_links.is_set or
                                        self.mode.is_set or
                                        self.remaining_time.is_set or
                                        self.set_reason.is_set or
                                        self.summary_lsa_metric.is_set or
                                        self.unset_reason.is_set or
                                        (self.abr_resume_time is not None and self.abr_resume_time.has_data()) or
                                        (self.start_time is not None and self.start_time.has_data()) or
                                        (self.unset_time is not None and self.unset_time.has_data()))

                                def has_operation(self):
                                    for c in self.trigger:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.abr_off_reason.yfilter != YFilter.not_set or
                                        self.active.yfilter != YFilter.not_set or
                                        self.external_lsa_metric.yfilter != YFilter.not_set or
                                        self.include_stub_links.yfilter != YFilter.not_set or
                                        self.mode.yfilter != YFilter.not_set or
                                        self.remaining_time.yfilter != YFilter.not_set or
                                        self.set_reason.yfilter != YFilter.not_set or
                                        self.summary_lsa_metric.yfilter != YFilter.not_set or
                                        self.unset_reason.yfilter != YFilter.not_set or
                                        (self.abr_resume_time is not None and self.abr_resume_time.has_operation()) or
                                        (self.start_time is not None and self.start_time.has_operation()) or
                                        (self.unset_time is not None and self.unset_time.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stub-router" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.abr_off_reason.is_set or self.abr_off_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.abr_off_reason.get_name_leafdata())
                                    if (self.active.is_set or self.active.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.active.get_name_leafdata())
                                    if (self.external_lsa_metric.is_set or self.external_lsa_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.external_lsa_metric.get_name_leafdata())
                                    if (self.include_stub_links.is_set or self.include_stub_links.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.include_stub_links.get_name_leafdata())
                                    if (self.mode.is_set or self.mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mode.get_name_leafdata())
                                    if (self.remaining_time.is_set or self.remaining_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.remaining_time.get_name_leafdata())
                                    if (self.set_reason.is_set or self.set_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.set_reason.get_name_leafdata())
                                    if (self.summary_lsa_metric.is_set or self.summary_lsa_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.summary_lsa_metric.get_name_leafdata())
                                    if (self.unset_reason.is_set or self.unset_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unset_reason.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "abr-resume-time"):
                                        if (self.abr_resume_time is None):
                                            self.abr_resume_time = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.AbrResumeTime()
                                            self.abr_resume_time.parent = self
                                            self._children_name_map["abr_resume_time"] = "abr-resume-time"
                                        return self.abr_resume_time

                                    if (child_yang_name == "start-time"):
                                        if (self.start_time is None):
                                            self.start_time = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.StartTime()
                                            self.start_time.parent = self
                                            self._children_name_map["start_time"] = "start-time"
                                        return self.start_time

                                    if (child_yang_name == "trigger"):
                                        for c in self.trigger:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.Trigger()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.trigger.append(c)
                                        return c

                                    if (child_yang_name == "unset-time"):
                                        if (self.unset_time is None):
                                            self.unset_time = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter.UnsetTime()
                                            self.unset_time.parent = self
                                            self._children_name_map["unset_time"] = "unset-time"
                                        return self.unset_time

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "abr-resume-time" or name == "start-time" or name == "trigger" or name == "unset-time" or name == "abr-off-reason" or name == "active" or name == "external-lsa-metric" or name == "include-stub-links" or name == "mode" or name == "remaining-time" or name == "set-reason" or name == "summary-lsa-metric" or name == "unset-reason"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "abr-off-reason"):
                                        self.abr_off_reason = value
                                        self.abr_off_reason.value_namespace = name_space
                                        self.abr_off_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "active"):
                                        self.active = value
                                        self.active.value_namespace = name_space
                                        self.active.value_namespace_prefix = name_space_prefix
                                    if(value_path == "external-lsa-metric"):
                                        self.external_lsa_metric = value
                                        self.external_lsa_metric.value_namespace = name_space
                                        self.external_lsa_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "include-stub-links"):
                                        self.include_stub_links = value
                                        self.include_stub_links.value_namespace = name_space
                                        self.include_stub_links.value_namespace_prefix = name_space_prefix
                                    if(value_path == "mode"):
                                        self.mode = value
                                        self.mode.value_namespace = name_space
                                        self.mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "remaining-time"):
                                        self.remaining_time = value
                                        self.remaining_time.value_namespace = name_space
                                        self.remaining_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "set-reason"):
                                        self.set_reason = value
                                        self.set_reason.value_namespace = name_space
                                        self.set_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "summary-lsa-metric"):
                                        self.summary_lsa_metric = value
                                        self.summary_lsa_metric.value_namespace = name_space
                                        self.summary_lsa_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unset-reason"):
                                        self.unset_reason = value
                                        self.unset_reason.value_namespace = name_space
                                        self.unset_reason.value_namespace_prefix = name_space_prefix


                            class IpfrrTiebreakers(Entity):
                                """
                                IPFRR\-Tiebreakers list
                                
                                .. attribute:: tiebreaker_index
                                
                                	Tiebreaker Index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tiebreaker_type
                                
                                	Tiebreaker Type
                                	**type**\:   :py:class:`IpfrrTbrkr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.IpfrrTbrkr>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.IpfrrTiebreakers, self).__init__()

                                    self.yang_name = "ipfrr-tiebreakers"
                                    self.yang_parent_name = "ospfv3"

                                    self.tiebreaker_index = YLeaf(YType.uint32, "tiebreaker-index")

                                    self.tiebreaker_type = YLeaf(YType.enumeration, "tiebreaker-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tiebreaker_index",
                                                    "tiebreaker_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.IpfrrTiebreakers, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.IpfrrTiebreakers, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.tiebreaker_index.is_set or
                                        self.tiebreaker_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tiebreaker_index.yfilter != YFilter.not_set or
                                        self.tiebreaker_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipfrr-tiebreakers" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tiebreaker_index.is_set or self.tiebreaker_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tiebreaker_index.get_name_leafdata())
                                    if (self.tiebreaker_type.is_set or self.tiebreaker_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tiebreaker_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "tiebreaker-index" or name == "tiebreaker-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tiebreaker-index"):
                                        self.tiebreaker_index = value
                                        self.tiebreaker_index.value_namespace = name_space
                                        self.tiebreaker_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tiebreaker-type"):
                                        self.tiebreaker_type = value
                                        self.tiebreaker_type.value_namespace = name_space
                                        self.tiebreaker_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ipfrr_tiebreakers:
                                    if (c.has_data()):
                                        return True
                                for c in self.stub_router:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.areas.is_set or
                                    self.as_dc_bitless_ls_as.is_set or
                                    self.as_do_not_age_ls_as.is_set or
                                    self.as_ls_as.is_set or
                                    self.as_lsa_flood_list_length.is_set or
                                    self.context_name.is_set or
                                    self.default_metric.is_set or
                                    self.default_metric_type.is_set or
                                    self.default_policy_name.is_set or
                                    self.default_tag.is_set or
                                    self.grace_resync_time.is_set or
                                    self.graceful_shutdown_state.is_set or
                                    self.is_area_border_router.is_set or
                                    self.is_as_border_router.is_set or
                                    self.is_auto_cost.is_set or
                                    self.is_default_always.is_set or
                                    self.is_default_originated.is_set or
                                    self.is_default_policy.is_set or
                                    self.is_grace_restart_enabled.is_set or
                                    self.is_nsr_enabled.is_set or
                                    self.is_nsr_switchover_on_restart.is_set or
                                    self.is_opaque_capable.is_set or
                                    self.is_role_standby.is_set or
                                    self.is_router_id_stalled.is_set or
                                    self.last_nsf_time.is_set or
                                    self.lsa_flood_pacing_interval.is_set or
                                    self.lsa_group_interval.is_set or
                                    self.lsa_hold_time.is_set or
                                    self.lsa_maximum_time.is_set or
                                    self.lsa_retransmission_pacing_interval.is_set or
                                    self.lsa_start_time.is_set or
                                    self.maximum_interfaces.is_set or
                                    self.maximum_paths.is_set or
                                    self.metric.is_set or
                                    self.minimum_lsa_interval.is_set or
                                    self.normal_areas.is_set or
                                    self.nssa_areas.is_set or
                                    self.opaque_lsa_checksum.is_set or
                                    self.opaque_lsas.is_set or
                                    self.redistribution_limit.is_set or
                                    self.redistribution_threshold.is_set or
                                    self.reference_bandwidth.is_set or
                                    self.role.is_set or
                                    self.router_id.is_set or
                                    self.snmp_trap_enabled.is_set or
                                    self.spf_hold_time.is_set or
                                    self.spf_maximum_time.is_set or
                                    self.spf_start_time.is_set or
                                    self.stub_areas.is_set or
                                    (self.domain_id is not None and self.domain_id.has_data()))

                            def has_operation(self):
                                for c in self.ipfrr_tiebreakers:
                                    if (c.has_operation()):
                                        return True
                                for c in self.stub_router:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.areas.yfilter != YFilter.not_set or
                                    self.as_dc_bitless_ls_as.yfilter != YFilter.not_set or
                                    self.as_do_not_age_ls_as.yfilter != YFilter.not_set or
                                    self.as_ls_as.yfilter != YFilter.not_set or
                                    self.as_lsa_flood_list_length.yfilter != YFilter.not_set or
                                    self.context_name.yfilter != YFilter.not_set or
                                    self.default_metric.yfilter != YFilter.not_set or
                                    self.default_metric_type.yfilter != YFilter.not_set or
                                    self.default_policy_name.yfilter != YFilter.not_set or
                                    self.default_tag.yfilter != YFilter.not_set or
                                    self.grace_resync_time.yfilter != YFilter.not_set or
                                    self.graceful_shutdown_state.yfilter != YFilter.not_set or
                                    self.is_area_border_router.yfilter != YFilter.not_set or
                                    self.is_as_border_router.yfilter != YFilter.not_set or
                                    self.is_auto_cost.yfilter != YFilter.not_set or
                                    self.is_default_always.yfilter != YFilter.not_set or
                                    self.is_default_originated.yfilter != YFilter.not_set or
                                    self.is_default_policy.yfilter != YFilter.not_set or
                                    self.is_grace_restart_enabled.yfilter != YFilter.not_set or
                                    self.is_nsr_enabled.yfilter != YFilter.not_set or
                                    self.is_nsr_switchover_on_restart.yfilter != YFilter.not_set or
                                    self.is_opaque_capable.yfilter != YFilter.not_set or
                                    self.is_role_standby.yfilter != YFilter.not_set or
                                    self.is_router_id_stalled.yfilter != YFilter.not_set or
                                    self.last_nsf_time.yfilter != YFilter.not_set or
                                    self.lsa_flood_pacing_interval.yfilter != YFilter.not_set or
                                    self.lsa_group_interval.yfilter != YFilter.not_set or
                                    self.lsa_hold_time.yfilter != YFilter.not_set or
                                    self.lsa_maximum_time.yfilter != YFilter.not_set or
                                    self.lsa_retransmission_pacing_interval.yfilter != YFilter.not_set or
                                    self.lsa_start_time.yfilter != YFilter.not_set or
                                    self.maximum_interfaces.yfilter != YFilter.not_set or
                                    self.maximum_paths.yfilter != YFilter.not_set or
                                    self.metric.yfilter != YFilter.not_set or
                                    self.minimum_lsa_interval.yfilter != YFilter.not_set or
                                    self.normal_areas.yfilter != YFilter.not_set or
                                    self.nssa_areas.yfilter != YFilter.not_set or
                                    self.opaque_lsa_checksum.yfilter != YFilter.not_set or
                                    self.opaque_lsas.yfilter != YFilter.not_set or
                                    self.redistribution_limit.yfilter != YFilter.not_set or
                                    self.redistribution_threshold.yfilter != YFilter.not_set or
                                    self.reference_bandwidth.yfilter != YFilter.not_set or
                                    self.role.yfilter != YFilter.not_set or
                                    self.router_id.yfilter != YFilter.not_set or
                                    self.snmp_trap_enabled.yfilter != YFilter.not_set or
                                    self.spf_hold_time.yfilter != YFilter.not_set or
                                    self.spf_maximum_time.yfilter != YFilter.not_set or
                                    self.spf_start_time.yfilter != YFilter.not_set or
                                    self.stub_areas.yfilter != YFilter.not_set or
                                    (self.domain_id is not None and self.domain_id.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ospfv3" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.areas.is_set or self.areas.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.areas.get_name_leafdata())
                                if (self.as_dc_bitless_ls_as.is_set or self.as_dc_bitless_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_dc_bitless_ls_as.get_name_leafdata())
                                if (self.as_do_not_age_ls_as.is_set or self.as_do_not_age_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_do_not_age_ls_as.get_name_leafdata())
                                if (self.as_ls_as.is_set or self.as_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_ls_as.get_name_leafdata())
                                if (self.as_lsa_flood_list_length.is_set or self.as_lsa_flood_list_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_lsa_flood_list_length.get_name_leafdata())
                                if (self.context_name.is_set or self.context_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.context_name.get_name_leafdata())
                                if (self.default_metric.is_set or self.default_metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.default_metric.get_name_leafdata())
                                if (self.default_metric_type.is_set or self.default_metric_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.default_metric_type.get_name_leafdata())
                                if (self.default_policy_name.is_set or self.default_policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.default_policy_name.get_name_leafdata())
                                if (self.default_tag.is_set or self.default_tag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.default_tag.get_name_leafdata())
                                if (self.grace_resync_time.is_set or self.grace_resync_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.grace_resync_time.get_name_leafdata())
                                if (self.graceful_shutdown_state.is_set or self.graceful_shutdown_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.graceful_shutdown_state.get_name_leafdata())
                                if (self.is_area_border_router.is_set or self.is_area_border_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_area_border_router.get_name_leafdata())
                                if (self.is_as_border_router.is_set or self.is_as_border_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_as_border_router.get_name_leafdata())
                                if (self.is_auto_cost.is_set or self.is_auto_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_auto_cost.get_name_leafdata())
                                if (self.is_default_always.is_set or self.is_default_always.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_default_always.get_name_leafdata())
                                if (self.is_default_originated.is_set or self.is_default_originated.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_default_originated.get_name_leafdata())
                                if (self.is_default_policy.is_set or self.is_default_policy.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_default_policy.get_name_leafdata())
                                if (self.is_grace_restart_enabled.is_set or self.is_grace_restart_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_grace_restart_enabled.get_name_leafdata())
                                if (self.is_nsr_enabled.is_set or self.is_nsr_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_nsr_enabled.get_name_leafdata())
                                if (self.is_nsr_switchover_on_restart.is_set or self.is_nsr_switchover_on_restart.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_nsr_switchover_on_restart.get_name_leafdata())
                                if (self.is_opaque_capable.is_set or self.is_opaque_capable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_opaque_capable.get_name_leafdata())
                                if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_role_standby.get_name_leafdata())
                                if (self.is_router_id_stalled.is_set or self.is_router_id_stalled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_router_id_stalled.get_name_leafdata())
                                if (self.last_nsf_time.is_set or self.last_nsf_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.last_nsf_time.get_name_leafdata())
                                if (self.lsa_flood_pacing_interval.is_set or self.lsa_flood_pacing_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_flood_pacing_interval.get_name_leafdata())
                                if (self.lsa_group_interval.is_set or self.lsa_group_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_group_interval.get_name_leafdata())
                                if (self.lsa_hold_time.is_set or self.lsa_hold_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_hold_time.get_name_leafdata())
                                if (self.lsa_maximum_time.is_set or self.lsa_maximum_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_maximum_time.get_name_leafdata())
                                if (self.lsa_retransmission_pacing_interval.is_set or self.lsa_retransmission_pacing_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_retransmission_pacing_interval.get_name_leafdata())
                                if (self.lsa_start_time.is_set or self.lsa_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_start_time.get_name_leafdata())
                                if (self.maximum_interfaces.is_set or self.maximum_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_interfaces.get_name_leafdata())
                                if (self.maximum_paths.is_set or self.maximum_paths.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_paths.get_name_leafdata())
                                if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.metric.get_name_leafdata())
                                if (self.minimum_lsa_interval.is_set or self.minimum_lsa_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.minimum_lsa_interval.get_name_leafdata())
                                if (self.normal_areas.is_set or self.normal_areas.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.normal_areas.get_name_leafdata())
                                if (self.nssa_areas.is_set or self.nssa_areas.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nssa_areas.get_name_leafdata())
                                if (self.opaque_lsa_checksum.is_set or self.opaque_lsa_checksum.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.opaque_lsa_checksum.get_name_leafdata())
                                if (self.opaque_lsas.is_set or self.opaque_lsas.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.opaque_lsas.get_name_leafdata())
                                if (self.redistribution_limit.is_set or self.redistribution_limit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.redistribution_limit.get_name_leafdata())
                                if (self.redistribution_threshold.is_set or self.redistribution_threshold.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.redistribution_threshold.get_name_leafdata())
                                if (self.reference_bandwidth.is_set or self.reference_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reference_bandwidth.get_name_leafdata())
                                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.role.get_name_leafdata())
                                if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.router_id.get_name_leafdata())
                                if (self.snmp_trap_enabled.is_set or self.snmp_trap_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.snmp_trap_enabled.get_name_leafdata())
                                if (self.spf_hold_time.is_set or self.spf_hold_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spf_hold_time.get_name_leafdata())
                                if (self.spf_maximum_time.is_set or self.spf_maximum_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spf_maximum_time.get_name_leafdata())
                                if (self.spf_start_time.is_set or self.spf_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spf_start_time.get_name_leafdata())
                                if (self.stub_areas.is_set or self.stub_areas.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.stub_areas.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "domain-id"):
                                    if (self.domain_id is None):
                                        self.domain_id = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.DomainId()
                                        self.domain_id.parent = self
                                        self._children_name_map["domain_id"] = "domain-id"
                                    return self.domain_id

                                if (child_yang_name == "ipfrr-tiebreakers"):
                                    for c in self.ipfrr_tiebreakers:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.IpfrrTiebreakers()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ipfrr_tiebreakers.append(c)
                                    return c

                                if (child_yang_name == "stub-router"):
                                    for c in self.stub_router:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3.StubRouter()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.stub_router.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "domain-id" or name == "ipfrr-tiebreakers" or name == "stub-router" or name == "areas" or name == "as-dc-bitless-ls-as" or name == "as-do-not-age-ls-as" or name == "as-ls-as" or name == "as-lsa-flood-list-length" or name == "context-name" or name == "default-metric" or name == "default-metric-type" or name == "default-policy-name" or name == "default-tag" or name == "grace-resync-time" or name == "graceful-shutdown-state" or name == "is-area-border-router" or name == "is-as-border-router" or name == "is-auto-cost" or name == "is-default-always" or name == "is-default-originated" or name == "is-default-policy" or name == "is-grace-restart-enabled" or name == "is-nsr-enabled" or name == "is-nsr-switchover-on-restart" or name == "is-opaque-capable" or name == "is-role-standby" or name == "is-router-id-stalled" or name == "last-nsf-time" or name == "lsa-flood-pacing-interval" or name == "lsa-group-interval" or name == "lsa-hold-time" or name == "lsa-maximum-time" or name == "lsa-retransmission-pacing-interval" or name == "lsa-start-time" or name == "maximum-interfaces" or name == "maximum-paths" or name == "metric" or name == "minimum-lsa-interval" or name == "normal-areas" or name == "nssa-areas" or name == "opaque-lsa-checksum" or name == "opaque-lsas" or name == "redistribution-limit" or name == "redistribution-threshold" or name == "reference-bandwidth" or name == "role" or name == "router-id" or name == "snmp-trap-enabled" or name == "spf-hold-time" or name == "spf-maximum-time" or name == "spf-start-time" or name == "stub-areas"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "areas"):
                                    self.areas = value
                                    self.areas.value_namespace = name_space
                                    self.areas.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-dc-bitless-ls-as"):
                                    self.as_dc_bitless_ls_as = value
                                    self.as_dc_bitless_ls_as.value_namespace = name_space
                                    self.as_dc_bitless_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-do-not-age-ls-as"):
                                    self.as_do_not_age_ls_as = value
                                    self.as_do_not_age_ls_as.value_namespace = name_space
                                    self.as_do_not_age_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-ls-as"):
                                    self.as_ls_as = value
                                    self.as_ls_as.value_namespace = name_space
                                    self.as_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-lsa-flood-list-length"):
                                    self.as_lsa_flood_list_length = value
                                    self.as_lsa_flood_list_length.value_namespace = name_space
                                    self.as_lsa_flood_list_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "context-name"):
                                    self.context_name = value
                                    self.context_name.value_namespace = name_space
                                    self.context_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "default-metric"):
                                    self.default_metric = value
                                    self.default_metric.value_namespace = name_space
                                    self.default_metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "default-metric-type"):
                                    self.default_metric_type = value
                                    self.default_metric_type.value_namespace = name_space
                                    self.default_metric_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "default-policy-name"):
                                    self.default_policy_name = value
                                    self.default_policy_name.value_namespace = name_space
                                    self.default_policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "default-tag"):
                                    self.default_tag = value
                                    self.default_tag.value_namespace = name_space
                                    self.default_tag.value_namespace_prefix = name_space_prefix
                                if(value_path == "grace-resync-time"):
                                    self.grace_resync_time = value
                                    self.grace_resync_time.value_namespace = name_space
                                    self.grace_resync_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "graceful-shutdown-state"):
                                    self.graceful_shutdown_state = value
                                    self.graceful_shutdown_state.value_namespace = name_space
                                    self.graceful_shutdown_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-area-border-router"):
                                    self.is_area_border_router = value
                                    self.is_area_border_router.value_namespace = name_space
                                    self.is_area_border_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-as-border-router"):
                                    self.is_as_border_router = value
                                    self.is_as_border_router.value_namespace = name_space
                                    self.is_as_border_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-auto-cost"):
                                    self.is_auto_cost = value
                                    self.is_auto_cost.value_namespace = name_space
                                    self.is_auto_cost.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-default-always"):
                                    self.is_default_always = value
                                    self.is_default_always.value_namespace = name_space
                                    self.is_default_always.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-default-originated"):
                                    self.is_default_originated = value
                                    self.is_default_originated.value_namespace = name_space
                                    self.is_default_originated.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-default-policy"):
                                    self.is_default_policy = value
                                    self.is_default_policy.value_namespace = name_space
                                    self.is_default_policy.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-grace-restart-enabled"):
                                    self.is_grace_restart_enabled = value
                                    self.is_grace_restart_enabled.value_namespace = name_space
                                    self.is_grace_restart_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-nsr-enabled"):
                                    self.is_nsr_enabled = value
                                    self.is_nsr_enabled.value_namespace = name_space
                                    self.is_nsr_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-nsr-switchover-on-restart"):
                                    self.is_nsr_switchover_on_restart = value
                                    self.is_nsr_switchover_on_restart.value_namespace = name_space
                                    self.is_nsr_switchover_on_restart.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-opaque-capable"):
                                    self.is_opaque_capable = value
                                    self.is_opaque_capable.value_namespace = name_space
                                    self.is_opaque_capable.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-role-standby"):
                                    self.is_role_standby = value
                                    self.is_role_standby.value_namespace = name_space
                                    self.is_role_standby.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-router-id-stalled"):
                                    self.is_router_id_stalled = value
                                    self.is_router_id_stalled.value_namespace = name_space
                                    self.is_router_id_stalled.value_namespace_prefix = name_space_prefix
                                if(value_path == "last-nsf-time"):
                                    self.last_nsf_time = value
                                    self.last_nsf_time.value_namespace = name_space
                                    self.last_nsf_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-flood-pacing-interval"):
                                    self.lsa_flood_pacing_interval = value
                                    self.lsa_flood_pacing_interval.value_namespace = name_space
                                    self.lsa_flood_pacing_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-group-interval"):
                                    self.lsa_group_interval = value
                                    self.lsa_group_interval.value_namespace = name_space
                                    self.lsa_group_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-hold-time"):
                                    self.lsa_hold_time = value
                                    self.lsa_hold_time.value_namespace = name_space
                                    self.lsa_hold_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-maximum-time"):
                                    self.lsa_maximum_time = value
                                    self.lsa_maximum_time.value_namespace = name_space
                                    self.lsa_maximum_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-retransmission-pacing-interval"):
                                    self.lsa_retransmission_pacing_interval = value
                                    self.lsa_retransmission_pacing_interval.value_namespace = name_space
                                    self.lsa_retransmission_pacing_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-start-time"):
                                    self.lsa_start_time = value
                                    self.lsa_start_time.value_namespace = name_space
                                    self.lsa_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-interfaces"):
                                    self.maximum_interfaces = value
                                    self.maximum_interfaces.value_namespace = name_space
                                    self.maximum_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-paths"):
                                    self.maximum_paths = value
                                    self.maximum_paths.value_namespace = name_space
                                    self.maximum_paths.value_namespace_prefix = name_space_prefix
                                if(value_path == "metric"):
                                    self.metric = value
                                    self.metric.value_namespace = name_space
                                    self.metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "minimum-lsa-interval"):
                                    self.minimum_lsa_interval = value
                                    self.minimum_lsa_interval.value_namespace = name_space
                                    self.minimum_lsa_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "normal-areas"):
                                    self.normal_areas = value
                                    self.normal_areas.value_namespace = name_space
                                    self.normal_areas.value_namespace_prefix = name_space_prefix
                                if(value_path == "nssa-areas"):
                                    self.nssa_areas = value
                                    self.nssa_areas.value_namespace = name_space
                                    self.nssa_areas.value_namespace_prefix = name_space_prefix
                                if(value_path == "opaque-lsa-checksum"):
                                    self.opaque_lsa_checksum = value
                                    self.opaque_lsa_checksum.value_namespace = name_space
                                    self.opaque_lsa_checksum.value_namespace_prefix = name_space_prefix
                                if(value_path == "opaque-lsas"):
                                    self.opaque_lsas = value
                                    self.opaque_lsas.value_namespace = name_space
                                    self.opaque_lsas.value_namespace_prefix = name_space_prefix
                                if(value_path == "redistribution-limit"):
                                    self.redistribution_limit = value
                                    self.redistribution_limit.value_namespace = name_space
                                    self.redistribution_limit.value_namespace_prefix = name_space_prefix
                                if(value_path == "redistribution-threshold"):
                                    self.redistribution_threshold = value
                                    self.redistribution_threshold.value_namespace = name_space
                                    self.redistribution_threshold.value_namespace_prefix = name_space_prefix
                                if(value_path == "reference-bandwidth"):
                                    self.reference_bandwidth = value
                                    self.reference_bandwidth.value_namespace = name_space
                                    self.reference_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "role"):
                                    self.role = value
                                    self.role.value_namespace = name_space
                                    self.role.value_namespace_prefix = name_space_prefix
                                if(value_path == "router-id"):
                                    self.router_id = value
                                    self.router_id.value_namespace = name_space
                                    self.router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "snmp-trap-enabled"):
                                    self.snmp_trap_enabled = value
                                    self.snmp_trap_enabled.value_namespace = name_space
                                    self.snmp_trap_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "spf-hold-time"):
                                    self.spf_hold_time = value
                                    self.spf_hold_time.value_namespace = name_space
                                    self.spf_hold_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "spf-maximum-time"):
                                    self.spf_maximum_time = value
                                    self.spf_maximum_time.value_namespace = name_space
                                    self.spf_maximum_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "spf-start-time"):
                                    self.spf_start_time = value
                                    self.spf_start_time.value_namespace = name_space
                                    self.spf_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "stub-areas"):
                                    self.stub_areas = value
                                    self.stub_areas.value_namespace = name_space
                                    self.stub_areas.value_namespace_prefix = name_space_prefix


                        class Route(Entity):
                            """
                            OSPFv3 route summary
                            
                            .. attribute:: extern_one_route
                            
                            	Extern 1 route summary 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extern_two_route
                            
                            	Extern 2 route summary 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: inter_area_route
                            
                            	Inter route summary 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: intra_area_route
                            
                            	Intra route summary 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nssa_one_route
                            
                            	NSSA 1 route summary 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nssa_two_route
                            
                            	NSSA 2 route summary 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: redistribution_route
                            
                            	Redistribution route summary 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: route_connected
                            
                            	Route connected 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: route_id
                            
                            	Route summary of a route ID 
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: total_received_route
                            
                            	Total route received summary
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_sent_route
                            
                            	Total route summary 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Route, self).__init__()

                                self.yang_name = "route"
                                self.yang_parent_name = "summary"

                                self.extern_one_route = YLeaf(YType.uint32, "extern-one-route")

                                self.extern_two_route = YLeaf(YType.uint32, "extern-two-route")

                                self.inter_area_route = YLeaf(YType.uint32, "inter-area-route")

                                self.intra_area_route = YLeaf(YType.uint32, "intra-area-route")

                                self.nssa_one_route = YLeaf(YType.uint32, "nssa-one-route")

                                self.nssa_two_route = YLeaf(YType.uint32, "nssa-two-route")

                                self.redistribution_route = YLeaf(YType.uint32, "redistribution-route")

                                self.route_connected = YLeaf(YType.uint32, "route-connected")

                                self.route_id = YLeaf(YType.str, "route-id")

                                self.total_received_route = YLeaf(YType.uint32, "total-received-route")

                                self.total_sent_route = YLeaf(YType.uint32, "total-sent-route")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("extern_one_route",
                                                "extern_two_route",
                                                "inter_area_route",
                                                "intra_area_route",
                                                "nssa_one_route",
                                                "nssa_two_route",
                                                "redistribution_route",
                                                "route_connected",
                                                "route_id",
                                                "total_received_route",
                                                "total_sent_route") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Route, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Route, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.extern_one_route.is_set or
                                    self.extern_two_route.is_set or
                                    self.inter_area_route.is_set or
                                    self.intra_area_route.is_set or
                                    self.nssa_one_route.is_set or
                                    self.nssa_two_route.is_set or
                                    self.redistribution_route.is_set or
                                    self.route_connected.is_set or
                                    self.route_id.is_set or
                                    self.total_received_route.is_set or
                                    self.total_sent_route.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.extern_one_route.yfilter != YFilter.not_set or
                                    self.extern_two_route.yfilter != YFilter.not_set or
                                    self.inter_area_route.yfilter != YFilter.not_set or
                                    self.intra_area_route.yfilter != YFilter.not_set or
                                    self.nssa_one_route.yfilter != YFilter.not_set or
                                    self.nssa_two_route.yfilter != YFilter.not_set or
                                    self.redistribution_route.yfilter != YFilter.not_set or
                                    self.route_connected.yfilter != YFilter.not_set or
                                    self.route_id.yfilter != YFilter.not_set or
                                    self.total_received_route.yfilter != YFilter.not_set or
                                    self.total_sent_route.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "route" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.extern_one_route.is_set or self.extern_one_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extern_one_route.get_name_leafdata())
                                if (self.extern_two_route.is_set or self.extern_two_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extern_two_route.get_name_leafdata())
                                if (self.inter_area_route.is_set or self.inter_area_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inter_area_route.get_name_leafdata())
                                if (self.intra_area_route.is_set or self.intra_area_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.intra_area_route.get_name_leafdata())
                                if (self.nssa_one_route.is_set or self.nssa_one_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nssa_one_route.get_name_leafdata())
                                if (self.nssa_two_route.is_set or self.nssa_two_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nssa_two_route.get_name_leafdata())
                                if (self.redistribution_route.is_set or self.redistribution_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.redistribution_route.get_name_leafdata())
                                if (self.route_connected.is_set or self.route_connected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_connected.get_name_leafdata())
                                if (self.route_id.is_set or self.route_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_id.get_name_leafdata())
                                if (self.total_received_route.is_set or self.total_received_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_received_route.get_name_leafdata())
                                if (self.total_sent_route.is_set or self.total_sent_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_sent_route.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "extern-one-route" or name == "extern-two-route" or name == "inter-area-route" or name == "intra-area-route" or name == "nssa-one-route" or name == "nssa-two-route" or name == "redistribution-route" or name == "route-connected" or name == "route-id" or name == "total-received-route" or name == "total-sent-route"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "extern-one-route"):
                                    self.extern_one_route = value
                                    self.extern_one_route.value_namespace = name_space
                                    self.extern_one_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "extern-two-route"):
                                    self.extern_two_route = value
                                    self.extern_two_route.value_namespace = name_space
                                    self.extern_two_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "inter-area-route"):
                                    self.inter_area_route = value
                                    self.inter_area_route.value_namespace = name_space
                                    self.inter_area_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "intra-area-route"):
                                    self.intra_area_route = value
                                    self.intra_area_route.value_namespace = name_space
                                    self.intra_area_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "nssa-one-route"):
                                    self.nssa_one_route = value
                                    self.nssa_one_route.value_namespace = name_space
                                    self.nssa_one_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "nssa-two-route"):
                                    self.nssa_two_route = value
                                    self.nssa_two_route.value_namespace = name_space
                                    self.nssa_two_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "redistribution-route"):
                                    self.redistribution_route = value
                                    self.redistribution_route.value_namespace = name_space
                                    self.redistribution_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-connected"):
                                    self.route_connected = value
                                    self.route_connected.value_namespace = name_space
                                    self.route_connected.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-id"):
                                    self.route_id = value
                                    self.route_id.value_namespace = name_space
                                    self.route_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-received-route"):
                                    self.total_received_route = value
                                    self.total_received_route.value_namespace = name_space
                                    self.total_received_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-sent-route"):
                                    self.total_sent_route = value
                                    self.total_sent_route.value_namespace = name_space
                                    self.total_sent_route.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.ospfv3 is not None and self.ospfv3.has_data()) or
                                (self.protocol is not None and self.protocol.has_data()) or
                                (self.route is not None and self.route.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ospfv3 is not None and self.ospfv3.has_operation()) or
                                (self.protocol is not None and self.protocol.has_operation()) or
                                (self.route is not None and self.route.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ospfv3"):
                                if (self.ospfv3 is None):
                                    self.ospfv3 = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Ospfv3()
                                    self.ospfv3.parent = self
                                    self._children_name_map["ospfv3"] = "ospfv3"
                                return self.ospfv3

                            if (child_yang_name == "protocol"):
                                if (self.protocol is None):
                                    self.protocol = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Protocol()
                                    self.protocol.parent = self
                                    self._children_name_map["protocol"] = "protocol"
                                return self.protocol

                            if (child_yang_name == "route"):
                                if (self.route is None):
                                    self.route = Ospfv3.Processes.Process.Vrfs.Vrf.Summary.Route()
                                    self.route.parent = self
                                    self._children_name_map["route"] = "route"
                                return self.route

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ospfv3" or name == "protocol" or name == "route"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class RetransmissionListProcessTable(Entity):
                        """
                        OSPFv3 retransmission list information table for
                        all areas
                        
                        .. attribute:: retransmission
                        
                        	OSPFv3 retransmission list information
                        	**type**\: list of    :py:class:`Retransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable, self).__init__()

                            self.yang_name = "retransmission-list-process-table"
                            self.yang_parent_name = "vrf"

                            self.retransmission = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable, self).__setattr__(name, value)


                        class Retransmission(Entity):
                            """
                            OSPFv3 retransmission list information
                            
                            .. attribute:: interface_name
                            
                            	Interface name
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: is_retransmission_sham_link
                            
                            	If true, sham link is retransmitted 
                            	**type**\:  bool
                            
                            .. attribute:: is_retransmissionvirtual_link
                            
                            	If true, virtual link is retransmitted 
                            	**type**\:  bool
                            
                            .. attribute:: neighbor_address
                            
                            	Neighbor address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: retransmission_area_db
                            
                            	List of area scope entries
                            	**type**\: list of    :py:class:`RetransmissionAreaDb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionAreaDb>`
                            
                            .. attribute:: retransmission_asdb
                            
                            	List of AS scope entries
                            	**type**\: list of    :py:class:`RetransmissionAsdb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionAsdb>`
                            
                            .. attribute:: retransmission_length
                            
                            	Retransmission queue length
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: retransmission_neighbor_address
                            
                            	Neighbor IP address
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: retransmission_sham_link_id
                            
                            	Retransmission sham link ID 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: retransmission_timer
                            
                            	Amount of time remaining on retransmission timer (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: retransmissionvirtual_link_db
                            
                            	List of virtual link scope entries 
                            	**type**\: list of    :py:class:`RetransmissionvirtualLinkDb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionvirtualLinkDb>`
                            
                            .. attribute:: retransmissionvirtual_link_id
                            
                            	Retransmission virtual link ID 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission, self).__init__()

                                self.yang_name = "retransmission"
                                self.yang_parent_name = "retransmission-list-process-table"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.is_retransmission_sham_link = YLeaf(YType.boolean, "is-retransmission-sham-link")

                                self.is_retransmissionvirtual_link = YLeaf(YType.boolean, "is-retransmissionvirtual-link")

                                self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                self.retransmission_length = YLeaf(YType.uint32, "retransmission-length")

                                self.retransmission_neighbor_address = YLeaf(YType.str, "retransmission-neighbor-address")

                                self.retransmission_sham_link_id = YLeaf(YType.uint32, "retransmission-sham-link-id")

                                self.retransmission_timer = YLeaf(YType.uint32, "retransmission-timer")

                                self.retransmissionvirtual_link_id = YLeaf(YType.uint32, "retransmissionvirtual-link-id")

                                self.retransmission_area_db = YList(self)
                                self.retransmission_asdb = YList(self)
                                self.retransmissionvirtual_link_db = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "is_retransmission_sham_link",
                                                "is_retransmissionvirtual_link",
                                                "neighbor_address",
                                                "retransmission_length",
                                                "retransmission_neighbor_address",
                                                "retransmission_sham_link_id",
                                                "retransmission_timer",
                                                "retransmissionvirtual_link_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission, self).__setattr__(name, value)


                            class RetransmissionvirtualLinkDb(Entity):
                                """
                                List of virtual link scope entries 
                                
                                .. attribute:: header_advertising_router
                                
                                	Router ID of the advertising router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_age
                                
                                	Age of the LSA (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                	**units**\: second
                                
                                .. attribute:: header_lsa_id
                                
                                	LSA ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_type
                                
                                	LSA type
                                	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                
                                .. attribute:: header_sequence_number
                                
                                	Current LSA sequence number
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionvirtualLinkDb, self).__init__()

                                    self.yang_name = "retransmissionvirtual-link-db"
                                    self.yang_parent_name = "retransmission"

                                    self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                    self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                    self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                    self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                    self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("header_advertising_router",
                                                    "header_lsa_age",
                                                    "header_lsa_id",
                                                    "header_lsa_type",
                                                    "header_sequence_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionvirtualLinkDb, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionvirtualLinkDb, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.header_advertising_router.is_set or
                                        self.header_lsa_age.is_set or
                                        self.header_lsa_id.is_set or
                                        self.header_lsa_type.is_set or
                                        self.header_sequence_number.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.header_advertising_router.yfilter != YFilter.not_set or
                                        self.header_lsa_age.yfilter != YFilter.not_set or
                                        self.header_lsa_id.yfilter != YFilter.not_set or
                                        self.header_lsa_type.yfilter != YFilter.not_set or
                                        self.header_sequence_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "retransmissionvirtual-link-db" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                    if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                    if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                    if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                    if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "header-advertising-router"):
                                        self.header_advertising_router = value
                                        self.header_advertising_router.value_namespace = name_space
                                        self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-age"):
                                        self.header_lsa_age = value
                                        self.header_lsa_age.value_namespace = name_space
                                        self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-id"):
                                        self.header_lsa_id = value
                                        self.header_lsa_id.value_namespace = name_space
                                        self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-type"):
                                        self.header_lsa_type = value
                                        self.header_lsa_type.value_namespace = name_space
                                        self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-sequence-number"):
                                        self.header_sequence_number = value
                                        self.header_sequence_number.value_namespace = name_space
                                        self.header_sequence_number.value_namespace_prefix = name_space_prefix


                            class RetransmissionAreaDb(Entity):
                                """
                                List of area scope entries
                                
                                .. attribute:: header_advertising_router
                                
                                	Router ID of the advertising router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_age
                                
                                	Age of the LSA (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                	**units**\: second
                                
                                .. attribute:: header_lsa_id
                                
                                	LSA ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_type
                                
                                	LSA type
                                	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                
                                .. attribute:: header_sequence_number
                                
                                	Current LSA sequence number
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionAreaDb, self).__init__()

                                    self.yang_name = "retransmission-area-db"
                                    self.yang_parent_name = "retransmission"

                                    self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                    self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                    self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                    self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                    self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("header_advertising_router",
                                                    "header_lsa_age",
                                                    "header_lsa_id",
                                                    "header_lsa_type",
                                                    "header_sequence_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionAreaDb, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionAreaDb, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.header_advertising_router.is_set or
                                        self.header_lsa_age.is_set or
                                        self.header_lsa_id.is_set or
                                        self.header_lsa_type.is_set or
                                        self.header_sequence_number.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.header_advertising_router.yfilter != YFilter.not_set or
                                        self.header_lsa_age.yfilter != YFilter.not_set or
                                        self.header_lsa_id.yfilter != YFilter.not_set or
                                        self.header_lsa_type.yfilter != YFilter.not_set or
                                        self.header_sequence_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "retransmission-area-db" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                    if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                    if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                    if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                    if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "header-advertising-router"):
                                        self.header_advertising_router = value
                                        self.header_advertising_router.value_namespace = name_space
                                        self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-age"):
                                        self.header_lsa_age = value
                                        self.header_lsa_age.value_namespace = name_space
                                        self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-id"):
                                        self.header_lsa_id = value
                                        self.header_lsa_id.value_namespace = name_space
                                        self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-type"):
                                        self.header_lsa_type = value
                                        self.header_lsa_type.value_namespace = name_space
                                        self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-sequence-number"):
                                        self.header_sequence_number = value
                                        self.header_sequence_number.value_namespace = name_space
                                        self.header_sequence_number.value_namespace_prefix = name_space_prefix


                            class RetransmissionAsdb(Entity):
                                """
                                List of AS scope entries
                                
                                .. attribute:: header_advertising_router
                                
                                	Router ID of the advertising router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_age
                                
                                	Age of the LSA (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                	**units**\: second
                                
                                .. attribute:: header_lsa_id
                                
                                	LSA ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: header_lsa_type
                                
                                	LSA type
                                	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                
                                .. attribute:: header_sequence_number
                                
                                	Current LSA sequence number
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionAsdb, self).__init__()

                                    self.yang_name = "retransmission-asdb"
                                    self.yang_parent_name = "retransmission"

                                    self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                    self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                    self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                    self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                    self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("header_advertising_router",
                                                    "header_lsa_age",
                                                    "header_lsa_id",
                                                    "header_lsa_type",
                                                    "header_sequence_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionAsdb, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionAsdb, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.header_advertising_router.is_set or
                                        self.header_lsa_age.is_set or
                                        self.header_lsa_id.is_set or
                                        self.header_lsa_type.is_set or
                                        self.header_sequence_number.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.header_advertising_router.yfilter != YFilter.not_set or
                                        self.header_lsa_age.yfilter != YFilter.not_set or
                                        self.header_lsa_id.yfilter != YFilter.not_set or
                                        self.header_lsa_type.yfilter != YFilter.not_set or
                                        self.header_sequence_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "retransmission-asdb" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                    if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                    if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                    if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                    if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "header-advertising-router"):
                                        self.header_advertising_router = value
                                        self.header_advertising_router.value_namespace = name_space
                                        self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-age"):
                                        self.header_lsa_age = value
                                        self.header_lsa_age.value_namespace = name_space
                                        self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-id"):
                                        self.header_lsa_id = value
                                        self.header_lsa_id.value_namespace = name_space
                                        self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-lsa-type"):
                                        self.header_lsa_type = value
                                        self.header_lsa_type.value_namespace = name_space
                                        self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "header-sequence-number"):
                                        self.header_sequence_number = value
                                        self.header_sequence_number.value_namespace = name_space
                                        self.header_sequence_number.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.retransmission_area_db:
                                    if (c.has_data()):
                                        return True
                                for c in self.retransmission_asdb:
                                    if (c.has_data()):
                                        return True
                                for c in self.retransmissionvirtual_link_db:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.interface_name.is_set or
                                    self.is_retransmission_sham_link.is_set or
                                    self.is_retransmissionvirtual_link.is_set or
                                    self.neighbor_address.is_set or
                                    self.retransmission_length.is_set or
                                    self.retransmission_neighbor_address.is_set or
                                    self.retransmission_sham_link_id.is_set or
                                    self.retransmission_timer.is_set or
                                    self.retransmissionvirtual_link_id.is_set)

                            def has_operation(self):
                                for c in self.retransmission_area_db:
                                    if (c.has_operation()):
                                        return True
                                for c in self.retransmission_asdb:
                                    if (c.has_operation()):
                                        return True
                                for c in self.retransmissionvirtual_link_db:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.is_retransmission_sham_link.yfilter != YFilter.not_set or
                                    self.is_retransmissionvirtual_link.yfilter != YFilter.not_set or
                                    self.neighbor_address.yfilter != YFilter.not_set or
                                    self.retransmission_length.yfilter != YFilter.not_set or
                                    self.retransmission_neighbor_address.yfilter != YFilter.not_set or
                                    self.retransmission_sham_link_id.yfilter != YFilter.not_set or
                                    self.retransmission_timer.yfilter != YFilter.not_set or
                                    self.retransmissionvirtual_link_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "retransmission" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.is_retransmission_sham_link.is_set or self.is_retransmission_sham_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_retransmission_sham_link.get_name_leafdata())
                                if (self.is_retransmissionvirtual_link.is_set or self.is_retransmissionvirtual_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_retransmissionvirtual_link.get_name_leafdata())
                                if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                if (self.retransmission_length.is_set or self.retransmission_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.retransmission_length.get_name_leafdata())
                                if (self.retransmission_neighbor_address.is_set or self.retransmission_neighbor_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.retransmission_neighbor_address.get_name_leafdata())
                                if (self.retransmission_sham_link_id.is_set or self.retransmission_sham_link_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.retransmission_sham_link_id.get_name_leafdata())
                                if (self.retransmission_timer.is_set or self.retransmission_timer.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.retransmission_timer.get_name_leafdata())
                                if (self.retransmissionvirtual_link_id.is_set or self.retransmissionvirtual_link_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.retransmissionvirtual_link_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "retransmission-area-db"):
                                    for c in self.retransmission_area_db:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionAreaDb()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.retransmission_area_db.append(c)
                                    return c

                                if (child_yang_name == "retransmission-asdb"):
                                    for c in self.retransmission_asdb:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionAsdb()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.retransmission_asdb.append(c)
                                    return c

                                if (child_yang_name == "retransmissionvirtual-link-db"):
                                    for c in self.retransmissionvirtual_link_db:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission.RetransmissionvirtualLinkDb()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.retransmissionvirtual_link_db.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "retransmission-area-db" or name == "retransmission-asdb" or name == "retransmissionvirtual-link-db" or name == "interface-name" or name == "is-retransmission-sham-link" or name == "is-retransmissionvirtual-link" or name == "neighbor-address" or name == "retransmission-length" or name == "retransmission-neighbor-address" or name == "retransmission-sham-link-id" or name == "retransmission-timer" or name == "retransmissionvirtual-link-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-retransmission-sham-link"):
                                    self.is_retransmission_sham_link = value
                                    self.is_retransmission_sham_link.value_namespace = name_space
                                    self.is_retransmission_sham_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-retransmissionvirtual-link"):
                                    self.is_retransmissionvirtual_link = value
                                    self.is_retransmissionvirtual_link.value_namespace = name_space
                                    self.is_retransmissionvirtual_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-address"):
                                    self.neighbor_address = value
                                    self.neighbor_address.value_namespace = name_space
                                    self.neighbor_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "retransmission-length"):
                                    self.retransmission_length = value
                                    self.retransmission_length.value_namespace = name_space
                                    self.retransmission_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "retransmission-neighbor-address"):
                                    self.retransmission_neighbor_address = value
                                    self.retransmission_neighbor_address.value_namespace = name_space
                                    self.retransmission_neighbor_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "retransmission-sham-link-id"):
                                    self.retransmission_sham_link_id = value
                                    self.retransmission_sham_link_id.value_namespace = name_space
                                    self.retransmission_sham_link_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "retransmission-timer"):
                                    self.retransmission_timer = value
                                    self.retransmission_timer.value_namespace = name_space
                                    self.retransmission_timer.value_namespace_prefix = name_space_prefix
                                if(value_path == "retransmissionvirtual-link-id"):
                                    self.retransmissionvirtual_link_id = value
                                    self.retransmissionvirtual_link_id.value_namespace = name_space
                                    self.retransmissionvirtual_link_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.retransmission:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.retransmission:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "retransmission-list-process-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "retransmission"):
                                for c in self.retransmission:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable.Retransmission()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.retransmission.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "retransmission"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class BadChecksums(Entity):
                        """
                        Bad Checksum Packets information table
                        
                        .. attribute:: bad_checksum
                        
                        	Bad Checksum Packet information
                        	**type**\: list of    :py:class:`BadChecksum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums, self).__init__()

                            self.yang_name = "bad-checksums"
                            self.yang_parent_name = "vrf"

                            self.bad_checksum = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums, self).__setattr__(name, value)


                        class BadChecksum(Entity):
                            """
                            Bad Checksum Packet information
                            
                            .. attribute:: packet_number  <key>
                            
                            	Bad Checksum Packets number
                            	**type**\:  int
                            
                            	**range:** 0..9
                            
                            .. attribute:: computed_checksum
                            
                            	Computed Checksum
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: received_checksum
                            
                            	Received Checksum
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: received_data
                            
                            	Received Hexadecimal Data
                            	**type**\:  str
                            
                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                            
                            .. attribute:: timestamp
                            
                            	Packet Timestamp (relative to 1970/1/1 00\:00)
                            	**type**\:   :py:class:`Timestamp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum.Timestamp>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum, self).__init__()

                                self.yang_name = "bad-checksum"
                                self.yang_parent_name = "bad-checksums"

                                self.packet_number = YLeaf(YType.uint32, "packet-number")

                                self.computed_checksum = YLeaf(YType.uint16, "computed-checksum")

                                self.received_checksum = YLeaf(YType.uint16, "received-checksum")

                                self.received_data = YLeaf(YType.str, "received-data")

                                self.timestamp = Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum.Timestamp()
                                self.timestamp.parent = self
                                self._children_name_map["timestamp"] = "timestamp"
                                self._children_yang_names.add("timestamp")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("packet_number",
                                                "computed_checksum",
                                                "received_checksum",
                                                "received_data") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum, self).__setattr__(name, value)


                            class Timestamp(Entity):
                                """
                                Packet Timestamp (relative to 1970/1/1 00\:00)
                                
                                .. attribute:: nanosecond
                                
                                	Nano seconds 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: nanosecond
                                
                                .. attribute:: second
                                
                                	Seconds 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum.Timestamp, self).__init__()

                                    self.yang_name = "timestamp"
                                    self.yang_parent_name = "bad-checksum"

                                    self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                    self.second = YLeaf(YType.uint32, "second")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nanosecond",
                                                    "second") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum.Timestamp, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum.Timestamp, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.nanosecond.is_set or
                                        self.second.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nanosecond.yfilter != YFilter.not_set or
                                        self.second.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "timestamp" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                    if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.second.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nanosecond" or name == "second"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nanosecond"):
                                        self.nanosecond = value
                                        self.nanosecond.value_namespace = name_space
                                        self.nanosecond.value_namespace_prefix = name_space_prefix
                                    if(value_path == "second"):
                                        self.second = value
                                        self.second.value_namespace = name_space
                                        self.second.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.packet_number.is_set or
                                    self.computed_checksum.is_set or
                                    self.received_checksum.is_set or
                                    self.received_data.is_set or
                                    (self.timestamp is not None and self.timestamp.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.packet_number.yfilter != YFilter.not_set or
                                    self.computed_checksum.yfilter != YFilter.not_set or
                                    self.received_checksum.yfilter != YFilter.not_set or
                                    self.received_data.yfilter != YFilter.not_set or
                                    (self.timestamp is not None and self.timestamp.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bad-checksum" + "[packet-number='" + self.packet_number.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.packet_number.is_set or self.packet_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.packet_number.get_name_leafdata())
                                if (self.computed_checksum.is_set or self.computed_checksum.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.computed_checksum.get_name_leafdata())
                                if (self.received_checksum.is_set or self.received_checksum.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.received_checksum.get_name_leafdata())
                                if (self.received_data.is_set or self.received_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.received_data.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "timestamp"):
                                    if (self.timestamp is None):
                                        self.timestamp = Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum.Timestamp()
                                        self.timestamp.parent = self
                                        self._children_name_map["timestamp"] = "timestamp"
                                    return self.timestamp

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "timestamp" or name == "packet-number" or name == "computed-checksum" or name == "received-checksum" or name == "received-data"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "packet-number"):
                                    self.packet_number = value
                                    self.packet_number.value_namespace = name_space
                                    self.packet_number.value_namespace_prefix = name_space_prefix
                                if(value_path == "computed-checksum"):
                                    self.computed_checksum = value
                                    self.computed_checksum.value_namespace = name_space
                                    self.computed_checksum.value_namespace_prefix = name_space_prefix
                                if(value_path == "received-checksum"):
                                    self.received_checksum = value
                                    self.received_checksum.value_namespace = name_space
                                    self.received_checksum.value_namespace_prefix = name_space_prefix
                                if(value_path == "received-data"):
                                    self.received_data = value
                                    self.received_data.value_namespace = name_space
                                    self.received_data.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.bad_checksum:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.bad_checksum:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bad-checksums" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bad-checksum"):
                                for c in self.bad_checksum:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums.BadChecksum()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.bad_checksum.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bad-checksum"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class DatabaseSummaryTable(Entity):
                        """
                        Database summary table
                        
                        .. attribute:: database_summary
                        
                        	Database Summary information
                        	**type**\:   :py:class:`DatabaseSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable, self).__init__()

                            self.yang_name = "database-summary-table"
                            self.yang_parent_name = "vrf"

                            self.database_summary = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary()
                            self.database_summary.parent = self
                            self._children_name_map["database_summary"] = "database-summary"
                            self._children_yang_names.add("database-summary")


                        class DatabaseSummary(Entity):
                            """
                            Database Summary information
                            
                            .. attribute:: area_database
                            
                            	OSPFv3 Area Database list 
                            	**type**\: list of    :py:class:`AreaDatabase <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase>`
                            
                            .. attribute:: database_counters
                            
                            	OSPFv3 database counters 
                            	**type**\:   :py:class:`DatabaseCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters>`
                            
                            .. attribute:: database_router_id
                            
                            	Database router ID 
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_opaque_database_capable
                            
                            	If true, opaque database is capable 
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary, self).__init__()

                                self.yang_name = "database-summary"
                                self.yang_parent_name = "database-summary-table"

                                self.database_router_id = YLeaf(YType.str, "database-router-id")

                                self.is_opaque_database_capable = YLeaf(YType.boolean, "is-opaque-database-capable")

                                self.database_counters = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters()
                                self.database_counters.parent = self
                                self._children_name_map["database_counters"] = "database-counters"
                                self._children_yang_names.add("database-counters")

                                self.area_database = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("database_router_id",
                                                "is_opaque_database_capable") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary, self).__setattr__(name, value)


                            class DatabaseCounters(Entity):
                                """
                                OSPFv3 database counters 
                                
                                .. attribute:: deleted_lsa
                                
                                	deleted lsa
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsa
                                
                                	lsa
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsa_checksum
                                
                                	lsa checksum
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: max_age_lsa
                                
                                	max age lsa
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__init__()

                                    self.yang_name = "database-counters"
                                    self.yang_parent_name = "database-summary"

                                    self.deleted_lsa = YLeafList(YType.uint32, "deleted-lsa")

                                    self.lsa = YLeafList(YType.uint32, "lsa")

                                    self.lsa_checksum = YLeafList(YType.uint32, "lsa-checksum")

                                    self.max_age_lsa = YLeafList(YType.uint32, "max-age-lsa")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deleted_lsa",
                                                    "lsa",
                                                    "lsa_checksum",
                                                    "max_age_lsa") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__setattr__(name, value)

                                def has_data(self):
                                    for leaf in self.deleted_lsa.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    for leaf in self.lsa.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    for leaf in self.lsa_checksum.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    for leaf in self.max_age_lsa.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    return False

                                def has_operation(self):
                                    for leaf in self.deleted_lsa.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    for leaf in self.lsa.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    for leaf in self.lsa_checksum.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    for leaf in self.max_age_lsa.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deleted_lsa.yfilter != YFilter.not_set or
                                        self.lsa.yfilter != YFilter.not_set or
                                        self.lsa_checksum.yfilter != YFilter.not_set or
                                        self.max_age_lsa.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "database-counters" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    leaf_name_data.extend(self.deleted_lsa.get_name_leafdata())

                                    leaf_name_data.extend(self.lsa.get_name_leafdata())

                                    leaf_name_data.extend(self.lsa_checksum.get_name_leafdata())

                                    leaf_name_data.extend(self.max_age_lsa.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deleted-lsa" or name == "lsa" or name == "lsa-checksum" or name == "max-age-lsa"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deleted-lsa"):
                                        self.deleted_lsa.append(value)
                                    if(value_path == "lsa"):
                                        self.lsa.append(value)
                                    if(value_path == "lsa-checksum"):
                                        self.lsa_checksum.append(value)
                                    if(value_path == "max-age-lsa"):
                                        self.max_age_lsa.append(value)


                            class AreaDatabase(Entity):
                                """
                                OSPFv3 Area Database list 
                                
                                .. attribute:: area_database_summary
                                
                                	Area database summary 
                                	**type**\:   :py:class:`AreaDatabaseSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary>`
                                
                                .. attribute:: lsa_area_id
                                
                                	Area ID in decimal or dotted\-decimal format
                                	**type**\:  str
                                
                                	**length:** 0..16
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__init__()

                                    self.yang_name = "area-database"
                                    self.yang_parent_name = "database-summary"

                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                    self.area_database_summary = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary()
                                    self.area_database_summary.parent = self
                                    self._children_name_map["area_database_summary"] = "area-database-summary"
                                    self._children_yang_names.add("area-database-summary")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("lsa_area_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__setattr__(name, value)


                                class AreaDatabaseSummary(Entity):
                                    """
                                    Area database summary 
                                    
                                    .. attribute:: deleted_lsa
                                    
                                    	deleted lsa
                                    	**type**\:  list of int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lsa
                                    
                                    	lsa
                                    	**type**\:  list of int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lsa_checksum
                                    
                                    	lsa checksum
                                    	**type**\:  list of int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: max_age_lsa
                                    
                                    	max age lsa
                                    	**type**\:  list of int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__init__()

                                        self.yang_name = "area-database-summary"
                                        self.yang_parent_name = "area-database"

                                        self.deleted_lsa = YLeafList(YType.uint32, "deleted-lsa")

                                        self.lsa = YLeafList(YType.uint32, "lsa")

                                        self.lsa_checksum = YLeafList(YType.uint32, "lsa-checksum")

                                        self.max_age_lsa = YLeafList(YType.uint32, "max-age-lsa")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("deleted_lsa",
                                                        "lsa",
                                                        "lsa_checksum",
                                                        "max_age_lsa") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__setattr__(name, value)

                                    def has_data(self):
                                        for leaf in self.deleted_lsa.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        for leaf in self.lsa.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        for leaf in self.lsa_checksum.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        for leaf in self.max_age_lsa.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for leaf in self.deleted_lsa.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        for leaf in self.lsa.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        for leaf in self.lsa_checksum.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        for leaf in self.max_age_lsa.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.deleted_lsa.yfilter != YFilter.not_set or
                                            self.lsa.yfilter != YFilter.not_set or
                                            self.lsa_checksum.yfilter != YFilter.not_set or
                                            self.max_age_lsa.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "area-database-summary" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        leaf_name_data.extend(self.deleted_lsa.get_name_leafdata())

                                        leaf_name_data.extend(self.lsa.get_name_leafdata())

                                        leaf_name_data.extend(self.lsa_checksum.get_name_leafdata())

                                        leaf_name_data.extend(self.max_age_lsa.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "deleted-lsa" or name == "lsa" or name == "lsa-checksum" or name == "max-age-lsa"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "deleted-lsa"):
                                            self.deleted_lsa.append(value)
                                        if(value_path == "lsa"):
                                            self.lsa.append(value)
                                        if(value_path == "lsa-checksum"):
                                            self.lsa_checksum.append(value)
                                        if(value_path == "max-age-lsa"):
                                            self.max_age_lsa.append(value)

                                def has_data(self):
                                    return (
                                        self.lsa_area_id.is_set or
                                        (self.area_database_summary is not None and self.area_database_summary.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                        (self.area_database_summary is not None and self.area_database_summary.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "area-database" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "area-database-summary"):
                                        if (self.area_database_summary is None):
                                            self.area_database_summary = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary()
                                            self.area_database_summary.parent = self
                                            self._children_name_map["area_database_summary"] = "area-database-summary"
                                        return self.area_database_summary

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "area-database-summary" or name == "lsa-area-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "lsa-area-id"):
                                        self.lsa_area_id = value
                                        self.lsa_area_id.value_namespace = name_space
                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.area_database:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.database_router_id.is_set or
                                    self.is_opaque_database_capable.is_set or
                                    (self.database_counters is not None and self.database_counters.has_data()))

                            def has_operation(self):
                                for c in self.area_database:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.database_router_id.yfilter != YFilter.not_set or
                                    self.is_opaque_database_capable.yfilter != YFilter.not_set or
                                    (self.database_counters is not None and self.database_counters.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "database-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.database_router_id.is_set or self.database_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.database_router_id.get_name_leafdata())
                                if (self.is_opaque_database_capable.is_set or self.is_opaque_database_capable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_opaque_database_capable.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "area-database"):
                                    for c in self.area_database:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.area_database.append(c)
                                    return c

                                if (child_yang_name == "database-counters"):
                                    if (self.database_counters is None):
                                        self.database_counters = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters()
                                        self.database_counters.parent = self
                                        self._children_name_map["database_counters"] = "database-counters"
                                    return self.database_counters

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "area-database" or name == "database-counters" or name == "database-router-id" or name == "is-opaque-database-capable"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "database-router-id"):
                                    self.database_router_id = value
                                    self.database_router_id.value_namespace = name_space
                                    self.database_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-opaque-database-capable"):
                                    self.is_opaque_database_capable = value
                                    self.is_opaque_database_capable.value_namespace = name_space
                                    self.is_opaque_database_capable.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.database_summary is not None and self.database_summary.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.database_summary is not None and self.database_summary.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "database-summary-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "database-summary"):
                                if (self.database_summary is None):
                                    self.database_summary = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable.DatabaseSummary()
                                    self.database_summary.parent = self
                                    self._children_name_map["database_summary"] = "database-summary"
                                return self.database_summary

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "database-summary"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class NeighborProcessTable(Entity):
                        """
                        OSPFv3 neighbor information table for all areas
                        
                        .. attribute:: neighbor
                        
                        	OSPFv3 neighbor detail information
                        	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable, self).__init__()

                            self.yang_name = "neighbor-process-table"
                            self.yang_parent_name = "vrf"

                            self.neighbor = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable, self).__setattr__(name, value)


                        class Neighbor(Entity):
                            """
                            OSPFv3 neighbor detail information
                            
                            .. attribute:: interface_name
                            
                            	Interface name
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: is_neighbor_sham_link
                            
                            	If true, neighbor is on a sham link 
                            	**type**\:  bool
                            
                            .. attribute:: is_neighbor_virtual_link
                            
                            	If true, neighbor is on a virtual link 
                            	**type**\:  bool
                            
                            .. attribute:: neighbor_address
                            
                            	Neighbor ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: neighbor_address_xr
                            
                            	Neighbor IP Address
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: neighbor_bfd_info
                            
                            	Neighbor BFD information
                            	**type**\:   :py:class:`NeighborBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborBfdInfo>`
                            
                            .. attribute:: neighbor_dead_timer
                            
                            	Time until neighbor's dead timer expires (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: neighbor_designated_router
                            
                            	Designated router 
                            	**type**\:  str
                            
                            	**length:** 0..9
                            
                            .. attribute:: neighbor_detail
                            
                            	Detailed OSPFv3 neighbor information 
                            	**type**\:   :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail>`
                            
                            .. attribute:: neighbor_dr_priority
                            
                            	Neighbor's DR priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: neighbor_interface_id
                            
                            	Neighbor interface ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_sham_link_id
                            
                            	Neighbor sham link id 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_state
                            
                            	Neighbor's state
                            	**type**\:   :py:class:`Ospfv3NeighborState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3NeighborState>`
                            
                            .. attribute:: neighbor_up_time
                            
                            	Amount of time since the adjacency is up (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: neighbor_virtual_link_id
                            
                            	Neighbor virtual link id 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor, self).__init__()

                                self.yang_name = "neighbor"
                                self.yang_parent_name = "neighbor-process-table"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.is_neighbor_sham_link = YLeaf(YType.boolean, "is-neighbor-sham-link")

                                self.is_neighbor_virtual_link = YLeaf(YType.boolean, "is-neighbor-virtual-link")

                                self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                self.neighbor_address_xr = YLeaf(YType.str, "neighbor-address-xr")

                                self.neighbor_dead_timer = YLeaf(YType.uint32, "neighbor-dead-timer")

                                self.neighbor_designated_router = YLeaf(YType.str, "neighbor-designated-router")

                                self.neighbor_dr_priority = YLeaf(YType.uint8, "neighbor-dr-priority")

                                self.neighbor_interface_id = YLeaf(YType.uint32, "neighbor-interface-id")

                                self.neighbor_sham_link_id = YLeaf(YType.uint32, "neighbor-sham-link-id")

                                self.neighbor_state = YLeaf(YType.enumeration, "neighbor-state")

                                self.neighbor_up_time = YLeaf(YType.uint32, "neighbor-up-time")

                                self.neighbor_virtual_link_id = YLeaf(YType.uint32, "neighbor-virtual-link-id")

                                self.neighbor_bfd_info = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborBfdInfo()
                                self.neighbor_bfd_info.parent = self
                                self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                self._children_yang_names.add("neighbor-bfd-info")

                                self.neighbor_detail = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail()
                                self.neighbor_detail.parent = self
                                self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                self._children_yang_names.add("neighbor-detail")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "is_neighbor_sham_link",
                                                "is_neighbor_virtual_link",
                                                "neighbor_address",
                                                "neighbor_address_xr",
                                                "neighbor_dead_timer",
                                                "neighbor_designated_router",
                                                "neighbor_dr_priority",
                                                "neighbor_interface_id",
                                                "neighbor_sham_link_id",
                                                "neighbor_state",
                                                "neighbor_up_time",
                                                "neighbor_virtual_link_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor, self).__setattr__(name, value)


                            class NeighborDetail(Entity):
                                """
                                Detailed OSPFv3 neighbor information 
                                
                                .. attribute:: interface_type
                                
                                	Interface type
                                	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                                
                                .. attribute:: is_neighbor_filtered
                                
                                	If true, filter outgoing LSAs 
                                	**type**\:  bool
                                
                                .. attribute:: neighbor_backup_designated_router_address
                                
                                	Address of backup designated router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: neighbor_cost
                                
                                	Cost of path to this neighbor 
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: neighbor_designated_router_address
                                
                                	Address of designated router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: neighbor_ignore_timer
                                
                                	Remaining time when ignore timer is running 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_option
                                
                                	 This is bitmask of neighbor's option field received 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_retransmission
                                
                                	Retransmission information with this neighbor
                                	**type**\:   :py:class:`NeighborRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission>`
                                
                                .. attribute:: next_poll_interval
                                
                                	For NBMA networks, amount of time remaining in seconds before the next poll interval expires and Hello is sent (s)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: pending_events
                                
                                	Number of pending events 
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: poll_interval
                                
                                	Poll interval (s)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: state_changes
                                
                                	Number of state changes 
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail, self).__init__()

                                    self.yang_name = "neighbor-detail"
                                    self.yang_parent_name = "neighbor"

                                    self.interface_type = YLeaf(YType.enumeration, "interface-type")

                                    self.is_neighbor_filtered = YLeaf(YType.boolean, "is-neighbor-filtered")

                                    self.neighbor_backup_designated_router_address = YLeaf(YType.str, "neighbor-backup-designated-router-address")

                                    self.neighbor_cost = YLeaf(YType.uint16, "neighbor-cost")

                                    self.neighbor_designated_router_address = YLeaf(YType.str, "neighbor-designated-router-address")

                                    self.neighbor_ignore_timer = YLeaf(YType.uint32, "neighbor-ignore-timer")

                                    self.neighbor_option = YLeaf(YType.uint32, "neighbor-option")

                                    self.next_poll_interval = YLeaf(YType.uint32, "next-poll-interval")

                                    self.pending_events = YLeaf(YType.uint16, "pending-events")

                                    self.poll_interval = YLeaf(YType.uint32, "poll-interval")

                                    self.state_changes = YLeaf(YType.uint16, "state-changes")

                                    self.neighbor_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission()
                                    self.neighbor_retransmission.parent = self
                                    self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                    self._children_yang_names.add("neighbor-retransmission")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_type",
                                                    "is_neighbor_filtered",
                                                    "neighbor_backup_designated_router_address",
                                                    "neighbor_cost",
                                                    "neighbor_designated_router_address",
                                                    "neighbor_ignore_timer",
                                                    "neighbor_option",
                                                    "next_poll_interval",
                                                    "pending_events",
                                                    "poll_interval",
                                                    "state_changes") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail, self).__setattr__(name, value)


                                class NeighborRetransmission(Entity):
                                    """
                                    Retransmission information with this neighbor
                                    
                                    .. attribute:: area_first_flood
                                    
                                    	First flood item for area scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: area_first_flood_index
                                    
                                    	Index of the first flood item for area scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: area_flood_index
                                    
                                    	Area scope LSA's flood index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: area_next_flood
                                    
                                    	Next flood item for area scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: area_next_flood_index
                                    
                                    	Index of next flood item for Area scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: as_first_flood
                                    
                                    	First flood item for AS scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: as_first_flood_index
                                    
                                    	Index for first flood item for AS scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: as_flood_index
                                    
                                    	AS scope LSA's flood index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: as_next_flood
                                    
                                    	Next flood item for AS scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: as_next_flood_index
                                    
                                    	Index of next flood item for AS scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: database_descriptor_retransmissions
                                    
                                    	Number of database descriptor retransmissions during last exchange
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_retransmission_length
                                    
                                    	Number of LSAs sent in last retransmission
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_retransmission_time
                                    
                                    	Last retransmission scan time (ms)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: link_first_flood
                                    
                                    	Link first flood information 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: link_first_flood_index
                                    
                                    	Link first flood information index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: link_flood_index
                                    
                                    	Link flood index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: link_next_flood
                                    
                                    	Link next flood information 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: link_next_flood_index
                                    
                                    	Link next flood information index 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lsa_retransmission_timer
                                    
                                    	Time until next LSA retransmission (ms)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: maximum_retransmission_length
                                    
                                    	Maximum number of LSAs sent in a retransmission
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: maximum_retransmission_time
                                    
                                    	Maximum retransmission scan time (ms)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_retransmissions
                                    
                                    	Number of neighbor retransmissions 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: retransmissions
                                    
                                    	Number of retransmissions for this neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__init__()

                                        self.yang_name = "neighbor-retransmission"
                                        self.yang_parent_name = "neighbor-detail"

                                        self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                        self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                        self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                        self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                        self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                        self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                        self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                        self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                        self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                        self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                        self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                        self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                        self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                        self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                        self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                        self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                        self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                        self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                        self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                        self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                        self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                        self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                        self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("area_first_flood",
                                                        "area_first_flood_index",
                                                        "area_flood_index",
                                                        "area_next_flood",
                                                        "area_next_flood_index",
                                                        "as_first_flood",
                                                        "as_first_flood_index",
                                                        "as_flood_index",
                                                        "as_next_flood",
                                                        "as_next_flood_index",
                                                        "database_descriptor_retransmissions",
                                                        "last_retransmission_length",
                                                        "last_retransmission_time",
                                                        "link_first_flood",
                                                        "link_first_flood_index",
                                                        "link_flood_index",
                                                        "link_next_flood",
                                                        "link_next_flood_index",
                                                        "lsa_retransmission_timer",
                                                        "maximum_retransmission_length",
                                                        "maximum_retransmission_time",
                                                        "neighbor_retransmissions",
                                                        "retransmissions") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.area_first_flood.is_set or
                                            self.area_first_flood_index.is_set or
                                            self.area_flood_index.is_set or
                                            self.area_next_flood.is_set or
                                            self.area_next_flood_index.is_set or
                                            self.as_first_flood.is_set or
                                            self.as_first_flood_index.is_set or
                                            self.as_flood_index.is_set or
                                            self.as_next_flood.is_set or
                                            self.as_next_flood_index.is_set or
                                            self.database_descriptor_retransmissions.is_set or
                                            self.last_retransmission_length.is_set or
                                            self.last_retransmission_time.is_set or
                                            self.link_first_flood.is_set or
                                            self.link_first_flood_index.is_set or
                                            self.link_flood_index.is_set or
                                            self.link_next_flood.is_set or
                                            self.link_next_flood_index.is_set or
                                            self.lsa_retransmission_timer.is_set or
                                            self.maximum_retransmission_length.is_set or
                                            self.maximum_retransmission_time.is_set or
                                            self.neighbor_retransmissions.is_set or
                                            self.retransmissions.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.area_first_flood.yfilter != YFilter.not_set or
                                            self.area_first_flood_index.yfilter != YFilter.not_set or
                                            self.area_flood_index.yfilter != YFilter.not_set or
                                            self.area_next_flood.yfilter != YFilter.not_set or
                                            self.area_next_flood_index.yfilter != YFilter.not_set or
                                            self.as_first_flood.yfilter != YFilter.not_set or
                                            self.as_first_flood_index.yfilter != YFilter.not_set or
                                            self.as_flood_index.yfilter != YFilter.not_set or
                                            self.as_next_flood.yfilter != YFilter.not_set or
                                            self.as_next_flood_index.yfilter != YFilter.not_set or
                                            self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                            self.last_retransmission_length.yfilter != YFilter.not_set or
                                            self.last_retransmission_time.yfilter != YFilter.not_set or
                                            self.link_first_flood.yfilter != YFilter.not_set or
                                            self.link_first_flood_index.yfilter != YFilter.not_set or
                                            self.link_flood_index.yfilter != YFilter.not_set or
                                            self.link_next_flood.yfilter != YFilter.not_set or
                                            self.link_next_flood_index.yfilter != YFilter.not_set or
                                            self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                            self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                            self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                            self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                            self.retransmissions.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "neighbor-retransmission" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                        if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                        if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                        if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                        if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                        if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                        if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                        if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                        if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                        if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                        if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                        if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                        if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                        if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                        if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                        if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                        if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                        if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                        if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                        if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                        if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                        if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                        if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "area-first-flood"):
                                            self.area_first_flood = value
                                            self.area_first_flood.value_namespace = name_space
                                            self.area_first_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "area-first-flood-index"):
                                            self.area_first_flood_index = value
                                            self.area_first_flood_index.value_namespace = name_space
                                            self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "area-flood-index"):
                                            self.area_flood_index = value
                                            self.area_flood_index.value_namespace = name_space
                                            self.area_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "area-next-flood"):
                                            self.area_next_flood = value
                                            self.area_next_flood.value_namespace = name_space
                                            self.area_next_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "area-next-flood-index"):
                                            self.area_next_flood_index = value
                                            self.area_next_flood_index.value_namespace = name_space
                                            self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "as-first-flood"):
                                            self.as_first_flood = value
                                            self.as_first_flood.value_namespace = name_space
                                            self.as_first_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "as-first-flood-index"):
                                            self.as_first_flood_index = value
                                            self.as_first_flood_index.value_namespace = name_space
                                            self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "as-flood-index"):
                                            self.as_flood_index = value
                                            self.as_flood_index.value_namespace = name_space
                                            self.as_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "as-next-flood"):
                                            self.as_next_flood = value
                                            self.as_next_flood.value_namespace = name_space
                                            self.as_next_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "as-next-flood-index"):
                                            self.as_next_flood_index = value
                                            self.as_next_flood_index.value_namespace = name_space
                                            self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "database-descriptor-retransmissions"):
                                            self.database_descriptor_retransmissions = value
                                            self.database_descriptor_retransmissions.value_namespace = name_space
                                            self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-retransmission-length"):
                                            self.last_retransmission_length = value
                                            self.last_retransmission_length.value_namespace = name_space
                                            self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-retransmission-time"):
                                            self.last_retransmission_time = value
                                            self.last_retransmission_time.value_namespace = name_space
                                            self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "link-first-flood"):
                                            self.link_first_flood = value
                                            self.link_first_flood.value_namespace = name_space
                                            self.link_first_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "link-first-flood-index"):
                                            self.link_first_flood_index = value
                                            self.link_first_flood_index.value_namespace = name_space
                                            self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "link-flood-index"):
                                            self.link_flood_index = value
                                            self.link_flood_index.value_namespace = name_space
                                            self.link_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "link-next-flood"):
                                            self.link_next_flood = value
                                            self.link_next_flood.value_namespace = name_space
                                            self.link_next_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "link-next-flood-index"):
                                            self.link_next_flood_index = value
                                            self.link_next_flood_index.value_namespace = name_space
                                            self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsa-retransmission-timer"):
                                            self.lsa_retransmission_timer = value
                                            self.lsa_retransmission_timer.value_namespace = name_space
                                            self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                        if(value_path == "maximum-retransmission-length"):
                                            self.maximum_retransmission_length = value
                                            self.maximum_retransmission_length.value_namespace = name_space
                                            self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "maximum-retransmission-time"):
                                            self.maximum_retransmission_time = value
                                            self.maximum_retransmission_time.value_namespace = name_space
                                            self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-retransmissions"):
                                            self.neighbor_retransmissions = value
                                            self.neighbor_retransmissions.value_namespace = name_space
                                            self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                        if(value_path == "retransmissions"):
                                            self.retransmissions = value
                                            self.retransmissions.value_namespace = name_space
                                            self.retransmissions.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_type.is_set or
                                        self.is_neighbor_filtered.is_set or
                                        self.neighbor_backup_designated_router_address.is_set or
                                        self.neighbor_cost.is_set or
                                        self.neighbor_designated_router_address.is_set or
                                        self.neighbor_ignore_timer.is_set or
                                        self.neighbor_option.is_set or
                                        self.next_poll_interval.is_set or
                                        self.pending_events.is_set or
                                        self.poll_interval.is_set or
                                        self.state_changes.is_set or
                                        (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_type.yfilter != YFilter.not_set or
                                        self.is_neighbor_filtered.yfilter != YFilter.not_set or
                                        self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set or
                                        self.neighbor_cost.yfilter != YFilter.not_set or
                                        self.neighbor_designated_router_address.yfilter != YFilter.not_set or
                                        self.neighbor_ignore_timer.yfilter != YFilter.not_set or
                                        self.neighbor_option.yfilter != YFilter.not_set or
                                        self.next_poll_interval.yfilter != YFilter.not_set or
                                        self.pending_events.yfilter != YFilter.not_set or
                                        self.poll_interval.yfilter != YFilter.not_set or
                                        self.state_changes.yfilter != YFilter.not_set or
                                        (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "neighbor-detail" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_type.is_set or self.interface_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_type.get_name_leafdata())
                                    if (self.is_neighbor_filtered.is_set or self.is_neighbor_filtered.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_neighbor_filtered.get_name_leafdata())
                                    if (self.neighbor_backup_designated_router_address.is_set or self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_backup_designated_router_address.get_name_leafdata())
                                    if (self.neighbor_cost.is_set or self.neighbor_cost.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_cost.get_name_leafdata())
                                    if (self.neighbor_designated_router_address.is_set or self.neighbor_designated_router_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_designated_router_address.get_name_leafdata())
                                    if (self.neighbor_ignore_timer.is_set or self.neighbor_ignore_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_ignore_timer.get_name_leafdata())
                                    if (self.neighbor_option.is_set or self.neighbor_option.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_option.get_name_leafdata())
                                    if (self.next_poll_interval.is_set or self.next_poll_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_poll_interval.get_name_leafdata())
                                    if (self.pending_events.is_set or self.pending_events.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pending_events.get_name_leafdata())
                                    if (self.poll_interval.is_set or self.poll_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.poll_interval.get_name_leafdata())
                                    if (self.state_changes.is_set or self.state_changes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_changes.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "neighbor-retransmission"):
                                        if (self.neighbor_retransmission is None):
                                            self.neighbor_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission()
                                            self.neighbor_retransmission.parent = self
                                            self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                        return self.neighbor_retransmission

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "neighbor-retransmission" or name == "interface-type" or name == "is-neighbor-filtered" or name == "neighbor-backup-designated-router-address" or name == "neighbor-cost" or name == "neighbor-designated-router-address" or name == "neighbor-ignore-timer" or name == "neighbor-option" or name == "next-poll-interval" or name == "pending-events" or name == "poll-interval" or name == "state-changes"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-type"):
                                        self.interface_type = value
                                        self.interface_type.value_namespace = name_space
                                        self.interface_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-neighbor-filtered"):
                                        self.is_neighbor_filtered = value
                                        self.is_neighbor_filtered.value_namespace = name_space
                                        self.is_neighbor_filtered.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-backup-designated-router-address"):
                                        self.neighbor_backup_designated_router_address = value
                                        self.neighbor_backup_designated_router_address.value_namespace = name_space
                                        self.neighbor_backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-cost"):
                                        self.neighbor_cost = value
                                        self.neighbor_cost.value_namespace = name_space
                                        self.neighbor_cost.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-designated-router-address"):
                                        self.neighbor_designated_router_address = value
                                        self.neighbor_designated_router_address.value_namespace = name_space
                                        self.neighbor_designated_router_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-ignore-timer"):
                                        self.neighbor_ignore_timer = value
                                        self.neighbor_ignore_timer.value_namespace = name_space
                                        self.neighbor_ignore_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-option"):
                                        self.neighbor_option = value
                                        self.neighbor_option.value_namespace = name_space
                                        self.neighbor_option.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-poll-interval"):
                                        self.next_poll_interval = value
                                        self.next_poll_interval.value_namespace = name_space
                                        self.next_poll_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pending-events"):
                                        self.pending_events = value
                                        self.pending_events.value_namespace = name_space
                                        self.pending_events.value_namespace_prefix = name_space_prefix
                                    if(value_path == "poll-interval"):
                                        self.poll_interval = value
                                        self.poll_interval.value_namespace = name_space
                                        self.poll_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-changes"):
                                        self.state_changes = value
                                        self.state_changes.value_namespace = name_space
                                        self.state_changes.value_namespace_prefix = name_space_prefix


                            class NeighborBfdInfo(Entity):
                                """
                                Neighbor BFD information
                                
                                .. attribute:: bfd_intf_enable_mode
                                
                                	BFD enable mode \- Default/Strict
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: bfd_status_flag
                                
                                	Status of the BFD Session
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborBfdInfo, self).__init__()

                                    self.yang_name = "neighbor-bfd-info"
                                    self.yang_parent_name = "neighbor"

                                    self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                    self.bfd_status_flag = YLeaf(YType.uint8, "bfd-status-flag")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bfd_intf_enable_mode",
                                                    "bfd_status_flag") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborBfdInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborBfdInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bfd_intf_enable_mode.is_set or
                                        self.bfd_status_flag.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bfd_intf_enable_mode.yfilter != YFilter.not_set or
                                        self.bfd_status_flag.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "neighbor-bfd-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())
                                    if (self.bfd_status_flag.is_set or self.bfd_status_flag.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bfd_status_flag.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bfd-intf-enable-mode" or name == "bfd-status-flag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bfd-intf-enable-mode"):
                                        self.bfd_intf_enable_mode = value
                                        self.bfd_intf_enable_mode.value_namespace = name_space
                                        self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "bfd-status-flag"):
                                        self.bfd_status_flag = value
                                        self.bfd_status_flag.value_namespace = name_space
                                        self.bfd_status_flag.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_name.is_set or
                                    self.is_neighbor_sham_link.is_set or
                                    self.is_neighbor_virtual_link.is_set or
                                    self.neighbor_address.is_set or
                                    self.neighbor_address_xr.is_set or
                                    self.neighbor_dead_timer.is_set or
                                    self.neighbor_designated_router.is_set or
                                    self.neighbor_dr_priority.is_set or
                                    self.neighbor_interface_id.is_set or
                                    self.neighbor_sham_link_id.is_set or
                                    self.neighbor_state.is_set or
                                    self.neighbor_up_time.is_set or
                                    self.neighbor_virtual_link_id.is_set or
                                    (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_data()) or
                                    (self.neighbor_detail is not None and self.neighbor_detail.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.is_neighbor_sham_link.yfilter != YFilter.not_set or
                                    self.is_neighbor_virtual_link.yfilter != YFilter.not_set or
                                    self.neighbor_address.yfilter != YFilter.not_set or
                                    self.neighbor_address_xr.yfilter != YFilter.not_set or
                                    self.neighbor_dead_timer.yfilter != YFilter.not_set or
                                    self.neighbor_designated_router.yfilter != YFilter.not_set or
                                    self.neighbor_dr_priority.yfilter != YFilter.not_set or
                                    self.neighbor_interface_id.yfilter != YFilter.not_set or
                                    self.neighbor_sham_link_id.yfilter != YFilter.not_set or
                                    self.neighbor_state.yfilter != YFilter.not_set or
                                    self.neighbor_up_time.yfilter != YFilter.not_set or
                                    self.neighbor_virtual_link_id.yfilter != YFilter.not_set or
                                    (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_operation()) or
                                    (self.neighbor_detail is not None and self.neighbor_detail.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.is_neighbor_sham_link.is_set or self.is_neighbor_sham_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_sham_link.get_name_leafdata())
                                if (self.is_neighbor_virtual_link.is_set or self.is_neighbor_virtual_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_virtual_link.get_name_leafdata())
                                if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                if (self.neighbor_address_xr.is_set or self.neighbor_address_xr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_address_xr.get_name_leafdata())
                                if (self.neighbor_dead_timer.is_set or self.neighbor_dead_timer.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_dead_timer.get_name_leafdata())
                                if (self.neighbor_designated_router.is_set or self.neighbor_designated_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_designated_router.get_name_leafdata())
                                if (self.neighbor_dr_priority.is_set or self.neighbor_dr_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_dr_priority.get_name_leafdata())
                                if (self.neighbor_interface_id.is_set or self.neighbor_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_interface_id.get_name_leafdata())
                                if (self.neighbor_sham_link_id.is_set or self.neighbor_sham_link_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_sham_link_id.get_name_leafdata())
                                if (self.neighbor_state.is_set or self.neighbor_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_state.get_name_leafdata())
                                if (self.neighbor_up_time.is_set or self.neighbor_up_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_up_time.get_name_leafdata())
                                if (self.neighbor_virtual_link_id.is_set or self.neighbor_virtual_link_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_virtual_link_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "neighbor-bfd-info"):
                                    if (self.neighbor_bfd_info is None):
                                        self.neighbor_bfd_info = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborBfdInfo()
                                        self.neighbor_bfd_info.parent = self
                                        self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                    return self.neighbor_bfd_info

                                if (child_yang_name == "neighbor-detail"):
                                    if (self.neighbor_detail is None):
                                        self.neighbor_detail = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor.NeighborDetail()
                                        self.neighbor_detail.parent = self
                                        self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                    return self.neighbor_detail

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "neighbor-bfd-info" or name == "neighbor-detail" or name == "interface-name" or name == "is-neighbor-sham-link" or name == "is-neighbor-virtual-link" or name == "neighbor-address" or name == "neighbor-address-xr" or name == "neighbor-dead-timer" or name == "neighbor-designated-router" or name == "neighbor-dr-priority" or name == "neighbor-interface-id" or name == "neighbor-sham-link-id" or name == "neighbor-state" or name == "neighbor-up-time" or name == "neighbor-virtual-link-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-sham-link"):
                                    self.is_neighbor_sham_link = value
                                    self.is_neighbor_sham_link.value_namespace = name_space
                                    self.is_neighbor_sham_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-virtual-link"):
                                    self.is_neighbor_virtual_link = value
                                    self.is_neighbor_virtual_link.value_namespace = name_space
                                    self.is_neighbor_virtual_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-address"):
                                    self.neighbor_address = value
                                    self.neighbor_address.value_namespace = name_space
                                    self.neighbor_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-address-xr"):
                                    self.neighbor_address_xr = value
                                    self.neighbor_address_xr.value_namespace = name_space
                                    self.neighbor_address_xr.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-dead-timer"):
                                    self.neighbor_dead_timer = value
                                    self.neighbor_dead_timer.value_namespace = name_space
                                    self.neighbor_dead_timer.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-designated-router"):
                                    self.neighbor_designated_router = value
                                    self.neighbor_designated_router.value_namespace = name_space
                                    self.neighbor_designated_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-dr-priority"):
                                    self.neighbor_dr_priority = value
                                    self.neighbor_dr_priority.value_namespace = name_space
                                    self.neighbor_dr_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-interface-id"):
                                    self.neighbor_interface_id = value
                                    self.neighbor_interface_id.value_namespace = name_space
                                    self.neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-sham-link-id"):
                                    self.neighbor_sham_link_id = value
                                    self.neighbor_sham_link_id.value_namespace = name_space
                                    self.neighbor_sham_link_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-state"):
                                    self.neighbor_state = value
                                    self.neighbor_state.value_namespace = name_space
                                    self.neighbor_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-up-time"):
                                    self.neighbor_up_time = value
                                    self.neighbor_up_time.value_namespace = name_space
                                    self.neighbor_up_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-virtual-link-id"):
                                    self.neighbor_virtual_link_id = value
                                    self.neighbor_virtual_link_id.value_namespace = name_space
                                    self.neighbor_virtual_link_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-process-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor"):
                                for c in self.neighbor:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable.Neighbor()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class FastReroutes(Entity):
                        """
                        OSPFv3 fast reroute topology information table
                        
                        .. attribute:: fast_reroute
                        
                        	OSPFv3 fast reroute topology information
                        	**type**\: list of    :py:class:`FastReroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes.FastReroute>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes, self).__init__()

                            self.yang_name = "fast-reroutes"
                            self.yang_parent_name = "vrf"

                            self.fast_reroute = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes, self).__setattr__(name, value)


                        class FastReroute(Entity):
                            """
                            OSPFv3 fast reroute topology information
                            
                            .. attribute:: area_id
                            
                            	AreaID
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: ipfrr_area_revision
                            
                            	IPFRR Topology Revision
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ipfrr_router_id
                            
                            	OSPF Router ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipfrr_topo
                            
                            	IPFRR Topology entries
                            	**type**\: list of    :py:class:`IpfrrTopo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes.FastReroute.IpfrrTopo>`
                            
                            .. attribute:: ipfrr_topo_area_id
                            
                            	Area ID string in decimal or dotted decimal format
                            	**type**\:  str
                            
                            	**length:** 0..16
                            
                            .. attribute:: router_id
                            
                            	Router ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes.FastReroute, self).__init__()

                                self.yang_name = "fast-reroute"
                                self.yang_parent_name = "fast-reroutes"

                                self.area_id = YLeaf(YType.int32, "area-id")

                                self.ipfrr_area_revision = YLeaf(YType.uint32, "ipfrr-area-revision")

                                self.ipfrr_router_id = YLeaf(YType.str, "ipfrr-router-id")

                                self.ipfrr_topo_area_id = YLeaf(YType.str, "ipfrr-topo-area-id")

                                self.router_id = YLeaf(YType.str, "router-id")

                                self.ipfrr_topo = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("area_id",
                                                "ipfrr_area_revision",
                                                "ipfrr_router_id",
                                                "ipfrr_topo_area_id",
                                                "router_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes.FastReroute, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes.FastReroute, self).__setattr__(name, value)


                            class IpfrrTopo(Entity):
                                """
                                IPFRR Topology entries
                                
                                .. attribute:: distance
                                
                                	IPFRR Topology Distance
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: dr
                                
                                	IPFRR Topology DR entry
                                	**type**\:  bool
                                
                                .. attribute:: lsaid
                                
                                	IPFRR Topology LSA ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_sourced
                                
                                	IPFRR Topology Neighbor Sourced
                                	**type**\:  bool
                                
                                .. attribute:: node_id
                                
                                	IPFRR Topology Node ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: revision
                                
                                	IPFRR Topology Revision
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: type4
                                
                                	IPFRR Topoogy Type\-4 entry
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes.FastReroute.IpfrrTopo, self).__init__()

                                    self.yang_name = "ipfrr-topo"
                                    self.yang_parent_name = "fast-reroute"

                                    self.distance = YLeaf(YType.uint32, "distance")

                                    self.dr = YLeaf(YType.boolean, "dr")

                                    self.lsaid = YLeaf(YType.uint32, "lsaid")

                                    self.neighbor_sourced = YLeaf(YType.boolean, "neighbor-sourced")

                                    self.node_id = YLeaf(YType.str, "node-id")

                                    self.revision = YLeaf(YType.uint32, "revision")

                                    self.type4 = YLeaf(YType.boolean, "type4")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("distance",
                                                    "dr",
                                                    "lsaid",
                                                    "neighbor_sourced",
                                                    "node_id",
                                                    "revision",
                                                    "type4") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes.FastReroute.IpfrrTopo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes.FastReroute.IpfrrTopo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.distance.is_set or
                                        self.dr.is_set or
                                        self.lsaid.is_set or
                                        self.neighbor_sourced.is_set or
                                        self.node_id.is_set or
                                        self.revision.is_set or
                                        self.type4.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.distance.yfilter != YFilter.not_set or
                                        self.dr.yfilter != YFilter.not_set or
                                        self.lsaid.yfilter != YFilter.not_set or
                                        self.neighbor_sourced.yfilter != YFilter.not_set or
                                        self.node_id.yfilter != YFilter.not_set or
                                        self.revision.yfilter != YFilter.not_set or
                                        self.type4.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipfrr-topo" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.distance.is_set or self.distance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.distance.get_name_leafdata())
                                    if (self.dr.is_set or self.dr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dr.get_name_leafdata())
                                    if (self.lsaid.is_set or self.lsaid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsaid.get_name_leafdata())
                                    if (self.neighbor_sourced.is_set or self.neighbor_sourced.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_sourced.get_name_leafdata())
                                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.node_id.get_name_leafdata())
                                    if (self.revision.is_set or self.revision.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.revision.get_name_leafdata())
                                    if (self.type4.is_set or self.type4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type4.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "distance" or name == "dr" or name == "lsaid" or name == "neighbor-sourced" or name == "node-id" or name == "revision" or name == "type4"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "distance"):
                                        self.distance = value
                                        self.distance.value_namespace = name_space
                                        self.distance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dr"):
                                        self.dr = value
                                        self.dr.value_namespace = name_space
                                        self.dr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsaid"):
                                        self.lsaid = value
                                        self.lsaid.value_namespace = name_space
                                        self.lsaid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-sourced"):
                                        self.neighbor_sourced = value
                                        self.neighbor_sourced.value_namespace = name_space
                                        self.neighbor_sourced.value_namespace_prefix = name_space_prefix
                                    if(value_path == "node-id"):
                                        self.node_id = value
                                        self.node_id.value_namespace = name_space
                                        self.node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "revision"):
                                        self.revision = value
                                        self.revision.value_namespace = name_space
                                        self.revision.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type4"):
                                        self.type4 = value
                                        self.type4.value_namespace = name_space
                                        self.type4.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ipfrr_topo:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.area_id.is_set or
                                    self.ipfrr_area_revision.is_set or
                                    self.ipfrr_router_id.is_set or
                                    self.ipfrr_topo_area_id.is_set or
                                    self.router_id.is_set)

                            def has_operation(self):
                                for c in self.ipfrr_topo:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.area_id.yfilter != YFilter.not_set or
                                    self.ipfrr_area_revision.yfilter != YFilter.not_set or
                                    self.ipfrr_router_id.yfilter != YFilter.not_set or
                                    self.ipfrr_topo_area_id.yfilter != YFilter.not_set or
                                    self.router_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fast-reroute" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_id.get_name_leafdata())
                                if (self.ipfrr_area_revision.is_set or self.ipfrr_area_revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipfrr_area_revision.get_name_leafdata())
                                if (self.ipfrr_router_id.is_set or self.ipfrr_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipfrr_router_id.get_name_leafdata())
                                if (self.ipfrr_topo_area_id.is_set or self.ipfrr_topo_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipfrr_topo_area_id.get_name_leafdata())
                                if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.router_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipfrr-topo"):
                                    for c in self.ipfrr_topo:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes.FastReroute.IpfrrTopo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ipfrr_topo.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipfrr-topo" or name == "area-id" or name == "ipfrr-area-revision" or name == "ipfrr-router-id" or name == "ipfrr-topo-area-id" or name == "router-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "area-id"):
                                    self.area_id = value
                                    self.area_id.value_namespace = name_space
                                    self.area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipfrr-area-revision"):
                                    self.ipfrr_area_revision = value
                                    self.ipfrr_area_revision.value_namespace = name_space
                                    self.ipfrr_area_revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipfrr-router-id"):
                                    self.ipfrr_router_id = value
                                    self.ipfrr_router_id.value_namespace = name_space
                                    self.ipfrr_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipfrr-topo-area-id"):
                                    self.ipfrr_topo_area_id = value
                                    self.ipfrr_topo_area_id.value_namespace = name_space
                                    self.ipfrr_topo_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "router-id"):
                                    self.router_id = value
                                    self.router_id.value_namespace = name_space
                                    self.router_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.fast_reroute:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.fast_reroute:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fast-reroutes" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fast-reroute"):
                                for c in self.fast_reroute:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes.FastReroute()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.fast_reroute.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fast-reroute"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class InterfaceBriefProcessTable(Entity):
                        """
                        OSPFv3 interface brief information table for all
                        areas
                        
                        .. attribute:: interface_brief
                        
                        	Interface brief information
                        	**type**\: list of    :py:class:`InterfaceBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable.InterfaceBrief>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable, self).__init__()

                            self.yang_name = "interface-brief-process-table"
                            self.yang_parent_name = "vrf"

                            self.interface_brief = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable, self).__setattr__(name, value)


                        class InterfaceBrief(Entity):
                            """
                            Interface brief information
                            
                            .. attribute:: interface_name  <key>
                            
                            	Interface name
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: interface_address
                            
                            	Interface IP address
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: interface_adjacent_neighbors
                            
                            	Total number of adjacent neighbors
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: interface_link_cost
                            
                            	Interface link cost
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: interface_neighbors
                            
                            	Total number of neighbors 
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: network_type
                            
                            	Network type
                            	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                            
                            .. attribute:: ospf_interface_state
                            
                            	Interface OSPF state
                            	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable.InterfaceBrief, self).__init__()

                                self.yang_name = "interface-brief"
                                self.yang_parent_name = "interface-brief-process-table"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.interface_address = YLeaf(YType.str, "interface-address")

                                self.interface_adjacent_neighbors = YLeaf(YType.uint16, "interface-adjacent-neighbors")

                                self.interface_link_cost = YLeaf(YType.uint16, "interface-link-cost")

                                self.interface_neighbors = YLeaf(YType.uint16, "interface-neighbors")

                                self.network_type = YLeaf(YType.enumeration, "network-type")

                                self.ospf_interface_state = YLeaf(YType.enumeration, "ospf-interface-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "interface_address",
                                                "interface_adjacent_neighbors",
                                                "interface_link_cost",
                                                "interface_neighbors",
                                                "network_type",
                                                "ospf_interface_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable.InterfaceBrief, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable.InterfaceBrief, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.interface_name.is_set or
                                    self.interface_address.is_set or
                                    self.interface_adjacent_neighbors.is_set or
                                    self.interface_link_cost.is_set or
                                    self.interface_neighbors.is_set or
                                    self.network_type.is_set or
                                    self.ospf_interface_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.interface_address.yfilter != YFilter.not_set or
                                    self.interface_adjacent_neighbors.yfilter != YFilter.not_set or
                                    self.interface_link_cost.yfilter != YFilter.not_set or
                                    self.interface_neighbors.yfilter != YFilter.not_set or
                                    self.network_type.yfilter != YFilter.not_set or
                                    self.ospf_interface_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interface-brief" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_address.get_name_leafdata())
                                if (self.interface_adjacent_neighbors.is_set or self.interface_adjacent_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_adjacent_neighbors.get_name_leafdata())
                                if (self.interface_link_cost.is_set or self.interface_link_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_link_cost.get_name_leafdata())
                                if (self.interface_neighbors.is_set or self.interface_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_neighbors.get_name_leafdata())
                                if (self.network_type.is_set or self.network_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.network_type.get_name_leafdata())
                                if (self.ospf_interface_state.is_set or self.ospf_interface_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ospf_interface_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "interface-name" or name == "interface-address" or name == "interface-adjacent-neighbors" or name == "interface-link-cost" or name == "interface-neighbors" or name == "network-type" or name == "ospf-interface-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-address"):
                                    self.interface_address = value
                                    self.interface_address.value_namespace = name_space
                                    self.interface_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-adjacent-neighbors"):
                                    self.interface_adjacent_neighbors = value
                                    self.interface_adjacent_neighbors.value_namespace = name_space
                                    self.interface_adjacent_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-link-cost"):
                                    self.interface_link_cost = value
                                    self.interface_link_cost.value_namespace = name_space
                                    self.interface_link_cost.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-neighbors"):
                                    self.interface_neighbors = value
                                    self.interface_neighbors.value_namespace = name_space
                                    self.interface_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "network-type"):
                                    self.network_type = value
                                    self.network_type.value_namespace = name_space
                                    self.network_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "ospf-interface-state"):
                                    self.ospf_interface_state = value
                                    self.ospf_interface_state.value_namespace = name_space
                                    self.ospf_interface_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.interface_brief:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.interface_brief:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface-brief-process-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "interface-brief"):
                                for c in self.interface_brief:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable.InterfaceBrief()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.interface_brief.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "interface-brief"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class NeighborDetailProcessTable(Entity):
                        """
                        OSPFv3 neighbor information table for all areas
                        
                        .. attribute:: neighbor_detail
                        
                        	OSPFv3 neighbor detail information
                        	**type**\: list of    :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable, self).__init__()

                            self.yang_name = "neighbor-detail-process-table"
                            self.yang_parent_name = "vrf"

                            self.neighbor_detail = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable, self).__setattr__(name, value)


                        class NeighborDetail(Entity):
                            """
                            OSPFv3 neighbor detail information
                            
                            .. attribute:: interface_name
                            
                            	Interface name
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: is_neighbor_sham_link
                            
                            	If true, neighbor is on a sham link 
                            	**type**\:  bool
                            
                            .. attribute:: is_neighbor_virtual_link
                            
                            	If true, neighbor is on a virtual link 
                            	**type**\:  bool
                            
                            .. attribute:: neighbor_address
                            
                            	Neighbor ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: neighbor_address_xr
                            
                            	Neighbor IP Address
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: neighbor_bfd_info
                            
                            	Neighbor BFD information
                            	**type**\:   :py:class:`NeighborBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo>`
                            
                            .. attribute:: neighbor_dead_timer
                            
                            	Time until neighbor's dead timer expires (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: neighbor_designated_router
                            
                            	Designated router 
                            	**type**\:  str
                            
                            	**length:** 0..9
                            
                            .. attribute:: neighbor_detail
                            
                            	Detailed OSPFv3 neighbor information 
                            	**type**\:   :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail>`
                            
                            .. attribute:: neighbor_dr_priority
                            
                            	Neighbor's DR priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: neighbor_interface_id
                            
                            	Neighbor interface ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_sham_link_id
                            
                            	Neighbor sham link id 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_state
                            
                            	Neighbor's state
                            	**type**\:   :py:class:`Ospfv3NeighborState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3NeighborState>`
                            
                            .. attribute:: neighbor_up_time
                            
                            	Amount of time since the adjacency is up (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: neighbor_virtual_link_id
                            
                            	Neighbor virtual link id 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail, self).__init__()

                                self.yang_name = "neighbor-detail"
                                self.yang_parent_name = "neighbor-detail-process-table"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.is_neighbor_sham_link = YLeaf(YType.boolean, "is-neighbor-sham-link")

                                self.is_neighbor_virtual_link = YLeaf(YType.boolean, "is-neighbor-virtual-link")

                                self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                self.neighbor_address_xr = YLeaf(YType.str, "neighbor-address-xr")

                                self.neighbor_dead_timer = YLeaf(YType.uint32, "neighbor-dead-timer")

                                self.neighbor_designated_router = YLeaf(YType.str, "neighbor-designated-router")

                                self.neighbor_dr_priority = YLeaf(YType.uint8, "neighbor-dr-priority")

                                self.neighbor_interface_id = YLeaf(YType.uint32, "neighbor-interface-id")

                                self.neighbor_sham_link_id = YLeaf(YType.uint32, "neighbor-sham-link-id")

                                self.neighbor_state = YLeaf(YType.enumeration, "neighbor-state")

                                self.neighbor_up_time = YLeaf(YType.uint32, "neighbor-up-time")

                                self.neighbor_virtual_link_id = YLeaf(YType.uint32, "neighbor-virtual-link-id")

                                self.neighbor_bfd_info = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo()
                                self.neighbor_bfd_info.parent = self
                                self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                self._children_yang_names.add("neighbor-bfd-info")

                                self.neighbor_detail = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail()
                                self.neighbor_detail.parent = self
                                self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                self._children_yang_names.add("neighbor-detail")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "is_neighbor_sham_link",
                                                "is_neighbor_virtual_link",
                                                "neighbor_address",
                                                "neighbor_address_xr",
                                                "neighbor_dead_timer",
                                                "neighbor_designated_router",
                                                "neighbor_dr_priority",
                                                "neighbor_interface_id",
                                                "neighbor_sham_link_id",
                                                "neighbor_state",
                                                "neighbor_up_time",
                                                "neighbor_virtual_link_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail, self).__setattr__(name, value)


                            class NeighborDetail(Entity):
                                """
                                Detailed OSPFv3 neighbor information 
                                
                                .. attribute:: interface_type
                                
                                	Interface type
                                	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                                
                                .. attribute:: is_neighbor_filtered
                                
                                	If true, filter outgoing LSAs 
                                	**type**\:  bool
                                
                                .. attribute:: neighbor_backup_designated_router_address
                                
                                	Address of backup designated router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: neighbor_cost
                                
                                	Cost of path to this neighbor 
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: neighbor_designated_router_address
                                
                                	Address of designated router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: neighbor_ignore_timer
                                
                                	Remaining time when ignore timer is running 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_option
                                
                                	 This is bitmask of neighbor's option field received 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_retransmission
                                
                                	Retransmission information with this neighbor
                                	**type**\:   :py:class:`NeighborRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission>`
                                
                                .. attribute:: next_poll_interval
                                
                                	For NBMA networks, amount of time remaining in seconds before the next poll interval expires and Hello is sent (s)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: pending_events
                                
                                	Number of pending events 
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: poll_interval
                                
                                	Poll interval (s)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: state_changes
                                
                                	Number of state changes 
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail, self).__init__()

                                    self.yang_name = "neighbor-detail"
                                    self.yang_parent_name = "neighbor-detail"

                                    self.interface_type = YLeaf(YType.enumeration, "interface-type")

                                    self.is_neighbor_filtered = YLeaf(YType.boolean, "is-neighbor-filtered")

                                    self.neighbor_backup_designated_router_address = YLeaf(YType.str, "neighbor-backup-designated-router-address")

                                    self.neighbor_cost = YLeaf(YType.uint16, "neighbor-cost")

                                    self.neighbor_designated_router_address = YLeaf(YType.str, "neighbor-designated-router-address")

                                    self.neighbor_ignore_timer = YLeaf(YType.uint32, "neighbor-ignore-timer")

                                    self.neighbor_option = YLeaf(YType.uint32, "neighbor-option")

                                    self.next_poll_interval = YLeaf(YType.uint32, "next-poll-interval")

                                    self.pending_events = YLeaf(YType.uint16, "pending-events")

                                    self.poll_interval = YLeaf(YType.uint32, "poll-interval")

                                    self.state_changes = YLeaf(YType.uint16, "state-changes")

                                    self.neighbor_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission()
                                    self.neighbor_retransmission.parent = self
                                    self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                    self._children_yang_names.add("neighbor-retransmission")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_type",
                                                    "is_neighbor_filtered",
                                                    "neighbor_backup_designated_router_address",
                                                    "neighbor_cost",
                                                    "neighbor_designated_router_address",
                                                    "neighbor_ignore_timer",
                                                    "neighbor_option",
                                                    "next_poll_interval",
                                                    "pending_events",
                                                    "poll_interval",
                                                    "state_changes") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail, self).__setattr__(name, value)


                                class NeighborRetransmission(Entity):
                                    """
                                    Retransmission information with this neighbor
                                    
                                    .. attribute:: area_first_flood
                                    
                                    	First flood item for area scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: area_first_flood_index
                                    
                                    	Index of the first flood item for area scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: area_flood_index
                                    
                                    	Area scope LSA's flood index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: area_next_flood
                                    
                                    	Next flood item for area scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: area_next_flood_index
                                    
                                    	Index of next flood item for Area scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: as_first_flood
                                    
                                    	First flood item for AS scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: as_first_flood_index
                                    
                                    	Index for first flood item for AS scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: as_flood_index
                                    
                                    	AS scope LSA's flood index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: as_next_flood
                                    
                                    	Next flood item for AS scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: as_next_flood_index
                                    
                                    	Index of next flood item for AS scope LSAs
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: database_descriptor_retransmissions
                                    
                                    	Number of database descriptor retransmissions during last exchange
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_retransmission_length
                                    
                                    	Number of LSAs sent in last retransmission
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_retransmission_time
                                    
                                    	Last retransmission scan time (ms)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: link_first_flood
                                    
                                    	Link first flood information 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: link_first_flood_index
                                    
                                    	Link first flood information index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: link_flood_index
                                    
                                    	Link flood index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: link_next_flood
                                    
                                    	Link next flood information 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: link_next_flood_index
                                    
                                    	Link next flood information index 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lsa_retransmission_timer
                                    
                                    	Time until next LSA retransmission (ms)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: maximum_retransmission_length
                                    
                                    	Maximum number of LSAs sent in a retransmission
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: maximum_retransmission_time
                                    
                                    	Maximum retransmission scan time (ms)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_retransmissions
                                    
                                    	Number of neighbor retransmissions 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: retransmissions
                                    
                                    	Number of retransmissions for this neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__init__()

                                        self.yang_name = "neighbor-retransmission"
                                        self.yang_parent_name = "neighbor-detail"

                                        self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                        self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                        self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                        self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                        self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                        self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                        self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                        self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                        self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                        self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                        self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                        self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                        self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                        self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                        self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                        self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                        self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                        self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                        self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                        self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                        self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                        self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                        self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("area_first_flood",
                                                        "area_first_flood_index",
                                                        "area_flood_index",
                                                        "area_next_flood",
                                                        "area_next_flood_index",
                                                        "as_first_flood",
                                                        "as_first_flood_index",
                                                        "as_flood_index",
                                                        "as_next_flood",
                                                        "as_next_flood_index",
                                                        "database_descriptor_retransmissions",
                                                        "last_retransmission_length",
                                                        "last_retransmission_time",
                                                        "link_first_flood",
                                                        "link_first_flood_index",
                                                        "link_flood_index",
                                                        "link_next_flood",
                                                        "link_next_flood_index",
                                                        "lsa_retransmission_timer",
                                                        "maximum_retransmission_length",
                                                        "maximum_retransmission_time",
                                                        "neighbor_retransmissions",
                                                        "retransmissions") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.area_first_flood.is_set or
                                            self.area_first_flood_index.is_set or
                                            self.area_flood_index.is_set or
                                            self.area_next_flood.is_set or
                                            self.area_next_flood_index.is_set or
                                            self.as_first_flood.is_set or
                                            self.as_first_flood_index.is_set or
                                            self.as_flood_index.is_set or
                                            self.as_next_flood.is_set or
                                            self.as_next_flood_index.is_set or
                                            self.database_descriptor_retransmissions.is_set or
                                            self.last_retransmission_length.is_set or
                                            self.last_retransmission_time.is_set or
                                            self.link_first_flood.is_set or
                                            self.link_first_flood_index.is_set or
                                            self.link_flood_index.is_set or
                                            self.link_next_flood.is_set or
                                            self.link_next_flood_index.is_set or
                                            self.lsa_retransmission_timer.is_set or
                                            self.maximum_retransmission_length.is_set or
                                            self.maximum_retransmission_time.is_set or
                                            self.neighbor_retransmissions.is_set or
                                            self.retransmissions.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.area_first_flood.yfilter != YFilter.not_set or
                                            self.area_first_flood_index.yfilter != YFilter.not_set or
                                            self.area_flood_index.yfilter != YFilter.not_set or
                                            self.area_next_flood.yfilter != YFilter.not_set or
                                            self.area_next_flood_index.yfilter != YFilter.not_set or
                                            self.as_first_flood.yfilter != YFilter.not_set or
                                            self.as_first_flood_index.yfilter != YFilter.not_set or
                                            self.as_flood_index.yfilter != YFilter.not_set or
                                            self.as_next_flood.yfilter != YFilter.not_set or
                                            self.as_next_flood_index.yfilter != YFilter.not_set or
                                            self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                            self.last_retransmission_length.yfilter != YFilter.not_set or
                                            self.last_retransmission_time.yfilter != YFilter.not_set or
                                            self.link_first_flood.yfilter != YFilter.not_set or
                                            self.link_first_flood_index.yfilter != YFilter.not_set or
                                            self.link_flood_index.yfilter != YFilter.not_set or
                                            self.link_next_flood.yfilter != YFilter.not_set or
                                            self.link_next_flood_index.yfilter != YFilter.not_set or
                                            self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                            self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                            self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                            self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                            self.retransmissions.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "neighbor-retransmission" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                        if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                        if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                        if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                        if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                        if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                        if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                        if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                        if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                        if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                        if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                        if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                        if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                        if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                        if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                        if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                        if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                        if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                        if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                        if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                        if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                        if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                        if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "area-first-flood"):
                                            self.area_first_flood = value
                                            self.area_first_flood.value_namespace = name_space
                                            self.area_first_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "area-first-flood-index"):
                                            self.area_first_flood_index = value
                                            self.area_first_flood_index.value_namespace = name_space
                                            self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "area-flood-index"):
                                            self.area_flood_index = value
                                            self.area_flood_index.value_namespace = name_space
                                            self.area_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "area-next-flood"):
                                            self.area_next_flood = value
                                            self.area_next_flood.value_namespace = name_space
                                            self.area_next_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "area-next-flood-index"):
                                            self.area_next_flood_index = value
                                            self.area_next_flood_index.value_namespace = name_space
                                            self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "as-first-flood"):
                                            self.as_first_flood = value
                                            self.as_first_flood.value_namespace = name_space
                                            self.as_first_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "as-first-flood-index"):
                                            self.as_first_flood_index = value
                                            self.as_first_flood_index.value_namespace = name_space
                                            self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "as-flood-index"):
                                            self.as_flood_index = value
                                            self.as_flood_index.value_namespace = name_space
                                            self.as_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "as-next-flood"):
                                            self.as_next_flood = value
                                            self.as_next_flood.value_namespace = name_space
                                            self.as_next_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "as-next-flood-index"):
                                            self.as_next_flood_index = value
                                            self.as_next_flood_index.value_namespace = name_space
                                            self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "database-descriptor-retransmissions"):
                                            self.database_descriptor_retransmissions = value
                                            self.database_descriptor_retransmissions.value_namespace = name_space
                                            self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-retransmission-length"):
                                            self.last_retransmission_length = value
                                            self.last_retransmission_length.value_namespace = name_space
                                            self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-retransmission-time"):
                                            self.last_retransmission_time = value
                                            self.last_retransmission_time.value_namespace = name_space
                                            self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "link-first-flood"):
                                            self.link_first_flood = value
                                            self.link_first_flood.value_namespace = name_space
                                            self.link_first_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "link-first-flood-index"):
                                            self.link_first_flood_index = value
                                            self.link_first_flood_index.value_namespace = name_space
                                            self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "link-flood-index"):
                                            self.link_flood_index = value
                                            self.link_flood_index.value_namespace = name_space
                                            self.link_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "link-next-flood"):
                                            self.link_next_flood = value
                                            self.link_next_flood.value_namespace = name_space
                                            self.link_next_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "link-next-flood-index"):
                                            self.link_next_flood_index = value
                                            self.link_next_flood_index.value_namespace = name_space
                                            self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsa-retransmission-timer"):
                                            self.lsa_retransmission_timer = value
                                            self.lsa_retransmission_timer.value_namespace = name_space
                                            self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                        if(value_path == "maximum-retransmission-length"):
                                            self.maximum_retransmission_length = value
                                            self.maximum_retransmission_length.value_namespace = name_space
                                            self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "maximum-retransmission-time"):
                                            self.maximum_retransmission_time = value
                                            self.maximum_retransmission_time.value_namespace = name_space
                                            self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-retransmissions"):
                                            self.neighbor_retransmissions = value
                                            self.neighbor_retransmissions.value_namespace = name_space
                                            self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                        if(value_path == "retransmissions"):
                                            self.retransmissions = value
                                            self.retransmissions.value_namespace = name_space
                                            self.retransmissions.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_type.is_set or
                                        self.is_neighbor_filtered.is_set or
                                        self.neighbor_backup_designated_router_address.is_set or
                                        self.neighbor_cost.is_set or
                                        self.neighbor_designated_router_address.is_set or
                                        self.neighbor_ignore_timer.is_set or
                                        self.neighbor_option.is_set or
                                        self.next_poll_interval.is_set or
                                        self.pending_events.is_set or
                                        self.poll_interval.is_set or
                                        self.state_changes.is_set or
                                        (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_type.yfilter != YFilter.not_set or
                                        self.is_neighbor_filtered.yfilter != YFilter.not_set or
                                        self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set or
                                        self.neighbor_cost.yfilter != YFilter.not_set or
                                        self.neighbor_designated_router_address.yfilter != YFilter.not_set or
                                        self.neighbor_ignore_timer.yfilter != YFilter.not_set or
                                        self.neighbor_option.yfilter != YFilter.not_set or
                                        self.next_poll_interval.yfilter != YFilter.not_set or
                                        self.pending_events.yfilter != YFilter.not_set or
                                        self.poll_interval.yfilter != YFilter.not_set or
                                        self.state_changes.yfilter != YFilter.not_set or
                                        (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "neighbor-detail" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_type.is_set or self.interface_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_type.get_name_leafdata())
                                    if (self.is_neighbor_filtered.is_set or self.is_neighbor_filtered.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_neighbor_filtered.get_name_leafdata())
                                    if (self.neighbor_backup_designated_router_address.is_set or self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_backup_designated_router_address.get_name_leafdata())
                                    if (self.neighbor_cost.is_set or self.neighbor_cost.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_cost.get_name_leafdata())
                                    if (self.neighbor_designated_router_address.is_set or self.neighbor_designated_router_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_designated_router_address.get_name_leafdata())
                                    if (self.neighbor_ignore_timer.is_set or self.neighbor_ignore_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_ignore_timer.get_name_leafdata())
                                    if (self.neighbor_option.is_set or self.neighbor_option.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_option.get_name_leafdata())
                                    if (self.next_poll_interval.is_set or self.next_poll_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_poll_interval.get_name_leafdata())
                                    if (self.pending_events.is_set or self.pending_events.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pending_events.get_name_leafdata())
                                    if (self.poll_interval.is_set or self.poll_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.poll_interval.get_name_leafdata())
                                    if (self.state_changes.is_set or self.state_changes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_changes.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "neighbor-retransmission"):
                                        if (self.neighbor_retransmission is None):
                                            self.neighbor_retransmission = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission()
                                            self.neighbor_retransmission.parent = self
                                            self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                        return self.neighbor_retransmission

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "neighbor-retransmission" or name == "interface-type" or name == "is-neighbor-filtered" or name == "neighbor-backup-designated-router-address" or name == "neighbor-cost" or name == "neighbor-designated-router-address" or name == "neighbor-ignore-timer" or name == "neighbor-option" or name == "next-poll-interval" or name == "pending-events" or name == "poll-interval" or name == "state-changes"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-type"):
                                        self.interface_type = value
                                        self.interface_type.value_namespace = name_space
                                        self.interface_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-neighbor-filtered"):
                                        self.is_neighbor_filtered = value
                                        self.is_neighbor_filtered.value_namespace = name_space
                                        self.is_neighbor_filtered.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-backup-designated-router-address"):
                                        self.neighbor_backup_designated_router_address = value
                                        self.neighbor_backup_designated_router_address.value_namespace = name_space
                                        self.neighbor_backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-cost"):
                                        self.neighbor_cost = value
                                        self.neighbor_cost.value_namespace = name_space
                                        self.neighbor_cost.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-designated-router-address"):
                                        self.neighbor_designated_router_address = value
                                        self.neighbor_designated_router_address.value_namespace = name_space
                                        self.neighbor_designated_router_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-ignore-timer"):
                                        self.neighbor_ignore_timer = value
                                        self.neighbor_ignore_timer.value_namespace = name_space
                                        self.neighbor_ignore_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-option"):
                                        self.neighbor_option = value
                                        self.neighbor_option.value_namespace = name_space
                                        self.neighbor_option.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-poll-interval"):
                                        self.next_poll_interval = value
                                        self.next_poll_interval.value_namespace = name_space
                                        self.next_poll_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pending-events"):
                                        self.pending_events = value
                                        self.pending_events.value_namespace = name_space
                                        self.pending_events.value_namespace_prefix = name_space_prefix
                                    if(value_path == "poll-interval"):
                                        self.poll_interval = value
                                        self.poll_interval.value_namespace = name_space
                                        self.poll_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-changes"):
                                        self.state_changes = value
                                        self.state_changes.value_namespace = name_space
                                        self.state_changes.value_namespace_prefix = name_space_prefix


                            class NeighborBfdInfo(Entity):
                                """
                                Neighbor BFD information
                                
                                .. attribute:: bfd_intf_enable_mode
                                
                                	BFD enable mode \- Default/Strict
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: bfd_status_flag
                                
                                	Status of the BFD Session
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo, self).__init__()

                                    self.yang_name = "neighbor-bfd-info"
                                    self.yang_parent_name = "neighbor-detail"

                                    self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                    self.bfd_status_flag = YLeaf(YType.uint8, "bfd-status-flag")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bfd_intf_enable_mode",
                                                    "bfd_status_flag") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bfd_intf_enable_mode.is_set or
                                        self.bfd_status_flag.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bfd_intf_enable_mode.yfilter != YFilter.not_set or
                                        self.bfd_status_flag.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "neighbor-bfd-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())
                                    if (self.bfd_status_flag.is_set or self.bfd_status_flag.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bfd_status_flag.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bfd-intf-enable-mode" or name == "bfd-status-flag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bfd-intf-enable-mode"):
                                        self.bfd_intf_enable_mode = value
                                        self.bfd_intf_enable_mode.value_namespace = name_space
                                        self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "bfd-status-flag"):
                                        self.bfd_status_flag = value
                                        self.bfd_status_flag.value_namespace = name_space
                                        self.bfd_status_flag.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_name.is_set or
                                    self.is_neighbor_sham_link.is_set or
                                    self.is_neighbor_virtual_link.is_set or
                                    self.neighbor_address.is_set or
                                    self.neighbor_address_xr.is_set or
                                    self.neighbor_dead_timer.is_set or
                                    self.neighbor_designated_router.is_set or
                                    self.neighbor_dr_priority.is_set or
                                    self.neighbor_interface_id.is_set or
                                    self.neighbor_sham_link_id.is_set or
                                    self.neighbor_state.is_set or
                                    self.neighbor_up_time.is_set or
                                    self.neighbor_virtual_link_id.is_set or
                                    (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_data()) or
                                    (self.neighbor_detail is not None and self.neighbor_detail.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.is_neighbor_sham_link.yfilter != YFilter.not_set or
                                    self.is_neighbor_virtual_link.yfilter != YFilter.not_set or
                                    self.neighbor_address.yfilter != YFilter.not_set or
                                    self.neighbor_address_xr.yfilter != YFilter.not_set or
                                    self.neighbor_dead_timer.yfilter != YFilter.not_set or
                                    self.neighbor_designated_router.yfilter != YFilter.not_set or
                                    self.neighbor_dr_priority.yfilter != YFilter.not_set or
                                    self.neighbor_interface_id.yfilter != YFilter.not_set or
                                    self.neighbor_sham_link_id.yfilter != YFilter.not_set or
                                    self.neighbor_state.yfilter != YFilter.not_set or
                                    self.neighbor_up_time.yfilter != YFilter.not_set or
                                    self.neighbor_virtual_link_id.yfilter != YFilter.not_set or
                                    (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_operation()) or
                                    (self.neighbor_detail is not None and self.neighbor_detail.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.is_neighbor_sham_link.is_set or self.is_neighbor_sham_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_sham_link.get_name_leafdata())
                                if (self.is_neighbor_virtual_link.is_set or self.is_neighbor_virtual_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_virtual_link.get_name_leafdata())
                                if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                if (self.neighbor_address_xr.is_set or self.neighbor_address_xr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_address_xr.get_name_leafdata())
                                if (self.neighbor_dead_timer.is_set or self.neighbor_dead_timer.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_dead_timer.get_name_leafdata())
                                if (self.neighbor_designated_router.is_set or self.neighbor_designated_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_designated_router.get_name_leafdata())
                                if (self.neighbor_dr_priority.is_set or self.neighbor_dr_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_dr_priority.get_name_leafdata())
                                if (self.neighbor_interface_id.is_set or self.neighbor_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_interface_id.get_name_leafdata())
                                if (self.neighbor_sham_link_id.is_set or self.neighbor_sham_link_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_sham_link_id.get_name_leafdata())
                                if (self.neighbor_state.is_set or self.neighbor_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_state.get_name_leafdata())
                                if (self.neighbor_up_time.is_set or self.neighbor_up_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_up_time.get_name_leafdata())
                                if (self.neighbor_virtual_link_id.is_set or self.neighbor_virtual_link_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_virtual_link_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "neighbor-bfd-info"):
                                    if (self.neighbor_bfd_info is None):
                                        self.neighbor_bfd_info = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo()
                                        self.neighbor_bfd_info.parent = self
                                        self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                    return self.neighbor_bfd_info

                                if (child_yang_name == "neighbor-detail"):
                                    if (self.neighbor_detail is None):
                                        self.neighbor_detail = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail()
                                        self.neighbor_detail.parent = self
                                        self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                    return self.neighbor_detail

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "neighbor-bfd-info" or name == "neighbor-detail" or name == "interface-name" or name == "is-neighbor-sham-link" or name == "is-neighbor-virtual-link" or name == "neighbor-address" or name == "neighbor-address-xr" or name == "neighbor-dead-timer" or name == "neighbor-designated-router" or name == "neighbor-dr-priority" or name == "neighbor-interface-id" or name == "neighbor-sham-link-id" or name == "neighbor-state" or name == "neighbor-up-time" or name == "neighbor-virtual-link-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-sham-link"):
                                    self.is_neighbor_sham_link = value
                                    self.is_neighbor_sham_link.value_namespace = name_space
                                    self.is_neighbor_sham_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-virtual-link"):
                                    self.is_neighbor_virtual_link = value
                                    self.is_neighbor_virtual_link.value_namespace = name_space
                                    self.is_neighbor_virtual_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-address"):
                                    self.neighbor_address = value
                                    self.neighbor_address.value_namespace = name_space
                                    self.neighbor_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-address-xr"):
                                    self.neighbor_address_xr = value
                                    self.neighbor_address_xr.value_namespace = name_space
                                    self.neighbor_address_xr.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-dead-timer"):
                                    self.neighbor_dead_timer = value
                                    self.neighbor_dead_timer.value_namespace = name_space
                                    self.neighbor_dead_timer.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-designated-router"):
                                    self.neighbor_designated_router = value
                                    self.neighbor_designated_router.value_namespace = name_space
                                    self.neighbor_designated_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-dr-priority"):
                                    self.neighbor_dr_priority = value
                                    self.neighbor_dr_priority.value_namespace = name_space
                                    self.neighbor_dr_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-interface-id"):
                                    self.neighbor_interface_id = value
                                    self.neighbor_interface_id.value_namespace = name_space
                                    self.neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-sham-link-id"):
                                    self.neighbor_sham_link_id = value
                                    self.neighbor_sham_link_id.value_namespace = name_space
                                    self.neighbor_sham_link_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-state"):
                                    self.neighbor_state = value
                                    self.neighbor_state.value_namespace = name_space
                                    self.neighbor_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-up-time"):
                                    self.neighbor_up_time = value
                                    self.neighbor_up_time.value_namespace = name_space
                                    self.neighbor_up_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-virtual-link-id"):
                                    self.neighbor_virtual_link_id = value
                                    self.neighbor_virtual_link_id.value_namespace = name_space
                                    self.neighbor_virtual_link_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor_detail:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor_detail:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-detail-process-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor-detail"):
                                for c in self.neighbor_detail:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable.NeighborDetail()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor_detail.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor-detail"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.vrf_name.is_set or
                            (self.area_informations is not None and self.area_informations.has_data()) or
                            (self.areas is not None and self.areas.has_data()) or
                            (self.bad_checksums is not None and self.bad_checksums.has_data()) or
                            (self.border_routers is not None and self.border_routers.has_data()) or
                            (self.connected_routes is not None and self.connected_routes.has_data()) or
                            (self.database_summary_table is not None and self.database_summary_table.has_data()) or
                            (self.database_table is not None and self.database_table.has_data()) or
                            (self.external_routes is not None and self.external_routes.has_data()) or
                            (self.fast_reroutes is not None and self.fast_reroutes.has_data()) or
                            (self.flood_list_process_table is not None and self.flood_list_process_table.has_data()) or
                            (self.interface_brief_process_table is not None and self.interface_brief_process_table.has_data()) or
                            (self.interface_process_table is not None and self.interface_process_table.has_data()) or
                            (self.internal_routes is not None and self.internal_routes.has_data()) or
                            (self.neighbor_detail_process_table is not None and self.neighbor_detail_process_table.has_data()) or
                            (self.neighbor_process_table is not None and self.neighbor_process_table.has_data()) or
                            (self.protocol_areas is not None and self.protocol_areas.has_data()) or
                            (self.redistributions is not None and self.redistributions.has_data()) or
                            (self.request_list_process_table is not None and self.request_list_process_table.has_data()) or
                            (self.retransmission_list_process_table is not None and self.retransmission_list_process_table.has_data()) or
                            (self.route_summary is not None and self.route_summary.has_data()) or
                            (self.sham_link_table is not None and self.sham_link_table.has_data()) or
                            (self.summary is not None and self.summary.has_data()) or
                            (self.summary_prefixes is not None and self.summary_prefixes.has_data()) or
                            (self.virtual_link is not None and self.virtual_link.has_data()) or
                            (self.vrf_statistics is not None and self.vrf_statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.vrf_name.yfilter != YFilter.not_set or
                            (self.area_informations is not None and self.area_informations.has_operation()) or
                            (self.areas is not None and self.areas.has_operation()) or
                            (self.bad_checksums is not None and self.bad_checksums.has_operation()) or
                            (self.border_routers is not None and self.border_routers.has_operation()) or
                            (self.connected_routes is not None and self.connected_routes.has_operation()) or
                            (self.database_summary_table is not None and self.database_summary_table.has_operation()) or
                            (self.database_table is not None and self.database_table.has_operation()) or
                            (self.external_routes is not None and self.external_routes.has_operation()) or
                            (self.fast_reroutes is not None and self.fast_reroutes.has_operation()) or
                            (self.flood_list_process_table is not None and self.flood_list_process_table.has_operation()) or
                            (self.interface_brief_process_table is not None and self.interface_brief_process_table.has_operation()) or
                            (self.interface_process_table is not None and self.interface_process_table.has_operation()) or
                            (self.internal_routes is not None and self.internal_routes.has_operation()) or
                            (self.neighbor_detail_process_table is not None and self.neighbor_detail_process_table.has_operation()) or
                            (self.neighbor_process_table is not None and self.neighbor_process_table.has_operation()) or
                            (self.protocol_areas is not None and self.protocol_areas.has_operation()) or
                            (self.redistributions is not None and self.redistributions.has_operation()) or
                            (self.request_list_process_table is not None and self.request_list_process_table.has_operation()) or
                            (self.retransmission_list_process_table is not None and self.retransmission_list_process_table.has_operation()) or
                            (self.route_summary is not None and self.route_summary.has_operation()) or
                            (self.sham_link_table is not None and self.sham_link_table.has_operation()) or
                            (self.summary is not None and self.summary.has_operation()) or
                            (self.summary_prefixes is not None and self.summary_prefixes.has_operation()) or
                            (self.virtual_link is not None and self.virtual_link.has_operation()) or
                            (self.vrf_statistics is not None and self.vrf_statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + "[vrf-name='" + self.vrf_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "area-informations"):
                            if (self.area_informations is None):
                                self.area_informations = Ospfv3.Processes.Process.Vrfs.Vrf.AreaInformations()
                                self.area_informations.parent = self
                                self._children_name_map["area_informations"] = "area-informations"
                            return self.area_informations

                        if (child_yang_name == "areas"):
                            if (self.areas is None):
                                self.areas = Ospfv3.Processes.Process.Vrfs.Vrf.Areas()
                                self.areas.parent = self
                                self._children_name_map["areas"] = "areas"
                            return self.areas

                        if (child_yang_name == "bad-checksums"):
                            if (self.bad_checksums is None):
                                self.bad_checksums = Ospfv3.Processes.Process.Vrfs.Vrf.BadChecksums()
                                self.bad_checksums.parent = self
                                self._children_name_map["bad_checksums"] = "bad-checksums"
                            return self.bad_checksums

                        if (child_yang_name == "border-routers"):
                            if (self.border_routers is None):
                                self.border_routers = Ospfv3.Processes.Process.Vrfs.Vrf.BorderRouters()
                                self.border_routers.parent = self
                                self._children_name_map["border_routers"] = "border-routers"
                            return self.border_routers

                        if (child_yang_name == "connected-routes"):
                            if (self.connected_routes is None):
                                self.connected_routes = Ospfv3.Processes.Process.Vrfs.Vrf.ConnectedRoutes()
                                self.connected_routes.parent = self
                                self._children_name_map["connected_routes"] = "connected-routes"
                            return self.connected_routes

                        if (child_yang_name == "database-summary-table"):
                            if (self.database_summary_table is None):
                                self.database_summary_table = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseSummaryTable()
                                self.database_summary_table.parent = self
                                self._children_name_map["database_summary_table"] = "database-summary-table"
                            return self.database_summary_table

                        if (child_yang_name == "database-table"):
                            if (self.database_table is None):
                                self.database_table = Ospfv3.Processes.Process.Vrfs.Vrf.DatabaseTable()
                                self.database_table.parent = self
                                self._children_name_map["database_table"] = "database-table"
                            return self.database_table

                        if (child_yang_name == "external-routes"):
                            if (self.external_routes is None):
                                self.external_routes = Ospfv3.Processes.Process.Vrfs.Vrf.ExternalRoutes()
                                self.external_routes.parent = self
                                self._children_name_map["external_routes"] = "external-routes"
                            return self.external_routes

                        if (child_yang_name == "fast-reroutes"):
                            if (self.fast_reroutes is None):
                                self.fast_reroutes = Ospfv3.Processes.Process.Vrfs.Vrf.FastReroutes()
                                self.fast_reroutes.parent = self
                                self._children_name_map["fast_reroutes"] = "fast-reroutes"
                            return self.fast_reroutes

                        if (child_yang_name == "flood-list-process-table"):
                            if (self.flood_list_process_table is None):
                                self.flood_list_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.FloodListProcessTable()
                                self.flood_list_process_table.parent = self
                                self._children_name_map["flood_list_process_table"] = "flood-list-process-table"
                            return self.flood_list_process_table

                        if (child_yang_name == "interface-brief-process-table"):
                            if (self.interface_brief_process_table is None):
                                self.interface_brief_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceBriefProcessTable()
                                self.interface_brief_process_table.parent = self
                                self._children_name_map["interface_brief_process_table"] = "interface-brief-process-table"
                            return self.interface_brief_process_table

                        if (child_yang_name == "interface-process-table"):
                            if (self.interface_process_table is None):
                                self.interface_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.InterfaceProcessTable()
                                self.interface_process_table.parent = self
                                self._children_name_map["interface_process_table"] = "interface-process-table"
                            return self.interface_process_table

                        if (child_yang_name == "internal-routes"):
                            if (self.internal_routes is None):
                                self.internal_routes = Ospfv3.Processes.Process.Vrfs.Vrf.InternalRoutes()
                                self.internal_routes.parent = self
                                self._children_name_map["internal_routes"] = "internal-routes"
                            return self.internal_routes

                        if (child_yang_name == "neighbor-detail-process-table"):
                            if (self.neighbor_detail_process_table is None):
                                self.neighbor_detail_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborDetailProcessTable()
                                self.neighbor_detail_process_table.parent = self
                                self._children_name_map["neighbor_detail_process_table"] = "neighbor-detail-process-table"
                            return self.neighbor_detail_process_table

                        if (child_yang_name == "neighbor-process-table"):
                            if (self.neighbor_process_table is None):
                                self.neighbor_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.NeighborProcessTable()
                                self.neighbor_process_table.parent = self
                                self._children_name_map["neighbor_process_table"] = "neighbor-process-table"
                            return self.neighbor_process_table

                        if (child_yang_name == "protocol-areas"):
                            if (self.protocol_areas is None):
                                self.protocol_areas = Ospfv3.Processes.Process.Vrfs.Vrf.ProtocolAreas()
                                self.protocol_areas.parent = self
                                self._children_name_map["protocol_areas"] = "protocol-areas"
                            return self.protocol_areas

                        if (child_yang_name == "redistributions"):
                            if (self.redistributions is None):
                                self.redistributions = Ospfv3.Processes.Process.Vrfs.Vrf.Redistributions()
                                self.redistributions.parent = self
                                self._children_name_map["redistributions"] = "redistributions"
                            return self.redistributions

                        if (child_yang_name == "request-list-process-table"):
                            if (self.request_list_process_table is None):
                                self.request_list_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.RequestListProcessTable()
                                self.request_list_process_table.parent = self
                                self._children_name_map["request_list_process_table"] = "request-list-process-table"
                            return self.request_list_process_table

                        if (child_yang_name == "retransmission-list-process-table"):
                            if (self.retransmission_list_process_table is None):
                                self.retransmission_list_process_table = Ospfv3.Processes.Process.Vrfs.Vrf.RetransmissionListProcessTable()
                                self.retransmission_list_process_table.parent = self
                                self._children_name_map["retransmission_list_process_table"] = "retransmission-list-process-table"
                            return self.retransmission_list_process_table

                        if (child_yang_name == "route-summary"):
                            if (self.route_summary is None):
                                self.route_summary = Ospfv3.Processes.Process.Vrfs.Vrf.RouteSummary()
                                self.route_summary.parent = self
                                self._children_name_map["route_summary"] = "route-summary"
                            return self.route_summary

                        if (child_yang_name == "sham-link-table"):
                            if (self.sham_link_table is None):
                                self.sham_link_table = Ospfv3.Processes.Process.Vrfs.Vrf.ShamLinkTable()
                                self.sham_link_table.parent = self
                                self._children_name_map["sham_link_table"] = "sham-link-table"
                            return self.sham_link_table

                        if (child_yang_name == "summary"):
                            if (self.summary is None):
                                self.summary = Ospfv3.Processes.Process.Vrfs.Vrf.Summary()
                                self.summary.parent = self
                                self._children_name_map["summary"] = "summary"
                            return self.summary

                        if (child_yang_name == "summary-prefixes"):
                            if (self.summary_prefixes is None):
                                self.summary_prefixes = Ospfv3.Processes.Process.Vrfs.Vrf.SummaryPrefixes()
                                self.summary_prefixes.parent = self
                                self._children_name_map["summary_prefixes"] = "summary-prefixes"
                            return self.summary_prefixes

                        if (child_yang_name == "virtual-link"):
                            if (self.virtual_link is None):
                                self.virtual_link = Ospfv3.Processes.Process.Vrfs.Vrf.VirtualLink()
                                self.virtual_link.parent = self
                                self._children_name_map["virtual_link"] = "virtual-link"
                            return self.virtual_link

                        if (child_yang_name == "vrf-statistics"):
                            if (self.vrf_statistics is None):
                                self.vrf_statistics = Ospfv3.Processes.Process.Vrfs.Vrf.VrfStatistics()
                                self.vrf_statistics.parent = self
                                self._children_name_map["vrf_statistics"] = "vrf-statistics"
                            return self.vrf_statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "area-informations" or name == "areas" or name == "bad-checksums" or name == "border-routers" or name == "connected-routes" or name == "database-summary-table" or name == "database-table" or name == "external-routes" or name == "fast-reroutes" or name == "flood-list-process-table" or name == "interface-brief-process-table" or name == "interface-process-table" or name == "internal-routes" or name == "neighbor-detail-process-table" or name == "neighbor-process-table" or name == "protocol-areas" or name == "redistributions" or name == "request-list-process-table" or name == "retransmission-list-process-table" or name == "route-summary" or name == "sham-link-table" or name == "summary" or name == "summary-prefixes" or name == "virtual-link" or name == "vrf-statistics" or name == "vrf-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "vrf-name"):
                            self.vrf_name = value
                            self.vrf_name.value_namespace = name_space
                            self.vrf_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.vrf:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.vrf:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "vrfs" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "vrf"):
                        for c in self.vrf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Ospfv3.Processes.Process.Vrfs.Vrf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.vrf.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "vrf"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Statistics(Entity):
                """
                Container for Statistics
                
                .. attribute:: issu_stats
                
                	OSPF ISSU statistics
                	**type**\:   :py:class:`IssuStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.IssuStats>`
                
                .. attribute:: nsr_pl_stats
                
                	OSPF NSR packet library statistics
                	**type**\:   :py:class:`NsrPlStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.NsrPlStats>`
                
                .. attribute:: nsr_stats
                
                	OSPF NSR statistics
                	**type**\:   :py:class:`NsrStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.NsrStats>`
                
                .. attribute:: prefix_priority_stats
                
                	OSPF Prefix SPF Prioritization statistics
                	**type**\:   :py:class:`PrefixPriorityStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.PrefixPriorityStats>`
                
                .. attribute:: protocol_stats
                
                	Protocol table
                	**type**\:   :py:class:`ProtocolStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.ProtocolStats>`
                
                .. attribute:: rawio_stats
                
                	OSPF Prefix SPF Prioritization statistics
                	**type**\:   :py:class:`RawioStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.RawioStats>`
                
                .. attribute:: rib_thread_stats
                
                	OSPFv3 RIB thread statistics
                	**type**\:   :py:class:`RibThreadStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.RibThreadStats>`
                
                .. attribute:: spf_stats
                
                	OSPFv3 RIB batch statistics
                	**type**\:   :py:class:`SpfStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.SpfStats>`
                
                .. attribute:: vrf_rib_batch_stats
                
                	OSPFv3 RIB batch statistics
                	**type**\:   :py:class:`VrfRibBatchStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.VrfRibBatchStats>`
                
                

                """

                _prefix = 'ipv6-ospfv3-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(Ospfv3.Processes.Process.Statistics, self).__init__()

                    self.yang_name = "statistics"
                    self.yang_parent_name = "process"

                    self.issu_stats = Ospfv3.Processes.Process.Statistics.IssuStats()
                    self.issu_stats.parent = self
                    self._children_name_map["issu_stats"] = "issu-stats"
                    self._children_yang_names.add("issu-stats")

                    self.nsr_pl_stats = Ospfv3.Processes.Process.Statistics.NsrPlStats()
                    self.nsr_pl_stats.parent = self
                    self._children_name_map["nsr_pl_stats"] = "nsr-pl-stats"
                    self._children_yang_names.add("nsr-pl-stats")

                    self.nsr_stats = Ospfv3.Processes.Process.Statistics.NsrStats()
                    self.nsr_stats.parent = self
                    self._children_name_map["nsr_stats"] = "nsr-stats"
                    self._children_yang_names.add("nsr-stats")

                    self.prefix_priority_stats = Ospfv3.Processes.Process.Statistics.PrefixPriorityStats()
                    self.prefix_priority_stats.parent = self
                    self._children_name_map["prefix_priority_stats"] = "prefix-priority-stats"
                    self._children_yang_names.add("prefix-priority-stats")

                    self.protocol_stats = Ospfv3.Processes.Process.Statistics.ProtocolStats()
                    self.protocol_stats.parent = self
                    self._children_name_map["protocol_stats"] = "protocol-stats"
                    self._children_yang_names.add("protocol-stats")

                    self.rawio_stats = Ospfv3.Processes.Process.Statistics.RawioStats()
                    self.rawio_stats.parent = self
                    self._children_name_map["rawio_stats"] = "rawio-stats"
                    self._children_yang_names.add("rawio-stats")

                    self.rib_thread_stats = Ospfv3.Processes.Process.Statistics.RibThreadStats()
                    self.rib_thread_stats.parent = self
                    self._children_name_map["rib_thread_stats"] = "rib-thread-stats"
                    self._children_yang_names.add("rib-thread-stats")

                    self.spf_stats = Ospfv3.Processes.Process.Statistics.SpfStats()
                    self.spf_stats.parent = self
                    self._children_name_map["spf_stats"] = "spf-stats"
                    self._children_yang_names.add("spf-stats")

                    self.vrf_rib_batch_stats = Ospfv3.Processes.Process.Statistics.VrfRibBatchStats()
                    self.vrf_rib_batch_stats.parent = self
                    self._children_name_map["vrf_rib_batch_stats"] = "vrf-rib-batch-stats"
                    self._children_yang_names.add("vrf-rib-batch-stats")


                class NsrStats(Entity):
                    """
                    OSPF NSR statistics
                    
                    .. attribute:: nsr_conn_to_active_attempts
                    
                    	Attempts to connect to active
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: nsr_conn_to_active_closes
                    
                    	Conn to active closes
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: nsr_conn_to_active_errors
                    
                    	Conn to active errors
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: nsr_conn_to_active_fails
                    
                    	Failures to connect to active
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: nsr_conn_to_active_opens
                    
                    	Conn to active opens
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: nsr_fsm_state
                    
                    	FSM state
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nsr_intf_seq_no
                    
                    	Interface TLV sequence no
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_lsa_init_sync_pend_count
                    
                    	Pending init\-sync LSA msgs
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nsr_lsa_qad_mdata_count
                    
                    	LSA QAD pending msgs
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_lsa_qad_qid
                    
                    	LSA QAD queue id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_mtu
                    
                    	Fabric MTU
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_nbr_init_sync_pend_count
                    
                    	Pending init\-sync NBR msgs
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nsr_nbr_qad_mdata_count
                    
                    	NBR QAD pending msg
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_nbr_qad_qid
                    
                    	NBR QAD queue id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_nbr_seq_no
                    
                    	Neighbor TLV sequence no
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_node_id
                    
                    	My nodeid
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_peer_node_id
                    
                    	Partner NodeID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_peer_version
                    
                    	Partner NSR version
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_revision
                    
                    	NSR revision
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nsr_rtr_thd_sched
                    
                    	Rtr thread NSR pulse handler stats
                    	**type**\:   :py:class:`NsrRtrThdSched <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched>`
                    
                    .. attribute:: nsr_thd_stats
                    
                    	NSR thread scheduler stats
                    	**type**\:   :py:class:`NsrThdStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats>`
                    
                    .. attribute:: nsr_tmr_quant
                    
                    	Timers processed per pulse
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nsr_version
                    
                    	NSR version
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.Statistics.NsrStats, self).__init__()

                        self.yang_name = "nsr-stats"
                        self.yang_parent_name = "statistics"

                        self.nsr_conn_to_active_attempts = YLeaf(YType.uint64, "nsr-conn-to-active-attempts")

                        self.nsr_conn_to_active_closes = YLeaf(YType.uint64, "nsr-conn-to-active-closes")

                        self.nsr_conn_to_active_errors = YLeaf(YType.uint64, "nsr-conn-to-active-errors")

                        self.nsr_conn_to_active_fails = YLeaf(YType.uint64, "nsr-conn-to-active-fails")

                        self.nsr_conn_to_active_opens = YLeaf(YType.uint64, "nsr-conn-to-active-opens")

                        self.nsr_fsm_state = YLeaf(YType.int32, "nsr-fsm-state")

                        self.nsr_intf_seq_no = YLeaf(YType.uint32, "nsr-intf-seq-no")

                        self.nsr_lsa_init_sync_pend_count = YLeaf(YType.int32, "nsr-lsa-init-sync-pend-count")

                        self.nsr_lsa_qad_mdata_count = YLeaf(YType.uint32, "nsr-lsa-qad-mdata-count")

                        self.nsr_lsa_qad_qid = YLeaf(YType.uint32, "nsr-lsa-qad-qid")

                        self.nsr_mtu = YLeaf(YType.uint32, "nsr-mtu")

                        self.nsr_nbr_init_sync_pend_count = YLeaf(YType.int32, "nsr-nbr-init-sync-pend-count")

                        self.nsr_nbr_qad_mdata_count = YLeaf(YType.uint32, "nsr-nbr-qad-mdata-count")

                        self.nsr_nbr_qad_qid = YLeaf(YType.uint32, "nsr-nbr-qad-qid")

                        self.nsr_nbr_seq_no = YLeaf(YType.uint32, "nsr-nbr-seq-no")

                        self.nsr_node_id = YLeaf(YType.uint32, "nsr-node-id")

                        self.nsr_peer_node_id = YLeaf(YType.uint32, "nsr-peer-node-id")

                        self.nsr_peer_version = YLeaf(YType.uint32, "nsr-peer-version")

                        self.nsr_revision = YLeaf(YType.int32, "nsr-revision")

                        self.nsr_tmr_quant = YLeaf(YType.int32, "nsr-tmr-quant")

                        self.nsr_version = YLeaf(YType.uint32, "nsr-version")

                        self.nsr_rtr_thd_sched = Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched()
                        self.nsr_rtr_thd_sched.parent = self
                        self._children_name_map["nsr_rtr_thd_sched"] = "nsr-rtr-thd-sched"
                        self._children_yang_names.add("nsr-rtr-thd-sched")

                        self.nsr_thd_stats = Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats()
                        self.nsr_thd_stats.parent = self
                        self._children_name_map["nsr_thd_stats"] = "nsr-thd-stats"
                        self._children_yang_names.add("nsr-thd-stats")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("nsr_conn_to_active_attempts",
                                        "nsr_conn_to_active_closes",
                                        "nsr_conn_to_active_errors",
                                        "nsr_conn_to_active_fails",
                                        "nsr_conn_to_active_opens",
                                        "nsr_fsm_state",
                                        "nsr_intf_seq_no",
                                        "nsr_lsa_init_sync_pend_count",
                                        "nsr_lsa_qad_mdata_count",
                                        "nsr_lsa_qad_qid",
                                        "nsr_mtu",
                                        "nsr_nbr_init_sync_pend_count",
                                        "nsr_nbr_qad_mdata_count",
                                        "nsr_nbr_qad_qid",
                                        "nsr_nbr_seq_no",
                                        "nsr_node_id",
                                        "nsr_peer_node_id",
                                        "nsr_peer_version",
                                        "nsr_revision",
                                        "nsr_tmr_quant",
                                        "nsr_version") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.Statistics.NsrStats, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.Statistics.NsrStats, self).__setattr__(name, value)


                    class NsrThdStats(Entity):
                        """
                        NSR thread scheduler stats
                        
                        .. attribute:: nsr_bad_pulses_rx
                        
                        	Bad pulses received
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_events_in_q
                        
                        	Events pending
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nsr_events_rx
                        
                        	Events processed
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_events_tx
                        
                        	Events to Router thread
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_good_pulses_rx
                        
                        	Good pulses received
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_pri
                        
                        	nsr pri
                        	**type**\: list of    :py:class:`NsrPri <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats.NsrPri>`
                        
                        .. attribute:: nsr_pulse_quant
                        
                        	Events processed per pulse
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: nsr_pulse_tx_fails
                        
                        	Pulse send failures
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_pulses_tx
                        
                        	Pulses to Router thread
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats, self).__init__()

                            self.yang_name = "nsr-thd-stats"
                            self.yang_parent_name = "nsr-stats"

                            self.nsr_bad_pulses_rx = YLeaf(YType.uint64, "nsr-bad-pulses-rx")

                            self.nsr_events_in_q = YLeaf(YType.uint32, "nsr-events-in-q")

                            self.nsr_events_rx = YLeaf(YType.uint64, "nsr-events-rx")

                            self.nsr_events_tx = YLeaf(YType.uint64, "nsr-events-tx")

                            self.nsr_good_pulses_rx = YLeaf(YType.uint64, "nsr-good-pulses-rx")

                            self.nsr_pulse_quant = YLeaf(YType.int32, "nsr-pulse-quant")

                            self.nsr_pulse_tx_fails = YLeaf(YType.uint64, "nsr-pulse-tx-fails")

                            self.nsr_pulses_tx = YLeaf(YType.uint64, "nsr-pulses-tx")

                            self.nsr_pri = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("nsr_bad_pulses_rx",
                                            "nsr_events_in_q",
                                            "nsr_events_rx",
                                            "nsr_events_tx",
                                            "nsr_good_pulses_rx",
                                            "nsr_pulse_quant",
                                            "nsr_pulse_tx_fails",
                                            "nsr_pulses_tx") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats, self).__setattr__(name, value)


                        class NsrPri(Entity):
                            """
                            nsr pri
                            
                            .. attribute:: nsr_sched_enq_fails
                            
                            	Event enqueue fails
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_evs_deqd
                            
                            	Events dequeued
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_evs_in_q
                            
                            	Events pending
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_evs_qd
                            
                            	Events queued
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_max_evs
                            
                            	Max Queued
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_peak_q_len
                            
                            	Peak queue length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_pri
                            
                            	Priority Type
                            	**type**\:   :py:class:`OspfNsrSchedPri <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfNsrSchedPri>`
                            
                            .. attribute:: nsr_sched_quant
                            
                            	Priority Queue
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: nsr_sched_remain_quant
                            
                            	Remaining quantum
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats.NsrPri, self).__init__()

                                self.yang_name = "nsr-pri"
                                self.yang_parent_name = "nsr-thd-stats"

                                self.nsr_sched_enq_fails = YLeaf(YType.uint64, "nsr-sched-enq-fails")

                                self.nsr_sched_evs_deqd = YLeaf(YType.uint64, "nsr-sched-evs-deqd")

                                self.nsr_sched_evs_in_q = YLeaf(YType.uint16, "nsr-sched-evs-in-q")

                                self.nsr_sched_evs_qd = YLeaf(YType.uint64, "nsr-sched-evs-qd")

                                self.nsr_sched_max_evs = YLeaf(YType.uint16, "nsr-sched-max-evs")

                                self.nsr_sched_peak_q_len = YLeaf(YType.uint16, "nsr-sched-peak-q-len")

                                self.nsr_sched_pri = YLeaf(YType.enumeration, "nsr-sched-pri")

                                self.nsr_sched_quant = YLeaf(YType.uint8, "nsr-sched-quant")

                                self.nsr_sched_remain_quant = YLeaf(YType.uint8, "nsr-sched-remain-quant")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_sched_enq_fails",
                                                "nsr_sched_evs_deqd",
                                                "nsr_sched_evs_in_q",
                                                "nsr_sched_evs_qd",
                                                "nsr_sched_max_evs",
                                                "nsr_sched_peak_q_len",
                                                "nsr_sched_pri",
                                                "nsr_sched_quant",
                                                "nsr_sched_remain_quant") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats.NsrPri, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats.NsrPri, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nsr_sched_enq_fails.is_set or
                                    self.nsr_sched_evs_deqd.is_set or
                                    self.nsr_sched_evs_in_q.is_set or
                                    self.nsr_sched_evs_qd.is_set or
                                    self.nsr_sched_max_evs.is_set or
                                    self.nsr_sched_peak_q_len.is_set or
                                    self.nsr_sched_pri.is_set or
                                    self.nsr_sched_quant.is_set or
                                    self.nsr_sched_remain_quant.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_sched_enq_fails.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_deqd.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_in_q.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_qd.yfilter != YFilter.not_set or
                                    self.nsr_sched_max_evs.yfilter != YFilter.not_set or
                                    self.nsr_sched_peak_q_len.yfilter != YFilter.not_set or
                                    self.nsr_sched_pri.yfilter != YFilter.not_set or
                                    self.nsr_sched_quant.yfilter != YFilter.not_set or
                                    self.nsr_sched_remain_quant.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nsr-pri" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nsr_sched_enq_fails.is_set or self.nsr_sched_enq_fails.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_enq_fails.get_name_leafdata())
                                if (self.nsr_sched_evs_deqd.is_set or self.nsr_sched_evs_deqd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_deqd.get_name_leafdata())
                                if (self.nsr_sched_evs_in_q.is_set or self.nsr_sched_evs_in_q.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_in_q.get_name_leafdata())
                                if (self.nsr_sched_evs_qd.is_set or self.nsr_sched_evs_qd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_qd.get_name_leafdata())
                                if (self.nsr_sched_max_evs.is_set or self.nsr_sched_max_evs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_max_evs.get_name_leafdata())
                                if (self.nsr_sched_peak_q_len.is_set or self.nsr_sched_peak_q_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_peak_q_len.get_name_leafdata())
                                if (self.nsr_sched_pri.is_set or self.nsr_sched_pri.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_pri.get_name_leafdata())
                                if (self.nsr_sched_quant.is_set or self.nsr_sched_quant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_quant.get_name_leafdata())
                                if (self.nsr_sched_remain_quant.is_set or self.nsr_sched_remain_quant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_remain_quant.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-sched-enq-fails" or name == "nsr-sched-evs-deqd" or name == "nsr-sched-evs-in-q" or name == "nsr-sched-evs-qd" or name == "nsr-sched-max-evs" or name == "nsr-sched-peak-q-len" or name == "nsr-sched-pri" or name == "nsr-sched-quant" or name == "nsr-sched-remain-quant"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-sched-enq-fails"):
                                    self.nsr_sched_enq_fails = value
                                    self.nsr_sched_enq_fails.value_namespace = name_space
                                    self.nsr_sched_enq_fails.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-deqd"):
                                    self.nsr_sched_evs_deqd = value
                                    self.nsr_sched_evs_deqd.value_namespace = name_space
                                    self.nsr_sched_evs_deqd.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-in-q"):
                                    self.nsr_sched_evs_in_q = value
                                    self.nsr_sched_evs_in_q.value_namespace = name_space
                                    self.nsr_sched_evs_in_q.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-qd"):
                                    self.nsr_sched_evs_qd = value
                                    self.nsr_sched_evs_qd.value_namespace = name_space
                                    self.nsr_sched_evs_qd.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-max-evs"):
                                    self.nsr_sched_max_evs = value
                                    self.nsr_sched_max_evs.value_namespace = name_space
                                    self.nsr_sched_max_evs.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-peak-q-len"):
                                    self.nsr_sched_peak_q_len = value
                                    self.nsr_sched_peak_q_len.value_namespace = name_space
                                    self.nsr_sched_peak_q_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-pri"):
                                    self.nsr_sched_pri = value
                                    self.nsr_sched_pri.value_namespace = name_space
                                    self.nsr_sched_pri.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-quant"):
                                    self.nsr_sched_quant = value
                                    self.nsr_sched_quant.value_namespace = name_space
                                    self.nsr_sched_quant.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-remain-quant"):
                                    self.nsr_sched_remain_quant = value
                                    self.nsr_sched_remain_quant.value_namespace = name_space
                                    self.nsr_sched_remain_quant.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.nsr_pri:
                                if (c.has_data()):
                                    return True
                            return (
                                self.nsr_bad_pulses_rx.is_set or
                                self.nsr_events_in_q.is_set or
                                self.nsr_events_rx.is_set or
                                self.nsr_events_tx.is_set or
                                self.nsr_good_pulses_rx.is_set or
                                self.nsr_pulse_quant.is_set or
                                self.nsr_pulse_tx_fails.is_set or
                                self.nsr_pulses_tx.is_set)

                        def has_operation(self):
                            for c in self.nsr_pri:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.nsr_bad_pulses_rx.yfilter != YFilter.not_set or
                                self.nsr_events_in_q.yfilter != YFilter.not_set or
                                self.nsr_events_rx.yfilter != YFilter.not_set or
                                self.nsr_events_tx.yfilter != YFilter.not_set or
                                self.nsr_good_pulses_rx.yfilter != YFilter.not_set or
                                self.nsr_pulse_quant.yfilter != YFilter.not_set or
                                self.nsr_pulse_tx_fails.yfilter != YFilter.not_set or
                                self.nsr_pulses_tx.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nsr-thd-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.nsr_bad_pulses_rx.is_set or self.nsr_bad_pulses_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_bad_pulses_rx.get_name_leafdata())
                            if (self.nsr_events_in_q.is_set or self.nsr_events_in_q.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_in_q.get_name_leafdata())
                            if (self.nsr_events_rx.is_set or self.nsr_events_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_rx.get_name_leafdata())
                            if (self.nsr_events_tx.is_set or self.nsr_events_tx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_tx.get_name_leafdata())
                            if (self.nsr_good_pulses_rx.is_set or self.nsr_good_pulses_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_good_pulses_rx.get_name_leafdata())
                            if (self.nsr_pulse_quant.is_set or self.nsr_pulse_quant.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulse_quant.get_name_leafdata())
                            if (self.nsr_pulse_tx_fails.is_set or self.nsr_pulse_tx_fails.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulse_tx_fails.get_name_leafdata())
                            if (self.nsr_pulses_tx.is_set or self.nsr_pulses_tx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulses_tx.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "nsr-pri"):
                                for c in self.nsr_pri:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats.NsrPri()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.nsr_pri.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "nsr-pri" or name == "nsr-bad-pulses-rx" or name == "nsr-events-in-q" or name == "nsr-events-rx" or name == "nsr-events-tx" or name == "nsr-good-pulses-rx" or name == "nsr-pulse-quant" or name == "nsr-pulse-tx-fails" or name == "nsr-pulses-tx"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "nsr-bad-pulses-rx"):
                                self.nsr_bad_pulses_rx = value
                                self.nsr_bad_pulses_rx.value_namespace = name_space
                                self.nsr_bad_pulses_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-in-q"):
                                self.nsr_events_in_q = value
                                self.nsr_events_in_q.value_namespace = name_space
                                self.nsr_events_in_q.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-rx"):
                                self.nsr_events_rx = value
                                self.nsr_events_rx.value_namespace = name_space
                                self.nsr_events_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-tx"):
                                self.nsr_events_tx = value
                                self.nsr_events_tx.value_namespace = name_space
                                self.nsr_events_tx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-good-pulses-rx"):
                                self.nsr_good_pulses_rx = value
                                self.nsr_good_pulses_rx.value_namespace = name_space
                                self.nsr_good_pulses_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulse-quant"):
                                self.nsr_pulse_quant = value
                                self.nsr_pulse_quant.value_namespace = name_space
                                self.nsr_pulse_quant.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulse-tx-fails"):
                                self.nsr_pulse_tx_fails = value
                                self.nsr_pulse_tx_fails.value_namespace = name_space
                                self.nsr_pulse_tx_fails.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulses-tx"):
                                self.nsr_pulses_tx = value
                                self.nsr_pulses_tx.value_namespace = name_space
                                self.nsr_pulses_tx.value_namespace_prefix = name_space_prefix


                    class NsrRtrThdSched(Entity):
                        """
                        Rtr thread NSR pulse handler stats
                        
                        .. attribute:: nsr_bad_pulses_rx
                        
                        	Bad pulses received
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_events_in_q
                        
                        	Events pending
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nsr_events_rx
                        
                        	Events processed
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_events_tx
                        
                        	Events to Router thread
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_good_pulses_rx
                        
                        	Good pulses received
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_pri
                        
                        	nsr pri
                        	**type**\: list of    :py:class:`NsrPri <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched.NsrPri>`
                        
                        .. attribute:: nsr_pulse_quant
                        
                        	Events processed per pulse
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: nsr_pulse_tx_fails
                        
                        	Pulse send failures
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_pulses_tx
                        
                        	Pulses to Router thread
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched, self).__init__()

                            self.yang_name = "nsr-rtr-thd-sched"
                            self.yang_parent_name = "nsr-stats"

                            self.nsr_bad_pulses_rx = YLeaf(YType.uint64, "nsr-bad-pulses-rx")

                            self.nsr_events_in_q = YLeaf(YType.uint32, "nsr-events-in-q")

                            self.nsr_events_rx = YLeaf(YType.uint64, "nsr-events-rx")

                            self.nsr_events_tx = YLeaf(YType.uint64, "nsr-events-tx")

                            self.nsr_good_pulses_rx = YLeaf(YType.uint64, "nsr-good-pulses-rx")

                            self.nsr_pulse_quant = YLeaf(YType.int32, "nsr-pulse-quant")

                            self.nsr_pulse_tx_fails = YLeaf(YType.uint64, "nsr-pulse-tx-fails")

                            self.nsr_pulses_tx = YLeaf(YType.uint64, "nsr-pulses-tx")

                            self.nsr_pri = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("nsr_bad_pulses_rx",
                                            "nsr_events_in_q",
                                            "nsr_events_rx",
                                            "nsr_events_tx",
                                            "nsr_good_pulses_rx",
                                            "nsr_pulse_quant",
                                            "nsr_pulse_tx_fails",
                                            "nsr_pulses_tx") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched, self).__setattr__(name, value)


                        class NsrPri(Entity):
                            """
                            nsr pri
                            
                            .. attribute:: nsr_sched_enq_fails
                            
                            	Event enqueue fails
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_evs_deqd
                            
                            	Events dequeued
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_evs_in_q
                            
                            	Events pending
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_evs_qd
                            
                            	Events queued
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_max_evs
                            
                            	Max Queued
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_peak_q_len
                            
                            	Peak queue length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_pri
                            
                            	Priority Type
                            	**type**\:   :py:class:`OspfNsrSchedPri <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfNsrSchedPri>`
                            
                            .. attribute:: nsr_sched_quant
                            
                            	Priority Queue
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: nsr_sched_remain_quant
                            
                            	Remaining quantum
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched.NsrPri, self).__init__()

                                self.yang_name = "nsr-pri"
                                self.yang_parent_name = "nsr-rtr-thd-sched"

                                self.nsr_sched_enq_fails = YLeaf(YType.uint64, "nsr-sched-enq-fails")

                                self.nsr_sched_evs_deqd = YLeaf(YType.uint64, "nsr-sched-evs-deqd")

                                self.nsr_sched_evs_in_q = YLeaf(YType.uint16, "nsr-sched-evs-in-q")

                                self.nsr_sched_evs_qd = YLeaf(YType.uint64, "nsr-sched-evs-qd")

                                self.nsr_sched_max_evs = YLeaf(YType.uint16, "nsr-sched-max-evs")

                                self.nsr_sched_peak_q_len = YLeaf(YType.uint16, "nsr-sched-peak-q-len")

                                self.nsr_sched_pri = YLeaf(YType.enumeration, "nsr-sched-pri")

                                self.nsr_sched_quant = YLeaf(YType.uint8, "nsr-sched-quant")

                                self.nsr_sched_remain_quant = YLeaf(YType.uint8, "nsr-sched-remain-quant")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_sched_enq_fails",
                                                "nsr_sched_evs_deqd",
                                                "nsr_sched_evs_in_q",
                                                "nsr_sched_evs_qd",
                                                "nsr_sched_max_evs",
                                                "nsr_sched_peak_q_len",
                                                "nsr_sched_pri",
                                                "nsr_sched_quant",
                                                "nsr_sched_remain_quant") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched.NsrPri, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched.NsrPri, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nsr_sched_enq_fails.is_set or
                                    self.nsr_sched_evs_deqd.is_set or
                                    self.nsr_sched_evs_in_q.is_set or
                                    self.nsr_sched_evs_qd.is_set or
                                    self.nsr_sched_max_evs.is_set or
                                    self.nsr_sched_peak_q_len.is_set or
                                    self.nsr_sched_pri.is_set or
                                    self.nsr_sched_quant.is_set or
                                    self.nsr_sched_remain_quant.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_sched_enq_fails.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_deqd.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_in_q.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_qd.yfilter != YFilter.not_set or
                                    self.nsr_sched_max_evs.yfilter != YFilter.not_set or
                                    self.nsr_sched_peak_q_len.yfilter != YFilter.not_set or
                                    self.nsr_sched_pri.yfilter != YFilter.not_set or
                                    self.nsr_sched_quant.yfilter != YFilter.not_set or
                                    self.nsr_sched_remain_quant.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nsr-pri" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nsr_sched_enq_fails.is_set or self.nsr_sched_enq_fails.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_enq_fails.get_name_leafdata())
                                if (self.nsr_sched_evs_deqd.is_set or self.nsr_sched_evs_deqd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_deqd.get_name_leafdata())
                                if (self.nsr_sched_evs_in_q.is_set or self.nsr_sched_evs_in_q.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_in_q.get_name_leafdata())
                                if (self.nsr_sched_evs_qd.is_set or self.nsr_sched_evs_qd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_qd.get_name_leafdata())
                                if (self.nsr_sched_max_evs.is_set or self.nsr_sched_max_evs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_max_evs.get_name_leafdata())
                                if (self.nsr_sched_peak_q_len.is_set or self.nsr_sched_peak_q_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_peak_q_len.get_name_leafdata())
                                if (self.nsr_sched_pri.is_set or self.nsr_sched_pri.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_pri.get_name_leafdata())
                                if (self.nsr_sched_quant.is_set or self.nsr_sched_quant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_quant.get_name_leafdata())
                                if (self.nsr_sched_remain_quant.is_set or self.nsr_sched_remain_quant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_remain_quant.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-sched-enq-fails" or name == "nsr-sched-evs-deqd" or name == "nsr-sched-evs-in-q" or name == "nsr-sched-evs-qd" or name == "nsr-sched-max-evs" or name == "nsr-sched-peak-q-len" or name == "nsr-sched-pri" or name == "nsr-sched-quant" or name == "nsr-sched-remain-quant"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-sched-enq-fails"):
                                    self.nsr_sched_enq_fails = value
                                    self.nsr_sched_enq_fails.value_namespace = name_space
                                    self.nsr_sched_enq_fails.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-deqd"):
                                    self.nsr_sched_evs_deqd = value
                                    self.nsr_sched_evs_deqd.value_namespace = name_space
                                    self.nsr_sched_evs_deqd.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-in-q"):
                                    self.nsr_sched_evs_in_q = value
                                    self.nsr_sched_evs_in_q.value_namespace = name_space
                                    self.nsr_sched_evs_in_q.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-qd"):
                                    self.nsr_sched_evs_qd = value
                                    self.nsr_sched_evs_qd.value_namespace = name_space
                                    self.nsr_sched_evs_qd.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-max-evs"):
                                    self.nsr_sched_max_evs = value
                                    self.nsr_sched_max_evs.value_namespace = name_space
                                    self.nsr_sched_max_evs.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-peak-q-len"):
                                    self.nsr_sched_peak_q_len = value
                                    self.nsr_sched_peak_q_len.value_namespace = name_space
                                    self.nsr_sched_peak_q_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-pri"):
                                    self.nsr_sched_pri = value
                                    self.nsr_sched_pri.value_namespace = name_space
                                    self.nsr_sched_pri.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-quant"):
                                    self.nsr_sched_quant = value
                                    self.nsr_sched_quant.value_namespace = name_space
                                    self.nsr_sched_quant.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-remain-quant"):
                                    self.nsr_sched_remain_quant = value
                                    self.nsr_sched_remain_quant.value_namespace = name_space
                                    self.nsr_sched_remain_quant.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.nsr_pri:
                                if (c.has_data()):
                                    return True
                            return (
                                self.nsr_bad_pulses_rx.is_set or
                                self.nsr_events_in_q.is_set or
                                self.nsr_events_rx.is_set or
                                self.nsr_events_tx.is_set or
                                self.nsr_good_pulses_rx.is_set or
                                self.nsr_pulse_quant.is_set or
                                self.nsr_pulse_tx_fails.is_set or
                                self.nsr_pulses_tx.is_set)

                        def has_operation(self):
                            for c in self.nsr_pri:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.nsr_bad_pulses_rx.yfilter != YFilter.not_set or
                                self.nsr_events_in_q.yfilter != YFilter.not_set or
                                self.nsr_events_rx.yfilter != YFilter.not_set or
                                self.nsr_events_tx.yfilter != YFilter.not_set or
                                self.nsr_good_pulses_rx.yfilter != YFilter.not_set or
                                self.nsr_pulse_quant.yfilter != YFilter.not_set or
                                self.nsr_pulse_tx_fails.yfilter != YFilter.not_set or
                                self.nsr_pulses_tx.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nsr-rtr-thd-sched" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.nsr_bad_pulses_rx.is_set or self.nsr_bad_pulses_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_bad_pulses_rx.get_name_leafdata())
                            if (self.nsr_events_in_q.is_set or self.nsr_events_in_q.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_in_q.get_name_leafdata())
                            if (self.nsr_events_rx.is_set or self.nsr_events_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_rx.get_name_leafdata())
                            if (self.nsr_events_tx.is_set or self.nsr_events_tx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_tx.get_name_leafdata())
                            if (self.nsr_good_pulses_rx.is_set or self.nsr_good_pulses_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_good_pulses_rx.get_name_leafdata())
                            if (self.nsr_pulse_quant.is_set or self.nsr_pulse_quant.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulse_quant.get_name_leafdata())
                            if (self.nsr_pulse_tx_fails.is_set or self.nsr_pulse_tx_fails.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulse_tx_fails.get_name_leafdata())
                            if (self.nsr_pulses_tx.is_set or self.nsr_pulses_tx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulses_tx.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "nsr-pri"):
                                for c in self.nsr_pri:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched.NsrPri()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.nsr_pri.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "nsr-pri" or name == "nsr-bad-pulses-rx" or name == "nsr-events-in-q" or name == "nsr-events-rx" or name == "nsr-events-tx" or name == "nsr-good-pulses-rx" or name == "nsr-pulse-quant" or name == "nsr-pulse-tx-fails" or name == "nsr-pulses-tx"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "nsr-bad-pulses-rx"):
                                self.nsr_bad_pulses_rx = value
                                self.nsr_bad_pulses_rx.value_namespace = name_space
                                self.nsr_bad_pulses_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-in-q"):
                                self.nsr_events_in_q = value
                                self.nsr_events_in_q.value_namespace = name_space
                                self.nsr_events_in_q.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-rx"):
                                self.nsr_events_rx = value
                                self.nsr_events_rx.value_namespace = name_space
                                self.nsr_events_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-tx"):
                                self.nsr_events_tx = value
                                self.nsr_events_tx.value_namespace = name_space
                                self.nsr_events_tx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-good-pulses-rx"):
                                self.nsr_good_pulses_rx = value
                                self.nsr_good_pulses_rx.value_namespace = name_space
                                self.nsr_good_pulses_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulse-quant"):
                                self.nsr_pulse_quant = value
                                self.nsr_pulse_quant.value_namespace = name_space
                                self.nsr_pulse_quant.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulse-tx-fails"):
                                self.nsr_pulse_tx_fails = value
                                self.nsr_pulse_tx_fails.value_namespace = name_space
                                self.nsr_pulse_tx_fails.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulses-tx"):
                                self.nsr_pulses_tx = value
                                self.nsr_pulses_tx.value_namespace = name_space
                                self.nsr_pulses_tx.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.nsr_conn_to_active_attempts.is_set or
                            self.nsr_conn_to_active_closes.is_set or
                            self.nsr_conn_to_active_errors.is_set or
                            self.nsr_conn_to_active_fails.is_set or
                            self.nsr_conn_to_active_opens.is_set or
                            self.nsr_fsm_state.is_set or
                            self.nsr_intf_seq_no.is_set or
                            self.nsr_lsa_init_sync_pend_count.is_set or
                            self.nsr_lsa_qad_mdata_count.is_set or
                            self.nsr_lsa_qad_qid.is_set or
                            self.nsr_mtu.is_set or
                            self.nsr_nbr_init_sync_pend_count.is_set or
                            self.nsr_nbr_qad_mdata_count.is_set or
                            self.nsr_nbr_qad_qid.is_set or
                            self.nsr_nbr_seq_no.is_set or
                            self.nsr_node_id.is_set or
                            self.nsr_peer_node_id.is_set or
                            self.nsr_peer_version.is_set or
                            self.nsr_revision.is_set or
                            self.nsr_tmr_quant.is_set or
                            self.nsr_version.is_set or
                            (self.nsr_rtr_thd_sched is not None and self.nsr_rtr_thd_sched.has_data()) or
                            (self.nsr_thd_stats is not None and self.nsr_thd_stats.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.nsr_conn_to_active_attempts.yfilter != YFilter.not_set or
                            self.nsr_conn_to_active_closes.yfilter != YFilter.not_set or
                            self.nsr_conn_to_active_errors.yfilter != YFilter.not_set or
                            self.nsr_conn_to_active_fails.yfilter != YFilter.not_set or
                            self.nsr_conn_to_active_opens.yfilter != YFilter.not_set or
                            self.nsr_fsm_state.yfilter != YFilter.not_set or
                            self.nsr_intf_seq_no.yfilter != YFilter.not_set or
                            self.nsr_lsa_init_sync_pend_count.yfilter != YFilter.not_set or
                            self.nsr_lsa_qad_mdata_count.yfilter != YFilter.not_set or
                            self.nsr_lsa_qad_qid.yfilter != YFilter.not_set or
                            self.nsr_mtu.yfilter != YFilter.not_set or
                            self.nsr_nbr_init_sync_pend_count.yfilter != YFilter.not_set or
                            self.nsr_nbr_qad_mdata_count.yfilter != YFilter.not_set or
                            self.nsr_nbr_qad_qid.yfilter != YFilter.not_set or
                            self.nsr_nbr_seq_no.yfilter != YFilter.not_set or
                            self.nsr_node_id.yfilter != YFilter.not_set or
                            self.nsr_peer_node_id.yfilter != YFilter.not_set or
                            self.nsr_peer_version.yfilter != YFilter.not_set or
                            self.nsr_revision.yfilter != YFilter.not_set or
                            self.nsr_tmr_quant.yfilter != YFilter.not_set or
                            self.nsr_version.yfilter != YFilter.not_set or
                            (self.nsr_rtr_thd_sched is not None and self.nsr_rtr_thd_sched.has_operation()) or
                            (self.nsr_thd_stats is not None and self.nsr_thd_stats.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "nsr-stats" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.nsr_conn_to_active_attempts.is_set or self.nsr_conn_to_active_attempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_conn_to_active_attempts.get_name_leafdata())
                        if (self.nsr_conn_to_active_closes.is_set or self.nsr_conn_to_active_closes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_conn_to_active_closes.get_name_leafdata())
                        if (self.nsr_conn_to_active_errors.is_set or self.nsr_conn_to_active_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_conn_to_active_errors.get_name_leafdata())
                        if (self.nsr_conn_to_active_fails.is_set or self.nsr_conn_to_active_fails.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_conn_to_active_fails.get_name_leafdata())
                        if (self.nsr_conn_to_active_opens.is_set or self.nsr_conn_to_active_opens.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_conn_to_active_opens.get_name_leafdata())
                        if (self.nsr_fsm_state.is_set or self.nsr_fsm_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_fsm_state.get_name_leafdata())
                        if (self.nsr_intf_seq_no.is_set or self.nsr_intf_seq_no.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_intf_seq_no.get_name_leafdata())
                        if (self.nsr_lsa_init_sync_pend_count.is_set or self.nsr_lsa_init_sync_pend_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_lsa_init_sync_pend_count.get_name_leafdata())
                        if (self.nsr_lsa_qad_mdata_count.is_set or self.nsr_lsa_qad_mdata_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_lsa_qad_mdata_count.get_name_leafdata())
                        if (self.nsr_lsa_qad_qid.is_set or self.nsr_lsa_qad_qid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_lsa_qad_qid.get_name_leafdata())
                        if (self.nsr_mtu.is_set or self.nsr_mtu.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_mtu.get_name_leafdata())
                        if (self.nsr_nbr_init_sync_pend_count.is_set or self.nsr_nbr_init_sync_pend_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_nbr_init_sync_pend_count.get_name_leafdata())
                        if (self.nsr_nbr_qad_mdata_count.is_set or self.nsr_nbr_qad_mdata_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_nbr_qad_mdata_count.get_name_leafdata())
                        if (self.nsr_nbr_qad_qid.is_set or self.nsr_nbr_qad_qid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_nbr_qad_qid.get_name_leafdata())
                        if (self.nsr_nbr_seq_no.is_set or self.nsr_nbr_seq_no.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_nbr_seq_no.get_name_leafdata())
                        if (self.nsr_node_id.is_set or self.nsr_node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_node_id.get_name_leafdata())
                        if (self.nsr_peer_node_id.is_set or self.nsr_peer_node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_peer_node_id.get_name_leafdata())
                        if (self.nsr_peer_version.is_set or self.nsr_peer_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_peer_version.get_name_leafdata())
                        if (self.nsr_revision.is_set or self.nsr_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_revision.get_name_leafdata())
                        if (self.nsr_tmr_quant.is_set or self.nsr_tmr_quant.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_tmr_quant.get_name_leafdata())
                        if (self.nsr_version.is_set or self.nsr_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_version.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "nsr-rtr-thd-sched"):
                            if (self.nsr_rtr_thd_sched is None):
                                self.nsr_rtr_thd_sched = Ospfv3.Processes.Process.Statistics.NsrStats.NsrRtrThdSched()
                                self.nsr_rtr_thd_sched.parent = self
                                self._children_name_map["nsr_rtr_thd_sched"] = "nsr-rtr-thd-sched"
                            return self.nsr_rtr_thd_sched

                        if (child_yang_name == "nsr-thd-stats"):
                            if (self.nsr_thd_stats is None):
                                self.nsr_thd_stats = Ospfv3.Processes.Process.Statistics.NsrStats.NsrThdStats()
                                self.nsr_thd_stats.parent = self
                                self._children_name_map["nsr_thd_stats"] = "nsr-thd-stats"
                            return self.nsr_thd_stats

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "nsr-rtr-thd-sched" or name == "nsr-thd-stats" or name == "nsr-conn-to-active-attempts" or name == "nsr-conn-to-active-closes" or name == "nsr-conn-to-active-errors" or name == "nsr-conn-to-active-fails" or name == "nsr-conn-to-active-opens" or name == "nsr-fsm-state" or name == "nsr-intf-seq-no" or name == "nsr-lsa-init-sync-pend-count" or name == "nsr-lsa-qad-mdata-count" or name == "nsr-lsa-qad-qid" or name == "nsr-mtu" or name == "nsr-nbr-init-sync-pend-count" or name == "nsr-nbr-qad-mdata-count" or name == "nsr-nbr-qad-qid" or name == "nsr-nbr-seq-no" or name == "nsr-node-id" or name == "nsr-peer-node-id" or name == "nsr-peer-version" or name == "nsr-revision" or name == "nsr-tmr-quant" or name == "nsr-version"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "nsr-conn-to-active-attempts"):
                            self.nsr_conn_to_active_attempts = value
                            self.nsr_conn_to_active_attempts.value_namespace = name_space
                            self.nsr_conn_to_active_attempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-conn-to-active-closes"):
                            self.nsr_conn_to_active_closes = value
                            self.nsr_conn_to_active_closes.value_namespace = name_space
                            self.nsr_conn_to_active_closes.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-conn-to-active-errors"):
                            self.nsr_conn_to_active_errors = value
                            self.nsr_conn_to_active_errors.value_namespace = name_space
                            self.nsr_conn_to_active_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-conn-to-active-fails"):
                            self.nsr_conn_to_active_fails = value
                            self.nsr_conn_to_active_fails.value_namespace = name_space
                            self.nsr_conn_to_active_fails.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-conn-to-active-opens"):
                            self.nsr_conn_to_active_opens = value
                            self.nsr_conn_to_active_opens.value_namespace = name_space
                            self.nsr_conn_to_active_opens.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-fsm-state"):
                            self.nsr_fsm_state = value
                            self.nsr_fsm_state.value_namespace = name_space
                            self.nsr_fsm_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-intf-seq-no"):
                            self.nsr_intf_seq_no = value
                            self.nsr_intf_seq_no.value_namespace = name_space
                            self.nsr_intf_seq_no.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-lsa-init-sync-pend-count"):
                            self.nsr_lsa_init_sync_pend_count = value
                            self.nsr_lsa_init_sync_pend_count.value_namespace = name_space
                            self.nsr_lsa_init_sync_pend_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-lsa-qad-mdata-count"):
                            self.nsr_lsa_qad_mdata_count = value
                            self.nsr_lsa_qad_mdata_count.value_namespace = name_space
                            self.nsr_lsa_qad_mdata_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-lsa-qad-qid"):
                            self.nsr_lsa_qad_qid = value
                            self.nsr_lsa_qad_qid.value_namespace = name_space
                            self.nsr_lsa_qad_qid.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-mtu"):
                            self.nsr_mtu = value
                            self.nsr_mtu.value_namespace = name_space
                            self.nsr_mtu.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-nbr-init-sync-pend-count"):
                            self.nsr_nbr_init_sync_pend_count = value
                            self.nsr_nbr_init_sync_pend_count.value_namespace = name_space
                            self.nsr_nbr_init_sync_pend_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-nbr-qad-mdata-count"):
                            self.nsr_nbr_qad_mdata_count = value
                            self.nsr_nbr_qad_mdata_count.value_namespace = name_space
                            self.nsr_nbr_qad_mdata_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-nbr-qad-qid"):
                            self.nsr_nbr_qad_qid = value
                            self.nsr_nbr_qad_qid.value_namespace = name_space
                            self.nsr_nbr_qad_qid.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-nbr-seq-no"):
                            self.nsr_nbr_seq_no = value
                            self.nsr_nbr_seq_no.value_namespace = name_space
                            self.nsr_nbr_seq_no.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-node-id"):
                            self.nsr_node_id = value
                            self.nsr_node_id.value_namespace = name_space
                            self.nsr_node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-peer-node-id"):
                            self.nsr_peer_node_id = value
                            self.nsr_peer_node_id.value_namespace = name_space
                            self.nsr_peer_node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-peer-version"):
                            self.nsr_peer_version = value
                            self.nsr_peer_version.value_namespace = name_space
                            self.nsr_peer_version.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-revision"):
                            self.nsr_revision = value
                            self.nsr_revision.value_namespace = name_space
                            self.nsr_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-tmr-quant"):
                            self.nsr_tmr_quant = value
                            self.nsr_tmr_quant.value_namespace = name_space
                            self.nsr_tmr_quant.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-version"):
                            self.nsr_version = value
                            self.nsr_version.value_namespace = name_space
                            self.nsr_version.value_namespace_prefix = name_space_prefix


                class RibThreadStats(Entity):
                    """
                    OSPFv3 RIB thread statistics
                    
                    .. attribute:: holdq
                    
                    	holdq
                    	**type**\: list of    :py:class:`Holdq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.RibThreadStats.Holdq>`
                    
                    .. attribute:: rib_base_clock
                    
                    	Rib Base Clock
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rib_base_time
                    
                    	rib base time
                    	**type**\:   :py:class:`RibBaseTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.RibThreadStats.RibBaseTime>`
                    
                    .. attribute:: rib_batch_backup
                    
                    	Rib Batches Back up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_batch_err
                    
                    	Batch errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_batch_limit
                    
                    	Rib Batches Limit
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_batch_no_table
                    
                    	Batches no table
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_batch_ok
                    
                    	Rib Batches Ok
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_batch_purged
                    
                    	No. of Rib batches purged
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_batch_sent
                    
                    	No. of Rib batches sent
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_batch_some_err
                    
                    	Batches with some error
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_drop_conn
                    
                    	Rib drop connections
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_drop_version
                    
                    	Rib drop version
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_max_latency
                    
                    	Max time entry was in queue
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rib_path_err
                    
                    	Route path errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_path_limit
                    
                    	Route path limits
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_route_err
                    
                    	Route Errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_route_limit
                    
                    	Route table limit
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_route_some_err
                    
                    	Route some errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rib_sum_latency
                    
                    	Sum latencies to calc average
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: thread_q
                    
                    	Inter Thread Queue
                    	**type**\:   :py:class:`ThreadQ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.RibThreadStats.ThreadQ>`
                    
                    .. attribute:: wq_signals
                    
                    	Signals sent to RIB Thread
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: wq_thread_active
                    
                    	RIB Thread Active Indicator
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.Statistics.RibThreadStats, self).__init__()

                        self.yang_name = "rib-thread-stats"
                        self.yang_parent_name = "statistics"

                        self.rib_base_clock = YLeaf(YType.uint64, "rib-base-clock")

                        self.rib_batch_backup = YLeaf(YType.uint32, "rib-batch-backup")

                        self.rib_batch_err = YLeaf(YType.uint32, "rib-batch-err")

                        self.rib_batch_limit = YLeaf(YType.uint32, "rib-batch-limit")

                        self.rib_batch_no_table = YLeaf(YType.uint32, "rib-batch-no-table")

                        self.rib_batch_ok = YLeaf(YType.uint32, "rib-batch-ok")

                        self.rib_batch_purged = YLeaf(YType.uint32, "rib-batch-purged")

                        self.rib_batch_sent = YLeaf(YType.uint32, "rib-batch-sent")

                        self.rib_batch_some_err = YLeaf(YType.uint32, "rib-batch-some-err")

                        self.rib_drop_conn = YLeaf(YType.uint32, "rib-drop-conn")

                        self.rib_drop_version = YLeaf(YType.uint32, "rib-drop-version")

                        self.rib_max_latency = YLeaf(YType.uint64, "rib-max-latency")

                        self.rib_path_err = YLeaf(YType.uint32, "rib-path-err")

                        self.rib_path_limit = YLeaf(YType.uint32, "rib-path-limit")

                        self.rib_route_err = YLeaf(YType.uint32, "rib-route-err")

                        self.rib_route_limit = YLeaf(YType.uint32, "rib-route-limit")

                        self.rib_route_some_err = YLeaf(YType.uint32, "rib-route-some-err")

                        self.rib_sum_latency = YLeaf(YType.uint64, "rib-sum-latency")

                        self.wq_signals = YLeaf(YType.uint32, "wq-signals")

                        self.wq_thread_active = YLeaf(YType.boolean, "wq-thread-active")

                        self.rib_base_time = Ospfv3.Processes.Process.Statistics.RibThreadStats.RibBaseTime()
                        self.rib_base_time.parent = self
                        self._children_name_map["rib_base_time"] = "rib-base-time"
                        self._children_yang_names.add("rib-base-time")

                        self.thread_q = Ospfv3.Processes.Process.Statistics.RibThreadStats.ThreadQ()
                        self.thread_q.parent = self
                        self._children_name_map["thread_q"] = "thread-q"
                        self._children_yang_names.add("thread-q")

                        self.holdq = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("rib_base_clock",
                                        "rib_batch_backup",
                                        "rib_batch_err",
                                        "rib_batch_limit",
                                        "rib_batch_no_table",
                                        "rib_batch_ok",
                                        "rib_batch_purged",
                                        "rib_batch_sent",
                                        "rib_batch_some_err",
                                        "rib_drop_conn",
                                        "rib_drop_version",
                                        "rib_max_latency",
                                        "rib_path_err",
                                        "rib_path_limit",
                                        "rib_route_err",
                                        "rib_route_limit",
                                        "rib_route_some_err",
                                        "rib_sum_latency",
                                        "wq_signals",
                                        "wq_thread_active") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.Statistics.RibThreadStats, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.Statistics.RibThreadStats, self).__setattr__(name, value)


                    class ThreadQ(Entity):
                        """
                        Inter Thread Queue
                        
                        .. attribute:: wq_dequeue_errs
                        
                        	Dequeue Errors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: wq_dqtime
                        
                        	Last Entry Dequeue
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: wq_eneueue_errs
                        
                        	Enqueue Errors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: wq_eqtime
                        
                        	Head Entry Enqueue
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: wq_first_eqtime
                        
                        	First Entry Enqueue
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: wq_len_cur
                        
                        	Current Work Queue Length
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: wq_len_max
                        
                        	Largest Work Queue Length
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: wq_max_latency
                        
                        	Max Time Entry Was In Q
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: wq_sum_latency
                        
                        	Sum Latencies To Calc Average
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: wq_total_dequeued
                        
                        	Total Entries Dequeued
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: wq_total_enqueued
                        
                        	Total Entries Enqueued
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.RibThreadStats.ThreadQ, self).__init__()

                            self.yang_name = "thread-q"
                            self.yang_parent_name = "rib-thread-stats"

                            self.wq_dequeue_errs = YLeaf(YType.uint32, "wq-dequeue-errs")

                            self.wq_dqtime = YLeaf(YType.uint64, "wq-dqtime")

                            self.wq_eneueue_errs = YLeaf(YType.uint32, "wq-eneueue-errs")

                            self.wq_eqtime = YLeaf(YType.uint64, "wq-eqtime")

                            self.wq_first_eqtime = YLeaf(YType.uint64, "wq-first-eqtime")

                            self.wq_len_cur = YLeaf(YType.int32, "wq-len-cur")

                            self.wq_len_max = YLeaf(YType.int32, "wq-len-max")

                            self.wq_max_latency = YLeaf(YType.uint64, "wq-max-latency")

                            self.wq_sum_latency = YLeaf(YType.uint64, "wq-sum-latency")

                            self.wq_total_dequeued = YLeaf(YType.uint32, "wq-total-dequeued")

                            self.wq_total_enqueued = YLeaf(YType.uint32, "wq-total-enqueued")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("wq_dequeue_errs",
                                            "wq_dqtime",
                                            "wq_eneueue_errs",
                                            "wq_eqtime",
                                            "wq_first_eqtime",
                                            "wq_len_cur",
                                            "wq_len_max",
                                            "wq_max_latency",
                                            "wq_sum_latency",
                                            "wq_total_dequeued",
                                            "wq_total_enqueued") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.RibThreadStats.ThreadQ, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.RibThreadStats.ThreadQ, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.wq_dequeue_errs.is_set or
                                self.wq_dqtime.is_set or
                                self.wq_eneueue_errs.is_set or
                                self.wq_eqtime.is_set or
                                self.wq_first_eqtime.is_set or
                                self.wq_len_cur.is_set or
                                self.wq_len_max.is_set or
                                self.wq_max_latency.is_set or
                                self.wq_sum_latency.is_set or
                                self.wq_total_dequeued.is_set or
                                self.wq_total_enqueued.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.wq_dequeue_errs.yfilter != YFilter.not_set or
                                self.wq_dqtime.yfilter != YFilter.not_set or
                                self.wq_eneueue_errs.yfilter != YFilter.not_set or
                                self.wq_eqtime.yfilter != YFilter.not_set or
                                self.wq_first_eqtime.yfilter != YFilter.not_set or
                                self.wq_len_cur.yfilter != YFilter.not_set or
                                self.wq_len_max.yfilter != YFilter.not_set or
                                self.wq_max_latency.yfilter != YFilter.not_set or
                                self.wq_sum_latency.yfilter != YFilter.not_set or
                                self.wq_total_dequeued.yfilter != YFilter.not_set or
                                self.wq_total_enqueued.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "thread-q" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.wq_dequeue_errs.is_set or self.wq_dequeue_errs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_dequeue_errs.get_name_leafdata())
                            if (self.wq_dqtime.is_set or self.wq_dqtime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_dqtime.get_name_leafdata())
                            if (self.wq_eneueue_errs.is_set or self.wq_eneueue_errs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_eneueue_errs.get_name_leafdata())
                            if (self.wq_eqtime.is_set or self.wq_eqtime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_eqtime.get_name_leafdata())
                            if (self.wq_first_eqtime.is_set or self.wq_first_eqtime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_first_eqtime.get_name_leafdata())
                            if (self.wq_len_cur.is_set or self.wq_len_cur.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_len_cur.get_name_leafdata())
                            if (self.wq_len_max.is_set or self.wq_len_max.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_len_max.get_name_leafdata())
                            if (self.wq_max_latency.is_set or self.wq_max_latency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_max_latency.get_name_leafdata())
                            if (self.wq_sum_latency.is_set or self.wq_sum_latency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_sum_latency.get_name_leafdata())
                            if (self.wq_total_dequeued.is_set or self.wq_total_dequeued.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_total_dequeued.get_name_leafdata())
                            if (self.wq_total_enqueued.is_set or self.wq_total_enqueued.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_total_enqueued.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "wq-dequeue-errs" or name == "wq-dqtime" or name == "wq-eneueue-errs" or name == "wq-eqtime" or name == "wq-first-eqtime" or name == "wq-len-cur" or name == "wq-len-max" or name == "wq-max-latency" or name == "wq-sum-latency" or name == "wq-total-dequeued" or name == "wq-total-enqueued"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "wq-dequeue-errs"):
                                self.wq_dequeue_errs = value
                                self.wq_dequeue_errs.value_namespace = name_space
                                self.wq_dequeue_errs.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-dqtime"):
                                self.wq_dqtime = value
                                self.wq_dqtime.value_namespace = name_space
                                self.wq_dqtime.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-eneueue-errs"):
                                self.wq_eneueue_errs = value
                                self.wq_eneueue_errs.value_namespace = name_space
                                self.wq_eneueue_errs.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-eqtime"):
                                self.wq_eqtime = value
                                self.wq_eqtime.value_namespace = name_space
                                self.wq_eqtime.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-first-eqtime"):
                                self.wq_first_eqtime = value
                                self.wq_first_eqtime.value_namespace = name_space
                                self.wq_first_eqtime.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-len-cur"):
                                self.wq_len_cur = value
                                self.wq_len_cur.value_namespace = name_space
                                self.wq_len_cur.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-len-max"):
                                self.wq_len_max = value
                                self.wq_len_max.value_namespace = name_space
                                self.wq_len_max.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-max-latency"):
                                self.wq_max_latency = value
                                self.wq_max_latency.value_namespace = name_space
                                self.wq_max_latency.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-sum-latency"):
                                self.wq_sum_latency = value
                                self.wq_sum_latency.value_namespace = name_space
                                self.wq_sum_latency.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-total-dequeued"):
                                self.wq_total_dequeued = value
                                self.wq_total_dequeued.value_namespace = name_space
                                self.wq_total_dequeued.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-total-enqueued"):
                                self.wq_total_enqueued = value
                                self.wq_total_enqueued.value_namespace = name_space
                                self.wq_total_enqueued.value_namespace_prefix = name_space_prefix


                    class RibBaseTime(Entity):
                        """
                        rib base time
                        
                        .. attribute:: nanosecond
                        
                        	Nano seconds 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: second
                        
                        	Seconds 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.RibThreadStats.RibBaseTime, self).__init__()

                            self.yang_name = "rib-base-time"
                            self.yang_parent_name = "rib-thread-stats"

                            self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                            self.second = YLeaf(YType.uint32, "second")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("nanosecond",
                                            "second") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.RibThreadStats.RibBaseTime, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.RibThreadStats.RibBaseTime, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.nanosecond.is_set or
                                self.second.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.nanosecond.yfilter != YFilter.not_set or
                                self.second.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rib-base-time" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nanosecond.get_name_leafdata())
                            if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.second.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "nanosecond" or name == "second"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "nanosecond"):
                                self.nanosecond = value
                                self.nanosecond.value_namespace = name_space
                                self.nanosecond.value_namespace_prefix = name_space_prefix
                            if(value_path == "second"):
                                self.second = value
                                self.second.value_namespace = name_space
                                self.second.value_namespace_prefix = name_space_prefix


                    class Holdq(Entity):
                        """
                        holdq
                        
                        .. attribute:: wq_dequeue_errs
                        
                        	Dequeue Errors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: wq_dqtime
                        
                        	Last Entry Dequeue
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: wq_eneueue_errs
                        
                        	Enqueue Errors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: wq_eqtime
                        
                        	Head Entry Enqueue
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: wq_first_eqtime
                        
                        	First Entry Enqueue
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: wq_len_cur
                        
                        	Current Work Queue Length
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: wq_len_max
                        
                        	Largest Work Queue Length
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: wq_max_latency
                        
                        	Max Time Entry Was In Q
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: wq_sum_latency
                        
                        	Sum Latencies To Calc Average
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: wq_total_dequeued
                        
                        	Total Entries Dequeued
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: wq_total_enqueued
                        
                        	Total Entries Enqueued
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.RibThreadStats.Holdq, self).__init__()

                            self.yang_name = "holdq"
                            self.yang_parent_name = "rib-thread-stats"

                            self.wq_dequeue_errs = YLeaf(YType.uint32, "wq-dequeue-errs")

                            self.wq_dqtime = YLeaf(YType.uint64, "wq-dqtime")

                            self.wq_eneueue_errs = YLeaf(YType.uint32, "wq-eneueue-errs")

                            self.wq_eqtime = YLeaf(YType.uint64, "wq-eqtime")

                            self.wq_first_eqtime = YLeaf(YType.uint64, "wq-first-eqtime")

                            self.wq_len_cur = YLeaf(YType.int32, "wq-len-cur")

                            self.wq_len_max = YLeaf(YType.int32, "wq-len-max")

                            self.wq_max_latency = YLeaf(YType.uint64, "wq-max-latency")

                            self.wq_sum_latency = YLeaf(YType.uint64, "wq-sum-latency")

                            self.wq_total_dequeued = YLeaf(YType.uint32, "wq-total-dequeued")

                            self.wq_total_enqueued = YLeaf(YType.uint32, "wq-total-enqueued")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("wq_dequeue_errs",
                                            "wq_dqtime",
                                            "wq_eneueue_errs",
                                            "wq_eqtime",
                                            "wq_first_eqtime",
                                            "wq_len_cur",
                                            "wq_len_max",
                                            "wq_max_latency",
                                            "wq_sum_latency",
                                            "wq_total_dequeued",
                                            "wq_total_enqueued") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.RibThreadStats.Holdq, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.RibThreadStats.Holdq, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.wq_dequeue_errs.is_set or
                                self.wq_dqtime.is_set or
                                self.wq_eneueue_errs.is_set or
                                self.wq_eqtime.is_set or
                                self.wq_first_eqtime.is_set or
                                self.wq_len_cur.is_set or
                                self.wq_len_max.is_set or
                                self.wq_max_latency.is_set or
                                self.wq_sum_latency.is_set or
                                self.wq_total_dequeued.is_set or
                                self.wq_total_enqueued.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.wq_dequeue_errs.yfilter != YFilter.not_set or
                                self.wq_dqtime.yfilter != YFilter.not_set or
                                self.wq_eneueue_errs.yfilter != YFilter.not_set or
                                self.wq_eqtime.yfilter != YFilter.not_set or
                                self.wq_first_eqtime.yfilter != YFilter.not_set or
                                self.wq_len_cur.yfilter != YFilter.not_set or
                                self.wq_len_max.yfilter != YFilter.not_set or
                                self.wq_max_latency.yfilter != YFilter.not_set or
                                self.wq_sum_latency.yfilter != YFilter.not_set or
                                self.wq_total_dequeued.yfilter != YFilter.not_set or
                                self.wq_total_enqueued.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "holdq" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.wq_dequeue_errs.is_set or self.wq_dequeue_errs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_dequeue_errs.get_name_leafdata())
                            if (self.wq_dqtime.is_set or self.wq_dqtime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_dqtime.get_name_leafdata())
                            if (self.wq_eneueue_errs.is_set or self.wq_eneueue_errs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_eneueue_errs.get_name_leafdata())
                            if (self.wq_eqtime.is_set or self.wq_eqtime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_eqtime.get_name_leafdata())
                            if (self.wq_first_eqtime.is_set or self.wq_first_eqtime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_first_eqtime.get_name_leafdata())
                            if (self.wq_len_cur.is_set or self.wq_len_cur.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_len_cur.get_name_leafdata())
                            if (self.wq_len_max.is_set or self.wq_len_max.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_len_max.get_name_leafdata())
                            if (self.wq_max_latency.is_set or self.wq_max_latency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_max_latency.get_name_leafdata())
                            if (self.wq_sum_latency.is_set or self.wq_sum_latency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_sum_latency.get_name_leafdata())
                            if (self.wq_total_dequeued.is_set or self.wq_total_dequeued.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_total_dequeued.get_name_leafdata())
                            if (self.wq_total_enqueued.is_set or self.wq_total_enqueued.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wq_total_enqueued.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "wq-dequeue-errs" or name == "wq-dqtime" or name == "wq-eneueue-errs" or name == "wq-eqtime" or name == "wq-first-eqtime" or name == "wq-len-cur" or name == "wq-len-max" or name == "wq-max-latency" or name == "wq-sum-latency" or name == "wq-total-dequeued" or name == "wq-total-enqueued"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "wq-dequeue-errs"):
                                self.wq_dequeue_errs = value
                                self.wq_dequeue_errs.value_namespace = name_space
                                self.wq_dequeue_errs.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-dqtime"):
                                self.wq_dqtime = value
                                self.wq_dqtime.value_namespace = name_space
                                self.wq_dqtime.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-eneueue-errs"):
                                self.wq_eneueue_errs = value
                                self.wq_eneueue_errs.value_namespace = name_space
                                self.wq_eneueue_errs.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-eqtime"):
                                self.wq_eqtime = value
                                self.wq_eqtime.value_namespace = name_space
                                self.wq_eqtime.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-first-eqtime"):
                                self.wq_first_eqtime = value
                                self.wq_first_eqtime.value_namespace = name_space
                                self.wq_first_eqtime.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-len-cur"):
                                self.wq_len_cur = value
                                self.wq_len_cur.value_namespace = name_space
                                self.wq_len_cur.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-len-max"):
                                self.wq_len_max = value
                                self.wq_len_max.value_namespace = name_space
                                self.wq_len_max.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-max-latency"):
                                self.wq_max_latency = value
                                self.wq_max_latency.value_namespace = name_space
                                self.wq_max_latency.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-sum-latency"):
                                self.wq_sum_latency = value
                                self.wq_sum_latency.value_namespace = name_space
                                self.wq_sum_latency.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-total-dequeued"):
                                self.wq_total_dequeued = value
                                self.wq_total_dequeued.value_namespace = name_space
                                self.wq_total_dequeued.value_namespace_prefix = name_space_prefix
                            if(value_path == "wq-total-enqueued"):
                                self.wq_total_enqueued = value
                                self.wq_total_enqueued.value_namespace = name_space
                                self.wq_total_enqueued.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.holdq:
                            if (c.has_data()):
                                return True
                        return (
                            self.rib_base_clock.is_set or
                            self.rib_batch_backup.is_set or
                            self.rib_batch_err.is_set or
                            self.rib_batch_limit.is_set or
                            self.rib_batch_no_table.is_set or
                            self.rib_batch_ok.is_set or
                            self.rib_batch_purged.is_set or
                            self.rib_batch_sent.is_set or
                            self.rib_batch_some_err.is_set or
                            self.rib_drop_conn.is_set or
                            self.rib_drop_version.is_set or
                            self.rib_max_latency.is_set or
                            self.rib_path_err.is_set or
                            self.rib_path_limit.is_set or
                            self.rib_route_err.is_set or
                            self.rib_route_limit.is_set or
                            self.rib_route_some_err.is_set or
                            self.rib_sum_latency.is_set or
                            self.wq_signals.is_set or
                            self.wq_thread_active.is_set or
                            (self.rib_base_time is not None and self.rib_base_time.has_data()) or
                            (self.thread_q is not None and self.thread_q.has_data()))

                    def has_operation(self):
                        for c in self.holdq:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.rib_base_clock.yfilter != YFilter.not_set or
                            self.rib_batch_backup.yfilter != YFilter.not_set or
                            self.rib_batch_err.yfilter != YFilter.not_set or
                            self.rib_batch_limit.yfilter != YFilter.not_set or
                            self.rib_batch_no_table.yfilter != YFilter.not_set or
                            self.rib_batch_ok.yfilter != YFilter.not_set or
                            self.rib_batch_purged.yfilter != YFilter.not_set or
                            self.rib_batch_sent.yfilter != YFilter.not_set or
                            self.rib_batch_some_err.yfilter != YFilter.not_set or
                            self.rib_drop_conn.yfilter != YFilter.not_set or
                            self.rib_drop_version.yfilter != YFilter.not_set or
                            self.rib_max_latency.yfilter != YFilter.not_set or
                            self.rib_path_err.yfilter != YFilter.not_set or
                            self.rib_path_limit.yfilter != YFilter.not_set or
                            self.rib_route_err.yfilter != YFilter.not_set or
                            self.rib_route_limit.yfilter != YFilter.not_set or
                            self.rib_route_some_err.yfilter != YFilter.not_set or
                            self.rib_sum_latency.yfilter != YFilter.not_set or
                            self.wq_signals.yfilter != YFilter.not_set or
                            self.wq_thread_active.yfilter != YFilter.not_set or
                            (self.rib_base_time is not None and self.rib_base_time.has_operation()) or
                            (self.thread_q is not None and self.thread_q.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rib-thread-stats" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.rib_base_clock.is_set or self.rib_base_clock.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_base_clock.get_name_leafdata())
                        if (self.rib_batch_backup.is_set or self.rib_batch_backup.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_batch_backup.get_name_leafdata())
                        if (self.rib_batch_err.is_set or self.rib_batch_err.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_batch_err.get_name_leafdata())
                        if (self.rib_batch_limit.is_set or self.rib_batch_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_batch_limit.get_name_leafdata())
                        if (self.rib_batch_no_table.is_set or self.rib_batch_no_table.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_batch_no_table.get_name_leafdata())
                        if (self.rib_batch_ok.is_set or self.rib_batch_ok.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_batch_ok.get_name_leafdata())
                        if (self.rib_batch_purged.is_set or self.rib_batch_purged.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_batch_purged.get_name_leafdata())
                        if (self.rib_batch_sent.is_set or self.rib_batch_sent.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_batch_sent.get_name_leafdata())
                        if (self.rib_batch_some_err.is_set or self.rib_batch_some_err.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_batch_some_err.get_name_leafdata())
                        if (self.rib_drop_conn.is_set or self.rib_drop_conn.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_drop_conn.get_name_leafdata())
                        if (self.rib_drop_version.is_set or self.rib_drop_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_drop_version.get_name_leafdata())
                        if (self.rib_max_latency.is_set or self.rib_max_latency.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_max_latency.get_name_leafdata())
                        if (self.rib_path_err.is_set or self.rib_path_err.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_path_err.get_name_leafdata())
                        if (self.rib_path_limit.is_set or self.rib_path_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_path_limit.get_name_leafdata())
                        if (self.rib_route_err.is_set or self.rib_route_err.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_route_err.get_name_leafdata())
                        if (self.rib_route_limit.is_set or self.rib_route_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_route_limit.get_name_leafdata())
                        if (self.rib_route_some_err.is_set or self.rib_route_some_err.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_route_some_err.get_name_leafdata())
                        if (self.rib_sum_latency.is_set or self.rib_sum_latency.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rib_sum_latency.get_name_leafdata())
                        if (self.wq_signals.is_set or self.wq_signals.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.wq_signals.get_name_leafdata())
                        if (self.wq_thread_active.is_set or self.wq_thread_active.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.wq_thread_active.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "holdq"):
                            for c in self.holdq:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.Statistics.RibThreadStats.Holdq()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.holdq.append(c)
                            return c

                        if (child_yang_name == "rib-base-time"):
                            if (self.rib_base_time is None):
                                self.rib_base_time = Ospfv3.Processes.Process.Statistics.RibThreadStats.RibBaseTime()
                                self.rib_base_time.parent = self
                                self._children_name_map["rib_base_time"] = "rib-base-time"
                            return self.rib_base_time

                        if (child_yang_name == "thread-q"):
                            if (self.thread_q is None):
                                self.thread_q = Ospfv3.Processes.Process.Statistics.RibThreadStats.ThreadQ()
                                self.thread_q.parent = self
                                self._children_name_map["thread_q"] = "thread-q"
                            return self.thread_q

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "holdq" or name == "rib-base-time" or name == "thread-q" or name == "rib-base-clock" or name == "rib-batch-backup" or name == "rib-batch-err" or name == "rib-batch-limit" or name == "rib-batch-no-table" or name == "rib-batch-ok" or name == "rib-batch-purged" or name == "rib-batch-sent" or name == "rib-batch-some-err" or name == "rib-drop-conn" or name == "rib-drop-version" or name == "rib-max-latency" or name == "rib-path-err" or name == "rib-path-limit" or name == "rib-route-err" or name == "rib-route-limit" or name == "rib-route-some-err" or name == "rib-sum-latency" or name == "wq-signals" or name == "wq-thread-active"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "rib-base-clock"):
                            self.rib_base_clock = value
                            self.rib_base_clock.value_namespace = name_space
                            self.rib_base_clock.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-batch-backup"):
                            self.rib_batch_backup = value
                            self.rib_batch_backup.value_namespace = name_space
                            self.rib_batch_backup.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-batch-err"):
                            self.rib_batch_err = value
                            self.rib_batch_err.value_namespace = name_space
                            self.rib_batch_err.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-batch-limit"):
                            self.rib_batch_limit = value
                            self.rib_batch_limit.value_namespace = name_space
                            self.rib_batch_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-batch-no-table"):
                            self.rib_batch_no_table = value
                            self.rib_batch_no_table.value_namespace = name_space
                            self.rib_batch_no_table.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-batch-ok"):
                            self.rib_batch_ok = value
                            self.rib_batch_ok.value_namespace = name_space
                            self.rib_batch_ok.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-batch-purged"):
                            self.rib_batch_purged = value
                            self.rib_batch_purged.value_namespace = name_space
                            self.rib_batch_purged.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-batch-sent"):
                            self.rib_batch_sent = value
                            self.rib_batch_sent.value_namespace = name_space
                            self.rib_batch_sent.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-batch-some-err"):
                            self.rib_batch_some_err = value
                            self.rib_batch_some_err.value_namespace = name_space
                            self.rib_batch_some_err.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-drop-conn"):
                            self.rib_drop_conn = value
                            self.rib_drop_conn.value_namespace = name_space
                            self.rib_drop_conn.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-drop-version"):
                            self.rib_drop_version = value
                            self.rib_drop_version.value_namespace = name_space
                            self.rib_drop_version.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-max-latency"):
                            self.rib_max_latency = value
                            self.rib_max_latency.value_namespace = name_space
                            self.rib_max_latency.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-path-err"):
                            self.rib_path_err = value
                            self.rib_path_err.value_namespace = name_space
                            self.rib_path_err.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-path-limit"):
                            self.rib_path_limit = value
                            self.rib_path_limit.value_namespace = name_space
                            self.rib_path_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-route-err"):
                            self.rib_route_err = value
                            self.rib_route_err.value_namespace = name_space
                            self.rib_route_err.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-route-limit"):
                            self.rib_route_limit = value
                            self.rib_route_limit.value_namespace = name_space
                            self.rib_route_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-route-some-err"):
                            self.rib_route_some_err = value
                            self.rib_route_some_err.value_namespace = name_space
                            self.rib_route_some_err.value_namespace_prefix = name_space_prefix
                        if(value_path == "rib-sum-latency"):
                            self.rib_sum_latency = value
                            self.rib_sum_latency.value_namespace = name_space
                            self.rib_sum_latency.value_namespace_prefix = name_space_prefix
                        if(value_path == "wq-signals"):
                            self.wq_signals = value
                            self.wq_signals.value_namespace = name_space
                            self.wq_signals.value_namespace_prefix = name_space_prefix
                        if(value_path == "wq-thread-active"):
                            self.wq_thread_active = value
                            self.wq_thread_active.value_namespace = name_space
                            self.wq_thread_active.value_namespace_prefix = name_space_prefix


                class IssuStats(Entity):
                    """
                    OSPF ISSU statistics
                    
                    .. attribute:: nsr_conn_to_active_attempts
                    
                    	Attempts to connect to active
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: nsr_conn_to_active_closes
                    
                    	Conn to active closes
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: nsr_conn_to_active_errors
                    
                    	Conn to active errors
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: nsr_conn_to_active_fails
                    
                    	Failures to connect to active
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: nsr_conn_to_active_opens
                    
                    	Conn to active opens
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: nsr_fsm_state
                    
                    	FSM state
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nsr_intf_seq_no
                    
                    	Interface TLV sequence no
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_lsa_init_sync_pend_count
                    
                    	Pending init\-sync LSA msgs
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nsr_lsa_qad_mdata_count
                    
                    	LSA QAD pending msgs
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_lsa_qad_qid
                    
                    	LSA QAD queue id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_mtu
                    
                    	Fabric MTU
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_nbr_init_sync_pend_count
                    
                    	Pending init\-sync NBR msgs
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nsr_nbr_qad_mdata_count
                    
                    	NBR QAD pending msg
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_nbr_qad_qid
                    
                    	NBR QAD queue id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_nbr_seq_no
                    
                    	Neighbor TLV sequence no
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_node_id
                    
                    	My nodeid
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_peer_node_id
                    
                    	Partner NodeID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_peer_version
                    
                    	Partner NSR version
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_revision
                    
                    	NSR revision
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nsr_rtr_thd_sched
                    
                    	Rtr thread NSR pulse handler stats
                    	**type**\:   :py:class:`NsrRtrThdSched <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched>`
                    
                    .. attribute:: nsr_thd_stats
                    
                    	NSR thread scheduler stats
                    	**type**\:   :py:class:`NsrThdStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats>`
                    
                    .. attribute:: nsr_tmr_quant
                    
                    	Timers processed per pulse
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nsr_version
                    
                    	NSR version
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.Statistics.IssuStats, self).__init__()

                        self.yang_name = "issu-stats"
                        self.yang_parent_name = "statistics"

                        self.nsr_conn_to_active_attempts = YLeaf(YType.uint64, "nsr-conn-to-active-attempts")

                        self.nsr_conn_to_active_closes = YLeaf(YType.uint64, "nsr-conn-to-active-closes")

                        self.nsr_conn_to_active_errors = YLeaf(YType.uint64, "nsr-conn-to-active-errors")

                        self.nsr_conn_to_active_fails = YLeaf(YType.uint64, "nsr-conn-to-active-fails")

                        self.nsr_conn_to_active_opens = YLeaf(YType.uint64, "nsr-conn-to-active-opens")

                        self.nsr_fsm_state = YLeaf(YType.int32, "nsr-fsm-state")

                        self.nsr_intf_seq_no = YLeaf(YType.uint32, "nsr-intf-seq-no")

                        self.nsr_lsa_init_sync_pend_count = YLeaf(YType.int32, "nsr-lsa-init-sync-pend-count")

                        self.nsr_lsa_qad_mdata_count = YLeaf(YType.uint32, "nsr-lsa-qad-mdata-count")

                        self.nsr_lsa_qad_qid = YLeaf(YType.uint32, "nsr-lsa-qad-qid")

                        self.nsr_mtu = YLeaf(YType.uint32, "nsr-mtu")

                        self.nsr_nbr_init_sync_pend_count = YLeaf(YType.int32, "nsr-nbr-init-sync-pend-count")

                        self.nsr_nbr_qad_mdata_count = YLeaf(YType.uint32, "nsr-nbr-qad-mdata-count")

                        self.nsr_nbr_qad_qid = YLeaf(YType.uint32, "nsr-nbr-qad-qid")

                        self.nsr_nbr_seq_no = YLeaf(YType.uint32, "nsr-nbr-seq-no")

                        self.nsr_node_id = YLeaf(YType.uint32, "nsr-node-id")

                        self.nsr_peer_node_id = YLeaf(YType.uint32, "nsr-peer-node-id")

                        self.nsr_peer_version = YLeaf(YType.uint32, "nsr-peer-version")

                        self.nsr_revision = YLeaf(YType.int32, "nsr-revision")

                        self.nsr_tmr_quant = YLeaf(YType.int32, "nsr-tmr-quant")

                        self.nsr_version = YLeaf(YType.uint32, "nsr-version")

                        self.nsr_rtr_thd_sched = Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched()
                        self.nsr_rtr_thd_sched.parent = self
                        self._children_name_map["nsr_rtr_thd_sched"] = "nsr-rtr-thd-sched"
                        self._children_yang_names.add("nsr-rtr-thd-sched")

                        self.nsr_thd_stats = Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats()
                        self.nsr_thd_stats.parent = self
                        self._children_name_map["nsr_thd_stats"] = "nsr-thd-stats"
                        self._children_yang_names.add("nsr-thd-stats")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("nsr_conn_to_active_attempts",
                                        "nsr_conn_to_active_closes",
                                        "nsr_conn_to_active_errors",
                                        "nsr_conn_to_active_fails",
                                        "nsr_conn_to_active_opens",
                                        "nsr_fsm_state",
                                        "nsr_intf_seq_no",
                                        "nsr_lsa_init_sync_pend_count",
                                        "nsr_lsa_qad_mdata_count",
                                        "nsr_lsa_qad_qid",
                                        "nsr_mtu",
                                        "nsr_nbr_init_sync_pend_count",
                                        "nsr_nbr_qad_mdata_count",
                                        "nsr_nbr_qad_qid",
                                        "nsr_nbr_seq_no",
                                        "nsr_node_id",
                                        "nsr_peer_node_id",
                                        "nsr_peer_version",
                                        "nsr_revision",
                                        "nsr_tmr_quant",
                                        "nsr_version") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.Statistics.IssuStats, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.Statistics.IssuStats, self).__setattr__(name, value)


                    class NsrThdStats(Entity):
                        """
                        NSR thread scheduler stats
                        
                        .. attribute:: nsr_bad_pulses_rx
                        
                        	Bad pulses received
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_events_in_q
                        
                        	Events pending
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nsr_events_rx
                        
                        	Events processed
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_events_tx
                        
                        	Events to Router thread
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_good_pulses_rx
                        
                        	Good pulses received
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_pri
                        
                        	nsr pri
                        	**type**\: list of    :py:class:`NsrPri <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats.NsrPri>`
                        
                        .. attribute:: nsr_pulse_quant
                        
                        	Events processed per pulse
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: nsr_pulse_tx_fails
                        
                        	Pulse send failures
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_pulses_tx
                        
                        	Pulses to Router thread
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats, self).__init__()

                            self.yang_name = "nsr-thd-stats"
                            self.yang_parent_name = "issu-stats"

                            self.nsr_bad_pulses_rx = YLeaf(YType.uint64, "nsr-bad-pulses-rx")

                            self.nsr_events_in_q = YLeaf(YType.uint32, "nsr-events-in-q")

                            self.nsr_events_rx = YLeaf(YType.uint64, "nsr-events-rx")

                            self.nsr_events_tx = YLeaf(YType.uint64, "nsr-events-tx")

                            self.nsr_good_pulses_rx = YLeaf(YType.uint64, "nsr-good-pulses-rx")

                            self.nsr_pulse_quant = YLeaf(YType.int32, "nsr-pulse-quant")

                            self.nsr_pulse_tx_fails = YLeaf(YType.uint64, "nsr-pulse-tx-fails")

                            self.nsr_pulses_tx = YLeaf(YType.uint64, "nsr-pulses-tx")

                            self.nsr_pri = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("nsr_bad_pulses_rx",
                                            "nsr_events_in_q",
                                            "nsr_events_rx",
                                            "nsr_events_tx",
                                            "nsr_good_pulses_rx",
                                            "nsr_pulse_quant",
                                            "nsr_pulse_tx_fails",
                                            "nsr_pulses_tx") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats, self).__setattr__(name, value)


                        class NsrPri(Entity):
                            """
                            nsr pri
                            
                            .. attribute:: nsr_sched_enq_fails
                            
                            	Event enqueue fails
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_evs_deqd
                            
                            	Events dequeued
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_evs_in_q
                            
                            	Events pending
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_evs_qd
                            
                            	Events queued
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_max_evs
                            
                            	Max Queued
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_peak_q_len
                            
                            	Peak queue length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_pri
                            
                            	Priority Type
                            	**type**\:   :py:class:`OspfNsrSchedPri <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfNsrSchedPri>`
                            
                            .. attribute:: nsr_sched_quant
                            
                            	Priority Queue
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: nsr_sched_remain_quant
                            
                            	Remaining quantum
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats.NsrPri, self).__init__()

                                self.yang_name = "nsr-pri"
                                self.yang_parent_name = "nsr-thd-stats"

                                self.nsr_sched_enq_fails = YLeaf(YType.uint64, "nsr-sched-enq-fails")

                                self.nsr_sched_evs_deqd = YLeaf(YType.uint64, "nsr-sched-evs-deqd")

                                self.nsr_sched_evs_in_q = YLeaf(YType.uint16, "nsr-sched-evs-in-q")

                                self.nsr_sched_evs_qd = YLeaf(YType.uint64, "nsr-sched-evs-qd")

                                self.nsr_sched_max_evs = YLeaf(YType.uint16, "nsr-sched-max-evs")

                                self.nsr_sched_peak_q_len = YLeaf(YType.uint16, "nsr-sched-peak-q-len")

                                self.nsr_sched_pri = YLeaf(YType.enumeration, "nsr-sched-pri")

                                self.nsr_sched_quant = YLeaf(YType.uint8, "nsr-sched-quant")

                                self.nsr_sched_remain_quant = YLeaf(YType.uint8, "nsr-sched-remain-quant")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_sched_enq_fails",
                                                "nsr_sched_evs_deqd",
                                                "nsr_sched_evs_in_q",
                                                "nsr_sched_evs_qd",
                                                "nsr_sched_max_evs",
                                                "nsr_sched_peak_q_len",
                                                "nsr_sched_pri",
                                                "nsr_sched_quant",
                                                "nsr_sched_remain_quant") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats.NsrPri, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats.NsrPri, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nsr_sched_enq_fails.is_set or
                                    self.nsr_sched_evs_deqd.is_set or
                                    self.nsr_sched_evs_in_q.is_set or
                                    self.nsr_sched_evs_qd.is_set or
                                    self.nsr_sched_max_evs.is_set or
                                    self.nsr_sched_peak_q_len.is_set or
                                    self.nsr_sched_pri.is_set or
                                    self.nsr_sched_quant.is_set or
                                    self.nsr_sched_remain_quant.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_sched_enq_fails.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_deqd.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_in_q.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_qd.yfilter != YFilter.not_set or
                                    self.nsr_sched_max_evs.yfilter != YFilter.not_set or
                                    self.nsr_sched_peak_q_len.yfilter != YFilter.not_set or
                                    self.nsr_sched_pri.yfilter != YFilter.not_set or
                                    self.nsr_sched_quant.yfilter != YFilter.not_set or
                                    self.nsr_sched_remain_quant.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nsr-pri" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nsr_sched_enq_fails.is_set or self.nsr_sched_enq_fails.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_enq_fails.get_name_leafdata())
                                if (self.nsr_sched_evs_deqd.is_set or self.nsr_sched_evs_deqd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_deqd.get_name_leafdata())
                                if (self.nsr_sched_evs_in_q.is_set or self.nsr_sched_evs_in_q.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_in_q.get_name_leafdata())
                                if (self.nsr_sched_evs_qd.is_set or self.nsr_sched_evs_qd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_qd.get_name_leafdata())
                                if (self.nsr_sched_max_evs.is_set or self.nsr_sched_max_evs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_max_evs.get_name_leafdata())
                                if (self.nsr_sched_peak_q_len.is_set or self.nsr_sched_peak_q_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_peak_q_len.get_name_leafdata())
                                if (self.nsr_sched_pri.is_set or self.nsr_sched_pri.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_pri.get_name_leafdata())
                                if (self.nsr_sched_quant.is_set or self.nsr_sched_quant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_quant.get_name_leafdata())
                                if (self.nsr_sched_remain_quant.is_set or self.nsr_sched_remain_quant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_remain_quant.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-sched-enq-fails" or name == "nsr-sched-evs-deqd" or name == "nsr-sched-evs-in-q" or name == "nsr-sched-evs-qd" or name == "nsr-sched-max-evs" or name == "nsr-sched-peak-q-len" or name == "nsr-sched-pri" or name == "nsr-sched-quant" or name == "nsr-sched-remain-quant"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-sched-enq-fails"):
                                    self.nsr_sched_enq_fails = value
                                    self.nsr_sched_enq_fails.value_namespace = name_space
                                    self.nsr_sched_enq_fails.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-deqd"):
                                    self.nsr_sched_evs_deqd = value
                                    self.nsr_sched_evs_deqd.value_namespace = name_space
                                    self.nsr_sched_evs_deqd.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-in-q"):
                                    self.nsr_sched_evs_in_q = value
                                    self.nsr_sched_evs_in_q.value_namespace = name_space
                                    self.nsr_sched_evs_in_q.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-qd"):
                                    self.nsr_sched_evs_qd = value
                                    self.nsr_sched_evs_qd.value_namespace = name_space
                                    self.nsr_sched_evs_qd.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-max-evs"):
                                    self.nsr_sched_max_evs = value
                                    self.nsr_sched_max_evs.value_namespace = name_space
                                    self.nsr_sched_max_evs.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-peak-q-len"):
                                    self.nsr_sched_peak_q_len = value
                                    self.nsr_sched_peak_q_len.value_namespace = name_space
                                    self.nsr_sched_peak_q_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-pri"):
                                    self.nsr_sched_pri = value
                                    self.nsr_sched_pri.value_namespace = name_space
                                    self.nsr_sched_pri.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-quant"):
                                    self.nsr_sched_quant = value
                                    self.nsr_sched_quant.value_namespace = name_space
                                    self.nsr_sched_quant.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-remain-quant"):
                                    self.nsr_sched_remain_quant = value
                                    self.nsr_sched_remain_quant.value_namespace = name_space
                                    self.nsr_sched_remain_quant.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.nsr_pri:
                                if (c.has_data()):
                                    return True
                            return (
                                self.nsr_bad_pulses_rx.is_set or
                                self.nsr_events_in_q.is_set or
                                self.nsr_events_rx.is_set or
                                self.nsr_events_tx.is_set or
                                self.nsr_good_pulses_rx.is_set or
                                self.nsr_pulse_quant.is_set or
                                self.nsr_pulse_tx_fails.is_set or
                                self.nsr_pulses_tx.is_set)

                        def has_operation(self):
                            for c in self.nsr_pri:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.nsr_bad_pulses_rx.yfilter != YFilter.not_set or
                                self.nsr_events_in_q.yfilter != YFilter.not_set or
                                self.nsr_events_rx.yfilter != YFilter.not_set or
                                self.nsr_events_tx.yfilter != YFilter.not_set or
                                self.nsr_good_pulses_rx.yfilter != YFilter.not_set or
                                self.nsr_pulse_quant.yfilter != YFilter.not_set or
                                self.nsr_pulse_tx_fails.yfilter != YFilter.not_set or
                                self.nsr_pulses_tx.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nsr-thd-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.nsr_bad_pulses_rx.is_set or self.nsr_bad_pulses_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_bad_pulses_rx.get_name_leafdata())
                            if (self.nsr_events_in_q.is_set or self.nsr_events_in_q.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_in_q.get_name_leafdata())
                            if (self.nsr_events_rx.is_set or self.nsr_events_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_rx.get_name_leafdata())
                            if (self.nsr_events_tx.is_set or self.nsr_events_tx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_tx.get_name_leafdata())
                            if (self.nsr_good_pulses_rx.is_set or self.nsr_good_pulses_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_good_pulses_rx.get_name_leafdata())
                            if (self.nsr_pulse_quant.is_set or self.nsr_pulse_quant.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulse_quant.get_name_leafdata())
                            if (self.nsr_pulse_tx_fails.is_set or self.nsr_pulse_tx_fails.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulse_tx_fails.get_name_leafdata())
                            if (self.nsr_pulses_tx.is_set or self.nsr_pulses_tx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulses_tx.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "nsr-pri"):
                                for c in self.nsr_pri:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats.NsrPri()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.nsr_pri.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "nsr-pri" or name == "nsr-bad-pulses-rx" or name == "nsr-events-in-q" or name == "nsr-events-rx" or name == "nsr-events-tx" or name == "nsr-good-pulses-rx" or name == "nsr-pulse-quant" or name == "nsr-pulse-tx-fails" or name == "nsr-pulses-tx"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "nsr-bad-pulses-rx"):
                                self.nsr_bad_pulses_rx = value
                                self.nsr_bad_pulses_rx.value_namespace = name_space
                                self.nsr_bad_pulses_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-in-q"):
                                self.nsr_events_in_q = value
                                self.nsr_events_in_q.value_namespace = name_space
                                self.nsr_events_in_q.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-rx"):
                                self.nsr_events_rx = value
                                self.nsr_events_rx.value_namespace = name_space
                                self.nsr_events_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-tx"):
                                self.nsr_events_tx = value
                                self.nsr_events_tx.value_namespace = name_space
                                self.nsr_events_tx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-good-pulses-rx"):
                                self.nsr_good_pulses_rx = value
                                self.nsr_good_pulses_rx.value_namespace = name_space
                                self.nsr_good_pulses_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulse-quant"):
                                self.nsr_pulse_quant = value
                                self.nsr_pulse_quant.value_namespace = name_space
                                self.nsr_pulse_quant.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulse-tx-fails"):
                                self.nsr_pulse_tx_fails = value
                                self.nsr_pulse_tx_fails.value_namespace = name_space
                                self.nsr_pulse_tx_fails.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulses-tx"):
                                self.nsr_pulses_tx = value
                                self.nsr_pulses_tx.value_namespace = name_space
                                self.nsr_pulses_tx.value_namespace_prefix = name_space_prefix


                    class NsrRtrThdSched(Entity):
                        """
                        Rtr thread NSR pulse handler stats
                        
                        .. attribute:: nsr_bad_pulses_rx
                        
                        	Bad pulses received
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_events_in_q
                        
                        	Events pending
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nsr_events_rx
                        
                        	Events processed
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_events_tx
                        
                        	Events to Router thread
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_good_pulses_rx
                        
                        	Good pulses received
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_pri
                        
                        	nsr pri
                        	**type**\: list of    :py:class:`NsrPri <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched.NsrPri>`
                        
                        .. attribute:: nsr_pulse_quant
                        
                        	Events processed per pulse
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: nsr_pulse_tx_fails
                        
                        	Pulse send failures
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: nsr_pulses_tx
                        
                        	Pulses to Router thread
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched, self).__init__()

                            self.yang_name = "nsr-rtr-thd-sched"
                            self.yang_parent_name = "issu-stats"

                            self.nsr_bad_pulses_rx = YLeaf(YType.uint64, "nsr-bad-pulses-rx")

                            self.nsr_events_in_q = YLeaf(YType.uint32, "nsr-events-in-q")

                            self.nsr_events_rx = YLeaf(YType.uint64, "nsr-events-rx")

                            self.nsr_events_tx = YLeaf(YType.uint64, "nsr-events-tx")

                            self.nsr_good_pulses_rx = YLeaf(YType.uint64, "nsr-good-pulses-rx")

                            self.nsr_pulse_quant = YLeaf(YType.int32, "nsr-pulse-quant")

                            self.nsr_pulse_tx_fails = YLeaf(YType.uint64, "nsr-pulse-tx-fails")

                            self.nsr_pulses_tx = YLeaf(YType.uint64, "nsr-pulses-tx")

                            self.nsr_pri = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("nsr_bad_pulses_rx",
                                            "nsr_events_in_q",
                                            "nsr_events_rx",
                                            "nsr_events_tx",
                                            "nsr_good_pulses_rx",
                                            "nsr_pulse_quant",
                                            "nsr_pulse_tx_fails",
                                            "nsr_pulses_tx") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched, self).__setattr__(name, value)


                        class NsrPri(Entity):
                            """
                            nsr pri
                            
                            .. attribute:: nsr_sched_enq_fails
                            
                            	Event enqueue fails
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_evs_deqd
                            
                            	Events dequeued
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_evs_in_q
                            
                            	Events pending
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_evs_qd
                            
                            	Events queued
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: nsr_sched_max_evs
                            
                            	Max Queued
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_peak_q_len
                            
                            	Peak queue length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nsr_sched_pri
                            
                            	Priority Type
                            	**type**\:   :py:class:`OspfNsrSchedPri <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfNsrSchedPri>`
                            
                            .. attribute:: nsr_sched_quant
                            
                            	Priority Queue
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: nsr_sched_remain_quant
                            
                            	Remaining quantum
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched.NsrPri, self).__init__()

                                self.yang_name = "nsr-pri"
                                self.yang_parent_name = "nsr-rtr-thd-sched"

                                self.nsr_sched_enq_fails = YLeaf(YType.uint64, "nsr-sched-enq-fails")

                                self.nsr_sched_evs_deqd = YLeaf(YType.uint64, "nsr-sched-evs-deqd")

                                self.nsr_sched_evs_in_q = YLeaf(YType.uint16, "nsr-sched-evs-in-q")

                                self.nsr_sched_evs_qd = YLeaf(YType.uint64, "nsr-sched-evs-qd")

                                self.nsr_sched_max_evs = YLeaf(YType.uint16, "nsr-sched-max-evs")

                                self.nsr_sched_peak_q_len = YLeaf(YType.uint16, "nsr-sched-peak-q-len")

                                self.nsr_sched_pri = YLeaf(YType.enumeration, "nsr-sched-pri")

                                self.nsr_sched_quant = YLeaf(YType.uint8, "nsr-sched-quant")

                                self.nsr_sched_remain_quant = YLeaf(YType.uint8, "nsr-sched-remain-quant")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_sched_enq_fails",
                                                "nsr_sched_evs_deqd",
                                                "nsr_sched_evs_in_q",
                                                "nsr_sched_evs_qd",
                                                "nsr_sched_max_evs",
                                                "nsr_sched_peak_q_len",
                                                "nsr_sched_pri",
                                                "nsr_sched_quant",
                                                "nsr_sched_remain_quant") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched.NsrPri, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched.NsrPri, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nsr_sched_enq_fails.is_set or
                                    self.nsr_sched_evs_deqd.is_set or
                                    self.nsr_sched_evs_in_q.is_set or
                                    self.nsr_sched_evs_qd.is_set or
                                    self.nsr_sched_max_evs.is_set or
                                    self.nsr_sched_peak_q_len.is_set or
                                    self.nsr_sched_pri.is_set or
                                    self.nsr_sched_quant.is_set or
                                    self.nsr_sched_remain_quant.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_sched_enq_fails.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_deqd.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_in_q.yfilter != YFilter.not_set or
                                    self.nsr_sched_evs_qd.yfilter != YFilter.not_set or
                                    self.nsr_sched_max_evs.yfilter != YFilter.not_set or
                                    self.nsr_sched_peak_q_len.yfilter != YFilter.not_set or
                                    self.nsr_sched_pri.yfilter != YFilter.not_set or
                                    self.nsr_sched_quant.yfilter != YFilter.not_set or
                                    self.nsr_sched_remain_quant.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nsr-pri" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nsr_sched_enq_fails.is_set or self.nsr_sched_enq_fails.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_enq_fails.get_name_leafdata())
                                if (self.nsr_sched_evs_deqd.is_set or self.nsr_sched_evs_deqd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_deqd.get_name_leafdata())
                                if (self.nsr_sched_evs_in_q.is_set or self.nsr_sched_evs_in_q.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_in_q.get_name_leafdata())
                                if (self.nsr_sched_evs_qd.is_set or self.nsr_sched_evs_qd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_evs_qd.get_name_leafdata())
                                if (self.nsr_sched_max_evs.is_set or self.nsr_sched_max_evs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_max_evs.get_name_leafdata())
                                if (self.nsr_sched_peak_q_len.is_set or self.nsr_sched_peak_q_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_peak_q_len.get_name_leafdata())
                                if (self.nsr_sched_pri.is_set or self.nsr_sched_pri.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_pri.get_name_leafdata())
                                if (self.nsr_sched_quant.is_set or self.nsr_sched_quant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_quant.get_name_leafdata())
                                if (self.nsr_sched_remain_quant.is_set or self.nsr_sched_remain_quant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sched_remain_quant.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-sched-enq-fails" or name == "nsr-sched-evs-deqd" or name == "nsr-sched-evs-in-q" or name == "nsr-sched-evs-qd" or name == "nsr-sched-max-evs" or name == "nsr-sched-peak-q-len" or name == "nsr-sched-pri" or name == "nsr-sched-quant" or name == "nsr-sched-remain-quant"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-sched-enq-fails"):
                                    self.nsr_sched_enq_fails = value
                                    self.nsr_sched_enq_fails.value_namespace = name_space
                                    self.nsr_sched_enq_fails.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-deqd"):
                                    self.nsr_sched_evs_deqd = value
                                    self.nsr_sched_evs_deqd.value_namespace = name_space
                                    self.nsr_sched_evs_deqd.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-in-q"):
                                    self.nsr_sched_evs_in_q = value
                                    self.nsr_sched_evs_in_q.value_namespace = name_space
                                    self.nsr_sched_evs_in_q.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-evs-qd"):
                                    self.nsr_sched_evs_qd = value
                                    self.nsr_sched_evs_qd.value_namespace = name_space
                                    self.nsr_sched_evs_qd.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-max-evs"):
                                    self.nsr_sched_max_evs = value
                                    self.nsr_sched_max_evs.value_namespace = name_space
                                    self.nsr_sched_max_evs.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-peak-q-len"):
                                    self.nsr_sched_peak_q_len = value
                                    self.nsr_sched_peak_q_len.value_namespace = name_space
                                    self.nsr_sched_peak_q_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-pri"):
                                    self.nsr_sched_pri = value
                                    self.nsr_sched_pri.value_namespace = name_space
                                    self.nsr_sched_pri.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-quant"):
                                    self.nsr_sched_quant = value
                                    self.nsr_sched_quant.value_namespace = name_space
                                    self.nsr_sched_quant.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sched-remain-quant"):
                                    self.nsr_sched_remain_quant = value
                                    self.nsr_sched_remain_quant.value_namespace = name_space
                                    self.nsr_sched_remain_quant.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.nsr_pri:
                                if (c.has_data()):
                                    return True
                            return (
                                self.nsr_bad_pulses_rx.is_set or
                                self.nsr_events_in_q.is_set or
                                self.nsr_events_rx.is_set or
                                self.nsr_events_tx.is_set or
                                self.nsr_good_pulses_rx.is_set or
                                self.nsr_pulse_quant.is_set or
                                self.nsr_pulse_tx_fails.is_set or
                                self.nsr_pulses_tx.is_set)

                        def has_operation(self):
                            for c in self.nsr_pri:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.nsr_bad_pulses_rx.yfilter != YFilter.not_set or
                                self.nsr_events_in_q.yfilter != YFilter.not_set or
                                self.nsr_events_rx.yfilter != YFilter.not_set or
                                self.nsr_events_tx.yfilter != YFilter.not_set or
                                self.nsr_good_pulses_rx.yfilter != YFilter.not_set or
                                self.nsr_pulse_quant.yfilter != YFilter.not_set or
                                self.nsr_pulse_tx_fails.yfilter != YFilter.not_set or
                                self.nsr_pulses_tx.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nsr-rtr-thd-sched" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.nsr_bad_pulses_rx.is_set or self.nsr_bad_pulses_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_bad_pulses_rx.get_name_leafdata())
                            if (self.nsr_events_in_q.is_set or self.nsr_events_in_q.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_in_q.get_name_leafdata())
                            if (self.nsr_events_rx.is_set or self.nsr_events_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_rx.get_name_leafdata())
                            if (self.nsr_events_tx.is_set or self.nsr_events_tx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_events_tx.get_name_leafdata())
                            if (self.nsr_good_pulses_rx.is_set or self.nsr_good_pulses_rx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_good_pulses_rx.get_name_leafdata())
                            if (self.nsr_pulse_quant.is_set or self.nsr_pulse_quant.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulse_quant.get_name_leafdata())
                            if (self.nsr_pulse_tx_fails.is_set or self.nsr_pulse_tx_fails.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulse_tx_fails.get_name_leafdata())
                            if (self.nsr_pulses_tx.is_set or self.nsr_pulses_tx.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_pulses_tx.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "nsr-pri"):
                                for c in self.nsr_pri:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched.NsrPri()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.nsr_pri.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "nsr-pri" or name == "nsr-bad-pulses-rx" or name == "nsr-events-in-q" or name == "nsr-events-rx" or name == "nsr-events-tx" or name == "nsr-good-pulses-rx" or name == "nsr-pulse-quant" or name == "nsr-pulse-tx-fails" or name == "nsr-pulses-tx"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "nsr-bad-pulses-rx"):
                                self.nsr_bad_pulses_rx = value
                                self.nsr_bad_pulses_rx.value_namespace = name_space
                                self.nsr_bad_pulses_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-in-q"):
                                self.nsr_events_in_q = value
                                self.nsr_events_in_q.value_namespace = name_space
                                self.nsr_events_in_q.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-rx"):
                                self.nsr_events_rx = value
                                self.nsr_events_rx.value_namespace = name_space
                                self.nsr_events_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-events-tx"):
                                self.nsr_events_tx = value
                                self.nsr_events_tx.value_namespace = name_space
                                self.nsr_events_tx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-good-pulses-rx"):
                                self.nsr_good_pulses_rx = value
                                self.nsr_good_pulses_rx.value_namespace = name_space
                                self.nsr_good_pulses_rx.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulse-quant"):
                                self.nsr_pulse_quant = value
                                self.nsr_pulse_quant.value_namespace = name_space
                                self.nsr_pulse_quant.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulse-tx-fails"):
                                self.nsr_pulse_tx_fails = value
                                self.nsr_pulse_tx_fails.value_namespace = name_space
                                self.nsr_pulse_tx_fails.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-pulses-tx"):
                                self.nsr_pulses_tx = value
                                self.nsr_pulses_tx.value_namespace = name_space
                                self.nsr_pulses_tx.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.nsr_conn_to_active_attempts.is_set or
                            self.nsr_conn_to_active_closes.is_set or
                            self.nsr_conn_to_active_errors.is_set or
                            self.nsr_conn_to_active_fails.is_set or
                            self.nsr_conn_to_active_opens.is_set or
                            self.nsr_fsm_state.is_set or
                            self.nsr_intf_seq_no.is_set or
                            self.nsr_lsa_init_sync_pend_count.is_set or
                            self.nsr_lsa_qad_mdata_count.is_set or
                            self.nsr_lsa_qad_qid.is_set or
                            self.nsr_mtu.is_set or
                            self.nsr_nbr_init_sync_pend_count.is_set or
                            self.nsr_nbr_qad_mdata_count.is_set or
                            self.nsr_nbr_qad_qid.is_set or
                            self.nsr_nbr_seq_no.is_set or
                            self.nsr_node_id.is_set or
                            self.nsr_peer_node_id.is_set or
                            self.nsr_peer_version.is_set or
                            self.nsr_revision.is_set or
                            self.nsr_tmr_quant.is_set or
                            self.nsr_version.is_set or
                            (self.nsr_rtr_thd_sched is not None and self.nsr_rtr_thd_sched.has_data()) or
                            (self.nsr_thd_stats is not None and self.nsr_thd_stats.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.nsr_conn_to_active_attempts.yfilter != YFilter.not_set or
                            self.nsr_conn_to_active_closes.yfilter != YFilter.not_set or
                            self.nsr_conn_to_active_errors.yfilter != YFilter.not_set or
                            self.nsr_conn_to_active_fails.yfilter != YFilter.not_set or
                            self.nsr_conn_to_active_opens.yfilter != YFilter.not_set or
                            self.nsr_fsm_state.yfilter != YFilter.not_set or
                            self.nsr_intf_seq_no.yfilter != YFilter.not_set or
                            self.nsr_lsa_init_sync_pend_count.yfilter != YFilter.not_set or
                            self.nsr_lsa_qad_mdata_count.yfilter != YFilter.not_set or
                            self.nsr_lsa_qad_qid.yfilter != YFilter.not_set or
                            self.nsr_mtu.yfilter != YFilter.not_set or
                            self.nsr_nbr_init_sync_pend_count.yfilter != YFilter.not_set or
                            self.nsr_nbr_qad_mdata_count.yfilter != YFilter.not_set or
                            self.nsr_nbr_qad_qid.yfilter != YFilter.not_set or
                            self.nsr_nbr_seq_no.yfilter != YFilter.not_set or
                            self.nsr_node_id.yfilter != YFilter.not_set or
                            self.nsr_peer_node_id.yfilter != YFilter.not_set or
                            self.nsr_peer_version.yfilter != YFilter.not_set or
                            self.nsr_revision.yfilter != YFilter.not_set or
                            self.nsr_tmr_quant.yfilter != YFilter.not_set or
                            self.nsr_version.yfilter != YFilter.not_set or
                            (self.nsr_rtr_thd_sched is not None and self.nsr_rtr_thd_sched.has_operation()) or
                            (self.nsr_thd_stats is not None and self.nsr_thd_stats.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "issu-stats" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.nsr_conn_to_active_attempts.is_set or self.nsr_conn_to_active_attempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_conn_to_active_attempts.get_name_leafdata())
                        if (self.nsr_conn_to_active_closes.is_set or self.nsr_conn_to_active_closes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_conn_to_active_closes.get_name_leafdata())
                        if (self.nsr_conn_to_active_errors.is_set or self.nsr_conn_to_active_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_conn_to_active_errors.get_name_leafdata())
                        if (self.nsr_conn_to_active_fails.is_set or self.nsr_conn_to_active_fails.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_conn_to_active_fails.get_name_leafdata())
                        if (self.nsr_conn_to_active_opens.is_set or self.nsr_conn_to_active_opens.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_conn_to_active_opens.get_name_leafdata())
                        if (self.nsr_fsm_state.is_set or self.nsr_fsm_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_fsm_state.get_name_leafdata())
                        if (self.nsr_intf_seq_no.is_set or self.nsr_intf_seq_no.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_intf_seq_no.get_name_leafdata())
                        if (self.nsr_lsa_init_sync_pend_count.is_set or self.nsr_lsa_init_sync_pend_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_lsa_init_sync_pend_count.get_name_leafdata())
                        if (self.nsr_lsa_qad_mdata_count.is_set or self.nsr_lsa_qad_mdata_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_lsa_qad_mdata_count.get_name_leafdata())
                        if (self.nsr_lsa_qad_qid.is_set or self.nsr_lsa_qad_qid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_lsa_qad_qid.get_name_leafdata())
                        if (self.nsr_mtu.is_set or self.nsr_mtu.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_mtu.get_name_leafdata())
                        if (self.nsr_nbr_init_sync_pend_count.is_set or self.nsr_nbr_init_sync_pend_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_nbr_init_sync_pend_count.get_name_leafdata())
                        if (self.nsr_nbr_qad_mdata_count.is_set or self.nsr_nbr_qad_mdata_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_nbr_qad_mdata_count.get_name_leafdata())
                        if (self.nsr_nbr_qad_qid.is_set or self.nsr_nbr_qad_qid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_nbr_qad_qid.get_name_leafdata())
                        if (self.nsr_nbr_seq_no.is_set or self.nsr_nbr_seq_no.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_nbr_seq_no.get_name_leafdata())
                        if (self.nsr_node_id.is_set or self.nsr_node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_node_id.get_name_leafdata())
                        if (self.nsr_peer_node_id.is_set or self.nsr_peer_node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_peer_node_id.get_name_leafdata())
                        if (self.nsr_peer_version.is_set or self.nsr_peer_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_peer_version.get_name_leafdata())
                        if (self.nsr_revision.is_set or self.nsr_revision.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_revision.get_name_leafdata())
                        if (self.nsr_tmr_quant.is_set or self.nsr_tmr_quant.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_tmr_quant.get_name_leafdata())
                        if (self.nsr_version.is_set or self.nsr_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_version.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "nsr-rtr-thd-sched"):
                            if (self.nsr_rtr_thd_sched is None):
                                self.nsr_rtr_thd_sched = Ospfv3.Processes.Process.Statistics.IssuStats.NsrRtrThdSched()
                                self.nsr_rtr_thd_sched.parent = self
                                self._children_name_map["nsr_rtr_thd_sched"] = "nsr-rtr-thd-sched"
                            return self.nsr_rtr_thd_sched

                        if (child_yang_name == "nsr-thd-stats"):
                            if (self.nsr_thd_stats is None):
                                self.nsr_thd_stats = Ospfv3.Processes.Process.Statistics.IssuStats.NsrThdStats()
                                self.nsr_thd_stats.parent = self
                                self._children_name_map["nsr_thd_stats"] = "nsr-thd-stats"
                            return self.nsr_thd_stats

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "nsr-rtr-thd-sched" or name == "nsr-thd-stats" or name == "nsr-conn-to-active-attempts" or name == "nsr-conn-to-active-closes" or name == "nsr-conn-to-active-errors" or name == "nsr-conn-to-active-fails" or name == "nsr-conn-to-active-opens" or name == "nsr-fsm-state" or name == "nsr-intf-seq-no" or name == "nsr-lsa-init-sync-pend-count" or name == "nsr-lsa-qad-mdata-count" or name == "nsr-lsa-qad-qid" or name == "nsr-mtu" or name == "nsr-nbr-init-sync-pend-count" or name == "nsr-nbr-qad-mdata-count" or name == "nsr-nbr-qad-qid" or name == "nsr-nbr-seq-no" or name == "nsr-node-id" or name == "nsr-peer-node-id" or name == "nsr-peer-version" or name == "nsr-revision" or name == "nsr-tmr-quant" or name == "nsr-version"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "nsr-conn-to-active-attempts"):
                            self.nsr_conn_to_active_attempts = value
                            self.nsr_conn_to_active_attempts.value_namespace = name_space
                            self.nsr_conn_to_active_attempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-conn-to-active-closes"):
                            self.nsr_conn_to_active_closes = value
                            self.nsr_conn_to_active_closes.value_namespace = name_space
                            self.nsr_conn_to_active_closes.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-conn-to-active-errors"):
                            self.nsr_conn_to_active_errors = value
                            self.nsr_conn_to_active_errors.value_namespace = name_space
                            self.nsr_conn_to_active_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-conn-to-active-fails"):
                            self.nsr_conn_to_active_fails = value
                            self.nsr_conn_to_active_fails.value_namespace = name_space
                            self.nsr_conn_to_active_fails.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-conn-to-active-opens"):
                            self.nsr_conn_to_active_opens = value
                            self.nsr_conn_to_active_opens.value_namespace = name_space
                            self.nsr_conn_to_active_opens.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-fsm-state"):
                            self.nsr_fsm_state = value
                            self.nsr_fsm_state.value_namespace = name_space
                            self.nsr_fsm_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-intf-seq-no"):
                            self.nsr_intf_seq_no = value
                            self.nsr_intf_seq_no.value_namespace = name_space
                            self.nsr_intf_seq_no.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-lsa-init-sync-pend-count"):
                            self.nsr_lsa_init_sync_pend_count = value
                            self.nsr_lsa_init_sync_pend_count.value_namespace = name_space
                            self.nsr_lsa_init_sync_pend_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-lsa-qad-mdata-count"):
                            self.nsr_lsa_qad_mdata_count = value
                            self.nsr_lsa_qad_mdata_count.value_namespace = name_space
                            self.nsr_lsa_qad_mdata_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-lsa-qad-qid"):
                            self.nsr_lsa_qad_qid = value
                            self.nsr_lsa_qad_qid.value_namespace = name_space
                            self.nsr_lsa_qad_qid.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-mtu"):
                            self.nsr_mtu = value
                            self.nsr_mtu.value_namespace = name_space
                            self.nsr_mtu.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-nbr-init-sync-pend-count"):
                            self.nsr_nbr_init_sync_pend_count = value
                            self.nsr_nbr_init_sync_pend_count.value_namespace = name_space
                            self.nsr_nbr_init_sync_pend_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-nbr-qad-mdata-count"):
                            self.nsr_nbr_qad_mdata_count = value
                            self.nsr_nbr_qad_mdata_count.value_namespace = name_space
                            self.nsr_nbr_qad_mdata_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-nbr-qad-qid"):
                            self.nsr_nbr_qad_qid = value
                            self.nsr_nbr_qad_qid.value_namespace = name_space
                            self.nsr_nbr_qad_qid.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-nbr-seq-no"):
                            self.nsr_nbr_seq_no = value
                            self.nsr_nbr_seq_no.value_namespace = name_space
                            self.nsr_nbr_seq_no.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-node-id"):
                            self.nsr_node_id = value
                            self.nsr_node_id.value_namespace = name_space
                            self.nsr_node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-peer-node-id"):
                            self.nsr_peer_node_id = value
                            self.nsr_peer_node_id.value_namespace = name_space
                            self.nsr_peer_node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-peer-version"):
                            self.nsr_peer_version = value
                            self.nsr_peer_version.value_namespace = name_space
                            self.nsr_peer_version.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-revision"):
                            self.nsr_revision = value
                            self.nsr_revision.value_namespace = name_space
                            self.nsr_revision.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-tmr-quant"):
                            self.nsr_tmr_quant = value
                            self.nsr_tmr_quant.value_namespace = name_space
                            self.nsr_tmr_quant.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-version"):
                            self.nsr_version = value
                            self.nsr_version.value_namespace = name_space
                            self.nsr_version.value_namespace_prefix = name_space_prefix


                class NsrPlStats(Entity):
                    """
                    OSPF NSR packet library statistics
                    
                    .. attribute:: ncd_pri
                    
                    	ncd pri
                    	**type**\: list of    :py:class:`NcdPri <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.Statistics.NsrPlStats, self).__init__()

                        self.yang_name = "nsr-pl-stats"
                        self.yang_parent_name = "statistics"

                        self.ncd_pri = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.Statistics.NsrPlStats, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.Statistics.NsrPlStats, self).__setattr__(name, value)


                    class NcdPri(Entity):
                        """
                        ncd pri
                        
                        .. attribute:: num_recv
                        
                        	Total recvd
                        	**type**\:  list of int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: num_recv_drop
                        
                        	Recv Errors/drops
                        	**type**\: list of    :py:class:`NumRecvDrop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri.NumRecvDrop>`
                        
                        .. attribute:: num_sent
                        
                        	Total sent
                        	**type**\:  list of int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: num_sent_drop
                        
                        	Sent Error/drops
                        	**type**\: list of    :py:class:`NumSentDrop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri.NumSentDrop>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri, self).__init__()

                            self.yang_name = "ncd-pri"
                            self.yang_parent_name = "nsr-pl-stats"

                            self.num_recv = YLeafList(YType.uint64, "num-recv")

                            self.num_sent = YLeafList(YType.uint64, "num-sent")

                            self.num_recv_drop = YList(self)
                            self.num_sent_drop = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("num_recv",
                                            "num_sent") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri, self).__setattr__(name, value)


                        class NumSentDrop(Entity):
                            """
                            Sent Error/drops
                            
                            .. attribute:: nsr_pl_send_drop_array
                            
                            	nsr pl send drop array
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri.NumSentDrop, self).__init__()

                                self.yang_name = "num-sent-drop"
                                self.yang_parent_name = "ncd-pri"

                                self.nsr_pl_send_drop_array = YLeafList(YType.uint32, "nsr-pl-send-drop-array")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_pl_send_drop_array") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri.NumSentDrop, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri.NumSentDrop, self).__setattr__(name, value)

                            def has_data(self):
                                for leaf in self.nsr_pl_send_drop_array.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                return False

                            def has_operation(self):
                                for leaf in self.nsr_pl_send_drop_array.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_pl_send_drop_array.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "num-sent-drop" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                leaf_name_data.extend(self.nsr_pl_send_drop_array.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-pl-send-drop-array"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-pl-send-drop-array"):
                                    self.nsr_pl_send_drop_array.append(value)


                        class NumRecvDrop(Entity):
                            """
                            Recv Errors/drops
                            
                            .. attribute:: nsr_pl_recv_drop_array
                            
                            	nsr pl recv drop array
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri.NumRecvDrop, self).__init__()

                                self.yang_name = "num-recv-drop"
                                self.yang_parent_name = "ncd-pri"

                                self.nsr_pl_recv_drop_array = YLeafList(YType.uint32, "nsr-pl-recv-drop-array")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_pl_recv_drop_array") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri.NumRecvDrop, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri.NumRecvDrop, self).__setattr__(name, value)

                            def has_data(self):
                                for leaf in self.nsr_pl_recv_drop_array.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                return False

                            def has_operation(self):
                                for leaf in self.nsr_pl_recv_drop_array.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_pl_recv_drop_array.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "num-recv-drop" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                leaf_name_data.extend(self.nsr_pl_recv_drop_array.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-pl-recv-drop-array"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-pl-recv-drop-array"):
                                    self.nsr_pl_recv_drop_array.append(value)

                        def has_data(self):
                            for c in self.num_recv_drop:
                                if (c.has_data()):
                                    return True
                            for c in self.num_sent_drop:
                                if (c.has_data()):
                                    return True
                            for leaf in self.num_recv.getYLeafs():
                                if (leaf.yfilter != YFilter.not_set):
                                    return True
                            for leaf in self.num_sent.getYLeafs():
                                if (leaf.yfilter != YFilter.not_set):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.num_recv_drop:
                                if (c.has_operation()):
                                    return True
                            for c in self.num_sent_drop:
                                if (c.has_operation()):
                                    return True
                            for leaf in self.num_recv.getYLeafs():
                                if (leaf.is_set):
                                    return True
                            for leaf in self.num_sent.getYLeafs():
                                if (leaf.is_set):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.num_recv.yfilter != YFilter.not_set or
                                self.num_sent.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ncd-pri" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            leaf_name_data.extend(self.num_recv.get_name_leafdata())

                            leaf_name_data.extend(self.num_sent.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "num-recv-drop"):
                                for c in self.num_recv_drop:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri.NumRecvDrop()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.num_recv_drop.append(c)
                                return c

                            if (child_yang_name == "num-sent-drop"):
                                for c in self.num_sent_drop:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri.NumSentDrop()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.num_sent_drop.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "num-recv-drop" or name == "num-sent-drop" or name == "num-recv" or name == "num-sent"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "num-recv"):
                                self.num_recv.append(value)
                            if(value_path == "num-sent"):
                                self.num_sent.append(value)

                    def has_data(self):
                        for c in self.ncd_pri:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.ncd_pri:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "nsr-pl-stats" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ncd-pri"):
                            for c in self.ncd_pri:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.Statistics.NsrPlStats.NcdPri()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.ncd_pri.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ncd-pri"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class ProtocolStats(Entity):
                    """
                    Protocol table
                    
                    .. attribute:: protocol_stat
                    
                    	Protocol statistics for an interface
                    	**type**\: list of    :py:class:`ProtocolStat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.ProtocolStats.ProtocolStat>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.Statistics.ProtocolStats, self).__init__()

                        self.yang_name = "protocol-stats"
                        self.yang_parent_name = "statistics"

                        self.protocol_stat = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.Statistics.ProtocolStats, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.Statistics.ProtocolStats, self).__setattr__(name, value)


                    class ProtocolStat(Entity):
                        """
                        Protocol statistics for an interface
                        
                        .. attribute:: interface_name  <key>
                        
                        	Interface name
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: checksum_err
                        
                        	Checksum Errors
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: dbdes_in_ls_as
                        
                        	Database Description LSAs in
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: dbdes_in_packets
                        
                        	Database Description Packets in
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: dbdes_out_ls_as
                        
                        	Database Description LSAs out
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: dbdes_out_packets
                        
                        	Database Description Packets out
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: dropped_in_gs
                        
                        	Dropped in GS
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: hello_in_packets
                        
                        	Hello packets in
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: hello_out_packets
                        
                        	Hello Out Packets
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_ack_in_ls_as
                        
                        	LS Ack LSAs in
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_ack_in_packets
                        
                        	LS Acks Packets in
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_ack_out_ls_as
                        
                        	LS Ack LSAs out
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_ack_out_packets
                        
                        	LS Ack Packets out
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_req_in_ls_as
                        
                        	LS Requests in
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_req_in_packets
                        
                        	LSA Requests in
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_req_out_ls_as
                        
                        	LS Reuqests LSAs out
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_req_out_packets
                        
                        	LS Request Packets out
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_upd_in_ignored
                        
                        	LS Updates ignored
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_upd_in_ls_as
                        
                        	LS Updates LSAs in
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_upd_in_packets
                        
                        	LS Updates Packets in
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_upd_out_ls_as
                        
                        	LS Update LSAs out
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: ls_upd_out_packets
                        
                        	LS Update Packets out
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: total_in_packets
                        
                        	Total inputs packets
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: total_out_packets
                        
                        	Total Out Packets
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.ProtocolStats.ProtocolStat, self).__init__()

                            self.yang_name = "protocol-stat"
                            self.yang_parent_name = "protocol-stats"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.checksum_err = YLeaf(YType.uint64, "checksum-err")

                            self.dbdes_in_ls_as = YLeaf(YType.uint64, "dbdes-in-ls-as")

                            self.dbdes_in_packets = YLeaf(YType.uint64, "dbdes-in-packets")

                            self.dbdes_out_ls_as = YLeaf(YType.uint64, "dbdes-out-ls-as")

                            self.dbdes_out_packets = YLeaf(YType.uint64, "dbdes-out-packets")

                            self.dropped_in_gs = YLeaf(YType.uint64, "dropped-in-gs")

                            self.hello_in_packets = YLeaf(YType.uint64, "hello-in-packets")

                            self.hello_out_packets = YLeaf(YType.uint64, "hello-out-packets")

                            self.ls_ack_in_ls_as = YLeaf(YType.uint64, "ls-ack-in-ls-as")

                            self.ls_ack_in_packets = YLeaf(YType.uint64, "ls-ack-in-packets")

                            self.ls_ack_out_ls_as = YLeaf(YType.uint64, "ls-ack-out-ls-as")

                            self.ls_ack_out_packets = YLeaf(YType.uint64, "ls-ack-out-packets")

                            self.ls_req_in_ls_as = YLeaf(YType.uint64, "ls-req-in-ls-as")

                            self.ls_req_in_packets = YLeaf(YType.uint64, "ls-req-in-packets")

                            self.ls_req_out_ls_as = YLeaf(YType.uint64, "ls-req-out-ls-as")

                            self.ls_req_out_packets = YLeaf(YType.uint64, "ls-req-out-packets")

                            self.ls_upd_in_ignored = YLeaf(YType.uint64, "ls-upd-in-ignored")

                            self.ls_upd_in_ls_as = YLeaf(YType.uint64, "ls-upd-in-ls-as")

                            self.ls_upd_in_packets = YLeaf(YType.uint64, "ls-upd-in-packets")

                            self.ls_upd_out_ls_as = YLeaf(YType.uint64, "ls-upd-out-ls-as")

                            self.ls_upd_out_packets = YLeaf(YType.uint64, "ls-upd-out-packets")

                            self.total_in_packets = YLeaf(YType.uint64, "total-in-packets")

                            self.total_out_packets = YLeaf(YType.uint64, "total-out-packets")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "checksum_err",
                                            "dbdes_in_ls_as",
                                            "dbdes_in_packets",
                                            "dbdes_out_ls_as",
                                            "dbdes_out_packets",
                                            "dropped_in_gs",
                                            "hello_in_packets",
                                            "hello_out_packets",
                                            "ls_ack_in_ls_as",
                                            "ls_ack_in_packets",
                                            "ls_ack_out_ls_as",
                                            "ls_ack_out_packets",
                                            "ls_req_in_ls_as",
                                            "ls_req_in_packets",
                                            "ls_req_out_ls_as",
                                            "ls_req_out_packets",
                                            "ls_upd_in_ignored",
                                            "ls_upd_in_ls_as",
                                            "ls_upd_in_packets",
                                            "ls_upd_out_ls_as",
                                            "ls_upd_out_packets",
                                            "total_in_packets",
                                            "total_out_packets") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.ProtocolStats.ProtocolStat, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.ProtocolStats.ProtocolStat, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.interface_name.is_set or
                                self.checksum_err.is_set or
                                self.dbdes_in_ls_as.is_set or
                                self.dbdes_in_packets.is_set or
                                self.dbdes_out_ls_as.is_set or
                                self.dbdes_out_packets.is_set or
                                self.dropped_in_gs.is_set or
                                self.hello_in_packets.is_set or
                                self.hello_out_packets.is_set or
                                self.ls_ack_in_ls_as.is_set or
                                self.ls_ack_in_packets.is_set or
                                self.ls_ack_out_ls_as.is_set or
                                self.ls_ack_out_packets.is_set or
                                self.ls_req_in_ls_as.is_set or
                                self.ls_req_in_packets.is_set or
                                self.ls_req_out_ls_as.is_set or
                                self.ls_req_out_packets.is_set or
                                self.ls_upd_in_ignored.is_set or
                                self.ls_upd_in_ls_as.is_set or
                                self.ls_upd_in_packets.is_set or
                                self.ls_upd_out_ls_as.is_set or
                                self.ls_upd_out_packets.is_set or
                                self.total_in_packets.is_set or
                                self.total_out_packets.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.checksum_err.yfilter != YFilter.not_set or
                                self.dbdes_in_ls_as.yfilter != YFilter.not_set or
                                self.dbdes_in_packets.yfilter != YFilter.not_set or
                                self.dbdes_out_ls_as.yfilter != YFilter.not_set or
                                self.dbdes_out_packets.yfilter != YFilter.not_set or
                                self.dropped_in_gs.yfilter != YFilter.not_set or
                                self.hello_in_packets.yfilter != YFilter.not_set or
                                self.hello_out_packets.yfilter != YFilter.not_set or
                                self.ls_ack_in_ls_as.yfilter != YFilter.not_set or
                                self.ls_ack_in_packets.yfilter != YFilter.not_set or
                                self.ls_ack_out_ls_as.yfilter != YFilter.not_set or
                                self.ls_ack_out_packets.yfilter != YFilter.not_set or
                                self.ls_req_in_ls_as.yfilter != YFilter.not_set or
                                self.ls_req_in_packets.yfilter != YFilter.not_set or
                                self.ls_req_out_ls_as.yfilter != YFilter.not_set or
                                self.ls_req_out_packets.yfilter != YFilter.not_set or
                                self.ls_upd_in_ignored.yfilter != YFilter.not_set or
                                self.ls_upd_in_ls_as.yfilter != YFilter.not_set or
                                self.ls_upd_in_packets.yfilter != YFilter.not_set or
                                self.ls_upd_out_ls_as.yfilter != YFilter.not_set or
                                self.ls_upd_out_packets.yfilter != YFilter.not_set or
                                self.total_in_packets.yfilter != YFilter.not_set or
                                self.total_out_packets.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protocol-stat" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.checksum_err.is_set or self.checksum_err.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.checksum_err.get_name_leafdata())
                            if (self.dbdes_in_ls_as.is_set or self.dbdes_in_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dbdes_in_ls_as.get_name_leafdata())
                            if (self.dbdes_in_packets.is_set or self.dbdes_in_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dbdes_in_packets.get_name_leafdata())
                            if (self.dbdes_out_ls_as.is_set or self.dbdes_out_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dbdes_out_ls_as.get_name_leafdata())
                            if (self.dbdes_out_packets.is_set or self.dbdes_out_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dbdes_out_packets.get_name_leafdata())
                            if (self.dropped_in_gs.is_set or self.dropped_in_gs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dropped_in_gs.get_name_leafdata())
                            if (self.hello_in_packets.is_set or self.hello_in_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hello_in_packets.get_name_leafdata())
                            if (self.hello_out_packets.is_set or self.hello_out_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hello_out_packets.get_name_leafdata())
                            if (self.ls_ack_in_ls_as.is_set or self.ls_ack_in_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_ack_in_ls_as.get_name_leafdata())
                            if (self.ls_ack_in_packets.is_set or self.ls_ack_in_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_ack_in_packets.get_name_leafdata())
                            if (self.ls_ack_out_ls_as.is_set or self.ls_ack_out_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_ack_out_ls_as.get_name_leafdata())
                            if (self.ls_ack_out_packets.is_set or self.ls_ack_out_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_ack_out_packets.get_name_leafdata())
                            if (self.ls_req_in_ls_as.is_set or self.ls_req_in_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_req_in_ls_as.get_name_leafdata())
                            if (self.ls_req_in_packets.is_set or self.ls_req_in_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_req_in_packets.get_name_leafdata())
                            if (self.ls_req_out_ls_as.is_set or self.ls_req_out_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_req_out_ls_as.get_name_leafdata())
                            if (self.ls_req_out_packets.is_set or self.ls_req_out_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_req_out_packets.get_name_leafdata())
                            if (self.ls_upd_in_ignored.is_set or self.ls_upd_in_ignored.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_upd_in_ignored.get_name_leafdata())
                            if (self.ls_upd_in_ls_as.is_set or self.ls_upd_in_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_upd_in_ls_as.get_name_leafdata())
                            if (self.ls_upd_in_packets.is_set or self.ls_upd_in_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_upd_in_packets.get_name_leafdata())
                            if (self.ls_upd_out_ls_as.is_set or self.ls_upd_out_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_upd_out_ls_as.get_name_leafdata())
                            if (self.ls_upd_out_packets.is_set or self.ls_upd_out_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_upd_out_packets.get_name_leafdata())
                            if (self.total_in_packets.is_set or self.total_in_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_in_packets.get_name_leafdata())
                            if (self.total_out_packets.is_set or self.total_out_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_out_packets.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "interface-name" or name == "checksum-err" or name == "dbdes-in-ls-as" or name == "dbdes-in-packets" or name == "dbdes-out-ls-as" or name == "dbdes-out-packets" or name == "dropped-in-gs" or name == "hello-in-packets" or name == "hello-out-packets" or name == "ls-ack-in-ls-as" or name == "ls-ack-in-packets" or name == "ls-ack-out-ls-as" or name == "ls-ack-out-packets" or name == "ls-req-in-ls-as" or name == "ls-req-in-packets" or name == "ls-req-out-ls-as" or name == "ls-req-out-packets" or name == "ls-upd-in-ignored" or name == "ls-upd-in-ls-as" or name == "ls-upd-in-packets" or name == "ls-upd-out-ls-as" or name == "ls-upd-out-packets" or name == "total-in-packets" or name == "total-out-packets"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "checksum-err"):
                                self.checksum_err = value
                                self.checksum_err.value_namespace = name_space
                                self.checksum_err.value_namespace_prefix = name_space_prefix
                            if(value_path == "dbdes-in-ls-as"):
                                self.dbdes_in_ls_as = value
                                self.dbdes_in_ls_as.value_namespace = name_space
                                self.dbdes_in_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "dbdes-in-packets"):
                                self.dbdes_in_packets = value
                                self.dbdes_in_packets.value_namespace = name_space
                                self.dbdes_in_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "dbdes-out-ls-as"):
                                self.dbdes_out_ls_as = value
                                self.dbdes_out_ls_as.value_namespace = name_space
                                self.dbdes_out_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "dbdes-out-packets"):
                                self.dbdes_out_packets = value
                                self.dbdes_out_packets.value_namespace = name_space
                                self.dbdes_out_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "dropped-in-gs"):
                                self.dropped_in_gs = value
                                self.dropped_in_gs.value_namespace = name_space
                                self.dropped_in_gs.value_namespace_prefix = name_space_prefix
                            if(value_path == "hello-in-packets"):
                                self.hello_in_packets = value
                                self.hello_in_packets.value_namespace = name_space
                                self.hello_in_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "hello-out-packets"):
                                self.hello_out_packets = value
                                self.hello_out_packets.value_namespace = name_space
                                self.hello_out_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-ack-in-ls-as"):
                                self.ls_ack_in_ls_as = value
                                self.ls_ack_in_ls_as.value_namespace = name_space
                                self.ls_ack_in_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-ack-in-packets"):
                                self.ls_ack_in_packets = value
                                self.ls_ack_in_packets.value_namespace = name_space
                                self.ls_ack_in_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-ack-out-ls-as"):
                                self.ls_ack_out_ls_as = value
                                self.ls_ack_out_ls_as.value_namespace = name_space
                                self.ls_ack_out_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-ack-out-packets"):
                                self.ls_ack_out_packets = value
                                self.ls_ack_out_packets.value_namespace = name_space
                                self.ls_ack_out_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-req-in-ls-as"):
                                self.ls_req_in_ls_as = value
                                self.ls_req_in_ls_as.value_namespace = name_space
                                self.ls_req_in_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-req-in-packets"):
                                self.ls_req_in_packets = value
                                self.ls_req_in_packets.value_namespace = name_space
                                self.ls_req_in_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-req-out-ls-as"):
                                self.ls_req_out_ls_as = value
                                self.ls_req_out_ls_as.value_namespace = name_space
                                self.ls_req_out_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-req-out-packets"):
                                self.ls_req_out_packets = value
                                self.ls_req_out_packets.value_namespace = name_space
                                self.ls_req_out_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-upd-in-ignored"):
                                self.ls_upd_in_ignored = value
                                self.ls_upd_in_ignored.value_namespace = name_space
                                self.ls_upd_in_ignored.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-upd-in-ls-as"):
                                self.ls_upd_in_ls_as = value
                                self.ls_upd_in_ls_as.value_namespace = name_space
                                self.ls_upd_in_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-upd-in-packets"):
                                self.ls_upd_in_packets = value
                                self.ls_upd_in_packets.value_namespace = name_space
                                self.ls_upd_in_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-upd-out-ls-as"):
                                self.ls_upd_out_ls_as = value
                                self.ls_upd_out_ls_as.value_namespace = name_space
                                self.ls_upd_out_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-upd-out-packets"):
                                self.ls_upd_out_packets = value
                                self.ls_upd_out_packets.value_namespace = name_space
                                self.ls_upd_out_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-in-packets"):
                                self.total_in_packets = value
                                self.total_in_packets.value_namespace = name_space
                                self.total_in_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-out-packets"):
                                self.total_out_packets = value
                                self.total_out_packets.value_namespace = name_space
                                self.total_out_packets.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.protocol_stat:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.protocol_stat:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "protocol-stats" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "protocol-stat"):
                            for c in self.protocol_stat:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.Statistics.ProtocolStats.ProtocolStat()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.protocol_stat.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "protocol-stat"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class SpfStats(Entity):
                    """
                    OSPFv3 RIB batch statistics
                    
                    .. attribute:: spf_header
                    
                    	SPF statistics header
                    	**type**\:   :py:class:`SpfHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader>`
                    
                    .. attribute:: spf_runtime
                    
                    	List of SPF run\-time statistics
                    	**type**\: list of    :py:class:`SpfRuntime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.Statistics.SpfStats, self).__init__()

                        self.yang_name = "spf-stats"
                        self.yang_parent_name = "statistics"

                        self.spf_header = Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader()
                        self.spf_header.parent = self
                        self._children_name_map["spf_header"] = "spf-header"
                        self._children_yang_names.add("spf-header")

                        self.spf_runtime = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.Statistics.SpfStats, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.Statistics.SpfStats, self).__setattr__(name, value)


                    class SpfHeader(Entity):
                        """
                        SPF statistics header
                        
                        .. attribute:: area_summary
                        
                        	List of Areas with SPF statistics
                        	**type**\: list of    :py:class:`AreaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader.AreaSummary>`
                        
                        .. attribute:: header_router_id
                        
                        	Router ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: header_sp_fs
                        
                        	Number of SPF calculations
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader, self).__init__()

                            self.yang_name = "spf-header"
                            self.yang_parent_name = "spf-stats"

                            self.header_router_id = YLeaf(YType.str, "header-router-id")

                            self.header_sp_fs = YLeaf(YType.uint32, "header-sp-fs")

                            self.area_summary = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("header_router_id",
                                            "header_sp_fs") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader, self).__setattr__(name, value)


                        class AreaSummary(Entity):
                            """
                            List of Areas with SPF statistics
                            
                            .. attribute:: area_id
                            
                            	Area ID of the area SPF statistics
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: sp_fs
                            
                            	Number of SPF calculations
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader.AreaSummary, self).__init__()

                                self.yang_name = "area-summary"
                                self.yang_parent_name = "spf-header"

                                self.area_id = YLeaf(YType.uint32, "area-id")

                                self.sp_fs = YLeaf(YType.uint32, "sp-fs")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("area_id",
                                                "sp_fs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader.AreaSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader.AreaSummary, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.area_id.is_set or
                                    self.sp_fs.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.area_id.yfilter != YFilter.not_set or
                                    self.sp_fs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "area-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_id.get_name_leafdata())
                                if (self.sp_fs.is_set or self.sp_fs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_fs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "area-id" or name == "sp-fs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "area-id"):
                                    self.area_id = value
                                    self.area_id.value_namespace = name_space
                                    self.area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-fs"):
                                    self.sp_fs = value
                                    self.sp_fs.value_namespace = name_space
                                    self.sp_fs.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.area_summary:
                                if (c.has_data()):
                                    return True
                            return (
                                self.header_router_id.is_set or
                                self.header_sp_fs.is_set)

                        def has_operation(self):
                            for c in self.area_summary:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.header_router_id.yfilter != YFilter.not_set or
                                self.header_sp_fs.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "spf-header" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.header_router_id.is_set or self.header_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.header_router_id.get_name_leafdata())
                            if (self.header_sp_fs.is_set or self.header_sp_fs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.header_sp_fs.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "area-summary"):
                                for c in self.area_summary:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader.AreaSummary()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.area_summary.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area-summary" or name == "header-router-id" or name == "header-sp-fs"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "header-router-id"):
                                self.header_router_id = value
                                self.header_router_id.value_namespace = name_space
                                self.header_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "header-sp-fs"):
                                self.header_sp_fs = value
                                self.header_sp_fs.value_namespace = name_space
                                self.header_sp_fs.value_namespace_prefix = name_space_prefix


                    class SpfRuntime(Entity):
                        """
                        List of SPF run\-time statistics
                        
                        .. attribute:: area_stat
                        
                        	List of per\-area SPF statistics
                        	**type**\: list of    :py:class:`AreaStat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat>`
                        
                        .. attribute:: global_time
                        
                        	Global SPF times
                        	**type**\:   :py:class:`GlobalTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.GlobalTime>`
                        
                        .. attribute:: lsa
                        
                        	List of LSAs triggering the SPF calculation
                        	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.Lsa>`
                        
                        .. attribute:: lsa_changes
                        
                        	Number of LSA changes triggering an SPF calculation
                        	**type**\:  int
                        
                        	**range:** \-32768..32767
                        
                        .. attribute:: reason_flags
                        
                        	Reasons for triggering an SPF calculation Bit 1 \- Router LSA update Bit 2 \- Network LSA update Bit 3 \- Inter\-Area Prefix LSA update Bit 4 \- Inter\-Area Router LSA update Bit 5 \- AS External LSA update Bit 6 \- MOSPF LSA update Bit 7 \- Type 7 AS External LSA update Bit 8 \- Link LSA update Bit 9 \- Prefix LSA update
                        	**type**\:  str
                        
                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                        
                        .. attribute:: rib_add_routes
                        
                        	Number of routes added to RIB
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rib_delete_routes
                        
                        	Number of routes deleted from RIB
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: start_time
                        
                        	SPF calculation start time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime, self).__init__()

                            self.yang_name = "spf-runtime"
                            self.yang_parent_name = "spf-stats"

                            self.lsa_changes = YLeaf(YType.int16, "lsa-changes")

                            self.reason_flags = YLeaf(YType.str, "reason-flags")

                            self.rib_add_routes = YLeaf(YType.uint32, "rib-add-routes")

                            self.rib_delete_routes = YLeaf(YType.uint32, "rib-delete-routes")

                            self.start_time = YLeaf(YType.uint32, "start-time")

                            self.global_time = Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.GlobalTime()
                            self.global_time.parent = self
                            self._children_name_map["global_time"] = "global-time"
                            self._children_yang_names.add("global-time")

                            self.area_stat = YList(self)
                            self.lsa = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lsa_changes",
                                            "reason_flags",
                                            "rib_add_routes",
                                            "rib_delete_routes",
                                            "start_time") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime, self).__setattr__(name, value)


                        class GlobalTime(Entity):
                            """
                            Global SPF times
                            
                            .. attribute:: dijkstra
                            
                            	Dijkstra time in msec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: external_prefix
                            
                            	External prefix processing time in msec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: external_prefix_del
                            
                            	External prefix deletion time in msec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: inter_prefix
                            
                            	Inter\-prefix processing time in msec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: inter_prefix_del
                            
                            	Intra\-prefix deletion time in msec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: intra_prefix
                            
                            	Intra\-prefix processing time in msec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: intra_prefix_del
                            
                            	Intra\-prefix deletion time in msec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rib_add
                            
                            	RIB add processing time in msec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rib_del
                            
                            	RIB deletion time in msec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.GlobalTime, self).__init__()

                                self.yang_name = "global-time"
                                self.yang_parent_name = "spf-runtime"

                                self.dijkstra = YLeaf(YType.uint32, "dijkstra")

                                self.external_prefix = YLeaf(YType.uint32, "external-prefix")

                                self.external_prefix_del = YLeaf(YType.uint32, "external-prefix-del")

                                self.inter_prefix = YLeaf(YType.uint32, "inter-prefix")

                                self.inter_prefix_del = YLeaf(YType.uint32, "inter-prefix-del")

                                self.intra_prefix = YLeaf(YType.uint32, "intra-prefix")

                                self.intra_prefix_del = YLeaf(YType.uint32, "intra-prefix-del")

                                self.rib_add = YLeaf(YType.uint32, "rib-add")

                                self.rib_del = YLeaf(YType.uint32, "rib-del")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("dijkstra",
                                                "external_prefix",
                                                "external_prefix_del",
                                                "inter_prefix",
                                                "inter_prefix_del",
                                                "intra_prefix",
                                                "intra_prefix_del",
                                                "rib_add",
                                                "rib_del") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.GlobalTime, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.GlobalTime, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.dijkstra.is_set or
                                    self.external_prefix.is_set or
                                    self.external_prefix_del.is_set or
                                    self.inter_prefix.is_set or
                                    self.inter_prefix_del.is_set or
                                    self.intra_prefix.is_set or
                                    self.intra_prefix_del.is_set or
                                    self.rib_add.is_set or
                                    self.rib_del.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.dijkstra.yfilter != YFilter.not_set or
                                    self.external_prefix.yfilter != YFilter.not_set or
                                    self.external_prefix_del.yfilter != YFilter.not_set or
                                    self.inter_prefix.yfilter != YFilter.not_set or
                                    self.inter_prefix_del.yfilter != YFilter.not_set or
                                    self.intra_prefix.yfilter != YFilter.not_set or
                                    self.intra_prefix_del.yfilter != YFilter.not_set or
                                    self.rib_add.yfilter != YFilter.not_set or
                                    self.rib_del.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "global-time" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.dijkstra.is_set or self.dijkstra.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dijkstra.get_name_leafdata())
                                if (self.external_prefix.is_set or self.external_prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.external_prefix.get_name_leafdata())
                                if (self.external_prefix_del.is_set or self.external_prefix_del.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.external_prefix_del.get_name_leafdata())
                                if (self.inter_prefix.is_set or self.inter_prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inter_prefix.get_name_leafdata())
                                if (self.inter_prefix_del.is_set or self.inter_prefix_del.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inter_prefix_del.get_name_leafdata())
                                if (self.intra_prefix.is_set or self.intra_prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.intra_prefix.get_name_leafdata())
                                if (self.intra_prefix_del.is_set or self.intra_prefix_del.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.intra_prefix_del.get_name_leafdata())
                                if (self.rib_add.is_set or self.rib_add.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rib_add.get_name_leafdata())
                                if (self.rib_del.is_set or self.rib_del.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rib_del.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dijkstra" or name == "external-prefix" or name == "external-prefix-del" or name == "inter-prefix" or name == "inter-prefix-del" or name == "intra-prefix" or name == "intra-prefix-del" or name == "rib-add" or name == "rib-del"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "dijkstra"):
                                    self.dijkstra = value
                                    self.dijkstra.value_namespace = name_space
                                    self.dijkstra.value_namespace_prefix = name_space_prefix
                                if(value_path == "external-prefix"):
                                    self.external_prefix = value
                                    self.external_prefix.value_namespace = name_space
                                    self.external_prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "external-prefix-del"):
                                    self.external_prefix_del = value
                                    self.external_prefix_del.value_namespace = name_space
                                    self.external_prefix_del.value_namespace_prefix = name_space_prefix
                                if(value_path == "inter-prefix"):
                                    self.inter_prefix = value
                                    self.inter_prefix.value_namespace = name_space
                                    self.inter_prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "inter-prefix-del"):
                                    self.inter_prefix_del = value
                                    self.inter_prefix_del.value_namespace = name_space
                                    self.inter_prefix_del.value_namespace_prefix = name_space_prefix
                                if(value_path == "intra-prefix"):
                                    self.intra_prefix = value
                                    self.intra_prefix.value_namespace = name_space
                                    self.intra_prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "intra-prefix-del"):
                                    self.intra_prefix_del = value
                                    self.intra_prefix_del.value_namespace = name_space
                                    self.intra_prefix_del.value_namespace_prefix = name_space_prefix
                                if(value_path == "rib-add"):
                                    self.rib_add = value
                                    self.rib_add.value_namespace = name_space
                                    self.rib_add.value_namespace_prefix = name_space_prefix
                                if(value_path == "rib-del"):
                                    self.rib_del = value
                                    self.rib_del.value_namespace = name_space
                                    self.rib_del.value_namespace_prefix = name_space_prefix


                        class Lsa(Entity):
                            """
                            List of LSAs triggering the SPF calculation
                            
                            .. attribute:: lsa_advertising_router
                            
                            	Advertising router ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: lsa_area_id
                            
                            	Area ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa_flush
                            
                            	If true, the LSA change is a flush
                            	**type**\:  bool
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.Lsa, self).__init__()

                                self.yang_name = "lsa"
                                self.yang_parent_name = "spf-runtime"

                                self.lsa_advertising_router = YLeaf(YType.str, "lsa-advertising-router")

                                self.lsa_area_id = YLeaf(YType.uint32, "lsa-area-id")

                                self.lsa_flush = YLeaf(YType.boolean, "lsa-flush")

                                self.lsa_id = YLeaf(YType.str, "lsa-id")

                                self.lsa_type = YLeaf(YType.uint8, "lsa-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsa_advertising_router",
                                                "lsa_area_id",
                                                "lsa_flush",
                                                "lsa_id",
                                                "lsa_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.Lsa, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.Lsa, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsa_advertising_router.is_set or
                                    self.lsa_area_id.is_set or
                                    self.lsa_flush.is_set or
                                    self.lsa_id.is_set or
                                    self.lsa_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsa_advertising_router.yfilter != YFilter.not_set or
                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                    self.lsa_flush.yfilter != YFilter.not_set or
                                    self.lsa_id.yfilter != YFilter.not_set or
                                    self.lsa_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsa" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsa_advertising_router.is_set or self.lsa_advertising_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_advertising_router.get_name_leafdata())
                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                if (self.lsa_flush.is_set or self.lsa_flush.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_flush.get_name_leafdata())
                                if (self.lsa_id.is_set or self.lsa_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_id.get_name_leafdata())
                                if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsa-advertising-router" or name == "lsa-area-id" or name == "lsa-flush" or name == "lsa-id" or name == "lsa-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsa-advertising-router"):
                                    self.lsa_advertising_router = value
                                    self.lsa_advertising_router.value_namespace = name_space
                                    self.lsa_advertising_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-area-id"):
                                    self.lsa_area_id = value
                                    self.lsa_area_id.value_namespace = name_space
                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-flush"):
                                    self.lsa_flush = value
                                    self.lsa_flush.value_namespace = name_space
                                    self.lsa_flush.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-id"):
                                    self.lsa_id = value
                                    self.lsa_id.value_namespace = name_space
                                    self.lsa_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-type"):
                                    self.lsa_type = value
                                    self.lsa_type.value_namespace = name_space
                                    self.lsa_type.value_namespace_prefix = name_space_prefix


                        class AreaStat(Entity):
                            """
                            List of per\-area SPF statistics
                            
                            .. attribute:: spf_stat_area_id
                            
                            	Area ID for area of these SPF statistics
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: spf_stat_lsa_type_count
                            
                            	Counts of LSA types triggering an SPF calculation
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: spf_stat_time
                            
                            	SPF time calculations
                            	**type**\:   :py:class:`SpfStatTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat, self).__init__()

                                self.yang_name = "area-stat"
                                self.yang_parent_name = "spf-runtime"

                                self.spf_stat_area_id = YLeaf(YType.uint32, "spf-stat-area-id")

                                self.spf_stat_lsa_type_count = YLeafList(YType.uint32, "spf-stat-lsa-type-count")

                                self.spf_stat_time = Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime()
                                self.spf_stat_time.parent = self
                                self._children_name_map["spf_stat_time"] = "spf-stat-time"
                                self._children_yang_names.add("spf-stat-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("spf_stat_area_id",
                                                "spf_stat_lsa_type_count") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat, self).__setattr__(name, value)


                            class SpfStatTime(Entity):
                                """
                                SPF time calculations
                                
                                .. attribute:: dijkstra
                                
                                	Dijkstra time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: external_prefix
                                
                                	External prefix processing time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: external_prefix_del
                                
                                	External prefix deletion time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: inter_prefix
                                
                                	Inter\-prefix processing time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: inter_prefix_del
                                
                                	Intra\-prefix deletion time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intra_prefix
                                
                                	Intra\-prefix processing time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intra_prefix_del
                                
                                	Intra\-prefix deletion time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rib_add
                                
                                	RIB add processing time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rib_del
                                
                                	RIB deletion time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime, self).__init__()

                                    self.yang_name = "spf-stat-time"
                                    self.yang_parent_name = "area-stat"

                                    self.dijkstra = YLeaf(YType.uint32, "dijkstra")

                                    self.external_prefix = YLeaf(YType.uint32, "external-prefix")

                                    self.external_prefix_del = YLeaf(YType.uint32, "external-prefix-del")

                                    self.inter_prefix = YLeaf(YType.uint32, "inter-prefix")

                                    self.inter_prefix_del = YLeaf(YType.uint32, "inter-prefix-del")

                                    self.intra_prefix = YLeaf(YType.uint32, "intra-prefix")

                                    self.intra_prefix_del = YLeaf(YType.uint32, "intra-prefix-del")

                                    self.rib_add = YLeaf(YType.uint32, "rib-add")

                                    self.rib_del = YLeaf(YType.uint32, "rib-del")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dijkstra",
                                                    "external_prefix",
                                                    "external_prefix_del",
                                                    "inter_prefix",
                                                    "inter_prefix_del",
                                                    "intra_prefix",
                                                    "intra_prefix_del",
                                                    "rib_add",
                                                    "rib_del") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.dijkstra.is_set or
                                        self.external_prefix.is_set or
                                        self.external_prefix_del.is_set or
                                        self.inter_prefix.is_set or
                                        self.inter_prefix_del.is_set or
                                        self.intra_prefix.is_set or
                                        self.intra_prefix_del.is_set or
                                        self.rib_add.is_set or
                                        self.rib_del.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dijkstra.yfilter != YFilter.not_set or
                                        self.external_prefix.yfilter != YFilter.not_set or
                                        self.external_prefix_del.yfilter != YFilter.not_set or
                                        self.inter_prefix.yfilter != YFilter.not_set or
                                        self.inter_prefix_del.yfilter != YFilter.not_set or
                                        self.intra_prefix.yfilter != YFilter.not_set or
                                        self.intra_prefix_del.yfilter != YFilter.not_set or
                                        self.rib_add.yfilter != YFilter.not_set or
                                        self.rib_del.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "spf-stat-time" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dijkstra.is_set or self.dijkstra.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dijkstra.get_name_leafdata())
                                    if (self.external_prefix.is_set or self.external_prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.external_prefix.get_name_leafdata())
                                    if (self.external_prefix_del.is_set or self.external_prefix_del.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.external_prefix_del.get_name_leafdata())
                                    if (self.inter_prefix.is_set or self.inter_prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.inter_prefix.get_name_leafdata())
                                    if (self.inter_prefix_del.is_set or self.inter_prefix_del.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.inter_prefix_del.get_name_leafdata())
                                    if (self.intra_prefix.is_set or self.intra_prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intra_prefix.get_name_leafdata())
                                    if (self.intra_prefix_del.is_set or self.intra_prefix_del.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intra_prefix_del.get_name_leafdata())
                                    if (self.rib_add.is_set or self.rib_add.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rib_add.get_name_leafdata())
                                    if (self.rib_del.is_set or self.rib_del.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rib_del.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dijkstra" or name == "external-prefix" or name == "external-prefix-del" or name == "inter-prefix" or name == "inter-prefix-del" or name == "intra-prefix" or name == "intra-prefix-del" or name == "rib-add" or name == "rib-del"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dijkstra"):
                                        self.dijkstra = value
                                        self.dijkstra.value_namespace = name_space
                                        self.dijkstra.value_namespace_prefix = name_space_prefix
                                    if(value_path == "external-prefix"):
                                        self.external_prefix = value
                                        self.external_prefix.value_namespace = name_space
                                        self.external_prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "external-prefix-del"):
                                        self.external_prefix_del = value
                                        self.external_prefix_del.value_namespace = name_space
                                        self.external_prefix_del.value_namespace_prefix = name_space_prefix
                                    if(value_path == "inter-prefix"):
                                        self.inter_prefix = value
                                        self.inter_prefix.value_namespace = name_space
                                        self.inter_prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "inter-prefix-del"):
                                        self.inter_prefix_del = value
                                        self.inter_prefix_del.value_namespace = name_space
                                        self.inter_prefix_del.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intra-prefix"):
                                        self.intra_prefix = value
                                        self.intra_prefix.value_namespace = name_space
                                        self.intra_prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intra-prefix-del"):
                                        self.intra_prefix_del = value
                                        self.intra_prefix_del.value_namespace = name_space
                                        self.intra_prefix_del.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rib-add"):
                                        self.rib_add = value
                                        self.rib_add.value_namespace = name_space
                                        self.rib_add.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rib-del"):
                                        self.rib_del = value
                                        self.rib_del.value_namespace = name_space
                                        self.rib_del.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for leaf in self.spf_stat_lsa_type_count.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                return (
                                    self.spf_stat_area_id.is_set or
                                    (self.spf_stat_time is not None and self.spf_stat_time.has_data()))

                            def has_operation(self):
                                for leaf in self.spf_stat_lsa_type_count.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.spf_stat_area_id.yfilter != YFilter.not_set or
                                    self.spf_stat_lsa_type_count.yfilter != YFilter.not_set or
                                    (self.spf_stat_time is not None and self.spf_stat_time.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "area-stat" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.spf_stat_area_id.is_set or self.spf_stat_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spf_stat_area_id.get_name_leafdata())

                                leaf_name_data.extend(self.spf_stat_lsa_type_count.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "spf-stat-time"):
                                    if (self.spf_stat_time is None):
                                        self.spf_stat_time = Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime()
                                        self.spf_stat_time.parent = self
                                        self._children_name_map["spf_stat_time"] = "spf-stat-time"
                                    return self.spf_stat_time

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "spf-stat-time" or name == "spf-stat-area-id" or name == "spf-stat-lsa-type-count"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "spf-stat-area-id"):
                                    self.spf_stat_area_id = value
                                    self.spf_stat_area_id.value_namespace = name_space
                                    self.spf_stat_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "spf-stat-lsa-type-count"):
                                    self.spf_stat_lsa_type_count.append(value)

                        def has_data(self):
                            for c in self.area_stat:
                                if (c.has_data()):
                                    return True
                            for c in self.lsa:
                                if (c.has_data()):
                                    return True
                            return (
                                self.lsa_changes.is_set or
                                self.reason_flags.is_set or
                                self.rib_add_routes.is_set or
                                self.rib_delete_routes.is_set or
                                self.start_time.is_set or
                                (self.global_time is not None and self.global_time.has_data()))

                        def has_operation(self):
                            for c in self.area_stat:
                                if (c.has_operation()):
                                    return True
                            for c in self.lsa:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lsa_changes.yfilter != YFilter.not_set or
                                self.reason_flags.yfilter != YFilter.not_set or
                                self.rib_add_routes.yfilter != YFilter.not_set or
                                self.rib_delete_routes.yfilter != YFilter.not_set or
                                self.start_time.yfilter != YFilter.not_set or
                                (self.global_time is not None and self.global_time.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "spf-runtime" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lsa_changes.is_set or self.lsa_changes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsa_changes.get_name_leafdata())
                            if (self.reason_flags.is_set or self.reason_flags.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reason_flags.get_name_leafdata())
                            if (self.rib_add_routes.is_set or self.rib_add_routes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rib_add_routes.get_name_leafdata())
                            if (self.rib_delete_routes.is_set or self.rib_delete_routes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rib_delete_routes.get_name_leafdata())
                            if (self.start_time.is_set or self.start_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.start_time.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "area-stat"):
                                for c in self.area_stat:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.AreaStat()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.area_stat.append(c)
                                return c

                            if (child_yang_name == "global-time"):
                                if (self.global_time is None):
                                    self.global_time = Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.GlobalTime()
                                    self.global_time.parent = self
                                    self._children_name_map["global_time"] = "global-time"
                                return self.global_time

                            if (child_yang_name == "lsa"):
                                for c in self.lsa:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime.Lsa()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.lsa.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area-stat" or name == "global-time" or name == "lsa" or name == "lsa-changes" or name == "reason-flags" or name == "rib-add-routes" or name == "rib-delete-routes" or name == "start-time"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lsa-changes"):
                                self.lsa_changes = value
                                self.lsa_changes.value_namespace = name_space
                                self.lsa_changes.value_namespace_prefix = name_space_prefix
                            if(value_path == "reason-flags"):
                                self.reason_flags = value
                                self.reason_flags.value_namespace = name_space
                                self.reason_flags.value_namespace_prefix = name_space_prefix
                            if(value_path == "rib-add-routes"):
                                self.rib_add_routes = value
                                self.rib_add_routes.value_namespace = name_space
                                self.rib_add_routes.value_namespace_prefix = name_space_prefix
                            if(value_path == "rib-delete-routes"):
                                self.rib_delete_routes = value
                                self.rib_delete_routes.value_namespace = name_space
                                self.rib_delete_routes.value_namespace_prefix = name_space_prefix
                            if(value_path == "start-time"):
                                self.start_time = value
                                self.start_time.value_namespace = name_space
                                self.start_time.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.spf_runtime:
                            if (c.has_data()):
                                return True
                        return (self.spf_header is not None and self.spf_header.has_data())

                    def has_operation(self):
                        for c in self.spf_runtime:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.spf_header is not None and self.spf_header.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "spf-stats" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "spf-header"):
                            if (self.spf_header is None):
                                self.spf_header = Ospfv3.Processes.Process.Statistics.SpfStats.SpfHeader()
                                self.spf_header.parent = self
                                self._children_name_map["spf_header"] = "spf-header"
                            return self.spf_header

                        if (child_yang_name == "spf-runtime"):
                            for c in self.spf_runtime:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.Statistics.SpfStats.SpfRuntime()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.spf_runtime.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "spf-header" or name == "spf-runtime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class RawioStats(Entity):
                    """
                    OSPF Prefix SPF Prioritization statistics
                    
                    .. attribute:: in_bytes
                    
                    	Received Bytes
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: in_error_drops
                    
                    	In Error Drops
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: in_handle_drops
                    
                    	In Handle Drops
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: in_ipsec_drops
                    
                    	In IPSEC Drops
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: in_long_packets
                    
                    	Received Long Packets
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: in_malloc_drops
                    
                    	In Malloc Drops
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: in_packets
                    
                    	Received Packets
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: in_queue_drops
                    
                    	In Queue Drops
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: in_short_drops
                    
                    	In Short Drops
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: out_bytes
                    
                    	Sent Bytes
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: out_error_drops
                    
                    	Error Drops
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: out_ipsec_drops
                    
                    	Out IPSEC Drops
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: out_nofd_drops
                    
                    	No FileDescriptor Drops
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: out_nopak_drops
                    
                    	No Packet Buffers
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: out_packets
                    
                    	Packets Sent
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: out_pakapi_errors
                    
                    	PAK API Errors
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: raw_conn_close
                    
                    	Raw Connections Close
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: raw_conn_error
                    
                    	Raw Connections Error
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: raw_conn_open
                    
                    	Raw Connections Open
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: raw_conn_state
                    
                    	Raw Connection State
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.Statistics.RawioStats, self).__init__()

                        self.yang_name = "rawio-stats"
                        self.yang_parent_name = "statistics"

                        self.in_bytes = YLeaf(YType.uint64, "in-bytes")

                        self.in_error_drops = YLeaf(YType.uint64, "in-error-drops")

                        self.in_handle_drops = YLeaf(YType.uint64, "in-handle-drops")

                        self.in_ipsec_drops = YLeaf(YType.uint64, "in-ipsec-drops")

                        self.in_long_packets = YLeaf(YType.uint64, "in-long-packets")

                        self.in_malloc_drops = YLeaf(YType.uint64, "in-malloc-drops")

                        self.in_packets = YLeaf(YType.uint64, "in-packets")

                        self.in_queue_drops = YLeaf(YType.uint64, "in-queue-drops")

                        self.in_short_drops = YLeaf(YType.uint64, "in-short-drops")

                        self.out_bytes = YLeaf(YType.uint64, "out-bytes")

                        self.out_error_drops = YLeaf(YType.uint64, "out-error-drops")

                        self.out_ipsec_drops = YLeaf(YType.uint64, "out-ipsec-drops")

                        self.out_nofd_drops = YLeaf(YType.uint64, "out-nofd-drops")

                        self.out_nopak_drops = YLeaf(YType.uint64, "out-nopak-drops")

                        self.out_packets = YLeaf(YType.uint64, "out-packets")

                        self.out_pakapi_errors = YLeaf(YType.uint64, "out-pakapi-errors")

                        self.raw_conn_close = YLeaf(YType.uint64, "raw-conn-close")

                        self.raw_conn_error = YLeaf(YType.uint64, "raw-conn-error")

                        self.raw_conn_open = YLeaf(YType.uint64, "raw-conn-open")

                        self.raw_conn_state = YLeaf(YType.uint32, "raw-conn-state")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("in_bytes",
                                        "in_error_drops",
                                        "in_handle_drops",
                                        "in_ipsec_drops",
                                        "in_long_packets",
                                        "in_malloc_drops",
                                        "in_packets",
                                        "in_queue_drops",
                                        "in_short_drops",
                                        "out_bytes",
                                        "out_error_drops",
                                        "out_ipsec_drops",
                                        "out_nofd_drops",
                                        "out_nopak_drops",
                                        "out_packets",
                                        "out_pakapi_errors",
                                        "raw_conn_close",
                                        "raw_conn_error",
                                        "raw_conn_open",
                                        "raw_conn_state") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.Statistics.RawioStats, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.Statistics.RawioStats, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.in_bytes.is_set or
                            self.in_error_drops.is_set or
                            self.in_handle_drops.is_set or
                            self.in_ipsec_drops.is_set or
                            self.in_long_packets.is_set or
                            self.in_malloc_drops.is_set or
                            self.in_packets.is_set or
                            self.in_queue_drops.is_set or
                            self.in_short_drops.is_set or
                            self.out_bytes.is_set or
                            self.out_error_drops.is_set or
                            self.out_ipsec_drops.is_set or
                            self.out_nofd_drops.is_set or
                            self.out_nopak_drops.is_set or
                            self.out_packets.is_set or
                            self.out_pakapi_errors.is_set or
                            self.raw_conn_close.is_set or
                            self.raw_conn_error.is_set or
                            self.raw_conn_open.is_set or
                            self.raw_conn_state.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.in_bytes.yfilter != YFilter.not_set or
                            self.in_error_drops.yfilter != YFilter.not_set or
                            self.in_handle_drops.yfilter != YFilter.not_set or
                            self.in_ipsec_drops.yfilter != YFilter.not_set or
                            self.in_long_packets.yfilter != YFilter.not_set or
                            self.in_malloc_drops.yfilter != YFilter.not_set or
                            self.in_packets.yfilter != YFilter.not_set or
                            self.in_queue_drops.yfilter != YFilter.not_set or
                            self.in_short_drops.yfilter != YFilter.not_set or
                            self.out_bytes.yfilter != YFilter.not_set or
                            self.out_error_drops.yfilter != YFilter.not_set or
                            self.out_ipsec_drops.yfilter != YFilter.not_set or
                            self.out_nofd_drops.yfilter != YFilter.not_set or
                            self.out_nopak_drops.yfilter != YFilter.not_set or
                            self.out_packets.yfilter != YFilter.not_set or
                            self.out_pakapi_errors.yfilter != YFilter.not_set or
                            self.raw_conn_close.yfilter != YFilter.not_set or
                            self.raw_conn_error.yfilter != YFilter.not_set or
                            self.raw_conn_open.yfilter != YFilter.not_set or
                            self.raw_conn_state.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rawio-stats" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.in_bytes.is_set or self.in_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_bytes.get_name_leafdata())
                        if (self.in_error_drops.is_set or self.in_error_drops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_error_drops.get_name_leafdata())
                        if (self.in_handle_drops.is_set or self.in_handle_drops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_handle_drops.get_name_leafdata())
                        if (self.in_ipsec_drops.is_set or self.in_ipsec_drops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_ipsec_drops.get_name_leafdata())
                        if (self.in_long_packets.is_set or self.in_long_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_long_packets.get_name_leafdata())
                        if (self.in_malloc_drops.is_set or self.in_malloc_drops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_malloc_drops.get_name_leafdata())
                        if (self.in_packets.is_set or self.in_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_packets.get_name_leafdata())
                        if (self.in_queue_drops.is_set or self.in_queue_drops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_queue_drops.get_name_leafdata())
                        if (self.in_short_drops.is_set or self.in_short_drops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_short_drops.get_name_leafdata())
                        if (self.out_bytes.is_set or self.out_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_bytes.get_name_leafdata())
                        if (self.out_error_drops.is_set or self.out_error_drops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_error_drops.get_name_leafdata())
                        if (self.out_ipsec_drops.is_set or self.out_ipsec_drops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_ipsec_drops.get_name_leafdata())
                        if (self.out_nofd_drops.is_set or self.out_nofd_drops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_nofd_drops.get_name_leafdata())
                        if (self.out_nopak_drops.is_set or self.out_nopak_drops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_nopak_drops.get_name_leafdata())
                        if (self.out_packets.is_set or self.out_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_packets.get_name_leafdata())
                        if (self.out_pakapi_errors.is_set or self.out_pakapi_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_pakapi_errors.get_name_leafdata())
                        if (self.raw_conn_close.is_set or self.raw_conn_close.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.raw_conn_close.get_name_leafdata())
                        if (self.raw_conn_error.is_set or self.raw_conn_error.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.raw_conn_error.get_name_leafdata())
                        if (self.raw_conn_open.is_set or self.raw_conn_open.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.raw_conn_open.get_name_leafdata())
                        if (self.raw_conn_state.is_set or self.raw_conn_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.raw_conn_state.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "in-bytes" or name == "in-error-drops" or name == "in-handle-drops" or name == "in-ipsec-drops" or name == "in-long-packets" or name == "in-malloc-drops" or name == "in-packets" or name == "in-queue-drops" or name == "in-short-drops" or name == "out-bytes" or name == "out-error-drops" or name == "out-ipsec-drops" or name == "out-nofd-drops" or name == "out-nopak-drops" or name == "out-packets" or name == "out-pakapi-errors" or name == "raw-conn-close" or name == "raw-conn-error" or name == "raw-conn-open" or name == "raw-conn-state"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "in-bytes"):
                            self.in_bytes = value
                            self.in_bytes.value_namespace = name_space
                            self.in_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "in-error-drops"):
                            self.in_error_drops = value
                            self.in_error_drops.value_namespace = name_space
                            self.in_error_drops.value_namespace_prefix = name_space_prefix
                        if(value_path == "in-handle-drops"):
                            self.in_handle_drops = value
                            self.in_handle_drops.value_namespace = name_space
                            self.in_handle_drops.value_namespace_prefix = name_space_prefix
                        if(value_path == "in-ipsec-drops"):
                            self.in_ipsec_drops = value
                            self.in_ipsec_drops.value_namespace = name_space
                            self.in_ipsec_drops.value_namespace_prefix = name_space_prefix
                        if(value_path == "in-long-packets"):
                            self.in_long_packets = value
                            self.in_long_packets.value_namespace = name_space
                            self.in_long_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "in-malloc-drops"):
                            self.in_malloc_drops = value
                            self.in_malloc_drops.value_namespace = name_space
                            self.in_malloc_drops.value_namespace_prefix = name_space_prefix
                        if(value_path == "in-packets"):
                            self.in_packets = value
                            self.in_packets.value_namespace = name_space
                            self.in_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "in-queue-drops"):
                            self.in_queue_drops = value
                            self.in_queue_drops.value_namespace = name_space
                            self.in_queue_drops.value_namespace_prefix = name_space_prefix
                        if(value_path == "in-short-drops"):
                            self.in_short_drops = value
                            self.in_short_drops.value_namespace = name_space
                            self.in_short_drops.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-bytes"):
                            self.out_bytes = value
                            self.out_bytes.value_namespace = name_space
                            self.out_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-error-drops"):
                            self.out_error_drops = value
                            self.out_error_drops.value_namespace = name_space
                            self.out_error_drops.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-ipsec-drops"):
                            self.out_ipsec_drops = value
                            self.out_ipsec_drops.value_namespace = name_space
                            self.out_ipsec_drops.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-nofd-drops"):
                            self.out_nofd_drops = value
                            self.out_nofd_drops.value_namespace = name_space
                            self.out_nofd_drops.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-nopak-drops"):
                            self.out_nopak_drops = value
                            self.out_nopak_drops.value_namespace = name_space
                            self.out_nopak_drops.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-packets"):
                            self.out_packets = value
                            self.out_packets.value_namespace = name_space
                            self.out_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-pakapi-errors"):
                            self.out_pakapi_errors = value
                            self.out_pakapi_errors.value_namespace = name_space
                            self.out_pakapi_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "raw-conn-close"):
                            self.raw_conn_close = value
                            self.raw_conn_close.value_namespace = name_space
                            self.raw_conn_close.value_namespace_prefix = name_space_prefix
                        if(value_path == "raw-conn-error"):
                            self.raw_conn_error = value
                            self.raw_conn_error.value_namespace = name_space
                            self.raw_conn_error.value_namespace_prefix = name_space_prefix
                        if(value_path == "raw-conn-open"):
                            self.raw_conn_open = value
                            self.raw_conn_open.value_namespace = name_space
                            self.raw_conn_open.value_namespace_prefix = name_space_prefix
                        if(value_path == "raw-conn-state"):
                            self.raw_conn_state = value
                            self.raw_conn_state.value_namespace = name_space
                            self.raw_conn_state.value_namespace_prefix = name_space_prefix


                class PrefixPriorityStats(Entity):
                    """
                    OSPF Prefix SPF Prioritization statistics
                    
                    .. attribute:: critical
                    
                    	Critical priority classifications
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: high
                    
                    	High priority classifications
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: low
                    
                    	Low priority classifications
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: medium
                    
                    	Medium priority classifications
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.Statistics.PrefixPriorityStats, self).__init__()

                        self.yang_name = "prefix-priority-stats"
                        self.yang_parent_name = "statistics"

                        self.critical = YLeaf(YType.uint32, "critical")

                        self.high = YLeaf(YType.uint32, "high")

                        self.low = YLeaf(YType.uint32, "low")

                        self.medium = YLeaf(YType.uint32, "medium")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("critical",
                                        "high",
                                        "low",
                                        "medium") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.Statistics.PrefixPriorityStats, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.Statistics.PrefixPriorityStats, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.critical.is_set or
                            self.high.is_set or
                            self.low.is_set or
                            self.medium.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.critical.yfilter != YFilter.not_set or
                            self.high.yfilter != YFilter.not_set or
                            self.low.yfilter != YFilter.not_set or
                            self.medium.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "prefix-priority-stats" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.critical.is_set or self.critical.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.critical.get_name_leafdata())
                        if (self.high.is_set or self.high.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.high.get_name_leafdata())
                        if (self.low.is_set or self.low.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.low.get_name_leafdata())
                        if (self.medium.is_set or self.medium.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.medium.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "critical" or name == "high" or name == "low" or name == "medium"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "critical"):
                            self.critical = value
                            self.critical.value_namespace = name_space
                            self.critical.value_namespace_prefix = name_space_prefix
                        if(value_path == "high"):
                            self.high = value
                            self.high.value_namespace = name_space
                            self.high.value_namespace_prefix = name_space_prefix
                        if(value_path == "low"):
                            self.low = value
                            self.low.value_namespace = name_space
                            self.low.value_namespace_prefix = name_space_prefix
                        if(value_path == "medium"):
                            self.medium = value
                            self.medium.value_namespace = name_space
                            self.medium.value_namespace_prefix = name_space_prefix


                class VrfRibBatchStats(Entity):
                    """
                    OSPFv3 RIB batch statistics
                    
                    .. attribute:: batches_sent
                    
                    	No. of RIB batches sent
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: max_routes
                    
                    	Max No. of Routes in a batch
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: paths_add
                    
                    	No. of paths added to RIB
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: paths_add_errs
                    
                    	No. of paths add errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: paths_del
                    
                    	No. of paths del sent to RIB
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: paths_del_errs
                    
                    	No. of Paths del errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: paths_pending
                    
                    	No. of paths waiting to be sent to RIB
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: paths_sent
                    
                    	No. of Paths sent to RIB
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: routes_pending
                    
                    	No of Pending Routes
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: routes_sent
                    
                    	No. of Routes sent to RIB
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.Statistics.VrfRibBatchStats, self).__init__()

                        self.yang_name = "vrf-rib-batch-stats"
                        self.yang_parent_name = "statistics"

                        self.batches_sent = YLeaf(YType.uint32, "batches-sent")

                        self.max_routes = YLeaf(YType.uint32, "max-routes")

                        self.paths_add = YLeaf(YType.uint32, "paths-add")

                        self.paths_add_errs = YLeaf(YType.uint32, "paths-add-errs")

                        self.paths_del = YLeaf(YType.uint32, "paths-del")

                        self.paths_del_errs = YLeaf(YType.uint32, "paths-del-errs")

                        self.paths_pending = YLeaf(YType.uint32, "paths-pending")

                        self.paths_sent = YLeaf(YType.uint32, "paths-sent")

                        self.routes_pending = YLeaf(YType.uint32, "routes-pending")

                        self.routes_sent = YLeaf(YType.uint32, "routes-sent")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("batches_sent",
                                        "max_routes",
                                        "paths_add",
                                        "paths_add_errs",
                                        "paths_del",
                                        "paths_del_errs",
                                        "paths_pending",
                                        "paths_sent",
                                        "routes_pending",
                                        "routes_sent") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.Statistics.VrfRibBatchStats, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.Statistics.VrfRibBatchStats, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.batches_sent.is_set or
                            self.max_routes.is_set or
                            self.paths_add.is_set or
                            self.paths_add_errs.is_set or
                            self.paths_del.is_set or
                            self.paths_del_errs.is_set or
                            self.paths_pending.is_set or
                            self.paths_sent.is_set or
                            self.routes_pending.is_set or
                            self.routes_sent.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.batches_sent.yfilter != YFilter.not_set or
                            self.max_routes.yfilter != YFilter.not_set or
                            self.paths_add.yfilter != YFilter.not_set or
                            self.paths_add_errs.yfilter != YFilter.not_set or
                            self.paths_del.yfilter != YFilter.not_set or
                            self.paths_del_errs.yfilter != YFilter.not_set or
                            self.paths_pending.yfilter != YFilter.not_set or
                            self.paths_sent.yfilter != YFilter.not_set or
                            self.routes_pending.yfilter != YFilter.not_set or
                            self.routes_sent.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf-rib-batch-stats" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.batches_sent.is_set or self.batches_sent.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.batches_sent.get_name_leafdata())
                        if (self.max_routes.is_set or self.max_routes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.max_routes.get_name_leafdata())
                        if (self.paths_add.is_set or self.paths_add.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.paths_add.get_name_leafdata())
                        if (self.paths_add_errs.is_set or self.paths_add_errs.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.paths_add_errs.get_name_leafdata())
                        if (self.paths_del.is_set or self.paths_del.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.paths_del.get_name_leafdata())
                        if (self.paths_del_errs.is_set or self.paths_del_errs.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.paths_del_errs.get_name_leafdata())
                        if (self.paths_pending.is_set or self.paths_pending.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.paths_pending.get_name_leafdata())
                        if (self.paths_sent.is_set or self.paths_sent.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.paths_sent.get_name_leafdata())
                        if (self.routes_pending.is_set or self.routes_pending.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.routes_pending.get_name_leafdata())
                        if (self.routes_sent.is_set or self.routes_sent.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.routes_sent.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "batches-sent" or name == "max-routes" or name == "paths-add" or name == "paths-add-errs" or name == "paths-del" or name == "paths-del-errs" or name == "paths-pending" or name == "paths-sent" or name == "routes-pending" or name == "routes-sent"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "batches-sent"):
                            self.batches_sent = value
                            self.batches_sent.value_namespace = name_space
                            self.batches_sent.value_namespace_prefix = name_space_prefix
                        if(value_path == "max-routes"):
                            self.max_routes = value
                            self.max_routes.value_namespace = name_space
                            self.max_routes.value_namespace_prefix = name_space_prefix
                        if(value_path == "paths-add"):
                            self.paths_add = value
                            self.paths_add.value_namespace = name_space
                            self.paths_add.value_namespace_prefix = name_space_prefix
                        if(value_path == "paths-add-errs"):
                            self.paths_add_errs = value
                            self.paths_add_errs.value_namespace = name_space
                            self.paths_add_errs.value_namespace_prefix = name_space_prefix
                        if(value_path == "paths-del"):
                            self.paths_del = value
                            self.paths_del.value_namespace = name_space
                            self.paths_del.value_namespace_prefix = name_space_prefix
                        if(value_path == "paths-del-errs"):
                            self.paths_del_errs = value
                            self.paths_del_errs.value_namespace = name_space
                            self.paths_del_errs.value_namespace_prefix = name_space_prefix
                        if(value_path == "paths-pending"):
                            self.paths_pending = value
                            self.paths_pending.value_namespace = name_space
                            self.paths_pending.value_namespace_prefix = name_space_prefix
                        if(value_path == "paths-sent"):
                            self.paths_sent = value
                            self.paths_sent.value_namespace = name_space
                            self.paths_sent.value_namespace_prefix = name_space_prefix
                        if(value_path == "routes-pending"):
                            self.routes_pending = value
                            self.routes_pending.value_namespace = name_space
                            self.routes_pending.value_namespace_prefix = name_space_prefix
                        if(value_path == "routes-sent"):
                            self.routes_sent = value
                            self.routes_sent.value_namespace = name_space
                            self.routes_sent.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.issu_stats is not None and self.issu_stats.has_data()) or
                        (self.nsr_pl_stats is not None and self.nsr_pl_stats.has_data()) or
                        (self.nsr_stats is not None and self.nsr_stats.has_data()) or
                        (self.prefix_priority_stats is not None and self.prefix_priority_stats.has_data()) or
                        (self.protocol_stats is not None and self.protocol_stats.has_data()) or
                        (self.rawio_stats is not None and self.rawio_stats.has_data()) or
                        (self.rib_thread_stats is not None and self.rib_thread_stats.has_data()) or
                        (self.spf_stats is not None and self.spf_stats.has_data()) or
                        (self.vrf_rib_batch_stats is not None and self.vrf_rib_batch_stats.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.issu_stats is not None and self.issu_stats.has_operation()) or
                        (self.nsr_pl_stats is not None and self.nsr_pl_stats.has_operation()) or
                        (self.nsr_stats is not None and self.nsr_stats.has_operation()) or
                        (self.prefix_priority_stats is not None and self.prefix_priority_stats.has_operation()) or
                        (self.protocol_stats is not None and self.protocol_stats.has_operation()) or
                        (self.rawio_stats is not None and self.rawio_stats.has_operation()) or
                        (self.rib_thread_stats is not None and self.rib_thread_stats.has_operation()) or
                        (self.spf_stats is not None and self.spf_stats.has_operation()) or
                        (self.vrf_rib_batch_stats is not None and self.vrf_rib_batch_stats.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "issu-stats"):
                        if (self.issu_stats is None):
                            self.issu_stats = Ospfv3.Processes.Process.Statistics.IssuStats()
                            self.issu_stats.parent = self
                            self._children_name_map["issu_stats"] = "issu-stats"
                        return self.issu_stats

                    if (child_yang_name == "nsr-pl-stats"):
                        if (self.nsr_pl_stats is None):
                            self.nsr_pl_stats = Ospfv3.Processes.Process.Statistics.NsrPlStats()
                            self.nsr_pl_stats.parent = self
                            self._children_name_map["nsr_pl_stats"] = "nsr-pl-stats"
                        return self.nsr_pl_stats

                    if (child_yang_name == "nsr-stats"):
                        if (self.nsr_stats is None):
                            self.nsr_stats = Ospfv3.Processes.Process.Statistics.NsrStats()
                            self.nsr_stats.parent = self
                            self._children_name_map["nsr_stats"] = "nsr-stats"
                        return self.nsr_stats

                    if (child_yang_name == "prefix-priority-stats"):
                        if (self.prefix_priority_stats is None):
                            self.prefix_priority_stats = Ospfv3.Processes.Process.Statistics.PrefixPriorityStats()
                            self.prefix_priority_stats.parent = self
                            self._children_name_map["prefix_priority_stats"] = "prefix-priority-stats"
                        return self.prefix_priority_stats

                    if (child_yang_name == "protocol-stats"):
                        if (self.protocol_stats is None):
                            self.protocol_stats = Ospfv3.Processes.Process.Statistics.ProtocolStats()
                            self.protocol_stats.parent = self
                            self._children_name_map["protocol_stats"] = "protocol-stats"
                        return self.protocol_stats

                    if (child_yang_name == "rawio-stats"):
                        if (self.rawio_stats is None):
                            self.rawio_stats = Ospfv3.Processes.Process.Statistics.RawioStats()
                            self.rawio_stats.parent = self
                            self._children_name_map["rawio_stats"] = "rawio-stats"
                        return self.rawio_stats

                    if (child_yang_name == "rib-thread-stats"):
                        if (self.rib_thread_stats is None):
                            self.rib_thread_stats = Ospfv3.Processes.Process.Statistics.RibThreadStats()
                            self.rib_thread_stats.parent = self
                            self._children_name_map["rib_thread_stats"] = "rib-thread-stats"
                        return self.rib_thread_stats

                    if (child_yang_name == "spf-stats"):
                        if (self.spf_stats is None):
                            self.spf_stats = Ospfv3.Processes.Process.Statistics.SpfStats()
                            self.spf_stats.parent = self
                            self._children_name_map["spf_stats"] = "spf-stats"
                        return self.spf_stats

                    if (child_yang_name == "vrf-rib-batch-stats"):
                        if (self.vrf_rib_batch_stats is None):
                            self.vrf_rib_batch_stats = Ospfv3.Processes.Process.Statistics.VrfRibBatchStats()
                            self.vrf_rib_batch_stats.parent = self
                            self._children_name_map["vrf_rib_batch_stats"] = "vrf-rib-batch-stats"
                        return self.vrf_rib_batch_stats

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "issu-stats" or name == "nsr-pl-stats" or name == "nsr-stats" or name == "prefix-priority-stats" or name == "protocol-stats" or name == "rawio-stats" or name == "rib-thread-stats" or name == "spf-stats" or name == "vrf-rib-batch-stats"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class DefaultVrf(Entity):
                """
                Operational data for the default VRF
                (instance) in the OSPFv3 process
                
                .. attribute:: area_informations
                
                	OSPFv3 area information table
                	**type**\:   :py:class:`AreaInformations <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.AreaInformations>`
                
                .. attribute:: areas
                
                	OSPFv3 area table
                	**type**\:   :py:class:`Areas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas>`
                
                .. attribute:: bad_checksums
                
                	Bad Checksum Packets information table
                	**type**\:   :py:class:`BadChecksums <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.BadChecksums>`
                
                .. attribute:: border_routers
                
                	OSPFv3 border router information table
                	**type**\:   :py:class:`BorderRouters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.BorderRouters>`
                
                .. attribute:: connected_routes
                
                	OSPFv3 connected route information table
                	**type**\:   :py:class:`ConnectedRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes>`
                
                .. attribute:: database_summary_table
                
                	Database summary table
                	**type**\:   :py:class:`DatabaseSummaryTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable>`
                
                .. attribute:: database_table
                
                	OSPF Link State Database
                	**type**\:   :py:class:`DatabaseTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable>`
                
                .. attribute:: external_routes
                
                	OSPFv3 external route information table
                	**type**\:   :py:class:`ExternalRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes>`
                
                .. attribute:: fast_reroutes
                
                	OSPFv3 fast reroute topology information table
                	**type**\:   :py:class:`FastReroutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.FastReroutes>`
                
                .. attribute:: flood_list_process_table
                
                	OSPFv3 flood list information table for all areas
                	**type**\:   :py:class:`FloodListProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable>`
                
                .. attribute:: interface_brief_process_table
                
                	OSPFv3 interface brief information table for all areas
                	**type**\:   :py:class:`InterfaceBriefProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable>`
                
                .. attribute:: interface_process_table
                
                	OSPFv3 interface information table for all areas
                	**type**\:   :py:class:`InterfaceProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable>`
                
                .. attribute:: internal_routes
                
                	OSPFv3 internal route information table
                	**type**\:   :py:class:`InternalRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InternalRoutes>`
                
                .. attribute:: neighbor_detail_process_table
                
                	OSPFv3 neighbor information table for all areas
                	**type**\:   :py:class:`NeighborDetailProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable>`
                
                .. attribute:: neighbor_process_table
                
                	OSPFv3 neighbor information table for all areas
                	**type**\:   :py:class:`NeighborProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable>`
                
                .. attribute:: protocol_areas
                
                	Protocol area table 
                	**type**\:   :py:class:`ProtocolAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas>`
                
                .. attribute:: redistributions
                
                	Redistribution information table
                	**type**\:   :py:class:`Redistributions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Redistributions>`
                
                .. attribute:: request_list_process_table
                
                	OSPFv3 request list information for all areas
                	**type**\:   :py:class:`RequestListProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable>`
                
                .. attribute:: retransmission_list_process_table
                
                	OSPFv3 retransmission list information table for all areas
                	**type**\:   :py:class:`RetransmissionListProcessTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable>`
                
                .. attribute:: route_summary
                
                	Summarize OSPFv3 local RIB tables
                	**type**\:   :py:class:`RouteSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.RouteSummary>`
                
                .. attribute:: sham_link_table
                
                	Sham link information
                	**type**\:   :py:class:`ShamLinkTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable>`
                
                .. attribute:: summary
                
                	OSPFv3 summary
                	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary>`
                
                .. attribute:: summary_prefixes
                
                	Summary prefix information table
                	**type**\:   :py:class:`SummaryPrefixes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes>`
                
                .. attribute:: virtual_link
                
                	Virtual link information
                	**type**\:   :py:class:`VirtualLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VirtualLink>`
                
                .. attribute:: vrf_statistics
                
                	Container for Statistics
                	**type**\:   :py:class:`VrfStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics>`
                
                

                """

                _prefix = 'ipv6-ospfv3-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(Ospfv3.Processes.Process.DefaultVrf, self).__init__()

                    self.yang_name = "default-vrf"
                    self.yang_parent_name = "process"

                    self.area_informations = Ospfv3.Processes.Process.DefaultVrf.AreaInformations()
                    self.area_informations.parent = self
                    self._children_name_map["area_informations"] = "area-informations"
                    self._children_yang_names.add("area-informations")

                    self.areas = Ospfv3.Processes.Process.DefaultVrf.Areas()
                    self.areas.parent = self
                    self._children_name_map["areas"] = "areas"
                    self._children_yang_names.add("areas")

                    self.bad_checksums = Ospfv3.Processes.Process.DefaultVrf.BadChecksums()
                    self.bad_checksums.parent = self
                    self._children_name_map["bad_checksums"] = "bad-checksums"
                    self._children_yang_names.add("bad-checksums")

                    self.border_routers = Ospfv3.Processes.Process.DefaultVrf.BorderRouters()
                    self.border_routers.parent = self
                    self._children_name_map["border_routers"] = "border-routers"
                    self._children_yang_names.add("border-routers")

                    self.connected_routes = Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes()
                    self.connected_routes.parent = self
                    self._children_name_map["connected_routes"] = "connected-routes"
                    self._children_yang_names.add("connected-routes")

                    self.database_summary_table = Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable()
                    self.database_summary_table.parent = self
                    self._children_name_map["database_summary_table"] = "database-summary-table"
                    self._children_yang_names.add("database-summary-table")

                    self.database_table = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable()
                    self.database_table.parent = self
                    self._children_name_map["database_table"] = "database-table"
                    self._children_yang_names.add("database-table")

                    self.external_routes = Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes()
                    self.external_routes.parent = self
                    self._children_name_map["external_routes"] = "external-routes"
                    self._children_yang_names.add("external-routes")

                    self.fast_reroutes = Ospfv3.Processes.Process.DefaultVrf.FastReroutes()
                    self.fast_reroutes.parent = self
                    self._children_name_map["fast_reroutes"] = "fast-reroutes"
                    self._children_yang_names.add("fast-reroutes")

                    self.flood_list_process_table = Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable()
                    self.flood_list_process_table.parent = self
                    self._children_name_map["flood_list_process_table"] = "flood-list-process-table"
                    self._children_yang_names.add("flood-list-process-table")

                    self.interface_brief_process_table = Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable()
                    self.interface_brief_process_table.parent = self
                    self._children_name_map["interface_brief_process_table"] = "interface-brief-process-table"
                    self._children_yang_names.add("interface-brief-process-table")

                    self.interface_process_table = Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable()
                    self.interface_process_table.parent = self
                    self._children_name_map["interface_process_table"] = "interface-process-table"
                    self._children_yang_names.add("interface-process-table")

                    self.internal_routes = Ospfv3.Processes.Process.DefaultVrf.InternalRoutes()
                    self.internal_routes.parent = self
                    self._children_name_map["internal_routes"] = "internal-routes"
                    self._children_yang_names.add("internal-routes")

                    self.neighbor_detail_process_table = Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable()
                    self.neighbor_detail_process_table.parent = self
                    self._children_name_map["neighbor_detail_process_table"] = "neighbor-detail-process-table"
                    self._children_yang_names.add("neighbor-detail-process-table")

                    self.neighbor_process_table = Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable()
                    self.neighbor_process_table.parent = self
                    self._children_name_map["neighbor_process_table"] = "neighbor-process-table"
                    self._children_yang_names.add("neighbor-process-table")

                    self.protocol_areas = Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas()
                    self.protocol_areas.parent = self
                    self._children_name_map["protocol_areas"] = "protocol-areas"
                    self._children_yang_names.add("protocol-areas")

                    self.redistributions = Ospfv3.Processes.Process.DefaultVrf.Redistributions()
                    self.redistributions.parent = self
                    self._children_name_map["redistributions"] = "redistributions"
                    self._children_yang_names.add("redistributions")

                    self.request_list_process_table = Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable()
                    self.request_list_process_table.parent = self
                    self._children_name_map["request_list_process_table"] = "request-list-process-table"
                    self._children_yang_names.add("request-list-process-table")

                    self.retransmission_list_process_table = Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable()
                    self.retransmission_list_process_table.parent = self
                    self._children_name_map["retransmission_list_process_table"] = "retransmission-list-process-table"
                    self._children_yang_names.add("retransmission-list-process-table")

                    self.route_summary = Ospfv3.Processes.Process.DefaultVrf.RouteSummary()
                    self.route_summary.parent = self
                    self._children_name_map["route_summary"] = "route-summary"
                    self._children_yang_names.add("route-summary")

                    self.sham_link_table = Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable()
                    self.sham_link_table.parent = self
                    self._children_name_map["sham_link_table"] = "sham-link-table"
                    self._children_yang_names.add("sham-link-table")

                    self.summary = Ospfv3.Processes.Process.DefaultVrf.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                    self._children_yang_names.add("summary")

                    self.summary_prefixes = Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes()
                    self.summary_prefixes.parent = self
                    self._children_name_map["summary_prefixes"] = "summary-prefixes"
                    self._children_yang_names.add("summary-prefixes")

                    self.virtual_link = Ospfv3.Processes.Process.DefaultVrf.VirtualLink()
                    self.virtual_link.parent = self
                    self._children_name_map["virtual_link"] = "virtual-link"
                    self._children_yang_names.add("virtual-link")

                    self.vrf_statistics = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics()
                    self.vrf_statistics.parent = self
                    self._children_name_map["vrf_statistics"] = "vrf-statistics"
                    self._children_yang_names.add("vrf-statistics")


                class SummaryPrefixes(Entity):
                    """
                    Summary prefix information table
                    
                    .. attribute:: summary_prefix
                    
                    	Summary prefix information
                    	**type**\: list of    :py:class:`SummaryPrefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes.SummaryPrefix>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes, self).__init__()

                        self.yang_name = "summary-prefixes"
                        self.yang_parent_name = "default-vrf"

                        self.summary_prefix = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes, self).__setattr__(name, value)


                    class SummaryPrefix(Entity):
                        """
                        Summary prefix information
                        
                        .. attribute:: prefix
                        
                        	Summary prefix
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..128
                        
                        .. attribute:: prefix_metric
                        
                        	Prefix metric
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: prefix_metric_type
                        
                        	Prefix metric type
                        	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                        
                        .. attribute:: tag
                        
                        	Tag
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes.SummaryPrefix, self).__init__()

                            self.yang_name = "summary-prefix"
                            self.yang_parent_name = "summary-prefixes"

                            self.prefix = YLeaf(YType.str, "prefix")

                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            self.prefix_metric = YLeaf(YType.uint32, "prefix-metric")

                            self.prefix_metric_type = YLeaf(YType.enumeration, "prefix-metric-type")

                            self.tag = YLeaf(YType.uint32, "tag")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("prefix",
                                            "prefix_length",
                                            "prefix_metric",
                                            "prefix_metric_type",
                                            "tag") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes.SummaryPrefix, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes.SummaryPrefix, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.prefix.is_set or
                                self.prefix_length.is_set or
                                self.prefix_metric.is_set or
                                self.prefix_metric_type.is_set or
                                self.tag.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set or
                                self.prefix_metric.yfilter != YFilter.not_set or
                                self.prefix_metric_type.yfilter != YFilter.not_set or
                                self.tag.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "summary-prefix" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                            if (self.prefix_metric.is_set or self.prefix_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_metric.get_name_leafdata())
                            if (self.prefix_metric_type.is_set or self.prefix_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_metric_type.get_name_leafdata())
                            if (self.tag.is_set or self.tag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tag.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "prefix" or name == "prefix-length" or name == "prefix-metric" or name == "prefix-metric-type" or name == "tag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-metric"):
                                self.prefix_metric = value
                                self.prefix_metric.value_namespace = name_space
                                self.prefix_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-metric-type"):
                                self.prefix_metric_type = value
                                self.prefix_metric_type.value_namespace = name_space
                                self.prefix_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "tag"):
                                self.tag = value
                                self.tag.value_namespace = name_space
                                self.tag.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.summary_prefix:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.summary_prefix:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "summary-prefixes" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "summary-prefix"):
                            for c in self.summary_prefix:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes.SummaryPrefix()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.summary_prefix.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "summary-prefix"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class BorderRouters(Entity):
                    """
                    OSPFv3 border router information table
                    
                    .. attribute:: border_router
                    
                    	OSPFv3 border router information
                    	**type**\: list of    :py:class:`BorderRouter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.BorderRouters.BorderRouter>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.BorderRouters, self).__init__()

                        self.yang_name = "border-routers"
                        self.yang_parent_name = "default-vrf"

                        self.border_router = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.BorderRouters, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.BorderRouters, self).__setattr__(name, value)


                    class BorderRouter(Entity):
                        """
                        OSPFv3 border router information
                        
                        .. attribute:: border_router_id  <key>
                        
                        	Router address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: border_router_path
                        
                        	List of border router paths
                        	**type**\: list of    :py:class:`BorderRouterPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.BorderRouters.BorderRouter.BorderRouterPath>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.BorderRouters.BorderRouter, self).__init__()

                            self.yang_name = "border-router"
                            self.yang_parent_name = "border-routers"

                            self.border_router_id = YLeaf(YType.str, "border-router-id")

                            self.border_router_path = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("border_router_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.BorderRouters.BorderRouter, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.BorderRouters.BorderRouter, self).__setattr__(name, value)


                        class BorderRouterPath(Entity):
                            """
                            List of border router paths
                            
                            .. attribute:: border_router_area_id
                            
                            	Area string in decimal or dotted\-decimal format 
                            	**type**\:  str
                            
                            	**length:** 0..16
                            
                            .. attribute:: border_router_next_hop
                            
                            	Next hop address 
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: border_router_route_metric
                            
                            	Metric
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: border_router_type
                            
                            	Border router type 
                            	**type**\:   :py:class:`Ospfv3BorderRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3BorderRoute>`
                            
                            .. attribute:: interface_name
                            
                            	Next hop interface name
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: is_intra_area_router
                            
                            	If true, intra\-area router else inter\-area router
                            	**type**\:  bool
                            
                            .. attribute:: spf_version
                            
                            	SPF version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.BorderRouters.BorderRouter.BorderRouterPath, self).__init__()

                                self.yang_name = "border-router-path"
                                self.yang_parent_name = "border-router"

                                self.border_router_area_id = YLeaf(YType.str, "border-router-area-id")

                                self.border_router_next_hop = YLeaf(YType.str, "border-router-next-hop")

                                self.border_router_route_metric = YLeaf(YType.uint32, "border-router-route-metric")

                                self.border_router_type = YLeaf(YType.enumeration, "border-router-type")

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.is_intra_area_router = YLeaf(YType.boolean, "is-intra-area-router")

                                self.spf_version = YLeaf(YType.uint32, "spf-version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("border_router_area_id",
                                                "border_router_next_hop",
                                                "border_router_route_metric",
                                                "border_router_type",
                                                "interface_name",
                                                "is_intra_area_router",
                                                "spf_version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.BorderRouters.BorderRouter.BorderRouterPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.BorderRouters.BorderRouter.BorderRouterPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.border_router_area_id.is_set or
                                    self.border_router_next_hop.is_set or
                                    self.border_router_route_metric.is_set or
                                    self.border_router_type.is_set or
                                    self.interface_name.is_set or
                                    self.is_intra_area_router.is_set or
                                    self.spf_version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.border_router_area_id.yfilter != YFilter.not_set or
                                    self.border_router_next_hop.yfilter != YFilter.not_set or
                                    self.border_router_route_metric.yfilter != YFilter.not_set or
                                    self.border_router_type.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.is_intra_area_router.yfilter != YFilter.not_set or
                                    self.spf_version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "border-router-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.border_router_area_id.is_set or self.border_router_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.border_router_area_id.get_name_leafdata())
                                if (self.border_router_next_hop.is_set or self.border_router_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.border_router_next_hop.get_name_leafdata())
                                if (self.border_router_route_metric.is_set or self.border_router_route_metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.border_router_route_metric.get_name_leafdata())
                                if (self.border_router_type.is_set or self.border_router_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.border_router_type.get_name_leafdata())
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.is_intra_area_router.is_set or self.is_intra_area_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_intra_area_router.get_name_leafdata())
                                if (self.spf_version.is_set or self.spf_version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spf_version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "border-router-area-id" or name == "border-router-next-hop" or name == "border-router-route-metric" or name == "border-router-type" or name == "interface-name" or name == "is-intra-area-router" or name == "spf-version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "border-router-area-id"):
                                    self.border_router_area_id = value
                                    self.border_router_area_id.value_namespace = name_space
                                    self.border_router_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "border-router-next-hop"):
                                    self.border_router_next_hop = value
                                    self.border_router_next_hop.value_namespace = name_space
                                    self.border_router_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "border-router-route-metric"):
                                    self.border_router_route_metric = value
                                    self.border_router_route_metric.value_namespace = name_space
                                    self.border_router_route_metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "border-router-type"):
                                    self.border_router_type = value
                                    self.border_router_type.value_namespace = name_space
                                    self.border_router_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-intra-area-router"):
                                    self.is_intra_area_router = value
                                    self.is_intra_area_router.value_namespace = name_space
                                    self.is_intra_area_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "spf-version"):
                                    self.spf_version = value
                                    self.spf_version.value_namespace = name_space
                                    self.spf_version.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.border_router_path:
                                if (c.has_data()):
                                    return True
                            return self.border_router_id.is_set

                        def has_operation(self):
                            for c in self.border_router_path:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.border_router_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "border-router" + "[border-router-id='" + self.border_router_id.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.border_router_id.is_set or self.border_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.border_router_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "border-router-path"):
                                for c in self.border_router_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.BorderRouters.BorderRouter.BorderRouterPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.border_router_path.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "border-router-path" or name == "border-router-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "border-router-id"):
                                self.border_router_id = value
                                self.border_router_id.value_namespace = name_space
                                self.border_router_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.border_router:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.border_router:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "border-routers" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "border-router"):
                            for c in self.border_router:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.BorderRouters.BorderRouter()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.border_router.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "border-router"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class ShamLinkTable(Entity):
                    """
                    Sham link information
                    
                    .. attribute:: is_sham_link_authentication_enabled
                    
                    	If true, sham link authentication is enabled 
                    	**type**\:  bool
                    
                    .. attribute:: is_sham_link_encryption_enabled
                    
                    	If true, sham link encryption is enabled 
                    	**type**\:  bool
                    
                    .. attribute:: is_sham_link_ip_security_active
                    
                    	If true, Sham link IP security is active 
                    	**type**\:  bool
                    
                    .. attribute:: is_sham_link_ip_security_required
                    
                    	If true, sham link IP security is required 
                    	**type**\:  bool
                    
                    .. attribute:: sham_link_area
                    
                    	Area id
                    	**type**\:  str
                    
                    .. attribute:: sham_link_authentication_transmit
                    
                    	Sham link authentication transmit 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sham_link_cost
                    
                    	Cost of the sham link
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: sham_link_dc_bitless_lsa
                    
                    	Number of LSA's with demand circuit bit not set
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sham_link_dead_interval
                    
                    	Dead interval (s)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sham_link_demand_circuit
                    
                    	If true, the link runs as demand circuit
                    	**type**\:  bool
                    
                    .. attribute:: sham_link_dest_address
                    
                    	Sham\-link dest
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: sham_link_encrypted_authentication_transmitted
                    
                    	Sham link encrypted authentication transmitted 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sham_link_encryption_spi
                    
                    	Sham link encryption spi
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sham_link_encryption_transmitted
                    
                    	Sham link encryption transmitted 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sham_link_gr
                    
                    	If true, Gracefule restart in progress
                    	**type**\:  bool
                    
                    .. attribute:: sham_link_gr_enabled
                    
                    	If true,  enabled
                    	**type**\:  bool
                    
                    .. attribute:: sham_link_hello_interval
                    
                    	Hello interval (s)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sham_link_ifindex
                    
                    	Sham\-link ifindex
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sham_link_last_gr
                    
                    	Time in seconds since last GR
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: sham_link_neighbor
                    
                    	Neighbor information
                    	**type**\:   :py:class:`ShamLinkNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor>`
                    
                    .. attribute:: sham_link_neighbor_id
                    
                    	Neighbor on other end of this sham link
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: sham_link_next_hello
                    
                    	Time until next hello (s)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sham_link_passive
                    
                    	If true, interface is passive
                    	**type**\:  bool
                    
                    .. attribute:: sham_link_retransmission_interval
                    
                    	Retransmission interval (s)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sham_link_source_address
                    
                    	Sham\-link source
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: sham_link_state
                    
                    	OSPF interface state for the sham link
                    	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                    
                    .. attribute:: sham_link_transmission_delay
                    
                    	Transmission delay in seconds
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    	**units**\: second
                    
                    .. attribute:: sham_link_wait_interval
                    
                    	Wait interval (s)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_authentication_spi
                    
                    	Sham link authentication spi 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable, self).__init__()

                        self.yang_name = "sham-link-table"
                        self.yang_parent_name = "default-vrf"

                        self.is_sham_link_authentication_enabled = YLeaf(YType.boolean, "is-sham-link-authentication-enabled")

                        self.is_sham_link_encryption_enabled = YLeaf(YType.boolean, "is-sham-link-encryption-enabled")

                        self.is_sham_link_ip_security_active = YLeaf(YType.boolean, "is-sham-link-ip-security-active")

                        self.is_sham_link_ip_security_required = YLeaf(YType.boolean, "is-sham-link-ip-security-required")

                        self.sham_link_area = YLeaf(YType.str, "sham-link-area")

                        self.sham_link_authentication_transmit = YLeaf(YType.uint32, "sham-link-authentication-transmit")

                        self.sham_link_cost = YLeaf(YType.uint16, "sham-link-cost")

                        self.sham_link_dc_bitless_lsa = YLeaf(YType.uint32, "sham-link-dc-bitless-lsa")

                        self.sham_link_dead_interval = YLeaf(YType.uint32, "sham-link-dead-interval")

                        self.sham_link_demand_circuit = YLeaf(YType.boolean, "sham-link-demand-circuit")

                        self.sham_link_dest_address = YLeaf(YType.str, "sham-link-dest-address")

                        self.sham_link_encrypted_authentication_transmitted = YLeaf(YType.uint32, "sham-link-encrypted-authentication-transmitted")

                        self.sham_link_encryption_spi = YLeaf(YType.uint32, "sham-link-encryption-spi")

                        self.sham_link_encryption_transmitted = YLeaf(YType.uint32, "sham-link-encryption-transmitted")

                        self.sham_link_gr = YLeaf(YType.boolean, "sham-link-gr")

                        self.sham_link_gr_enabled = YLeaf(YType.boolean, "sham-link-gr-enabled")

                        self.sham_link_hello_interval = YLeaf(YType.uint32, "sham-link-hello-interval")

                        self.sham_link_ifindex = YLeaf(YType.uint32, "sham-link-ifindex")

                        self.sham_link_last_gr = YLeaf(YType.uint32, "sham-link-last-gr")

                        self.sham_link_neighbor_id = YLeaf(YType.str, "sham-link-neighbor-id")

                        self.sham_link_next_hello = YLeaf(YType.uint32, "sham-link-next-hello")

                        self.sham_link_passive = YLeaf(YType.boolean, "sham-link-passive")

                        self.sham_link_retransmission_interval = YLeaf(YType.uint32, "sham-link-retransmission-interval")

                        self.sham_link_source_address = YLeaf(YType.str, "sham-link-source-address")

                        self.sham_link_state = YLeaf(YType.enumeration, "sham-link-state")

                        self.sham_link_transmission_delay = YLeaf(YType.uint16, "sham-link-transmission-delay")

                        self.sham_link_wait_interval = YLeaf(YType.uint32, "sham-link-wait-interval")

                        self.virtual_link_authentication_spi = YLeaf(YType.uint32, "virtual-link-authentication-spi")

                        self.sham_link_neighbor = Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor()
                        self.sham_link_neighbor.parent = self
                        self._children_name_map["sham_link_neighbor"] = "sham-link-neighbor"
                        self._children_yang_names.add("sham-link-neighbor")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_sham_link_authentication_enabled",
                                        "is_sham_link_encryption_enabled",
                                        "is_sham_link_ip_security_active",
                                        "is_sham_link_ip_security_required",
                                        "sham_link_area",
                                        "sham_link_authentication_transmit",
                                        "sham_link_cost",
                                        "sham_link_dc_bitless_lsa",
                                        "sham_link_dead_interval",
                                        "sham_link_demand_circuit",
                                        "sham_link_dest_address",
                                        "sham_link_encrypted_authentication_transmitted",
                                        "sham_link_encryption_spi",
                                        "sham_link_encryption_transmitted",
                                        "sham_link_gr",
                                        "sham_link_gr_enabled",
                                        "sham_link_hello_interval",
                                        "sham_link_ifindex",
                                        "sham_link_last_gr",
                                        "sham_link_neighbor_id",
                                        "sham_link_next_hello",
                                        "sham_link_passive",
                                        "sham_link_retransmission_interval",
                                        "sham_link_source_address",
                                        "sham_link_state",
                                        "sham_link_transmission_delay",
                                        "sham_link_wait_interval",
                                        "virtual_link_authentication_spi") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable, self).__setattr__(name, value)


                    class ShamLinkNeighbor(Entity):
                        """
                        Neighbor information
                        
                        .. attribute:: sham_link_retransmission
                        
                        	Neighbor retransmission info
                        	**type**\:   :py:class:`ShamLinkRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission>`
                        
                        .. attribute:: sham_link_state
                        
                        	Adjacency state
                        	**type**\:   :py:class:`Ospfv3NeighborState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3NeighborState>`
                        
                        .. attribute:: sham_link_suppress_hello
                        
                        	If true Hellos suppressed
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor, self).__init__()

                            self.yang_name = "sham-link-neighbor"
                            self.yang_parent_name = "sham-link-table"

                            self.sham_link_state = YLeaf(YType.enumeration, "sham-link-state")

                            self.sham_link_suppress_hello = YLeaf(YType.boolean, "sham-link-suppress-hello")

                            self.sham_link_retransmission = Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission()
                            self.sham_link_retransmission.parent = self
                            self._children_name_map["sham_link_retransmission"] = "sham-link-retransmission"
                            self._children_yang_names.add("sham-link-retransmission")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("sham_link_state",
                                            "sham_link_suppress_hello") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor, self).__setattr__(name, value)


                        class ShamLinkRetransmission(Entity):
                            """
                            Neighbor retransmission info
                            
                            .. attribute:: area_first_flood
                            
                            	First flood item for area scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_first_flood_index
                            
                            	Index of the first flood item for area scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_flood_index
                            
                            	Area scope LSA's flood index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_next_flood
                            
                            	Next flood item for area scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_next_flood_index
                            
                            	Index of next flood item for Area scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_first_flood
                            
                            	First flood item for AS scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_first_flood_index
                            
                            	Index for first flood item for AS scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_flood_index
                            
                            	AS scope LSA's flood index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_next_flood
                            
                            	Next flood item for AS scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_next_flood_index
                            
                            	Index of next flood item for AS scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: database_descriptor_retransmissions
                            
                            	Number of database descriptor retransmissions during last exchange
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: last_retransmission_length
                            
                            	Number of LSAs sent in last retransmission
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: last_retransmission_time
                            
                            	Last retransmission scan time (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: link_first_flood
                            
                            	Link first flood information 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: link_first_flood_index
                            
                            	Link first flood information index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: link_flood_index
                            
                            	Link flood index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: link_next_flood
                            
                            	Link next flood information 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: link_next_flood_index
                            
                            	Link next flood information index 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa_retransmission_timer
                            
                            	Time until next LSA retransmission (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: maximum_retransmission_length
                            
                            	Maximum number of LSAs sent in a retransmission
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: maximum_retransmission_time
                            
                            	Maximum retransmission scan time (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_retransmissions
                            
                            	Number of neighbor retransmissions 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: retransmissions
                            
                            	Number of retransmissions for this neighbor
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission, self).__init__()

                                self.yang_name = "sham-link-retransmission"
                                self.yang_parent_name = "sham-link-neighbor"

                                self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("area_first_flood",
                                                "area_first_flood_index",
                                                "area_flood_index",
                                                "area_next_flood",
                                                "area_next_flood_index",
                                                "as_first_flood",
                                                "as_first_flood_index",
                                                "as_flood_index",
                                                "as_next_flood",
                                                "as_next_flood_index",
                                                "database_descriptor_retransmissions",
                                                "last_retransmission_length",
                                                "last_retransmission_time",
                                                "link_first_flood",
                                                "link_first_flood_index",
                                                "link_flood_index",
                                                "link_next_flood",
                                                "link_next_flood_index",
                                                "lsa_retransmission_timer",
                                                "maximum_retransmission_length",
                                                "maximum_retransmission_time",
                                                "neighbor_retransmissions",
                                                "retransmissions") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.area_first_flood.is_set or
                                    self.area_first_flood_index.is_set or
                                    self.area_flood_index.is_set or
                                    self.area_next_flood.is_set or
                                    self.area_next_flood_index.is_set or
                                    self.as_first_flood.is_set or
                                    self.as_first_flood_index.is_set or
                                    self.as_flood_index.is_set or
                                    self.as_next_flood.is_set or
                                    self.as_next_flood_index.is_set or
                                    self.database_descriptor_retransmissions.is_set or
                                    self.last_retransmission_length.is_set or
                                    self.last_retransmission_time.is_set or
                                    self.link_first_flood.is_set or
                                    self.link_first_flood_index.is_set or
                                    self.link_flood_index.is_set or
                                    self.link_next_flood.is_set or
                                    self.link_next_flood_index.is_set or
                                    self.lsa_retransmission_timer.is_set or
                                    self.maximum_retransmission_length.is_set or
                                    self.maximum_retransmission_time.is_set or
                                    self.neighbor_retransmissions.is_set or
                                    self.retransmissions.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.area_first_flood.yfilter != YFilter.not_set or
                                    self.area_first_flood_index.yfilter != YFilter.not_set or
                                    self.area_flood_index.yfilter != YFilter.not_set or
                                    self.area_next_flood.yfilter != YFilter.not_set or
                                    self.area_next_flood_index.yfilter != YFilter.not_set or
                                    self.as_first_flood.yfilter != YFilter.not_set or
                                    self.as_first_flood_index.yfilter != YFilter.not_set or
                                    self.as_flood_index.yfilter != YFilter.not_set or
                                    self.as_next_flood.yfilter != YFilter.not_set or
                                    self.as_next_flood_index.yfilter != YFilter.not_set or
                                    self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                    self.last_retransmission_length.yfilter != YFilter.not_set or
                                    self.last_retransmission_time.yfilter != YFilter.not_set or
                                    self.link_first_flood.yfilter != YFilter.not_set or
                                    self.link_first_flood_index.yfilter != YFilter.not_set or
                                    self.link_flood_index.yfilter != YFilter.not_set or
                                    self.link_next_flood.yfilter != YFilter.not_set or
                                    self.link_next_flood_index.yfilter != YFilter.not_set or
                                    self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                    self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                    self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                    self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                    self.retransmissions.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sham-link-retransmission" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "area-first-flood"):
                                    self.area_first_flood = value
                                    self.area_first_flood.value_namespace = name_space
                                    self.area_first_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-first-flood-index"):
                                    self.area_first_flood_index = value
                                    self.area_first_flood_index.value_namespace = name_space
                                    self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-flood-index"):
                                    self.area_flood_index = value
                                    self.area_flood_index.value_namespace = name_space
                                    self.area_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-next-flood"):
                                    self.area_next_flood = value
                                    self.area_next_flood.value_namespace = name_space
                                    self.area_next_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-next-flood-index"):
                                    self.area_next_flood_index = value
                                    self.area_next_flood_index.value_namespace = name_space
                                    self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-first-flood"):
                                    self.as_first_flood = value
                                    self.as_first_flood.value_namespace = name_space
                                    self.as_first_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-first-flood-index"):
                                    self.as_first_flood_index = value
                                    self.as_first_flood_index.value_namespace = name_space
                                    self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-flood-index"):
                                    self.as_flood_index = value
                                    self.as_flood_index.value_namespace = name_space
                                    self.as_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-next-flood"):
                                    self.as_next_flood = value
                                    self.as_next_flood.value_namespace = name_space
                                    self.as_next_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-next-flood-index"):
                                    self.as_next_flood_index = value
                                    self.as_next_flood_index.value_namespace = name_space
                                    self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "database-descriptor-retransmissions"):
                                    self.database_descriptor_retransmissions = value
                                    self.database_descriptor_retransmissions.value_namespace = name_space
                                    self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                if(value_path == "last-retransmission-length"):
                                    self.last_retransmission_length = value
                                    self.last_retransmission_length.value_namespace = name_space
                                    self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "last-retransmission-time"):
                                    self.last_retransmission_time = value
                                    self.last_retransmission_time.value_namespace = name_space
                                    self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-first-flood"):
                                    self.link_first_flood = value
                                    self.link_first_flood.value_namespace = name_space
                                    self.link_first_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-first-flood-index"):
                                    self.link_first_flood_index = value
                                    self.link_first_flood_index.value_namespace = name_space
                                    self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-flood-index"):
                                    self.link_flood_index = value
                                    self.link_flood_index.value_namespace = name_space
                                    self.link_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-next-flood"):
                                    self.link_next_flood = value
                                    self.link_next_flood.value_namespace = name_space
                                    self.link_next_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-next-flood-index"):
                                    self.link_next_flood_index = value
                                    self.link_next_flood_index.value_namespace = name_space
                                    self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-retransmission-timer"):
                                    self.lsa_retransmission_timer = value
                                    self.lsa_retransmission_timer.value_namespace = name_space
                                    self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-retransmission-length"):
                                    self.maximum_retransmission_length = value
                                    self.maximum_retransmission_length.value_namespace = name_space
                                    self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-retransmission-time"):
                                    self.maximum_retransmission_time = value
                                    self.maximum_retransmission_time.value_namespace = name_space
                                    self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-retransmissions"):
                                    self.neighbor_retransmissions = value
                                    self.neighbor_retransmissions.value_namespace = name_space
                                    self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                if(value_path == "retransmissions"):
                                    self.retransmissions = value
                                    self.retransmissions.value_namespace = name_space
                                    self.retransmissions.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.sham_link_state.is_set or
                                self.sham_link_suppress_hello.is_set or
                                (self.sham_link_retransmission is not None and self.sham_link_retransmission.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.sham_link_state.yfilter != YFilter.not_set or
                                self.sham_link_suppress_hello.yfilter != YFilter.not_set or
                                (self.sham_link_retransmission is not None and self.sham_link_retransmission.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sham-link-neighbor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.sham_link_state.is_set or self.sham_link_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_state.get_name_leafdata())
                            if (self.sham_link_suppress_hello.is_set or self.sham_link_suppress_hello.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sham_link_suppress_hello.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "sham-link-retransmission"):
                                if (self.sham_link_retransmission is None):
                                    self.sham_link_retransmission = Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor.ShamLinkRetransmission()
                                    self.sham_link_retransmission.parent = self
                                    self._children_name_map["sham_link_retransmission"] = "sham-link-retransmission"
                                return self.sham_link_retransmission

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sham-link-retransmission" or name == "sham-link-state" or name == "sham-link-suppress-hello"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "sham-link-state"):
                                self.sham_link_state = value
                                self.sham_link_state.value_namespace = name_space
                                self.sham_link_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "sham-link-suppress-hello"):
                                self.sham_link_suppress_hello = value
                                self.sham_link_suppress_hello.value_namespace = name_space
                                self.sham_link_suppress_hello.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.is_sham_link_authentication_enabled.is_set or
                            self.is_sham_link_encryption_enabled.is_set or
                            self.is_sham_link_ip_security_active.is_set or
                            self.is_sham_link_ip_security_required.is_set or
                            self.sham_link_area.is_set or
                            self.sham_link_authentication_transmit.is_set or
                            self.sham_link_cost.is_set or
                            self.sham_link_dc_bitless_lsa.is_set or
                            self.sham_link_dead_interval.is_set or
                            self.sham_link_demand_circuit.is_set or
                            self.sham_link_dest_address.is_set or
                            self.sham_link_encrypted_authentication_transmitted.is_set or
                            self.sham_link_encryption_spi.is_set or
                            self.sham_link_encryption_transmitted.is_set or
                            self.sham_link_gr.is_set or
                            self.sham_link_gr_enabled.is_set or
                            self.sham_link_hello_interval.is_set or
                            self.sham_link_ifindex.is_set or
                            self.sham_link_last_gr.is_set or
                            self.sham_link_neighbor_id.is_set or
                            self.sham_link_next_hello.is_set or
                            self.sham_link_passive.is_set or
                            self.sham_link_retransmission_interval.is_set or
                            self.sham_link_source_address.is_set or
                            self.sham_link_state.is_set or
                            self.sham_link_transmission_delay.is_set or
                            self.sham_link_wait_interval.is_set or
                            self.virtual_link_authentication_spi.is_set or
                            (self.sham_link_neighbor is not None and self.sham_link_neighbor.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_sham_link_authentication_enabled.yfilter != YFilter.not_set or
                            self.is_sham_link_encryption_enabled.yfilter != YFilter.not_set or
                            self.is_sham_link_ip_security_active.yfilter != YFilter.not_set or
                            self.is_sham_link_ip_security_required.yfilter != YFilter.not_set or
                            self.sham_link_area.yfilter != YFilter.not_set or
                            self.sham_link_authentication_transmit.yfilter != YFilter.not_set or
                            self.sham_link_cost.yfilter != YFilter.not_set or
                            self.sham_link_dc_bitless_lsa.yfilter != YFilter.not_set or
                            self.sham_link_dead_interval.yfilter != YFilter.not_set or
                            self.sham_link_demand_circuit.yfilter != YFilter.not_set or
                            self.sham_link_dest_address.yfilter != YFilter.not_set or
                            self.sham_link_encrypted_authentication_transmitted.yfilter != YFilter.not_set or
                            self.sham_link_encryption_spi.yfilter != YFilter.not_set or
                            self.sham_link_encryption_transmitted.yfilter != YFilter.not_set or
                            self.sham_link_gr.yfilter != YFilter.not_set or
                            self.sham_link_gr_enabled.yfilter != YFilter.not_set or
                            self.sham_link_hello_interval.yfilter != YFilter.not_set or
                            self.sham_link_ifindex.yfilter != YFilter.not_set or
                            self.sham_link_last_gr.yfilter != YFilter.not_set or
                            self.sham_link_neighbor_id.yfilter != YFilter.not_set or
                            self.sham_link_next_hello.yfilter != YFilter.not_set or
                            self.sham_link_passive.yfilter != YFilter.not_set or
                            self.sham_link_retransmission_interval.yfilter != YFilter.not_set or
                            self.sham_link_source_address.yfilter != YFilter.not_set or
                            self.sham_link_state.yfilter != YFilter.not_set or
                            self.sham_link_transmission_delay.yfilter != YFilter.not_set or
                            self.sham_link_wait_interval.yfilter != YFilter.not_set or
                            self.virtual_link_authentication_spi.yfilter != YFilter.not_set or
                            (self.sham_link_neighbor is not None and self.sham_link_neighbor.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sham-link-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_sham_link_authentication_enabled.is_set or self.is_sham_link_authentication_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sham_link_authentication_enabled.get_name_leafdata())
                        if (self.is_sham_link_encryption_enabled.is_set or self.is_sham_link_encryption_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sham_link_encryption_enabled.get_name_leafdata())
                        if (self.is_sham_link_ip_security_active.is_set or self.is_sham_link_ip_security_active.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sham_link_ip_security_active.get_name_leafdata())
                        if (self.is_sham_link_ip_security_required.is_set or self.is_sham_link_ip_security_required.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sham_link_ip_security_required.get_name_leafdata())
                        if (self.sham_link_area.is_set or self.sham_link_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_area.get_name_leafdata())
                        if (self.sham_link_authentication_transmit.is_set or self.sham_link_authentication_transmit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_authentication_transmit.get_name_leafdata())
                        if (self.sham_link_cost.is_set or self.sham_link_cost.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_cost.get_name_leafdata())
                        if (self.sham_link_dc_bitless_lsa.is_set or self.sham_link_dc_bitless_lsa.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_dc_bitless_lsa.get_name_leafdata())
                        if (self.sham_link_dead_interval.is_set or self.sham_link_dead_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_dead_interval.get_name_leafdata())
                        if (self.sham_link_demand_circuit.is_set or self.sham_link_demand_circuit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_demand_circuit.get_name_leafdata())
                        if (self.sham_link_dest_address.is_set or self.sham_link_dest_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_dest_address.get_name_leafdata())
                        if (self.sham_link_encrypted_authentication_transmitted.is_set or self.sham_link_encrypted_authentication_transmitted.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_encrypted_authentication_transmitted.get_name_leafdata())
                        if (self.sham_link_encryption_spi.is_set or self.sham_link_encryption_spi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_encryption_spi.get_name_leafdata())
                        if (self.sham_link_encryption_transmitted.is_set or self.sham_link_encryption_transmitted.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_encryption_transmitted.get_name_leafdata())
                        if (self.sham_link_gr.is_set or self.sham_link_gr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_gr.get_name_leafdata())
                        if (self.sham_link_gr_enabled.is_set or self.sham_link_gr_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_gr_enabled.get_name_leafdata())
                        if (self.sham_link_hello_interval.is_set or self.sham_link_hello_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_hello_interval.get_name_leafdata())
                        if (self.sham_link_ifindex.is_set or self.sham_link_ifindex.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_ifindex.get_name_leafdata())
                        if (self.sham_link_last_gr.is_set or self.sham_link_last_gr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_last_gr.get_name_leafdata())
                        if (self.sham_link_neighbor_id.is_set or self.sham_link_neighbor_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_neighbor_id.get_name_leafdata())
                        if (self.sham_link_next_hello.is_set or self.sham_link_next_hello.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_next_hello.get_name_leafdata())
                        if (self.sham_link_passive.is_set or self.sham_link_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_passive.get_name_leafdata())
                        if (self.sham_link_retransmission_interval.is_set or self.sham_link_retransmission_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_retransmission_interval.get_name_leafdata())
                        if (self.sham_link_source_address.is_set or self.sham_link_source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_source_address.get_name_leafdata())
                        if (self.sham_link_state.is_set or self.sham_link_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_state.get_name_leafdata())
                        if (self.sham_link_transmission_delay.is_set or self.sham_link_transmission_delay.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_transmission_delay.get_name_leafdata())
                        if (self.sham_link_wait_interval.is_set or self.sham_link_wait_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sham_link_wait_interval.get_name_leafdata())
                        if (self.virtual_link_authentication_spi.is_set or self.virtual_link_authentication_spi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_authentication_spi.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "sham-link-neighbor"):
                            if (self.sham_link_neighbor is None):
                                self.sham_link_neighbor = Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable.ShamLinkNeighbor()
                                self.sham_link_neighbor.parent = self
                                self._children_name_map["sham_link_neighbor"] = "sham-link-neighbor"
                            return self.sham_link_neighbor

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "sham-link-neighbor" or name == "is-sham-link-authentication-enabled" or name == "is-sham-link-encryption-enabled" or name == "is-sham-link-ip-security-active" or name == "is-sham-link-ip-security-required" or name == "sham-link-area" or name == "sham-link-authentication-transmit" or name == "sham-link-cost" or name == "sham-link-dc-bitless-lsa" or name == "sham-link-dead-interval" or name == "sham-link-demand-circuit" or name == "sham-link-dest-address" or name == "sham-link-encrypted-authentication-transmitted" or name == "sham-link-encryption-spi" or name == "sham-link-encryption-transmitted" or name == "sham-link-gr" or name == "sham-link-gr-enabled" or name == "sham-link-hello-interval" or name == "sham-link-ifindex" or name == "sham-link-last-gr" or name == "sham-link-neighbor-id" or name == "sham-link-next-hello" or name == "sham-link-passive" or name == "sham-link-retransmission-interval" or name == "sham-link-source-address" or name == "sham-link-state" or name == "sham-link-transmission-delay" or name == "sham-link-wait-interval" or name == "virtual-link-authentication-spi"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-sham-link-authentication-enabled"):
                            self.is_sham_link_authentication_enabled = value
                            self.is_sham_link_authentication_enabled.value_namespace = name_space
                            self.is_sham_link_authentication_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sham-link-encryption-enabled"):
                            self.is_sham_link_encryption_enabled = value
                            self.is_sham_link_encryption_enabled.value_namespace = name_space
                            self.is_sham_link_encryption_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sham-link-ip-security-active"):
                            self.is_sham_link_ip_security_active = value
                            self.is_sham_link_ip_security_active.value_namespace = name_space
                            self.is_sham_link_ip_security_active.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sham-link-ip-security-required"):
                            self.is_sham_link_ip_security_required = value
                            self.is_sham_link_ip_security_required.value_namespace = name_space
                            self.is_sham_link_ip_security_required.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-area"):
                            self.sham_link_area = value
                            self.sham_link_area.value_namespace = name_space
                            self.sham_link_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-authentication-transmit"):
                            self.sham_link_authentication_transmit = value
                            self.sham_link_authentication_transmit.value_namespace = name_space
                            self.sham_link_authentication_transmit.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-cost"):
                            self.sham_link_cost = value
                            self.sham_link_cost.value_namespace = name_space
                            self.sham_link_cost.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-dc-bitless-lsa"):
                            self.sham_link_dc_bitless_lsa = value
                            self.sham_link_dc_bitless_lsa.value_namespace = name_space
                            self.sham_link_dc_bitless_lsa.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-dead-interval"):
                            self.sham_link_dead_interval = value
                            self.sham_link_dead_interval.value_namespace = name_space
                            self.sham_link_dead_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-demand-circuit"):
                            self.sham_link_demand_circuit = value
                            self.sham_link_demand_circuit.value_namespace = name_space
                            self.sham_link_demand_circuit.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-dest-address"):
                            self.sham_link_dest_address = value
                            self.sham_link_dest_address.value_namespace = name_space
                            self.sham_link_dest_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-encrypted-authentication-transmitted"):
                            self.sham_link_encrypted_authentication_transmitted = value
                            self.sham_link_encrypted_authentication_transmitted.value_namespace = name_space
                            self.sham_link_encrypted_authentication_transmitted.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-encryption-spi"):
                            self.sham_link_encryption_spi = value
                            self.sham_link_encryption_spi.value_namespace = name_space
                            self.sham_link_encryption_spi.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-encryption-transmitted"):
                            self.sham_link_encryption_transmitted = value
                            self.sham_link_encryption_transmitted.value_namespace = name_space
                            self.sham_link_encryption_transmitted.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-gr"):
                            self.sham_link_gr = value
                            self.sham_link_gr.value_namespace = name_space
                            self.sham_link_gr.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-gr-enabled"):
                            self.sham_link_gr_enabled = value
                            self.sham_link_gr_enabled.value_namespace = name_space
                            self.sham_link_gr_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-hello-interval"):
                            self.sham_link_hello_interval = value
                            self.sham_link_hello_interval.value_namespace = name_space
                            self.sham_link_hello_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-ifindex"):
                            self.sham_link_ifindex = value
                            self.sham_link_ifindex.value_namespace = name_space
                            self.sham_link_ifindex.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-last-gr"):
                            self.sham_link_last_gr = value
                            self.sham_link_last_gr.value_namespace = name_space
                            self.sham_link_last_gr.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-neighbor-id"):
                            self.sham_link_neighbor_id = value
                            self.sham_link_neighbor_id.value_namespace = name_space
                            self.sham_link_neighbor_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-next-hello"):
                            self.sham_link_next_hello = value
                            self.sham_link_next_hello.value_namespace = name_space
                            self.sham_link_next_hello.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-passive"):
                            self.sham_link_passive = value
                            self.sham_link_passive.value_namespace = name_space
                            self.sham_link_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-retransmission-interval"):
                            self.sham_link_retransmission_interval = value
                            self.sham_link_retransmission_interval.value_namespace = name_space
                            self.sham_link_retransmission_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-source-address"):
                            self.sham_link_source_address = value
                            self.sham_link_source_address.value_namespace = name_space
                            self.sham_link_source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-state"):
                            self.sham_link_state = value
                            self.sham_link_state.value_namespace = name_space
                            self.sham_link_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-transmission-delay"):
                            self.sham_link_transmission_delay = value
                            self.sham_link_transmission_delay.value_namespace = name_space
                            self.sham_link_transmission_delay.value_namespace_prefix = name_space_prefix
                        if(value_path == "sham-link-wait-interval"):
                            self.sham_link_wait_interval = value
                            self.sham_link_wait_interval.value_namespace = name_space
                            self.sham_link_wait_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-authentication-spi"):
                            self.virtual_link_authentication_spi = value
                            self.virtual_link_authentication_spi.value_namespace = name_space
                            self.virtual_link_authentication_spi.value_namespace_prefix = name_space_prefix


                class AreaInformations(Entity):
                    """
                    OSPFv3 area information table
                    
                    .. attribute:: area_information
                    
                    	OSPFv3 area information
                    	**type**\: list of    :py:class:`AreaInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.AreaInformations.AreaInformation>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.AreaInformations, self).__init__()

                        self.yang_name = "area-informations"
                        self.yang_parent_name = "default-vrf"

                        self.area_information = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.AreaInformations, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.AreaInformations, self).__setattr__(name, value)


                    class AreaInformation(Entity):
                        """
                        OSPFv3 area information
                        
                        .. attribute:: area_id  <key>
                        
                        	Area ID
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: area_dc_bitless_ls_as
                        
                        	Number of LSA with demand circuit bit not set
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_interfaces
                        
                        	Number of interfaces in the area
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: area_lfa_interface_count
                        
                        	Number of LFA enabled interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lfa_revision
                        
                        	Area LFA revision
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_opaque_lsa_checksum
                        
                        	Sum of opaque LSA checksums
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_opaque_lsas
                        
                        	Number of opaque LSAs in the area
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_per_prefix_lfa_interface_count
                        
                        	Number of Per Prefix LFA enabled interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_range
                        
                        	List of ranges to summarize
                        	**type**\: list of    :py:class:`AreaRange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.AreaInformations.AreaInformation.AreaRange>`
                        
                        .. attribute:: do_not_age_ls_as
                        
                        	Number of do not age LSAs
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: flood_list_length
                        
                        	Number of LSAs which need to be flooded
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: indication_ls_as
                        
                        	Number of indication LSAs
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_area_nssa
                        
                        	If true, area is a NSSA
                        	**type**\:  bool
                        
                        .. attribute:: is_area_stubbed
                        
                        	If true, stub area
                        	**type**\:  bool
                        
                        .. attribute:: is_area_total_stubbed
                        
                        	If true, totally stubby area
                        	**type**\:  bool
                        
                        .. attribute:: is_backbone_area_active
                        
                        	If true, Backbone area is active
                        	**type**\:  bool
                        
                        .. attribute:: is_nssa_default
                        
                        	If true, generate NSSA default route
                        	**type**\:  bool
                        
                        .. attribute:: is_nssa_translated
                        
                        	If true, perform 7/5 translation
                        	**type**\:  bool
                        
                        .. attribute:: is_rrr_enabled
                        
                        	If true, RRR is enabled
                        	**type**\:  bool
                        
                        .. attribute:: nssa_no_redistribution
                        
                        	If true, No redistribution into this NSSA area
                        	**type**\:  bool
                        
                        .. attribute:: sp_fs
                        
                        	Number of SPF calculations run
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: stub_default_cost
                        
                        	Default cost for Stub or NSSA area
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.AreaInformations.AreaInformation, self).__init__()

                            self.yang_name = "area-information"
                            self.yang_parent_name = "area-informations"

                            self.area_id = YLeaf(YType.int32, "area-id")

                            self.area_dc_bitless_ls_as = YLeaf(YType.uint32, "area-dc-bitless-ls-as")

                            self.area_interfaces = YLeaf(YType.uint16, "area-interfaces")

                            self.area_lfa_interface_count = YLeaf(YType.uint32, "area-lfa-interface-count")

                            self.area_lfa_revision = YLeaf(YType.uint32, "area-lfa-revision")

                            self.area_opaque_lsa_checksum = YLeaf(YType.uint32, "area-opaque-lsa-checksum")

                            self.area_opaque_lsas = YLeaf(YType.uint32, "area-opaque-lsas")

                            self.area_per_prefix_lfa_interface_count = YLeaf(YType.uint32, "area-per-prefix-lfa-interface-count")

                            self.do_not_age_ls_as = YLeaf(YType.uint32, "do-not-age-ls-as")

                            self.flood_list_length = YLeaf(YType.uint32, "flood-list-length")

                            self.indication_ls_as = YLeaf(YType.uint32, "indication-ls-as")

                            self.is_area_nssa = YLeaf(YType.boolean, "is-area-nssa")

                            self.is_area_stubbed = YLeaf(YType.boolean, "is-area-stubbed")

                            self.is_area_total_stubbed = YLeaf(YType.boolean, "is-area-total-stubbed")

                            self.is_backbone_area_active = YLeaf(YType.boolean, "is-backbone-area-active")

                            self.is_nssa_default = YLeaf(YType.boolean, "is-nssa-default")

                            self.is_nssa_translated = YLeaf(YType.boolean, "is-nssa-translated")

                            self.is_rrr_enabled = YLeaf(YType.boolean, "is-rrr-enabled")

                            self.nssa_no_redistribution = YLeaf(YType.boolean, "nssa-no-redistribution")

                            self.sp_fs = YLeaf(YType.uint32, "sp-fs")

                            self.stub_default_cost = YLeaf(YType.uint16, "stub-default-cost")

                            self.area_range = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("area_id",
                                            "area_dc_bitless_ls_as",
                                            "area_interfaces",
                                            "area_lfa_interface_count",
                                            "area_lfa_revision",
                                            "area_opaque_lsa_checksum",
                                            "area_opaque_lsas",
                                            "area_per_prefix_lfa_interface_count",
                                            "do_not_age_ls_as",
                                            "flood_list_length",
                                            "indication_ls_as",
                                            "is_area_nssa",
                                            "is_area_stubbed",
                                            "is_area_total_stubbed",
                                            "is_backbone_area_active",
                                            "is_nssa_default",
                                            "is_nssa_translated",
                                            "is_rrr_enabled",
                                            "nssa_no_redistribution",
                                            "sp_fs",
                                            "stub_default_cost") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.AreaInformations.AreaInformation, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.AreaInformations.AreaInformation, self).__setattr__(name, value)


                        class AreaRange(Entity):
                            """
                            List of ranges to summarize
                            
                            .. attribute:: is_cost_configured
                            
                            	If true, cost is configured 
                            	**type**\:  bool
                            
                            .. attribute:: net_cost
                            
                            	Net cost 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: range_prefix
                            
                            	IP prefix for summarization
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: range_prefix_length
                            
                            	IP prefix length for summarization
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	Area range status 
                            	**type**\:   :py:class:`Ospfv3AreaRangeStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3AreaRangeStatus>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.AreaInformations.AreaInformation.AreaRange, self).__init__()

                                self.yang_name = "area-range"
                                self.yang_parent_name = "area-information"

                                self.is_cost_configured = YLeaf(YType.boolean, "is-cost-configured")

                                self.net_cost = YLeaf(YType.uint32, "net-cost")

                                self.range_prefix = YLeaf(YType.str, "range-prefix")

                                self.range_prefix_length = YLeaf(YType.uint32, "range-prefix-length")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_cost_configured",
                                                "net_cost",
                                                "range_prefix",
                                                "range_prefix_length",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.AreaInformations.AreaInformation.AreaRange, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.AreaInformations.AreaInformation.AreaRange, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.is_cost_configured.is_set or
                                    self.net_cost.is_set or
                                    self.range_prefix.is_set or
                                    self.range_prefix_length.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_cost_configured.yfilter != YFilter.not_set or
                                    self.net_cost.yfilter != YFilter.not_set or
                                    self.range_prefix.yfilter != YFilter.not_set or
                                    self.range_prefix_length.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "area-range" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_cost_configured.is_set or self.is_cost_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_cost_configured.get_name_leafdata())
                                if (self.net_cost.is_set or self.net_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.net_cost.get_name_leafdata())
                                if (self.range_prefix.is_set or self.range_prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.range_prefix.get_name_leafdata())
                                if (self.range_prefix_length.is_set or self.range_prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.range_prefix_length.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "is-cost-configured" or name == "net-cost" or name == "range-prefix" or name == "range-prefix-length" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-cost-configured"):
                                    self.is_cost_configured = value
                                    self.is_cost_configured.value_namespace = name_space
                                    self.is_cost_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "net-cost"):
                                    self.net_cost = value
                                    self.net_cost.value_namespace = name_space
                                    self.net_cost.value_namespace_prefix = name_space_prefix
                                if(value_path == "range-prefix"):
                                    self.range_prefix = value
                                    self.range_prefix.value_namespace = name_space
                                    self.range_prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "range-prefix-length"):
                                    self.range_prefix_length = value
                                    self.range_prefix_length.value_namespace = name_space
                                    self.range_prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.area_range:
                                if (c.has_data()):
                                    return True
                            return (
                                self.area_id.is_set or
                                self.area_dc_bitless_ls_as.is_set or
                                self.area_interfaces.is_set or
                                self.area_lfa_interface_count.is_set or
                                self.area_lfa_revision.is_set or
                                self.area_opaque_lsa_checksum.is_set or
                                self.area_opaque_lsas.is_set or
                                self.area_per_prefix_lfa_interface_count.is_set or
                                self.do_not_age_ls_as.is_set or
                                self.flood_list_length.is_set or
                                self.indication_ls_as.is_set or
                                self.is_area_nssa.is_set or
                                self.is_area_stubbed.is_set or
                                self.is_area_total_stubbed.is_set or
                                self.is_backbone_area_active.is_set or
                                self.is_nssa_default.is_set or
                                self.is_nssa_translated.is_set or
                                self.is_rrr_enabled.is_set or
                                self.nssa_no_redistribution.is_set or
                                self.sp_fs.is_set or
                                self.stub_default_cost.is_set)

                        def has_operation(self):
                            for c in self.area_range:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.area_id.yfilter != YFilter.not_set or
                                self.area_dc_bitless_ls_as.yfilter != YFilter.not_set or
                                self.area_interfaces.yfilter != YFilter.not_set or
                                self.area_lfa_interface_count.yfilter != YFilter.not_set or
                                self.area_lfa_revision.yfilter != YFilter.not_set or
                                self.area_opaque_lsa_checksum.yfilter != YFilter.not_set or
                                self.area_opaque_lsas.yfilter != YFilter.not_set or
                                self.area_per_prefix_lfa_interface_count.yfilter != YFilter.not_set or
                                self.do_not_age_ls_as.yfilter != YFilter.not_set or
                                self.flood_list_length.yfilter != YFilter.not_set or
                                self.indication_ls_as.yfilter != YFilter.not_set or
                                self.is_area_nssa.yfilter != YFilter.not_set or
                                self.is_area_stubbed.yfilter != YFilter.not_set or
                                self.is_area_total_stubbed.yfilter != YFilter.not_set or
                                self.is_backbone_area_active.yfilter != YFilter.not_set or
                                self.is_nssa_default.yfilter != YFilter.not_set or
                                self.is_nssa_translated.yfilter != YFilter.not_set or
                                self.is_rrr_enabled.yfilter != YFilter.not_set or
                                self.nssa_no_redistribution.yfilter != YFilter.not_set or
                                self.sp_fs.yfilter != YFilter.not_set or
                                self.stub_default_cost.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "area-information" + "[area-id='" + self.area_id.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_id.get_name_leafdata())
                            if (self.area_dc_bitless_ls_as.is_set or self.area_dc_bitless_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_dc_bitless_ls_as.get_name_leafdata())
                            if (self.area_interfaces.is_set or self.area_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_interfaces.get_name_leafdata())
                            if (self.area_lfa_interface_count.is_set or self.area_lfa_interface_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lfa_interface_count.get_name_leafdata())
                            if (self.area_lfa_revision.is_set or self.area_lfa_revision.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lfa_revision.get_name_leafdata())
                            if (self.area_opaque_lsa_checksum.is_set or self.area_opaque_lsa_checksum.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_opaque_lsa_checksum.get_name_leafdata())
                            if (self.area_opaque_lsas.is_set or self.area_opaque_lsas.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_opaque_lsas.get_name_leafdata())
                            if (self.area_per_prefix_lfa_interface_count.is_set or self.area_per_prefix_lfa_interface_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_per_prefix_lfa_interface_count.get_name_leafdata())
                            if (self.do_not_age_ls_as.is_set or self.do_not_age_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.do_not_age_ls_as.get_name_leafdata())
                            if (self.flood_list_length.is_set or self.flood_list_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.flood_list_length.get_name_leafdata())
                            if (self.indication_ls_as.is_set or self.indication_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.indication_ls_as.get_name_leafdata())
                            if (self.is_area_nssa.is_set or self.is_area_nssa.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_area_nssa.get_name_leafdata())
                            if (self.is_area_stubbed.is_set or self.is_area_stubbed.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_area_stubbed.get_name_leafdata())
                            if (self.is_area_total_stubbed.is_set or self.is_area_total_stubbed.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_area_total_stubbed.get_name_leafdata())
                            if (self.is_backbone_area_active.is_set or self.is_backbone_area_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_backbone_area_active.get_name_leafdata())
                            if (self.is_nssa_default.is_set or self.is_nssa_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_nssa_default.get_name_leafdata())
                            if (self.is_nssa_translated.is_set or self.is_nssa_translated.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_nssa_translated.get_name_leafdata())
                            if (self.is_rrr_enabled.is_set or self.is_rrr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_rrr_enabled.get_name_leafdata())
                            if (self.nssa_no_redistribution.is_set or self.nssa_no_redistribution.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nssa_no_redistribution.get_name_leafdata())
                            if (self.sp_fs.is_set or self.sp_fs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sp_fs.get_name_leafdata())
                            if (self.stub_default_cost.is_set or self.stub_default_cost.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stub_default_cost.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "area-range"):
                                for c in self.area_range:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.AreaInformations.AreaInformation.AreaRange()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.area_range.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area-range" or name == "area-id" or name == "area-dc-bitless-ls-as" or name == "area-interfaces" or name == "area-lfa-interface-count" or name == "area-lfa-revision" or name == "area-opaque-lsa-checksum" or name == "area-opaque-lsas" or name == "area-per-prefix-lfa-interface-count" or name == "do-not-age-ls-as" or name == "flood-list-length" or name == "indication-ls-as" or name == "is-area-nssa" or name == "is-area-stubbed" or name == "is-area-total-stubbed" or name == "is-backbone-area-active" or name == "is-nssa-default" or name == "is-nssa-translated" or name == "is-rrr-enabled" or name == "nssa-no-redistribution" or name == "sp-fs" or name == "stub-default-cost"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "area-id"):
                                self.area_id = value
                                self.area_id.value_namespace = name_space
                                self.area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-dc-bitless-ls-as"):
                                self.area_dc_bitless_ls_as = value
                                self.area_dc_bitless_ls_as.value_namespace = name_space
                                self.area_dc_bitless_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-interfaces"):
                                self.area_interfaces = value
                                self.area_interfaces.value_namespace = name_space
                                self.area_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lfa-interface-count"):
                                self.area_lfa_interface_count = value
                                self.area_lfa_interface_count.value_namespace = name_space
                                self.area_lfa_interface_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lfa-revision"):
                                self.area_lfa_revision = value
                                self.area_lfa_revision.value_namespace = name_space
                                self.area_lfa_revision.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-opaque-lsa-checksum"):
                                self.area_opaque_lsa_checksum = value
                                self.area_opaque_lsa_checksum.value_namespace = name_space
                                self.area_opaque_lsa_checksum.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-opaque-lsas"):
                                self.area_opaque_lsas = value
                                self.area_opaque_lsas.value_namespace = name_space
                                self.area_opaque_lsas.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-per-prefix-lfa-interface-count"):
                                self.area_per_prefix_lfa_interface_count = value
                                self.area_per_prefix_lfa_interface_count.value_namespace = name_space
                                self.area_per_prefix_lfa_interface_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "do-not-age-ls-as"):
                                self.do_not_age_ls_as = value
                                self.do_not_age_ls_as.value_namespace = name_space
                                self.do_not_age_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "flood-list-length"):
                                self.flood_list_length = value
                                self.flood_list_length.value_namespace = name_space
                                self.flood_list_length.value_namespace_prefix = name_space_prefix
                            if(value_path == "indication-ls-as"):
                                self.indication_ls_as = value
                                self.indication_ls_as.value_namespace = name_space
                                self.indication_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-area-nssa"):
                                self.is_area_nssa = value
                                self.is_area_nssa.value_namespace = name_space
                                self.is_area_nssa.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-area-stubbed"):
                                self.is_area_stubbed = value
                                self.is_area_stubbed.value_namespace = name_space
                                self.is_area_stubbed.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-area-total-stubbed"):
                                self.is_area_total_stubbed = value
                                self.is_area_total_stubbed.value_namespace = name_space
                                self.is_area_total_stubbed.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-backbone-area-active"):
                                self.is_backbone_area_active = value
                                self.is_backbone_area_active.value_namespace = name_space
                                self.is_backbone_area_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-nssa-default"):
                                self.is_nssa_default = value
                                self.is_nssa_default.value_namespace = name_space
                                self.is_nssa_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-nssa-translated"):
                                self.is_nssa_translated = value
                                self.is_nssa_translated.value_namespace = name_space
                                self.is_nssa_translated.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-rrr-enabled"):
                                self.is_rrr_enabled = value
                                self.is_rrr_enabled.value_namespace = name_space
                                self.is_rrr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "nssa-no-redistribution"):
                                self.nssa_no_redistribution = value
                                self.nssa_no_redistribution.value_namespace = name_space
                                self.nssa_no_redistribution.value_namespace_prefix = name_space_prefix
                            if(value_path == "sp-fs"):
                                self.sp_fs = value
                                self.sp_fs.value_namespace = name_space
                                self.sp_fs.value_namespace_prefix = name_space_prefix
                            if(value_path == "stub-default-cost"):
                                self.stub_default_cost = value
                                self.stub_default_cost.value_namespace = name_space
                                self.stub_default_cost.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.area_information:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.area_information:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "area-informations" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "area-information"):
                            for c in self.area_information:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.AreaInformations.AreaInformation()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.area_information.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "area-information"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class DatabaseTable(Entity):
                    """
                    OSPF Link State Database
                    
                    .. attribute:: lsa_internal_table
                    
                    	Database LSA information
                    	**type**\:   :py:class:`LsaInternalTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable>`
                    
                    .. attribute:: lsa_table
                    
                    	Database LSA information
                    	**type**\:   :py:class:`LsaTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable, self).__init__()

                        self.yang_name = "database-table"
                        self.yang_parent_name = "default-vrf"

                        self.lsa_internal_table = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable()
                        self.lsa_internal_table.parent = self
                        self._children_name_map["lsa_internal_table"] = "lsa-internal-table"
                        self._children_yang_names.add("lsa-internal-table")

                        self.lsa_table = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable()
                        self.lsa_table.parent = self
                        self._children_name_map["lsa_table"] = "lsa-table"
                        self._children_yang_names.add("lsa-table")


                    class LsaTable(Entity):
                        """
                        Database LSA information
                        
                        .. attribute:: lsa
                        
                        	Database LSA information
                        	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable, self).__init__()

                            self.yang_name = "lsa-table"
                            self.yang_parent_name = "database-table"

                            self.lsa = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable, self).__setattr__(name, value)


                        class Lsa(Entity):
                            """
                            Database LSA information
                            
                            .. attribute:: advertising_router
                            
                            	Advertising Router ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: area_id
                            
                            	Area ID
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: interface_name
                            
                            	InterfaceName
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: ls_id
                            
                            	Link state ID
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: ls_type
                            
                            	LSA type
                            	**type**\:   :py:class:`Ospfv3Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa>`
                            
                            .. attribute:: lsa_info
                            
                            	Summary of all LSAs or LSA specific information 
                            	**type**\:   :py:class:`LsaInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa, self).__init__()

                                self.yang_name = "lsa"
                                self.yang_parent_name = "lsa-table"

                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                self.area_id = YLeaf(YType.int32, "area-id")

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.ls_id = YLeaf(YType.int32, "ls-id")

                                self.ls_type = YLeaf(YType.enumeration, "ls-type")

                                self.lsa_info = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo()
                                self.lsa_info.parent = self
                                self._children_name_map["lsa_info"] = "lsa-info"
                                self._children_yang_names.add("lsa-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("advertising_router",
                                                "area_id",
                                                "interface_name",
                                                "ls_id",
                                                "ls_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa, self).__setattr__(name, value)


                            class LsaInfo(Entity):
                                """
                                Summary of all LSAs or LSA specific information 
                                
                                .. attribute:: external_lsa_type
                                
                                	External LSA
                                	**type**\:   :py:class:`ExternalLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType>`
                                
                                .. attribute:: grace_lsa
                                
                                	Grace LSA
                                	**type**\:   :py:class:`GraceLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa>`
                                
                                .. attribute:: inter_area_prefix_lsa_type
                                
                                	Inter Area Prefix LSA
                                	**type**\:   :py:class:`InterAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType>`
                                
                                .. attribute:: inter_area_router_lsa_type
                                
                                	Inter Area Router LSA
                                	**type**\:   :py:class:`InterAreaRouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType>`
                                
                                .. attribute:: intra_area_prefix_lsa_type
                                
                                	Intra Area Prefix LSA
                                	**type**\:   :py:class:`IntraAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType>`
                                
                                .. attribute:: link_lsa_type
                                
                                	Link LSA
                                	**type**\:   :py:class:`LinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType>`
                                
                                .. attribute:: lsa_info_type
                                
                                	LSAInfoType
                                	**type**\:   :py:class:`Ospfv3LsaInfoTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3LsaInfoTypes>`
                                
                                .. attribute:: lsa_summary_info
                                
                                	Summary information of LSAs
                                	**type**\:   :py:class:`LsaSummaryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo>`
                                
                                .. attribute:: network_lsa_type
                                
                                	Network LSA
                                	**type**\:   :py:class:`NetworkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType>`
                                
                                .. attribute:: nssalsa_type
                                
                                	NSSA External LSA
                                	**type**\:   :py:class:`NssalsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType>`
                                
                                .. attribute:: router_lsa_type
                                
                                	Router LSA
                                	**type**\:   :py:class:`RouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType>`
                                
                                .. attribute:: unknown_area_lsa_type
                                
                                	Unknown\-Area scope LSA
                                	**type**\:   :py:class:`UnknownAreaLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType>`
                                
                                .. attribute:: unknown_aslsa_type
                                
                                	Unknown\-AS scope LSA
                                	**type**\:   :py:class:`UnknownAslsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType>`
                                
                                .. attribute:: unknown_link_lsa_type
                                
                                	Unknown Link Scope LSA
                                	**type**\:   :py:class:`UnknownLinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType>`
                                
                                .. attribute:: unknown_lsa_type
                                
                                	Unknown LSA
                                	**type**\:   :py:class:`UnknownLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__init__()

                                    self.yang_name = "lsa-info"
                                    self.yang_parent_name = "lsa"

                                    self.lsa_info_type = YLeaf(YType.enumeration, "lsa-info-type")

                                    self.external_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType()
                                    self.external_lsa_type.parent = self
                                    self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                    self._children_yang_names.add("external-lsa-type")

                                    self.grace_lsa = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa()
                                    self.grace_lsa.parent = self
                                    self._children_name_map["grace_lsa"] = "grace-lsa"
                                    self._children_yang_names.add("grace-lsa")

                                    self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                    self.inter_area_prefix_lsa_type.parent = self
                                    self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                    self._children_yang_names.add("inter-area-prefix-lsa-type")

                                    self.inter_area_router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                    self.inter_area_router_lsa_type.parent = self
                                    self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                    self._children_yang_names.add("inter-area-router-lsa-type")

                                    self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                    self.intra_area_prefix_lsa_type.parent = self
                                    self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                    self._children_yang_names.add("intra-area-prefix-lsa-type")

                                    self.link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType()
                                    self.link_lsa_type.parent = self
                                    self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                    self._children_yang_names.add("link-lsa-type")

                                    self.lsa_summary_info = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo()
                                    self.lsa_summary_info.parent = self
                                    self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                    self._children_yang_names.add("lsa-summary-info")

                                    self.network_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType()
                                    self.network_lsa_type.parent = self
                                    self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                    self._children_yang_names.add("network-lsa-type")

                                    self.nssalsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType()
                                    self.nssalsa_type.parent = self
                                    self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                    self._children_yang_names.add("nssalsa-type")

                                    self.router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType()
                                    self.router_lsa_type.parent = self
                                    self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                    self._children_yang_names.add("router-lsa-type")

                                    self.unknown_area_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                    self.unknown_area_lsa_type.parent = self
                                    self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                    self._children_yang_names.add("unknown-area-lsa-type")

                                    self.unknown_aslsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType()
                                    self.unknown_aslsa_type.parent = self
                                    self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                    self._children_yang_names.add("unknown-aslsa-type")

                                    self.unknown_link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                    self.unknown_link_lsa_type.parent = self
                                    self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                    self._children_yang_names.add("unknown-link-lsa-type")

                                    self.unknown_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType()
                                    self.unknown_lsa_type.parent = self
                                    self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                    self._children_yang_names.add("unknown-lsa-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("lsa_info_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__setattr__(name, value)


                                class LsaSummaryInfo(Entity):
                                    """
                                    Summary information of LSAs
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface name 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: links
                                    
                                    	Number of links
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader>`
                                    
                                    .. attribute:: lsa_router_id
                                    
                                    	LSA router ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	OSPFv3 address Prefix 
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: reference_lsa_id
                                    
                                    	Reference LSA ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: reference_type
                                    
                                    	Reference type 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: router_la_bits
                                    
                                    	Router LA bits 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Sham link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__init__()

                                        self.yang_name = "lsa-summary-info"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.links = YLeaf(YType.uint16, "links")

                                        self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                        self.reference_type = YLeaf(YType.uint16, "reference-type")

                                        self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "links",
                                                        "lsa_router_id",
                                                        "prefix",
                                                        "prefix_length",
                                                        "reference_lsa_id",
                                                        "reference_type",
                                                        "router_la_bits",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "lsa-summary-info"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "lsa-summary-info"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.links.is_set or
                                            self.lsa_router_id.is_set or
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.reference_lsa_id.is_set or
                                            self.reference_type.is_set or
                                            self.router_la_bits.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.links.yfilter != YFilter.not_set or
                                            self.lsa_router_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.reference_lsa_id.yfilter != YFilter.not_set or
                                            self.reference_type.yfilter != YFilter.not_set or
                                            self.router_la_bits.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsa-summary-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.links.get_name_leafdata())
                                        if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_router_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                        if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reference_type.get_name_leafdata())
                                        if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_la_bits.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "links" or name == "lsa-router-id" or name == "prefix" or name == "prefix-length" or name == "reference-lsa-id" or name == "reference-type" or name == "router-la-bits" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "links"):
                                            self.links = value
                                            self.links.value_namespace = name_space
                                            self.links.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsa-router-id"):
                                            self.lsa_router_id = value
                                            self.lsa_router_id.value_namespace = name_space
                                            self.lsa_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reference-lsa-id"):
                                            self.reference_lsa_id = value
                                            self.reference_lsa_id.value_namespace = name_space
                                            self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reference-type"):
                                            self.reference_type = value
                                            self.reference_type.value_namespace = name_space
                                            self.reference_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-la-bits"):
                                            self.router_la_bits = value
                                            self.router_la_bits.value_namespace = name_space
                                            self.router_la_bits.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                class RouterLsaType(Entity):
                                    """
                                    Router LSA
                                    
                                    .. attribute:: link
                                    
                                    	List of links in this LSA
                                    	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link>`
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader>`
                                    
                                    .. attribute:: router_la_bits
                                    
                                    	Router LA bits 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: rpf_path
                                    
                                    	Router LSA Reverse\-Path Forwarding information 
                                    	**type**\:   :py:class:`RpfPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__init__()

                                        self.yang_name = "router-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                        self.rpf_path = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                        self.rpf_path.parent = self
                                        self._children_name_map["rpf_path"] = "rpf-path"
                                        self._children_yang_names.add("rpf-path")

                                        self.link = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("router_la_bits") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "router-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "router-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix


                                    class RpfPath(Entity):
                                        """
                                        Router LSA Reverse\-Path Forwarding information 
                                        
                                        .. attribute:: interface_name
                                        
                                        	RPF multicast IDB 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: rpf_multicast_next_hop
                                        
                                        	RPF multicast next hop 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__init__()

                                            self.yang_name = "rpf-path"
                                            self.yang_parent_name = "router-lsa-type"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.rpf_multicast_next_hop = YLeaf(YType.uint32, "rpf-multicast-next-hop")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "rpf_multicast_next_hop") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.rpf_multicast_next_hop.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.rpf_multicast_next_hop.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "rpf-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.rpf_multicast_next_hop.is_set or self.rpf_multicast_next_hop.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rpf_multicast_next_hop.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface-name" or name == "rpf-multicast-next-hop"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rpf-multicast-next-hop"):
                                                self.rpf_multicast_next_hop = value
                                                self.rpf_multicast_next_hop.value_namespace = name_space
                                                self.rpf_multicast_next_hop.value_namespace_prefix = name_space_prefix


                                    class Link(Entity):
                                        """
                                        List of links in this LSA
                                        
                                        .. attribute:: link_interface_id
                                        
                                        	LSA link interface ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_metric
                                        
                                        	LSA link metric 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: link_neighbor_interface_id
                                        
                                        	LSA link neighbor interface ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_neighbor_router_id
                                        
                                        	LSA link neigbhor router id 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_type
                                        
                                        	Type of link
                                        	**type**\:   :py:class:`Ospfv3Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Link>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__init__()

                                            self.yang_name = "link"
                                            self.yang_parent_name = "router-lsa-type"

                                            self.link_interface_id = YLeaf(YType.uint32, "link-interface-id")

                                            self.link_metric = YLeaf(YType.uint16, "link-metric")

                                            self.link_neighbor_interface_id = YLeaf(YType.uint32, "link-neighbor-interface-id")

                                            self.link_neighbor_router_id = YLeaf(YType.uint32, "link-neighbor-router-id")

                                            self.link_type = YLeaf(YType.enumeration, "link-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("link_interface_id",
                                                            "link_metric",
                                                            "link_neighbor_interface_id",
                                                            "link_neighbor_router_id",
                                                            "link_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.link_interface_id.is_set or
                                                self.link_metric.is_set or
                                                self.link_neighbor_interface_id.is_set or
                                                self.link_neighbor_router_id.is_set or
                                                self.link_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.link_interface_id.yfilter != YFilter.not_set or
                                                self.link_metric.yfilter != YFilter.not_set or
                                                self.link_neighbor_interface_id.yfilter != YFilter.not_set or
                                                self.link_neighbor_router_id.yfilter != YFilter.not_set or
                                                self.link_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.link_interface_id.is_set or self.link_interface_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_interface_id.get_name_leafdata())
                                            if (self.link_metric.is_set or self.link_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_metric.get_name_leafdata())
                                            if (self.link_neighbor_interface_id.is_set or self.link_neighbor_interface_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_neighbor_interface_id.get_name_leafdata())
                                            if (self.link_neighbor_router_id.is_set or self.link_neighbor_router_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_neighbor_router_id.get_name_leafdata())
                                            if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "link-interface-id" or name == "link-metric" or name == "link-neighbor-interface-id" or name == "link-neighbor-router-id" or name == "link-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "link-interface-id"):
                                                self.link_interface_id = value
                                                self.link_interface_id.value_namespace = name_space
                                                self.link_interface_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-metric"):
                                                self.link_metric = value
                                                self.link_metric.value_namespace = name_space
                                                self.link_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-neighbor-interface-id"):
                                                self.link_neighbor_interface_id = value
                                                self.link_neighbor_interface_id.value_namespace = name_space
                                                self.link_neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-neighbor-router-id"):
                                                self.link_neighbor_router_id = value
                                                self.link_neighbor_router_id.value_namespace = name_space
                                                self.link_neighbor_router_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-type"):
                                                self.link_type = value
                                                self.link_type.value_namespace = name_space
                                                self.link_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.link:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.router_la_bits.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()) or
                                            (self.rpf_path is not None and self.rpf_path.has_data()))

                                    def has_operation(self):
                                        for c in self.link:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.router_la_bits.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()) or
                                            (self.rpf_path is not None and self.rpf_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "router-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_la_bits.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link"):
                                            for c in self.link:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.link.append(c)
                                            return c

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        if (child_yang_name == "rpf-path"):
                                            if (self.rpf_path is None):
                                                self.rpf_path = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                self.rpf_path.parent = self
                                                self._children_name_map["rpf_path"] = "rpf-path"
                                            return self.rpf_path

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link" or name == "lsa-detail" or name == "lsa-header" or name == "rpf-path" or name == "router-la-bits"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "router-la-bits"):
                                            self.router_la_bits = value
                                            self.router_la_bits.value_namespace = name_space
                                            self.router_la_bits.value_namespace_prefix = name_space_prefix


                                class NetworkLsaType(Entity):
                                    """
                                    Network LSA
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader>`
                                    
                                    .. attribute:: neighbor_router
                                    
                                    	Neighbor router list
                                    	**type**\:  list of str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__init__()

                                        self.yang_name = "network-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.neighbor_router = YLeafList(YType.str, "neighbor-router")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("neighbor_router") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "network-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "network-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for leaf in self.neighbor_router.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        for leaf in self.neighbor_router.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.neighbor_router.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "network-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        leaf_name_data.extend(self.neighbor_router.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "neighbor-router"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "neighbor-router"):
                                            self.neighbor_router.append(value)


                                class InterAreaPrefixLsaType(Entity):
                                    """
                                    Inter Area Prefix LSA
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA Information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader>`
                                    
                                    .. attribute:: prefix
                                    
                                    	LSA address prefix 
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: priority
                                    
                                    	Prefix priority
                                    	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__init__()

                                        self.yang_name = "inter-area-prefix-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.priority = YLeaf(YType.enumeration, "priority")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "inter-area-prefix-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA Information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "inter-area-prefix-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.priority.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.priority.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inter-area-prefix-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "prefix-length" or name == "priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "priority"):
                                            self.priority = value
                                            self.priority.value_namespace = name_space
                                            self.priority.value_namespace_prefix = name_space_prefix


                                class InterAreaRouterLsaType(Entity):
                                    """
                                    Inter Area Router LSA
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader>`
                                    
                                    .. attribute:: lsa_router_id
                                    
                                    	LSA router ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__init__()

                                        self.yang_name = "inter-area-router-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("lsa_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "inter-area-router-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "inter-area-router-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.lsa_router_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.lsa_router_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inter-area-router-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "lsa-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "lsa-router-id"):
                                            self.lsa_router_id = value
                                            self.lsa_router_id.value_namespace = name_space
                                            self.lsa_router_id.value_namespace_prefix = name_space_prefix


                                class ExternalLsaType(Entity):
                                    """
                                    External LSA
                                    
                                    .. attribute:: external_tag
                                    
                                    	Route Tag
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forwarding_address
                                    
                                    	Forwarding Address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: is_forwarding_address_set
                                    
                                    	If true, forwarding address is set 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA Information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader>`
                                    
                                    .. attribute:: metric_type
                                    
                                    	Metric type 
                                    	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                    
                                    .. attribute:: prefix
                                    
                                    	IPV6 address prefix 
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: priority
                                    
                                    	Prefix priority
                                    	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                    
                                    .. attribute:: tos_cost
                                    
                                    	Type of service cost metric 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__init__()

                                        self.yang_name = "external-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.external_tag = YLeaf(YType.uint32, "external-tag")

                                        self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                        self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                        self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.priority = YLeaf(YType.enumeration, "priority")

                                        self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("external_tag",
                                                        "forwarding_address",
                                                        "is_forwarding_address_set",
                                                        "metric_type",
                                                        "prefix",
                                                        "prefix_length",
                                                        "priority",
                                                        "tos_cost") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "external-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA Information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "external-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.external_tag.is_set or
                                            self.forwarding_address.is_set or
                                            self.is_forwarding_address_set.is_set or
                                            self.metric_type.is_set or
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.priority.is_set or
                                            self.tos_cost.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.external_tag.yfilter != YFilter.not_set or
                                            self.forwarding_address.yfilter != YFilter.not_set or
                                            self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                            self.metric_type.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.priority.yfilter != YFilter.not_set or
                                            self.tos_cost.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "external-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.external_tag.get_name_leafdata())
                                        if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                        if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                        if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.metric_type.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.priority.get_name_leafdata())
                                        if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "external-tag"):
                                            self.external_tag = value
                                            self.external_tag.value_namespace = name_space
                                            self.external_tag.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forwarding-address"):
                                            self.forwarding_address = value
                                            self.forwarding_address.value_namespace = name_space
                                            self.forwarding_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-forwarding-address-set"):
                                            self.is_forwarding_address_set = value
                                            self.is_forwarding_address_set.value_namespace = name_space
                                            self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                        if(value_path == "metric-type"):
                                            self.metric_type = value
                                            self.metric_type.value_namespace = name_space
                                            self.metric_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "priority"):
                                            self.priority = value
                                            self.priority.value_namespace = name_space
                                            self.priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tos-cost"):
                                            self.tos_cost = value
                                            self.tos_cost.value_namespace = name_space
                                            self.tos_cost.value_namespace_prefix = name_space_prefix


                                class NssalsaType(Entity):
                                    """
                                    NSSA External LSA
                                    
                                    .. attribute:: external_tag
                                    
                                    	Route Tag
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forwarding_address
                                    
                                    	Forwarding Address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: is_forwarding_address_set
                                    
                                    	If true, forwarding address is set 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA Information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader>`
                                    
                                    .. attribute:: metric_type
                                    
                                    	Metric type 
                                    	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                    
                                    .. attribute:: prefix
                                    
                                    	IPV6 address prefix 
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: priority
                                    
                                    	Prefix priority
                                    	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                    
                                    .. attribute:: tos_cost
                                    
                                    	Type of service cost metric 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__init__()

                                        self.yang_name = "nssalsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.external_tag = YLeaf(YType.uint32, "external-tag")

                                        self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                        self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                        self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.priority = YLeaf(YType.enumeration, "priority")

                                        self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("external_tag",
                                                        "forwarding_address",
                                                        "is_forwarding_address_set",
                                                        "metric_type",
                                                        "prefix",
                                                        "prefix_length",
                                                        "priority",
                                                        "tos_cost") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "nssalsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA Information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "nssalsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.external_tag.is_set or
                                            self.forwarding_address.is_set or
                                            self.is_forwarding_address_set.is_set or
                                            self.metric_type.is_set or
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.priority.is_set or
                                            self.tos_cost.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.external_tag.yfilter != YFilter.not_set or
                                            self.forwarding_address.yfilter != YFilter.not_set or
                                            self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                            self.metric_type.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.priority.yfilter != YFilter.not_set or
                                            self.tos_cost.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nssalsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.external_tag.get_name_leafdata())
                                        if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                        if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                        if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.metric_type.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.priority.get_name_leafdata())
                                        if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "external-tag"):
                                            self.external_tag = value
                                            self.external_tag.value_namespace = name_space
                                            self.external_tag.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forwarding-address"):
                                            self.forwarding_address = value
                                            self.forwarding_address.value_namespace = name_space
                                            self.forwarding_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-forwarding-address-set"):
                                            self.is_forwarding_address_set = value
                                            self.is_forwarding_address_set.value_namespace = name_space
                                            self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                        if(value_path == "metric-type"):
                                            self.metric_type = value
                                            self.metric_type.value_namespace = name_space
                                            self.metric_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "priority"):
                                            self.priority = value
                                            self.priority.value_namespace = name_space
                                            self.priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tos-cost"):
                                            self.tos_cost = value
                                            self.tos_cost.value_namespace = name_space
                                            self.tos_cost.value_namespace_prefix = name_space_prefix


                                class LinkLsaType(Entity):
                                    """
                                    Link LSA
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface handle
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader>`
                                    
                                    .. attribute:: lsa_link_local
                                    
                                    	LSA link local 
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix
                                    
                                    	OSPFv3 prefix 
                                    	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix>`
                                    
                                    .. attribute:: router_priority
                                    
                                    	Router priority 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Sham link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__init__()

                                        self.yang_name = "link-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.lsa_link_local = YLeaf(YType.str, "lsa-link-local")

                                        self.router_priority = YLeaf(YType.uint8, "router-priority")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                        self.prefix = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "lsa_link_local",
                                                        "router_priority",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "link-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "link-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix


                                    class Prefix(Entity):
                                        """
                                        OSPFv3 prefix 
                                        
                                        .. attribute:: ospfv3_prefix_length
                                        
                                        	OSPFv3 prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ospfv3_prefix_metric
                                        
                                        	OSPFv3 prefix metric 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ospfv3_prefix_options
                                        
                                        	OSPFv3 prefix options 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: prefix
                                        
                                        	OSPFv3 prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: priority
                                        
                                        	Prefix priority
                                        	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__init__()

                                            self.yang_name = "prefix"
                                            self.yang_parent_name = "link-lsa-type"

                                            self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                            self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                            self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.priority = YLeaf(YType.enumeration, "priority")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("ospfv3_prefix_length",
                                                            "ospfv3_prefix_metric",
                                                            "ospfv3_prefix_options",
                                                            "prefix",
                                                            "priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.ospfv3_prefix_length.is_set or
                                                self.ospfv3_prefix_metric.is_set or
                                                self.ospfv3_prefix_options.is_set or
                                                self.prefix.is_set or
                                                self.priority.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prefix" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                            if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                            if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "ospfv3-prefix-length"):
                                                self.ospfv3_prefix_length = value
                                                self.ospfv3_prefix_length.value_namespace = name_space
                                                self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ospfv3-prefix-metric"):
                                                self.ospfv3_prefix_metric = value
                                                self.ospfv3_prefix_metric.value_namespace = name_space
                                                self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ospfv3-prefix-options"):
                                                self.ospfv3_prefix_options = value
                                                self.ospfv3_prefix_options.value_namespace = name_space
                                                self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.prefix:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.lsa_link_local.is_set or
                                            self.router_priority.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        for c in self.prefix:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.lsa_link_local.yfilter != YFilter.not_set or
                                            self.router_priority.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.lsa_link_local.is_set or self.lsa_link_local.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_link_local.get_name_leafdata())
                                        if (self.router_priority.is_set or self.router_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_priority.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        if (child_yang_name == "prefix"):
                                            for c in self.prefix:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.prefix.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "lsa-link-local" or name == "router-priority" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsa-link-local"):
                                            self.lsa_link_local = value
                                            self.lsa_link_local.value_namespace = name_space
                                            self.lsa_link_local.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-priority"):
                                            self.router_priority = value
                                            self.router_priority.value_namespace = name_space
                                            self.router_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                class IntraAreaPrefixLsaType(Entity):
                                    """
                                    Intra Area Prefix LSA
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader>`
                                    
                                    .. attribute:: prefix
                                    
                                    	OSPFv3 prefix 
                                    	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix>`
                                    
                                    .. attribute:: reference_advertised_router
                                    
                                    	Reference advertised router 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: reference_lsa_id
                                    
                                    	Reference LSA ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: reference_type
                                    
                                    	Reference type 
                                    	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__init__()

                                        self.yang_name = "intra-area-prefix-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.reference_advertised_router = YLeaf(YType.str, "reference-advertised-router")

                                        self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                        self.reference_type = YLeaf(YType.enumeration, "reference-type")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                        self.prefix = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("reference_advertised_router",
                                                        "reference_lsa_id",
                                                        "reference_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "intra-area-prefix-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "intra-area-prefix-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix


                                    class Prefix(Entity):
                                        """
                                        OSPFv3 prefix 
                                        
                                        .. attribute:: ospfv3_prefix_length
                                        
                                        	OSPFv3 prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ospfv3_prefix_metric
                                        
                                        	OSPFv3 prefix metric 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ospfv3_prefix_options
                                        
                                        	OSPFv3 prefix options 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: prefix
                                        
                                        	OSPFv3 prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: priority
                                        
                                        	Prefix priority
                                        	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__init__()

                                            self.yang_name = "prefix"
                                            self.yang_parent_name = "intra-area-prefix-lsa-type"

                                            self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                            self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                            self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.priority = YLeaf(YType.enumeration, "priority")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("ospfv3_prefix_length",
                                                            "ospfv3_prefix_metric",
                                                            "ospfv3_prefix_options",
                                                            "prefix",
                                                            "priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.ospfv3_prefix_length.is_set or
                                                self.ospfv3_prefix_metric.is_set or
                                                self.ospfv3_prefix_options.is_set or
                                                self.prefix.is_set or
                                                self.priority.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prefix" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                            if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                            if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "ospfv3-prefix-length"):
                                                self.ospfv3_prefix_length = value
                                                self.ospfv3_prefix_length.value_namespace = name_space
                                                self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ospfv3-prefix-metric"):
                                                self.ospfv3_prefix_metric = value
                                                self.ospfv3_prefix_metric.value_namespace = name_space
                                                self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ospfv3-prefix-options"):
                                                self.ospfv3_prefix_options = value
                                                self.ospfv3_prefix_options.value_namespace = name_space
                                                self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.prefix:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.reference_advertised_router.is_set or
                                            self.reference_lsa_id.is_set or
                                            self.reference_type.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        for c in self.prefix:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.reference_advertised_router.yfilter != YFilter.not_set or
                                            self.reference_lsa_id.yfilter != YFilter.not_set or
                                            self.reference_type.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "intra-area-prefix-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.reference_advertised_router.is_set or self.reference_advertised_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reference_advertised_router.get_name_leafdata())
                                        if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                        if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reference_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        if (child_yang_name == "prefix"):
                                            for c in self.prefix:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.prefix.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "reference-advertised-router" or name == "reference-lsa-id" or name == "reference-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "reference-advertised-router"):
                                            self.reference_advertised_router = value
                                            self.reference_advertised_router.value_namespace = name_space
                                            self.reference_advertised_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reference-lsa-id"):
                                            self.reference_lsa_id = value
                                            self.reference_lsa_id.value_namespace = name_space
                                            self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reference-type"):
                                            self.reference_type = value
                                            self.reference_type.value_namespace = name_space
                                            self.reference_type.value_namespace_prefix = name_space_prefix


                                class GraceLsa(Entity):
                                    """
                                    Grace LSA
                                    
                                    .. attribute:: grace_period
                                    
                                    	The grace periord where helper routers should wait before advertising it fully adjacent(s) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: grace_reason
                                    
                                    	Reason for router restart
                                    	**type**\:   :py:class:`Ospfv3GracefulRestartReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3GracefulRestartReason>`
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__init__()

                                        self.yang_name = "grace-lsa"
                                        self.yang_parent_name = "lsa-info"

                                        self.grace_period = YLeaf(YType.uint32, "grace-period")

                                        self.grace_reason = YLeaf(YType.enumeration, "grace-reason")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("grace_period",
                                                        "grace_reason") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "grace-lsa"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "grace-lsa"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.grace_period.is_set or
                                            self.grace_reason.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.grace_period.yfilter != YFilter.not_set or
                                            self.grace_reason.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "grace-lsa" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.grace_period.is_set or self.grace_period.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grace_period.get_name_leafdata())
                                        if (self.grace_reason.is_set or self.grace_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grace_reason.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "grace-period" or name == "grace-reason"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "grace-period"):
                                            self.grace_period = value
                                            self.grace_period.value_namespace = name_space
                                            self.grace_period.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grace-reason"):
                                            self.grace_reason = value
                                            self.grace_reason.value_namespace = name_space
                                            self.grace_reason.value_namespace_prefix = name_space_prefix


                                class UnknownLinkLsaType(Entity):
                                    """
                                    Unknown Link Scope LSA
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface name 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader>`
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Shamlink ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__init__()

                                        self.yang_name = "unknown-link-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "unknown-link-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "unknown-link-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unknown-link-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                class UnknownAreaLsaType(Entity):
                                    """
                                    Unknown\-Area scope LSA
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface name 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader>`
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Shamlink ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__init__()

                                        self.yang_name = "unknown-area-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "unknown-area-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "unknown-area-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unknown-area-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                class UnknownAslsaType(Entity):
                                    """
                                    Unknown\-AS scope LSA
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface name 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader>`
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Shamlink ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__init__()

                                        self.yang_name = "unknown-aslsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "unknown-aslsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "unknown-aslsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unknown-aslsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                class UnknownLsaType(Entity):
                                    """
                                    Unknown LSA
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface name 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader>`
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Shamlink ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__init__()

                                        self.yang_name = "unknown-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "unknown-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "unknown-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unknown-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.lsa_info_type.is_set or
                                        (self.external_lsa_type is not None and self.external_lsa_type.has_data()) or
                                        (self.grace_lsa is not None and self.grace_lsa.has_data()) or
                                        (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_data()) or
                                        (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_data()) or
                                        (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_data()) or
                                        (self.link_lsa_type is not None and self.link_lsa_type.has_data()) or
                                        (self.lsa_summary_info is not None and self.lsa_summary_info.has_data()) or
                                        (self.network_lsa_type is not None and self.network_lsa_type.has_data()) or
                                        (self.nssalsa_type is not None and self.nssalsa_type.has_data()) or
                                        (self.router_lsa_type is not None and self.router_lsa_type.has_data()) or
                                        (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_data()) or
                                        (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_data()) or
                                        (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_data()) or
                                        (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.lsa_info_type.yfilter != YFilter.not_set or
                                        (self.external_lsa_type is not None and self.external_lsa_type.has_operation()) or
                                        (self.grace_lsa is not None and self.grace_lsa.has_operation()) or
                                        (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_operation()) or
                                        (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_operation()) or
                                        (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_operation()) or
                                        (self.link_lsa_type is not None and self.link_lsa_type.has_operation()) or
                                        (self.lsa_summary_info is not None and self.lsa_summary_info.has_operation()) or
                                        (self.network_lsa_type is not None and self.network_lsa_type.has_operation()) or
                                        (self.nssalsa_type is not None and self.nssalsa_type.has_operation()) or
                                        (self.router_lsa_type is not None and self.router_lsa_type.has_operation()) or
                                        (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_operation()) or
                                        (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_operation()) or
                                        (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_operation()) or
                                        (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsa-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.lsa_info_type.is_set or self.lsa_info_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_info_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "external-lsa-type"):
                                        if (self.external_lsa_type is None):
                                            self.external_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType()
                                            self.external_lsa_type.parent = self
                                            self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                        return self.external_lsa_type

                                    if (child_yang_name == "grace-lsa"):
                                        if (self.grace_lsa is None):
                                            self.grace_lsa = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa()
                                            self.grace_lsa.parent = self
                                            self._children_name_map["grace_lsa"] = "grace-lsa"
                                        return self.grace_lsa

                                    if (child_yang_name == "inter-area-prefix-lsa-type"):
                                        if (self.inter_area_prefix_lsa_type is None):
                                            self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                            self.inter_area_prefix_lsa_type.parent = self
                                            self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                        return self.inter_area_prefix_lsa_type

                                    if (child_yang_name == "inter-area-router-lsa-type"):
                                        if (self.inter_area_router_lsa_type is None):
                                            self.inter_area_router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                            self.inter_area_router_lsa_type.parent = self
                                            self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                        return self.inter_area_router_lsa_type

                                    if (child_yang_name == "intra-area-prefix-lsa-type"):
                                        if (self.intra_area_prefix_lsa_type is None):
                                            self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                            self.intra_area_prefix_lsa_type.parent = self
                                            self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                        return self.intra_area_prefix_lsa_type

                                    if (child_yang_name == "link-lsa-type"):
                                        if (self.link_lsa_type is None):
                                            self.link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType()
                                            self.link_lsa_type.parent = self
                                            self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                        return self.link_lsa_type

                                    if (child_yang_name == "lsa-summary-info"):
                                        if (self.lsa_summary_info is None):
                                            self.lsa_summary_info = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo()
                                            self.lsa_summary_info.parent = self
                                            self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                        return self.lsa_summary_info

                                    if (child_yang_name == "network-lsa-type"):
                                        if (self.network_lsa_type is None):
                                            self.network_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType()
                                            self.network_lsa_type.parent = self
                                            self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                        return self.network_lsa_type

                                    if (child_yang_name == "nssalsa-type"):
                                        if (self.nssalsa_type is None):
                                            self.nssalsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType()
                                            self.nssalsa_type.parent = self
                                            self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                        return self.nssalsa_type

                                    if (child_yang_name == "router-lsa-type"):
                                        if (self.router_lsa_type is None):
                                            self.router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType()
                                            self.router_lsa_type.parent = self
                                            self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                        return self.router_lsa_type

                                    if (child_yang_name == "unknown-area-lsa-type"):
                                        if (self.unknown_area_lsa_type is None):
                                            self.unknown_area_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                            self.unknown_area_lsa_type.parent = self
                                            self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                        return self.unknown_area_lsa_type

                                    if (child_yang_name == "unknown-aslsa-type"):
                                        if (self.unknown_aslsa_type is None):
                                            self.unknown_aslsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType()
                                            self.unknown_aslsa_type.parent = self
                                            self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                        return self.unknown_aslsa_type

                                    if (child_yang_name == "unknown-link-lsa-type"):
                                        if (self.unknown_link_lsa_type is None):
                                            self.unknown_link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                            self.unknown_link_lsa_type.parent = self
                                            self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                        return self.unknown_link_lsa_type

                                    if (child_yang_name == "unknown-lsa-type"):
                                        if (self.unknown_lsa_type is None):
                                            self.unknown_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType()
                                            self.unknown_lsa_type.parent = self
                                            self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                        return self.unknown_lsa_type

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "external-lsa-type" or name == "grace-lsa" or name == "inter-area-prefix-lsa-type" or name == "inter-area-router-lsa-type" or name == "intra-area-prefix-lsa-type" or name == "link-lsa-type" or name == "lsa-summary-info" or name == "network-lsa-type" or name == "nssalsa-type" or name == "router-lsa-type" or name == "unknown-area-lsa-type" or name == "unknown-aslsa-type" or name == "unknown-link-lsa-type" or name == "unknown-lsa-type" or name == "lsa-info-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "lsa-info-type"):
                                        self.lsa_info_type = value
                                        self.lsa_info_type.value_namespace = name_space
                                        self.lsa_info_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.advertising_router.is_set or
                                    self.area_id.is_set or
                                    self.interface_name.is_set or
                                    self.ls_id.is_set or
                                    self.ls_type.is_set or
                                    (self.lsa_info is not None and self.lsa_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.advertising_router.yfilter != YFilter.not_set or
                                    self.area_id.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.ls_id.yfilter != YFilter.not_set or
                                    self.ls_type.yfilter != YFilter.not_set or
                                    (self.lsa_info is not None and self.lsa_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsa" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_id.get_name_leafdata())
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                if (self.ls_type.is_set or self.ls_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "lsa-info"):
                                    if (self.lsa_info is None):
                                        self.lsa_info = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa.LsaInfo()
                                        self.lsa_info.parent = self
                                        self._children_name_map["lsa_info"] = "lsa-info"
                                    return self.lsa_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsa-info" or name == "advertising-router" or name == "area-id" or name == "interface-name" or name == "ls-id" or name == "ls-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "advertising-router"):
                                    self.advertising_router = value
                                    self.advertising_router.value_namespace = name_space
                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-id"):
                                    self.area_id = value
                                    self.area_id.value_namespace = name_space
                                    self.area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-id"):
                                    self.ls_id = value
                                    self.ls_id.value_namespace = name_space
                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-type"):
                                    self.ls_type = value
                                    self.ls_type.value_namespace = name_space
                                    self.ls_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.lsa:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.lsa:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsa-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "lsa"):
                                for c in self.lsa:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable.Lsa()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.lsa.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsa"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class LsaInternalTable(Entity):
                        """
                        Database LSA information
                        
                        .. attribute:: lsa
                        
                        	Database LSA information
                        	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable, self).__init__()

                            self.yang_name = "lsa-internal-table"
                            self.yang_parent_name = "database-table"

                            self.lsa = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable, self).__setattr__(name, value)


                        class Lsa(Entity):
                            """
                            Database LSA information
                            
                            .. attribute:: advertising_router
                            
                            	Advertising Router ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: area_id
                            
                            	Area ID
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: interface_name
                            
                            	InterfaceName
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: ls_id
                            
                            	Link state ID
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: ls_type
                            
                            	LSA type
                            	**type**\:   :py:class:`Ospfv3Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa>`
                            
                            .. attribute:: lsa_info
                            
                            	Summary of all LSAs or LSA specific information 
                            	**type**\:   :py:class:`LsaInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa, self).__init__()

                                self.yang_name = "lsa"
                                self.yang_parent_name = "lsa-internal-table"

                                self.advertising_router = YLeaf(YType.str, "advertising-router")

                                self.area_id = YLeaf(YType.int32, "area-id")

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.ls_id = YLeaf(YType.int32, "ls-id")

                                self.ls_type = YLeaf(YType.enumeration, "ls-type")

                                self.lsa_info = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo()
                                self.lsa_info.parent = self
                                self._children_name_map["lsa_info"] = "lsa-info"
                                self._children_yang_names.add("lsa-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("advertising_router",
                                                "area_id",
                                                "interface_name",
                                                "ls_id",
                                                "ls_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa, self).__setattr__(name, value)


                            class LsaInfo(Entity):
                                """
                                Summary of all LSAs or LSA specific information 
                                
                                .. attribute:: external_lsa_type
                                
                                	External LSA
                                	**type**\:   :py:class:`ExternalLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType>`
                                
                                .. attribute:: grace_lsa
                                
                                	Grace LSA
                                	**type**\:   :py:class:`GraceLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa>`
                                
                                .. attribute:: inter_area_prefix_lsa_type
                                
                                	Inter Area Prefix LSA
                                	**type**\:   :py:class:`InterAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType>`
                                
                                .. attribute:: inter_area_router_lsa_type
                                
                                	Inter Area Router LSA
                                	**type**\:   :py:class:`InterAreaRouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType>`
                                
                                .. attribute:: intra_area_prefix_lsa_type
                                
                                	Intra Area Prefix LSA
                                	**type**\:   :py:class:`IntraAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType>`
                                
                                .. attribute:: link_lsa_type
                                
                                	Link LSA
                                	**type**\:   :py:class:`LinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType>`
                                
                                .. attribute:: lsa_info_type
                                
                                	LSAInfoType
                                	**type**\:   :py:class:`Ospfv3LsaInfoTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3LsaInfoTypes>`
                                
                                .. attribute:: lsa_summary_info
                                
                                	Summary information of LSAs
                                	**type**\:   :py:class:`LsaSummaryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo>`
                                
                                .. attribute:: network_lsa_type
                                
                                	Network LSA
                                	**type**\:   :py:class:`NetworkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType>`
                                
                                .. attribute:: nssalsa_type
                                
                                	NSSA External LSA
                                	**type**\:   :py:class:`NssalsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType>`
                                
                                .. attribute:: router_lsa_type
                                
                                	Router LSA
                                	**type**\:   :py:class:`RouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType>`
                                
                                .. attribute:: unknown_area_lsa_type
                                
                                	Unknown\-Area scope LSA
                                	**type**\:   :py:class:`UnknownAreaLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType>`
                                
                                .. attribute:: unknown_aslsa_type
                                
                                	Unknown\-AS scope LSA
                                	**type**\:   :py:class:`UnknownAslsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType>`
                                
                                .. attribute:: unknown_link_lsa_type
                                
                                	Unknown Link Scope LSA
                                	**type**\:   :py:class:`UnknownLinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType>`
                                
                                .. attribute:: unknown_lsa_type
                                
                                	Unknown LSA
                                	**type**\:   :py:class:`UnknownLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__init__()

                                    self.yang_name = "lsa-info"
                                    self.yang_parent_name = "lsa"

                                    self.lsa_info_type = YLeaf(YType.enumeration, "lsa-info-type")

                                    self.external_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType()
                                    self.external_lsa_type.parent = self
                                    self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                    self._children_yang_names.add("external-lsa-type")

                                    self.grace_lsa = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa()
                                    self.grace_lsa.parent = self
                                    self._children_name_map["grace_lsa"] = "grace-lsa"
                                    self._children_yang_names.add("grace-lsa")

                                    self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                    self.inter_area_prefix_lsa_type.parent = self
                                    self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                    self._children_yang_names.add("inter-area-prefix-lsa-type")

                                    self.inter_area_router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                    self.inter_area_router_lsa_type.parent = self
                                    self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                    self._children_yang_names.add("inter-area-router-lsa-type")

                                    self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                    self.intra_area_prefix_lsa_type.parent = self
                                    self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                    self._children_yang_names.add("intra-area-prefix-lsa-type")

                                    self.link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType()
                                    self.link_lsa_type.parent = self
                                    self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                    self._children_yang_names.add("link-lsa-type")

                                    self.lsa_summary_info = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo()
                                    self.lsa_summary_info.parent = self
                                    self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                    self._children_yang_names.add("lsa-summary-info")

                                    self.network_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType()
                                    self.network_lsa_type.parent = self
                                    self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                    self._children_yang_names.add("network-lsa-type")

                                    self.nssalsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType()
                                    self.nssalsa_type.parent = self
                                    self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                    self._children_yang_names.add("nssalsa-type")

                                    self.router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType()
                                    self.router_lsa_type.parent = self
                                    self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                    self._children_yang_names.add("router-lsa-type")

                                    self.unknown_area_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                    self.unknown_area_lsa_type.parent = self
                                    self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                    self._children_yang_names.add("unknown-area-lsa-type")

                                    self.unknown_aslsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType()
                                    self.unknown_aslsa_type.parent = self
                                    self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                    self._children_yang_names.add("unknown-aslsa-type")

                                    self.unknown_link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                    self.unknown_link_lsa_type.parent = self
                                    self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                    self._children_yang_names.add("unknown-link-lsa-type")

                                    self.unknown_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType()
                                    self.unknown_lsa_type.parent = self
                                    self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                    self._children_yang_names.add("unknown-lsa-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("lsa_info_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__setattr__(name, value)


                                class LsaSummaryInfo(Entity):
                                    """
                                    Summary information of LSAs
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface name 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: links
                                    
                                    	Number of links
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader>`
                                    
                                    .. attribute:: lsa_router_id
                                    
                                    	LSA router ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	OSPFv3 address Prefix 
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: reference_lsa_id
                                    
                                    	Reference LSA ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: reference_type
                                    
                                    	Reference type 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: router_la_bits
                                    
                                    	Router LA bits 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Sham link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__init__()

                                        self.yang_name = "lsa-summary-info"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.links = YLeaf(YType.uint16, "links")

                                        self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                        self.reference_type = YLeaf(YType.uint16, "reference-type")

                                        self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "links",
                                                        "lsa_router_id",
                                                        "prefix",
                                                        "prefix_length",
                                                        "reference_lsa_id",
                                                        "reference_type",
                                                        "router_la_bits",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "lsa-summary-info"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "lsa-summary-info"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.links.is_set or
                                            self.lsa_router_id.is_set or
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.reference_lsa_id.is_set or
                                            self.reference_type.is_set or
                                            self.router_la_bits.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.links.yfilter != YFilter.not_set or
                                            self.lsa_router_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.reference_lsa_id.yfilter != YFilter.not_set or
                                            self.reference_type.yfilter != YFilter.not_set or
                                            self.router_la_bits.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsa-summary-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.links.get_name_leafdata())
                                        if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_router_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                        if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reference_type.get_name_leafdata())
                                        if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_la_bits.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "links" or name == "lsa-router-id" or name == "prefix" or name == "prefix-length" or name == "reference-lsa-id" or name == "reference-type" or name == "router-la-bits" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "links"):
                                            self.links = value
                                            self.links.value_namespace = name_space
                                            self.links.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsa-router-id"):
                                            self.lsa_router_id = value
                                            self.lsa_router_id.value_namespace = name_space
                                            self.lsa_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reference-lsa-id"):
                                            self.reference_lsa_id = value
                                            self.reference_lsa_id.value_namespace = name_space
                                            self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reference-type"):
                                            self.reference_type = value
                                            self.reference_type.value_namespace = name_space
                                            self.reference_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-la-bits"):
                                            self.router_la_bits = value
                                            self.router_la_bits.value_namespace = name_space
                                            self.router_la_bits.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                class RouterLsaType(Entity):
                                    """
                                    Router LSA
                                    
                                    .. attribute:: link
                                    
                                    	List of links in this LSA
                                    	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link>`
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader>`
                                    
                                    .. attribute:: router_la_bits
                                    
                                    	Router LA bits 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: rpf_path
                                    
                                    	Router LSA Reverse\-Path Forwarding information 
                                    	**type**\:   :py:class:`RpfPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__init__()

                                        self.yang_name = "router-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                        self.rpf_path = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                        self.rpf_path.parent = self
                                        self._children_name_map["rpf_path"] = "rpf-path"
                                        self._children_yang_names.add("rpf-path")

                                        self.link = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("router_la_bits") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "router-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "router-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix


                                    class RpfPath(Entity):
                                        """
                                        Router LSA Reverse\-Path Forwarding information 
                                        
                                        .. attribute:: interface_name
                                        
                                        	RPF multicast IDB 
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: rpf_multicast_next_hop
                                        
                                        	RPF multicast next hop 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__init__()

                                            self.yang_name = "rpf-path"
                                            self.yang_parent_name = "router-lsa-type"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.rpf_multicast_next_hop = YLeaf(YType.uint32, "rpf-multicast-next-hop")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "rpf_multicast_next_hop") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.interface_name.is_set or
                                                self.rpf_multicast_next_hop.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.rpf_multicast_next_hop.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "rpf-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.rpf_multicast_next_hop.is_set or self.rpf_multicast_next_hop.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rpf_multicast_next_hop.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface-name" or name == "rpf-multicast-next-hop"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rpf-multicast-next-hop"):
                                                self.rpf_multicast_next_hop = value
                                                self.rpf_multicast_next_hop.value_namespace = name_space
                                                self.rpf_multicast_next_hop.value_namespace_prefix = name_space_prefix


                                    class Link(Entity):
                                        """
                                        List of links in this LSA
                                        
                                        .. attribute:: link_interface_id
                                        
                                        	LSA link interface ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_metric
                                        
                                        	LSA link metric 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: link_neighbor_interface_id
                                        
                                        	LSA link neighbor interface ID 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_neighbor_router_id
                                        
                                        	LSA link neigbhor router id 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_type
                                        
                                        	Type of link
                                        	**type**\:   :py:class:`Ospfv3Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Link>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__init__()

                                            self.yang_name = "link"
                                            self.yang_parent_name = "router-lsa-type"

                                            self.link_interface_id = YLeaf(YType.uint32, "link-interface-id")

                                            self.link_metric = YLeaf(YType.uint16, "link-metric")

                                            self.link_neighbor_interface_id = YLeaf(YType.uint32, "link-neighbor-interface-id")

                                            self.link_neighbor_router_id = YLeaf(YType.uint32, "link-neighbor-router-id")

                                            self.link_type = YLeaf(YType.enumeration, "link-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("link_interface_id",
                                                            "link_metric",
                                                            "link_neighbor_interface_id",
                                                            "link_neighbor_router_id",
                                                            "link_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.link_interface_id.is_set or
                                                self.link_metric.is_set or
                                                self.link_neighbor_interface_id.is_set or
                                                self.link_neighbor_router_id.is_set or
                                                self.link_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.link_interface_id.yfilter != YFilter.not_set or
                                                self.link_metric.yfilter != YFilter.not_set or
                                                self.link_neighbor_interface_id.yfilter != YFilter.not_set or
                                                self.link_neighbor_router_id.yfilter != YFilter.not_set or
                                                self.link_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.link_interface_id.is_set or self.link_interface_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_interface_id.get_name_leafdata())
                                            if (self.link_metric.is_set or self.link_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_metric.get_name_leafdata())
                                            if (self.link_neighbor_interface_id.is_set or self.link_neighbor_interface_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_neighbor_interface_id.get_name_leafdata())
                                            if (self.link_neighbor_router_id.is_set or self.link_neighbor_router_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_neighbor_router_id.get_name_leafdata())
                                            if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "link-interface-id" or name == "link-metric" or name == "link-neighbor-interface-id" or name == "link-neighbor-router-id" or name == "link-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "link-interface-id"):
                                                self.link_interface_id = value
                                                self.link_interface_id.value_namespace = name_space
                                                self.link_interface_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-metric"):
                                                self.link_metric = value
                                                self.link_metric.value_namespace = name_space
                                                self.link_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-neighbor-interface-id"):
                                                self.link_neighbor_interface_id = value
                                                self.link_neighbor_interface_id.value_namespace = name_space
                                                self.link_neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-neighbor-router-id"):
                                                self.link_neighbor_router_id = value
                                                self.link_neighbor_router_id.value_namespace = name_space
                                                self.link_neighbor_router_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-type"):
                                                self.link_type = value
                                                self.link_type.value_namespace = name_space
                                                self.link_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.link:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.router_la_bits.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()) or
                                            (self.rpf_path is not None and self.rpf_path.has_data()))

                                    def has_operation(self):
                                        for c in self.link:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.router_la_bits.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()) or
                                            (self.rpf_path is not None and self.rpf_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "router-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_la_bits.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link"):
                                            for c in self.link:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.link.append(c)
                                            return c

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        if (child_yang_name == "rpf-path"):
                                            if (self.rpf_path is None):
                                                self.rpf_path = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                self.rpf_path.parent = self
                                                self._children_name_map["rpf_path"] = "rpf-path"
                                            return self.rpf_path

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link" or name == "lsa-detail" or name == "lsa-header" or name == "rpf-path" or name == "router-la-bits"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "router-la-bits"):
                                            self.router_la_bits = value
                                            self.router_la_bits.value_namespace = name_space
                                            self.router_la_bits.value_namespace_prefix = name_space_prefix


                                class NetworkLsaType(Entity):
                                    """
                                    Network LSA
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader>`
                                    
                                    .. attribute:: neighbor_router
                                    
                                    	Neighbor router list
                                    	**type**\:  list of str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__init__()

                                        self.yang_name = "network-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.neighbor_router = YLeafList(YType.str, "neighbor-router")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("neighbor_router") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "network-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "network-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for leaf in self.neighbor_router.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        for leaf in self.neighbor_router.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.neighbor_router.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "network-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        leaf_name_data.extend(self.neighbor_router.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "neighbor-router"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "neighbor-router"):
                                            self.neighbor_router.append(value)


                                class InterAreaPrefixLsaType(Entity):
                                    """
                                    Inter Area Prefix LSA
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA Information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader>`
                                    
                                    .. attribute:: prefix
                                    
                                    	LSA address prefix 
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: priority
                                    
                                    	Prefix priority
                                    	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__init__()

                                        self.yang_name = "inter-area-prefix-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.priority = YLeaf(YType.enumeration, "priority")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "inter-area-prefix-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA Information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "inter-area-prefix-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.priority.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.priority.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inter-area-prefix-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "prefix-length" or name == "priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "priority"):
                                            self.priority = value
                                            self.priority.value_namespace = name_space
                                            self.priority.value_namespace_prefix = name_space_prefix


                                class InterAreaRouterLsaType(Entity):
                                    """
                                    Inter Area Router LSA
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader>`
                                    
                                    .. attribute:: lsa_router_id
                                    
                                    	LSA router ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__init__()

                                        self.yang_name = "inter-area-router-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("lsa_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "inter-area-router-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "inter-area-router-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.lsa_router_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.lsa_router_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inter-area-router-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "lsa-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "lsa-router-id"):
                                            self.lsa_router_id = value
                                            self.lsa_router_id.value_namespace = name_space
                                            self.lsa_router_id.value_namespace_prefix = name_space_prefix


                                class ExternalLsaType(Entity):
                                    """
                                    External LSA
                                    
                                    .. attribute:: external_tag
                                    
                                    	Route Tag
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forwarding_address
                                    
                                    	Forwarding Address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: is_forwarding_address_set
                                    
                                    	If true, forwarding address is set 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA Information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader>`
                                    
                                    .. attribute:: metric_type
                                    
                                    	Metric type 
                                    	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                    
                                    .. attribute:: prefix
                                    
                                    	IPV6 address prefix 
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: priority
                                    
                                    	Prefix priority
                                    	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                    
                                    .. attribute:: tos_cost
                                    
                                    	Type of service cost metric 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__init__()

                                        self.yang_name = "external-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.external_tag = YLeaf(YType.uint32, "external-tag")

                                        self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                        self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                        self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.priority = YLeaf(YType.enumeration, "priority")

                                        self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("external_tag",
                                                        "forwarding_address",
                                                        "is_forwarding_address_set",
                                                        "metric_type",
                                                        "prefix",
                                                        "prefix_length",
                                                        "priority",
                                                        "tos_cost") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "external-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA Information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "external-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.external_tag.is_set or
                                            self.forwarding_address.is_set or
                                            self.is_forwarding_address_set.is_set or
                                            self.metric_type.is_set or
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.priority.is_set or
                                            self.tos_cost.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.external_tag.yfilter != YFilter.not_set or
                                            self.forwarding_address.yfilter != YFilter.not_set or
                                            self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                            self.metric_type.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.priority.yfilter != YFilter.not_set or
                                            self.tos_cost.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "external-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.external_tag.get_name_leafdata())
                                        if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                        if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                        if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.metric_type.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.priority.get_name_leafdata())
                                        if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "external-tag"):
                                            self.external_tag = value
                                            self.external_tag.value_namespace = name_space
                                            self.external_tag.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forwarding-address"):
                                            self.forwarding_address = value
                                            self.forwarding_address.value_namespace = name_space
                                            self.forwarding_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-forwarding-address-set"):
                                            self.is_forwarding_address_set = value
                                            self.is_forwarding_address_set.value_namespace = name_space
                                            self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                        if(value_path == "metric-type"):
                                            self.metric_type = value
                                            self.metric_type.value_namespace = name_space
                                            self.metric_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "priority"):
                                            self.priority = value
                                            self.priority.value_namespace = name_space
                                            self.priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tos-cost"):
                                            self.tos_cost = value
                                            self.tos_cost.value_namespace = name_space
                                            self.tos_cost.value_namespace_prefix = name_space_prefix


                                class NssalsaType(Entity):
                                    """
                                    NSSA External LSA
                                    
                                    .. attribute:: external_tag
                                    
                                    	Route Tag
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forwarding_address
                                    
                                    	Forwarding Address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: is_forwarding_address_set
                                    
                                    	If true, forwarding address is set 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA Information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader>`
                                    
                                    .. attribute:: metric_type
                                    
                                    	Metric type 
                                    	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                    
                                    .. attribute:: prefix
                                    
                                    	IPV6 address prefix 
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: priority
                                    
                                    	Prefix priority
                                    	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                    
                                    .. attribute:: tos_cost
                                    
                                    	Type of service cost metric 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__init__()

                                        self.yang_name = "nssalsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.external_tag = YLeaf(YType.uint32, "external-tag")

                                        self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                        self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                        self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.priority = YLeaf(YType.enumeration, "priority")

                                        self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("external_tag",
                                                        "forwarding_address",
                                                        "is_forwarding_address_set",
                                                        "metric_type",
                                                        "prefix",
                                                        "prefix_length",
                                                        "priority",
                                                        "tos_cost") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "nssalsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA Information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "nssalsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.external_tag.is_set or
                                            self.forwarding_address.is_set or
                                            self.is_forwarding_address_set.is_set or
                                            self.metric_type.is_set or
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.priority.is_set or
                                            self.tos_cost.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.external_tag.yfilter != YFilter.not_set or
                                            self.forwarding_address.yfilter != YFilter.not_set or
                                            self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                            self.metric_type.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.priority.yfilter != YFilter.not_set or
                                            self.tos_cost.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nssalsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.external_tag.get_name_leafdata())
                                        if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                        if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                        if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.metric_type.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.priority.get_name_leafdata())
                                        if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "external-tag"):
                                            self.external_tag = value
                                            self.external_tag.value_namespace = name_space
                                            self.external_tag.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forwarding-address"):
                                            self.forwarding_address = value
                                            self.forwarding_address.value_namespace = name_space
                                            self.forwarding_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-forwarding-address-set"):
                                            self.is_forwarding_address_set = value
                                            self.is_forwarding_address_set.value_namespace = name_space
                                            self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                        if(value_path == "metric-type"):
                                            self.metric_type = value
                                            self.metric_type.value_namespace = name_space
                                            self.metric_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "priority"):
                                            self.priority = value
                                            self.priority.value_namespace = name_space
                                            self.priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tos-cost"):
                                            self.tos_cost = value
                                            self.tos_cost.value_namespace = name_space
                                            self.tos_cost.value_namespace_prefix = name_space_prefix


                                class LinkLsaType(Entity):
                                    """
                                    Link LSA
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface handle
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader>`
                                    
                                    .. attribute:: lsa_link_local
                                    
                                    	LSA link local 
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix
                                    
                                    	OSPFv3 prefix 
                                    	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix>`
                                    
                                    .. attribute:: router_priority
                                    
                                    	Router priority 
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Sham link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__init__()

                                        self.yang_name = "link-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.lsa_link_local = YLeaf(YType.str, "lsa-link-local")

                                        self.router_priority = YLeaf(YType.uint8, "router-priority")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                        self.prefix = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "lsa_link_local",
                                                        "router_priority",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "link-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "link-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix


                                    class Prefix(Entity):
                                        """
                                        OSPFv3 prefix 
                                        
                                        .. attribute:: ospfv3_prefix_length
                                        
                                        	OSPFv3 prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ospfv3_prefix_metric
                                        
                                        	OSPFv3 prefix metric 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ospfv3_prefix_options
                                        
                                        	OSPFv3 prefix options 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: prefix
                                        
                                        	OSPFv3 prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: priority
                                        
                                        	Prefix priority
                                        	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__init__()

                                            self.yang_name = "prefix"
                                            self.yang_parent_name = "link-lsa-type"

                                            self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                            self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                            self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.priority = YLeaf(YType.enumeration, "priority")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("ospfv3_prefix_length",
                                                            "ospfv3_prefix_metric",
                                                            "ospfv3_prefix_options",
                                                            "prefix",
                                                            "priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.ospfv3_prefix_length.is_set or
                                                self.ospfv3_prefix_metric.is_set or
                                                self.ospfv3_prefix_options.is_set or
                                                self.prefix.is_set or
                                                self.priority.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prefix" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                            if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                            if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "ospfv3-prefix-length"):
                                                self.ospfv3_prefix_length = value
                                                self.ospfv3_prefix_length.value_namespace = name_space
                                                self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ospfv3-prefix-metric"):
                                                self.ospfv3_prefix_metric = value
                                                self.ospfv3_prefix_metric.value_namespace = name_space
                                                self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ospfv3-prefix-options"):
                                                self.ospfv3_prefix_options = value
                                                self.ospfv3_prefix_options.value_namespace = name_space
                                                self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.prefix:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.lsa_link_local.is_set or
                                            self.router_priority.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        for c in self.prefix:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.lsa_link_local.yfilter != YFilter.not_set or
                                            self.router_priority.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.lsa_link_local.is_set or self.lsa_link_local.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_link_local.get_name_leafdata())
                                        if (self.router_priority.is_set or self.router_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_priority.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        if (child_yang_name == "prefix"):
                                            for c in self.prefix:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.prefix.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "lsa-link-local" or name == "router-priority" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsa-link-local"):
                                            self.lsa_link_local = value
                                            self.lsa_link_local.value_namespace = name_space
                                            self.lsa_link_local.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-priority"):
                                            self.router_priority = value
                                            self.router_priority.value_namespace = name_space
                                            self.router_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                class IntraAreaPrefixLsaType(Entity):
                                    """
                                    Intra Area Prefix LSA
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader>`
                                    
                                    .. attribute:: prefix
                                    
                                    	OSPFv3 prefix 
                                    	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix>`
                                    
                                    .. attribute:: reference_advertised_router
                                    
                                    	Reference advertised router 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: reference_lsa_id
                                    
                                    	Reference LSA ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: reference_type
                                    
                                    	Reference type 
                                    	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__init__()

                                        self.yang_name = "intra-area-prefix-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.reference_advertised_router = YLeaf(YType.str, "reference-advertised-router")

                                        self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                        self.reference_type = YLeaf(YType.enumeration, "reference-type")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                        self.prefix = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("reference_advertised_router",
                                                        "reference_lsa_id",
                                                        "reference_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "intra-area-prefix-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "intra-area-prefix-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix


                                    class Prefix(Entity):
                                        """
                                        OSPFv3 prefix 
                                        
                                        .. attribute:: ospfv3_prefix_length
                                        
                                        	OSPFv3 prefix length 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ospfv3_prefix_metric
                                        
                                        	OSPFv3 prefix metric 
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ospfv3_prefix_options
                                        
                                        	OSPFv3 prefix options 
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: prefix
                                        
                                        	OSPFv3 prefix 
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: priority
                                        
                                        	Prefix priority
                                        	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__init__()

                                            self.yang_name = "prefix"
                                            self.yang_parent_name = "intra-area-prefix-lsa-type"

                                            self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                            self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                            self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                            self.prefix = YLeaf(YType.str, "prefix")

                                            self.priority = YLeaf(YType.enumeration, "priority")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("ospfv3_prefix_length",
                                                            "ospfv3_prefix_metric",
                                                            "ospfv3_prefix_options",
                                                            "prefix",
                                                            "priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.ospfv3_prefix_length.is_set or
                                                self.ospfv3_prefix_metric.is_set or
                                                self.ospfv3_prefix_options.is_set or
                                                self.prefix.is_set or
                                                self.priority.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                self.prefix.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prefix" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                            if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                            if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "ospfv3-prefix-length"):
                                                self.ospfv3_prefix_length = value
                                                self.ospfv3_prefix_length.value_namespace = name_space
                                                self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ospfv3-prefix-metric"):
                                                self.ospfv3_prefix_metric = value
                                                self.ospfv3_prefix_metric.value_namespace = name_space
                                                self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ospfv3-prefix-options"):
                                                self.ospfv3_prefix_options = value
                                                self.ospfv3_prefix_options.value_namespace = name_space
                                                self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix"):
                                                self.prefix = value
                                                self.prefix.value_namespace = name_space
                                                self.prefix.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.prefix:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.reference_advertised_router.is_set or
                                            self.reference_lsa_id.is_set or
                                            self.reference_type.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        for c in self.prefix:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.reference_advertised_router.yfilter != YFilter.not_set or
                                            self.reference_lsa_id.yfilter != YFilter.not_set or
                                            self.reference_type.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "intra-area-prefix-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.reference_advertised_router.is_set or self.reference_advertised_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reference_advertised_router.get_name_leafdata())
                                        if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                        if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reference_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        if (child_yang_name == "prefix"):
                                            for c in self.prefix:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.prefix.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "reference-advertised-router" or name == "reference-lsa-id" or name == "reference-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "reference-advertised-router"):
                                            self.reference_advertised_router = value
                                            self.reference_advertised_router.value_namespace = name_space
                                            self.reference_advertised_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reference-lsa-id"):
                                            self.reference_lsa_id = value
                                            self.reference_lsa_id.value_namespace = name_space
                                            self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reference-type"):
                                            self.reference_type = value
                                            self.reference_type.value_namespace = name_space
                                            self.reference_type.value_namespace_prefix = name_space_prefix


                                class GraceLsa(Entity):
                                    """
                                    Grace LSA
                                    
                                    .. attribute:: grace_period
                                    
                                    	The grace periord where helper routers should wait before advertising it fully adjacent(s) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: grace_reason
                                    
                                    	Reason for router restart
                                    	**type**\:   :py:class:`Ospfv3GracefulRestartReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3GracefulRestartReason>`
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__init__()

                                        self.yang_name = "grace-lsa"
                                        self.yang_parent_name = "lsa-info"

                                        self.grace_period = YLeaf(YType.uint32, "grace-period")

                                        self.grace_reason = YLeaf(YType.enumeration, "grace-reason")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("grace_period",
                                                        "grace_reason") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "grace-lsa"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "grace-lsa"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.grace_period.is_set or
                                            self.grace_reason.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.grace_period.yfilter != YFilter.not_set or
                                            self.grace_reason.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "grace-lsa" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.grace_period.is_set or self.grace_period.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grace_period.get_name_leafdata())
                                        if (self.grace_reason.is_set or self.grace_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grace_reason.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "grace-period" or name == "grace-reason"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "grace-period"):
                                            self.grace_period = value
                                            self.grace_period.value_namespace = name_space
                                            self.grace_period.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grace-reason"):
                                            self.grace_reason = value
                                            self.grace_reason.value_namespace = name_space
                                            self.grace_reason.value_namespace_prefix = name_space_prefix


                                class UnknownLinkLsaType(Entity):
                                    """
                                    Unknown Link Scope LSA
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface name 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader>`
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Shamlink ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__init__()

                                        self.yang_name = "unknown-link-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "unknown-link-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "unknown-link-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unknown-link-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                class UnknownAreaLsaType(Entity):
                                    """
                                    Unknown\-Area scope LSA
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface name 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader>`
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Shamlink ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__init__()

                                        self.yang_name = "unknown-area-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "unknown-area-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "unknown-area-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unknown-area-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                class UnknownAslsaType(Entity):
                                    """
                                    Unknown\-AS scope LSA
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface name 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader>`
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Shamlink ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__init__()

                                        self.yang_name = "unknown-aslsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "unknown-aslsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "unknown-aslsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unknown-aslsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                class UnknownLsaType(Entity):
                                    """
                                    Unknown LSA
                                    
                                    .. attribute:: interface_name
                                    
                                    	LSA interface name 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: is_sham_link
                                    
                                    	If true, it is a sham link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_virtual_link
                                    
                                    	If true, it is a virtual link 
                                    	**type**\:  bool
                                    
                                    .. attribute:: lsa_detail
                                    
                                    	Detailed LSA information
                                    	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail>`
                                    
                                    .. attribute:: lsa_header
                                    
                                    	Header information 
                                    	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader>`
                                    
                                    .. attribute:: sham_link_id
                                    
                                    	Shamlink ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: virtual_link_id
                                    
                                    	Virtual link ID 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__init__()

                                        self.yang_name = "unknown-lsa-type"
                                        self.yang_parent_name = "lsa-info"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                        self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                        self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                        self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                        self.lsa_detail.parent = self
                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                        self._children_yang_names.add("lsa-detail")

                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                        self.lsa_header.parent = self
                                        self._children_name_map["lsa_header"] = "lsa-header"
                                        self._children_yang_names.add("lsa-header")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "is_sham_link",
                                                        "is_virtual_link",
                                                        "sham_link_id",
                                                        "virtual_link_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)


                                    class LsaHeader(Entity):
                                        """
                                        Header information 
                                        
                                        .. attribute:: advertising_router
                                        
                                        	Router ID of Advertising Router
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: checksum
                                        
                                        	Checksum value
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: is_do_not_age_lsa
                                        
                                        	If true, Do Not Age this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_graceful_restart_active
                                        
                                        	If true, if grace restart is active 
                                        	**type**\:  bool
                                        
                                        .. attribute:: ls_id
                                        
                                        	LS ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_age
                                        
                                        	LSA's Age (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_area_id
                                        
                                        	Area ID in decimal or dotted\-decimal format
                                        	**type**\:  str
                                        
                                        	**length:** 0..16
                                        
                                        .. attribute:: lsa_type
                                        
                                        	LSA type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sequence_number
                                        
                                        	Current Sequence number
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__init__()

                                            self.yang_name = "lsa-header"
                                            self.yang_parent_name = "unknown-lsa-type"

                                            self.advertising_router = YLeaf(YType.str, "advertising-router")

                                            self.checksum = YLeaf(YType.uint16, "checksum")

                                            self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                            self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                            self.ls_id = YLeaf(YType.uint32, "ls-id")

                                            self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                            self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                            self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                            self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("advertising_router",
                                                            "checksum",
                                                            "is_do_not_age_lsa",
                                                            "is_graceful_restart_active",
                                                            "ls_id",
                                                            "lsa_age",
                                                            "lsa_area_id",
                                                            "lsa_type",
                                                            "sequence_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.advertising_router.is_set or
                                                self.checksum.is_set or
                                                self.is_do_not_age_lsa.is_set or
                                                self.is_graceful_restart_active.is_set or
                                                self.ls_id.is_set or
                                                self.lsa_age.is_set or
                                                self.lsa_area_id.is_set or
                                                self.lsa_type.is_set or
                                                self.sequence_number.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.advertising_router.yfilter != YFilter.not_set or
                                                self.checksum.yfilter != YFilter.not_set or
                                                self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                self.ls_id.yfilter != YFilter.not_set or
                                                self.lsa_age.yfilter != YFilter.not_set or
                                                self.lsa_area_id.yfilter != YFilter.not_set or
                                                self.lsa_type.yfilter != YFilter.not_set or
                                                self.sequence_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                            if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.checksum.get_name_leafdata())
                                            if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                            if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                            if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ls_id.get_name_leafdata())
                                            if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                            if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                            if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                            if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "advertising-router"):
                                                self.advertising_router = value
                                                self.advertising_router.value_namespace = name_space
                                                self.advertising_router.value_namespace_prefix = name_space_prefix
                                            if(value_path == "checksum"):
                                                self.checksum = value
                                                self.checksum.value_namespace = name_space
                                                self.checksum.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-do-not-age-lsa"):
                                                self.is_do_not_age_lsa = value
                                                self.is_do_not_age_lsa.value_namespace = name_space
                                                self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-graceful-restart-active"):
                                                self.is_graceful_restart_active = value
                                                self.is_graceful_restart_active.value_namespace = name_space
                                                self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ls-id"):
                                                self.ls_id = value
                                                self.ls_id.value_namespace = name_space
                                                self.ls_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-age"):
                                                self.lsa_age = value
                                                self.lsa_age.value_namespace = name_space
                                                self.lsa_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-area-id"):
                                                self.lsa_area_id = value
                                                self.lsa_area_id.value_namespace = name_space
                                                self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-type"):
                                                self.lsa_type = value
                                                self.lsa_type.value_namespace = name_space
                                                self.lsa_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sequence-number"):
                                                self.sequence_number = value
                                                self.sequence_number.value_namespace = name_space
                                                self.sequence_number.value_namespace_prefix = name_space_prefix


                                    class LsaDetail(Entity):
                                        """
                                        Detailed LSA information
                                        
                                        .. attribute:: free_time
                                        
                                        	The amount of time since the last check was made to free this LSA (s)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_acknowledged
                                        
                                        	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_advertising_router_reachable
                                        
                                        	If true, Advertising Router is reachable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_deleted
                                        
                                        	If true, flag is set to delete this LSA 
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_flood_pending
                                        
                                        	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_maximum_aged
                                        
                                        	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_neighbor_exchange
                                        
                                        	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_no_delete
                                        
                                        	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_nsr_ack_pending
                                        
                                        	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_partial_spf
                                        
                                        	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_bit
                                        
                                        	If true, Routing Bit set on the LSA
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_routing_table
                                        
                                        	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_flood_required_post_fail_over
                                        
                                        	LSA flood required after FO
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsa_length
                                        
                                        	Length of the LSA
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsa_sync_state
                                        
                                        	State of LSA sync with active
                                        	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                        
                                        .. attribute:: minute_table_index
                                        
                                        	Minute table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: nsr_flood_required
                                        
                                        	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                        	**type**\:  bool
                                        
                                        .. attribute:: rate_limit
                                        
                                        	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                        	**type**\:  bool
                                        
                                        .. attribute:: second_table_index
                                        
                                        	Second table index
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__init__()

                                            self.yang_name = "lsa-detail"
                                            self.yang_parent_name = "unknown-lsa-type"

                                            self.free_time = YLeaf(YType.uint32, "free-time")

                                            self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                            self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                            self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                            self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                            self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                            self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                            self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                            self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                            self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                            self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                            self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                            self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                            self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                            self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                            self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                            self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                            self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                            self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("free_time",
                                                            "is_acknowledged",
                                                            "is_advertising_router_reachable",
                                                            "is_deleted",
                                                            "is_flood_pending",
                                                            "is_maximum_aged",
                                                            "is_neighbor_exchange",
                                                            "is_no_delete",
                                                            "is_nsr_ack_pending",
                                                            "is_partial_spf",
                                                            "is_routing_bit",
                                                            "is_routing_table",
                                                            "lsa_flood_required_post_fail_over",
                                                            "lsa_length",
                                                            "lsa_sync_state",
                                                            "minute_table_index",
                                                            "nsr_flood_required",
                                                            "rate_limit",
                                                            "second_table_index") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.free_time.is_set or
                                                self.is_acknowledged.is_set or
                                                self.is_advertising_router_reachable.is_set or
                                                self.is_deleted.is_set or
                                                self.is_flood_pending.is_set or
                                                self.is_maximum_aged.is_set or
                                                self.is_neighbor_exchange.is_set or
                                                self.is_no_delete.is_set or
                                                self.is_nsr_ack_pending.is_set or
                                                self.is_partial_spf.is_set or
                                                self.is_routing_bit.is_set or
                                                self.is_routing_table.is_set or
                                                self.lsa_flood_required_post_fail_over.is_set or
                                                self.lsa_length.is_set or
                                                self.lsa_sync_state.is_set or
                                                self.minute_table_index.is_set or
                                                self.nsr_flood_required.is_set or
                                                self.rate_limit.is_set or
                                                self.second_table_index.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.free_time.yfilter != YFilter.not_set or
                                                self.is_acknowledged.yfilter != YFilter.not_set or
                                                self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                self.is_deleted.yfilter != YFilter.not_set or
                                                self.is_flood_pending.yfilter != YFilter.not_set or
                                                self.is_maximum_aged.yfilter != YFilter.not_set or
                                                self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                self.is_no_delete.yfilter != YFilter.not_set or
                                                self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                self.is_partial_spf.yfilter != YFilter.not_set or
                                                self.is_routing_bit.yfilter != YFilter.not_set or
                                                self.is_routing_table.yfilter != YFilter.not_set or
                                                self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                self.lsa_length.yfilter != YFilter.not_set or
                                                self.lsa_sync_state.yfilter != YFilter.not_set or
                                                self.minute_table_index.yfilter != YFilter.not_set or
                                                self.nsr_flood_required.yfilter != YFilter.not_set or
                                                self.rate_limit.yfilter != YFilter.not_set or
                                                self.second_table_index.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-detail" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.free_time.get_name_leafdata())
                                            if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                            if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                            if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                            if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                            if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                            if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                            if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                            if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                            if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                            if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                            if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                            if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                            if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                            if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                            if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                            if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                            if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                            if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "free-time"):
                                                self.free_time = value
                                                self.free_time.value_namespace = name_space
                                                self.free_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-acknowledged"):
                                                self.is_acknowledged = value
                                                self.is_acknowledged.value_namespace = name_space
                                                self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-advertising-router-reachable"):
                                                self.is_advertising_router_reachable = value
                                                self.is_advertising_router_reachable.value_namespace = name_space
                                                self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-deleted"):
                                                self.is_deleted = value
                                                self.is_deleted.value_namespace = name_space
                                                self.is_deleted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-flood-pending"):
                                                self.is_flood_pending = value
                                                self.is_flood_pending.value_namespace = name_space
                                                self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-maximum-aged"):
                                                self.is_maximum_aged = value
                                                self.is_maximum_aged.value_namespace = name_space
                                                self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-neighbor-exchange"):
                                                self.is_neighbor_exchange = value
                                                self.is_neighbor_exchange.value_namespace = name_space
                                                self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-delete"):
                                                self.is_no_delete = value
                                                self.is_no_delete.value_namespace = name_space
                                                self.is_no_delete.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-nsr-ack-pending"):
                                                self.is_nsr_ack_pending = value
                                                self.is_nsr_ack_pending.value_namespace = name_space
                                                self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-partial-spf"):
                                                self.is_partial_spf = value
                                                self.is_partial_spf.value_namespace = name_space
                                                self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-bit"):
                                                self.is_routing_bit = value
                                                self.is_routing_bit.value_namespace = name_space
                                                self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-routing-table"):
                                                self.is_routing_table = value
                                                self.is_routing_table.value_namespace = name_space
                                                self.is_routing_table.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-flood-required-post-fail-over"):
                                                self.lsa_flood_required_post_fail_over = value
                                                self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-length"):
                                                self.lsa_length = value
                                                self.lsa_length.value_namespace = name_space
                                                self.lsa_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-sync-state"):
                                                self.lsa_sync_state = value
                                                self.lsa_sync_state.value_namespace = name_space
                                                self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "minute-table-index"):
                                                self.minute_table_index = value
                                                self.minute_table_index.value_namespace = name_space
                                                self.minute_table_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nsr-flood-required"):
                                                self.nsr_flood_required = value
                                                self.nsr_flood_required.value_namespace = name_space
                                                self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rate-limit"):
                                                self.rate_limit = value
                                                self.rate_limit.value_namespace = name_space
                                                self.rate_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "second-table-index"):
                                                self.second_table_index = value
                                                self.second_table_index.value_namespace = name_space
                                                self.second_table_index.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            self.is_sham_link.is_set or
                                            self.is_virtual_link.is_set or
                                            self.sham_link_id.is_set or
                                            self.virtual_link_id.is_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                            (self.lsa_header is not None and self.lsa_header.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.is_sham_link.yfilter != YFilter.not_set or
                                            self.is_virtual_link.yfilter != YFilter.not_set or
                                            self.sham_link_id.yfilter != YFilter.not_set or
                                            self.virtual_link_id.yfilter != YFilter.not_set or
                                            (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                            (self.lsa_header is not None and self.lsa_header.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unknown-lsa-type" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                        if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                        if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                        if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-detail"):
                                            if (self.lsa_detail is None):
                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                            return self.lsa_detail

                                        if (child_yang_name == "lsa-header"):
                                            if (self.lsa_header is None):
                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                            return self.lsa_header

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-sham-link"):
                                            self.is_sham_link = value
                                            self.is_sham_link.value_namespace = name_space
                                            self.is_sham_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-virtual-link"):
                                            self.is_virtual_link = value
                                            self.is_virtual_link.value_namespace = name_space
                                            self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sham-link-id"):
                                            self.sham_link_id = value
                                            self.sham_link_id.value_namespace = name_space
                                            self.sham_link_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "virtual-link-id"):
                                            self.virtual_link_id = value
                                            self.virtual_link_id.value_namespace = name_space
                                            self.virtual_link_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.lsa_info_type.is_set or
                                        (self.external_lsa_type is not None and self.external_lsa_type.has_data()) or
                                        (self.grace_lsa is not None and self.grace_lsa.has_data()) or
                                        (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_data()) or
                                        (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_data()) or
                                        (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_data()) or
                                        (self.link_lsa_type is not None and self.link_lsa_type.has_data()) or
                                        (self.lsa_summary_info is not None and self.lsa_summary_info.has_data()) or
                                        (self.network_lsa_type is not None and self.network_lsa_type.has_data()) or
                                        (self.nssalsa_type is not None and self.nssalsa_type.has_data()) or
                                        (self.router_lsa_type is not None and self.router_lsa_type.has_data()) or
                                        (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_data()) or
                                        (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_data()) or
                                        (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_data()) or
                                        (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.lsa_info_type.yfilter != YFilter.not_set or
                                        (self.external_lsa_type is not None and self.external_lsa_type.has_operation()) or
                                        (self.grace_lsa is not None and self.grace_lsa.has_operation()) or
                                        (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_operation()) or
                                        (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_operation()) or
                                        (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_operation()) or
                                        (self.link_lsa_type is not None and self.link_lsa_type.has_operation()) or
                                        (self.lsa_summary_info is not None and self.lsa_summary_info.has_operation()) or
                                        (self.network_lsa_type is not None and self.network_lsa_type.has_operation()) or
                                        (self.nssalsa_type is not None and self.nssalsa_type.has_operation()) or
                                        (self.router_lsa_type is not None and self.router_lsa_type.has_operation()) or
                                        (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_operation()) or
                                        (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_operation()) or
                                        (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_operation()) or
                                        (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsa-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.lsa_info_type.is_set or self.lsa_info_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_info_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "external-lsa-type"):
                                        if (self.external_lsa_type is None):
                                            self.external_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType()
                                            self.external_lsa_type.parent = self
                                            self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                        return self.external_lsa_type

                                    if (child_yang_name == "grace-lsa"):
                                        if (self.grace_lsa is None):
                                            self.grace_lsa = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa()
                                            self.grace_lsa.parent = self
                                            self._children_name_map["grace_lsa"] = "grace-lsa"
                                        return self.grace_lsa

                                    if (child_yang_name == "inter-area-prefix-lsa-type"):
                                        if (self.inter_area_prefix_lsa_type is None):
                                            self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                            self.inter_area_prefix_lsa_type.parent = self
                                            self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                        return self.inter_area_prefix_lsa_type

                                    if (child_yang_name == "inter-area-router-lsa-type"):
                                        if (self.inter_area_router_lsa_type is None):
                                            self.inter_area_router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                            self.inter_area_router_lsa_type.parent = self
                                            self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                        return self.inter_area_router_lsa_type

                                    if (child_yang_name == "intra-area-prefix-lsa-type"):
                                        if (self.intra_area_prefix_lsa_type is None):
                                            self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                            self.intra_area_prefix_lsa_type.parent = self
                                            self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                        return self.intra_area_prefix_lsa_type

                                    if (child_yang_name == "link-lsa-type"):
                                        if (self.link_lsa_type is None):
                                            self.link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType()
                                            self.link_lsa_type.parent = self
                                            self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                        return self.link_lsa_type

                                    if (child_yang_name == "lsa-summary-info"):
                                        if (self.lsa_summary_info is None):
                                            self.lsa_summary_info = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo()
                                            self.lsa_summary_info.parent = self
                                            self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                        return self.lsa_summary_info

                                    if (child_yang_name == "network-lsa-type"):
                                        if (self.network_lsa_type is None):
                                            self.network_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType()
                                            self.network_lsa_type.parent = self
                                            self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                        return self.network_lsa_type

                                    if (child_yang_name == "nssalsa-type"):
                                        if (self.nssalsa_type is None):
                                            self.nssalsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType()
                                            self.nssalsa_type.parent = self
                                            self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                        return self.nssalsa_type

                                    if (child_yang_name == "router-lsa-type"):
                                        if (self.router_lsa_type is None):
                                            self.router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType()
                                            self.router_lsa_type.parent = self
                                            self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                        return self.router_lsa_type

                                    if (child_yang_name == "unknown-area-lsa-type"):
                                        if (self.unknown_area_lsa_type is None):
                                            self.unknown_area_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                            self.unknown_area_lsa_type.parent = self
                                            self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                        return self.unknown_area_lsa_type

                                    if (child_yang_name == "unknown-aslsa-type"):
                                        if (self.unknown_aslsa_type is None):
                                            self.unknown_aslsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType()
                                            self.unknown_aslsa_type.parent = self
                                            self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                        return self.unknown_aslsa_type

                                    if (child_yang_name == "unknown-link-lsa-type"):
                                        if (self.unknown_link_lsa_type is None):
                                            self.unknown_link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                            self.unknown_link_lsa_type.parent = self
                                            self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                        return self.unknown_link_lsa_type

                                    if (child_yang_name == "unknown-lsa-type"):
                                        if (self.unknown_lsa_type is None):
                                            self.unknown_lsa_type = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType()
                                            self.unknown_lsa_type.parent = self
                                            self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                        return self.unknown_lsa_type

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "external-lsa-type" or name == "grace-lsa" or name == "inter-area-prefix-lsa-type" or name == "inter-area-router-lsa-type" or name == "intra-area-prefix-lsa-type" or name == "link-lsa-type" or name == "lsa-summary-info" or name == "network-lsa-type" or name == "nssalsa-type" or name == "router-lsa-type" or name == "unknown-area-lsa-type" or name == "unknown-aslsa-type" or name == "unknown-link-lsa-type" or name == "unknown-lsa-type" or name == "lsa-info-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "lsa-info-type"):
                                        self.lsa_info_type = value
                                        self.lsa_info_type.value_namespace = name_space
                                        self.lsa_info_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.advertising_router.is_set or
                                    self.area_id.is_set or
                                    self.interface_name.is_set or
                                    self.ls_id.is_set or
                                    self.ls_type.is_set or
                                    (self.lsa_info is not None and self.lsa_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.advertising_router.yfilter != YFilter.not_set or
                                    self.area_id.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.ls_id.yfilter != YFilter.not_set or
                                    self.ls_type.yfilter != YFilter.not_set or
                                    (self.lsa_info is not None and self.lsa_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsa" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_id.get_name_leafdata())
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_id.get_name_leafdata())
                                if (self.ls_type.is_set or self.ls_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "lsa-info"):
                                    if (self.lsa_info is None):
                                        self.lsa_info = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa.LsaInfo()
                                        self.lsa_info.parent = self
                                        self._children_name_map["lsa_info"] = "lsa-info"
                                    return self.lsa_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsa-info" or name == "advertising-router" or name == "area-id" or name == "interface-name" or name == "ls-id" or name == "ls-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "advertising-router"):
                                    self.advertising_router = value
                                    self.advertising_router.value_namespace = name_space
                                    self.advertising_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-id"):
                                    self.area_id = value
                                    self.area_id.value_namespace = name_space
                                    self.area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-id"):
                                    self.ls_id = value
                                    self.ls_id.value_namespace = name_space
                                    self.ls_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-type"):
                                    self.ls_type = value
                                    self.ls_type.value_namespace = name_space
                                    self.ls_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.lsa:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.lsa:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsa-internal-table" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "lsa"):
                                for c in self.lsa:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable.Lsa()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.lsa.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsa"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            (self.lsa_internal_table is not None and self.lsa_internal_table.has_data()) or
                            (self.lsa_table is not None and self.lsa_table.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.lsa_internal_table is not None and self.lsa_internal_table.has_operation()) or
                            (self.lsa_table is not None and self.lsa_table.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "database-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsa-internal-table"):
                            if (self.lsa_internal_table is None):
                                self.lsa_internal_table = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaInternalTable()
                                self.lsa_internal_table.parent = self
                                self._children_name_map["lsa_internal_table"] = "lsa-internal-table"
                            return self.lsa_internal_table

                        if (child_yang_name == "lsa-table"):
                            if (self.lsa_table is None):
                                self.lsa_table = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable.LsaTable()
                                self.lsa_table.parent = self
                                self._children_name_map["lsa_table"] = "lsa-table"
                            return self.lsa_table

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsa-internal-table" or name == "lsa-table"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class InterfaceProcessTable(Entity):
                    """
                    OSPFv3 interface information table for all areas
                    
                    .. attribute:: interface
                    
                    	OSPFv3 interface information
                    	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable, self).__init__()

                        self.yang_name = "interface-process-table"
                        self.yang_parent_name = "default-vrf"

                        self.interface = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable, self).__setattr__(name, value)


                    class Interface(Entity):
                        """
                        OSPFv3 interface information
                        
                        .. attribute:: interface_name  <key>
                        
                        	Interface name
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: active_interface
                        
                        	Active interface details 
                        	**type**\:   :py:class:`ActiveInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.ActiveInterface>`
                        
                        .. attribute:: adjacent_neighbor
                        
                        	Number of adjacent neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: backup_designated_router_address
                        
                        	Backup designated router interface address
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: backup_designated_router_id
                        
                        	Backup designated router ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: configured_ldp_sync
                        
                        	If true, configured as LDP sync
                        	**type**\:  bool
                        
                        .. attribute:: dead_interval
                        
                        	Configured dead interval (s) 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: designated_router_address
                        
                        	Designated router interface address
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: designated_router_id
                        
                        	Designated router ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: hello_interval
                        
                        	Configured hello interval (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: interface_address
                        
                        	Interface IPv6 address
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: interface_authentication_spi
                        
                        	Interface authentication spi 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: interface_authentication_transmit
                        
                        	Interface authentication transmit 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: interface_bfd
                        
                        	BFD information 
                        	**type**\:   :py:class:`InterfaceBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceBfd>`
                        
                        .. attribute:: interface_dc_bitless_ls_as
                        
                        	Number of LSAs with demand circuit bit not set for the area in which the interface is running
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: interface_encrypted_authentication_transmitted
                        
                        	Interface encrypted authentication transmitted 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: interface_encryption_spi
                        
                        	Interface encryption spi
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: interface_encryption_transmitted
                        
                        	Interface encryption transmitted 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: interface_ldp_sync
                        
                        	If true, interface LDP sync is achieved
                        	**type**\:  bool
                        
                        .. attribute:: interface_link_cost
                        
                        	Interface link cost
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: interface_neighbor
                        
                        	Information for neighbors on the interface
                        	**type**\: list of    :py:class:`InterfaceNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceNeighbor>`
                        
                        .. attribute:: interface_number
                        
                        	Interface number 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: interface_priority
                        
                        	Interface priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: interface_references
                        
                        	Interface reference count 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: interface_retransmission_interval
                        
                        	Configured retransmit interval (s) 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: interface_router_id
                        
                        	Interface router ID 
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: interface_state
                        
                        	Interface state
                        	**type**\:   :py:class:`ImStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.ImStateEnum>`
                        
                        .. attribute:: is_demand_circuit_configured
                        
                        	If true, configured as demand circuit 
                        	**type**\:  bool
                        
                        .. attribute:: is_designated_router
                        
                        	If true, designated router
                        	**type**\:  bool
                        
                        .. attribute:: is_interface_demand_circuit
                        
                        	If true, interface running as demand circuit
                        	**type**\:  bool
                        
                        .. attribute:: is_interface_encryption_enabled
                        
                        	If true, interface encryption is enabled 
                        	**type**\:  bool
                        
                        .. attribute:: is_interface_flood_reduction
                        
                        	If true, interface flood reduction is active 
                        	**type**\:  bool
                        
                        .. attribute:: is_interface_ip_security_active
                        
                        	If true, interface IP security is active 
                        	**type**\:  bool
                        
                        .. attribute:: is_interface_ip_security_required
                        
                        	If true, interface IP security is required 
                        	**type**\:  bool
                        
                        .. attribute:: is_interface_line_up
                        
                        	If true, line protocol is up 
                        	**type**\:  bool
                        
                        .. attribute:: is_interface_lsa_filtered
                        
                        	Filter is configured for out going LSAs 
                        	**type**\:  bool
                        
                        .. attribute:: is_prefix_suppress
                        
                        	If true prefix suppression is enabled
                        	**type**\:  bool
                        
                        .. attribute:: network_lsa_flush_timer
                        
                        	The amount of time in seconds before flush timer for old network LSA expires 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: network_type
                        
                        	Network type
                        	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                        
                        .. attribute:: next_hello_time
                        
                        	Time until next Hello (s) 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: ospf_interface_state
                        
                        	Interface state
                        	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                        
                        .. attribute:: transmission_delay
                        
                        	Interface transmission delay (sec)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: wait_interval
                        
                        	Configured wait interval (s) 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface, self).__init__()

                            self.yang_name = "interface"
                            self.yang_parent_name = "interface-process-table"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.adjacent_neighbor = YLeaf(YType.uint32, "adjacent-neighbor")

                            self.backup_designated_router_address = YLeaf(YType.str, "backup-designated-router-address")

                            self.backup_designated_router_id = YLeaf(YType.str, "backup-designated-router-id")

                            self.configured_ldp_sync = YLeaf(YType.boolean, "configured-ldp-sync")

                            self.dead_interval = YLeaf(YType.uint32, "dead-interval")

                            self.designated_router_address = YLeaf(YType.str, "designated-router-address")

                            self.designated_router_id = YLeaf(YType.str, "designated-router-id")

                            self.hello_interval = YLeaf(YType.uint32, "hello-interval")

                            self.interface_address = YLeaf(YType.str, "interface-address")

                            self.interface_authentication_spi = YLeaf(YType.uint32, "interface-authentication-spi")

                            self.interface_authentication_transmit = YLeaf(YType.uint32, "interface-authentication-transmit")

                            self.interface_dc_bitless_ls_as = YLeaf(YType.uint32, "interface-dc-bitless-ls-as")

                            self.interface_encrypted_authentication_transmitted = YLeaf(YType.uint32, "interface-encrypted-authentication-transmitted")

                            self.interface_encryption_spi = YLeaf(YType.uint32, "interface-encryption-spi")

                            self.interface_encryption_transmitted = YLeaf(YType.uint32, "interface-encryption-transmitted")

                            self.interface_ldp_sync = YLeaf(YType.boolean, "interface-ldp-sync")

                            self.interface_link_cost = YLeaf(YType.uint16, "interface-link-cost")

                            self.interface_number = YLeaf(YType.uint32, "interface-number")

                            self.interface_priority = YLeaf(YType.uint8, "interface-priority")

                            self.interface_references = YLeaf(YType.uint32, "interface-references")

                            self.interface_retransmission_interval = YLeaf(YType.uint32, "interface-retransmission-interval")

                            self.interface_router_id = YLeaf(YType.str, "interface-router-id")

                            self.interface_state = YLeaf(YType.enumeration, "interface-state")

                            self.is_demand_circuit_configured = YLeaf(YType.boolean, "is-demand-circuit-configured")

                            self.is_designated_router = YLeaf(YType.boolean, "is-designated-router")

                            self.is_interface_demand_circuit = YLeaf(YType.boolean, "is-interface-demand-circuit")

                            self.is_interface_encryption_enabled = YLeaf(YType.boolean, "is-interface-encryption-enabled")

                            self.is_interface_flood_reduction = YLeaf(YType.boolean, "is-interface-flood-reduction")

                            self.is_interface_ip_security_active = YLeaf(YType.boolean, "is-interface-ip-security-active")

                            self.is_interface_ip_security_required = YLeaf(YType.boolean, "is-interface-ip-security-required")

                            self.is_interface_line_up = YLeaf(YType.boolean, "is-interface-line-up")

                            self.is_interface_lsa_filtered = YLeaf(YType.boolean, "is-interface-lsa-filtered")

                            self.is_prefix_suppress = YLeaf(YType.boolean, "is-prefix-suppress")

                            self.network_lsa_flush_timer = YLeaf(YType.uint32, "network-lsa-flush-timer")

                            self.network_type = YLeaf(YType.enumeration, "network-type")

                            self.next_hello_time = YLeaf(YType.uint32, "next-hello-time")

                            self.ospf_interface_state = YLeaf(YType.enumeration, "ospf-interface-state")

                            self.transmission_delay = YLeaf(YType.uint16, "transmission-delay")

                            self.wait_interval = YLeaf(YType.uint32, "wait-interval")

                            self.active_interface = Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.ActiveInterface()
                            self.active_interface.parent = self
                            self._children_name_map["active_interface"] = "active-interface"
                            self._children_yang_names.add("active-interface")

                            self.interface_bfd = Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceBfd()
                            self.interface_bfd.parent = self
                            self._children_name_map["interface_bfd"] = "interface-bfd"
                            self._children_yang_names.add("interface-bfd")

                            self.interface_neighbor = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "adjacent_neighbor",
                                            "backup_designated_router_address",
                                            "backup_designated_router_id",
                                            "configured_ldp_sync",
                                            "dead_interval",
                                            "designated_router_address",
                                            "designated_router_id",
                                            "hello_interval",
                                            "interface_address",
                                            "interface_authentication_spi",
                                            "interface_authentication_transmit",
                                            "interface_dc_bitless_ls_as",
                                            "interface_encrypted_authentication_transmitted",
                                            "interface_encryption_spi",
                                            "interface_encryption_transmitted",
                                            "interface_ldp_sync",
                                            "interface_link_cost",
                                            "interface_number",
                                            "interface_priority",
                                            "interface_references",
                                            "interface_retransmission_interval",
                                            "interface_router_id",
                                            "interface_state",
                                            "is_demand_circuit_configured",
                                            "is_designated_router",
                                            "is_interface_demand_circuit",
                                            "is_interface_encryption_enabled",
                                            "is_interface_flood_reduction",
                                            "is_interface_ip_security_active",
                                            "is_interface_ip_security_required",
                                            "is_interface_line_up",
                                            "is_interface_lsa_filtered",
                                            "is_prefix_suppress",
                                            "network_lsa_flush_timer",
                                            "network_type",
                                            "next_hello_time",
                                            "ospf_interface_state",
                                            "transmission_delay",
                                            "wait_interval") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface, self).__setattr__(name, value)


                        class ActiveInterface(Entity):
                            """
                            Active interface details 
                            
                            .. attribute:: flood_queue_length
                            
                            	Flood queue length
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flood_scan_length
                            
                            	Last flood scan length 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_area_flood_index
                            
                            	Area scope LSAs flood index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_area_next_flood
                            
                            	Next LSA to flood (Area scope)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_area_next_flood_index
                            
                            	Index of next LSA to flood (Area scope) 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_as_flood_index
                            
                            	AS scope LSAs flood index 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_as_next_flood
                            
                            	Next LSA to flood (AS scope)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_as_next_flood_index
                            
                            	Index of next LSA to flood (AS scope)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_flood_pacing_timer
                            
                            	Time until next flood pacing timer (ms) 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_link_flood_index
                            
                            	Interface flood link index 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_link_next_flood
                            
                            	Interface link next flood information 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_link_next_index
                            
                            	Interface link next information index 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_neighbors
                            
                            	Total number of neighbors 
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: last_flood_time
                            
                            	Last flood scan time (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: maximum_flood_length
                            
                            	Maximum flood length 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: maximum_flood_time
                            
                            	Maximum flood time (ms) 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: suppressed_hellos
                            
                            	Number of neighbors for which hellos are suppressed 
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: wait_time
                            
                            	Wait time for DR/BDR selection (s)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.ActiveInterface, self).__init__()

                                self.yang_name = "active-interface"
                                self.yang_parent_name = "interface"

                                self.flood_queue_length = YLeaf(YType.uint32, "flood-queue-length")

                                self.flood_scan_length = YLeaf(YType.uint32, "flood-scan-length")

                                self.interface_area_flood_index = YLeaf(YType.uint32, "interface-area-flood-index")

                                self.interface_area_next_flood = YLeaf(YType.uint32, "interface-area-next-flood")

                                self.interface_area_next_flood_index = YLeaf(YType.uint32, "interface-area-next-flood-index")

                                self.interface_as_flood_index = YLeaf(YType.uint32, "interface-as-flood-index")

                                self.interface_as_next_flood = YLeaf(YType.uint32, "interface-as-next-flood")

                                self.interface_as_next_flood_index = YLeaf(YType.uint32, "interface-as-next-flood-index")

                                self.interface_flood_pacing_timer = YLeaf(YType.uint32, "interface-flood-pacing-timer")

                                self.interface_link_flood_index = YLeaf(YType.uint32, "interface-link-flood-index")

                                self.interface_link_next_flood = YLeaf(YType.uint32, "interface-link-next-flood")

                                self.interface_link_next_index = YLeaf(YType.uint32, "interface-link-next-index")

                                self.interface_neighbors = YLeaf(YType.uint16, "interface-neighbors")

                                self.last_flood_time = YLeaf(YType.uint32, "last-flood-time")

                                self.maximum_flood_length = YLeaf(YType.uint32, "maximum-flood-length")

                                self.maximum_flood_time = YLeaf(YType.uint32, "maximum-flood-time")

                                self.suppressed_hellos = YLeaf(YType.uint16, "suppressed-hellos")

                                self.wait_time = YLeaf(YType.uint32, "wait-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("flood_queue_length",
                                                "flood_scan_length",
                                                "interface_area_flood_index",
                                                "interface_area_next_flood",
                                                "interface_area_next_flood_index",
                                                "interface_as_flood_index",
                                                "interface_as_next_flood",
                                                "interface_as_next_flood_index",
                                                "interface_flood_pacing_timer",
                                                "interface_link_flood_index",
                                                "interface_link_next_flood",
                                                "interface_link_next_index",
                                                "interface_neighbors",
                                                "last_flood_time",
                                                "maximum_flood_length",
                                                "maximum_flood_time",
                                                "suppressed_hellos",
                                                "wait_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.ActiveInterface, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.ActiveInterface, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.flood_queue_length.is_set or
                                    self.flood_scan_length.is_set or
                                    self.interface_area_flood_index.is_set or
                                    self.interface_area_next_flood.is_set or
                                    self.interface_area_next_flood_index.is_set or
                                    self.interface_as_flood_index.is_set or
                                    self.interface_as_next_flood.is_set or
                                    self.interface_as_next_flood_index.is_set or
                                    self.interface_flood_pacing_timer.is_set or
                                    self.interface_link_flood_index.is_set or
                                    self.interface_link_next_flood.is_set or
                                    self.interface_link_next_index.is_set or
                                    self.interface_neighbors.is_set or
                                    self.last_flood_time.is_set or
                                    self.maximum_flood_length.is_set or
                                    self.maximum_flood_time.is_set or
                                    self.suppressed_hellos.is_set or
                                    self.wait_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.flood_queue_length.yfilter != YFilter.not_set or
                                    self.flood_scan_length.yfilter != YFilter.not_set or
                                    self.interface_area_flood_index.yfilter != YFilter.not_set or
                                    self.interface_area_next_flood.yfilter != YFilter.not_set or
                                    self.interface_area_next_flood_index.yfilter != YFilter.not_set or
                                    self.interface_as_flood_index.yfilter != YFilter.not_set or
                                    self.interface_as_next_flood.yfilter != YFilter.not_set or
                                    self.interface_as_next_flood_index.yfilter != YFilter.not_set or
                                    self.interface_flood_pacing_timer.yfilter != YFilter.not_set or
                                    self.interface_link_flood_index.yfilter != YFilter.not_set or
                                    self.interface_link_next_flood.yfilter != YFilter.not_set or
                                    self.interface_link_next_index.yfilter != YFilter.not_set or
                                    self.interface_neighbors.yfilter != YFilter.not_set or
                                    self.last_flood_time.yfilter != YFilter.not_set or
                                    self.maximum_flood_length.yfilter != YFilter.not_set or
                                    self.maximum_flood_time.yfilter != YFilter.not_set or
                                    self.suppressed_hellos.yfilter != YFilter.not_set or
                                    self.wait_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-interface" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.flood_queue_length.is_set or self.flood_queue_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.flood_queue_length.get_name_leafdata())
                                if (self.flood_scan_length.is_set or self.flood_scan_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.flood_scan_length.get_name_leafdata())
                                if (self.interface_area_flood_index.is_set or self.interface_area_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_area_flood_index.get_name_leafdata())
                                if (self.interface_area_next_flood.is_set or self.interface_area_next_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_area_next_flood.get_name_leafdata())
                                if (self.interface_area_next_flood_index.is_set or self.interface_area_next_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_area_next_flood_index.get_name_leafdata())
                                if (self.interface_as_flood_index.is_set or self.interface_as_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_as_flood_index.get_name_leafdata())
                                if (self.interface_as_next_flood.is_set or self.interface_as_next_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_as_next_flood.get_name_leafdata())
                                if (self.interface_as_next_flood_index.is_set or self.interface_as_next_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_as_next_flood_index.get_name_leafdata())
                                if (self.interface_flood_pacing_timer.is_set or self.interface_flood_pacing_timer.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_flood_pacing_timer.get_name_leafdata())
                                if (self.interface_link_flood_index.is_set or self.interface_link_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_link_flood_index.get_name_leafdata())
                                if (self.interface_link_next_flood.is_set or self.interface_link_next_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_link_next_flood.get_name_leafdata())
                                if (self.interface_link_next_index.is_set or self.interface_link_next_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_link_next_index.get_name_leafdata())
                                if (self.interface_neighbors.is_set or self.interface_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_neighbors.get_name_leafdata())
                                if (self.last_flood_time.is_set or self.last_flood_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.last_flood_time.get_name_leafdata())
                                if (self.maximum_flood_length.is_set or self.maximum_flood_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_flood_length.get_name_leafdata())
                                if (self.maximum_flood_time.is_set or self.maximum_flood_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_flood_time.get_name_leafdata())
                                if (self.suppressed_hellos.is_set or self.suppressed_hellos.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.suppressed_hellos.get_name_leafdata())
                                if (self.wait_time.is_set or self.wait_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.wait_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flood-queue-length" or name == "flood-scan-length" or name == "interface-area-flood-index" or name == "interface-area-next-flood" or name == "interface-area-next-flood-index" or name == "interface-as-flood-index" or name == "interface-as-next-flood" or name == "interface-as-next-flood-index" or name == "interface-flood-pacing-timer" or name == "interface-link-flood-index" or name == "interface-link-next-flood" or name == "interface-link-next-index" or name == "interface-neighbors" or name == "last-flood-time" or name == "maximum-flood-length" or name == "maximum-flood-time" or name == "suppressed-hellos" or name == "wait-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "flood-queue-length"):
                                    self.flood_queue_length = value
                                    self.flood_queue_length.value_namespace = name_space
                                    self.flood_queue_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "flood-scan-length"):
                                    self.flood_scan_length = value
                                    self.flood_scan_length.value_namespace = name_space
                                    self.flood_scan_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-area-flood-index"):
                                    self.interface_area_flood_index = value
                                    self.interface_area_flood_index.value_namespace = name_space
                                    self.interface_area_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-area-next-flood"):
                                    self.interface_area_next_flood = value
                                    self.interface_area_next_flood.value_namespace = name_space
                                    self.interface_area_next_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-area-next-flood-index"):
                                    self.interface_area_next_flood_index = value
                                    self.interface_area_next_flood_index.value_namespace = name_space
                                    self.interface_area_next_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-as-flood-index"):
                                    self.interface_as_flood_index = value
                                    self.interface_as_flood_index.value_namespace = name_space
                                    self.interface_as_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-as-next-flood"):
                                    self.interface_as_next_flood = value
                                    self.interface_as_next_flood.value_namespace = name_space
                                    self.interface_as_next_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-as-next-flood-index"):
                                    self.interface_as_next_flood_index = value
                                    self.interface_as_next_flood_index.value_namespace = name_space
                                    self.interface_as_next_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-flood-pacing-timer"):
                                    self.interface_flood_pacing_timer = value
                                    self.interface_flood_pacing_timer.value_namespace = name_space
                                    self.interface_flood_pacing_timer.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-link-flood-index"):
                                    self.interface_link_flood_index = value
                                    self.interface_link_flood_index.value_namespace = name_space
                                    self.interface_link_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-link-next-flood"):
                                    self.interface_link_next_flood = value
                                    self.interface_link_next_flood.value_namespace = name_space
                                    self.interface_link_next_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-link-next-index"):
                                    self.interface_link_next_index = value
                                    self.interface_link_next_index.value_namespace = name_space
                                    self.interface_link_next_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-neighbors"):
                                    self.interface_neighbors = value
                                    self.interface_neighbors.value_namespace = name_space
                                    self.interface_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "last-flood-time"):
                                    self.last_flood_time = value
                                    self.last_flood_time.value_namespace = name_space
                                    self.last_flood_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-flood-length"):
                                    self.maximum_flood_length = value
                                    self.maximum_flood_length.value_namespace = name_space
                                    self.maximum_flood_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-flood-time"):
                                    self.maximum_flood_time = value
                                    self.maximum_flood_time.value_namespace = name_space
                                    self.maximum_flood_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "suppressed-hellos"):
                                    self.suppressed_hellos = value
                                    self.suppressed_hellos.value_namespace = name_space
                                    self.suppressed_hellos.value_namespace_prefix = name_space_prefix
                                if(value_path == "wait-time"):
                                    self.wait_time = value
                                    self.wait_time.value_namespace = name_space
                                    self.wait_time.value_namespace_prefix = name_space_prefix


                        class InterfaceBfd(Entity):
                            """
                            BFD information 
                            
                            .. attribute:: bfd_detection_multiplier
                            
                            	BFD detection multiplier 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_interval
                            
                            	BFD interval (ms) 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_intf_enable_mode
                            
                            	BFD Enable Mode on the interface \- Default/Strict
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceBfd, self).__init__()

                                self.yang_name = "interface-bfd"
                                self.yang_parent_name = "interface"

                                self.bfd_detection_multiplier = YLeaf(YType.uint32, "bfd-detection-multiplier")

                                self.bfd_interval = YLeaf(YType.uint32, "bfd-interval")

                                self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_detection_multiplier",
                                                "bfd_interval",
                                                "bfd_intf_enable_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceBfd, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceBfd, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.bfd_detection_multiplier.is_set or
                                    self.bfd_interval.is_set or
                                    self.bfd_intf_enable_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_detection_multiplier.yfilter != YFilter.not_set or
                                    self.bfd_interval.yfilter != YFilter.not_set or
                                    self.bfd_intf_enable_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interface-bfd" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_detection_multiplier.is_set or self.bfd_detection_multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_detection_multiplier.get_name_leafdata())
                                if (self.bfd_interval.is_set or self.bfd_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_interval.get_name_leafdata())
                                if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-detection-multiplier" or name == "bfd-interval" or name == "bfd-intf-enable-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-detection-multiplier"):
                                    self.bfd_detection_multiplier = value
                                    self.bfd_detection_multiplier.value_namespace = name_space
                                    self.bfd_detection_multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-interval"):
                                    self.bfd_interval = value
                                    self.bfd_interval.value_namespace = name_space
                                    self.bfd_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-intf-enable-mode"):
                                    self.bfd_intf_enable_mode = value
                                    self.bfd_intf_enable_mode.value_namespace = name_space
                                    self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix


                        class InterfaceNeighbor(Entity):
                            """
                            Information for neighbors on the interface
                            
                            .. attribute:: interface_neighbor_cost
                            
                            	Cost of link to neighbor
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: interface_neighbor_id
                            
                            	Neighbor router ID 
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_hello_suppressed
                            
                            	If true, hello is suppressed 
                            	**type**\:  bool
                            
                            .. attribute:: is_neighbor_bdr
                            
                            	If true, backup designated router is found 
                            	**type**\:  bool
                            
                            .. attribute:: is_neighbor_dr
                            
                            	If true, designated router is found 
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceNeighbor, self).__init__()

                                self.yang_name = "interface-neighbor"
                                self.yang_parent_name = "interface"

                                self.interface_neighbor_cost = YLeaf(YType.uint32, "interface-neighbor-cost")

                                self.interface_neighbor_id = YLeaf(YType.str, "interface-neighbor-id")

                                self.is_hello_suppressed = YLeaf(YType.boolean, "is-hello-suppressed")

                                self.is_neighbor_bdr = YLeaf(YType.boolean, "is-neighbor-bdr")

                                self.is_neighbor_dr = YLeaf(YType.boolean, "is-neighbor-dr")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_neighbor_cost",
                                                "interface_neighbor_id",
                                                "is_hello_suppressed",
                                                "is_neighbor_bdr",
                                                "is_neighbor_dr") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceNeighbor, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceNeighbor, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.interface_neighbor_cost.is_set or
                                    self.interface_neighbor_id.is_set or
                                    self.is_hello_suppressed.is_set or
                                    self.is_neighbor_bdr.is_set or
                                    self.is_neighbor_dr.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_neighbor_cost.yfilter != YFilter.not_set or
                                    self.interface_neighbor_id.yfilter != YFilter.not_set or
                                    self.is_hello_suppressed.yfilter != YFilter.not_set or
                                    self.is_neighbor_bdr.yfilter != YFilter.not_set or
                                    self.is_neighbor_dr.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interface-neighbor" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_neighbor_cost.is_set or self.interface_neighbor_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_neighbor_cost.get_name_leafdata())
                                if (self.interface_neighbor_id.is_set or self.interface_neighbor_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_neighbor_id.get_name_leafdata())
                                if (self.is_hello_suppressed.is_set or self.is_hello_suppressed.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_hello_suppressed.get_name_leafdata())
                                if (self.is_neighbor_bdr.is_set or self.is_neighbor_bdr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_bdr.get_name_leafdata())
                                if (self.is_neighbor_dr.is_set or self.is_neighbor_dr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_dr.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "interface-neighbor-cost" or name == "interface-neighbor-id" or name == "is-hello-suppressed" or name == "is-neighbor-bdr" or name == "is-neighbor-dr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-neighbor-cost"):
                                    self.interface_neighbor_cost = value
                                    self.interface_neighbor_cost.value_namespace = name_space
                                    self.interface_neighbor_cost.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-neighbor-id"):
                                    self.interface_neighbor_id = value
                                    self.interface_neighbor_id.value_namespace = name_space
                                    self.interface_neighbor_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-hello-suppressed"):
                                    self.is_hello_suppressed = value
                                    self.is_hello_suppressed.value_namespace = name_space
                                    self.is_hello_suppressed.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-bdr"):
                                    self.is_neighbor_bdr = value
                                    self.is_neighbor_bdr.value_namespace = name_space
                                    self.is_neighbor_bdr.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-dr"):
                                    self.is_neighbor_dr = value
                                    self.is_neighbor_dr.value_namespace = name_space
                                    self.is_neighbor_dr.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.interface_neighbor:
                                if (c.has_data()):
                                    return True
                            return (
                                self.interface_name.is_set or
                                self.adjacent_neighbor.is_set or
                                self.backup_designated_router_address.is_set or
                                self.backup_designated_router_id.is_set or
                                self.configured_ldp_sync.is_set or
                                self.dead_interval.is_set or
                                self.designated_router_address.is_set or
                                self.designated_router_id.is_set or
                                self.hello_interval.is_set or
                                self.interface_address.is_set or
                                self.interface_authentication_spi.is_set or
                                self.interface_authentication_transmit.is_set or
                                self.interface_dc_bitless_ls_as.is_set or
                                self.interface_encrypted_authentication_transmitted.is_set or
                                self.interface_encryption_spi.is_set or
                                self.interface_encryption_transmitted.is_set or
                                self.interface_ldp_sync.is_set or
                                self.interface_link_cost.is_set or
                                self.interface_number.is_set or
                                self.interface_priority.is_set or
                                self.interface_references.is_set or
                                self.interface_retransmission_interval.is_set or
                                self.interface_router_id.is_set or
                                self.interface_state.is_set or
                                self.is_demand_circuit_configured.is_set or
                                self.is_designated_router.is_set or
                                self.is_interface_demand_circuit.is_set or
                                self.is_interface_encryption_enabled.is_set or
                                self.is_interface_flood_reduction.is_set or
                                self.is_interface_ip_security_active.is_set or
                                self.is_interface_ip_security_required.is_set or
                                self.is_interface_line_up.is_set or
                                self.is_interface_lsa_filtered.is_set or
                                self.is_prefix_suppress.is_set or
                                self.network_lsa_flush_timer.is_set or
                                self.network_type.is_set or
                                self.next_hello_time.is_set or
                                self.ospf_interface_state.is_set or
                                self.transmission_delay.is_set or
                                self.wait_interval.is_set or
                                (self.active_interface is not None and self.active_interface.has_data()) or
                                (self.interface_bfd is not None and self.interface_bfd.has_data()))

                        def has_operation(self):
                            for c in self.interface_neighbor:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.adjacent_neighbor.yfilter != YFilter.not_set or
                                self.backup_designated_router_address.yfilter != YFilter.not_set or
                                self.backup_designated_router_id.yfilter != YFilter.not_set or
                                self.configured_ldp_sync.yfilter != YFilter.not_set or
                                self.dead_interval.yfilter != YFilter.not_set or
                                self.designated_router_address.yfilter != YFilter.not_set or
                                self.designated_router_id.yfilter != YFilter.not_set or
                                self.hello_interval.yfilter != YFilter.not_set or
                                self.interface_address.yfilter != YFilter.not_set or
                                self.interface_authentication_spi.yfilter != YFilter.not_set or
                                self.interface_authentication_transmit.yfilter != YFilter.not_set or
                                self.interface_dc_bitless_ls_as.yfilter != YFilter.not_set or
                                self.interface_encrypted_authentication_transmitted.yfilter != YFilter.not_set or
                                self.interface_encryption_spi.yfilter != YFilter.not_set or
                                self.interface_encryption_transmitted.yfilter != YFilter.not_set or
                                self.interface_ldp_sync.yfilter != YFilter.not_set or
                                self.interface_link_cost.yfilter != YFilter.not_set or
                                self.interface_number.yfilter != YFilter.not_set or
                                self.interface_priority.yfilter != YFilter.not_set or
                                self.interface_references.yfilter != YFilter.not_set or
                                self.interface_retransmission_interval.yfilter != YFilter.not_set or
                                self.interface_router_id.yfilter != YFilter.not_set or
                                self.interface_state.yfilter != YFilter.not_set or
                                self.is_demand_circuit_configured.yfilter != YFilter.not_set or
                                self.is_designated_router.yfilter != YFilter.not_set or
                                self.is_interface_demand_circuit.yfilter != YFilter.not_set or
                                self.is_interface_encryption_enabled.yfilter != YFilter.not_set or
                                self.is_interface_flood_reduction.yfilter != YFilter.not_set or
                                self.is_interface_ip_security_active.yfilter != YFilter.not_set or
                                self.is_interface_ip_security_required.yfilter != YFilter.not_set or
                                self.is_interface_line_up.yfilter != YFilter.not_set or
                                self.is_interface_lsa_filtered.yfilter != YFilter.not_set or
                                self.is_prefix_suppress.yfilter != YFilter.not_set or
                                self.network_lsa_flush_timer.yfilter != YFilter.not_set or
                                self.network_type.yfilter != YFilter.not_set or
                                self.next_hello_time.yfilter != YFilter.not_set or
                                self.ospf_interface_state.yfilter != YFilter.not_set or
                                self.transmission_delay.yfilter != YFilter.not_set or
                                self.wait_interval.yfilter != YFilter.not_set or
                                (self.active_interface is not None and self.active_interface.has_operation()) or
                                (self.interface_bfd is not None and self.interface_bfd.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.adjacent_neighbor.is_set or self.adjacent_neighbor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjacent_neighbor.get_name_leafdata())
                            if (self.backup_designated_router_address.is_set or self.backup_designated_router_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_designated_router_address.get_name_leafdata())
                            if (self.backup_designated_router_id.is_set or self.backup_designated_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_designated_router_id.get_name_leafdata())
                            if (self.configured_ldp_sync.is_set or self.configured_ldp_sync.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.configured_ldp_sync.get_name_leafdata())
                            if (self.dead_interval.is_set or self.dead_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dead_interval.get_name_leafdata())
                            if (self.designated_router_address.is_set or self.designated_router_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.designated_router_address.get_name_leafdata())
                            if (self.designated_router_id.is_set or self.designated_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.designated_router_id.get_name_leafdata())
                            if (self.hello_interval.is_set or self.hello_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hello_interval.get_name_leafdata())
                            if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_address.get_name_leafdata())
                            if (self.interface_authentication_spi.is_set or self.interface_authentication_spi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_authentication_spi.get_name_leafdata())
                            if (self.interface_authentication_transmit.is_set or self.interface_authentication_transmit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_authentication_transmit.get_name_leafdata())
                            if (self.interface_dc_bitless_ls_as.is_set or self.interface_dc_bitless_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_dc_bitless_ls_as.get_name_leafdata())
                            if (self.interface_encrypted_authentication_transmitted.is_set or self.interface_encrypted_authentication_transmitted.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_encrypted_authentication_transmitted.get_name_leafdata())
                            if (self.interface_encryption_spi.is_set or self.interface_encryption_spi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_encryption_spi.get_name_leafdata())
                            if (self.interface_encryption_transmitted.is_set or self.interface_encryption_transmitted.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_encryption_transmitted.get_name_leafdata())
                            if (self.interface_ldp_sync.is_set or self.interface_ldp_sync.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_ldp_sync.get_name_leafdata())
                            if (self.interface_link_cost.is_set or self.interface_link_cost.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_link_cost.get_name_leafdata())
                            if (self.interface_number.is_set or self.interface_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_number.get_name_leafdata())
                            if (self.interface_priority.is_set or self.interface_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_priority.get_name_leafdata())
                            if (self.interface_references.is_set or self.interface_references.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_references.get_name_leafdata())
                            if (self.interface_retransmission_interval.is_set or self.interface_retransmission_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_retransmission_interval.get_name_leafdata())
                            if (self.interface_router_id.is_set or self.interface_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_router_id.get_name_leafdata())
                            if (self.interface_state.is_set or self.interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_state.get_name_leafdata())
                            if (self.is_demand_circuit_configured.is_set or self.is_demand_circuit_configured.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_demand_circuit_configured.get_name_leafdata())
                            if (self.is_designated_router.is_set or self.is_designated_router.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_designated_router.get_name_leafdata())
                            if (self.is_interface_demand_circuit.is_set or self.is_interface_demand_circuit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_interface_demand_circuit.get_name_leafdata())
                            if (self.is_interface_encryption_enabled.is_set or self.is_interface_encryption_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_interface_encryption_enabled.get_name_leafdata())
                            if (self.is_interface_flood_reduction.is_set or self.is_interface_flood_reduction.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_interface_flood_reduction.get_name_leafdata())
                            if (self.is_interface_ip_security_active.is_set or self.is_interface_ip_security_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_interface_ip_security_active.get_name_leafdata())
                            if (self.is_interface_ip_security_required.is_set or self.is_interface_ip_security_required.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_interface_ip_security_required.get_name_leafdata())
                            if (self.is_interface_line_up.is_set or self.is_interface_line_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_interface_line_up.get_name_leafdata())
                            if (self.is_interface_lsa_filtered.is_set or self.is_interface_lsa_filtered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_interface_lsa_filtered.get_name_leafdata())
                            if (self.is_prefix_suppress.is_set or self.is_prefix_suppress.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_prefix_suppress.get_name_leafdata())
                            if (self.network_lsa_flush_timer.is_set or self.network_lsa_flush_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.network_lsa_flush_timer.get_name_leafdata())
                            if (self.network_type.is_set or self.network_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.network_type.get_name_leafdata())
                            if (self.next_hello_time.is_set or self.next_hello_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hello_time.get_name_leafdata())
                            if (self.ospf_interface_state.is_set or self.ospf_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ospf_interface_state.get_name_leafdata())
                            if (self.transmission_delay.is_set or self.transmission_delay.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.transmission_delay.get_name_leafdata())
                            if (self.wait_interval.is_set or self.wait_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.wait_interval.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-interface"):
                                if (self.active_interface is None):
                                    self.active_interface = Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.ActiveInterface()
                                    self.active_interface.parent = self
                                    self._children_name_map["active_interface"] = "active-interface"
                                return self.active_interface

                            if (child_yang_name == "interface-bfd"):
                                if (self.interface_bfd is None):
                                    self.interface_bfd = Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceBfd()
                                    self.interface_bfd.parent = self
                                    self._children_name_map["interface_bfd"] = "interface-bfd"
                                return self.interface_bfd

                            if (child_yang_name == "interface-neighbor"):
                                for c in self.interface_neighbor:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface.InterfaceNeighbor()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.interface_neighbor.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-interface" or name == "interface-bfd" or name == "interface-neighbor" or name == "interface-name" or name == "adjacent-neighbor" or name == "backup-designated-router-address" or name == "backup-designated-router-id" or name == "configured-ldp-sync" or name == "dead-interval" or name == "designated-router-address" or name == "designated-router-id" or name == "hello-interval" or name == "interface-address" or name == "interface-authentication-spi" or name == "interface-authentication-transmit" or name == "interface-dc-bitless-ls-as" or name == "interface-encrypted-authentication-transmitted" or name == "interface-encryption-spi" or name == "interface-encryption-transmitted" or name == "interface-ldp-sync" or name == "interface-link-cost" or name == "interface-number" or name == "interface-priority" or name == "interface-references" or name == "interface-retransmission-interval" or name == "interface-router-id" or name == "interface-state" or name == "is-demand-circuit-configured" or name == "is-designated-router" or name == "is-interface-demand-circuit" or name == "is-interface-encryption-enabled" or name == "is-interface-flood-reduction" or name == "is-interface-ip-security-active" or name == "is-interface-ip-security-required" or name == "is-interface-line-up" or name == "is-interface-lsa-filtered" or name == "is-prefix-suppress" or name == "network-lsa-flush-timer" or name == "network-type" or name == "next-hello-time" or name == "ospf-interface-state" or name == "transmission-delay" or name == "wait-interval"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "adjacent-neighbor"):
                                self.adjacent_neighbor = value
                                self.adjacent_neighbor.value_namespace = name_space
                                self.adjacent_neighbor.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-designated-router-address"):
                                self.backup_designated_router_address = value
                                self.backup_designated_router_address.value_namespace = name_space
                                self.backup_designated_router_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-designated-router-id"):
                                self.backup_designated_router_id = value
                                self.backup_designated_router_id.value_namespace = name_space
                                self.backup_designated_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "configured-ldp-sync"):
                                self.configured_ldp_sync = value
                                self.configured_ldp_sync.value_namespace = name_space
                                self.configured_ldp_sync.value_namespace_prefix = name_space_prefix
                            if(value_path == "dead-interval"):
                                self.dead_interval = value
                                self.dead_interval.value_namespace = name_space
                                self.dead_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "designated-router-address"):
                                self.designated_router_address = value
                                self.designated_router_address.value_namespace = name_space
                                self.designated_router_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "designated-router-id"):
                                self.designated_router_id = value
                                self.designated_router_id.value_namespace = name_space
                                self.designated_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "hello-interval"):
                                self.hello_interval = value
                                self.hello_interval.value_namespace = name_space
                                self.hello_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-address"):
                                self.interface_address = value
                                self.interface_address.value_namespace = name_space
                                self.interface_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-authentication-spi"):
                                self.interface_authentication_spi = value
                                self.interface_authentication_spi.value_namespace = name_space
                                self.interface_authentication_spi.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-authentication-transmit"):
                                self.interface_authentication_transmit = value
                                self.interface_authentication_transmit.value_namespace = name_space
                                self.interface_authentication_transmit.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-dc-bitless-ls-as"):
                                self.interface_dc_bitless_ls_as = value
                                self.interface_dc_bitless_ls_as.value_namespace = name_space
                                self.interface_dc_bitless_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-encrypted-authentication-transmitted"):
                                self.interface_encrypted_authentication_transmitted = value
                                self.interface_encrypted_authentication_transmitted.value_namespace = name_space
                                self.interface_encrypted_authentication_transmitted.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-encryption-spi"):
                                self.interface_encryption_spi = value
                                self.interface_encryption_spi.value_namespace = name_space
                                self.interface_encryption_spi.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-encryption-transmitted"):
                                self.interface_encryption_transmitted = value
                                self.interface_encryption_transmitted.value_namespace = name_space
                                self.interface_encryption_transmitted.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-ldp-sync"):
                                self.interface_ldp_sync = value
                                self.interface_ldp_sync.value_namespace = name_space
                                self.interface_ldp_sync.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-link-cost"):
                                self.interface_link_cost = value
                                self.interface_link_cost.value_namespace = name_space
                                self.interface_link_cost.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-number"):
                                self.interface_number = value
                                self.interface_number.value_namespace = name_space
                                self.interface_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-priority"):
                                self.interface_priority = value
                                self.interface_priority.value_namespace = name_space
                                self.interface_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-references"):
                                self.interface_references = value
                                self.interface_references.value_namespace = name_space
                                self.interface_references.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-retransmission-interval"):
                                self.interface_retransmission_interval = value
                                self.interface_retransmission_interval.value_namespace = name_space
                                self.interface_retransmission_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-router-id"):
                                self.interface_router_id = value
                                self.interface_router_id.value_namespace = name_space
                                self.interface_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-state"):
                                self.interface_state = value
                                self.interface_state.value_namespace = name_space
                                self.interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-demand-circuit-configured"):
                                self.is_demand_circuit_configured = value
                                self.is_demand_circuit_configured.value_namespace = name_space
                                self.is_demand_circuit_configured.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-designated-router"):
                                self.is_designated_router = value
                                self.is_designated_router.value_namespace = name_space
                                self.is_designated_router.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-interface-demand-circuit"):
                                self.is_interface_demand_circuit = value
                                self.is_interface_demand_circuit.value_namespace = name_space
                                self.is_interface_demand_circuit.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-interface-encryption-enabled"):
                                self.is_interface_encryption_enabled = value
                                self.is_interface_encryption_enabled.value_namespace = name_space
                                self.is_interface_encryption_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-interface-flood-reduction"):
                                self.is_interface_flood_reduction = value
                                self.is_interface_flood_reduction.value_namespace = name_space
                                self.is_interface_flood_reduction.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-interface-ip-security-active"):
                                self.is_interface_ip_security_active = value
                                self.is_interface_ip_security_active.value_namespace = name_space
                                self.is_interface_ip_security_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-interface-ip-security-required"):
                                self.is_interface_ip_security_required = value
                                self.is_interface_ip_security_required.value_namespace = name_space
                                self.is_interface_ip_security_required.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-interface-line-up"):
                                self.is_interface_line_up = value
                                self.is_interface_line_up.value_namespace = name_space
                                self.is_interface_line_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-interface-lsa-filtered"):
                                self.is_interface_lsa_filtered = value
                                self.is_interface_lsa_filtered.value_namespace = name_space
                                self.is_interface_lsa_filtered.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-prefix-suppress"):
                                self.is_prefix_suppress = value
                                self.is_prefix_suppress.value_namespace = name_space
                                self.is_prefix_suppress.value_namespace_prefix = name_space_prefix
                            if(value_path == "network-lsa-flush-timer"):
                                self.network_lsa_flush_timer = value
                                self.network_lsa_flush_timer.value_namespace = name_space
                                self.network_lsa_flush_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "network-type"):
                                self.network_type = value
                                self.network_type.value_namespace = name_space
                                self.network_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hello-time"):
                                self.next_hello_time = value
                                self.next_hello_time.value_namespace = name_space
                                self.next_hello_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "ospf-interface-state"):
                                self.ospf_interface_state = value
                                self.ospf_interface_state.value_namespace = name_space
                                self.ospf_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "transmission-delay"):
                                self.transmission_delay = value
                                self.transmission_delay.value_namespace = name_space
                                self.transmission_delay.value_namespace_prefix = name_space_prefix
                            if(value_path == "wait-interval"):
                                self.wait_interval = value
                                self.wait_interval.value_namespace = name_space
                                self.wait_interval.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.interface:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.interface:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "interface-process-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "interface"):
                            for c in self.interface:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable.Interface()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.interface.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "interface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Redistributions(Entity):
                    """
                    Redistribution information table
                    
                    .. attribute:: redistribution
                    
                    	Redistribution information
                    	**type**\: list of    :py:class:`Redistribution <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Redistributions.Redistribution>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.Redistributions, self).__init__()

                        self.yang_name = "redistributions"
                        self.yang_parent_name = "default-vrf"

                        self.redistribution = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Redistributions, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.Redistributions, self).__setattr__(name, value)


                    class Redistribution(Entity):
                        """
                        Redistribution information
                        
                        .. attribute:: policy_name
                        
                        	Route policy name 
                        	**type**\:  str
                        
                        .. attribute:: process_id
                        
                        	Process ID 
                        	**type**\:  str
                        
                        	**length:** 0..40
                        
                        .. attribute:: process_name
                        
                        	Process name of a protocolbeing redistributed 
                        	**type**\:  str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        .. attribute:: protocol_name
                        
                        	Protocol name that is redistributed
                        	**type**\:  str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        .. attribute:: protocol_name_xr
                        
                        	Protocol name 
                        	**type**\:  str
                        
                        	**length:** 0..40
                        
                        .. attribute:: red_metric
                        
                        	red metric
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: red_metric_flag
                        
                        	red metric flag
                        	**type**\:  bool
                        
                        .. attribute:: red_metric_type
                        
                        	red metric type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: red_mtype_flag
                        
                        	red mtype flag
                        	**type**\:  bool
                        
                        .. attribute:: red_tag
                        
                        	red tag
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.Redistributions.Redistribution, self).__init__()

                            self.yang_name = "redistribution"
                            self.yang_parent_name = "redistributions"

                            self.policy_name = YLeaf(YType.str, "policy-name")

                            self.process_id = YLeaf(YType.str, "process-id")

                            self.process_name = YLeaf(YType.str, "process-name")

                            self.protocol_name = YLeaf(YType.str, "protocol-name")

                            self.protocol_name_xr = YLeaf(YType.str, "protocol-name-xr")

                            self.red_metric = YLeaf(YType.uint32, "red-metric")

                            self.red_metric_flag = YLeaf(YType.boolean, "red-metric-flag")

                            self.red_metric_type = YLeaf(YType.uint8, "red-metric-type")

                            self.red_mtype_flag = YLeaf(YType.boolean, "red-mtype-flag")

                            self.red_tag = YLeaf(YType.uint32, "red-tag")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("policy_name",
                                            "process_id",
                                            "process_name",
                                            "protocol_name",
                                            "protocol_name_xr",
                                            "red_metric",
                                            "red_metric_flag",
                                            "red_metric_type",
                                            "red_mtype_flag",
                                            "red_tag") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Redistributions.Redistribution, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.Redistributions.Redistribution, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.policy_name.is_set or
                                self.process_id.is_set or
                                self.process_name.is_set or
                                self.protocol_name.is_set or
                                self.protocol_name_xr.is_set or
                                self.red_metric.is_set or
                                self.red_metric_flag.is_set or
                                self.red_metric_type.is_set or
                                self.red_mtype_flag.is_set or
                                self.red_tag.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.policy_name.yfilter != YFilter.not_set or
                                self.process_id.yfilter != YFilter.not_set or
                                self.process_name.yfilter != YFilter.not_set or
                                self.protocol_name.yfilter != YFilter.not_set or
                                self.protocol_name_xr.yfilter != YFilter.not_set or
                                self.red_metric.yfilter != YFilter.not_set or
                                self.red_metric_flag.yfilter != YFilter.not_set or
                                self.red_metric_type.yfilter != YFilter.not_set or
                                self.red_mtype_flag.yfilter != YFilter.not_set or
                                self.red_tag.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "redistribution" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                            if (self.process_id.is_set or self.process_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.process_id.get_name_leafdata())
                            if (self.process_name.is_set or self.process_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.process_name.get_name_leafdata())
                            if (self.protocol_name.is_set or self.protocol_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_name.get_name_leafdata())
                            if (self.protocol_name_xr.is_set or self.protocol_name_xr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_name_xr.get_name_leafdata())
                            if (self.red_metric.is_set or self.red_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.red_metric.get_name_leafdata())
                            if (self.red_metric_flag.is_set or self.red_metric_flag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.red_metric_flag.get_name_leafdata())
                            if (self.red_metric_type.is_set or self.red_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.red_metric_type.get_name_leafdata())
                            if (self.red_mtype_flag.is_set or self.red_mtype_flag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.red_mtype_flag.get_name_leafdata())
                            if (self.red_tag.is_set or self.red_tag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.red_tag.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "policy-name" or name == "process-id" or name == "process-name" or name == "protocol-name" or name == "protocol-name-xr" or name == "red-metric" or name == "red-metric-flag" or name == "red-metric-type" or name == "red-mtype-flag" or name == "red-tag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "policy-name"):
                                self.policy_name = value
                                self.policy_name.value_namespace = name_space
                                self.policy_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "process-id"):
                                self.process_id = value
                                self.process_id.value_namespace = name_space
                                self.process_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "process-name"):
                                self.process_name = value
                                self.process_name.value_namespace = name_space
                                self.process_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-name"):
                                self.protocol_name = value
                                self.protocol_name.value_namespace = name_space
                                self.protocol_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-name-xr"):
                                self.protocol_name_xr = value
                                self.protocol_name_xr.value_namespace = name_space
                                self.protocol_name_xr.value_namespace_prefix = name_space_prefix
                            if(value_path == "red-metric"):
                                self.red_metric = value
                                self.red_metric.value_namespace = name_space
                                self.red_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "red-metric-flag"):
                                self.red_metric_flag = value
                                self.red_metric_flag.value_namespace = name_space
                                self.red_metric_flag.value_namespace_prefix = name_space_prefix
                            if(value_path == "red-metric-type"):
                                self.red_metric_type = value
                                self.red_metric_type.value_namespace = name_space
                                self.red_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "red-mtype-flag"):
                                self.red_mtype_flag = value
                                self.red_mtype_flag.value_namespace = name_space
                                self.red_mtype_flag.value_namespace_prefix = name_space_prefix
                            if(value_path == "red-tag"):
                                self.red_tag = value
                                self.red_tag.value_namespace = name_space
                                self.red_tag.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.redistribution:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.redistribution:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "redistributions" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "redistribution"):
                            for c in self.redistribution:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.Redistributions.Redistribution()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.redistribution.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "redistribution"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class ExternalRoutes(Entity):
                    """
                    OSPFv3 external route information table
                    
                    .. attribute:: external_route
                    
                    	OSPFv3 external route information
                    	**type**\: list of    :py:class:`ExternalRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes, self).__init__()

                        self.yang_name = "external-routes"
                        self.yang_parent_name = "default-vrf"

                        self.external_route = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes, self).__setattr__(name, value)


                    class ExternalRoute(Entity):
                        """
                        OSPFv3 external route information
                        
                        .. attribute:: prefix
                        
                        	Route prefix
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..128
                        
                        .. attribute:: route_extended_community
                        
                        	Extended communities in the route
                        	**type**\:   :py:class:`RouteExtendedCommunity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity>`
                        
                        .. attribute:: route_path
                        
                        	List of paths to this route
                        	**type**\: list of    :py:class:`RoutePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath>`
                        
                        .. attribute:: route_topology
                        
                        	Common Route topology information
                        	**type**\:   :py:class:`RouteTopology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteTopology>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute, self).__init__()

                            self.yang_name = "external-route"
                            self.yang_parent_name = "external-routes"

                            self.prefix = YLeaf(YType.str, "prefix")

                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            self.route_extended_community = Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity()
                            self.route_extended_community.parent = self
                            self._children_name_map["route_extended_community"] = "route-extended-community"
                            self._children_yang_names.add("route-extended-community")

                            self.route_topology = Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteTopology()
                            self.route_topology.parent = self
                            self._children_name_map["route_topology"] = "route-topology"
                            self._children_yang_names.add("route-topology")

                            self.route_path = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("prefix",
                                            "prefix_length") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute, self).__setattr__(name, value)


                        class RouteTopology(Entity):
                            """
                            Common Route topology information
                            
                            .. attribute:: route_cost
                            
                            	Route cost 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: route_distance
                            
                            	Route distance 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: route_id
                            
                            	Route ID 
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: route_type
                            
                            	Route type
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteTopology, self).__init__()

                                self.yang_name = "route-topology"
                                self.yang_parent_name = "external-route"

                                self.route_cost = YLeaf(YType.uint32, "route-cost")

                                self.route_distance = YLeaf(YType.uint32, "route-distance")

                                self.route_id = YLeaf(YType.str, "route-id")

                                self.route_type = YLeaf(YType.uint32, "route-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("route_cost",
                                                "route_distance",
                                                "route_id",
                                                "route_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteTopology, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteTopology, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.route_cost.is_set or
                                    self.route_distance.is_set or
                                    self.route_id.is_set or
                                    self.route_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.route_cost.yfilter != YFilter.not_set or
                                    self.route_distance.yfilter != YFilter.not_set or
                                    self.route_id.yfilter != YFilter.not_set or
                                    self.route_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "route-topology" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.route_cost.is_set or self.route_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_cost.get_name_leafdata())
                                if (self.route_distance.is_set or self.route_distance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_distance.get_name_leafdata())
                                if (self.route_id.is_set or self.route_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_id.get_name_leafdata())
                                if (self.route_type.is_set or self.route_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "route-cost" or name == "route-distance" or name == "route-id" or name == "route-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "route-cost"):
                                    self.route_cost = value
                                    self.route_cost.value_namespace = name_space
                                    self.route_cost.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-distance"):
                                    self.route_distance = value
                                    self.route_distance.value_namespace = name_space
                                    self.route_distance.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-id"):
                                    self.route_id = value
                                    self.route_id.value_namespace = name_space
                                    self.route_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-type"):
                                    self.route_type = value
                                    self.route_type.value_namespace = name_space
                                    self.route_type.value_namespace_prefix = name_space_prefix


                        class RouteExtendedCommunity(Entity):
                            """
                            Extended communities in the route
                            
                            .. attribute:: extended_community_area_id
                            
                            	Area id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_community_domain_id_value
                            
                            	Domain ID value
                            	**type**\:  str
                            
                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                            
                            .. attribute:: extended_community_options
                            
                            	Route Options
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: extended_community_route_type
                            
                            	Route type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: extended_community_router_id
                            
                            	Router id
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: extended_communityl_domain_id_type
                            
                            	Domain ID type
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity, self).__init__()

                                self.yang_name = "route-extended-community"
                                self.yang_parent_name = "external-route"

                                self.extended_community_area_id = YLeaf(YType.uint32, "extended-community-area-id")

                                self.extended_community_domain_id_value = YLeaf(YType.str, "extended-community-domain-id-value")

                                self.extended_community_options = YLeaf(YType.uint8, "extended-community-options")

                                self.extended_community_route_type = YLeaf(YType.uint8, "extended-community-route-type")

                                self.extended_community_router_id = YLeaf(YType.str, "extended-community-router-id")

                                self.extended_communityl_domain_id_type = YLeaf(YType.uint16, "extended-communityl-domain-id-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("extended_community_area_id",
                                                "extended_community_domain_id_value",
                                                "extended_community_options",
                                                "extended_community_route_type",
                                                "extended_community_router_id",
                                                "extended_communityl_domain_id_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.extended_community_area_id.is_set or
                                    self.extended_community_domain_id_value.is_set or
                                    self.extended_community_options.is_set or
                                    self.extended_community_route_type.is_set or
                                    self.extended_community_router_id.is_set or
                                    self.extended_communityl_domain_id_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.extended_community_area_id.yfilter != YFilter.not_set or
                                    self.extended_community_domain_id_value.yfilter != YFilter.not_set or
                                    self.extended_community_options.yfilter != YFilter.not_set or
                                    self.extended_community_route_type.yfilter != YFilter.not_set or
                                    self.extended_community_router_id.yfilter != YFilter.not_set or
                                    self.extended_communityl_domain_id_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "route-extended-community" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.extended_community_area_id.is_set or self.extended_community_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_community_area_id.get_name_leafdata())
                                if (self.extended_community_domain_id_value.is_set or self.extended_community_domain_id_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_community_domain_id_value.get_name_leafdata())
                                if (self.extended_community_options.is_set or self.extended_community_options.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_community_options.get_name_leafdata())
                                if (self.extended_community_route_type.is_set or self.extended_community_route_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_community_route_type.get_name_leafdata())
                                if (self.extended_community_router_id.is_set or self.extended_community_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_community_router_id.get_name_leafdata())
                                if (self.extended_communityl_domain_id_type.is_set or self.extended_communityl_domain_id_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_communityl_domain_id_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "extended-community-area-id" or name == "extended-community-domain-id-value" or name == "extended-community-options" or name == "extended-community-route-type" or name == "extended-community-router-id" or name == "extended-communityl-domain-id-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "extended-community-area-id"):
                                    self.extended_community_area_id = value
                                    self.extended_community_area_id.value_namespace = name_space
                                    self.extended_community_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-community-domain-id-value"):
                                    self.extended_community_domain_id_value = value
                                    self.extended_community_domain_id_value.value_namespace = name_space
                                    self.extended_community_domain_id_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-community-options"):
                                    self.extended_community_options = value
                                    self.extended_community_options.value_namespace = name_space
                                    self.extended_community_options.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-community-route-type"):
                                    self.extended_community_route_type = value
                                    self.extended_community_route_type.value_namespace = name_space
                                    self.extended_community_route_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-community-router-id"):
                                    self.extended_community_router_id = value
                                    self.extended_community_router_id.value_namespace = name_space
                                    self.extended_community_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-communityl-domain-id-type"):
                                    self.extended_communityl_domain_id_type = value
                                    self.extended_communityl_domain_id_type.value_namespace = name_space
                                    self.extended_communityl_domain_id_type.value_namespace_prefix = name_space_prefix


                        class RoutePath(Entity):
                            """
                            List of paths to this route
                            
                            .. attribute:: interface_name
                            
                            	Route path interface name 
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: route_backup_path
                            
                            	Backup Path Info
                            	**type**\:   :py:class:`RouteBackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath>`
                            
                            .. attribute:: route_path_id
                            
                            	Path ID of path
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: route_path_next_hop
                            
                            	Route path next hop 
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath, self).__init__()

                                self.yang_name = "route-path"
                                self.yang_parent_name = "external-route"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.route_path_id = YLeaf(YType.uint16, "route-path-id")

                                self.route_path_next_hop = YLeaf(YType.str, "route-path-next-hop")

                                self.route_backup_path = Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath()
                                self.route_backup_path.parent = self
                                self._children_name_map["route_backup_path"] = "route-backup-path"
                                self._children_yang_names.add("route-backup-path")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "route_path_id",
                                                "route_path_next_hop") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath, self).__setattr__(name, value)


                            class RouteBackupPath(Entity):
                                """
                                Backup Path Info
                                
                                .. attribute:: backup_metric
                                
                                	Metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: backup_route_interface_name
                                
                                	Next hop Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: backup_route_next_hop_address
                                
                                	Nexthop IP address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: backup_route_source
                                
                                	IP address of source of route
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: downstream
                                
                                	Downstream
                                	**type**\:  bool
                                
                                .. attribute:: line_card_disjoint
                                
                                	Line Card Disjoint
                                	**type**\:  bool
                                
                                .. attribute:: node_protect
                                
                                	Node Protect
                                	**type**\:  bool
                                
                                .. attribute:: primary_path
                                
                                	Primary Path
                                	**type**\:  bool
                                
                                .. attribute:: srlg_disjoint
                                
                                	SRLG Disjoint
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath, self).__init__()

                                    self.yang_name = "route-backup-path"
                                    self.yang_parent_name = "route-path"

                                    self.backup_metric = YLeaf(YType.uint32, "backup-metric")

                                    self.backup_route_interface_name = YLeaf(YType.str, "backup-route-interface-name")

                                    self.backup_route_next_hop_address = YLeaf(YType.str, "backup-route-next-hop-address")

                                    self.backup_route_source = YLeaf(YType.str, "backup-route-source")

                                    self.downstream = YLeaf(YType.boolean, "downstream")

                                    self.line_card_disjoint = YLeaf(YType.boolean, "line-card-disjoint")

                                    self.node_protect = YLeaf(YType.boolean, "node-protect")

                                    self.primary_path = YLeaf(YType.boolean, "primary-path")

                                    self.srlg_disjoint = YLeaf(YType.boolean, "srlg-disjoint")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_metric",
                                                    "backup_route_interface_name",
                                                    "backup_route_next_hop_address",
                                                    "backup_route_source",
                                                    "downstream",
                                                    "line_card_disjoint",
                                                    "node_protect",
                                                    "primary_path",
                                                    "srlg_disjoint") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_metric.is_set or
                                        self.backup_route_interface_name.is_set or
                                        self.backup_route_next_hop_address.is_set or
                                        self.backup_route_source.is_set or
                                        self.downstream.is_set or
                                        self.line_card_disjoint.is_set or
                                        self.node_protect.is_set or
                                        self.primary_path.is_set or
                                        self.srlg_disjoint.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_metric.yfilter != YFilter.not_set or
                                        self.backup_route_interface_name.yfilter != YFilter.not_set or
                                        self.backup_route_next_hop_address.yfilter != YFilter.not_set or
                                        self.backup_route_source.yfilter != YFilter.not_set or
                                        self.downstream.yfilter != YFilter.not_set or
                                        self.line_card_disjoint.yfilter != YFilter.not_set or
                                        self.node_protect.yfilter != YFilter.not_set or
                                        self.primary_path.yfilter != YFilter.not_set or
                                        self.srlg_disjoint.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-backup-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_metric.is_set or self.backup_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_metric.get_name_leafdata())
                                    if (self.backup_route_interface_name.is_set or self.backup_route_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_route_interface_name.get_name_leafdata())
                                    if (self.backup_route_next_hop_address.is_set or self.backup_route_next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_route_next_hop_address.get_name_leafdata())
                                    if (self.backup_route_source.is_set or self.backup_route_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_route_source.get_name_leafdata())
                                    if (self.downstream.is_set or self.downstream.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.downstream.get_name_leafdata())
                                    if (self.line_card_disjoint.is_set or self.line_card_disjoint.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.line_card_disjoint.get_name_leafdata())
                                    if (self.node_protect.is_set or self.node_protect.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.node_protect.get_name_leafdata())
                                    if (self.primary_path.is_set or self.primary_path.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.primary_path.get_name_leafdata())
                                    if (self.srlg_disjoint.is_set or self.srlg_disjoint.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.srlg_disjoint.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-metric" or name == "backup-route-interface-name" or name == "backup-route-next-hop-address" or name == "backup-route-source" or name == "downstream" or name == "line-card-disjoint" or name == "node-protect" or name == "primary-path" or name == "srlg-disjoint"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-metric"):
                                        self.backup_metric = value
                                        self.backup_metric.value_namespace = name_space
                                        self.backup_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-route-interface-name"):
                                        self.backup_route_interface_name = value
                                        self.backup_route_interface_name.value_namespace = name_space
                                        self.backup_route_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-route-next-hop-address"):
                                        self.backup_route_next_hop_address = value
                                        self.backup_route_next_hop_address.value_namespace = name_space
                                        self.backup_route_next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-route-source"):
                                        self.backup_route_source = value
                                        self.backup_route_source.value_namespace = name_space
                                        self.backup_route_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "downstream"):
                                        self.downstream = value
                                        self.downstream.value_namespace = name_space
                                        self.downstream.value_namespace_prefix = name_space_prefix
                                    if(value_path == "line-card-disjoint"):
                                        self.line_card_disjoint = value
                                        self.line_card_disjoint.value_namespace = name_space
                                        self.line_card_disjoint.value_namespace_prefix = name_space_prefix
                                    if(value_path == "node-protect"):
                                        self.node_protect = value
                                        self.node_protect.value_namespace = name_space
                                        self.node_protect.value_namespace_prefix = name_space_prefix
                                    if(value_path == "primary-path"):
                                        self.primary_path = value
                                        self.primary_path.value_namespace = name_space
                                        self.primary_path.value_namespace_prefix = name_space_prefix
                                    if(value_path == "srlg-disjoint"):
                                        self.srlg_disjoint = value
                                        self.srlg_disjoint.value_namespace = name_space
                                        self.srlg_disjoint.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_name.is_set or
                                    self.route_path_id.is_set or
                                    self.route_path_next_hop.is_set or
                                    (self.route_backup_path is not None and self.route_backup_path.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.route_path_id.yfilter != YFilter.not_set or
                                    self.route_path_next_hop.yfilter != YFilter.not_set or
                                    (self.route_backup_path is not None and self.route_backup_path.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "route-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.route_path_id.is_set or self.route_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_path_id.get_name_leafdata())
                                if (self.route_path_next_hop.is_set or self.route_path_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_path_next_hop.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "route-backup-path"):
                                    if (self.route_backup_path is None):
                                        self.route_backup_path = Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath.RouteBackupPath()
                                        self.route_backup_path.parent = self
                                        self._children_name_map["route_backup_path"] = "route-backup-path"
                                    return self.route_backup_path

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "route-backup-path" or name == "interface-name" or name == "route-path-id" or name == "route-path-next-hop"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-path-id"):
                                    self.route_path_id = value
                                    self.route_path_id.value_namespace = name_space
                                    self.route_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-path-next-hop"):
                                    self.route_path_next_hop = value
                                    self.route_path_next_hop.value_namespace = name_space
                                    self.route_path_next_hop.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.route_path:
                                if (c.has_data()):
                                    return True
                            return (
                                self.prefix.is_set or
                                self.prefix_length.is_set or
                                (self.route_extended_community is not None and self.route_extended_community.has_data()) or
                                (self.route_topology is not None and self.route_topology.has_data()))

                        def has_operation(self):
                            for c in self.route_path:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set or
                                (self.route_extended_community is not None and self.route_extended_community.has_operation()) or
                                (self.route_topology is not None and self.route_topology.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "external-route" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "route-extended-community"):
                                if (self.route_extended_community is None):
                                    self.route_extended_community = Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteExtendedCommunity()
                                    self.route_extended_community.parent = self
                                    self._children_name_map["route_extended_community"] = "route-extended-community"
                                return self.route_extended_community

                            if (child_yang_name == "route-path"):
                                for c in self.route_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RoutePath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.route_path.append(c)
                                return c

                            if (child_yang_name == "route-topology"):
                                if (self.route_topology is None):
                                    self.route_topology = Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute.RouteTopology()
                                    self.route_topology.parent = self
                                    self._children_name_map["route_topology"] = "route-topology"
                                return self.route_topology

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "route-extended-community" or name == "route-path" or name == "route-topology" or name == "prefix" or name == "prefix-length"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.external_route:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.external_route:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "external-routes" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "external-route"):
                            for c in self.external_route:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes.ExternalRoute()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.external_route.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "external-route"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class RequestListProcessTable(Entity):
                    """
                    OSPFv3 request list information for all areas
                    
                    .. attribute:: request
                    
                    	OSPFv3 request list information
                    	**type**\: list of    :py:class:`Request <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable.Request>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable, self).__init__()

                        self.yang_name = "request-list-process-table"
                        self.yang_parent_name = "default-vrf"

                        self.request = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable, self).__setattr__(name, value)


                    class Request(Entity):
                        """
                        OSPFv3 request list information
                        
                        .. attribute:: interface_name
                        
                        	Interface name
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: is_request_sham_link
                        
                        	If true, sham link is requested 
                        	**type**\:  bool
                        
                        .. attribute:: is_request_virtual_link
                        
                        	If true, virtual link is requested 
                        	**type**\:  bool
                        
                        .. attribute:: neighbor_address
                        
                        	Neighbor address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: request
                        
                        	List of request list entries
                        	**type**\: list of    :py:class:`Request <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable.Request.Request>`
                        
                        .. attribute:: request_neighbor_address
                        
                        	Neighbor IP address
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: request_sham_link_id
                        
                        	Request sham link ID 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: request_virtual_link_id
                        
                        	Request virtual link ID 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable.Request, self).__init__()

                            self.yang_name = "request"
                            self.yang_parent_name = "request-list-process-table"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.is_request_sham_link = YLeaf(YType.boolean, "is-request-sham-link")

                            self.is_request_virtual_link = YLeaf(YType.boolean, "is-request-virtual-link")

                            self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                            self.request_neighbor_address = YLeaf(YType.str, "request-neighbor-address")

                            self.request_sham_link_id = YLeaf(YType.uint32, "request-sham-link-id")

                            self.request_virtual_link_id = YLeaf(YType.uint32, "request-virtual-link-id")

                            self.request = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "is_request_sham_link",
                                            "is_request_virtual_link",
                                            "neighbor_address",
                                            "request_neighbor_address",
                                            "request_sham_link_id",
                                            "request_virtual_link_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable.Request, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable.Request, self).__setattr__(name, value)


                        class Request(Entity):
                            """
                            List of request list entries
                            
                            .. attribute:: header_advertising_router
                            
                            	Router ID of the advertising router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_age
                            
                            	Age of the LSA (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: header_lsa_id
                            
                            	LSA ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_type
                            
                            	LSA type
                            	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                            
                            .. attribute:: header_sequence_number
                            
                            	Current LSA sequence number
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable.Request.Request, self).__init__()

                                self.yang_name = "request"
                                self.yang_parent_name = "request"

                                self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("header_advertising_router",
                                                "header_lsa_age",
                                                "header_lsa_id",
                                                "header_lsa_type",
                                                "header_sequence_number") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable.Request.Request, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable.Request.Request, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.header_advertising_router.is_set or
                                    self.header_lsa_age.is_set or
                                    self.header_lsa_id.is_set or
                                    self.header_lsa_type.is_set or
                                    self.header_sequence_number.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.header_advertising_router.yfilter != YFilter.not_set or
                                    self.header_lsa_age.yfilter != YFilter.not_set or
                                    self.header_lsa_id.yfilter != YFilter.not_set or
                                    self.header_lsa_type.yfilter != YFilter.not_set or
                                    self.header_sequence_number.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "request" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "header-advertising-router"):
                                    self.header_advertising_router = value
                                    self.header_advertising_router.value_namespace = name_space
                                    self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-age"):
                                    self.header_lsa_age = value
                                    self.header_lsa_age.value_namespace = name_space
                                    self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-id"):
                                    self.header_lsa_id = value
                                    self.header_lsa_id.value_namespace = name_space
                                    self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-type"):
                                    self.header_lsa_type = value
                                    self.header_lsa_type.value_namespace = name_space
                                    self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-sequence-number"):
                                    self.header_sequence_number = value
                                    self.header_sequence_number.value_namespace = name_space
                                    self.header_sequence_number.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.request:
                                if (c.has_data()):
                                    return True
                            return (
                                self.interface_name.is_set or
                                self.is_request_sham_link.is_set or
                                self.is_request_virtual_link.is_set or
                                self.neighbor_address.is_set or
                                self.request_neighbor_address.is_set or
                                self.request_sham_link_id.is_set or
                                self.request_virtual_link_id.is_set)

                        def has_operation(self):
                            for c in self.request:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.is_request_sham_link.yfilter != YFilter.not_set or
                                self.is_request_virtual_link.yfilter != YFilter.not_set or
                                self.neighbor_address.yfilter != YFilter.not_set or
                                self.request_neighbor_address.yfilter != YFilter.not_set or
                                self.request_sham_link_id.yfilter != YFilter.not_set or
                                self.request_virtual_link_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "request" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.is_request_sham_link.is_set or self.is_request_sham_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_request_sham_link.get_name_leafdata())
                            if (self.is_request_virtual_link.is_set or self.is_request_virtual_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_request_virtual_link.get_name_leafdata())
                            if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                            if (self.request_neighbor_address.is_set or self.request_neighbor_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.request_neighbor_address.get_name_leafdata())
                            if (self.request_sham_link_id.is_set or self.request_sham_link_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.request_sham_link_id.get_name_leafdata())
                            if (self.request_virtual_link_id.is_set or self.request_virtual_link_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.request_virtual_link_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "request"):
                                for c in self.request:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable.Request.Request()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.request.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "request" or name == "interface-name" or name == "is-request-sham-link" or name == "is-request-virtual-link" or name == "neighbor-address" or name == "request-neighbor-address" or name == "request-sham-link-id" or name == "request-virtual-link-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-request-sham-link"):
                                self.is_request_sham_link = value
                                self.is_request_sham_link.value_namespace = name_space
                                self.is_request_sham_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-request-virtual-link"):
                                self.is_request_virtual_link = value
                                self.is_request_virtual_link.value_namespace = name_space
                                self.is_request_virtual_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-address"):
                                self.neighbor_address = value
                                self.neighbor_address.value_namespace = name_space
                                self.neighbor_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "request-neighbor-address"):
                                self.request_neighbor_address = value
                                self.request_neighbor_address.value_namespace = name_space
                                self.request_neighbor_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "request-sham-link-id"):
                                self.request_sham_link_id = value
                                self.request_sham_link_id.value_namespace = name_space
                                self.request_sham_link_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "request-virtual-link-id"):
                                self.request_virtual_link_id = value
                                self.request_virtual_link_id.value_namespace = name_space
                                self.request_virtual_link_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.request:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.request:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "request-list-process-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "request"):
                            for c in self.request:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable.Request()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.request.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "request"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class VirtualLink(Entity):
                    """
                    Virtual link information
                    
                    .. attribute:: interface_name
                    
                    	Interface on which this virtual link is formed
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: is_virtual_link_authentication_enabled
                    
                    	If true, virtual link authentication is enabled 
                    	**type**\:  bool
                    
                    .. attribute:: is_virtual_link_demand_circuit
                    
                    	If true, the link runs as demand circuit
                    	**type**\:  bool
                    
                    .. attribute:: is_virtual_link_encryption_enabled
                    
                    	If true, virtual link encryption is enabled 
                    	**type**\:  bool
                    
                    .. attribute:: is_virtual_link_ip_security_active
                    
                    	If true, Virtual link IP security is active 
                    	**type**\:  bool
                    
                    .. attribute:: is_virtual_link_ip_security_required
                    
                    	If true, virtual link IP security is required 
                    	**type**\:  bool
                    
                    .. attribute:: is_virtual_link_passive
                    
                    	If true, interface is passive
                    	**type**\:  bool
                    
                    .. attribute:: transit_area_id
                    
                    	Transit area id 
                    	**type**\:  str
                    
                    .. attribute:: virtual_link_authentication_spi
                    
                    	Virtual link authentication spi 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_authentication_transmit
                    
                    	Virtual link authentication transmit 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_cost
                    
                    	Cost of the virtual link
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: virtual_link_dc_bitless_lsa
                    
                    	Number of LSA's with demand circuit bit not set 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_dead_interval
                    
                    	Dead interval (s)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_encrypted_authentication_transmitted
                    
                    	Virtual link encrypted authentication transmitted 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_encryption_spi
                    
                    	Virtual link encryption spi
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_encryption_transmitted
                    
                    	Virtual link encryption transmitted 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_hello_interval
                    
                    	Hello interval (s)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_interface_number
                    
                    	Virtual link interface number 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_neighbor
                    
                    	Neighbor information 
                    	**type**\:   :py:class:`VirtualLinkNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor>`
                    
                    .. attribute:: virtual_link_neighbor_address
                    
                    	Virtual link neighbor addresss 
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: virtual_link_neighbor_id
                    
                    	Neighbor on other end of this virtual link
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: virtual_link_next_hello
                    
                    	Time until next hello (s)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_retransmission_interval
                    
                    	Retransmission interval (s)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virtual_link_state
                    
                    	OSPF interface state for the virtual link
                    	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                    
                    .. attribute:: virtual_link_wait_interval
                    
                    	Wait interval (s)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: virual_link_transmission_delay
                    
                    	Transmission delay in seconds
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.VirtualLink, self).__init__()

                        self.yang_name = "virtual-link"
                        self.yang_parent_name = "default-vrf"

                        self.interface_name = YLeaf(YType.str, "interface-name")

                        self.is_virtual_link_authentication_enabled = YLeaf(YType.boolean, "is-virtual-link-authentication-enabled")

                        self.is_virtual_link_demand_circuit = YLeaf(YType.boolean, "is-virtual-link-demand-circuit")

                        self.is_virtual_link_encryption_enabled = YLeaf(YType.boolean, "is-virtual-link-encryption-enabled")

                        self.is_virtual_link_ip_security_active = YLeaf(YType.boolean, "is-virtual-link-ip-security-active")

                        self.is_virtual_link_ip_security_required = YLeaf(YType.boolean, "is-virtual-link-ip-security-required")

                        self.is_virtual_link_passive = YLeaf(YType.boolean, "is-virtual-link-passive")

                        self.transit_area_id = YLeaf(YType.str, "transit-area-id")

                        self.virtual_link_authentication_spi = YLeaf(YType.uint32, "virtual-link-authentication-spi")

                        self.virtual_link_authentication_transmit = YLeaf(YType.uint32, "virtual-link-authentication-transmit")

                        self.virtual_link_cost = YLeaf(YType.uint16, "virtual-link-cost")

                        self.virtual_link_dc_bitless_lsa = YLeaf(YType.uint32, "virtual-link-dc-bitless-lsa")

                        self.virtual_link_dead_interval = YLeaf(YType.uint32, "virtual-link-dead-interval")

                        self.virtual_link_encrypted_authentication_transmitted = YLeaf(YType.uint32, "virtual-link-encrypted-authentication-transmitted")

                        self.virtual_link_encryption_spi = YLeaf(YType.uint32, "virtual-link-encryption-spi")

                        self.virtual_link_encryption_transmitted = YLeaf(YType.uint32, "virtual-link-encryption-transmitted")

                        self.virtual_link_hello_interval = YLeaf(YType.uint32, "virtual-link-hello-interval")

                        self.virtual_link_interface_number = YLeaf(YType.uint32, "virtual-link-interface-number")

                        self.virtual_link_neighbor_address = YLeaf(YType.str, "virtual-link-neighbor-address")

                        self.virtual_link_neighbor_id = YLeaf(YType.str, "virtual-link-neighbor-id")

                        self.virtual_link_next_hello = YLeaf(YType.uint32, "virtual-link-next-hello")

                        self.virtual_link_retransmission_interval = YLeaf(YType.uint32, "virtual-link-retransmission-interval")

                        self.virtual_link_state = YLeaf(YType.enumeration, "virtual-link-state")

                        self.virtual_link_wait_interval = YLeaf(YType.uint32, "virtual-link-wait-interval")

                        self.virual_link_transmission_delay = YLeaf(YType.uint16, "virual-link-transmission-delay")

                        self.virtual_link_neighbor = Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor()
                        self.virtual_link_neighbor.parent = self
                        self._children_name_map["virtual_link_neighbor"] = "virtual-link-neighbor"
                        self._children_yang_names.add("virtual-link-neighbor")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interface_name",
                                        "is_virtual_link_authentication_enabled",
                                        "is_virtual_link_demand_circuit",
                                        "is_virtual_link_encryption_enabled",
                                        "is_virtual_link_ip_security_active",
                                        "is_virtual_link_ip_security_required",
                                        "is_virtual_link_passive",
                                        "transit_area_id",
                                        "virtual_link_authentication_spi",
                                        "virtual_link_authentication_transmit",
                                        "virtual_link_cost",
                                        "virtual_link_dc_bitless_lsa",
                                        "virtual_link_dead_interval",
                                        "virtual_link_encrypted_authentication_transmitted",
                                        "virtual_link_encryption_spi",
                                        "virtual_link_encryption_transmitted",
                                        "virtual_link_hello_interval",
                                        "virtual_link_interface_number",
                                        "virtual_link_neighbor_address",
                                        "virtual_link_neighbor_id",
                                        "virtual_link_next_hello",
                                        "virtual_link_retransmission_interval",
                                        "virtual_link_state",
                                        "virtual_link_wait_interval",
                                        "virual_link_transmission_delay") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.VirtualLink, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.VirtualLink, self).__setattr__(name, value)


                    class VirtualLinkNeighbor(Entity):
                        """
                        Neighbor information 
                        
                        .. attribute:: is_virtual_link_hello_suppressed
                        
                        	If true, hello suppressed 
                        	**type**\:  bool
                        
                        .. attribute:: virtual_link_retransmission
                        
                        	Virtual link retransmission information 
                        	**type**\:   :py:class:`VirtualLinkRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission>`
                        
                        .. attribute:: virtual_link_state
                        
                        	OSPF interface state for the virtual link
                        	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor, self).__init__()

                            self.yang_name = "virtual-link-neighbor"
                            self.yang_parent_name = "virtual-link"

                            self.is_virtual_link_hello_suppressed = YLeaf(YType.boolean, "is-virtual-link-hello-suppressed")

                            self.virtual_link_state = YLeaf(YType.enumeration, "virtual-link-state")

                            self.virtual_link_retransmission = Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission()
                            self.virtual_link_retransmission.parent = self
                            self._children_name_map["virtual_link_retransmission"] = "virtual-link-retransmission"
                            self._children_yang_names.add("virtual-link-retransmission")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_virtual_link_hello_suppressed",
                                            "virtual_link_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor, self).__setattr__(name, value)


                        class VirtualLinkRetransmission(Entity):
                            """
                            Virtual link retransmission information 
                            
                            .. attribute:: area_first_flood
                            
                            	First flood item for area scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_first_flood_index
                            
                            	Index of the first flood item for area scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_flood_index
                            
                            	Area scope LSA's flood index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_next_flood
                            
                            	Next flood item for area scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: area_next_flood_index
                            
                            	Index of next flood item for Area scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_first_flood
                            
                            	First flood item for AS scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_first_flood_index
                            
                            	Index for first flood item for AS scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_flood_index
                            
                            	AS scope LSA's flood index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_next_flood
                            
                            	Next flood item for AS scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: as_next_flood_index
                            
                            	Index of next flood item for AS scope LSAs
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: database_descriptor_retransmissions
                            
                            	Number of database descriptor retransmissions during last exchange
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: last_retransmission_length
                            
                            	Number of LSAs sent in last retransmission
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: last_retransmission_time
                            
                            	Last retransmission scan time (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: link_first_flood
                            
                            	Link first flood information 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: link_first_flood_index
                            
                            	Link first flood information index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: link_flood_index
                            
                            	Link flood index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: link_next_flood
                            
                            	Link next flood information 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: link_next_flood_index
                            
                            	Link next flood information index 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa_retransmission_timer
                            
                            	Time until next LSA retransmission (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: maximum_retransmission_length
                            
                            	Maximum number of LSAs sent in a retransmission
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: maximum_retransmission_time
                            
                            	Maximum retransmission scan time (ms)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_retransmissions
                            
                            	Number of neighbor retransmissions 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: retransmissions
                            
                            	Number of retransmissions for this neighbor
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission, self).__init__()

                                self.yang_name = "virtual-link-retransmission"
                                self.yang_parent_name = "virtual-link-neighbor"

                                self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("area_first_flood",
                                                "area_first_flood_index",
                                                "area_flood_index",
                                                "area_next_flood",
                                                "area_next_flood_index",
                                                "as_first_flood",
                                                "as_first_flood_index",
                                                "as_flood_index",
                                                "as_next_flood",
                                                "as_next_flood_index",
                                                "database_descriptor_retransmissions",
                                                "last_retransmission_length",
                                                "last_retransmission_time",
                                                "link_first_flood",
                                                "link_first_flood_index",
                                                "link_flood_index",
                                                "link_next_flood",
                                                "link_next_flood_index",
                                                "lsa_retransmission_timer",
                                                "maximum_retransmission_length",
                                                "maximum_retransmission_time",
                                                "neighbor_retransmissions",
                                                "retransmissions") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.area_first_flood.is_set or
                                    self.area_first_flood_index.is_set or
                                    self.area_flood_index.is_set or
                                    self.area_next_flood.is_set or
                                    self.area_next_flood_index.is_set or
                                    self.as_first_flood.is_set or
                                    self.as_first_flood_index.is_set or
                                    self.as_flood_index.is_set or
                                    self.as_next_flood.is_set or
                                    self.as_next_flood_index.is_set or
                                    self.database_descriptor_retransmissions.is_set or
                                    self.last_retransmission_length.is_set or
                                    self.last_retransmission_time.is_set or
                                    self.link_first_flood.is_set or
                                    self.link_first_flood_index.is_set or
                                    self.link_flood_index.is_set or
                                    self.link_next_flood.is_set or
                                    self.link_next_flood_index.is_set or
                                    self.lsa_retransmission_timer.is_set or
                                    self.maximum_retransmission_length.is_set or
                                    self.maximum_retransmission_time.is_set or
                                    self.neighbor_retransmissions.is_set or
                                    self.retransmissions.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.area_first_flood.yfilter != YFilter.not_set or
                                    self.area_first_flood_index.yfilter != YFilter.not_set or
                                    self.area_flood_index.yfilter != YFilter.not_set or
                                    self.area_next_flood.yfilter != YFilter.not_set or
                                    self.area_next_flood_index.yfilter != YFilter.not_set or
                                    self.as_first_flood.yfilter != YFilter.not_set or
                                    self.as_first_flood_index.yfilter != YFilter.not_set or
                                    self.as_flood_index.yfilter != YFilter.not_set or
                                    self.as_next_flood.yfilter != YFilter.not_set or
                                    self.as_next_flood_index.yfilter != YFilter.not_set or
                                    self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                    self.last_retransmission_length.yfilter != YFilter.not_set or
                                    self.last_retransmission_time.yfilter != YFilter.not_set or
                                    self.link_first_flood.yfilter != YFilter.not_set or
                                    self.link_first_flood_index.yfilter != YFilter.not_set or
                                    self.link_flood_index.yfilter != YFilter.not_set or
                                    self.link_next_flood.yfilter != YFilter.not_set or
                                    self.link_next_flood_index.yfilter != YFilter.not_set or
                                    self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                    self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                    self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                    self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                    self.retransmissions.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "virtual-link-retransmission" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "area-first-flood"):
                                    self.area_first_flood = value
                                    self.area_first_flood.value_namespace = name_space
                                    self.area_first_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-first-flood-index"):
                                    self.area_first_flood_index = value
                                    self.area_first_flood_index.value_namespace = name_space
                                    self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-flood-index"):
                                    self.area_flood_index = value
                                    self.area_flood_index.value_namespace = name_space
                                    self.area_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-next-flood"):
                                    self.area_next_flood = value
                                    self.area_next_flood.value_namespace = name_space
                                    self.area_next_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "area-next-flood-index"):
                                    self.area_next_flood_index = value
                                    self.area_next_flood_index.value_namespace = name_space
                                    self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-first-flood"):
                                    self.as_first_flood = value
                                    self.as_first_flood.value_namespace = name_space
                                    self.as_first_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-first-flood-index"):
                                    self.as_first_flood_index = value
                                    self.as_first_flood_index.value_namespace = name_space
                                    self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-flood-index"):
                                    self.as_flood_index = value
                                    self.as_flood_index.value_namespace = name_space
                                    self.as_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-next-flood"):
                                    self.as_next_flood = value
                                    self.as_next_flood.value_namespace = name_space
                                    self.as_next_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "as-next-flood-index"):
                                    self.as_next_flood_index = value
                                    self.as_next_flood_index.value_namespace = name_space
                                    self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "database-descriptor-retransmissions"):
                                    self.database_descriptor_retransmissions = value
                                    self.database_descriptor_retransmissions.value_namespace = name_space
                                    self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                if(value_path == "last-retransmission-length"):
                                    self.last_retransmission_length = value
                                    self.last_retransmission_length.value_namespace = name_space
                                    self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "last-retransmission-time"):
                                    self.last_retransmission_time = value
                                    self.last_retransmission_time.value_namespace = name_space
                                    self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-first-flood"):
                                    self.link_first_flood = value
                                    self.link_first_flood.value_namespace = name_space
                                    self.link_first_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-first-flood-index"):
                                    self.link_first_flood_index = value
                                    self.link_first_flood_index.value_namespace = name_space
                                    self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-flood-index"):
                                    self.link_flood_index = value
                                    self.link_flood_index.value_namespace = name_space
                                    self.link_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-next-flood"):
                                    self.link_next_flood = value
                                    self.link_next_flood.value_namespace = name_space
                                    self.link_next_flood.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-next-flood-index"):
                                    self.link_next_flood_index = value
                                    self.link_next_flood_index.value_namespace = name_space
                                    self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsa-retransmission-timer"):
                                    self.lsa_retransmission_timer = value
                                    self.lsa_retransmission_timer.value_namespace = name_space
                                    self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-retransmission-length"):
                                    self.maximum_retransmission_length = value
                                    self.maximum_retransmission_length.value_namespace = name_space
                                    self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-retransmission-time"):
                                    self.maximum_retransmission_time = value
                                    self.maximum_retransmission_time.value_namespace = name_space
                                    self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-retransmissions"):
                                    self.neighbor_retransmissions = value
                                    self.neighbor_retransmissions.value_namespace = name_space
                                    self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                if(value_path == "retransmissions"):
                                    self.retransmissions = value
                                    self.retransmissions.value_namespace = name_space
                                    self.retransmissions.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.is_virtual_link_hello_suppressed.is_set or
                                self.virtual_link_state.is_set or
                                (self.virtual_link_retransmission is not None and self.virtual_link_retransmission.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_virtual_link_hello_suppressed.yfilter != YFilter.not_set or
                                self.virtual_link_state.yfilter != YFilter.not_set or
                                (self.virtual_link_retransmission is not None and self.virtual_link_retransmission.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "virtual-link-neighbor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_virtual_link_hello_suppressed.is_set or self.is_virtual_link_hello_suppressed.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_virtual_link_hello_suppressed.get_name_leafdata())
                            if (self.virtual_link_state.is_set or self.virtual_link_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.virtual_link_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "virtual-link-retransmission"):
                                if (self.virtual_link_retransmission is None):
                                    self.virtual_link_retransmission = Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor.VirtualLinkRetransmission()
                                    self.virtual_link_retransmission.parent = self
                                    self._children_name_map["virtual_link_retransmission"] = "virtual-link-retransmission"
                                return self.virtual_link_retransmission

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "virtual-link-retransmission" or name == "is-virtual-link-hello-suppressed" or name == "virtual-link-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-virtual-link-hello-suppressed"):
                                self.is_virtual_link_hello_suppressed = value
                                self.is_virtual_link_hello_suppressed.value_namespace = name_space
                                self.is_virtual_link_hello_suppressed.value_namespace_prefix = name_space_prefix
                            if(value_path == "virtual-link-state"):
                                self.virtual_link_state = value
                                self.virtual_link_state.value_namespace = name_space
                                self.virtual_link_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.interface_name.is_set or
                            self.is_virtual_link_authentication_enabled.is_set or
                            self.is_virtual_link_demand_circuit.is_set or
                            self.is_virtual_link_encryption_enabled.is_set or
                            self.is_virtual_link_ip_security_active.is_set or
                            self.is_virtual_link_ip_security_required.is_set or
                            self.is_virtual_link_passive.is_set or
                            self.transit_area_id.is_set or
                            self.virtual_link_authentication_spi.is_set or
                            self.virtual_link_authentication_transmit.is_set or
                            self.virtual_link_cost.is_set or
                            self.virtual_link_dc_bitless_lsa.is_set or
                            self.virtual_link_dead_interval.is_set or
                            self.virtual_link_encrypted_authentication_transmitted.is_set or
                            self.virtual_link_encryption_spi.is_set or
                            self.virtual_link_encryption_transmitted.is_set or
                            self.virtual_link_hello_interval.is_set or
                            self.virtual_link_interface_number.is_set or
                            self.virtual_link_neighbor_address.is_set or
                            self.virtual_link_neighbor_id.is_set or
                            self.virtual_link_next_hello.is_set or
                            self.virtual_link_retransmission_interval.is_set or
                            self.virtual_link_state.is_set or
                            self.virtual_link_wait_interval.is_set or
                            self.virual_link_transmission_delay.is_set or
                            (self.virtual_link_neighbor is not None and self.virtual_link_neighbor.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interface_name.yfilter != YFilter.not_set or
                            self.is_virtual_link_authentication_enabled.yfilter != YFilter.not_set or
                            self.is_virtual_link_demand_circuit.yfilter != YFilter.not_set or
                            self.is_virtual_link_encryption_enabled.yfilter != YFilter.not_set or
                            self.is_virtual_link_ip_security_active.yfilter != YFilter.not_set or
                            self.is_virtual_link_ip_security_required.yfilter != YFilter.not_set or
                            self.is_virtual_link_passive.yfilter != YFilter.not_set or
                            self.transit_area_id.yfilter != YFilter.not_set or
                            self.virtual_link_authentication_spi.yfilter != YFilter.not_set or
                            self.virtual_link_authentication_transmit.yfilter != YFilter.not_set or
                            self.virtual_link_cost.yfilter != YFilter.not_set or
                            self.virtual_link_dc_bitless_lsa.yfilter != YFilter.not_set or
                            self.virtual_link_dead_interval.yfilter != YFilter.not_set or
                            self.virtual_link_encrypted_authentication_transmitted.yfilter != YFilter.not_set or
                            self.virtual_link_encryption_spi.yfilter != YFilter.not_set or
                            self.virtual_link_encryption_transmitted.yfilter != YFilter.not_set or
                            self.virtual_link_hello_interval.yfilter != YFilter.not_set or
                            self.virtual_link_interface_number.yfilter != YFilter.not_set or
                            self.virtual_link_neighbor_address.yfilter != YFilter.not_set or
                            self.virtual_link_neighbor_id.yfilter != YFilter.not_set or
                            self.virtual_link_next_hello.yfilter != YFilter.not_set or
                            self.virtual_link_retransmission_interval.yfilter != YFilter.not_set or
                            self.virtual_link_state.yfilter != YFilter.not_set or
                            self.virtual_link_wait_interval.yfilter != YFilter.not_set or
                            self.virual_link_transmission_delay.yfilter != YFilter.not_set or
                            (self.virtual_link_neighbor is not None and self.virtual_link_neighbor.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "virtual-link" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                        if (self.is_virtual_link_authentication_enabled.is_set or self.is_virtual_link_authentication_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_virtual_link_authentication_enabled.get_name_leafdata())
                        if (self.is_virtual_link_demand_circuit.is_set or self.is_virtual_link_demand_circuit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_virtual_link_demand_circuit.get_name_leafdata())
                        if (self.is_virtual_link_encryption_enabled.is_set or self.is_virtual_link_encryption_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_virtual_link_encryption_enabled.get_name_leafdata())
                        if (self.is_virtual_link_ip_security_active.is_set or self.is_virtual_link_ip_security_active.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_virtual_link_ip_security_active.get_name_leafdata())
                        if (self.is_virtual_link_ip_security_required.is_set or self.is_virtual_link_ip_security_required.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_virtual_link_ip_security_required.get_name_leafdata())
                        if (self.is_virtual_link_passive.is_set or self.is_virtual_link_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_virtual_link_passive.get_name_leafdata())
                        if (self.transit_area_id.is_set or self.transit_area_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.transit_area_id.get_name_leafdata())
                        if (self.virtual_link_authentication_spi.is_set or self.virtual_link_authentication_spi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_authentication_spi.get_name_leafdata())
                        if (self.virtual_link_authentication_transmit.is_set or self.virtual_link_authentication_transmit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_authentication_transmit.get_name_leafdata())
                        if (self.virtual_link_cost.is_set or self.virtual_link_cost.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_cost.get_name_leafdata())
                        if (self.virtual_link_dc_bitless_lsa.is_set or self.virtual_link_dc_bitless_lsa.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_dc_bitless_lsa.get_name_leafdata())
                        if (self.virtual_link_dead_interval.is_set or self.virtual_link_dead_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_dead_interval.get_name_leafdata())
                        if (self.virtual_link_encrypted_authentication_transmitted.is_set or self.virtual_link_encrypted_authentication_transmitted.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_encrypted_authentication_transmitted.get_name_leafdata())
                        if (self.virtual_link_encryption_spi.is_set or self.virtual_link_encryption_spi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_encryption_spi.get_name_leafdata())
                        if (self.virtual_link_encryption_transmitted.is_set or self.virtual_link_encryption_transmitted.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_encryption_transmitted.get_name_leafdata())
                        if (self.virtual_link_hello_interval.is_set or self.virtual_link_hello_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_hello_interval.get_name_leafdata())
                        if (self.virtual_link_interface_number.is_set or self.virtual_link_interface_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_interface_number.get_name_leafdata())
                        if (self.virtual_link_neighbor_address.is_set or self.virtual_link_neighbor_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_neighbor_address.get_name_leafdata())
                        if (self.virtual_link_neighbor_id.is_set or self.virtual_link_neighbor_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_neighbor_id.get_name_leafdata())
                        if (self.virtual_link_next_hello.is_set or self.virtual_link_next_hello.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_next_hello.get_name_leafdata())
                        if (self.virtual_link_retransmission_interval.is_set or self.virtual_link_retransmission_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_retransmission_interval.get_name_leafdata())
                        if (self.virtual_link_state.is_set or self.virtual_link_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_state.get_name_leafdata())
                        if (self.virtual_link_wait_interval.is_set or self.virtual_link_wait_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virtual_link_wait_interval.get_name_leafdata())
                        if (self.virual_link_transmission_delay.is_set or self.virual_link_transmission_delay.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.virual_link_transmission_delay.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "virtual-link-neighbor"):
                            if (self.virtual_link_neighbor is None):
                                self.virtual_link_neighbor = Ospfv3.Processes.Process.DefaultVrf.VirtualLink.VirtualLinkNeighbor()
                                self.virtual_link_neighbor.parent = self
                                self._children_name_map["virtual_link_neighbor"] = "virtual-link-neighbor"
                            return self.virtual_link_neighbor

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "virtual-link-neighbor" or name == "interface-name" or name == "is-virtual-link-authentication-enabled" or name == "is-virtual-link-demand-circuit" or name == "is-virtual-link-encryption-enabled" or name == "is-virtual-link-ip-security-active" or name == "is-virtual-link-ip-security-required" or name == "is-virtual-link-passive" or name == "transit-area-id" or name == "virtual-link-authentication-spi" or name == "virtual-link-authentication-transmit" or name == "virtual-link-cost" or name == "virtual-link-dc-bitless-lsa" or name == "virtual-link-dead-interval" or name == "virtual-link-encrypted-authentication-transmitted" or name == "virtual-link-encryption-spi" or name == "virtual-link-encryption-transmitted" or name == "virtual-link-hello-interval" or name == "virtual-link-interface-number" or name == "virtual-link-neighbor-address" or name == "virtual-link-neighbor-id" or name == "virtual-link-next-hello" or name == "virtual-link-retransmission-interval" or name == "virtual-link-state" or name == "virtual-link-wait-interval" or name == "virual-link-transmission-delay"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interface-name"):
                            self.interface_name = value
                            self.interface_name.value_namespace = name_space
                            self.interface_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-virtual-link-authentication-enabled"):
                            self.is_virtual_link_authentication_enabled = value
                            self.is_virtual_link_authentication_enabled.value_namespace = name_space
                            self.is_virtual_link_authentication_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-virtual-link-demand-circuit"):
                            self.is_virtual_link_demand_circuit = value
                            self.is_virtual_link_demand_circuit.value_namespace = name_space
                            self.is_virtual_link_demand_circuit.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-virtual-link-encryption-enabled"):
                            self.is_virtual_link_encryption_enabled = value
                            self.is_virtual_link_encryption_enabled.value_namespace = name_space
                            self.is_virtual_link_encryption_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-virtual-link-ip-security-active"):
                            self.is_virtual_link_ip_security_active = value
                            self.is_virtual_link_ip_security_active.value_namespace = name_space
                            self.is_virtual_link_ip_security_active.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-virtual-link-ip-security-required"):
                            self.is_virtual_link_ip_security_required = value
                            self.is_virtual_link_ip_security_required.value_namespace = name_space
                            self.is_virtual_link_ip_security_required.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-virtual-link-passive"):
                            self.is_virtual_link_passive = value
                            self.is_virtual_link_passive.value_namespace = name_space
                            self.is_virtual_link_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "transit-area-id"):
                            self.transit_area_id = value
                            self.transit_area_id.value_namespace = name_space
                            self.transit_area_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-authentication-spi"):
                            self.virtual_link_authentication_spi = value
                            self.virtual_link_authentication_spi.value_namespace = name_space
                            self.virtual_link_authentication_spi.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-authentication-transmit"):
                            self.virtual_link_authentication_transmit = value
                            self.virtual_link_authentication_transmit.value_namespace = name_space
                            self.virtual_link_authentication_transmit.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-cost"):
                            self.virtual_link_cost = value
                            self.virtual_link_cost.value_namespace = name_space
                            self.virtual_link_cost.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-dc-bitless-lsa"):
                            self.virtual_link_dc_bitless_lsa = value
                            self.virtual_link_dc_bitless_lsa.value_namespace = name_space
                            self.virtual_link_dc_bitless_lsa.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-dead-interval"):
                            self.virtual_link_dead_interval = value
                            self.virtual_link_dead_interval.value_namespace = name_space
                            self.virtual_link_dead_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-encrypted-authentication-transmitted"):
                            self.virtual_link_encrypted_authentication_transmitted = value
                            self.virtual_link_encrypted_authentication_transmitted.value_namespace = name_space
                            self.virtual_link_encrypted_authentication_transmitted.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-encryption-spi"):
                            self.virtual_link_encryption_spi = value
                            self.virtual_link_encryption_spi.value_namespace = name_space
                            self.virtual_link_encryption_spi.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-encryption-transmitted"):
                            self.virtual_link_encryption_transmitted = value
                            self.virtual_link_encryption_transmitted.value_namespace = name_space
                            self.virtual_link_encryption_transmitted.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-hello-interval"):
                            self.virtual_link_hello_interval = value
                            self.virtual_link_hello_interval.value_namespace = name_space
                            self.virtual_link_hello_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-interface-number"):
                            self.virtual_link_interface_number = value
                            self.virtual_link_interface_number.value_namespace = name_space
                            self.virtual_link_interface_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-neighbor-address"):
                            self.virtual_link_neighbor_address = value
                            self.virtual_link_neighbor_address.value_namespace = name_space
                            self.virtual_link_neighbor_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-neighbor-id"):
                            self.virtual_link_neighbor_id = value
                            self.virtual_link_neighbor_id.value_namespace = name_space
                            self.virtual_link_neighbor_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-next-hello"):
                            self.virtual_link_next_hello = value
                            self.virtual_link_next_hello.value_namespace = name_space
                            self.virtual_link_next_hello.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-retransmission-interval"):
                            self.virtual_link_retransmission_interval = value
                            self.virtual_link_retransmission_interval.value_namespace = name_space
                            self.virtual_link_retransmission_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-state"):
                            self.virtual_link_state = value
                            self.virtual_link_state.value_namespace = name_space
                            self.virtual_link_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "virtual-link-wait-interval"):
                            self.virtual_link_wait_interval = value
                            self.virtual_link_wait_interval.value_namespace = name_space
                            self.virtual_link_wait_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "virual-link-transmission-delay"):
                            self.virual_link_transmission_delay = value
                            self.virual_link_transmission_delay.value_namespace = name_space
                            self.virual_link_transmission_delay.value_namespace_prefix = name_space_prefix


                class FloodListProcessTable(Entity):
                    """
                    OSPFv3 flood list information table for all
                    areas
                    
                    .. attribute:: flood
                    
                    	OSPFv3 flood list information
                    	**type**\: list of    :py:class:`Flood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable, self).__init__()

                        self.yang_name = "flood-list-process-table"
                        self.yang_parent_name = "default-vrf"

                        self.flood = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable, self).__setattr__(name, value)


                    class Flood(Entity):
                        """
                        OSPFv3 flood list information
                        
                        .. attribute:: interface_name  <key>
                        
                        	Interface name
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: area_flood
                        
                        	Area scope floodlist
                        	**type**\: list of    :py:class:`AreaFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.AreaFlood>`
                        
                        .. attribute:: as_flood
                        
                        	AS scope floodlist
                        	**type**\: list of    :py:class:`AsFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.AsFlood>`
                        
                        .. attribute:: link_flood
                        
                        	Link floodlist
                        	**type**\: list of    :py:class:`LinkFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.LinkFlood>`
                        
                        .. attribute:: ls_transmission_timer
                        
                        	Time until next LS transmission (ms) 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: queue_length
                        
                        	Number of LSAs currently being flooded 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood, self).__init__()

                            self.yang_name = "flood"
                            self.yang_parent_name = "flood-list-process-table"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.ls_transmission_timer = YLeaf(YType.uint32, "ls-transmission-timer")

                            self.queue_length = YLeaf(YType.uint32, "queue-length")

                            self.area_flood = YList(self)
                            self.as_flood = YList(self)
                            self.link_flood = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "ls_transmission_timer",
                                            "queue_length") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood, self).__setattr__(name, value)


                        class LinkFlood(Entity):
                            """
                            Link floodlist
                            
                            .. attribute:: header_advertising_router
                            
                            	Router ID of the advertising router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_age
                            
                            	Age of the LSA (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: header_lsa_id
                            
                            	LSA ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_type
                            
                            	LSA type
                            	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                            
                            .. attribute:: header_sequence_number
                            
                            	Current LSA sequence number
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.LinkFlood, self).__init__()

                                self.yang_name = "link-flood"
                                self.yang_parent_name = "flood"

                                self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("header_advertising_router",
                                                "header_lsa_age",
                                                "header_lsa_id",
                                                "header_lsa_type",
                                                "header_sequence_number") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.LinkFlood, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.LinkFlood, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.header_advertising_router.is_set or
                                    self.header_lsa_age.is_set or
                                    self.header_lsa_id.is_set or
                                    self.header_lsa_type.is_set or
                                    self.header_sequence_number.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.header_advertising_router.yfilter != YFilter.not_set or
                                    self.header_lsa_age.yfilter != YFilter.not_set or
                                    self.header_lsa_id.yfilter != YFilter.not_set or
                                    self.header_lsa_type.yfilter != YFilter.not_set or
                                    self.header_sequence_number.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "link-flood" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "header-advertising-router"):
                                    self.header_advertising_router = value
                                    self.header_advertising_router.value_namespace = name_space
                                    self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-age"):
                                    self.header_lsa_age = value
                                    self.header_lsa_age.value_namespace = name_space
                                    self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-id"):
                                    self.header_lsa_id = value
                                    self.header_lsa_id.value_namespace = name_space
                                    self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-type"):
                                    self.header_lsa_type = value
                                    self.header_lsa_type.value_namespace = name_space
                                    self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-sequence-number"):
                                    self.header_sequence_number = value
                                    self.header_sequence_number.value_namespace = name_space
                                    self.header_sequence_number.value_namespace_prefix = name_space_prefix


                        class AreaFlood(Entity):
                            """
                            Area scope floodlist
                            
                            .. attribute:: header_advertising_router
                            
                            	Router ID of the advertising router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_age
                            
                            	Age of the LSA (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: header_lsa_id
                            
                            	LSA ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_type
                            
                            	LSA type
                            	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                            
                            .. attribute:: header_sequence_number
                            
                            	Current LSA sequence number
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.AreaFlood, self).__init__()

                                self.yang_name = "area-flood"
                                self.yang_parent_name = "flood"

                                self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("header_advertising_router",
                                                "header_lsa_age",
                                                "header_lsa_id",
                                                "header_lsa_type",
                                                "header_sequence_number") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.AreaFlood, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.AreaFlood, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.header_advertising_router.is_set or
                                    self.header_lsa_age.is_set or
                                    self.header_lsa_id.is_set or
                                    self.header_lsa_type.is_set or
                                    self.header_sequence_number.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.header_advertising_router.yfilter != YFilter.not_set or
                                    self.header_lsa_age.yfilter != YFilter.not_set or
                                    self.header_lsa_id.yfilter != YFilter.not_set or
                                    self.header_lsa_type.yfilter != YFilter.not_set or
                                    self.header_sequence_number.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "area-flood" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "header-advertising-router"):
                                    self.header_advertising_router = value
                                    self.header_advertising_router.value_namespace = name_space
                                    self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-age"):
                                    self.header_lsa_age = value
                                    self.header_lsa_age.value_namespace = name_space
                                    self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-id"):
                                    self.header_lsa_id = value
                                    self.header_lsa_id.value_namespace = name_space
                                    self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-type"):
                                    self.header_lsa_type = value
                                    self.header_lsa_type.value_namespace = name_space
                                    self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-sequence-number"):
                                    self.header_sequence_number = value
                                    self.header_sequence_number.value_namespace = name_space
                                    self.header_sequence_number.value_namespace_prefix = name_space_prefix


                        class AsFlood(Entity):
                            """
                            AS scope floodlist
                            
                            .. attribute:: header_advertising_router
                            
                            	Router ID of the advertising router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_age
                            
                            	Age of the LSA (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: header_lsa_id
                            
                            	LSA ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_type
                            
                            	LSA type
                            	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                            
                            .. attribute:: header_sequence_number
                            
                            	Current LSA sequence number
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.AsFlood, self).__init__()

                                self.yang_name = "as-flood"
                                self.yang_parent_name = "flood"

                                self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("header_advertising_router",
                                                "header_lsa_age",
                                                "header_lsa_id",
                                                "header_lsa_type",
                                                "header_sequence_number") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.AsFlood, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.AsFlood, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.header_advertising_router.is_set or
                                    self.header_lsa_age.is_set or
                                    self.header_lsa_id.is_set or
                                    self.header_lsa_type.is_set or
                                    self.header_sequence_number.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.header_advertising_router.yfilter != YFilter.not_set or
                                    self.header_lsa_age.yfilter != YFilter.not_set or
                                    self.header_lsa_id.yfilter != YFilter.not_set or
                                    self.header_lsa_type.yfilter != YFilter.not_set or
                                    self.header_sequence_number.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "as-flood" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "header-advertising-router"):
                                    self.header_advertising_router = value
                                    self.header_advertising_router.value_namespace = name_space
                                    self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-age"):
                                    self.header_lsa_age = value
                                    self.header_lsa_age.value_namespace = name_space
                                    self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-id"):
                                    self.header_lsa_id = value
                                    self.header_lsa_id.value_namespace = name_space
                                    self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-type"):
                                    self.header_lsa_type = value
                                    self.header_lsa_type.value_namespace = name_space
                                    self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-sequence-number"):
                                    self.header_sequence_number = value
                                    self.header_sequence_number.value_namespace = name_space
                                    self.header_sequence_number.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.area_flood:
                                if (c.has_data()):
                                    return True
                            for c in self.as_flood:
                                if (c.has_data()):
                                    return True
                            for c in self.link_flood:
                                if (c.has_data()):
                                    return True
                            return (
                                self.interface_name.is_set or
                                self.ls_transmission_timer.is_set or
                                self.queue_length.is_set)

                        def has_operation(self):
                            for c in self.area_flood:
                                if (c.has_operation()):
                                    return True
                            for c in self.as_flood:
                                if (c.has_operation()):
                                    return True
                            for c in self.link_flood:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.ls_transmission_timer.yfilter != YFilter.not_set or
                                self.queue_length.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flood" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.ls_transmission_timer.is_set or self.ls_transmission_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ls_transmission_timer.get_name_leafdata())
                            if (self.queue_length.is_set or self.queue_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.queue_length.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "area-flood"):
                                for c in self.area_flood:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.AreaFlood()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.area_flood.append(c)
                                return c

                            if (child_yang_name == "as-flood"):
                                for c in self.as_flood:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.AsFlood()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.as_flood.append(c)
                                return c

                            if (child_yang_name == "link-flood"):
                                for c in self.link_flood:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood.LinkFlood()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.link_flood.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area-flood" or name == "as-flood" or name == "link-flood" or name == "interface-name" or name == "ls-transmission-timer" or name == "queue-length"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "ls-transmission-timer"):
                                self.ls_transmission_timer = value
                                self.ls_transmission_timer.value_namespace = name_space
                                self.ls_transmission_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "queue-length"):
                                self.queue_length = value
                                self.queue_length.value_namespace = name_space
                                self.queue_length.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.flood:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.flood:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "flood-list-process-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "flood"):
                            for c in self.flood:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable.Flood()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.flood.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "flood"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class RouteSummary(Entity):
                    """
                    Summarize OSPFv3 local RIB tables
                    
                    .. attribute:: extern_one_route
                    
                    	Extern 1 route summary 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: extern_two_route
                    
                    	Extern 2 route summary 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: inter_area_route
                    
                    	Inter route summary 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: intra_area_route
                    
                    	Intra route summary 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nssa_one_route
                    
                    	NSSA 1 route summary 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nssa_two_route
                    
                    	NSSA 2 route summary 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: redistribution_route
                    
                    	Redistribution route summary 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: route_connected
                    
                    	Route connected 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: route_id
                    
                    	Route summary of a route ID 
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: total_received_route
                    
                    	Total route received summary
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_sent_route
                    
                    	Total route summary 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.RouteSummary, self).__init__()

                        self.yang_name = "route-summary"
                        self.yang_parent_name = "default-vrf"

                        self.extern_one_route = YLeaf(YType.uint32, "extern-one-route")

                        self.extern_two_route = YLeaf(YType.uint32, "extern-two-route")

                        self.inter_area_route = YLeaf(YType.uint32, "inter-area-route")

                        self.intra_area_route = YLeaf(YType.uint32, "intra-area-route")

                        self.nssa_one_route = YLeaf(YType.uint32, "nssa-one-route")

                        self.nssa_two_route = YLeaf(YType.uint32, "nssa-two-route")

                        self.redistribution_route = YLeaf(YType.uint32, "redistribution-route")

                        self.route_connected = YLeaf(YType.uint32, "route-connected")

                        self.route_id = YLeaf(YType.str, "route-id")

                        self.total_received_route = YLeaf(YType.uint32, "total-received-route")

                        self.total_sent_route = YLeaf(YType.uint32, "total-sent-route")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("extern_one_route",
                                        "extern_two_route",
                                        "inter_area_route",
                                        "intra_area_route",
                                        "nssa_one_route",
                                        "nssa_two_route",
                                        "redistribution_route",
                                        "route_connected",
                                        "route_id",
                                        "total_received_route",
                                        "total_sent_route") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.RouteSummary, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.RouteSummary, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.extern_one_route.is_set or
                            self.extern_two_route.is_set or
                            self.inter_area_route.is_set or
                            self.intra_area_route.is_set or
                            self.nssa_one_route.is_set or
                            self.nssa_two_route.is_set or
                            self.redistribution_route.is_set or
                            self.route_connected.is_set or
                            self.route_id.is_set or
                            self.total_received_route.is_set or
                            self.total_sent_route.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.extern_one_route.yfilter != YFilter.not_set or
                            self.extern_two_route.yfilter != YFilter.not_set or
                            self.inter_area_route.yfilter != YFilter.not_set or
                            self.intra_area_route.yfilter != YFilter.not_set or
                            self.nssa_one_route.yfilter != YFilter.not_set or
                            self.nssa_two_route.yfilter != YFilter.not_set or
                            self.redistribution_route.yfilter != YFilter.not_set or
                            self.route_connected.yfilter != YFilter.not_set or
                            self.route_id.yfilter != YFilter.not_set or
                            self.total_received_route.yfilter != YFilter.not_set or
                            self.total_sent_route.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "route-summary" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.extern_one_route.is_set or self.extern_one_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.extern_one_route.get_name_leafdata())
                        if (self.extern_two_route.is_set or self.extern_two_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.extern_two_route.get_name_leafdata())
                        if (self.inter_area_route.is_set or self.inter_area_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.inter_area_route.get_name_leafdata())
                        if (self.intra_area_route.is_set or self.intra_area_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.intra_area_route.get_name_leafdata())
                        if (self.nssa_one_route.is_set or self.nssa_one_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nssa_one_route.get_name_leafdata())
                        if (self.nssa_two_route.is_set or self.nssa_two_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nssa_two_route.get_name_leafdata())
                        if (self.redistribution_route.is_set or self.redistribution_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.redistribution_route.get_name_leafdata())
                        if (self.route_connected.is_set or self.route_connected.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.route_connected.get_name_leafdata())
                        if (self.route_id.is_set or self.route_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.route_id.get_name_leafdata())
                        if (self.total_received_route.is_set or self.total_received_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_received_route.get_name_leafdata())
                        if (self.total_sent_route.is_set or self.total_sent_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_sent_route.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "extern-one-route" or name == "extern-two-route" or name == "inter-area-route" or name == "intra-area-route" or name == "nssa-one-route" or name == "nssa-two-route" or name == "redistribution-route" or name == "route-connected" or name == "route-id" or name == "total-received-route" or name == "total-sent-route"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "extern-one-route"):
                            self.extern_one_route = value
                            self.extern_one_route.value_namespace = name_space
                            self.extern_one_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "extern-two-route"):
                            self.extern_two_route = value
                            self.extern_two_route.value_namespace = name_space
                            self.extern_two_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "inter-area-route"):
                            self.inter_area_route = value
                            self.inter_area_route.value_namespace = name_space
                            self.inter_area_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "intra-area-route"):
                            self.intra_area_route = value
                            self.intra_area_route.value_namespace = name_space
                            self.intra_area_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "nssa-one-route"):
                            self.nssa_one_route = value
                            self.nssa_one_route.value_namespace = name_space
                            self.nssa_one_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "nssa-two-route"):
                            self.nssa_two_route = value
                            self.nssa_two_route.value_namespace = name_space
                            self.nssa_two_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "redistribution-route"):
                            self.redistribution_route = value
                            self.redistribution_route.value_namespace = name_space
                            self.redistribution_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "route-connected"):
                            self.route_connected = value
                            self.route_connected.value_namespace = name_space
                            self.route_connected.value_namespace_prefix = name_space_prefix
                        if(value_path == "route-id"):
                            self.route_id = value
                            self.route_id.value_namespace = name_space
                            self.route_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-received-route"):
                            self.total_received_route = value
                            self.total_received_route.value_namespace = name_space
                            self.total_received_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-sent-route"):
                            self.total_sent_route = value
                            self.total_sent_route.value_namespace = name_space
                            self.total_sent_route.value_namespace_prefix = name_space_prefix


                class Areas(Entity):
                    """
                    OSPFv3 area table
                    
                    .. attribute:: area
                    
                    	Per\-area information
                    	**type**\: list of    :py:class:`Area <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.Areas, self).__init__()

                        self.yang_name = "areas"
                        self.yang_parent_name = "default-vrf"

                        self.area = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.Areas, self).__setattr__(name, value)


                    class Area(Entity):
                        """
                        Per\-area information
                        
                        .. attribute:: area_id  <key>
                        
                        	Area ID
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: database_summary_table
                        
                        	Database summary table
                        	**type**\:   :py:class:`DatabaseSummaryTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable>`
                        
                        .. attribute:: database_table
                        
                        	OSPF Link State Database
                        	**type**\:   :py:class:`DatabaseTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable>`
                        
                        .. attribute:: flood_list_table
                        
                        	OSPFv3 flood list information table for an area
                        	**type**\:   :py:class:`FloodListTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable>`
                        
                        .. attribute:: interface_brief_table
                        
                        	OSPFv3 interface brief information table for an area
                        	**type**\:   :py:class:`InterfaceBriefTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable>`
                        
                        .. attribute:: interface_table
                        
                        	OSPFv3 interface information table for an area
                        	**type**\:   :py:class:`InterfaceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable>`
                        
                        .. attribute:: neighbor_detail_table
                        
                        	OSPFv3 area neighbor information table
                        	**type**\:   :py:class:`NeighborDetailTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable>`
                        
                        .. attribute:: neighbor_table
                        
                        	OSPFv3 neighbor information table
                        	**type**\:   :py:class:`NeighborTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable>`
                        
                        .. attribute:: request_list_table
                        
                        	OSPFv3 request list information in an area
                        	**type**\:   :py:class:`RequestListTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable>`
                        
                        .. attribute:: retransmission_list_table
                        
                        	OSPFv3 retransmission list information table in an area
                        	**type**\:   :py:class:`RetransmissionListTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area, self).__init__()

                            self.yang_name = "area"
                            self.yang_parent_name = "areas"

                            self.area_id = YLeaf(YType.int32, "area-id")

                            self.database_summary_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable()
                            self.database_summary_table.parent = self
                            self._children_name_map["database_summary_table"] = "database-summary-table"
                            self._children_yang_names.add("database-summary-table")

                            self.database_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable()
                            self.database_table.parent = self
                            self._children_name_map["database_table"] = "database-table"
                            self._children_yang_names.add("database-table")

                            self.flood_list_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable()
                            self.flood_list_table.parent = self
                            self._children_name_map["flood_list_table"] = "flood-list-table"
                            self._children_yang_names.add("flood-list-table")

                            self.interface_brief_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable()
                            self.interface_brief_table.parent = self
                            self._children_name_map["interface_brief_table"] = "interface-brief-table"
                            self._children_yang_names.add("interface-brief-table")

                            self.interface_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable()
                            self.interface_table.parent = self
                            self._children_name_map["interface_table"] = "interface-table"
                            self._children_yang_names.add("interface-table")

                            self.neighbor_detail_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable()
                            self.neighbor_detail_table.parent = self
                            self._children_name_map["neighbor_detail_table"] = "neighbor-detail-table"
                            self._children_yang_names.add("neighbor-detail-table")

                            self.neighbor_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable()
                            self.neighbor_table.parent = self
                            self._children_name_map["neighbor_table"] = "neighbor-table"
                            self._children_yang_names.add("neighbor-table")

                            self.request_list_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable()
                            self.request_list_table.parent = self
                            self._children_name_map["request_list_table"] = "request-list-table"
                            self._children_yang_names.add("request-list-table")

                            self.retransmission_list_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable()
                            self.retransmission_list_table.parent = self
                            self._children_name_map["retransmission_list_table"] = "retransmission-list-table"
                            self._children_yang_names.add("retransmission-list-table")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("area_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area, self).__setattr__(name, value)


                        class NeighborDetailTable(Entity):
                            """
                            OSPFv3 area neighbor information table
                            
                            .. attribute:: neighbor_detail
                            
                            	OSPFv3 neighbor detail information
                            	**type**\: list of    :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable, self).__init__()

                                self.yang_name = "neighbor-detail-table"
                                self.yang_parent_name = "area"

                                self.neighbor_detail = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable, self).__setattr__(name, value)


                            class NeighborDetail(Entity):
                                """
                                OSPFv3 neighbor detail information
                                
                                .. attribute:: interface_name
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: is_neighbor_sham_link
                                
                                	If true, neighbor is on a sham link 
                                	**type**\:  bool
                                
                                .. attribute:: is_neighbor_virtual_link
                                
                                	If true, neighbor is on a virtual link 
                                	**type**\:  bool
                                
                                .. attribute:: neighbor_address
                                
                                	Neighbor ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: neighbor_address_xr
                                
                                	Neighbor IP Address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: neighbor_bfd_info
                                
                                	Neighbor BFD information
                                	**type**\:   :py:class:`NeighborBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo>`
                                
                                .. attribute:: neighbor_dead_timer
                                
                                	Time until neighbor's dead timer expires (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: neighbor_designated_router
                                
                                	Designated router 
                                	**type**\:  str
                                
                                	**length:** 0..9
                                
                                .. attribute:: neighbor_detail
                                
                                	Detailed OSPFv3 neighbor information 
                                	**type**\:   :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail>`
                                
                                .. attribute:: neighbor_dr_priority
                                
                                	Neighbor's DR priority
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: neighbor_interface_id
                                
                                	Neighbor interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_sham_link_id
                                
                                	Neighbor sham link id 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_state
                                
                                	Neighbor's state
                                	**type**\:   :py:class:`Ospfv3NeighborState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3NeighborState>`
                                
                                .. attribute:: neighbor_up_time
                                
                                	Amount of time since the adjacency is up (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: neighbor_virtual_link_id
                                
                                	Neighbor virtual link id 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail, self).__init__()

                                    self.yang_name = "neighbor-detail"
                                    self.yang_parent_name = "neighbor-detail-table"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.is_neighbor_sham_link = YLeaf(YType.boolean, "is-neighbor-sham-link")

                                    self.is_neighbor_virtual_link = YLeaf(YType.boolean, "is-neighbor-virtual-link")

                                    self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                    self.neighbor_address_xr = YLeaf(YType.str, "neighbor-address-xr")

                                    self.neighbor_dead_timer = YLeaf(YType.uint32, "neighbor-dead-timer")

                                    self.neighbor_designated_router = YLeaf(YType.str, "neighbor-designated-router")

                                    self.neighbor_dr_priority = YLeaf(YType.uint8, "neighbor-dr-priority")

                                    self.neighbor_interface_id = YLeaf(YType.uint32, "neighbor-interface-id")

                                    self.neighbor_sham_link_id = YLeaf(YType.uint32, "neighbor-sham-link-id")

                                    self.neighbor_state = YLeaf(YType.enumeration, "neighbor-state")

                                    self.neighbor_up_time = YLeaf(YType.uint32, "neighbor-up-time")

                                    self.neighbor_virtual_link_id = YLeaf(YType.uint32, "neighbor-virtual-link-id")

                                    self.neighbor_bfd_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo()
                                    self.neighbor_bfd_info.parent = self
                                    self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                    self._children_yang_names.add("neighbor-bfd-info")

                                    self.neighbor_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail()
                                    self.neighbor_detail.parent = self
                                    self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                    self._children_yang_names.add("neighbor-detail")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "is_neighbor_sham_link",
                                                    "is_neighbor_virtual_link",
                                                    "neighbor_address",
                                                    "neighbor_address_xr",
                                                    "neighbor_dead_timer",
                                                    "neighbor_designated_router",
                                                    "neighbor_dr_priority",
                                                    "neighbor_interface_id",
                                                    "neighbor_sham_link_id",
                                                    "neighbor_state",
                                                    "neighbor_up_time",
                                                    "neighbor_virtual_link_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail, self).__setattr__(name, value)


                                class NeighborDetail(Entity):
                                    """
                                    Detailed OSPFv3 neighbor information 
                                    
                                    .. attribute:: interface_type
                                    
                                    	Interface type
                                    	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                                    
                                    .. attribute:: is_neighbor_filtered
                                    
                                    	If true, filter outgoing LSAs 
                                    	**type**\:  bool
                                    
                                    .. attribute:: neighbor_backup_designated_router_address
                                    
                                    	Address of backup designated router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: neighbor_cost
                                    
                                    	Cost of path to this neighbor 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: neighbor_designated_router_address
                                    
                                    	Address of designated router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: neighbor_ignore_timer
                                    
                                    	Remaining time when ignore timer is running 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_option
                                    
                                    	 This is bitmask of neighbor's option field received 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_retransmission
                                    
                                    	Retransmission information with this neighbor
                                    	**type**\:   :py:class:`NeighborRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission>`
                                    
                                    .. attribute:: next_poll_interval
                                    
                                    	For NBMA networks, amount of time remaining in seconds before the next poll interval expires and Hello is sent (s)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: pending_events
                                    
                                    	Number of pending events 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: poll_interval
                                    
                                    	Poll interval (s)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state_changes
                                    
                                    	Number of state changes 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail, self).__init__()

                                        self.yang_name = "neighbor-detail"
                                        self.yang_parent_name = "neighbor-detail"

                                        self.interface_type = YLeaf(YType.enumeration, "interface-type")

                                        self.is_neighbor_filtered = YLeaf(YType.boolean, "is-neighbor-filtered")

                                        self.neighbor_backup_designated_router_address = YLeaf(YType.str, "neighbor-backup-designated-router-address")

                                        self.neighbor_cost = YLeaf(YType.uint16, "neighbor-cost")

                                        self.neighbor_designated_router_address = YLeaf(YType.str, "neighbor-designated-router-address")

                                        self.neighbor_ignore_timer = YLeaf(YType.uint32, "neighbor-ignore-timer")

                                        self.neighbor_option = YLeaf(YType.uint32, "neighbor-option")

                                        self.next_poll_interval = YLeaf(YType.uint32, "next-poll-interval")

                                        self.pending_events = YLeaf(YType.uint16, "pending-events")

                                        self.poll_interval = YLeaf(YType.uint32, "poll-interval")

                                        self.state_changes = YLeaf(YType.uint16, "state-changes")

                                        self.neighbor_retransmission = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission()
                                        self.neighbor_retransmission.parent = self
                                        self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                        self._children_yang_names.add("neighbor-retransmission")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_type",
                                                        "is_neighbor_filtered",
                                                        "neighbor_backup_designated_router_address",
                                                        "neighbor_cost",
                                                        "neighbor_designated_router_address",
                                                        "neighbor_ignore_timer",
                                                        "neighbor_option",
                                                        "next_poll_interval",
                                                        "pending_events",
                                                        "poll_interval",
                                                        "state_changes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail, self).__setattr__(name, value)


                                    class NeighborRetransmission(Entity):
                                        """
                                        Retransmission information with this neighbor
                                        
                                        .. attribute:: area_first_flood
                                        
                                        	First flood item for area scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: area_first_flood_index
                                        
                                        	Index of the first flood item for area scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: area_flood_index
                                        
                                        	Area scope LSA's flood index
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: area_next_flood
                                        
                                        	Next flood item for area scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: area_next_flood_index
                                        
                                        	Index of next flood item for Area scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: as_first_flood
                                        
                                        	First flood item for AS scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: as_first_flood_index
                                        
                                        	Index for first flood item for AS scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: as_flood_index
                                        
                                        	AS scope LSA's flood index
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: as_next_flood
                                        
                                        	Next flood item for AS scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: as_next_flood_index
                                        
                                        	Index of next flood item for AS scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: database_descriptor_retransmissions
                                        
                                        	Number of database descriptor retransmissions during last exchange
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: last_retransmission_length
                                        
                                        	Number of LSAs sent in last retransmission
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: last_retransmission_time
                                        
                                        	Last retransmission scan time (ms)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_first_flood
                                        
                                        	Link first flood information 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_first_flood_index
                                        
                                        	Link first flood information index
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_flood_index
                                        
                                        	Link flood index
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_next_flood
                                        
                                        	Link next flood information 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_next_flood_index
                                        
                                        	Link next flood information index 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_retransmission_timer
                                        
                                        	Time until next LSA retransmission (ms)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: maximum_retransmission_length
                                        
                                        	Maximum number of LSAs sent in a retransmission
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: maximum_retransmission_time
                                        
                                        	Maximum retransmission scan time (ms)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: neighbor_retransmissions
                                        
                                        	Number of neighbor retransmissions 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: retransmissions
                                        
                                        	Number of retransmissions for this neighbor
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__init__()

                                            self.yang_name = "neighbor-retransmission"
                                            self.yang_parent_name = "neighbor-detail"

                                            self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                            self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                            self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                            self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                            self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                            self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                            self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                            self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                            self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                            self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                            self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                            self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                            self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                            self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                            self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                            self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                            self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                            self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                            self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                            self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                            self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                            self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                            self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("area_first_flood",
                                                            "area_first_flood_index",
                                                            "area_flood_index",
                                                            "area_next_flood",
                                                            "area_next_flood_index",
                                                            "as_first_flood",
                                                            "as_first_flood_index",
                                                            "as_flood_index",
                                                            "as_next_flood",
                                                            "as_next_flood_index",
                                                            "database_descriptor_retransmissions",
                                                            "last_retransmission_length",
                                                            "last_retransmission_time",
                                                            "link_first_flood",
                                                            "link_first_flood_index",
                                                            "link_flood_index",
                                                            "link_next_flood",
                                                            "link_next_flood_index",
                                                            "lsa_retransmission_timer",
                                                            "maximum_retransmission_length",
                                                            "maximum_retransmission_time",
                                                            "neighbor_retransmissions",
                                                            "retransmissions") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.area_first_flood.is_set or
                                                self.area_first_flood_index.is_set or
                                                self.area_flood_index.is_set or
                                                self.area_next_flood.is_set or
                                                self.area_next_flood_index.is_set or
                                                self.as_first_flood.is_set or
                                                self.as_first_flood_index.is_set or
                                                self.as_flood_index.is_set or
                                                self.as_next_flood.is_set or
                                                self.as_next_flood_index.is_set or
                                                self.database_descriptor_retransmissions.is_set or
                                                self.last_retransmission_length.is_set or
                                                self.last_retransmission_time.is_set or
                                                self.link_first_flood.is_set or
                                                self.link_first_flood_index.is_set or
                                                self.link_flood_index.is_set or
                                                self.link_next_flood.is_set or
                                                self.link_next_flood_index.is_set or
                                                self.lsa_retransmission_timer.is_set or
                                                self.maximum_retransmission_length.is_set or
                                                self.maximum_retransmission_time.is_set or
                                                self.neighbor_retransmissions.is_set or
                                                self.retransmissions.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.area_first_flood.yfilter != YFilter.not_set or
                                                self.area_first_flood_index.yfilter != YFilter.not_set or
                                                self.area_flood_index.yfilter != YFilter.not_set or
                                                self.area_next_flood.yfilter != YFilter.not_set or
                                                self.area_next_flood_index.yfilter != YFilter.not_set or
                                                self.as_first_flood.yfilter != YFilter.not_set or
                                                self.as_first_flood_index.yfilter != YFilter.not_set or
                                                self.as_flood_index.yfilter != YFilter.not_set or
                                                self.as_next_flood.yfilter != YFilter.not_set or
                                                self.as_next_flood_index.yfilter != YFilter.not_set or
                                                self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                                self.last_retransmission_length.yfilter != YFilter.not_set or
                                                self.last_retransmission_time.yfilter != YFilter.not_set or
                                                self.link_first_flood.yfilter != YFilter.not_set or
                                                self.link_first_flood_index.yfilter != YFilter.not_set or
                                                self.link_flood_index.yfilter != YFilter.not_set or
                                                self.link_next_flood.yfilter != YFilter.not_set or
                                                self.link_next_flood_index.yfilter != YFilter.not_set or
                                                self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                                self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                                self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                                self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                                self.retransmissions.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "neighbor-retransmission" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                            if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                            if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                            if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                            if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                            if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                            if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                            if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                            if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                            if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                            if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                            if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                            if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                            if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                            if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                            if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                            if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                            if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                            if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                            if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                            if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                            if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                            if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "area-first-flood"):
                                                self.area_first_flood = value
                                                self.area_first_flood.value_namespace = name_space
                                                self.area_first_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "area-first-flood-index"):
                                                self.area_first_flood_index = value
                                                self.area_first_flood_index.value_namespace = name_space
                                                self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "area-flood-index"):
                                                self.area_flood_index = value
                                                self.area_flood_index.value_namespace = name_space
                                                self.area_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "area-next-flood"):
                                                self.area_next_flood = value
                                                self.area_next_flood.value_namespace = name_space
                                                self.area_next_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "area-next-flood-index"):
                                                self.area_next_flood_index = value
                                                self.area_next_flood_index.value_namespace = name_space
                                                self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "as-first-flood"):
                                                self.as_first_flood = value
                                                self.as_first_flood.value_namespace = name_space
                                                self.as_first_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "as-first-flood-index"):
                                                self.as_first_flood_index = value
                                                self.as_first_flood_index.value_namespace = name_space
                                                self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "as-flood-index"):
                                                self.as_flood_index = value
                                                self.as_flood_index.value_namespace = name_space
                                                self.as_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "as-next-flood"):
                                                self.as_next_flood = value
                                                self.as_next_flood.value_namespace = name_space
                                                self.as_next_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "as-next-flood-index"):
                                                self.as_next_flood_index = value
                                                self.as_next_flood_index.value_namespace = name_space
                                                self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "database-descriptor-retransmissions"):
                                                self.database_descriptor_retransmissions = value
                                                self.database_descriptor_retransmissions.value_namespace = name_space
                                                self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-retransmission-length"):
                                                self.last_retransmission_length = value
                                                self.last_retransmission_length.value_namespace = name_space
                                                self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-retransmission-time"):
                                                self.last_retransmission_time = value
                                                self.last_retransmission_time.value_namespace = name_space
                                                self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-first-flood"):
                                                self.link_first_flood = value
                                                self.link_first_flood.value_namespace = name_space
                                                self.link_first_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-first-flood-index"):
                                                self.link_first_flood_index = value
                                                self.link_first_flood_index.value_namespace = name_space
                                                self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-flood-index"):
                                                self.link_flood_index = value
                                                self.link_flood_index.value_namespace = name_space
                                                self.link_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-next-flood"):
                                                self.link_next_flood = value
                                                self.link_next_flood.value_namespace = name_space
                                                self.link_next_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-next-flood-index"):
                                                self.link_next_flood_index = value
                                                self.link_next_flood_index.value_namespace = name_space
                                                self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-retransmission-timer"):
                                                self.lsa_retransmission_timer = value
                                                self.lsa_retransmission_timer.value_namespace = name_space
                                                self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                            if(value_path == "maximum-retransmission-length"):
                                                self.maximum_retransmission_length = value
                                                self.maximum_retransmission_length.value_namespace = name_space
                                                self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "maximum-retransmission-time"):
                                                self.maximum_retransmission_time = value
                                                self.maximum_retransmission_time.value_namespace = name_space
                                                self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-retransmissions"):
                                                self.neighbor_retransmissions = value
                                                self.neighbor_retransmissions.value_namespace = name_space
                                                self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                            if(value_path == "retransmissions"):
                                                self.retransmissions = value
                                                self.retransmissions.value_namespace = name_space
                                                self.retransmissions.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_type.is_set or
                                            self.is_neighbor_filtered.is_set or
                                            self.neighbor_backup_designated_router_address.is_set or
                                            self.neighbor_cost.is_set or
                                            self.neighbor_designated_router_address.is_set or
                                            self.neighbor_ignore_timer.is_set or
                                            self.neighbor_option.is_set or
                                            self.next_poll_interval.is_set or
                                            self.pending_events.is_set or
                                            self.poll_interval.is_set or
                                            self.state_changes.is_set or
                                            (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_type.yfilter != YFilter.not_set or
                                            self.is_neighbor_filtered.yfilter != YFilter.not_set or
                                            self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set or
                                            self.neighbor_cost.yfilter != YFilter.not_set or
                                            self.neighbor_designated_router_address.yfilter != YFilter.not_set or
                                            self.neighbor_ignore_timer.yfilter != YFilter.not_set or
                                            self.neighbor_option.yfilter != YFilter.not_set or
                                            self.next_poll_interval.yfilter != YFilter.not_set or
                                            self.pending_events.yfilter != YFilter.not_set or
                                            self.poll_interval.yfilter != YFilter.not_set or
                                            self.state_changes.yfilter != YFilter.not_set or
                                            (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "neighbor-detail" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_type.is_set or self.interface_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_type.get_name_leafdata())
                                        if (self.is_neighbor_filtered.is_set or self.is_neighbor_filtered.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_neighbor_filtered.get_name_leafdata())
                                        if (self.neighbor_backup_designated_router_address.is_set or self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_backup_designated_router_address.get_name_leafdata())
                                        if (self.neighbor_cost.is_set or self.neighbor_cost.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_cost.get_name_leafdata())
                                        if (self.neighbor_designated_router_address.is_set or self.neighbor_designated_router_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_designated_router_address.get_name_leafdata())
                                        if (self.neighbor_ignore_timer.is_set or self.neighbor_ignore_timer.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_ignore_timer.get_name_leafdata())
                                        if (self.neighbor_option.is_set or self.neighbor_option.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_option.get_name_leafdata())
                                        if (self.next_poll_interval.is_set or self.next_poll_interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_poll_interval.get_name_leafdata())
                                        if (self.pending_events.is_set or self.pending_events.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pending_events.get_name_leafdata())
                                        if (self.poll_interval.is_set or self.poll_interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.poll_interval.get_name_leafdata())
                                        if (self.state_changes.is_set or self.state_changes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_changes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "neighbor-retransmission"):
                                            if (self.neighbor_retransmission is None):
                                                self.neighbor_retransmission = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail.NeighborRetransmission()
                                                self.neighbor_retransmission.parent = self
                                                self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                            return self.neighbor_retransmission

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "neighbor-retransmission" or name == "interface-type" or name == "is-neighbor-filtered" or name == "neighbor-backup-designated-router-address" or name == "neighbor-cost" or name == "neighbor-designated-router-address" or name == "neighbor-ignore-timer" or name == "neighbor-option" or name == "next-poll-interval" or name == "pending-events" or name == "poll-interval" or name == "state-changes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-type"):
                                            self.interface_type = value
                                            self.interface_type.value_namespace = name_space
                                            self.interface_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-neighbor-filtered"):
                                            self.is_neighbor_filtered = value
                                            self.is_neighbor_filtered.value_namespace = name_space
                                            self.is_neighbor_filtered.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-backup-designated-router-address"):
                                            self.neighbor_backup_designated_router_address = value
                                            self.neighbor_backup_designated_router_address.value_namespace = name_space
                                            self.neighbor_backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-cost"):
                                            self.neighbor_cost = value
                                            self.neighbor_cost.value_namespace = name_space
                                            self.neighbor_cost.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-designated-router-address"):
                                            self.neighbor_designated_router_address = value
                                            self.neighbor_designated_router_address.value_namespace = name_space
                                            self.neighbor_designated_router_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-ignore-timer"):
                                            self.neighbor_ignore_timer = value
                                            self.neighbor_ignore_timer.value_namespace = name_space
                                            self.neighbor_ignore_timer.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-option"):
                                            self.neighbor_option = value
                                            self.neighbor_option.value_namespace = name_space
                                            self.neighbor_option.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-poll-interval"):
                                            self.next_poll_interval = value
                                            self.next_poll_interval.value_namespace = name_space
                                            self.next_poll_interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pending-events"):
                                            self.pending_events = value
                                            self.pending_events.value_namespace = name_space
                                            self.pending_events.value_namespace_prefix = name_space_prefix
                                        if(value_path == "poll-interval"):
                                            self.poll_interval = value
                                            self.poll_interval.value_namespace = name_space
                                            self.poll_interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-changes"):
                                            self.state_changes = value
                                            self.state_changes.value_namespace = name_space
                                            self.state_changes.value_namespace_prefix = name_space_prefix


                                class NeighborBfdInfo(Entity):
                                    """
                                    Neighbor BFD information
                                    
                                    .. attribute:: bfd_intf_enable_mode
                                    
                                    	BFD enable mode \- Default/Strict
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: bfd_status_flag
                                    
                                    	Status of the BFD Session
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo, self).__init__()

                                        self.yang_name = "neighbor-bfd-info"
                                        self.yang_parent_name = "neighbor-detail"

                                        self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                        self.bfd_status_flag = YLeaf(YType.uint8, "bfd-status-flag")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bfd_intf_enable_mode",
                                                        "bfd_status_flag") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.bfd_intf_enable_mode.is_set or
                                            self.bfd_status_flag.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bfd_intf_enable_mode.yfilter != YFilter.not_set or
                                            self.bfd_status_flag.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "neighbor-bfd-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())
                                        if (self.bfd_status_flag.is_set or self.bfd_status_flag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bfd_status_flag.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bfd-intf-enable-mode" or name == "bfd-status-flag"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bfd-intf-enable-mode"):
                                            self.bfd_intf_enable_mode = value
                                            self.bfd_intf_enable_mode.value_namespace = name_space
                                            self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bfd-status-flag"):
                                            self.bfd_status_flag = value
                                            self.bfd_status_flag.value_namespace = name_space
                                            self.bfd_status_flag.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        self.is_neighbor_sham_link.is_set or
                                        self.is_neighbor_virtual_link.is_set or
                                        self.neighbor_address.is_set or
                                        self.neighbor_address_xr.is_set or
                                        self.neighbor_dead_timer.is_set or
                                        self.neighbor_designated_router.is_set or
                                        self.neighbor_dr_priority.is_set or
                                        self.neighbor_interface_id.is_set or
                                        self.neighbor_sham_link_id.is_set or
                                        self.neighbor_state.is_set or
                                        self.neighbor_up_time.is_set or
                                        self.neighbor_virtual_link_id.is_set or
                                        (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_data()) or
                                        (self.neighbor_detail is not None and self.neighbor_detail.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.is_neighbor_sham_link.yfilter != YFilter.not_set or
                                        self.is_neighbor_virtual_link.yfilter != YFilter.not_set or
                                        self.neighbor_address.yfilter != YFilter.not_set or
                                        self.neighbor_address_xr.yfilter != YFilter.not_set or
                                        self.neighbor_dead_timer.yfilter != YFilter.not_set or
                                        self.neighbor_designated_router.yfilter != YFilter.not_set or
                                        self.neighbor_dr_priority.yfilter != YFilter.not_set or
                                        self.neighbor_interface_id.yfilter != YFilter.not_set or
                                        self.neighbor_sham_link_id.yfilter != YFilter.not_set or
                                        self.neighbor_state.yfilter != YFilter.not_set or
                                        self.neighbor_up_time.yfilter != YFilter.not_set or
                                        self.neighbor_virtual_link_id.yfilter != YFilter.not_set or
                                        (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_operation()) or
                                        (self.neighbor_detail is not None and self.neighbor_detail.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "neighbor-detail" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.is_neighbor_sham_link.is_set or self.is_neighbor_sham_link.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_neighbor_sham_link.get_name_leafdata())
                                    if (self.is_neighbor_virtual_link.is_set or self.is_neighbor_virtual_link.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_neighbor_virtual_link.get_name_leafdata())
                                    if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                    if (self.neighbor_address_xr.is_set or self.neighbor_address_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_address_xr.get_name_leafdata())
                                    if (self.neighbor_dead_timer.is_set or self.neighbor_dead_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_dead_timer.get_name_leafdata())
                                    if (self.neighbor_designated_router.is_set or self.neighbor_designated_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_designated_router.get_name_leafdata())
                                    if (self.neighbor_dr_priority.is_set or self.neighbor_dr_priority.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_dr_priority.get_name_leafdata())
                                    if (self.neighbor_interface_id.is_set or self.neighbor_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_interface_id.get_name_leafdata())
                                    if (self.neighbor_sham_link_id.is_set or self.neighbor_sham_link_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_sham_link_id.get_name_leafdata())
                                    if (self.neighbor_state.is_set or self.neighbor_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_state.get_name_leafdata())
                                    if (self.neighbor_up_time.is_set or self.neighbor_up_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_up_time.get_name_leafdata())
                                    if (self.neighbor_virtual_link_id.is_set or self.neighbor_virtual_link_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_virtual_link_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "neighbor-bfd-info"):
                                        if (self.neighbor_bfd_info is None):
                                            self.neighbor_bfd_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborBfdInfo()
                                            self.neighbor_bfd_info.parent = self
                                            self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                        return self.neighbor_bfd_info

                                    if (child_yang_name == "neighbor-detail"):
                                        if (self.neighbor_detail is None):
                                            self.neighbor_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail.NeighborDetail()
                                            self.neighbor_detail.parent = self
                                            self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                        return self.neighbor_detail

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "neighbor-bfd-info" or name == "neighbor-detail" or name == "interface-name" or name == "is-neighbor-sham-link" or name == "is-neighbor-virtual-link" or name == "neighbor-address" or name == "neighbor-address-xr" or name == "neighbor-dead-timer" or name == "neighbor-designated-router" or name == "neighbor-dr-priority" or name == "neighbor-interface-id" or name == "neighbor-sham-link-id" or name == "neighbor-state" or name == "neighbor-up-time" or name == "neighbor-virtual-link-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-neighbor-sham-link"):
                                        self.is_neighbor_sham_link = value
                                        self.is_neighbor_sham_link.value_namespace = name_space
                                        self.is_neighbor_sham_link.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-neighbor-virtual-link"):
                                        self.is_neighbor_virtual_link = value
                                        self.is_neighbor_virtual_link.value_namespace = name_space
                                        self.is_neighbor_virtual_link.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-address"):
                                        self.neighbor_address = value
                                        self.neighbor_address.value_namespace = name_space
                                        self.neighbor_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-address-xr"):
                                        self.neighbor_address_xr = value
                                        self.neighbor_address_xr.value_namespace = name_space
                                        self.neighbor_address_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-dead-timer"):
                                        self.neighbor_dead_timer = value
                                        self.neighbor_dead_timer.value_namespace = name_space
                                        self.neighbor_dead_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-designated-router"):
                                        self.neighbor_designated_router = value
                                        self.neighbor_designated_router.value_namespace = name_space
                                        self.neighbor_designated_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-dr-priority"):
                                        self.neighbor_dr_priority = value
                                        self.neighbor_dr_priority.value_namespace = name_space
                                        self.neighbor_dr_priority.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-interface-id"):
                                        self.neighbor_interface_id = value
                                        self.neighbor_interface_id.value_namespace = name_space
                                        self.neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-sham-link-id"):
                                        self.neighbor_sham_link_id = value
                                        self.neighbor_sham_link_id.value_namespace = name_space
                                        self.neighbor_sham_link_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-state"):
                                        self.neighbor_state = value
                                        self.neighbor_state.value_namespace = name_space
                                        self.neighbor_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-up-time"):
                                        self.neighbor_up_time = value
                                        self.neighbor_up_time.value_namespace = name_space
                                        self.neighbor_up_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-virtual-link-id"):
                                        self.neighbor_virtual_link_id = value
                                        self.neighbor_virtual_link_id.value_namespace = name_space
                                        self.neighbor_virtual_link_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.neighbor_detail:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.neighbor_detail:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-detail-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "neighbor-detail"):
                                    for c in self.neighbor_detail:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable.NeighborDetail()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.neighbor_detail.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "neighbor-detail"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class InterfaceBriefTable(Entity):
                            """
                            OSPFv3 interface brief information table for
                            an area
                            
                            .. attribute:: interface_brief
                            
                            	Interface brief information
                            	**type**\: list of    :py:class:`InterfaceBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable.InterfaceBrief>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable, self).__init__()

                                self.yang_name = "interface-brief-table"
                                self.yang_parent_name = "area"

                                self.interface_brief = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable, self).__setattr__(name, value)


                            class InterfaceBrief(Entity):
                                """
                                Interface brief information
                                
                                .. attribute:: interface_name  <key>
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: interface_address
                                
                                	Interface IP address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_adjacent_neighbors
                                
                                	Total number of adjacent neighbors
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: interface_link_cost
                                
                                	Interface link cost
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: interface_neighbors
                                
                                	Total number of neighbors 
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: network_type
                                
                                	Network type
                                	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                                
                                .. attribute:: ospf_interface_state
                                
                                	Interface OSPF state
                                	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable.InterfaceBrief, self).__init__()

                                    self.yang_name = "interface-brief"
                                    self.yang_parent_name = "interface-brief-table"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_adjacent_neighbors = YLeaf(YType.uint16, "interface-adjacent-neighbors")

                                    self.interface_link_cost = YLeaf(YType.uint16, "interface-link-cost")

                                    self.interface_neighbors = YLeaf(YType.uint16, "interface-neighbors")

                                    self.network_type = YLeaf(YType.enumeration, "network-type")

                                    self.ospf_interface_state = YLeaf(YType.enumeration, "ospf-interface-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "interface_address",
                                                    "interface_adjacent_neighbors",
                                                    "interface_link_cost",
                                                    "interface_neighbors",
                                                    "network_type",
                                                    "ospf_interface_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable.InterfaceBrief, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable.InterfaceBrief, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        self.interface_address.is_set or
                                        self.interface_adjacent_neighbors.is_set or
                                        self.interface_link_cost.is_set or
                                        self.interface_neighbors.is_set or
                                        self.network_type.is_set or
                                        self.ospf_interface_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_adjacent_neighbors.yfilter != YFilter.not_set or
                                        self.interface_link_cost.yfilter != YFilter.not_set or
                                        self.interface_neighbors.yfilter != YFilter.not_set or
                                        self.network_type.yfilter != YFilter.not_set or
                                        self.ospf_interface_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface-brief" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_adjacent_neighbors.is_set or self.interface_adjacent_neighbors.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_adjacent_neighbors.get_name_leafdata())
                                    if (self.interface_link_cost.is_set or self.interface_link_cost.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_link_cost.get_name_leafdata())
                                    if (self.interface_neighbors.is_set or self.interface_neighbors.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_neighbors.get_name_leafdata())
                                    if (self.network_type.is_set or self.network_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.network_type.get_name_leafdata())
                                    if (self.ospf_interface_state.is_set or self.ospf_interface_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ospf_interface_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-name" or name == "interface-address" or name == "interface-adjacent-neighbors" or name == "interface-link-cost" or name == "interface-neighbors" or name == "network-type" or name == "ospf-interface-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-adjacent-neighbors"):
                                        self.interface_adjacent_neighbors = value
                                        self.interface_adjacent_neighbors.value_namespace = name_space
                                        self.interface_adjacent_neighbors.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-link-cost"):
                                        self.interface_link_cost = value
                                        self.interface_link_cost.value_namespace = name_space
                                        self.interface_link_cost.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-neighbors"):
                                        self.interface_neighbors = value
                                        self.interface_neighbors.value_namespace = name_space
                                        self.interface_neighbors.value_namespace_prefix = name_space_prefix
                                    if(value_path == "network-type"):
                                        self.network_type = value
                                        self.network_type.value_namespace = name_space
                                        self.network_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ospf-interface-state"):
                                        self.ospf_interface_state = value
                                        self.ospf_interface_state.value_namespace = name_space
                                        self.ospf_interface_state.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.interface_brief:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.interface_brief:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interface-brief-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "interface-brief"):
                                    for c in self.interface_brief:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable.InterfaceBrief()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.interface_brief.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "interface-brief"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class RequestListTable(Entity):
                            """
                            OSPFv3 request list information in an area
                            
                            .. attribute:: request
                            
                            	OSPFv3 request list information
                            	**type**\: list of    :py:class:`Request <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable.Request>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable, self).__init__()

                                self.yang_name = "request-list-table"
                                self.yang_parent_name = "area"

                                self.request = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable, self).__setattr__(name, value)


                            class Request(Entity):
                                """
                                OSPFv3 request list information
                                
                                .. attribute:: interface_name
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: is_request_sham_link
                                
                                	If true, sham link is requested 
                                	**type**\:  bool
                                
                                .. attribute:: is_request_virtual_link
                                
                                	If true, virtual link is requested 
                                	**type**\:  bool
                                
                                .. attribute:: neighbor_address
                                
                                	Neighbor address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: request
                                
                                	List of request list entries
                                	**type**\: list of    :py:class:`Request <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable.Request.Request>`
                                
                                .. attribute:: request_neighbor_address
                                
                                	Neighbor IP address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: request_sham_link_id
                                
                                	Request sham link ID 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: request_virtual_link_id
                                
                                	Request virtual link ID 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable.Request, self).__init__()

                                    self.yang_name = "request"
                                    self.yang_parent_name = "request-list-table"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.is_request_sham_link = YLeaf(YType.boolean, "is-request-sham-link")

                                    self.is_request_virtual_link = YLeaf(YType.boolean, "is-request-virtual-link")

                                    self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                    self.request_neighbor_address = YLeaf(YType.str, "request-neighbor-address")

                                    self.request_sham_link_id = YLeaf(YType.uint32, "request-sham-link-id")

                                    self.request_virtual_link_id = YLeaf(YType.uint32, "request-virtual-link-id")

                                    self.request = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "is_request_sham_link",
                                                    "is_request_virtual_link",
                                                    "neighbor_address",
                                                    "request_neighbor_address",
                                                    "request_sham_link_id",
                                                    "request_virtual_link_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable.Request, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable.Request, self).__setattr__(name, value)


                                class Request(Entity):
                                    """
                                    List of request list entries
                                    
                                    .. attribute:: header_advertising_router
                                    
                                    	Router ID of the advertising router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_age
                                    
                                    	Age of the LSA (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: header_lsa_id
                                    
                                    	LSA ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_type
                                    
                                    	LSA type
                                    	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                    
                                    .. attribute:: header_sequence_number
                                    
                                    	Current LSA sequence number
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable.Request.Request, self).__init__()

                                        self.yang_name = "request"
                                        self.yang_parent_name = "request"

                                        self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                        self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                        self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                        self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                        self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("header_advertising_router",
                                                        "header_lsa_age",
                                                        "header_lsa_id",
                                                        "header_lsa_type",
                                                        "header_sequence_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable.Request.Request, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable.Request.Request, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.header_advertising_router.is_set or
                                            self.header_lsa_age.is_set or
                                            self.header_lsa_id.is_set or
                                            self.header_lsa_type.is_set or
                                            self.header_sequence_number.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.header_advertising_router.yfilter != YFilter.not_set or
                                            self.header_lsa_age.yfilter != YFilter.not_set or
                                            self.header_lsa_id.yfilter != YFilter.not_set or
                                            self.header_lsa_type.yfilter != YFilter.not_set or
                                            self.header_sequence_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "request" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                        if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                        if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                        if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                        if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "header-advertising-router"):
                                            self.header_advertising_router = value
                                            self.header_advertising_router.value_namespace = name_space
                                            self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-age"):
                                            self.header_lsa_age = value
                                            self.header_lsa_age.value_namespace = name_space
                                            self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-id"):
                                            self.header_lsa_id = value
                                            self.header_lsa_id.value_namespace = name_space
                                            self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-type"):
                                            self.header_lsa_type = value
                                            self.header_lsa_type.value_namespace = name_space
                                            self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-sequence-number"):
                                            self.header_sequence_number = value
                                            self.header_sequence_number.value_namespace = name_space
                                            self.header_sequence_number.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.request:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.interface_name.is_set or
                                        self.is_request_sham_link.is_set or
                                        self.is_request_virtual_link.is_set or
                                        self.neighbor_address.is_set or
                                        self.request_neighbor_address.is_set or
                                        self.request_sham_link_id.is_set or
                                        self.request_virtual_link_id.is_set)

                                def has_operation(self):
                                    for c in self.request:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.is_request_sham_link.yfilter != YFilter.not_set or
                                        self.is_request_virtual_link.yfilter != YFilter.not_set or
                                        self.neighbor_address.yfilter != YFilter.not_set or
                                        self.request_neighbor_address.yfilter != YFilter.not_set or
                                        self.request_sham_link_id.yfilter != YFilter.not_set or
                                        self.request_virtual_link_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "request" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.is_request_sham_link.is_set or self.is_request_sham_link.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_request_sham_link.get_name_leafdata())
                                    if (self.is_request_virtual_link.is_set or self.is_request_virtual_link.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_request_virtual_link.get_name_leafdata())
                                    if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                    if (self.request_neighbor_address.is_set or self.request_neighbor_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.request_neighbor_address.get_name_leafdata())
                                    if (self.request_sham_link_id.is_set or self.request_sham_link_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.request_sham_link_id.get_name_leafdata())
                                    if (self.request_virtual_link_id.is_set or self.request_virtual_link_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.request_virtual_link_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "request"):
                                        for c in self.request:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable.Request.Request()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.request.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "request" or name == "interface-name" or name == "is-request-sham-link" or name == "is-request-virtual-link" or name == "neighbor-address" or name == "request-neighbor-address" or name == "request-sham-link-id" or name == "request-virtual-link-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-request-sham-link"):
                                        self.is_request_sham_link = value
                                        self.is_request_sham_link.value_namespace = name_space
                                        self.is_request_sham_link.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-request-virtual-link"):
                                        self.is_request_virtual_link = value
                                        self.is_request_virtual_link.value_namespace = name_space
                                        self.is_request_virtual_link.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-address"):
                                        self.neighbor_address = value
                                        self.neighbor_address.value_namespace = name_space
                                        self.neighbor_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "request-neighbor-address"):
                                        self.request_neighbor_address = value
                                        self.request_neighbor_address.value_namespace = name_space
                                        self.request_neighbor_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "request-sham-link-id"):
                                        self.request_sham_link_id = value
                                        self.request_sham_link_id.value_namespace = name_space
                                        self.request_sham_link_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "request-virtual-link-id"):
                                        self.request_virtual_link_id = value
                                        self.request_virtual_link_id.value_namespace = name_space
                                        self.request_virtual_link_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.request:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.request:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "request-list-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "request"):
                                    for c in self.request:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable.Request()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.request.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "request"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class NeighborTable(Entity):
                            """
                            OSPFv3 neighbor information table
                            
                            .. attribute:: neighbor
                            
                            	OSPFv3 neighbor detail information
                            	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable, self).__init__()

                                self.yang_name = "neighbor-table"
                                self.yang_parent_name = "area"

                                self.neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable, self).__setattr__(name, value)


                            class Neighbor(Entity):
                                """
                                OSPFv3 neighbor detail information
                                
                                .. attribute:: interface_name
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: is_neighbor_sham_link
                                
                                	If true, neighbor is on a sham link 
                                	**type**\:  bool
                                
                                .. attribute:: is_neighbor_virtual_link
                                
                                	If true, neighbor is on a virtual link 
                                	**type**\:  bool
                                
                                .. attribute:: neighbor_address
                                
                                	Neighbor ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: neighbor_address_xr
                                
                                	Neighbor IP Address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: neighbor_bfd_info
                                
                                	Neighbor BFD information
                                	**type**\:   :py:class:`NeighborBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo>`
                                
                                .. attribute:: neighbor_dead_timer
                                
                                	Time until neighbor's dead timer expires (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: neighbor_designated_router
                                
                                	Designated router 
                                	**type**\:  str
                                
                                	**length:** 0..9
                                
                                .. attribute:: neighbor_detail
                                
                                	Detailed OSPFv3 neighbor information 
                                	**type**\:   :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail>`
                                
                                .. attribute:: neighbor_dr_priority
                                
                                	Neighbor's DR priority
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: neighbor_interface_id
                                
                                	Neighbor interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_sham_link_id
                                
                                	Neighbor sham link id 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_state
                                
                                	Neighbor's state
                                	**type**\:   :py:class:`Ospfv3NeighborState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3NeighborState>`
                                
                                .. attribute:: neighbor_up_time
                                
                                	Amount of time since the adjacency is up (seconds)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: neighbor_virtual_link_id
                                
                                	Neighbor virtual link id 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor, self).__init__()

                                    self.yang_name = "neighbor"
                                    self.yang_parent_name = "neighbor-table"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.is_neighbor_sham_link = YLeaf(YType.boolean, "is-neighbor-sham-link")

                                    self.is_neighbor_virtual_link = YLeaf(YType.boolean, "is-neighbor-virtual-link")

                                    self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                    self.neighbor_address_xr = YLeaf(YType.str, "neighbor-address-xr")

                                    self.neighbor_dead_timer = YLeaf(YType.uint32, "neighbor-dead-timer")

                                    self.neighbor_designated_router = YLeaf(YType.str, "neighbor-designated-router")

                                    self.neighbor_dr_priority = YLeaf(YType.uint8, "neighbor-dr-priority")

                                    self.neighbor_interface_id = YLeaf(YType.uint32, "neighbor-interface-id")

                                    self.neighbor_sham_link_id = YLeaf(YType.uint32, "neighbor-sham-link-id")

                                    self.neighbor_state = YLeaf(YType.enumeration, "neighbor-state")

                                    self.neighbor_up_time = YLeaf(YType.uint32, "neighbor-up-time")

                                    self.neighbor_virtual_link_id = YLeaf(YType.uint32, "neighbor-virtual-link-id")

                                    self.neighbor_bfd_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo()
                                    self.neighbor_bfd_info.parent = self
                                    self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                    self._children_yang_names.add("neighbor-bfd-info")

                                    self.neighbor_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail()
                                    self.neighbor_detail.parent = self
                                    self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                    self._children_yang_names.add("neighbor-detail")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "is_neighbor_sham_link",
                                                    "is_neighbor_virtual_link",
                                                    "neighbor_address",
                                                    "neighbor_address_xr",
                                                    "neighbor_dead_timer",
                                                    "neighbor_designated_router",
                                                    "neighbor_dr_priority",
                                                    "neighbor_interface_id",
                                                    "neighbor_sham_link_id",
                                                    "neighbor_state",
                                                    "neighbor_up_time",
                                                    "neighbor_virtual_link_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor, self).__setattr__(name, value)


                                class NeighborDetail(Entity):
                                    """
                                    Detailed OSPFv3 neighbor information 
                                    
                                    .. attribute:: interface_type
                                    
                                    	Interface type
                                    	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                                    
                                    .. attribute:: is_neighbor_filtered
                                    
                                    	If true, filter outgoing LSAs 
                                    	**type**\:  bool
                                    
                                    .. attribute:: neighbor_backup_designated_router_address
                                    
                                    	Address of backup designated router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: neighbor_cost
                                    
                                    	Cost of path to this neighbor 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: neighbor_designated_router_address
                                    
                                    	Address of designated router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: neighbor_ignore_timer
                                    
                                    	Remaining time when ignore timer is running 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_option
                                    
                                    	 This is bitmask of neighbor's option field received 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_retransmission
                                    
                                    	Retransmission information with this neighbor
                                    	**type**\:   :py:class:`NeighborRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission>`
                                    
                                    .. attribute:: next_poll_interval
                                    
                                    	For NBMA networks, amount of time remaining in seconds before the next poll interval expires and Hello is sent (s)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: pending_events
                                    
                                    	Number of pending events 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: poll_interval
                                    
                                    	Poll interval (s)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state_changes
                                    
                                    	Number of state changes 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail, self).__init__()

                                        self.yang_name = "neighbor-detail"
                                        self.yang_parent_name = "neighbor"

                                        self.interface_type = YLeaf(YType.enumeration, "interface-type")

                                        self.is_neighbor_filtered = YLeaf(YType.boolean, "is-neighbor-filtered")

                                        self.neighbor_backup_designated_router_address = YLeaf(YType.str, "neighbor-backup-designated-router-address")

                                        self.neighbor_cost = YLeaf(YType.uint16, "neighbor-cost")

                                        self.neighbor_designated_router_address = YLeaf(YType.str, "neighbor-designated-router-address")

                                        self.neighbor_ignore_timer = YLeaf(YType.uint32, "neighbor-ignore-timer")

                                        self.neighbor_option = YLeaf(YType.uint32, "neighbor-option")

                                        self.next_poll_interval = YLeaf(YType.uint32, "next-poll-interval")

                                        self.pending_events = YLeaf(YType.uint16, "pending-events")

                                        self.poll_interval = YLeaf(YType.uint32, "poll-interval")

                                        self.state_changes = YLeaf(YType.uint16, "state-changes")

                                        self.neighbor_retransmission = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission()
                                        self.neighbor_retransmission.parent = self
                                        self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                        self._children_yang_names.add("neighbor-retransmission")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_type",
                                                        "is_neighbor_filtered",
                                                        "neighbor_backup_designated_router_address",
                                                        "neighbor_cost",
                                                        "neighbor_designated_router_address",
                                                        "neighbor_ignore_timer",
                                                        "neighbor_option",
                                                        "next_poll_interval",
                                                        "pending_events",
                                                        "poll_interval",
                                                        "state_changes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail, self).__setattr__(name, value)


                                    class NeighborRetransmission(Entity):
                                        """
                                        Retransmission information with this neighbor
                                        
                                        .. attribute:: area_first_flood
                                        
                                        	First flood item for area scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: area_first_flood_index
                                        
                                        	Index of the first flood item for area scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: area_flood_index
                                        
                                        	Area scope LSA's flood index
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: area_next_flood
                                        
                                        	Next flood item for area scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: area_next_flood_index
                                        
                                        	Index of next flood item for Area scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: as_first_flood
                                        
                                        	First flood item for AS scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: as_first_flood_index
                                        
                                        	Index for first flood item for AS scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: as_flood_index
                                        
                                        	AS scope LSA's flood index
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: as_next_flood
                                        
                                        	Next flood item for AS scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: as_next_flood_index
                                        
                                        	Index of next flood item for AS scope LSAs
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: database_descriptor_retransmissions
                                        
                                        	Number of database descriptor retransmissions during last exchange
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: last_retransmission_length
                                        
                                        	Number of LSAs sent in last retransmission
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: last_retransmission_time
                                        
                                        	Last retransmission scan time (ms)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_first_flood
                                        
                                        	Link first flood information 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_first_flood_index
                                        
                                        	Link first flood information index
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_flood_index
                                        
                                        	Link flood index
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_next_flood
                                        
                                        	Link next flood information 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: link_next_flood_index
                                        
                                        	Link next flood information index 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_retransmission_timer
                                        
                                        	Time until next LSA retransmission (ms)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: maximum_retransmission_length
                                        
                                        	Maximum number of LSAs sent in a retransmission
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: maximum_retransmission_time
                                        
                                        	Maximum retransmission scan time (ms)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: neighbor_retransmissions
                                        
                                        	Number of neighbor retransmissions 
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: retransmissions
                                        
                                        	Number of retransmissions for this neighbor
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__init__()

                                            self.yang_name = "neighbor-retransmission"
                                            self.yang_parent_name = "neighbor-detail"

                                            self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                            self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                            self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                            self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                            self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                            self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                            self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                            self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                            self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                            self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                            self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                            self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                            self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                            self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                            self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                            self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                            self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                            self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                            self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                            self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                            self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                            self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                            self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("area_first_flood",
                                                            "area_first_flood_index",
                                                            "area_flood_index",
                                                            "area_next_flood",
                                                            "area_next_flood_index",
                                                            "as_first_flood",
                                                            "as_first_flood_index",
                                                            "as_flood_index",
                                                            "as_next_flood",
                                                            "as_next_flood_index",
                                                            "database_descriptor_retransmissions",
                                                            "last_retransmission_length",
                                                            "last_retransmission_time",
                                                            "link_first_flood",
                                                            "link_first_flood_index",
                                                            "link_flood_index",
                                                            "link_next_flood",
                                                            "link_next_flood_index",
                                                            "lsa_retransmission_timer",
                                                            "maximum_retransmission_length",
                                                            "maximum_retransmission_time",
                                                            "neighbor_retransmissions",
                                                            "retransmissions") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.area_first_flood.is_set or
                                                self.area_first_flood_index.is_set or
                                                self.area_flood_index.is_set or
                                                self.area_next_flood.is_set or
                                                self.area_next_flood_index.is_set or
                                                self.as_first_flood.is_set or
                                                self.as_first_flood_index.is_set or
                                                self.as_flood_index.is_set or
                                                self.as_next_flood.is_set or
                                                self.as_next_flood_index.is_set or
                                                self.database_descriptor_retransmissions.is_set or
                                                self.last_retransmission_length.is_set or
                                                self.last_retransmission_time.is_set or
                                                self.link_first_flood.is_set or
                                                self.link_first_flood_index.is_set or
                                                self.link_flood_index.is_set or
                                                self.link_next_flood.is_set or
                                                self.link_next_flood_index.is_set or
                                                self.lsa_retransmission_timer.is_set or
                                                self.maximum_retransmission_length.is_set or
                                                self.maximum_retransmission_time.is_set or
                                                self.neighbor_retransmissions.is_set or
                                                self.retransmissions.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.area_first_flood.yfilter != YFilter.not_set or
                                                self.area_first_flood_index.yfilter != YFilter.not_set or
                                                self.area_flood_index.yfilter != YFilter.not_set or
                                                self.area_next_flood.yfilter != YFilter.not_set or
                                                self.area_next_flood_index.yfilter != YFilter.not_set or
                                                self.as_first_flood.yfilter != YFilter.not_set or
                                                self.as_first_flood_index.yfilter != YFilter.not_set or
                                                self.as_flood_index.yfilter != YFilter.not_set or
                                                self.as_next_flood.yfilter != YFilter.not_set or
                                                self.as_next_flood_index.yfilter != YFilter.not_set or
                                                self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                                self.last_retransmission_length.yfilter != YFilter.not_set or
                                                self.last_retransmission_time.yfilter != YFilter.not_set or
                                                self.link_first_flood.yfilter != YFilter.not_set or
                                                self.link_first_flood_index.yfilter != YFilter.not_set or
                                                self.link_flood_index.yfilter != YFilter.not_set or
                                                self.link_next_flood.yfilter != YFilter.not_set or
                                                self.link_next_flood_index.yfilter != YFilter.not_set or
                                                self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                                self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                                self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                                self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                                self.retransmissions.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "neighbor-retransmission" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                            if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                            if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                            if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                            if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                            if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                            if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                            if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                            if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                            if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                            if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                            if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                            if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                            if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                            if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                            if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                            if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                            if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                            if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                            if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                            if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                            if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                            if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "area-first-flood"):
                                                self.area_first_flood = value
                                                self.area_first_flood.value_namespace = name_space
                                                self.area_first_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "area-first-flood-index"):
                                                self.area_first_flood_index = value
                                                self.area_first_flood_index.value_namespace = name_space
                                                self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "area-flood-index"):
                                                self.area_flood_index = value
                                                self.area_flood_index.value_namespace = name_space
                                                self.area_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "area-next-flood"):
                                                self.area_next_flood = value
                                                self.area_next_flood.value_namespace = name_space
                                                self.area_next_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "area-next-flood-index"):
                                                self.area_next_flood_index = value
                                                self.area_next_flood_index.value_namespace = name_space
                                                self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "as-first-flood"):
                                                self.as_first_flood = value
                                                self.as_first_flood.value_namespace = name_space
                                                self.as_first_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "as-first-flood-index"):
                                                self.as_first_flood_index = value
                                                self.as_first_flood_index.value_namespace = name_space
                                                self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "as-flood-index"):
                                                self.as_flood_index = value
                                                self.as_flood_index.value_namespace = name_space
                                                self.as_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "as-next-flood"):
                                                self.as_next_flood = value
                                                self.as_next_flood.value_namespace = name_space
                                                self.as_next_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "as-next-flood-index"):
                                                self.as_next_flood_index = value
                                                self.as_next_flood_index.value_namespace = name_space
                                                self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "database-descriptor-retransmissions"):
                                                self.database_descriptor_retransmissions = value
                                                self.database_descriptor_retransmissions.value_namespace = name_space
                                                self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-retransmission-length"):
                                                self.last_retransmission_length = value
                                                self.last_retransmission_length.value_namespace = name_space
                                                self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-retransmission-time"):
                                                self.last_retransmission_time = value
                                                self.last_retransmission_time.value_namespace = name_space
                                                self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-first-flood"):
                                                self.link_first_flood = value
                                                self.link_first_flood.value_namespace = name_space
                                                self.link_first_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-first-flood-index"):
                                                self.link_first_flood_index = value
                                                self.link_first_flood_index.value_namespace = name_space
                                                self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-flood-index"):
                                                self.link_flood_index = value
                                                self.link_flood_index.value_namespace = name_space
                                                self.link_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-next-flood"):
                                                self.link_next_flood = value
                                                self.link_next_flood.value_namespace = name_space
                                                self.link_next_flood.value_namespace_prefix = name_space_prefix
                                            if(value_path == "link-next-flood-index"):
                                                self.link_next_flood_index = value
                                                self.link_next_flood_index.value_namespace = name_space
                                                self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsa-retransmission-timer"):
                                                self.lsa_retransmission_timer = value
                                                self.lsa_retransmission_timer.value_namespace = name_space
                                                self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                            if(value_path == "maximum-retransmission-length"):
                                                self.maximum_retransmission_length = value
                                                self.maximum_retransmission_length.value_namespace = name_space
                                                self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "maximum-retransmission-time"):
                                                self.maximum_retransmission_time = value
                                                self.maximum_retransmission_time.value_namespace = name_space
                                                self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-retransmissions"):
                                                self.neighbor_retransmissions = value
                                                self.neighbor_retransmissions.value_namespace = name_space
                                                self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                            if(value_path == "retransmissions"):
                                                self.retransmissions = value
                                                self.retransmissions.value_namespace = name_space
                                                self.retransmissions.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.interface_type.is_set or
                                            self.is_neighbor_filtered.is_set or
                                            self.neighbor_backup_designated_router_address.is_set or
                                            self.neighbor_cost.is_set or
                                            self.neighbor_designated_router_address.is_set or
                                            self.neighbor_ignore_timer.is_set or
                                            self.neighbor_option.is_set or
                                            self.next_poll_interval.is_set or
                                            self.pending_events.is_set or
                                            self.poll_interval.is_set or
                                            self.state_changes.is_set or
                                            (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_type.yfilter != YFilter.not_set or
                                            self.is_neighbor_filtered.yfilter != YFilter.not_set or
                                            self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set or
                                            self.neighbor_cost.yfilter != YFilter.not_set or
                                            self.neighbor_designated_router_address.yfilter != YFilter.not_set or
                                            self.neighbor_ignore_timer.yfilter != YFilter.not_set or
                                            self.neighbor_option.yfilter != YFilter.not_set or
                                            self.next_poll_interval.yfilter != YFilter.not_set or
                                            self.pending_events.yfilter != YFilter.not_set or
                                            self.poll_interval.yfilter != YFilter.not_set or
                                            self.state_changes.yfilter != YFilter.not_set or
                                            (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "neighbor-detail" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_type.is_set or self.interface_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_type.get_name_leafdata())
                                        if (self.is_neighbor_filtered.is_set or self.is_neighbor_filtered.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_neighbor_filtered.get_name_leafdata())
                                        if (self.neighbor_backup_designated_router_address.is_set or self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_backup_designated_router_address.get_name_leafdata())
                                        if (self.neighbor_cost.is_set or self.neighbor_cost.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_cost.get_name_leafdata())
                                        if (self.neighbor_designated_router_address.is_set or self.neighbor_designated_router_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_designated_router_address.get_name_leafdata())
                                        if (self.neighbor_ignore_timer.is_set or self.neighbor_ignore_timer.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_ignore_timer.get_name_leafdata())
                                        if (self.neighbor_option.is_set or self.neighbor_option.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_option.get_name_leafdata())
                                        if (self.next_poll_interval.is_set or self.next_poll_interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_poll_interval.get_name_leafdata())
                                        if (self.pending_events.is_set or self.pending_events.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pending_events.get_name_leafdata())
                                        if (self.poll_interval.is_set or self.poll_interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.poll_interval.get_name_leafdata())
                                        if (self.state_changes.is_set or self.state_changes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_changes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "neighbor-retransmission"):
                                            if (self.neighbor_retransmission is None):
                                                self.neighbor_retransmission = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail.NeighborRetransmission()
                                                self.neighbor_retransmission.parent = self
                                                self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                            return self.neighbor_retransmission

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "neighbor-retransmission" or name == "interface-type" or name == "is-neighbor-filtered" or name == "neighbor-backup-designated-router-address" or name == "neighbor-cost" or name == "neighbor-designated-router-address" or name == "neighbor-ignore-timer" or name == "neighbor-option" or name == "next-poll-interval" or name == "pending-events" or name == "poll-interval" or name == "state-changes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-type"):
                                            self.interface_type = value
                                            self.interface_type.value_namespace = name_space
                                            self.interface_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-neighbor-filtered"):
                                            self.is_neighbor_filtered = value
                                            self.is_neighbor_filtered.value_namespace = name_space
                                            self.is_neighbor_filtered.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-backup-designated-router-address"):
                                            self.neighbor_backup_designated_router_address = value
                                            self.neighbor_backup_designated_router_address.value_namespace = name_space
                                            self.neighbor_backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-cost"):
                                            self.neighbor_cost = value
                                            self.neighbor_cost.value_namespace = name_space
                                            self.neighbor_cost.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-designated-router-address"):
                                            self.neighbor_designated_router_address = value
                                            self.neighbor_designated_router_address.value_namespace = name_space
                                            self.neighbor_designated_router_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-ignore-timer"):
                                            self.neighbor_ignore_timer = value
                                            self.neighbor_ignore_timer.value_namespace = name_space
                                            self.neighbor_ignore_timer.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-option"):
                                            self.neighbor_option = value
                                            self.neighbor_option.value_namespace = name_space
                                            self.neighbor_option.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-poll-interval"):
                                            self.next_poll_interval = value
                                            self.next_poll_interval.value_namespace = name_space
                                            self.next_poll_interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pending-events"):
                                            self.pending_events = value
                                            self.pending_events.value_namespace = name_space
                                            self.pending_events.value_namespace_prefix = name_space_prefix
                                        if(value_path == "poll-interval"):
                                            self.poll_interval = value
                                            self.poll_interval.value_namespace = name_space
                                            self.poll_interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-changes"):
                                            self.state_changes = value
                                            self.state_changes.value_namespace = name_space
                                            self.state_changes.value_namespace_prefix = name_space_prefix


                                class NeighborBfdInfo(Entity):
                                    """
                                    Neighbor BFD information
                                    
                                    .. attribute:: bfd_intf_enable_mode
                                    
                                    	BFD enable mode \- Default/Strict
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: bfd_status_flag
                                    
                                    	Status of the BFD Session
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo, self).__init__()

                                        self.yang_name = "neighbor-bfd-info"
                                        self.yang_parent_name = "neighbor"

                                        self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                        self.bfd_status_flag = YLeaf(YType.uint8, "bfd-status-flag")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bfd_intf_enable_mode",
                                                        "bfd_status_flag") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.bfd_intf_enable_mode.is_set or
                                            self.bfd_status_flag.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bfd_intf_enable_mode.yfilter != YFilter.not_set or
                                            self.bfd_status_flag.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "neighbor-bfd-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())
                                        if (self.bfd_status_flag.is_set or self.bfd_status_flag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bfd_status_flag.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bfd-intf-enable-mode" or name == "bfd-status-flag"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bfd-intf-enable-mode"):
                                            self.bfd_intf_enable_mode = value
                                            self.bfd_intf_enable_mode.value_namespace = name_space
                                            self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bfd-status-flag"):
                                            self.bfd_status_flag = value
                                            self.bfd_status_flag.value_namespace = name_space
                                            self.bfd_status_flag.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        self.is_neighbor_sham_link.is_set or
                                        self.is_neighbor_virtual_link.is_set or
                                        self.neighbor_address.is_set or
                                        self.neighbor_address_xr.is_set or
                                        self.neighbor_dead_timer.is_set or
                                        self.neighbor_designated_router.is_set or
                                        self.neighbor_dr_priority.is_set or
                                        self.neighbor_interface_id.is_set or
                                        self.neighbor_sham_link_id.is_set or
                                        self.neighbor_state.is_set or
                                        self.neighbor_up_time.is_set or
                                        self.neighbor_virtual_link_id.is_set or
                                        (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_data()) or
                                        (self.neighbor_detail is not None and self.neighbor_detail.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.is_neighbor_sham_link.yfilter != YFilter.not_set or
                                        self.is_neighbor_virtual_link.yfilter != YFilter.not_set or
                                        self.neighbor_address.yfilter != YFilter.not_set or
                                        self.neighbor_address_xr.yfilter != YFilter.not_set or
                                        self.neighbor_dead_timer.yfilter != YFilter.not_set or
                                        self.neighbor_designated_router.yfilter != YFilter.not_set or
                                        self.neighbor_dr_priority.yfilter != YFilter.not_set or
                                        self.neighbor_interface_id.yfilter != YFilter.not_set or
                                        self.neighbor_sham_link_id.yfilter != YFilter.not_set or
                                        self.neighbor_state.yfilter != YFilter.not_set or
                                        self.neighbor_up_time.yfilter != YFilter.not_set or
                                        self.neighbor_virtual_link_id.yfilter != YFilter.not_set or
                                        (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_operation()) or
                                        (self.neighbor_detail is not None and self.neighbor_detail.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.is_neighbor_sham_link.is_set or self.is_neighbor_sham_link.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_neighbor_sham_link.get_name_leafdata())
                                    if (self.is_neighbor_virtual_link.is_set or self.is_neighbor_virtual_link.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_neighbor_virtual_link.get_name_leafdata())
                                    if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                    if (self.neighbor_address_xr.is_set or self.neighbor_address_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_address_xr.get_name_leafdata())
                                    if (self.neighbor_dead_timer.is_set or self.neighbor_dead_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_dead_timer.get_name_leafdata())
                                    if (self.neighbor_designated_router.is_set or self.neighbor_designated_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_designated_router.get_name_leafdata())
                                    if (self.neighbor_dr_priority.is_set or self.neighbor_dr_priority.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_dr_priority.get_name_leafdata())
                                    if (self.neighbor_interface_id.is_set or self.neighbor_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_interface_id.get_name_leafdata())
                                    if (self.neighbor_sham_link_id.is_set or self.neighbor_sham_link_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_sham_link_id.get_name_leafdata())
                                    if (self.neighbor_state.is_set or self.neighbor_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_state.get_name_leafdata())
                                    if (self.neighbor_up_time.is_set or self.neighbor_up_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_up_time.get_name_leafdata())
                                    if (self.neighbor_virtual_link_id.is_set or self.neighbor_virtual_link_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_virtual_link_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "neighbor-bfd-info"):
                                        if (self.neighbor_bfd_info is None):
                                            self.neighbor_bfd_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborBfdInfo()
                                            self.neighbor_bfd_info.parent = self
                                            self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                        return self.neighbor_bfd_info

                                    if (child_yang_name == "neighbor-detail"):
                                        if (self.neighbor_detail is None):
                                            self.neighbor_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor.NeighborDetail()
                                            self.neighbor_detail.parent = self
                                            self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                        return self.neighbor_detail

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "neighbor-bfd-info" or name == "neighbor-detail" or name == "interface-name" or name == "is-neighbor-sham-link" or name == "is-neighbor-virtual-link" or name == "neighbor-address" or name == "neighbor-address-xr" or name == "neighbor-dead-timer" or name == "neighbor-designated-router" or name == "neighbor-dr-priority" or name == "neighbor-interface-id" or name == "neighbor-sham-link-id" or name == "neighbor-state" or name == "neighbor-up-time" or name == "neighbor-virtual-link-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-neighbor-sham-link"):
                                        self.is_neighbor_sham_link = value
                                        self.is_neighbor_sham_link.value_namespace = name_space
                                        self.is_neighbor_sham_link.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-neighbor-virtual-link"):
                                        self.is_neighbor_virtual_link = value
                                        self.is_neighbor_virtual_link.value_namespace = name_space
                                        self.is_neighbor_virtual_link.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-address"):
                                        self.neighbor_address = value
                                        self.neighbor_address.value_namespace = name_space
                                        self.neighbor_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-address-xr"):
                                        self.neighbor_address_xr = value
                                        self.neighbor_address_xr.value_namespace = name_space
                                        self.neighbor_address_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-dead-timer"):
                                        self.neighbor_dead_timer = value
                                        self.neighbor_dead_timer.value_namespace = name_space
                                        self.neighbor_dead_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-designated-router"):
                                        self.neighbor_designated_router = value
                                        self.neighbor_designated_router.value_namespace = name_space
                                        self.neighbor_designated_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-dr-priority"):
                                        self.neighbor_dr_priority = value
                                        self.neighbor_dr_priority.value_namespace = name_space
                                        self.neighbor_dr_priority.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-interface-id"):
                                        self.neighbor_interface_id = value
                                        self.neighbor_interface_id.value_namespace = name_space
                                        self.neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-sham-link-id"):
                                        self.neighbor_sham_link_id = value
                                        self.neighbor_sham_link_id.value_namespace = name_space
                                        self.neighbor_sham_link_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-state"):
                                        self.neighbor_state = value
                                        self.neighbor_state.value_namespace = name_space
                                        self.neighbor_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-up-time"):
                                        self.neighbor_up_time = value
                                        self.neighbor_up_time.value_namespace = name_space
                                        self.neighbor_up_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-virtual-link-id"):
                                        self.neighbor_virtual_link_id = value
                                        self.neighbor_virtual_link_id.value_namespace = name_space
                                        self.neighbor_virtual_link_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.neighbor:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.neighbor:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "neighbor"):
                                    for c in self.neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable.Neighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "neighbor"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class InterfaceTable(Entity):
                            """
                            OSPFv3 interface information table for an area
                            
                            .. attribute:: interface
                            
                            	OSPFv3 interface information
                            	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable, self).__init__()

                                self.yang_name = "interface-table"
                                self.yang_parent_name = "area"

                                self.interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable, self).__setattr__(name, value)


                            class Interface(Entity):
                                """
                                OSPFv3 interface information
                                
                                .. attribute:: interface_name  <key>
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: active_interface
                                
                                	Active interface details 
                                	**type**\:   :py:class:`ActiveInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.ActiveInterface>`
                                
                                .. attribute:: adjacent_neighbor
                                
                                	Number of adjacent neighbors
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: backup_designated_router_address
                                
                                	Backup designated router interface address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: backup_designated_router_id
                                
                                	Backup designated router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: configured_ldp_sync
                                
                                	If true, configured as LDP sync
                                	**type**\:  bool
                                
                                .. attribute:: dead_interval
                                
                                	Configured dead interval (s) 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: designated_router_address
                                
                                	Designated router interface address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: designated_router_id
                                
                                	Designated router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: hello_interval
                                
                                	Configured hello interval (s)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_address
                                
                                	Interface IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_authentication_spi
                                
                                	Interface authentication spi 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_authentication_transmit
                                
                                	Interface authentication transmit 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_bfd
                                
                                	BFD information 
                                	**type**\:   :py:class:`InterfaceBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd>`
                                
                                .. attribute:: interface_dc_bitless_ls_as
                                
                                	Number of LSAs with demand circuit bit not set for the area in which the interface is running
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_encrypted_authentication_transmitted
                                
                                	Interface encrypted authentication transmitted 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_encryption_spi
                                
                                	Interface encryption spi
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_encryption_transmitted
                                
                                	Interface encryption transmitted 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_ldp_sync
                                
                                	If true, interface LDP sync is achieved
                                	**type**\:  bool
                                
                                .. attribute:: interface_link_cost
                                
                                	Interface link cost
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: interface_neighbor
                                
                                	Information for neighbors on the interface
                                	**type**\: list of    :py:class:`InterfaceNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceNeighbor>`
                                
                                .. attribute:: interface_number
                                
                                	Interface number 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_priority
                                
                                	Interface priority
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: interface_references
                                
                                	Interface reference count 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_retransmission_interval
                                
                                	Configured retransmit interval (s) 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: interface_router_id
                                
                                	Interface router ID 
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_state
                                
                                	Interface state
                                	**type**\:   :py:class:`ImStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.ImStateEnum>`
                                
                                .. attribute:: is_demand_circuit_configured
                                
                                	If true, configured as demand circuit 
                                	**type**\:  bool
                                
                                .. attribute:: is_designated_router
                                
                                	If true, designated router
                                	**type**\:  bool
                                
                                .. attribute:: is_interface_demand_circuit
                                
                                	If true, interface running as demand circuit
                                	**type**\:  bool
                                
                                .. attribute:: is_interface_encryption_enabled
                                
                                	If true, interface encryption is enabled 
                                	**type**\:  bool
                                
                                .. attribute:: is_interface_flood_reduction
                                
                                	If true, interface flood reduction is active 
                                	**type**\:  bool
                                
                                .. attribute:: is_interface_ip_security_active
                                
                                	If true, interface IP security is active 
                                	**type**\:  bool
                                
                                .. attribute:: is_interface_ip_security_required
                                
                                	If true, interface IP security is required 
                                	**type**\:  bool
                                
                                .. attribute:: is_interface_line_up
                                
                                	If true, line protocol is up 
                                	**type**\:  bool
                                
                                .. attribute:: is_interface_lsa_filtered
                                
                                	Filter is configured for out going LSAs 
                                	**type**\:  bool
                                
                                .. attribute:: is_prefix_suppress
                                
                                	If true prefix suppression is enabled
                                	**type**\:  bool
                                
                                .. attribute:: network_lsa_flush_timer
                                
                                	The amount of time in seconds before flush timer for old network LSA expires 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: network_type
                                
                                	Network type
                                	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                                
                                .. attribute:: next_hello_time
                                
                                	Time until next Hello (s) 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ospf_interface_state
                                
                                	Interface state
                                	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                                
                                .. attribute:: transmission_delay
                                
                                	Interface transmission delay (sec)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: wait_interval
                                
                                	Configured wait interval (s) 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface, self).__init__()

                                    self.yang_name = "interface"
                                    self.yang_parent_name = "interface-table"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.adjacent_neighbor = YLeaf(YType.uint32, "adjacent-neighbor")

                                    self.backup_designated_router_address = YLeaf(YType.str, "backup-designated-router-address")

                                    self.backup_designated_router_id = YLeaf(YType.str, "backup-designated-router-id")

                                    self.configured_ldp_sync = YLeaf(YType.boolean, "configured-ldp-sync")

                                    self.dead_interval = YLeaf(YType.uint32, "dead-interval")

                                    self.designated_router_address = YLeaf(YType.str, "designated-router-address")

                                    self.designated_router_id = YLeaf(YType.str, "designated-router-id")

                                    self.hello_interval = YLeaf(YType.uint32, "hello-interval")

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_authentication_spi = YLeaf(YType.uint32, "interface-authentication-spi")

                                    self.interface_authentication_transmit = YLeaf(YType.uint32, "interface-authentication-transmit")

                                    self.interface_dc_bitless_ls_as = YLeaf(YType.uint32, "interface-dc-bitless-ls-as")

                                    self.interface_encrypted_authentication_transmitted = YLeaf(YType.uint32, "interface-encrypted-authentication-transmitted")

                                    self.interface_encryption_spi = YLeaf(YType.uint32, "interface-encryption-spi")

                                    self.interface_encryption_transmitted = YLeaf(YType.uint32, "interface-encryption-transmitted")

                                    self.interface_ldp_sync = YLeaf(YType.boolean, "interface-ldp-sync")

                                    self.interface_link_cost = YLeaf(YType.uint16, "interface-link-cost")

                                    self.interface_number = YLeaf(YType.uint32, "interface-number")

                                    self.interface_priority = YLeaf(YType.uint8, "interface-priority")

                                    self.interface_references = YLeaf(YType.uint32, "interface-references")

                                    self.interface_retransmission_interval = YLeaf(YType.uint32, "interface-retransmission-interval")

                                    self.interface_router_id = YLeaf(YType.str, "interface-router-id")

                                    self.interface_state = YLeaf(YType.enumeration, "interface-state")

                                    self.is_demand_circuit_configured = YLeaf(YType.boolean, "is-demand-circuit-configured")

                                    self.is_designated_router = YLeaf(YType.boolean, "is-designated-router")

                                    self.is_interface_demand_circuit = YLeaf(YType.boolean, "is-interface-demand-circuit")

                                    self.is_interface_encryption_enabled = YLeaf(YType.boolean, "is-interface-encryption-enabled")

                                    self.is_interface_flood_reduction = YLeaf(YType.boolean, "is-interface-flood-reduction")

                                    self.is_interface_ip_security_active = YLeaf(YType.boolean, "is-interface-ip-security-active")

                                    self.is_interface_ip_security_required = YLeaf(YType.boolean, "is-interface-ip-security-required")

                                    self.is_interface_line_up = YLeaf(YType.boolean, "is-interface-line-up")

                                    self.is_interface_lsa_filtered = YLeaf(YType.boolean, "is-interface-lsa-filtered")

                                    self.is_prefix_suppress = YLeaf(YType.boolean, "is-prefix-suppress")

                                    self.network_lsa_flush_timer = YLeaf(YType.uint32, "network-lsa-flush-timer")

                                    self.network_type = YLeaf(YType.enumeration, "network-type")

                                    self.next_hello_time = YLeaf(YType.uint32, "next-hello-time")

                                    self.ospf_interface_state = YLeaf(YType.enumeration, "ospf-interface-state")

                                    self.transmission_delay = YLeaf(YType.uint16, "transmission-delay")

                                    self.wait_interval = YLeaf(YType.uint32, "wait-interval")

                                    self.active_interface = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.ActiveInterface()
                                    self.active_interface.parent = self
                                    self._children_name_map["active_interface"] = "active-interface"
                                    self._children_yang_names.add("active-interface")

                                    self.interface_bfd = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd()
                                    self.interface_bfd.parent = self
                                    self._children_name_map["interface_bfd"] = "interface-bfd"
                                    self._children_yang_names.add("interface-bfd")

                                    self.interface_neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "adjacent_neighbor",
                                                    "backup_designated_router_address",
                                                    "backup_designated_router_id",
                                                    "configured_ldp_sync",
                                                    "dead_interval",
                                                    "designated_router_address",
                                                    "designated_router_id",
                                                    "hello_interval",
                                                    "interface_address",
                                                    "interface_authentication_spi",
                                                    "interface_authentication_transmit",
                                                    "interface_dc_bitless_ls_as",
                                                    "interface_encrypted_authentication_transmitted",
                                                    "interface_encryption_spi",
                                                    "interface_encryption_transmitted",
                                                    "interface_ldp_sync",
                                                    "interface_link_cost",
                                                    "interface_number",
                                                    "interface_priority",
                                                    "interface_references",
                                                    "interface_retransmission_interval",
                                                    "interface_router_id",
                                                    "interface_state",
                                                    "is_demand_circuit_configured",
                                                    "is_designated_router",
                                                    "is_interface_demand_circuit",
                                                    "is_interface_encryption_enabled",
                                                    "is_interface_flood_reduction",
                                                    "is_interface_ip_security_active",
                                                    "is_interface_ip_security_required",
                                                    "is_interface_line_up",
                                                    "is_interface_lsa_filtered",
                                                    "is_prefix_suppress",
                                                    "network_lsa_flush_timer",
                                                    "network_type",
                                                    "next_hello_time",
                                                    "ospf_interface_state",
                                                    "transmission_delay",
                                                    "wait_interval") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface, self).__setattr__(name, value)


                                class ActiveInterface(Entity):
                                    """
                                    Active interface details 
                                    
                                    .. attribute:: flood_queue_length
                                    
                                    	Flood queue length
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: flood_scan_length
                                    
                                    	Last flood scan length 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_area_flood_index
                                    
                                    	Area scope LSAs flood index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_area_next_flood
                                    
                                    	Next LSA to flood (Area scope)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_area_next_flood_index
                                    
                                    	Index of next LSA to flood (Area scope) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_as_flood_index
                                    
                                    	AS scope LSAs flood index 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_as_next_flood
                                    
                                    	Next LSA to flood (AS scope)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_as_next_flood_index
                                    
                                    	Index of next LSA to flood (AS scope)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_flood_pacing_timer
                                    
                                    	Time until next flood pacing timer (ms) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_link_flood_index
                                    
                                    	Interface flood link index 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_link_next_flood
                                    
                                    	Interface link next flood information 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_link_next_index
                                    
                                    	Interface link next information index 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_neighbors
                                    
                                    	Total number of neighbors 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: last_flood_time
                                    
                                    	Last flood scan time (ms)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: maximum_flood_length
                                    
                                    	Maximum flood length 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: maximum_flood_time
                                    
                                    	Maximum flood time (ms) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: suppressed_hellos
                                    
                                    	Number of neighbors for which hellos are suppressed 
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: wait_time
                                    
                                    	Wait time for DR/BDR selection (s)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.ActiveInterface, self).__init__()

                                        self.yang_name = "active-interface"
                                        self.yang_parent_name = "interface"

                                        self.flood_queue_length = YLeaf(YType.uint32, "flood-queue-length")

                                        self.flood_scan_length = YLeaf(YType.uint32, "flood-scan-length")

                                        self.interface_area_flood_index = YLeaf(YType.uint32, "interface-area-flood-index")

                                        self.interface_area_next_flood = YLeaf(YType.uint32, "interface-area-next-flood")

                                        self.interface_area_next_flood_index = YLeaf(YType.uint32, "interface-area-next-flood-index")

                                        self.interface_as_flood_index = YLeaf(YType.uint32, "interface-as-flood-index")

                                        self.interface_as_next_flood = YLeaf(YType.uint32, "interface-as-next-flood")

                                        self.interface_as_next_flood_index = YLeaf(YType.uint32, "interface-as-next-flood-index")

                                        self.interface_flood_pacing_timer = YLeaf(YType.uint32, "interface-flood-pacing-timer")

                                        self.interface_link_flood_index = YLeaf(YType.uint32, "interface-link-flood-index")

                                        self.interface_link_next_flood = YLeaf(YType.uint32, "interface-link-next-flood")

                                        self.interface_link_next_index = YLeaf(YType.uint32, "interface-link-next-index")

                                        self.interface_neighbors = YLeaf(YType.uint16, "interface-neighbors")

                                        self.last_flood_time = YLeaf(YType.uint32, "last-flood-time")

                                        self.maximum_flood_length = YLeaf(YType.uint32, "maximum-flood-length")

                                        self.maximum_flood_time = YLeaf(YType.uint32, "maximum-flood-time")

                                        self.suppressed_hellos = YLeaf(YType.uint16, "suppressed-hellos")

                                        self.wait_time = YLeaf(YType.uint32, "wait-time")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("flood_queue_length",
                                                        "flood_scan_length",
                                                        "interface_area_flood_index",
                                                        "interface_area_next_flood",
                                                        "interface_area_next_flood_index",
                                                        "interface_as_flood_index",
                                                        "interface_as_next_flood",
                                                        "interface_as_next_flood_index",
                                                        "interface_flood_pacing_timer",
                                                        "interface_link_flood_index",
                                                        "interface_link_next_flood",
                                                        "interface_link_next_index",
                                                        "interface_neighbors",
                                                        "last_flood_time",
                                                        "maximum_flood_length",
                                                        "maximum_flood_time",
                                                        "suppressed_hellos",
                                                        "wait_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.ActiveInterface, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.ActiveInterface, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.flood_queue_length.is_set or
                                            self.flood_scan_length.is_set or
                                            self.interface_area_flood_index.is_set or
                                            self.interface_area_next_flood.is_set or
                                            self.interface_area_next_flood_index.is_set or
                                            self.interface_as_flood_index.is_set or
                                            self.interface_as_next_flood.is_set or
                                            self.interface_as_next_flood_index.is_set or
                                            self.interface_flood_pacing_timer.is_set or
                                            self.interface_link_flood_index.is_set or
                                            self.interface_link_next_flood.is_set or
                                            self.interface_link_next_index.is_set or
                                            self.interface_neighbors.is_set or
                                            self.last_flood_time.is_set or
                                            self.maximum_flood_length.is_set or
                                            self.maximum_flood_time.is_set or
                                            self.suppressed_hellos.is_set or
                                            self.wait_time.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.flood_queue_length.yfilter != YFilter.not_set or
                                            self.flood_scan_length.yfilter != YFilter.not_set or
                                            self.interface_area_flood_index.yfilter != YFilter.not_set or
                                            self.interface_area_next_flood.yfilter != YFilter.not_set or
                                            self.interface_area_next_flood_index.yfilter != YFilter.not_set or
                                            self.interface_as_flood_index.yfilter != YFilter.not_set or
                                            self.interface_as_next_flood.yfilter != YFilter.not_set or
                                            self.interface_as_next_flood_index.yfilter != YFilter.not_set or
                                            self.interface_flood_pacing_timer.yfilter != YFilter.not_set or
                                            self.interface_link_flood_index.yfilter != YFilter.not_set or
                                            self.interface_link_next_flood.yfilter != YFilter.not_set or
                                            self.interface_link_next_index.yfilter != YFilter.not_set or
                                            self.interface_neighbors.yfilter != YFilter.not_set or
                                            self.last_flood_time.yfilter != YFilter.not_set or
                                            self.maximum_flood_length.yfilter != YFilter.not_set or
                                            self.maximum_flood_time.yfilter != YFilter.not_set or
                                            self.suppressed_hellos.yfilter != YFilter.not_set or
                                            self.wait_time.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "active-interface" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.flood_queue_length.is_set or self.flood_queue_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.flood_queue_length.get_name_leafdata())
                                        if (self.flood_scan_length.is_set or self.flood_scan_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.flood_scan_length.get_name_leafdata())
                                        if (self.interface_area_flood_index.is_set or self.interface_area_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_area_flood_index.get_name_leafdata())
                                        if (self.interface_area_next_flood.is_set or self.interface_area_next_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_area_next_flood.get_name_leafdata())
                                        if (self.interface_area_next_flood_index.is_set or self.interface_area_next_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_area_next_flood_index.get_name_leafdata())
                                        if (self.interface_as_flood_index.is_set or self.interface_as_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_as_flood_index.get_name_leafdata())
                                        if (self.interface_as_next_flood.is_set or self.interface_as_next_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_as_next_flood.get_name_leafdata())
                                        if (self.interface_as_next_flood_index.is_set or self.interface_as_next_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_as_next_flood_index.get_name_leafdata())
                                        if (self.interface_flood_pacing_timer.is_set or self.interface_flood_pacing_timer.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_flood_pacing_timer.get_name_leafdata())
                                        if (self.interface_link_flood_index.is_set or self.interface_link_flood_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_link_flood_index.get_name_leafdata())
                                        if (self.interface_link_next_flood.is_set or self.interface_link_next_flood.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_link_next_flood.get_name_leafdata())
                                        if (self.interface_link_next_index.is_set or self.interface_link_next_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_link_next_index.get_name_leafdata())
                                        if (self.interface_neighbors.is_set or self.interface_neighbors.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_neighbors.get_name_leafdata())
                                        if (self.last_flood_time.is_set or self.last_flood_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_flood_time.get_name_leafdata())
                                        if (self.maximum_flood_length.is_set or self.maximum_flood_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.maximum_flood_length.get_name_leafdata())
                                        if (self.maximum_flood_time.is_set or self.maximum_flood_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.maximum_flood_time.get_name_leafdata())
                                        if (self.suppressed_hellos.is_set or self.suppressed_hellos.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.suppressed_hellos.get_name_leafdata())
                                        if (self.wait_time.is_set or self.wait_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "flood-queue-length" or name == "flood-scan-length" or name == "interface-area-flood-index" or name == "interface-area-next-flood" or name == "interface-area-next-flood-index" or name == "interface-as-flood-index" or name == "interface-as-next-flood" or name == "interface-as-next-flood-index" or name == "interface-flood-pacing-timer" or name == "interface-link-flood-index" or name == "interface-link-next-flood" or name == "interface-link-next-index" or name == "interface-neighbors" or name == "last-flood-time" or name == "maximum-flood-length" or name == "maximum-flood-time" or name == "suppressed-hellos" or name == "wait-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "flood-queue-length"):
                                            self.flood_queue_length = value
                                            self.flood_queue_length.value_namespace = name_space
                                            self.flood_queue_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "flood-scan-length"):
                                            self.flood_scan_length = value
                                            self.flood_scan_length.value_namespace = name_space
                                            self.flood_scan_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-area-flood-index"):
                                            self.interface_area_flood_index = value
                                            self.interface_area_flood_index.value_namespace = name_space
                                            self.interface_area_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-area-next-flood"):
                                            self.interface_area_next_flood = value
                                            self.interface_area_next_flood.value_namespace = name_space
                                            self.interface_area_next_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-area-next-flood-index"):
                                            self.interface_area_next_flood_index = value
                                            self.interface_area_next_flood_index.value_namespace = name_space
                                            self.interface_area_next_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-as-flood-index"):
                                            self.interface_as_flood_index = value
                                            self.interface_as_flood_index.value_namespace = name_space
                                            self.interface_as_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-as-next-flood"):
                                            self.interface_as_next_flood = value
                                            self.interface_as_next_flood.value_namespace = name_space
                                            self.interface_as_next_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-as-next-flood-index"):
                                            self.interface_as_next_flood_index = value
                                            self.interface_as_next_flood_index.value_namespace = name_space
                                            self.interface_as_next_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-flood-pacing-timer"):
                                            self.interface_flood_pacing_timer = value
                                            self.interface_flood_pacing_timer.value_namespace = name_space
                                            self.interface_flood_pacing_timer.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-link-flood-index"):
                                            self.interface_link_flood_index = value
                                            self.interface_link_flood_index.value_namespace = name_space
                                            self.interface_link_flood_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-link-next-flood"):
                                            self.interface_link_next_flood = value
                                            self.interface_link_next_flood.value_namespace = name_space
                                            self.interface_link_next_flood.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-link-next-index"):
                                            self.interface_link_next_index = value
                                            self.interface_link_next_index.value_namespace = name_space
                                            self.interface_link_next_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-neighbors"):
                                            self.interface_neighbors = value
                                            self.interface_neighbors.value_namespace = name_space
                                            self.interface_neighbors.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-flood-time"):
                                            self.last_flood_time = value
                                            self.last_flood_time.value_namespace = name_space
                                            self.last_flood_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "maximum-flood-length"):
                                            self.maximum_flood_length = value
                                            self.maximum_flood_length.value_namespace = name_space
                                            self.maximum_flood_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "maximum-flood-time"):
                                            self.maximum_flood_time = value
                                            self.maximum_flood_time.value_namespace = name_space
                                            self.maximum_flood_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "suppressed-hellos"):
                                            self.suppressed_hellos = value
                                            self.suppressed_hellos.value_namespace = name_space
                                            self.suppressed_hellos.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-time"):
                                            self.wait_time = value
                                            self.wait_time.value_namespace = name_space
                                            self.wait_time.value_namespace_prefix = name_space_prefix


                                class InterfaceBfd(Entity):
                                    """
                                    BFD information 
                                    
                                    .. attribute:: bfd_detection_multiplier
                                    
                                    	BFD detection multiplier 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: bfd_interval
                                    
                                    	BFD interval (ms) 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: bfd_intf_enable_mode
                                    
                                    	BFD Enable Mode on the interface \- Default/Strict
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd, self).__init__()

                                        self.yang_name = "interface-bfd"
                                        self.yang_parent_name = "interface"

                                        self.bfd_detection_multiplier = YLeaf(YType.uint32, "bfd-detection-multiplier")

                                        self.bfd_interval = YLeaf(YType.uint32, "bfd-interval")

                                        self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bfd_detection_multiplier",
                                                        "bfd_interval",
                                                        "bfd_intf_enable_mode") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.bfd_detection_multiplier.is_set or
                                            self.bfd_interval.is_set or
                                            self.bfd_intf_enable_mode.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bfd_detection_multiplier.yfilter != YFilter.not_set or
                                            self.bfd_interval.yfilter != YFilter.not_set or
                                            self.bfd_intf_enable_mode.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "interface-bfd" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bfd_detection_multiplier.is_set or self.bfd_detection_multiplier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bfd_detection_multiplier.get_name_leafdata())
                                        if (self.bfd_interval.is_set or self.bfd_interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bfd_interval.get_name_leafdata())
                                        if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bfd-detection-multiplier" or name == "bfd-interval" or name == "bfd-intf-enable-mode"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bfd-detection-multiplier"):
                                            self.bfd_detection_multiplier = value
                                            self.bfd_detection_multiplier.value_namespace = name_space
                                            self.bfd_detection_multiplier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bfd-interval"):
                                            self.bfd_interval = value
                                            self.bfd_interval.value_namespace = name_space
                                            self.bfd_interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bfd-intf-enable-mode"):
                                            self.bfd_intf_enable_mode = value
                                            self.bfd_intf_enable_mode.value_namespace = name_space
                                            self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix


                                class InterfaceNeighbor(Entity):
                                    """
                                    Information for neighbors on the interface
                                    
                                    .. attribute:: interface_neighbor_cost
                                    
                                    	Cost of link to neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interface_neighbor_id
                                    
                                    	Neighbor router ID 
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: is_hello_suppressed
                                    
                                    	If true, hello is suppressed 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_neighbor_bdr
                                    
                                    	If true, backup designated router is found 
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_neighbor_dr
                                    
                                    	If true, designated router is found 
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceNeighbor, self).__init__()

                                        self.yang_name = "interface-neighbor"
                                        self.yang_parent_name = "interface"

                                        self.interface_neighbor_cost = YLeaf(YType.uint32, "interface-neighbor-cost")

                                        self.interface_neighbor_id = YLeaf(YType.str, "interface-neighbor-id")

                                        self.is_hello_suppressed = YLeaf(YType.boolean, "is-hello-suppressed")

                                        self.is_neighbor_bdr = YLeaf(YType.boolean, "is-neighbor-bdr")

                                        self.is_neighbor_dr = YLeaf(YType.boolean, "is-neighbor-dr")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_neighbor_cost",
                                                        "interface_neighbor_id",
                                                        "is_hello_suppressed",
                                                        "is_neighbor_bdr",
                                                        "is_neighbor_dr") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceNeighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceNeighbor, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_neighbor_cost.is_set or
                                            self.interface_neighbor_id.is_set or
                                            self.is_hello_suppressed.is_set or
                                            self.is_neighbor_bdr.is_set or
                                            self.is_neighbor_dr.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_neighbor_cost.yfilter != YFilter.not_set or
                                            self.interface_neighbor_id.yfilter != YFilter.not_set or
                                            self.is_hello_suppressed.yfilter != YFilter.not_set or
                                            self.is_neighbor_bdr.yfilter != YFilter.not_set or
                                            self.is_neighbor_dr.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "interface-neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_neighbor_cost.is_set or self.interface_neighbor_cost.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_neighbor_cost.get_name_leafdata())
                                        if (self.interface_neighbor_id.is_set or self.interface_neighbor_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_neighbor_id.get_name_leafdata())
                                        if (self.is_hello_suppressed.is_set or self.is_hello_suppressed.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hello_suppressed.get_name_leafdata())
                                        if (self.is_neighbor_bdr.is_set or self.is_neighbor_bdr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_neighbor_bdr.get_name_leafdata())
                                        if (self.is_neighbor_dr.is_set or self.is_neighbor_dr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_neighbor_dr.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-neighbor-cost" or name == "interface-neighbor-id" or name == "is-hello-suppressed" or name == "is-neighbor-bdr" or name == "is-neighbor-dr"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-neighbor-cost"):
                                            self.interface_neighbor_cost = value
                                            self.interface_neighbor_cost.value_namespace = name_space
                                            self.interface_neighbor_cost.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-neighbor-id"):
                                            self.interface_neighbor_id = value
                                            self.interface_neighbor_id.value_namespace = name_space
                                            self.interface_neighbor_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hello-suppressed"):
                                            self.is_hello_suppressed = value
                                            self.is_hello_suppressed.value_namespace = name_space
                                            self.is_hello_suppressed.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-neighbor-bdr"):
                                            self.is_neighbor_bdr = value
                                            self.is_neighbor_bdr.value_namespace = name_space
                                            self.is_neighbor_bdr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-neighbor-dr"):
                                            self.is_neighbor_dr = value
                                            self.is_neighbor_dr.value_namespace = name_space
                                            self.is_neighbor_dr.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.interface_neighbor:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.interface_name.is_set or
                                        self.adjacent_neighbor.is_set or
                                        self.backup_designated_router_address.is_set or
                                        self.backup_designated_router_id.is_set or
                                        self.configured_ldp_sync.is_set or
                                        self.dead_interval.is_set or
                                        self.designated_router_address.is_set or
                                        self.designated_router_id.is_set or
                                        self.hello_interval.is_set or
                                        self.interface_address.is_set or
                                        self.interface_authentication_spi.is_set or
                                        self.interface_authentication_transmit.is_set or
                                        self.interface_dc_bitless_ls_as.is_set or
                                        self.interface_encrypted_authentication_transmitted.is_set or
                                        self.interface_encryption_spi.is_set or
                                        self.interface_encryption_transmitted.is_set or
                                        self.interface_ldp_sync.is_set or
                                        self.interface_link_cost.is_set or
                                        self.interface_number.is_set or
                                        self.interface_priority.is_set or
                                        self.interface_references.is_set or
                                        self.interface_retransmission_interval.is_set or
                                        self.interface_router_id.is_set or
                                        self.interface_state.is_set or
                                        self.is_demand_circuit_configured.is_set or
                                        self.is_designated_router.is_set or
                                        self.is_interface_demand_circuit.is_set or
                                        self.is_interface_encryption_enabled.is_set or
                                        self.is_interface_flood_reduction.is_set or
                                        self.is_interface_ip_security_active.is_set or
                                        self.is_interface_ip_security_required.is_set or
                                        self.is_interface_line_up.is_set or
                                        self.is_interface_lsa_filtered.is_set or
                                        self.is_prefix_suppress.is_set or
                                        self.network_lsa_flush_timer.is_set or
                                        self.network_type.is_set or
                                        self.next_hello_time.is_set or
                                        self.ospf_interface_state.is_set or
                                        self.transmission_delay.is_set or
                                        self.wait_interval.is_set or
                                        (self.active_interface is not None and self.active_interface.has_data()) or
                                        (self.interface_bfd is not None and self.interface_bfd.has_data()))

                                def has_operation(self):
                                    for c in self.interface_neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.adjacent_neighbor.yfilter != YFilter.not_set or
                                        self.backup_designated_router_address.yfilter != YFilter.not_set or
                                        self.backup_designated_router_id.yfilter != YFilter.not_set or
                                        self.configured_ldp_sync.yfilter != YFilter.not_set or
                                        self.dead_interval.yfilter != YFilter.not_set or
                                        self.designated_router_address.yfilter != YFilter.not_set or
                                        self.designated_router_id.yfilter != YFilter.not_set or
                                        self.hello_interval.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_authentication_spi.yfilter != YFilter.not_set or
                                        self.interface_authentication_transmit.yfilter != YFilter.not_set or
                                        self.interface_dc_bitless_ls_as.yfilter != YFilter.not_set or
                                        self.interface_encrypted_authentication_transmitted.yfilter != YFilter.not_set or
                                        self.interface_encryption_spi.yfilter != YFilter.not_set or
                                        self.interface_encryption_transmitted.yfilter != YFilter.not_set or
                                        self.interface_ldp_sync.yfilter != YFilter.not_set or
                                        self.interface_link_cost.yfilter != YFilter.not_set or
                                        self.interface_number.yfilter != YFilter.not_set or
                                        self.interface_priority.yfilter != YFilter.not_set or
                                        self.interface_references.yfilter != YFilter.not_set or
                                        self.interface_retransmission_interval.yfilter != YFilter.not_set or
                                        self.interface_router_id.yfilter != YFilter.not_set or
                                        self.interface_state.yfilter != YFilter.not_set or
                                        self.is_demand_circuit_configured.yfilter != YFilter.not_set or
                                        self.is_designated_router.yfilter != YFilter.not_set or
                                        self.is_interface_demand_circuit.yfilter != YFilter.not_set or
                                        self.is_interface_encryption_enabled.yfilter != YFilter.not_set or
                                        self.is_interface_flood_reduction.yfilter != YFilter.not_set or
                                        self.is_interface_ip_security_active.yfilter != YFilter.not_set or
                                        self.is_interface_ip_security_required.yfilter != YFilter.not_set or
                                        self.is_interface_line_up.yfilter != YFilter.not_set or
                                        self.is_interface_lsa_filtered.yfilter != YFilter.not_set or
                                        self.is_prefix_suppress.yfilter != YFilter.not_set or
                                        self.network_lsa_flush_timer.yfilter != YFilter.not_set or
                                        self.network_type.yfilter != YFilter.not_set or
                                        self.next_hello_time.yfilter != YFilter.not_set or
                                        self.ospf_interface_state.yfilter != YFilter.not_set or
                                        self.transmission_delay.yfilter != YFilter.not_set or
                                        self.wait_interval.yfilter != YFilter.not_set or
                                        (self.active_interface is not None and self.active_interface.has_operation()) or
                                        (self.interface_bfd is not None and self.interface_bfd.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.adjacent_neighbor.is_set or self.adjacent_neighbor.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.adjacent_neighbor.get_name_leafdata())
                                    if (self.backup_designated_router_address.is_set or self.backup_designated_router_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_designated_router_address.get_name_leafdata())
                                    if (self.backup_designated_router_id.is_set or self.backup_designated_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_designated_router_id.get_name_leafdata())
                                    if (self.configured_ldp_sync.is_set or self.configured_ldp_sync.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.configured_ldp_sync.get_name_leafdata())
                                    if (self.dead_interval.is_set or self.dead_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dead_interval.get_name_leafdata())
                                    if (self.designated_router_address.is_set or self.designated_router_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.designated_router_address.get_name_leafdata())
                                    if (self.designated_router_id.is_set or self.designated_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.designated_router_id.get_name_leafdata())
                                    if (self.hello_interval.is_set or self.hello_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hello_interval.get_name_leafdata())
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_authentication_spi.is_set or self.interface_authentication_spi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_authentication_spi.get_name_leafdata())
                                    if (self.interface_authentication_transmit.is_set or self.interface_authentication_transmit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_authentication_transmit.get_name_leafdata())
                                    if (self.interface_dc_bitless_ls_as.is_set or self.interface_dc_bitless_ls_as.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_dc_bitless_ls_as.get_name_leafdata())
                                    if (self.interface_encrypted_authentication_transmitted.is_set or self.interface_encrypted_authentication_transmitted.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_encrypted_authentication_transmitted.get_name_leafdata())
                                    if (self.interface_encryption_spi.is_set or self.interface_encryption_spi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_encryption_spi.get_name_leafdata())
                                    if (self.interface_encryption_transmitted.is_set or self.interface_encryption_transmitted.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_encryption_transmitted.get_name_leafdata())
                                    if (self.interface_ldp_sync.is_set or self.interface_ldp_sync.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_ldp_sync.get_name_leafdata())
                                    if (self.interface_link_cost.is_set or self.interface_link_cost.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_link_cost.get_name_leafdata())
                                    if (self.interface_number.is_set or self.interface_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_number.get_name_leafdata())
                                    if (self.interface_priority.is_set or self.interface_priority.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_priority.get_name_leafdata())
                                    if (self.interface_references.is_set or self.interface_references.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_references.get_name_leafdata())
                                    if (self.interface_retransmission_interval.is_set or self.interface_retransmission_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_retransmission_interval.get_name_leafdata())
                                    if (self.interface_router_id.is_set or self.interface_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_router_id.get_name_leafdata())
                                    if (self.interface_state.is_set or self.interface_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_state.get_name_leafdata())
                                    if (self.is_demand_circuit_configured.is_set or self.is_demand_circuit_configured.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_demand_circuit_configured.get_name_leafdata())
                                    if (self.is_designated_router.is_set or self.is_designated_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_designated_router.get_name_leafdata())
                                    if (self.is_interface_demand_circuit.is_set or self.is_interface_demand_circuit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_interface_demand_circuit.get_name_leafdata())
                                    if (self.is_interface_encryption_enabled.is_set or self.is_interface_encryption_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_interface_encryption_enabled.get_name_leafdata())
                                    if (self.is_interface_flood_reduction.is_set or self.is_interface_flood_reduction.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_interface_flood_reduction.get_name_leafdata())
                                    if (self.is_interface_ip_security_active.is_set or self.is_interface_ip_security_active.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_interface_ip_security_active.get_name_leafdata())
                                    if (self.is_interface_ip_security_required.is_set or self.is_interface_ip_security_required.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_interface_ip_security_required.get_name_leafdata())
                                    if (self.is_interface_line_up.is_set or self.is_interface_line_up.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_interface_line_up.get_name_leafdata())
                                    if (self.is_interface_lsa_filtered.is_set or self.is_interface_lsa_filtered.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_interface_lsa_filtered.get_name_leafdata())
                                    if (self.is_prefix_suppress.is_set or self.is_prefix_suppress.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_prefix_suppress.get_name_leafdata())
                                    if (self.network_lsa_flush_timer.is_set or self.network_lsa_flush_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.network_lsa_flush_timer.get_name_leafdata())
                                    if (self.network_type.is_set or self.network_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.network_type.get_name_leafdata())
                                    if (self.next_hello_time.is_set or self.next_hello_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hello_time.get_name_leafdata())
                                    if (self.ospf_interface_state.is_set or self.ospf_interface_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ospf_interface_state.get_name_leafdata())
                                    if (self.transmission_delay.is_set or self.transmission_delay.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.transmission_delay.get_name_leafdata())
                                    if (self.wait_interval.is_set or self.wait_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.wait_interval.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "active-interface"):
                                        if (self.active_interface is None):
                                            self.active_interface = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.ActiveInterface()
                                            self.active_interface.parent = self
                                            self._children_name_map["active_interface"] = "active-interface"
                                        return self.active_interface

                                    if (child_yang_name == "interface-bfd"):
                                        if (self.interface_bfd is None):
                                            self.interface_bfd = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceBfd()
                                            self.interface_bfd.parent = self
                                            self._children_name_map["interface_bfd"] = "interface-bfd"
                                        return self.interface_bfd

                                    if (child_yang_name == "interface-neighbor"):
                                        for c in self.interface_neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface.InterfaceNeighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.interface_neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "active-interface" or name == "interface-bfd" or name == "interface-neighbor" or name == "interface-name" or name == "adjacent-neighbor" or name == "backup-designated-router-address" or name == "backup-designated-router-id" or name == "configured-ldp-sync" or name == "dead-interval" or name == "designated-router-address" or name == "designated-router-id" or name == "hello-interval" or name == "interface-address" or name == "interface-authentication-spi" or name == "interface-authentication-transmit" or name == "interface-dc-bitless-ls-as" or name == "interface-encrypted-authentication-transmitted" or name == "interface-encryption-spi" or name == "interface-encryption-transmitted" or name == "interface-ldp-sync" or name == "interface-link-cost" or name == "interface-number" or name == "interface-priority" or name == "interface-references" or name == "interface-retransmission-interval" or name == "interface-router-id" or name == "interface-state" or name == "is-demand-circuit-configured" or name == "is-designated-router" or name == "is-interface-demand-circuit" or name == "is-interface-encryption-enabled" or name == "is-interface-flood-reduction" or name == "is-interface-ip-security-active" or name == "is-interface-ip-security-required" or name == "is-interface-line-up" or name == "is-interface-lsa-filtered" or name == "is-prefix-suppress" or name == "network-lsa-flush-timer" or name == "network-type" or name == "next-hello-time" or name == "ospf-interface-state" or name == "transmission-delay" or name == "wait-interval"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "adjacent-neighbor"):
                                        self.adjacent_neighbor = value
                                        self.adjacent_neighbor.value_namespace = name_space
                                        self.adjacent_neighbor.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-designated-router-address"):
                                        self.backup_designated_router_address = value
                                        self.backup_designated_router_address.value_namespace = name_space
                                        self.backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-designated-router-id"):
                                        self.backup_designated_router_id = value
                                        self.backup_designated_router_id.value_namespace = name_space
                                        self.backup_designated_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "configured-ldp-sync"):
                                        self.configured_ldp_sync = value
                                        self.configured_ldp_sync.value_namespace = name_space
                                        self.configured_ldp_sync.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dead-interval"):
                                        self.dead_interval = value
                                        self.dead_interval.value_namespace = name_space
                                        self.dead_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "designated-router-address"):
                                        self.designated_router_address = value
                                        self.designated_router_address.value_namespace = name_space
                                        self.designated_router_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "designated-router-id"):
                                        self.designated_router_id = value
                                        self.designated_router_id.value_namespace = name_space
                                        self.designated_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hello-interval"):
                                        self.hello_interval = value
                                        self.hello_interval.value_namespace = name_space
                                        self.hello_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-authentication-spi"):
                                        self.interface_authentication_spi = value
                                        self.interface_authentication_spi.value_namespace = name_space
                                        self.interface_authentication_spi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-authentication-transmit"):
                                        self.interface_authentication_transmit = value
                                        self.interface_authentication_transmit.value_namespace = name_space
                                        self.interface_authentication_transmit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-dc-bitless-ls-as"):
                                        self.interface_dc_bitless_ls_as = value
                                        self.interface_dc_bitless_ls_as.value_namespace = name_space
                                        self.interface_dc_bitless_ls_as.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-encrypted-authentication-transmitted"):
                                        self.interface_encrypted_authentication_transmitted = value
                                        self.interface_encrypted_authentication_transmitted.value_namespace = name_space
                                        self.interface_encrypted_authentication_transmitted.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-encryption-spi"):
                                        self.interface_encryption_spi = value
                                        self.interface_encryption_spi.value_namespace = name_space
                                        self.interface_encryption_spi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-encryption-transmitted"):
                                        self.interface_encryption_transmitted = value
                                        self.interface_encryption_transmitted.value_namespace = name_space
                                        self.interface_encryption_transmitted.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-ldp-sync"):
                                        self.interface_ldp_sync = value
                                        self.interface_ldp_sync.value_namespace = name_space
                                        self.interface_ldp_sync.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-link-cost"):
                                        self.interface_link_cost = value
                                        self.interface_link_cost.value_namespace = name_space
                                        self.interface_link_cost.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-number"):
                                        self.interface_number = value
                                        self.interface_number.value_namespace = name_space
                                        self.interface_number.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-priority"):
                                        self.interface_priority = value
                                        self.interface_priority.value_namespace = name_space
                                        self.interface_priority.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-references"):
                                        self.interface_references = value
                                        self.interface_references.value_namespace = name_space
                                        self.interface_references.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-retransmission-interval"):
                                        self.interface_retransmission_interval = value
                                        self.interface_retransmission_interval.value_namespace = name_space
                                        self.interface_retransmission_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-router-id"):
                                        self.interface_router_id = value
                                        self.interface_router_id.value_namespace = name_space
                                        self.interface_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-state"):
                                        self.interface_state = value
                                        self.interface_state.value_namespace = name_space
                                        self.interface_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-demand-circuit-configured"):
                                        self.is_demand_circuit_configured = value
                                        self.is_demand_circuit_configured.value_namespace = name_space
                                        self.is_demand_circuit_configured.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-designated-router"):
                                        self.is_designated_router = value
                                        self.is_designated_router.value_namespace = name_space
                                        self.is_designated_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-interface-demand-circuit"):
                                        self.is_interface_demand_circuit = value
                                        self.is_interface_demand_circuit.value_namespace = name_space
                                        self.is_interface_demand_circuit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-interface-encryption-enabled"):
                                        self.is_interface_encryption_enabled = value
                                        self.is_interface_encryption_enabled.value_namespace = name_space
                                        self.is_interface_encryption_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-interface-flood-reduction"):
                                        self.is_interface_flood_reduction = value
                                        self.is_interface_flood_reduction.value_namespace = name_space
                                        self.is_interface_flood_reduction.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-interface-ip-security-active"):
                                        self.is_interface_ip_security_active = value
                                        self.is_interface_ip_security_active.value_namespace = name_space
                                        self.is_interface_ip_security_active.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-interface-ip-security-required"):
                                        self.is_interface_ip_security_required = value
                                        self.is_interface_ip_security_required.value_namespace = name_space
                                        self.is_interface_ip_security_required.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-interface-line-up"):
                                        self.is_interface_line_up = value
                                        self.is_interface_line_up.value_namespace = name_space
                                        self.is_interface_line_up.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-interface-lsa-filtered"):
                                        self.is_interface_lsa_filtered = value
                                        self.is_interface_lsa_filtered.value_namespace = name_space
                                        self.is_interface_lsa_filtered.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-prefix-suppress"):
                                        self.is_prefix_suppress = value
                                        self.is_prefix_suppress.value_namespace = name_space
                                        self.is_prefix_suppress.value_namespace_prefix = name_space_prefix
                                    if(value_path == "network-lsa-flush-timer"):
                                        self.network_lsa_flush_timer = value
                                        self.network_lsa_flush_timer.value_namespace = name_space
                                        self.network_lsa_flush_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "network-type"):
                                        self.network_type = value
                                        self.network_type.value_namespace = name_space
                                        self.network_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-hello-time"):
                                        self.next_hello_time = value
                                        self.next_hello_time.value_namespace = name_space
                                        self.next_hello_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ospf-interface-state"):
                                        self.ospf_interface_state = value
                                        self.ospf_interface_state.value_namespace = name_space
                                        self.ospf_interface_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "transmission-delay"):
                                        self.transmission_delay = value
                                        self.transmission_delay.value_namespace = name_space
                                        self.transmission_delay.value_namespace_prefix = name_space_prefix
                                    if(value_path == "wait-interval"):
                                        self.wait_interval = value
                                        self.wait_interval.value_namespace = name_space
                                        self.wait_interval.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.interface:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.interface:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interface-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "interface"):
                                    for c in self.interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable.Interface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.interface.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class FloodListTable(Entity):
                            """
                            OSPFv3 flood list information table for an
                            area
                            
                            .. attribute:: flood
                            
                            	OSPFv3 flood list information
                            	**type**\: list of    :py:class:`Flood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable, self).__init__()

                                self.yang_name = "flood-list-table"
                                self.yang_parent_name = "area"

                                self.flood = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable, self).__setattr__(name, value)


                            class Flood(Entity):
                                """
                                OSPFv3 flood list information
                                
                                .. attribute:: interface_name  <key>
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: area_flood
                                
                                	Area scope floodlist
                                	**type**\: list of    :py:class:`AreaFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.AreaFlood>`
                                
                                .. attribute:: as_flood
                                
                                	AS scope floodlist
                                	**type**\: list of    :py:class:`AsFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.AsFlood>`
                                
                                .. attribute:: link_flood
                                
                                	Link floodlist
                                	**type**\: list of    :py:class:`LinkFlood <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.LinkFlood>`
                                
                                .. attribute:: ls_transmission_timer
                                
                                	Time until next LS transmission (ms) 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: queue_length
                                
                                	Number of LSAs currently being flooded 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood, self).__init__()

                                    self.yang_name = "flood"
                                    self.yang_parent_name = "flood-list-table"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.ls_transmission_timer = YLeaf(YType.uint32, "ls-transmission-timer")

                                    self.queue_length = YLeaf(YType.uint32, "queue-length")

                                    self.area_flood = YList(self)
                                    self.as_flood = YList(self)
                                    self.link_flood = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "ls_transmission_timer",
                                                    "queue_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood, self).__setattr__(name, value)


                                class LinkFlood(Entity):
                                    """
                                    Link floodlist
                                    
                                    .. attribute:: header_advertising_router
                                    
                                    	Router ID of the advertising router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_age
                                    
                                    	Age of the LSA (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: header_lsa_id
                                    
                                    	LSA ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_type
                                    
                                    	LSA type
                                    	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                    
                                    .. attribute:: header_sequence_number
                                    
                                    	Current LSA sequence number
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.LinkFlood, self).__init__()

                                        self.yang_name = "link-flood"
                                        self.yang_parent_name = "flood"

                                        self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                        self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                        self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                        self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                        self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("header_advertising_router",
                                                        "header_lsa_age",
                                                        "header_lsa_id",
                                                        "header_lsa_type",
                                                        "header_sequence_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.LinkFlood, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.LinkFlood, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.header_advertising_router.is_set or
                                            self.header_lsa_age.is_set or
                                            self.header_lsa_id.is_set or
                                            self.header_lsa_type.is_set or
                                            self.header_sequence_number.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.header_advertising_router.yfilter != YFilter.not_set or
                                            self.header_lsa_age.yfilter != YFilter.not_set or
                                            self.header_lsa_id.yfilter != YFilter.not_set or
                                            self.header_lsa_type.yfilter != YFilter.not_set or
                                            self.header_sequence_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-flood" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                        if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                        if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                        if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                        if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "header-advertising-router"):
                                            self.header_advertising_router = value
                                            self.header_advertising_router.value_namespace = name_space
                                            self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-age"):
                                            self.header_lsa_age = value
                                            self.header_lsa_age.value_namespace = name_space
                                            self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-id"):
                                            self.header_lsa_id = value
                                            self.header_lsa_id.value_namespace = name_space
                                            self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-type"):
                                            self.header_lsa_type = value
                                            self.header_lsa_type.value_namespace = name_space
                                            self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-sequence-number"):
                                            self.header_sequence_number = value
                                            self.header_sequence_number.value_namespace = name_space
                                            self.header_sequence_number.value_namespace_prefix = name_space_prefix


                                class AreaFlood(Entity):
                                    """
                                    Area scope floodlist
                                    
                                    .. attribute:: header_advertising_router
                                    
                                    	Router ID of the advertising router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_age
                                    
                                    	Age of the LSA (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: header_lsa_id
                                    
                                    	LSA ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_type
                                    
                                    	LSA type
                                    	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                    
                                    .. attribute:: header_sequence_number
                                    
                                    	Current LSA sequence number
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.AreaFlood, self).__init__()

                                        self.yang_name = "area-flood"
                                        self.yang_parent_name = "flood"

                                        self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                        self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                        self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                        self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                        self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("header_advertising_router",
                                                        "header_lsa_age",
                                                        "header_lsa_id",
                                                        "header_lsa_type",
                                                        "header_sequence_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.AreaFlood, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.AreaFlood, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.header_advertising_router.is_set or
                                            self.header_lsa_age.is_set or
                                            self.header_lsa_id.is_set or
                                            self.header_lsa_type.is_set or
                                            self.header_sequence_number.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.header_advertising_router.yfilter != YFilter.not_set or
                                            self.header_lsa_age.yfilter != YFilter.not_set or
                                            self.header_lsa_id.yfilter != YFilter.not_set or
                                            self.header_lsa_type.yfilter != YFilter.not_set or
                                            self.header_sequence_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "area-flood" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                        if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                        if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                        if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                        if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "header-advertising-router"):
                                            self.header_advertising_router = value
                                            self.header_advertising_router.value_namespace = name_space
                                            self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-age"):
                                            self.header_lsa_age = value
                                            self.header_lsa_age.value_namespace = name_space
                                            self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-id"):
                                            self.header_lsa_id = value
                                            self.header_lsa_id.value_namespace = name_space
                                            self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-type"):
                                            self.header_lsa_type = value
                                            self.header_lsa_type.value_namespace = name_space
                                            self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-sequence-number"):
                                            self.header_sequence_number = value
                                            self.header_sequence_number.value_namespace = name_space
                                            self.header_sequence_number.value_namespace_prefix = name_space_prefix


                                class AsFlood(Entity):
                                    """
                                    AS scope floodlist
                                    
                                    .. attribute:: header_advertising_router
                                    
                                    	Router ID of the advertising router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_age
                                    
                                    	Age of the LSA (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: header_lsa_id
                                    
                                    	LSA ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_type
                                    
                                    	LSA type
                                    	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                    
                                    .. attribute:: header_sequence_number
                                    
                                    	Current LSA sequence number
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.AsFlood, self).__init__()

                                        self.yang_name = "as-flood"
                                        self.yang_parent_name = "flood"

                                        self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                        self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                        self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                        self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                        self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("header_advertising_router",
                                                        "header_lsa_age",
                                                        "header_lsa_id",
                                                        "header_lsa_type",
                                                        "header_sequence_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.AsFlood, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.AsFlood, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.header_advertising_router.is_set or
                                            self.header_lsa_age.is_set or
                                            self.header_lsa_id.is_set or
                                            self.header_lsa_type.is_set or
                                            self.header_sequence_number.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.header_advertising_router.yfilter != YFilter.not_set or
                                            self.header_lsa_age.yfilter != YFilter.not_set or
                                            self.header_lsa_id.yfilter != YFilter.not_set or
                                            self.header_lsa_type.yfilter != YFilter.not_set or
                                            self.header_sequence_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-flood" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                        if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                        if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                        if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                        if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "header-advertising-router"):
                                            self.header_advertising_router = value
                                            self.header_advertising_router.value_namespace = name_space
                                            self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-age"):
                                            self.header_lsa_age = value
                                            self.header_lsa_age.value_namespace = name_space
                                            self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-id"):
                                            self.header_lsa_id = value
                                            self.header_lsa_id.value_namespace = name_space
                                            self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-type"):
                                            self.header_lsa_type = value
                                            self.header_lsa_type.value_namespace = name_space
                                            self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-sequence-number"):
                                            self.header_sequence_number = value
                                            self.header_sequence_number.value_namespace = name_space
                                            self.header_sequence_number.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.area_flood:
                                        if (c.has_data()):
                                            return True
                                    for c in self.as_flood:
                                        if (c.has_data()):
                                            return True
                                    for c in self.link_flood:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.interface_name.is_set or
                                        self.ls_transmission_timer.is_set or
                                        self.queue_length.is_set)

                                def has_operation(self):
                                    for c in self.area_flood:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.as_flood:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.link_flood:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.ls_transmission_timer.yfilter != YFilter.not_set or
                                        self.queue_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flood" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.ls_transmission_timer.is_set or self.ls_transmission_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ls_transmission_timer.get_name_leafdata())
                                    if (self.queue_length.is_set or self.queue_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "area-flood"):
                                        for c in self.area_flood:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.AreaFlood()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.area_flood.append(c)
                                        return c

                                    if (child_yang_name == "as-flood"):
                                        for c in self.as_flood:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.AsFlood()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.as_flood.append(c)
                                        return c

                                    if (child_yang_name == "link-flood"):
                                        for c in self.link_flood:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood.LinkFlood()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.link_flood.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "area-flood" or name == "as-flood" or name == "link-flood" or name == "interface-name" or name == "ls-transmission-timer" or name == "queue-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ls-transmission-timer"):
                                        self.ls_transmission_timer = value
                                        self.ls_transmission_timer.value_namespace = name_space
                                        self.ls_transmission_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-length"):
                                        self.queue_length = value
                                        self.queue_length.value_namespace = name_space
                                        self.queue_length.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.flood:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.flood:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flood-list-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flood"):
                                    for c in self.flood:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable.Flood()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.flood.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flood"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class RetransmissionListTable(Entity):
                            """
                            OSPFv3 retransmission list information table
                            in an area
                            
                            .. attribute:: retransmission
                            
                            	OSPFv3 retransmission list information
                            	**type**\: list of    :py:class:`Retransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable, self).__init__()

                                self.yang_name = "retransmission-list-table"
                                self.yang_parent_name = "area"

                                self.retransmission = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable, self).__setattr__(name, value)


                            class Retransmission(Entity):
                                """
                                OSPFv3 retransmission list information
                                
                                .. attribute:: interface_name
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: is_retransmission_sham_link
                                
                                	If true, sham link is retransmitted 
                                	**type**\:  bool
                                
                                .. attribute:: is_retransmissionvirtual_link
                                
                                	If true, virtual link is retransmitted 
                                	**type**\:  bool
                                
                                .. attribute:: neighbor_address
                                
                                	Neighbor address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: retransmission_area_db
                                
                                	List of area scope entries
                                	**type**\: list of    :py:class:`RetransmissionAreaDb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAreaDb>`
                                
                                .. attribute:: retransmission_asdb
                                
                                	List of AS scope entries
                                	**type**\: list of    :py:class:`RetransmissionAsdb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAsdb>`
                                
                                .. attribute:: retransmission_length
                                
                                	Retransmission queue length
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: retransmission_neighbor_address
                                
                                	Neighbor IP address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: retransmission_sham_link_id
                                
                                	Retransmission sham link ID 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: retransmission_timer
                                
                                	Amount of time remaining on retransmission timer (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: retransmissionvirtual_link_db
                                
                                	List of virtual link scope entries 
                                	**type**\: list of    :py:class:`RetransmissionvirtualLinkDb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionvirtualLinkDb>`
                                
                                .. attribute:: retransmissionvirtual_link_id
                                
                                	Retransmission virtual link ID 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission, self).__init__()

                                    self.yang_name = "retransmission"
                                    self.yang_parent_name = "retransmission-list-table"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.is_retransmission_sham_link = YLeaf(YType.boolean, "is-retransmission-sham-link")

                                    self.is_retransmissionvirtual_link = YLeaf(YType.boolean, "is-retransmissionvirtual-link")

                                    self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                                    self.retransmission_length = YLeaf(YType.uint32, "retransmission-length")

                                    self.retransmission_neighbor_address = YLeaf(YType.str, "retransmission-neighbor-address")

                                    self.retransmission_sham_link_id = YLeaf(YType.uint32, "retransmission-sham-link-id")

                                    self.retransmission_timer = YLeaf(YType.uint32, "retransmission-timer")

                                    self.retransmissionvirtual_link_id = YLeaf(YType.uint32, "retransmissionvirtual-link-id")

                                    self.retransmission_area_db = YList(self)
                                    self.retransmission_asdb = YList(self)
                                    self.retransmissionvirtual_link_db = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "is_retransmission_sham_link",
                                                    "is_retransmissionvirtual_link",
                                                    "neighbor_address",
                                                    "retransmission_length",
                                                    "retransmission_neighbor_address",
                                                    "retransmission_sham_link_id",
                                                    "retransmission_timer",
                                                    "retransmissionvirtual_link_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission, self).__setattr__(name, value)


                                class RetransmissionvirtualLinkDb(Entity):
                                    """
                                    List of virtual link scope entries 
                                    
                                    .. attribute:: header_advertising_router
                                    
                                    	Router ID of the advertising router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_age
                                    
                                    	Age of the LSA (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: header_lsa_id
                                    
                                    	LSA ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_type
                                    
                                    	LSA type
                                    	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                    
                                    .. attribute:: header_sequence_number
                                    
                                    	Current LSA sequence number
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionvirtualLinkDb, self).__init__()

                                        self.yang_name = "retransmissionvirtual-link-db"
                                        self.yang_parent_name = "retransmission"

                                        self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                        self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                        self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                        self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                        self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("header_advertising_router",
                                                        "header_lsa_age",
                                                        "header_lsa_id",
                                                        "header_lsa_type",
                                                        "header_sequence_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionvirtualLinkDb, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionvirtualLinkDb, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.header_advertising_router.is_set or
                                            self.header_lsa_age.is_set or
                                            self.header_lsa_id.is_set or
                                            self.header_lsa_type.is_set or
                                            self.header_sequence_number.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.header_advertising_router.yfilter != YFilter.not_set or
                                            self.header_lsa_age.yfilter != YFilter.not_set or
                                            self.header_lsa_id.yfilter != YFilter.not_set or
                                            self.header_lsa_type.yfilter != YFilter.not_set or
                                            self.header_sequence_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "retransmissionvirtual-link-db" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                        if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                        if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                        if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                        if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "header-advertising-router"):
                                            self.header_advertising_router = value
                                            self.header_advertising_router.value_namespace = name_space
                                            self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-age"):
                                            self.header_lsa_age = value
                                            self.header_lsa_age.value_namespace = name_space
                                            self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-id"):
                                            self.header_lsa_id = value
                                            self.header_lsa_id.value_namespace = name_space
                                            self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-type"):
                                            self.header_lsa_type = value
                                            self.header_lsa_type.value_namespace = name_space
                                            self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-sequence-number"):
                                            self.header_sequence_number = value
                                            self.header_sequence_number.value_namespace = name_space
                                            self.header_sequence_number.value_namespace_prefix = name_space_prefix


                                class RetransmissionAreaDb(Entity):
                                    """
                                    List of area scope entries
                                    
                                    .. attribute:: header_advertising_router
                                    
                                    	Router ID of the advertising router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_age
                                    
                                    	Age of the LSA (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: header_lsa_id
                                    
                                    	LSA ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_type
                                    
                                    	LSA type
                                    	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                    
                                    .. attribute:: header_sequence_number
                                    
                                    	Current LSA sequence number
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAreaDb, self).__init__()

                                        self.yang_name = "retransmission-area-db"
                                        self.yang_parent_name = "retransmission"

                                        self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                        self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                        self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                        self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                        self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("header_advertising_router",
                                                        "header_lsa_age",
                                                        "header_lsa_id",
                                                        "header_lsa_type",
                                                        "header_sequence_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAreaDb, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAreaDb, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.header_advertising_router.is_set or
                                            self.header_lsa_age.is_set or
                                            self.header_lsa_id.is_set or
                                            self.header_lsa_type.is_set or
                                            self.header_sequence_number.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.header_advertising_router.yfilter != YFilter.not_set or
                                            self.header_lsa_age.yfilter != YFilter.not_set or
                                            self.header_lsa_id.yfilter != YFilter.not_set or
                                            self.header_lsa_type.yfilter != YFilter.not_set or
                                            self.header_sequence_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "retransmission-area-db" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                        if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                        if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                        if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                        if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "header-advertising-router"):
                                            self.header_advertising_router = value
                                            self.header_advertising_router.value_namespace = name_space
                                            self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-age"):
                                            self.header_lsa_age = value
                                            self.header_lsa_age.value_namespace = name_space
                                            self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-id"):
                                            self.header_lsa_id = value
                                            self.header_lsa_id.value_namespace = name_space
                                            self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-type"):
                                            self.header_lsa_type = value
                                            self.header_lsa_type.value_namespace = name_space
                                            self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-sequence-number"):
                                            self.header_sequence_number = value
                                            self.header_sequence_number.value_namespace = name_space
                                            self.header_sequence_number.value_namespace_prefix = name_space_prefix


                                class RetransmissionAsdb(Entity):
                                    """
                                    List of AS scope entries
                                    
                                    .. attribute:: header_advertising_router
                                    
                                    	Router ID of the advertising router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_age
                                    
                                    	Age of the LSA (seconds)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: header_lsa_id
                                    
                                    	LSA ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: header_lsa_type
                                    
                                    	LSA type
                                    	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                    
                                    .. attribute:: header_sequence_number
                                    
                                    	Current LSA sequence number
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAsdb, self).__init__()

                                        self.yang_name = "retransmission-asdb"
                                        self.yang_parent_name = "retransmission"

                                        self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                        self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                        self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                        self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                        self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("header_advertising_router",
                                                        "header_lsa_age",
                                                        "header_lsa_id",
                                                        "header_lsa_type",
                                                        "header_sequence_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAsdb, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAsdb, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.header_advertising_router.is_set or
                                            self.header_lsa_age.is_set or
                                            self.header_lsa_id.is_set or
                                            self.header_lsa_type.is_set or
                                            self.header_sequence_number.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.header_advertising_router.yfilter != YFilter.not_set or
                                            self.header_lsa_age.yfilter != YFilter.not_set or
                                            self.header_lsa_id.yfilter != YFilter.not_set or
                                            self.header_lsa_type.yfilter != YFilter.not_set or
                                            self.header_sequence_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "retransmission-asdb" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                        if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                        if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                        if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                        if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "header-advertising-router"):
                                            self.header_advertising_router = value
                                            self.header_advertising_router.value_namespace = name_space
                                            self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-age"):
                                            self.header_lsa_age = value
                                            self.header_lsa_age.value_namespace = name_space
                                            self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-id"):
                                            self.header_lsa_id = value
                                            self.header_lsa_id.value_namespace = name_space
                                            self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-lsa-type"):
                                            self.header_lsa_type = value
                                            self.header_lsa_type.value_namespace = name_space
                                            self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "header-sequence-number"):
                                            self.header_sequence_number = value
                                            self.header_sequence_number.value_namespace = name_space
                                            self.header_sequence_number.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.retransmission_area_db:
                                        if (c.has_data()):
                                            return True
                                    for c in self.retransmission_asdb:
                                        if (c.has_data()):
                                            return True
                                    for c in self.retransmissionvirtual_link_db:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.interface_name.is_set or
                                        self.is_retransmission_sham_link.is_set or
                                        self.is_retransmissionvirtual_link.is_set or
                                        self.neighbor_address.is_set or
                                        self.retransmission_length.is_set or
                                        self.retransmission_neighbor_address.is_set or
                                        self.retransmission_sham_link_id.is_set or
                                        self.retransmission_timer.is_set or
                                        self.retransmissionvirtual_link_id.is_set)

                                def has_operation(self):
                                    for c in self.retransmission_area_db:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.retransmission_asdb:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.retransmissionvirtual_link_db:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.is_retransmission_sham_link.yfilter != YFilter.not_set or
                                        self.is_retransmissionvirtual_link.yfilter != YFilter.not_set or
                                        self.neighbor_address.yfilter != YFilter.not_set or
                                        self.retransmission_length.yfilter != YFilter.not_set or
                                        self.retransmission_neighbor_address.yfilter != YFilter.not_set or
                                        self.retransmission_sham_link_id.yfilter != YFilter.not_set or
                                        self.retransmission_timer.yfilter != YFilter.not_set or
                                        self.retransmissionvirtual_link_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "retransmission" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.is_retransmission_sham_link.is_set or self.is_retransmission_sham_link.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_retransmission_sham_link.get_name_leafdata())
                                    if (self.is_retransmissionvirtual_link.is_set or self.is_retransmissionvirtual_link.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_retransmissionvirtual_link.get_name_leafdata())
                                    if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                                    if (self.retransmission_length.is_set or self.retransmission_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.retransmission_length.get_name_leafdata())
                                    if (self.retransmission_neighbor_address.is_set or self.retransmission_neighbor_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.retransmission_neighbor_address.get_name_leafdata())
                                    if (self.retransmission_sham_link_id.is_set or self.retransmission_sham_link_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.retransmission_sham_link_id.get_name_leafdata())
                                    if (self.retransmission_timer.is_set or self.retransmission_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.retransmission_timer.get_name_leafdata())
                                    if (self.retransmissionvirtual_link_id.is_set or self.retransmissionvirtual_link_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.retransmissionvirtual_link_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "retransmission-area-db"):
                                        for c in self.retransmission_area_db:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAreaDb()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.retransmission_area_db.append(c)
                                        return c

                                    if (child_yang_name == "retransmission-asdb"):
                                        for c in self.retransmission_asdb:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionAsdb()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.retransmission_asdb.append(c)
                                        return c

                                    if (child_yang_name == "retransmissionvirtual-link-db"):
                                        for c in self.retransmissionvirtual_link_db:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission.RetransmissionvirtualLinkDb()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.retransmissionvirtual_link_db.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "retransmission-area-db" or name == "retransmission-asdb" or name == "retransmissionvirtual-link-db" or name == "interface-name" or name == "is-retransmission-sham-link" or name == "is-retransmissionvirtual-link" or name == "neighbor-address" or name == "retransmission-length" or name == "retransmission-neighbor-address" or name == "retransmission-sham-link-id" or name == "retransmission-timer" or name == "retransmissionvirtual-link-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-retransmission-sham-link"):
                                        self.is_retransmission_sham_link = value
                                        self.is_retransmission_sham_link.value_namespace = name_space
                                        self.is_retransmission_sham_link.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-retransmissionvirtual-link"):
                                        self.is_retransmissionvirtual_link = value
                                        self.is_retransmissionvirtual_link.value_namespace = name_space
                                        self.is_retransmissionvirtual_link.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-address"):
                                        self.neighbor_address = value
                                        self.neighbor_address.value_namespace = name_space
                                        self.neighbor_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "retransmission-length"):
                                        self.retransmission_length = value
                                        self.retransmission_length.value_namespace = name_space
                                        self.retransmission_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "retransmission-neighbor-address"):
                                        self.retransmission_neighbor_address = value
                                        self.retransmission_neighbor_address.value_namespace = name_space
                                        self.retransmission_neighbor_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "retransmission-sham-link-id"):
                                        self.retransmission_sham_link_id = value
                                        self.retransmission_sham_link_id.value_namespace = name_space
                                        self.retransmission_sham_link_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "retransmission-timer"):
                                        self.retransmission_timer = value
                                        self.retransmission_timer.value_namespace = name_space
                                        self.retransmission_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "retransmissionvirtual-link-id"):
                                        self.retransmissionvirtual_link_id = value
                                        self.retransmissionvirtual_link_id.value_namespace = name_space
                                        self.retransmissionvirtual_link_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.retransmission:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.retransmission:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "retransmission-list-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "retransmission"):
                                    for c in self.retransmission:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable.Retransmission()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.retransmission.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "retransmission"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class DatabaseTable(Entity):
                            """
                            OSPF Link State Database
                            
                            .. attribute:: lsa_internal_table
                            
                            	Database LSA information
                            	**type**\:   :py:class:`LsaInternalTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable>`
                            
                            .. attribute:: lsa_table
                            
                            	Database LSA information
                            	**type**\:   :py:class:`LsaTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable, self).__init__()

                                self.yang_name = "database-table"
                                self.yang_parent_name = "area"

                                self.lsa_internal_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable()
                                self.lsa_internal_table.parent = self
                                self._children_name_map["lsa_internal_table"] = "lsa-internal-table"
                                self._children_yang_names.add("lsa-internal-table")

                                self.lsa_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable()
                                self.lsa_table.parent = self
                                self._children_name_map["lsa_table"] = "lsa-table"
                                self._children_yang_names.add("lsa-table")


                            class LsaTable(Entity):
                                """
                                Database LSA information
                                
                                .. attribute:: lsa
                                
                                	Database LSA information
                                	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable, self).__init__()

                                    self.yang_name = "lsa-table"
                                    self.yang_parent_name = "database-table"

                                    self.lsa = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable, self).__setattr__(name, value)


                                class Lsa(Entity):
                                    """
                                    Database LSA information
                                    
                                    .. attribute:: advertising_router
                                    
                                    	Advertising Router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: area_id
                                    
                                    	Area ID
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: interface_name
                                    
                                    	InterfaceName
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: ls_id
                                    
                                    	Link state ID
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: ls_type
                                    
                                    	LSA type
                                    	**type**\:   :py:class:`Ospfv3Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa>`
                                    
                                    .. attribute:: lsa_info
                                    
                                    	Summary of all LSAs or LSA specific information 
                                    	**type**\:   :py:class:`LsaInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa, self).__init__()

                                        self.yang_name = "lsa"
                                        self.yang_parent_name = "lsa-table"

                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                        self.area_id = YLeaf(YType.int32, "area-id")

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.ls_id = YLeaf(YType.int32, "ls-id")

                                        self.ls_type = YLeaf(YType.enumeration, "ls-type")

                                        self.lsa_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo()
                                        self.lsa_info.parent = self
                                        self._children_name_map["lsa_info"] = "lsa-info"
                                        self._children_yang_names.add("lsa-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("advertising_router",
                                                        "area_id",
                                                        "interface_name",
                                                        "ls_id",
                                                        "ls_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa, self).__setattr__(name, value)


                                    class LsaInfo(Entity):
                                        """
                                        Summary of all LSAs or LSA specific information 
                                        
                                        .. attribute:: external_lsa_type
                                        
                                        	External LSA
                                        	**type**\:   :py:class:`ExternalLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType>`
                                        
                                        .. attribute:: grace_lsa
                                        
                                        	Grace LSA
                                        	**type**\:   :py:class:`GraceLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa>`
                                        
                                        .. attribute:: inter_area_prefix_lsa_type
                                        
                                        	Inter Area Prefix LSA
                                        	**type**\:   :py:class:`InterAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType>`
                                        
                                        .. attribute:: inter_area_router_lsa_type
                                        
                                        	Inter Area Router LSA
                                        	**type**\:   :py:class:`InterAreaRouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType>`
                                        
                                        .. attribute:: intra_area_prefix_lsa_type
                                        
                                        	Intra Area Prefix LSA
                                        	**type**\:   :py:class:`IntraAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType>`
                                        
                                        .. attribute:: link_lsa_type
                                        
                                        	Link LSA
                                        	**type**\:   :py:class:`LinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType>`
                                        
                                        .. attribute:: lsa_info_type
                                        
                                        	LSAInfoType
                                        	**type**\:   :py:class:`Ospfv3LsaInfoTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3LsaInfoTypes>`
                                        
                                        .. attribute:: lsa_summary_info
                                        
                                        	Summary information of LSAs
                                        	**type**\:   :py:class:`LsaSummaryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo>`
                                        
                                        .. attribute:: network_lsa_type
                                        
                                        	Network LSA
                                        	**type**\:   :py:class:`NetworkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType>`
                                        
                                        .. attribute:: nssalsa_type
                                        
                                        	NSSA External LSA
                                        	**type**\:   :py:class:`NssalsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType>`
                                        
                                        .. attribute:: router_lsa_type
                                        
                                        	Router LSA
                                        	**type**\:   :py:class:`RouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType>`
                                        
                                        .. attribute:: unknown_area_lsa_type
                                        
                                        	Unknown\-Area scope LSA
                                        	**type**\:   :py:class:`UnknownAreaLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType>`
                                        
                                        .. attribute:: unknown_aslsa_type
                                        
                                        	Unknown\-AS scope LSA
                                        	**type**\:   :py:class:`UnknownAslsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType>`
                                        
                                        .. attribute:: unknown_link_lsa_type
                                        
                                        	Unknown Link Scope LSA
                                        	**type**\:   :py:class:`UnknownLinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType>`
                                        
                                        .. attribute:: unknown_lsa_type
                                        
                                        	Unknown LSA
                                        	**type**\:   :py:class:`UnknownLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__init__()

                                            self.yang_name = "lsa-info"
                                            self.yang_parent_name = "lsa"

                                            self.lsa_info_type = YLeaf(YType.enumeration, "lsa-info-type")

                                            self.external_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType()
                                            self.external_lsa_type.parent = self
                                            self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                            self._children_yang_names.add("external-lsa-type")

                                            self.grace_lsa = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa()
                                            self.grace_lsa.parent = self
                                            self._children_name_map["grace_lsa"] = "grace-lsa"
                                            self._children_yang_names.add("grace-lsa")

                                            self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                            self.inter_area_prefix_lsa_type.parent = self
                                            self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                            self._children_yang_names.add("inter-area-prefix-lsa-type")

                                            self.inter_area_router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                            self.inter_area_router_lsa_type.parent = self
                                            self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                            self._children_yang_names.add("inter-area-router-lsa-type")

                                            self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                            self.intra_area_prefix_lsa_type.parent = self
                                            self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                            self._children_yang_names.add("intra-area-prefix-lsa-type")

                                            self.link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType()
                                            self.link_lsa_type.parent = self
                                            self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                            self._children_yang_names.add("link-lsa-type")

                                            self.lsa_summary_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo()
                                            self.lsa_summary_info.parent = self
                                            self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                            self._children_yang_names.add("lsa-summary-info")

                                            self.network_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType()
                                            self.network_lsa_type.parent = self
                                            self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                            self._children_yang_names.add("network-lsa-type")

                                            self.nssalsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType()
                                            self.nssalsa_type.parent = self
                                            self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                            self._children_yang_names.add("nssalsa-type")

                                            self.router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType()
                                            self.router_lsa_type.parent = self
                                            self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                            self._children_yang_names.add("router-lsa-type")

                                            self.unknown_area_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                            self.unknown_area_lsa_type.parent = self
                                            self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                            self._children_yang_names.add("unknown-area-lsa-type")

                                            self.unknown_aslsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType()
                                            self.unknown_aslsa_type.parent = self
                                            self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                            self._children_yang_names.add("unknown-aslsa-type")

                                            self.unknown_link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                            self.unknown_link_lsa_type.parent = self
                                            self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                            self._children_yang_names.add("unknown-link-lsa-type")

                                            self.unknown_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType()
                                            self.unknown_lsa_type.parent = self
                                            self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                            self._children_yang_names.add("unknown-lsa-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("lsa_info_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo, self).__setattr__(name, value)


                                        class LsaSummaryInfo(Entity):
                                            """
                                            Summary information of LSAs
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface name 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: links
                                            
                                            	Number of links
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader>`
                                            
                                            .. attribute:: lsa_router_id
                                            
                                            	LSA router ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: prefix
                                            
                                            	OSPFv3 address Prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: prefix_length
                                            
                                            	Prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: reference_lsa_id
                                            
                                            	Reference LSA ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: reference_type
                                            
                                            	Reference type 
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: router_la_bits
                                            
                                            	Router LA bits 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Sham link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__init__()

                                                self.yang_name = "lsa-summary-info"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.links = YLeaf(YType.uint16, "links")

                                                self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                                self.reference_type = YLeaf(YType.uint16, "reference-type")

                                                self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "links",
                                                                "lsa_router_id",
                                                                "prefix",
                                                                "prefix_length",
                                                                "reference_lsa_id",
                                                                "reference_type",
                                                                "router_la_bits",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "lsa-summary-info"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "lsa-summary-info"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.links.is_set or
                                                    self.lsa_router_id.is_set or
                                                    self.prefix.is_set or
                                                    self.prefix_length.is_set or
                                                    self.reference_lsa_id.is_set or
                                                    self.reference_type.is_set or
                                                    self.router_la_bits.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.links.yfilter != YFilter.not_set or
                                                    self.lsa_router_id.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.prefix_length.yfilter != YFilter.not_set or
                                                    self.reference_lsa_id.yfilter != YFilter.not_set or
                                                    self.reference_type.yfilter != YFilter.not_set or
                                                    self.router_la_bits.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-summary-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.links.get_name_leafdata())
                                                if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_router_id.get_name_leafdata())
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                                if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.reference_type.get_name_leafdata())
                                                if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.router_la_bits.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "links" or name == "lsa-router-id" or name == "prefix" or name == "prefix-length" or name == "reference-lsa-id" or name == "reference-type" or name == "router-la-bits" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "links"):
                                                    self.links = value
                                                    self.links.value_namespace = name_space
                                                    self.links.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-router-id"):
                                                    self.lsa_router_id = value
                                                    self.lsa_router_id.value_namespace = name_space
                                                    self.lsa_router_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix-length"):
                                                    self.prefix_length = value
                                                    self.prefix_length.value_namespace = name_space
                                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "reference-lsa-id"):
                                                    self.reference_lsa_id = value
                                                    self.reference_lsa_id.value_namespace = name_space
                                                    self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "reference-type"):
                                                    self.reference_type = value
                                                    self.reference_type.value_namespace = name_space
                                                    self.reference_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "router-la-bits"):
                                                    self.router_la_bits = value
                                                    self.router_la_bits.value_namespace = name_space
                                                    self.router_la_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                        class RouterLsaType(Entity):
                                            """
                                            Router LSA
                                            
                                            .. attribute:: link
                                            
                                            	List of links in this LSA
                                            	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link>`
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader>`
                                            
                                            .. attribute:: router_la_bits
                                            
                                            	Router LA bits 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: rpf_path
                                            
                                            	Router LSA Reverse\-Path Forwarding information 
                                            	**type**\:   :py:class:`RpfPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__init__()

                                                self.yang_name = "router-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                                self.rpf_path = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                self.rpf_path.parent = self
                                                self._children_name_map["rpf_path"] = "rpf-path"
                                                self._children_yang_names.add("rpf-path")

                                                self.link = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("router_la_bits") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "router-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "router-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix


                                            class RpfPath(Entity):
                                                """
                                                Router LSA Reverse\-Path Forwarding information 
                                                
                                                .. attribute:: interface_name
                                                
                                                	RPF multicast IDB 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: rpf_multicast_next_hop
                                                
                                                	RPF multicast next hop 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__init__()

                                                    self.yang_name = "rpf-path"
                                                    self.yang_parent_name = "router-lsa-type"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.rpf_multicast_next_hop = YLeaf(YType.uint32, "rpf-multicast-next-hop")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "rpf_multicast_next_hop") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.rpf_multicast_next_hop.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.rpf_multicast_next_hop.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "rpf-path" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.rpf_multicast_next_hop.is_set or self.rpf_multicast_next_hop.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rpf_multicast_next_hop.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "interface-name" or name == "rpf-multicast-next-hop"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rpf-multicast-next-hop"):
                                                        self.rpf_multicast_next_hop = value
                                                        self.rpf_multicast_next_hop.value_namespace = name_space
                                                        self.rpf_multicast_next_hop.value_namespace_prefix = name_space_prefix


                                            class Link(Entity):
                                                """
                                                List of links in this LSA
                                                
                                                .. attribute:: link_interface_id
                                                
                                                	LSA link interface ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: link_metric
                                                
                                                	LSA link metric 
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: link_neighbor_interface_id
                                                
                                                	LSA link neighbor interface ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: link_neighbor_router_id
                                                
                                                	LSA link neigbhor router id 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: link_type
                                                
                                                	Type of link
                                                	**type**\:   :py:class:`Ospfv3Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Link>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__init__()

                                                    self.yang_name = "link"
                                                    self.yang_parent_name = "router-lsa-type"

                                                    self.link_interface_id = YLeaf(YType.uint32, "link-interface-id")

                                                    self.link_metric = YLeaf(YType.uint16, "link-metric")

                                                    self.link_neighbor_interface_id = YLeaf(YType.uint32, "link-neighbor-interface-id")

                                                    self.link_neighbor_router_id = YLeaf(YType.uint32, "link-neighbor-router-id")

                                                    self.link_type = YLeaf(YType.enumeration, "link-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("link_interface_id",
                                                                    "link_metric",
                                                                    "link_neighbor_interface_id",
                                                                    "link_neighbor_router_id",
                                                                    "link_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.link_interface_id.is_set or
                                                        self.link_metric.is_set or
                                                        self.link_neighbor_interface_id.is_set or
                                                        self.link_neighbor_router_id.is_set or
                                                        self.link_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.link_interface_id.yfilter != YFilter.not_set or
                                                        self.link_metric.yfilter != YFilter.not_set or
                                                        self.link_neighbor_interface_id.yfilter != YFilter.not_set or
                                                        self.link_neighbor_router_id.yfilter != YFilter.not_set or
                                                        self.link_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "link" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.link_interface_id.is_set or self.link_interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.link_interface_id.get_name_leafdata())
                                                    if (self.link_metric.is_set or self.link_metric.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.link_metric.get_name_leafdata())
                                                    if (self.link_neighbor_interface_id.is_set or self.link_neighbor_interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.link_neighbor_interface_id.get_name_leafdata())
                                                    if (self.link_neighbor_router_id.is_set or self.link_neighbor_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.link_neighbor_router_id.get_name_leafdata())
                                                    if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.link_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "link-interface-id" or name == "link-metric" or name == "link-neighbor-interface-id" or name == "link-neighbor-router-id" or name == "link-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "link-interface-id"):
                                                        self.link_interface_id = value
                                                        self.link_interface_id.value_namespace = name_space
                                                        self.link_interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "link-metric"):
                                                        self.link_metric = value
                                                        self.link_metric.value_namespace = name_space
                                                        self.link_metric.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "link-neighbor-interface-id"):
                                                        self.link_neighbor_interface_id = value
                                                        self.link_neighbor_interface_id.value_namespace = name_space
                                                        self.link_neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "link-neighbor-router-id"):
                                                        self.link_neighbor_router_id = value
                                                        self.link_neighbor_router_id.value_namespace = name_space
                                                        self.link_neighbor_router_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "link-type"):
                                                        self.link_type = value
                                                        self.link_type.value_namespace = name_space
                                                        self.link_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.link:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.router_la_bits.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()) or
                                                    (self.rpf_path is not None and self.rpf_path.has_data()))

                                            def has_operation(self):
                                                for c in self.link:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.router_la_bits.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()) or
                                                    (self.rpf_path is not None and self.rpf_path.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "router-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.router_la_bits.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "link"):
                                                    for c in self.link:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.Link()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.link.append(c)
                                                    return c

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                if (child_yang_name == "rpf-path"):
                                                    if (self.rpf_path is None):
                                                        self.rpf_path = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                        self.rpf_path.parent = self
                                                        self._children_name_map["rpf_path"] = "rpf-path"
                                                    return self.rpf_path

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "link" or name == "lsa-detail" or name == "lsa-header" or name == "rpf-path" or name == "router-la-bits"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "router-la-bits"):
                                                    self.router_la_bits = value
                                                    self.router_la_bits.value_namespace = name_space
                                                    self.router_la_bits.value_namespace_prefix = name_space_prefix


                                        class NetworkLsaType(Entity):
                                            """
                                            Network LSA
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader>`
                                            
                                            .. attribute:: neighbor_router
                                            
                                            	Neighbor router list
                                            	**type**\:  list of str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__init__()

                                                self.yang_name = "network-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.neighbor_router = YLeafList(YType.str, "neighbor-router")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("neighbor_router") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "network-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "network-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for leaf in self.neighbor_router.getYLeafs():
                                                    if (leaf.yfilter != YFilter.not_set):
                                                        return True
                                                return (
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                for leaf in self.neighbor_router.getYLeafs():
                                                    if (leaf.is_set):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.neighbor_router.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "network-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                leaf_name_data.extend(self.neighbor_router.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "neighbor-router"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "neighbor-router"):
                                                    self.neighbor_router.append(value)


                                        class InterAreaPrefixLsaType(Entity):
                                            """
                                            Inter Area Prefix LSA
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA Information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader>`
                                            
                                            .. attribute:: prefix
                                            
                                            	LSA address prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: prefix_length
                                            
                                            	Prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: priority
                                            
                                            	Prefix priority
                                            	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__init__()

                                                self.yang_name = "inter-area-prefix-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                self.priority = YLeaf(YType.enumeration, "priority")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("prefix",
                                                                "prefix_length",
                                                                "priority") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA Information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.prefix.is_set or
                                                    self.prefix_length.is_set or
                                                    self.priority.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.prefix_length.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inter-area-prefix-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "prefix-length" or name == "priority"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix-length"):
                                                    self.prefix_length = value
                                                    self.prefix_length.value_namespace = name_space
                                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix


                                        class InterAreaRouterLsaType(Entity):
                                            """
                                            Inter Area Router LSA
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader>`
                                            
                                            .. attribute:: lsa_router_id
                                            
                                            	LSA router ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__init__()

                                                self.yang_name = "inter-area-router-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("lsa_router_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "inter-area-router-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "inter-area-router-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.lsa_router_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.lsa_router_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inter-area-router-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_router_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "lsa-router-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "lsa-router-id"):
                                                    self.lsa_router_id = value
                                                    self.lsa_router_id.value_namespace = name_space
                                                    self.lsa_router_id.value_namespace_prefix = name_space_prefix


                                        class ExternalLsaType(Entity):
                                            """
                                            External LSA
                                            
                                            .. attribute:: external_tag
                                            
                                            	Route Tag
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forwarding_address
                                            
                                            	Forwarding Address
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: is_forwarding_address_set
                                            
                                            	If true, forwarding address is set 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA Information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader>`
                                            
                                            .. attribute:: metric_type
                                            
                                            	Metric type 
                                            	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                            
                                            .. attribute:: prefix
                                            
                                            	IPV6 address prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: prefix_length
                                            
                                            	Prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: priority
                                            
                                            	Prefix priority
                                            	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                            
                                            .. attribute:: tos_cost
                                            
                                            	Type of service cost metric 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__init__()

                                                self.yang_name = "external-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.external_tag = YLeaf(YType.uint32, "external-tag")

                                                self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                                self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                                self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                self.priority = YLeaf(YType.enumeration, "priority")

                                                self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("external_tag",
                                                                "forwarding_address",
                                                                "is_forwarding_address_set",
                                                                "metric_type",
                                                                "prefix",
                                                                "prefix_length",
                                                                "priority",
                                                                "tos_cost") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "external-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA Information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "external-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.external_tag.is_set or
                                                    self.forwarding_address.is_set or
                                                    self.is_forwarding_address_set.is_set or
                                                    self.metric_type.is_set or
                                                    self.prefix.is_set or
                                                    self.prefix_length.is_set or
                                                    self.priority.is_set or
                                                    self.tos_cost.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.external_tag.yfilter != YFilter.not_set or
                                                    self.forwarding_address.yfilter != YFilter.not_set or
                                                    self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                    self.metric_type.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.prefix_length.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set or
                                                    self.tos_cost.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "external-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.external_tag.get_name_leafdata())
                                                if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                                if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                                if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.metric_type.get_name_leafdata())
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())
                                                if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "external-tag"):
                                                    self.external_tag = value
                                                    self.external_tag.value_namespace = name_space
                                                    self.external_tag.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forwarding-address"):
                                                    self.forwarding_address = value
                                                    self.forwarding_address.value_namespace = name_space
                                                    self.forwarding_address.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-forwarding-address-set"):
                                                    self.is_forwarding_address_set = value
                                                    self.is_forwarding_address_set.value_namespace = name_space
                                                    self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                                if(value_path == "metric-type"):
                                                    self.metric_type = value
                                                    self.metric_type.value_namespace = name_space
                                                    self.metric_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix-length"):
                                                    self.prefix_length = value
                                                    self.prefix_length.value_namespace = name_space
                                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tos-cost"):
                                                    self.tos_cost = value
                                                    self.tos_cost.value_namespace = name_space
                                                    self.tos_cost.value_namespace_prefix = name_space_prefix


                                        class NssalsaType(Entity):
                                            """
                                            NSSA External LSA
                                            
                                            .. attribute:: external_tag
                                            
                                            	Route Tag
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forwarding_address
                                            
                                            	Forwarding Address
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: is_forwarding_address_set
                                            
                                            	If true, forwarding address is set 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA Information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader>`
                                            
                                            .. attribute:: metric_type
                                            
                                            	Metric type 
                                            	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                            
                                            .. attribute:: prefix
                                            
                                            	IPV6 address prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: prefix_length
                                            
                                            	Prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: priority
                                            
                                            	Prefix priority
                                            	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                            
                                            .. attribute:: tos_cost
                                            
                                            	Type of service cost metric 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__init__()

                                                self.yang_name = "nssalsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.external_tag = YLeaf(YType.uint32, "external-tag")

                                                self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                                self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                                self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                self.priority = YLeaf(YType.enumeration, "priority")

                                                self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("external_tag",
                                                                "forwarding_address",
                                                                "is_forwarding_address_set",
                                                                "metric_type",
                                                                "prefix",
                                                                "prefix_length",
                                                                "priority",
                                                                "tos_cost") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "nssalsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA Information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "nssalsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.external_tag.is_set or
                                                    self.forwarding_address.is_set or
                                                    self.is_forwarding_address_set.is_set or
                                                    self.metric_type.is_set or
                                                    self.prefix.is_set or
                                                    self.prefix_length.is_set or
                                                    self.priority.is_set or
                                                    self.tos_cost.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.external_tag.yfilter != YFilter.not_set or
                                                    self.forwarding_address.yfilter != YFilter.not_set or
                                                    self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                    self.metric_type.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.prefix_length.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set or
                                                    self.tos_cost.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "nssalsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.external_tag.get_name_leafdata())
                                                if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                                if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                                if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.metric_type.get_name_leafdata())
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())
                                                if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "external-tag"):
                                                    self.external_tag = value
                                                    self.external_tag.value_namespace = name_space
                                                    self.external_tag.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forwarding-address"):
                                                    self.forwarding_address = value
                                                    self.forwarding_address.value_namespace = name_space
                                                    self.forwarding_address.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-forwarding-address-set"):
                                                    self.is_forwarding_address_set = value
                                                    self.is_forwarding_address_set.value_namespace = name_space
                                                    self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                                if(value_path == "metric-type"):
                                                    self.metric_type = value
                                                    self.metric_type.value_namespace = name_space
                                                    self.metric_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix-length"):
                                                    self.prefix_length = value
                                                    self.prefix_length.value_namespace = name_space
                                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tos-cost"):
                                                    self.tos_cost = value
                                                    self.tos_cost.value_namespace = name_space
                                                    self.tos_cost.value_namespace_prefix = name_space_prefix


                                        class LinkLsaType(Entity):
                                            """
                                            Link LSA
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface handle
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader>`
                                            
                                            .. attribute:: lsa_link_local
                                            
                                            	LSA link local 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: prefix
                                            
                                            	OSPFv3 prefix 
                                            	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix>`
                                            
                                            .. attribute:: router_priority
                                            
                                            	Router priority 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Sham link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__init__()

                                                self.yang_name = "link-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.lsa_link_local = YLeaf(YType.str, "lsa-link-local")

                                                self.router_priority = YLeaf(YType.uint8, "router-priority")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                                self.prefix = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "lsa_link_local",
                                                                "router_priority",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "link-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "link-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix


                                            class Prefix(Entity):
                                                """
                                                OSPFv3 prefix 
                                                
                                                .. attribute:: ospfv3_prefix_length
                                                
                                                	OSPFv3 prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ospfv3_prefix_metric
                                                
                                                	OSPFv3 prefix metric 
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: ospfv3_prefix_options
                                                
                                                	OSPFv3 prefix options 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: prefix
                                                
                                                	OSPFv3 prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: priority
                                                
                                                	Prefix priority
                                                	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__init__()

                                                    self.yang_name = "prefix"
                                                    self.yang_parent_name = "link-lsa-type"

                                                    self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                    self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                    self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.priority = YLeaf(YType.enumeration, "priority")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("ospfv3_prefix_length",
                                                                    "ospfv3_prefix_metric",
                                                                    "ospfv3_prefix_options",
                                                                    "prefix",
                                                                    "priority") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.ospfv3_prefix_length.is_set or
                                                        self.ospfv3_prefix_metric.is_set or
                                                        self.ospfv3_prefix_options.is_set or
                                                        self.prefix.is_set or
                                                        self.priority.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.priority.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prefix" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                    if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                    if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.priority.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "ospfv3-prefix-length"):
                                                        self.ospfv3_prefix_length = value
                                                        self.ospfv3_prefix_length.value_namespace = name_space
                                                        self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ospfv3-prefix-metric"):
                                                        self.ospfv3_prefix_metric = value
                                                        self.ospfv3_prefix_metric.value_namespace = name_space
                                                        self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ospfv3-prefix-options"):
                                                        self.ospfv3_prefix_options = value
                                                        self.ospfv3_prefix_options.value_namespace = name_space
                                                        self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "priority"):
                                                        self.priority = value
                                                        self.priority.value_namespace = name_space
                                                        self.priority.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prefix:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.lsa_link_local.is_set or
                                                    self.router_priority.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                for c in self.prefix:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.lsa_link_local.yfilter != YFilter.not_set or
                                                    self.router_priority.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "link-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.lsa_link_local.is_set or self.lsa_link_local.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_link_local.get_name_leafdata())
                                                if (self.router_priority.is_set or self.router_priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.router_priority.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                if (child_yang_name == "prefix"):
                                                    for c in self.prefix:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType.Prefix()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prefix.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "lsa-link-local" or name == "router-priority" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-link-local"):
                                                    self.lsa_link_local = value
                                                    self.lsa_link_local.value_namespace = name_space
                                                    self.lsa_link_local.value_namespace_prefix = name_space_prefix
                                                if(value_path == "router-priority"):
                                                    self.router_priority = value
                                                    self.router_priority.value_namespace = name_space
                                                    self.router_priority.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                        class IntraAreaPrefixLsaType(Entity):
                                            """
                                            Intra Area Prefix LSA
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader>`
                                            
                                            .. attribute:: prefix
                                            
                                            	OSPFv3 prefix 
                                            	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix>`
                                            
                                            .. attribute:: reference_advertised_router
                                            
                                            	Reference advertised router 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: reference_lsa_id
                                            
                                            	Reference LSA ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: reference_type
                                            
                                            	Reference type 
                                            	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__init__()

                                                self.yang_name = "intra-area-prefix-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.reference_advertised_router = YLeaf(YType.str, "reference-advertised-router")

                                                self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                                self.reference_type = YLeaf(YType.enumeration, "reference-type")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                                self.prefix = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("reference_advertised_router",
                                                                "reference_lsa_id",
                                                                "reference_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix


                                            class Prefix(Entity):
                                                """
                                                OSPFv3 prefix 
                                                
                                                .. attribute:: ospfv3_prefix_length
                                                
                                                	OSPFv3 prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ospfv3_prefix_metric
                                                
                                                	OSPFv3 prefix metric 
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: ospfv3_prefix_options
                                                
                                                	OSPFv3 prefix options 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: prefix
                                                
                                                	OSPFv3 prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: priority
                                                
                                                	Prefix priority
                                                	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__init__()

                                                    self.yang_name = "prefix"
                                                    self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                    self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                    self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                    self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.priority = YLeaf(YType.enumeration, "priority")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("ospfv3_prefix_length",
                                                                    "ospfv3_prefix_metric",
                                                                    "ospfv3_prefix_options",
                                                                    "prefix",
                                                                    "priority") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.ospfv3_prefix_length.is_set or
                                                        self.ospfv3_prefix_metric.is_set or
                                                        self.ospfv3_prefix_options.is_set or
                                                        self.prefix.is_set or
                                                        self.priority.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.priority.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prefix" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                    if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                    if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.priority.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "ospfv3-prefix-length"):
                                                        self.ospfv3_prefix_length = value
                                                        self.ospfv3_prefix_length.value_namespace = name_space
                                                        self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ospfv3-prefix-metric"):
                                                        self.ospfv3_prefix_metric = value
                                                        self.ospfv3_prefix_metric.value_namespace = name_space
                                                        self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ospfv3-prefix-options"):
                                                        self.ospfv3_prefix_options = value
                                                        self.ospfv3_prefix_options.value_namespace = name_space
                                                        self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "priority"):
                                                        self.priority = value
                                                        self.priority.value_namespace = name_space
                                                        self.priority.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prefix:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.reference_advertised_router.is_set or
                                                    self.reference_lsa_id.is_set or
                                                    self.reference_type.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                for c in self.prefix:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.reference_advertised_router.yfilter != YFilter.not_set or
                                                    self.reference_lsa_id.yfilter != YFilter.not_set or
                                                    self.reference_type.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "intra-area-prefix-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.reference_advertised_router.is_set or self.reference_advertised_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.reference_advertised_router.get_name_leafdata())
                                                if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                                if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.reference_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                if (child_yang_name == "prefix"):
                                                    for c in self.prefix:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prefix.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "reference-advertised-router" or name == "reference-lsa-id" or name == "reference-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "reference-advertised-router"):
                                                    self.reference_advertised_router = value
                                                    self.reference_advertised_router.value_namespace = name_space
                                                    self.reference_advertised_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "reference-lsa-id"):
                                                    self.reference_lsa_id = value
                                                    self.reference_lsa_id.value_namespace = name_space
                                                    self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "reference-type"):
                                                    self.reference_type = value
                                                    self.reference_type.value_namespace = name_space
                                                    self.reference_type.value_namespace_prefix = name_space_prefix


                                        class GraceLsa(Entity):
                                            """
                                            Grace LSA
                                            
                                            .. attribute:: grace_period
                                            
                                            	The grace periord where helper routers should wait before advertising it fully adjacent(s) 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: grace_reason
                                            
                                            	Reason for router restart
                                            	**type**\:   :py:class:`Ospfv3GracefulRestartReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3GracefulRestartReason>`
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__init__()

                                                self.yang_name = "grace-lsa"
                                                self.yang_parent_name = "lsa-info"

                                                self.grace_period = YLeaf(YType.uint32, "grace-period")

                                                self.grace_reason = YLeaf(YType.enumeration, "grace-reason")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("grace_period",
                                                                "grace_reason") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "grace-lsa"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "grace-lsa"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.grace_period.is_set or
                                                    self.grace_reason.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.grace_period.yfilter != YFilter.not_set or
                                                    self.grace_reason.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "grace-lsa" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.grace_period.is_set or self.grace_period.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grace_period.get_name_leafdata())
                                                if (self.grace_reason.is_set or self.grace_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grace_reason.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "grace-period" or name == "grace-reason"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "grace-period"):
                                                    self.grace_period = value
                                                    self.grace_period.value_namespace = name_space
                                                    self.grace_period.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grace-reason"):
                                                    self.grace_reason = value
                                                    self.grace_reason.value_namespace = name_space
                                                    self.grace_reason.value_namespace_prefix = name_space_prefix


                                        class UnknownLinkLsaType(Entity):
                                            """
                                            Unknown Link Scope LSA
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface name 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader>`
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Shamlink ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__init__()

                                                self.yang_name = "unknown-link-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "unknown-link-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "unknown-link-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "unknown-link-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                        class UnknownAreaLsaType(Entity):
                                            """
                                            Unknown\-Area scope LSA
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface name 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader>`
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Shamlink ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__init__()

                                                self.yang_name = "unknown-area-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "unknown-area-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "unknown-area-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "unknown-area-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                        class UnknownAslsaType(Entity):
                                            """
                                            Unknown\-AS scope LSA
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface name 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader>`
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Shamlink ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__init__()

                                                self.yang_name = "unknown-aslsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "unknown-aslsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "unknown-aslsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "unknown-aslsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                        class UnknownLsaType(Entity):
                                            """
                                            Unknown LSA
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface name 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader>`
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Shamlink ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__init__()

                                                self.yang_name = "unknown-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "unknown-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "unknown-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "unknown-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.lsa_info_type.is_set or
                                                (self.external_lsa_type is not None and self.external_lsa_type.has_data()) or
                                                (self.grace_lsa is not None and self.grace_lsa.has_data()) or
                                                (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_data()) or
                                                (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_data()) or
                                                (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_data()) or
                                                (self.link_lsa_type is not None and self.link_lsa_type.has_data()) or
                                                (self.lsa_summary_info is not None and self.lsa_summary_info.has_data()) or
                                                (self.network_lsa_type is not None and self.network_lsa_type.has_data()) or
                                                (self.nssalsa_type is not None and self.nssalsa_type.has_data()) or
                                                (self.router_lsa_type is not None and self.router_lsa_type.has_data()) or
                                                (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_data()) or
                                                (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_data()) or
                                                (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_data()) or
                                                (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.lsa_info_type.yfilter != YFilter.not_set or
                                                (self.external_lsa_type is not None and self.external_lsa_type.has_operation()) or
                                                (self.grace_lsa is not None and self.grace_lsa.has_operation()) or
                                                (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_operation()) or
                                                (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_operation()) or
                                                (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_operation()) or
                                                (self.link_lsa_type is not None and self.link_lsa_type.has_operation()) or
                                                (self.lsa_summary_info is not None and self.lsa_summary_info.has_operation()) or
                                                (self.network_lsa_type is not None and self.network_lsa_type.has_operation()) or
                                                (self.nssalsa_type is not None and self.nssalsa_type.has_operation()) or
                                                (self.router_lsa_type is not None and self.router_lsa_type.has_operation()) or
                                                (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_operation()) or
                                                (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_operation()) or
                                                (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_operation()) or
                                                (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.lsa_info_type.is_set or self.lsa_info_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_info_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "external-lsa-type"):
                                                if (self.external_lsa_type is None):
                                                    self.external_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.ExternalLsaType()
                                                    self.external_lsa_type.parent = self
                                                    self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                                return self.external_lsa_type

                                            if (child_yang_name == "grace-lsa"):
                                                if (self.grace_lsa is None):
                                                    self.grace_lsa = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.GraceLsa()
                                                    self.grace_lsa.parent = self
                                                    self._children_name_map["grace_lsa"] = "grace-lsa"
                                                return self.grace_lsa

                                            if (child_yang_name == "inter-area-prefix-lsa-type"):
                                                if (self.inter_area_prefix_lsa_type is None):
                                                    self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                                    self.inter_area_prefix_lsa_type.parent = self
                                                    self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                                return self.inter_area_prefix_lsa_type

                                            if (child_yang_name == "inter-area-router-lsa-type"):
                                                if (self.inter_area_router_lsa_type is None):
                                                    self.inter_area_router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                                    self.inter_area_router_lsa_type.parent = self
                                                    self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                                return self.inter_area_router_lsa_type

                                            if (child_yang_name == "intra-area-prefix-lsa-type"):
                                                if (self.intra_area_prefix_lsa_type is None):
                                                    self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                                    self.intra_area_prefix_lsa_type.parent = self
                                                    self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                                return self.intra_area_prefix_lsa_type

                                            if (child_yang_name == "link-lsa-type"):
                                                if (self.link_lsa_type is None):
                                                    self.link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LinkLsaType()
                                                    self.link_lsa_type.parent = self
                                                    self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                                return self.link_lsa_type

                                            if (child_yang_name == "lsa-summary-info"):
                                                if (self.lsa_summary_info is None):
                                                    self.lsa_summary_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.LsaSummaryInfo()
                                                    self.lsa_summary_info.parent = self
                                                    self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                                return self.lsa_summary_info

                                            if (child_yang_name == "network-lsa-type"):
                                                if (self.network_lsa_type is None):
                                                    self.network_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NetworkLsaType()
                                                    self.network_lsa_type.parent = self
                                                    self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                                return self.network_lsa_type

                                            if (child_yang_name == "nssalsa-type"):
                                                if (self.nssalsa_type is None):
                                                    self.nssalsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.NssalsaType()
                                                    self.nssalsa_type.parent = self
                                                    self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                                return self.nssalsa_type

                                            if (child_yang_name == "router-lsa-type"):
                                                if (self.router_lsa_type is None):
                                                    self.router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.RouterLsaType()
                                                    self.router_lsa_type.parent = self
                                                    self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                                return self.router_lsa_type

                                            if (child_yang_name == "unknown-area-lsa-type"):
                                                if (self.unknown_area_lsa_type is None):
                                                    self.unknown_area_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                                    self.unknown_area_lsa_type.parent = self
                                                    self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                                return self.unknown_area_lsa_type

                                            if (child_yang_name == "unknown-aslsa-type"):
                                                if (self.unknown_aslsa_type is None):
                                                    self.unknown_aslsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownAslsaType()
                                                    self.unknown_aslsa_type.parent = self
                                                    self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                                return self.unknown_aslsa_type

                                            if (child_yang_name == "unknown-link-lsa-type"):
                                                if (self.unknown_link_lsa_type is None):
                                                    self.unknown_link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                                    self.unknown_link_lsa_type.parent = self
                                                    self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                                return self.unknown_link_lsa_type

                                            if (child_yang_name == "unknown-lsa-type"):
                                                if (self.unknown_lsa_type is None):
                                                    self.unknown_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo.UnknownLsaType()
                                                    self.unknown_lsa_type.parent = self
                                                    self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                                return self.unknown_lsa_type

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "external-lsa-type" or name == "grace-lsa" or name == "inter-area-prefix-lsa-type" or name == "inter-area-router-lsa-type" or name == "intra-area-prefix-lsa-type" or name == "link-lsa-type" or name == "lsa-summary-info" or name == "network-lsa-type" or name == "nssalsa-type" or name == "router-lsa-type" or name == "unknown-area-lsa-type" or name == "unknown-aslsa-type" or name == "unknown-link-lsa-type" or name == "unknown-lsa-type" or name == "lsa-info-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "lsa-info-type"):
                                                self.lsa_info_type = value
                                                self.lsa_info_type.value_namespace = name_space
                                                self.lsa_info_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.advertising_router.is_set or
                                            self.area_id.is_set or
                                            self.interface_name.is_set or
                                            self.ls_id.is_set or
                                            self.ls_type.is_set or
                                            (self.lsa_info is not None and self.lsa_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.advertising_router.yfilter != YFilter.not_set or
                                            self.area_id.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.ls_id.yfilter != YFilter.not_set or
                                            self.ls_type.yfilter != YFilter.not_set or
                                            (self.lsa_info is not None and self.lsa_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsa" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                        if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_id.get_name_leafdata())
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                        if (self.ls_type.is_set or self.ls_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ls_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-info"):
                                            if (self.lsa_info is None):
                                                self.lsa_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa.LsaInfo()
                                                self.lsa_info.parent = self
                                                self._children_name_map["lsa_info"] = "lsa-info"
                                            return self.lsa_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-info" or name == "advertising-router" or name == "area-id" or name == "interface-name" or name == "ls-id" or name == "ls-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "advertising-router"):
                                            self.advertising_router = value
                                            self.advertising_router.value_namespace = name_space
                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "area-id"):
                                            self.area_id = value
                                            self.area_id.value_namespace = name_space
                                            self.area_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ls-id"):
                                            self.ls_id = value
                                            self.ls_id.value_namespace = name_space
                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ls-type"):
                                            self.ls_type = value
                                            self.ls_type.value_namespace = name_space
                                            self.ls_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.lsa:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.lsa:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsa-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "lsa"):
                                        for c in self.lsa:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable.Lsa()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.lsa.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "lsa"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class LsaInternalTable(Entity):
                                """
                                Database LSA information
                                
                                .. attribute:: lsa
                                
                                	Database LSA information
                                	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable, self).__init__()

                                    self.yang_name = "lsa-internal-table"
                                    self.yang_parent_name = "database-table"

                                    self.lsa = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable, self).__setattr__(name, value)


                                class Lsa(Entity):
                                    """
                                    Database LSA information
                                    
                                    .. attribute:: advertising_router
                                    
                                    	Advertising Router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: area_id
                                    
                                    	Area ID
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: interface_name
                                    
                                    	InterfaceName
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: ls_id
                                    
                                    	Link state ID
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: ls_type
                                    
                                    	LSA type
                                    	**type**\:   :py:class:`Ospfv3Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa>`
                                    
                                    .. attribute:: lsa_info
                                    
                                    	Summary of all LSAs or LSA specific information 
                                    	**type**\:   :py:class:`LsaInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo>`
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa, self).__init__()

                                        self.yang_name = "lsa"
                                        self.yang_parent_name = "lsa-internal-table"

                                        self.advertising_router = YLeaf(YType.str, "advertising-router")

                                        self.area_id = YLeaf(YType.int32, "area-id")

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.ls_id = YLeaf(YType.int32, "ls-id")

                                        self.ls_type = YLeaf(YType.enumeration, "ls-type")

                                        self.lsa_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo()
                                        self.lsa_info.parent = self
                                        self._children_name_map["lsa_info"] = "lsa-info"
                                        self._children_yang_names.add("lsa-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("advertising_router",
                                                        "area_id",
                                                        "interface_name",
                                                        "ls_id",
                                                        "ls_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa, self).__setattr__(name, value)


                                    class LsaInfo(Entity):
                                        """
                                        Summary of all LSAs or LSA specific information 
                                        
                                        .. attribute:: external_lsa_type
                                        
                                        	External LSA
                                        	**type**\:   :py:class:`ExternalLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType>`
                                        
                                        .. attribute:: grace_lsa
                                        
                                        	Grace LSA
                                        	**type**\:   :py:class:`GraceLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa>`
                                        
                                        .. attribute:: inter_area_prefix_lsa_type
                                        
                                        	Inter Area Prefix LSA
                                        	**type**\:   :py:class:`InterAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType>`
                                        
                                        .. attribute:: inter_area_router_lsa_type
                                        
                                        	Inter Area Router LSA
                                        	**type**\:   :py:class:`InterAreaRouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType>`
                                        
                                        .. attribute:: intra_area_prefix_lsa_type
                                        
                                        	Intra Area Prefix LSA
                                        	**type**\:   :py:class:`IntraAreaPrefixLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType>`
                                        
                                        .. attribute:: link_lsa_type
                                        
                                        	Link LSA
                                        	**type**\:   :py:class:`LinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType>`
                                        
                                        .. attribute:: lsa_info_type
                                        
                                        	LSAInfoType
                                        	**type**\:   :py:class:`Ospfv3LsaInfoTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3LsaInfoTypes>`
                                        
                                        .. attribute:: lsa_summary_info
                                        
                                        	Summary information of LSAs
                                        	**type**\:   :py:class:`LsaSummaryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo>`
                                        
                                        .. attribute:: network_lsa_type
                                        
                                        	Network LSA
                                        	**type**\:   :py:class:`NetworkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType>`
                                        
                                        .. attribute:: nssalsa_type
                                        
                                        	NSSA External LSA
                                        	**type**\:   :py:class:`NssalsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType>`
                                        
                                        .. attribute:: router_lsa_type
                                        
                                        	Router LSA
                                        	**type**\:   :py:class:`RouterLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType>`
                                        
                                        .. attribute:: unknown_area_lsa_type
                                        
                                        	Unknown\-Area scope LSA
                                        	**type**\:   :py:class:`UnknownAreaLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType>`
                                        
                                        .. attribute:: unknown_aslsa_type
                                        
                                        	Unknown\-AS scope LSA
                                        	**type**\:   :py:class:`UnknownAslsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType>`
                                        
                                        .. attribute:: unknown_link_lsa_type
                                        
                                        	Unknown Link Scope LSA
                                        	**type**\:   :py:class:`UnknownLinkLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType>`
                                        
                                        .. attribute:: unknown_lsa_type
                                        
                                        	Unknown LSA
                                        	**type**\:   :py:class:`UnknownLsaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType>`
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__init__()

                                            self.yang_name = "lsa-info"
                                            self.yang_parent_name = "lsa"

                                            self.lsa_info_type = YLeaf(YType.enumeration, "lsa-info-type")

                                            self.external_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType()
                                            self.external_lsa_type.parent = self
                                            self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                            self._children_yang_names.add("external-lsa-type")

                                            self.grace_lsa = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa()
                                            self.grace_lsa.parent = self
                                            self._children_name_map["grace_lsa"] = "grace-lsa"
                                            self._children_yang_names.add("grace-lsa")

                                            self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                            self.inter_area_prefix_lsa_type.parent = self
                                            self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                            self._children_yang_names.add("inter-area-prefix-lsa-type")

                                            self.inter_area_router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                            self.inter_area_router_lsa_type.parent = self
                                            self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                            self._children_yang_names.add("inter-area-router-lsa-type")

                                            self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                            self.intra_area_prefix_lsa_type.parent = self
                                            self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                            self._children_yang_names.add("intra-area-prefix-lsa-type")

                                            self.link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType()
                                            self.link_lsa_type.parent = self
                                            self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                            self._children_yang_names.add("link-lsa-type")

                                            self.lsa_summary_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo()
                                            self.lsa_summary_info.parent = self
                                            self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                            self._children_yang_names.add("lsa-summary-info")

                                            self.network_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType()
                                            self.network_lsa_type.parent = self
                                            self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                            self._children_yang_names.add("network-lsa-type")

                                            self.nssalsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType()
                                            self.nssalsa_type.parent = self
                                            self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                            self._children_yang_names.add("nssalsa-type")

                                            self.router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType()
                                            self.router_lsa_type.parent = self
                                            self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                            self._children_yang_names.add("router-lsa-type")

                                            self.unknown_area_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                            self.unknown_area_lsa_type.parent = self
                                            self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                            self._children_yang_names.add("unknown-area-lsa-type")

                                            self.unknown_aslsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType()
                                            self.unknown_aslsa_type.parent = self
                                            self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                            self._children_yang_names.add("unknown-aslsa-type")

                                            self.unknown_link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                            self.unknown_link_lsa_type.parent = self
                                            self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                            self._children_yang_names.add("unknown-link-lsa-type")

                                            self.unknown_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType()
                                            self.unknown_lsa_type.parent = self
                                            self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                            self._children_yang_names.add("unknown-lsa-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("lsa_info_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo, self).__setattr__(name, value)


                                        class LsaSummaryInfo(Entity):
                                            """
                                            Summary information of LSAs
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface name 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: links
                                            
                                            	Number of links
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader>`
                                            
                                            .. attribute:: lsa_router_id
                                            
                                            	LSA router ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: prefix
                                            
                                            	OSPFv3 address Prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: prefix_length
                                            
                                            	Prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: reference_lsa_id
                                            
                                            	Reference LSA ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: reference_type
                                            
                                            	Reference type 
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: router_la_bits
                                            
                                            	Router LA bits 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Sham link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__init__()

                                                self.yang_name = "lsa-summary-info"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.links = YLeaf(YType.uint16, "links")

                                                self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                                self.reference_type = YLeaf(YType.uint16, "reference-type")

                                                self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "links",
                                                                "lsa_router_id",
                                                                "prefix",
                                                                "prefix_length",
                                                                "reference_lsa_id",
                                                                "reference_type",
                                                                "router_la_bits",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "lsa-summary-info"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "lsa-summary-info"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.links.is_set or
                                                    self.lsa_router_id.is_set or
                                                    self.prefix.is_set or
                                                    self.prefix_length.is_set or
                                                    self.reference_lsa_id.is_set or
                                                    self.reference_type.is_set or
                                                    self.router_la_bits.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.links.yfilter != YFilter.not_set or
                                                    self.lsa_router_id.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.prefix_length.yfilter != YFilter.not_set or
                                                    self.reference_lsa_id.yfilter != YFilter.not_set or
                                                    self.reference_type.yfilter != YFilter.not_set or
                                                    self.router_la_bits.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "lsa-summary-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.links.get_name_leafdata())
                                                if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_router_id.get_name_leafdata())
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                                if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.reference_type.get_name_leafdata())
                                                if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.router_la_bits.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "links" or name == "lsa-router-id" or name == "prefix" or name == "prefix-length" or name == "reference-lsa-id" or name == "reference-type" or name == "router-la-bits" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "links"):
                                                    self.links = value
                                                    self.links.value_namespace = name_space
                                                    self.links.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-router-id"):
                                                    self.lsa_router_id = value
                                                    self.lsa_router_id.value_namespace = name_space
                                                    self.lsa_router_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix-length"):
                                                    self.prefix_length = value
                                                    self.prefix_length.value_namespace = name_space
                                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "reference-lsa-id"):
                                                    self.reference_lsa_id = value
                                                    self.reference_lsa_id.value_namespace = name_space
                                                    self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "reference-type"):
                                                    self.reference_type = value
                                                    self.reference_type.value_namespace = name_space
                                                    self.reference_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "router-la-bits"):
                                                    self.router_la_bits = value
                                                    self.router_la_bits.value_namespace = name_space
                                                    self.router_la_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                        class RouterLsaType(Entity):
                                            """
                                            Router LSA
                                            
                                            .. attribute:: link
                                            
                                            	List of links in this LSA
                                            	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link>`
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader>`
                                            
                                            .. attribute:: router_la_bits
                                            
                                            	Router LA bits 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: rpf_path
                                            
                                            	Router LSA Reverse\-Path Forwarding information 
                                            	**type**\:   :py:class:`RpfPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__init__()

                                                self.yang_name = "router-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.router_la_bits = YLeaf(YType.uint8, "router-la-bits")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                                self.rpf_path = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                self.rpf_path.parent = self
                                                self._children_name_map["rpf_path"] = "rpf-path"
                                                self._children_yang_names.add("rpf-path")

                                                self.link = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("router_la_bits") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "router-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "router-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix


                                            class RpfPath(Entity):
                                                """
                                                Router LSA Reverse\-Path Forwarding information 
                                                
                                                .. attribute:: interface_name
                                                
                                                	RPF multicast IDB 
                                                	**type**\:  str
                                                
                                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                                
                                                .. attribute:: rpf_multicast_next_hop
                                                
                                                	RPF multicast next hop 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__init__()

                                                    self.yang_name = "rpf-path"
                                                    self.yang_parent_name = "router-lsa-type"

                                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                                    self.rpf_multicast_next_hop = YLeaf(YType.uint32, "rpf-multicast-next-hop")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("interface_name",
                                                                    "rpf_multicast_next_hop") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.interface_name.is_set or
                                                        self.rpf_multicast_next_hop.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.interface_name.yfilter != YFilter.not_set or
                                                        self.rpf_multicast_next_hop.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "rpf-path" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                    if (self.rpf_multicast_next_hop.is_set or self.rpf_multicast_next_hop.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rpf_multicast_next_hop.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "interface-name" or name == "rpf-multicast-next-hop"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "interface-name"):
                                                        self.interface_name = value
                                                        self.interface_name.value_namespace = name_space
                                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rpf-multicast-next-hop"):
                                                        self.rpf_multicast_next_hop = value
                                                        self.rpf_multicast_next_hop.value_namespace = name_space
                                                        self.rpf_multicast_next_hop.value_namespace_prefix = name_space_prefix


                                            class Link(Entity):
                                                """
                                                List of links in this LSA
                                                
                                                .. attribute:: link_interface_id
                                                
                                                	LSA link interface ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: link_metric
                                                
                                                	LSA link metric 
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: link_neighbor_interface_id
                                                
                                                	LSA link neighbor interface ID 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: link_neighbor_router_id
                                                
                                                	LSA link neigbhor router id 
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: link_type
                                                
                                                	Type of link
                                                	**type**\:   :py:class:`Ospfv3Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Link>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__init__()

                                                    self.yang_name = "link"
                                                    self.yang_parent_name = "router-lsa-type"

                                                    self.link_interface_id = YLeaf(YType.uint32, "link-interface-id")

                                                    self.link_metric = YLeaf(YType.uint16, "link-metric")

                                                    self.link_neighbor_interface_id = YLeaf(YType.uint32, "link-neighbor-interface-id")

                                                    self.link_neighbor_router_id = YLeaf(YType.uint32, "link-neighbor-router-id")

                                                    self.link_type = YLeaf(YType.enumeration, "link-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("link_interface_id",
                                                                    "link_metric",
                                                                    "link_neighbor_interface_id",
                                                                    "link_neighbor_router_id",
                                                                    "link_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.link_interface_id.is_set or
                                                        self.link_metric.is_set or
                                                        self.link_neighbor_interface_id.is_set or
                                                        self.link_neighbor_router_id.is_set or
                                                        self.link_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.link_interface_id.yfilter != YFilter.not_set or
                                                        self.link_metric.yfilter != YFilter.not_set or
                                                        self.link_neighbor_interface_id.yfilter != YFilter.not_set or
                                                        self.link_neighbor_router_id.yfilter != YFilter.not_set or
                                                        self.link_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "link" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.link_interface_id.is_set or self.link_interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.link_interface_id.get_name_leafdata())
                                                    if (self.link_metric.is_set or self.link_metric.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.link_metric.get_name_leafdata())
                                                    if (self.link_neighbor_interface_id.is_set or self.link_neighbor_interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.link_neighbor_interface_id.get_name_leafdata())
                                                    if (self.link_neighbor_router_id.is_set or self.link_neighbor_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.link_neighbor_router_id.get_name_leafdata())
                                                    if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.link_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "link-interface-id" or name == "link-metric" or name == "link-neighbor-interface-id" or name == "link-neighbor-router-id" or name == "link-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "link-interface-id"):
                                                        self.link_interface_id = value
                                                        self.link_interface_id.value_namespace = name_space
                                                        self.link_interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "link-metric"):
                                                        self.link_metric = value
                                                        self.link_metric.value_namespace = name_space
                                                        self.link_metric.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "link-neighbor-interface-id"):
                                                        self.link_neighbor_interface_id = value
                                                        self.link_neighbor_interface_id.value_namespace = name_space
                                                        self.link_neighbor_interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "link-neighbor-router-id"):
                                                        self.link_neighbor_router_id = value
                                                        self.link_neighbor_router_id.value_namespace = name_space
                                                        self.link_neighbor_router_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "link-type"):
                                                        self.link_type = value
                                                        self.link_type.value_namespace = name_space
                                                        self.link_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.link:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.router_la_bits.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()) or
                                                    (self.rpf_path is not None and self.rpf_path.has_data()))

                                            def has_operation(self):
                                                for c in self.link:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.router_la_bits.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()) or
                                                    (self.rpf_path is not None and self.rpf_path.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "router-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.router_la_bits.is_set or self.router_la_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.router_la_bits.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "link"):
                                                    for c in self.link:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.Link()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.link.append(c)
                                                    return c

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                if (child_yang_name == "rpf-path"):
                                                    if (self.rpf_path is None):
                                                        self.rpf_path = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType.RpfPath()
                                                        self.rpf_path.parent = self
                                                        self._children_name_map["rpf_path"] = "rpf-path"
                                                    return self.rpf_path

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "link" or name == "lsa-detail" or name == "lsa-header" or name == "rpf-path" or name == "router-la-bits"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "router-la-bits"):
                                                    self.router_la_bits = value
                                                    self.router_la_bits.value_namespace = name_space
                                                    self.router_la_bits.value_namespace_prefix = name_space_prefix


                                        class NetworkLsaType(Entity):
                                            """
                                            Network LSA
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader>`
                                            
                                            .. attribute:: neighbor_router
                                            
                                            	Neighbor router list
                                            	**type**\:  list of str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__init__()

                                                self.yang_name = "network-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.neighbor_router = YLeafList(YType.str, "neighbor-router")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("neighbor_router") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "network-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "network-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for leaf in self.neighbor_router.getYLeafs():
                                                    if (leaf.yfilter != YFilter.not_set):
                                                        return True
                                                return (
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                for leaf in self.neighbor_router.getYLeafs():
                                                    if (leaf.is_set):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.neighbor_router.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "network-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                leaf_name_data.extend(self.neighbor_router.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "neighbor-router"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "neighbor-router"):
                                                    self.neighbor_router.append(value)


                                        class InterAreaPrefixLsaType(Entity):
                                            """
                                            Inter Area Prefix LSA
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA Information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader>`
                                            
                                            .. attribute:: prefix
                                            
                                            	LSA address prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: prefix_length
                                            
                                            	Prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: priority
                                            
                                            	Prefix priority
                                            	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__init__()

                                                self.yang_name = "inter-area-prefix-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                self.priority = YLeaf(YType.enumeration, "priority")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("prefix",
                                                                "prefix_length",
                                                                "priority") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA Information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "inter-area-prefix-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.prefix.is_set or
                                                    self.prefix_length.is_set or
                                                    self.priority.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.prefix_length.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inter-area-prefix-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "prefix-length" or name == "priority"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix-length"):
                                                    self.prefix_length = value
                                                    self.prefix_length.value_namespace = name_space
                                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix


                                        class InterAreaRouterLsaType(Entity):
                                            """
                                            Inter Area Router LSA
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader>`
                                            
                                            .. attribute:: lsa_router_id
                                            
                                            	LSA router ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__init__()

                                                self.yang_name = "inter-area-router-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.lsa_router_id = YLeaf(YType.uint32, "lsa-router-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("lsa_router_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "inter-area-router-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "inter-area-router-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.lsa_router_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.lsa_router_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "inter-area-router-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.lsa_router_id.is_set or self.lsa_router_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_router_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "lsa-router-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "lsa-router-id"):
                                                    self.lsa_router_id = value
                                                    self.lsa_router_id.value_namespace = name_space
                                                    self.lsa_router_id.value_namespace_prefix = name_space_prefix


                                        class ExternalLsaType(Entity):
                                            """
                                            External LSA
                                            
                                            .. attribute:: external_tag
                                            
                                            	Route Tag
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forwarding_address
                                            
                                            	Forwarding Address
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: is_forwarding_address_set
                                            
                                            	If true, forwarding address is set 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA Information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader>`
                                            
                                            .. attribute:: metric_type
                                            
                                            	Metric type 
                                            	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                            
                                            .. attribute:: prefix
                                            
                                            	IPV6 address prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: prefix_length
                                            
                                            	Prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: priority
                                            
                                            	Prefix priority
                                            	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                            
                                            .. attribute:: tos_cost
                                            
                                            	Type of service cost metric 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__init__()

                                                self.yang_name = "external-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.external_tag = YLeaf(YType.uint32, "external-tag")

                                                self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                                self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                                self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                self.priority = YLeaf(YType.enumeration, "priority")

                                                self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("external_tag",
                                                                "forwarding_address",
                                                                "is_forwarding_address_set",
                                                                "metric_type",
                                                                "prefix",
                                                                "prefix_length",
                                                                "priority",
                                                                "tos_cost") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "external-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA Information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "external-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.external_tag.is_set or
                                                    self.forwarding_address.is_set or
                                                    self.is_forwarding_address_set.is_set or
                                                    self.metric_type.is_set or
                                                    self.prefix.is_set or
                                                    self.prefix_length.is_set or
                                                    self.priority.is_set or
                                                    self.tos_cost.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.external_tag.yfilter != YFilter.not_set or
                                                    self.forwarding_address.yfilter != YFilter.not_set or
                                                    self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                    self.metric_type.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.prefix_length.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set or
                                                    self.tos_cost.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "external-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.external_tag.get_name_leafdata())
                                                if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                                if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                                if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.metric_type.get_name_leafdata())
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())
                                                if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "external-tag"):
                                                    self.external_tag = value
                                                    self.external_tag.value_namespace = name_space
                                                    self.external_tag.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forwarding-address"):
                                                    self.forwarding_address = value
                                                    self.forwarding_address.value_namespace = name_space
                                                    self.forwarding_address.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-forwarding-address-set"):
                                                    self.is_forwarding_address_set = value
                                                    self.is_forwarding_address_set.value_namespace = name_space
                                                    self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                                if(value_path == "metric-type"):
                                                    self.metric_type = value
                                                    self.metric_type.value_namespace = name_space
                                                    self.metric_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix-length"):
                                                    self.prefix_length = value
                                                    self.prefix_length.value_namespace = name_space
                                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tos-cost"):
                                                    self.tos_cost = value
                                                    self.tos_cost.value_namespace = name_space
                                                    self.tos_cost.value_namespace_prefix = name_space_prefix


                                        class NssalsaType(Entity):
                                            """
                                            NSSA External LSA
                                            
                                            .. attribute:: external_tag
                                            
                                            	Route Tag
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forwarding_address
                                            
                                            	Forwarding Address
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: is_forwarding_address_set
                                            
                                            	If true, forwarding address is set 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA Information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader>`
                                            
                                            .. attribute:: metric_type
                                            
                                            	Metric type 
                                            	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                                            
                                            .. attribute:: prefix
                                            
                                            	IPV6 address prefix 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: prefix_length
                                            
                                            	Prefix length 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: priority
                                            
                                            	Prefix priority
                                            	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                            
                                            .. attribute:: tos_cost
                                            
                                            	Type of service cost metric 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__init__()

                                                self.yang_name = "nssalsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.external_tag = YLeaf(YType.uint32, "external-tag")

                                                self.forwarding_address = YLeaf(YType.str, "forwarding-address")

                                                self.is_forwarding_address_set = YLeaf(YType.boolean, "is-forwarding-address-set")

                                                self.metric_type = YLeaf(YType.enumeration, "metric-type")

                                                self.prefix = YLeaf(YType.str, "prefix")

                                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                                self.priority = YLeaf(YType.enumeration, "priority")

                                                self.tos_cost = YLeaf(YType.uint32, "tos-cost")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("external_tag",
                                                                "forwarding_address",
                                                                "is_forwarding_address_set",
                                                                "metric_type",
                                                                "prefix",
                                                                "prefix_length",
                                                                "priority",
                                                                "tos_cost") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "nssalsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA Information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "nssalsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.external_tag.is_set or
                                                    self.forwarding_address.is_set or
                                                    self.is_forwarding_address_set.is_set or
                                                    self.metric_type.is_set or
                                                    self.prefix.is_set or
                                                    self.prefix_length.is_set or
                                                    self.priority.is_set or
                                                    self.tos_cost.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.external_tag.yfilter != YFilter.not_set or
                                                    self.forwarding_address.yfilter != YFilter.not_set or
                                                    self.is_forwarding_address_set.yfilter != YFilter.not_set or
                                                    self.metric_type.yfilter != YFilter.not_set or
                                                    self.prefix.yfilter != YFilter.not_set or
                                                    self.prefix_length.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set or
                                                    self.tos_cost.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "nssalsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.external_tag.is_set or self.external_tag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.external_tag.get_name_leafdata())
                                                if (self.forwarding_address.is_set or self.forwarding_address.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_address.get_name_leafdata())
                                                if (self.is_forwarding_address_set.is_set or self.is_forwarding_address_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_forwarding_address_set.get_name_leafdata())
                                                if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.metric_type.get_name_leafdata())
                                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())
                                                if (self.tos_cost.is_set or self.tos_cost.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tos_cost.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "external-tag" or name == "forwarding-address" or name == "is-forwarding-address-set" or name == "metric-type" or name == "prefix" or name == "prefix-length" or name == "priority" or name == "tos-cost"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "external-tag"):
                                                    self.external_tag = value
                                                    self.external_tag.value_namespace = name_space
                                                    self.external_tag.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forwarding-address"):
                                                    self.forwarding_address = value
                                                    self.forwarding_address.value_namespace = name_space
                                                    self.forwarding_address.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-forwarding-address-set"):
                                                    self.is_forwarding_address_set = value
                                                    self.is_forwarding_address_set.value_namespace = name_space
                                                    self.is_forwarding_address_set.value_namespace_prefix = name_space_prefix
                                                if(value_path == "metric-type"):
                                                    self.metric_type = value
                                                    self.metric_type.value_namespace = name_space
                                                    self.metric_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix"):
                                                    self.prefix = value
                                                    self.prefix.value_namespace = name_space
                                                    self.prefix.value_namespace_prefix = name_space_prefix
                                                if(value_path == "prefix-length"):
                                                    self.prefix_length = value
                                                    self.prefix_length.value_namespace = name_space
                                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tos-cost"):
                                                    self.tos_cost = value
                                                    self.tos_cost.value_namespace = name_space
                                                    self.tos_cost.value_namespace_prefix = name_space_prefix


                                        class LinkLsaType(Entity):
                                            """
                                            Link LSA
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface handle
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader>`
                                            
                                            .. attribute:: lsa_link_local
                                            
                                            	LSA link local 
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: prefix
                                            
                                            	OSPFv3 prefix 
                                            	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix>`
                                            
                                            .. attribute:: router_priority
                                            
                                            	Router priority 
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Sham link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__init__()

                                                self.yang_name = "link-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.lsa_link_local = YLeaf(YType.str, "lsa-link-local")

                                                self.router_priority = YLeaf(YType.uint8, "router-priority")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                                self.prefix = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "lsa_link_local",
                                                                "router_priority",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "link-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "link-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix


                                            class Prefix(Entity):
                                                """
                                                OSPFv3 prefix 
                                                
                                                .. attribute:: ospfv3_prefix_length
                                                
                                                	OSPFv3 prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ospfv3_prefix_metric
                                                
                                                	OSPFv3 prefix metric 
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: ospfv3_prefix_options
                                                
                                                	OSPFv3 prefix options 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: prefix
                                                
                                                	OSPFv3 prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: priority
                                                
                                                	Prefix priority
                                                	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__init__()

                                                    self.yang_name = "prefix"
                                                    self.yang_parent_name = "link-lsa-type"

                                                    self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                    self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                    self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.priority = YLeaf(YType.enumeration, "priority")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("ospfv3_prefix_length",
                                                                    "ospfv3_prefix_metric",
                                                                    "ospfv3_prefix_options",
                                                                    "prefix",
                                                                    "priority") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.ospfv3_prefix_length.is_set or
                                                        self.ospfv3_prefix_metric.is_set or
                                                        self.ospfv3_prefix_options.is_set or
                                                        self.prefix.is_set or
                                                        self.priority.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.priority.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prefix" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                    if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                    if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.priority.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "ospfv3-prefix-length"):
                                                        self.ospfv3_prefix_length = value
                                                        self.ospfv3_prefix_length.value_namespace = name_space
                                                        self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ospfv3-prefix-metric"):
                                                        self.ospfv3_prefix_metric = value
                                                        self.ospfv3_prefix_metric.value_namespace = name_space
                                                        self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ospfv3-prefix-options"):
                                                        self.ospfv3_prefix_options = value
                                                        self.ospfv3_prefix_options.value_namespace = name_space
                                                        self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "priority"):
                                                        self.priority = value
                                                        self.priority.value_namespace = name_space
                                                        self.priority.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prefix:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.lsa_link_local.is_set or
                                                    self.router_priority.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                for c in self.prefix:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.lsa_link_local.yfilter != YFilter.not_set or
                                                    self.router_priority.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "link-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.lsa_link_local.is_set or self.lsa_link_local.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsa_link_local.get_name_leafdata())
                                                if (self.router_priority.is_set or self.router_priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.router_priority.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                if (child_yang_name == "prefix"):
                                                    for c in self.prefix:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType.Prefix()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prefix.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "lsa-link-local" or name == "router-priority" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsa-link-local"):
                                                    self.lsa_link_local = value
                                                    self.lsa_link_local.value_namespace = name_space
                                                    self.lsa_link_local.value_namespace_prefix = name_space_prefix
                                                if(value_path == "router-priority"):
                                                    self.router_priority = value
                                                    self.router_priority.value_namespace = name_space
                                                    self.router_priority.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                        class IntraAreaPrefixLsaType(Entity):
                                            """
                                            Intra Area Prefix LSA
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader>`
                                            
                                            .. attribute:: prefix
                                            
                                            	OSPFv3 prefix 
                                            	**type**\: list of    :py:class:`Prefix <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix>`
                                            
                                            .. attribute:: reference_advertised_router
                                            
                                            	Reference advertised router 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: reference_lsa_id
                                            
                                            	Reference LSA ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: reference_type
                                            
                                            	Reference type 
                                            	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__init__()

                                                self.yang_name = "intra-area-prefix-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.reference_advertised_router = YLeaf(YType.str, "reference-advertised-router")

                                                self.reference_lsa_id = YLeaf(YType.uint32, "reference-lsa-id")

                                                self.reference_type = YLeaf(YType.enumeration, "reference-type")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                                self.prefix = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("reference_advertised_router",
                                                                "reference_lsa_id",
                                                                "reference_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix


                                            class Prefix(Entity):
                                                """
                                                OSPFv3 prefix 
                                                
                                                .. attribute:: ospfv3_prefix_length
                                                
                                                	OSPFv3 prefix length 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ospfv3_prefix_metric
                                                
                                                	OSPFv3 prefix metric 
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: ospfv3_prefix_options
                                                
                                                	OSPFv3 prefix options 
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: prefix
                                                
                                                	OSPFv3 prefix 
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: priority
                                                
                                                	Prefix priority
                                                	**type**\:   :py:class:`PrefixPriority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.PrefixPriority>`
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__init__()

                                                    self.yang_name = "prefix"
                                                    self.yang_parent_name = "intra-area-prefix-lsa-type"

                                                    self.ospfv3_prefix_length = YLeaf(YType.uint8, "ospfv3-prefix-length")

                                                    self.ospfv3_prefix_metric = YLeaf(YType.uint16, "ospfv3-prefix-metric")

                                                    self.ospfv3_prefix_options = YLeaf(YType.uint8, "ospfv3-prefix-options")

                                                    self.prefix = YLeaf(YType.str, "prefix")

                                                    self.priority = YLeaf(YType.enumeration, "priority")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("ospfv3_prefix_length",
                                                                    "ospfv3_prefix_metric",
                                                                    "ospfv3_prefix_options",
                                                                    "prefix",
                                                                    "priority") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.ospfv3_prefix_length.is_set or
                                                        self.ospfv3_prefix_metric.is_set or
                                                        self.ospfv3_prefix_options.is_set or
                                                        self.prefix.is_set or
                                                        self.priority.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_length.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_metric.yfilter != YFilter.not_set or
                                                        self.ospfv3_prefix_options.yfilter != YFilter.not_set or
                                                        self.prefix.yfilter != YFilter.not_set or
                                                        self.priority.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prefix" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.ospfv3_prefix_length.is_set or self.ospfv3_prefix_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_length.get_name_leafdata())
                                                    if (self.ospfv3_prefix_metric.is_set or self.ospfv3_prefix_metric.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_metric.get_name_leafdata())
                                                    if (self.ospfv3_prefix_options.is_set or self.ospfv3_prefix_options.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ospfv3_prefix_options.get_name_leafdata())
                                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                                    if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.priority.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "ospfv3-prefix-length" or name == "ospfv3-prefix-metric" or name == "ospfv3-prefix-options" or name == "prefix" or name == "priority"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "ospfv3-prefix-length"):
                                                        self.ospfv3_prefix_length = value
                                                        self.ospfv3_prefix_length.value_namespace = name_space
                                                        self.ospfv3_prefix_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ospfv3-prefix-metric"):
                                                        self.ospfv3_prefix_metric = value
                                                        self.ospfv3_prefix_metric.value_namespace = name_space
                                                        self.ospfv3_prefix_metric.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ospfv3-prefix-options"):
                                                        self.ospfv3_prefix_options = value
                                                        self.ospfv3_prefix_options.value_namespace = name_space
                                                        self.ospfv3_prefix_options.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix"):
                                                        self.prefix = value
                                                        self.prefix.value_namespace = name_space
                                                        self.prefix.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "priority"):
                                                        self.priority = value
                                                        self.priority.value_namespace = name_space
                                                        self.priority.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prefix:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.reference_advertised_router.is_set or
                                                    self.reference_lsa_id.is_set or
                                                    self.reference_type.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                for c in self.prefix:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.reference_advertised_router.yfilter != YFilter.not_set or
                                                    self.reference_lsa_id.yfilter != YFilter.not_set or
                                                    self.reference_type.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "intra-area-prefix-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.reference_advertised_router.is_set or self.reference_advertised_router.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.reference_advertised_router.get_name_leafdata())
                                                if (self.reference_lsa_id.is_set or self.reference_lsa_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.reference_lsa_id.get_name_leafdata())
                                                if (self.reference_type.is_set or self.reference_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.reference_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                if (child_yang_name == "prefix"):
                                                    for c in self.prefix:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType.Prefix()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prefix.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "prefix" or name == "reference-advertised-router" or name == "reference-lsa-id" or name == "reference-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "reference-advertised-router"):
                                                    self.reference_advertised_router = value
                                                    self.reference_advertised_router.value_namespace = name_space
                                                    self.reference_advertised_router.value_namespace_prefix = name_space_prefix
                                                if(value_path == "reference-lsa-id"):
                                                    self.reference_lsa_id = value
                                                    self.reference_lsa_id.value_namespace = name_space
                                                    self.reference_lsa_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "reference-type"):
                                                    self.reference_type = value
                                                    self.reference_type.value_namespace = name_space
                                                    self.reference_type.value_namespace_prefix = name_space_prefix


                                        class GraceLsa(Entity):
                                            """
                                            Grace LSA
                                            
                                            .. attribute:: grace_period
                                            
                                            	The grace periord where helper routers should wait before advertising it fully adjacent(s) 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: grace_reason
                                            
                                            	Reason for router restart
                                            	**type**\:   :py:class:`Ospfv3GracefulRestartReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3GracefulRestartReason>`
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader>`
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__init__()

                                                self.yang_name = "grace-lsa"
                                                self.yang_parent_name = "lsa-info"

                                                self.grace_period = YLeaf(YType.uint32, "grace-period")

                                                self.grace_reason = YLeaf(YType.enumeration, "grace-reason")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("grace_period",
                                                                "grace_reason") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "grace-lsa"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "grace-lsa"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.grace_period.is_set or
                                                    self.grace_reason.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.grace_period.yfilter != YFilter.not_set or
                                                    self.grace_reason.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "grace-lsa" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.grace_period.is_set or self.grace_period.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grace_period.get_name_leafdata())
                                                if (self.grace_reason.is_set or self.grace_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grace_reason.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "grace-period" or name == "grace-reason"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "grace-period"):
                                                    self.grace_period = value
                                                    self.grace_period.value_namespace = name_space
                                                    self.grace_period.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grace-reason"):
                                                    self.grace_reason = value
                                                    self.grace_reason.value_namespace = name_space
                                                    self.grace_reason.value_namespace_prefix = name_space_prefix


                                        class UnknownLinkLsaType(Entity):
                                            """
                                            Unknown Link Scope LSA
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface name 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader>`
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Shamlink ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__init__()

                                                self.yang_name = "unknown-link-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "unknown-link-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "unknown-link-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "unknown-link-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                        class UnknownAreaLsaType(Entity):
                                            """
                                            Unknown\-Area scope LSA
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface name 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader>`
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Shamlink ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__init__()

                                                self.yang_name = "unknown-area-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "unknown-area-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "unknown-area-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "unknown-area-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                        class UnknownAslsaType(Entity):
                                            """
                                            Unknown\-AS scope LSA
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface name 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader>`
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Shamlink ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__init__()

                                                self.yang_name = "unknown-aslsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "unknown-aslsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "unknown-aslsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "unknown-aslsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix


                                        class UnknownLsaType(Entity):
                                            """
                                            Unknown LSA
                                            
                                            .. attribute:: interface_name
                                            
                                            	LSA interface name 
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: is_sham_link
                                            
                                            	If true, it is a sham link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_virtual_link
                                            
                                            	If true, it is a virtual link 
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsa_detail
                                            
                                            	Detailed LSA information
                                            	**type**\:   :py:class:`LsaDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail>`
                                            
                                            .. attribute:: lsa_header
                                            
                                            	Header information 
                                            	**type**\:   :py:class:`LsaHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader>`
                                            
                                            .. attribute:: sham_link_id
                                            
                                            	Shamlink ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: virtual_link_id
                                            
                                            	Virtual link ID 
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'ipv6-ospfv3-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__init__()

                                                self.yang_name = "unknown-lsa-type"
                                                self.yang_parent_name = "lsa-info"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.is_sham_link = YLeaf(YType.boolean, "is-sham-link")

                                                self.is_virtual_link = YLeaf(YType.boolean, "is-virtual-link")

                                                self.sham_link_id = YLeaf(YType.uint32, "sham-link-id")

                                                self.virtual_link_id = YLeaf(YType.uint32, "virtual-link-id")

                                                self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                self.lsa_detail.parent = self
                                                self._children_name_map["lsa_detail"] = "lsa-detail"
                                                self._children_yang_names.add("lsa-detail")

                                                self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                self.lsa_header.parent = self
                                                self._children_name_map["lsa_header"] = "lsa-header"
                                                self._children_yang_names.add("lsa-header")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "is_sham_link",
                                                                "is_virtual_link",
                                                                "sham_link_id",
                                                                "virtual_link_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType, self).__setattr__(name, value)


                                            class LsaHeader(Entity):
                                                """
                                                Header information 
                                                
                                                .. attribute:: advertising_router
                                                
                                                	Router ID of Advertising Router
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: checksum
                                                
                                                	Checksum value
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: is_do_not_age_lsa
                                                
                                                	If true, Do Not Age this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_graceful_restart_active
                                                
                                                	If true, if grace restart is active 
                                                	**type**\:  bool
                                                
                                                .. attribute:: ls_id
                                                
                                                	LS ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: lsa_age
                                                
                                                	LSA's Age (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_area_id
                                                
                                                	Area ID in decimal or dotted\-decimal format
                                                	**type**\:  str
                                                
                                                	**length:** 0..16
                                                
                                                .. attribute:: lsa_type
                                                
                                                	LSA type
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: sequence_number
                                                
                                                	Current Sequence number
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__init__()

                                                    self.yang_name = "lsa-header"
                                                    self.yang_parent_name = "unknown-lsa-type"

                                                    self.advertising_router = YLeaf(YType.str, "advertising-router")

                                                    self.checksum = YLeaf(YType.uint16, "checksum")

                                                    self.is_do_not_age_lsa = YLeaf(YType.boolean, "is-do-not-age-lsa")

                                                    self.is_graceful_restart_active = YLeaf(YType.boolean, "is-graceful-restart-active")

                                                    self.ls_id = YLeaf(YType.uint32, "ls-id")

                                                    self.lsa_age = YLeaf(YType.uint16, "lsa-age")

                                                    self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                                    self.lsa_type = YLeaf(YType.uint16, "lsa-type")

                                                    self.sequence_number = YLeaf(YType.uint32, "sequence-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("advertising_router",
                                                                    "checksum",
                                                                    "is_do_not_age_lsa",
                                                                    "is_graceful_restart_active",
                                                                    "ls_id",
                                                                    "lsa_age",
                                                                    "lsa_area_id",
                                                                    "lsa_type",
                                                                    "sequence_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.advertising_router.is_set or
                                                        self.checksum.is_set or
                                                        self.is_do_not_age_lsa.is_set or
                                                        self.is_graceful_restart_active.is_set or
                                                        self.ls_id.is_set or
                                                        self.lsa_age.is_set or
                                                        self.lsa_area_id.is_set or
                                                        self.lsa_type.is_set or
                                                        self.sequence_number.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.advertising_router.yfilter != YFilter.not_set or
                                                        self.checksum.yfilter != YFilter.not_set or
                                                        self.is_do_not_age_lsa.yfilter != YFilter.not_set or
                                                        self.is_graceful_restart_active.yfilter != YFilter.not_set or
                                                        self.ls_id.yfilter != YFilter.not_set or
                                                        self.lsa_age.yfilter != YFilter.not_set or
                                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                                        self.lsa_type.yfilter != YFilter.not_set or
                                                        self.sequence_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-header" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                                    if (self.checksum.is_set or self.checksum.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.checksum.get_name_leafdata())
                                                    if (self.is_do_not_age_lsa.is_set or self.is_do_not_age_lsa.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_do_not_age_lsa.get_name_leafdata())
                                                    if (self.is_graceful_restart_active.is_set or self.is_graceful_restart_active.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_graceful_restart_active.get_name_leafdata())
                                                    if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ls_id.get_name_leafdata())
                                                    if (self.lsa_age.is_set or self.lsa_age.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_age.get_name_leafdata())
                                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())
                                                    if (self.sequence_number.is_set or self.sequence_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.sequence_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "advertising-router" or name == "checksum" or name == "is-do-not-age-lsa" or name == "is-graceful-restart-active" or name == "ls-id" or name == "lsa-age" or name == "lsa-area-id" or name == "lsa-type" or name == "sequence-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "advertising-router"):
                                                        self.advertising_router = value
                                                        self.advertising_router.value_namespace = name_space
                                                        self.advertising_router.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "checksum"):
                                                        self.checksum = value
                                                        self.checksum.value_namespace = name_space
                                                        self.checksum.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-do-not-age-lsa"):
                                                        self.is_do_not_age_lsa = value
                                                        self.is_do_not_age_lsa.value_namespace = name_space
                                                        self.is_do_not_age_lsa.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-graceful-restart-active"):
                                                        self.is_graceful_restart_active = value
                                                        self.is_graceful_restart_active.value_namespace = name_space
                                                        self.is_graceful_restart_active.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ls-id"):
                                                        self.ls_id = value
                                                        self.ls_id.value_namespace = name_space
                                                        self.ls_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-age"):
                                                        self.lsa_age = value
                                                        self.lsa_age.value_namespace = name_space
                                                        self.lsa_age.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-area-id"):
                                                        self.lsa_area_id = value
                                                        self.lsa_area_id.value_namespace = name_space
                                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-type"):
                                                        self.lsa_type = value
                                                        self.lsa_type.value_namespace = name_space
                                                        self.lsa_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "sequence-number"):
                                                        self.sequence_number = value
                                                        self.sequence_number.value_namespace = name_space
                                                        self.sequence_number.value_namespace_prefix = name_space_prefix


                                            class LsaDetail(Entity):
                                                """
                                                Detailed LSA information
                                                
                                                .. attribute:: free_time
                                                
                                                	The amount of time since the last check was made to free this LSA (s)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: is_acknowledged
                                                
                                                	If true, the reason not to delete this LSA is because it's Acknowledgement list is not empty 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_advertising_router_reachable
                                                
                                                	If true, Advertising Router is reachable
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_deleted
                                                
                                                	If true, flag is set to delete this LSA 
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_flood_pending
                                                
                                                	If true, the reason not to delete this LSA is because waiting for flooding or retransmission
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_maximum_aged
                                                
                                                	If true, the reason not to delete this LSA is because it is in Maxage Queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_neighbor_exchange
                                                
                                                	If true, the reason  not to delete this LSA is because neighbor is in exchange state
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_no_delete
                                                
                                                	If true, the reason not to delete this LSA is because delete flag not set on this LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_nsr_ack_pending
                                                
                                                	If true, the reason not to delete this LSA is because NSR ACK from standby is pending
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_partial_spf
                                                
                                                	If true, the reason not to delete this LSA is because it is in partial SPF queue
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_bit
                                                
                                                	If true, Routing Bit set on the LSA
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_routing_table
                                                
                                                	If true, the reason  not to delete this LSA is because it has a contributing entry in the routing table 
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_flood_required_post_fail_over
                                                
                                                	LSA flood required after FO
                                                	**type**\:  bool
                                                
                                                .. attribute:: lsa_length
                                                
                                                	Length of the LSA
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: lsa_sync_state
                                                
                                                	State of LSA sync with active
                                                	**type**\:   :py:class:`OspfLsaSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.OspfLsaSyncState>`
                                                
                                                .. attribute:: minute_table_index
                                                
                                                	Minute table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: nsr_flood_required
                                                
                                                	If true, the reason not to delete this LSA is because it is pending flooding on switchover
                                                	**type**\:  bool
                                                
                                                .. attribute:: rate_limit
                                                
                                                	If true, the reason not to delete this LSA is because waiting for next wait\-interval to expire
                                                	**type**\:  bool
                                                
                                                .. attribute:: second_table_index
                                                
                                                	Second table index
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'ipv6-ospfv3-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__init__()

                                                    self.yang_name = "lsa-detail"
                                                    self.yang_parent_name = "unknown-lsa-type"

                                                    self.free_time = YLeaf(YType.uint32, "free-time")

                                                    self.is_acknowledged = YLeaf(YType.boolean, "is-acknowledged")

                                                    self.is_advertising_router_reachable = YLeaf(YType.boolean, "is-advertising-router-reachable")

                                                    self.is_deleted = YLeaf(YType.boolean, "is-deleted")

                                                    self.is_flood_pending = YLeaf(YType.boolean, "is-flood-pending")

                                                    self.is_maximum_aged = YLeaf(YType.boolean, "is-maximum-aged")

                                                    self.is_neighbor_exchange = YLeaf(YType.boolean, "is-neighbor-exchange")

                                                    self.is_no_delete = YLeaf(YType.boolean, "is-no-delete")

                                                    self.is_nsr_ack_pending = YLeaf(YType.boolean, "is-nsr-ack-pending")

                                                    self.is_partial_spf = YLeaf(YType.boolean, "is-partial-spf")

                                                    self.is_routing_bit = YLeaf(YType.boolean, "is-routing-bit")

                                                    self.is_routing_table = YLeaf(YType.boolean, "is-routing-table")

                                                    self.lsa_flood_required_post_fail_over = YLeaf(YType.boolean, "lsa-flood-required-post-fail-over")

                                                    self.lsa_length = YLeaf(YType.uint16, "lsa-length")

                                                    self.lsa_sync_state = YLeaf(YType.enumeration, "lsa-sync-state")

                                                    self.minute_table_index = YLeaf(YType.uint8, "minute-table-index")

                                                    self.nsr_flood_required = YLeaf(YType.boolean, "nsr-flood-required")

                                                    self.rate_limit = YLeaf(YType.boolean, "rate-limit")

                                                    self.second_table_index = YLeaf(YType.uint8, "second-table-index")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("free_time",
                                                                    "is_acknowledged",
                                                                    "is_advertising_router_reachable",
                                                                    "is_deleted",
                                                                    "is_flood_pending",
                                                                    "is_maximum_aged",
                                                                    "is_neighbor_exchange",
                                                                    "is_no_delete",
                                                                    "is_nsr_ack_pending",
                                                                    "is_partial_spf",
                                                                    "is_routing_bit",
                                                                    "is_routing_table",
                                                                    "lsa_flood_required_post_fail_over",
                                                                    "lsa_length",
                                                                    "lsa_sync_state",
                                                                    "minute_table_index",
                                                                    "nsr_flood_required",
                                                                    "rate_limit",
                                                                    "second_table_index") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.free_time.is_set or
                                                        self.is_acknowledged.is_set or
                                                        self.is_advertising_router_reachable.is_set or
                                                        self.is_deleted.is_set or
                                                        self.is_flood_pending.is_set or
                                                        self.is_maximum_aged.is_set or
                                                        self.is_neighbor_exchange.is_set or
                                                        self.is_no_delete.is_set or
                                                        self.is_nsr_ack_pending.is_set or
                                                        self.is_partial_spf.is_set or
                                                        self.is_routing_bit.is_set or
                                                        self.is_routing_table.is_set or
                                                        self.lsa_flood_required_post_fail_over.is_set or
                                                        self.lsa_length.is_set or
                                                        self.lsa_sync_state.is_set or
                                                        self.minute_table_index.is_set or
                                                        self.nsr_flood_required.is_set or
                                                        self.rate_limit.is_set or
                                                        self.second_table_index.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.free_time.yfilter != YFilter.not_set or
                                                        self.is_acknowledged.yfilter != YFilter.not_set or
                                                        self.is_advertising_router_reachable.yfilter != YFilter.not_set or
                                                        self.is_deleted.yfilter != YFilter.not_set or
                                                        self.is_flood_pending.yfilter != YFilter.not_set or
                                                        self.is_maximum_aged.yfilter != YFilter.not_set or
                                                        self.is_neighbor_exchange.yfilter != YFilter.not_set or
                                                        self.is_no_delete.yfilter != YFilter.not_set or
                                                        self.is_nsr_ack_pending.yfilter != YFilter.not_set or
                                                        self.is_partial_spf.yfilter != YFilter.not_set or
                                                        self.is_routing_bit.yfilter != YFilter.not_set or
                                                        self.is_routing_table.yfilter != YFilter.not_set or
                                                        self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set or
                                                        self.lsa_length.yfilter != YFilter.not_set or
                                                        self.lsa_sync_state.yfilter != YFilter.not_set or
                                                        self.minute_table_index.yfilter != YFilter.not_set or
                                                        self.nsr_flood_required.yfilter != YFilter.not_set or
                                                        self.rate_limit.yfilter != YFilter.not_set or
                                                        self.second_table_index.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsa-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.free_time.is_set or self.free_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.free_time.get_name_leafdata())
                                                    if (self.is_acknowledged.is_set or self.is_acknowledged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_acknowledged.get_name_leafdata())
                                                    if (self.is_advertising_router_reachable.is_set or self.is_advertising_router_reachable.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_advertising_router_reachable.get_name_leafdata())
                                                    if (self.is_deleted.is_set or self.is_deleted.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_deleted.get_name_leafdata())
                                                    if (self.is_flood_pending.is_set or self.is_flood_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_flood_pending.get_name_leafdata())
                                                    if (self.is_maximum_aged.is_set or self.is_maximum_aged.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_maximum_aged.get_name_leafdata())
                                                    if (self.is_neighbor_exchange.is_set or self.is_neighbor_exchange.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_neighbor_exchange.get_name_leafdata())
                                                    if (self.is_no_delete.is_set or self.is_no_delete.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_no_delete.get_name_leafdata())
                                                    if (self.is_nsr_ack_pending.is_set or self.is_nsr_ack_pending.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_nsr_ack_pending.get_name_leafdata())
                                                    if (self.is_partial_spf.is_set or self.is_partial_spf.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_partial_spf.get_name_leafdata())
                                                    if (self.is_routing_bit.is_set or self.is_routing_bit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_bit.get_name_leafdata())
                                                    if (self.is_routing_table.is_set or self.is_routing_table.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_routing_table.get_name_leafdata())
                                                    if (self.lsa_flood_required_post_fail_over.is_set or self.lsa_flood_required_post_fail_over.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_flood_required_post_fail_over.get_name_leafdata())
                                                    if (self.lsa_length.is_set or self.lsa_length.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_length.get_name_leafdata())
                                                    if (self.lsa_sync_state.is_set or self.lsa_sync_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsa_sync_state.get_name_leafdata())
                                                    if (self.minute_table_index.is_set or self.minute_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.minute_table_index.get_name_leafdata())
                                                    if (self.nsr_flood_required.is_set or self.nsr_flood_required.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.nsr_flood_required.get_name_leafdata())
                                                    if (self.rate_limit.is_set or self.rate_limit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.rate_limit.get_name_leafdata())
                                                    if (self.second_table_index.is_set or self.second_table_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.second_table_index.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "free-time" or name == "is-acknowledged" or name == "is-advertising-router-reachable" or name == "is-deleted" or name == "is-flood-pending" or name == "is-maximum-aged" or name == "is-neighbor-exchange" or name == "is-no-delete" or name == "is-nsr-ack-pending" or name == "is-partial-spf" or name == "is-routing-bit" or name == "is-routing-table" or name == "lsa-flood-required-post-fail-over" or name == "lsa-length" or name == "lsa-sync-state" or name == "minute-table-index" or name == "nsr-flood-required" or name == "rate-limit" or name == "second-table-index"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "free-time"):
                                                        self.free_time = value
                                                        self.free_time.value_namespace = name_space
                                                        self.free_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-acknowledged"):
                                                        self.is_acknowledged = value
                                                        self.is_acknowledged.value_namespace = name_space
                                                        self.is_acknowledged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-advertising-router-reachable"):
                                                        self.is_advertising_router_reachable = value
                                                        self.is_advertising_router_reachable.value_namespace = name_space
                                                        self.is_advertising_router_reachable.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-deleted"):
                                                        self.is_deleted = value
                                                        self.is_deleted.value_namespace = name_space
                                                        self.is_deleted.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-flood-pending"):
                                                        self.is_flood_pending = value
                                                        self.is_flood_pending.value_namespace = name_space
                                                        self.is_flood_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-maximum-aged"):
                                                        self.is_maximum_aged = value
                                                        self.is_maximum_aged.value_namespace = name_space
                                                        self.is_maximum_aged.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-neighbor-exchange"):
                                                        self.is_neighbor_exchange = value
                                                        self.is_neighbor_exchange.value_namespace = name_space
                                                        self.is_neighbor_exchange.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-no-delete"):
                                                        self.is_no_delete = value
                                                        self.is_no_delete.value_namespace = name_space
                                                        self.is_no_delete.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-nsr-ack-pending"):
                                                        self.is_nsr_ack_pending = value
                                                        self.is_nsr_ack_pending.value_namespace = name_space
                                                        self.is_nsr_ack_pending.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-partial-spf"):
                                                        self.is_partial_spf = value
                                                        self.is_partial_spf.value_namespace = name_space
                                                        self.is_partial_spf.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-bit"):
                                                        self.is_routing_bit = value
                                                        self.is_routing_bit.value_namespace = name_space
                                                        self.is_routing_bit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-routing-table"):
                                                        self.is_routing_table = value
                                                        self.is_routing_table.value_namespace = name_space
                                                        self.is_routing_table.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-flood-required-post-fail-over"):
                                                        self.lsa_flood_required_post_fail_over = value
                                                        self.lsa_flood_required_post_fail_over.value_namespace = name_space
                                                        self.lsa_flood_required_post_fail_over.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-length"):
                                                        self.lsa_length = value
                                                        self.lsa_length.value_namespace = name_space
                                                        self.lsa_length.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsa-sync-state"):
                                                        self.lsa_sync_state = value
                                                        self.lsa_sync_state.value_namespace = name_space
                                                        self.lsa_sync_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "minute-table-index"):
                                                        self.minute_table_index = value
                                                        self.minute_table_index.value_namespace = name_space
                                                        self.minute_table_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "nsr-flood-required"):
                                                        self.nsr_flood_required = value
                                                        self.nsr_flood_required.value_namespace = name_space
                                                        self.nsr_flood_required.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "rate-limit"):
                                                        self.rate_limit = value
                                                        self.rate_limit.value_namespace = name_space
                                                        self.rate_limit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "second-table-index"):
                                                        self.second_table_index = value
                                                        self.second_table_index.value_namespace = name_space
                                                        self.second_table_index.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interface_name.is_set or
                                                    self.is_sham_link.is_set or
                                                    self.is_virtual_link.is_set or
                                                    self.sham_link_id.is_set or
                                                    self.virtual_link_id.is_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_data()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.is_sham_link.yfilter != YFilter.not_set or
                                                    self.is_virtual_link.yfilter != YFilter.not_set or
                                                    self.sham_link_id.yfilter != YFilter.not_set or
                                                    self.virtual_link_id.yfilter != YFilter.not_set or
                                                    (self.lsa_detail is not None and self.lsa_detail.has_operation()) or
                                                    (self.lsa_header is not None and self.lsa_header.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "unknown-lsa-type" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.is_sham_link.is_set or self.is_sham_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_sham_link.get_name_leafdata())
                                                if (self.is_virtual_link.is_set or self.is_virtual_link.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_virtual_link.get_name_leafdata())
                                                if (self.sham_link_id.is_set or self.sham_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sham_link_id.get_name_leafdata())
                                                if (self.virtual_link_id.is_set or self.virtual_link_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.virtual_link_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "lsa-detail"):
                                                    if (self.lsa_detail is None):
                                                        self.lsa_detail = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaDetail()
                                                        self.lsa_detail.parent = self
                                                        self._children_name_map["lsa_detail"] = "lsa-detail"
                                                    return self.lsa_detail

                                                if (child_yang_name == "lsa-header"):
                                                    if (self.lsa_header is None):
                                                        self.lsa_header = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType.LsaHeader()
                                                        self.lsa_header.parent = self
                                                        self._children_name_map["lsa_header"] = "lsa-header"
                                                    return self.lsa_header

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "lsa-detail" or name == "lsa-header" or name == "interface-name" or name == "is-sham-link" or name == "is-virtual-link" or name == "sham-link-id" or name == "virtual-link-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-sham-link"):
                                                    self.is_sham_link = value
                                                    self.is_sham_link.value_namespace = name_space
                                                    self.is_sham_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-virtual-link"):
                                                    self.is_virtual_link = value
                                                    self.is_virtual_link.value_namespace = name_space
                                                    self.is_virtual_link.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sham-link-id"):
                                                    self.sham_link_id = value
                                                    self.sham_link_id.value_namespace = name_space
                                                    self.sham_link_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "virtual-link-id"):
                                                    self.virtual_link_id = value
                                                    self.virtual_link_id.value_namespace = name_space
                                                    self.virtual_link_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.lsa_info_type.is_set or
                                                (self.external_lsa_type is not None and self.external_lsa_type.has_data()) or
                                                (self.grace_lsa is not None and self.grace_lsa.has_data()) or
                                                (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_data()) or
                                                (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_data()) or
                                                (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_data()) or
                                                (self.link_lsa_type is not None and self.link_lsa_type.has_data()) or
                                                (self.lsa_summary_info is not None and self.lsa_summary_info.has_data()) or
                                                (self.network_lsa_type is not None and self.network_lsa_type.has_data()) or
                                                (self.nssalsa_type is not None and self.nssalsa_type.has_data()) or
                                                (self.router_lsa_type is not None and self.router_lsa_type.has_data()) or
                                                (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_data()) or
                                                (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_data()) or
                                                (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_data()) or
                                                (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.lsa_info_type.yfilter != YFilter.not_set or
                                                (self.external_lsa_type is not None and self.external_lsa_type.has_operation()) or
                                                (self.grace_lsa is not None and self.grace_lsa.has_operation()) or
                                                (self.inter_area_prefix_lsa_type is not None and self.inter_area_prefix_lsa_type.has_operation()) or
                                                (self.inter_area_router_lsa_type is not None and self.inter_area_router_lsa_type.has_operation()) or
                                                (self.intra_area_prefix_lsa_type is not None and self.intra_area_prefix_lsa_type.has_operation()) or
                                                (self.link_lsa_type is not None and self.link_lsa_type.has_operation()) or
                                                (self.lsa_summary_info is not None and self.lsa_summary_info.has_operation()) or
                                                (self.network_lsa_type is not None and self.network_lsa_type.has_operation()) or
                                                (self.nssalsa_type is not None and self.nssalsa_type.has_operation()) or
                                                (self.router_lsa_type is not None and self.router_lsa_type.has_operation()) or
                                                (self.unknown_area_lsa_type is not None and self.unknown_area_lsa_type.has_operation()) or
                                                (self.unknown_aslsa_type is not None and self.unknown_aslsa_type.has_operation()) or
                                                (self.unknown_link_lsa_type is not None and self.unknown_link_lsa_type.has_operation()) or
                                                (self.unknown_lsa_type is not None and self.unknown_lsa_type.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsa-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.lsa_info_type.is_set or self.lsa_info_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsa_info_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "external-lsa-type"):
                                                if (self.external_lsa_type is None):
                                                    self.external_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.ExternalLsaType()
                                                    self.external_lsa_type.parent = self
                                                    self._children_name_map["external_lsa_type"] = "external-lsa-type"
                                                return self.external_lsa_type

                                            if (child_yang_name == "grace-lsa"):
                                                if (self.grace_lsa is None):
                                                    self.grace_lsa = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.GraceLsa()
                                                    self.grace_lsa.parent = self
                                                    self._children_name_map["grace_lsa"] = "grace-lsa"
                                                return self.grace_lsa

                                            if (child_yang_name == "inter-area-prefix-lsa-type"):
                                                if (self.inter_area_prefix_lsa_type is None):
                                                    self.inter_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaPrefixLsaType()
                                                    self.inter_area_prefix_lsa_type.parent = self
                                                    self._children_name_map["inter_area_prefix_lsa_type"] = "inter-area-prefix-lsa-type"
                                                return self.inter_area_prefix_lsa_type

                                            if (child_yang_name == "inter-area-router-lsa-type"):
                                                if (self.inter_area_router_lsa_type is None):
                                                    self.inter_area_router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.InterAreaRouterLsaType()
                                                    self.inter_area_router_lsa_type.parent = self
                                                    self._children_name_map["inter_area_router_lsa_type"] = "inter-area-router-lsa-type"
                                                return self.inter_area_router_lsa_type

                                            if (child_yang_name == "intra-area-prefix-lsa-type"):
                                                if (self.intra_area_prefix_lsa_type is None):
                                                    self.intra_area_prefix_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.IntraAreaPrefixLsaType()
                                                    self.intra_area_prefix_lsa_type.parent = self
                                                    self._children_name_map["intra_area_prefix_lsa_type"] = "intra-area-prefix-lsa-type"
                                                return self.intra_area_prefix_lsa_type

                                            if (child_yang_name == "link-lsa-type"):
                                                if (self.link_lsa_type is None):
                                                    self.link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LinkLsaType()
                                                    self.link_lsa_type.parent = self
                                                    self._children_name_map["link_lsa_type"] = "link-lsa-type"
                                                return self.link_lsa_type

                                            if (child_yang_name == "lsa-summary-info"):
                                                if (self.lsa_summary_info is None):
                                                    self.lsa_summary_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.LsaSummaryInfo()
                                                    self.lsa_summary_info.parent = self
                                                    self._children_name_map["lsa_summary_info"] = "lsa-summary-info"
                                                return self.lsa_summary_info

                                            if (child_yang_name == "network-lsa-type"):
                                                if (self.network_lsa_type is None):
                                                    self.network_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NetworkLsaType()
                                                    self.network_lsa_type.parent = self
                                                    self._children_name_map["network_lsa_type"] = "network-lsa-type"
                                                return self.network_lsa_type

                                            if (child_yang_name == "nssalsa-type"):
                                                if (self.nssalsa_type is None):
                                                    self.nssalsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.NssalsaType()
                                                    self.nssalsa_type.parent = self
                                                    self._children_name_map["nssalsa_type"] = "nssalsa-type"
                                                return self.nssalsa_type

                                            if (child_yang_name == "router-lsa-type"):
                                                if (self.router_lsa_type is None):
                                                    self.router_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.RouterLsaType()
                                                    self.router_lsa_type.parent = self
                                                    self._children_name_map["router_lsa_type"] = "router-lsa-type"
                                                return self.router_lsa_type

                                            if (child_yang_name == "unknown-area-lsa-type"):
                                                if (self.unknown_area_lsa_type is None):
                                                    self.unknown_area_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAreaLsaType()
                                                    self.unknown_area_lsa_type.parent = self
                                                    self._children_name_map["unknown_area_lsa_type"] = "unknown-area-lsa-type"
                                                return self.unknown_area_lsa_type

                                            if (child_yang_name == "unknown-aslsa-type"):
                                                if (self.unknown_aslsa_type is None):
                                                    self.unknown_aslsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownAslsaType()
                                                    self.unknown_aslsa_type.parent = self
                                                    self._children_name_map["unknown_aslsa_type"] = "unknown-aslsa-type"
                                                return self.unknown_aslsa_type

                                            if (child_yang_name == "unknown-link-lsa-type"):
                                                if (self.unknown_link_lsa_type is None):
                                                    self.unknown_link_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLinkLsaType()
                                                    self.unknown_link_lsa_type.parent = self
                                                    self._children_name_map["unknown_link_lsa_type"] = "unknown-link-lsa-type"
                                                return self.unknown_link_lsa_type

                                            if (child_yang_name == "unknown-lsa-type"):
                                                if (self.unknown_lsa_type is None):
                                                    self.unknown_lsa_type = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo.UnknownLsaType()
                                                    self.unknown_lsa_type.parent = self
                                                    self._children_name_map["unknown_lsa_type"] = "unknown-lsa-type"
                                                return self.unknown_lsa_type

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "external-lsa-type" or name == "grace-lsa" or name == "inter-area-prefix-lsa-type" or name == "inter-area-router-lsa-type" or name == "intra-area-prefix-lsa-type" or name == "link-lsa-type" or name == "lsa-summary-info" or name == "network-lsa-type" or name == "nssalsa-type" or name == "router-lsa-type" or name == "unknown-area-lsa-type" or name == "unknown-aslsa-type" or name == "unknown-link-lsa-type" or name == "unknown-lsa-type" or name == "lsa-info-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "lsa-info-type"):
                                                self.lsa_info_type = value
                                                self.lsa_info_type.value_namespace = name_space
                                                self.lsa_info_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.advertising_router.is_set or
                                            self.area_id.is_set or
                                            self.interface_name.is_set or
                                            self.ls_id.is_set or
                                            self.ls_type.is_set or
                                            (self.lsa_info is not None and self.lsa_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.advertising_router.yfilter != YFilter.not_set or
                                            self.area_id.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.ls_id.yfilter != YFilter.not_set or
                                            self.ls_type.yfilter != YFilter.not_set or
                                            (self.lsa_info is not None and self.lsa_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsa" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.advertising_router.is_set or self.advertising_router.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.advertising_router.get_name_leafdata())
                                        if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.area_id.get_name_leafdata())
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.ls_id.is_set or self.ls_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ls_id.get_name_leafdata())
                                        if (self.ls_type.is_set or self.ls_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ls_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "lsa-info"):
                                            if (self.lsa_info is None):
                                                self.lsa_info = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa.LsaInfo()
                                                self.lsa_info.parent = self
                                                self._children_name_map["lsa_info"] = "lsa-info"
                                            return self.lsa_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsa-info" or name == "advertising-router" or name == "area-id" or name == "interface-name" or name == "ls-id" or name == "ls-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "advertising-router"):
                                            self.advertising_router = value
                                            self.advertising_router.value_namespace = name_space
                                            self.advertising_router.value_namespace_prefix = name_space_prefix
                                        if(value_path == "area-id"):
                                            self.area_id = value
                                            self.area_id.value_namespace = name_space
                                            self.area_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ls-id"):
                                            self.ls_id = value
                                            self.ls_id.value_namespace = name_space
                                            self.ls_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ls-type"):
                                            self.ls_type = value
                                            self.ls_type.value_namespace = name_space
                                            self.ls_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.lsa:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.lsa:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsa-internal-table" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "lsa"):
                                        for c in self.lsa:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable.Lsa()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.lsa.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "lsa"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.lsa_internal_table is not None and self.lsa_internal_table.has_data()) or
                                    (self.lsa_table is not None and self.lsa_table.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.lsa_internal_table is not None and self.lsa_internal_table.has_operation()) or
                                    (self.lsa_table is not None and self.lsa_table.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "database-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "lsa-internal-table"):
                                    if (self.lsa_internal_table is None):
                                        self.lsa_internal_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaInternalTable()
                                        self.lsa_internal_table.parent = self
                                        self._children_name_map["lsa_internal_table"] = "lsa-internal-table"
                                    return self.lsa_internal_table

                                if (child_yang_name == "lsa-table"):
                                    if (self.lsa_table is None):
                                        self.lsa_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable.LsaTable()
                                        self.lsa_table.parent = self
                                        self._children_name_map["lsa_table"] = "lsa-table"
                                    return self.lsa_table

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsa-internal-table" or name == "lsa-table"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class DatabaseSummaryTable(Entity):
                            """
                            Database summary table
                            
                            .. attribute:: database_summary
                            
                            	Database Summary information
                            	**type**\:   :py:class:`DatabaseSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable, self).__init__()

                                self.yang_name = "database-summary-table"
                                self.yang_parent_name = "area"

                                self.database_summary = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary()
                                self.database_summary.parent = self
                                self._children_name_map["database_summary"] = "database-summary"
                                self._children_yang_names.add("database-summary")


                            class DatabaseSummary(Entity):
                                """
                                Database Summary information
                                
                                .. attribute:: area_database
                                
                                	OSPFv3 Area Database list 
                                	**type**\: list of    :py:class:`AreaDatabase <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase>`
                                
                                .. attribute:: database_counters
                                
                                	OSPFv3 database counters 
                                	**type**\:   :py:class:`DatabaseCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters>`
                                
                                .. attribute:: database_router_id
                                
                                	Database router ID 
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_opaque_database_capable
                                
                                	If true, opaque database is capable 
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary, self).__init__()

                                    self.yang_name = "database-summary"
                                    self.yang_parent_name = "database-summary-table"

                                    self.database_router_id = YLeaf(YType.str, "database-router-id")

                                    self.is_opaque_database_capable = YLeaf(YType.boolean, "is-opaque-database-capable")

                                    self.database_counters = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters()
                                    self.database_counters.parent = self
                                    self._children_name_map["database_counters"] = "database-counters"
                                    self._children_yang_names.add("database-counters")

                                    self.area_database = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("database_router_id",
                                                    "is_opaque_database_capable") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary, self).__setattr__(name, value)


                                class DatabaseCounters(Entity):
                                    """
                                    OSPFv3 database counters 
                                    
                                    .. attribute:: deleted_lsa
                                    
                                    	deleted lsa
                                    	**type**\:  list of int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lsa
                                    
                                    	lsa
                                    	**type**\:  list of int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lsa_checksum
                                    
                                    	lsa checksum
                                    	**type**\:  list of int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: max_age_lsa
                                    
                                    	max age lsa
                                    	**type**\:  list of int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__init__()

                                        self.yang_name = "database-counters"
                                        self.yang_parent_name = "database-summary"

                                        self.deleted_lsa = YLeafList(YType.uint32, "deleted-lsa")

                                        self.lsa = YLeafList(YType.uint32, "lsa")

                                        self.lsa_checksum = YLeafList(YType.uint32, "lsa-checksum")

                                        self.max_age_lsa = YLeafList(YType.uint32, "max-age-lsa")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("deleted_lsa",
                                                        "lsa",
                                                        "lsa_checksum",
                                                        "max_age_lsa") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__setattr__(name, value)

                                    def has_data(self):
                                        for leaf in self.deleted_lsa.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        for leaf in self.lsa.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        for leaf in self.lsa_checksum.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        for leaf in self.max_age_lsa.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for leaf in self.deleted_lsa.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        for leaf in self.lsa.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        for leaf in self.lsa_checksum.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        for leaf in self.max_age_lsa.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.deleted_lsa.yfilter != YFilter.not_set or
                                            self.lsa.yfilter != YFilter.not_set or
                                            self.lsa_checksum.yfilter != YFilter.not_set or
                                            self.max_age_lsa.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "database-counters" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        leaf_name_data.extend(self.deleted_lsa.get_name_leafdata())

                                        leaf_name_data.extend(self.lsa.get_name_leafdata())

                                        leaf_name_data.extend(self.lsa_checksum.get_name_leafdata())

                                        leaf_name_data.extend(self.max_age_lsa.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "deleted-lsa" or name == "lsa" or name == "lsa-checksum" or name == "max-age-lsa"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "deleted-lsa"):
                                            self.deleted_lsa.append(value)
                                        if(value_path == "lsa"):
                                            self.lsa.append(value)
                                        if(value_path == "lsa-checksum"):
                                            self.lsa_checksum.append(value)
                                        if(value_path == "max-age-lsa"):
                                            self.max_age_lsa.append(value)


                                class AreaDatabase(Entity):
                                    """
                                    OSPFv3 Area Database list 
                                    
                                    .. attribute:: area_database_summary
                                    
                                    	Area database summary 
                                    	**type**\:   :py:class:`AreaDatabaseSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary>`
                                    
                                    .. attribute:: lsa_area_id
                                    
                                    	Area ID in decimal or dotted\-decimal format
                                    	**type**\:  str
                                    
                                    	**length:** 0..16
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__init__()

                                        self.yang_name = "area-database"
                                        self.yang_parent_name = "database-summary"

                                        self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                        self.area_database_summary = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary()
                                        self.area_database_summary.parent = self
                                        self._children_name_map["area_database_summary"] = "area-database-summary"
                                        self._children_yang_names.add("area-database-summary")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("lsa_area_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__setattr__(name, value)


                                    class AreaDatabaseSummary(Entity):
                                        """
                                        Area database summary 
                                        
                                        .. attribute:: deleted_lsa
                                        
                                        	deleted lsa
                                        	**type**\:  list of int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa
                                        
                                        	lsa
                                        	**type**\:  list of int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: lsa_checksum
                                        
                                        	lsa checksum
                                        	**type**\:  list of int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_age_lsa
                                        
                                        	max age lsa
                                        	**type**\:  list of int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'ipv6-ospfv3-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__init__()

                                            self.yang_name = "area-database-summary"
                                            self.yang_parent_name = "area-database"

                                            self.deleted_lsa = YLeafList(YType.uint32, "deleted-lsa")

                                            self.lsa = YLeafList(YType.uint32, "lsa")

                                            self.lsa_checksum = YLeafList(YType.uint32, "lsa-checksum")

                                            self.max_age_lsa = YLeafList(YType.uint32, "max-age-lsa")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("deleted_lsa",
                                                            "lsa",
                                                            "lsa_checksum",
                                                            "max_age_lsa") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__setattr__(name, value)

                                        def has_data(self):
                                            for leaf in self.deleted_lsa.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            for leaf in self.lsa.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            for leaf in self.lsa_checksum.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            for leaf in self.max_age_lsa.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for leaf in self.deleted_lsa.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            for leaf in self.lsa.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            for leaf in self.lsa_checksum.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            for leaf in self.max_age_lsa.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.deleted_lsa.yfilter != YFilter.not_set or
                                                self.lsa.yfilter != YFilter.not_set or
                                                self.lsa_checksum.yfilter != YFilter.not_set or
                                                self.max_age_lsa.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "area-database-summary" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            leaf_name_data.extend(self.deleted_lsa.get_name_leafdata())

                                            leaf_name_data.extend(self.lsa.get_name_leafdata())

                                            leaf_name_data.extend(self.lsa_checksum.get_name_leafdata())

                                            leaf_name_data.extend(self.max_age_lsa.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "deleted-lsa" or name == "lsa" or name == "lsa-checksum" or name == "max-age-lsa"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "deleted-lsa"):
                                                self.deleted_lsa.append(value)
                                            if(value_path == "lsa"):
                                                self.lsa.append(value)
                                            if(value_path == "lsa-checksum"):
                                                self.lsa_checksum.append(value)
                                            if(value_path == "max-age-lsa"):
                                                self.max_age_lsa.append(value)

                                    def has_data(self):
                                        return (
                                            self.lsa_area_id.is_set or
                                            (self.area_database_summary is not None and self.area_database_summary.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.lsa_area_id.yfilter != YFilter.not_set or
                                            (self.area_database_summary is not None and self.area_database_summary.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "area-database" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsa_area_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "area-database-summary"):
                                            if (self.area_database_summary is None):
                                                self.area_database_summary = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary()
                                                self.area_database_summary.parent = self
                                                self._children_name_map["area_database_summary"] = "area-database-summary"
                                            return self.area_database_summary

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "area-database-summary" or name == "lsa-area-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "lsa-area-id"):
                                            self.lsa_area_id = value
                                            self.lsa_area_id.value_namespace = name_space
                                            self.lsa_area_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.area_database:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.database_router_id.is_set or
                                        self.is_opaque_database_capable.is_set or
                                        (self.database_counters is not None and self.database_counters.has_data()))

                                def has_operation(self):
                                    for c in self.area_database:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.database_router_id.yfilter != YFilter.not_set or
                                        self.is_opaque_database_capable.yfilter != YFilter.not_set or
                                        (self.database_counters is not None and self.database_counters.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "database-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.database_router_id.is_set or self.database_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.database_router_id.get_name_leafdata())
                                    if (self.is_opaque_database_capable.is_set or self.is_opaque_database_capable.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_opaque_database_capable.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "area-database"):
                                        for c in self.area_database:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.AreaDatabase()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.area_database.append(c)
                                        return c

                                    if (child_yang_name == "database-counters"):
                                        if (self.database_counters is None):
                                            self.database_counters = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters()
                                            self.database_counters.parent = self
                                            self._children_name_map["database_counters"] = "database-counters"
                                        return self.database_counters

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "area-database" or name == "database-counters" or name == "database-router-id" or name == "is-opaque-database-capable"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "database-router-id"):
                                        self.database_router_id = value
                                        self.database_router_id.value_namespace = name_space
                                        self.database_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-opaque-database-capable"):
                                        self.is_opaque_database_capable = value
                                        self.is_opaque_database_capable.value_namespace = name_space
                                        self.is_opaque_database_capable.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.database_summary is not None and self.database_summary.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.database_summary is not None and self.database_summary.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "database-summary-table" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "database-summary"):
                                    if (self.database_summary is None):
                                        self.database_summary = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable.DatabaseSummary()
                                        self.database_summary.parent = self
                                        self._children_name_map["database_summary"] = "database-summary"
                                    return self.database_summary

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "database-summary"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.area_id.is_set or
                                (self.database_summary_table is not None and self.database_summary_table.has_data()) or
                                (self.database_table is not None and self.database_table.has_data()) or
                                (self.flood_list_table is not None and self.flood_list_table.has_data()) or
                                (self.interface_brief_table is not None and self.interface_brief_table.has_data()) or
                                (self.interface_table is not None and self.interface_table.has_data()) or
                                (self.neighbor_detail_table is not None and self.neighbor_detail_table.has_data()) or
                                (self.neighbor_table is not None and self.neighbor_table.has_data()) or
                                (self.request_list_table is not None and self.request_list_table.has_data()) or
                                (self.retransmission_list_table is not None and self.retransmission_list_table.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.area_id.yfilter != YFilter.not_set or
                                (self.database_summary_table is not None and self.database_summary_table.has_operation()) or
                                (self.database_table is not None and self.database_table.has_operation()) or
                                (self.flood_list_table is not None and self.flood_list_table.has_operation()) or
                                (self.interface_brief_table is not None and self.interface_brief_table.has_operation()) or
                                (self.interface_table is not None and self.interface_table.has_operation()) or
                                (self.neighbor_detail_table is not None and self.neighbor_detail_table.has_operation()) or
                                (self.neighbor_table is not None and self.neighbor_table.has_operation()) or
                                (self.request_list_table is not None and self.request_list_table.has_operation()) or
                                (self.retransmission_list_table is not None and self.retransmission_list_table.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "area" + "[area-id='" + self.area_id.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "database-summary-table"):
                                if (self.database_summary_table is None):
                                    self.database_summary_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseSummaryTable()
                                    self.database_summary_table.parent = self
                                    self._children_name_map["database_summary_table"] = "database-summary-table"
                                return self.database_summary_table

                            if (child_yang_name == "database-table"):
                                if (self.database_table is None):
                                    self.database_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.DatabaseTable()
                                    self.database_table.parent = self
                                    self._children_name_map["database_table"] = "database-table"
                                return self.database_table

                            if (child_yang_name == "flood-list-table"):
                                if (self.flood_list_table is None):
                                    self.flood_list_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.FloodListTable()
                                    self.flood_list_table.parent = self
                                    self._children_name_map["flood_list_table"] = "flood-list-table"
                                return self.flood_list_table

                            if (child_yang_name == "interface-brief-table"):
                                if (self.interface_brief_table is None):
                                    self.interface_brief_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceBriefTable()
                                    self.interface_brief_table.parent = self
                                    self._children_name_map["interface_brief_table"] = "interface-brief-table"
                                return self.interface_brief_table

                            if (child_yang_name == "interface-table"):
                                if (self.interface_table is None):
                                    self.interface_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.InterfaceTable()
                                    self.interface_table.parent = self
                                    self._children_name_map["interface_table"] = "interface-table"
                                return self.interface_table

                            if (child_yang_name == "neighbor-detail-table"):
                                if (self.neighbor_detail_table is None):
                                    self.neighbor_detail_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborDetailTable()
                                    self.neighbor_detail_table.parent = self
                                    self._children_name_map["neighbor_detail_table"] = "neighbor-detail-table"
                                return self.neighbor_detail_table

                            if (child_yang_name == "neighbor-table"):
                                if (self.neighbor_table is None):
                                    self.neighbor_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.NeighborTable()
                                    self.neighbor_table.parent = self
                                    self._children_name_map["neighbor_table"] = "neighbor-table"
                                return self.neighbor_table

                            if (child_yang_name == "request-list-table"):
                                if (self.request_list_table is None):
                                    self.request_list_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RequestListTable()
                                    self.request_list_table.parent = self
                                    self._children_name_map["request_list_table"] = "request-list-table"
                                return self.request_list_table

                            if (child_yang_name == "retransmission-list-table"):
                                if (self.retransmission_list_table is None):
                                    self.retransmission_list_table = Ospfv3.Processes.Process.DefaultVrf.Areas.Area.RetransmissionListTable()
                                    self.retransmission_list_table.parent = self
                                    self._children_name_map["retransmission_list_table"] = "retransmission-list-table"
                                return self.retransmission_list_table

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "database-summary-table" or name == "database-table" or name == "flood-list-table" or name == "interface-brief-table" or name == "interface-table" or name == "neighbor-detail-table" or name == "neighbor-table" or name == "request-list-table" or name == "retransmission-list-table" or name == "area-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "area-id"):
                                self.area_id = value
                                self.area_id.value_namespace = name_space
                                self.area_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.area:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.area:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "areas" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "area"):
                            for c in self.area:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.Areas.Area()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.area.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "area"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class InternalRoutes(Entity):
                    """
                    OSPFv3 internal route information table
                    
                    .. attribute:: internal_route
                    
                    	OSPFv3 internal route information
                    	**type**\: list of    :py:class:`InternalRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes, self).__init__()

                        self.yang_name = "internal-routes"
                        self.yang_parent_name = "default-vrf"

                        self.internal_route = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes, self).__setattr__(name, value)


                    class InternalRoute(Entity):
                        """
                        OSPFv3 internal route information
                        
                        .. attribute:: prefix
                        
                        	Route prefix
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..128
                        
                        .. attribute:: route_area_id
                        
                        	Route area ID 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: route_path
                        
                        	List of paths to this route
                        	**type**\: list of    :py:class:`RoutePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath>`
                        
                        .. attribute:: route_source
                        
                        	List of topology source information
                        	**type**\: list of    :py:class:`RouteSource <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteSource>`
                        
                        .. attribute:: route_topology
                        
                        	Common Route topology information
                        	**type**\:   :py:class:`RouteTopology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteTopology>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute, self).__init__()

                            self.yang_name = "internal-route"
                            self.yang_parent_name = "internal-routes"

                            self.prefix = YLeaf(YType.str, "prefix")

                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            self.route_area_id = YLeaf(YType.uint32, "route-area-id")

                            self.route_topology = Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteTopology()
                            self.route_topology.parent = self
                            self._children_name_map["route_topology"] = "route-topology"
                            self._children_yang_names.add("route-topology")

                            self.route_path = YList(self)
                            self.route_source = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("prefix",
                                            "prefix_length",
                                            "route_area_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute, self).__setattr__(name, value)


                        class RouteTopology(Entity):
                            """
                            Common Route topology information
                            
                            .. attribute:: route_cost
                            
                            	Route cost 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: route_distance
                            
                            	Route distance 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: route_id
                            
                            	Route ID 
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: route_type
                            
                            	Route type
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteTopology, self).__init__()

                                self.yang_name = "route-topology"
                                self.yang_parent_name = "internal-route"

                                self.route_cost = YLeaf(YType.uint32, "route-cost")

                                self.route_distance = YLeaf(YType.uint32, "route-distance")

                                self.route_id = YLeaf(YType.str, "route-id")

                                self.route_type = YLeaf(YType.uint32, "route-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("route_cost",
                                                "route_distance",
                                                "route_id",
                                                "route_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteTopology, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteTopology, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.route_cost.is_set or
                                    self.route_distance.is_set or
                                    self.route_id.is_set or
                                    self.route_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.route_cost.yfilter != YFilter.not_set or
                                    self.route_distance.yfilter != YFilter.not_set or
                                    self.route_id.yfilter != YFilter.not_set or
                                    self.route_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "route-topology" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.route_cost.is_set or self.route_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_cost.get_name_leafdata())
                                if (self.route_distance.is_set or self.route_distance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_distance.get_name_leafdata())
                                if (self.route_id.is_set or self.route_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_id.get_name_leafdata())
                                if (self.route_type.is_set or self.route_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "route-cost" or name == "route-distance" or name == "route-id" or name == "route-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "route-cost"):
                                    self.route_cost = value
                                    self.route_cost.value_namespace = name_space
                                    self.route_cost.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-distance"):
                                    self.route_distance = value
                                    self.route_distance.value_namespace = name_space
                                    self.route_distance.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-id"):
                                    self.route_id = value
                                    self.route_id.value_namespace = name_space
                                    self.route_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-type"):
                                    self.route_type = value
                                    self.route_type.value_namespace = name_space
                                    self.route_type.value_namespace_prefix = name_space_prefix


                        class RouteSource(Entity):
                            """
                            List of topology source information
                            
                            .. attribute:: route_source_adversting_router
                            
                            	Route source of the advertising router 
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: route_source_id
                            
                            	Route source ID 
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: route_source_lsa_type
                            
                            	Type of LSA advertising the prefix, see RFC5340
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteSource, self).__init__()

                                self.yang_name = "route-source"
                                self.yang_parent_name = "internal-route"

                                self.route_source_adversting_router = YLeaf(YType.str, "route-source-adversting-router")

                                self.route_source_id = YLeaf(YType.str, "route-source-id")

                                self.route_source_lsa_type = YLeaf(YType.uint32, "route-source-lsa-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("route_source_adversting_router",
                                                "route_source_id",
                                                "route_source_lsa_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteSource, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteSource, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.route_source_adversting_router.is_set or
                                    self.route_source_id.is_set or
                                    self.route_source_lsa_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.route_source_adversting_router.yfilter != YFilter.not_set or
                                    self.route_source_id.yfilter != YFilter.not_set or
                                    self.route_source_lsa_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "route-source" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.route_source_adversting_router.is_set or self.route_source_adversting_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_source_adversting_router.get_name_leafdata())
                                if (self.route_source_id.is_set or self.route_source_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_source_id.get_name_leafdata())
                                if (self.route_source_lsa_type.is_set or self.route_source_lsa_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_source_lsa_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "route-source-adversting-router" or name == "route-source-id" or name == "route-source-lsa-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "route-source-adversting-router"):
                                    self.route_source_adversting_router = value
                                    self.route_source_adversting_router.value_namespace = name_space
                                    self.route_source_adversting_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-source-id"):
                                    self.route_source_id = value
                                    self.route_source_id.value_namespace = name_space
                                    self.route_source_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-source-lsa-type"):
                                    self.route_source_lsa_type = value
                                    self.route_source_lsa_type.value_namespace = name_space
                                    self.route_source_lsa_type.value_namespace_prefix = name_space_prefix


                        class RoutePath(Entity):
                            """
                            List of paths to this route
                            
                            .. attribute:: interface_name
                            
                            	Route path interface name 
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: route_backup_path
                            
                            	Backup Path Info
                            	**type**\:   :py:class:`RouteBackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath>`
                            
                            .. attribute:: route_path_id
                            
                            	Path ID of path
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: route_path_next_hop
                            
                            	Route path next hop 
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath, self).__init__()

                                self.yang_name = "route-path"
                                self.yang_parent_name = "internal-route"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.route_path_id = YLeaf(YType.uint16, "route-path-id")

                                self.route_path_next_hop = YLeaf(YType.str, "route-path-next-hop")

                                self.route_backup_path = Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath()
                                self.route_backup_path.parent = self
                                self._children_name_map["route_backup_path"] = "route-backup-path"
                                self._children_yang_names.add("route-backup-path")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "route_path_id",
                                                "route_path_next_hop") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath, self).__setattr__(name, value)


                            class RouteBackupPath(Entity):
                                """
                                Backup Path Info
                                
                                .. attribute:: backup_metric
                                
                                	Metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: backup_route_interface_name
                                
                                	Next hop Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: backup_route_next_hop_address
                                
                                	Nexthop IP address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: backup_route_source
                                
                                	IP address of source of route
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: downstream
                                
                                	Downstream
                                	**type**\:  bool
                                
                                .. attribute:: line_card_disjoint
                                
                                	Line Card Disjoint
                                	**type**\:  bool
                                
                                .. attribute:: node_protect
                                
                                	Node Protect
                                	**type**\:  bool
                                
                                .. attribute:: primary_path
                                
                                	Primary Path
                                	**type**\:  bool
                                
                                .. attribute:: srlg_disjoint
                                
                                	SRLG Disjoint
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath, self).__init__()

                                    self.yang_name = "route-backup-path"
                                    self.yang_parent_name = "route-path"

                                    self.backup_metric = YLeaf(YType.uint32, "backup-metric")

                                    self.backup_route_interface_name = YLeaf(YType.str, "backup-route-interface-name")

                                    self.backup_route_next_hop_address = YLeaf(YType.str, "backup-route-next-hop-address")

                                    self.backup_route_source = YLeaf(YType.str, "backup-route-source")

                                    self.downstream = YLeaf(YType.boolean, "downstream")

                                    self.line_card_disjoint = YLeaf(YType.boolean, "line-card-disjoint")

                                    self.node_protect = YLeaf(YType.boolean, "node-protect")

                                    self.primary_path = YLeaf(YType.boolean, "primary-path")

                                    self.srlg_disjoint = YLeaf(YType.boolean, "srlg-disjoint")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_metric",
                                                    "backup_route_interface_name",
                                                    "backup_route_next_hop_address",
                                                    "backup_route_source",
                                                    "downstream",
                                                    "line_card_disjoint",
                                                    "node_protect",
                                                    "primary_path",
                                                    "srlg_disjoint") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_metric.is_set or
                                        self.backup_route_interface_name.is_set or
                                        self.backup_route_next_hop_address.is_set or
                                        self.backup_route_source.is_set or
                                        self.downstream.is_set or
                                        self.line_card_disjoint.is_set or
                                        self.node_protect.is_set or
                                        self.primary_path.is_set or
                                        self.srlg_disjoint.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_metric.yfilter != YFilter.not_set or
                                        self.backup_route_interface_name.yfilter != YFilter.not_set or
                                        self.backup_route_next_hop_address.yfilter != YFilter.not_set or
                                        self.backup_route_source.yfilter != YFilter.not_set or
                                        self.downstream.yfilter != YFilter.not_set or
                                        self.line_card_disjoint.yfilter != YFilter.not_set or
                                        self.node_protect.yfilter != YFilter.not_set or
                                        self.primary_path.yfilter != YFilter.not_set or
                                        self.srlg_disjoint.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-backup-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_metric.is_set or self.backup_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_metric.get_name_leafdata())
                                    if (self.backup_route_interface_name.is_set or self.backup_route_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_route_interface_name.get_name_leafdata())
                                    if (self.backup_route_next_hop_address.is_set or self.backup_route_next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_route_next_hop_address.get_name_leafdata())
                                    if (self.backup_route_source.is_set or self.backup_route_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_route_source.get_name_leafdata())
                                    if (self.downstream.is_set or self.downstream.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.downstream.get_name_leafdata())
                                    if (self.line_card_disjoint.is_set or self.line_card_disjoint.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.line_card_disjoint.get_name_leafdata())
                                    if (self.node_protect.is_set or self.node_protect.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.node_protect.get_name_leafdata())
                                    if (self.primary_path.is_set or self.primary_path.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.primary_path.get_name_leafdata())
                                    if (self.srlg_disjoint.is_set or self.srlg_disjoint.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.srlg_disjoint.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-metric" or name == "backup-route-interface-name" or name == "backup-route-next-hop-address" or name == "backup-route-source" or name == "downstream" or name == "line-card-disjoint" or name == "node-protect" or name == "primary-path" or name == "srlg-disjoint"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-metric"):
                                        self.backup_metric = value
                                        self.backup_metric.value_namespace = name_space
                                        self.backup_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-route-interface-name"):
                                        self.backup_route_interface_name = value
                                        self.backup_route_interface_name.value_namespace = name_space
                                        self.backup_route_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-route-next-hop-address"):
                                        self.backup_route_next_hop_address = value
                                        self.backup_route_next_hop_address.value_namespace = name_space
                                        self.backup_route_next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-route-source"):
                                        self.backup_route_source = value
                                        self.backup_route_source.value_namespace = name_space
                                        self.backup_route_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "downstream"):
                                        self.downstream = value
                                        self.downstream.value_namespace = name_space
                                        self.downstream.value_namespace_prefix = name_space_prefix
                                    if(value_path == "line-card-disjoint"):
                                        self.line_card_disjoint = value
                                        self.line_card_disjoint.value_namespace = name_space
                                        self.line_card_disjoint.value_namespace_prefix = name_space_prefix
                                    if(value_path == "node-protect"):
                                        self.node_protect = value
                                        self.node_protect.value_namespace = name_space
                                        self.node_protect.value_namespace_prefix = name_space_prefix
                                    if(value_path == "primary-path"):
                                        self.primary_path = value
                                        self.primary_path.value_namespace = name_space
                                        self.primary_path.value_namespace_prefix = name_space_prefix
                                    if(value_path == "srlg-disjoint"):
                                        self.srlg_disjoint = value
                                        self.srlg_disjoint.value_namespace = name_space
                                        self.srlg_disjoint.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_name.is_set or
                                    self.route_path_id.is_set or
                                    self.route_path_next_hop.is_set or
                                    (self.route_backup_path is not None and self.route_backup_path.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.route_path_id.yfilter != YFilter.not_set or
                                    self.route_path_next_hop.yfilter != YFilter.not_set or
                                    (self.route_backup_path is not None and self.route_backup_path.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "route-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.route_path_id.is_set or self.route_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_path_id.get_name_leafdata())
                                if (self.route_path_next_hop.is_set or self.route_path_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_path_next_hop.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "route-backup-path"):
                                    if (self.route_backup_path is None):
                                        self.route_backup_path = Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath.RouteBackupPath()
                                        self.route_backup_path.parent = self
                                        self._children_name_map["route_backup_path"] = "route-backup-path"
                                    return self.route_backup_path

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "route-backup-path" or name == "interface-name" or name == "route-path-id" or name == "route-path-next-hop"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-path-id"):
                                    self.route_path_id = value
                                    self.route_path_id.value_namespace = name_space
                                    self.route_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-path-next-hop"):
                                    self.route_path_next_hop = value
                                    self.route_path_next_hop.value_namespace = name_space
                                    self.route_path_next_hop.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.route_path:
                                if (c.has_data()):
                                    return True
                            for c in self.route_source:
                                if (c.has_data()):
                                    return True
                            return (
                                self.prefix.is_set or
                                self.prefix_length.is_set or
                                self.route_area_id.is_set or
                                (self.route_topology is not None and self.route_topology.has_data()))

                        def has_operation(self):
                            for c in self.route_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.route_source:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set or
                                self.route_area_id.yfilter != YFilter.not_set or
                                (self.route_topology is not None and self.route_topology.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "internal-route" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                            if (self.route_area_id.is_set or self.route_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.route_area_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "route-path"):
                                for c in self.route_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RoutePath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.route_path.append(c)
                                return c

                            if (child_yang_name == "route-source"):
                                for c in self.route_source:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteSource()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.route_source.append(c)
                                return c

                            if (child_yang_name == "route-topology"):
                                if (self.route_topology is None):
                                    self.route_topology = Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute.RouteTopology()
                                    self.route_topology.parent = self
                                    self._children_name_map["route_topology"] = "route-topology"
                                return self.route_topology

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "route-path" or name == "route-source" or name == "route-topology" or name == "prefix" or name == "prefix-length" or name == "route-area-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix
                            if(value_path == "route-area-id"):
                                self.route_area_id = value
                                self.route_area_id.value_namespace = name_space
                                self.route_area_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.internal_route:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.internal_route:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "internal-routes" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "internal-route"):
                            for c in self.internal_route:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.InternalRoutes.InternalRoute()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.internal_route.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "internal-route"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class ProtocolAreas(Entity):
                    """
                    Protocol area table 
                    
                    .. attribute:: protocol_area
                    
                    	Area information 
                    	**type**\: list of    :py:class:`ProtocolArea <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas.ProtocolArea>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas, self).__init__()

                        self.yang_name = "protocol-areas"
                        self.yang_parent_name = "default-vrf"

                        self.protocol_area = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas, self).__setattr__(name, value)


                    class ProtocolArea(Entity):
                        """
                        Area information 
                        
                        .. attribute:: area_id  <key>
                        
                        	Area ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: distribute_list_in
                        
                        	Distribute List In
                        	**type**\:  str
                        
                        .. attribute:: protocol_area_id
                        
                        	Area ID string in decimal and dotted\-decimal format
                        	**type**\:  str
                        
                        	**length:** 0..16
                        
                        .. attribute:: protocol_interface
                        
                        	Interface list
                        	**type**\: list of    :py:class:`ProtocolInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas.ProtocolArea.ProtocolInterface>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas.ProtocolArea, self).__init__()

                            self.yang_name = "protocol-area"
                            self.yang_parent_name = "protocol-areas"

                            self.area_id = YLeaf(YType.str, "area-id")

                            self.distribute_list_in = YLeaf(YType.str, "distribute-list-in")

                            self.protocol_area_id = YLeaf(YType.str, "protocol-area-id")

                            self.protocol_interface = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("area_id",
                                            "distribute_list_in",
                                            "protocol_area_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas.ProtocolArea, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas.ProtocolArea, self).__setattr__(name, value)


                        class ProtocolInterface(Entity):
                            """
                            Interface list
                            
                            .. attribute:: distribute_list_in
                            
                            	Distribute List In
                            	**type**\:  str
                            
                            .. attribute:: interface_name
                            
                            	Protocol interface name 
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas.ProtocolArea.ProtocolInterface, self).__init__()

                                self.yang_name = "protocol-interface"
                                self.yang_parent_name = "protocol-area"

                                self.distribute_list_in = YLeaf(YType.str, "distribute-list-in")

                                self.interface_name = YLeaf(YType.str, "interface-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("distribute_list_in",
                                                "interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas.ProtocolArea.ProtocolInterface, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas.ProtocolArea.ProtocolInterface, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.distribute_list_in.is_set or
                                    self.interface_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.distribute_list_in.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protocol-interface" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.distribute_list_in.is_set or self.distribute_list_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.distribute_list_in.get_name_leafdata())
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "distribute-list-in" or name == "interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "distribute-list-in"):
                                    self.distribute_list_in = value
                                    self.distribute_list_in.value_namespace = name_space
                                    self.distribute_list_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.protocol_interface:
                                if (c.has_data()):
                                    return True
                            return (
                                self.area_id.is_set or
                                self.distribute_list_in.is_set or
                                self.protocol_area_id.is_set)

                        def has_operation(self):
                            for c in self.protocol_interface:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.area_id.yfilter != YFilter.not_set or
                                self.distribute_list_in.yfilter != YFilter.not_set or
                                self.protocol_area_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protocol-area" + "[area-id='" + self.area_id.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_id.get_name_leafdata())
                            if (self.distribute_list_in.is_set or self.distribute_list_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.distribute_list_in.get_name_leafdata())
                            if (self.protocol_area_id.is_set or self.protocol_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_area_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protocol-interface"):
                                for c in self.protocol_interface:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas.ProtocolArea.ProtocolInterface()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.protocol_interface.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protocol-interface" or name == "area-id" or name == "distribute-list-in" or name == "protocol-area-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "area-id"):
                                self.area_id = value
                                self.area_id.value_namespace = name_space
                                self.area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "distribute-list-in"):
                                self.distribute_list_in = value
                                self.distribute_list_in.value_namespace = name_space
                                self.distribute_list_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-area-id"):
                                self.protocol_area_id = value
                                self.protocol_area_id.value_namespace = name_space
                                self.protocol_area_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.protocol_area:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.protocol_area:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "protocol-areas" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "protocol-area"):
                            for c in self.protocol_area:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas.ProtocolArea()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.protocol_area.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "protocol-area"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class ConnectedRoutes(Entity):
                    """
                    OSPFv3 connected route information table
                    
                    .. attribute:: connected_route
                    
                    	OSPFv3 connected route information
                    	**type**\: list of    :py:class:`ConnectedRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes, self).__init__()

                        self.yang_name = "connected-routes"
                        self.yang_parent_name = "default-vrf"

                        self.connected_route = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes, self).__setattr__(name, value)


                    class ConnectedRoute(Entity):
                        """
                        OSPFv3 connected route information
                        
                        .. attribute:: prefix
                        
                        	Route prefix
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..128
                        
                        .. attribute:: route_path
                        
                        	List of paths to this route
                        	**type**\: list of    :py:class:`RoutePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath>`
                        
                        .. attribute:: route_topology
                        
                        	Common Route topology information
                        	**type**\:   :py:class:`RouteTopology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RouteTopology>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute, self).__init__()

                            self.yang_name = "connected-route"
                            self.yang_parent_name = "connected-routes"

                            self.prefix = YLeaf(YType.str, "prefix")

                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            self.route_topology = Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RouteTopology()
                            self.route_topology.parent = self
                            self._children_name_map["route_topology"] = "route-topology"
                            self._children_yang_names.add("route-topology")

                            self.route_path = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("prefix",
                                            "prefix_length") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute, self).__setattr__(name, value)


                        class RouteTopology(Entity):
                            """
                            Common Route topology information
                            
                            .. attribute:: route_cost
                            
                            	Route cost 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: route_distance
                            
                            	Route distance 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: route_id
                            
                            	Route ID 
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: route_type
                            
                            	Route type
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RouteTopology, self).__init__()

                                self.yang_name = "route-topology"
                                self.yang_parent_name = "connected-route"

                                self.route_cost = YLeaf(YType.uint32, "route-cost")

                                self.route_distance = YLeaf(YType.uint32, "route-distance")

                                self.route_id = YLeaf(YType.str, "route-id")

                                self.route_type = YLeaf(YType.uint32, "route-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("route_cost",
                                                "route_distance",
                                                "route_id",
                                                "route_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RouteTopology, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RouteTopology, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.route_cost.is_set or
                                    self.route_distance.is_set or
                                    self.route_id.is_set or
                                    self.route_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.route_cost.yfilter != YFilter.not_set or
                                    self.route_distance.yfilter != YFilter.not_set or
                                    self.route_id.yfilter != YFilter.not_set or
                                    self.route_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "route-topology" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.route_cost.is_set or self.route_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_cost.get_name_leafdata())
                                if (self.route_distance.is_set or self.route_distance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_distance.get_name_leafdata())
                                if (self.route_id.is_set or self.route_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_id.get_name_leafdata())
                                if (self.route_type.is_set or self.route_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "route-cost" or name == "route-distance" or name == "route-id" or name == "route-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "route-cost"):
                                    self.route_cost = value
                                    self.route_cost.value_namespace = name_space
                                    self.route_cost.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-distance"):
                                    self.route_distance = value
                                    self.route_distance.value_namespace = name_space
                                    self.route_distance.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-id"):
                                    self.route_id = value
                                    self.route_id.value_namespace = name_space
                                    self.route_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-type"):
                                    self.route_type = value
                                    self.route_type.value_namespace = name_space
                                    self.route_type.value_namespace_prefix = name_space_prefix


                        class RoutePath(Entity):
                            """
                            List of paths to this route
                            
                            .. attribute:: interface_name
                            
                            	Route path interface name 
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: route_backup_path
                            
                            	Backup Path Info
                            	**type**\:   :py:class:`RouteBackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath>`
                            
                            .. attribute:: route_path_id
                            
                            	Path ID of path
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: route_path_next_hop
                            
                            	Route path next hop 
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath, self).__init__()

                                self.yang_name = "route-path"
                                self.yang_parent_name = "connected-route"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.route_path_id = YLeaf(YType.uint16, "route-path-id")

                                self.route_path_next_hop = YLeaf(YType.str, "route-path-next-hop")

                                self.route_backup_path = Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath()
                                self.route_backup_path.parent = self
                                self._children_name_map["route_backup_path"] = "route-backup-path"
                                self._children_yang_names.add("route-backup-path")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "route_path_id",
                                                "route_path_next_hop") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath, self).__setattr__(name, value)


                            class RouteBackupPath(Entity):
                                """
                                Backup Path Info
                                
                                .. attribute:: backup_metric
                                
                                	Metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: backup_route_interface_name
                                
                                	Next hop Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: backup_route_next_hop_address
                                
                                	Nexthop IP address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: backup_route_source
                                
                                	IP address of source of route
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: downstream
                                
                                	Downstream
                                	**type**\:  bool
                                
                                .. attribute:: line_card_disjoint
                                
                                	Line Card Disjoint
                                	**type**\:  bool
                                
                                .. attribute:: node_protect
                                
                                	Node Protect
                                	**type**\:  bool
                                
                                .. attribute:: primary_path
                                
                                	Primary Path
                                	**type**\:  bool
                                
                                .. attribute:: srlg_disjoint
                                
                                	SRLG Disjoint
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath, self).__init__()

                                    self.yang_name = "route-backup-path"
                                    self.yang_parent_name = "route-path"

                                    self.backup_metric = YLeaf(YType.uint32, "backup-metric")

                                    self.backup_route_interface_name = YLeaf(YType.str, "backup-route-interface-name")

                                    self.backup_route_next_hop_address = YLeaf(YType.str, "backup-route-next-hop-address")

                                    self.backup_route_source = YLeaf(YType.str, "backup-route-source")

                                    self.downstream = YLeaf(YType.boolean, "downstream")

                                    self.line_card_disjoint = YLeaf(YType.boolean, "line-card-disjoint")

                                    self.node_protect = YLeaf(YType.boolean, "node-protect")

                                    self.primary_path = YLeaf(YType.boolean, "primary-path")

                                    self.srlg_disjoint = YLeaf(YType.boolean, "srlg-disjoint")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_metric",
                                                    "backup_route_interface_name",
                                                    "backup_route_next_hop_address",
                                                    "backup_route_source",
                                                    "downstream",
                                                    "line_card_disjoint",
                                                    "node_protect",
                                                    "primary_path",
                                                    "srlg_disjoint") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_metric.is_set or
                                        self.backup_route_interface_name.is_set or
                                        self.backup_route_next_hop_address.is_set or
                                        self.backup_route_source.is_set or
                                        self.downstream.is_set or
                                        self.line_card_disjoint.is_set or
                                        self.node_protect.is_set or
                                        self.primary_path.is_set or
                                        self.srlg_disjoint.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_metric.yfilter != YFilter.not_set or
                                        self.backup_route_interface_name.yfilter != YFilter.not_set or
                                        self.backup_route_next_hop_address.yfilter != YFilter.not_set or
                                        self.backup_route_source.yfilter != YFilter.not_set or
                                        self.downstream.yfilter != YFilter.not_set or
                                        self.line_card_disjoint.yfilter != YFilter.not_set or
                                        self.node_protect.yfilter != YFilter.not_set or
                                        self.primary_path.yfilter != YFilter.not_set or
                                        self.srlg_disjoint.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "route-backup-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_metric.is_set or self.backup_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_metric.get_name_leafdata())
                                    if (self.backup_route_interface_name.is_set or self.backup_route_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_route_interface_name.get_name_leafdata())
                                    if (self.backup_route_next_hop_address.is_set or self.backup_route_next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_route_next_hop_address.get_name_leafdata())
                                    if (self.backup_route_source.is_set or self.backup_route_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_route_source.get_name_leafdata())
                                    if (self.downstream.is_set or self.downstream.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.downstream.get_name_leafdata())
                                    if (self.line_card_disjoint.is_set or self.line_card_disjoint.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.line_card_disjoint.get_name_leafdata())
                                    if (self.node_protect.is_set or self.node_protect.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.node_protect.get_name_leafdata())
                                    if (self.primary_path.is_set or self.primary_path.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.primary_path.get_name_leafdata())
                                    if (self.srlg_disjoint.is_set or self.srlg_disjoint.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.srlg_disjoint.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-metric" or name == "backup-route-interface-name" or name == "backup-route-next-hop-address" or name == "backup-route-source" or name == "downstream" or name == "line-card-disjoint" or name == "node-protect" or name == "primary-path" or name == "srlg-disjoint"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-metric"):
                                        self.backup_metric = value
                                        self.backup_metric.value_namespace = name_space
                                        self.backup_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-route-interface-name"):
                                        self.backup_route_interface_name = value
                                        self.backup_route_interface_name.value_namespace = name_space
                                        self.backup_route_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-route-next-hop-address"):
                                        self.backup_route_next_hop_address = value
                                        self.backup_route_next_hop_address.value_namespace = name_space
                                        self.backup_route_next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-route-source"):
                                        self.backup_route_source = value
                                        self.backup_route_source.value_namespace = name_space
                                        self.backup_route_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "downstream"):
                                        self.downstream = value
                                        self.downstream.value_namespace = name_space
                                        self.downstream.value_namespace_prefix = name_space_prefix
                                    if(value_path == "line-card-disjoint"):
                                        self.line_card_disjoint = value
                                        self.line_card_disjoint.value_namespace = name_space
                                        self.line_card_disjoint.value_namespace_prefix = name_space_prefix
                                    if(value_path == "node-protect"):
                                        self.node_protect = value
                                        self.node_protect.value_namespace = name_space
                                        self.node_protect.value_namespace_prefix = name_space_prefix
                                    if(value_path == "primary-path"):
                                        self.primary_path = value
                                        self.primary_path.value_namespace = name_space
                                        self.primary_path.value_namespace_prefix = name_space_prefix
                                    if(value_path == "srlg-disjoint"):
                                        self.srlg_disjoint = value
                                        self.srlg_disjoint.value_namespace = name_space
                                        self.srlg_disjoint.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_name.is_set or
                                    self.route_path_id.is_set or
                                    self.route_path_next_hop.is_set or
                                    (self.route_backup_path is not None and self.route_backup_path.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.route_path_id.yfilter != YFilter.not_set or
                                    self.route_path_next_hop.yfilter != YFilter.not_set or
                                    (self.route_backup_path is not None and self.route_backup_path.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "route-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.route_path_id.is_set or self.route_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_path_id.get_name_leafdata())
                                if (self.route_path_next_hop.is_set or self.route_path_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_path_next_hop.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "route-backup-path"):
                                    if (self.route_backup_path is None):
                                        self.route_backup_path = Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath.RouteBackupPath()
                                        self.route_backup_path.parent = self
                                        self._children_name_map["route_backup_path"] = "route-backup-path"
                                    return self.route_backup_path

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "route-backup-path" or name == "interface-name" or name == "route-path-id" or name == "route-path-next-hop"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-path-id"):
                                    self.route_path_id = value
                                    self.route_path_id.value_namespace = name_space
                                    self.route_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-path-next-hop"):
                                    self.route_path_next_hop = value
                                    self.route_path_next_hop.value_namespace = name_space
                                    self.route_path_next_hop.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.route_path:
                                if (c.has_data()):
                                    return True
                            return (
                                self.prefix.is_set or
                                self.prefix_length.is_set or
                                (self.route_topology is not None and self.route_topology.has_data()))

                        def has_operation(self):
                            for c in self.route_path:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set or
                                (self.route_topology is not None and self.route_topology.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "connected-route" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "route-path"):
                                for c in self.route_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RoutePath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.route_path.append(c)
                                return c

                            if (child_yang_name == "route-topology"):
                                if (self.route_topology is None):
                                    self.route_topology = Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute.RouteTopology()
                                    self.route_topology.parent = self
                                    self._children_name_map["route_topology"] = "route-topology"
                                return self.route_topology

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "route-path" or name == "route-topology" or name == "prefix" or name == "prefix-length"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.connected_route:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.connected_route:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "connected-routes" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "connected-route"):
                            for c in self.connected_route:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes.ConnectedRoute()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.connected_route.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "connected-route"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class VrfStatistics(Entity):
                    """
                    Container for Statistics
                    
                    .. attribute:: prefix_priority_stats
                    
                    	OSPF Prefix SPF Prioritization statistics
                    	**type**\:   :py:class:`PrefixPriorityStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.PrefixPriorityStats>`
                    
                    .. attribute:: protocol_stats
                    
                    	Protocol table
                    	**type**\:   :py:class:`ProtocolStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats>`
                    
                    .. attribute:: rawio_stats
                    
                    	OSPF Prefix SPF Prioritization statistics
                    	**type**\:   :py:class:`RawioStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.RawioStats>`
                    
                    .. attribute:: spf_stats
                    
                    	OSPFv3 RIB batch statistics
                    	**type**\:   :py:class:`SpfStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats>`
                    
                    .. attribute:: vrf_rib_batch_stats
                    
                    	OSPFv3 RIB batch statistics
                    	**type**\:   :py:class:`VrfRibBatchStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.VrfRibBatchStats>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics, self).__init__()

                        self.yang_name = "vrf-statistics"
                        self.yang_parent_name = "default-vrf"

                        self.prefix_priority_stats = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.PrefixPriorityStats()
                        self.prefix_priority_stats.parent = self
                        self._children_name_map["prefix_priority_stats"] = "prefix-priority-stats"
                        self._children_yang_names.add("prefix-priority-stats")

                        self.protocol_stats = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats()
                        self.protocol_stats.parent = self
                        self._children_name_map["protocol_stats"] = "protocol-stats"
                        self._children_yang_names.add("protocol-stats")

                        self.rawio_stats = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.RawioStats()
                        self.rawio_stats.parent = self
                        self._children_name_map["rawio_stats"] = "rawio-stats"
                        self._children_yang_names.add("rawio-stats")

                        self.spf_stats = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats()
                        self.spf_stats.parent = self
                        self._children_name_map["spf_stats"] = "spf-stats"
                        self._children_yang_names.add("spf-stats")

                        self.vrf_rib_batch_stats = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.VrfRibBatchStats()
                        self.vrf_rib_batch_stats.parent = self
                        self._children_name_map["vrf_rib_batch_stats"] = "vrf-rib-batch-stats"
                        self._children_yang_names.add("vrf-rib-batch-stats")


                    class ProtocolStats(Entity):
                        """
                        Protocol table
                        
                        .. attribute:: protocol_stat
                        
                        	Protocol statistics for an interface
                        	**type**\: list of    :py:class:`ProtocolStat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats.ProtocolStat>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats, self).__init__()

                            self.yang_name = "protocol-stats"
                            self.yang_parent_name = "vrf-statistics"

                            self.protocol_stat = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats, self).__setattr__(name, value)


                        class ProtocolStat(Entity):
                            """
                            Protocol statistics for an interface
                            
                            .. attribute:: interface_name  <key>
                            
                            	Interface name
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: checksum_err
                            
                            	Checksum Errors
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: dbdes_in_ls_as
                            
                            	Database Description LSAs in
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: dbdes_in_packets
                            
                            	Database Description Packets in
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: dbdes_out_ls_as
                            
                            	Database Description LSAs out
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: dbdes_out_packets
                            
                            	Database Description Packets out
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: dropped_in_gs
                            
                            	Dropped in GS
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: hello_in_packets
                            
                            	Hello packets in
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: hello_out_packets
                            
                            	Hello Out Packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_ack_in_ls_as
                            
                            	LS Ack LSAs in
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_ack_in_packets
                            
                            	LS Acks Packets in
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_ack_out_ls_as
                            
                            	LS Ack LSAs out
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_ack_out_packets
                            
                            	LS Ack Packets out
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_req_in_ls_as
                            
                            	LS Requests in
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_req_in_packets
                            
                            	LSA Requests in
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_req_out_ls_as
                            
                            	LS Reuqests LSAs out
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_req_out_packets
                            
                            	LS Request Packets out
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_upd_in_ignored
                            
                            	LS Updates ignored
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_upd_in_ls_as
                            
                            	LS Updates LSAs in
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_upd_in_packets
                            
                            	LS Updates Packets in
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_upd_out_ls_as
                            
                            	LS Update LSAs out
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: ls_upd_out_packets
                            
                            	LS Update Packets out
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: total_in_packets
                            
                            	Total inputs packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: total_out_packets
                            
                            	Total Out Packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats.ProtocolStat, self).__init__()

                                self.yang_name = "protocol-stat"
                                self.yang_parent_name = "protocol-stats"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.checksum_err = YLeaf(YType.uint64, "checksum-err")

                                self.dbdes_in_ls_as = YLeaf(YType.uint64, "dbdes-in-ls-as")

                                self.dbdes_in_packets = YLeaf(YType.uint64, "dbdes-in-packets")

                                self.dbdes_out_ls_as = YLeaf(YType.uint64, "dbdes-out-ls-as")

                                self.dbdes_out_packets = YLeaf(YType.uint64, "dbdes-out-packets")

                                self.dropped_in_gs = YLeaf(YType.uint64, "dropped-in-gs")

                                self.hello_in_packets = YLeaf(YType.uint64, "hello-in-packets")

                                self.hello_out_packets = YLeaf(YType.uint64, "hello-out-packets")

                                self.ls_ack_in_ls_as = YLeaf(YType.uint64, "ls-ack-in-ls-as")

                                self.ls_ack_in_packets = YLeaf(YType.uint64, "ls-ack-in-packets")

                                self.ls_ack_out_ls_as = YLeaf(YType.uint64, "ls-ack-out-ls-as")

                                self.ls_ack_out_packets = YLeaf(YType.uint64, "ls-ack-out-packets")

                                self.ls_req_in_ls_as = YLeaf(YType.uint64, "ls-req-in-ls-as")

                                self.ls_req_in_packets = YLeaf(YType.uint64, "ls-req-in-packets")

                                self.ls_req_out_ls_as = YLeaf(YType.uint64, "ls-req-out-ls-as")

                                self.ls_req_out_packets = YLeaf(YType.uint64, "ls-req-out-packets")

                                self.ls_upd_in_ignored = YLeaf(YType.uint64, "ls-upd-in-ignored")

                                self.ls_upd_in_ls_as = YLeaf(YType.uint64, "ls-upd-in-ls-as")

                                self.ls_upd_in_packets = YLeaf(YType.uint64, "ls-upd-in-packets")

                                self.ls_upd_out_ls_as = YLeaf(YType.uint64, "ls-upd-out-ls-as")

                                self.ls_upd_out_packets = YLeaf(YType.uint64, "ls-upd-out-packets")

                                self.total_in_packets = YLeaf(YType.uint64, "total-in-packets")

                                self.total_out_packets = YLeaf(YType.uint64, "total-out-packets")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name",
                                                "checksum_err",
                                                "dbdes_in_ls_as",
                                                "dbdes_in_packets",
                                                "dbdes_out_ls_as",
                                                "dbdes_out_packets",
                                                "dropped_in_gs",
                                                "hello_in_packets",
                                                "hello_out_packets",
                                                "ls_ack_in_ls_as",
                                                "ls_ack_in_packets",
                                                "ls_ack_out_ls_as",
                                                "ls_ack_out_packets",
                                                "ls_req_in_ls_as",
                                                "ls_req_in_packets",
                                                "ls_req_out_ls_as",
                                                "ls_req_out_packets",
                                                "ls_upd_in_ignored",
                                                "ls_upd_in_ls_as",
                                                "ls_upd_in_packets",
                                                "ls_upd_out_ls_as",
                                                "ls_upd_out_packets",
                                                "total_in_packets",
                                                "total_out_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats.ProtocolStat, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats.ProtocolStat, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.interface_name.is_set or
                                    self.checksum_err.is_set or
                                    self.dbdes_in_ls_as.is_set or
                                    self.dbdes_in_packets.is_set or
                                    self.dbdes_out_ls_as.is_set or
                                    self.dbdes_out_packets.is_set or
                                    self.dropped_in_gs.is_set or
                                    self.hello_in_packets.is_set or
                                    self.hello_out_packets.is_set or
                                    self.ls_ack_in_ls_as.is_set or
                                    self.ls_ack_in_packets.is_set or
                                    self.ls_ack_out_ls_as.is_set or
                                    self.ls_ack_out_packets.is_set or
                                    self.ls_req_in_ls_as.is_set or
                                    self.ls_req_in_packets.is_set or
                                    self.ls_req_out_ls_as.is_set or
                                    self.ls_req_out_packets.is_set or
                                    self.ls_upd_in_ignored.is_set or
                                    self.ls_upd_in_ls_as.is_set or
                                    self.ls_upd_in_packets.is_set or
                                    self.ls_upd_out_ls_as.is_set or
                                    self.ls_upd_out_packets.is_set or
                                    self.total_in_packets.is_set or
                                    self.total_out_packets.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    self.checksum_err.yfilter != YFilter.not_set or
                                    self.dbdes_in_ls_as.yfilter != YFilter.not_set or
                                    self.dbdes_in_packets.yfilter != YFilter.not_set or
                                    self.dbdes_out_ls_as.yfilter != YFilter.not_set or
                                    self.dbdes_out_packets.yfilter != YFilter.not_set or
                                    self.dropped_in_gs.yfilter != YFilter.not_set or
                                    self.hello_in_packets.yfilter != YFilter.not_set or
                                    self.hello_out_packets.yfilter != YFilter.not_set or
                                    self.ls_ack_in_ls_as.yfilter != YFilter.not_set or
                                    self.ls_ack_in_packets.yfilter != YFilter.not_set or
                                    self.ls_ack_out_ls_as.yfilter != YFilter.not_set or
                                    self.ls_ack_out_packets.yfilter != YFilter.not_set or
                                    self.ls_req_in_ls_as.yfilter != YFilter.not_set or
                                    self.ls_req_in_packets.yfilter != YFilter.not_set or
                                    self.ls_req_out_ls_as.yfilter != YFilter.not_set or
                                    self.ls_req_out_packets.yfilter != YFilter.not_set or
                                    self.ls_upd_in_ignored.yfilter != YFilter.not_set or
                                    self.ls_upd_in_ls_as.yfilter != YFilter.not_set or
                                    self.ls_upd_in_packets.yfilter != YFilter.not_set or
                                    self.ls_upd_out_ls_as.yfilter != YFilter.not_set or
                                    self.ls_upd_out_packets.yfilter != YFilter.not_set or
                                    self.total_in_packets.yfilter != YFilter.not_set or
                                    self.total_out_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protocol-stat" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                if (self.checksum_err.is_set or self.checksum_err.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.checksum_err.get_name_leafdata())
                                if (self.dbdes_in_ls_as.is_set or self.dbdes_in_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dbdes_in_ls_as.get_name_leafdata())
                                if (self.dbdes_in_packets.is_set or self.dbdes_in_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dbdes_in_packets.get_name_leafdata())
                                if (self.dbdes_out_ls_as.is_set or self.dbdes_out_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dbdes_out_ls_as.get_name_leafdata())
                                if (self.dbdes_out_packets.is_set or self.dbdes_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dbdes_out_packets.get_name_leafdata())
                                if (self.dropped_in_gs.is_set or self.dropped_in_gs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dropped_in_gs.get_name_leafdata())
                                if (self.hello_in_packets.is_set or self.hello_in_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hello_in_packets.get_name_leafdata())
                                if (self.hello_out_packets.is_set or self.hello_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hello_out_packets.get_name_leafdata())
                                if (self.ls_ack_in_ls_as.is_set or self.ls_ack_in_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_ack_in_ls_as.get_name_leafdata())
                                if (self.ls_ack_in_packets.is_set or self.ls_ack_in_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_ack_in_packets.get_name_leafdata())
                                if (self.ls_ack_out_ls_as.is_set or self.ls_ack_out_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_ack_out_ls_as.get_name_leafdata())
                                if (self.ls_ack_out_packets.is_set or self.ls_ack_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_ack_out_packets.get_name_leafdata())
                                if (self.ls_req_in_ls_as.is_set or self.ls_req_in_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_req_in_ls_as.get_name_leafdata())
                                if (self.ls_req_in_packets.is_set or self.ls_req_in_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_req_in_packets.get_name_leafdata())
                                if (self.ls_req_out_ls_as.is_set or self.ls_req_out_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_req_out_ls_as.get_name_leafdata())
                                if (self.ls_req_out_packets.is_set or self.ls_req_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_req_out_packets.get_name_leafdata())
                                if (self.ls_upd_in_ignored.is_set or self.ls_upd_in_ignored.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_upd_in_ignored.get_name_leafdata())
                                if (self.ls_upd_in_ls_as.is_set or self.ls_upd_in_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_upd_in_ls_as.get_name_leafdata())
                                if (self.ls_upd_in_packets.is_set or self.ls_upd_in_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_upd_in_packets.get_name_leafdata())
                                if (self.ls_upd_out_ls_as.is_set or self.ls_upd_out_ls_as.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_upd_out_ls_as.get_name_leafdata())
                                if (self.ls_upd_out_packets.is_set or self.ls_upd_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ls_upd_out_packets.get_name_leafdata())
                                if (self.total_in_packets.is_set or self.total_in_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_in_packets.get_name_leafdata())
                                if (self.total_out_packets.is_set or self.total_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_out_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "interface-name" or name == "checksum-err" or name == "dbdes-in-ls-as" or name == "dbdes-in-packets" or name == "dbdes-out-ls-as" or name == "dbdes-out-packets" or name == "dropped-in-gs" or name == "hello-in-packets" or name == "hello-out-packets" or name == "ls-ack-in-ls-as" or name == "ls-ack-in-packets" or name == "ls-ack-out-ls-as" or name == "ls-ack-out-packets" or name == "ls-req-in-ls-as" or name == "ls-req-in-packets" or name == "ls-req-out-ls-as" or name == "ls-req-out-packets" or name == "ls-upd-in-ignored" or name == "ls-upd-in-ls-as" or name == "ls-upd-in-packets" or name == "ls-upd-out-ls-as" or name == "ls-upd-out-packets" or name == "total-in-packets" or name == "total-out-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "checksum-err"):
                                    self.checksum_err = value
                                    self.checksum_err.value_namespace = name_space
                                    self.checksum_err.value_namespace_prefix = name_space_prefix
                                if(value_path == "dbdes-in-ls-as"):
                                    self.dbdes_in_ls_as = value
                                    self.dbdes_in_ls_as.value_namespace = name_space
                                    self.dbdes_in_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "dbdes-in-packets"):
                                    self.dbdes_in_packets = value
                                    self.dbdes_in_packets.value_namespace = name_space
                                    self.dbdes_in_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "dbdes-out-ls-as"):
                                    self.dbdes_out_ls_as = value
                                    self.dbdes_out_ls_as.value_namespace = name_space
                                    self.dbdes_out_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "dbdes-out-packets"):
                                    self.dbdes_out_packets = value
                                    self.dbdes_out_packets.value_namespace = name_space
                                    self.dbdes_out_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "dropped-in-gs"):
                                    self.dropped_in_gs = value
                                    self.dropped_in_gs.value_namespace = name_space
                                    self.dropped_in_gs.value_namespace_prefix = name_space_prefix
                                if(value_path == "hello-in-packets"):
                                    self.hello_in_packets = value
                                    self.hello_in_packets.value_namespace = name_space
                                    self.hello_in_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "hello-out-packets"):
                                    self.hello_out_packets = value
                                    self.hello_out_packets.value_namespace = name_space
                                    self.hello_out_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-ack-in-ls-as"):
                                    self.ls_ack_in_ls_as = value
                                    self.ls_ack_in_ls_as.value_namespace = name_space
                                    self.ls_ack_in_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-ack-in-packets"):
                                    self.ls_ack_in_packets = value
                                    self.ls_ack_in_packets.value_namespace = name_space
                                    self.ls_ack_in_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-ack-out-ls-as"):
                                    self.ls_ack_out_ls_as = value
                                    self.ls_ack_out_ls_as.value_namespace = name_space
                                    self.ls_ack_out_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-ack-out-packets"):
                                    self.ls_ack_out_packets = value
                                    self.ls_ack_out_packets.value_namespace = name_space
                                    self.ls_ack_out_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-req-in-ls-as"):
                                    self.ls_req_in_ls_as = value
                                    self.ls_req_in_ls_as.value_namespace = name_space
                                    self.ls_req_in_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-req-in-packets"):
                                    self.ls_req_in_packets = value
                                    self.ls_req_in_packets.value_namespace = name_space
                                    self.ls_req_in_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-req-out-ls-as"):
                                    self.ls_req_out_ls_as = value
                                    self.ls_req_out_ls_as.value_namespace = name_space
                                    self.ls_req_out_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-req-out-packets"):
                                    self.ls_req_out_packets = value
                                    self.ls_req_out_packets.value_namespace = name_space
                                    self.ls_req_out_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-upd-in-ignored"):
                                    self.ls_upd_in_ignored = value
                                    self.ls_upd_in_ignored.value_namespace = name_space
                                    self.ls_upd_in_ignored.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-upd-in-ls-as"):
                                    self.ls_upd_in_ls_as = value
                                    self.ls_upd_in_ls_as.value_namespace = name_space
                                    self.ls_upd_in_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-upd-in-packets"):
                                    self.ls_upd_in_packets = value
                                    self.ls_upd_in_packets.value_namespace = name_space
                                    self.ls_upd_in_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-upd-out-ls-as"):
                                    self.ls_upd_out_ls_as = value
                                    self.ls_upd_out_ls_as.value_namespace = name_space
                                    self.ls_upd_out_ls_as.value_namespace_prefix = name_space_prefix
                                if(value_path == "ls-upd-out-packets"):
                                    self.ls_upd_out_packets = value
                                    self.ls_upd_out_packets.value_namespace = name_space
                                    self.ls_upd_out_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-in-packets"):
                                    self.total_in_packets = value
                                    self.total_in_packets.value_namespace = name_space
                                    self.total_in_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-out-packets"):
                                    self.total_out_packets = value
                                    self.total_out_packets.value_namespace = name_space
                                    self.total_out_packets.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.protocol_stat:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.protocol_stat:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protocol-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protocol-stat"):
                                for c in self.protocol_stat:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats.ProtocolStat()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.protocol_stat.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protocol-stat"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class SpfStats(Entity):
                        """
                        OSPFv3 RIB batch statistics
                        
                        .. attribute:: spf_header
                        
                        	SPF statistics header
                        	**type**\:   :py:class:`SpfHeader <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader>`
                        
                        .. attribute:: spf_runtime
                        
                        	List of SPF run\-time statistics
                        	**type**\: list of    :py:class:`SpfRuntime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats, self).__init__()

                            self.yang_name = "spf-stats"
                            self.yang_parent_name = "vrf-statistics"

                            self.spf_header = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader()
                            self.spf_header.parent = self
                            self._children_name_map["spf_header"] = "spf-header"
                            self._children_yang_names.add("spf-header")

                            self.spf_runtime = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats, self).__setattr__(name, value)


                        class SpfHeader(Entity):
                            """
                            SPF statistics header
                            
                            .. attribute:: area_summary
                            
                            	List of Areas with SPF statistics
                            	**type**\: list of    :py:class:`AreaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader.AreaSummary>`
                            
                            .. attribute:: header_router_id
                            
                            	Router ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_sp_fs
                            
                            	Number of SPF calculations
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader, self).__init__()

                                self.yang_name = "spf-header"
                                self.yang_parent_name = "spf-stats"

                                self.header_router_id = YLeaf(YType.str, "header-router-id")

                                self.header_sp_fs = YLeaf(YType.uint32, "header-sp-fs")

                                self.area_summary = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("header_router_id",
                                                "header_sp_fs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader, self).__setattr__(name, value)


                            class AreaSummary(Entity):
                                """
                                List of Areas with SPF statistics
                                
                                .. attribute:: area_id
                                
                                	Area ID of the area SPF statistics
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: sp_fs
                                
                                	Number of SPF calculations
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader.AreaSummary, self).__init__()

                                    self.yang_name = "area-summary"
                                    self.yang_parent_name = "spf-header"

                                    self.area_id = YLeaf(YType.uint32, "area-id")

                                    self.sp_fs = YLeaf(YType.uint32, "sp-fs")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("area_id",
                                                    "sp_fs") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader.AreaSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader.AreaSummary, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.area_id.is_set or
                                        self.sp_fs.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.area_id.yfilter != YFilter.not_set or
                                        self.sp_fs.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "area-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_id.get_name_leafdata())
                                    if (self.sp_fs.is_set or self.sp_fs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_fs.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "area-id" or name == "sp-fs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "area-id"):
                                        self.area_id = value
                                        self.area_id.value_namespace = name_space
                                        self.area_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-fs"):
                                        self.sp_fs = value
                                        self.sp_fs.value_namespace = name_space
                                        self.sp_fs.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.area_summary:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.header_router_id.is_set or
                                    self.header_sp_fs.is_set)

                            def has_operation(self):
                                for c in self.area_summary:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.header_router_id.yfilter != YFilter.not_set or
                                    self.header_sp_fs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "spf-header" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.header_router_id.is_set or self.header_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_router_id.get_name_leafdata())
                                if (self.header_sp_fs.is_set or self.header_sp_fs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_sp_fs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "area-summary"):
                                    for c in self.area_summary:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader.AreaSummary()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.area_summary.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "area-summary" or name == "header-router-id" or name == "header-sp-fs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "header-router-id"):
                                    self.header_router_id = value
                                    self.header_router_id.value_namespace = name_space
                                    self.header_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-sp-fs"):
                                    self.header_sp_fs = value
                                    self.header_sp_fs.value_namespace = name_space
                                    self.header_sp_fs.value_namespace_prefix = name_space_prefix


                        class SpfRuntime(Entity):
                            """
                            List of SPF run\-time statistics
                            
                            .. attribute:: area_stat
                            
                            	List of per\-area SPF statistics
                            	**type**\: list of    :py:class:`AreaStat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat>`
                            
                            .. attribute:: global_time
                            
                            	Global SPF times
                            	**type**\:   :py:class:`GlobalTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime>`
                            
                            .. attribute:: lsa
                            
                            	List of LSAs triggering the SPF calculation
                            	**type**\: list of    :py:class:`Lsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.Lsa>`
                            
                            .. attribute:: lsa_changes
                            
                            	Number of LSA changes triggering an SPF calculation
                            	**type**\:  int
                            
                            	**range:** \-32768..32767
                            
                            .. attribute:: reason_flags
                            
                            	Reasons for triggering an SPF calculation Bit 1 \- Router LSA update Bit 2 \- Network LSA update Bit 3 \- Inter\-Area Prefix LSA update Bit 4 \- Inter\-Area Router LSA update Bit 5 \- AS External LSA update Bit 6 \- MOSPF LSA update Bit 7 \- Type 7 AS External LSA update Bit 8 \- Link LSA update Bit 9 \- Prefix LSA update
                            	**type**\:  str
                            
                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                            
                            .. attribute:: rib_add_routes
                            
                            	Number of routes added to RIB
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rib_delete_routes
                            
                            	Number of routes deleted from RIB
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: start_time
                            
                            	SPF calculation start time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime, self).__init__()

                                self.yang_name = "spf-runtime"
                                self.yang_parent_name = "spf-stats"

                                self.lsa_changes = YLeaf(YType.int16, "lsa-changes")

                                self.reason_flags = YLeaf(YType.str, "reason-flags")

                                self.rib_add_routes = YLeaf(YType.uint32, "rib-add-routes")

                                self.rib_delete_routes = YLeaf(YType.uint32, "rib-delete-routes")

                                self.start_time = YLeaf(YType.uint32, "start-time")

                                self.global_time = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime()
                                self.global_time.parent = self
                                self._children_name_map["global_time"] = "global-time"
                                self._children_yang_names.add("global-time")

                                self.area_stat = YList(self)
                                self.lsa = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsa_changes",
                                                "reason_flags",
                                                "rib_add_routes",
                                                "rib_delete_routes",
                                                "start_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime, self).__setattr__(name, value)


                            class GlobalTime(Entity):
                                """
                                Global SPF times
                                
                                .. attribute:: dijkstra
                                
                                	Dijkstra time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: external_prefix
                                
                                	External prefix processing time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: external_prefix_del
                                
                                	External prefix deletion time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: inter_prefix
                                
                                	Inter\-prefix processing time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: inter_prefix_del
                                
                                	Intra\-prefix deletion time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intra_prefix
                                
                                	Intra\-prefix processing time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intra_prefix_del
                                
                                	Intra\-prefix deletion time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rib_add
                                
                                	RIB add processing time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rib_del
                                
                                	RIB deletion time in msec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime, self).__init__()

                                    self.yang_name = "global-time"
                                    self.yang_parent_name = "spf-runtime"

                                    self.dijkstra = YLeaf(YType.uint32, "dijkstra")

                                    self.external_prefix = YLeaf(YType.uint32, "external-prefix")

                                    self.external_prefix_del = YLeaf(YType.uint32, "external-prefix-del")

                                    self.inter_prefix = YLeaf(YType.uint32, "inter-prefix")

                                    self.inter_prefix_del = YLeaf(YType.uint32, "inter-prefix-del")

                                    self.intra_prefix = YLeaf(YType.uint32, "intra-prefix")

                                    self.intra_prefix_del = YLeaf(YType.uint32, "intra-prefix-del")

                                    self.rib_add = YLeaf(YType.uint32, "rib-add")

                                    self.rib_del = YLeaf(YType.uint32, "rib-del")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dijkstra",
                                                    "external_prefix",
                                                    "external_prefix_del",
                                                    "inter_prefix",
                                                    "inter_prefix_del",
                                                    "intra_prefix",
                                                    "intra_prefix_del",
                                                    "rib_add",
                                                    "rib_del") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.dijkstra.is_set or
                                        self.external_prefix.is_set or
                                        self.external_prefix_del.is_set or
                                        self.inter_prefix.is_set or
                                        self.inter_prefix_del.is_set or
                                        self.intra_prefix.is_set or
                                        self.intra_prefix_del.is_set or
                                        self.rib_add.is_set or
                                        self.rib_del.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dijkstra.yfilter != YFilter.not_set or
                                        self.external_prefix.yfilter != YFilter.not_set or
                                        self.external_prefix_del.yfilter != YFilter.not_set or
                                        self.inter_prefix.yfilter != YFilter.not_set or
                                        self.inter_prefix_del.yfilter != YFilter.not_set or
                                        self.intra_prefix.yfilter != YFilter.not_set or
                                        self.intra_prefix_del.yfilter != YFilter.not_set or
                                        self.rib_add.yfilter != YFilter.not_set or
                                        self.rib_del.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "global-time" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dijkstra.is_set or self.dijkstra.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dijkstra.get_name_leafdata())
                                    if (self.external_prefix.is_set or self.external_prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.external_prefix.get_name_leafdata())
                                    if (self.external_prefix_del.is_set or self.external_prefix_del.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.external_prefix_del.get_name_leafdata())
                                    if (self.inter_prefix.is_set or self.inter_prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.inter_prefix.get_name_leafdata())
                                    if (self.inter_prefix_del.is_set or self.inter_prefix_del.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.inter_prefix_del.get_name_leafdata())
                                    if (self.intra_prefix.is_set or self.intra_prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intra_prefix.get_name_leafdata())
                                    if (self.intra_prefix_del.is_set or self.intra_prefix_del.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intra_prefix_del.get_name_leafdata())
                                    if (self.rib_add.is_set or self.rib_add.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rib_add.get_name_leafdata())
                                    if (self.rib_del.is_set or self.rib_del.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rib_del.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dijkstra" or name == "external-prefix" or name == "external-prefix-del" or name == "inter-prefix" or name == "inter-prefix-del" or name == "intra-prefix" or name == "intra-prefix-del" or name == "rib-add" or name == "rib-del"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dijkstra"):
                                        self.dijkstra = value
                                        self.dijkstra.value_namespace = name_space
                                        self.dijkstra.value_namespace_prefix = name_space_prefix
                                    if(value_path == "external-prefix"):
                                        self.external_prefix = value
                                        self.external_prefix.value_namespace = name_space
                                        self.external_prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "external-prefix-del"):
                                        self.external_prefix_del = value
                                        self.external_prefix_del.value_namespace = name_space
                                        self.external_prefix_del.value_namespace_prefix = name_space_prefix
                                    if(value_path == "inter-prefix"):
                                        self.inter_prefix = value
                                        self.inter_prefix.value_namespace = name_space
                                        self.inter_prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "inter-prefix-del"):
                                        self.inter_prefix_del = value
                                        self.inter_prefix_del.value_namespace = name_space
                                        self.inter_prefix_del.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intra-prefix"):
                                        self.intra_prefix = value
                                        self.intra_prefix.value_namespace = name_space
                                        self.intra_prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intra-prefix-del"):
                                        self.intra_prefix_del = value
                                        self.intra_prefix_del.value_namespace = name_space
                                        self.intra_prefix_del.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rib-add"):
                                        self.rib_add = value
                                        self.rib_add.value_namespace = name_space
                                        self.rib_add.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rib-del"):
                                        self.rib_del = value
                                        self.rib_del.value_namespace = name_space
                                        self.rib_del.value_namespace_prefix = name_space_prefix


                            class Lsa(Entity):
                                """
                                List of LSAs triggering the SPF calculation
                                
                                .. attribute:: lsa_advertising_router
                                
                                	Advertising router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: lsa_area_id
                                
                                	Area ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsa_flush
                                
                                	If true, the LSA change is a flush
                                	**type**\:  bool
                                
                                .. attribute:: lsa_id
                                
                                	LSA ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: lsa_type
                                
                                	LSA type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.Lsa, self).__init__()

                                    self.yang_name = "lsa"
                                    self.yang_parent_name = "spf-runtime"

                                    self.lsa_advertising_router = YLeaf(YType.str, "lsa-advertising-router")

                                    self.lsa_area_id = YLeaf(YType.uint32, "lsa-area-id")

                                    self.lsa_flush = YLeaf(YType.boolean, "lsa-flush")

                                    self.lsa_id = YLeaf(YType.str, "lsa-id")

                                    self.lsa_type = YLeaf(YType.uint8, "lsa-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("lsa_advertising_router",
                                                    "lsa_area_id",
                                                    "lsa_flush",
                                                    "lsa_id",
                                                    "lsa_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.Lsa, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.Lsa, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.lsa_advertising_router.is_set or
                                        self.lsa_area_id.is_set or
                                        self.lsa_flush.is_set or
                                        self.lsa_id.is_set or
                                        self.lsa_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.lsa_advertising_router.yfilter != YFilter.not_set or
                                        self.lsa_area_id.yfilter != YFilter.not_set or
                                        self.lsa_flush.yfilter != YFilter.not_set or
                                        self.lsa_id.yfilter != YFilter.not_set or
                                        self.lsa_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsa" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.lsa_advertising_router.is_set or self.lsa_advertising_router.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_advertising_router.get_name_leafdata())
                                    if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_area_id.get_name_leafdata())
                                    if (self.lsa_flush.is_set or self.lsa_flush.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_flush.get_name_leafdata())
                                    if (self.lsa_id.is_set or self.lsa_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_id.get_name_leafdata())
                                    if (self.lsa_type.is_set or self.lsa_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "lsa-advertising-router" or name == "lsa-area-id" or name == "lsa-flush" or name == "lsa-id" or name == "lsa-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "lsa-advertising-router"):
                                        self.lsa_advertising_router = value
                                        self.lsa_advertising_router.value_namespace = name_space
                                        self.lsa_advertising_router.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsa-area-id"):
                                        self.lsa_area_id = value
                                        self.lsa_area_id.value_namespace = name_space
                                        self.lsa_area_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsa-flush"):
                                        self.lsa_flush = value
                                        self.lsa_flush.value_namespace = name_space
                                        self.lsa_flush.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsa-id"):
                                        self.lsa_id = value
                                        self.lsa_id.value_namespace = name_space
                                        self.lsa_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsa-type"):
                                        self.lsa_type = value
                                        self.lsa_type.value_namespace = name_space
                                        self.lsa_type.value_namespace_prefix = name_space_prefix


                            class AreaStat(Entity):
                                """
                                List of per\-area SPF statistics
                                
                                .. attribute:: spf_stat_area_id
                                
                                	Area ID for area of these SPF statistics
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: spf_stat_lsa_type_count
                                
                                	Counts of LSA types triggering an SPF calculation
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: spf_stat_time
                                
                                	SPF time calculations
                                	**type**\:   :py:class:`SpfStatTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime>`
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat, self).__init__()

                                    self.yang_name = "area-stat"
                                    self.yang_parent_name = "spf-runtime"

                                    self.spf_stat_area_id = YLeaf(YType.uint32, "spf-stat-area-id")

                                    self.spf_stat_lsa_type_count = YLeafList(YType.uint32, "spf-stat-lsa-type-count")

                                    self.spf_stat_time = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime()
                                    self.spf_stat_time.parent = self
                                    self._children_name_map["spf_stat_time"] = "spf-stat-time"
                                    self._children_yang_names.add("spf-stat-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("spf_stat_area_id",
                                                    "spf_stat_lsa_type_count") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat, self).__setattr__(name, value)


                                class SpfStatTime(Entity):
                                    """
                                    SPF time calculations
                                    
                                    .. attribute:: dijkstra
                                    
                                    	Dijkstra time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: external_prefix
                                    
                                    	External prefix processing time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: external_prefix_del
                                    
                                    	External prefix deletion time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: inter_prefix
                                    
                                    	Inter\-prefix processing time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: inter_prefix_del
                                    
                                    	Intra\-prefix deletion time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intra_prefix
                                    
                                    	Intra\-prefix processing time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intra_prefix_del
                                    
                                    	Intra\-prefix deletion time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rib_add
                                    
                                    	RIB add processing time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rib_del
                                    
                                    	RIB deletion time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime, self).__init__()

                                        self.yang_name = "spf-stat-time"
                                        self.yang_parent_name = "area-stat"

                                        self.dijkstra = YLeaf(YType.uint32, "dijkstra")

                                        self.external_prefix = YLeaf(YType.uint32, "external-prefix")

                                        self.external_prefix_del = YLeaf(YType.uint32, "external-prefix-del")

                                        self.inter_prefix = YLeaf(YType.uint32, "inter-prefix")

                                        self.inter_prefix_del = YLeaf(YType.uint32, "inter-prefix-del")

                                        self.intra_prefix = YLeaf(YType.uint32, "intra-prefix")

                                        self.intra_prefix_del = YLeaf(YType.uint32, "intra-prefix-del")

                                        self.rib_add = YLeaf(YType.uint32, "rib-add")

                                        self.rib_del = YLeaf(YType.uint32, "rib-del")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("dijkstra",
                                                        "external_prefix",
                                                        "external_prefix_del",
                                                        "inter_prefix",
                                                        "inter_prefix_del",
                                                        "intra_prefix",
                                                        "intra_prefix_del",
                                                        "rib_add",
                                                        "rib_del") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.dijkstra.is_set or
                                            self.external_prefix.is_set or
                                            self.external_prefix_del.is_set or
                                            self.inter_prefix.is_set or
                                            self.inter_prefix_del.is_set or
                                            self.intra_prefix.is_set or
                                            self.intra_prefix_del.is_set or
                                            self.rib_add.is_set or
                                            self.rib_del.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.dijkstra.yfilter != YFilter.not_set or
                                            self.external_prefix.yfilter != YFilter.not_set or
                                            self.external_prefix_del.yfilter != YFilter.not_set or
                                            self.inter_prefix.yfilter != YFilter.not_set or
                                            self.inter_prefix_del.yfilter != YFilter.not_set or
                                            self.intra_prefix.yfilter != YFilter.not_set or
                                            self.intra_prefix_del.yfilter != YFilter.not_set or
                                            self.rib_add.yfilter != YFilter.not_set or
                                            self.rib_del.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "spf-stat-time" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.dijkstra.is_set or self.dijkstra.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dijkstra.get_name_leafdata())
                                        if (self.external_prefix.is_set or self.external_prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.external_prefix.get_name_leafdata())
                                        if (self.external_prefix_del.is_set or self.external_prefix_del.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.external_prefix_del.get_name_leafdata())
                                        if (self.inter_prefix.is_set or self.inter_prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.inter_prefix.get_name_leafdata())
                                        if (self.inter_prefix_del.is_set or self.inter_prefix_del.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.inter_prefix_del.get_name_leafdata())
                                        if (self.intra_prefix.is_set or self.intra_prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intra_prefix.get_name_leafdata())
                                        if (self.intra_prefix_del.is_set or self.intra_prefix_del.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intra_prefix_del.get_name_leafdata())
                                        if (self.rib_add.is_set or self.rib_add.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rib_add.get_name_leafdata())
                                        if (self.rib_del.is_set or self.rib_del.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rib_del.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dijkstra" or name == "external-prefix" or name == "external-prefix-del" or name == "inter-prefix" or name == "inter-prefix-del" or name == "intra-prefix" or name == "intra-prefix-del" or name == "rib-add" or name == "rib-del"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "dijkstra"):
                                            self.dijkstra = value
                                            self.dijkstra.value_namespace = name_space
                                            self.dijkstra.value_namespace_prefix = name_space_prefix
                                        if(value_path == "external-prefix"):
                                            self.external_prefix = value
                                            self.external_prefix.value_namespace = name_space
                                            self.external_prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "external-prefix-del"):
                                            self.external_prefix_del = value
                                            self.external_prefix_del.value_namespace = name_space
                                            self.external_prefix_del.value_namespace_prefix = name_space_prefix
                                        if(value_path == "inter-prefix"):
                                            self.inter_prefix = value
                                            self.inter_prefix.value_namespace = name_space
                                            self.inter_prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "inter-prefix-del"):
                                            self.inter_prefix_del = value
                                            self.inter_prefix_del.value_namespace = name_space
                                            self.inter_prefix_del.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intra-prefix"):
                                            self.intra_prefix = value
                                            self.intra_prefix.value_namespace = name_space
                                            self.intra_prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intra-prefix-del"):
                                            self.intra_prefix_del = value
                                            self.intra_prefix_del.value_namespace = name_space
                                            self.intra_prefix_del.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rib-add"):
                                            self.rib_add = value
                                            self.rib_add.value_namespace = name_space
                                            self.rib_add.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rib-del"):
                                            self.rib_del = value
                                            self.rib_del.value_namespace = name_space
                                            self.rib_del.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for leaf in self.spf_stat_lsa_type_count.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    return (
                                        self.spf_stat_area_id.is_set or
                                        (self.spf_stat_time is not None and self.spf_stat_time.has_data()))

                                def has_operation(self):
                                    for leaf in self.spf_stat_lsa_type_count.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.spf_stat_area_id.yfilter != YFilter.not_set or
                                        self.spf_stat_lsa_type_count.yfilter != YFilter.not_set or
                                        (self.spf_stat_time is not None and self.spf_stat_time.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "area-stat" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.spf_stat_area_id.is_set or self.spf_stat_area_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spf_stat_area_id.get_name_leafdata())

                                    leaf_name_data.extend(self.spf_stat_lsa_type_count.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "spf-stat-time"):
                                        if (self.spf_stat_time is None):
                                            self.spf_stat_time = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat.SpfStatTime()
                                            self.spf_stat_time.parent = self
                                            self._children_name_map["spf_stat_time"] = "spf-stat-time"
                                        return self.spf_stat_time

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "spf-stat-time" or name == "spf-stat-area-id" or name == "spf-stat-lsa-type-count"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "spf-stat-area-id"):
                                        self.spf_stat_area_id = value
                                        self.spf_stat_area_id.value_namespace = name_space
                                        self.spf_stat_area_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spf-stat-lsa-type-count"):
                                        self.spf_stat_lsa_type_count.append(value)

                            def has_data(self):
                                for c in self.area_stat:
                                    if (c.has_data()):
                                        return True
                                for c in self.lsa:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.lsa_changes.is_set or
                                    self.reason_flags.is_set or
                                    self.rib_add_routes.is_set or
                                    self.rib_delete_routes.is_set or
                                    self.start_time.is_set or
                                    (self.global_time is not None and self.global_time.has_data()))

                            def has_operation(self):
                                for c in self.area_stat:
                                    if (c.has_operation()):
                                        return True
                                for c in self.lsa:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsa_changes.yfilter != YFilter.not_set or
                                    self.reason_flags.yfilter != YFilter.not_set or
                                    self.rib_add_routes.yfilter != YFilter.not_set or
                                    self.rib_delete_routes.yfilter != YFilter.not_set or
                                    self.start_time.yfilter != YFilter.not_set or
                                    (self.global_time is not None and self.global_time.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "spf-runtime" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsa_changes.is_set or self.lsa_changes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_changes.get_name_leafdata())
                                if (self.reason_flags.is_set or self.reason_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason_flags.get_name_leafdata())
                                if (self.rib_add_routes.is_set or self.rib_add_routes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rib_add_routes.get_name_leafdata())
                                if (self.rib_delete_routes.is_set or self.rib_delete_routes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rib_delete_routes.get_name_leafdata())
                                if (self.start_time.is_set or self.start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.start_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "area-stat"):
                                    for c in self.area_stat:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.AreaStat()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.area_stat.append(c)
                                    return c

                                if (child_yang_name == "global-time"):
                                    if (self.global_time is None):
                                        self.global_time = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.GlobalTime()
                                        self.global_time.parent = self
                                        self._children_name_map["global_time"] = "global-time"
                                    return self.global_time

                                if (child_yang_name == "lsa"):
                                    for c in self.lsa:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime.Lsa()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.lsa.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "area-stat" or name == "global-time" or name == "lsa" or name == "lsa-changes" or name == "reason-flags" or name == "rib-add-routes" or name == "rib-delete-routes" or name == "start-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsa-changes"):
                                    self.lsa_changes = value
                                    self.lsa_changes.value_namespace = name_space
                                    self.lsa_changes.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason-flags"):
                                    self.reason_flags = value
                                    self.reason_flags.value_namespace = name_space
                                    self.reason_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "rib-add-routes"):
                                    self.rib_add_routes = value
                                    self.rib_add_routes.value_namespace = name_space
                                    self.rib_add_routes.value_namespace_prefix = name_space_prefix
                                if(value_path == "rib-delete-routes"):
                                    self.rib_delete_routes = value
                                    self.rib_delete_routes.value_namespace = name_space
                                    self.rib_delete_routes.value_namespace_prefix = name_space_prefix
                                if(value_path == "start-time"):
                                    self.start_time = value
                                    self.start_time.value_namespace = name_space
                                    self.start_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.spf_runtime:
                                if (c.has_data()):
                                    return True
                            return (self.spf_header is not None and self.spf_header.has_data())

                        def has_operation(self):
                            for c in self.spf_runtime:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.spf_header is not None and self.spf_header.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "spf-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "spf-header"):
                                if (self.spf_header is None):
                                    self.spf_header = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfHeader()
                                    self.spf_header.parent = self
                                    self._children_name_map["spf_header"] = "spf-header"
                                return self.spf_header

                            if (child_yang_name == "spf-runtime"):
                                for c in self.spf_runtime:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats.SpfRuntime()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.spf_runtime.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "spf-header" or name == "spf-runtime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class RawioStats(Entity):
                        """
                        OSPF Prefix SPF Prioritization statistics
                        
                        .. attribute:: in_bytes
                        
                        	Received Bytes
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: byte
                        
                        .. attribute:: in_error_drops
                        
                        	In Error Drops
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: in_handle_drops
                        
                        	In Handle Drops
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: in_ipsec_drops
                        
                        	In IPSEC Drops
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: in_long_packets
                        
                        	Received Long Packets
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: in_malloc_drops
                        
                        	In Malloc Drops
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: in_packets
                        
                        	Received Packets
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: in_queue_drops
                        
                        	In Queue Drops
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: in_short_drops
                        
                        	In Short Drops
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: out_bytes
                        
                        	Sent Bytes
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: byte
                        
                        .. attribute:: out_error_drops
                        
                        	Error Drops
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: out_ipsec_drops
                        
                        	Out IPSEC Drops
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: out_nofd_drops
                        
                        	No FileDescriptor Drops
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: out_nopak_drops
                        
                        	No Packet Buffers
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: out_packets
                        
                        	Packets Sent
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: out_pakapi_errors
                        
                        	PAK API Errors
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: raw_conn_close
                        
                        	Raw Connections Close
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: raw_conn_error
                        
                        	Raw Connections Error
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: raw_conn_open
                        
                        	Raw Connections Open
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: raw_conn_state
                        
                        	Raw Connection State
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.RawioStats, self).__init__()

                            self.yang_name = "rawio-stats"
                            self.yang_parent_name = "vrf-statistics"

                            self.in_bytes = YLeaf(YType.uint64, "in-bytes")

                            self.in_error_drops = YLeaf(YType.uint64, "in-error-drops")

                            self.in_handle_drops = YLeaf(YType.uint64, "in-handle-drops")

                            self.in_ipsec_drops = YLeaf(YType.uint64, "in-ipsec-drops")

                            self.in_long_packets = YLeaf(YType.uint64, "in-long-packets")

                            self.in_malloc_drops = YLeaf(YType.uint64, "in-malloc-drops")

                            self.in_packets = YLeaf(YType.uint64, "in-packets")

                            self.in_queue_drops = YLeaf(YType.uint64, "in-queue-drops")

                            self.in_short_drops = YLeaf(YType.uint64, "in-short-drops")

                            self.out_bytes = YLeaf(YType.uint64, "out-bytes")

                            self.out_error_drops = YLeaf(YType.uint64, "out-error-drops")

                            self.out_ipsec_drops = YLeaf(YType.uint64, "out-ipsec-drops")

                            self.out_nofd_drops = YLeaf(YType.uint64, "out-nofd-drops")

                            self.out_nopak_drops = YLeaf(YType.uint64, "out-nopak-drops")

                            self.out_packets = YLeaf(YType.uint64, "out-packets")

                            self.out_pakapi_errors = YLeaf(YType.uint64, "out-pakapi-errors")

                            self.raw_conn_close = YLeaf(YType.uint64, "raw-conn-close")

                            self.raw_conn_error = YLeaf(YType.uint64, "raw-conn-error")

                            self.raw_conn_open = YLeaf(YType.uint64, "raw-conn-open")

                            self.raw_conn_state = YLeaf(YType.uint32, "raw-conn-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("in_bytes",
                                            "in_error_drops",
                                            "in_handle_drops",
                                            "in_ipsec_drops",
                                            "in_long_packets",
                                            "in_malloc_drops",
                                            "in_packets",
                                            "in_queue_drops",
                                            "in_short_drops",
                                            "out_bytes",
                                            "out_error_drops",
                                            "out_ipsec_drops",
                                            "out_nofd_drops",
                                            "out_nopak_drops",
                                            "out_packets",
                                            "out_pakapi_errors",
                                            "raw_conn_close",
                                            "raw_conn_error",
                                            "raw_conn_open",
                                            "raw_conn_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.RawioStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.RawioStats, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.in_bytes.is_set or
                                self.in_error_drops.is_set or
                                self.in_handle_drops.is_set or
                                self.in_ipsec_drops.is_set or
                                self.in_long_packets.is_set or
                                self.in_malloc_drops.is_set or
                                self.in_packets.is_set or
                                self.in_queue_drops.is_set or
                                self.in_short_drops.is_set or
                                self.out_bytes.is_set or
                                self.out_error_drops.is_set or
                                self.out_ipsec_drops.is_set or
                                self.out_nofd_drops.is_set or
                                self.out_nopak_drops.is_set or
                                self.out_packets.is_set or
                                self.out_pakapi_errors.is_set or
                                self.raw_conn_close.is_set or
                                self.raw_conn_error.is_set or
                                self.raw_conn_open.is_set or
                                self.raw_conn_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.in_bytes.yfilter != YFilter.not_set or
                                self.in_error_drops.yfilter != YFilter.not_set or
                                self.in_handle_drops.yfilter != YFilter.not_set or
                                self.in_ipsec_drops.yfilter != YFilter.not_set or
                                self.in_long_packets.yfilter != YFilter.not_set or
                                self.in_malloc_drops.yfilter != YFilter.not_set or
                                self.in_packets.yfilter != YFilter.not_set or
                                self.in_queue_drops.yfilter != YFilter.not_set or
                                self.in_short_drops.yfilter != YFilter.not_set or
                                self.out_bytes.yfilter != YFilter.not_set or
                                self.out_error_drops.yfilter != YFilter.not_set or
                                self.out_ipsec_drops.yfilter != YFilter.not_set or
                                self.out_nofd_drops.yfilter != YFilter.not_set or
                                self.out_nopak_drops.yfilter != YFilter.not_set or
                                self.out_packets.yfilter != YFilter.not_set or
                                self.out_pakapi_errors.yfilter != YFilter.not_set or
                                self.raw_conn_close.yfilter != YFilter.not_set or
                                self.raw_conn_error.yfilter != YFilter.not_set or
                                self.raw_conn_open.yfilter != YFilter.not_set or
                                self.raw_conn_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rawio-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.in_bytes.is_set or self.in_bytes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_bytes.get_name_leafdata())
                            if (self.in_error_drops.is_set or self.in_error_drops.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_error_drops.get_name_leafdata())
                            if (self.in_handle_drops.is_set or self.in_handle_drops.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_handle_drops.get_name_leafdata())
                            if (self.in_ipsec_drops.is_set or self.in_ipsec_drops.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_ipsec_drops.get_name_leafdata())
                            if (self.in_long_packets.is_set or self.in_long_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_long_packets.get_name_leafdata())
                            if (self.in_malloc_drops.is_set or self.in_malloc_drops.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_malloc_drops.get_name_leafdata())
                            if (self.in_packets.is_set or self.in_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_packets.get_name_leafdata())
                            if (self.in_queue_drops.is_set or self.in_queue_drops.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_queue_drops.get_name_leafdata())
                            if (self.in_short_drops.is_set or self.in_short_drops.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_short_drops.get_name_leafdata())
                            if (self.out_bytes.is_set or self.out_bytes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_bytes.get_name_leafdata())
                            if (self.out_error_drops.is_set or self.out_error_drops.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_error_drops.get_name_leafdata())
                            if (self.out_ipsec_drops.is_set or self.out_ipsec_drops.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_ipsec_drops.get_name_leafdata())
                            if (self.out_nofd_drops.is_set or self.out_nofd_drops.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_nofd_drops.get_name_leafdata())
                            if (self.out_nopak_drops.is_set or self.out_nopak_drops.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_nopak_drops.get_name_leafdata())
                            if (self.out_packets.is_set or self.out_packets.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_packets.get_name_leafdata())
                            if (self.out_pakapi_errors.is_set or self.out_pakapi_errors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_pakapi_errors.get_name_leafdata())
                            if (self.raw_conn_close.is_set or self.raw_conn_close.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.raw_conn_close.get_name_leafdata())
                            if (self.raw_conn_error.is_set or self.raw_conn_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.raw_conn_error.get_name_leafdata())
                            if (self.raw_conn_open.is_set or self.raw_conn_open.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.raw_conn_open.get_name_leafdata())
                            if (self.raw_conn_state.is_set or self.raw_conn_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.raw_conn_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "in-bytes" or name == "in-error-drops" or name == "in-handle-drops" or name == "in-ipsec-drops" or name == "in-long-packets" or name == "in-malloc-drops" or name == "in-packets" or name == "in-queue-drops" or name == "in-short-drops" or name == "out-bytes" or name == "out-error-drops" or name == "out-ipsec-drops" or name == "out-nofd-drops" or name == "out-nopak-drops" or name == "out-packets" or name == "out-pakapi-errors" or name == "raw-conn-close" or name == "raw-conn-error" or name == "raw-conn-open" or name == "raw-conn-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "in-bytes"):
                                self.in_bytes = value
                                self.in_bytes.value_namespace = name_space
                                self.in_bytes.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-error-drops"):
                                self.in_error_drops = value
                                self.in_error_drops.value_namespace = name_space
                                self.in_error_drops.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-handle-drops"):
                                self.in_handle_drops = value
                                self.in_handle_drops.value_namespace = name_space
                                self.in_handle_drops.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-ipsec-drops"):
                                self.in_ipsec_drops = value
                                self.in_ipsec_drops.value_namespace = name_space
                                self.in_ipsec_drops.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-long-packets"):
                                self.in_long_packets = value
                                self.in_long_packets.value_namespace = name_space
                                self.in_long_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-malloc-drops"):
                                self.in_malloc_drops = value
                                self.in_malloc_drops.value_namespace = name_space
                                self.in_malloc_drops.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-packets"):
                                self.in_packets = value
                                self.in_packets.value_namespace = name_space
                                self.in_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-queue-drops"):
                                self.in_queue_drops = value
                                self.in_queue_drops.value_namespace = name_space
                                self.in_queue_drops.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-short-drops"):
                                self.in_short_drops = value
                                self.in_short_drops.value_namespace = name_space
                                self.in_short_drops.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-bytes"):
                                self.out_bytes = value
                                self.out_bytes.value_namespace = name_space
                                self.out_bytes.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-error-drops"):
                                self.out_error_drops = value
                                self.out_error_drops.value_namespace = name_space
                                self.out_error_drops.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-ipsec-drops"):
                                self.out_ipsec_drops = value
                                self.out_ipsec_drops.value_namespace = name_space
                                self.out_ipsec_drops.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-nofd-drops"):
                                self.out_nofd_drops = value
                                self.out_nofd_drops.value_namespace = name_space
                                self.out_nofd_drops.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-nopak-drops"):
                                self.out_nopak_drops = value
                                self.out_nopak_drops.value_namespace = name_space
                                self.out_nopak_drops.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-packets"):
                                self.out_packets = value
                                self.out_packets.value_namespace = name_space
                                self.out_packets.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-pakapi-errors"):
                                self.out_pakapi_errors = value
                                self.out_pakapi_errors.value_namespace = name_space
                                self.out_pakapi_errors.value_namespace_prefix = name_space_prefix
                            if(value_path == "raw-conn-close"):
                                self.raw_conn_close = value
                                self.raw_conn_close.value_namespace = name_space
                                self.raw_conn_close.value_namespace_prefix = name_space_prefix
                            if(value_path == "raw-conn-error"):
                                self.raw_conn_error = value
                                self.raw_conn_error.value_namespace = name_space
                                self.raw_conn_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "raw-conn-open"):
                                self.raw_conn_open = value
                                self.raw_conn_open.value_namespace = name_space
                                self.raw_conn_open.value_namespace_prefix = name_space_prefix
                            if(value_path == "raw-conn-state"):
                                self.raw_conn_state = value
                                self.raw_conn_state.value_namespace = name_space
                                self.raw_conn_state.value_namespace_prefix = name_space_prefix


                    class PrefixPriorityStats(Entity):
                        """
                        OSPF Prefix SPF Prioritization statistics
                        
                        .. attribute:: critical
                        
                        	Critical priority classifications
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: high
                        
                        	High priority classifications
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: low
                        
                        	Low priority classifications
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: medium
                        
                        	Medium priority classifications
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.PrefixPriorityStats, self).__init__()

                            self.yang_name = "prefix-priority-stats"
                            self.yang_parent_name = "vrf-statistics"

                            self.critical = YLeaf(YType.uint32, "critical")

                            self.high = YLeaf(YType.uint32, "high")

                            self.low = YLeaf(YType.uint32, "low")

                            self.medium = YLeaf(YType.uint32, "medium")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("critical",
                                            "high",
                                            "low",
                                            "medium") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.PrefixPriorityStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.PrefixPriorityStats, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.critical.is_set or
                                self.high.is_set or
                                self.low.is_set or
                                self.medium.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.critical.yfilter != YFilter.not_set or
                                self.high.yfilter != YFilter.not_set or
                                self.low.yfilter != YFilter.not_set or
                                self.medium.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "prefix-priority-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.critical.is_set or self.critical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.critical.get_name_leafdata())
                            if (self.high.is_set or self.high.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.high.get_name_leafdata())
                            if (self.low.is_set or self.low.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.low.get_name_leafdata())
                            if (self.medium.is_set or self.medium.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.medium.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "critical" or name == "high" or name == "low" or name == "medium"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "critical"):
                                self.critical = value
                                self.critical.value_namespace = name_space
                                self.critical.value_namespace_prefix = name_space_prefix
                            if(value_path == "high"):
                                self.high = value
                                self.high.value_namespace = name_space
                                self.high.value_namespace_prefix = name_space_prefix
                            if(value_path == "low"):
                                self.low = value
                                self.low.value_namespace = name_space
                                self.low.value_namespace_prefix = name_space_prefix
                            if(value_path == "medium"):
                                self.medium = value
                                self.medium.value_namespace = name_space
                                self.medium.value_namespace_prefix = name_space_prefix


                    class VrfRibBatchStats(Entity):
                        """
                        OSPFv3 RIB batch statistics
                        
                        .. attribute:: batches_sent
                        
                        	No. of RIB batches sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_routes
                        
                        	Max No. of Routes in a batch
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: paths_add
                        
                        	No. of paths added to RIB
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: paths_add_errs
                        
                        	No. of paths add errors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: paths_del
                        
                        	No. of paths del sent to RIB
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: paths_del_errs
                        
                        	No. of Paths del errors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: paths_pending
                        
                        	No. of paths waiting to be sent to RIB
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: paths_sent
                        
                        	No. of Paths sent to RIB
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: routes_pending
                        
                        	No of Pending Routes
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: routes_sent
                        
                        	No. of Routes sent to RIB
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.VrfRibBatchStats, self).__init__()

                            self.yang_name = "vrf-rib-batch-stats"
                            self.yang_parent_name = "vrf-statistics"

                            self.batches_sent = YLeaf(YType.uint32, "batches-sent")

                            self.max_routes = YLeaf(YType.uint32, "max-routes")

                            self.paths_add = YLeaf(YType.uint32, "paths-add")

                            self.paths_add_errs = YLeaf(YType.uint32, "paths-add-errs")

                            self.paths_del = YLeaf(YType.uint32, "paths-del")

                            self.paths_del_errs = YLeaf(YType.uint32, "paths-del-errs")

                            self.paths_pending = YLeaf(YType.uint32, "paths-pending")

                            self.paths_sent = YLeaf(YType.uint32, "paths-sent")

                            self.routes_pending = YLeaf(YType.uint32, "routes-pending")

                            self.routes_sent = YLeaf(YType.uint32, "routes-sent")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("batches_sent",
                                            "max_routes",
                                            "paths_add",
                                            "paths_add_errs",
                                            "paths_del",
                                            "paths_del_errs",
                                            "paths_pending",
                                            "paths_sent",
                                            "routes_pending",
                                            "routes_sent") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.VrfRibBatchStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.VrfRibBatchStats, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.batches_sent.is_set or
                                self.max_routes.is_set or
                                self.paths_add.is_set or
                                self.paths_add_errs.is_set or
                                self.paths_del.is_set or
                                self.paths_del_errs.is_set or
                                self.paths_pending.is_set or
                                self.paths_sent.is_set or
                                self.routes_pending.is_set or
                                self.routes_sent.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.batches_sent.yfilter != YFilter.not_set or
                                self.max_routes.yfilter != YFilter.not_set or
                                self.paths_add.yfilter != YFilter.not_set or
                                self.paths_add_errs.yfilter != YFilter.not_set or
                                self.paths_del.yfilter != YFilter.not_set or
                                self.paths_del_errs.yfilter != YFilter.not_set or
                                self.paths_pending.yfilter != YFilter.not_set or
                                self.paths_sent.yfilter != YFilter.not_set or
                                self.routes_pending.yfilter != YFilter.not_set or
                                self.routes_sent.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vrf-rib-batch-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.batches_sent.is_set or self.batches_sent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.batches_sent.get_name_leafdata())
                            if (self.max_routes.is_set or self.max_routes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_routes.get_name_leafdata())
                            if (self.paths_add.is_set or self.paths_add.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.paths_add.get_name_leafdata())
                            if (self.paths_add_errs.is_set or self.paths_add_errs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.paths_add_errs.get_name_leafdata())
                            if (self.paths_del.is_set or self.paths_del.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.paths_del.get_name_leafdata())
                            if (self.paths_del_errs.is_set or self.paths_del_errs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.paths_del_errs.get_name_leafdata())
                            if (self.paths_pending.is_set or self.paths_pending.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.paths_pending.get_name_leafdata())
                            if (self.paths_sent.is_set or self.paths_sent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.paths_sent.get_name_leafdata())
                            if (self.routes_pending.is_set or self.routes_pending.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.routes_pending.get_name_leafdata())
                            if (self.routes_sent.is_set or self.routes_sent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.routes_sent.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "batches-sent" or name == "max-routes" or name == "paths-add" or name == "paths-add-errs" or name == "paths-del" or name == "paths-del-errs" or name == "paths-pending" or name == "paths-sent" or name == "routes-pending" or name == "routes-sent"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "batches-sent"):
                                self.batches_sent = value
                                self.batches_sent.value_namespace = name_space
                                self.batches_sent.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-routes"):
                                self.max_routes = value
                                self.max_routes.value_namespace = name_space
                                self.max_routes.value_namespace_prefix = name_space_prefix
                            if(value_path == "paths-add"):
                                self.paths_add = value
                                self.paths_add.value_namespace = name_space
                                self.paths_add.value_namespace_prefix = name_space_prefix
                            if(value_path == "paths-add-errs"):
                                self.paths_add_errs = value
                                self.paths_add_errs.value_namespace = name_space
                                self.paths_add_errs.value_namespace_prefix = name_space_prefix
                            if(value_path == "paths-del"):
                                self.paths_del = value
                                self.paths_del.value_namespace = name_space
                                self.paths_del.value_namespace_prefix = name_space_prefix
                            if(value_path == "paths-del-errs"):
                                self.paths_del_errs = value
                                self.paths_del_errs.value_namespace = name_space
                                self.paths_del_errs.value_namespace_prefix = name_space_prefix
                            if(value_path == "paths-pending"):
                                self.paths_pending = value
                                self.paths_pending.value_namespace = name_space
                                self.paths_pending.value_namespace_prefix = name_space_prefix
                            if(value_path == "paths-sent"):
                                self.paths_sent = value
                                self.paths_sent.value_namespace = name_space
                                self.paths_sent.value_namespace_prefix = name_space_prefix
                            if(value_path == "routes-pending"):
                                self.routes_pending = value
                                self.routes_pending.value_namespace = name_space
                                self.routes_pending.value_namespace_prefix = name_space_prefix
                            if(value_path == "routes-sent"):
                                self.routes_sent = value
                                self.routes_sent.value_namespace = name_space
                                self.routes_sent.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.prefix_priority_stats is not None and self.prefix_priority_stats.has_data()) or
                            (self.protocol_stats is not None and self.protocol_stats.has_data()) or
                            (self.rawio_stats is not None and self.rawio_stats.has_data()) or
                            (self.spf_stats is not None and self.spf_stats.has_data()) or
                            (self.vrf_rib_batch_stats is not None and self.vrf_rib_batch_stats.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.prefix_priority_stats is not None and self.prefix_priority_stats.has_operation()) or
                            (self.protocol_stats is not None and self.protocol_stats.has_operation()) or
                            (self.rawio_stats is not None and self.rawio_stats.has_operation()) or
                            (self.spf_stats is not None and self.spf_stats.has_operation()) or
                            (self.vrf_rib_batch_stats is not None and self.vrf_rib_batch_stats.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf-statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "prefix-priority-stats"):
                            if (self.prefix_priority_stats is None):
                                self.prefix_priority_stats = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.PrefixPriorityStats()
                                self.prefix_priority_stats.parent = self
                                self._children_name_map["prefix_priority_stats"] = "prefix-priority-stats"
                            return self.prefix_priority_stats

                        if (child_yang_name == "protocol-stats"):
                            if (self.protocol_stats is None):
                                self.protocol_stats = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.ProtocolStats()
                                self.protocol_stats.parent = self
                                self._children_name_map["protocol_stats"] = "protocol-stats"
                            return self.protocol_stats

                        if (child_yang_name == "rawio-stats"):
                            if (self.rawio_stats is None):
                                self.rawio_stats = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.RawioStats()
                                self.rawio_stats.parent = self
                                self._children_name_map["rawio_stats"] = "rawio-stats"
                            return self.rawio_stats

                        if (child_yang_name == "spf-stats"):
                            if (self.spf_stats is None):
                                self.spf_stats = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.SpfStats()
                                self.spf_stats.parent = self
                                self._children_name_map["spf_stats"] = "spf-stats"
                            return self.spf_stats

                        if (child_yang_name == "vrf-rib-batch-stats"):
                            if (self.vrf_rib_batch_stats is None):
                                self.vrf_rib_batch_stats = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics.VrfRibBatchStats()
                                self.vrf_rib_batch_stats.parent = self
                                self._children_name_map["vrf_rib_batch_stats"] = "vrf-rib-batch-stats"
                            return self.vrf_rib_batch_stats

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "prefix-priority-stats" or name == "protocol-stats" or name == "rawio-stats" or name == "spf-stats" or name == "vrf-rib-batch-stats"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Summary(Entity):
                    """
                    OSPFv3 summary
                    
                    .. attribute:: ospfv3
                    
                    	OSPFv3 summary
                    	**type**\:   :py:class:`Ospfv3 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3>`
                    
                    .. attribute:: protocol
                    
                    	OSPFv3 protocol summary
                    	**type**\:   :py:class:`Protocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Protocol>`
                    
                    .. attribute:: route
                    
                    	OSPFv3 route summary
                    	**type**\:   :py:class:`Route <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Route>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "default-vrf"

                        self.ospfv3 = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3()
                        self.ospfv3.parent = self
                        self._children_name_map["ospfv3"] = "ospfv3"
                        self._children_yang_names.add("ospfv3")

                        self.protocol = Ospfv3.Processes.Process.DefaultVrf.Summary.Protocol()
                        self.protocol.parent = self
                        self._children_name_map["protocol"] = "protocol"
                        self._children_yang_names.add("protocol")

                        self.route = Ospfv3.Processes.Process.DefaultVrf.Summary.Route()
                        self.route.parent = self
                        self._children_name_map["route"] = "route"
                        self._children_yang_names.add("route")


                    class Protocol(Entity):
                        """
                        OSPFv3 protocol summary
                        
                        .. attribute:: administrative_distance
                        
                        	Administrative distance
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: administrative_distance_external
                        
                        	Administrative Distance for External routes
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: administrative_distance_inter_area
                        
                        	Administrative Distance for Inter Area routes
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: distribute_list_in
                        
                        	Distribute List In
                        	**type**\:  str
                        
                        .. attribute:: is_graceful_restart
                        
                        	If true, Graceful restart is enabled 
                        	**type**\:  bool
                        
                        .. attribute:: protocol_router_id
                        
                        	Protocol router ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Protocol, self).__init__()

                            self.yang_name = "protocol"
                            self.yang_parent_name = "summary"

                            self.administrative_distance = YLeaf(YType.uint32, "administrative-distance")

                            self.administrative_distance_external = YLeaf(YType.uint32, "administrative-distance-external")

                            self.administrative_distance_inter_area = YLeaf(YType.uint32, "administrative-distance-inter-area")

                            self.distribute_list_in = YLeaf(YType.str, "distribute-list-in")

                            self.is_graceful_restart = YLeaf(YType.boolean, "is-graceful-restart")

                            self.protocol_router_id = YLeaf(YType.str, "protocol-router-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("administrative_distance",
                                            "administrative_distance_external",
                                            "administrative_distance_inter_area",
                                            "distribute_list_in",
                                            "is_graceful_restart",
                                            "protocol_router_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Summary.Protocol, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Protocol, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.administrative_distance.is_set or
                                self.administrative_distance_external.is_set or
                                self.administrative_distance_inter_area.is_set or
                                self.distribute_list_in.is_set or
                                self.is_graceful_restart.is_set or
                                self.protocol_router_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.administrative_distance.yfilter != YFilter.not_set or
                                self.administrative_distance_external.yfilter != YFilter.not_set or
                                self.administrative_distance_inter_area.yfilter != YFilter.not_set or
                                self.distribute_list_in.yfilter != YFilter.not_set or
                                self.is_graceful_restart.yfilter != YFilter.not_set or
                                self.protocol_router_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protocol" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.administrative_distance.is_set or self.administrative_distance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.administrative_distance.get_name_leafdata())
                            if (self.administrative_distance_external.is_set or self.administrative_distance_external.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.administrative_distance_external.get_name_leafdata())
                            if (self.administrative_distance_inter_area.is_set or self.administrative_distance_inter_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.administrative_distance_inter_area.get_name_leafdata())
                            if (self.distribute_list_in.is_set or self.distribute_list_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.distribute_list_in.get_name_leafdata())
                            if (self.is_graceful_restart.is_set or self.is_graceful_restart.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_graceful_restart.get_name_leafdata())
                            if (self.protocol_router_id.is_set or self.protocol_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_router_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "administrative-distance" or name == "administrative-distance-external" or name == "administrative-distance-inter-area" or name == "distribute-list-in" or name == "is-graceful-restart" or name == "protocol-router-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "administrative-distance"):
                                self.administrative_distance = value
                                self.administrative_distance.value_namespace = name_space
                                self.administrative_distance.value_namespace_prefix = name_space_prefix
                            if(value_path == "administrative-distance-external"):
                                self.administrative_distance_external = value
                                self.administrative_distance_external.value_namespace = name_space
                                self.administrative_distance_external.value_namespace_prefix = name_space_prefix
                            if(value_path == "administrative-distance-inter-area"):
                                self.administrative_distance_inter_area = value
                                self.administrative_distance_inter_area.value_namespace = name_space
                                self.administrative_distance_inter_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "distribute-list-in"):
                                self.distribute_list_in = value
                                self.distribute_list_in.value_namespace = name_space
                                self.distribute_list_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-graceful-restart"):
                                self.is_graceful_restart = value
                                self.is_graceful_restart.value_namespace = name_space
                                self.is_graceful_restart.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-router-id"):
                                self.protocol_router_id = value
                                self.protocol_router_id.value_namespace = name_space
                                self.protocol_router_id.value_namespace_prefix = name_space_prefix


                    class Ospfv3(Entity):
                        """
                        OSPFv3 summary
                        
                        .. attribute:: areas
                        
                        	Number of areas
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: as_dc_bitless_ls_as
                        
                        	Number of external and AS opaque LSAs with demand circut bit not set
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: as_do_not_age_ls_as
                        
                        	Number of external and AS opaque LSAs with do not age set 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: as_ls_as
                        
                        	Number of AS scope LSAs
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: as_lsa_flood_list_length
                        
                        	Length of AS LSAs flood list
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: context_name
                        
                        	Context name
                        	**type**\:  str
                        
                        	**length:** 0..32
                        
                        .. attribute:: default_metric
                        
                        	Default metric 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: default_metric_type
                        
                        	Default metric type 
                        	**type**\:   :py:class:`Ospfv3DefaultMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3DefaultMetric>`
                        
                        .. attribute:: default_policy_name
                        
                        	Default policy name 
                        	**type**\:  str
                        
                        .. attribute:: default_tag
                        
                        	Default tag 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: domain_id
                        
                        	Domain ID information
                        	**type**\:   :py:class:`DomainId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId>`
                        
                        .. attribute:: grace_resync_time
                        
                        	Grace time to resync 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: graceful_shutdown_state
                        
                        	Graceful shutdown state
                        	**type**\:   :py:class:`Ospfv3GracefulShutdownState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3GracefulShutdownState>`
                        
                        .. attribute:: ipfrr_tiebreakers
                        
                        	IPFRR\-Tiebreakers list
                        	**type**\: list of    :py:class:`IpfrrTiebreakers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.IpfrrTiebreakers>`
                        
                        .. attribute:: is_area_border_router
                        
                        	If true, is an area border router
                        	**type**\:  bool
                        
                        .. attribute:: is_as_border_router
                        
                        	If true, is an AS border router
                        	**type**\:  bool
                        
                        .. attribute:: is_auto_cost
                        
                        	If true, auto cost is enabled
                        	**type**\:  bool
                        
                        .. attribute:: is_default_always
                        
                        	If true, default always 
                        	**type**\:  bool
                        
                        .. attribute:: is_default_originated
                        
                        	If true, origin is by default 
                        	**type**\:  bool
                        
                        .. attribute:: is_default_policy
                        
                        	If true, is a default policy 
                        	**type**\:  bool
                        
                        .. attribute:: is_grace_restart_enabled
                        
                        	If true, grace restart is enabled 
                        	**type**\:  bool
                        
                        .. attribute:: is_nsr_enabled
                        
                        	If true, NSR is enabled
                        	**type**\:  bool
                        
                        .. attribute:: is_nsr_switchover_on_restart
                        
                        	Trigger RP Switchover on detectable process restart
                        	**type**\:  bool
                        
                        .. attribute:: is_opaque_capable
                        
                        	Opaque LSA capable 
                        	**type**\:  bool
                        
                        .. attribute:: is_role_standby
                        
                        	If true, the process is running as stanby role
                        	**type**\:  bool
                        
                        .. attribute:: is_router_id_stalled
                        
                        	Stalled Router ID 
                        	**type**\:  bool
                        
                        .. attribute:: last_nsf_time
                        
                        	 Length of time since the last NSF (s)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: lsa_flood_pacing_interval
                        
                        	LSA flood pacing timer (ms)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: lsa_group_interval
                        
                        	LSA refresh interval (sec)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: lsa_hold_time
                        
                        	Second delay before generating next LSA (ms)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: lsa_maximum_time
                        
                        	Maximum delay before generating an LSA (ms)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: lsa_retransmission_pacing_interval
                        
                        	LSA retransmission pacing timer (ms)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: lsa_start_time
                        
                        	Initial LSA throttle delay (ms)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: maximum_interfaces
                        
                        	Maximum number of interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: maximum_paths
                        
                        	Maximum number of paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: metric
                        
                        	Redistribution metric 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: minimum_lsa_interval
                        
                        	Minimum time between LSA regeneration (ms)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: normal_areas
                        
                        	Number of normal areas
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: nssa_areas
                        
                        	Number of NSSA areas
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: opaque_lsa_checksum
                        
                        	Sum of opaque LSA checksum
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: opaque_lsas
                        
                        	Number of opaque LSAs
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: redistribution_limit
                        
                        	The number of redistributed prefixes allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: redistribution_threshold
                        
                        	When the number of redistributed prefixes reaches this threshold, a warning message is issued 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: reference_bandwidth
                        
                        	Reference Bandwdith
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: role
                        
                        	Role, V1/V2 Active/Standby
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: router_id
                        
                        	Router ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: snmp_trap_enabled
                        
                        	If true, snmp trap is enabled
                        	**type**\:  bool
                        
                        .. attribute:: spf_hold_time
                        
                        	Minimum delay time between SPF runs (ms)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: spf_maximum_time
                        
                        	Maximum delay time between SPF runs (ms)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: spf_start_time
                        
                        	Scheduling delay for SPF (ms)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: stub_areas
                        
                        	Number of stub and total stub areas
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: stub_router
                        
                        	Stub Router Information
                        	**type**\: list of    :py:class:`StubRouter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3, self).__init__()

                            self.yang_name = "ospfv3"
                            self.yang_parent_name = "summary"

                            self.areas = YLeaf(YType.uint16, "areas")

                            self.as_dc_bitless_ls_as = YLeaf(YType.uint32, "as-dc-bitless-ls-as")

                            self.as_do_not_age_ls_as = YLeaf(YType.uint32, "as-do-not-age-ls-as")

                            self.as_ls_as = YLeaf(YType.uint32, "as-ls-as")

                            self.as_lsa_flood_list_length = YLeaf(YType.uint32, "as-lsa-flood-list-length")

                            self.context_name = YLeaf(YType.str, "context-name")

                            self.default_metric = YLeaf(YType.uint32, "default-metric")

                            self.default_metric_type = YLeaf(YType.enumeration, "default-metric-type")

                            self.default_policy_name = YLeaf(YType.str, "default-policy-name")

                            self.default_tag = YLeaf(YType.uint32, "default-tag")

                            self.grace_resync_time = YLeaf(YType.uint32, "grace-resync-time")

                            self.graceful_shutdown_state = YLeaf(YType.enumeration, "graceful-shutdown-state")

                            self.is_area_border_router = YLeaf(YType.boolean, "is-area-border-router")

                            self.is_as_border_router = YLeaf(YType.boolean, "is-as-border-router")

                            self.is_auto_cost = YLeaf(YType.boolean, "is-auto-cost")

                            self.is_default_always = YLeaf(YType.boolean, "is-default-always")

                            self.is_default_originated = YLeaf(YType.boolean, "is-default-originated")

                            self.is_default_policy = YLeaf(YType.boolean, "is-default-policy")

                            self.is_grace_restart_enabled = YLeaf(YType.boolean, "is-grace-restart-enabled")

                            self.is_nsr_enabled = YLeaf(YType.boolean, "is-nsr-enabled")

                            self.is_nsr_switchover_on_restart = YLeaf(YType.boolean, "is-nsr-switchover-on-restart")

                            self.is_opaque_capable = YLeaf(YType.boolean, "is-opaque-capable")

                            self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                            self.is_router_id_stalled = YLeaf(YType.boolean, "is-router-id-stalled")

                            self.last_nsf_time = YLeaf(YType.uint32, "last-nsf-time")

                            self.lsa_flood_pacing_interval = YLeaf(YType.uint32, "lsa-flood-pacing-interval")

                            self.lsa_group_interval = YLeaf(YType.uint32, "lsa-group-interval")

                            self.lsa_hold_time = YLeaf(YType.uint32, "lsa-hold-time")

                            self.lsa_maximum_time = YLeaf(YType.uint32, "lsa-maximum-time")

                            self.lsa_retransmission_pacing_interval = YLeaf(YType.uint32, "lsa-retransmission-pacing-interval")

                            self.lsa_start_time = YLeaf(YType.uint32, "lsa-start-time")

                            self.maximum_interfaces = YLeaf(YType.uint32, "maximum-interfaces")

                            self.maximum_paths = YLeaf(YType.uint32, "maximum-paths")

                            self.metric = YLeaf(YType.uint32, "metric")

                            self.minimum_lsa_interval = YLeaf(YType.uint32, "minimum-lsa-interval")

                            self.normal_areas = YLeaf(YType.uint16, "normal-areas")

                            self.nssa_areas = YLeaf(YType.uint16, "nssa-areas")

                            self.opaque_lsa_checksum = YLeaf(YType.uint32, "opaque-lsa-checksum")

                            self.opaque_lsas = YLeaf(YType.uint32, "opaque-lsas")

                            self.redistribution_limit = YLeaf(YType.uint32, "redistribution-limit")

                            self.redistribution_threshold = YLeaf(YType.uint32, "redistribution-threshold")

                            self.reference_bandwidth = YLeaf(YType.uint32, "reference-bandwidth")

                            self.role = YLeaf(YType.uint32, "role")

                            self.router_id = YLeaf(YType.str, "router-id")

                            self.snmp_trap_enabled = YLeaf(YType.boolean, "snmp-trap-enabled")

                            self.spf_hold_time = YLeaf(YType.uint32, "spf-hold-time")

                            self.spf_maximum_time = YLeaf(YType.uint32, "spf-maximum-time")

                            self.spf_start_time = YLeaf(YType.uint32, "spf-start-time")

                            self.stub_areas = YLeaf(YType.uint16, "stub-areas")

                            self.domain_id = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId()
                            self.domain_id.parent = self
                            self._children_name_map["domain_id"] = "domain-id"
                            self._children_yang_names.add("domain-id")

                            self.ipfrr_tiebreakers = YList(self)
                            self.stub_router = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("areas",
                                            "as_dc_bitless_ls_as",
                                            "as_do_not_age_ls_as",
                                            "as_ls_as",
                                            "as_lsa_flood_list_length",
                                            "context_name",
                                            "default_metric",
                                            "default_metric_type",
                                            "default_policy_name",
                                            "default_tag",
                                            "grace_resync_time",
                                            "graceful_shutdown_state",
                                            "is_area_border_router",
                                            "is_as_border_router",
                                            "is_auto_cost",
                                            "is_default_always",
                                            "is_default_originated",
                                            "is_default_policy",
                                            "is_grace_restart_enabled",
                                            "is_nsr_enabled",
                                            "is_nsr_switchover_on_restart",
                                            "is_opaque_capable",
                                            "is_role_standby",
                                            "is_router_id_stalled",
                                            "last_nsf_time",
                                            "lsa_flood_pacing_interval",
                                            "lsa_group_interval",
                                            "lsa_hold_time",
                                            "lsa_maximum_time",
                                            "lsa_retransmission_pacing_interval",
                                            "lsa_start_time",
                                            "maximum_interfaces",
                                            "maximum_paths",
                                            "metric",
                                            "minimum_lsa_interval",
                                            "normal_areas",
                                            "nssa_areas",
                                            "opaque_lsa_checksum",
                                            "opaque_lsas",
                                            "redistribution_limit",
                                            "redistribution_threshold",
                                            "reference_bandwidth",
                                            "role",
                                            "router_id",
                                            "snmp_trap_enabled",
                                            "spf_hold_time",
                                            "spf_maximum_time",
                                            "spf_start_time",
                                            "stub_areas") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3, self).__setattr__(name, value)


                        class DomainId(Entity):
                            """
                            Domain ID information
                            
                            .. attribute:: primary_domain_id
                            
                            	Primary Domain ID
                            	**type**\:   :py:class:`PrimaryDomainId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.PrimaryDomainId>`
                            
                            .. attribute:: secondary_domain_id
                            
                            	List of secondary domain IDs
                            	**type**\: list of    :py:class:`SecondaryDomainId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.SecondaryDomainId>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId, self).__init__()

                                self.yang_name = "domain-id"
                                self.yang_parent_name = "ospfv3"

                                self.primary_domain_id = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.PrimaryDomainId()
                                self.primary_domain_id.parent = self
                                self._children_name_map["primary_domain_id"] = "primary-domain-id"
                                self._children_yang_names.add("primary-domain-id")

                                self.secondary_domain_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId, self).__setattr__(name, value)


                            class PrimaryDomainId(Entity):
                                """
                                Primary Domain ID
                                
                                .. attribute:: domain_id_type
                                
                                	Domain ID Type
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: domain_id_value
                                
                                	Domain ID value
                                	**type**\:  str
                                
                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.PrimaryDomainId, self).__init__()

                                    self.yang_name = "primary-domain-id"
                                    self.yang_parent_name = "domain-id"

                                    self.domain_id_type = YLeaf(YType.uint16, "domain-id-type")

                                    self.domain_id_value = YLeaf(YType.str, "domain-id-value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("domain_id_type",
                                                    "domain_id_value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.PrimaryDomainId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.PrimaryDomainId, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.domain_id_type.is_set or
                                        self.domain_id_value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.domain_id_type.yfilter != YFilter.not_set or
                                        self.domain_id_value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "primary-domain-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.domain_id_type.is_set or self.domain_id_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.domain_id_type.get_name_leafdata())
                                    if (self.domain_id_value.is_set or self.domain_id_value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.domain_id_value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "domain-id-type" or name == "domain-id-value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "domain-id-type"):
                                        self.domain_id_type = value
                                        self.domain_id_type.value_namespace = name_space
                                        self.domain_id_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "domain-id-value"):
                                        self.domain_id_value = value
                                        self.domain_id_value.value_namespace = name_space
                                        self.domain_id_value.value_namespace_prefix = name_space_prefix


                            class SecondaryDomainId(Entity):
                                """
                                List of secondary domain IDs
                                
                                .. attribute:: domain_id_type
                                
                                	Domain ID Type
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: domain_id_value
                                
                                	Domain ID value
                                	**type**\:  str
                                
                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.SecondaryDomainId, self).__init__()

                                    self.yang_name = "secondary-domain-id"
                                    self.yang_parent_name = "domain-id"

                                    self.domain_id_type = YLeaf(YType.uint16, "domain-id-type")

                                    self.domain_id_value = YLeaf(YType.str, "domain-id-value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("domain_id_type",
                                                    "domain_id_value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.SecondaryDomainId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.SecondaryDomainId, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.domain_id_type.is_set or
                                        self.domain_id_value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.domain_id_type.yfilter != YFilter.not_set or
                                        self.domain_id_value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "secondary-domain-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.domain_id_type.is_set or self.domain_id_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.domain_id_type.get_name_leafdata())
                                    if (self.domain_id_value.is_set or self.domain_id_value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.domain_id_value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "domain-id-type" or name == "domain-id-value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "domain-id-type"):
                                        self.domain_id_type = value
                                        self.domain_id_type.value_namespace = name_space
                                        self.domain_id_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "domain-id-value"):
                                        self.domain_id_value = value
                                        self.domain_id_value.value_namespace = name_space
                                        self.domain_id_value.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.secondary_domain_id:
                                    if (c.has_data()):
                                        return True
                                return (self.primary_domain_id is not None and self.primary_domain_id.has_data())

                            def has_operation(self):
                                for c in self.secondary_domain_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.primary_domain_id is not None and self.primary_domain_id.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "domain-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "primary-domain-id"):
                                    if (self.primary_domain_id is None):
                                        self.primary_domain_id = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.PrimaryDomainId()
                                        self.primary_domain_id.parent = self
                                        self._children_name_map["primary_domain_id"] = "primary-domain-id"
                                    return self.primary_domain_id

                                if (child_yang_name == "secondary-domain-id"):
                                    for c in self.secondary_domain_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId.SecondaryDomainId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.secondary_domain_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "primary-domain-id" or name == "secondary-domain-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class StubRouter(Entity):
                            """
                            Stub Router Information
                            
                            .. attribute:: abr_off_reason
                            
                            	Reason for being in ABR off mode
                            	**type**\:   :py:class:`StubRouterAbrOffReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterAbrOffReason>`
                            
                            .. attribute:: abr_resume_time
                            
                            	Timestamp (relative to 1970/1/1 00\:00) when ABR duties were resumed
                            	**type**\:   :py:class:`AbrResumeTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.AbrResumeTime>`
                            
                            .. attribute:: active
                            
                            	If true, stub router mode is active
                            	**type**\:  bool
                            
                            .. attribute:: external_lsa_metric
                            
                            	Metric for external LSAs in max\-metric mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: include_stub_links
                            
                            	If true, advertise maximum metric for stub links
                            	**type**\:  bool
                            
                            .. attribute:: mode
                            
                            	Stub router mode
                            	**type**\:   :py:class:`StubRouterMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterMode>`
                            
                            .. attribute:: remaining_time
                            
                            	Remaining time (in seconds) in stub router mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: set_reason
                            
                            	Reason for entering stub router mode
                            	**type**\:   :py:class:`StubRouterTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterTrigger>`
                            
                            .. attribute:: start_time
                            
                            	Timestamp (relative to 1970/1/1 00\:00) when stub router mode was activated
                            	**type**\:   :py:class:`StartTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.StartTime>`
                            
                            .. attribute:: summary_lsa_metric
                            
                            	Metric for summary LSAs in max\-metric mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: trigger
                            
                            	Triggers for entering stub router mode
                            	**type**\: list of    :py:class:`Trigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger>`
                            
                            .. attribute:: unset_reason
                            
                            	Reason for clearing stub router condition
                            	**type**\:   :py:class:`StubRouterExitReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterExitReason>`
                            
                            .. attribute:: unset_time
                            
                            	Timestamp (relative to 1970/1/1 00\:00) when stub router condition was cleared
                            	**type**\:   :py:class:`UnsetTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.UnsetTime>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter, self).__init__()

                                self.yang_name = "stub-router"
                                self.yang_parent_name = "ospfv3"

                                self.abr_off_reason = YLeaf(YType.enumeration, "abr-off-reason")

                                self.active = YLeaf(YType.boolean, "active")

                                self.external_lsa_metric = YLeaf(YType.uint32, "external-lsa-metric")

                                self.include_stub_links = YLeaf(YType.boolean, "include-stub-links")

                                self.mode = YLeaf(YType.enumeration, "mode")

                                self.remaining_time = YLeaf(YType.uint32, "remaining-time")

                                self.set_reason = YLeaf(YType.enumeration, "set-reason")

                                self.summary_lsa_metric = YLeaf(YType.uint32, "summary-lsa-metric")

                                self.unset_reason = YLeaf(YType.enumeration, "unset-reason")

                                self.abr_resume_time = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.AbrResumeTime()
                                self.abr_resume_time.parent = self
                                self._children_name_map["abr_resume_time"] = "abr-resume-time"
                                self._children_yang_names.add("abr-resume-time")

                                self.start_time = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.StartTime()
                                self.start_time.parent = self
                                self._children_name_map["start_time"] = "start-time"
                                self._children_yang_names.add("start-time")

                                self.unset_time = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.UnsetTime()
                                self.unset_time.parent = self
                                self._children_name_map["unset_time"] = "unset-time"
                                self._children_yang_names.add("unset-time")

                                self.trigger = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("abr_off_reason",
                                                "active",
                                                "external_lsa_metric",
                                                "include_stub_links",
                                                "mode",
                                                "remaining_time",
                                                "set_reason",
                                                "summary_lsa_metric",
                                                "unset_reason") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter, self).__setattr__(name, value)


                            class UnsetTime(Entity):
                                """
                                Timestamp (relative to 1970/1/1 00\:00) when stub
                                router condition was cleared
                                
                                .. attribute:: nanosecond
                                
                                	Nano seconds 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: nanosecond
                                
                                .. attribute:: second
                                
                                	Seconds 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.UnsetTime, self).__init__()

                                    self.yang_name = "unset-time"
                                    self.yang_parent_name = "stub-router"

                                    self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                    self.second = YLeaf(YType.uint32, "second")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nanosecond",
                                                    "second") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.UnsetTime, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.UnsetTime, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.nanosecond.is_set or
                                        self.second.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nanosecond.yfilter != YFilter.not_set or
                                        self.second.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unset-time" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                    if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.second.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nanosecond" or name == "second"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nanosecond"):
                                        self.nanosecond = value
                                        self.nanosecond.value_namespace = name_space
                                        self.nanosecond.value_namespace_prefix = name_space_prefix
                                    if(value_path == "second"):
                                        self.second = value
                                        self.second.value_namespace = name_space
                                        self.second.value_namespace_prefix = name_space_prefix


                            class StartTime(Entity):
                                """
                                Timestamp (relative to 1970/1/1 00\:00) when stub
                                router mode was activated
                                
                                .. attribute:: nanosecond
                                
                                	Nano seconds 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: nanosecond
                                
                                .. attribute:: second
                                
                                	Seconds 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.StartTime, self).__init__()

                                    self.yang_name = "start-time"
                                    self.yang_parent_name = "stub-router"

                                    self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                    self.second = YLeaf(YType.uint32, "second")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nanosecond",
                                                    "second") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.StartTime, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.StartTime, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.nanosecond.is_set or
                                        self.second.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nanosecond.yfilter != YFilter.not_set or
                                        self.second.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "start-time" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                    if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.second.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nanosecond" or name == "second"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nanosecond"):
                                        self.nanosecond = value
                                        self.nanosecond.value_namespace = name_space
                                        self.nanosecond.value_namespace_prefix = name_space_prefix
                                    if(value_path == "second"):
                                        self.second = value
                                        self.second.value_namespace = name_space
                                        self.second.value_namespace_prefix = name_space_prefix


                            class AbrResumeTime(Entity):
                                """
                                Timestamp (relative to 1970/1/1 00\:00) when ABR
                                duties were resumed
                                
                                .. attribute:: nanosecond
                                
                                	Nano seconds 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: nanosecond
                                
                                .. attribute:: second
                                
                                	Seconds 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.AbrResumeTime, self).__init__()

                                    self.yang_name = "abr-resume-time"
                                    self.yang_parent_name = "stub-router"

                                    self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                    self.second = YLeaf(YType.uint32, "second")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nanosecond",
                                                    "second") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.AbrResumeTime, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.AbrResumeTime, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.nanosecond.is_set or
                                        self.second.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nanosecond.yfilter != YFilter.not_set or
                                        self.second.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "abr-resume-time" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                    if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.second.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nanosecond" or name == "second"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nanosecond"):
                                        self.nanosecond = value
                                        self.nanosecond.value_namespace = name_space
                                        self.nanosecond.value_namespace_prefix = name_space_prefix
                                    if(value_path == "second"):
                                        self.second = value
                                        self.second.value_namespace = name_space
                                        self.second.value_namespace_prefix = name_space_prefix


                            class Trigger(Entity):
                                """
                                Triggers for entering stub router mode
                                
                                .. attribute:: start_time
                                
                                	Timestamp (relative to 1970/1/1 00\:00) when stub router mode was activated
                                	**type**\:   :py:class:`StartTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.StartTime>`
                                
                                .. attribute:: time
                                
                                	Time (in seconds) to stay in stub router mode
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: trigger
                                
                                	Stub Router Trigger type
                                	**type**\:   :py:class:`StubRouterTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterTrigger>`
                                
                                .. attribute:: unset_reason
                                
                                	Reason for clearing stub router condition
                                	**type**\:   :py:class:`StubRouterExitReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.StubRouterExitReason>`
                                
                                .. attribute:: unset_time
                                
                                	Timestamp (relative to 1970/1/1 00\:00) when stub router condition was cleared
                                	**type**\:   :py:class:`UnsetTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime>`
                                
                                .. attribute:: wait_for_bgp
                                
                                	If true, stub router is terminated when BGP converges
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger, self).__init__()

                                    self.yang_name = "trigger"
                                    self.yang_parent_name = "stub-router"

                                    self.time = YLeaf(YType.uint32, "time")

                                    self.trigger = YLeaf(YType.enumeration, "trigger")

                                    self.unset_reason = YLeaf(YType.enumeration, "unset-reason")

                                    self.wait_for_bgp = YLeaf(YType.boolean, "wait-for-bgp")

                                    self.start_time = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.StartTime()
                                    self.start_time.parent = self
                                    self._children_name_map["start_time"] = "start-time"
                                    self._children_yang_names.add("start-time")

                                    self.unset_time = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime()
                                    self.unset_time.parent = self
                                    self._children_name_map["unset_time"] = "unset-time"
                                    self._children_yang_names.add("unset-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("time",
                                                    "trigger",
                                                    "unset_reason",
                                                    "wait_for_bgp") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger, self).__setattr__(name, value)


                                class UnsetTime(Entity):
                                    """
                                    Timestamp (relative to 1970/1/1 00\:00) when stub
                                    router condition was cleared
                                    
                                    .. attribute:: nanosecond
                                    
                                    	Nano seconds 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: nanosecond
                                    
                                    .. attribute:: second
                                    
                                    	Seconds 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime, self).__init__()

                                        self.yang_name = "unset-time"
                                        self.yang_parent_name = "trigger"

                                        self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                        self.second = YLeaf(YType.uint32, "second")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nanosecond",
                                                        "second") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.nanosecond.is_set or
                                            self.second.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nanosecond.yfilter != YFilter.not_set or
                                            self.second.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unset-time" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                        if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.second.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "nanosecond" or name == "second"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nanosecond"):
                                            self.nanosecond = value
                                            self.nanosecond.value_namespace = name_space
                                            self.nanosecond.value_namespace_prefix = name_space_prefix
                                        if(value_path == "second"):
                                            self.second = value
                                            self.second.value_namespace = name_space
                                            self.second.value_namespace_prefix = name_space_prefix


                                class StartTime(Entity):
                                    """
                                    Timestamp (relative to 1970/1/1 00\:00) when stub
                                    router mode was activated
                                    
                                    .. attribute:: nanosecond
                                    
                                    	Nano seconds 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: nanosecond
                                    
                                    .. attribute:: second
                                    
                                    	Seconds 
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    

                                    """

                                    _prefix = 'ipv6-ospfv3-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.StartTime, self).__init__()

                                        self.yang_name = "start-time"
                                        self.yang_parent_name = "trigger"

                                        self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                        self.second = YLeaf(YType.uint32, "second")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nanosecond",
                                                        "second") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.StartTime, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.StartTime, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.nanosecond.is_set or
                                            self.second.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nanosecond.yfilter != YFilter.not_set or
                                            self.second.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "start-time" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                        if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.second.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "nanosecond" or name == "second"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nanosecond"):
                                            self.nanosecond = value
                                            self.nanosecond.value_namespace = name_space
                                            self.nanosecond.value_namespace_prefix = name_space_prefix
                                        if(value_path == "second"):
                                            self.second = value
                                            self.second.value_namespace = name_space
                                            self.second.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.time.is_set or
                                        self.trigger.is_set or
                                        self.unset_reason.is_set or
                                        self.wait_for_bgp.is_set or
                                        (self.start_time is not None and self.start_time.has_data()) or
                                        (self.unset_time is not None and self.unset_time.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.time.yfilter != YFilter.not_set or
                                        self.trigger.yfilter != YFilter.not_set or
                                        self.unset_reason.yfilter != YFilter.not_set or
                                        self.wait_for_bgp.yfilter != YFilter.not_set or
                                        (self.start_time is not None and self.start_time.has_operation()) or
                                        (self.unset_time is not None and self.unset_time.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "trigger" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.time.is_set or self.time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.time.get_name_leafdata())
                                    if (self.trigger.is_set or self.trigger.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.trigger.get_name_leafdata())
                                    if (self.unset_reason.is_set or self.unset_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unset_reason.get_name_leafdata())
                                    if (self.wait_for_bgp.is_set or self.wait_for_bgp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.wait_for_bgp.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "start-time"):
                                        if (self.start_time is None):
                                            self.start_time = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.StartTime()
                                            self.start_time.parent = self
                                            self._children_name_map["start_time"] = "start-time"
                                        return self.start_time

                                    if (child_yang_name == "unset-time"):
                                        if (self.unset_time is None):
                                            self.unset_time = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger.UnsetTime()
                                            self.unset_time.parent = self
                                            self._children_name_map["unset_time"] = "unset-time"
                                        return self.unset_time

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "start-time" or name == "unset-time" or name == "time" or name == "trigger" or name == "unset-reason" or name == "wait-for-bgp"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "time"):
                                        self.time = value
                                        self.time.value_namespace = name_space
                                        self.time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "trigger"):
                                        self.trigger = value
                                        self.trigger.value_namespace = name_space
                                        self.trigger.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unset-reason"):
                                        self.unset_reason = value
                                        self.unset_reason.value_namespace = name_space
                                        self.unset_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "wait-for-bgp"):
                                        self.wait_for_bgp = value
                                        self.wait_for_bgp.value_namespace = name_space
                                        self.wait_for_bgp.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.trigger:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.abr_off_reason.is_set or
                                    self.active.is_set or
                                    self.external_lsa_metric.is_set or
                                    self.include_stub_links.is_set or
                                    self.mode.is_set or
                                    self.remaining_time.is_set or
                                    self.set_reason.is_set or
                                    self.summary_lsa_metric.is_set or
                                    self.unset_reason.is_set or
                                    (self.abr_resume_time is not None and self.abr_resume_time.has_data()) or
                                    (self.start_time is not None and self.start_time.has_data()) or
                                    (self.unset_time is not None and self.unset_time.has_data()))

                            def has_operation(self):
                                for c in self.trigger:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.abr_off_reason.yfilter != YFilter.not_set or
                                    self.active.yfilter != YFilter.not_set or
                                    self.external_lsa_metric.yfilter != YFilter.not_set or
                                    self.include_stub_links.yfilter != YFilter.not_set or
                                    self.mode.yfilter != YFilter.not_set or
                                    self.remaining_time.yfilter != YFilter.not_set or
                                    self.set_reason.yfilter != YFilter.not_set or
                                    self.summary_lsa_metric.yfilter != YFilter.not_set or
                                    self.unset_reason.yfilter != YFilter.not_set or
                                    (self.abr_resume_time is not None and self.abr_resume_time.has_operation()) or
                                    (self.start_time is not None and self.start_time.has_operation()) or
                                    (self.unset_time is not None and self.unset_time.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "stub-router" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.abr_off_reason.is_set or self.abr_off_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.abr_off_reason.get_name_leafdata())
                                if (self.active.is_set or self.active.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.active.get_name_leafdata())
                                if (self.external_lsa_metric.is_set or self.external_lsa_metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.external_lsa_metric.get_name_leafdata())
                                if (self.include_stub_links.is_set or self.include_stub_links.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.include_stub_links.get_name_leafdata())
                                if (self.mode.is_set or self.mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mode.get_name_leafdata())
                                if (self.remaining_time.is_set or self.remaining_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remaining_time.get_name_leafdata())
                                if (self.set_reason.is_set or self.set_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.set_reason.get_name_leafdata())
                                if (self.summary_lsa_metric.is_set or self.summary_lsa_metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.summary_lsa_metric.get_name_leafdata())
                                if (self.unset_reason.is_set or self.unset_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unset_reason.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "abr-resume-time"):
                                    if (self.abr_resume_time is None):
                                        self.abr_resume_time = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.AbrResumeTime()
                                        self.abr_resume_time.parent = self
                                        self._children_name_map["abr_resume_time"] = "abr-resume-time"
                                    return self.abr_resume_time

                                if (child_yang_name == "start-time"):
                                    if (self.start_time is None):
                                        self.start_time = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.StartTime()
                                        self.start_time.parent = self
                                        self._children_name_map["start_time"] = "start-time"
                                    return self.start_time

                                if (child_yang_name == "trigger"):
                                    for c in self.trigger:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.Trigger()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.trigger.append(c)
                                    return c

                                if (child_yang_name == "unset-time"):
                                    if (self.unset_time is None):
                                        self.unset_time = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter.UnsetTime()
                                        self.unset_time.parent = self
                                        self._children_name_map["unset_time"] = "unset-time"
                                    return self.unset_time

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "abr-resume-time" or name == "start-time" or name == "trigger" or name == "unset-time" or name == "abr-off-reason" or name == "active" or name == "external-lsa-metric" or name == "include-stub-links" or name == "mode" or name == "remaining-time" or name == "set-reason" or name == "summary-lsa-metric" or name == "unset-reason"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "abr-off-reason"):
                                    self.abr_off_reason = value
                                    self.abr_off_reason.value_namespace = name_space
                                    self.abr_off_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "active"):
                                    self.active = value
                                    self.active.value_namespace = name_space
                                    self.active.value_namespace_prefix = name_space_prefix
                                if(value_path == "external-lsa-metric"):
                                    self.external_lsa_metric = value
                                    self.external_lsa_metric.value_namespace = name_space
                                    self.external_lsa_metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "include-stub-links"):
                                    self.include_stub_links = value
                                    self.include_stub_links.value_namespace = name_space
                                    self.include_stub_links.value_namespace_prefix = name_space_prefix
                                if(value_path == "mode"):
                                    self.mode = value
                                    self.mode.value_namespace = name_space
                                    self.mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "remaining-time"):
                                    self.remaining_time = value
                                    self.remaining_time.value_namespace = name_space
                                    self.remaining_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "set-reason"):
                                    self.set_reason = value
                                    self.set_reason.value_namespace = name_space
                                    self.set_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "summary-lsa-metric"):
                                    self.summary_lsa_metric = value
                                    self.summary_lsa_metric.value_namespace = name_space
                                    self.summary_lsa_metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "unset-reason"):
                                    self.unset_reason = value
                                    self.unset_reason.value_namespace = name_space
                                    self.unset_reason.value_namespace_prefix = name_space_prefix


                        class IpfrrTiebreakers(Entity):
                            """
                            IPFRR\-Tiebreakers list
                            
                            .. attribute:: tiebreaker_index
                            
                            	Tiebreaker Index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tiebreaker_type
                            
                            	Tiebreaker Type
                            	**type**\:   :py:class:`IpfrrTbrkr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.IpfrrTbrkr>`
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.IpfrrTiebreakers, self).__init__()

                                self.yang_name = "ipfrr-tiebreakers"
                                self.yang_parent_name = "ospfv3"

                                self.tiebreaker_index = YLeaf(YType.uint32, "tiebreaker-index")

                                self.tiebreaker_type = YLeaf(YType.enumeration, "tiebreaker-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tiebreaker_index",
                                                "tiebreaker_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.IpfrrTiebreakers, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.IpfrrTiebreakers, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.tiebreaker_index.is_set or
                                    self.tiebreaker_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tiebreaker_index.yfilter != YFilter.not_set or
                                    self.tiebreaker_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipfrr-tiebreakers" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tiebreaker_index.is_set or self.tiebreaker_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tiebreaker_index.get_name_leafdata())
                                if (self.tiebreaker_type.is_set or self.tiebreaker_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tiebreaker_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "tiebreaker-index" or name == "tiebreaker-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tiebreaker-index"):
                                    self.tiebreaker_index = value
                                    self.tiebreaker_index.value_namespace = name_space
                                    self.tiebreaker_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "tiebreaker-type"):
                                    self.tiebreaker_type = value
                                    self.tiebreaker_type.value_namespace = name_space
                                    self.tiebreaker_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.ipfrr_tiebreakers:
                                if (c.has_data()):
                                    return True
                            for c in self.stub_router:
                                if (c.has_data()):
                                    return True
                            return (
                                self.areas.is_set or
                                self.as_dc_bitless_ls_as.is_set or
                                self.as_do_not_age_ls_as.is_set or
                                self.as_ls_as.is_set or
                                self.as_lsa_flood_list_length.is_set or
                                self.context_name.is_set or
                                self.default_metric.is_set or
                                self.default_metric_type.is_set or
                                self.default_policy_name.is_set or
                                self.default_tag.is_set or
                                self.grace_resync_time.is_set or
                                self.graceful_shutdown_state.is_set or
                                self.is_area_border_router.is_set or
                                self.is_as_border_router.is_set or
                                self.is_auto_cost.is_set or
                                self.is_default_always.is_set or
                                self.is_default_originated.is_set or
                                self.is_default_policy.is_set or
                                self.is_grace_restart_enabled.is_set or
                                self.is_nsr_enabled.is_set or
                                self.is_nsr_switchover_on_restart.is_set or
                                self.is_opaque_capable.is_set or
                                self.is_role_standby.is_set or
                                self.is_router_id_stalled.is_set or
                                self.last_nsf_time.is_set or
                                self.lsa_flood_pacing_interval.is_set or
                                self.lsa_group_interval.is_set or
                                self.lsa_hold_time.is_set or
                                self.lsa_maximum_time.is_set or
                                self.lsa_retransmission_pacing_interval.is_set or
                                self.lsa_start_time.is_set or
                                self.maximum_interfaces.is_set or
                                self.maximum_paths.is_set or
                                self.metric.is_set or
                                self.minimum_lsa_interval.is_set or
                                self.normal_areas.is_set or
                                self.nssa_areas.is_set or
                                self.opaque_lsa_checksum.is_set or
                                self.opaque_lsas.is_set or
                                self.redistribution_limit.is_set or
                                self.redistribution_threshold.is_set or
                                self.reference_bandwidth.is_set or
                                self.role.is_set or
                                self.router_id.is_set or
                                self.snmp_trap_enabled.is_set or
                                self.spf_hold_time.is_set or
                                self.spf_maximum_time.is_set or
                                self.spf_start_time.is_set or
                                self.stub_areas.is_set or
                                (self.domain_id is not None and self.domain_id.has_data()))

                        def has_operation(self):
                            for c in self.ipfrr_tiebreakers:
                                if (c.has_operation()):
                                    return True
                            for c in self.stub_router:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.areas.yfilter != YFilter.not_set or
                                self.as_dc_bitless_ls_as.yfilter != YFilter.not_set or
                                self.as_do_not_age_ls_as.yfilter != YFilter.not_set or
                                self.as_ls_as.yfilter != YFilter.not_set or
                                self.as_lsa_flood_list_length.yfilter != YFilter.not_set or
                                self.context_name.yfilter != YFilter.not_set or
                                self.default_metric.yfilter != YFilter.not_set or
                                self.default_metric_type.yfilter != YFilter.not_set or
                                self.default_policy_name.yfilter != YFilter.not_set or
                                self.default_tag.yfilter != YFilter.not_set or
                                self.grace_resync_time.yfilter != YFilter.not_set or
                                self.graceful_shutdown_state.yfilter != YFilter.not_set or
                                self.is_area_border_router.yfilter != YFilter.not_set or
                                self.is_as_border_router.yfilter != YFilter.not_set or
                                self.is_auto_cost.yfilter != YFilter.not_set or
                                self.is_default_always.yfilter != YFilter.not_set or
                                self.is_default_originated.yfilter != YFilter.not_set or
                                self.is_default_policy.yfilter != YFilter.not_set or
                                self.is_grace_restart_enabled.yfilter != YFilter.not_set or
                                self.is_nsr_enabled.yfilter != YFilter.not_set or
                                self.is_nsr_switchover_on_restart.yfilter != YFilter.not_set or
                                self.is_opaque_capable.yfilter != YFilter.not_set or
                                self.is_role_standby.yfilter != YFilter.not_set or
                                self.is_router_id_stalled.yfilter != YFilter.not_set or
                                self.last_nsf_time.yfilter != YFilter.not_set or
                                self.lsa_flood_pacing_interval.yfilter != YFilter.not_set or
                                self.lsa_group_interval.yfilter != YFilter.not_set or
                                self.lsa_hold_time.yfilter != YFilter.not_set or
                                self.lsa_maximum_time.yfilter != YFilter.not_set or
                                self.lsa_retransmission_pacing_interval.yfilter != YFilter.not_set or
                                self.lsa_start_time.yfilter != YFilter.not_set or
                                self.maximum_interfaces.yfilter != YFilter.not_set or
                                self.maximum_paths.yfilter != YFilter.not_set or
                                self.metric.yfilter != YFilter.not_set or
                                self.minimum_lsa_interval.yfilter != YFilter.not_set or
                                self.normal_areas.yfilter != YFilter.not_set or
                                self.nssa_areas.yfilter != YFilter.not_set or
                                self.opaque_lsa_checksum.yfilter != YFilter.not_set or
                                self.opaque_lsas.yfilter != YFilter.not_set or
                                self.redistribution_limit.yfilter != YFilter.not_set or
                                self.redistribution_threshold.yfilter != YFilter.not_set or
                                self.reference_bandwidth.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.router_id.yfilter != YFilter.not_set or
                                self.snmp_trap_enabled.yfilter != YFilter.not_set or
                                self.spf_hold_time.yfilter != YFilter.not_set or
                                self.spf_maximum_time.yfilter != YFilter.not_set or
                                self.spf_start_time.yfilter != YFilter.not_set or
                                self.stub_areas.yfilter != YFilter.not_set or
                                (self.domain_id is not None and self.domain_id.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ospfv3" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.areas.is_set or self.areas.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.areas.get_name_leafdata())
                            if (self.as_dc_bitless_ls_as.is_set or self.as_dc_bitless_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.as_dc_bitless_ls_as.get_name_leafdata())
                            if (self.as_do_not_age_ls_as.is_set or self.as_do_not_age_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.as_do_not_age_ls_as.get_name_leafdata())
                            if (self.as_ls_as.is_set or self.as_ls_as.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.as_ls_as.get_name_leafdata())
                            if (self.as_lsa_flood_list_length.is_set or self.as_lsa_flood_list_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.as_lsa_flood_list_length.get_name_leafdata())
                            if (self.context_name.is_set or self.context_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.context_name.get_name_leafdata())
                            if (self.default_metric.is_set or self.default_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.default_metric.get_name_leafdata())
                            if (self.default_metric_type.is_set or self.default_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.default_metric_type.get_name_leafdata())
                            if (self.default_policy_name.is_set or self.default_policy_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.default_policy_name.get_name_leafdata())
                            if (self.default_tag.is_set or self.default_tag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.default_tag.get_name_leafdata())
                            if (self.grace_resync_time.is_set or self.grace_resync_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.grace_resync_time.get_name_leafdata())
                            if (self.graceful_shutdown_state.is_set or self.graceful_shutdown_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.graceful_shutdown_state.get_name_leafdata())
                            if (self.is_area_border_router.is_set or self.is_area_border_router.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_area_border_router.get_name_leafdata())
                            if (self.is_as_border_router.is_set or self.is_as_border_router.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_as_border_router.get_name_leafdata())
                            if (self.is_auto_cost.is_set or self.is_auto_cost.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_auto_cost.get_name_leafdata())
                            if (self.is_default_always.is_set or self.is_default_always.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_default_always.get_name_leafdata())
                            if (self.is_default_originated.is_set or self.is_default_originated.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_default_originated.get_name_leafdata())
                            if (self.is_default_policy.is_set or self.is_default_policy.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_default_policy.get_name_leafdata())
                            if (self.is_grace_restart_enabled.is_set or self.is_grace_restart_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_grace_restart_enabled.get_name_leafdata())
                            if (self.is_nsr_enabled.is_set or self.is_nsr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_nsr_enabled.get_name_leafdata())
                            if (self.is_nsr_switchover_on_restart.is_set or self.is_nsr_switchover_on_restart.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_nsr_switchover_on_restart.get_name_leafdata())
                            if (self.is_opaque_capable.is_set or self.is_opaque_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_opaque_capable.get_name_leafdata())
                            if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_role_standby.get_name_leafdata())
                            if (self.is_router_id_stalled.is_set or self.is_router_id_stalled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_router_id_stalled.get_name_leafdata())
                            if (self.last_nsf_time.is_set or self.last_nsf_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_nsf_time.get_name_leafdata())
                            if (self.lsa_flood_pacing_interval.is_set or self.lsa_flood_pacing_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsa_flood_pacing_interval.get_name_leafdata())
                            if (self.lsa_group_interval.is_set or self.lsa_group_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsa_group_interval.get_name_leafdata())
                            if (self.lsa_hold_time.is_set or self.lsa_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsa_hold_time.get_name_leafdata())
                            if (self.lsa_maximum_time.is_set or self.lsa_maximum_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsa_maximum_time.get_name_leafdata())
                            if (self.lsa_retransmission_pacing_interval.is_set or self.lsa_retransmission_pacing_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsa_retransmission_pacing_interval.get_name_leafdata())
                            if (self.lsa_start_time.is_set or self.lsa_start_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsa_start_time.get_name_leafdata())
                            if (self.maximum_interfaces.is_set or self.maximum_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_interfaces.get_name_leafdata())
                            if (self.maximum_paths.is_set or self.maximum_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_paths.get_name_leafdata())
                            if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.metric.get_name_leafdata())
                            if (self.minimum_lsa_interval.is_set or self.minimum_lsa_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.minimum_lsa_interval.get_name_leafdata())
                            if (self.normal_areas.is_set or self.normal_areas.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.normal_areas.get_name_leafdata())
                            if (self.nssa_areas.is_set or self.nssa_areas.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nssa_areas.get_name_leafdata())
                            if (self.opaque_lsa_checksum.is_set or self.opaque_lsa_checksum.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.opaque_lsa_checksum.get_name_leafdata())
                            if (self.opaque_lsas.is_set or self.opaque_lsas.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.opaque_lsas.get_name_leafdata())
                            if (self.redistribution_limit.is_set or self.redistribution_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.redistribution_limit.get_name_leafdata())
                            if (self.redistribution_threshold.is_set or self.redistribution_threshold.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.redistribution_threshold.get_name_leafdata())
                            if (self.reference_bandwidth.is_set or self.reference_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reference_bandwidth.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.router_id.get_name_leafdata())
                            if (self.snmp_trap_enabled.is_set or self.snmp_trap_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.snmp_trap_enabled.get_name_leafdata())
                            if (self.spf_hold_time.is_set or self.spf_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.spf_hold_time.get_name_leafdata())
                            if (self.spf_maximum_time.is_set or self.spf_maximum_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.spf_maximum_time.get_name_leafdata())
                            if (self.spf_start_time.is_set or self.spf_start_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.spf_start_time.get_name_leafdata())
                            if (self.stub_areas.is_set or self.stub_areas.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stub_areas.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "domain-id"):
                                if (self.domain_id is None):
                                    self.domain_id = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.DomainId()
                                    self.domain_id.parent = self
                                    self._children_name_map["domain_id"] = "domain-id"
                                return self.domain_id

                            if (child_yang_name == "ipfrr-tiebreakers"):
                                for c in self.ipfrr_tiebreakers:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.IpfrrTiebreakers()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ipfrr_tiebreakers.append(c)
                                return c

                            if (child_yang_name == "stub-router"):
                                for c in self.stub_router:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3.StubRouter()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.stub_router.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "domain-id" or name == "ipfrr-tiebreakers" or name == "stub-router" or name == "areas" or name == "as-dc-bitless-ls-as" or name == "as-do-not-age-ls-as" or name == "as-ls-as" or name == "as-lsa-flood-list-length" or name == "context-name" or name == "default-metric" or name == "default-metric-type" or name == "default-policy-name" or name == "default-tag" or name == "grace-resync-time" or name == "graceful-shutdown-state" or name == "is-area-border-router" or name == "is-as-border-router" or name == "is-auto-cost" or name == "is-default-always" or name == "is-default-originated" or name == "is-default-policy" or name == "is-grace-restart-enabled" or name == "is-nsr-enabled" or name == "is-nsr-switchover-on-restart" or name == "is-opaque-capable" or name == "is-role-standby" or name == "is-router-id-stalled" or name == "last-nsf-time" or name == "lsa-flood-pacing-interval" or name == "lsa-group-interval" or name == "lsa-hold-time" or name == "lsa-maximum-time" or name == "lsa-retransmission-pacing-interval" or name == "lsa-start-time" or name == "maximum-interfaces" or name == "maximum-paths" or name == "metric" or name == "minimum-lsa-interval" or name == "normal-areas" or name == "nssa-areas" or name == "opaque-lsa-checksum" or name == "opaque-lsas" or name == "redistribution-limit" or name == "redistribution-threshold" or name == "reference-bandwidth" or name == "role" or name == "router-id" or name == "snmp-trap-enabled" or name == "spf-hold-time" or name == "spf-maximum-time" or name == "spf-start-time" or name == "stub-areas"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "areas"):
                                self.areas = value
                                self.areas.value_namespace = name_space
                                self.areas.value_namespace_prefix = name_space_prefix
                            if(value_path == "as-dc-bitless-ls-as"):
                                self.as_dc_bitless_ls_as = value
                                self.as_dc_bitless_ls_as.value_namespace = name_space
                                self.as_dc_bitless_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "as-do-not-age-ls-as"):
                                self.as_do_not_age_ls_as = value
                                self.as_do_not_age_ls_as.value_namespace = name_space
                                self.as_do_not_age_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "as-ls-as"):
                                self.as_ls_as = value
                                self.as_ls_as.value_namespace = name_space
                                self.as_ls_as.value_namespace_prefix = name_space_prefix
                            if(value_path == "as-lsa-flood-list-length"):
                                self.as_lsa_flood_list_length = value
                                self.as_lsa_flood_list_length.value_namespace = name_space
                                self.as_lsa_flood_list_length.value_namespace_prefix = name_space_prefix
                            if(value_path == "context-name"):
                                self.context_name = value
                                self.context_name.value_namespace = name_space
                                self.context_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "default-metric"):
                                self.default_metric = value
                                self.default_metric.value_namespace = name_space
                                self.default_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "default-metric-type"):
                                self.default_metric_type = value
                                self.default_metric_type.value_namespace = name_space
                                self.default_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "default-policy-name"):
                                self.default_policy_name = value
                                self.default_policy_name.value_namespace = name_space
                                self.default_policy_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "default-tag"):
                                self.default_tag = value
                                self.default_tag.value_namespace = name_space
                                self.default_tag.value_namespace_prefix = name_space_prefix
                            if(value_path == "grace-resync-time"):
                                self.grace_resync_time = value
                                self.grace_resync_time.value_namespace = name_space
                                self.grace_resync_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "graceful-shutdown-state"):
                                self.graceful_shutdown_state = value
                                self.graceful_shutdown_state.value_namespace = name_space
                                self.graceful_shutdown_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-area-border-router"):
                                self.is_area_border_router = value
                                self.is_area_border_router.value_namespace = name_space
                                self.is_area_border_router.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-as-border-router"):
                                self.is_as_border_router = value
                                self.is_as_border_router.value_namespace = name_space
                                self.is_as_border_router.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-auto-cost"):
                                self.is_auto_cost = value
                                self.is_auto_cost.value_namespace = name_space
                                self.is_auto_cost.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-default-always"):
                                self.is_default_always = value
                                self.is_default_always.value_namespace = name_space
                                self.is_default_always.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-default-originated"):
                                self.is_default_originated = value
                                self.is_default_originated.value_namespace = name_space
                                self.is_default_originated.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-default-policy"):
                                self.is_default_policy = value
                                self.is_default_policy.value_namespace = name_space
                                self.is_default_policy.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-grace-restart-enabled"):
                                self.is_grace_restart_enabled = value
                                self.is_grace_restart_enabled.value_namespace = name_space
                                self.is_grace_restart_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-nsr-enabled"):
                                self.is_nsr_enabled = value
                                self.is_nsr_enabled.value_namespace = name_space
                                self.is_nsr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-nsr-switchover-on-restart"):
                                self.is_nsr_switchover_on_restart = value
                                self.is_nsr_switchover_on_restart.value_namespace = name_space
                                self.is_nsr_switchover_on_restart.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-opaque-capable"):
                                self.is_opaque_capable = value
                                self.is_opaque_capable.value_namespace = name_space
                                self.is_opaque_capable.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-role-standby"):
                                self.is_role_standby = value
                                self.is_role_standby.value_namespace = name_space
                                self.is_role_standby.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-router-id-stalled"):
                                self.is_router_id_stalled = value
                                self.is_router_id_stalled.value_namespace = name_space
                                self.is_router_id_stalled.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-nsf-time"):
                                self.last_nsf_time = value
                                self.last_nsf_time.value_namespace = name_space
                                self.last_nsf_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsa-flood-pacing-interval"):
                                self.lsa_flood_pacing_interval = value
                                self.lsa_flood_pacing_interval.value_namespace = name_space
                                self.lsa_flood_pacing_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsa-group-interval"):
                                self.lsa_group_interval = value
                                self.lsa_group_interval.value_namespace = name_space
                                self.lsa_group_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsa-hold-time"):
                                self.lsa_hold_time = value
                                self.lsa_hold_time.value_namespace = name_space
                                self.lsa_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsa-maximum-time"):
                                self.lsa_maximum_time = value
                                self.lsa_maximum_time.value_namespace = name_space
                                self.lsa_maximum_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsa-retransmission-pacing-interval"):
                                self.lsa_retransmission_pacing_interval = value
                                self.lsa_retransmission_pacing_interval.value_namespace = name_space
                                self.lsa_retransmission_pacing_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsa-start-time"):
                                self.lsa_start_time = value
                                self.lsa_start_time.value_namespace = name_space
                                self.lsa_start_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-interfaces"):
                                self.maximum_interfaces = value
                                self.maximum_interfaces.value_namespace = name_space
                                self.maximum_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-paths"):
                                self.maximum_paths = value
                                self.maximum_paths.value_namespace = name_space
                                self.maximum_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "metric"):
                                self.metric = value
                                self.metric.value_namespace = name_space
                                self.metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "minimum-lsa-interval"):
                                self.minimum_lsa_interval = value
                                self.minimum_lsa_interval.value_namespace = name_space
                                self.minimum_lsa_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "normal-areas"):
                                self.normal_areas = value
                                self.normal_areas.value_namespace = name_space
                                self.normal_areas.value_namespace_prefix = name_space_prefix
                            if(value_path == "nssa-areas"):
                                self.nssa_areas = value
                                self.nssa_areas.value_namespace = name_space
                                self.nssa_areas.value_namespace_prefix = name_space_prefix
                            if(value_path == "opaque-lsa-checksum"):
                                self.opaque_lsa_checksum = value
                                self.opaque_lsa_checksum.value_namespace = name_space
                                self.opaque_lsa_checksum.value_namespace_prefix = name_space_prefix
                            if(value_path == "opaque-lsas"):
                                self.opaque_lsas = value
                                self.opaque_lsas.value_namespace = name_space
                                self.opaque_lsas.value_namespace_prefix = name_space_prefix
                            if(value_path == "redistribution-limit"):
                                self.redistribution_limit = value
                                self.redistribution_limit.value_namespace = name_space
                                self.redistribution_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "redistribution-threshold"):
                                self.redistribution_threshold = value
                                self.redistribution_threshold.value_namespace = name_space
                                self.redistribution_threshold.value_namespace_prefix = name_space_prefix
                            if(value_path == "reference-bandwidth"):
                                self.reference_bandwidth = value
                                self.reference_bandwidth.value_namespace = name_space
                                self.reference_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "router-id"):
                                self.router_id = value
                                self.router_id.value_namespace = name_space
                                self.router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "snmp-trap-enabled"):
                                self.snmp_trap_enabled = value
                                self.snmp_trap_enabled.value_namespace = name_space
                                self.snmp_trap_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "spf-hold-time"):
                                self.spf_hold_time = value
                                self.spf_hold_time.value_namespace = name_space
                                self.spf_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "spf-maximum-time"):
                                self.spf_maximum_time = value
                                self.spf_maximum_time.value_namespace = name_space
                                self.spf_maximum_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "spf-start-time"):
                                self.spf_start_time = value
                                self.spf_start_time.value_namespace = name_space
                                self.spf_start_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "stub-areas"):
                                self.stub_areas = value
                                self.stub_areas.value_namespace = name_space
                                self.stub_areas.value_namespace_prefix = name_space_prefix


                    class Route(Entity):
                        """
                        OSPFv3 route summary
                        
                        .. attribute:: extern_one_route
                        
                        	Extern 1 route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: extern_two_route
                        
                        	Extern 2 route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: inter_area_route
                        
                        	Inter route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: intra_area_route
                        
                        	Intra route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nssa_one_route
                        
                        	NSSA 1 route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nssa_two_route
                        
                        	NSSA 2 route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: redistribution_route
                        
                        	Redistribution route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: route_connected
                        
                        	Route connected 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: route_id
                        
                        	Route summary of a route ID 
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: total_received_route
                        
                        	Total route received summary
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_sent_route
                        
                        	Total route summary 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.Summary.Route, self).__init__()

                            self.yang_name = "route"
                            self.yang_parent_name = "summary"

                            self.extern_one_route = YLeaf(YType.uint32, "extern-one-route")

                            self.extern_two_route = YLeaf(YType.uint32, "extern-two-route")

                            self.inter_area_route = YLeaf(YType.uint32, "inter-area-route")

                            self.intra_area_route = YLeaf(YType.uint32, "intra-area-route")

                            self.nssa_one_route = YLeaf(YType.uint32, "nssa-one-route")

                            self.nssa_two_route = YLeaf(YType.uint32, "nssa-two-route")

                            self.redistribution_route = YLeaf(YType.uint32, "redistribution-route")

                            self.route_connected = YLeaf(YType.uint32, "route-connected")

                            self.route_id = YLeaf(YType.str, "route-id")

                            self.total_received_route = YLeaf(YType.uint32, "total-received-route")

                            self.total_sent_route = YLeaf(YType.uint32, "total-sent-route")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("extern_one_route",
                                            "extern_two_route",
                                            "inter_area_route",
                                            "intra_area_route",
                                            "nssa_one_route",
                                            "nssa_two_route",
                                            "redistribution_route",
                                            "route_connected",
                                            "route_id",
                                            "total_received_route",
                                            "total_sent_route") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.Summary.Route, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.Summary.Route, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.extern_one_route.is_set or
                                self.extern_two_route.is_set or
                                self.inter_area_route.is_set or
                                self.intra_area_route.is_set or
                                self.nssa_one_route.is_set or
                                self.nssa_two_route.is_set or
                                self.redistribution_route.is_set or
                                self.route_connected.is_set or
                                self.route_id.is_set or
                                self.total_received_route.is_set or
                                self.total_sent_route.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.extern_one_route.yfilter != YFilter.not_set or
                                self.extern_two_route.yfilter != YFilter.not_set or
                                self.inter_area_route.yfilter != YFilter.not_set or
                                self.intra_area_route.yfilter != YFilter.not_set or
                                self.nssa_one_route.yfilter != YFilter.not_set or
                                self.nssa_two_route.yfilter != YFilter.not_set or
                                self.redistribution_route.yfilter != YFilter.not_set or
                                self.route_connected.yfilter != YFilter.not_set or
                                self.route_id.yfilter != YFilter.not_set or
                                self.total_received_route.yfilter != YFilter.not_set or
                                self.total_sent_route.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "route" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.extern_one_route.is_set or self.extern_one_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.extern_one_route.get_name_leafdata())
                            if (self.extern_two_route.is_set or self.extern_two_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.extern_two_route.get_name_leafdata())
                            if (self.inter_area_route.is_set or self.inter_area_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.inter_area_route.get_name_leafdata())
                            if (self.intra_area_route.is_set or self.intra_area_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.intra_area_route.get_name_leafdata())
                            if (self.nssa_one_route.is_set or self.nssa_one_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nssa_one_route.get_name_leafdata())
                            if (self.nssa_two_route.is_set or self.nssa_two_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nssa_two_route.get_name_leafdata())
                            if (self.redistribution_route.is_set or self.redistribution_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.redistribution_route.get_name_leafdata())
                            if (self.route_connected.is_set or self.route_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.route_connected.get_name_leafdata())
                            if (self.route_id.is_set or self.route_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.route_id.get_name_leafdata())
                            if (self.total_received_route.is_set or self.total_received_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_received_route.get_name_leafdata())
                            if (self.total_sent_route.is_set or self.total_sent_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_sent_route.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "extern-one-route" or name == "extern-two-route" or name == "inter-area-route" or name == "intra-area-route" or name == "nssa-one-route" or name == "nssa-two-route" or name == "redistribution-route" or name == "route-connected" or name == "route-id" or name == "total-received-route" or name == "total-sent-route"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "extern-one-route"):
                                self.extern_one_route = value
                                self.extern_one_route.value_namespace = name_space
                                self.extern_one_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "extern-two-route"):
                                self.extern_two_route = value
                                self.extern_two_route.value_namespace = name_space
                                self.extern_two_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "inter-area-route"):
                                self.inter_area_route = value
                                self.inter_area_route.value_namespace = name_space
                                self.inter_area_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "intra-area-route"):
                                self.intra_area_route = value
                                self.intra_area_route.value_namespace = name_space
                                self.intra_area_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "nssa-one-route"):
                                self.nssa_one_route = value
                                self.nssa_one_route.value_namespace = name_space
                                self.nssa_one_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "nssa-two-route"):
                                self.nssa_two_route = value
                                self.nssa_two_route.value_namespace = name_space
                                self.nssa_two_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "redistribution-route"):
                                self.redistribution_route = value
                                self.redistribution_route.value_namespace = name_space
                                self.redistribution_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "route-connected"):
                                self.route_connected = value
                                self.route_connected.value_namespace = name_space
                                self.route_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "route-id"):
                                self.route_id = value
                                self.route_id.value_namespace = name_space
                                self.route_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-received-route"):
                                self.total_received_route = value
                                self.total_received_route.value_namespace = name_space
                                self.total_received_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-sent-route"):
                                self.total_sent_route = value
                                self.total_sent_route.value_namespace = name_space
                                self.total_sent_route.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.ospfv3 is not None and self.ospfv3.has_data()) or
                            (self.protocol is not None and self.protocol.has_data()) or
                            (self.route is not None and self.route.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.ospfv3 is not None and self.ospfv3.has_operation()) or
                            (self.protocol is not None and self.protocol.has_operation()) or
                            (self.route is not None and self.route.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "summary" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ospfv3"):
                            if (self.ospfv3 is None):
                                self.ospfv3 = Ospfv3.Processes.Process.DefaultVrf.Summary.Ospfv3()
                                self.ospfv3.parent = self
                                self._children_name_map["ospfv3"] = "ospfv3"
                            return self.ospfv3

                        if (child_yang_name == "protocol"):
                            if (self.protocol is None):
                                self.protocol = Ospfv3.Processes.Process.DefaultVrf.Summary.Protocol()
                                self.protocol.parent = self
                                self._children_name_map["protocol"] = "protocol"
                            return self.protocol

                        if (child_yang_name == "route"):
                            if (self.route is None):
                                self.route = Ospfv3.Processes.Process.DefaultVrf.Summary.Route()
                                self.route.parent = self
                                self._children_name_map["route"] = "route"
                            return self.route

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ospfv3" or name == "protocol" or name == "route"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class RetransmissionListProcessTable(Entity):
                    """
                    OSPFv3 retransmission list information table for
                    all areas
                    
                    .. attribute:: retransmission
                    
                    	OSPFv3 retransmission list information
                    	**type**\: list of    :py:class:`Retransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable, self).__init__()

                        self.yang_name = "retransmission-list-process-table"
                        self.yang_parent_name = "default-vrf"

                        self.retransmission = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable, self).__setattr__(name, value)


                    class Retransmission(Entity):
                        """
                        OSPFv3 retransmission list information
                        
                        .. attribute:: interface_name
                        
                        	Interface name
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: is_retransmission_sham_link
                        
                        	If true, sham link is retransmitted 
                        	**type**\:  bool
                        
                        .. attribute:: is_retransmissionvirtual_link
                        
                        	If true, virtual link is retransmitted 
                        	**type**\:  bool
                        
                        .. attribute:: neighbor_address
                        
                        	Neighbor address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: retransmission_area_db
                        
                        	List of area scope entries
                        	**type**\: list of    :py:class:`RetransmissionAreaDb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionAreaDb>`
                        
                        .. attribute:: retransmission_asdb
                        
                        	List of AS scope entries
                        	**type**\: list of    :py:class:`RetransmissionAsdb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionAsdb>`
                        
                        .. attribute:: retransmission_length
                        
                        	Retransmission queue length
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: retransmission_neighbor_address
                        
                        	Neighbor IP address
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: retransmission_sham_link_id
                        
                        	Retransmission sham link ID 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: retransmission_timer
                        
                        	Amount of time remaining on retransmission timer (ms)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: retransmissionvirtual_link_db
                        
                        	List of virtual link scope entries 
                        	**type**\: list of    :py:class:`RetransmissionvirtualLinkDb <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionvirtualLinkDb>`
                        
                        .. attribute:: retransmissionvirtual_link_id
                        
                        	Retransmission virtual link ID 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission, self).__init__()

                            self.yang_name = "retransmission"
                            self.yang_parent_name = "retransmission-list-process-table"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.is_retransmission_sham_link = YLeaf(YType.boolean, "is-retransmission-sham-link")

                            self.is_retransmissionvirtual_link = YLeaf(YType.boolean, "is-retransmissionvirtual-link")

                            self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                            self.retransmission_length = YLeaf(YType.uint32, "retransmission-length")

                            self.retransmission_neighbor_address = YLeaf(YType.str, "retransmission-neighbor-address")

                            self.retransmission_sham_link_id = YLeaf(YType.uint32, "retransmission-sham-link-id")

                            self.retransmission_timer = YLeaf(YType.uint32, "retransmission-timer")

                            self.retransmissionvirtual_link_id = YLeaf(YType.uint32, "retransmissionvirtual-link-id")

                            self.retransmission_area_db = YList(self)
                            self.retransmission_asdb = YList(self)
                            self.retransmissionvirtual_link_db = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "is_retransmission_sham_link",
                                            "is_retransmissionvirtual_link",
                                            "neighbor_address",
                                            "retransmission_length",
                                            "retransmission_neighbor_address",
                                            "retransmission_sham_link_id",
                                            "retransmission_timer",
                                            "retransmissionvirtual_link_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission, self).__setattr__(name, value)


                        class RetransmissionvirtualLinkDb(Entity):
                            """
                            List of virtual link scope entries 
                            
                            .. attribute:: header_advertising_router
                            
                            	Router ID of the advertising router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_age
                            
                            	Age of the LSA (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: header_lsa_id
                            
                            	LSA ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_type
                            
                            	LSA type
                            	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                            
                            .. attribute:: header_sequence_number
                            
                            	Current LSA sequence number
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionvirtualLinkDb, self).__init__()

                                self.yang_name = "retransmissionvirtual-link-db"
                                self.yang_parent_name = "retransmission"

                                self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("header_advertising_router",
                                                "header_lsa_age",
                                                "header_lsa_id",
                                                "header_lsa_type",
                                                "header_sequence_number") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionvirtualLinkDb, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionvirtualLinkDb, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.header_advertising_router.is_set or
                                    self.header_lsa_age.is_set or
                                    self.header_lsa_id.is_set or
                                    self.header_lsa_type.is_set or
                                    self.header_sequence_number.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.header_advertising_router.yfilter != YFilter.not_set or
                                    self.header_lsa_age.yfilter != YFilter.not_set or
                                    self.header_lsa_id.yfilter != YFilter.not_set or
                                    self.header_lsa_type.yfilter != YFilter.not_set or
                                    self.header_sequence_number.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "retransmissionvirtual-link-db" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "header-advertising-router"):
                                    self.header_advertising_router = value
                                    self.header_advertising_router.value_namespace = name_space
                                    self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-age"):
                                    self.header_lsa_age = value
                                    self.header_lsa_age.value_namespace = name_space
                                    self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-id"):
                                    self.header_lsa_id = value
                                    self.header_lsa_id.value_namespace = name_space
                                    self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-type"):
                                    self.header_lsa_type = value
                                    self.header_lsa_type.value_namespace = name_space
                                    self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-sequence-number"):
                                    self.header_sequence_number = value
                                    self.header_sequence_number.value_namespace = name_space
                                    self.header_sequence_number.value_namespace_prefix = name_space_prefix


                        class RetransmissionAreaDb(Entity):
                            """
                            List of area scope entries
                            
                            .. attribute:: header_advertising_router
                            
                            	Router ID of the advertising router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_age
                            
                            	Age of the LSA (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: header_lsa_id
                            
                            	LSA ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_type
                            
                            	LSA type
                            	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                            
                            .. attribute:: header_sequence_number
                            
                            	Current LSA sequence number
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionAreaDb, self).__init__()

                                self.yang_name = "retransmission-area-db"
                                self.yang_parent_name = "retransmission"

                                self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("header_advertising_router",
                                                "header_lsa_age",
                                                "header_lsa_id",
                                                "header_lsa_type",
                                                "header_sequence_number") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionAreaDb, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionAreaDb, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.header_advertising_router.is_set or
                                    self.header_lsa_age.is_set or
                                    self.header_lsa_id.is_set or
                                    self.header_lsa_type.is_set or
                                    self.header_sequence_number.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.header_advertising_router.yfilter != YFilter.not_set or
                                    self.header_lsa_age.yfilter != YFilter.not_set or
                                    self.header_lsa_id.yfilter != YFilter.not_set or
                                    self.header_lsa_type.yfilter != YFilter.not_set or
                                    self.header_sequence_number.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "retransmission-area-db" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "header-advertising-router"):
                                    self.header_advertising_router = value
                                    self.header_advertising_router.value_namespace = name_space
                                    self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-age"):
                                    self.header_lsa_age = value
                                    self.header_lsa_age.value_namespace = name_space
                                    self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-id"):
                                    self.header_lsa_id = value
                                    self.header_lsa_id.value_namespace = name_space
                                    self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-type"):
                                    self.header_lsa_type = value
                                    self.header_lsa_type.value_namespace = name_space
                                    self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-sequence-number"):
                                    self.header_sequence_number = value
                                    self.header_sequence_number.value_namespace = name_space
                                    self.header_sequence_number.value_namespace_prefix = name_space_prefix


                        class RetransmissionAsdb(Entity):
                            """
                            List of AS scope entries
                            
                            .. attribute:: header_advertising_router
                            
                            	Router ID of the advertising router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_age
                            
                            	Age of the LSA (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: header_lsa_id
                            
                            	LSA ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: header_lsa_type
                            
                            	LSA type
                            	**type**\:   :py:class:`Ospfv3Lsa1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Lsa1>`
                            
                            .. attribute:: header_sequence_number
                            
                            	Current LSA sequence number
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionAsdb, self).__init__()

                                self.yang_name = "retransmission-asdb"
                                self.yang_parent_name = "retransmission"

                                self.header_advertising_router = YLeaf(YType.str, "header-advertising-router")

                                self.header_lsa_age = YLeaf(YType.uint16, "header-lsa-age")

                                self.header_lsa_id = YLeaf(YType.str, "header-lsa-id")

                                self.header_lsa_type = YLeaf(YType.enumeration, "header-lsa-type")

                                self.header_sequence_number = YLeaf(YType.int32, "header-sequence-number")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("header_advertising_router",
                                                "header_lsa_age",
                                                "header_lsa_id",
                                                "header_lsa_type",
                                                "header_sequence_number") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionAsdb, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionAsdb, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.header_advertising_router.is_set or
                                    self.header_lsa_age.is_set or
                                    self.header_lsa_id.is_set or
                                    self.header_lsa_type.is_set or
                                    self.header_sequence_number.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.header_advertising_router.yfilter != YFilter.not_set or
                                    self.header_lsa_age.yfilter != YFilter.not_set or
                                    self.header_lsa_id.yfilter != YFilter.not_set or
                                    self.header_lsa_type.yfilter != YFilter.not_set or
                                    self.header_sequence_number.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "retransmission-asdb" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.header_advertising_router.is_set or self.header_advertising_router.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_advertising_router.get_name_leafdata())
                                if (self.header_lsa_age.is_set or self.header_lsa_age.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_age.get_name_leafdata())
                                if (self.header_lsa_id.is_set or self.header_lsa_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_id.get_name_leafdata())
                                if (self.header_lsa_type.is_set or self.header_lsa_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_lsa_type.get_name_leafdata())
                                if (self.header_sequence_number.is_set or self.header_sequence_number.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.header_sequence_number.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "header-advertising-router" or name == "header-lsa-age" or name == "header-lsa-id" or name == "header-lsa-type" or name == "header-sequence-number"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "header-advertising-router"):
                                    self.header_advertising_router = value
                                    self.header_advertising_router.value_namespace = name_space
                                    self.header_advertising_router.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-age"):
                                    self.header_lsa_age = value
                                    self.header_lsa_age.value_namespace = name_space
                                    self.header_lsa_age.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-id"):
                                    self.header_lsa_id = value
                                    self.header_lsa_id.value_namespace = name_space
                                    self.header_lsa_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-lsa-type"):
                                    self.header_lsa_type = value
                                    self.header_lsa_type.value_namespace = name_space
                                    self.header_lsa_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "header-sequence-number"):
                                    self.header_sequence_number = value
                                    self.header_sequence_number.value_namespace = name_space
                                    self.header_sequence_number.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.retransmission_area_db:
                                if (c.has_data()):
                                    return True
                            for c in self.retransmission_asdb:
                                if (c.has_data()):
                                    return True
                            for c in self.retransmissionvirtual_link_db:
                                if (c.has_data()):
                                    return True
                            return (
                                self.interface_name.is_set or
                                self.is_retransmission_sham_link.is_set or
                                self.is_retransmissionvirtual_link.is_set or
                                self.neighbor_address.is_set or
                                self.retransmission_length.is_set or
                                self.retransmission_neighbor_address.is_set or
                                self.retransmission_sham_link_id.is_set or
                                self.retransmission_timer.is_set or
                                self.retransmissionvirtual_link_id.is_set)

                        def has_operation(self):
                            for c in self.retransmission_area_db:
                                if (c.has_operation()):
                                    return True
                            for c in self.retransmission_asdb:
                                if (c.has_operation()):
                                    return True
                            for c in self.retransmissionvirtual_link_db:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.is_retransmission_sham_link.yfilter != YFilter.not_set or
                                self.is_retransmissionvirtual_link.yfilter != YFilter.not_set or
                                self.neighbor_address.yfilter != YFilter.not_set or
                                self.retransmission_length.yfilter != YFilter.not_set or
                                self.retransmission_neighbor_address.yfilter != YFilter.not_set or
                                self.retransmission_sham_link_id.yfilter != YFilter.not_set or
                                self.retransmission_timer.yfilter != YFilter.not_set or
                                self.retransmissionvirtual_link_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "retransmission" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.is_retransmission_sham_link.is_set or self.is_retransmission_sham_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_retransmission_sham_link.get_name_leafdata())
                            if (self.is_retransmissionvirtual_link.is_set or self.is_retransmissionvirtual_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_retransmissionvirtual_link.get_name_leafdata())
                            if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                            if (self.retransmission_length.is_set or self.retransmission_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.retransmission_length.get_name_leafdata())
                            if (self.retransmission_neighbor_address.is_set or self.retransmission_neighbor_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.retransmission_neighbor_address.get_name_leafdata())
                            if (self.retransmission_sham_link_id.is_set or self.retransmission_sham_link_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.retransmission_sham_link_id.get_name_leafdata())
                            if (self.retransmission_timer.is_set or self.retransmission_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.retransmission_timer.get_name_leafdata())
                            if (self.retransmissionvirtual_link_id.is_set or self.retransmissionvirtual_link_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.retransmissionvirtual_link_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "retransmission-area-db"):
                                for c in self.retransmission_area_db:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionAreaDb()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.retransmission_area_db.append(c)
                                return c

                            if (child_yang_name == "retransmission-asdb"):
                                for c in self.retransmission_asdb:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionAsdb()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.retransmission_asdb.append(c)
                                return c

                            if (child_yang_name == "retransmissionvirtual-link-db"):
                                for c in self.retransmissionvirtual_link_db:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission.RetransmissionvirtualLinkDb()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.retransmissionvirtual_link_db.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "retransmission-area-db" or name == "retransmission-asdb" or name == "retransmissionvirtual-link-db" or name == "interface-name" or name == "is-retransmission-sham-link" or name == "is-retransmissionvirtual-link" or name == "neighbor-address" or name == "retransmission-length" or name == "retransmission-neighbor-address" or name == "retransmission-sham-link-id" or name == "retransmission-timer" or name == "retransmissionvirtual-link-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-retransmission-sham-link"):
                                self.is_retransmission_sham_link = value
                                self.is_retransmission_sham_link.value_namespace = name_space
                                self.is_retransmission_sham_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-retransmissionvirtual-link"):
                                self.is_retransmissionvirtual_link = value
                                self.is_retransmissionvirtual_link.value_namespace = name_space
                                self.is_retransmissionvirtual_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-address"):
                                self.neighbor_address = value
                                self.neighbor_address.value_namespace = name_space
                                self.neighbor_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "retransmission-length"):
                                self.retransmission_length = value
                                self.retransmission_length.value_namespace = name_space
                                self.retransmission_length.value_namespace_prefix = name_space_prefix
                            if(value_path == "retransmission-neighbor-address"):
                                self.retransmission_neighbor_address = value
                                self.retransmission_neighbor_address.value_namespace = name_space
                                self.retransmission_neighbor_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "retransmission-sham-link-id"):
                                self.retransmission_sham_link_id = value
                                self.retransmission_sham_link_id.value_namespace = name_space
                                self.retransmission_sham_link_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "retransmission-timer"):
                                self.retransmission_timer = value
                                self.retransmission_timer.value_namespace = name_space
                                self.retransmission_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "retransmissionvirtual-link-id"):
                                self.retransmissionvirtual_link_id = value
                                self.retransmissionvirtual_link_id.value_namespace = name_space
                                self.retransmissionvirtual_link_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.retransmission:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.retransmission:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "retransmission-list-process-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "retransmission"):
                            for c in self.retransmission:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable.Retransmission()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.retransmission.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "retransmission"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class BadChecksums(Entity):
                    """
                    Bad Checksum Packets information table
                    
                    .. attribute:: bad_checksum
                    
                    	Bad Checksum Packet information
                    	**type**\: list of    :py:class:`BadChecksum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.BadChecksums, self).__init__()

                        self.yang_name = "bad-checksums"
                        self.yang_parent_name = "default-vrf"

                        self.bad_checksum = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.BadChecksums, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.BadChecksums, self).__setattr__(name, value)


                    class BadChecksum(Entity):
                        """
                        Bad Checksum Packet information
                        
                        .. attribute:: packet_number  <key>
                        
                        	Bad Checksum Packets number
                        	**type**\:  int
                        
                        	**range:** 0..9
                        
                        .. attribute:: computed_checksum
                        
                        	Computed Checksum
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: received_checksum
                        
                        	Received Checksum
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: received_data
                        
                        	Received Hexadecimal Data
                        	**type**\:  str
                        
                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                        
                        .. attribute:: timestamp
                        
                        	Packet Timestamp (relative to 1970/1/1 00\:00)
                        	**type**\:   :py:class:`Timestamp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum.Timestamp>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum, self).__init__()

                            self.yang_name = "bad-checksum"
                            self.yang_parent_name = "bad-checksums"

                            self.packet_number = YLeaf(YType.uint32, "packet-number")

                            self.computed_checksum = YLeaf(YType.uint16, "computed-checksum")

                            self.received_checksum = YLeaf(YType.uint16, "received-checksum")

                            self.received_data = YLeaf(YType.str, "received-data")

                            self.timestamp = Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum.Timestamp()
                            self.timestamp.parent = self
                            self._children_name_map["timestamp"] = "timestamp"
                            self._children_yang_names.add("timestamp")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("packet_number",
                                            "computed_checksum",
                                            "received_checksum",
                                            "received_data") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum, self).__setattr__(name, value)


                        class Timestamp(Entity):
                            """
                            Packet Timestamp (relative to 1970/1/1 00\:00)
                            
                            .. attribute:: nanosecond
                            
                            	Nano seconds 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: second
                            
                            	Seconds 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum.Timestamp, self).__init__()

                                self.yang_name = "timestamp"
                                self.yang_parent_name = "bad-checksum"

                                self.nanosecond = YLeaf(YType.uint32, "nanosecond")

                                self.second = YLeaf(YType.uint32, "second")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nanosecond",
                                                "second") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum.Timestamp, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum.Timestamp, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nanosecond.is_set or
                                    self.second.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nanosecond.yfilter != YFilter.not_set or
                                    self.second.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "timestamp" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nanosecond.is_set or self.nanosecond.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nanosecond.get_name_leafdata())
                                if (self.second.is_set or self.second.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.second.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nanosecond" or name == "second"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nanosecond"):
                                    self.nanosecond = value
                                    self.nanosecond.value_namespace = name_space
                                    self.nanosecond.value_namespace_prefix = name_space_prefix
                                if(value_path == "second"):
                                    self.second = value
                                    self.second.value_namespace = name_space
                                    self.second.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.packet_number.is_set or
                                self.computed_checksum.is_set or
                                self.received_checksum.is_set or
                                self.received_data.is_set or
                                (self.timestamp is not None and self.timestamp.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.packet_number.yfilter != YFilter.not_set or
                                self.computed_checksum.yfilter != YFilter.not_set or
                                self.received_checksum.yfilter != YFilter.not_set or
                                self.received_data.yfilter != YFilter.not_set or
                                (self.timestamp is not None and self.timestamp.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bad-checksum" + "[packet-number='" + self.packet_number.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.packet_number.is_set or self.packet_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.packet_number.get_name_leafdata())
                            if (self.computed_checksum.is_set or self.computed_checksum.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.computed_checksum.get_name_leafdata())
                            if (self.received_checksum.is_set or self.received_checksum.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.received_checksum.get_name_leafdata())
                            if (self.received_data.is_set or self.received_data.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.received_data.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "timestamp"):
                                if (self.timestamp is None):
                                    self.timestamp = Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum.Timestamp()
                                    self.timestamp.parent = self
                                    self._children_name_map["timestamp"] = "timestamp"
                                return self.timestamp

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "timestamp" or name == "packet-number" or name == "computed-checksum" or name == "received-checksum" or name == "received-data"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "packet-number"):
                                self.packet_number = value
                                self.packet_number.value_namespace = name_space
                                self.packet_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "computed-checksum"):
                                self.computed_checksum = value
                                self.computed_checksum.value_namespace = name_space
                                self.computed_checksum.value_namespace_prefix = name_space_prefix
                            if(value_path == "received-checksum"):
                                self.received_checksum = value
                                self.received_checksum.value_namespace = name_space
                                self.received_checksum.value_namespace_prefix = name_space_prefix
                            if(value_path == "received-data"):
                                self.received_data = value
                                self.received_data.value_namespace = name_space
                                self.received_data.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.bad_checksum:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.bad_checksum:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bad-checksums" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "bad-checksum"):
                            for c in self.bad_checksum:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.BadChecksums.BadChecksum()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.bad_checksum.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bad-checksum"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class DatabaseSummaryTable(Entity):
                    """
                    Database summary table
                    
                    .. attribute:: database_summary
                    
                    	Database Summary information
                    	**type**\:   :py:class:`DatabaseSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable, self).__init__()

                        self.yang_name = "database-summary-table"
                        self.yang_parent_name = "default-vrf"

                        self.database_summary = Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary()
                        self.database_summary.parent = self
                        self._children_name_map["database_summary"] = "database-summary"
                        self._children_yang_names.add("database-summary")


                    class DatabaseSummary(Entity):
                        """
                        Database Summary information
                        
                        .. attribute:: area_database
                        
                        	OSPFv3 Area Database list 
                        	**type**\: list of    :py:class:`AreaDatabase <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase>`
                        
                        .. attribute:: database_counters
                        
                        	OSPFv3 database counters 
                        	**type**\:   :py:class:`DatabaseCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters>`
                        
                        .. attribute:: database_router_id
                        
                        	Database router ID 
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: is_opaque_database_capable
                        
                        	If true, opaque database is capable 
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary, self).__init__()

                            self.yang_name = "database-summary"
                            self.yang_parent_name = "database-summary-table"

                            self.database_router_id = YLeaf(YType.str, "database-router-id")

                            self.is_opaque_database_capable = YLeaf(YType.boolean, "is-opaque-database-capable")

                            self.database_counters = Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters()
                            self.database_counters.parent = self
                            self._children_name_map["database_counters"] = "database-counters"
                            self._children_yang_names.add("database-counters")

                            self.area_database = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("database_router_id",
                                            "is_opaque_database_capable") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary, self).__setattr__(name, value)


                        class DatabaseCounters(Entity):
                            """
                            OSPFv3 database counters 
                            
                            .. attribute:: deleted_lsa
                            
                            	deleted lsa
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa
                            
                            	lsa
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsa_checksum
                            
                            	lsa checksum
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: max_age_lsa
                            
                            	max age lsa
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__init__()

                                self.yang_name = "database-counters"
                                self.yang_parent_name = "database-summary"

                                self.deleted_lsa = YLeafList(YType.uint32, "deleted-lsa")

                                self.lsa = YLeafList(YType.uint32, "lsa")

                                self.lsa_checksum = YLeafList(YType.uint32, "lsa-checksum")

                                self.max_age_lsa = YLeafList(YType.uint32, "max-age-lsa")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("deleted_lsa",
                                                "lsa",
                                                "lsa_checksum",
                                                "max_age_lsa") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters, self).__setattr__(name, value)

                            def has_data(self):
                                for leaf in self.deleted_lsa.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                for leaf in self.lsa.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                for leaf in self.lsa_checksum.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                for leaf in self.max_age_lsa.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                return False

                            def has_operation(self):
                                for leaf in self.deleted_lsa.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                for leaf in self.lsa.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                for leaf in self.lsa_checksum.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                for leaf in self.max_age_lsa.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.deleted_lsa.yfilter != YFilter.not_set or
                                    self.lsa.yfilter != YFilter.not_set or
                                    self.lsa_checksum.yfilter != YFilter.not_set or
                                    self.max_age_lsa.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "database-counters" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                leaf_name_data.extend(self.deleted_lsa.get_name_leafdata())

                                leaf_name_data.extend(self.lsa.get_name_leafdata())

                                leaf_name_data.extend(self.lsa_checksum.get_name_leafdata())

                                leaf_name_data.extend(self.max_age_lsa.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "deleted-lsa" or name == "lsa" or name == "lsa-checksum" or name == "max-age-lsa"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "deleted-lsa"):
                                    self.deleted_lsa.append(value)
                                if(value_path == "lsa"):
                                    self.lsa.append(value)
                                if(value_path == "lsa-checksum"):
                                    self.lsa_checksum.append(value)
                                if(value_path == "max-age-lsa"):
                                    self.max_age_lsa.append(value)


                        class AreaDatabase(Entity):
                            """
                            OSPFv3 Area Database list 
                            
                            .. attribute:: area_database_summary
                            
                            	Area database summary 
                            	**type**\:   :py:class:`AreaDatabaseSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary>`
                            
                            .. attribute:: lsa_area_id
                            
                            	Area ID in decimal or dotted\-decimal format
                            	**type**\:  str
                            
                            	**length:** 0..16
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__init__()

                                self.yang_name = "area-database"
                                self.yang_parent_name = "database-summary"

                                self.lsa_area_id = YLeaf(YType.str, "lsa-area-id")

                                self.area_database_summary = Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary()
                                self.area_database_summary.parent = self
                                self._children_name_map["area_database_summary"] = "area-database-summary"
                                self._children_yang_names.add("area-database-summary")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsa_area_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase, self).__setattr__(name, value)


                            class AreaDatabaseSummary(Entity):
                                """
                                Area database summary 
                                
                                .. attribute:: deleted_lsa
                                
                                	deleted lsa
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsa
                                
                                	lsa
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsa_checksum
                                
                                	lsa checksum
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: max_age_lsa
                                
                                	max age lsa
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__init__()

                                    self.yang_name = "area-database-summary"
                                    self.yang_parent_name = "area-database"

                                    self.deleted_lsa = YLeafList(YType.uint32, "deleted-lsa")

                                    self.lsa = YLeafList(YType.uint32, "lsa")

                                    self.lsa_checksum = YLeafList(YType.uint32, "lsa-checksum")

                                    self.max_age_lsa = YLeafList(YType.uint32, "max-age-lsa")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deleted_lsa",
                                                    "lsa",
                                                    "lsa_checksum",
                                                    "max_age_lsa") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary, self).__setattr__(name, value)

                                def has_data(self):
                                    for leaf in self.deleted_lsa.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    for leaf in self.lsa.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    for leaf in self.lsa_checksum.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    for leaf in self.max_age_lsa.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    return False

                                def has_operation(self):
                                    for leaf in self.deleted_lsa.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    for leaf in self.lsa.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    for leaf in self.lsa_checksum.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    for leaf in self.max_age_lsa.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deleted_lsa.yfilter != YFilter.not_set or
                                        self.lsa.yfilter != YFilter.not_set or
                                        self.lsa_checksum.yfilter != YFilter.not_set or
                                        self.max_age_lsa.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "area-database-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    leaf_name_data.extend(self.deleted_lsa.get_name_leafdata())

                                    leaf_name_data.extend(self.lsa.get_name_leafdata())

                                    leaf_name_data.extend(self.lsa_checksum.get_name_leafdata())

                                    leaf_name_data.extend(self.max_age_lsa.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deleted-lsa" or name == "lsa" or name == "lsa-checksum" or name == "max-age-lsa"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deleted-lsa"):
                                        self.deleted_lsa.append(value)
                                    if(value_path == "lsa"):
                                        self.lsa.append(value)
                                    if(value_path == "lsa-checksum"):
                                        self.lsa_checksum.append(value)
                                    if(value_path == "max-age-lsa"):
                                        self.max_age_lsa.append(value)

                            def has_data(self):
                                return (
                                    self.lsa_area_id.is_set or
                                    (self.area_database_summary is not None and self.area_database_summary.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsa_area_id.yfilter != YFilter.not_set or
                                    (self.area_database_summary is not None and self.area_database_summary.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "area-database" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsa_area_id.is_set or self.lsa_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsa_area_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "area-database-summary"):
                                    if (self.area_database_summary is None):
                                        self.area_database_summary = Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase.AreaDatabaseSummary()
                                        self.area_database_summary.parent = self
                                        self._children_name_map["area_database_summary"] = "area-database-summary"
                                    return self.area_database_summary

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "area-database-summary" or name == "lsa-area-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsa-area-id"):
                                    self.lsa_area_id = value
                                    self.lsa_area_id.value_namespace = name_space
                                    self.lsa_area_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.area_database:
                                if (c.has_data()):
                                    return True
                            return (
                                self.database_router_id.is_set or
                                self.is_opaque_database_capable.is_set or
                                (self.database_counters is not None and self.database_counters.has_data()))

                        def has_operation(self):
                            for c in self.area_database:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.database_router_id.yfilter != YFilter.not_set or
                                self.is_opaque_database_capable.yfilter != YFilter.not_set or
                                (self.database_counters is not None and self.database_counters.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "database-summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.database_router_id.is_set or self.database_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.database_router_id.get_name_leafdata())
                            if (self.is_opaque_database_capable.is_set or self.is_opaque_database_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_opaque_database_capable.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "area-database"):
                                for c in self.area_database:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.AreaDatabase()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.area_database.append(c)
                                return c

                            if (child_yang_name == "database-counters"):
                                if (self.database_counters is None):
                                    self.database_counters = Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary.DatabaseCounters()
                                    self.database_counters.parent = self
                                    self._children_name_map["database_counters"] = "database-counters"
                                return self.database_counters

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area-database" or name == "database-counters" or name == "database-router-id" or name == "is-opaque-database-capable"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "database-router-id"):
                                self.database_router_id = value
                                self.database_router_id.value_namespace = name_space
                                self.database_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-opaque-database-capable"):
                                self.is_opaque_database_capable = value
                                self.is_opaque_database_capable.value_namespace = name_space
                                self.is_opaque_database_capable.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (self.database_summary is not None and self.database_summary.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.database_summary is not None and self.database_summary.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "database-summary-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "database-summary"):
                            if (self.database_summary is None):
                                self.database_summary = Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable.DatabaseSummary()
                                self.database_summary.parent = self
                                self._children_name_map["database_summary"] = "database-summary"
                            return self.database_summary

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "database-summary"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class NeighborProcessTable(Entity):
                    """
                    OSPFv3 neighbor information table for all areas
                    
                    .. attribute:: neighbor
                    
                    	OSPFv3 neighbor detail information
                    	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable, self).__init__()

                        self.yang_name = "neighbor-process-table"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable, self).__setattr__(name, value)


                    class Neighbor(Entity):
                        """
                        OSPFv3 neighbor detail information
                        
                        .. attribute:: interface_name
                        
                        	Interface name
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: is_neighbor_sham_link
                        
                        	If true, neighbor is on a sham link 
                        	**type**\:  bool
                        
                        .. attribute:: is_neighbor_virtual_link
                        
                        	If true, neighbor is on a virtual link 
                        	**type**\:  bool
                        
                        .. attribute:: neighbor_address
                        
                        	Neighbor ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: neighbor_address_xr
                        
                        	Neighbor IP Address
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: neighbor_bfd_info
                        
                        	Neighbor BFD information
                        	**type**\:   :py:class:`NeighborBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborBfdInfo>`
                        
                        .. attribute:: neighbor_dead_timer
                        
                        	Time until neighbor's dead timer expires (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: neighbor_designated_router
                        
                        	Designated router 
                        	**type**\:  str
                        
                        	**length:** 0..9
                        
                        .. attribute:: neighbor_detail
                        
                        	Detailed OSPFv3 neighbor information 
                        	**type**\:   :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail>`
                        
                        .. attribute:: neighbor_dr_priority
                        
                        	Neighbor's DR priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: neighbor_interface_id
                        
                        	Neighbor interface ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: neighbor_sham_link_id
                        
                        	Neighbor sham link id 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: neighbor_state
                        
                        	Neighbor's state
                        	**type**\:   :py:class:`Ospfv3NeighborState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3NeighborState>`
                        
                        .. attribute:: neighbor_up_time
                        
                        	Amount of time since the adjacency is up (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: neighbor_virtual_link_id
                        
                        	Neighbor virtual link id 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor, self).__init__()

                            self.yang_name = "neighbor"
                            self.yang_parent_name = "neighbor-process-table"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.is_neighbor_sham_link = YLeaf(YType.boolean, "is-neighbor-sham-link")

                            self.is_neighbor_virtual_link = YLeaf(YType.boolean, "is-neighbor-virtual-link")

                            self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                            self.neighbor_address_xr = YLeaf(YType.str, "neighbor-address-xr")

                            self.neighbor_dead_timer = YLeaf(YType.uint32, "neighbor-dead-timer")

                            self.neighbor_designated_router = YLeaf(YType.str, "neighbor-designated-router")

                            self.neighbor_dr_priority = YLeaf(YType.uint8, "neighbor-dr-priority")

                            self.neighbor_interface_id = YLeaf(YType.uint32, "neighbor-interface-id")

                            self.neighbor_sham_link_id = YLeaf(YType.uint32, "neighbor-sham-link-id")

                            self.neighbor_state = YLeaf(YType.enumeration, "neighbor-state")

                            self.neighbor_up_time = YLeaf(YType.uint32, "neighbor-up-time")

                            self.neighbor_virtual_link_id = YLeaf(YType.uint32, "neighbor-virtual-link-id")

                            self.neighbor_bfd_info = Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborBfdInfo()
                            self.neighbor_bfd_info.parent = self
                            self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                            self._children_yang_names.add("neighbor-bfd-info")

                            self.neighbor_detail = Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail()
                            self.neighbor_detail.parent = self
                            self._children_name_map["neighbor_detail"] = "neighbor-detail"
                            self._children_yang_names.add("neighbor-detail")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "is_neighbor_sham_link",
                                            "is_neighbor_virtual_link",
                                            "neighbor_address",
                                            "neighbor_address_xr",
                                            "neighbor_dead_timer",
                                            "neighbor_designated_router",
                                            "neighbor_dr_priority",
                                            "neighbor_interface_id",
                                            "neighbor_sham_link_id",
                                            "neighbor_state",
                                            "neighbor_up_time",
                                            "neighbor_virtual_link_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor, self).__setattr__(name, value)


                        class NeighborDetail(Entity):
                            """
                            Detailed OSPFv3 neighbor information 
                            
                            .. attribute:: interface_type
                            
                            	Interface type
                            	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                            
                            .. attribute:: is_neighbor_filtered
                            
                            	If true, filter outgoing LSAs 
                            	**type**\:  bool
                            
                            .. attribute:: neighbor_backup_designated_router_address
                            
                            	Address of backup designated router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: neighbor_cost
                            
                            	Cost of path to this neighbor 
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: neighbor_designated_router_address
                            
                            	Address of designated router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: neighbor_ignore_timer
                            
                            	Remaining time when ignore timer is running 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_option
                            
                            	 This is bitmask of neighbor's option field received 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_retransmission
                            
                            	Retransmission information with this neighbor
                            	**type**\:   :py:class:`NeighborRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission>`
                            
                            .. attribute:: next_poll_interval
                            
                            	For NBMA networks, amount of time remaining in seconds before the next poll interval expires and Hello is sent (s)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: pending_events
                            
                            	Number of pending events 
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: poll_interval
                            
                            	Poll interval (s)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state_changes
                            
                            	Number of state changes 
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail, self).__init__()

                                self.yang_name = "neighbor-detail"
                                self.yang_parent_name = "neighbor"

                                self.interface_type = YLeaf(YType.enumeration, "interface-type")

                                self.is_neighbor_filtered = YLeaf(YType.boolean, "is-neighbor-filtered")

                                self.neighbor_backup_designated_router_address = YLeaf(YType.str, "neighbor-backup-designated-router-address")

                                self.neighbor_cost = YLeaf(YType.uint16, "neighbor-cost")

                                self.neighbor_designated_router_address = YLeaf(YType.str, "neighbor-designated-router-address")

                                self.neighbor_ignore_timer = YLeaf(YType.uint32, "neighbor-ignore-timer")

                                self.neighbor_option = YLeaf(YType.uint32, "neighbor-option")

                                self.next_poll_interval = YLeaf(YType.uint32, "next-poll-interval")

                                self.pending_events = YLeaf(YType.uint16, "pending-events")

                                self.poll_interval = YLeaf(YType.uint32, "poll-interval")

                                self.state_changes = YLeaf(YType.uint16, "state-changes")

                                self.neighbor_retransmission = Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission()
                                self.neighbor_retransmission.parent = self
                                self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                self._children_yang_names.add("neighbor-retransmission")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_type",
                                                "is_neighbor_filtered",
                                                "neighbor_backup_designated_router_address",
                                                "neighbor_cost",
                                                "neighbor_designated_router_address",
                                                "neighbor_ignore_timer",
                                                "neighbor_option",
                                                "next_poll_interval",
                                                "pending_events",
                                                "poll_interval",
                                                "state_changes") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail, self).__setattr__(name, value)


                            class NeighborRetransmission(Entity):
                                """
                                Retransmission information with this neighbor
                                
                                .. attribute:: area_first_flood
                                
                                	First flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_first_flood_index
                                
                                	Index of the first flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_flood_index
                                
                                	Area scope LSA's flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_next_flood
                                
                                	Next flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_next_flood_index
                                
                                	Index of next flood item for Area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_first_flood
                                
                                	First flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_first_flood_index
                                
                                	Index for first flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_flood_index
                                
                                	AS scope LSA's flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_next_flood
                                
                                	Next flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_next_flood_index
                                
                                	Index of next flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: database_descriptor_retransmissions
                                
                                	Number of database descriptor retransmissions during last exchange
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_retransmission_length
                                
                                	Number of LSAs sent in last retransmission
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_retransmission_time
                                
                                	Last retransmission scan time (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_first_flood
                                
                                	Link first flood information 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_first_flood_index
                                
                                	Link first flood information index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_flood_index
                                
                                	Link flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_next_flood
                                
                                	Link next flood information 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_next_flood_index
                                
                                	Link next flood information index 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsa_retransmission_timer
                                
                                	Time until next LSA retransmission (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: maximum_retransmission_length
                                
                                	Maximum number of LSAs sent in a retransmission
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: maximum_retransmission_time
                                
                                	Maximum retransmission scan time (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_retransmissions
                                
                                	Number of neighbor retransmissions 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: retransmissions
                                
                                	Number of retransmissions for this neighbor
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__init__()

                                    self.yang_name = "neighbor-retransmission"
                                    self.yang_parent_name = "neighbor-detail"

                                    self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                    self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                    self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                    self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                    self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                    self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                    self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                    self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                    self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                    self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                    self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                    self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                    self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                    self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                    self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                    self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                    self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                    self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                    self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                    self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                    self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                    self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                    self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("area_first_flood",
                                                    "area_first_flood_index",
                                                    "area_flood_index",
                                                    "area_next_flood",
                                                    "area_next_flood_index",
                                                    "as_first_flood",
                                                    "as_first_flood_index",
                                                    "as_flood_index",
                                                    "as_next_flood",
                                                    "as_next_flood_index",
                                                    "database_descriptor_retransmissions",
                                                    "last_retransmission_length",
                                                    "last_retransmission_time",
                                                    "link_first_flood",
                                                    "link_first_flood_index",
                                                    "link_flood_index",
                                                    "link_next_flood",
                                                    "link_next_flood_index",
                                                    "lsa_retransmission_timer",
                                                    "maximum_retransmission_length",
                                                    "maximum_retransmission_time",
                                                    "neighbor_retransmissions",
                                                    "retransmissions") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.area_first_flood.is_set or
                                        self.area_first_flood_index.is_set or
                                        self.area_flood_index.is_set or
                                        self.area_next_flood.is_set or
                                        self.area_next_flood_index.is_set or
                                        self.as_first_flood.is_set or
                                        self.as_first_flood_index.is_set or
                                        self.as_flood_index.is_set or
                                        self.as_next_flood.is_set or
                                        self.as_next_flood_index.is_set or
                                        self.database_descriptor_retransmissions.is_set or
                                        self.last_retransmission_length.is_set or
                                        self.last_retransmission_time.is_set or
                                        self.link_first_flood.is_set or
                                        self.link_first_flood_index.is_set or
                                        self.link_flood_index.is_set or
                                        self.link_next_flood.is_set or
                                        self.link_next_flood_index.is_set or
                                        self.lsa_retransmission_timer.is_set or
                                        self.maximum_retransmission_length.is_set or
                                        self.maximum_retransmission_time.is_set or
                                        self.neighbor_retransmissions.is_set or
                                        self.retransmissions.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.area_first_flood.yfilter != YFilter.not_set or
                                        self.area_first_flood_index.yfilter != YFilter.not_set or
                                        self.area_flood_index.yfilter != YFilter.not_set or
                                        self.area_next_flood.yfilter != YFilter.not_set or
                                        self.area_next_flood_index.yfilter != YFilter.not_set or
                                        self.as_first_flood.yfilter != YFilter.not_set or
                                        self.as_first_flood_index.yfilter != YFilter.not_set or
                                        self.as_flood_index.yfilter != YFilter.not_set or
                                        self.as_next_flood.yfilter != YFilter.not_set or
                                        self.as_next_flood_index.yfilter != YFilter.not_set or
                                        self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                        self.last_retransmission_length.yfilter != YFilter.not_set or
                                        self.last_retransmission_time.yfilter != YFilter.not_set or
                                        self.link_first_flood.yfilter != YFilter.not_set or
                                        self.link_first_flood_index.yfilter != YFilter.not_set or
                                        self.link_flood_index.yfilter != YFilter.not_set or
                                        self.link_next_flood.yfilter != YFilter.not_set or
                                        self.link_next_flood_index.yfilter != YFilter.not_set or
                                        self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                        self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                        self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                        self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                        self.retransmissions.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "neighbor-retransmission" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                    if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                    if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                    if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                    if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                    if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                    if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                    if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                    if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                    if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                    if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                    if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                    if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                    if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                    if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                    if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                    if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                    if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                    if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                    if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                    if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                    if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                    if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "area-first-flood"):
                                        self.area_first_flood = value
                                        self.area_first_flood.value_namespace = name_space
                                        self.area_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-first-flood-index"):
                                        self.area_first_flood_index = value
                                        self.area_first_flood_index.value_namespace = name_space
                                        self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-flood-index"):
                                        self.area_flood_index = value
                                        self.area_flood_index.value_namespace = name_space
                                        self.area_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-next-flood"):
                                        self.area_next_flood = value
                                        self.area_next_flood.value_namespace = name_space
                                        self.area_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-next-flood-index"):
                                        self.area_next_flood_index = value
                                        self.area_next_flood_index.value_namespace = name_space
                                        self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-first-flood"):
                                        self.as_first_flood = value
                                        self.as_first_flood.value_namespace = name_space
                                        self.as_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-first-flood-index"):
                                        self.as_first_flood_index = value
                                        self.as_first_flood_index.value_namespace = name_space
                                        self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-flood-index"):
                                        self.as_flood_index = value
                                        self.as_flood_index.value_namespace = name_space
                                        self.as_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-next-flood"):
                                        self.as_next_flood = value
                                        self.as_next_flood.value_namespace = name_space
                                        self.as_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-next-flood-index"):
                                        self.as_next_flood_index = value
                                        self.as_next_flood_index.value_namespace = name_space
                                        self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "database-descriptor-retransmissions"):
                                        self.database_descriptor_retransmissions = value
                                        self.database_descriptor_retransmissions.value_namespace = name_space
                                        self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-retransmission-length"):
                                        self.last_retransmission_length = value
                                        self.last_retransmission_length.value_namespace = name_space
                                        self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-retransmission-time"):
                                        self.last_retransmission_time = value
                                        self.last_retransmission_time.value_namespace = name_space
                                        self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-first-flood"):
                                        self.link_first_flood = value
                                        self.link_first_flood.value_namespace = name_space
                                        self.link_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-first-flood-index"):
                                        self.link_first_flood_index = value
                                        self.link_first_flood_index.value_namespace = name_space
                                        self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-flood-index"):
                                        self.link_flood_index = value
                                        self.link_flood_index.value_namespace = name_space
                                        self.link_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-next-flood"):
                                        self.link_next_flood = value
                                        self.link_next_flood.value_namespace = name_space
                                        self.link_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-next-flood-index"):
                                        self.link_next_flood_index = value
                                        self.link_next_flood_index.value_namespace = name_space
                                        self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsa-retransmission-timer"):
                                        self.lsa_retransmission_timer = value
                                        self.lsa_retransmission_timer.value_namespace = name_space
                                        self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "maximum-retransmission-length"):
                                        self.maximum_retransmission_length = value
                                        self.maximum_retransmission_length.value_namespace = name_space
                                        self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "maximum-retransmission-time"):
                                        self.maximum_retransmission_time = value
                                        self.maximum_retransmission_time.value_namespace = name_space
                                        self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-retransmissions"):
                                        self.neighbor_retransmissions = value
                                        self.neighbor_retransmissions.value_namespace = name_space
                                        self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                    if(value_path == "retransmissions"):
                                        self.retransmissions = value
                                        self.retransmissions.value_namespace = name_space
                                        self.retransmissions.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_type.is_set or
                                    self.is_neighbor_filtered.is_set or
                                    self.neighbor_backup_designated_router_address.is_set or
                                    self.neighbor_cost.is_set or
                                    self.neighbor_designated_router_address.is_set or
                                    self.neighbor_ignore_timer.is_set or
                                    self.neighbor_option.is_set or
                                    self.next_poll_interval.is_set or
                                    self.pending_events.is_set or
                                    self.poll_interval.is_set or
                                    self.state_changes.is_set or
                                    (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_type.yfilter != YFilter.not_set or
                                    self.is_neighbor_filtered.yfilter != YFilter.not_set or
                                    self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set or
                                    self.neighbor_cost.yfilter != YFilter.not_set or
                                    self.neighbor_designated_router_address.yfilter != YFilter.not_set or
                                    self.neighbor_ignore_timer.yfilter != YFilter.not_set or
                                    self.neighbor_option.yfilter != YFilter.not_set or
                                    self.next_poll_interval.yfilter != YFilter.not_set or
                                    self.pending_events.yfilter != YFilter.not_set or
                                    self.poll_interval.yfilter != YFilter.not_set or
                                    self.state_changes.yfilter != YFilter.not_set or
                                    (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_type.is_set or self.interface_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_type.get_name_leafdata())
                                if (self.is_neighbor_filtered.is_set or self.is_neighbor_filtered.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_filtered.get_name_leafdata())
                                if (self.neighbor_backup_designated_router_address.is_set or self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_backup_designated_router_address.get_name_leafdata())
                                if (self.neighbor_cost.is_set or self.neighbor_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_cost.get_name_leafdata())
                                if (self.neighbor_designated_router_address.is_set or self.neighbor_designated_router_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_designated_router_address.get_name_leafdata())
                                if (self.neighbor_ignore_timer.is_set or self.neighbor_ignore_timer.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_ignore_timer.get_name_leafdata())
                                if (self.neighbor_option.is_set or self.neighbor_option.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_option.get_name_leafdata())
                                if (self.next_poll_interval.is_set or self.next_poll_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_poll_interval.get_name_leafdata())
                                if (self.pending_events.is_set or self.pending_events.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pending_events.get_name_leafdata())
                                if (self.poll_interval.is_set or self.poll_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.poll_interval.get_name_leafdata())
                                if (self.state_changes.is_set or self.state_changes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_changes.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "neighbor-retransmission"):
                                    if (self.neighbor_retransmission is None):
                                        self.neighbor_retransmission = Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail.NeighborRetransmission()
                                        self.neighbor_retransmission.parent = self
                                        self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                    return self.neighbor_retransmission

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "neighbor-retransmission" or name == "interface-type" or name == "is-neighbor-filtered" or name == "neighbor-backup-designated-router-address" or name == "neighbor-cost" or name == "neighbor-designated-router-address" or name == "neighbor-ignore-timer" or name == "neighbor-option" or name == "next-poll-interval" or name == "pending-events" or name == "poll-interval" or name == "state-changes"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-type"):
                                    self.interface_type = value
                                    self.interface_type.value_namespace = name_space
                                    self.interface_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-filtered"):
                                    self.is_neighbor_filtered = value
                                    self.is_neighbor_filtered.value_namespace = name_space
                                    self.is_neighbor_filtered.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-backup-designated-router-address"):
                                    self.neighbor_backup_designated_router_address = value
                                    self.neighbor_backup_designated_router_address.value_namespace = name_space
                                    self.neighbor_backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-cost"):
                                    self.neighbor_cost = value
                                    self.neighbor_cost.value_namespace = name_space
                                    self.neighbor_cost.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-designated-router-address"):
                                    self.neighbor_designated_router_address = value
                                    self.neighbor_designated_router_address.value_namespace = name_space
                                    self.neighbor_designated_router_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-ignore-timer"):
                                    self.neighbor_ignore_timer = value
                                    self.neighbor_ignore_timer.value_namespace = name_space
                                    self.neighbor_ignore_timer.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-option"):
                                    self.neighbor_option = value
                                    self.neighbor_option.value_namespace = name_space
                                    self.neighbor_option.value_namespace_prefix = name_space_prefix
                                if(value_path == "next-poll-interval"):
                                    self.next_poll_interval = value
                                    self.next_poll_interval.value_namespace = name_space
                                    self.next_poll_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "pending-events"):
                                    self.pending_events = value
                                    self.pending_events.value_namespace = name_space
                                    self.pending_events.value_namespace_prefix = name_space_prefix
                                if(value_path == "poll-interval"):
                                    self.poll_interval = value
                                    self.poll_interval.value_namespace = name_space
                                    self.poll_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-changes"):
                                    self.state_changes = value
                                    self.state_changes.value_namespace = name_space
                                    self.state_changes.value_namespace_prefix = name_space_prefix


                        class NeighborBfdInfo(Entity):
                            """
                            Neighbor BFD information
                            
                            .. attribute:: bfd_intf_enable_mode
                            
                            	BFD enable mode \- Default/Strict
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_status_flag
                            
                            	Status of the BFD Session
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborBfdInfo, self).__init__()

                                self.yang_name = "neighbor-bfd-info"
                                self.yang_parent_name = "neighbor"

                                self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                self.bfd_status_flag = YLeaf(YType.uint8, "bfd-status-flag")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_intf_enable_mode",
                                                "bfd_status_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborBfdInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.bfd_intf_enable_mode.is_set or
                                    self.bfd_status_flag.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_intf_enable_mode.yfilter != YFilter.not_set or
                                    self.bfd_status_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())
                                if (self.bfd_status_flag.is_set or self.bfd_status_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_status_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-intf-enable-mode" or name == "bfd-status-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-intf-enable-mode"):
                                    self.bfd_intf_enable_mode = value
                                    self.bfd_intf_enable_mode.value_namespace = name_space
                                    self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-status-flag"):
                                    self.bfd_status_flag = value
                                    self.bfd_status_flag.value_namespace = name_space
                                    self.bfd_status_flag.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.interface_name.is_set or
                                self.is_neighbor_sham_link.is_set or
                                self.is_neighbor_virtual_link.is_set or
                                self.neighbor_address.is_set or
                                self.neighbor_address_xr.is_set or
                                self.neighbor_dead_timer.is_set or
                                self.neighbor_designated_router.is_set or
                                self.neighbor_dr_priority.is_set or
                                self.neighbor_interface_id.is_set or
                                self.neighbor_sham_link_id.is_set or
                                self.neighbor_state.is_set or
                                self.neighbor_up_time.is_set or
                                self.neighbor_virtual_link_id.is_set or
                                (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_data()) or
                                (self.neighbor_detail is not None and self.neighbor_detail.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.is_neighbor_sham_link.yfilter != YFilter.not_set or
                                self.is_neighbor_virtual_link.yfilter != YFilter.not_set or
                                self.neighbor_address.yfilter != YFilter.not_set or
                                self.neighbor_address_xr.yfilter != YFilter.not_set or
                                self.neighbor_dead_timer.yfilter != YFilter.not_set or
                                self.neighbor_designated_router.yfilter != YFilter.not_set or
                                self.neighbor_dr_priority.yfilter != YFilter.not_set or
                                self.neighbor_interface_id.yfilter != YFilter.not_set or
                                self.neighbor_sham_link_id.yfilter != YFilter.not_set or
                                self.neighbor_state.yfilter != YFilter.not_set or
                                self.neighbor_up_time.yfilter != YFilter.not_set or
                                self.neighbor_virtual_link_id.yfilter != YFilter.not_set or
                                (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_operation()) or
                                (self.neighbor_detail is not None and self.neighbor_detail.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.is_neighbor_sham_link.is_set or self.is_neighbor_sham_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_neighbor_sham_link.get_name_leafdata())
                            if (self.is_neighbor_virtual_link.is_set or self.is_neighbor_virtual_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_neighbor_virtual_link.get_name_leafdata())
                            if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                            if (self.neighbor_address_xr.is_set or self.neighbor_address_xr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_address_xr.get_name_leafdata())
                            if (self.neighbor_dead_timer.is_set or self.neighbor_dead_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_dead_timer.get_name_leafdata())
                            if (self.neighbor_designated_router.is_set or self.neighbor_designated_router.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_designated_router.get_name_leafdata())
                            if (self.neighbor_dr_priority.is_set or self.neighbor_dr_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_dr_priority.get_name_leafdata())
                            if (self.neighbor_interface_id.is_set or self.neighbor_interface_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_interface_id.get_name_leafdata())
                            if (self.neighbor_sham_link_id.is_set or self.neighbor_sham_link_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_sham_link_id.get_name_leafdata())
                            if (self.neighbor_state.is_set or self.neighbor_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_state.get_name_leafdata())
                            if (self.neighbor_up_time.is_set or self.neighbor_up_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_up_time.get_name_leafdata())
                            if (self.neighbor_virtual_link_id.is_set or self.neighbor_virtual_link_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_virtual_link_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor-bfd-info"):
                                if (self.neighbor_bfd_info is None):
                                    self.neighbor_bfd_info = Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborBfdInfo()
                                    self.neighbor_bfd_info.parent = self
                                    self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                return self.neighbor_bfd_info

                            if (child_yang_name == "neighbor-detail"):
                                if (self.neighbor_detail is None):
                                    self.neighbor_detail = Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor.NeighborDetail()
                                    self.neighbor_detail.parent = self
                                    self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                return self.neighbor_detail

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor-bfd-info" or name == "neighbor-detail" or name == "interface-name" or name == "is-neighbor-sham-link" or name == "is-neighbor-virtual-link" or name == "neighbor-address" or name == "neighbor-address-xr" or name == "neighbor-dead-timer" or name == "neighbor-designated-router" or name == "neighbor-dr-priority" or name == "neighbor-interface-id" or name == "neighbor-sham-link-id" or name == "neighbor-state" or name == "neighbor-up-time" or name == "neighbor-virtual-link-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-neighbor-sham-link"):
                                self.is_neighbor_sham_link = value
                                self.is_neighbor_sham_link.value_namespace = name_space
                                self.is_neighbor_sham_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-neighbor-virtual-link"):
                                self.is_neighbor_virtual_link = value
                                self.is_neighbor_virtual_link.value_namespace = name_space
                                self.is_neighbor_virtual_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-address"):
                                self.neighbor_address = value
                                self.neighbor_address.value_namespace = name_space
                                self.neighbor_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-address-xr"):
                                self.neighbor_address_xr = value
                                self.neighbor_address_xr.value_namespace = name_space
                                self.neighbor_address_xr.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-dead-timer"):
                                self.neighbor_dead_timer = value
                                self.neighbor_dead_timer.value_namespace = name_space
                                self.neighbor_dead_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-designated-router"):
                                self.neighbor_designated_router = value
                                self.neighbor_designated_router.value_namespace = name_space
                                self.neighbor_designated_router.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-dr-priority"):
                                self.neighbor_dr_priority = value
                                self.neighbor_dr_priority.value_namespace = name_space
                                self.neighbor_dr_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-interface-id"):
                                self.neighbor_interface_id = value
                                self.neighbor_interface_id.value_namespace = name_space
                                self.neighbor_interface_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-sham-link-id"):
                                self.neighbor_sham_link_id = value
                                self.neighbor_sham_link_id.value_namespace = name_space
                                self.neighbor_sham_link_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-state"):
                                self.neighbor_state = value
                                self.neighbor_state.value_namespace = name_space
                                self.neighbor_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-up-time"):
                                self.neighbor_up_time = value
                                self.neighbor_up_time.value_namespace = name_space
                                self.neighbor_up_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-virtual-link-id"):
                                self.neighbor_virtual_link_id = value
                                self.neighbor_virtual_link_id.value_namespace = name_space
                                self.neighbor_virtual_link_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbor-process-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor"):
                            for c in self.neighbor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable.Neighbor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class FastReroutes(Entity):
                    """
                    OSPFv3 fast reroute topology information table
                    
                    .. attribute:: fast_reroute
                    
                    	OSPFv3 fast reroute topology information
                    	**type**\: list of    :py:class:`FastReroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.FastReroutes.FastReroute>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.FastReroutes, self).__init__()

                        self.yang_name = "fast-reroutes"
                        self.yang_parent_name = "default-vrf"

                        self.fast_reroute = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.FastReroutes, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.FastReroutes, self).__setattr__(name, value)


                    class FastReroute(Entity):
                        """
                        OSPFv3 fast reroute topology information
                        
                        .. attribute:: area_id
                        
                        	AreaID
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: ipfrr_area_revision
                        
                        	IPFRR Topology Revision
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: ipfrr_router_id
                        
                        	OSPF Router ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: ipfrr_topo
                        
                        	IPFRR Topology entries
                        	**type**\: list of    :py:class:`IpfrrTopo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.FastReroutes.FastReroute.IpfrrTopo>`
                        
                        .. attribute:: ipfrr_topo_area_id
                        
                        	Area ID string in decimal or dotted decimal format
                        	**type**\:  str
                        
                        	**length:** 0..16
                        
                        .. attribute:: router_id
                        
                        	Router ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.FastReroutes.FastReroute, self).__init__()

                            self.yang_name = "fast-reroute"
                            self.yang_parent_name = "fast-reroutes"

                            self.area_id = YLeaf(YType.int32, "area-id")

                            self.ipfrr_area_revision = YLeaf(YType.uint32, "ipfrr-area-revision")

                            self.ipfrr_router_id = YLeaf(YType.str, "ipfrr-router-id")

                            self.ipfrr_topo_area_id = YLeaf(YType.str, "ipfrr-topo-area-id")

                            self.router_id = YLeaf(YType.str, "router-id")

                            self.ipfrr_topo = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("area_id",
                                            "ipfrr_area_revision",
                                            "ipfrr_router_id",
                                            "ipfrr_topo_area_id",
                                            "router_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.FastReroutes.FastReroute, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.FastReroutes.FastReroute, self).__setattr__(name, value)


                        class IpfrrTopo(Entity):
                            """
                            IPFRR Topology entries
                            
                            .. attribute:: distance
                            
                            	IPFRR Topology Distance
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: dr
                            
                            	IPFRR Topology DR entry
                            	**type**\:  bool
                            
                            .. attribute:: lsaid
                            
                            	IPFRR Topology LSA ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_sourced
                            
                            	IPFRR Topology Neighbor Sourced
                            	**type**\:  bool
                            
                            .. attribute:: node_id
                            
                            	IPFRR Topology Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: revision
                            
                            	IPFRR Topology Revision
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: type4
                            
                            	IPFRR Topoogy Type\-4 entry
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.FastReroutes.FastReroute.IpfrrTopo, self).__init__()

                                self.yang_name = "ipfrr-topo"
                                self.yang_parent_name = "fast-reroute"

                                self.distance = YLeaf(YType.uint32, "distance")

                                self.dr = YLeaf(YType.boolean, "dr")

                                self.lsaid = YLeaf(YType.uint32, "lsaid")

                                self.neighbor_sourced = YLeaf(YType.boolean, "neighbor-sourced")

                                self.node_id = YLeaf(YType.str, "node-id")

                                self.revision = YLeaf(YType.uint32, "revision")

                                self.type4 = YLeaf(YType.boolean, "type4")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("distance",
                                                "dr",
                                                "lsaid",
                                                "neighbor_sourced",
                                                "node_id",
                                                "revision",
                                                "type4") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.FastReroutes.FastReroute.IpfrrTopo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.FastReroutes.FastReroute.IpfrrTopo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.distance.is_set or
                                    self.dr.is_set or
                                    self.lsaid.is_set or
                                    self.neighbor_sourced.is_set or
                                    self.node_id.is_set or
                                    self.revision.is_set or
                                    self.type4.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.distance.yfilter != YFilter.not_set or
                                    self.dr.yfilter != YFilter.not_set or
                                    self.lsaid.yfilter != YFilter.not_set or
                                    self.neighbor_sourced.yfilter != YFilter.not_set or
                                    self.node_id.yfilter != YFilter.not_set or
                                    self.revision.yfilter != YFilter.not_set or
                                    self.type4.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipfrr-topo" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.distance.is_set or self.distance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.distance.get_name_leafdata())
                                if (self.dr.is_set or self.dr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dr.get_name_leafdata())
                                if (self.lsaid.is_set or self.lsaid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsaid.get_name_leafdata())
                                if (self.neighbor_sourced.is_set or self.neighbor_sourced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_sourced.get_name_leafdata())
                                if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.node_id.get_name_leafdata())
                                if (self.revision.is_set or self.revision.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.revision.get_name_leafdata())
                                if (self.type4.is_set or self.type4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type4.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "distance" or name == "dr" or name == "lsaid" or name == "neighbor-sourced" or name == "node-id" or name == "revision" or name == "type4"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "distance"):
                                    self.distance = value
                                    self.distance.value_namespace = name_space
                                    self.distance.value_namespace_prefix = name_space_prefix
                                if(value_path == "dr"):
                                    self.dr = value
                                    self.dr.value_namespace = name_space
                                    self.dr.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsaid"):
                                    self.lsaid = value
                                    self.lsaid.value_namespace = name_space
                                    self.lsaid.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-sourced"):
                                    self.neighbor_sourced = value
                                    self.neighbor_sourced.value_namespace = name_space
                                    self.neighbor_sourced.value_namespace_prefix = name_space_prefix
                                if(value_path == "node-id"):
                                    self.node_id = value
                                    self.node_id.value_namespace = name_space
                                    self.node_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "revision"):
                                    self.revision = value
                                    self.revision.value_namespace = name_space
                                    self.revision.value_namespace_prefix = name_space_prefix
                                if(value_path == "type4"):
                                    self.type4 = value
                                    self.type4.value_namespace = name_space
                                    self.type4.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.ipfrr_topo:
                                if (c.has_data()):
                                    return True
                            return (
                                self.area_id.is_set or
                                self.ipfrr_area_revision.is_set or
                                self.ipfrr_router_id.is_set or
                                self.ipfrr_topo_area_id.is_set or
                                self.router_id.is_set)

                        def has_operation(self):
                            for c in self.ipfrr_topo:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.area_id.yfilter != YFilter.not_set or
                                self.ipfrr_area_revision.yfilter != YFilter.not_set or
                                self.ipfrr_router_id.yfilter != YFilter.not_set or
                                self.ipfrr_topo_area_id.yfilter != YFilter.not_set or
                                self.router_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fast-reroute" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_id.get_name_leafdata())
                            if (self.ipfrr_area_revision.is_set or self.ipfrr_area_revision.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipfrr_area_revision.get_name_leafdata())
                            if (self.ipfrr_router_id.is_set or self.ipfrr_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipfrr_router_id.get_name_leafdata())
                            if (self.ipfrr_topo_area_id.is_set or self.ipfrr_topo_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipfrr_topo_area_id.get_name_leafdata())
                            if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.router_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipfrr-topo"):
                                for c in self.ipfrr_topo:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Ospfv3.Processes.Process.DefaultVrf.FastReroutes.FastReroute.IpfrrTopo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ipfrr_topo.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipfrr-topo" or name == "area-id" or name == "ipfrr-area-revision" or name == "ipfrr-router-id" or name == "ipfrr-topo-area-id" or name == "router-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "area-id"):
                                self.area_id = value
                                self.area_id.value_namespace = name_space
                                self.area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipfrr-area-revision"):
                                self.ipfrr_area_revision = value
                                self.ipfrr_area_revision.value_namespace = name_space
                                self.ipfrr_area_revision.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipfrr-router-id"):
                                self.ipfrr_router_id = value
                                self.ipfrr_router_id.value_namespace = name_space
                                self.ipfrr_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipfrr-topo-area-id"):
                                self.ipfrr_topo_area_id = value
                                self.ipfrr_topo_area_id.value_namespace = name_space
                                self.ipfrr_topo_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "router-id"):
                                self.router_id = value
                                self.router_id.value_namespace = name_space
                                self.router_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.fast_reroute:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.fast_reroute:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "fast-reroutes" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "fast-reroute"):
                            for c in self.fast_reroute:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.FastReroutes.FastReroute()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.fast_reroute.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fast-reroute"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class InterfaceBriefProcessTable(Entity):
                    """
                    OSPFv3 interface brief information table for all
                    areas
                    
                    .. attribute:: interface_brief
                    
                    	Interface brief information
                    	**type**\: list of    :py:class:`InterfaceBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable.InterfaceBrief>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable, self).__init__()

                        self.yang_name = "interface-brief-process-table"
                        self.yang_parent_name = "default-vrf"

                        self.interface_brief = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable, self).__setattr__(name, value)


                    class InterfaceBrief(Entity):
                        """
                        Interface brief information
                        
                        .. attribute:: interface_name  <key>
                        
                        	Interface name
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: interface_address
                        
                        	Interface IP address
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: interface_adjacent_neighbors
                        
                        	Total number of adjacent neighbors
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: interface_link_cost
                        
                        	Interface link cost
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: interface_neighbors
                        
                        	Total number of neighbors 
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: network_type
                        
                        	Network type
                        	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                        
                        .. attribute:: ospf_interface_state
                        
                        	Interface OSPF state
                        	**type**\:   :py:class:`Ospfv3InterfaceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3InterfaceState>`
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable.InterfaceBrief, self).__init__()

                            self.yang_name = "interface-brief"
                            self.yang_parent_name = "interface-brief-process-table"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.interface_address = YLeaf(YType.str, "interface-address")

                            self.interface_adjacent_neighbors = YLeaf(YType.uint16, "interface-adjacent-neighbors")

                            self.interface_link_cost = YLeaf(YType.uint16, "interface-link-cost")

                            self.interface_neighbors = YLeaf(YType.uint16, "interface-neighbors")

                            self.network_type = YLeaf(YType.enumeration, "network-type")

                            self.ospf_interface_state = YLeaf(YType.enumeration, "ospf-interface-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "interface_address",
                                            "interface_adjacent_neighbors",
                                            "interface_link_cost",
                                            "interface_neighbors",
                                            "network_type",
                                            "ospf_interface_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable.InterfaceBrief, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable.InterfaceBrief, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.interface_name.is_set or
                                self.interface_address.is_set or
                                self.interface_adjacent_neighbors.is_set or
                                self.interface_link_cost.is_set or
                                self.interface_neighbors.is_set or
                                self.network_type.is_set or
                                self.ospf_interface_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.interface_address.yfilter != YFilter.not_set or
                                self.interface_adjacent_neighbors.yfilter != YFilter.not_set or
                                self.interface_link_cost.yfilter != YFilter.not_set or
                                self.interface_neighbors.yfilter != YFilter.not_set or
                                self.network_type.yfilter != YFilter.not_set or
                                self.ospf_interface_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface-brief" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_address.get_name_leafdata())
                            if (self.interface_adjacent_neighbors.is_set or self.interface_adjacent_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_adjacent_neighbors.get_name_leafdata())
                            if (self.interface_link_cost.is_set or self.interface_link_cost.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_link_cost.get_name_leafdata())
                            if (self.interface_neighbors.is_set or self.interface_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_neighbors.get_name_leafdata())
                            if (self.network_type.is_set or self.network_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.network_type.get_name_leafdata())
                            if (self.ospf_interface_state.is_set or self.ospf_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ospf_interface_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "interface-name" or name == "interface-address" or name == "interface-adjacent-neighbors" or name == "interface-link-cost" or name == "interface-neighbors" or name == "network-type" or name == "ospf-interface-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-address"):
                                self.interface_address = value
                                self.interface_address.value_namespace = name_space
                                self.interface_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-adjacent-neighbors"):
                                self.interface_adjacent_neighbors = value
                                self.interface_adjacent_neighbors.value_namespace = name_space
                                self.interface_adjacent_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-link-cost"):
                                self.interface_link_cost = value
                                self.interface_link_cost.value_namespace = name_space
                                self.interface_link_cost.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-neighbors"):
                                self.interface_neighbors = value
                                self.interface_neighbors.value_namespace = name_space
                                self.interface_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "network-type"):
                                self.network_type = value
                                self.network_type.value_namespace = name_space
                                self.network_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "ospf-interface-state"):
                                self.ospf_interface_state = value
                                self.ospf_interface_state.value_namespace = name_space
                                self.ospf_interface_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.interface_brief:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.interface_brief:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "interface-brief-process-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "interface-brief"):
                            for c in self.interface_brief:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable.InterfaceBrief()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.interface_brief.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "interface-brief"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class NeighborDetailProcessTable(Entity):
                    """
                    OSPFv3 neighbor information table for all areas
                    
                    .. attribute:: neighbor_detail
                    
                    	OSPFv3 neighbor detail information
                    	**type**\: list of    :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail>`
                    
                    

                    """

                    _prefix = 'ipv6-ospfv3-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable, self).__init__()

                        self.yang_name = "neighbor-detail-process-table"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor_detail = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable, self).__setattr__(name, value)


                    class NeighborDetail(Entity):
                        """
                        OSPFv3 neighbor detail information
                        
                        .. attribute:: interface_name
                        
                        	Interface name
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: is_neighbor_sham_link
                        
                        	If true, neighbor is on a sham link 
                        	**type**\:  bool
                        
                        .. attribute:: is_neighbor_virtual_link
                        
                        	If true, neighbor is on a virtual link 
                        	**type**\:  bool
                        
                        .. attribute:: neighbor_address
                        
                        	Neighbor ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: neighbor_address_xr
                        
                        	Neighbor IP Address
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: neighbor_bfd_info
                        
                        	Neighbor BFD information
                        	**type**\:   :py:class:`NeighborBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo>`
                        
                        .. attribute:: neighbor_dead_timer
                        
                        	Time until neighbor's dead timer expires (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: neighbor_designated_router
                        
                        	Designated router 
                        	**type**\:  str
                        
                        	**length:** 0..9
                        
                        .. attribute:: neighbor_detail
                        
                        	Detailed OSPFv3 neighbor information 
                        	**type**\:   :py:class:`NeighborDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail>`
                        
                        .. attribute:: neighbor_dr_priority
                        
                        	Neighbor's DR priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: neighbor_interface_id
                        
                        	Neighbor interface ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: neighbor_sham_link_id
                        
                        	Neighbor sham link id 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: neighbor_state
                        
                        	Neighbor's state
                        	**type**\:   :py:class:`Ospfv3NeighborState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3NeighborState>`
                        
                        .. attribute:: neighbor_up_time
                        
                        	Amount of time since the adjacency is up (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: neighbor_virtual_link_id
                        
                        	Neighbor virtual link id 
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'ipv6-ospfv3-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail, self).__init__()

                            self.yang_name = "neighbor-detail"
                            self.yang_parent_name = "neighbor-detail-process-table"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.is_neighbor_sham_link = YLeaf(YType.boolean, "is-neighbor-sham-link")

                            self.is_neighbor_virtual_link = YLeaf(YType.boolean, "is-neighbor-virtual-link")

                            self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                            self.neighbor_address_xr = YLeaf(YType.str, "neighbor-address-xr")

                            self.neighbor_dead_timer = YLeaf(YType.uint32, "neighbor-dead-timer")

                            self.neighbor_designated_router = YLeaf(YType.str, "neighbor-designated-router")

                            self.neighbor_dr_priority = YLeaf(YType.uint8, "neighbor-dr-priority")

                            self.neighbor_interface_id = YLeaf(YType.uint32, "neighbor-interface-id")

                            self.neighbor_sham_link_id = YLeaf(YType.uint32, "neighbor-sham-link-id")

                            self.neighbor_state = YLeaf(YType.enumeration, "neighbor-state")

                            self.neighbor_up_time = YLeaf(YType.uint32, "neighbor-up-time")

                            self.neighbor_virtual_link_id = YLeaf(YType.uint32, "neighbor-virtual-link-id")

                            self.neighbor_bfd_info = Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo()
                            self.neighbor_bfd_info.parent = self
                            self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                            self._children_yang_names.add("neighbor-bfd-info")

                            self.neighbor_detail = Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail()
                            self.neighbor_detail.parent = self
                            self._children_name_map["neighbor_detail"] = "neighbor-detail"
                            self._children_yang_names.add("neighbor-detail")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "is_neighbor_sham_link",
                                            "is_neighbor_virtual_link",
                                            "neighbor_address",
                                            "neighbor_address_xr",
                                            "neighbor_dead_timer",
                                            "neighbor_designated_router",
                                            "neighbor_dr_priority",
                                            "neighbor_interface_id",
                                            "neighbor_sham_link_id",
                                            "neighbor_state",
                                            "neighbor_up_time",
                                            "neighbor_virtual_link_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail, self).__setattr__(name, value)


                        class NeighborDetail(Entity):
                            """
                            Detailed OSPFv3 neighbor information 
                            
                            .. attribute:: interface_type
                            
                            	Interface type
                            	**type**\:   :py:class:`Ospfv3Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3Interface>`
                            
                            .. attribute:: is_neighbor_filtered
                            
                            	If true, filter outgoing LSAs 
                            	**type**\:  bool
                            
                            .. attribute:: neighbor_backup_designated_router_address
                            
                            	Address of backup designated router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: neighbor_cost
                            
                            	Cost of path to this neighbor 
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: neighbor_designated_router_address
                            
                            	Address of designated router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: neighbor_ignore_timer
                            
                            	Remaining time when ignore timer is running 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_option
                            
                            	 This is bitmask of neighbor's option field received 
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: neighbor_retransmission
                            
                            	Retransmission information with this neighbor
                            	**type**\:   :py:class:`NeighborRetransmission <ydk.models.cisco_ios_xr.Cisco_IOS_XR_ipv6_ospfv3_oper.Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission>`
                            
                            .. attribute:: next_poll_interval
                            
                            	For NBMA networks, amount of time remaining in seconds before the next poll interval expires and Hello is sent (s)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: pending_events
                            
                            	Number of pending events 
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: poll_interval
                            
                            	Poll interval (s)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state_changes
                            
                            	Number of state changes 
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail, self).__init__()

                                self.yang_name = "neighbor-detail"
                                self.yang_parent_name = "neighbor-detail"

                                self.interface_type = YLeaf(YType.enumeration, "interface-type")

                                self.is_neighbor_filtered = YLeaf(YType.boolean, "is-neighbor-filtered")

                                self.neighbor_backup_designated_router_address = YLeaf(YType.str, "neighbor-backup-designated-router-address")

                                self.neighbor_cost = YLeaf(YType.uint16, "neighbor-cost")

                                self.neighbor_designated_router_address = YLeaf(YType.str, "neighbor-designated-router-address")

                                self.neighbor_ignore_timer = YLeaf(YType.uint32, "neighbor-ignore-timer")

                                self.neighbor_option = YLeaf(YType.uint32, "neighbor-option")

                                self.next_poll_interval = YLeaf(YType.uint32, "next-poll-interval")

                                self.pending_events = YLeaf(YType.uint16, "pending-events")

                                self.poll_interval = YLeaf(YType.uint32, "poll-interval")

                                self.state_changes = YLeaf(YType.uint16, "state-changes")

                                self.neighbor_retransmission = Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission()
                                self.neighbor_retransmission.parent = self
                                self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                self._children_yang_names.add("neighbor-retransmission")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_type",
                                                "is_neighbor_filtered",
                                                "neighbor_backup_designated_router_address",
                                                "neighbor_cost",
                                                "neighbor_designated_router_address",
                                                "neighbor_ignore_timer",
                                                "neighbor_option",
                                                "next_poll_interval",
                                                "pending_events",
                                                "poll_interval",
                                                "state_changes") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail, self).__setattr__(name, value)


                            class NeighborRetransmission(Entity):
                                """
                                Retransmission information with this neighbor
                                
                                .. attribute:: area_first_flood
                                
                                	First flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_first_flood_index
                                
                                	Index of the first flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_flood_index
                                
                                	Area scope LSA's flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_next_flood
                                
                                	Next flood item for area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: area_next_flood_index
                                
                                	Index of next flood item for Area scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_first_flood
                                
                                	First flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_first_flood_index
                                
                                	Index for first flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_flood_index
                                
                                	AS scope LSA's flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_next_flood
                                
                                	Next flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: as_next_flood_index
                                
                                	Index of next flood item for AS scope LSAs
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: database_descriptor_retransmissions
                                
                                	Number of database descriptor retransmissions during last exchange
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_retransmission_length
                                
                                	Number of LSAs sent in last retransmission
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_retransmission_time
                                
                                	Last retransmission scan time (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_first_flood
                                
                                	Link first flood information 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_first_flood_index
                                
                                	Link first flood information index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_flood_index
                                
                                	Link flood index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_next_flood
                                
                                	Link next flood information 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: link_next_flood_index
                                
                                	Link next flood information index 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsa_retransmission_timer
                                
                                	Time until next LSA retransmission (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: maximum_retransmission_length
                                
                                	Maximum number of LSAs sent in a retransmission
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: maximum_retransmission_time
                                
                                	Maximum retransmission scan time (ms)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: neighbor_retransmissions
                                
                                	Number of neighbor retransmissions 
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: retransmissions
                                
                                	Number of retransmissions for this neighbor
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'ipv6-ospfv3-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__init__()

                                    self.yang_name = "neighbor-retransmission"
                                    self.yang_parent_name = "neighbor-detail"

                                    self.area_first_flood = YLeaf(YType.uint32, "area-first-flood")

                                    self.area_first_flood_index = YLeaf(YType.uint32, "area-first-flood-index")

                                    self.area_flood_index = YLeaf(YType.uint32, "area-flood-index")

                                    self.area_next_flood = YLeaf(YType.uint32, "area-next-flood")

                                    self.area_next_flood_index = YLeaf(YType.uint32, "area-next-flood-index")

                                    self.as_first_flood = YLeaf(YType.uint32, "as-first-flood")

                                    self.as_first_flood_index = YLeaf(YType.uint32, "as-first-flood-index")

                                    self.as_flood_index = YLeaf(YType.uint32, "as-flood-index")

                                    self.as_next_flood = YLeaf(YType.uint32, "as-next-flood")

                                    self.as_next_flood_index = YLeaf(YType.uint32, "as-next-flood-index")

                                    self.database_descriptor_retransmissions = YLeaf(YType.uint32, "database-descriptor-retransmissions")

                                    self.last_retransmission_length = YLeaf(YType.uint32, "last-retransmission-length")

                                    self.last_retransmission_time = YLeaf(YType.uint32, "last-retransmission-time")

                                    self.link_first_flood = YLeaf(YType.uint32, "link-first-flood")

                                    self.link_first_flood_index = YLeaf(YType.uint32, "link-first-flood-index")

                                    self.link_flood_index = YLeaf(YType.uint32, "link-flood-index")

                                    self.link_next_flood = YLeaf(YType.uint32, "link-next-flood")

                                    self.link_next_flood_index = YLeaf(YType.uint32, "link-next-flood-index")

                                    self.lsa_retransmission_timer = YLeaf(YType.uint32, "lsa-retransmission-timer")

                                    self.maximum_retransmission_length = YLeaf(YType.uint32, "maximum-retransmission-length")

                                    self.maximum_retransmission_time = YLeaf(YType.uint32, "maximum-retransmission-time")

                                    self.neighbor_retransmissions = YLeaf(YType.uint32, "neighbor-retransmissions")

                                    self.retransmissions = YLeaf(YType.uint32, "retransmissions")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("area_first_flood",
                                                    "area_first_flood_index",
                                                    "area_flood_index",
                                                    "area_next_flood",
                                                    "area_next_flood_index",
                                                    "as_first_flood",
                                                    "as_first_flood_index",
                                                    "as_flood_index",
                                                    "as_next_flood",
                                                    "as_next_flood_index",
                                                    "database_descriptor_retransmissions",
                                                    "last_retransmission_length",
                                                    "last_retransmission_time",
                                                    "link_first_flood",
                                                    "link_first_flood_index",
                                                    "link_flood_index",
                                                    "link_next_flood",
                                                    "link_next_flood_index",
                                                    "lsa_retransmission_timer",
                                                    "maximum_retransmission_length",
                                                    "maximum_retransmission_time",
                                                    "neighbor_retransmissions",
                                                    "retransmissions") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.area_first_flood.is_set or
                                        self.area_first_flood_index.is_set or
                                        self.area_flood_index.is_set or
                                        self.area_next_flood.is_set or
                                        self.area_next_flood_index.is_set or
                                        self.as_first_flood.is_set or
                                        self.as_first_flood_index.is_set or
                                        self.as_flood_index.is_set or
                                        self.as_next_flood.is_set or
                                        self.as_next_flood_index.is_set or
                                        self.database_descriptor_retransmissions.is_set or
                                        self.last_retransmission_length.is_set or
                                        self.last_retransmission_time.is_set or
                                        self.link_first_flood.is_set or
                                        self.link_first_flood_index.is_set or
                                        self.link_flood_index.is_set or
                                        self.link_next_flood.is_set or
                                        self.link_next_flood_index.is_set or
                                        self.lsa_retransmission_timer.is_set or
                                        self.maximum_retransmission_length.is_set or
                                        self.maximum_retransmission_time.is_set or
                                        self.neighbor_retransmissions.is_set or
                                        self.retransmissions.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.area_first_flood.yfilter != YFilter.not_set or
                                        self.area_first_flood_index.yfilter != YFilter.not_set or
                                        self.area_flood_index.yfilter != YFilter.not_set or
                                        self.area_next_flood.yfilter != YFilter.not_set or
                                        self.area_next_flood_index.yfilter != YFilter.not_set or
                                        self.as_first_flood.yfilter != YFilter.not_set or
                                        self.as_first_flood_index.yfilter != YFilter.not_set or
                                        self.as_flood_index.yfilter != YFilter.not_set or
                                        self.as_next_flood.yfilter != YFilter.not_set or
                                        self.as_next_flood_index.yfilter != YFilter.not_set or
                                        self.database_descriptor_retransmissions.yfilter != YFilter.not_set or
                                        self.last_retransmission_length.yfilter != YFilter.not_set or
                                        self.last_retransmission_time.yfilter != YFilter.not_set or
                                        self.link_first_flood.yfilter != YFilter.not_set or
                                        self.link_first_flood_index.yfilter != YFilter.not_set or
                                        self.link_flood_index.yfilter != YFilter.not_set or
                                        self.link_next_flood.yfilter != YFilter.not_set or
                                        self.link_next_flood_index.yfilter != YFilter.not_set or
                                        self.lsa_retransmission_timer.yfilter != YFilter.not_set or
                                        self.maximum_retransmission_length.yfilter != YFilter.not_set or
                                        self.maximum_retransmission_time.yfilter != YFilter.not_set or
                                        self.neighbor_retransmissions.yfilter != YFilter.not_set or
                                        self.retransmissions.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "neighbor-retransmission" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.area_first_flood.is_set or self.area_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_first_flood.get_name_leafdata())
                                    if (self.area_first_flood_index.is_set or self.area_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_first_flood_index.get_name_leafdata())
                                    if (self.area_flood_index.is_set or self.area_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_flood_index.get_name_leafdata())
                                    if (self.area_next_flood.is_set or self.area_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_next_flood.get_name_leafdata())
                                    if (self.area_next_flood_index.is_set or self.area_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.area_next_flood_index.get_name_leafdata())
                                    if (self.as_first_flood.is_set or self.as_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_first_flood.get_name_leafdata())
                                    if (self.as_first_flood_index.is_set or self.as_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_first_flood_index.get_name_leafdata())
                                    if (self.as_flood_index.is_set or self.as_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_flood_index.get_name_leafdata())
                                    if (self.as_next_flood.is_set or self.as_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_next_flood.get_name_leafdata())
                                    if (self.as_next_flood_index.is_set or self.as_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_next_flood_index.get_name_leafdata())
                                    if (self.database_descriptor_retransmissions.is_set or self.database_descriptor_retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.database_descriptor_retransmissions.get_name_leafdata())
                                    if (self.last_retransmission_length.is_set or self.last_retransmission_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_retransmission_length.get_name_leafdata())
                                    if (self.last_retransmission_time.is_set or self.last_retransmission_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_retransmission_time.get_name_leafdata())
                                    if (self.link_first_flood.is_set or self.link_first_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_first_flood.get_name_leafdata())
                                    if (self.link_first_flood_index.is_set or self.link_first_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_first_flood_index.get_name_leafdata())
                                    if (self.link_flood_index.is_set or self.link_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_flood_index.get_name_leafdata())
                                    if (self.link_next_flood.is_set or self.link_next_flood.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_next_flood.get_name_leafdata())
                                    if (self.link_next_flood_index.is_set or self.link_next_flood_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.link_next_flood_index.get_name_leafdata())
                                    if (self.lsa_retransmission_timer.is_set or self.lsa_retransmission_timer.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsa_retransmission_timer.get_name_leafdata())
                                    if (self.maximum_retransmission_length.is_set or self.maximum_retransmission_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_retransmission_length.get_name_leafdata())
                                    if (self.maximum_retransmission_time.is_set or self.maximum_retransmission_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_retransmission_time.get_name_leafdata())
                                    if (self.neighbor_retransmissions.is_set or self.neighbor_retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.neighbor_retransmissions.get_name_leafdata())
                                    if (self.retransmissions.is_set or self.retransmissions.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.retransmissions.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "area-first-flood" or name == "area-first-flood-index" or name == "area-flood-index" or name == "area-next-flood" or name == "area-next-flood-index" or name == "as-first-flood" or name == "as-first-flood-index" or name == "as-flood-index" or name == "as-next-flood" or name == "as-next-flood-index" or name == "database-descriptor-retransmissions" or name == "last-retransmission-length" or name == "last-retransmission-time" or name == "link-first-flood" or name == "link-first-flood-index" or name == "link-flood-index" or name == "link-next-flood" or name == "link-next-flood-index" or name == "lsa-retransmission-timer" or name == "maximum-retransmission-length" or name == "maximum-retransmission-time" or name == "neighbor-retransmissions" or name == "retransmissions"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "area-first-flood"):
                                        self.area_first_flood = value
                                        self.area_first_flood.value_namespace = name_space
                                        self.area_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-first-flood-index"):
                                        self.area_first_flood_index = value
                                        self.area_first_flood_index.value_namespace = name_space
                                        self.area_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-flood-index"):
                                        self.area_flood_index = value
                                        self.area_flood_index.value_namespace = name_space
                                        self.area_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-next-flood"):
                                        self.area_next_flood = value
                                        self.area_next_flood.value_namespace = name_space
                                        self.area_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "area-next-flood-index"):
                                        self.area_next_flood_index = value
                                        self.area_next_flood_index.value_namespace = name_space
                                        self.area_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-first-flood"):
                                        self.as_first_flood = value
                                        self.as_first_flood.value_namespace = name_space
                                        self.as_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-first-flood-index"):
                                        self.as_first_flood_index = value
                                        self.as_first_flood_index.value_namespace = name_space
                                        self.as_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-flood-index"):
                                        self.as_flood_index = value
                                        self.as_flood_index.value_namespace = name_space
                                        self.as_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-next-flood"):
                                        self.as_next_flood = value
                                        self.as_next_flood.value_namespace = name_space
                                        self.as_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "as-next-flood-index"):
                                        self.as_next_flood_index = value
                                        self.as_next_flood_index.value_namespace = name_space
                                        self.as_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "database-descriptor-retransmissions"):
                                        self.database_descriptor_retransmissions = value
                                        self.database_descriptor_retransmissions.value_namespace = name_space
                                        self.database_descriptor_retransmissions.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-retransmission-length"):
                                        self.last_retransmission_length = value
                                        self.last_retransmission_length.value_namespace = name_space
                                        self.last_retransmission_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-retransmission-time"):
                                        self.last_retransmission_time = value
                                        self.last_retransmission_time.value_namespace = name_space
                                        self.last_retransmission_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-first-flood"):
                                        self.link_first_flood = value
                                        self.link_first_flood.value_namespace = name_space
                                        self.link_first_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-first-flood-index"):
                                        self.link_first_flood_index = value
                                        self.link_first_flood_index.value_namespace = name_space
                                        self.link_first_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-flood-index"):
                                        self.link_flood_index = value
                                        self.link_flood_index.value_namespace = name_space
                                        self.link_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-next-flood"):
                                        self.link_next_flood = value
                                        self.link_next_flood.value_namespace = name_space
                                        self.link_next_flood.value_namespace_prefix = name_space_prefix
                                    if(value_path == "link-next-flood-index"):
                                        self.link_next_flood_index = value
                                        self.link_next_flood_index.value_namespace = name_space
                                        self.link_next_flood_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsa-retransmission-timer"):
                                        self.lsa_retransmission_timer = value
                                        self.lsa_retransmission_timer.value_namespace = name_space
                                        self.lsa_retransmission_timer.value_namespace_prefix = name_space_prefix
                                    if(value_path == "maximum-retransmission-length"):
                                        self.maximum_retransmission_length = value
                                        self.maximum_retransmission_length.value_namespace = name_space
                                        self.maximum_retransmission_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "maximum-retransmission-time"):
                                        self.maximum_retransmission_time = value
                                        self.maximum_retransmission_time.value_namespace = name_space
                                        self.maximum_retransmission_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "neighbor-retransmissions"):
                                        self.neighbor_retransmissions = value
                                        self.neighbor_retransmissions.value_namespace = name_space
                                        self.neighbor_retransmissions.value_namespace_prefix = name_space_prefix
                                    if(value_path == "retransmissions"):
                                        self.retransmissions = value
                                        self.retransmissions.value_namespace = name_space
                                        self.retransmissions.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_type.is_set or
                                    self.is_neighbor_filtered.is_set or
                                    self.neighbor_backup_designated_router_address.is_set or
                                    self.neighbor_cost.is_set or
                                    self.neighbor_designated_router_address.is_set or
                                    self.neighbor_ignore_timer.is_set or
                                    self.neighbor_option.is_set or
                                    self.next_poll_interval.is_set or
                                    self.pending_events.is_set or
                                    self.poll_interval.is_set or
                                    self.state_changes.is_set or
                                    (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_type.yfilter != YFilter.not_set or
                                    self.is_neighbor_filtered.yfilter != YFilter.not_set or
                                    self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set or
                                    self.neighbor_cost.yfilter != YFilter.not_set or
                                    self.neighbor_designated_router_address.yfilter != YFilter.not_set or
                                    self.neighbor_ignore_timer.yfilter != YFilter.not_set or
                                    self.neighbor_option.yfilter != YFilter.not_set or
                                    self.next_poll_interval.yfilter != YFilter.not_set or
                                    self.pending_events.yfilter != YFilter.not_set or
                                    self.poll_interval.yfilter != YFilter.not_set or
                                    self.state_changes.yfilter != YFilter.not_set or
                                    (self.neighbor_retransmission is not None and self.neighbor_retransmission.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_type.is_set or self.interface_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_type.get_name_leafdata())
                                if (self.is_neighbor_filtered.is_set or self.is_neighbor_filtered.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_filtered.get_name_leafdata())
                                if (self.neighbor_backup_designated_router_address.is_set or self.neighbor_backup_designated_router_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_backup_designated_router_address.get_name_leafdata())
                                if (self.neighbor_cost.is_set or self.neighbor_cost.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_cost.get_name_leafdata())
                                if (self.neighbor_designated_router_address.is_set or self.neighbor_designated_router_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_designated_router_address.get_name_leafdata())
                                if (self.neighbor_ignore_timer.is_set or self.neighbor_ignore_timer.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_ignore_timer.get_name_leafdata())
                                if (self.neighbor_option.is_set or self.neighbor_option.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.neighbor_option.get_name_leafdata())
                                if (self.next_poll_interval.is_set or self.next_poll_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_poll_interval.get_name_leafdata())
                                if (self.pending_events.is_set or self.pending_events.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pending_events.get_name_leafdata())
                                if (self.poll_interval.is_set or self.poll_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.poll_interval.get_name_leafdata())
                                if (self.state_changes.is_set or self.state_changes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_changes.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "neighbor-retransmission"):
                                    if (self.neighbor_retransmission is None):
                                        self.neighbor_retransmission = Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail.NeighborRetransmission()
                                        self.neighbor_retransmission.parent = self
                                        self._children_name_map["neighbor_retransmission"] = "neighbor-retransmission"
                                    return self.neighbor_retransmission

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "neighbor-retransmission" or name == "interface-type" or name == "is-neighbor-filtered" or name == "neighbor-backup-designated-router-address" or name == "neighbor-cost" or name == "neighbor-designated-router-address" or name == "neighbor-ignore-timer" or name == "neighbor-option" or name == "next-poll-interval" or name == "pending-events" or name == "poll-interval" or name == "state-changes"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-type"):
                                    self.interface_type = value
                                    self.interface_type.value_namespace = name_space
                                    self.interface_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-filtered"):
                                    self.is_neighbor_filtered = value
                                    self.is_neighbor_filtered.value_namespace = name_space
                                    self.is_neighbor_filtered.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-backup-designated-router-address"):
                                    self.neighbor_backup_designated_router_address = value
                                    self.neighbor_backup_designated_router_address.value_namespace = name_space
                                    self.neighbor_backup_designated_router_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-cost"):
                                    self.neighbor_cost = value
                                    self.neighbor_cost.value_namespace = name_space
                                    self.neighbor_cost.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-designated-router-address"):
                                    self.neighbor_designated_router_address = value
                                    self.neighbor_designated_router_address.value_namespace = name_space
                                    self.neighbor_designated_router_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-ignore-timer"):
                                    self.neighbor_ignore_timer = value
                                    self.neighbor_ignore_timer.value_namespace = name_space
                                    self.neighbor_ignore_timer.value_namespace_prefix = name_space_prefix
                                if(value_path == "neighbor-option"):
                                    self.neighbor_option = value
                                    self.neighbor_option.value_namespace = name_space
                                    self.neighbor_option.value_namespace_prefix = name_space_prefix
                                if(value_path == "next-poll-interval"):
                                    self.next_poll_interval = value
                                    self.next_poll_interval.value_namespace = name_space
                                    self.next_poll_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "pending-events"):
                                    self.pending_events = value
                                    self.pending_events.value_namespace = name_space
                                    self.pending_events.value_namespace_prefix = name_space_prefix
                                if(value_path == "poll-interval"):
                                    self.poll_interval = value
                                    self.poll_interval.value_namespace = name_space
                                    self.poll_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-changes"):
                                    self.state_changes = value
                                    self.state_changes.value_namespace = name_space
                                    self.state_changes.value_namespace_prefix = name_space_prefix


                        class NeighborBfdInfo(Entity):
                            """
                            Neighbor BFD information
                            
                            .. attribute:: bfd_intf_enable_mode
                            
                            	BFD enable mode \- Default/Strict
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_status_flag
                            
                            	Status of the BFD Session
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'ipv6-ospfv3-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo, self).__init__()

                                self.yang_name = "neighbor-bfd-info"
                                self.yang_parent_name = "neighbor-detail"

                                self.bfd_intf_enable_mode = YLeaf(YType.uint32, "bfd-intf-enable-mode")

                                self.bfd_status_flag = YLeaf(YType.uint8, "bfd-status-flag")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_intf_enable_mode",
                                                "bfd_status_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.bfd_intf_enable_mode.is_set or
                                    self.bfd_status_flag.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_intf_enable_mode.yfilter != YFilter.not_set or
                                    self.bfd_status_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_intf_enable_mode.is_set or self.bfd_intf_enable_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_intf_enable_mode.get_name_leafdata())
                                if (self.bfd_status_flag.is_set or self.bfd_status_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_status_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-intf-enable-mode" or name == "bfd-status-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-intf-enable-mode"):
                                    self.bfd_intf_enable_mode = value
                                    self.bfd_intf_enable_mode.value_namespace = name_space
                                    self.bfd_intf_enable_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-status-flag"):
                                    self.bfd_status_flag = value
                                    self.bfd_status_flag.value_namespace = name_space
                                    self.bfd_status_flag.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.interface_name.is_set or
                                self.is_neighbor_sham_link.is_set or
                                self.is_neighbor_virtual_link.is_set or
                                self.neighbor_address.is_set or
                                self.neighbor_address_xr.is_set or
                                self.neighbor_dead_timer.is_set or
                                self.neighbor_designated_router.is_set or
                                self.neighbor_dr_priority.is_set or
                                self.neighbor_interface_id.is_set or
                                self.neighbor_sham_link_id.is_set or
                                self.neighbor_state.is_set or
                                self.neighbor_up_time.is_set or
                                self.neighbor_virtual_link_id.is_set or
                                (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_data()) or
                                (self.neighbor_detail is not None and self.neighbor_detail.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.is_neighbor_sham_link.yfilter != YFilter.not_set or
                                self.is_neighbor_virtual_link.yfilter != YFilter.not_set or
                                self.neighbor_address.yfilter != YFilter.not_set or
                                self.neighbor_address_xr.yfilter != YFilter.not_set or
                                self.neighbor_dead_timer.yfilter != YFilter.not_set or
                                self.neighbor_designated_router.yfilter != YFilter.not_set or
                                self.neighbor_dr_priority.yfilter != YFilter.not_set or
                                self.neighbor_interface_id.yfilter != YFilter.not_set or
                                self.neighbor_sham_link_id.yfilter != YFilter.not_set or
                                self.neighbor_state.yfilter != YFilter.not_set or
                                self.neighbor_up_time.yfilter != YFilter.not_set or
                                self.neighbor_virtual_link_id.yfilter != YFilter.not_set or
                                (self.neighbor_bfd_info is not None and self.neighbor_bfd_info.has_operation()) or
                                (self.neighbor_detail is not None and self.neighbor_detail.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-detail" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.is_neighbor_sham_link.is_set or self.is_neighbor_sham_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_neighbor_sham_link.get_name_leafdata())
                            if (self.is_neighbor_virtual_link.is_set or self.is_neighbor_virtual_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_neighbor_virtual_link.get_name_leafdata())
                            if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                            if (self.neighbor_address_xr.is_set or self.neighbor_address_xr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_address_xr.get_name_leafdata())
                            if (self.neighbor_dead_timer.is_set or self.neighbor_dead_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_dead_timer.get_name_leafdata())
                            if (self.neighbor_designated_router.is_set or self.neighbor_designated_router.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_designated_router.get_name_leafdata())
                            if (self.neighbor_dr_priority.is_set or self.neighbor_dr_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_dr_priority.get_name_leafdata())
                            if (self.neighbor_interface_id.is_set or self.neighbor_interface_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_interface_id.get_name_leafdata())
                            if (self.neighbor_sham_link_id.is_set or self.neighbor_sham_link_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_sham_link_id.get_name_leafdata())
                            if (self.neighbor_state.is_set or self.neighbor_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_state.get_name_leafdata())
                            if (self.neighbor_up_time.is_set or self.neighbor_up_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_up_time.get_name_leafdata())
                            if (self.neighbor_virtual_link_id.is_set or self.neighbor_virtual_link_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.neighbor_virtual_link_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor-bfd-info"):
                                if (self.neighbor_bfd_info is None):
                                    self.neighbor_bfd_info = Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborBfdInfo()
                                    self.neighbor_bfd_info.parent = self
                                    self._children_name_map["neighbor_bfd_info"] = "neighbor-bfd-info"
                                return self.neighbor_bfd_info

                            if (child_yang_name == "neighbor-detail"):
                                if (self.neighbor_detail is None):
                                    self.neighbor_detail = Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail.NeighborDetail()
                                    self.neighbor_detail.parent = self
                                    self._children_name_map["neighbor_detail"] = "neighbor-detail"
                                return self.neighbor_detail

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor-bfd-info" or name == "neighbor-detail" or name == "interface-name" or name == "is-neighbor-sham-link" or name == "is-neighbor-virtual-link" or name == "neighbor-address" or name == "neighbor-address-xr" or name == "neighbor-dead-timer" or name == "neighbor-designated-router" or name == "neighbor-dr-priority" or name == "neighbor-interface-id" or name == "neighbor-sham-link-id" or name == "neighbor-state" or name == "neighbor-up-time" or name == "neighbor-virtual-link-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-neighbor-sham-link"):
                                self.is_neighbor_sham_link = value
                                self.is_neighbor_sham_link.value_namespace = name_space
                                self.is_neighbor_sham_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-neighbor-virtual-link"):
                                self.is_neighbor_virtual_link = value
                                self.is_neighbor_virtual_link.value_namespace = name_space
                                self.is_neighbor_virtual_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-address"):
                                self.neighbor_address = value
                                self.neighbor_address.value_namespace = name_space
                                self.neighbor_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-address-xr"):
                                self.neighbor_address_xr = value
                                self.neighbor_address_xr.value_namespace = name_space
                                self.neighbor_address_xr.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-dead-timer"):
                                self.neighbor_dead_timer = value
                                self.neighbor_dead_timer.value_namespace = name_space
                                self.neighbor_dead_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-designated-router"):
                                self.neighbor_designated_router = value
                                self.neighbor_designated_router.value_namespace = name_space
                                self.neighbor_designated_router.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-dr-priority"):
                                self.neighbor_dr_priority = value
                                self.neighbor_dr_priority.value_namespace = name_space
                                self.neighbor_dr_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-interface-id"):
                                self.neighbor_interface_id = value
                                self.neighbor_interface_id.value_namespace = name_space
                                self.neighbor_interface_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-sham-link-id"):
                                self.neighbor_sham_link_id = value
                                self.neighbor_sham_link_id.value_namespace = name_space
                                self.neighbor_sham_link_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-state"):
                                self.neighbor_state = value
                                self.neighbor_state.value_namespace = name_space
                                self.neighbor_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-up-time"):
                                self.neighbor_up_time = value
                                self.neighbor_up_time.value_namespace = name_space
                                self.neighbor_up_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "neighbor-virtual-link-id"):
                                self.neighbor_virtual_link_id = value
                                self.neighbor_virtual_link_id.value_namespace = name_space
                                self.neighbor_virtual_link_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor_detail:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor_detail:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbor-detail-process-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor-detail"):
                            for c in self.neighbor_detail:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable.NeighborDetail()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor_detail.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor-detail"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        (self.area_informations is not None and self.area_informations.has_data()) or
                        (self.areas is not None and self.areas.has_data()) or
                        (self.bad_checksums is not None and self.bad_checksums.has_data()) or
                        (self.border_routers is not None and self.border_routers.has_data()) or
                        (self.connected_routes is not None and self.connected_routes.has_data()) or
                        (self.database_summary_table is not None and self.database_summary_table.has_data()) or
                        (self.database_table is not None and self.database_table.has_data()) or
                        (self.external_routes is not None and self.external_routes.has_data()) or
                        (self.fast_reroutes is not None and self.fast_reroutes.has_data()) or
                        (self.flood_list_process_table is not None and self.flood_list_process_table.has_data()) or
                        (self.interface_brief_process_table is not None and self.interface_brief_process_table.has_data()) or
                        (self.interface_process_table is not None and self.interface_process_table.has_data()) or
                        (self.internal_routes is not None and self.internal_routes.has_data()) or
                        (self.neighbor_detail_process_table is not None and self.neighbor_detail_process_table.has_data()) or
                        (self.neighbor_process_table is not None and self.neighbor_process_table.has_data()) or
                        (self.protocol_areas is not None and self.protocol_areas.has_data()) or
                        (self.redistributions is not None and self.redistributions.has_data()) or
                        (self.request_list_process_table is not None and self.request_list_process_table.has_data()) or
                        (self.retransmission_list_process_table is not None and self.retransmission_list_process_table.has_data()) or
                        (self.route_summary is not None and self.route_summary.has_data()) or
                        (self.sham_link_table is not None and self.sham_link_table.has_data()) or
                        (self.summary is not None and self.summary.has_data()) or
                        (self.summary_prefixes is not None and self.summary_prefixes.has_data()) or
                        (self.virtual_link is not None and self.virtual_link.has_data()) or
                        (self.vrf_statistics is not None and self.vrf_statistics.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.area_informations is not None and self.area_informations.has_operation()) or
                        (self.areas is not None and self.areas.has_operation()) or
                        (self.bad_checksums is not None and self.bad_checksums.has_operation()) or
                        (self.border_routers is not None and self.border_routers.has_operation()) or
                        (self.connected_routes is not None and self.connected_routes.has_operation()) or
                        (self.database_summary_table is not None and self.database_summary_table.has_operation()) or
                        (self.database_table is not None and self.database_table.has_operation()) or
                        (self.external_routes is not None and self.external_routes.has_operation()) or
                        (self.fast_reroutes is not None and self.fast_reroutes.has_operation()) or
                        (self.flood_list_process_table is not None and self.flood_list_process_table.has_operation()) or
                        (self.interface_brief_process_table is not None and self.interface_brief_process_table.has_operation()) or
                        (self.interface_process_table is not None and self.interface_process_table.has_operation()) or
                        (self.internal_routes is not None and self.internal_routes.has_operation()) or
                        (self.neighbor_detail_process_table is not None and self.neighbor_detail_process_table.has_operation()) or
                        (self.neighbor_process_table is not None and self.neighbor_process_table.has_operation()) or
                        (self.protocol_areas is not None and self.protocol_areas.has_operation()) or
                        (self.redistributions is not None and self.redistributions.has_operation()) or
                        (self.request_list_process_table is not None and self.request_list_process_table.has_operation()) or
                        (self.retransmission_list_process_table is not None and self.retransmission_list_process_table.has_operation()) or
                        (self.route_summary is not None and self.route_summary.has_operation()) or
                        (self.sham_link_table is not None and self.sham_link_table.has_operation()) or
                        (self.summary is not None and self.summary.has_operation()) or
                        (self.summary_prefixes is not None and self.summary_prefixes.has_operation()) or
                        (self.virtual_link is not None and self.virtual_link.has_operation()) or
                        (self.vrf_statistics is not None and self.vrf_statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "default-vrf" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "area-informations"):
                        if (self.area_informations is None):
                            self.area_informations = Ospfv3.Processes.Process.DefaultVrf.AreaInformations()
                            self.area_informations.parent = self
                            self._children_name_map["area_informations"] = "area-informations"
                        return self.area_informations

                    if (child_yang_name == "areas"):
                        if (self.areas is None):
                            self.areas = Ospfv3.Processes.Process.DefaultVrf.Areas()
                            self.areas.parent = self
                            self._children_name_map["areas"] = "areas"
                        return self.areas

                    if (child_yang_name == "bad-checksums"):
                        if (self.bad_checksums is None):
                            self.bad_checksums = Ospfv3.Processes.Process.DefaultVrf.BadChecksums()
                            self.bad_checksums.parent = self
                            self._children_name_map["bad_checksums"] = "bad-checksums"
                        return self.bad_checksums

                    if (child_yang_name == "border-routers"):
                        if (self.border_routers is None):
                            self.border_routers = Ospfv3.Processes.Process.DefaultVrf.BorderRouters()
                            self.border_routers.parent = self
                            self._children_name_map["border_routers"] = "border-routers"
                        return self.border_routers

                    if (child_yang_name == "connected-routes"):
                        if (self.connected_routes is None):
                            self.connected_routes = Ospfv3.Processes.Process.DefaultVrf.ConnectedRoutes()
                            self.connected_routes.parent = self
                            self._children_name_map["connected_routes"] = "connected-routes"
                        return self.connected_routes

                    if (child_yang_name == "database-summary-table"):
                        if (self.database_summary_table is None):
                            self.database_summary_table = Ospfv3.Processes.Process.DefaultVrf.DatabaseSummaryTable()
                            self.database_summary_table.parent = self
                            self._children_name_map["database_summary_table"] = "database-summary-table"
                        return self.database_summary_table

                    if (child_yang_name == "database-table"):
                        if (self.database_table is None):
                            self.database_table = Ospfv3.Processes.Process.DefaultVrf.DatabaseTable()
                            self.database_table.parent = self
                            self._children_name_map["database_table"] = "database-table"
                        return self.database_table

                    if (child_yang_name == "external-routes"):
                        if (self.external_routes is None):
                            self.external_routes = Ospfv3.Processes.Process.DefaultVrf.ExternalRoutes()
                            self.external_routes.parent = self
                            self._children_name_map["external_routes"] = "external-routes"
                        return self.external_routes

                    if (child_yang_name == "fast-reroutes"):
                        if (self.fast_reroutes is None):
                            self.fast_reroutes = Ospfv3.Processes.Process.DefaultVrf.FastReroutes()
                            self.fast_reroutes.parent = self
                            self._children_name_map["fast_reroutes"] = "fast-reroutes"
                        return self.fast_reroutes

                    if (child_yang_name == "flood-list-process-table"):
                        if (self.flood_list_process_table is None):
                            self.flood_list_process_table = Ospfv3.Processes.Process.DefaultVrf.FloodListProcessTable()
                            self.flood_list_process_table.parent = self
                            self._children_name_map["flood_list_process_table"] = "flood-list-process-table"
                        return self.flood_list_process_table

                    if (child_yang_name == "interface-brief-process-table"):
                        if (self.interface_brief_process_table is None):
                            self.interface_brief_process_table = Ospfv3.Processes.Process.DefaultVrf.InterfaceBriefProcessTable()
                            self.interface_brief_process_table.parent = self
                            self._children_name_map["interface_brief_process_table"] = "interface-brief-process-table"
                        return self.interface_brief_process_table

                    if (child_yang_name == "interface-process-table"):
                        if (self.interface_process_table is None):
                            self.interface_process_table = Ospfv3.Processes.Process.DefaultVrf.InterfaceProcessTable()
                            self.interface_process_table.parent = self
                            self._children_name_map["interface_process_table"] = "interface-process-table"
                        return self.interface_process_table

                    if (child_yang_name == "internal-routes"):
                        if (self.internal_routes is None):
                            self.internal_routes = Ospfv3.Processes.Process.DefaultVrf.InternalRoutes()
                            self.internal_routes.parent = self
                            self._children_name_map["internal_routes"] = "internal-routes"
                        return self.internal_routes

                    if (child_yang_name == "neighbor-detail-process-table"):
                        if (self.neighbor_detail_process_table is None):
                            self.neighbor_detail_process_table = Ospfv3.Processes.Process.DefaultVrf.NeighborDetailProcessTable()
                            self.neighbor_detail_process_table.parent = self
                            self._children_name_map["neighbor_detail_process_table"] = "neighbor-detail-process-table"
                        return self.neighbor_detail_process_table

                    if (child_yang_name == "neighbor-process-table"):
                        if (self.neighbor_process_table is None):
                            self.neighbor_process_table = Ospfv3.Processes.Process.DefaultVrf.NeighborProcessTable()
                            self.neighbor_process_table.parent = self
                            self._children_name_map["neighbor_process_table"] = "neighbor-process-table"
                        return self.neighbor_process_table

                    if (child_yang_name == "protocol-areas"):
                        if (self.protocol_areas is None):
                            self.protocol_areas = Ospfv3.Processes.Process.DefaultVrf.ProtocolAreas()
                            self.protocol_areas.parent = self
                            self._children_name_map["protocol_areas"] = "protocol-areas"
                        return self.protocol_areas

                    if (child_yang_name == "redistributions"):
                        if (self.redistributions is None):
                            self.redistributions = Ospfv3.Processes.Process.DefaultVrf.Redistributions()
                            self.redistributions.parent = self
                            self._children_name_map["redistributions"] = "redistributions"
                        return self.redistributions

                    if (child_yang_name == "request-list-process-table"):
                        if (self.request_list_process_table is None):
                            self.request_list_process_table = Ospfv3.Processes.Process.DefaultVrf.RequestListProcessTable()
                            self.request_list_process_table.parent = self
                            self._children_name_map["request_list_process_table"] = "request-list-process-table"
                        return self.request_list_process_table

                    if (child_yang_name == "retransmission-list-process-table"):
                        if (self.retransmission_list_process_table is None):
                            self.retransmission_list_process_table = Ospfv3.Processes.Process.DefaultVrf.RetransmissionListProcessTable()
                            self.retransmission_list_process_table.parent = self
                            self._children_name_map["retransmission_list_process_table"] = "retransmission-list-process-table"
                        return self.retransmission_list_process_table

                    if (child_yang_name == "route-summary"):
                        if (self.route_summary is None):
                            self.route_summary = Ospfv3.Processes.Process.DefaultVrf.RouteSummary()
                            self.route_summary.parent = self
                            self._children_name_map["route_summary"] = "route-summary"
                        return self.route_summary

                    if (child_yang_name == "sham-link-table"):
                        if (self.sham_link_table is None):
                            self.sham_link_table = Ospfv3.Processes.Process.DefaultVrf.ShamLinkTable()
                            self.sham_link_table.parent = self
                            self._children_name_map["sham_link_table"] = "sham-link-table"
                        return self.sham_link_table

                    if (child_yang_name == "summary"):
                        if (self.summary is None):
                            self.summary = Ospfv3.Processes.Process.DefaultVrf.Summary()
                            self.summary.parent = self
                            self._children_name_map["summary"] = "summary"
                        return self.summary

                    if (child_yang_name == "summary-prefixes"):
                        if (self.summary_prefixes is None):
                            self.summary_prefixes = Ospfv3.Processes.Process.DefaultVrf.SummaryPrefixes()
                            self.summary_prefixes.parent = self
                            self._children_name_map["summary_prefixes"] = "summary-prefixes"
                        return self.summary_prefixes

                    if (child_yang_name == "virtual-link"):
                        if (self.virtual_link is None):
                            self.virtual_link = Ospfv3.Processes.Process.DefaultVrf.VirtualLink()
                            self.virtual_link.parent = self
                            self._children_name_map["virtual_link"] = "virtual-link"
                        return self.virtual_link

                    if (child_yang_name == "vrf-statistics"):
                        if (self.vrf_statistics is None):
                            self.vrf_statistics = Ospfv3.Processes.Process.DefaultVrf.VrfStatistics()
                            self.vrf_statistics.parent = self
                            self._children_name_map["vrf_statistics"] = "vrf-statistics"
                        return self.vrf_statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "area-informations" or name == "areas" or name == "bad-checksums" or name == "border-routers" or name == "connected-routes" or name == "database-summary-table" or name == "database-table" or name == "external-routes" or name == "fast-reroutes" or name == "flood-list-process-table" or name == "interface-brief-process-table" or name == "interface-process-table" or name == "internal-routes" or name == "neighbor-detail-process-table" or name == "neighbor-process-table" or name == "protocol-areas" or name == "redistributions" or name == "request-list-process-table" or name == "retransmission-list-process-table" or name == "route-summary" or name == "sham-link-table" or name == "summary" or name == "summary-prefixes" or name == "virtual-link" or name == "vrf-statistics"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    self.process_name.is_set or
                    (self.default_vrf is not None and self.default_vrf.has_data()) or
                    (self.statistics is not None and self.statistics.has_data()) or
                    (self.vrfs is not None and self.vrfs.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.process_name.yfilter != YFilter.not_set or
                    (self.default_vrf is not None and self.default_vrf.has_operation()) or
                    (self.statistics is not None and self.statistics.has_operation()) or
                    (self.vrfs is not None and self.vrfs.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "process" + "[process-name='" + self.process_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-ipv6-ospfv3-oper:ospfv3/processes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.process_name.is_set or self.process_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.process_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "default-vrf"):
                    if (self.default_vrf is None):
                        self.default_vrf = Ospfv3.Processes.Process.DefaultVrf()
                        self.default_vrf.parent = self
                        self._children_name_map["default_vrf"] = "default-vrf"
                    return self.default_vrf

                if (child_yang_name == "statistics"):
                    if (self.statistics is None):
                        self.statistics = Ospfv3.Processes.Process.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                    return self.statistics

                if (child_yang_name == "vrfs"):
                    if (self.vrfs is None):
                        self.vrfs = Ospfv3.Processes.Process.Vrfs()
                        self.vrfs.parent = self
                        self._children_name_map["vrfs"] = "vrfs"
                    return self.vrfs

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "default-vrf" or name == "statistics" or name == "vrfs" or name == "process-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "process-name"):
                    self.process_name = value
                    self.process_name.value_namespace = name_space
                    self.process_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.process:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.process:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "processes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-ipv6-ospfv3-oper:ospfv3/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "process"):
                for c in self.process:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = Ospfv3.Processes.Process()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.process.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "process"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass

    def has_data(self):
        return (self.processes is not None and self.processes.has_data())

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.processes is not None and self.processes.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-ipv6-ospfv3-oper:ospfv3" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "processes"):
            if (self.processes is None):
                self.processes = Ospfv3.Processes()
                self.processes.parent = self
                self._children_name_map["processes"] = "processes"
            return self.processes

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "processes"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = Ospfv3()
        return self._top_entity

